


MODULE module_scalar_tables
  USE module_driver_constants
  USE module_state_description
  USE module_domain_type, ONLY : streamrec






  INTEGER, TARGET :: moist_index_table( param_num_moist, max_domains )
  INTEGER, TARGET :: moist_num_table( max_domains )
  TYPE(streamrec), TARGET :: moist_streams_table( max_domains, param_num_moist )
  LOGICAL, TARGET :: moist_boundary_table( max_domains, param_num_moist )
  CHARACTER*256, TARGET :: moist_dname_table( max_domains, param_num_moist )
  CHARACTER*256, TARGET :: moist_desc_table( max_domains, param_num_moist )
  CHARACTER*256, TARGET :: moist_units_table( max_domains, param_num_moist )
  INTEGER, TARGET :: dfi_moist_index_table( param_num_dfi_moist, max_domains )
  INTEGER, TARGET :: dfi_moist_num_table( max_domains )
  TYPE(streamrec), TARGET :: dfi_moist_streams_table( max_domains, param_num_dfi_moist )
  LOGICAL, TARGET :: dfi_moist_boundary_table( max_domains, param_num_dfi_moist )
  CHARACTER*256, TARGET :: dfi_moist_dname_table( max_domains, param_num_dfi_moist )
  CHARACTER*256, TARGET :: dfi_moist_desc_table( max_domains, param_num_dfi_moist )
  CHARACTER*256, TARGET :: dfi_moist_units_table( max_domains, param_num_dfi_moist )
  INTEGER, TARGET :: scalar_index_table( param_num_scalar, max_domains )
  INTEGER, TARGET :: scalar_num_table( max_domains )
  TYPE(streamrec), TARGET :: scalar_streams_table( max_domains, param_num_scalar )
  LOGICAL, TARGET :: scalar_boundary_table( max_domains, param_num_scalar )
  CHARACTER*256, TARGET :: scalar_dname_table( max_domains, param_num_scalar )
  CHARACTER*256, TARGET :: scalar_desc_table( max_domains, param_num_scalar )
  CHARACTER*256, TARGET :: scalar_units_table( max_domains, param_num_scalar )
  INTEGER, TARGET :: dfi_scalar_index_table( param_num_dfi_scalar, max_domains )
  INTEGER, TARGET :: dfi_scalar_num_table( max_domains )
  TYPE(streamrec), TARGET :: dfi_scalar_streams_table( max_domains, param_num_dfi_scalar )
  LOGICAL, TARGET :: dfi_scalar_boundary_table( max_domains, param_num_dfi_scalar )
  CHARACTER*256, TARGET :: dfi_scalar_dname_table( max_domains, param_num_dfi_scalar )
  CHARACTER*256, TARGET :: dfi_scalar_desc_table( max_domains, param_num_dfi_scalar )
  CHARACTER*256, TARGET :: dfi_scalar_units_table( max_domains, param_num_dfi_scalar )
  INTEGER, TARGET :: aerod_index_table( param_num_aerod, max_domains )
  INTEGER, TARGET :: aerod_num_table( max_domains )
  TYPE(streamrec), TARGET :: aerod_streams_table( max_domains, param_num_aerod )
  LOGICAL, TARGET :: aerod_boundary_table( max_domains, param_num_aerod )
  CHARACTER*256, TARGET :: aerod_dname_table( max_domains, param_num_aerod )
  CHARACTER*256, TARGET :: aerod_desc_table( max_domains, param_num_aerod )
  CHARACTER*256, TARGET :: aerod_units_table( max_domains, param_num_aerod )
  INTEGER, TARGET :: aerocu_index_table( param_num_aerocu, max_domains )
  INTEGER, TARGET :: aerocu_num_table( max_domains )
  TYPE(streamrec), TARGET :: aerocu_streams_table( max_domains, param_num_aerocu )
  LOGICAL, TARGET :: aerocu_boundary_table( max_domains, param_num_aerocu )
  CHARACTER*256, TARGET :: aerocu_dname_table( max_domains, param_num_aerocu )
  CHARACTER*256, TARGET :: aerocu_desc_table( max_domains, param_num_aerocu )
  CHARACTER*256, TARGET :: aerocu_units_table( max_domains, param_num_aerocu )
  INTEGER, TARGET :: ozmixm_index_table( param_num_ozmixm, max_domains )
  INTEGER, TARGET :: ozmixm_num_table( max_domains )
  TYPE(streamrec), TARGET :: ozmixm_streams_table( max_domains, param_num_ozmixm )
  LOGICAL, TARGET :: ozmixm_boundary_table( max_domains, param_num_ozmixm )
  CHARACTER*256, TARGET :: ozmixm_dname_table( max_domains, param_num_ozmixm )
  CHARACTER*256, TARGET :: ozmixm_desc_table( max_domains, param_num_ozmixm )
  CHARACTER*256, TARGET :: ozmixm_units_table( max_domains, param_num_ozmixm )
  INTEGER, TARGET :: aerosolc_index_table( param_num_aerosolc, max_domains )
  INTEGER, TARGET :: aerosolc_num_table( max_domains )
  TYPE(streamrec), TARGET :: aerosolc_streams_table( max_domains, param_num_aerosolc )
  LOGICAL, TARGET :: aerosolc_boundary_table( max_domains, param_num_aerosolc )
  CHARACTER*256, TARGET :: aerosolc_dname_table( max_domains, param_num_aerosolc )
  CHARACTER*256, TARGET :: aerosolc_desc_table( max_domains, param_num_aerosolc )
  CHARACTER*256, TARGET :: aerosolc_units_table( max_domains, param_num_aerosolc )
  INTEGER, TARGET :: fdda3d_index_table( param_num_fdda3d, max_domains )
  INTEGER, TARGET :: fdda3d_num_table( max_domains )
  TYPE(streamrec), TARGET :: fdda3d_streams_table( max_domains, param_num_fdda3d )
  LOGICAL, TARGET :: fdda3d_boundary_table( max_domains, param_num_fdda3d )
  CHARACTER*256, TARGET :: fdda3d_dname_table( max_domains, param_num_fdda3d )
  CHARACTER*256, TARGET :: fdda3d_desc_table( max_domains, param_num_fdda3d )
  CHARACTER*256, TARGET :: fdda3d_units_table( max_domains, param_num_fdda3d )
  INTEGER, TARGET :: fdda2d_index_table( param_num_fdda2d, max_domains )
  INTEGER, TARGET :: fdda2d_num_table( max_domains )
  TYPE(streamrec), TARGET :: fdda2d_streams_table( max_domains, param_num_fdda2d )
  LOGICAL, TARGET :: fdda2d_boundary_table( max_domains, param_num_fdda2d )
  CHARACTER*256, TARGET :: fdda2d_dname_table( max_domains, param_num_fdda2d )
  CHARACTER*256, TARGET :: fdda2d_desc_table( max_domains, param_num_fdda2d )
  CHARACTER*256, TARGET :: fdda2d_units_table( max_domains, param_num_fdda2d )
  INTEGER, TARGET :: advh_t_index_table( param_num_advh_t, max_domains )
  INTEGER, TARGET :: advh_t_num_table( max_domains )
  TYPE(streamrec), TARGET :: advh_t_streams_table( max_domains, param_num_advh_t )
  LOGICAL, TARGET :: advh_t_boundary_table( max_domains, param_num_advh_t )
  CHARACTER*256, TARGET :: advh_t_dname_table( max_domains, param_num_advh_t )
  CHARACTER*256, TARGET :: advh_t_desc_table( max_domains, param_num_advh_t )
  CHARACTER*256, TARGET :: advh_t_units_table( max_domains, param_num_advh_t )
  INTEGER, TARGET :: advz_t_index_table( param_num_advz_t, max_domains )
  INTEGER, TARGET :: advz_t_num_table( max_domains )
  TYPE(streamrec), TARGET :: advz_t_streams_table( max_domains, param_num_advz_t )
  LOGICAL, TARGET :: advz_t_boundary_table( max_domains, param_num_advz_t )
  CHARACTER*256, TARGET :: advz_t_dname_table( max_domains, param_num_advz_t )
  CHARACTER*256, TARGET :: advz_t_desc_table( max_domains, param_num_advz_t )
  CHARACTER*256, TARGET :: advz_t_units_table( max_domains, param_num_advz_t )
  INTEGER, TARGET :: tracer_index_table( param_num_tracer, max_domains )
  INTEGER, TARGET :: tracer_num_table( max_domains )
  TYPE(streamrec), TARGET :: tracer_streams_table( max_domains, param_num_tracer )
  LOGICAL, TARGET :: tracer_boundary_table( max_domains, param_num_tracer )
  CHARACTER*256, TARGET :: tracer_dname_table( max_domains, param_num_tracer )
  CHARACTER*256, TARGET :: tracer_desc_table( max_domains, param_num_tracer )
  CHARACTER*256, TARGET :: tracer_units_table( max_domains, param_num_tracer )
  INTEGER, TARGET :: nba_mij_index_table( param_num_nba_mij, max_domains )
  INTEGER, TARGET :: nba_mij_num_table( max_domains )
  TYPE(streamrec), TARGET :: nba_mij_streams_table( max_domains, param_num_nba_mij )
  LOGICAL, TARGET :: nba_mij_boundary_table( max_domains, param_num_nba_mij )
  CHARACTER*256, TARGET :: nba_mij_dname_table( max_domains, param_num_nba_mij )
  CHARACTER*256, TARGET :: nba_mij_desc_table( max_domains, param_num_nba_mij )
  CHARACTER*256, TARGET :: nba_mij_units_table( max_domains, param_num_nba_mij )
  INTEGER, TARGET :: nba_rij_index_table( param_num_nba_rij, max_domains )
  INTEGER, TARGET :: nba_rij_num_table( max_domains )
  TYPE(streamrec), TARGET :: nba_rij_streams_table( max_domains, param_num_nba_rij )
  LOGICAL, TARGET :: nba_rij_boundary_table( max_domains, param_num_nba_rij )
  CHARACTER*256, TARGET :: nba_rij_dname_table( max_domains, param_num_nba_rij )
  CHARACTER*256, TARGET :: nba_rij_desc_table( max_domains, param_num_nba_rij )
  CHARACTER*256, TARGET :: nba_rij_units_table( max_domains, param_num_nba_rij )
  INTEGER, TARGET :: chem_index_table( param_num_chem, max_domains )
  INTEGER, TARGET :: chem_num_table( max_domains )
  TYPE(streamrec), TARGET :: chem_streams_table( max_domains, param_num_chem )
  LOGICAL, TARGET :: chem_boundary_table( max_domains, param_num_chem )
  CHARACTER*256, TARGET :: chem_dname_table( max_domains, param_num_chem )
  CHARACTER*256, TARGET :: chem_desc_table( max_domains, param_num_chem )
  CHARACTER*256, TARGET :: chem_units_table( max_domains, param_num_chem )

CONTAINS
  SUBROUTINE init_module_scalar_tables
     INTEGER i , j
     DO j = 1, max_domains






  moist_num_table( j ) = 1
  dfi_moist_num_table( j ) = 1
  scalar_num_table( j ) = 1
  dfi_scalar_num_table( j ) = 1
  aerod_num_table( j ) = 1
  aerocu_num_table( j ) = 1
  ozmixm_num_table( j ) = 1
  aerosolc_num_table( j ) = 1
  fdda3d_num_table( j ) = 1
  fdda2d_num_table( j ) = 1
  advh_t_num_table( j ) = 1
  advz_t_num_table( j ) = 1
  tracer_num_table( j ) = 1
  nba_mij_num_table( j ) = 1
  nba_rij_num_table( j ) = 1
  chem_num_table( j ) = 1

     END DO
  END SUBROUTINE init_module_scalar_tables
END MODULE module_scalar_tables


MODULE module_configure

   USE module_driver_constants
   USE module_state_description
   USE module_wrf_error

   TYPE model_config_rec_type
      SEQUENCE











integer    :: first_item_in_struct
integer :: run_days
integer :: run_hours
integer :: run_minutes
integer :: run_seconds
integer , DIMENSION(max_domains) :: start_year
integer , DIMENSION(max_domains) :: start_month
integer , DIMENSION(max_domains) :: start_day
integer , DIMENSION(max_domains) :: start_hour
integer , DIMENSION(max_domains) :: start_minute
integer , DIMENSION(max_domains) :: start_second
integer , DIMENSION(max_domains) :: end_year
integer , DIMENSION(max_domains) :: end_month
integer , DIMENSION(max_domains) :: end_day
integer , DIMENSION(max_domains) :: end_hour
integer , DIMENSION(max_domains) :: end_minute
integer , DIMENSION(max_domains) :: end_second
integer :: interval_seconds
logical , DIMENSION(max_domains) :: input_from_file
integer , DIMENSION(max_domains) :: fine_input_stream
logical , DIMENSION(max_domains) :: input_from_hires
character*256 :: rsmas_data_path
logical :: all_ic_times
integer , DIMENSION(max_domains) :: julyr
integer , DIMENSION(max_domains) :: julday
real , DIMENSION(max_domains) :: gmt
character*256 :: input_inname
character*256 :: input_outname
character*256 :: bdy_inname
character*256 :: bdy_outname
character*256 :: rst_inname
character*256 :: rst_outname
logical :: write_input
logical :: write_restart_at_0h
logical :: write_hist_at_0h_rst
logical :: adjust_output_times
logical :: adjust_input_times
integer :: diag_print
logical :: nocolons
logical :: cycling
integer :: output_diagnostics
integer :: nwp_diagnostics
logical :: output_ready_flag
logical :: force_use_old_data
logical :: usepio
integer :: pioprocs
integer :: piostart
integer :: piostride
integer :: pioshift
integer :: dfi_opt
integer :: dfi_savehydmeteors
integer :: dfi_nfilter
logical :: dfi_write_filtered_input
logical :: dfi_write_dfi_history
integer :: dfi_cutoff_seconds
integer :: dfi_time_dim
integer :: dfi_fwdstop_year
integer :: dfi_fwdstop_month
integer :: dfi_fwdstop_day
integer :: dfi_fwdstop_hour
integer :: dfi_fwdstop_minute
integer :: dfi_fwdstop_second
integer :: dfi_bckstop_year
integer :: dfi_bckstop_month
integer :: dfi_bckstop_day
integer :: dfi_bckstop_hour
integer :: dfi_bckstop_minute
integer :: dfi_bckstop_second
integer :: time_step
integer :: time_step_fract_num
integer :: time_step_fract_den
integer :: time_step_dfi
integer , DIMENSION(max_domains) :: min_time_step
integer , DIMENSION(max_domains) :: min_time_step_den
integer , DIMENSION(max_domains) :: max_time_step
integer , DIMENSION(max_domains) :: max_time_step_den
real , DIMENSION(max_domains) :: target_cfl
real , DIMENSION(max_domains) :: target_hcfl
integer , DIMENSION(max_domains) :: max_step_increase_pct
integer , DIMENSION(max_domains) :: starting_time_step
integer , DIMENSION(max_domains) :: starting_time_step_den
logical :: step_to_output_time
integer :: adaptation_domain
logical :: use_adaptive_time_step
logical :: use_adaptive_time_step_dfi
integer :: max_dom
integer :: lats_to_mic
integer , DIMENSION(max_domains) :: s_we
integer , DIMENSION(max_domains) :: e_we
integer , DIMENSION(max_domains) :: s_sn
integer , DIMENSION(max_domains) :: e_sn
integer , DIMENSION(max_domains) :: s_vert
integer , DIMENSION(max_domains) :: e_vert
integer :: num_metgrid_levels
integer :: num_metgrid_soil_levels
real :: p_top_requested
logical :: interp_theta
integer :: interp_type
integer :: rebalance
integer , DIMENSION(max_domains) :: vert_refine_method
integer :: vert_refine_fact
integer :: extrap_type
integer :: t_extrap_type
integer :: hypsometric_opt
logical :: lowest_lev_from_sfc
logical :: use_levels_below_ground
logical :: use_tavg_for_tsk
logical :: use_surface
integer :: lagrange_order
integer :: linear_interp
integer :: force_sfc_in_vinterp
real :: zap_close_levels
real :: maxw_horiz_pres_diff
real :: trop_horiz_pres_diff
real :: maxw_above_this_level
integer :: use_maxw_level
integer :: use_trop_level
logical :: sfcp_to_sfcp
logical :: adjust_heights
logical :: smooth_cg_topo
integer :: nest_interp_coord
integer :: interp_method_type
logical :: aggregate_lu
logical :: rh2qv_wrt_liquid
integer :: rh2qv_method
real :: qv_max_p_safe
real :: qv_max_flag
real :: qv_max_value
real :: qv_min_p_safe
real :: qv_min_flag
real :: qv_min_value
integer :: ideal_init_method
real , DIMENSION(max_domains) :: dx
real , DIMENSION(max_domains) :: dy
integer , DIMENSION(max_domains) :: grid_id
logical , DIMENSION(max_domains) :: grid_allowed
integer , DIMENSION(max_domains) :: parent_id
integer , DIMENSION(max_domains) :: i_parent_start
integer , DIMENSION(max_domains) :: j_parent_start
integer , DIMENSION(max_domains) :: parent_grid_ratio
integer , DIMENSION(max_domains) :: parent_time_step_ratio
integer :: feedback
integer :: smooth_option
integer :: blend_width
real , DIMENSION(max_domains) :: ztop
integer , DIMENSION(max_domains) :: moad_grid_ratio
integer , DIMENSION(max_domains) :: moad_time_step_ratio
integer , DIMENSION(max_domains) :: shw
integer :: tile_sz_x
integer :: tile_sz_y
integer :: numtiles
integer :: numtiles_inc
integer :: numtiles_x
integer :: numtiles_y
integer :: tile_strategy
integer :: nproc_x
integer :: nproc_y
integer :: irand
real , DIMENSION(max_domains) :: dt
integer :: fft_used
integer :: cu_used
integer :: shcu_used
integer :: cam_used
integer :: alloc_qndropsource
integer :: num_moves
integer :: ts_buf_size
integer :: max_ts_locs
logical :: tslist_ij
logical :: tslist_unstagger_winds
integer , DIMENSION(max_domains) :: vortex_interval
integer , DIMENSION(max_domains) :: max_vortex_speed
integer , DIMENSION(max_domains) :: corral_dist
integer :: track_level
real , DIMENSION(max_domains) :: time_to_move
integer , DIMENSION(max_moves) :: move_id
integer , DIMENSION(max_moves) :: move_interval
integer , DIMENSION(max_moves) :: move_cd_x
integer , DIMENSION(max_moves) :: move_cd_y
logical , DIMENSION(max_domains) :: swap_x
logical , DIMENSION(max_domains) :: swap_y
logical , DIMENSION(max_domains) :: cycle_x
logical , DIMENSION(max_domains) :: cycle_y
logical :: reorder_mesh
logical :: perturb_input
real , DIMENSION(max_eta) :: eta_levels
integer :: auto_levels_opt
real :: max_dz
real :: dzbot
real :: dzstretch_s
real :: dzstretch_u
integer :: ocean_levels
real , DIMENSION(max_ocean) :: ocean_z
real , DIMENSION(max_ocean) :: ocean_t
real , DIMENSION(max_ocean) :: ocean_s
integer :: num_traj
integer :: max_ts_level
integer :: track_loc_in
integer :: num_ext_model_couple_dom
logical :: insert_bogus_storm
logical :: remove_storm
integer :: num_storm
real , DIMENSION(max_bogus) :: latc_loc
real , DIMENSION(max_bogus) :: lonc_loc
real , DIMENSION(max_bogus) :: vmax_meters_per_second
real , DIMENSION(max_bogus) :: rmax
real , DIMENSION(max_bogus) :: vmax_ratio
real :: rankine_lid
character*256 :: physics_suite
logical :: force_read_thompson
logical :: write_thompson_tables
integer , DIMENSION(max_domains) :: mp_physics
real , DIMENSION(max_domains) :: nssl_cccn
real , DIMENSION(max_domains) :: nssl_alphah
real , DIMENSION(max_domains) :: nssl_alphahl
real , DIMENSION(max_domains) :: nssl_cnoh
real , DIMENSION(max_domains) :: nssl_cnohl
real , DIMENSION(max_domains) :: nssl_cnor
real , DIMENSION(max_domains) :: nssl_cnos
real , DIMENSION(max_domains) :: nssl_rho_qh
real , DIMENSION(max_domains) :: nssl_rho_qhl
real , DIMENSION(max_domains) :: nssl_rho_qs
integer , DIMENSION(max_domains) :: nudge_lightning
integer , DIMENSION(max_domains) :: nudge_light_times
integer , DIMENSION(max_domains) :: nudge_light_timee
integer , DIMENSION(max_domains) :: nudge_light_int
character*256 :: path_to_files
integer :: gsfcgce_hail
integer :: gsfcgce_2ice
integer , DIMENSION(max_domains) :: progn
real :: accum_mode
real :: aitken_mode
real :: coarse_mode
integer :: do_radar_ref
integer :: compute_radar_ref
integer , DIMENSION(max_domains) :: ra_lw_physics
integer , DIMENSION(max_domains) :: ra_sw_physics
real , DIMENSION(max_domains) :: radt
real , DIMENSION(max_domains) :: naer
integer , DIMENSION(max_domains) :: sf_sfclay_physics
integer , DIMENSION(max_domains) :: sf_surface_physics
integer , DIMENSION(max_domains) :: bl_pbl_physics
integer , DIMENSION(max_domains) :: bl_mynn_tkebudget
integer :: ysu_topdown_pblmix
integer , DIMENSION(max_domains) :: shinhong_tke_diag
logical , DIMENSION(max_domains) :: bl_mynn_tkeadvect
integer :: bl_mynn_cloudpdf
integer :: bl_mynn_mixlength
integer , DIMENSION(max_domains) :: bl_mynn_edmf
integer , DIMENSION(max_domains) :: bl_mynn_edmf_mom
integer , DIMENSION(max_domains) :: bl_mynn_edmf_tke
integer , DIMENSION(max_domains) :: bl_mynn_mixscalars
integer , DIMENSION(max_domains) :: bl_mynn_cloudmix
integer , DIMENSION(max_domains) :: bl_mynn_mixqt
integer :: icloud_bl
integer , DIMENSION(max_domains) :: mfshconv
integer , DIMENSION(max_domains) :: sf_urban_physics
real , DIMENSION(max_domains) :: bldt
integer , DIMENSION(max_domains) :: cu_physics
integer , DIMENSION(max_domains) :: shcu_physics
integer , DIMENSION(max_domains) :: cu_diag
integer , DIMENSION(max_domains) :: kf_edrates
integer :: kfeta_trigger
integer :: nsas_dx_factor
real , DIMENSION(max_domains) :: cudt
real , DIMENSION(max_domains) :: gsmdt
integer :: isfflx
integer :: ifsnow
integer :: icloud
integer :: cldovrlp
integer :: ideal_xland
real :: swrad_scat
integer :: surface_input_source
integer :: num_soil_layers
integer :: maxpatch
integer :: num_snow_layers
integer :: num_snso_layers
integer :: num_urban_ndm
integer :: num_urban_ng
integer :: num_urban_nwr
integer :: num_urban_ngb
integer :: num_urban_nf
integer :: num_urban_nz
integer :: num_urban_nbui
integer :: urban_map_zrd
integer :: urban_map_zwd
integer :: urban_map_gd
integer :: urban_map_zd
integer :: urban_map_zdf
integer :: urban_map_bd
integer :: urban_map_wd
integer :: urban_map_gbd
integer :: urban_map_fbd
integer :: num_urban_hi
integer :: num_months
integer :: sf_surface_mosaic
integer :: mosaic_cat
integer :: mosaic_cat_soil
integer :: mosaic_lu
integer :: mosaic_soil
integer :: flag_sm_adj
integer :: maxiens
integer :: maxens
integer :: maxens2
integer :: maxens3
integer :: ensdim
integer :: cugd_avedx
integer :: clos_choice
integer :: imomentum
integer :: ishallow
real :: convtrans_avglen_m
integer :: num_land_cat
integer :: num_soil_cat
integer :: mp_zero_out
real :: mp_zero_out_thresh
real :: seaice_threshold
integer :: sst_update
integer :: sst_skin
integer :: tmn_update
logical :: usemonalb
logical :: rdmaxalb
logical :: rdlai2d
logical :: ua_phys
integer :: opt_thcnd
integer :: co2tf
integer :: ra_call_offset
real :: cam_abs_freq_s
integer :: levsiz
integer :: paerlev
integer :: cam_abs_dim1
integer :: cam_abs_dim2
integer :: lagday
integer :: no_src_types
integer :: alevsiz
integer :: o3input
integer :: aer_opt
integer :: swint_opt
integer , DIMENSION(max_domains) :: aer_type
integer , DIMENSION(max_domains) :: aer_aod550_opt
integer , DIMENSION(max_domains) :: aer_angexp_opt
integer , DIMENSION(max_domains) :: aer_ssa_opt
integer , DIMENSION(max_domains) :: aer_asy_opt
real , DIMENSION(max_domains) :: aer_aod550_val
real , DIMENSION(max_domains) :: aer_angexp_val
real , DIMENSION(max_domains) :: aer_ssa_val
real , DIMENSION(max_domains) :: aer_asy_val
logical , DIMENSION(max_domains) :: cu_rad_feedback
integer :: dust_emis
integer :: erosion_dim
integer :: no_src_types_cu
integer :: alevsiz_cu
integer :: aercu_opt
real :: aercu_fct
integer :: aercu_used
logical , DIMENSION(max_domains) :: shallowcu_forced_ra
integer , DIMENSION(max_domains) :: numbins
real , DIMENSION(max_domains) :: thbinsize
real , DIMENSION(max_domains) :: rbinsize
real , DIMENSION(max_domains) :: mindeepfreq
real , DIMENSION(max_domains) :: minshallowfreq
integer , DIMENSION(max_domains) :: shcu_aerosols_opt
integer , DIMENSION(max_domains) :: icloud_cu
integer , DIMENSION(max_domains) :: pxlsm_smois_init
integer , DIMENSION(max_domains) :: pxlsm_modis_veg
integer :: omlcall
integer :: sf_ocean_physics
integer :: traj_opt
logical , DIMENSION(max_domains) :: dm_has_traj
integer :: tracercall
real :: omdt
real :: oml_hml0
real :: oml_gamma
real :: oml_relaxation_time
integer :: isftcflx
integer :: iz0tlnd
real :: shadlen
integer , DIMENSION(max_domains) :: slope_rad
integer , DIMENSION(max_domains) :: topo_shading
integer , DIMENSION(max_domains) :: topo_wind
integer :: no_mp_heating
integer :: fractional_seaice
integer :: seaice_snowdepth_opt
real :: seaice_snowdepth_max
real :: seaice_snowdepth_min
integer :: seaice_albedo_opt
real :: seaice_albedo_default
integer :: seaice_thickness_opt
real :: seaice_thickness_default
logical :: tice2tsk_if2cold
real :: bucket_mm
real :: bucket_j
real :: mp_tend_lim
real , DIMENSION(max_domains) :: prec_acc_dt
integer :: prec_acc_opt
integer :: bucketr_opt
integer :: bucketf_opt
integer :: process_time_series
integer , DIMENSION(max_domains) :: grav_settling
real , DIMENSION(max_domains) :: sas_pgcon
integer , DIMENSION(max_domains) :: scalar_pblmix
integer , DIMENSION(max_domains) :: tracer_pblmix
logical :: use_aero_icbc
logical :: use_rap_aero_icbc
integer :: use_mp_re
real :: ccn_conc
integer :: hail_opt
integer :: morr_rimed_ice
integer :: clean_atm_diag
integer :: calc_clean_atm_diag
integer :: dveg
integer :: opt_crs
integer :: opt_btr
integer :: opt_run
integer :: opt_sfc
integer :: opt_frz
integer :: opt_inf
integer :: opt_rad
integer :: opt_alb
integer :: opt_snf
integer :: opt_tbot
integer :: opt_stc
integer :: opt_gla
integer :: opt_rsf
integer :: opt_soil
integer :: opt_pedo
integer :: opt_crop
real , DIMENSION(max_domains) :: wtddt
integer :: wrf_hydro
real , DIMENSION(max_domains) :: fgdt
integer , DIMENSION(max_domains) :: fgdtzero
integer , DIMENSION(max_domains) :: grid_fdda
integer , DIMENSION(max_domains) :: grid_sfdda
integer , DIMENSION(max_domains) :: if_no_pbl_nudging_uv
integer , DIMENSION(max_domains) :: if_no_pbl_nudging_t
integer , DIMENSION(max_domains) :: if_no_pbl_nudging_ph
integer , DIMENSION(max_domains) :: if_no_pbl_nudging_q
integer , DIMENSION(max_domains) :: if_zfac_uv
integer , DIMENSION(max_domains) :: k_zfac_uv
integer , DIMENSION(max_domains) :: if_zfac_t
integer , DIMENSION(max_domains) :: k_zfac_t
integer , DIMENSION(max_domains) :: if_zfac_ph
integer , DIMENSION(max_domains) :: k_zfac_ph
integer , DIMENSION(max_domains) :: if_zfac_q
integer , DIMENSION(max_domains) :: k_zfac_q
integer , DIMENSION(max_domains) :: dk_zfac_uv
integer , DIMENSION(max_domains) :: dk_zfac_t
integer , DIMENSION(max_domains) :: dk_zfac_ph
integer , DIMENSION(max_domains) :: dk_zfac_q
integer :: ktrop
real , DIMENSION(max_domains) :: guv
real , DIMENSION(max_domains) :: guv_sfc
real , DIMENSION(max_domains) :: gt
real , DIMENSION(max_domains) :: gt_sfc
real , DIMENSION(max_domains) :: gq
real , DIMENSION(max_domains) :: gq_sfc
real , DIMENSION(max_domains) :: gph
real :: dtramp_min
integer :: if_ramping
real , DIMENSION(max_domains) :: rinblw
integer , DIMENSION(max_domains) :: xwavenum
integer , DIMENSION(max_domains) :: ywavenum
integer , DIMENSION(max_domains) :: pxlsm_soil_nudge
integer , DIMENSION(max_domains) :: fasdas
integer , DIMENSION(max_domains) :: obs_nudge_opt
integer :: max_obs
real , DIMENSION(max_domains) :: fdda_start
real , DIMENSION(max_domains) :: fdda_end
integer , DIMENSION(max_domains) :: obs_nudge_wind
real , DIMENSION(max_domains) :: obs_coef_wind
integer , DIMENSION(max_domains) :: obs_nudge_temp
real , DIMENSION(max_domains) :: obs_coef_temp
integer , DIMENSION(max_domains) :: obs_nudge_mois
real , DIMENSION(max_domains) :: obs_coef_mois
integer , DIMENSION(max_domains) :: obs_nudge_pstr
real , DIMENSION(max_domains) :: obs_coef_pstr
integer , DIMENSION(max_domains) :: obs_no_pbl_nudge_uv
integer , DIMENSION(max_domains) :: obs_no_pbl_nudge_t
integer , DIMENSION(max_domains) :: obs_no_pbl_nudge_q
integer :: obs_sfc_scheme_horiz
integer :: obs_sfc_scheme_vert
real :: obs_max_sndng_gap
real :: obs_nudgezfullr1_uv
real :: obs_nudgezrampr1_uv
real :: obs_nudgezfullr2_uv
real :: obs_nudgezrampr2_uv
real :: obs_nudgezfullr4_uv
real :: obs_nudgezrampr4_uv
real :: obs_nudgezfullr1_t
real :: obs_nudgezrampr1_t
real :: obs_nudgezfullr2_t
real :: obs_nudgezrampr2_t
real :: obs_nudgezfullr4_t
real :: obs_nudgezrampr4_t
real :: obs_nudgezfullr1_q
real :: obs_nudgezrampr1_q
real :: obs_nudgezfullr2_q
real :: obs_nudgezrampr2_q
real :: obs_nudgezfullr4_q
real :: obs_nudgezrampr4_q
real :: obs_nudgezfullmin
real :: obs_nudgezrampmin
real :: obs_nudgezmax
real :: obs_sfcfact
real :: obs_sfcfacr
real :: obs_dpsmx
real , DIMENSION(max_domains) :: obs_rinxy
real :: obs_rinsig
real , DIMENSION(max_domains) :: obs_twindo
integer :: obs_npfi
integer , DIMENSION(max_domains) :: obs_ionf
integer :: obs_idynin
real :: obs_dtramp
integer :: obs_prt_max
integer , DIMENSION(max_domains) :: obs_prt_freq
logical :: obs_ipf_in4dob
logical :: obs_ipf_errob
logical :: obs_ipf_nudob
logical :: obs_ipf_init
integer :: obs_scl_neg_qv_innov
integer :: scm_force
real :: scm_force_dx
integer :: num_force_layers
integer :: scm_lu_index
integer :: scm_isltyp
real :: scm_vegfra
real :: scm_canwat
real :: scm_lat
real :: scm_lon
logical :: scm_th_t_tend
logical :: scm_qv_t_tend
logical :: scm_th_adv
logical :: scm_wind_adv
logical :: scm_qv_adv
logical :: scm_ql_adv
logical :: scm_vert_adv
integer :: num_force_soil_layers
logical :: scm_soilt_force
logical :: scm_soilq_force
logical :: scm_force_th_largescale
logical :: scm_force_qv_largescale
logical :: scm_force_ql_largescale
logical :: scm_force_wind_largescale
integer :: scm_force_skintemp
integer :: scm_force_flux
integer :: dyn_opt
integer :: rk_ord
integer :: w_damping
integer , DIMENSION(max_domains) :: diff_opt
integer , DIMENSION(max_domains) :: diff_opt_dfi
integer , DIMENSION(max_domains) :: km_opt
integer , DIMENSION(max_domains) :: km_opt_dfi
integer :: damp_opt
integer :: rad_nudge
integer :: gwd_opt
real :: max_rot_angle_gwd
real , DIMENSION(max_domains) :: zdamp
real , DIMENSION(max_domains) :: dampcoef
real , DIMENSION(max_domains) :: khdif
real , DIMENSION(max_domains) :: kvdif
real , DIMENSION(max_domains) :: diff_6th_factor
integer , DIMENSION(max_domains) :: diff_6th_opt
integer , DIMENSION(max_domains) :: diff_6th_slopeopt
real , DIMENSION(max_domains) :: diff_6th_thresh
integer :: use_theta_m
integer :: use_q_diabatic
real , DIMENSION(max_domains) :: c_s
real , DIMENSION(max_domains) :: c_k
real , DIMENSION(max_domains) :: smdiv
real , DIMENSION(max_domains) :: emdiv
real , DIMENSION(max_domains) :: epssm
logical , DIMENSION(max_domains) :: non_hydrostatic
logical :: use_input_w
integer , DIMENSION(max_domains) :: time_step_sound
integer , DIMENSION(max_domains) :: h_mom_adv_order
integer , DIMENSION(max_domains) :: v_mom_adv_order
integer , DIMENSION(max_domains) :: h_sca_adv_order
integer , DIMENSION(max_domains) :: v_sca_adv_order
integer , DIMENSION(max_domains) :: momentum_adv_opt
integer , DIMENSION(max_domains) :: moist_adv_opt
integer , DIMENSION(max_domains) :: moist_adv_dfi_opt
integer , DIMENSION(max_domains) :: chem_adv_opt
integer , DIMENSION(max_domains) :: tracer_adv_opt
integer , DIMENSION(max_domains) :: scalar_adv_opt
integer , DIMENSION(max_domains) :: tke_adv_opt
logical , DIMENSION(max_domains) :: moist_mix2_off
logical , DIMENSION(max_domains) :: chem_mix2_off
logical , DIMENSION(max_domains) :: tracer_mix2_off
logical , DIMENSION(max_domains) :: scalar_mix2_off
logical , DIMENSION(max_domains) :: tke_mix2_off
logical , DIMENSION(max_domains) :: moist_mix6_off
logical , DIMENSION(max_domains) :: chem_mix6_off
logical , DIMENSION(max_domains) :: tracer_mix6_off
logical , DIMENSION(max_domains) :: scalar_mix6_off
logical , DIMENSION(max_domains) :: tke_mix6_off
logical , DIMENSION(max_domains) :: top_radiation
integer , DIMENSION(max_domains) :: mix_isotropic
real , DIMENSION(max_domains) :: mix_upper_bound
logical , DIMENSION(max_domains) :: top_lid
real , DIMENSION(max_domains) :: tke_upper_bound
real , DIMENSION(max_domains) :: tke_drag_coefficient
real , DIMENSION(max_domains) :: tke_heat_flux
logical , DIMENSION(max_domains) :: pert_coriolis
logical , DIMENSION(max_domains) :: coriolis2d
logical , DIMENSION(max_domains) :: mix_full_fields
real :: base_pres
real :: base_temp
real :: base_lapse
real :: iso_temp
real :: base_pres_strat
real :: base_lapse_strat
logical :: use_baseparam_fr_nml
real :: fft_filter_lat
logical :: coupled_filtering
logical :: pos_def
logical :: swap_pole_with_next_j
logical :: actual_distance_average
logical :: rotated_pole
logical , DIMENSION(max_domains) :: do_coriolis
logical , DIMENSION(max_domains) :: do_curvature
logical , DIMENSION(max_domains) :: do_gradp
integer , DIMENSION(max_domains) :: tracer_opt
integer , DIMENSION(max_domains) :: tenddiag
integer :: spec_bdy_width
integer :: spec_zone
integer :: relax_zone
logical , DIMENSION(max_domains) :: specified
logical :: constant_bc
logical , DIMENSION(max_domains) :: periodic_x
logical , DIMENSION(max_domains) :: symmetric_xs
logical , DIMENSION(max_domains) :: symmetric_xe
logical , DIMENSION(max_domains) :: open_xs
logical , DIMENSION(max_domains) :: open_xe
logical , DIMENSION(max_domains) :: periodic_y
logical , DIMENSION(max_domains) :: symmetric_ys
logical , DIMENSION(max_domains) :: symmetric_ye
logical , DIMENSION(max_domains) :: open_ys
logical , DIMENSION(max_domains) :: open_ye
logical , DIMENSION(max_domains) :: polar
logical , DIMENSION(max_domains) :: nested
real :: spec_exp
integer :: spec_bdy_final_mu
integer :: real_data_init_type
logical , DIMENSION(max_domains) :: have_bcs_moist
logical , DIMENSION(max_domains) :: have_bcs_scalar
integer :: background_proc_id
integer :: forecast_proc_id
integer :: production_status
integer :: compression
integer :: nobs_ndg_vars
integer :: nobs_err_flds
real , DIMENSION(max_domains) :: cen_lat
real , DIMENSION(max_domains) :: cen_lon
real , DIMENSION(max_domains) :: truelat1
real , DIMENSION(max_domains) :: truelat2
real , DIMENSION(max_domains) :: moad_cen_lat
real , DIMENSION(max_domains) :: stand_lon
real , DIMENSION(max_domains) :: pole_lat
real , DIMENSION(max_domains) :: pole_lon
integer :: flag_metgrid
integer :: flag_snow
integer :: flag_psfc
integer :: flag_sm000010
integer :: flag_sm010040
integer :: flag_sm040100
integer :: flag_sm100200
integer :: flag_st000010
integer :: flag_st010040
integer :: flag_st040100
integer :: flag_st100200
integer :: flag_soil_layers
integer :: flag_slp
integer :: flag_soilhgt
integer :: flag_mf_xy
integer :: flag_um_soil
real , DIMENSION(max_domains) :: bdyfrq
character*256 , DIMENSION(max_domains) :: mminlu
integer , DIMENSION(max_domains) :: iswater
integer , DIMENSION(max_domains) :: islake
integer , DIMENSION(max_domains) :: isice
integer , DIMENSION(max_domains) :: isurban
integer , DIMENSION(max_domains) :: isoilwater
integer , DIMENSION(max_domains) :: map_proj
integer :: use_wps_input
integer , DIMENSION(max_domains) :: dfi_stage
integer , DIMENSION(max_domains) :: mp_physics_dfi
integer , DIMENSION(max_domains) :: bl_pbl_physics_dfi
integer , DIMENSION(max_domains) :: windfarm_opt
integer :: windfarm_ij
integer :: ideal_case
integer , DIMENSION(max_domains) :: hailcast_opt
real , DIMENSION(max_domains) :: haildt
integer , DIMENSION(max_domains) :: lightning_option
real , DIMENSION(max_domains) :: lightning_dt
real , DIMENSION(max_domains) :: lightning_start_seconds
real , DIMENSION(max_domains) :: flashrate_factor
integer , DIMENSION(max_domains) :: iccg_method
real , DIMENSION(max_domains) :: iccg_prescribed_num
real , DIMENSION(max_domains) :: iccg_prescribed_den
integer , DIMENSION(max_domains) :: cellcount_method
real , DIMENSION(max_domains) :: cldtop_adjustment
integer , DIMENSION(max_domains) :: sf_lake_physics
character*256 :: auxinput1_inname
integer :: io_form_auxinput1
logical :: override_restart_timers
character*256 :: auxhist1_inname
character*256 :: auxhist1_outname
integer , DIMENSION(max_domains) :: auxhist1_interval_y
integer , DIMENSION(max_domains) :: auxhist1_interval_d
integer , DIMENSION(max_domains) :: auxhist1_interval_h
integer , DIMENSION(max_domains) :: auxhist1_interval_m
integer , DIMENSION(max_domains) :: auxhist1_interval_s
integer , DIMENSION(max_domains) :: auxhist1_interval
integer , DIMENSION(max_domains) :: auxhist1_begin_y
integer , DIMENSION(max_domains) :: auxhist1_begin_d
integer , DIMENSION(max_domains) :: auxhist1_begin_h
integer , DIMENSION(max_domains) :: auxhist1_begin_m
integer , DIMENSION(max_domains) :: auxhist1_begin_s
integer , DIMENSION(max_domains) :: auxhist1_begin
integer , DIMENSION(max_domains) :: auxhist1_end_y
integer , DIMENSION(max_domains) :: auxhist1_end_d
integer , DIMENSION(max_domains) :: auxhist1_end_h
integer , DIMENSION(max_domains) :: auxhist1_end_m
integer , DIMENSION(max_domains) :: auxhist1_end_s
integer , DIMENSION(max_domains) :: auxhist1_end
integer :: io_form_auxhist1
integer , DIMENSION(max_domains) :: frames_per_auxhist1
character*256 :: auxhist2_inname
character*256 :: auxhist2_outname
integer , DIMENSION(max_domains) :: auxhist2_interval_y
integer , DIMENSION(max_domains) :: auxhist2_interval_d
integer , DIMENSION(max_domains) :: auxhist2_interval_h
integer , DIMENSION(max_domains) :: auxhist2_interval_m
integer , DIMENSION(max_domains) :: auxhist2_interval_s
integer , DIMENSION(max_domains) :: auxhist2_interval
integer , DIMENSION(max_domains) :: auxhist2_begin_y
integer , DIMENSION(max_domains) :: auxhist2_begin_d
integer , DIMENSION(max_domains) :: auxhist2_begin_h
integer , DIMENSION(max_domains) :: auxhist2_begin_m
integer , DIMENSION(max_domains) :: auxhist2_begin_s
integer , DIMENSION(max_domains) :: auxhist2_begin
integer , DIMENSION(max_domains) :: auxhist2_end_y
integer , DIMENSION(max_domains) :: auxhist2_end_d
integer , DIMENSION(max_domains) :: auxhist2_end_h
integer , DIMENSION(max_domains) :: auxhist2_end_m
integer , DIMENSION(max_domains) :: auxhist2_end_s
integer , DIMENSION(max_domains) :: auxhist2_end
integer :: io_form_auxhist2
integer , DIMENSION(max_domains) :: frames_per_auxhist2
character*256 :: auxhist3_inname
character*256 :: auxhist3_outname
integer , DIMENSION(max_domains) :: auxhist3_interval_y
integer , DIMENSION(max_domains) :: auxhist3_interval_d
integer , DIMENSION(max_domains) :: auxhist3_interval_h
integer , DIMENSION(max_domains) :: auxhist3_interval_m
integer , DIMENSION(max_domains) :: auxhist3_interval_s
integer , DIMENSION(max_domains) :: auxhist3_interval
integer , DIMENSION(max_domains) :: auxhist3_begin_y
integer , DIMENSION(max_domains) :: auxhist3_begin_d
integer , DIMENSION(max_domains) :: auxhist3_begin_h
integer , DIMENSION(max_domains) :: auxhist3_begin_m
integer , DIMENSION(max_domains) :: auxhist3_begin_s
integer , DIMENSION(max_domains) :: auxhist3_begin
integer , DIMENSION(max_domains) :: auxhist3_end_y
integer , DIMENSION(max_domains) :: auxhist3_end_d
integer , DIMENSION(max_domains) :: auxhist3_end_h
integer , DIMENSION(max_domains) :: auxhist3_end_m
integer , DIMENSION(max_domains) :: auxhist3_end_s
integer , DIMENSION(max_domains) :: auxhist3_end
integer :: io_form_auxhist3
integer , DIMENSION(max_domains) :: frames_per_auxhist3
character*256 :: auxhist4_inname
character*256 :: auxhist4_outname
integer , DIMENSION(max_domains) :: auxhist4_interval_y
integer , DIMENSION(max_domains) :: auxhist4_interval_d
integer , DIMENSION(max_domains) :: auxhist4_interval_h
integer , DIMENSION(max_domains) :: auxhist4_interval_m
integer , DIMENSION(max_domains) :: auxhist4_interval_s
integer , DIMENSION(max_domains) :: auxhist4_interval
integer , DIMENSION(max_domains) :: auxhist4_begin_y
integer , DIMENSION(max_domains) :: auxhist4_begin_d
integer , DIMENSION(max_domains) :: auxhist4_begin_h
integer , DIMENSION(max_domains) :: auxhist4_begin_m
integer , DIMENSION(max_domains) :: auxhist4_begin_s
integer , DIMENSION(max_domains) :: auxhist4_begin
integer , DIMENSION(max_domains) :: auxhist4_end_y
integer , DIMENSION(max_domains) :: auxhist4_end_d
integer , DIMENSION(max_domains) :: auxhist4_end_h
integer , DIMENSION(max_domains) :: auxhist4_end_m
integer , DIMENSION(max_domains) :: auxhist4_end_s
integer , DIMENSION(max_domains) :: auxhist4_end
integer :: io_form_auxhist4
integer , DIMENSION(max_domains) :: frames_per_auxhist4
character*256 :: auxhist5_inname
character*256 :: auxhist5_outname
integer , DIMENSION(max_domains) :: auxhist5_interval_y
integer , DIMENSION(max_domains) :: auxhist5_interval_d
integer , DIMENSION(max_domains) :: auxhist5_interval_h
integer , DIMENSION(max_domains) :: auxhist5_interval_m
integer , DIMENSION(max_domains) :: auxhist5_interval_s
integer , DIMENSION(max_domains) :: auxhist5_interval
integer , DIMENSION(max_domains) :: auxhist5_begin_y
integer , DIMENSION(max_domains) :: auxhist5_begin_d
integer , DIMENSION(max_domains) :: auxhist5_begin_h
integer , DIMENSION(max_domains) :: auxhist5_begin_m
integer , DIMENSION(max_domains) :: auxhist5_begin_s
integer , DIMENSION(max_domains) :: auxhist5_begin
integer , DIMENSION(max_domains) :: auxhist5_end_y
integer , DIMENSION(max_domains) :: auxhist5_end_d
integer , DIMENSION(max_domains) :: auxhist5_end_h
integer , DIMENSION(max_domains) :: auxhist5_end_m
integer , DIMENSION(max_domains) :: auxhist5_end_s
integer , DIMENSION(max_domains) :: auxhist5_end
integer :: io_form_auxhist5
integer , DIMENSION(max_domains) :: frames_per_auxhist5
character*256 :: auxhist6_inname
character*256 :: auxhist6_outname
integer , DIMENSION(max_domains) :: auxhist6_interval_y
integer , DIMENSION(max_domains) :: auxhist6_interval_d
integer , DIMENSION(max_domains) :: auxhist6_interval_h
integer , DIMENSION(max_domains) :: auxhist6_interval_m
integer , DIMENSION(max_domains) :: auxhist6_interval_s
integer , DIMENSION(max_domains) :: auxhist6_interval
integer , DIMENSION(max_domains) :: auxhist6_begin_y
integer , DIMENSION(max_domains) :: auxhist6_begin_d
integer , DIMENSION(max_domains) :: auxhist6_begin_h
integer , DIMENSION(max_domains) :: auxhist6_begin_m
integer , DIMENSION(max_domains) :: auxhist6_begin_s
integer , DIMENSION(max_domains) :: auxhist6_begin
integer , DIMENSION(max_domains) :: auxhist6_end_y
integer , DIMENSION(max_domains) :: auxhist6_end_d
integer , DIMENSION(max_domains) :: auxhist6_end_h
integer , DIMENSION(max_domains) :: auxhist6_end_m
integer , DIMENSION(max_domains) :: auxhist6_end_s
integer , DIMENSION(max_domains) :: auxhist6_end
integer :: io_form_auxhist6
integer , DIMENSION(max_domains) :: frames_per_auxhist6
character*256 :: auxhist7_inname
character*256 :: auxhist7_outname
integer , DIMENSION(max_domains) :: auxhist7_interval_y
integer , DIMENSION(max_domains) :: auxhist7_interval_d
integer , DIMENSION(max_domains) :: auxhist7_interval_h
integer , DIMENSION(max_domains) :: auxhist7_interval_m
integer , DIMENSION(max_domains) :: auxhist7_interval_s
integer , DIMENSION(max_domains) :: auxhist7_interval
integer , DIMENSION(max_domains) :: auxhist7_begin_y
integer , DIMENSION(max_domains) :: auxhist7_begin_d
integer , DIMENSION(max_domains) :: auxhist7_begin_h
integer , DIMENSION(max_domains) :: auxhist7_begin_m
integer , DIMENSION(max_domains) :: auxhist7_begin_s
integer , DIMENSION(max_domains) :: auxhist7_begin
integer , DIMENSION(max_domains) :: auxhist7_end_y
integer , DIMENSION(max_domains) :: auxhist7_end_d
integer , DIMENSION(max_domains) :: auxhist7_end_h
integer , DIMENSION(max_domains) :: auxhist7_end_m
integer , DIMENSION(max_domains) :: auxhist7_end_s
integer , DIMENSION(max_domains) :: auxhist7_end
integer :: io_form_auxhist7
integer , DIMENSION(max_domains) :: frames_per_auxhist7
character*256 :: auxhist8_inname
character*256 :: auxhist8_outname
integer , DIMENSION(max_domains) :: auxhist8_interval_y
integer , DIMENSION(max_domains) :: auxhist8_interval_d
integer , DIMENSION(max_domains) :: auxhist8_interval_h
integer , DIMENSION(max_domains) :: auxhist8_interval_m
integer , DIMENSION(max_domains) :: auxhist8_interval_s
integer , DIMENSION(max_domains) :: auxhist8_interval
integer , DIMENSION(max_domains) :: auxhist8_begin_y
integer , DIMENSION(max_domains) :: auxhist8_begin_d
integer , DIMENSION(max_domains) :: auxhist8_begin_h
integer , DIMENSION(max_domains) :: auxhist8_begin_m
integer , DIMENSION(max_domains) :: auxhist8_begin_s
integer , DIMENSION(max_domains) :: auxhist8_begin
integer , DIMENSION(max_domains) :: auxhist8_end_y
integer , DIMENSION(max_domains) :: auxhist8_end_d
integer , DIMENSION(max_domains) :: auxhist8_end_h
integer , DIMENSION(max_domains) :: auxhist8_end_m
integer , DIMENSION(max_domains) :: auxhist8_end_s
integer , DIMENSION(max_domains) :: auxhist8_end
integer :: io_form_auxhist8
integer , DIMENSION(max_domains) :: frames_per_auxhist8
character*256 :: auxhist9_inname
character*256 :: auxhist9_outname
integer , DIMENSION(max_domains) :: auxhist9_interval_y
integer , DIMENSION(max_domains) :: auxhist9_interval_d
integer , DIMENSION(max_domains) :: auxhist9_interval_h
integer , DIMENSION(max_domains) :: auxhist9_interval_m
integer , DIMENSION(max_domains) :: auxhist9_interval_s
integer , DIMENSION(max_domains) :: auxhist9_interval
integer , DIMENSION(max_domains) :: auxhist9_begin_y
integer , DIMENSION(max_domains) :: auxhist9_begin_d
integer , DIMENSION(max_domains) :: auxhist9_begin_h
integer , DIMENSION(max_domains) :: auxhist9_begin_m
integer , DIMENSION(max_domains) :: auxhist9_begin_s
integer , DIMENSION(max_domains) :: auxhist9_begin
integer , DIMENSION(max_domains) :: auxhist9_end_y
integer , DIMENSION(max_domains) :: auxhist9_end_d
integer , DIMENSION(max_domains) :: auxhist9_end_h
integer , DIMENSION(max_domains) :: auxhist9_end_m
integer , DIMENSION(max_domains) :: auxhist9_end_s
integer , DIMENSION(max_domains) :: auxhist9_end
integer :: io_form_auxhist9
integer , DIMENSION(max_domains) :: frames_per_auxhist9
character*256 :: auxhist10_inname
character*256 :: auxhist10_outname
integer , DIMENSION(max_domains) :: auxhist10_interval_y
integer , DIMENSION(max_domains) :: auxhist10_interval_d
integer , DIMENSION(max_domains) :: auxhist10_interval_h
integer , DIMENSION(max_domains) :: auxhist10_interval_m
integer , DIMENSION(max_domains) :: auxhist10_interval_s
integer , DIMENSION(max_domains) :: auxhist10_interval
integer , DIMENSION(max_domains) :: auxhist10_begin_y
integer , DIMENSION(max_domains) :: auxhist10_begin_d
integer , DIMENSION(max_domains) :: auxhist10_begin_h
integer , DIMENSION(max_domains) :: auxhist10_begin_m
integer , DIMENSION(max_domains) :: auxhist10_begin_s
integer , DIMENSION(max_domains) :: auxhist10_begin
integer , DIMENSION(max_domains) :: auxhist10_end_y
integer , DIMENSION(max_domains) :: auxhist10_end_d
integer , DIMENSION(max_domains) :: auxhist10_end_h
integer , DIMENSION(max_domains) :: auxhist10_end_m
integer , DIMENSION(max_domains) :: auxhist10_end_s
integer , DIMENSION(max_domains) :: auxhist10_end
integer :: io_form_auxhist10
integer , DIMENSION(max_domains) :: frames_per_auxhist10
character*256 :: auxhist11_inname
character*256 :: auxhist11_outname
integer , DIMENSION(max_domains) :: auxhist11_interval_y
integer , DIMENSION(max_domains) :: auxhist11_interval_d
integer , DIMENSION(max_domains) :: auxhist11_interval_h
integer , DIMENSION(max_domains) :: auxhist11_interval_m
integer , DIMENSION(max_domains) :: auxhist11_interval_s
integer , DIMENSION(max_domains) :: auxhist11_interval
integer , DIMENSION(max_domains) :: auxhist11_begin_y
integer , DIMENSION(max_domains) :: auxhist11_begin_d
integer , DIMENSION(max_domains) :: auxhist11_begin_h
integer , DIMENSION(max_domains) :: auxhist11_begin_m
integer , DIMENSION(max_domains) :: auxhist11_begin_s
integer , DIMENSION(max_domains) :: auxhist11_begin
integer , DIMENSION(max_domains) :: auxhist11_end_y
integer , DIMENSION(max_domains) :: auxhist11_end_d
integer , DIMENSION(max_domains) :: auxhist11_end_h
integer , DIMENSION(max_domains) :: auxhist11_end_m
integer , DIMENSION(max_domains) :: auxhist11_end_s
integer , DIMENSION(max_domains) :: auxhist11_end
integer :: io_form_auxhist11
integer , DIMENSION(max_domains) :: frames_per_auxhist11
character*256 :: auxhist12_inname
character*256 :: auxhist12_outname
integer , DIMENSION(max_domains) :: auxhist12_interval_y
integer , DIMENSION(max_domains) :: auxhist12_interval_d
integer , DIMENSION(max_domains) :: auxhist12_interval_h
integer , DIMENSION(max_domains) :: auxhist12_interval_m
integer , DIMENSION(max_domains) :: auxhist12_interval_s
integer , DIMENSION(max_domains) :: auxhist12_interval
integer , DIMENSION(max_domains) :: auxhist12_begin_y
integer , DIMENSION(max_domains) :: auxhist12_begin_d
integer , DIMENSION(max_domains) :: auxhist12_begin_h
integer , DIMENSION(max_domains) :: auxhist12_begin_m
integer , DIMENSION(max_domains) :: auxhist12_begin_s
integer , DIMENSION(max_domains) :: auxhist12_begin
integer , DIMENSION(max_domains) :: auxhist12_end_y
integer , DIMENSION(max_domains) :: auxhist12_end_d
integer , DIMENSION(max_domains) :: auxhist12_end_h
integer , DIMENSION(max_domains) :: auxhist12_end_m
integer , DIMENSION(max_domains) :: auxhist12_end_s
integer , DIMENSION(max_domains) :: auxhist12_end
integer :: io_form_auxhist12
integer , DIMENSION(max_domains) :: frames_per_auxhist12
character*256 :: auxhist13_inname
character*256 :: auxhist13_outname
integer , DIMENSION(max_domains) :: auxhist13_interval_y
integer , DIMENSION(max_domains) :: auxhist13_interval_d
integer , DIMENSION(max_domains) :: auxhist13_interval_h
integer , DIMENSION(max_domains) :: auxhist13_interval_m
integer , DIMENSION(max_domains) :: auxhist13_interval_s
integer , DIMENSION(max_domains) :: auxhist13_interval
integer , DIMENSION(max_domains) :: auxhist13_begin_y
integer , DIMENSION(max_domains) :: auxhist13_begin_d
integer , DIMENSION(max_domains) :: auxhist13_begin_h
integer , DIMENSION(max_domains) :: auxhist13_begin_m
integer , DIMENSION(max_domains) :: auxhist13_begin_s
integer , DIMENSION(max_domains) :: auxhist13_begin
integer , DIMENSION(max_domains) :: auxhist13_end_y
integer , DIMENSION(max_domains) :: auxhist13_end_d
integer , DIMENSION(max_domains) :: auxhist13_end_h
integer , DIMENSION(max_domains) :: auxhist13_end_m
integer , DIMENSION(max_domains) :: auxhist13_end_s
integer , DIMENSION(max_domains) :: auxhist13_end
integer :: io_form_auxhist13
integer , DIMENSION(max_domains) :: frames_per_auxhist13
character*256 :: auxhist14_inname
character*256 :: auxhist14_outname
integer , DIMENSION(max_domains) :: auxhist14_interval_y
integer , DIMENSION(max_domains) :: auxhist14_interval_d
integer , DIMENSION(max_domains) :: auxhist14_interval_h
integer , DIMENSION(max_domains) :: auxhist14_interval_m
integer , DIMENSION(max_domains) :: auxhist14_interval_s
integer , DIMENSION(max_domains) :: auxhist14_interval
integer , DIMENSION(max_domains) :: auxhist14_begin_y
integer , DIMENSION(max_domains) :: auxhist14_begin_d
integer , DIMENSION(max_domains) :: auxhist14_begin_h
integer , DIMENSION(max_domains) :: auxhist14_begin_m
integer , DIMENSION(max_domains) :: auxhist14_begin_s
integer , DIMENSION(max_domains) :: auxhist14_begin
integer , DIMENSION(max_domains) :: auxhist14_end_y
integer , DIMENSION(max_domains) :: auxhist14_end_d
integer , DIMENSION(max_domains) :: auxhist14_end_h
integer , DIMENSION(max_domains) :: auxhist14_end_m
integer , DIMENSION(max_domains) :: auxhist14_end_s
integer , DIMENSION(max_domains) :: auxhist14_end
integer :: io_form_auxhist14
integer , DIMENSION(max_domains) :: frames_per_auxhist14
character*256 :: auxhist15_inname
character*256 :: auxhist15_outname
integer , DIMENSION(max_domains) :: auxhist15_interval_y
integer , DIMENSION(max_domains) :: auxhist15_interval_d
integer , DIMENSION(max_domains) :: auxhist15_interval_h
integer , DIMENSION(max_domains) :: auxhist15_interval_m
integer , DIMENSION(max_domains) :: auxhist15_interval_s
integer , DIMENSION(max_domains) :: auxhist15_interval
integer , DIMENSION(max_domains) :: auxhist15_begin_y
integer , DIMENSION(max_domains) :: auxhist15_begin_d
integer , DIMENSION(max_domains) :: auxhist15_begin_h
integer , DIMENSION(max_domains) :: auxhist15_begin_m
integer , DIMENSION(max_domains) :: auxhist15_begin_s
integer , DIMENSION(max_domains) :: auxhist15_begin
integer , DIMENSION(max_domains) :: auxhist15_end_y
integer , DIMENSION(max_domains) :: auxhist15_end_d
integer , DIMENSION(max_domains) :: auxhist15_end_h
integer , DIMENSION(max_domains) :: auxhist15_end_m
integer , DIMENSION(max_domains) :: auxhist15_end_s
integer , DIMENSION(max_domains) :: auxhist15_end
integer :: io_form_auxhist15
integer , DIMENSION(max_domains) :: frames_per_auxhist15
character*256 :: auxhist16_inname
character*256 :: auxhist16_outname
integer , DIMENSION(max_domains) :: auxhist16_interval_y
integer , DIMENSION(max_domains) :: auxhist16_interval_d
integer , DIMENSION(max_domains) :: auxhist16_interval_h
integer , DIMENSION(max_domains) :: auxhist16_interval_m
integer , DIMENSION(max_domains) :: auxhist16_interval_s
integer , DIMENSION(max_domains) :: auxhist16_interval
integer , DIMENSION(max_domains) :: auxhist16_begin_y
integer , DIMENSION(max_domains) :: auxhist16_begin_d
integer , DIMENSION(max_domains) :: auxhist16_begin_h
integer , DIMENSION(max_domains) :: auxhist16_begin_m
integer , DIMENSION(max_domains) :: auxhist16_begin_s
integer , DIMENSION(max_domains) :: auxhist16_begin
integer , DIMENSION(max_domains) :: auxhist16_end_y
integer , DIMENSION(max_domains) :: auxhist16_end_d
integer , DIMENSION(max_domains) :: auxhist16_end_h
integer , DIMENSION(max_domains) :: auxhist16_end_m
integer , DIMENSION(max_domains) :: auxhist16_end_s
integer , DIMENSION(max_domains) :: auxhist16_end
integer :: io_form_auxhist16
integer , DIMENSION(max_domains) :: frames_per_auxhist16
character*256 :: auxhist17_inname
character*256 :: auxhist17_outname
integer , DIMENSION(max_domains) :: auxhist17_interval_y
integer , DIMENSION(max_domains) :: auxhist17_interval_d
integer , DIMENSION(max_domains) :: auxhist17_interval_h
integer , DIMENSION(max_domains) :: auxhist17_interval_m
integer , DIMENSION(max_domains) :: auxhist17_interval_s
integer , DIMENSION(max_domains) :: auxhist17_interval
integer , DIMENSION(max_domains) :: auxhist17_begin_y
integer , DIMENSION(max_domains) :: auxhist17_begin_d
integer , DIMENSION(max_domains) :: auxhist17_begin_h
integer , DIMENSION(max_domains) :: auxhist17_begin_m
integer , DIMENSION(max_domains) :: auxhist17_begin_s
integer , DIMENSION(max_domains) :: auxhist17_begin
integer , DIMENSION(max_domains) :: auxhist17_end_y
integer , DIMENSION(max_domains) :: auxhist17_end_d
integer , DIMENSION(max_domains) :: auxhist17_end_h
integer , DIMENSION(max_domains) :: auxhist17_end_m
integer , DIMENSION(max_domains) :: auxhist17_end_s
integer , DIMENSION(max_domains) :: auxhist17_end
integer :: io_form_auxhist17
integer , DIMENSION(max_domains) :: frames_per_auxhist17
character*256 :: auxhist18_inname
character*256 :: auxhist18_outname
integer , DIMENSION(max_domains) :: auxhist18_interval_y
integer , DIMENSION(max_domains) :: auxhist18_interval_d
integer , DIMENSION(max_domains) :: auxhist18_interval_h
integer , DIMENSION(max_domains) :: auxhist18_interval_m
integer , DIMENSION(max_domains) :: auxhist18_interval_s
integer , DIMENSION(max_domains) :: auxhist18_interval
integer , DIMENSION(max_domains) :: auxhist18_begin_y
integer , DIMENSION(max_domains) :: auxhist18_begin_d
integer , DIMENSION(max_domains) :: auxhist18_begin_h
integer , DIMENSION(max_domains) :: auxhist18_begin_m
integer , DIMENSION(max_domains) :: auxhist18_begin_s
integer , DIMENSION(max_domains) :: auxhist18_begin
integer , DIMENSION(max_domains) :: auxhist18_end_y
integer , DIMENSION(max_domains) :: auxhist18_end_d
integer , DIMENSION(max_domains) :: auxhist18_end_h
integer , DIMENSION(max_domains) :: auxhist18_end_m
integer , DIMENSION(max_domains) :: auxhist18_end_s
integer , DIMENSION(max_domains) :: auxhist18_end
integer :: io_form_auxhist18
integer , DIMENSION(max_domains) :: frames_per_auxhist18
character*256 :: auxhist19_inname
character*256 :: auxhist19_outname
integer , DIMENSION(max_domains) :: auxhist19_interval_y
integer , DIMENSION(max_domains) :: auxhist19_interval_d
integer , DIMENSION(max_domains) :: auxhist19_interval_h
integer , DIMENSION(max_domains) :: auxhist19_interval_m
integer , DIMENSION(max_domains) :: auxhist19_interval_s
integer , DIMENSION(max_domains) :: auxhist19_interval
integer , DIMENSION(max_domains) :: auxhist19_begin_y
integer , DIMENSION(max_domains) :: auxhist19_begin_d
integer , DIMENSION(max_domains) :: auxhist19_begin_h
integer , DIMENSION(max_domains) :: auxhist19_begin_m
integer , DIMENSION(max_domains) :: auxhist19_begin_s
integer , DIMENSION(max_domains) :: auxhist19_begin
integer , DIMENSION(max_domains) :: auxhist19_end_y
integer , DIMENSION(max_domains) :: auxhist19_end_d
integer , DIMENSION(max_domains) :: auxhist19_end_h
integer , DIMENSION(max_domains) :: auxhist19_end_m
integer , DIMENSION(max_domains) :: auxhist19_end_s
integer , DIMENSION(max_domains) :: auxhist19_end
integer :: io_form_auxhist19
integer , DIMENSION(max_domains) :: frames_per_auxhist19
character*256 :: auxhist20_inname
character*256 :: auxhist20_outname
integer , DIMENSION(max_domains) :: auxhist20_interval_y
integer , DIMENSION(max_domains) :: auxhist20_interval_d
integer , DIMENSION(max_domains) :: auxhist20_interval_h
integer , DIMENSION(max_domains) :: auxhist20_interval_m
integer , DIMENSION(max_domains) :: auxhist20_interval_s
integer , DIMENSION(max_domains) :: auxhist20_interval
integer , DIMENSION(max_domains) :: auxhist20_begin_y
integer , DIMENSION(max_domains) :: auxhist20_begin_d
integer , DIMENSION(max_domains) :: auxhist20_begin_h
integer , DIMENSION(max_domains) :: auxhist20_begin_m
integer , DIMENSION(max_domains) :: auxhist20_begin_s
integer , DIMENSION(max_domains) :: auxhist20_begin
integer , DIMENSION(max_domains) :: auxhist20_end_y
integer , DIMENSION(max_domains) :: auxhist20_end_d
integer , DIMENSION(max_domains) :: auxhist20_end_h
integer , DIMENSION(max_domains) :: auxhist20_end_m
integer , DIMENSION(max_domains) :: auxhist20_end_s
integer , DIMENSION(max_domains) :: auxhist20_end
integer :: io_form_auxhist20
integer , DIMENSION(max_domains) :: frames_per_auxhist20
character*256 :: auxhist21_inname
character*256 :: auxhist21_outname
integer , DIMENSION(max_domains) :: auxhist21_interval_y
integer , DIMENSION(max_domains) :: auxhist21_interval_d
integer , DIMENSION(max_domains) :: auxhist21_interval_h
integer , DIMENSION(max_domains) :: auxhist21_interval_m
integer , DIMENSION(max_domains) :: auxhist21_interval_s
integer , DIMENSION(max_domains) :: auxhist21_interval
integer , DIMENSION(max_domains) :: auxhist21_begin_y
integer , DIMENSION(max_domains) :: auxhist21_begin_d
integer , DIMENSION(max_domains) :: auxhist21_begin_h
integer , DIMENSION(max_domains) :: auxhist21_begin_m
integer , DIMENSION(max_domains) :: auxhist21_begin_s
integer , DIMENSION(max_domains) :: auxhist21_begin
integer , DIMENSION(max_domains) :: auxhist21_end_y
integer , DIMENSION(max_domains) :: auxhist21_end_d
integer , DIMENSION(max_domains) :: auxhist21_end_h
integer , DIMENSION(max_domains) :: auxhist21_end_m
integer , DIMENSION(max_domains) :: auxhist21_end_s
integer , DIMENSION(max_domains) :: auxhist21_end
integer :: io_form_auxhist21
integer , DIMENSION(max_domains) :: frames_per_auxhist21
character*256 :: auxhist22_inname
character*256 :: auxhist22_outname
integer , DIMENSION(max_domains) :: auxhist22_interval_y
integer , DIMENSION(max_domains) :: auxhist22_interval_d
integer , DIMENSION(max_domains) :: auxhist22_interval_h
integer , DIMENSION(max_domains) :: auxhist22_interval_m
integer , DIMENSION(max_domains) :: auxhist22_interval_s
integer , DIMENSION(max_domains) :: auxhist22_interval
integer , DIMENSION(max_domains) :: auxhist22_begin_y
integer , DIMENSION(max_domains) :: auxhist22_begin_d
integer , DIMENSION(max_domains) :: auxhist22_begin_h
integer , DIMENSION(max_domains) :: auxhist22_begin_m
integer , DIMENSION(max_domains) :: auxhist22_begin_s
integer , DIMENSION(max_domains) :: auxhist22_begin
integer , DIMENSION(max_domains) :: auxhist22_end_y
integer , DIMENSION(max_domains) :: auxhist22_end_d
integer , DIMENSION(max_domains) :: auxhist22_end_h
integer , DIMENSION(max_domains) :: auxhist22_end_m
integer , DIMENSION(max_domains) :: auxhist22_end_s
integer , DIMENSION(max_domains) :: auxhist22_end
integer :: io_form_auxhist22
integer , DIMENSION(max_domains) :: frames_per_auxhist22
character*256 :: auxhist23_inname
character*256 :: auxhist23_outname
integer , DIMENSION(max_domains) :: auxhist23_interval_y
integer , DIMENSION(max_domains) :: auxhist23_interval_d
integer , DIMENSION(max_domains) :: auxhist23_interval_h
integer , DIMENSION(max_domains) :: auxhist23_interval_m
integer , DIMENSION(max_domains) :: auxhist23_interval_s
integer , DIMENSION(max_domains) :: auxhist23_interval
integer , DIMENSION(max_domains) :: auxhist23_begin_y
integer , DIMENSION(max_domains) :: auxhist23_begin_d
integer , DIMENSION(max_domains) :: auxhist23_begin_h
integer , DIMENSION(max_domains) :: auxhist23_begin_m
integer , DIMENSION(max_domains) :: auxhist23_begin_s
integer , DIMENSION(max_domains) :: auxhist23_begin
integer , DIMENSION(max_domains) :: auxhist23_end_y
integer , DIMENSION(max_domains) :: auxhist23_end_d
integer , DIMENSION(max_domains) :: auxhist23_end_h
integer , DIMENSION(max_domains) :: auxhist23_end_m
integer , DIMENSION(max_domains) :: auxhist23_end_s
integer , DIMENSION(max_domains) :: auxhist23_end
integer :: io_form_auxhist23
integer , DIMENSION(max_domains) :: frames_per_auxhist23
character*256 :: auxhist24_inname
character*256 :: auxhist24_outname
integer , DIMENSION(max_domains) :: auxhist24_interval_y
integer , DIMENSION(max_domains) :: auxhist24_interval_d
integer , DIMENSION(max_domains) :: auxhist24_interval_h
integer , DIMENSION(max_domains) :: auxhist24_interval_m
integer , DIMENSION(max_domains) :: auxhist24_interval_s
integer , DIMENSION(max_domains) :: auxhist24_interval
integer , DIMENSION(max_domains) :: auxhist24_begin_y
integer , DIMENSION(max_domains) :: auxhist24_begin_d
integer , DIMENSION(max_domains) :: auxhist24_begin_h
integer , DIMENSION(max_domains) :: auxhist24_begin_m
integer , DIMENSION(max_domains) :: auxhist24_begin_s
integer , DIMENSION(max_domains) :: auxhist24_begin
integer , DIMENSION(max_domains) :: auxhist24_end_y
integer , DIMENSION(max_domains) :: auxhist24_end_d
integer , DIMENSION(max_domains) :: auxhist24_end_h
integer , DIMENSION(max_domains) :: auxhist24_end_m
integer , DIMENSION(max_domains) :: auxhist24_end_s
integer , DIMENSION(max_domains) :: auxhist24_end
integer :: io_form_auxhist24
integer , DIMENSION(max_domains) :: frames_per_auxhist24
character*256 :: auxinput1_outname
integer , DIMENSION(max_domains) :: auxinput1_interval_y
integer , DIMENSION(max_domains) :: auxinput1_interval_d
integer , DIMENSION(max_domains) :: auxinput1_interval_h
integer , DIMENSION(max_domains) :: auxinput1_interval_m
integer , DIMENSION(max_domains) :: auxinput1_interval_s
integer , DIMENSION(max_domains) :: auxinput1_interval
integer , DIMENSION(max_domains) :: auxinput1_begin_y
integer , DIMENSION(max_domains) :: auxinput1_begin_d
integer , DIMENSION(max_domains) :: auxinput1_begin_h
integer , DIMENSION(max_domains) :: auxinput1_begin_m
integer , DIMENSION(max_domains) :: auxinput1_begin_s
integer , DIMENSION(max_domains) :: auxinput1_begin
integer , DIMENSION(max_domains) :: auxinput1_end_y
integer , DIMENSION(max_domains) :: auxinput1_end_d
integer , DIMENSION(max_domains) :: auxinput1_end_h
integer , DIMENSION(max_domains) :: auxinput1_end_m
integer , DIMENSION(max_domains) :: auxinput1_end_s
integer , DIMENSION(max_domains) :: auxinput1_end
integer , DIMENSION(max_domains) :: frames_per_auxinput1
character*256 :: auxinput2_inname
character*256 :: auxinput2_outname
integer , DIMENSION(max_domains) :: auxinput2_interval_y
integer , DIMENSION(max_domains) :: auxinput2_interval_d
integer , DIMENSION(max_domains) :: auxinput2_interval_h
integer , DIMENSION(max_domains) :: auxinput2_interval_m
integer , DIMENSION(max_domains) :: auxinput2_interval_s
integer , DIMENSION(max_domains) :: auxinput2_interval
integer , DIMENSION(max_domains) :: auxinput2_begin_y
integer , DIMENSION(max_domains) :: auxinput2_begin_d
integer , DIMENSION(max_domains) :: auxinput2_begin_h
integer , DIMENSION(max_domains) :: auxinput2_begin_m
integer , DIMENSION(max_domains) :: auxinput2_begin_s
integer , DIMENSION(max_domains) :: auxinput2_begin
integer , DIMENSION(max_domains) :: auxinput2_end_y
integer , DIMENSION(max_domains) :: auxinput2_end_d
integer , DIMENSION(max_domains) :: auxinput2_end_h
integer , DIMENSION(max_domains) :: auxinput2_end_m
integer , DIMENSION(max_domains) :: auxinput2_end_s
integer , DIMENSION(max_domains) :: auxinput2_end
integer :: io_form_auxinput2
integer , DIMENSION(max_domains) :: frames_per_auxinput2
character*256 :: auxinput3_inname
character*256 :: auxinput3_outname
integer , DIMENSION(max_domains) :: auxinput3_interval_y
integer , DIMENSION(max_domains) :: auxinput3_interval_d
integer , DIMENSION(max_domains) :: auxinput3_interval_h
integer , DIMENSION(max_domains) :: auxinput3_interval_m
integer , DIMENSION(max_domains) :: auxinput3_interval_s
integer , DIMENSION(max_domains) :: auxinput3_interval
integer , DIMENSION(max_domains) :: auxinput3_begin_y
integer , DIMENSION(max_domains) :: auxinput3_begin_d
integer , DIMENSION(max_domains) :: auxinput3_begin_h
integer , DIMENSION(max_domains) :: auxinput3_begin_m
integer , DIMENSION(max_domains) :: auxinput3_begin_s
integer , DIMENSION(max_domains) :: auxinput3_begin
integer , DIMENSION(max_domains) :: auxinput3_end_y
integer , DIMENSION(max_domains) :: auxinput3_end_d
integer , DIMENSION(max_domains) :: auxinput3_end_h
integer , DIMENSION(max_domains) :: auxinput3_end_m
integer , DIMENSION(max_domains) :: auxinput3_end_s
integer , DIMENSION(max_domains) :: auxinput3_end
integer :: io_form_auxinput3
integer , DIMENSION(max_domains) :: frames_per_auxinput3
character*256 :: auxinput4_inname
character*256 :: auxinput4_outname
integer , DIMENSION(max_domains) :: auxinput4_interval_y
integer , DIMENSION(max_domains) :: auxinput4_interval_d
integer , DIMENSION(max_domains) :: auxinput4_interval_h
integer , DIMENSION(max_domains) :: auxinput4_interval_m
integer , DIMENSION(max_domains) :: auxinput4_interval_s
integer , DIMENSION(max_domains) :: auxinput4_interval
integer , DIMENSION(max_domains) :: auxinput4_begin_y
integer , DIMENSION(max_domains) :: auxinput4_begin_d
integer , DIMENSION(max_domains) :: auxinput4_begin_h
integer , DIMENSION(max_domains) :: auxinput4_begin_m
integer , DIMENSION(max_domains) :: auxinput4_begin_s
integer , DIMENSION(max_domains) :: auxinput4_begin
integer , DIMENSION(max_domains) :: auxinput4_end_y
integer , DIMENSION(max_domains) :: auxinput4_end_d
integer , DIMENSION(max_domains) :: auxinput4_end_h
integer , DIMENSION(max_domains) :: auxinput4_end_m
integer , DIMENSION(max_domains) :: auxinput4_end_s
integer , DIMENSION(max_domains) :: auxinput4_end
integer :: io_form_auxinput4
integer , DIMENSION(max_domains) :: frames_per_auxinput4
character*256 :: auxinput5_inname
character*256 :: auxinput5_outname
integer , DIMENSION(max_domains) :: auxinput5_interval_y
integer , DIMENSION(max_domains) :: auxinput5_interval_d
integer , DIMENSION(max_domains) :: auxinput5_interval_h
integer , DIMENSION(max_domains) :: auxinput5_interval_m
integer , DIMENSION(max_domains) :: auxinput5_interval_s
integer , DIMENSION(max_domains) :: auxinput5_interval
integer , DIMENSION(max_domains) :: auxinput5_begin_y
integer , DIMENSION(max_domains) :: auxinput5_begin_d
integer , DIMENSION(max_domains) :: auxinput5_begin_h
integer , DIMENSION(max_domains) :: auxinput5_begin_m
integer , DIMENSION(max_domains) :: auxinput5_begin_s
integer , DIMENSION(max_domains) :: auxinput5_begin
integer , DIMENSION(max_domains) :: auxinput5_end_y
integer , DIMENSION(max_domains) :: auxinput5_end_d
integer , DIMENSION(max_domains) :: auxinput5_end_h
integer , DIMENSION(max_domains) :: auxinput5_end_m
integer , DIMENSION(max_domains) :: auxinput5_end_s
integer , DIMENSION(max_domains) :: auxinput5_end
integer :: io_form_auxinput5
integer , DIMENSION(max_domains) :: frames_per_auxinput5
character*256 :: auxinput6_inname
character*256 :: auxinput6_outname
integer , DIMENSION(max_domains) :: auxinput6_interval_y
integer , DIMENSION(max_domains) :: auxinput6_interval_d
integer , DIMENSION(max_domains) :: auxinput6_interval_h
integer , DIMENSION(max_domains) :: auxinput6_interval_m
integer , DIMENSION(max_domains) :: auxinput6_interval_s
integer , DIMENSION(max_domains) :: auxinput6_interval
integer , DIMENSION(max_domains) :: auxinput6_begin_y
integer , DIMENSION(max_domains) :: auxinput6_begin_d
integer , DIMENSION(max_domains) :: auxinput6_begin_h
integer , DIMENSION(max_domains) :: auxinput6_begin_m
integer , DIMENSION(max_domains) :: auxinput6_begin_s
integer , DIMENSION(max_domains) :: auxinput6_begin
integer , DIMENSION(max_domains) :: auxinput6_end_y
integer , DIMENSION(max_domains) :: auxinput6_end_d
integer , DIMENSION(max_domains) :: auxinput6_end_h
integer , DIMENSION(max_domains) :: auxinput6_end_m
integer , DIMENSION(max_domains) :: auxinput6_end_s
integer , DIMENSION(max_domains) :: auxinput6_end
integer :: io_form_auxinput6
integer , DIMENSION(max_domains) :: frames_per_auxinput6
character*256 :: auxinput7_inname
character*256 :: auxinput7_outname
integer , DIMENSION(max_domains) :: auxinput7_interval_y
integer , DIMENSION(max_domains) :: auxinput7_interval_d
integer , DIMENSION(max_domains) :: auxinput7_interval_h
integer , DIMENSION(max_domains) :: auxinput7_interval_m
integer , DIMENSION(max_domains) :: auxinput7_interval_s
integer , DIMENSION(max_domains) :: auxinput7_interval
integer , DIMENSION(max_domains) :: auxinput7_begin_y
integer , DIMENSION(max_domains) :: auxinput7_begin_d
integer , DIMENSION(max_domains) :: auxinput7_begin_h
integer , DIMENSION(max_domains) :: auxinput7_begin_m
integer , DIMENSION(max_domains) :: auxinput7_begin_s
integer , DIMENSION(max_domains) :: auxinput7_begin
integer , DIMENSION(max_domains) :: auxinput7_end_y
integer , DIMENSION(max_domains) :: auxinput7_end_d
integer , DIMENSION(max_domains) :: auxinput7_end_h
integer , DIMENSION(max_domains) :: auxinput7_end_m
integer , DIMENSION(max_domains) :: auxinput7_end_s
integer , DIMENSION(max_domains) :: auxinput7_end
integer :: io_form_auxinput7
integer , DIMENSION(max_domains) :: frames_per_auxinput7
character*256 :: auxinput8_inname
character*256 :: auxinput8_outname
integer , DIMENSION(max_domains) :: auxinput8_interval_y
integer , DIMENSION(max_domains) :: auxinput8_interval_d
integer , DIMENSION(max_domains) :: auxinput8_interval_h
integer , DIMENSION(max_domains) :: auxinput8_interval_m
integer , DIMENSION(max_domains) :: auxinput8_interval_s
integer , DIMENSION(max_domains) :: auxinput8_interval
integer , DIMENSION(max_domains) :: auxinput8_begin_y
integer , DIMENSION(max_domains) :: auxinput8_begin_d
integer , DIMENSION(max_domains) :: auxinput8_begin_h
integer , DIMENSION(max_domains) :: auxinput8_begin_m
integer , DIMENSION(max_domains) :: auxinput8_begin_s
integer , DIMENSION(max_domains) :: auxinput8_begin
integer , DIMENSION(max_domains) :: auxinput8_end_y
integer , DIMENSION(max_domains) :: auxinput8_end_d
integer , DIMENSION(max_domains) :: auxinput8_end_h
integer , DIMENSION(max_domains) :: auxinput8_end_m
integer , DIMENSION(max_domains) :: auxinput8_end_s
integer , DIMENSION(max_domains) :: auxinput8_end
integer :: io_form_auxinput8
integer , DIMENSION(max_domains) :: frames_per_auxinput8
character*256 :: auxinput9_inname
character*256 :: auxinput9_outname
integer , DIMENSION(max_domains) :: auxinput9_interval_y
integer , DIMENSION(max_domains) :: auxinput9_interval_d
integer , DIMENSION(max_domains) :: auxinput9_interval_h
integer , DIMENSION(max_domains) :: auxinput9_interval_m
integer , DIMENSION(max_domains) :: auxinput9_interval_s
integer , DIMENSION(max_domains) :: auxinput9_interval
integer , DIMENSION(max_domains) :: auxinput9_begin_y
integer , DIMENSION(max_domains) :: auxinput9_begin_d
integer , DIMENSION(max_domains) :: auxinput9_begin_h
integer , DIMENSION(max_domains) :: auxinput9_begin_m
integer , DIMENSION(max_domains) :: auxinput9_begin_s
integer , DIMENSION(max_domains) :: auxinput9_begin
integer , DIMENSION(max_domains) :: auxinput9_end_y
integer , DIMENSION(max_domains) :: auxinput9_end_d
integer , DIMENSION(max_domains) :: auxinput9_end_h
integer , DIMENSION(max_domains) :: auxinput9_end_m
integer , DIMENSION(max_domains) :: auxinput9_end_s
integer , DIMENSION(max_domains) :: auxinput9_end
integer :: io_form_auxinput9
integer , DIMENSION(max_domains) :: frames_per_auxinput9
character*256 :: auxinput10_inname
character*256 :: auxinput10_outname
integer , DIMENSION(max_domains) :: auxinput10_interval_y
integer , DIMENSION(max_domains) :: auxinput10_interval_d
integer , DIMENSION(max_domains) :: auxinput10_interval_h
integer , DIMENSION(max_domains) :: auxinput10_interval_m
integer , DIMENSION(max_domains) :: auxinput10_interval_s
integer , DIMENSION(max_domains) :: auxinput10_interval
integer , DIMENSION(max_domains) :: auxinput10_begin_y
integer , DIMENSION(max_domains) :: auxinput10_begin_d
integer , DIMENSION(max_domains) :: auxinput10_begin_h
integer , DIMENSION(max_domains) :: auxinput10_begin_m
integer , DIMENSION(max_domains) :: auxinput10_begin_s
integer , DIMENSION(max_domains) :: auxinput10_begin
integer , DIMENSION(max_domains) :: auxinput10_end_y
integer , DIMENSION(max_domains) :: auxinput10_end_d
integer , DIMENSION(max_domains) :: auxinput10_end_h
integer , DIMENSION(max_domains) :: auxinput10_end_m
integer , DIMENSION(max_domains) :: auxinput10_end_s
integer , DIMENSION(max_domains) :: auxinput10_end
integer :: io_form_auxinput10
integer , DIMENSION(max_domains) :: frames_per_auxinput10
character*256 :: auxinput11_inname
character*256 :: auxinput11_outname
integer , DIMENSION(max_domains) :: auxinput11_interval_y
integer , DIMENSION(max_domains) :: auxinput11_interval_d
integer , DIMENSION(max_domains) :: auxinput11_interval_h
integer , DIMENSION(max_domains) :: auxinput11_interval_m
integer , DIMENSION(max_domains) :: auxinput11_interval_s
integer , DIMENSION(max_domains) :: auxinput11_interval
integer , DIMENSION(max_domains) :: auxinput11_begin_y
integer , DIMENSION(max_domains) :: auxinput11_begin_d
integer , DIMENSION(max_domains) :: auxinput11_begin_h
integer , DIMENSION(max_domains) :: auxinput11_begin_m
integer , DIMENSION(max_domains) :: auxinput11_begin_s
integer , DIMENSION(max_domains) :: auxinput11_begin
integer , DIMENSION(max_domains) :: auxinput11_end_y
integer , DIMENSION(max_domains) :: auxinput11_end_d
integer , DIMENSION(max_domains) :: auxinput11_end_h
integer , DIMENSION(max_domains) :: auxinput11_end_m
integer , DIMENSION(max_domains) :: auxinput11_end_s
integer , DIMENSION(max_domains) :: auxinput11_end
integer :: io_form_auxinput11
integer , DIMENSION(max_domains) :: frames_per_auxinput11
character*256 :: auxinput12_inname
character*256 :: auxinput12_outname
integer , DIMENSION(max_domains) :: auxinput12_interval_y
integer , DIMENSION(max_domains) :: auxinput12_interval_d
integer , DIMENSION(max_domains) :: auxinput12_interval_h
integer , DIMENSION(max_domains) :: auxinput12_interval_m
integer , DIMENSION(max_domains) :: auxinput12_interval_s
integer , DIMENSION(max_domains) :: auxinput12_interval
integer , DIMENSION(max_domains) :: auxinput12_begin_y
integer , DIMENSION(max_domains) :: auxinput12_begin_d
integer , DIMENSION(max_domains) :: auxinput12_begin_h
integer , DIMENSION(max_domains) :: auxinput12_begin_m
integer , DIMENSION(max_domains) :: auxinput12_begin_s
integer , DIMENSION(max_domains) :: auxinput12_begin
integer , DIMENSION(max_domains) :: auxinput12_end_y
integer , DIMENSION(max_domains) :: auxinput12_end_d
integer , DIMENSION(max_domains) :: auxinput12_end_h
integer , DIMENSION(max_domains) :: auxinput12_end_m
integer , DIMENSION(max_domains) :: auxinput12_end_s
integer , DIMENSION(max_domains) :: auxinput12_end
integer :: io_form_auxinput12
integer , DIMENSION(max_domains) :: frames_per_auxinput12
character*256 :: auxinput13_inname
character*256 :: auxinput13_outname
integer , DIMENSION(max_domains) :: auxinput13_interval_y
integer , DIMENSION(max_domains) :: auxinput13_interval_d
integer , DIMENSION(max_domains) :: auxinput13_interval_h
integer , DIMENSION(max_domains) :: auxinput13_interval_m
integer , DIMENSION(max_domains) :: auxinput13_interval_s
integer , DIMENSION(max_domains) :: auxinput13_interval
integer , DIMENSION(max_domains) :: auxinput13_begin_y
integer , DIMENSION(max_domains) :: auxinput13_begin_d
integer , DIMENSION(max_domains) :: auxinput13_begin_h
integer , DIMENSION(max_domains) :: auxinput13_begin_m
integer , DIMENSION(max_domains) :: auxinput13_begin_s
integer , DIMENSION(max_domains) :: auxinput13_begin
integer , DIMENSION(max_domains) :: auxinput13_end_y
integer , DIMENSION(max_domains) :: auxinput13_end_d
integer , DIMENSION(max_domains) :: auxinput13_end_h
integer , DIMENSION(max_domains) :: auxinput13_end_m
integer , DIMENSION(max_domains) :: auxinput13_end_s
integer , DIMENSION(max_domains) :: auxinput13_end
integer :: io_form_auxinput13
integer , DIMENSION(max_domains) :: frames_per_auxinput13
character*256 :: auxinput14_inname
character*256 :: auxinput14_outname
integer , DIMENSION(max_domains) :: auxinput14_interval_y
integer , DIMENSION(max_domains) :: auxinput14_interval_d
integer , DIMENSION(max_domains) :: auxinput14_interval_h
integer , DIMENSION(max_domains) :: auxinput14_interval_m
integer , DIMENSION(max_domains) :: auxinput14_interval_s
integer , DIMENSION(max_domains) :: auxinput14_interval
integer , DIMENSION(max_domains) :: auxinput14_begin_y
integer , DIMENSION(max_domains) :: auxinput14_begin_d
integer , DIMENSION(max_domains) :: auxinput14_begin_h
integer , DIMENSION(max_domains) :: auxinput14_begin_m
integer , DIMENSION(max_domains) :: auxinput14_begin_s
integer , DIMENSION(max_domains) :: auxinput14_begin
integer , DIMENSION(max_domains) :: auxinput14_end_y
integer , DIMENSION(max_domains) :: auxinput14_end_d
integer , DIMENSION(max_domains) :: auxinput14_end_h
integer , DIMENSION(max_domains) :: auxinput14_end_m
integer , DIMENSION(max_domains) :: auxinput14_end_s
integer , DIMENSION(max_domains) :: auxinput14_end
integer :: io_form_auxinput14
integer , DIMENSION(max_domains) :: frames_per_auxinput14
character*256 :: auxinput15_inname
character*256 :: auxinput15_outname
integer , DIMENSION(max_domains) :: auxinput15_interval_y
integer , DIMENSION(max_domains) :: auxinput15_interval_d
integer , DIMENSION(max_domains) :: auxinput15_interval_h
integer , DIMENSION(max_domains) :: auxinput15_interval_m
integer , DIMENSION(max_domains) :: auxinput15_interval_s
integer , DIMENSION(max_domains) :: auxinput15_interval
integer , DIMENSION(max_domains) :: auxinput15_begin_y
integer , DIMENSION(max_domains) :: auxinput15_begin_d
integer , DIMENSION(max_domains) :: auxinput15_begin_h
integer , DIMENSION(max_domains) :: auxinput15_begin_m
integer , DIMENSION(max_domains) :: auxinput15_begin_s
integer , DIMENSION(max_domains) :: auxinput15_begin
integer , DIMENSION(max_domains) :: auxinput15_end_y
integer , DIMENSION(max_domains) :: auxinput15_end_d
integer , DIMENSION(max_domains) :: auxinput15_end_h
integer , DIMENSION(max_domains) :: auxinput15_end_m
integer , DIMENSION(max_domains) :: auxinput15_end_s
integer , DIMENSION(max_domains) :: auxinput15_end
integer :: io_form_auxinput15
integer , DIMENSION(max_domains) :: frames_per_auxinput15
character*256 :: auxinput16_inname
character*256 :: auxinput16_outname
integer , DIMENSION(max_domains) :: auxinput16_interval_y
integer , DIMENSION(max_domains) :: auxinput16_interval_d
integer , DIMENSION(max_domains) :: auxinput16_interval_h
integer , DIMENSION(max_domains) :: auxinput16_interval_m
integer , DIMENSION(max_domains) :: auxinput16_interval_s
integer , DIMENSION(max_domains) :: auxinput16_interval
integer , DIMENSION(max_domains) :: auxinput16_begin_y
integer , DIMENSION(max_domains) :: auxinput16_begin_d
integer , DIMENSION(max_domains) :: auxinput16_begin_h
integer , DIMENSION(max_domains) :: auxinput16_begin_m
integer , DIMENSION(max_domains) :: auxinput16_begin_s
integer , DIMENSION(max_domains) :: auxinput16_begin
integer , DIMENSION(max_domains) :: auxinput16_end_y
integer , DIMENSION(max_domains) :: auxinput16_end_d
integer , DIMENSION(max_domains) :: auxinput16_end_h
integer , DIMENSION(max_domains) :: auxinput16_end_m
integer , DIMENSION(max_domains) :: auxinput16_end_s
integer , DIMENSION(max_domains) :: auxinput16_end
integer :: io_form_auxinput16
integer , DIMENSION(max_domains) :: frames_per_auxinput16
character*256 :: auxinput17_inname
character*256 :: auxinput17_outname
integer , DIMENSION(max_domains) :: auxinput17_interval_y
integer , DIMENSION(max_domains) :: auxinput17_interval_d
integer , DIMENSION(max_domains) :: auxinput17_interval_h
integer , DIMENSION(max_domains) :: auxinput17_interval_m
integer , DIMENSION(max_domains) :: auxinput17_interval_s
integer , DIMENSION(max_domains) :: auxinput17_interval
integer , DIMENSION(max_domains) :: auxinput17_begin_y
integer , DIMENSION(max_domains) :: auxinput17_begin_d
integer , DIMENSION(max_domains) :: auxinput17_begin_h
integer , DIMENSION(max_domains) :: auxinput17_begin_m
integer , DIMENSION(max_domains) :: auxinput17_begin_s
integer , DIMENSION(max_domains) :: auxinput17_begin
integer , DIMENSION(max_domains) :: auxinput17_end_y
integer , DIMENSION(max_domains) :: auxinput17_end_d
integer , DIMENSION(max_domains) :: auxinput17_end_h
integer , DIMENSION(max_domains) :: auxinput17_end_m
integer , DIMENSION(max_domains) :: auxinput17_end_s
integer , DIMENSION(max_domains) :: auxinput17_end
integer :: io_form_auxinput17
integer , DIMENSION(max_domains) :: frames_per_auxinput17
character*256 :: auxinput18_inname
character*256 :: auxinput18_outname
integer , DIMENSION(max_domains) :: auxinput18_interval_y
integer , DIMENSION(max_domains) :: auxinput18_interval_d
integer , DIMENSION(max_domains) :: auxinput18_interval_h
integer , DIMENSION(max_domains) :: auxinput18_interval_m
integer , DIMENSION(max_domains) :: auxinput18_interval_s
integer , DIMENSION(max_domains) :: auxinput18_interval
integer , DIMENSION(max_domains) :: auxinput18_begin_y
integer , DIMENSION(max_domains) :: auxinput18_begin_d
integer , DIMENSION(max_domains) :: auxinput18_begin_h
integer , DIMENSION(max_domains) :: auxinput18_begin_m
integer , DIMENSION(max_domains) :: auxinput18_begin_s
integer , DIMENSION(max_domains) :: auxinput18_begin
integer , DIMENSION(max_domains) :: auxinput18_end_y
integer , DIMENSION(max_domains) :: auxinput18_end_d
integer , DIMENSION(max_domains) :: auxinput18_end_h
integer , DIMENSION(max_domains) :: auxinput18_end_m
integer , DIMENSION(max_domains) :: auxinput18_end_s
integer , DIMENSION(max_domains) :: auxinput18_end
integer :: io_form_auxinput18
integer , DIMENSION(max_domains) :: frames_per_auxinput18
character*256 :: auxinput19_inname
character*256 :: auxinput19_outname
integer , DIMENSION(max_domains) :: auxinput19_interval_y
integer , DIMENSION(max_domains) :: auxinput19_interval_d
integer , DIMENSION(max_domains) :: auxinput19_interval_h
integer , DIMENSION(max_domains) :: auxinput19_interval_m
integer , DIMENSION(max_domains) :: auxinput19_interval_s
integer , DIMENSION(max_domains) :: auxinput19_interval
integer , DIMENSION(max_domains) :: auxinput19_begin_y
integer , DIMENSION(max_domains) :: auxinput19_begin_d
integer , DIMENSION(max_domains) :: auxinput19_begin_h
integer , DIMENSION(max_domains) :: auxinput19_begin_m
integer , DIMENSION(max_domains) :: auxinput19_begin_s
integer , DIMENSION(max_domains) :: auxinput19_begin
integer , DIMENSION(max_domains) :: auxinput19_end_y
integer , DIMENSION(max_domains) :: auxinput19_end_d
integer , DIMENSION(max_domains) :: auxinput19_end_h
integer , DIMENSION(max_domains) :: auxinput19_end_m
integer , DIMENSION(max_domains) :: auxinput19_end_s
integer , DIMENSION(max_domains) :: auxinput19_end
integer :: io_form_auxinput19
integer , DIMENSION(max_domains) :: frames_per_auxinput19
character*256 :: auxinput20_inname
character*256 :: auxinput20_outname
integer , DIMENSION(max_domains) :: auxinput20_interval_y
integer , DIMENSION(max_domains) :: auxinput20_interval_d
integer , DIMENSION(max_domains) :: auxinput20_interval_h
integer , DIMENSION(max_domains) :: auxinput20_interval_m
integer , DIMENSION(max_domains) :: auxinput20_interval_s
integer , DIMENSION(max_domains) :: auxinput20_interval
integer , DIMENSION(max_domains) :: auxinput20_begin_y
integer , DIMENSION(max_domains) :: auxinput20_begin_d
integer , DIMENSION(max_domains) :: auxinput20_begin_h
integer , DIMENSION(max_domains) :: auxinput20_begin_m
integer , DIMENSION(max_domains) :: auxinput20_begin_s
integer , DIMENSION(max_domains) :: auxinput20_begin
integer , DIMENSION(max_domains) :: auxinput20_end_y
integer , DIMENSION(max_domains) :: auxinput20_end_d
integer , DIMENSION(max_domains) :: auxinput20_end_h
integer , DIMENSION(max_domains) :: auxinput20_end_m
integer , DIMENSION(max_domains) :: auxinput20_end_s
integer , DIMENSION(max_domains) :: auxinput20_end
integer :: io_form_auxinput20
integer , DIMENSION(max_domains) :: frames_per_auxinput20
character*256 :: auxinput21_inname
character*256 :: auxinput21_outname
integer , DIMENSION(max_domains) :: auxinput21_interval_y
integer , DIMENSION(max_domains) :: auxinput21_interval_d
integer , DIMENSION(max_domains) :: auxinput21_interval_h
integer , DIMENSION(max_domains) :: auxinput21_interval_m
integer , DIMENSION(max_domains) :: auxinput21_interval_s
integer , DIMENSION(max_domains) :: auxinput21_interval
integer , DIMENSION(max_domains) :: auxinput21_begin_y
integer , DIMENSION(max_domains) :: auxinput21_begin_d
integer , DIMENSION(max_domains) :: auxinput21_begin_h
integer , DIMENSION(max_domains) :: auxinput21_begin_m
integer , DIMENSION(max_domains) :: auxinput21_begin_s
integer , DIMENSION(max_domains) :: auxinput21_begin
integer , DIMENSION(max_domains) :: auxinput21_end_y
integer , DIMENSION(max_domains) :: auxinput21_end_d
integer , DIMENSION(max_domains) :: auxinput21_end_h
integer , DIMENSION(max_domains) :: auxinput21_end_m
integer , DIMENSION(max_domains) :: auxinput21_end_s
integer , DIMENSION(max_domains) :: auxinput21_end
integer :: io_form_auxinput21
integer , DIMENSION(max_domains) :: frames_per_auxinput21
character*256 :: auxinput22_inname
character*256 :: auxinput22_outname
integer , DIMENSION(max_domains) :: auxinput22_interval_y
integer , DIMENSION(max_domains) :: auxinput22_interval_d
integer , DIMENSION(max_domains) :: auxinput22_interval_h
integer , DIMENSION(max_domains) :: auxinput22_interval_m
integer , DIMENSION(max_domains) :: auxinput22_interval_s
integer , DIMENSION(max_domains) :: auxinput22_interval
integer , DIMENSION(max_domains) :: auxinput22_begin_y
integer , DIMENSION(max_domains) :: auxinput22_begin_d
integer , DIMENSION(max_domains) :: auxinput22_begin_h
integer , DIMENSION(max_domains) :: auxinput22_begin_m
integer , DIMENSION(max_domains) :: auxinput22_begin_s
integer , DIMENSION(max_domains) :: auxinput22_begin
integer , DIMENSION(max_domains) :: auxinput22_end_y
integer , DIMENSION(max_domains) :: auxinput22_end_d
integer , DIMENSION(max_domains) :: auxinput22_end_h
integer , DIMENSION(max_domains) :: auxinput22_end_m
integer , DIMENSION(max_domains) :: auxinput22_end_s
integer , DIMENSION(max_domains) :: auxinput22_end
integer :: io_form_auxinput22
integer , DIMENSION(max_domains) :: frames_per_auxinput22
character*256 :: auxinput23_inname
character*256 :: auxinput23_outname
integer , DIMENSION(max_domains) :: auxinput23_interval_y
integer , DIMENSION(max_domains) :: auxinput23_interval_d
integer , DIMENSION(max_domains) :: auxinput23_interval_h
integer , DIMENSION(max_domains) :: auxinput23_interval_m
integer , DIMENSION(max_domains) :: auxinput23_interval_s
integer , DIMENSION(max_domains) :: auxinput23_interval
integer , DIMENSION(max_domains) :: auxinput23_begin_y
integer , DIMENSION(max_domains) :: auxinput23_begin_d
integer , DIMENSION(max_domains) :: auxinput23_begin_h
integer , DIMENSION(max_domains) :: auxinput23_begin_m
integer , DIMENSION(max_domains) :: auxinput23_begin_s
integer , DIMENSION(max_domains) :: auxinput23_begin
integer , DIMENSION(max_domains) :: auxinput23_end_y
integer , DIMENSION(max_domains) :: auxinput23_end_d
integer , DIMENSION(max_domains) :: auxinput23_end_h
integer , DIMENSION(max_domains) :: auxinput23_end_m
integer , DIMENSION(max_domains) :: auxinput23_end_s
integer , DIMENSION(max_domains) :: auxinput23_end
integer :: io_form_auxinput23
integer , DIMENSION(max_domains) :: frames_per_auxinput23
character*256 :: auxinput24_inname
character*256 :: auxinput24_outname
integer , DIMENSION(max_domains) :: auxinput24_interval_y
integer , DIMENSION(max_domains) :: auxinput24_interval_d
integer , DIMENSION(max_domains) :: auxinput24_interval_h
integer , DIMENSION(max_domains) :: auxinput24_interval_m
integer , DIMENSION(max_domains) :: auxinput24_interval_s
integer , DIMENSION(max_domains) :: auxinput24_interval
integer , DIMENSION(max_domains) :: auxinput24_begin_y
integer , DIMENSION(max_domains) :: auxinput24_begin_d
integer , DIMENSION(max_domains) :: auxinput24_begin_h
integer , DIMENSION(max_domains) :: auxinput24_begin_m
integer , DIMENSION(max_domains) :: auxinput24_begin_s
integer , DIMENSION(max_domains) :: auxinput24_begin
integer , DIMENSION(max_domains) :: auxinput24_end_y
integer , DIMENSION(max_domains) :: auxinput24_end_d
integer , DIMENSION(max_domains) :: auxinput24_end_h
integer , DIMENSION(max_domains) :: auxinput24_end_m
integer , DIMENSION(max_domains) :: auxinput24_end_s
integer , DIMENSION(max_domains) :: auxinput24_end
integer :: io_form_auxinput24
integer , DIMENSION(max_domains) :: frames_per_auxinput24
integer , DIMENSION(max_domains) :: history_interval
integer , DIMENSION(max_domains) :: frames_per_outfile
logical :: restart
integer :: restart_interval
integer :: io_form_input
integer :: io_form_history
integer :: io_form_restart
integer :: io_form_boundary
integer :: debug_level
logical :: self_test_domain
character*256 :: history_outname
character*256 :: history_inname
logical :: use_netcdf_classic
integer , DIMENSION(max_domains) :: history_interval_d
integer , DIMENSION(max_domains) :: history_interval_h
integer , DIMENSION(max_domains) :: history_interval_m
integer , DIMENSION(max_domains) :: history_interval_s
integer , DIMENSION(max_domains) :: inputout_interval_d
integer , DIMENSION(max_domains) :: inputout_interval_h
integer , DIMENSION(max_domains) :: inputout_interval_m
integer , DIMENSION(max_domains) :: inputout_interval_s
integer , DIMENSION(max_domains) :: inputout_interval
integer :: restart_interval_d
integer :: restart_interval_h
integer :: restart_interval_m
integer :: restart_interval_s
integer , DIMENSION(max_domains) :: history_begin_y
integer , DIMENSION(max_domains) :: history_begin_d
integer , DIMENSION(max_domains) :: history_begin_h
integer , DIMENSION(max_domains) :: history_begin_m
integer , DIMENSION(max_domains) :: history_begin_s
integer , DIMENSION(max_domains) :: history_begin
integer , DIMENSION(max_domains) :: inputout_begin_y
integer , DIMENSION(max_domains) :: inputout_begin_d
integer , DIMENSION(max_domains) :: inputout_begin_h
integer , DIMENSION(max_domains) :: inputout_begin_m
integer , DIMENSION(max_domains) :: inputout_begin_s
integer :: restart_begin_y
integer :: restart_begin_d
integer :: restart_begin_h
integer :: restart_begin_m
integer :: restart_begin_s
integer :: restart_begin
integer , DIMENSION(max_domains) :: history_end_y
integer , DIMENSION(max_domains) :: history_end_d
integer , DIMENSION(max_domains) :: history_end_h
integer , DIMENSION(max_domains) :: history_end_m
integer , DIMENSION(max_domains) :: history_end_s
integer , DIMENSION(max_domains) :: history_end
integer , DIMENSION(max_domains) :: inputout_end_y
integer , DIMENSION(max_domains) :: inputout_end_d
integer , DIMENSION(max_domains) :: inputout_end_h
integer , DIMENSION(max_domains) :: inputout_end_m
integer , DIMENSION(max_domains) :: inputout_end_s
integer :: simulation_start_year
integer :: simulation_start_month
integer :: simulation_start_day
integer :: simulation_start_hour
integer :: simulation_start_minute
integer :: simulation_start_second
logical :: reset_simulation_start
integer , DIMENSION(max_domains) :: sr_x
integer , DIMENSION(max_domains) :: sr_y
character*256 :: sgfdda_inname
character*256 :: gfdda_inname
integer , DIMENSION(max_domains) :: sgfdda_interval_d
integer , DIMENSION(max_domains) :: sgfdda_interval_h
integer , DIMENSION(max_domains) :: sgfdda_interval_m
integer , DIMENSION(max_domains) :: sgfdda_interval_s
integer , DIMENSION(max_domains) :: sgfdda_interval_y
integer , DIMENSION(max_domains) :: sgfdda_interval
integer , DIMENSION(max_domains) :: gfdda_interval_d
integer , DIMENSION(max_domains) :: gfdda_interval_h
integer , DIMENSION(max_domains) :: gfdda_interval_m
integer , DIMENSION(max_domains) :: gfdda_interval_s
integer , DIMENSION(max_domains) :: gfdda_interval_y
integer , DIMENSION(max_domains) :: gfdda_interval
integer , DIMENSION(max_domains) :: sgfdda_begin_y
integer , DIMENSION(max_domains) :: sgfdda_begin_d
integer , DIMENSION(max_domains) :: sgfdda_begin_h
integer , DIMENSION(max_domains) :: sgfdda_begin_m
integer , DIMENSION(max_domains) :: sgfdda_begin_s
integer , DIMENSION(max_domains) :: gfdda_begin_y
integer , DIMENSION(max_domains) :: gfdda_begin_d
integer , DIMENSION(max_domains) :: gfdda_begin_h
integer , DIMENSION(max_domains) :: gfdda_begin_m
integer , DIMENSION(max_domains) :: gfdda_begin_s
integer , DIMENSION(max_domains) :: sgfdda_end_y
integer , DIMENSION(max_domains) :: sgfdda_end_d
integer , DIMENSION(max_domains) :: sgfdda_end_h
integer , DIMENSION(max_domains) :: sgfdda_end_m
integer , DIMENSION(max_domains) :: sgfdda_end_s
integer , DIMENSION(max_domains) :: gfdda_end_y
integer , DIMENSION(max_domains) :: gfdda_end_d
integer , DIMENSION(max_domains) :: gfdda_end_h
integer , DIMENSION(max_domains) :: gfdda_end_m
integer , DIMENSION(max_domains) :: gfdda_end_s
integer :: io_form_sgfdda
integer :: io_form_gfdda
character*256 , DIMENSION(max_domains) :: iofields_filename
logical :: ignore_iofields_warning
logical :: ncd_nofill
integer , DIMENSION(max_domains) :: ifire
integer , DIMENSION(max_domains) :: fire_boundary_guard
integer , DIMENSION(max_domains) :: fire_num_ignitions
real , DIMENSION(max_domains) :: fire_ignition_ros1
real , DIMENSION(max_domains) :: fire_ignition_start_lon1
real , DIMENSION(max_domains) :: fire_ignition_start_lat1
real , DIMENSION(max_domains) :: fire_ignition_end_lon1
real , DIMENSION(max_domains) :: fire_ignition_end_lat1
real , DIMENSION(max_domains) :: fire_ignition_radius1
real , DIMENSION(max_domains) :: fire_ignition_start_time1
real , DIMENSION(max_domains) :: fire_ignition_end_time1
real , DIMENSION(max_domains) :: fire_ignition_ros2
real , DIMENSION(max_domains) :: fire_ignition_start_lon2
real , DIMENSION(max_domains) :: fire_ignition_start_lat2
real , DIMENSION(max_domains) :: fire_ignition_end_lon2
real , DIMENSION(max_domains) :: fire_ignition_end_lat2
real , DIMENSION(max_domains) :: fire_ignition_radius2
real , DIMENSION(max_domains) :: fire_ignition_start_time2
real , DIMENSION(max_domains) :: fire_ignition_end_time2
real , DIMENSION(max_domains) :: fire_ignition_ros3
real , DIMENSION(max_domains) :: fire_ignition_start_lon3
real , DIMENSION(max_domains) :: fire_ignition_start_lat3
real , DIMENSION(max_domains) :: fire_ignition_end_lon3
real , DIMENSION(max_domains) :: fire_ignition_end_lat3
real , DIMENSION(max_domains) :: fire_ignition_radius3
real , DIMENSION(max_domains) :: fire_ignition_start_time3
real , DIMENSION(max_domains) :: fire_ignition_end_time3
real , DIMENSION(max_domains) :: fire_ignition_ros4
real , DIMENSION(max_domains) :: fire_ignition_start_lon4
real , DIMENSION(max_domains) :: fire_ignition_start_lat4
real , DIMENSION(max_domains) :: fire_ignition_end_lon4
real , DIMENSION(max_domains) :: fire_ignition_end_lat4
real , DIMENSION(max_domains) :: fire_ignition_radius4
real , DIMENSION(max_domains) :: fire_ignition_start_time4
real , DIMENSION(max_domains) :: fire_ignition_end_time4
real , DIMENSION(max_domains) :: fire_ignition_ros5
real , DIMENSION(max_domains) :: fire_ignition_start_lon5
real , DIMENSION(max_domains) :: fire_ignition_start_lat5
real , DIMENSION(max_domains) :: fire_ignition_end_lon5
real , DIMENSION(max_domains) :: fire_ignition_end_lat5
real , DIMENSION(max_domains) :: fire_ignition_radius5
real , DIMENSION(max_domains) :: fire_ignition_start_time5
real , DIMENSION(max_domains) :: fire_ignition_end_time5
real , DIMENSION(max_domains) :: fire_ignition_start_x1
real , DIMENSION(max_domains) :: fire_ignition_start_y1
real , DIMENSION(max_domains) :: fire_ignition_end_x1
real , DIMENSION(max_domains) :: fire_ignition_end_y1
real , DIMENSION(max_domains) :: fire_ignition_start_x2
real , DIMENSION(max_domains) :: fire_ignition_start_y2
real , DIMENSION(max_domains) :: fire_ignition_end_x2
real , DIMENSION(max_domains) :: fire_ignition_end_y2
real , DIMENSION(max_domains) :: fire_ignition_start_x3
real , DIMENSION(max_domains) :: fire_ignition_start_y3
real , DIMENSION(max_domains) :: fire_ignition_end_x3
real , DIMENSION(max_domains) :: fire_ignition_end_y3
real , DIMENSION(max_domains) :: fire_ignition_start_x4
real , DIMENSION(max_domains) :: fire_ignition_start_y4
real , DIMENSION(max_domains) :: fire_ignition_end_x4
real , DIMENSION(max_domains) :: fire_ignition_end_y4
real , DIMENSION(max_domains) :: fire_ignition_start_x5
real , DIMENSION(max_domains) :: fire_ignition_start_y5
real , DIMENSION(max_domains) :: fire_ignition_end_x5
real , DIMENSION(max_domains) :: fire_ignition_end_y5
real , DIMENSION(max_domains) :: fire_lat_init
real , DIMENSION(max_domains) :: fire_lon_init
real , DIMENSION(max_domains) :: fire_ign_time
integer , DIMENSION(max_domains) :: fire_shape
integer , DIMENSION(max_domains) :: fire_sprd_mdl
real , DIMENSION(max_domains) :: fire_crwn_hgt
real , DIMENSION(max_domains) :: fire_ext_grnd
real , DIMENSION(max_domains) :: fire_ext_crwn
real , DIMENSION(max_domains) :: fire_wind_height
integer , DIMENSION(max_domains) :: fire_fuel_read
integer , DIMENSION(max_domains) :: fire_fuel_cat
integer , DIMENSION(max_domains) :: fire_print_msg
integer , DIMENSION(max_domains) :: fire_print_file
integer , DIMENSION(max_domains) :: fire_fuel_left_method
integer , DIMENSION(max_domains) :: fire_fuel_left_irl
integer , DIMENSION(max_domains) :: fire_fuel_left_jrl
integer , DIMENSION(max_domains) :: fire_grows_only
integer , DIMENSION(max_domains) :: fire_upwinding
integer , DIMENSION(max_domains) :: fire_upwind_split
real , DIMENSION(max_domains) :: fire_viscosity
real , DIMENSION(max_domains) :: fire_lfn_ext_up
integer , DIMENSION(max_domains) :: fire_topo_from_atm
integer , DIMENSION(max_domains) :: fire_advection
integer , DIMENSION(max_domains) :: fire_test_steps
real , DIMENSION(max_domains) :: fire_const_time
real , DIMENSION(max_domains) :: fire_const_grnhfx
real , DIMENSION(max_domains) :: fire_const_grnqfx
real , DIMENSION(max_domains) :: fire_atm_feedback
integer , DIMENSION(max_domains) :: fire_mountain_type
real , DIMENSION(max_domains) :: fire_mountain_height
real , DIMENSION(max_domains) :: fire_mountain_start_x
real , DIMENSION(max_domains) :: fire_mountain_start_y
real , DIMENSION(max_domains) :: fire_mountain_end_x
real , DIMENSION(max_domains) :: fire_mountain_end_y
real , DIMENSION(max_domains) :: delt_perturbation
real , DIMENSION(max_domains) :: xrad_perturbation
real , DIMENSION(max_domains) :: yrad_perturbation
real , DIMENSION(max_domains) :: zrad_perturbation
real , DIMENSION(max_domains) :: hght_perturbation
logical , DIMENSION(max_domains) :: stretch_grd
logical , DIMENSION(max_domains) :: stretch_hyp
real , DIMENSION(max_domains) :: z_grd_scale
logical , DIMENSION(max_domains) :: sfc_full_init
integer , DIMENSION(max_domains) :: sfc_lu_index
real , DIMENSION(max_domains) :: sfc_tsk
real , DIMENSION(max_domains) :: sfc_tmn
logical , DIMENSION(max_domains) :: fire_read_lu
logical , DIMENSION(max_domains) :: fire_read_tsk
logical , DIMENSION(max_domains) :: fire_read_tmn
logical , DIMENSION(max_domains) :: fire_read_atm_ht
logical , DIMENSION(max_domains) :: fire_read_fire_ht
logical , DIMENSION(max_domains) :: fire_read_atm_grad
logical , DIMENSION(max_domains) :: fire_read_fire_grad
real , DIMENSION(max_domains) :: sfc_vegfra
real , DIMENSION(max_domains) :: sfc_canwat
integer , DIMENSION(max_domains) :: sfc_ivgtyp
integer , DIMENSION(max_domains) :: sfc_isltyp
logical , DIMENSION(max_domains) :: fire_lsm_reinit
integer , DIMENSION(max_domains) :: fire_lsm_reinit_iter
integer , DIMENSION(max_domains) :: fire_upwinding_reinit
logical , DIMENSION(max_domains) :: fire_is_real_perim
integer , DIMENSION(max_domains) :: fire_lsm_band_ngp
logical , DIMENSION(max_domains) :: fire_lsm_zcoupling
real , DIMENSION(max_domains) :: fire_lsm_zcoupling_ref
real , DIMENSION(max_domains) :: fire_tracer_smoke
real , DIMENSION(max_domains) :: fire_viscosity_bg
real , DIMENSION(max_domains) :: fire_viscosity_band
integer , DIMENSION(max_domains) :: fire_viscosity_ngp
real , DIMENSION(max_domains) :: fire_slope_factor
integer , DIMENSION(max_domains) :: do_avgflx_em
integer , DIMENSION(max_domains) :: do_avgflx_cugd
integer :: nens
integer , DIMENSION(max_domains) :: skebs
integer , DIMENSION(max_domains) :: stoch_force_opt
integer :: skebs_vertstruc
integer , DIMENSION(max_domains) :: stoch_vertstruc_opt
real , DIMENSION(max_domains) :: tot_backscat_psi
real , DIMENSION(max_domains) :: tot_backscat_t
real :: ztau_psi
real :: ztau_t
real :: rexponent_psi
real :: rexponent_t
real :: zsigma2_eps
real :: zsigma2_eta
integer :: kminforc
integer :: lminforc
integer :: kminforct
integer :: lminforct
integer :: kmaxforc
integer :: lmaxforc
integer :: kmaxforct
integer :: lmaxforct
integer :: iseed_skebs
integer :: kmaxforch
integer :: lmaxforch
integer :: kmaxforcth
integer :: lmaxforcth
integer , DIMENSION(max_domains) :: sppt
real , DIMENSION(max_domains) :: gridpt_stddev_sppt
real , DIMENSION(max_domains) :: stddev_cutoff_sppt
real , DIMENSION(max_domains) :: lengthscale_sppt
real , DIMENSION(max_domains) :: timescale_sppt
integer :: sppt_vertstruc
integer :: iseed_sppt
integer , DIMENSION(max_domains) :: rand_perturb
real , DIMENSION(max_domains) :: gridpt_stddev_rand_pert
real , DIMENSION(max_domains) :: stddev_cutoff_rand_pert
real , DIMENSION(max_domains) :: lengthscale_rand_pert
real , DIMENSION(max_domains) :: timescale_rand_pert
integer :: rand_pert_vertstruc
integer :: iseed_rand_pert
integer , DIMENSION(max_domains) :: spp
logical :: hrrr_cycling
integer , DIMENSION(max_domains) :: spp_conv
real , DIMENSION(max_domains) :: gridpt_stddev_spp_conv
real , DIMENSION(max_domains) :: stddev_cutoff_spp_conv
real , DIMENSION(max_domains) :: lengthscale_spp_conv
real , DIMENSION(max_domains) :: timescale_spp_conv
integer :: vertstruc_spp_conv
integer :: iseed_spp_conv
integer , DIMENSION(max_domains) :: spp_pbl
real , DIMENSION(max_domains) :: gridpt_stddev_spp_pbl
real , DIMENSION(max_domains) :: stddev_cutoff_spp_pbl
real , DIMENSION(max_domains) :: lengthscale_spp_pbl
real , DIMENSION(max_domains) :: timescale_spp_pbl
integer :: vertstruc_spp_pbl
integer :: iseed_spp_pbl
integer , DIMENSION(max_domains) :: spp_lsm
real , DIMENSION(max_domains) :: gridpt_stddev_spp_lsm
real , DIMENSION(max_domains) :: stddev_cutoff_spp_lsm
real , DIMENSION(max_domains) :: lengthscale_spp_lsm
real , DIMENSION(max_domains) :: timescale_spp_lsm
integer :: vertstruc_spp_lsm
integer :: iseed_spp_lsm
integer :: skebs_on
integer :: sppt_on
integer :: spp_on
integer :: rand_perturb_on
integer :: num_stoch_levels
integer :: seed_dim
integer , DIMENSION(max_domains) :: sfs_opt
integer , DIMENSION(max_domains) :: m_opt
real , DIMENSION(max_domains) :: lakedepth_default
real , DIMENSION(max_domains) :: lake_min_elev
integer , DIMENSION(max_domains) :: use_lakedepth
integer :: p_lev_diags
integer :: p_lev_diags_dfi
integer :: num_press_levels
real , DIMENSION(max_plevs) :: press_levels
integer :: use_tot_or_hyd_p
integer :: extrap_below_grnd
real :: p_lev_missing
real , DIMENSION(max_domains) :: p_lev_interval
integer :: z_lev_diags
integer :: z_lev_diags_dfi
integer :: num_z_levels
real , DIMENSION(max_zlevs) :: z_levels
real :: z_lev_missing
real , DIMENSION(max_domains) :: z_lev_interval
integer , DIMENSION(max_domains) :: afwa_diag_opt
integer , DIMENSION(max_domains) :: afwa_ptype_opt
integer , DIMENSION(max_domains) :: afwa_vil_opt
integer , DIMENSION(max_domains) :: afwa_radar_opt
integer , DIMENSION(max_domains) :: afwa_severe_opt
integer , DIMENSION(max_domains) :: afwa_icing_opt
integer , DIMENSION(max_domains) :: afwa_vis_opt
integer , DIMENSION(max_domains) :: afwa_cloud_opt
integer , DIMENSION(max_domains) :: afwa_therm_opt
integer , DIMENSION(max_domains) :: afwa_turb_opt
integer , DIMENSION(max_domains) :: afwa_buoy_opt
real :: afwa_ptype_ccn_tmp
real :: afwa_ptype_tot_melt
integer :: afwa_bad_data_check
integer :: mean_diag
integer :: mean_freq
integer , DIMENSION(max_domains) :: mean_interval
integer , DIMENSION(max_domains) :: mean_diag_interval
integer , DIMENSION(max_domains) :: mean_diag_interval_s
integer , DIMENSION(max_domains) :: mean_diag_interval_m
integer , DIMENSION(max_domains) :: mean_diag_interval_h
integer , DIMENSION(max_domains) :: mean_diag_interval_d
integer , DIMENSION(max_domains) :: mean_diag_interval_mo
integer :: diurnal_diag
integer , DIMENSION(max_domains) :: nssl_ipelec
integer :: nssl_isaund
integer :: nssl_iscreen
real :: nssl_lightrad
integer :: nssl_idischarge
integer :: nssl_ibrkd
real :: nssl_ecrit
real :: nssl_disfrac
integer :: elec_physics
integer :: perturb_bdy
integer :: perturb_chem_bdy
integer :: hybrid_opt
real :: etac
integer :: num_wif_levels
integer :: wif_input_opt
integer :: diag_nwp2
integer , DIMENSION(max_domains) :: chem_opt
integer    :: last_item_in_struct

   END TYPE model_config_rec_type

   TYPE grid_config_rec_type






integer    :: first_item_in_struct
integer :: run_days
integer :: run_hours
integer :: run_minutes
integer :: run_seconds
integer :: start_year
integer :: start_month
integer :: start_day
integer :: start_hour
integer :: start_minute
integer :: start_second
integer :: end_year
integer :: end_month
integer :: end_day
integer :: end_hour
integer :: end_minute
integer :: end_second
integer :: interval_seconds
logical :: input_from_file
integer :: fine_input_stream
logical :: input_from_hires
character*256 :: rsmas_data_path
logical :: all_ic_times
integer :: julyr
integer :: julday
real :: gmt
character*256 :: input_inname
character*256 :: input_outname
character*256 :: bdy_inname
character*256 :: bdy_outname
character*256 :: rst_inname
character*256 :: rst_outname
logical :: write_input
logical :: write_restart_at_0h
logical :: write_hist_at_0h_rst
logical :: adjust_output_times
logical :: adjust_input_times
integer :: diag_print
logical :: nocolons
logical :: cycling
integer :: output_diagnostics
integer :: nwp_diagnostics
logical :: output_ready_flag
logical :: force_use_old_data
logical :: usepio
integer :: pioprocs
integer :: piostart
integer :: piostride
integer :: pioshift
integer :: dfi_opt
integer :: dfi_savehydmeteors
integer :: dfi_nfilter
logical :: dfi_write_filtered_input
logical :: dfi_write_dfi_history
integer :: dfi_cutoff_seconds
integer :: dfi_time_dim
integer :: dfi_fwdstop_year
integer :: dfi_fwdstop_month
integer :: dfi_fwdstop_day
integer :: dfi_fwdstop_hour
integer :: dfi_fwdstop_minute
integer :: dfi_fwdstop_second
integer :: dfi_bckstop_year
integer :: dfi_bckstop_month
integer :: dfi_bckstop_day
integer :: dfi_bckstop_hour
integer :: dfi_bckstop_minute
integer :: dfi_bckstop_second
integer :: time_step
integer :: time_step_fract_num
integer :: time_step_fract_den
integer :: time_step_dfi
integer :: min_time_step
integer :: min_time_step_den
integer :: max_time_step
integer :: max_time_step_den
real :: target_cfl
real :: target_hcfl
integer :: max_step_increase_pct
integer :: starting_time_step
integer :: starting_time_step_den
logical :: step_to_output_time
integer :: adaptation_domain
logical :: use_adaptive_time_step
logical :: use_adaptive_time_step_dfi
integer :: max_dom
integer :: lats_to_mic
integer :: s_we
integer :: e_we
integer :: s_sn
integer :: e_sn
integer :: s_vert
integer :: e_vert
integer :: num_metgrid_levels
integer :: num_metgrid_soil_levels
real :: p_top_requested
logical :: interp_theta
integer :: interp_type
integer :: rebalance
integer :: vert_refine_method
integer :: vert_refine_fact
integer :: extrap_type
integer :: t_extrap_type
integer :: hypsometric_opt
logical :: lowest_lev_from_sfc
logical :: use_levels_below_ground
logical :: use_tavg_for_tsk
logical :: use_surface
integer :: lagrange_order
integer :: linear_interp
integer :: force_sfc_in_vinterp
real :: zap_close_levels
real :: maxw_horiz_pres_diff
real :: trop_horiz_pres_diff
real :: maxw_above_this_level
integer :: use_maxw_level
integer :: use_trop_level
logical :: sfcp_to_sfcp
logical :: adjust_heights
logical :: smooth_cg_topo
integer :: nest_interp_coord
integer :: interp_method_type
logical :: aggregate_lu
logical :: rh2qv_wrt_liquid
integer :: rh2qv_method
real :: qv_max_p_safe
real :: qv_max_flag
real :: qv_max_value
real :: qv_min_p_safe
real :: qv_min_flag
real :: qv_min_value
integer :: ideal_init_method
real :: dx
real :: dy
integer :: grid_id
logical :: grid_allowed
integer :: parent_id
integer :: i_parent_start
integer :: j_parent_start
integer :: parent_grid_ratio
integer :: parent_time_step_ratio
integer :: feedback
integer :: smooth_option
integer :: blend_width
real :: ztop
integer :: moad_grid_ratio
integer :: moad_time_step_ratio
integer :: shw
integer :: tile_sz_x
integer :: tile_sz_y
integer :: numtiles
integer :: numtiles_inc
integer :: numtiles_x
integer :: numtiles_y
integer :: tile_strategy
integer :: nproc_x
integer :: nproc_y
integer :: irand
real :: dt
integer :: fft_used
integer :: cu_used
integer :: shcu_used
integer :: cam_used
integer :: alloc_qndropsource
integer :: num_moves
integer :: ts_buf_size
integer :: max_ts_locs
logical :: tslist_ij
logical :: tslist_unstagger_winds
integer :: vortex_interval
integer :: max_vortex_speed
integer :: corral_dist
integer :: track_level
real :: time_to_move
integer :: move_id
integer :: move_interval
integer :: move_cd_x
integer :: move_cd_y
logical :: swap_x
logical :: swap_y
logical :: cycle_x
logical :: cycle_y
logical :: reorder_mesh
logical :: perturb_input
real :: eta_levels
integer :: auto_levels_opt
real :: max_dz
real :: dzbot
real :: dzstretch_s
real :: dzstretch_u
integer :: ocean_levels
real :: ocean_z
real :: ocean_t
real :: ocean_s
integer :: num_traj
integer :: max_ts_level
integer :: track_loc_in
integer :: num_ext_model_couple_dom
logical :: insert_bogus_storm
logical :: remove_storm
integer :: num_storm
real :: latc_loc
real :: lonc_loc
real :: vmax_meters_per_second
real :: rmax
real :: vmax_ratio
real :: rankine_lid
character*256 :: physics_suite
logical :: force_read_thompson
logical :: write_thompson_tables
integer :: mp_physics
real :: nssl_cccn
real :: nssl_alphah
real :: nssl_alphahl
real :: nssl_cnoh
real :: nssl_cnohl
real :: nssl_cnor
real :: nssl_cnos
real :: nssl_rho_qh
real :: nssl_rho_qhl
real :: nssl_rho_qs
integer :: nudge_lightning
integer :: nudge_light_times
integer :: nudge_light_timee
integer :: nudge_light_int
character*256 :: path_to_files
integer :: gsfcgce_hail
integer :: gsfcgce_2ice
integer :: progn
real :: accum_mode
real :: aitken_mode
real :: coarse_mode
integer :: do_radar_ref
integer :: compute_radar_ref
integer :: ra_lw_physics
integer :: ra_sw_physics
real :: radt
real :: naer
integer :: sf_sfclay_physics
integer :: sf_surface_physics
integer :: bl_pbl_physics
integer :: bl_mynn_tkebudget
integer :: ysu_topdown_pblmix
integer :: shinhong_tke_diag
logical :: bl_mynn_tkeadvect
integer :: bl_mynn_cloudpdf
integer :: bl_mynn_mixlength
integer :: bl_mynn_edmf
integer :: bl_mynn_edmf_mom
integer :: bl_mynn_edmf_tke
integer :: bl_mynn_mixscalars
integer :: bl_mynn_cloudmix
integer :: bl_mynn_mixqt
integer :: icloud_bl
integer :: mfshconv
integer :: sf_urban_physics
real :: bldt
integer :: cu_physics
integer :: shcu_physics
integer :: cu_diag
integer :: kf_edrates
integer :: kfeta_trigger
integer :: nsas_dx_factor
real :: cudt
real :: gsmdt
integer :: isfflx
integer :: ifsnow
integer :: icloud
integer :: cldovrlp
integer :: ideal_xland
real :: swrad_scat
integer :: surface_input_source
integer :: num_soil_layers
integer :: maxpatch
integer :: num_snow_layers
integer :: num_snso_layers
integer :: num_urban_ndm
integer :: num_urban_ng
integer :: num_urban_nwr
integer :: num_urban_ngb
integer :: num_urban_nf
integer :: num_urban_nz
integer :: num_urban_nbui
integer :: urban_map_zrd
integer :: urban_map_zwd
integer :: urban_map_gd
integer :: urban_map_zd
integer :: urban_map_zdf
integer :: urban_map_bd
integer :: urban_map_wd
integer :: urban_map_gbd
integer :: urban_map_fbd
integer :: num_urban_hi
integer :: num_months
integer :: sf_surface_mosaic
integer :: mosaic_cat
integer :: mosaic_cat_soil
integer :: mosaic_lu
integer :: mosaic_soil
integer :: flag_sm_adj
integer :: maxiens
integer :: maxens
integer :: maxens2
integer :: maxens3
integer :: ensdim
integer :: cugd_avedx
integer :: clos_choice
integer :: imomentum
integer :: ishallow
real :: convtrans_avglen_m
integer :: num_land_cat
integer :: num_soil_cat
integer :: mp_zero_out
real :: mp_zero_out_thresh
real :: seaice_threshold
integer :: sst_update
integer :: sst_skin
integer :: tmn_update
logical :: usemonalb
logical :: rdmaxalb
logical :: rdlai2d
logical :: ua_phys
integer :: opt_thcnd
integer :: co2tf
integer :: ra_call_offset
real :: cam_abs_freq_s
integer :: levsiz
integer :: paerlev
integer :: cam_abs_dim1
integer :: cam_abs_dim2
integer :: lagday
integer :: no_src_types
integer :: alevsiz
integer :: o3input
integer :: aer_opt
integer :: swint_opt
integer :: aer_type
integer :: aer_aod550_opt
integer :: aer_angexp_opt
integer :: aer_ssa_opt
integer :: aer_asy_opt
real :: aer_aod550_val
real :: aer_angexp_val
real :: aer_ssa_val
real :: aer_asy_val
logical :: cu_rad_feedback
integer :: dust_emis
integer :: erosion_dim
integer :: no_src_types_cu
integer :: alevsiz_cu
integer :: aercu_opt
real :: aercu_fct
integer :: aercu_used
logical :: shallowcu_forced_ra
integer :: numbins
real :: thbinsize
real :: rbinsize
real :: mindeepfreq
real :: minshallowfreq
integer :: shcu_aerosols_opt
integer :: icloud_cu
integer :: pxlsm_smois_init
integer :: pxlsm_modis_veg
integer :: omlcall
integer :: sf_ocean_physics
integer :: traj_opt
logical :: dm_has_traj
integer :: tracercall
real :: omdt
real :: oml_hml0
real :: oml_gamma
real :: oml_relaxation_time
integer :: isftcflx
integer :: iz0tlnd
real :: shadlen
integer :: slope_rad
integer :: topo_shading
integer :: topo_wind
integer :: no_mp_heating
integer :: fractional_seaice
integer :: seaice_snowdepth_opt
real :: seaice_snowdepth_max
real :: seaice_snowdepth_min
integer :: seaice_albedo_opt
real :: seaice_albedo_default
integer :: seaice_thickness_opt
real :: seaice_thickness_default
logical :: tice2tsk_if2cold
real :: bucket_mm
real :: bucket_j
real :: mp_tend_lim
real :: prec_acc_dt
integer :: prec_acc_opt
integer :: bucketr_opt
integer :: bucketf_opt
integer :: process_time_series
integer :: grav_settling
real :: sas_pgcon
integer :: scalar_pblmix
integer :: tracer_pblmix
logical :: use_aero_icbc
logical :: use_rap_aero_icbc
integer :: use_mp_re
real :: ccn_conc
integer :: hail_opt
integer :: morr_rimed_ice
integer :: clean_atm_diag
integer :: calc_clean_atm_diag
integer :: dveg
integer :: opt_crs
integer :: opt_btr
integer :: opt_run
integer :: opt_sfc
integer :: opt_frz
integer :: opt_inf
integer :: opt_rad
integer :: opt_alb
integer :: opt_snf
integer :: opt_tbot
integer :: opt_stc
integer :: opt_gla
integer :: opt_rsf
integer :: opt_soil
integer :: opt_pedo
integer :: opt_crop
real :: wtddt
integer :: wrf_hydro
real :: fgdt
integer :: fgdtzero
integer :: grid_fdda
integer :: grid_sfdda
integer :: if_no_pbl_nudging_uv
integer :: if_no_pbl_nudging_t
integer :: if_no_pbl_nudging_ph
integer :: if_no_pbl_nudging_q
integer :: if_zfac_uv
integer :: k_zfac_uv
integer :: if_zfac_t
integer :: k_zfac_t
integer :: if_zfac_ph
integer :: k_zfac_ph
integer :: if_zfac_q
integer :: k_zfac_q
integer :: dk_zfac_uv
integer :: dk_zfac_t
integer :: dk_zfac_ph
integer :: dk_zfac_q
integer :: ktrop
real :: guv
real :: guv_sfc
real :: gt
real :: gt_sfc
real :: gq
real :: gq_sfc
real :: gph
real :: dtramp_min
integer :: if_ramping
real :: rinblw
integer :: xwavenum
integer :: ywavenum
integer :: pxlsm_soil_nudge
integer :: fasdas
integer :: obs_nudge_opt
integer :: max_obs
real :: fdda_start
real :: fdda_end
integer :: obs_nudge_wind
real :: obs_coef_wind
integer :: obs_nudge_temp
real :: obs_coef_temp
integer :: obs_nudge_mois
real :: obs_coef_mois
integer :: obs_nudge_pstr
real :: obs_coef_pstr
integer :: obs_no_pbl_nudge_uv
integer :: obs_no_pbl_nudge_t
integer :: obs_no_pbl_nudge_q
integer :: obs_sfc_scheme_horiz
integer :: obs_sfc_scheme_vert
real :: obs_max_sndng_gap
real :: obs_nudgezfullr1_uv
real :: obs_nudgezrampr1_uv
real :: obs_nudgezfullr2_uv
real :: obs_nudgezrampr2_uv
real :: obs_nudgezfullr4_uv
real :: obs_nudgezrampr4_uv
real :: obs_nudgezfullr1_t
real :: obs_nudgezrampr1_t
real :: obs_nudgezfullr2_t
real :: obs_nudgezrampr2_t
real :: obs_nudgezfullr4_t
real :: obs_nudgezrampr4_t
real :: obs_nudgezfullr1_q
real :: obs_nudgezrampr1_q
real :: obs_nudgezfullr2_q
real :: obs_nudgezrampr2_q
real :: obs_nudgezfullr4_q
real :: obs_nudgezrampr4_q
real :: obs_nudgezfullmin
real :: obs_nudgezrampmin
real :: obs_nudgezmax
real :: obs_sfcfact
real :: obs_sfcfacr
real :: obs_dpsmx
real :: obs_rinxy
real :: obs_rinsig
real :: obs_twindo
integer :: obs_npfi
integer :: obs_ionf
integer :: obs_idynin
real :: obs_dtramp
integer :: obs_prt_max
integer :: obs_prt_freq
logical :: obs_ipf_in4dob
logical :: obs_ipf_errob
logical :: obs_ipf_nudob
logical :: obs_ipf_init
integer :: obs_scl_neg_qv_innov
integer :: scm_force
real :: scm_force_dx
integer :: num_force_layers
integer :: scm_lu_index
integer :: scm_isltyp
real :: scm_vegfra
real :: scm_canwat
real :: scm_lat
real :: scm_lon
logical :: scm_th_t_tend
logical :: scm_qv_t_tend
logical :: scm_th_adv
logical :: scm_wind_adv
logical :: scm_qv_adv
logical :: scm_ql_adv
logical :: scm_vert_adv
integer :: num_force_soil_layers
logical :: scm_soilt_force
logical :: scm_soilq_force
logical :: scm_force_th_largescale
logical :: scm_force_qv_largescale
logical :: scm_force_ql_largescale
logical :: scm_force_wind_largescale
integer :: scm_force_skintemp
integer :: scm_force_flux
integer :: dyn_opt
integer :: rk_ord
integer :: w_damping
integer :: diff_opt
integer :: diff_opt_dfi
integer :: km_opt
integer :: km_opt_dfi
integer :: damp_opt
integer :: rad_nudge
integer :: gwd_opt
real :: max_rot_angle_gwd
real :: zdamp
real :: dampcoef
real :: khdif
real :: kvdif
real :: diff_6th_factor
integer :: diff_6th_opt
integer :: diff_6th_slopeopt
real :: diff_6th_thresh
integer :: use_theta_m
integer :: use_q_diabatic
real :: c_s
real :: c_k
real :: smdiv
real :: emdiv
real :: epssm
logical :: non_hydrostatic
logical :: use_input_w
integer :: time_step_sound
integer :: h_mom_adv_order
integer :: v_mom_adv_order
integer :: h_sca_adv_order
integer :: v_sca_adv_order
integer :: momentum_adv_opt
integer :: moist_adv_opt
integer :: moist_adv_dfi_opt
integer :: chem_adv_opt
integer :: tracer_adv_opt
integer :: scalar_adv_opt
integer :: tke_adv_opt
logical :: moist_mix2_off
logical :: chem_mix2_off
logical :: tracer_mix2_off
logical :: scalar_mix2_off
logical :: tke_mix2_off
logical :: moist_mix6_off
logical :: chem_mix6_off
logical :: tracer_mix6_off
logical :: scalar_mix6_off
logical :: tke_mix6_off
logical :: top_radiation
integer :: mix_isotropic
real :: mix_upper_bound
logical :: top_lid
real :: tke_upper_bound
real :: tke_drag_coefficient
real :: tke_heat_flux
logical :: pert_coriolis
logical :: coriolis2d
logical :: mix_full_fields
real :: base_pres
real :: base_temp
real :: base_lapse
real :: iso_temp
real :: base_pres_strat
real :: base_lapse_strat
logical :: use_baseparam_fr_nml
real :: fft_filter_lat
logical :: coupled_filtering
logical :: pos_def
logical :: swap_pole_with_next_j
logical :: actual_distance_average
logical :: rotated_pole
logical :: do_coriolis
logical :: do_curvature
logical :: do_gradp
integer :: tracer_opt
integer :: tenddiag
integer :: spec_bdy_width
integer :: spec_zone
integer :: relax_zone
logical :: specified
logical :: constant_bc
logical :: periodic_x
logical :: symmetric_xs
logical :: symmetric_xe
logical :: open_xs
logical :: open_xe
logical :: periodic_y
logical :: symmetric_ys
logical :: symmetric_ye
logical :: open_ys
logical :: open_ye
logical :: polar
logical :: nested
real :: spec_exp
integer :: spec_bdy_final_mu
integer :: real_data_init_type
logical :: have_bcs_moist
logical :: have_bcs_scalar
integer :: background_proc_id
integer :: forecast_proc_id
integer :: production_status
integer :: compression
integer :: nobs_ndg_vars
integer :: nobs_err_flds
real :: cen_lat
real :: cen_lon
real :: truelat1
real :: truelat2
real :: moad_cen_lat
real :: stand_lon
real :: pole_lat
real :: pole_lon
integer :: flag_metgrid
integer :: flag_snow
integer :: flag_psfc
integer :: flag_sm000010
integer :: flag_sm010040
integer :: flag_sm040100
integer :: flag_sm100200
integer :: flag_st000010
integer :: flag_st010040
integer :: flag_st040100
integer :: flag_st100200
integer :: flag_soil_layers
integer :: flag_slp
integer :: flag_soilhgt
integer :: flag_mf_xy
integer :: flag_um_soil
real :: bdyfrq
character*256 :: mminlu
integer :: iswater
integer :: islake
integer :: isice
integer :: isurban
integer :: isoilwater
integer :: map_proj
integer :: use_wps_input
integer :: dfi_stage
integer :: mp_physics_dfi
integer :: bl_pbl_physics_dfi
integer :: windfarm_opt
integer :: windfarm_ij
integer :: ideal_case
integer :: hailcast_opt
real :: haildt
integer :: lightning_option
real :: lightning_dt
real :: lightning_start_seconds
real :: flashrate_factor
integer :: iccg_method
real :: iccg_prescribed_num
real :: iccg_prescribed_den
integer :: cellcount_method
real :: cldtop_adjustment
integer :: sf_lake_physics
character*256 :: auxinput1_inname
integer :: io_form_auxinput1
logical :: override_restart_timers
character*256 :: auxhist1_inname
character*256 :: auxhist1_outname
integer :: auxhist1_interval_y
integer :: auxhist1_interval_d
integer :: auxhist1_interval_h
integer :: auxhist1_interval_m
integer :: auxhist1_interval_s
integer :: auxhist1_interval
integer :: auxhist1_begin_y
integer :: auxhist1_begin_d
integer :: auxhist1_begin_h
integer :: auxhist1_begin_m
integer :: auxhist1_begin_s
integer :: auxhist1_begin
integer :: auxhist1_end_y
integer :: auxhist1_end_d
integer :: auxhist1_end_h
integer :: auxhist1_end_m
integer :: auxhist1_end_s
integer :: auxhist1_end
integer :: io_form_auxhist1
integer :: frames_per_auxhist1
character*256 :: auxhist2_inname
character*256 :: auxhist2_outname
integer :: auxhist2_interval_y
integer :: auxhist2_interval_d
integer :: auxhist2_interval_h
integer :: auxhist2_interval_m
integer :: auxhist2_interval_s
integer :: auxhist2_interval
integer :: auxhist2_begin_y
integer :: auxhist2_begin_d
integer :: auxhist2_begin_h
integer :: auxhist2_begin_m
integer :: auxhist2_begin_s
integer :: auxhist2_begin
integer :: auxhist2_end_y
integer :: auxhist2_end_d
integer :: auxhist2_end_h
integer :: auxhist2_end_m
integer :: auxhist2_end_s
integer :: auxhist2_end
integer :: io_form_auxhist2
integer :: frames_per_auxhist2
character*256 :: auxhist3_inname
character*256 :: auxhist3_outname
integer :: auxhist3_interval_y
integer :: auxhist3_interval_d
integer :: auxhist3_interval_h
integer :: auxhist3_interval_m
integer :: auxhist3_interval_s
integer :: auxhist3_interval
integer :: auxhist3_begin_y
integer :: auxhist3_begin_d
integer :: auxhist3_begin_h
integer :: auxhist3_begin_m
integer :: auxhist3_begin_s
integer :: auxhist3_begin
integer :: auxhist3_end_y
integer :: auxhist3_end_d
integer :: auxhist3_end_h
integer :: auxhist3_end_m
integer :: auxhist3_end_s
integer :: auxhist3_end
integer :: io_form_auxhist3
integer :: frames_per_auxhist3
character*256 :: auxhist4_inname
character*256 :: auxhist4_outname
integer :: auxhist4_interval_y
integer :: auxhist4_interval_d
integer :: auxhist4_interval_h
integer :: auxhist4_interval_m
integer :: auxhist4_interval_s
integer :: auxhist4_interval
integer :: auxhist4_begin_y
integer :: auxhist4_begin_d
integer :: auxhist4_begin_h
integer :: auxhist4_begin_m
integer :: auxhist4_begin_s
integer :: auxhist4_begin
integer :: auxhist4_end_y
integer :: auxhist4_end_d
integer :: auxhist4_end_h
integer :: auxhist4_end_m
integer :: auxhist4_end_s
integer :: auxhist4_end
integer :: io_form_auxhist4
integer :: frames_per_auxhist4
character*256 :: auxhist5_inname
character*256 :: auxhist5_outname
integer :: auxhist5_interval_y
integer :: auxhist5_interval_d
integer :: auxhist5_interval_h
integer :: auxhist5_interval_m
integer :: auxhist5_interval_s
integer :: auxhist5_interval
integer :: auxhist5_begin_y
integer :: auxhist5_begin_d
integer :: auxhist5_begin_h
integer :: auxhist5_begin_m
integer :: auxhist5_begin_s
integer :: auxhist5_begin
integer :: auxhist5_end_y
integer :: auxhist5_end_d
integer :: auxhist5_end_h
integer :: auxhist5_end_m
integer :: auxhist5_end_s
integer :: auxhist5_end
integer :: io_form_auxhist5
integer :: frames_per_auxhist5
character*256 :: auxhist6_inname
character*256 :: auxhist6_outname
integer :: auxhist6_interval_y
integer :: auxhist6_interval_d
integer :: auxhist6_interval_h
integer :: auxhist6_interval_m
integer :: auxhist6_interval_s
integer :: auxhist6_interval
integer :: auxhist6_begin_y
integer :: auxhist6_begin_d
integer :: auxhist6_begin_h
integer :: auxhist6_begin_m
integer :: auxhist6_begin_s
integer :: auxhist6_begin
integer :: auxhist6_end_y
integer :: auxhist6_end_d
integer :: auxhist6_end_h
integer :: auxhist6_end_m
integer :: auxhist6_end_s
integer :: auxhist6_end
integer :: io_form_auxhist6
integer :: frames_per_auxhist6
character*256 :: auxhist7_inname
character*256 :: auxhist7_outname
integer :: auxhist7_interval_y
integer :: auxhist7_interval_d
integer :: auxhist7_interval_h
integer :: auxhist7_interval_m
integer :: auxhist7_interval_s
integer :: auxhist7_interval
integer :: auxhist7_begin_y
integer :: auxhist7_begin_d
integer :: auxhist7_begin_h
integer :: auxhist7_begin_m
integer :: auxhist7_begin_s
integer :: auxhist7_begin
integer :: auxhist7_end_y
integer :: auxhist7_end_d
integer :: auxhist7_end_h
integer :: auxhist7_end_m
integer :: auxhist7_end_s
integer :: auxhist7_end
integer :: io_form_auxhist7
integer :: frames_per_auxhist7
character*256 :: auxhist8_inname
character*256 :: auxhist8_outname
integer :: auxhist8_interval_y
integer :: auxhist8_interval_d
integer :: auxhist8_interval_h
integer :: auxhist8_interval_m
integer :: auxhist8_interval_s
integer :: auxhist8_interval
integer :: auxhist8_begin_y
integer :: auxhist8_begin_d
integer :: auxhist8_begin_h
integer :: auxhist8_begin_m
integer :: auxhist8_begin_s
integer :: auxhist8_begin
integer :: auxhist8_end_y
integer :: auxhist8_end_d
integer :: auxhist8_end_h
integer :: auxhist8_end_m
integer :: auxhist8_end_s
integer :: auxhist8_end
integer :: io_form_auxhist8
integer :: frames_per_auxhist8
character*256 :: auxhist9_inname
character*256 :: auxhist9_outname
integer :: auxhist9_interval_y
integer :: auxhist9_interval_d
integer :: auxhist9_interval_h
integer :: auxhist9_interval_m
integer :: auxhist9_interval_s
integer :: auxhist9_interval
integer :: auxhist9_begin_y
integer :: auxhist9_begin_d
integer :: auxhist9_begin_h
integer :: auxhist9_begin_m
integer :: auxhist9_begin_s
integer :: auxhist9_begin
integer :: auxhist9_end_y
integer :: auxhist9_end_d
integer :: auxhist9_end_h
integer :: auxhist9_end_m
integer :: auxhist9_end_s
integer :: auxhist9_end
integer :: io_form_auxhist9
integer :: frames_per_auxhist9
character*256 :: auxhist10_inname
character*256 :: auxhist10_outname
integer :: auxhist10_interval_y
integer :: auxhist10_interval_d
integer :: auxhist10_interval_h
integer :: auxhist10_interval_m
integer :: auxhist10_interval_s
integer :: auxhist10_interval
integer :: auxhist10_begin_y
integer :: auxhist10_begin_d
integer :: auxhist10_begin_h
integer :: auxhist10_begin_m
integer :: auxhist10_begin_s
integer :: auxhist10_begin
integer :: auxhist10_end_y
integer :: auxhist10_end_d
integer :: auxhist10_end_h
integer :: auxhist10_end_m
integer :: auxhist10_end_s
integer :: auxhist10_end
integer :: io_form_auxhist10
integer :: frames_per_auxhist10
character*256 :: auxhist11_inname
character*256 :: auxhist11_outname
integer :: auxhist11_interval_y
integer :: auxhist11_interval_d
integer :: auxhist11_interval_h
integer :: auxhist11_interval_m
integer :: auxhist11_interval_s
integer :: auxhist11_interval
integer :: auxhist11_begin_y
integer :: auxhist11_begin_d
integer :: auxhist11_begin_h
integer :: auxhist11_begin_m
integer :: auxhist11_begin_s
integer :: auxhist11_begin
integer :: auxhist11_end_y
integer :: auxhist11_end_d
integer :: auxhist11_end_h
integer :: auxhist11_end_m
integer :: auxhist11_end_s
integer :: auxhist11_end
integer :: io_form_auxhist11
integer :: frames_per_auxhist11
character*256 :: auxhist12_inname
character*256 :: auxhist12_outname
integer :: auxhist12_interval_y
integer :: auxhist12_interval_d
integer :: auxhist12_interval_h
integer :: auxhist12_interval_m
integer :: auxhist12_interval_s
integer :: auxhist12_interval
integer :: auxhist12_begin_y
integer :: auxhist12_begin_d
integer :: auxhist12_begin_h
integer :: auxhist12_begin_m
integer :: auxhist12_begin_s
integer :: auxhist12_begin
integer :: auxhist12_end_y
integer :: auxhist12_end_d
integer :: auxhist12_end_h
integer :: auxhist12_end_m
integer :: auxhist12_end_s
integer :: auxhist12_end
integer :: io_form_auxhist12
integer :: frames_per_auxhist12
character*256 :: auxhist13_inname
character*256 :: auxhist13_outname
integer :: auxhist13_interval_y
integer :: auxhist13_interval_d
integer :: auxhist13_interval_h
integer :: auxhist13_interval_m
integer :: auxhist13_interval_s
integer :: auxhist13_interval
integer :: auxhist13_begin_y
integer :: auxhist13_begin_d
integer :: auxhist13_begin_h
integer :: auxhist13_begin_m
integer :: auxhist13_begin_s
integer :: auxhist13_begin
integer :: auxhist13_end_y
integer :: auxhist13_end_d
integer :: auxhist13_end_h
integer :: auxhist13_end_m
integer :: auxhist13_end_s
integer :: auxhist13_end
integer :: io_form_auxhist13
integer :: frames_per_auxhist13
character*256 :: auxhist14_inname
character*256 :: auxhist14_outname
integer :: auxhist14_interval_y
integer :: auxhist14_interval_d
integer :: auxhist14_interval_h
integer :: auxhist14_interval_m
integer :: auxhist14_interval_s
integer :: auxhist14_interval
integer :: auxhist14_begin_y
integer :: auxhist14_begin_d
integer :: auxhist14_begin_h
integer :: auxhist14_begin_m
integer :: auxhist14_begin_s
integer :: auxhist14_begin
integer :: auxhist14_end_y
integer :: auxhist14_end_d
integer :: auxhist14_end_h
integer :: auxhist14_end_m
integer :: auxhist14_end_s
integer :: auxhist14_end
integer :: io_form_auxhist14
integer :: frames_per_auxhist14
character*256 :: auxhist15_inname
character*256 :: auxhist15_outname
integer :: auxhist15_interval_y
integer :: auxhist15_interval_d
integer :: auxhist15_interval_h
integer :: auxhist15_interval_m
integer :: auxhist15_interval_s
integer :: auxhist15_interval
integer :: auxhist15_begin_y
integer :: auxhist15_begin_d
integer :: auxhist15_begin_h
integer :: auxhist15_begin_m
integer :: auxhist15_begin_s
integer :: auxhist15_begin
integer :: auxhist15_end_y
integer :: auxhist15_end_d
integer :: auxhist15_end_h
integer :: auxhist15_end_m
integer :: auxhist15_end_s
integer :: auxhist15_end
integer :: io_form_auxhist15
integer :: frames_per_auxhist15
character*256 :: auxhist16_inname
character*256 :: auxhist16_outname
integer :: auxhist16_interval_y
integer :: auxhist16_interval_d
integer :: auxhist16_interval_h
integer :: auxhist16_interval_m
integer :: auxhist16_interval_s
integer :: auxhist16_interval
integer :: auxhist16_begin_y
integer :: auxhist16_begin_d
integer :: auxhist16_begin_h
integer :: auxhist16_begin_m
integer :: auxhist16_begin_s
integer :: auxhist16_begin
integer :: auxhist16_end_y
integer :: auxhist16_end_d
integer :: auxhist16_end_h
integer :: auxhist16_end_m
integer :: auxhist16_end_s
integer :: auxhist16_end
integer :: io_form_auxhist16
integer :: frames_per_auxhist16
character*256 :: auxhist17_inname
character*256 :: auxhist17_outname
integer :: auxhist17_interval_y
integer :: auxhist17_interval_d
integer :: auxhist17_interval_h
integer :: auxhist17_interval_m
integer :: auxhist17_interval_s
integer :: auxhist17_interval
integer :: auxhist17_begin_y
integer :: auxhist17_begin_d
integer :: auxhist17_begin_h
integer :: auxhist17_begin_m
integer :: auxhist17_begin_s
integer :: auxhist17_begin
integer :: auxhist17_end_y
integer :: auxhist17_end_d
integer :: auxhist17_end_h
integer :: auxhist17_end_m
integer :: auxhist17_end_s
integer :: auxhist17_end
integer :: io_form_auxhist17
integer :: frames_per_auxhist17
character*256 :: auxhist18_inname
character*256 :: auxhist18_outname
integer :: auxhist18_interval_y
integer :: auxhist18_interval_d
integer :: auxhist18_interval_h
integer :: auxhist18_interval_m
integer :: auxhist18_interval_s
integer :: auxhist18_interval
integer :: auxhist18_begin_y
integer :: auxhist18_begin_d
integer :: auxhist18_begin_h
integer :: auxhist18_begin_m
integer :: auxhist18_begin_s
integer :: auxhist18_begin
integer :: auxhist18_end_y
integer :: auxhist18_end_d
integer :: auxhist18_end_h
integer :: auxhist18_end_m
integer :: auxhist18_end_s
integer :: auxhist18_end
integer :: io_form_auxhist18
integer :: frames_per_auxhist18
character*256 :: auxhist19_inname
character*256 :: auxhist19_outname
integer :: auxhist19_interval_y
integer :: auxhist19_interval_d
integer :: auxhist19_interval_h
integer :: auxhist19_interval_m
integer :: auxhist19_interval_s
integer :: auxhist19_interval
integer :: auxhist19_begin_y
integer :: auxhist19_begin_d
integer :: auxhist19_begin_h
integer :: auxhist19_begin_m
integer :: auxhist19_begin_s
integer :: auxhist19_begin
integer :: auxhist19_end_y
integer :: auxhist19_end_d
integer :: auxhist19_end_h
integer :: auxhist19_end_m
integer :: auxhist19_end_s
integer :: auxhist19_end
integer :: io_form_auxhist19
integer :: frames_per_auxhist19
character*256 :: auxhist20_inname
character*256 :: auxhist20_outname
integer :: auxhist20_interval_y
integer :: auxhist20_interval_d
integer :: auxhist20_interval_h
integer :: auxhist20_interval_m
integer :: auxhist20_interval_s
integer :: auxhist20_interval
integer :: auxhist20_begin_y
integer :: auxhist20_begin_d
integer :: auxhist20_begin_h
integer :: auxhist20_begin_m
integer :: auxhist20_begin_s
integer :: auxhist20_begin
integer :: auxhist20_end_y
integer :: auxhist20_end_d
integer :: auxhist20_end_h
integer :: auxhist20_end_m
integer :: auxhist20_end_s
integer :: auxhist20_end
integer :: io_form_auxhist20
integer :: frames_per_auxhist20
character*256 :: auxhist21_inname
character*256 :: auxhist21_outname
integer :: auxhist21_interval_y
integer :: auxhist21_interval_d
integer :: auxhist21_interval_h
integer :: auxhist21_interval_m
integer :: auxhist21_interval_s
integer :: auxhist21_interval
integer :: auxhist21_begin_y
integer :: auxhist21_begin_d
integer :: auxhist21_begin_h
integer :: auxhist21_begin_m
integer :: auxhist21_begin_s
integer :: auxhist21_begin
integer :: auxhist21_end_y
integer :: auxhist21_end_d
integer :: auxhist21_end_h
integer :: auxhist21_end_m
integer :: auxhist21_end_s
integer :: auxhist21_end
integer :: io_form_auxhist21
integer :: frames_per_auxhist21
character*256 :: auxhist22_inname
character*256 :: auxhist22_outname
integer :: auxhist22_interval_y
integer :: auxhist22_interval_d
integer :: auxhist22_interval_h
integer :: auxhist22_interval_m
integer :: auxhist22_interval_s
integer :: auxhist22_interval
integer :: auxhist22_begin_y
integer :: auxhist22_begin_d
integer :: auxhist22_begin_h
integer :: auxhist22_begin_m
integer :: auxhist22_begin_s
integer :: auxhist22_begin
integer :: auxhist22_end_y
integer :: auxhist22_end_d
integer :: auxhist22_end_h
integer :: auxhist22_end_m
integer :: auxhist22_end_s
integer :: auxhist22_end
integer :: io_form_auxhist22
integer :: frames_per_auxhist22
character*256 :: auxhist23_inname
character*256 :: auxhist23_outname
integer :: auxhist23_interval_y
integer :: auxhist23_interval_d
integer :: auxhist23_interval_h
integer :: auxhist23_interval_m
integer :: auxhist23_interval_s
integer :: auxhist23_interval
integer :: auxhist23_begin_y
integer :: auxhist23_begin_d
integer :: auxhist23_begin_h
integer :: auxhist23_begin_m
integer :: auxhist23_begin_s
integer :: auxhist23_begin
integer :: auxhist23_end_y
integer :: auxhist23_end_d
integer :: auxhist23_end_h
integer :: auxhist23_end_m
integer :: auxhist23_end_s
integer :: auxhist23_end
integer :: io_form_auxhist23
integer :: frames_per_auxhist23
character*256 :: auxhist24_inname
character*256 :: auxhist24_outname
integer :: auxhist24_interval_y
integer :: auxhist24_interval_d
integer :: auxhist24_interval_h
integer :: auxhist24_interval_m
integer :: auxhist24_interval_s
integer :: auxhist24_interval
integer :: auxhist24_begin_y
integer :: auxhist24_begin_d
integer :: auxhist24_begin_h
integer :: auxhist24_begin_m
integer :: auxhist24_begin_s
integer :: auxhist24_begin
integer :: auxhist24_end_y
integer :: auxhist24_end_d
integer :: auxhist24_end_h
integer :: auxhist24_end_m
integer :: auxhist24_end_s
integer :: auxhist24_end
integer :: io_form_auxhist24
integer :: frames_per_auxhist24
character*256 :: auxinput1_outname
integer :: auxinput1_interval_y
integer :: auxinput1_interval_d
integer :: auxinput1_interval_h
integer :: auxinput1_interval_m
integer :: auxinput1_interval_s
integer :: auxinput1_interval
integer :: auxinput1_begin_y
integer :: auxinput1_begin_d
integer :: auxinput1_begin_h
integer :: auxinput1_begin_m
integer :: auxinput1_begin_s
integer :: auxinput1_begin
integer :: auxinput1_end_y
integer :: auxinput1_end_d
integer :: auxinput1_end_h
integer :: auxinput1_end_m
integer :: auxinput1_end_s
integer :: auxinput1_end
integer :: frames_per_auxinput1
character*256 :: auxinput2_inname
character*256 :: auxinput2_outname
integer :: auxinput2_interval_y
integer :: auxinput2_interval_d
integer :: auxinput2_interval_h
integer :: auxinput2_interval_m
integer :: auxinput2_interval_s
integer :: auxinput2_interval
integer :: auxinput2_begin_y
integer :: auxinput2_begin_d
integer :: auxinput2_begin_h
integer :: auxinput2_begin_m
integer :: auxinput2_begin_s
integer :: auxinput2_begin
integer :: auxinput2_end_y
integer :: auxinput2_end_d
integer :: auxinput2_end_h
integer :: auxinput2_end_m
integer :: auxinput2_end_s
integer :: auxinput2_end
integer :: io_form_auxinput2
integer :: frames_per_auxinput2
character*256 :: auxinput3_inname
character*256 :: auxinput3_outname
integer :: auxinput3_interval_y
integer :: auxinput3_interval_d
integer :: auxinput3_interval_h
integer :: auxinput3_interval_m
integer :: auxinput3_interval_s
integer :: auxinput3_interval
integer :: auxinput3_begin_y
integer :: auxinput3_begin_d
integer :: auxinput3_begin_h
integer :: auxinput3_begin_m
integer :: auxinput3_begin_s
integer :: auxinput3_begin
integer :: auxinput3_end_y
integer :: auxinput3_end_d
integer :: auxinput3_end_h
integer :: auxinput3_end_m
integer :: auxinput3_end_s
integer :: auxinput3_end
integer :: io_form_auxinput3
integer :: frames_per_auxinput3
character*256 :: auxinput4_inname
character*256 :: auxinput4_outname
integer :: auxinput4_interval_y
integer :: auxinput4_interval_d
integer :: auxinput4_interval_h
integer :: auxinput4_interval_m
integer :: auxinput4_interval_s
integer :: auxinput4_interval
integer :: auxinput4_begin_y
integer :: auxinput4_begin_d
integer :: auxinput4_begin_h
integer :: auxinput4_begin_m
integer :: auxinput4_begin_s
integer :: auxinput4_begin
integer :: auxinput4_end_y
integer :: auxinput4_end_d
integer :: auxinput4_end_h
integer :: auxinput4_end_m
integer :: auxinput4_end_s
integer :: auxinput4_end
integer :: io_form_auxinput4
integer :: frames_per_auxinput4
character*256 :: auxinput5_inname
character*256 :: auxinput5_outname
integer :: auxinput5_interval_y
integer :: auxinput5_interval_d
integer :: auxinput5_interval_h
integer :: auxinput5_interval_m
integer :: auxinput5_interval_s
integer :: auxinput5_interval
integer :: auxinput5_begin_y
integer :: auxinput5_begin_d
integer :: auxinput5_begin_h
integer :: auxinput5_begin_m
integer :: auxinput5_begin_s
integer :: auxinput5_begin
integer :: auxinput5_end_y
integer :: auxinput5_end_d
integer :: auxinput5_end_h
integer :: auxinput5_end_m
integer :: auxinput5_end_s
integer :: auxinput5_end
integer :: io_form_auxinput5
integer :: frames_per_auxinput5
character*256 :: auxinput6_inname
character*256 :: auxinput6_outname
integer :: auxinput6_interval_y
integer :: auxinput6_interval_d
integer :: auxinput6_interval_h
integer :: auxinput6_interval_m
integer :: auxinput6_interval_s
integer :: auxinput6_interval
integer :: auxinput6_begin_y
integer :: auxinput6_begin_d
integer :: auxinput6_begin_h
integer :: auxinput6_begin_m
integer :: auxinput6_begin_s
integer :: auxinput6_begin
integer :: auxinput6_end_y
integer :: auxinput6_end_d
integer :: auxinput6_end_h
integer :: auxinput6_end_m
integer :: auxinput6_end_s
integer :: auxinput6_end
integer :: io_form_auxinput6
integer :: frames_per_auxinput6
character*256 :: auxinput7_inname
character*256 :: auxinput7_outname
integer :: auxinput7_interval_y
integer :: auxinput7_interval_d
integer :: auxinput7_interval_h
integer :: auxinput7_interval_m
integer :: auxinput7_interval_s
integer :: auxinput7_interval
integer :: auxinput7_begin_y
integer :: auxinput7_begin_d
integer :: auxinput7_begin_h
integer :: auxinput7_begin_m
integer :: auxinput7_begin_s
integer :: auxinput7_begin
integer :: auxinput7_end_y
integer :: auxinput7_end_d
integer :: auxinput7_end_h
integer :: auxinput7_end_m
integer :: auxinput7_end_s
integer :: auxinput7_end
integer :: io_form_auxinput7
integer :: frames_per_auxinput7
character*256 :: auxinput8_inname
character*256 :: auxinput8_outname
integer :: auxinput8_interval_y
integer :: auxinput8_interval_d
integer :: auxinput8_interval_h
integer :: auxinput8_interval_m
integer :: auxinput8_interval_s
integer :: auxinput8_interval
integer :: auxinput8_begin_y
integer :: auxinput8_begin_d
integer :: auxinput8_begin_h
integer :: auxinput8_begin_m
integer :: auxinput8_begin_s
integer :: auxinput8_begin
integer :: auxinput8_end_y
integer :: auxinput8_end_d
integer :: auxinput8_end_h
integer :: auxinput8_end_m
integer :: auxinput8_end_s
integer :: auxinput8_end
integer :: io_form_auxinput8
integer :: frames_per_auxinput8
character*256 :: auxinput9_inname
character*256 :: auxinput9_outname
integer :: auxinput9_interval_y
integer :: auxinput9_interval_d
integer :: auxinput9_interval_h
integer :: auxinput9_interval_m
integer :: auxinput9_interval_s
integer :: auxinput9_interval
integer :: auxinput9_begin_y
integer :: auxinput9_begin_d
integer :: auxinput9_begin_h
integer :: auxinput9_begin_m
integer :: auxinput9_begin_s
integer :: auxinput9_begin
integer :: auxinput9_end_y
integer :: auxinput9_end_d
integer :: auxinput9_end_h
integer :: auxinput9_end_m
integer :: auxinput9_end_s
integer :: auxinput9_end
integer :: io_form_auxinput9
integer :: frames_per_auxinput9
character*256 :: auxinput10_inname
character*256 :: auxinput10_outname
integer :: auxinput10_interval_y
integer :: auxinput10_interval_d
integer :: auxinput10_interval_h
integer :: auxinput10_interval_m
integer :: auxinput10_interval_s
integer :: auxinput10_interval
integer :: auxinput10_begin_y
integer :: auxinput10_begin_d
integer :: auxinput10_begin_h
integer :: auxinput10_begin_m
integer :: auxinput10_begin_s
integer :: auxinput10_begin
integer :: auxinput10_end_y
integer :: auxinput10_end_d
integer :: auxinput10_end_h
integer :: auxinput10_end_m
integer :: auxinput10_end_s
integer :: auxinput10_end
integer :: io_form_auxinput10
integer :: frames_per_auxinput10
character*256 :: auxinput11_inname
character*256 :: auxinput11_outname
integer :: auxinput11_interval_y
integer :: auxinput11_interval_d
integer :: auxinput11_interval_h
integer :: auxinput11_interval_m
integer :: auxinput11_interval_s
integer :: auxinput11_interval
integer :: auxinput11_begin_y
integer :: auxinput11_begin_d
integer :: auxinput11_begin_h
integer :: auxinput11_begin_m
integer :: auxinput11_begin_s
integer :: auxinput11_begin
integer :: auxinput11_end_y
integer :: auxinput11_end_d
integer :: auxinput11_end_h
integer :: auxinput11_end_m
integer :: auxinput11_end_s
integer :: auxinput11_end
integer :: io_form_auxinput11
integer :: frames_per_auxinput11
character*256 :: auxinput12_inname
character*256 :: auxinput12_outname
integer :: auxinput12_interval_y
integer :: auxinput12_interval_d
integer :: auxinput12_interval_h
integer :: auxinput12_interval_m
integer :: auxinput12_interval_s
integer :: auxinput12_interval
integer :: auxinput12_begin_y
integer :: auxinput12_begin_d
integer :: auxinput12_begin_h
integer :: auxinput12_begin_m
integer :: auxinput12_begin_s
integer :: auxinput12_begin
integer :: auxinput12_end_y
integer :: auxinput12_end_d
integer :: auxinput12_end_h
integer :: auxinput12_end_m
integer :: auxinput12_end_s
integer :: auxinput12_end
integer :: io_form_auxinput12
integer :: frames_per_auxinput12
character*256 :: auxinput13_inname
character*256 :: auxinput13_outname
integer :: auxinput13_interval_y
integer :: auxinput13_interval_d
integer :: auxinput13_interval_h
integer :: auxinput13_interval_m
integer :: auxinput13_interval_s
integer :: auxinput13_interval
integer :: auxinput13_begin_y
integer :: auxinput13_begin_d
integer :: auxinput13_begin_h
integer :: auxinput13_begin_m
integer :: auxinput13_begin_s
integer :: auxinput13_begin
integer :: auxinput13_end_y
integer :: auxinput13_end_d
integer :: auxinput13_end_h
integer :: auxinput13_end_m
integer :: auxinput13_end_s
integer :: auxinput13_end
integer :: io_form_auxinput13
integer :: frames_per_auxinput13
character*256 :: auxinput14_inname
character*256 :: auxinput14_outname
integer :: auxinput14_interval_y
integer :: auxinput14_interval_d
integer :: auxinput14_interval_h
integer :: auxinput14_interval_m
integer :: auxinput14_interval_s
integer :: auxinput14_interval
integer :: auxinput14_begin_y
integer :: auxinput14_begin_d
integer :: auxinput14_begin_h
integer :: auxinput14_begin_m
integer :: auxinput14_begin_s
integer :: auxinput14_begin
integer :: auxinput14_end_y
integer :: auxinput14_end_d
integer :: auxinput14_end_h
integer :: auxinput14_end_m
integer :: auxinput14_end_s
integer :: auxinput14_end
integer :: io_form_auxinput14
integer :: frames_per_auxinput14
character*256 :: auxinput15_inname
character*256 :: auxinput15_outname
integer :: auxinput15_interval_y
integer :: auxinput15_interval_d
integer :: auxinput15_interval_h
integer :: auxinput15_interval_m
integer :: auxinput15_interval_s
integer :: auxinput15_interval
integer :: auxinput15_begin_y
integer :: auxinput15_begin_d
integer :: auxinput15_begin_h
integer :: auxinput15_begin_m
integer :: auxinput15_begin_s
integer :: auxinput15_begin
integer :: auxinput15_end_y
integer :: auxinput15_end_d
integer :: auxinput15_end_h
integer :: auxinput15_end_m
integer :: auxinput15_end_s
integer :: auxinput15_end
integer :: io_form_auxinput15
integer :: frames_per_auxinput15
character*256 :: auxinput16_inname
character*256 :: auxinput16_outname
integer :: auxinput16_interval_y
integer :: auxinput16_interval_d
integer :: auxinput16_interval_h
integer :: auxinput16_interval_m
integer :: auxinput16_interval_s
integer :: auxinput16_interval
integer :: auxinput16_begin_y
integer :: auxinput16_begin_d
integer :: auxinput16_begin_h
integer :: auxinput16_begin_m
integer :: auxinput16_begin_s
integer :: auxinput16_begin
integer :: auxinput16_end_y
integer :: auxinput16_end_d
integer :: auxinput16_end_h
integer :: auxinput16_end_m
integer :: auxinput16_end_s
integer :: auxinput16_end
integer :: io_form_auxinput16
integer :: frames_per_auxinput16
character*256 :: auxinput17_inname
character*256 :: auxinput17_outname
integer :: auxinput17_interval_y
integer :: auxinput17_interval_d
integer :: auxinput17_interval_h
integer :: auxinput17_interval_m
integer :: auxinput17_interval_s
integer :: auxinput17_interval
integer :: auxinput17_begin_y
integer :: auxinput17_begin_d
integer :: auxinput17_begin_h
integer :: auxinput17_begin_m
integer :: auxinput17_begin_s
integer :: auxinput17_begin
integer :: auxinput17_end_y
integer :: auxinput17_end_d
integer :: auxinput17_end_h
integer :: auxinput17_end_m
integer :: auxinput17_end_s
integer :: auxinput17_end
integer :: io_form_auxinput17
integer :: frames_per_auxinput17
character*256 :: auxinput18_inname
character*256 :: auxinput18_outname
integer :: auxinput18_interval_y
integer :: auxinput18_interval_d
integer :: auxinput18_interval_h
integer :: auxinput18_interval_m
integer :: auxinput18_interval_s
integer :: auxinput18_interval
integer :: auxinput18_begin_y
integer :: auxinput18_begin_d
integer :: auxinput18_begin_h
integer :: auxinput18_begin_m
integer :: auxinput18_begin_s
integer :: auxinput18_begin
integer :: auxinput18_end_y
integer :: auxinput18_end_d
integer :: auxinput18_end_h
integer :: auxinput18_end_m
integer :: auxinput18_end_s
integer :: auxinput18_end
integer :: io_form_auxinput18
integer :: frames_per_auxinput18
character*256 :: auxinput19_inname
character*256 :: auxinput19_outname
integer :: auxinput19_interval_y
integer :: auxinput19_interval_d
integer :: auxinput19_interval_h
integer :: auxinput19_interval_m
integer :: auxinput19_interval_s
integer :: auxinput19_interval
integer :: auxinput19_begin_y
integer :: auxinput19_begin_d
integer :: auxinput19_begin_h
integer :: auxinput19_begin_m
integer :: auxinput19_begin_s
integer :: auxinput19_begin
integer :: auxinput19_end_y
integer :: auxinput19_end_d
integer :: auxinput19_end_h
integer :: auxinput19_end_m
integer :: auxinput19_end_s
integer :: auxinput19_end
integer :: io_form_auxinput19
integer :: frames_per_auxinput19
character*256 :: auxinput20_inname
character*256 :: auxinput20_outname
integer :: auxinput20_interval_y
integer :: auxinput20_interval_d
integer :: auxinput20_interval_h
integer :: auxinput20_interval_m
integer :: auxinput20_interval_s
integer :: auxinput20_interval
integer :: auxinput20_begin_y
integer :: auxinput20_begin_d
integer :: auxinput20_begin_h
integer :: auxinput20_begin_m
integer :: auxinput20_begin_s
integer :: auxinput20_begin
integer :: auxinput20_end_y
integer :: auxinput20_end_d
integer :: auxinput20_end_h
integer :: auxinput20_end_m
integer :: auxinput20_end_s
integer :: auxinput20_end
integer :: io_form_auxinput20
integer :: frames_per_auxinput20
character*256 :: auxinput21_inname
character*256 :: auxinput21_outname
integer :: auxinput21_interval_y
integer :: auxinput21_interval_d
integer :: auxinput21_interval_h
integer :: auxinput21_interval_m
integer :: auxinput21_interval_s
integer :: auxinput21_interval
integer :: auxinput21_begin_y
integer :: auxinput21_begin_d
integer :: auxinput21_begin_h
integer :: auxinput21_begin_m
integer :: auxinput21_begin_s
integer :: auxinput21_begin
integer :: auxinput21_end_y
integer :: auxinput21_end_d
integer :: auxinput21_end_h
integer :: auxinput21_end_m
integer :: auxinput21_end_s
integer :: auxinput21_end
integer :: io_form_auxinput21
integer :: frames_per_auxinput21
character*256 :: auxinput22_inname
character*256 :: auxinput22_outname
integer :: auxinput22_interval_y
integer :: auxinput22_interval_d
integer :: auxinput22_interval_h
integer :: auxinput22_interval_m
integer :: auxinput22_interval_s
integer :: auxinput22_interval
integer :: auxinput22_begin_y
integer :: auxinput22_begin_d
integer :: auxinput22_begin_h
integer :: auxinput22_begin_m
integer :: auxinput22_begin_s
integer :: auxinput22_begin
integer :: auxinput22_end_y
integer :: auxinput22_end_d
integer :: auxinput22_end_h
integer :: auxinput22_end_m
integer :: auxinput22_end_s
integer :: auxinput22_end
integer :: io_form_auxinput22
integer :: frames_per_auxinput22
character*256 :: auxinput23_inname
character*256 :: auxinput23_outname
integer :: auxinput23_interval_y
integer :: auxinput23_interval_d
integer :: auxinput23_interval_h
integer :: auxinput23_interval_m
integer :: auxinput23_interval_s
integer :: auxinput23_interval
integer :: auxinput23_begin_y
integer :: auxinput23_begin_d
integer :: auxinput23_begin_h
integer :: auxinput23_begin_m
integer :: auxinput23_begin_s
integer :: auxinput23_begin
integer :: auxinput23_end_y
integer :: auxinput23_end_d
integer :: auxinput23_end_h
integer :: auxinput23_end_m
integer :: auxinput23_end_s
integer :: auxinput23_end
integer :: io_form_auxinput23
integer :: frames_per_auxinput23
character*256 :: auxinput24_inname
character*256 :: auxinput24_outname
integer :: auxinput24_interval_y
integer :: auxinput24_interval_d
integer :: auxinput24_interval_h
integer :: auxinput24_interval_m
integer :: auxinput24_interval_s
integer :: auxinput24_interval
integer :: auxinput24_begin_y
integer :: auxinput24_begin_d
integer :: auxinput24_begin_h
integer :: auxinput24_begin_m
integer :: auxinput24_begin_s
integer :: auxinput24_begin
integer :: auxinput24_end_y
integer :: auxinput24_end_d
integer :: auxinput24_end_h
integer :: auxinput24_end_m
integer :: auxinput24_end_s
integer :: auxinput24_end
integer :: io_form_auxinput24
integer :: frames_per_auxinput24
integer :: history_interval
integer :: frames_per_outfile
logical :: restart
integer :: restart_interval
integer :: io_form_input
integer :: io_form_history
integer :: io_form_restart
integer :: io_form_boundary
integer :: debug_level
logical :: self_test_domain
character*256 :: history_outname
character*256 :: history_inname
logical :: use_netcdf_classic
integer :: history_interval_d
integer :: history_interval_h
integer :: history_interval_m
integer :: history_interval_s
integer :: inputout_interval_d
integer :: inputout_interval_h
integer :: inputout_interval_m
integer :: inputout_interval_s
integer :: inputout_interval
integer :: restart_interval_d
integer :: restart_interval_h
integer :: restart_interval_m
integer :: restart_interval_s
integer :: history_begin_y
integer :: history_begin_d
integer :: history_begin_h
integer :: history_begin_m
integer :: history_begin_s
integer :: history_begin
integer :: inputout_begin_y
integer :: inputout_begin_d
integer :: inputout_begin_h
integer :: inputout_begin_m
integer :: inputout_begin_s
integer :: restart_begin_y
integer :: restart_begin_d
integer :: restart_begin_h
integer :: restart_begin_m
integer :: restart_begin_s
integer :: restart_begin
integer :: history_end_y
integer :: history_end_d
integer :: history_end_h
integer :: history_end_m
integer :: history_end_s
integer :: history_end
integer :: inputout_end_y
integer :: inputout_end_d
integer :: inputout_end_h
integer :: inputout_end_m
integer :: inputout_end_s
integer :: simulation_start_year
integer :: simulation_start_month
integer :: simulation_start_day
integer :: simulation_start_hour
integer :: simulation_start_minute
integer :: simulation_start_second
logical :: reset_simulation_start
integer :: sr_x
integer :: sr_y
character*256 :: sgfdda_inname
character*256 :: gfdda_inname
integer :: sgfdda_interval_d
integer :: sgfdda_interval_h
integer :: sgfdda_interval_m
integer :: sgfdda_interval_s
integer :: sgfdda_interval_y
integer :: sgfdda_interval
integer :: gfdda_interval_d
integer :: gfdda_interval_h
integer :: gfdda_interval_m
integer :: gfdda_interval_s
integer :: gfdda_interval_y
integer :: gfdda_interval
integer :: sgfdda_begin_y
integer :: sgfdda_begin_d
integer :: sgfdda_begin_h
integer :: sgfdda_begin_m
integer :: sgfdda_begin_s
integer :: gfdda_begin_y
integer :: gfdda_begin_d
integer :: gfdda_begin_h
integer :: gfdda_begin_m
integer :: gfdda_begin_s
integer :: sgfdda_end_y
integer :: sgfdda_end_d
integer :: sgfdda_end_h
integer :: sgfdda_end_m
integer :: sgfdda_end_s
integer :: gfdda_end_y
integer :: gfdda_end_d
integer :: gfdda_end_h
integer :: gfdda_end_m
integer :: gfdda_end_s
integer :: io_form_sgfdda
integer :: io_form_gfdda
character*256 :: iofields_filename
logical :: ignore_iofields_warning
logical :: ncd_nofill
integer :: ifire
integer :: fire_boundary_guard
integer :: fire_num_ignitions
real :: fire_ignition_ros1
real :: fire_ignition_start_lon1
real :: fire_ignition_start_lat1
real :: fire_ignition_end_lon1
real :: fire_ignition_end_lat1
real :: fire_ignition_radius1
real :: fire_ignition_start_time1
real :: fire_ignition_end_time1
real :: fire_ignition_ros2
real :: fire_ignition_start_lon2
real :: fire_ignition_start_lat2
real :: fire_ignition_end_lon2
real :: fire_ignition_end_lat2
real :: fire_ignition_radius2
real :: fire_ignition_start_time2
real :: fire_ignition_end_time2
real :: fire_ignition_ros3
real :: fire_ignition_start_lon3
real :: fire_ignition_start_lat3
real :: fire_ignition_end_lon3
real :: fire_ignition_end_lat3
real :: fire_ignition_radius3
real :: fire_ignition_start_time3
real :: fire_ignition_end_time3
real :: fire_ignition_ros4
real :: fire_ignition_start_lon4
real :: fire_ignition_start_lat4
real :: fire_ignition_end_lon4
real :: fire_ignition_end_lat4
real :: fire_ignition_radius4
real :: fire_ignition_start_time4
real :: fire_ignition_end_time4
real :: fire_ignition_ros5
real :: fire_ignition_start_lon5
real :: fire_ignition_start_lat5
real :: fire_ignition_end_lon5
real :: fire_ignition_end_lat5
real :: fire_ignition_radius5
real :: fire_ignition_start_time5
real :: fire_ignition_end_time5
real :: fire_ignition_start_x1
real :: fire_ignition_start_y1
real :: fire_ignition_end_x1
real :: fire_ignition_end_y1
real :: fire_ignition_start_x2
real :: fire_ignition_start_y2
real :: fire_ignition_end_x2
real :: fire_ignition_end_y2
real :: fire_ignition_start_x3
real :: fire_ignition_start_y3
real :: fire_ignition_end_x3
real :: fire_ignition_end_y3
real :: fire_ignition_start_x4
real :: fire_ignition_start_y4
real :: fire_ignition_end_x4
real :: fire_ignition_end_y4
real :: fire_ignition_start_x5
real :: fire_ignition_start_y5
real :: fire_ignition_end_x5
real :: fire_ignition_end_y5
real :: fire_lat_init
real :: fire_lon_init
real :: fire_ign_time
integer :: fire_shape
integer :: fire_sprd_mdl
real :: fire_crwn_hgt
real :: fire_ext_grnd
real :: fire_ext_crwn
real :: fire_wind_height
integer :: fire_fuel_read
integer :: fire_fuel_cat
integer :: fire_print_msg
integer :: fire_print_file
integer :: fire_fuel_left_method
integer :: fire_fuel_left_irl
integer :: fire_fuel_left_jrl
integer :: fire_grows_only
integer :: fire_upwinding
integer :: fire_upwind_split
real :: fire_viscosity
real :: fire_lfn_ext_up
integer :: fire_topo_from_atm
integer :: fire_advection
integer :: fire_test_steps
real :: fire_const_time
real :: fire_const_grnhfx
real :: fire_const_grnqfx
real :: fire_atm_feedback
integer :: fire_mountain_type
real :: fire_mountain_height
real :: fire_mountain_start_x
real :: fire_mountain_start_y
real :: fire_mountain_end_x
real :: fire_mountain_end_y
real :: delt_perturbation
real :: xrad_perturbation
real :: yrad_perturbation
real :: zrad_perturbation
real :: hght_perturbation
logical :: stretch_grd
logical :: stretch_hyp
real :: z_grd_scale
logical :: sfc_full_init
integer :: sfc_lu_index
real :: sfc_tsk
real :: sfc_tmn
logical :: fire_read_lu
logical :: fire_read_tsk
logical :: fire_read_tmn
logical :: fire_read_atm_ht
logical :: fire_read_fire_ht
logical :: fire_read_atm_grad
logical :: fire_read_fire_grad
real :: sfc_vegfra
real :: sfc_canwat
integer :: sfc_ivgtyp
integer :: sfc_isltyp
logical :: fire_lsm_reinit
integer :: fire_lsm_reinit_iter
integer :: fire_upwinding_reinit
logical :: fire_is_real_perim
integer :: fire_lsm_band_ngp
logical :: fire_lsm_zcoupling
real :: fire_lsm_zcoupling_ref
real :: fire_tracer_smoke
real :: fire_viscosity_bg
real :: fire_viscosity_band
integer :: fire_viscosity_ngp
real :: fire_slope_factor
integer :: do_avgflx_em
integer :: do_avgflx_cugd
integer :: nens
integer :: skebs
integer :: stoch_force_opt
integer :: skebs_vertstruc
integer :: stoch_vertstruc_opt
real :: tot_backscat_psi
real :: tot_backscat_t
real :: ztau_psi
real :: ztau_t
real :: rexponent_psi
real :: rexponent_t
real :: zsigma2_eps
real :: zsigma2_eta
integer :: kminforc
integer :: lminforc
integer :: kminforct
integer :: lminforct
integer :: kmaxforc
integer :: lmaxforc
integer :: kmaxforct
integer :: lmaxforct
integer :: iseed_skebs
integer :: kmaxforch
integer :: lmaxforch
integer :: kmaxforcth
integer :: lmaxforcth
integer :: sppt
real :: gridpt_stddev_sppt
real :: stddev_cutoff_sppt
real :: lengthscale_sppt
real :: timescale_sppt
integer :: sppt_vertstruc
integer :: iseed_sppt
integer :: rand_perturb
real :: gridpt_stddev_rand_pert
real :: stddev_cutoff_rand_pert
real :: lengthscale_rand_pert
real :: timescale_rand_pert
integer :: rand_pert_vertstruc
integer :: iseed_rand_pert
integer :: spp
logical :: hrrr_cycling
integer :: spp_conv
real :: gridpt_stddev_spp_conv
real :: stddev_cutoff_spp_conv
real :: lengthscale_spp_conv
real :: timescale_spp_conv
integer :: vertstruc_spp_conv
integer :: iseed_spp_conv
integer :: spp_pbl
real :: gridpt_stddev_spp_pbl
real :: stddev_cutoff_spp_pbl
real :: lengthscale_spp_pbl
real :: timescale_spp_pbl
integer :: vertstruc_spp_pbl
integer :: iseed_spp_pbl
integer :: spp_lsm
real :: gridpt_stddev_spp_lsm
real :: stddev_cutoff_spp_lsm
real :: lengthscale_spp_lsm
real :: timescale_spp_lsm
integer :: vertstruc_spp_lsm
integer :: iseed_spp_lsm
integer :: skebs_on
integer :: sppt_on
integer :: spp_on
integer :: rand_perturb_on
integer :: num_stoch_levels
integer :: seed_dim
integer :: sfs_opt
integer :: m_opt
real :: lakedepth_default
real :: lake_min_elev
integer :: use_lakedepth
integer :: p_lev_diags
integer :: p_lev_diags_dfi
integer :: num_press_levels
real :: press_levels
integer :: use_tot_or_hyd_p
integer :: extrap_below_grnd
real :: p_lev_missing
real :: p_lev_interval
integer :: z_lev_diags
integer :: z_lev_diags_dfi
integer :: num_z_levels
real :: z_levels
real :: z_lev_missing
real :: z_lev_interval
integer :: afwa_diag_opt
integer :: afwa_ptype_opt
integer :: afwa_vil_opt
integer :: afwa_radar_opt
integer :: afwa_severe_opt
integer :: afwa_icing_opt
integer :: afwa_vis_opt
integer :: afwa_cloud_opt
integer :: afwa_therm_opt
integer :: afwa_turb_opt
integer :: afwa_buoy_opt
real :: afwa_ptype_ccn_tmp
real :: afwa_ptype_tot_melt
integer :: afwa_bad_data_check
integer :: mean_diag
integer :: mean_freq
integer :: mean_interval
integer :: mean_diag_interval
integer :: mean_diag_interval_s
integer :: mean_diag_interval_m
integer :: mean_diag_interval_h
integer :: mean_diag_interval_d
integer :: mean_diag_interval_mo
integer :: diurnal_diag
integer :: nssl_ipelec
integer :: nssl_isaund
integer :: nssl_iscreen
real :: nssl_lightrad
integer :: nssl_idischarge
integer :: nssl_ibrkd
real :: nssl_ecrit
real :: nssl_disfrac
integer :: elec_physics
integer :: perturb_bdy
integer :: perturb_chem_bdy
integer :: hybrid_opt
real :: etac
integer :: num_wif_levels
integer :: wif_input_opt
integer :: diag_nwp2
integer :: chem_opt
integer    :: last_item_in_struct

   END TYPE grid_config_rec_type

   TYPE(model_config_rec_type) :: model_config_rec







CONTAINS




   SUBROUTINE initial_config







































      IMPLICIT NONE

      INTEGER              :: io_status
      INTEGER              :: i

      LOGICAL              :: nml_read_error

      CHARACTER (LEN=1024) :: nml_name

      INTEGER, PARAMETER :: nml_write_unit= 9
      INTEGER, PARAMETER :: nml_read_unit = 10

      CHARACTER (LEN=1024) :: entire_line









integer    :: first_item_in_struct
integer :: run_days
integer :: run_hours
integer :: run_minutes
integer :: run_seconds
integer , DIMENSION(max_domains) :: start_year
integer , DIMENSION(max_domains) :: start_month
integer , DIMENSION(max_domains) :: start_day
integer , DIMENSION(max_domains) :: start_hour
integer , DIMENSION(max_domains) :: start_minute
integer , DIMENSION(max_domains) :: start_second
integer , DIMENSION(max_domains) :: end_year
integer , DIMENSION(max_domains) :: end_month
integer , DIMENSION(max_domains) :: end_day
integer , DIMENSION(max_domains) :: end_hour
integer , DIMENSION(max_domains) :: end_minute
integer , DIMENSION(max_domains) :: end_second
integer :: interval_seconds
logical , DIMENSION(max_domains) :: input_from_file
integer , DIMENSION(max_domains) :: fine_input_stream
logical , DIMENSION(max_domains) :: input_from_hires
character*256 :: rsmas_data_path
logical :: all_ic_times
integer , DIMENSION(max_domains) :: julyr
integer , DIMENSION(max_domains) :: julday
real , DIMENSION(max_domains) :: gmt
character*256 :: input_inname
character*256 :: input_outname
character*256 :: bdy_inname
character*256 :: bdy_outname
character*256 :: rst_inname
character*256 :: rst_outname
logical :: write_input
logical :: write_restart_at_0h
logical :: write_hist_at_0h_rst
logical :: adjust_output_times
logical :: adjust_input_times
integer :: diag_print
logical :: nocolons
logical :: cycling
integer :: output_diagnostics
integer :: nwp_diagnostics
logical :: output_ready_flag
logical :: force_use_old_data
logical :: usepio
integer :: pioprocs
integer :: piostart
integer :: piostride
integer :: pioshift
integer :: dfi_opt
integer :: dfi_savehydmeteors
integer :: dfi_nfilter
logical :: dfi_write_filtered_input
logical :: dfi_write_dfi_history
integer :: dfi_cutoff_seconds
integer :: dfi_time_dim
integer :: dfi_fwdstop_year
integer :: dfi_fwdstop_month
integer :: dfi_fwdstop_day
integer :: dfi_fwdstop_hour
integer :: dfi_fwdstop_minute
integer :: dfi_fwdstop_second
integer :: dfi_bckstop_year
integer :: dfi_bckstop_month
integer :: dfi_bckstop_day
integer :: dfi_bckstop_hour
integer :: dfi_bckstop_minute
integer :: dfi_bckstop_second
integer :: time_step
integer :: time_step_fract_num
integer :: time_step_fract_den
integer :: time_step_dfi
integer , DIMENSION(max_domains) :: min_time_step
integer , DIMENSION(max_domains) :: min_time_step_den
integer , DIMENSION(max_domains) :: max_time_step
integer , DIMENSION(max_domains) :: max_time_step_den
real , DIMENSION(max_domains) :: target_cfl
real , DIMENSION(max_domains) :: target_hcfl
integer , DIMENSION(max_domains) :: max_step_increase_pct
integer , DIMENSION(max_domains) :: starting_time_step
integer , DIMENSION(max_domains) :: starting_time_step_den
logical :: step_to_output_time
integer :: adaptation_domain
logical :: use_adaptive_time_step
logical :: use_adaptive_time_step_dfi
integer :: max_dom
integer :: lats_to_mic
integer , DIMENSION(max_domains) :: s_we
integer , DIMENSION(max_domains) :: e_we
integer , DIMENSION(max_domains) :: s_sn
integer , DIMENSION(max_domains) :: e_sn
integer , DIMENSION(max_domains) :: s_vert
integer , DIMENSION(max_domains) :: e_vert
integer :: num_metgrid_levels
integer :: num_metgrid_soil_levels
real :: p_top_requested
logical :: interp_theta
integer :: interp_type
integer :: rebalance
integer , DIMENSION(max_domains) :: vert_refine_method
integer :: vert_refine_fact
integer :: extrap_type
integer :: t_extrap_type
integer :: hypsometric_opt
logical :: lowest_lev_from_sfc
logical :: use_levels_below_ground
logical :: use_tavg_for_tsk
logical :: use_surface
integer :: lagrange_order
integer :: linear_interp
integer :: force_sfc_in_vinterp
real :: zap_close_levels
real :: maxw_horiz_pres_diff
real :: trop_horiz_pres_diff
real :: maxw_above_this_level
integer :: use_maxw_level
integer :: use_trop_level
logical :: sfcp_to_sfcp
logical :: adjust_heights
logical :: smooth_cg_topo
integer :: nest_interp_coord
integer :: interp_method_type
logical :: aggregate_lu
logical :: rh2qv_wrt_liquid
integer :: rh2qv_method
real :: qv_max_p_safe
real :: qv_max_flag
real :: qv_max_value
real :: qv_min_p_safe
real :: qv_min_flag
real :: qv_min_value
integer :: ideal_init_method
real , DIMENSION(max_domains) :: dx
real , DIMENSION(max_domains) :: dy
integer , DIMENSION(max_domains) :: grid_id
logical , DIMENSION(max_domains) :: grid_allowed
integer , DIMENSION(max_domains) :: parent_id
integer , DIMENSION(max_domains) :: i_parent_start
integer , DIMENSION(max_domains) :: j_parent_start
integer , DIMENSION(max_domains) :: parent_grid_ratio
integer , DIMENSION(max_domains) :: parent_time_step_ratio
integer :: feedback
integer :: smooth_option
integer :: blend_width
real , DIMENSION(max_domains) :: ztop
integer , DIMENSION(max_domains) :: moad_grid_ratio
integer , DIMENSION(max_domains) :: moad_time_step_ratio
integer , DIMENSION(max_domains) :: shw
integer :: tile_sz_x
integer :: tile_sz_y
integer :: numtiles
integer :: numtiles_inc
integer :: numtiles_x
integer :: numtiles_y
integer :: tile_strategy
integer :: nproc_x
integer :: nproc_y
integer :: irand
real , DIMENSION(max_domains) :: dt
integer :: fft_used
integer :: cu_used
integer :: shcu_used
integer :: cam_used
integer :: alloc_qndropsource
integer :: num_moves
integer :: ts_buf_size
integer :: max_ts_locs
logical :: tslist_ij
logical :: tslist_unstagger_winds
integer , DIMENSION(max_domains) :: vortex_interval
integer , DIMENSION(max_domains) :: max_vortex_speed
integer , DIMENSION(max_domains) :: corral_dist
integer :: track_level
real , DIMENSION(max_domains) :: time_to_move
integer , DIMENSION(max_moves) :: move_id
integer , DIMENSION(max_moves) :: move_interval
integer , DIMENSION(max_moves) :: move_cd_x
integer , DIMENSION(max_moves) :: move_cd_y
logical , DIMENSION(max_domains) :: swap_x
logical , DIMENSION(max_domains) :: swap_y
logical , DIMENSION(max_domains) :: cycle_x
logical , DIMENSION(max_domains) :: cycle_y
logical :: reorder_mesh
logical :: perturb_input
real , DIMENSION(max_eta) :: eta_levels
integer :: auto_levels_opt
real :: max_dz
real :: dzbot
real :: dzstretch_s
real :: dzstretch_u
integer :: ocean_levels
real , DIMENSION(max_ocean) :: ocean_z
real , DIMENSION(max_ocean) :: ocean_t
real , DIMENSION(max_ocean) :: ocean_s
integer :: num_traj
integer :: max_ts_level
integer :: track_loc_in
integer :: num_ext_model_couple_dom
logical :: insert_bogus_storm
logical :: remove_storm
integer :: num_storm
real , DIMENSION(max_bogus) :: latc_loc
real , DIMENSION(max_bogus) :: lonc_loc
real , DIMENSION(max_bogus) :: vmax_meters_per_second
real , DIMENSION(max_bogus) :: rmax
real , DIMENSION(max_bogus) :: vmax_ratio
real :: rankine_lid
character*256 :: physics_suite
logical :: force_read_thompson
logical :: write_thompson_tables
integer , DIMENSION(max_domains) :: mp_physics
real , DIMENSION(max_domains) :: nssl_cccn
real , DIMENSION(max_domains) :: nssl_alphah
real , DIMENSION(max_domains) :: nssl_alphahl
real , DIMENSION(max_domains) :: nssl_cnoh
real , DIMENSION(max_domains) :: nssl_cnohl
real , DIMENSION(max_domains) :: nssl_cnor
real , DIMENSION(max_domains) :: nssl_cnos
real , DIMENSION(max_domains) :: nssl_rho_qh
real , DIMENSION(max_domains) :: nssl_rho_qhl
real , DIMENSION(max_domains) :: nssl_rho_qs
integer , DIMENSION(max_domains) :: nudge_lightning
integer , DIMENSION(max_domains) :: nudge_light_times
integer , DIMENSION(max_domains) :: nudge_light_timee
integer , DIMENSION(max_domains) :: nudge_light_int
character*256 :: path_to_files
integer :: gsfcgce_hail
integer :: gsfcgce_2ice
integer , DIMENSION(max_domains) :: progn
real :: accum_mode
real :: aitken_mode
real :: coarse_mode
integer :: do_radar_ref
integer :: compute_radar_ref
integer , DIMENSION(max_domains) :: ra_lw_physics
integer , DIMENSION(max_domains) :: ra_sw_physics
real , DIMENSION(max_domains) :: radt
real , DIMENSION(max_domains) :: naer
integer , DIMENSION(max_domains) :: sf_sfclay_physics
integer , DIMENSION(max_domains) :: sf_surface_physics
integer , DIMENSION(max_domains) :: bl_pbl_physics
integer , DIMENSION(max_domains) :: bl_mynn_tkebudget
integer :: ysu_topdown_pblmix
integer , DIMENSION(max_domains) :: shinhong_tke_diag
logical , DIMENSION(max_domains) :: bl_mynn_tkeadvect
integer :: bl_mynn_cloudpdf
integer :: bl_mynn_mixlength
integer , DIMENSION(max_domains) :: bl_mynn_edmf
integer , DIMENSION(max_domains) :: bl_mynn_edmf_mom
integer , DIMENSION(max_domains) :: bl_mynn_edmf_tke
integer , DIMENSION(max_domains) :: bl_mynn_mixscalars
integer , DIMENSION(max_domains) :: bl_mynn_cloudmix
integer , DIMENSION(max_domains) :: bl_mynn_mixqt
integer :: icloud_bl
integer , DIMENSION(max_domains) :: mfshconv
integer , DIMENSION(max_domains) :: sf_urban_physics
real , DIMENSION(max_domains) :: bldt
integer , DIMENSION(max_domains) :: cu_physics
integer , DIMENSION(max_domains) :: shcu_physics
integer , DIMENSION(max_domains) :: cu_diag
integer , DIMENSION(max_domains) :: kf_edrates
integer :: kfeta_trigger
integer :: nsas_dx_factor
real , DIMENSION(max_domains) :: cudt
real , DIMENSION(max_domains) :: gsmdt
integer :: isfflx
integer :: ifsnow
integer :: icloud
integer :: cldovrlp
integer :: ideal_xland
real :: swrad_scat
integer :: surface_input_source
integer :: num_soil_layers
integer :: maxpatch
integer :: num_snow_layers
integer :: num_snso_layers
integer :: num_urban_ndm
integer :: num_urban_ng
integer :: num_urban_nwr
integer :: num_urban_ngb
integer :: num_urban_nf
integer :: num_urban_nz
integer :: num_urban_nbui
integer :: urban_map_zrd
integer :: urban_map_zwd
integer :: urban_map_gd
integer :: urban_map_zd
integer :: urban_map_zdf
integer :: urban_map_bd
integer :: urban_map_wd
integer :: urban_map_gbd
integer :: urban_map_fbd
integer :: num_urban_hi
integer :: num_months
integer :: sf_surface_mosaic
integer :: mosaic_cat
integer :: mosaic_cat_soil
integer :: mosaic_lu
integer :: mosaic_soil
integer :: flag_sm_adj
integer :: maxiens
integer :: maxens
integer :: maxens2
integer :: maxens3
integer :: ensdim
integer :: cugd_avedx
integer :: clos_choice
integer :: imomentum
integer :: ishallow
real :: convtrans_avglen_m
integer :: num_land_cat
integer :: num_soil_cat
integer :: mp_zero_out
real :: mp_zero_out_thresh
real :: seaice_threshold
integer :: sst_update
integer :: sst_skin
integer :: tmn_update
logical :: usemonalb
logical :: rdmaxalb
logical :: rdlai2d
logical :: ua_phys
integer :: opt_thcnd
integer :: co2tf
integer :: ra_call_offset
real :: cam_abs_freq_s
integer :: levsiz
integer :: paerlev
integer :: cam_abs_dim1
integer :: cam_abs_dim2
integer :: lagday
integer :: no_src_types
integer :: alevsiz
integer :: o3input
integer :: aer_opt
integer :: swint_opt
integer , DIMENSION(max_domains) :: aer_type
integer , DIMENSION(max_domains) :: aer_aod550_opt
integer , DIMENSION(max_domains) :: aer_angexp_opt
integer , DIMENSION(max_domains) :: aer_ssa_opt
integer , DIMENSION(max_domains) :: aer_asy_opt
real , DIMENSION(max_domains) :: aer_aod550_val
real , DIMENSION(max_domains) :: aer_angexp_val
real , DIMENSION(max_domains) :: aer_ssa_val
real , DIMENSION(max_domains) :: aer_asy_val
logical , DIMENSION(max_domains) :: cu_rad_feedback
integer :: dust_emis
integer :: erosion_dim
integer :: no_src_types_cu
integer :: alevsiz_cu
integer :: aercu_opt
real :: aercu_fct
integer :: aercu_used
logical , DIMENSION(max_domains) :: shallowcu_forced_ra
integer , DIMENSION(max_domains) :: numbins
real , DIMENSION(max_domains) :: thbinsize
real , DIMENSION(max_domains) :: rbinsize
real , DIMENSION(max_domains) :: mindeepfreq
real , DIMENSION(max_domains) :: minshallowfreq
integer , DIMENSION(max_domains) :: shcu_aerosols_opt
integer , DIMENSION(max_domains) :: icloud_cu
integer , DIMENSION(max_domains) :: pxlsm_smois_init
integer , DIMENSION(max_domains) :: pxlsm_modis_veg
integer :: omlcall
integer :: sf_ocean_physics
integer :: traj_opt
logical , DIMENSION(max_domains) :: dm_has_traj
integer :: tracercall
real :: omdt
real :: oml_hml0
real :: oml_gamma
real :: oml_relaxation_time
integer :: isftcflx
integer :: iz0tlnd
real :: shadlen
integer , DIMENSION(max_domains) :: slope_rad
integer , DIMENSION(max_domains) :: topo_shading
integer , DIMENSION(max_domains) :: topo_wind
integer :: no_mp_heating
integer :: fractional_seaice
integer :: seaice_snowdepth_opt
real :: seaice_snowdepth_max
real :: seaice_snowdepth_min
integer :: seaice_albedo_opt
real :: seaice_albedo_default
integer :: seaice_thickness_opt
real :: seaice_thickness_default
logical :: tice2tsk_if2cold
real :: bucket_mm
real :: bucket_j
real :: mp_tend_lim
real , DIMENSION(max_domains) :: prec_acc_dt
integer :: prec_acc_opt
integer :: bucketr_opt
integer :: bucketf_opt
integer :: process_time_series
integer , DIMENSION(max_domains) :: grav_settling
real , DIMENSION(max_domains) :: sas_pgcon
integer , DIMENSION(max_domains) :: scalar_pblmix
integer , DIMENSION(max_domains) :: tracer_pblmix
logical :: use_aero_icbc
logical :: use_rap_aero_icbc
integer :: use_mp_re
real :: ccn_conc
integer :: hail_opt
integer :: morr_rimed_ice
integer :: clean_atm_diag
integer :: calc_clean_atm_diag
integer :: dveg
integer :: opt_crs
integer :: opt_btr
integer :: opt_run
integer :: opt_sfc
integer :: opt_frz
integer :: opt_inf
integer :: opt_rad
integer :: opt_alb
integer :: opt_snf
integer :: opt_tbot
integer :: opt_stc
integer :: opt_gla
integer :: opt_rsf
integer :: opt_soil
integer :: opt_pedo
integer :: opt_crop
real , DIMENSION(max_domains) :: wtddt
integer :: wrf_hydro
real , DIMENSION(max_domains) :: fgdt
integer , DIMENSION(max_domains) :: fgdtzero
integer , DIMENSION(max_domains) :: grid_fdda
integer , DIMENSION(max_domains) :: grid_sfdda
integer , DIMENSION(max_domains) :: if_no_pbl_nudging_uv
integer , DIMENSION(max_domains) :: if_no_pbl_nudging_t
integer , DIMENSION(max_domains) :: if_no_pbl_nudging_ph
integer , DIMENSION(max_domains) :: if_no_pbl_nudging_q
integer , DIMENSION(max_domains) :: if_zfac_uv
integer , DIMENSION(max_domains) :: k_zfac_uv
integer , DIMENSION(max_domains) :: if_zfac_t
integer , DIMENSION(max_domains) :: k_zfac_t
integer , DIMENSION(max_domains) :: if_zfac_ph
integer , DIMENSION(max_domains) :: k_zfac_ph
integer , DIMENSION(max_domains) :: if_zfac_q
integer , DIMENSION(max_domains) :: k_zfac_q
integer , DIMENSION(max_domains) :: dk_zfac_uv
integer , DIMENSION(max_domains) :: dk_zfac_t
integer , DIMENSION(max_domains) :: dk_zfac_ph
integer , DIMENSION(max_domains) :: dk_zfac_q
integer :: ktrop
real , DIMENSION(max_domains) :: guv
real , DIMENSION(max_domains) :: guv_sfc
real , DIMENSION(max_domains) :: gt
real , DIMENSION(max_domains) :: gt_sfc
real , DIMENSION(max_domains) :: gq
real , DIMENSION(max_domains) :: gq_sfc
real , DIMENSION(max_domains) :: gph
real :: dtramp_min
integer :: if_ramping
real , DIMENSION(max_domains) :: rinblw
integer , DIMENSION(max_domains) :: xwavenum
integer , DIMENSION(max_domains) :: ywavenum
integer , DIMENSION(max_domains) :: pxlsm_soil_nudge
integer , DIMENSION(max_domains) :: fasdas
integer , DIMENSION(max_domains) :: obs_nudge_opt
integer :: max_obs
real , DIMENSION(max_domains) :: fdda_start
real , DIMENSION(max_domains) :: fdda_end
integer , DIMENSION(max_domains) :: obs_nudge_wind
real , DIMENSION(max_domains) :: obs_coef_wind
integer , DIMENSION(max_domains) :: obs_nudge_temp
real , DIMENSION(max_domains) :: obs_coef_temp
integer , DIMENSION(max_domains) :: obs_nudge_mois
real , DIMENSION(max_domains) :: obs_coef_mois
integer , DIMENSION(max_domains) :: obs_nudge_pstr
real , DIMENSION(max_domains) :: obs_coef_pstr
integer , DIMENSION(max_domains) :: obs_no_pbl_nudge_uv
integer , DIMENSION(max_domains) :: obs_no_pbl_nudge_t
integer , DIMENSION(max_domains) :: obs_no_pbl_nudge_q
integer :: obs_sfc_scheme_horiz
integer :: obs_sfc_scheme_vert
real :: obs_max_sndng_gap
real :: obs_nudgezfullr1_uv
real :: obs_nudgezrampr1_uv
real :: obs_nudgezfullr2_uv
real :: obs_nudgezrampr2_uv
real :: obs_nudgezfullr4_uv
real :: obs_nudgezrampr4_uv
real :: obs_nudgezfullr1_t
real :: obs_nudgezrampr1_t
real :: obs_nudgezfullr2_t
real :: obs_nudgezrampr2_t
real :: obs_nudgezfullr4_t
real :: obs_nudgezrampr4_t
real :: obs_nudgezfullr1_q
real :: obs_nudgezrampr1_q
real :: obs_nudgezfullr2_q
real :: obs_nudgezrampr2_q
real :: obs_nudgezfullr4_q
real :: obs_nudgezrampr4_q
real :: obs_nudgezfullmin
real :: obs_nudgezrampmin
real :: obs_nudgezmax
real :: obs_sfcfact
real :: obs_sfcfacr
real :: obs_dpsmx
real , DIMENSION(max_domains) :: obs_rinxy
real :: obs_rinsig
real , DIMENSION(max_domains) :: obs_twindo
integer :: obs_npfi
integer , DIMENSION(max_domains) :: obs_ionf
integer :: obs_idynin
real :: obs_dtramp
integer :: obs_prt_max
integer , DIMENSION(max_domains) :: obs_prt_freq
logical :: obs_ipf_in4dob
logical :: obs_ipf_errob
logical :: obs_ipf_nudob
logical :: obs_ipf_init
integer :: obs_scl_neg_qv_innov
integer :: scm_force
real :: scm_force_dx
integer :: num_force_layers
integer :: scm_lu_index
integer :: scm_isltyp
real :: scm_vegfra
real :: scm_canwat
real :: scm_lat
real :: scm_lon
logical :: scm_th_t_tend
logical :: scm_qv_t_tend
logical :: scm_th_adv
logical :: scm_wind_adv
logical :: scm_qv_adv
logical :: scm_ql_adv
logical :: scm_vert_adv
integer :: num_force_soil_layers
logical :: scm_soilt_force
logical :: scm_soilq_force
logical :: scm_force_th_largescale
logical :: scm_force_qv_largescale
logical :: scm_force_ql_largescale
logical :: scm_force_wind_largescale
integer :: scm_force_skintemp
integer :: scm_force_flux
integer :: dyn_opt
integer :: rk_ord
integer :: w_damping
integer , DIMENSION(max_domains) :: diff_opt
integer , DIMENSION(max_domains) :: diff_opt_dfi
integer , DIMENSION(max_domains) :: km_opt
integer , DIMENSION(max_domains) :: km_opt_dfi
integer :: damp_opt
integer :: rad_nudge
integer :: gwd_opt
real :: max_rot_angle_gwd
real , DIMENSION(max_domains) :: zdamp
real , DIMENSION(max_domains) :: dampcoef
real , DIMENSION(max_domains) :: khdif
real , DIMENSION(max_domains) :: kvdif
real , DIMENSION(max_domains) :: diff_6th_factor
integer , DIMENSION(max_domains) :: diff_6th_opt
integer , DIMENSION(max_domains) :: diff_6th_slopeopt
real , DIMENSION(max_domains) :: diff_6th_thresh
integer :: use_theta_m
integer :: use_q_diabatic
real , DIMENSION(max_domains) :: c_s
real , DIMENSION(max_domains) :: c_k
real , DIMENSION(max_domains) :: smdiv
real , DIMENSION(max_domains) :: emdiv
real , DIMENSION(max_domains) :: epssm
logical , DIMENSION(max_domains) :: non_hydrostatic
logical :: use_input_w
integer , DIMENSION(max_domains) :: time_step_sound
integer , DIMENSION(max_domains) :: h_mom_adv_order
integer , DIMENSION(max_domains) :: v_mom_adv_order
integer , DIMENSION(max_domains) :: h_sca_adv_order
integer , DIMENSION(max_domains) :: v_sca_adv_order
integer , DIMENSION(max_domains) :: momentum_adv_opt
integer , DIMENSION(max_domains) :: moist_adv_opt
integer , DIMENSION(max_domains) :: moist_adv_dfi_opt
integer , DIMENSION(max_domains) :: chem_adv_opt
integer , DIMENSION(max_domains) :: tracer_adv_opt
integer , DIMENSION(max_domains) :: scalar_adv_opt
integer , DIMENSION(max_domains) :: tke_adv_opt
logical , DIMENSION(max_domains) :: moist_mix2_off
logical , DIMENSION(max_domains) :: chem_mix2_off
logical , DIMENSION(max_domains) :: tracer_mix2_off
logical , DIMENSION(max_domains) :: scalar_mix2_off
logical , DIMENSION(max_domains) :: tke_mix2_off
logical , DIMENSION(max_domains) :: moist_mix6_off
logical , DIMENSION(max_domains) :: chem_mix6_off
logical , DIMENSION(max_domains) :: tracer_mix6_off
logical , DIMENSION(max_domains) :: scalar_mix6_off
logical , DIMENSION(max_domains) :: tke_mix6_off
logical , DIMENSION(max_domains) :: top_radiation
integer , DIMENSION(max_domains) :: mix_isotropic
real , DIMENSION(max_domains) :: mix_upper_bound
logical , DIMENSION(max_domains) :: top_lid
real , DIMENSION(max_domains) :: tke_upper_bound
real , DIMENSION(max_domains) :: tke_drag_coefficient
real , DIMENSION(max_domains) :: tke_heat_flux
logical , DIMENSION(max_domains) :: pert_coriolis
logical , DIMENSION(max_domains) :: coriolis2d
logical , DIMENSION(max_domains) :: mix_full_fields
real :: base_pres
real :: base_temp
real :: base_lapse
real :: iso_temp
real :: base_pres_strat
real :: base_lapse_strat
logical :: use_baseparam_fr_nml
real :: fft_filter_lat
logical :: coupled_filtering
logical :: pos_def
logical :: swap_pole_with_next_j
logical :: actual_distance_average
logical :: rotated_pole
logical , DIMENSION(max_domains) :: do_coriolis
logical , DIMENSION(max_domains) :: do_curvature
logical , DIMENSION(max_domains) :: do_gradp
integer , DIMENSION(max_domains) :: tracer_opt
integer , DIMENSION(max_domains) :: tenddiag
integer :: spec_bdy_width
integer :: spec_zone
integer :: relax_zone
logical , DIMENSION(max_domains) :: specified
logical :: constant_bc
logical , DIMENSION(max_domains) :: periodic_x
logical , DIMENSION(max_domains) :: symmetric_xs
logical , DIMENSION(max_domains) :: symmetric_xe
logical , DIMENSION(max_domains) :: open_xs
logical , DIMENSION(max_domains) :: open_xe
logical , DIMENSION(max_domains) :: periodic_y
logical , DIMENSION(max_domains) :: symmetric_ys
logical , DIMENSION(max_domains) :: symmetric_ye
logical , DIMENSION(max_domains) :: open_ys
logical , DIMENSION(max_domains) :: open_ye
logical , DIMENSION(max_domains) :: polar
logical , DIMENSION(max_domains) :: nested
real :: spec_exp
integer :: spec_bdy_final_mu
integer :: real_data_init_type
logical , DIMENSION(max_domains) :: have_bcs_moist
logical , DIMENSION(max_domains) :: have_bcs_scalar
integer :: background_proc_id
integer :: forecast_proc_id
integer :: production_status
integer :: compression
integer :: nobs_ndg_vars
integer :: nobs_err_flds
real , DIMENSION(max_domains) :: cen_lat
real , DIMENSION(max_domains) :: cen_lon
real , DIMENSION(max_domains) :: truelat1
real , DIMENSION(max_domains) :: truelat2
real , DIMENSION(max_domains) :: moad_cen_lat
real , DIMENSION(max_domains) :: stand_lon
real , DIMENSION(max_domains) :: pole_lat
real , DIMENSION(max_domains) :: pole_lon
integer :: flag_metgrid
integer :: flag_snow
integer :: flag_psfc
integer :: flag_sm000010
integer :: flag_sm010040
integer :: flag_sm040100
integer :: flag_sm100200
integer :: flag_st000010
integer :: flag_st010040
integer :: flag_st040100
integer :: flag_st100200
integer :: flag_soil_layers
integer :: flag_slp
integer :: flag_soilhgt
integer :: flag_mf_xy
integer :: flag_um_soil
real , DIMENSION(max_domains) :: bdyfrq
character*256 , DIMENSION(max_domains) :: mminlu
integer , DIMENSION(max_domains) :: iswater
integer , DIMENSION(max_domains) :: islake
integer , DIMENSION(max_domains) :: isice
integer , DIMENSION(max_domains) :: isurban
integer , DIMENSION(max_domains) :: isoilwater
integer , DIMENSION(max_domains) :: map_proj
integer :: use_wps_input
integer , DIMENSION(max_domains) :: dfi_stage
integer , DIMENSION(max_domains) :: mp_physics_dfi
integer , DIMENSION(max_domains) :: bl_pbl_physics_dfi
integer , DIMENSION(max_domains) :: windfarm_opt
integer :: windfarm_ij
integer :: ideal_case
integer , DIMENSION(max_domains) :: hailcast_opt
real , DIMENSION(max_domains) :: haildt
integer , DIMENSION(max_domains) :: lightning_option
real , DIMENSION(max_domains) :: lightning_dt
real , DIMENSION(max_domains) :: lightning_start_seconds
real , DIMENSION(max_domains) :: flashrate_factor
integer , DIMENSION(max_domains) :: iccg_method
real , DIMENSION(max_domains) :: iccg_prescribed_num
real , DIMENSION(max_domains) :: iccg_prescribed_den
integer , DIMENSION(max_domains) :: cellcount_method
real , DIMENSION(max_domains) :: cldtop_adjustment
integer , DIMENSION(max_domains) :: sf_lake_physics
character*256 :: auxinput1_inname
integer :: io_form_auxinput1
logical :: override_restart_timers
character*256 :: auxhist1_inname
character*256 :: auxhist1_outname
integer , DIMENSION(max_domains) :: auxhist1_interval_y
integer , DIMENSION(max_domains) :: auxhist1_interval_d
integer , DIMENSION(max_domains) :: auxhist1_interval_h
integer , DIMENSION(max_domains) :: auxhist1_interval_m
integer , DIMENSION(max_domains) :: auxhist1_interval_s
integer , DIMENSION(max_domains) :: auxhist1_interval
integer , DIMENSION(max_domains) :: auxhist1_begin_y
integer , DIMENSION(max_domains) :: auxhist1_begin_d
integer , DIMENSION(max_domains) :: auxhist1_begin_h
integer , DIMENSION(max_domains) :: auxhist1_begin_m
integer , DIMENSION(max_domains) :: auxhist1_begin_s
integer , DIMENSION(max_domains) :: auxhist1_begin
integer , DIMENSION(max_domains) :: auxhist1_end_y
integer , DIMENSION(max_domains) :: auxhist1_end_d
integer , DIMENSION(max_domains) :: auxhist1_end_h
integer , DIMENSION(max_domains) :: auxhist1_end_m
integer , DIMENSION(max_domains) :: auxhist1_end_s
integer , DIMENSION(max_domains) :: auxhist1_end
integer :: io_form_auxhist1
integer , DIMENSION(max_domains) :: frames_per_auxhist1
character*256 :: auxhist2_inname
character*256 :: auxhist2_outname
integer , DIMENSION(max_domains) :: auxhist2_interval_y
integer , DIMENSION(max_domains) :: auxhist2_interval_d
integer , DIMENSION(max_domains) :: auxhist2_interval_h
integer , DIMENSION(max_domains) :: auxhist2_interval_m
integer , DIMENSION(max_domains) :: auxhist2_interval_s
integer , DIMENSION(max_domains) :: auxhist2_interval
integer , DIMENSION(max_domains) :: auxhist2_begin_y
integer , DIMENSION(max_domains) :: auxhist2_begin_d
integer , DIMENSION(max_domains) :: auxhist2_begin_h
integer , DIMENSION(max_domains) :: auxhist2_begin_m
integer , DIMENSION(max_domains) :: auxhist2_begin_s
integer , DIMENSION(max_domains) :: auxhist2_begin
integer , DIMENSION(max_domains) :: auxhist2_end_y
integer , DIMENSION(max_domains) :: auxhist2_end_d
integer , DIMENSION(max_domains) :: auxhist2_end_h
integer , DIMENSION(max_domains) :: auxhist2_end_m
integer , DIMENSION(max_domains) :: auxhist2_end_s
integer , DIMENSION(max_domains) :: auxhist2_end
integer :: io_form_auxhist2
integer , DIMENSION(max_domains) :: frames_per_auxhist2
character*256 :: auxhist3_inname
character*256 :: auxhist3_outname
integer , DIMENSION(max_domains) :: auxhist3_interval_y
integer , DIMENSION(max_domains) :: auxhist3_interval_d
integer , DIMENSION(max_domains) :: auxhist3_interval_h
integer , DIMENSION(max_domains) :: auxhist3_interval_m
integer , DIMENSION(max_domains) :: auxhist3_interval_s
integer , DIMENSION(max_domains) :: auxhist3_interval
integer , DIMENSION(max_domains) :: auxhist3_begin_y
integer , DIMENSION(max_domains) :: auxhist3_begin_d
integer , DIMENSION(max_domains) :: auxhist3_begin_h
integer , DIMENSION(max_domains) :: auxhist3_begin_m
integer , DIMENSION(max_domains) :: auxhist3_begin_s
integer , DIMENSION(max_domains) :: auxhist3_begin
integer , DIMENSION(max_domains) :: auxhist3_end_y
integer , DIMENSION(max_domains) :: auxhist3_end_d
integer , DIMENSION(max_domains) :: auxhist3_end_h
integer , DIMENSION(max_domains) :: auxhist3_end_m
integer , DIMENSION(max_domains) :: auxhist3_end_s
integer , DIMENSION(max_domains) :: auxhist3_end
integer :: io_form_auxhist3
integer , DIMENSION(max_domains) :: frames_per_auxhist3
character*256 :: auxhist4_inname
character*256 :: auxhist4_outname
integer , DIMENSION(max_domains) :: auxhist4_interval_y
integer , DIMENSION(max_domains) :: auxhist4_interval_d
integer , DIMENSION(max_domains) :: auxhist4_interval_h
integer , DIMENSION(max_domains) :: auxhist4_interval_m
integer , DIMENSION(max_domains) :: auxhist4_interval_s
integer , DIMENSION(max_domains) :: auxhist4_interval
integer , DIMENSION(max_domains) :: auxhist4_begin_y
integer , DIMENSION(max_domains) :: auxhist4_begin_d
integer , DIMENSION(max_domains) :: auxhist4_begin_h
integer , DIMENSION(max_domains) :: auxhist4_begin_m
integer , DIMENSION(max_domains) :: auxhist4_begin_s
integer , DIMENSION(max_domains) :: auxhist4_begin
integer , DIMENSION(max_domains) :: auxhist4_end_y
integer , DIMENSION(max_domains) :: auxhist4_end_d
integer , DIMENSION(max_domains) :: auxhist4_end_h
integer , DIMENSION(max_domains) :: auxhist4_end_m
integer , DIMENSION(max_domains) :: auxhist4_end_s
integer , DIMENSION(max_domains) :: auxhist4_end
integer :: io_form_auxhist4
integer , DIMENSION(max_domains) :: frames_per_auxhist4
character*256 :: auxhist5_inname
character*256 :: auxhist5_outname
integer , DIMENSION(max_domains) :: auxhist5_interval_y
integer , DIMENSION(max_domains) :: auxhist5_interval_d
integer , DIMENSION(max_domains) :: auxhist5_interval_h
integer , DIMENSION(max_domains) :: auxhist5_interval_m
integer , DIMENSION(max_domains) :: auxhist5_interval_s
integer , DIMENSION(max_domains) :: auxhist5_interval
integer , DIMENSION(max_domains) :: auxhist5_begin_y
integer , DIMENSION(max_domains) :: auxhist5_begin_d
integer , DIMENSION(max_domains) :: auxhist5_begin_h
integer , DIMENSION(max_domains) :: auxhist5_begin_m
integer , DIMENSION(max_domains) :: auxhist5_begin_s
integer , DIMENSION(max_domains) :: auxhist5_begin
integer , DIMENSION(max_domains) :: auxhist5_end_y
integer , DIMENSION(max_domains) :: auxhist5_end_d
integer , DIMENSION(max_domains) :: auxhist5_end_h
integer , DIMENSION(max_domains) :: auxhist5_end_m
integer , DIMENSION(max_domains) :: auxhist5_end_s
integer , DIMENSION(max_domains) :: auxhist5_end
integer :: io_form_auxhist5
integer , DIMENSION(max_domains) :: frames_per_auxhist5
character*256 :: auxhist6_inname
character*256 :: auxhist6_outname
integer , DIMENSION(max_domains) :: auxhist6_interval_y
integer , DIMENSION(max_domains) :: auxhist6_interval_d
integer , DIMENSION(max_domains) :: auxhist6_interval_h
integer , DIMENSION(max_domains) :: auxhist6_interval_m
integer , DIMENSION(max_domains) :: auxhist6_interval_s
integer , DIMENSION(max_domains) :: auxhist6_interval
integer , DIMENSION(max_domains) :: auxhist6_begin_y
integer , DIMENSION(max_domains) :: auxhist6_begin_d
integer , DIMENSION(max_domains) :: auxhist6_begin_h
integer , DIMENSION(max_domains) :: auxhist6_begin_m
integer , DIMENSION(max_domains) :: auxhist6_begin_s
integer , DIMENSION(max_domains) :: auxhist6_begin
integer , DIMENSION(max_domains) :: auxhist6_end_y
integer , DIMENSION(max_domains) :: auxhist6_end_d
integer , DIMENSION(max_domains) :: auxhist6_end_h
integer , DIMENSION(max_domains) :: auxhist6_end_m
integer , DIMENSION(max_domains) :: auxhist6_end_s
integer , DIMENSION(max_domains) :: auxhist6_end
integer :: io_form_auxhist6
integer , DIMENSION(max_domains) :: frames_per_auxhist6
character*256 :: auxhist7_inname
character*256 :: auxhist7_outname
integer , DIMENSION(max_domains) :: auxhist7_interval_y
integer , DIMENSION(max_domains) :: auxhist7_interval_d
integer , DIMENSION(max_domains) :: auxhist7_interval_h
integer , DIMENSION(max_domains) :: auxhist7_interval_m
integer , DIMENSION(max_domains) :: auxhist7_interval_s
integer , DIMENSION(max_domains) :: auxhist7_interval
integer , DIMENSION(max_domains) :: auxhist7_begin_y
integer , DIMENSION(max_domains) :: auxhist7_begin_d
integer , DIMENSION(max_domains) :: auxhist7_begin_h
integer , DIMENSION(max_domains) :: auxhist7_begin_m
integer , DIMENSION(max_domains) :: auxhist7_begin_s
integer , DIMENSION(max_domains) :: auxhist7_begin
integer , DIMENSION(max_domains) :: auxhist7_end_y
integer , DIMENSION(max_domains) :: auxhist7_end_d
integer , DIMENSION(max_domains) :: auxhist7_end_h
integer , DIMENSION(max_domains) :: auxhist7_end_m
integer , DIMENSION(max_domains) :: auxhist7_end_s
integer , DIMENSION(max_domains) :: auxhist7_end
integer :: io_form_auxhist7
integer , DIMENSION(max_domains) :: frames_per_auxhist7
character*256 :: auxhist8_inname
character*256 :: auxhist8_outname
integer , DIMENSION(max_domains) :: auxhist8_interval_y
integer , DIMENSION(max_domains) :: auxhist8_interval_d
integer , DIMENSION(max_domains) :: auxhist8_interval_h
integer , DIMENSION(max_domains) :: auxhist8_interval_m
integer , DIMENSION(max_domains) :: auxhist8_interval_s
integer , DIMENSION(max_domains) :: auxhist8_interval
integer , DIMENSION(max_domains) :: auxhist8_begin_y
integer , DIMENSION(max_domains) :: auxhist8_begin_d
integer , DIMENSION(max_domains) :: auxhist8_begin_h
integer , DIMENSION(max_domains) :: auxhist8_begin_m
integer , DIMENSION(max_domains) :: auxhist8_begin_s
integer , DIMENSION(max_domains) :: auxhist8_begin
integer , DIMENSION(max_domains) :: auxhist8_end_y
integer , DIMENSION(max_domains) :: auxhist8_end_d
integer , DIMENSION(max_domains) :: auxhist8_end_h
integer , DIMENSION(max_domains) :: auxhist8_end_m
integer , DIMENSION(max_domains) :: auxhist8_end_s
integer , DIMENSION(max_domains) :: auxhist8_end
integer :: io_form_auxhist8
integer , DIMENSION(max_domains) :: frames_per_auxhist8
character*256 :: auxhist9_inname
character*256 :: auxhist9_outname
integer , DIMENSION(max_domains) :: auxhist9_interval_y
integer , DIMENSION(max_domains) :: auxhist9_interval_d
integer , DIMENSION(max_domains) :: auxhist9_interval_h
integer , DIMENSION(max_domains) :: auxhist9_interval_m
integer , DIMENSION(max_domains) :: auxhist9_interval_s
integer , DIMENSION(max_domains) :: auxhist9_interval
integer , DIMENSION(max_domains) :: auxhist9_begin_y
integer , DIMENSION(max_domains) :: auxhist9_begin_d
integer , DIMENSION(max_domains) :: auxhist9_begin_h
integer , DIMENSION(max_domains) :: auxhist9_begin_m
integer , DIMENSION(max_domains) :: auxhist9_begin_s
integer , DIMENSION(max_domains) :: auxhist9_begin
integer , DIMENSION(max_domains) :: auxhist9_end_y
integer , DIMENSION(max_domains) :: auxhist9_end_d
integer , DIMENSION(max_domains) :: auxhist9_end_h
integer , DIMENSION(max_domains) :: auxhist9_end_m
integer , DIMENSION(max_domains) :: auxhist9_end_s
integer , DIMENSION(max_domains) :: auxhist9_end
integer :: io_form_auxhist9
integer , DIMENSION(max_domains) :: frames_per_auxhist9
character*256 :: auxhist10_inname
character*256 :: auxhist10_outname
integer , DIMENSION(max_domains) :: auxhist10_interval_y
integer , DIMENSION(max_domains) :: auxhist10_interval_d
integer , DIMENSION(max_domains) :: auxhist10_interval_h
integer , DIMENSION(max_domains) :: auxhist10_interval_m
integer , DIMENSION(max_domains) :: auxhist10_interval_s
integer , DIMENSION(max_domains) :: auxhist10_interval
integer , DIMENSION(max_domains) :: auxhist10_begin_y
integer , DIMENSION(max_domains) :: auxhist10_begin_d
integer , DIMENSION(max_domains) :: auxhist10_begin_h
integer , DIMENSION(max_domains) :: auxhist10_begin_m
integer , DIMENSION(max_domains) :: auxhist10_begin_s
integer , DIMENSION(max_domains) :: auxhist10_begin
integer , DIMENSION(max_domains) :: auxhist10_end_y
integer , DIMENSION(max_domains) :: auxhist10_end_d
integer , DIMENSION(max_domains) :: auxhist10_end_h
integer , DIMENSION(max_domains) :: auxhist10_end_m
integer , DIMENSION(max_domains) :: auxhist10_end_s
integer , DIMENSION(max_domains) :: auxhist10_end
integer :: io_form_auxhist10
integer , DIMENSION(max_domains) :: frames_per_auxhist10
character*256 :: auxhist11_inname
character*256 :: auxhist11_outname
integer , DIMENSION(max_domains) :: auxhist11_interval_y
integer , DIMENSION(max_domains) :: auxhist11_interval_d
integer , DIMENSION(max_domains) :: auxhist11_interval_h
integer , DIMENSION(max_domains) :: auxhist11_interval_m
integer , DIMENSION(max_domains) :: auxhist11_interval_s
integer , DIMENSION(max_domains) :: auxhist11_interval
integer , DIMENSION(max_domains) :: auxhist11_begin_y
integer , DIMENSION(max_domains) :: auxhist11_begin_d
integer , DIMENSION(max_domains) :: auxhist11_begin_h
integer , DIMENSION(max_domains) :: auxhist11_begin_m
integer , DIMENSION(max_domains) :: auxhist11_begin_s
integer , DIMENSION(max_domains) :: auxhist11_begin
integer , DIMENSION(max_domains) :: auxhist11_end_y
integer , DIMENSION(max_domains) :: auxhist11_end_d
integer , DIMENSION(max_domains) :: auxhist11_end_h
integer , DIMENSION(max_domains) :: auxhist11_end_m
integer , DIMENSION(max_domains) :: auxhist11_end_s
integer , DIMENSION(max_domains) :: auxhist11_end
integer :: io_form_auxhist11
integer , DIMENSION(max_domains) :: frames_per_auxhist11
character*256 :: auxhist12_inname
character*256 :: auxhist12_outname
integer , DIMENSION(max_domains) :: auxhist12_interval_y
integer , DIMENSION(max_domains) :: auxhist12_interval_d
integer , DIMENSION(max_domains) :: auxhist12_interval_h
integer , DIMENSION(max_domains) :: auxhist12_interval_m
integer , DIMENSION(max_domains) :: auxhist12_interval_s
integer , DIMENSION(max_domains) :: auxhist12_interval
integer , DIMENSION(max_domains) :: auxhist12_begin_y
integer , DIMENSION(max_domains) :: auxhist12_begin_d
integer , DIMENSION(max_domains) :: auxhist12_begin_h
integer , DIMENSION(max_domains) :: auxhist12_begin_m
integer , DIMENSION(max_domains) :: auxhist12_begin_s
integer , DIMENSION(max_domains) :: auxhist12_begin
integer , DIMENSION(max_domains) :: auxhist12_end_y
integer , DIMENSION(max_domains) :: auxhist12_end_d
integer , DIMENSION(max_domains) :: auxhist12_end_h
integer , DIMENSION(max_domains) :: auxhist12_end_m
integer , DIMENSION(max_domains) :: auxhist12_end_s
integer , DIMENSION(max_domains) :: auxhist12_end
integer :: io_form_auxhist12
integer , DIMENSION(max_domains) :: frames_per_auxhist12
character*256 :: auxhist13_inname
character*256 :: auxhist13_outname
integer , DIMENSION(max_domains) :: auxhist13_interval_y
integer , DIMENSION(max_domains) :: auxhist13_interval_d
integer , DIMENSION(max_domains) :: auxhist13_interval_h
integer , DIMENSION(max_domains) :: auxhist13_interval_m
integer , DIMENSION(max_domains) :: auxhist13_interval_s
integer , DIMENSION(max_domains) :: auxhist13_interval
integer , DIMENSION(max_domains) :: auxhist13_begin_y
integer , DIMENSION(max_domains) :: auxhist13_begin_d
integer , DIMENSION(max_domains) :: auxhist13_begin_h
integer , DIMENSION(max_domains) :: auxhist13_begin_m
integer , DIMENSION(max_domains) :: auxhist13_begin_s
integer , DIMENSION(max_domains) :: auxhist13_begin
integer , DIMENSION(max_domains) :: auxhist13_end_y
integer , DIMENSION(max_domains) :: auxhist13_end_d
integer , DIMENSION(max_domains) :: auxhist13_end_h
integer , DIMENSION(max_domains) :: auxhist13_end_m
integer , DIMENSION(max_domains) :: auxhist13_end_s
integer , DIMENSION(max_domains) :: auxhist13_end
integer :: io_form_auxhist13
integer , DIMENSION(max_domains) :: frames_per_auxhist13
character*256 :: auxhist14_inname
character*256 :: auxhist14_outname
integer , DIMENSION(max_domains) :: auxhist14_interval_y
integer , DIMENSION(max_domains) :: auxhist14_interval_d
integer , DIMENSION(max_domains) :: auxhist14_interval_h
integer , DIMENSION(max_domains) :: auxhist14_interval_m
integer , DIMENSION(max_domains) :: auxhist14_interval_s
integer , DIMENSION(max_domains) :: auxhist14_interval
integer , DIMENSION(max_domains) :: auxhist14_begin_y
integer , DIMENSION(max_domains) :: auxhist14_begin_d
integer , DIMENSION(max_domains) :: auxhist14_begin_h
integer , DIMENSION(max_domains) :: auxhist14_begin_m
integer , DIMENSION(max_domains) :: auxhist14_begin_s
integer , DIMENSION(max_domains) :: auxhist14_begin
integer , DIMENSION(max_domains) :: auxhist14_end_y
integer , DIMENSION(max_domains) :: auxhist14_end_d
integer , DIMENSION(max_domains) :: auxhist14_end_h
integer , DIMENSION(max_domains) :: auxhist14_end_m
integer , DIMENSION(max_domains) :: auxhist14_end_s
integer , DIMENSION(max_domains) :: auxhist14_end
integer :: io_form_auxhist14
integer , DIMENSION(max_domains) :: frames_per_auxhist14
character*256 :: auxhist15_inname
character*256 :: auxhist15_outname
integer , DIMENSION(max_domains) :: auxhist15_interval_y
integer , DIMENSION(max_domains) :: auxhist15_interval_d
integer , DIMENSION(max_domains) :: auxhist15_interval_h
integer , DIMENSION(max_domains) :: auxhist15_interval_m
integer , DIMENSION(max_domains) :: auxhist15_interval_s
integer , DIMENSION(max_domains) :: auxhist15_interval
integer , DIMENSION(max_domains) :: auxhist15_begin_y
integer , DIMENSION(max_domains) :: auxhist15_begin_d
integer , DIMENSION(max_domains) :: auxhist15_begin_h
integer , DIMENSION(max_domains) :: auxhist15_begin_m
integer , DIMENSION(max_domains) :: auxhist15_begin_s
integer , DIMENSION(max_domains) :: auxhist15_begin
integer , DIMENSION(max_domains) :: auxhist15_end_y
integer , DIMENSION(max_domains) :: auxhist15_end_d
integer , DIMENSION(max_domains) :: auxhist15_end_h
integer , DIMENSION(max_domains) :: auxhist15_end_m
integer , DIMENSION(max_domains) :: auxhist15_end_s
integer , DIMENSION(max_domains) :: auxhist15_end
integer :: io_form_auxhist15
integer , DIMENSION(max_domains) :: frames_per_auxhist15
character*256 :: auxhist16_inname
character*256 :: auxhist16_outname
integer , DIMENSION(max_domains) :: auxhist16_interval_y
integer , DIMENSION(max_domains) :: auxhist16_interval_d
integer , DIMENSION(max_domains) :: auxhist16_interval_h
integer , DIMENSION(max_domains) :: auxhist16_interval_m
integer , DIMENSION(max_domains) :: auxhist16_interval_s
integer , DIMENSION(max_domains) :: auxhist16_interval
integer , DIMENSION(max_domains) :: auxhist16_begin_y
integer , DIMENSION(max_domains) :: auxhist16_begin_d
integer , DIMENSION(max_domains) :: auxhist16_begin_h
integer , DIMENSION(max_domains) :: auxhist16_begin_m
integer , DIMENSION(max_domains) :: auxhist16_begin_s
integer , DIMENSION(max_domains) :: auxhist16_begin
integer , DIMENSION(max_domains) :: auxhist16_end_y
integer , DIMENSION(max_domains) :: auxhist16_end_d
integer , DIMENSION(max_domains) :: auxhist16_end_h
integer , DIMENSION(max_domains) :: auxhist16_end_m
integer , DIMENSION(max_domains) :: auxhist16_end_s
integer , DIMENSION(max_domains) :: auxhist16_end
integer :: io_form_auxhist16
integer , DIMENSION(max_domains) :: frames_per_auxhist16
character*256 :: auxhist17_inname
character*256 :: auxhist17_outname
integer , DIMENSION(max_domains) :: auxhist17_interval_y
integer , DIMENSION(max_domains) :: auxhist17_interval_d
integer , DIMENSION(max_domains) :: auxhist17_interval_h
integer , DIMENSION(max_domains) :: auxhist17_interval_m
integer , DIMENSION(max_domains) :: auxhist17_interval_s
integer , DIMENSION(max_domains) :: auxhist17_interval
integer , DIMENSION(max_domains) :: auxhist17_begin_y
integer , DIMENSION(max_domains) :: auxhist17_begin_d
integer , DIMENSION(max_domains) :: auxhist17_begin_h
integer , DIMENSION(max_domains) :: auxhist17_begin_m
integer , DIMENSION(max_domains) :: auxhist17_begin_s
integer , DIMENSION(max_domains) :: auxhist17_begin
integer , DIMENSION(max_domains) :: auxhist17_end_y
integer , DIMENSION(max_domains) :: auxhist17_end_d
integer , DIMENSION(max_domains) :: auxhist17_end_h
integer , DIMENSION(max_domains) :: auxhist17_end_m
integer , DIMENSION(max_domains) :: auxhist17_end_s
integer , DIMENSION(max_domains) :: auxhist17_end
integer :: io_form_auxhist17
integer , DIMENSION(max_domains) :: frames_per_auxhist17
character*256 :: auxhist18_inname
character*256 :: auxhist18_outname
integer , DIMENSION(max_domains) :: auxhist18_interval_y
integer , DIMENSION(max_domains) :: auxhist18_interval_d
integer , DIMENSION(max_domains) :: auxhist18_interval_h
integer , DIMENSION(max_domains) :: auxhist18_interval_m
integer , DIMENSION(max_domains) :: auxhist18_interval_s
integer , DIMENSION(max_domains) :: auxhist18_interval
integer , DIMENSION(max_domains) :: auxhist18_begin_y
integer , DIMENSION(max_domains) :: auxhist18_begin_d
integer , DIMENSION(max_domains) :: auxhist18_begin_h
integer , DIMENSION(max_domains) :: auxhist18_begin_m
integer , DIMENSION(max_domains) :: auxhist18_begin_s
integer , DIMENSION(max_domains) :: auxhist18_begin
integer , DIMENSION(max_domains) :: auxhist18_end_y
integer , DIMENSION(max_domains) :: auxhist18_end_d
integer , DIMENSION(max_domains) :: auxhist18_end_h
integer , DIMENSION(max_domains) :: auxhist18_end_m
integer , DIMENSION(max_domains) :: auxhist18_end_s
integer , DIMENSION(max_domains) :: auxhist18_end
integer :: io_form_auxhist18
integer , DIMENSION(max_domains) :: frames_per_auxhist18
character*256 :: auxhist19_inname
character*256 :: auxhist19_outname
integer , DIMENSION(max_domains) :: auxhist19_interval_y
integer , DIMENSION(max_domains) :: auxhist19_interval_d
integer , DIMENSION(max_domains) :: auxhist19_interval_h
integer , DIMENSION(max_domains) :: auxhist19_interval_m
integer , DIMENSION(max_domains) :: auxhist19_interval_s
integer , DIMENSION(max_domains) :: auxhist19_interval
integer , DIMENSION(max_domains) :: auxhist19_begin_y
integer , DIMENSION(max_domains) :: auxhist19_begin_d
integer , DIMENSION(max_domains) :: auxhist19_begin_h
integer , DIMENSION(max_domains) :: auxhist19_begin_m
integer , DIMENSION(max_domains) :: auxhist19_begin_s
integer , DIMENSION(max_domains) :: auxhist19_begin
integer , DIMENSION(max_domains) :: auxhist19_end_y
integer , DIMENSION(max_domains) :: auxhist19_end_d
integer , DIMENSION(max_domains) :: auxhist19_end_h
integer , DIMENSION(max_domains) :: auxhist19_end_m
integer , DIMENSION(max_domains) :: auxhist19_end_s
integer , DIMENSION(max_domains) :: auxhist19_end
integer :: io_form_auxhist19
integer , DIMENSION(max_domains) :: frames_per_auxhist19
character*256 :: auxhist20_inname
character*256 :: auxhist20_outname
integer , DIMENSION(max_domains) :: auxhist20_interval_y
integer , DIMENSION(max_domains) :: auxhist20_interval_d
integer , DIMENSION(max_domains) :: auxhist20_interval_h
integer , DIMENSION(max_domains) :: auxhist20_interval_m
integer , DIMENSION(max_domains) :: auxhist20_interval_s
integer , DIMENSION(max_domains) :: auxhist20_interval
integer , DIMENSION(max_domains) :: auxhist20_begin_y
integer , DIMENSION(max_domains) :: auxhist20_begin_d
integer , DIMENSION(max_domains) :: auxhist20_begin_h
integer , DIMENSION(max_domains) :: auxhist20_begin_m
integer , DIMENSION(max_domains) :: auxhist20_begin_s
integer , DIMENSION(max_domains) :: auxhist20_begin
integer , DIMENSION(max_domains) :: auxhist20_end_y
integer , DIMENSION(max_domains) :: auxhist20_end_d
integer , DIMENSION(max_domains) :: auxhist20_end_h
integer , DIMENSION(max_domains) :: auxhist20_end_m
integer , DIMENSION(max_domains) :: auxhist20_end_s
integer , DIMENSION(max_domains) :: auxhist20_end
integer :: io_form_auxhist20
integer , DIMENSION(max_domains) :: frames_per_auxhist20
character*256 :: auxhist21_inname
character*256 :: auxhist21_outname
integer , DIMENSION(max_domains) :: auxhist21_interval_y
integer , DIMENSION(max_domains) :: auxhist21_interval_d
integer , DIMENSION(max_domains) :: auxhist21_interval_h
integer , DIMENSION(max_domains) :: auxhist21_interval_m
integer , DIMENSION(max_domains) :: auxhist21_interval_s
integer , DIMENSION(max_domains) :: auxhist21_interval
integer , DIMENSION(max_domains) :: auxhist21_begin_y
integer , DIMENSION(max_domains) :: auxhist21_begin_d
integer , DIMENSION(max_domains) :: auxhist21_begin_h
integer , DIMENSION(max_domains) :: auxhist21_begin_m
integer , DIMENSION(max_domains) :: auxhist21_begin_s
integer , DIMENSION(max_domains) :: auxhist21_begin
integer , DIMENSION(max_domains) :: auxhist21_end_y
integer , DIMENSION(max_domains) :: auxhist21_end_d
integer , DIMENSION(max_domains) :: auxhist21_end_h
integer , DIMENSION(max_domains) :: auxhist21_end_m
integer , DIMENSION(max_domains) :: auxhist21_end_s
integer , DIMENSION(max_domains) :: auxhist21_end
integer :: io_form_auxhist21
integer , DIMENSION(max_domains) :: frames_per_auxhist21
character*256 :: auxhist22_inname
character*256 :: auxhist22_outname
integer , DIMENSION(max_domains) :: auxhist22_interval_y
integer , DIMENSION(max_domains) :: auxhist22_interval_d
integer , DIMENSION(max_domains) :: auxhist22_interval_h
integer , DIMENSION(max_domains) :: auxhist22_interval_m
integer , DIMENSION(max_domains) :: auxhist22_interval_s
integer , DIMENSION(max_domains) :: auxhist22_interval
integer , DIMENSION(max_domains) :: auxhist22_begin_y
integer , DIMENSION(max_domains) :: auxhist22_begin_d
integer , DIMENSION(max_domains) :: auxhist22_begin_h
integer , DIMENSION(max_domains) :: auxhist22_begin_m
integer , DIMENSION(max_domains) :: auxhist22_begin_s
integer , DIMENSION(max_domains) :: auxhist22_begin
integer , DIMENSION(max_domains) :: auxhist22_end_y
integer , DIMENSION(max_domains) :: auxhist22_end_d
integer , DIMENSION(max_domains) :: auxhist22_end_h
integer , DIMENSION(max_domains) :: auxhist22_end_m
integer , DIMENSION(max_domains) :: auxhist22_end_s
integer , DIMENSION(max_domains) :: auxhist22_end
integer :: io_form_auxhist22
integer , DIMENSION(max_domains) :: frames_per_auxhist22
character*256 :: auxhist23_inname
character*256 :: auxhist23_outname
integer , DIMENSION(max_domains) :: auxhist23_interval_y
integer , DIMENSION(max_domains) :: auxhist23_interval_d
integer , DIMENSION(max_domains) :: auxhist23_interval_h
integer , DIMENSION(max_domains) :: auxhist23_interval_m
integer , DIMENSION(max_domains) :: auxhist23_interval_s
integer , DIMENSION(max_domains) :: auxhist23_interval
integer , DIMENSION(max_domains) :: auxhist23_begin_y
integer , DIMENSION(max_domains) :: auxhist23_begin_d
integer , DIMENSION(max_domains) :: auxhist23_begin_h
integer , DIMENSION(max_domains) :: auxhist23_begin_m
integer , DIMENSION(max_domains) :: auxhist23_begin_s
integer , DIMENSION(max_domains) :: auxhist23_begin
integer , DIMENSION(max_domains) :: auxhist23_end_y
integer , DIMENSION(max_domains) :: auxhist23_end_d
integer , DIMENSION(max_domains) :: auxhist23_end_h
integer , DIMENSION(max_domains) :: auxhist23_end_m
integer , DIMENSION(max_domains) :: auxhist23_end_s
integer , DIMENSION(max_domains) :: auxhist23_end
integer :: io_form_auxhist23
integer , DIMENSION(max_domains) :: frames_per_auxhist23
character*256 :: auxhist24_inname
character*256 :: auxhist24_outname
integer , DIMENSION(max_domains) :: auxhist24_interval_y
integer , DIMENSION(max_domains) :: auxhist24_interval_d
integer , DIMENSION(max_domains) :: auxhist24_interval_h
integer , DIMENSION(max_domains) :: auxhist24_interval_m
integer , DIMENSION(max_domains) :: auxhist24_interval_s
integer , DIMENSION(max_domains) :: auxhist24_interval
integer , DIMENSION(max_domains) :: auxhist24_begin_y
integer , DIMENSION(max_domains) :: auxhist24_begin_d
integer , DIMENSION(max_domains) :: auxhist24_begin_h
integer , DIMENSION(max_domains) :: auxhist24_begin_m
integer , DIMENSION(max_domains) :: auxhist24_begin_s
integer , DIMENSION(max_domains) :: auxhist24_begin
integer , DIMENSION(max_domains) :: auxhist24_end_y
integer , DIMENSION(max_domains) :: auxhist24_end_d
integer , DIMENSION(max_domains) :: auxhist24_end_h
integer , DIMENSION(max_domains) :: auxhist24_end_m
integer , DIMENSION(max_domains) :: auxhist24_end_s
integer , DIMENSION(max_domains) :: auxhist24_end
integer :: io_form_auxhist24
integer , DIMENSION(max_domains) :: frames_per_auxhist24
character*256 :: auxinput1_outname
integer , DIMENSION(max_domains) :: auxinput1_interval_y
integer , DIMENSION(max_domains) :: auxinput1_interval_d
integer , DIMENSION(max_domains) :: auxinput1_interval_h
integer , DIMENSION(max_domains) :: auxinput1_interval_m
integer , DIMENSION(max_domains) :: auxinput1_interval_s
integer , DIMENSION(max_domains) :: auxinput1_interval
integer , DIMENSION(max_domains) :: auxinput1_begin_y
integer , DIMENSION(max_domains) :: auxinput1_begin_d
integer , DIMENSION(max_domains) :: auxinput1_begin_h
integer , DIMENSION(max_domains) :: auxinput1_begin_m
integer , DIMENSION(max_domains) :: auxinput1_begin_s
integer , DIMENSION(max_domains) :: auxinput1_begin
integer , DIMENSION(max_domains) :: auxinput1_end_y
integer , DIMENSION(max_domains) :: auxinput1_end_d
integer , DIMENSION(max_domains) :: auxinput1_end_h
integer , DIMENSION(max_domains) :: auxinput1_end_m
integer , DIMENSION(max_domains) :: auxinput1_end_s
integer , DIMENSION(max_domains) :: auxinput1_end
integer , DIMENSION(max_domains) :: frames_per_auxinput1
character*256 :: auxinput2_inname
character*256 :: auxinput2_outname
integer , DIMENSION(max_domains) :: auxinput2_interval_y
integer , DIMENSION(max_domains) :: auxinput2_interval_d
integer , DIMENSION(max_domains) :: auxinput2_interval_h
integer , DIMENSION(max_domains) :: auxinput2_interval_m
integer , DIMENSION(max_domains) :: auxinput2_interval_s
integer , DIMENSION(max_domains) :: auxinput2_interval
integer , DIMENSION(max_domains) :: auxinput2_begin_y
integer , DIMENSION(max_domains) :: auxinput2_begin_d
integer , DIMENSION(max_domains) :: auxinput2_begin_h
integer , DIMENSION(max_domains) :: auxinput2_begin_m
integer , DIMENSION(max_domains) :: auxinput2_begin_s
integer , DIMENSION(max_domains) :: auxinput2_begin
integer , DIMENSION(max_domains) :: auxinput2_end_y
integer , DIMENSION(max_domains) :: auxinput2_end_d
integer , DIMENSION(max_domains) :: auxinput2_end_h
integer , DIMENSION(max_domains) :: auxinput2_end_m
integer , DIMENSION(max_domains) :: auxinput2_end_s
integer , DIMENSION(max_domains) :: auxinput2_end
integer :: io_form_auxinput2
integer , DIMENSION(max_domains) :: frames_per_auxinput2
character*256 :: auxinput3_inname
character*256 :: auxinput3_outname
integer , DIMENSION(max_domains) :: auxinput3_interval_y
integer , DIMENSION(max_domains) :: auxinput3_interval_d
integer , DIMENSION(max_domains) :: auxinput3_interval_h
integer , DIMENSION(max_domains) :: auxinput3_interval_m
integer , DIMENSION(max_domains) :: auxinput3_interval_s
integer , DIMENSION(max_domains) :: auxinput3_interval
integer , DIMENSION(max_domains) :: auxinput3_begin_y
integer , DIMENSION(max_domains) :: auxinput3_begin_d
integer , DIMENSION(max_domains) :: auxinput3_begin_h
integer , DIMENSION(max_domains) :: auxinput3_begin_m
integer , DIMENSION(max_domains) :: auxinput3_begin_s
integer , DIMENSION(max_domains) :: auxinput3_begin
integer , DIMENSION(max_domains) :: auxinput3_end_y
integer , DIMENSION(max_domains) :: auxinput3_end_d
integer , DIMENSION(max_domains) :: auxinput3_end_h
integer , DIMENSION(max_domains) :: auxinput3_end_m
integer , DIMENSION(max_domains) :: auxinput3_end_s
integer , DIMENSION(max_domains) :: auxinput3_end
integer :: io_form_auxinput3
integer , DIMENSION(max_domains) :: frames_per_auxinput3
character*256 :: auxinput4_inname
character*256 :: auxinput4_outname
integer , DIMENSION(max_domains) :: auxinput4_interval_y
integer , DIMENSION(max_domains) :: auxinput4_interval_d
integer , DIMENSION(max_domains) :: auxinput4_interval_h
integer , DIMENSION(max_domains) :: auxinput4_interval_m
integer , DIMENSION(max_domains) :: auxinput4_interval_s
integer , DIMENSION(max_domains) :: auxinput4_interval
integer , DIMENSION(max_domains) :: auxinput4_begin_y
integer , DIMENSION(max_domains) :: auxinput4_begin_d
integer , DIMENSION(max_domains) :: auxinput4_begin_h
integer , DIMENSION(max_domains) :: auxinput4_begin_m
integer , DIMENSION(max_domains) :: auxinput4_begin_s
integer , DIMENSION(max_domains) :: auxinput4_begin
integer , DIMENSION(max_domains) :: auxinput4_end_y
integer , DIMENSION(max_domains) :: auxinput4_end_d
integer , DIMENSION(max_domains) :: auxinput4_end_h
integer , DIMENSION(max_domains) :: auxinput4_end_m
integer , DIMENSION(max_domains) :: auxinput4_end_s
integer , DIMENSION(max_domains) :: auxinput4_end
integer :: io_form_auxinput4
integer , DIMENSION(max_domains) :: frames_per_auxinput4
character*256 :: auxinput5_inname
character*256 :: auxinput5_outname
integer , DIMENSION(max_domains) :: auxinput5_interval_y
integer , DIMENSION(max_domains) :: auxinput5_interval_d
integer , DIMENSION(max_domains) :: auxinput5_interval_h
integer , DIMENSION(max_domains) :: auxinput5_interval_m
integer , DIMENSION(max_domains) :: auxinput5_interval_s
integer , DIMENSION(max_domains) :: auxinput5_interval
integer , DIMENSION(max_domains) :: auxinput5_begin_y
integer , DIMENSION(max_domains) :: auxinput5_begin_d
integer , DIMENSION(max_domains) :: auxinput5_begin_h
integer , DIMENSION(max_domains) :: auxinput5_begin_m
integer , DIMENSION(max_domains) :: auxinput5_begin_s
integer , DIMENSION(max_domains) :: auxinput5_begin
integer , DIMENSION(max_domains) :: auxinput5_end_y
integer , DIMENSION(max_domains) :: auxinput5_end_d
integer , DIMENSION(max_domains) :: auxinput5_end_h
integer , DIMENSION(max_domains) :: auxinput5_end_m
integer , DIMENSION(max_domains) :: auxinput5_end_s
integer , DIMENSION(max_domains) :: auxinput5_end
integer :: io_form_auxinput5
integer , DIMENSION(max_domains) :: frames_per_auxinput5
character*256 :: auxinput6_inname
character*256 :: auxinput6_outname
integer , DIMENSION(max_domains) :: auxinput6_interval_y
integer , DIMENSION(max_domains) :: auxinput6_interval_d
integer , DIMENSION(max_domains) :: auxinput6_interval_h
integer , DIMENSION(max_domains) :: auxinput6_interval_m
integer , DIMENSION(max_domains) :: auxinput6_interval_s
integer , DIMENSION(max_domains) :: auxinput6_interval
integer , DIMENSION(max_domains) :: auxinput6_begin_y
integer , DIMENSION(max_domains) :: auxinput6_begin_d
integer , DIMENSION(max_domains) :: auxinput6_begin_h
integer , DIMENSION(max_domains) :: auxinput6_begin_m
integer , DIMENSION(max_domains) :: auxinput6_begin_s
integer , DIMENSION(max_domains) :: auxinput6_begin
integer , DIMENSION(max_domains) :: auxinput6_end_y
integer , DIMENSION(max_domains) :: auxinput6_end_d
integer , DIMENSION(max_domains) :: auxinput6_end_h
integer , DIMENSION(max_domains) :: auxinput6_end_m
integer , DIMENSION(max_domains) :: auxinput6_end_s
integer , DIMENSION(max_domains) :: auxinput6_end
integer :: io_form_auxinput6
integer , DIMENSION(max_domains) :: frames_per_auxinput6
character*256 :: auxinput7_inname
character*256 :: auxinput7_outname
integer , DIMENSION(max_domains) :: auxinput7_interval_y
integer , DIMENSION(max_domains) :: auxinput7_interval_d
integer , DIMENSION(max_domains) :: auxinput7_interval_h
integer , DIMENSION(max_domains) :: auxinput7_interval_m
integer , DIMENSION(max_domains) :: auxinput7_interval_s
integer , DIMENSION(max_domains) :: auxinput7_interval
integer , DIMENSION(max_domains) :: auxinput7_begin_y
integer , DIMENSION(max_domains) :: auxinput7_begin_d
integer , DIMENSION(max_domains) :: auxinput7_begin_h
integer , DIMENSION(max_domains) :: auxinput7_begin_m
integer , DIMENSION(max_domains) :: auxinput7_begin_s
integer , DIMENSION(max_domains) :: auxinput7_begin
integer , DIMENSION(max_domains) :: auxinput7_end_y
integer , DIMENSION(max_domains) :: auxinput7_end_d
integer , DIMENSION(max_domains) :: auxinput7_end_h
integer , DIMENSION(max_domains) :: auxinput7_end_m
integer , DIMENSION(max_domains) :: auxinput7_end_s
integer , DIMENSION(max_domains) :: auxinput7_end
integer :: io_form_auxinput7
integer , DIMENSION(max_domains) :: frames_per_auxinput7
character*256 :: auxinput8_inname
character*256 :: auxinput8_outname
integer , DIMENSION(max_domains) :: auxinput8_interval_y
integer , DIMENSION(max_domains) :: auxinput8_interval_d
integer , DIMENSION(max_domains) :: auxinput8_interval_h
integer , DIMENSION(max_domains) :: auxinput8_interval_m
integer , DIMENSION(max_domains) :: auxinput8_interval_s
integer , DIMENSION(max_domains) :: auxinput8_interval
integer , DIMENSION(max_domains) :: auxinput8_begin_y
integer , DIMENSION(max_domains) :: auxinput8_begin_d
integer , DIMENSION(max_domains) :: auxinput8_begin_h
integer , DIMENSION(max_domains) :: auxinput8_begin_m
integer , DIMENSION(max_domains) :: auxinput8_begin_s
integer , DIMENSION(max_domains) :: auxinput8_begin
integer , DIMENSION(max_domains) :: auxinput8_end_y
integer , DIMENSION(max_domains) :: auxinput8_end_d
integer , DIMENSION(max_domains) :: auxinput8_end_h
integer , DIMENSION(max_domains) :: auxinput8_end_m
integer , DIMENSION(max_domains) :: auxinput8_end_s
integer , DIMENSION(max_domains) :: auxinput8_end
integer :: io_form_auxinput8
integer , DIMENSION(max_domains) :: frames_per_auxinput8
character*256 :: auxinput9_inname
character*256 :: auxinput9_outname
integer , DIMENSION(max_domains) :: auxinput9_interval_y
integer , DIMENSION(max_domains) :: auxinput9_interval_d
integer , DIMENSION(max_domains) :: auxinput9_interval_h
integer , DIMENSION(max_domains) :: auxinput9_interval_m
integer , DIMENSION(max_domains) :: auxinput9_interval_s
integer , DIMENSION(max_domains) :: auxinput9_interval
integer , DIMENSION(max_domains) :: auxinput9_begin_y
integer , DIMENSION(max_domains) :: auxinput9_begin_d
integer , DIMENSION(max_domains) :: auxinput9_begin_h
integer , DIMENSION(max_domains) :: auxinput9_begin_m
integer , DIMENSION(max_domains) :: auxinput9_begin_s
integer , DIMENSION(max_domains) :: auxinput9_begin
integer , DIMENSION(max_domains) :: auxinput9_end_y
integer , DIMENSION(max_domains) :: auxinput9_end_d
integer , DIMENSION(max_domains) :: auxinput9_end_h
integer , DIMENSION(max_domains) :: auxinput9_end_m
integer , DIMENSION(max_domains) :: auxinput9_end_s
integer , DIMENSION(max_domains) :: auxinput9_end
integer :: io_form_auxinput9
integer , DIMENSION(max_domains) :: frames_per_auxinput9
character*256 :: auxinput10_inname
character*256 :: auxinput10_outname
integer , DIMENSION(max_domains) :: auxinput10_interval_y
integer , DIMENSION(max_domains) :: auxinput10_interval_d
integer , DIMENSION(max_domains) :: auxinput10_interval_h
integer , DIMENSION(max_domains) :: auxinput10_interval_m
integer , DIMENSION(max_domains) :: auxinput10_interval_s
integer , DIMENSION(max_domains) :: auxinput10_interval
integer , DIMENSION(max_domains) :: auxinput10_begin_y
integer , DIMENSION(max_domains) :: auxinput10_begin_d
integer , DIMENSION(max_domains) :: auxinput10_begin_h
integer , DIMENSION(max_domains) :: auxinput10_begin_m
integer , DIMENSION(max_domains) :: auxinput10_begin_s
integer , DIMENSION(max_domains) :: auxinput10_begin
integer , DIMENSION(max_domains) :: auxinput10_end_y
integer , DIMENSION(max_domains) :: auxinput10_end_d
integer , DIMENSION(max_domains) :: auxinput10_end_h
integer , DIMENSION(max_domains) :: auxinput10_end_m
integer , DIMENSION(max_domains) :: auxinput10_end_s
integer , DIMENSION(max_domains) :: auxinput10_end
integer :: io_form_auxinput10
integer , DIMENSION(max_domains) :: frames_per_auxinput10
character*256 :: auxinput11_inname
character*256 :: auxinput11_outname
integer , DIMENSION(max_domains) :: auxinput11_interval_y
integer , DIMENSION(max_domains) :: auxinput11_interval_d
integer , DIMENSION(max_domains) :: auxinput11_interval_h
integer , DIMENSION(max_domains) :: auxinput11_interval_m
integer , DIMENSION(max_domains) :: auxinput11_interval_s
integer , DIMENSION(max_domains) :: auxinput11_interval
integer , DIMENSION(max_domains) :: auxinput11_begin_y
integer , DIMENSION(max_domains) :: auxinput11_begin_d
integer , DIMENSION(max_domains) :: auxinput11_begin_h
integer , DIMENSION(max_domains) :: auxinput11_begin_m
integer , DIMENSION(max_domains) :: auxinput11_begin_s
integer , DIMENSION(max_domains) :: auxinput11_begin
integer , DIMENSION(max_domains) :: auxinput11_end_y
integer , DIMENSION(max_domains) :: auxinput11_end_d
integer , DIMENSION(max_domains) :: auxinput11_end_h
integer , DIMENSION(max_domains) :: auxinput11_end_m
integer , DIMENSION(max_domains) :: auxinput11_end_s
integer , DIMENSION(max_domains) :: auxinput11_end
integer :: io_form_auxinput11
integer , DIMENSION(max_domains) :: frames_per_auxinput11
character*256 :: auxinput12_inname
character*256 :: auxinput12_outname
integer , DIMENSION(max_domains) :: auxinput12_interval_y
integer , DIMENSION(max_domains) :: auxinput12_interval_d
integer , DIMENSION(max_domains) :: auxinput12_interval_h
integer , DIMENSION(max_domains) :: auxinput12_interval_m
integer , DIMENSION(max_domains) :: auxinput12_interval_s
integer , DIMENSION(max_domains) :: auxinput12_interval
integer , DIMENSION(max_domains) :: auxinput12_begin_y
integer , DIMENSION(max_domains) :: auxinput12_begin_d
integer , DIMENSION(max_domains) :: auxinput12_begin_h
integer , DIMENSION(max_domains) :: auxinput12_begin_m
integer , DIMENSION(max_domains) :: auxinput12_begin_s
integer , DIMENSION(max_domains) :: auxinput12_begin
integer , DIMENSION(max_domains) :: auxinput12_end_y
integer , DIMENSION(max_domains) :: auxinput12_end_d
integer , DIMENSION(max_domains) :: auxinput12_end_h
integer , DIMENSION(max_domains) :: auxinput12_end_m
integer , DIMENSION(max_domains) :: auxinput12_end_s
integer , DIMENSION(max_domains) :: auxinput12_end
integer :: io_form_auxinput12
integer , DIMENSION(max_domains) :: frames_per_auxinput12
character*256 :: auxinput13_inname
character*256 :: auxinput13_outname
integer , DIMENSION(max_domains) :: auxinput13_interval_y
integer , DIMENSION(max_domains) :: auxinput13_interval_d
integer , DIMENSION(max_domains) :: auxinput13_interval_h
integer , DIMENSION(max_domains) :: auxinput13_interval_m
integer , DIMENSION(max_domains) :: auxinput13_interval_s
integer , DIMENSION(max_domains) :: auxinput13_interval
integer , DIMENSION(max_domains) :: auxinput13_begin_y
integer , DIMENSION(max_domains) :: auxinput13_begin_d
integer , DIMENSION(max_domains) :: auxinput13_begin_h
integer , DIMENSION(max_domains) :: auxinput13_begin_m
integer , DIMENSION(max_domains) :: auxinput13_begin_s
integer , DIMENSION(max_domains) :: auxinput13_begin
integer , DIMENSION(max_domains) :: auxinput13_end_y
integer , DIMENSION(max_domains) :: auxinput13_end_d
integer , DIMENSION(max_domains) :: auxinput13_end_h
integer , DIMENSION(max_domains) :: auxinput13_end_m
integer , DIMENSION(max_domains) :: auxinput13_end_s
integer , DIMENSION(max_domains) :: auxinput13_end
integer :: io_form_auxinput13
integer , DIMENSION(max_domains) :: frames_per_auxinput13
character*256 :: auxinput14_inname
character*256 :: auxinput14_outname
integer , DIMENSION(max_domains) :: auxinput14_interval_y
integer , DIMENSION(max_domains) :: auxinput14_interval_d
integer , DIMENSION(max_domains) :: auxinput14_interval_h
integer , DIMENSION(max_domains) :: auxinput14_interval_m
integer , DIMENSION(max_domains) :: auxinput14_interval_s
integer , DIMENSION(max_domains) :: auxinput14_interval
integer , DIMENSION(max_domains) :: auxinput14_begin_y
integer , DIMENSION(max_domains) :: auxinput14_begin_d
integer , DIMENSION(max_domains) :: auxinput14_begin_h
integer , DIMENSION(max_domains) :: auxinput14_begin_m
integer , DIMENSION(max_domains) :: auxinput14_begin_s
integer , DIMENSION(max_domains) :: auxinput14_begin
integer , DIMENSION(max_domains) :: auxinput14_end_y
integer , DIMENSION(max_domains) :: auxinput14_end_d
integer , DIMENSION(max_domains) :: auxinput14_end_h
integer , DIMENSION(max_domains) :: auxinput14_end_m
integer , DIMENSION(max_domains) :: auxinput14_end_s
integer , DIMENSION(max_domains) :: auxinput14_end
integer :: io_form_auxinput14
integer , DIMENSION(max_domains) :: frames_per_auxinput14
character*256 :: auxinput15_inname
character*256 :: auxinput15_outname
integer , DIMENSION(max_domains) :: auxinput15_interval_y
integer , DIMENSION(max_domains) :: auxinput15_interval_d
integer , DIMENSION(max_domains) :: auxinput15_interval_h
integer , DIMENSION(max_domains) :: auxinput15_interval_m
integer , DIMENSION(max_domains) :: auxinput15_interval_s
integer , DIMENSION(max_domains) :: auxinput15_interval
integer , DIMENSION(max_domains) :: auxinput15_begin_y
integer , DIMENSION(max_domains) :: auxinput15_begin_d
integer , DIMENSION(max_domains) :: auxinput15_begin_h
integer , DIMENSION(max_domains) :: auxinput15_begin_m
integer , DIMENSION(max_domains) :: auxinput15_begin_s
integer , DIMENSION(max_domains) :: auxinput15_begin
integer , DIMENSION(max_domains) :: auxinput15_end_y
integer , DIMENSION(max_domains) :: auxinput15_end_d
integer , DIMENSION(max_domains) :: auxinput15_end_h
integer , DIMENSION(max_domains) :: auxinput15_end_m
integer , DIMENSION(max_domains) :: auxinput15_end_s
integer , DIMENSION(max_domains) :: auxinput15_end
integer :: io_form_auxinput15
integer , DIMENSION(max_domains) :: frames_per_auxinput15
character*256 :: auxinput16_inname
character*256 :: auxinput16_outname
integer , DIMENSION(max_domains) :: auxinput16_interval_y
integer , DIMENSION(max_domains) :: auxinput16_interval_d
integer , DIMENSION(max_domains) :: auxinput16_interval_h
integer , DIMENSION(max_domains) :: auxinput16_interval_m
integer , DIMENSION(max_domains) :: auxinput16_interval_s
integer , DIMENSION(max_domains) :: auxinput16_interval
integer , DIMENSION(max_domains) :: auxinput16_begin_y
integer , DIMENSION(max_domains) :: auxinput16_begin_d
integer , DIMENSION(max_domains) :: auxinput16_begin_h
integer , DIMENSION(max_domains) :: auxinput16_begin_m
integer , DIMENSION(max_domains) :: auxinput16_begin_s
integer , DIMENSION(max_domains) :: auxinput16_begin
integer , DIMENSION(max_domains) :: auxinput16_end_y
integer , DIMENSION(max_domains) :: auxinput16_end_d
integer , DIMENSION(max_domains) :: auxinput16_end_h
integer , DIMENSION(max_domains) :: auxinput16_end_m
integer , DIMENSION(max_domains) :: auxinput16_end_s
integer , DIMENSION(max_domains) :: auxinput16_end
integer :: io_form_auxinput16
integer , DIMENSION(max_domains) :: frames_per_auxinput16
character*256 :: auxinput17_inname
character*256 :: auxinput17_outname
integer , DIMENSION(max_domains) :: auxinput17_interval_y
integer , DIMENSION(max_domains) :: auxinput17_interval_d
integer , DIMENSION(max_domains) :: auxinput17_interval_h
integer , DIMENSION(max_domains) :: auxinput17_interval_m
integer , DIMENSION(max_domains) :: auxinput17_interval_s
integer , DIMENSION(max_domains) :: auxinput17_interval
integer , DIMENSION(max_domains) :: auxinput17_begin_y
integer , DIMENSION(max_domains) :: auxinput17_begin_d
integer , DIMENSION(max_domains) :: auxinput17_begin_h
integer , DIMENSION(max_domains) :: auxinput17_begin_m
integer , DIMENSION(max_domains) :: auxinput17_begin_s
integer , DIMENSION(max_domains) :: auxinput17_begin
integer , DIMENSION(max_domains) :: auxinput17_end_y
integer , DIMENSION(max_domains) :: auxinput17_end_d
integer , DIMENSION(max_domains) :: auxinput17_end_h
integer , DIMENSION(max_domains) :: auxinput17_end_m
integer , DIMENSION(max_domains) :: auxinput17_end_s
integer , DIMENSION(max_domains) :: auxinput17_end
integer :: io_form_auxinput17
integer , DIMENSION(max_domains) :: frames_per_auxinput17
character*256 :: auxinput18_inname
character*256 :: auxinput18_outname
integer , DIMENSION(max_domains) :: auxinput18_interval_y
integer , DIMENSION(max_domains) :: auxinput18_interval_d
integer , DIMENSION(max_domains) :: auxinput18_interval_h
integer , DIMENSION(max_domains) :: auxinput18_interval_m
integer , DIMENSION(max_domains) :: auxinput18_interval_s
integer , DIMENSION(max_domains) :: auxinput18_interval
integer , DIMENSION(max_domains) :: auxinput18_begin_y
integer , DIMENSION(max_domains) :: auxinput18_begin_d
integer , DIMENSION(max_domains) :: auxinput18_begin_h
integer , DIMENSION(max_domains) :: auxinput18_begin_m
integer , DIMENSION(max_domains) :: auxinput18_begin_s
integer , DIMENSION(max_domains) :: auxinput18_begin
integer , DIMENSION(max_domains) :: auxinput18_end_y
integer , DIMENSION(max_domains) :: auxinput18_end_d
integer , DIMENSION(max_domains) :: auxinput18_end_h
integer , DIMENSION(max_domains) :: auxinput18_end_m
integer , DIMENSION(max_domains) :: auxinput18_end_s
integer , DIMENSION(max_domains) :: auxinput18_end
integer :: io_form_auxinput18
integer , DIMENSION(max_domains) :: frames_per_auxinput18
character*256 :: auxinput19_inname
character*256 :: auxinput19_outname
integer , DIMENSION(max_domains) :: auxinput19_interval_y
integer , DIMENSION(max_domains) :: auxinput19_interval_d
integer , DIMENSION(max_domains) :: auxinput19_interval_h
integer , DIMENSION(max_domains) :: auxinput19_interval_m
integer , DIMENSION(max_domains) :: auxinput19_interval_s
integer , DIMENSION(max_domains) :: auxinput19_interval
integer , DIMENSION(max_domains) :: auxinput19_begin_y
integer , DIMENSION(max_domains) :: auxinput19_begin_d
integer , DIMENSION(max_domains) :: auxinput19_begin_h
integer , DIMENSION(max_domains) :: auxinput19_begin_m
integer , DIMENSION(max_domains) :: auxinput19_begin_s
integer , DIMENSION(max_domains) :: auxinput19_begin
integer , DIMENSION(max_domains) :: auxinput19_end_y
integer , DIMENSION(max_domains) :: auxinput19_end_d
integer , DIMENSION(max_domains) :: auxinput19_end_h
integer , DIMENSION(max_domains) :: auxinput19_end_m
integer , DIMENSION(max_domains) :: auxinput19_end_s
integer , DIMENSION(max_domains) :: auxinput19_end
integer :: io_form_auxinput19
integer , DIMENSION(max_domains) :: frames_per_auxinput19
character*256 :: auxinput20_inname
character*256 :: auxinput20_outname
integer , DIMENSION(max_domains) :: auxinput20_interval_y
integer , DIMENSION(max_domains) :: auxinput20_interval_d
integer , DIMENSION(max_domains) :: auxinput20_interval_h
integer , DIMENSION(max_domains) :: auxinput20_interval_m
integer , DIMENSION(max_domains) :: auxinput20_interval_s
integer , DIMENSION(max_domains) :: auxinput20_interval
integer , DIMENSION(max_domains) :: auxinput20_begin_y
integer , DIMENSION(max_domains) :: auxinput20_begin_d
integer , DIMENSION(max_domains) :: auxinput20_begin_h
integer , DIMENSION(max_domains) :: auxinput20_begin_m
integer , DIMENSION(max_domains) :: auxinput20_begin_s
integer , DIMENSION(max_domains) :: auxinput20_begin
integer , DIMENSION(max_domains) :: auxinput20_end_y
integer , DIMENSION(max_domains) :: auxinput20_end_d
integer , DIMENSION(max_domains) :: auxinput20_end_h
integer , DIMENSION(max_domains) :: auxinput20_end_m
integer , DIMENSION(max_domains) :: auxinput20_end_s
integer , DIMENSION(max_domains) :: auxinput20_end
integer :: io_form_auxinput20
integer , DIMENSION(max_domains) :: frames_per_auxinput20
character*256 :: auxinput21_inname
character*256 :: auxinput21_outname
integer , DIMENSION(max_domains) :: auxinput21_interval_y
integer , DIMENSION(max_domains) :: auxinput21_interval_d
integer , DIMENSION(max_domains) :: auxinput21_interval_h
integer , DIMENSION(max_domains) :: auxinput21_interval_m
integer , DIMENSION(max_domains) :: auxinput21_interval_s
integer , DIMENSION(max_domains) :: auxinput21_interval
integer , DIMENSION(max_domains) :: auxinput21_begin_y
integer , DIMENSION(max_domains) :: auxinput21_begin_d
integer , DIMENSION(max_domains) :: auxinput21_begin_h
integer , DIMENSION(max_domains) :: auxinput21_begin_m
integer , DIMENSION(max_domains) :: auxinput21_begin_s
integer , DIMENSION(max_domains) :: auxinput21_begin
integer , DIMENSION(max_domains) :: auxinput21_end_y
integer , DIMENSION(max_domains) :: auxinput21_end_d
integer , DIMENSION(max_domains) :: auxinput21_end_h
integer , DIMENSION(max_domains) :: auxinput21_end_m
integer , DIMENSION(max_domains) :: auxinput21_end_s
integer , DIMENSION(max_domains) :: auxinput21_end
integer :: io_form_auxinput21
integer , DIMENSION(max_domains) :: frames_per_auxinput21
character*256 :: auxinput22_inname
character*256 :: auxinput22_outname
integer , DIMENSION(max_domains) :: auxinput22_interval_y
integer , DIMENSION(max_domains) :: auxinput22_interval_d
integer , DIMENSION(max_domains) :: auxinput22_interval_h
integer , DIMENSION(max_domains) :: auxinput22_interval_m
integer , DIMENSION(max_domains) :: auxinput22_interval_s
integer , DIMENSION(max_domains) :: auxinput22_interval
integer , DIMENSION(max_domains) :: auxinput22_begin_y
integer , DIMENSION(max_domains) :: auxinput22_begin_d
integer , DIMENSION(max_domains) :: auxinput22_begin_h
integer , DIMENSION(max_domains) :: auxinput22_begin_m
integer , DIMENSION(max_domains) :: auxinput22_begin_s
integer , DIMENSION(max_domains) :: auxinput22_begin
integer , DIMENSION(max_domains) :: auxinput22_end_y
integer , DIMENSION(max_domains) :: auxinput22_end_d
integer , DIMENSION(max_domains) :: auxinput22_end_h
integer , DIMENSION(max_domains) :: auxinput22_end_m
integer , DIMENSION(max_domains) :: auxinput22_end_s
integer , DIMENSION(max_domains) :: auxinput22_end
integer :: io_form_auxinput22
integer , DIMENSION(max_domains) :: frames_per_auxinput22
character*256 :: auxinput23_inname
character*256 :: auxinput23_outname
integer , DIMENSION(max_domains) :: auxinput23_interval_y
integer , DIMENSION(max_domains) :: auxinput23_interval_d
integer , DIMENSION(max_domains) :: auxinput23_interval_h
integer , DIMENSION(max_domains) :: auxinput23_interval_m
integer , DIMENSION(max_domains) :: auxinput23_interval_s
integer , DIMENSION(max_domains) :: auxinput23_interval
integer , DIMENSION(max_domains) :: auxinput23_begin_y
integer , DIMENSION(max_domains) :: auxinput23_begin_d
integer , DIMENSION(max_domains) :: auxinput23_begin_h
integer , DIMENSION(max_domains) :: auxinput23_begin_m
integer , DIMENSION(max_domains) :: auxinput23_begin_s
integer , DIMENSION(max_domains) :: auxinput23_begin
integer , DIMENSION(max_domains) :: auxinput23_end_y
integer , DIMENSION(max_domains) :: auxinput23_end_d
integer , DIMENSION(max_domains) :: auxinput23_end_h
integer , DIMENSION(max_domains) :: auxinput23_end_m
integer , DIMENSION(max_domains) :: auxinput23_end_s
integer , DIMENSION(max_domains) :: auxinput23_end
integer :: io_form_auxinput23
integer , DIMENSION(max_domains) :: frames_per_auxinput23
character*256 :: auxinput24_inname
character*256 :: auxinput24_outname
integer , DIMENSION(max_domains) :: auxinput24_interval_y
integer , DIMENSION(max_domains) :: auxinput24_interval_d
integer , DIMENSION(max_domains) :: auxinput24_interval_h
integer , DIMENSION(max_domains) :: auxinput24_interval_m
integer , DIMENSION(max_domains) :: auxinput24_interval_s
integer , DIMENSION(max_domains) :: auxinput24_interval
integer , DIMENSION(max_domains) :: auxinput24_begin_y
integer , DIMENSION(max_domains) :: auxinput24_begin_d
integer , DIMENSION(max_domains) :: auxinput24_begin_h
integer , DIMENSION(max_domains) :: auxinput24_begin_m
integer , DIMENSION(max_domains) :: auxinput24_begin_s
integer , DIMENSION(max_domains) :: auxinput24_begin
integer , DIMENSION(max_domains) :: auxinput24_end_y
integer , DIMENSION(max_domains) :: auxinput24_end_d
integer , DIMENSION(max_domains) :: auxinput24_end_h
integer , DIMENSION(max_domains) :: auxinput24_end_m
integer , DIMENSION(max_domains) :: auxinput24_end_s
integer , DIMENSION(max_domains) :: auxinput24_end
integer :: io_form_auxinput24
integer , DIMENSION(max_domains) :: frames_per_auxinput24
integer , DIMENSION(max_domains) :: history_interval
integer , DIMENSION(max_domains) :: frames_per_outfile
logical :: restart
integer :: restart_interval
integer :: io_form_input
integer :: io_form_history
integer :: io_form_restart
integer :: io_form_boundary
integer :: debug_level
logical :: self_test_domain
character*256 :: history_outname
character*256 :: history_inname
logical :: use_netcdf_classic
integer , DIMENSION(max_domains) :: history_interval_d
integer , DIMENSION(max_domains) :: history_interval_h
integer , DIMENSION(max_domains) :: history_interval_m
integer , DIMENSION(max_domains) :: history_interval_s
integer , DIMENSION(max_domains) :: inputout_interval_d
integer , DIMENSION(max_domains) :: inputout_interval_h
integer , DIMENSION(max_domains) :: inputout_interval_m
integer , DIMENSION(max_domains) :: inputout_interval_s
integer , DIMENSION(max_domains) :: inputout_interval
integer :: restart_interval_d
integer :: restart_interval_h
integer :: restart_interval_m
integer :: restart_interval_s
integer , DIMENSION(max_domains) :: history_begin_y
integer , DIMENSION(max_domains) :: history_begin_d
integer , DIMENSION(max_domains) :: history_begin_h
integer , DIMENSION(max_domains) :: history_begin_m
integer , DIMENSION(max_domains) :: history_begin_s
integer , DIMENSION(max_domains) :: history_begin
integer , DIMENSION(max_domains) :: inputout_begin_y
integer , DIMENSION(max_domains) :: inputout_begin_d
integer , DIMENSION(max_domains) :: inputout_begin_h
integer , DIMENSION(max_domains) :: inputout_begin_m
integer , DIMENSION(max_domains) :: inputout_begin_s
integer :: restart_begin_y
integer :: restart_begin_d
integer :: restart_begin_h
integer :: restart_begin_m
integer :: restart_begin_s
integer :: restart_begin
integer , DIMENSION(max_domains) :: history_end_y
integer , DIMENSION(max_domains) :: history_end_d
integer , DIMENSION(max_domains) :: history_end_h
integer , DIMENSION(max_domains) :: history_end_m
integer , DIMENSION(max_domains) :: history_end_s
integer , DIMENSION(max_domains) :: history_end
integer , DIMENSION(max_domains) :: inputout_end_y
integer , DIMENSION(max_domains) :: inputout_end_d
integer , DIMENSION(max_domains) :: inputout_end_h
integer , DIMENSION(max_domains) :: inputout_end_m
integer , DIMENSION(max_domains) :: inputout_end_s
integer :: simulation_start_year
integer :: simulation_start_month
integer :: simulation_start_day
integer :: simulation_start_hour
integer :: simulation_start_minute
integer :: simulation_start_second
logical :: reset_simulation_start
integer , DIMENSION(max_domains) :: sr_x
integer , DIMENSION(max_domains) :: sr_y
character*256 :: sgfdda_inname
character*256 :: gfdda_inname
integer , DIMENSION(max_domains) :: sgfdda_interval_d
integer , DIMENSION(max_domains) :: sgfdda_interval_h
integer , DIMENSION(max_domains) :: sgfdda_interval_m
integer , DIMENSION(max_domains) :: sgfdda_interval_s
integer , DIMENSION(max_domains) :: sgfdda_interval_y
integer , DIMENSION(max_domains) :: sgfdda_interval
integer , DIMENSION(max_domains) :: gfdda_interval_d
integer , DIMENSION(max_domains) :: gfdda_interval_h
integer , DIMENSION(max_domains) :: gfdda_interval_m
integer , DIMENSION(max_domains) :: gfdda_interval_s
integer , DIMENSION(max_domains) :: gfdda_interval_y
integer , DIMENSION(max_domains) :: gfdda_interval
integer , DIMENSION(max_domains) :: sgfdda_begin_y
integer , DIMENSION(max_domains) :: sgfdda_begin_d
integer , DIMENSION(max_domains) :: sgfdda_begin_h
integer , DIMENSION(max_domains) :: sgfdda_begin_m
integer , DIMENSION(max_domains) :: sgfdda_begin_s
integer , DIMENSION(max_domains) :: gfdda_begin_y
integer , DIMENSION(max_domains) :: gfdda_begin_d
integer , DIMENSION(max_domains) :: gfdda_begin_h
integer , DIMENSION(max_domains) :: gfdda_begin_m
integer , DIMENSION(max_domains) :: gfdda_begin_s
integer , DIMENSION(max_domains) :: sgfdda_end_y
integer , DIMENSION(max_domains) :: sgfdda_end_d
integer , DIMENSION(max_domains) :: sgfdda_end_h
integer , DIMENSION(max_domains) :: sgfdda_end_m
integer , DIMENSION(max_domains) :: sgfdda_end_s
integer , DIMENSION(max_domains) :: gfdda_end_y
integer , DIMENSION(max_domains) :: gfdda_end_d
integer , DIMENSION(max_domains) :: gfdda_end_h
integer , DIMENSION(max_domains) :: gfdda_end_m
integer , DIMENSION(max_domains) :: gfdda_end_s
integer :: io_form_sgfdda
integer :: io_form_gfdda
character*256 , DIMENSION(max_domains) :: iofields_filename
logical :: ignore_iofields_warning
logical :: ncd_nofill
integer , DIMENSION(max_domains) :: ifire
integer , DIMENSION(max_domains) :: fire_boundary_guard
integer , DIMENSION(max_domains) :: fire_num_ignitions
real , DIMENSION(max_domains) :: fire_ignition_ros1
real , DIMENSION(max_domains) :: fire_ignition_start_lon1
real , DIMENSION(max_domains) :: fire_ignition_start_lat1
real , DIMENSION(max_domains) :: fire_ignition_end_lon1
real , DIMENSION(max_domains) :: fire_ignition_end_lat1
real , DIMENSION(max_domains) :: fire_ignition_radius1
real , DIMENSION(max_domains) :: fire_ignition_start_time1
real , DIMENSION(max_domains) :: fire_ignition_end_time1
real , DIMENSION(max_domains) :: fire_ignition_ros2
real , DIMENSION(max_domains) :: fire_ignition_start_lon2
real , DIMENSION(max_domains) :: fire_ignition_start_lat2
real , DIMENSION(max_domains) :: fire_ignition_end_lon2
real , DIMENSION(max_domains) :: fire_ignition_end_lat2
real , DIMENSION(max_domains) :: fire_ignition_radius2
real , DIMENSION(max_domains) :: fire_ignition_start_time2
real , DIMENSION(max_domains) :: fire_ignition_end_time2
real , DIMENSION(max_domains) :: fire_ignition_ros3
real , DIMENSION(max_domains) :: fire_ignition_start_lon3
real , DIMENSION(max_domains) :: fire_ignition_start_lat3
real , DIMENSION(max_domains) :: fire_ignition_end_lon3
real , DIMENSION(max_domains) :: fire_ignition_end_lat3
real , DIMENSION(max_domains) :: fire_ignition_radius3
real , DIMENSION(max_domains) :: fire_ignition_start_time3
real , DIMENSION(max_domains) :: fire_ignition_end_time3
real , DIMENSION(max_domains) :: fire_ignition_ros4
real , DIMENSION(max_domains) :: fire_ignition_start_lon4
real , DIMENSION(max_domains) :: fire_ignition_start_lat4
real , DIMENSION(max_domains) :: fire_ignition_end_lon4
real , DIMENSION(max_domains) :: fire_ignition_end_lat4
real , DIMENSION(max_domains) :: fire_ignition_radius4
real , DIMENSION(max_domains) :: fire_ignition_start_time4
real , DIMENSION(max_domains) :: fire_ignition_end_time4
real , DIMENSION(max_domains) :: fire_ignition_ros5
real , DIMENSION(max_domains) :: fire_ignition_start_lon5
real , DIMENSION(max_domains) :: fire_ignition_start_lat5
real , DIMENSION(max_domains) :: fire_ignition_end_lon5
real , DIMENSION(max_domains) :: fire_ignition_end_lat5
real , DIMENSION(max_domains) :: fire_ignition_radius5
real , DIMENSION(max_domains) :: fire_ignition_start_time5
real , DIMENSION(max_domains) :: fire_ignition_end_time5
real , DIMENSION(max_domains) :: fire_ignition_start_x1
real , DIMENSION(max_domains) :: fire_ignition_start_y1
real , DIMENSION(max_domains) :: fire_ignition_end_x1
real , DIMENSION(max_domains) :: fire_ignition_end_y1
real , DIMENSION(max_domains) :: fire_ignition_start_x2
real , DIMENSION(max_domains) :: fire_ignition_start_y2
real , DIMENSION(max_domains) :: fire_ignition_end_x2
real , DIMENSION(max_domains) :: fire_ignition_end_y2
real , DIMENSION(max_domains) :: fire_ignition_start_x3
real , DIMENSION(max_domains) :: fire_ignition_start_y3
real , DIMENSION(max_domains) :: fire_ignition_end_x3
real , DIMENSION(max_domains) :: fire_ignition_end_y3
real , DIMENSION(max_domains) :: fire_ignition_start_x4
real , DIMENSION(max_domains) :: fire_ignition_start_y4
real , DIMENSION(max_domains) :: fire_ignition_end_x4
real , DIMENSION(max_domains) :: fire_ignition_end_y4
real , DIMENSION(max_domains) :: fire_ignition_start_x5
real , DIMENSION(max_domains) :: fire_ignition_start_y5
real , DIMENSION(max_domains) :: fire_ignition_end_x5
real , DIMENSION(max_domains) :: fire_ignition_end_y5
real , DIMENSION(max_domains) :: fire_lat_init
real , DIMENSION(max_domains) :: fire_lon_init
real , DIMENSION(max_domains) :: fire_ign_time
integer , DIMENSION(max_domains) :: fire_shape
integer , DIMENSION(max_domains) :: fire_sprd_mdl
real , DIMENSION(max_domains) :: fire_crwn_hgt
real , DIMENSION(max_domains) :: fire_ext_grnd
real , DIMENSION(max_domains) :: fire_ext_crwn
real , DIMENSION(max_domains) :: fire_wind_height
integer , DIMENSION(max_domains) :: fire_fuel_read
integer , DIMENSION(max_domains) :: fire_fuel_cat
integer , DIMENSION(max_domains) :: fire_print_msg
integer , DIMENSION(max_domains) :: fire_print_file
integer , DIMENSION(max_domains) :: fire_fuel_left_method
integer , DIMENSION(max_domains) :: fire_fuel_left_irl
integer , DIMENSION(max_domains) :: fire_fuel_left_jrl
integer , DIMENSION(max_domains) :: fire_grows_only
integer , DIMENSION(max_domains) :: fire_upwinding
integer , DIMENSION(max_domains) :: fire_upwind_split
real , DIMENSION(max_domains) :: fire_viscosity
real , DIMENSION(max_domains) :: fire_lfn_ext_up
integer , DIMENSION(max_domains) :: fire_topo_from_atm
integer , DIMENSION(max_domains) :: fire_advection
integer , DIMENSION(max_domains) :: fire_test_steps
real , DIMENSION(max_domains) :: fire_const_time
real , DIMENSION(max_domains) :: fire_const_grnhfx
real , DIMENSION(max_domains) :: fire_const_grnqfx
real , DIMENSION(max_domains) :: fire_atm_feedback
integer , DIMENSION(max_domains) :: fire_mountain_type
real , DIMENSION(max_domains) :: fire_mountain_height
real , DIMENSION(max_domains) :: fire_mountain_start_x
real , DIMENSION(max_domains) :: fire_mountain_start_y
real , DIMENSION(max_domains) :: fire_mountain_end_x
real , DIMENSION(max_domains) :: fire_mountain_end_y
real , DIMENSION(max_domains) :: delt_perturbation
real , DIMENSION(max_domains) :: xrad_perturbation
real , DIMENSION(max_domains) :: yrad_perturbation
real , DIMENSION(max_domains) :: zrad_perturbation
real , DIMENSION(max_domains) :: hght_perturbation
logical , DIMENSION(max_domains) :: stretch_grd
logical , DIMENSION(max_domains) :: stretch_hyp
real , DIMENSION(max_domains) :: z_grd_scale
logical , DIMENSION(max_domains) :: sfc_full_init
integer , DIMENSION(max_domains) :: sfc_lu_index
real , DIMENSION(max_domains) :: sfc_tsk
real , DIMENSION(max_domains) :: sfc_tmn
logical , DIMENSION(max_domains) :: fire_read_lu
logical , DIMENSION(max_domains) :: fire_read_tsk
logical , DIMENSION(max_domains) :: fire_read_tmn
logical , DIMENSION(max_domains) :: fire_read_atm_ht
logical , DIMENSION(max_domains) :: fire_read_fire_ht
logical , DIMENSION(max_domains) :: fire_read_atm_grad
logical , DIMENSION(max_domains) :: fire_read_fire_grad
real , DIMENSION(max_domains) :: sfc_vegfra
real , DIMENSION(max_domains) :: sfc_canwat
integer , DIMENSION(max_domains) :: sfc_ivgtyp
integer , DIMENSION(max_domains) :: sfc_isltyp
logical , DIMENSION(max_domains) :: fire_lsm_reinit
integer , DIMENSION(max_domains) :: fire_lsm_reinit_iter
integer , DIMENSION(max_domains) :: fire_upwinding_reinit
logical , DIMENSION(max_domains) :: fire_is_real_perim
integer , DIMENSION(max_domains) :: fire_lsm_band_ngp
logical , DIMENSION(max_domains) :: fire_lsm_zcoupling
real , DIMENSION(max_domains) :: fire_lsm_zcoupling_ref
real , DIMENSION(max_domains) :: fire_tracer_smoke
real , DIMENSION(max_domains) :: fire_viscosity_bg
real , DIMENSION(max_domains) :: fire_viscosity_band
integer , DIMENSION(max_domains) :: fire_viscosity_ngp
real , DIMENSION(max_domains) :: fire_slope_factor
integer , DIMENSION(max_domains) :: do_avgflx_em
integer , DIMENSION(max_domains) :: do_avgflx_cugd
integer :: nens
integer , DIMENSION(max_domains) :: skebs
integer , DIMENSION(max_domains) :: stoch_force_opt
integer :: skebs_vertstruc
integer , DIMENSION(max_domains) :: stoch_vertstruc_opt
real , DIMENSION(max_domains) :: tot_backscat_psi
real , DIMENSION(max_domains) :: tot_backscat_t
real :: ztau_psi
real :: ztau_t
real :: rexponent_psi
real :: rexponent_t
real :: zsigma2_eps
real :: zsigma2_eta
integer :: kminforc
integer :: lminforc
integer :: kminforct
integer :: lminforct
integer :: kmaxforc
integer :: lmaxforc
integer :: kmaxforct
integer :: lmaxforct
integer :: iseed_skebs
integer :: kmaxforch
integer :: lmaxforch
integer :: kmaxforcth
integer :: lmaxforcth
integer , DIMENSION(max_domains) :: sppt
real , DIMENSION(max_domains) :: gridpt_stddev_sppt
real , DIMENSION(max_domains) :: stddev_cutoff_sppt
real , DIMENSION(max_domains) :: lengthscale_sppt
real , DIMENSION(max_domains) :: timescale_sppt
integer :: sppt_vertstruc
integer :: iseed_sppt
integer , DIMENSION(max_domains) :: rand_perturb
real , DIMENSION(max_domains) :: gridpt_stddev_rand_pert
real , DIMENSION(max_domains) :: stddev_cutoff_rand_pert
real , DIMENSION(max_domains) :: lengthscale_rand_pert
real , DIMENSION(max_domains) :: timescale_rand_pert
integer :: rand_pert_vertstruc
integer :: iseed_rand_pert
integer , DIMENSION(max_domains) :: spp
logical :: hrrr_cycling
integer , DIMENSION(max_domains) :: spp_conv
real , DIMENSION(max_domains) :: gridpt_stddev_spp_conv
real , DIMENSION(max_domains) :: stddev_cutoff_spp_conv
real , DIMENSION(max_domains) :: lengthscale_spp_conv
real , DIMENSION(max_domains) :: timescale_spp_conv
integer :: vertstruc_spp_conv
integer :: iseed_spp_conv
integer , DIMENSION(max_domains) :: spp_pbl
real , DIMENSION(max_domains) :: gridpt_stddev_spp_pbl
real , DIMENSION(max_domains) :: stddev_cutoff_spp_pbl
real , DIMENSION(max_domains) :: lengthscale_spp_pbl
real , DIMENSION(max_domains) :: timescale_spp_pbl
integer :: vertstruc_spp_pbl
integer :: iseed_spp_pbl
integer , DIMENSION(max_domains) :: spp_lsm
real , DIMENSION(max_domains) :: gridpt_stddev_spp_lsm
real , DIMENSION(max_domains) :: stddev_cutoff_spp_lsm
real , DIMENSION(max_domains) :: lengthscale_spp_lsm
real , DIMENSION(max_domains) :: timescale_spp_lsm
integer :: vertstruc_spp_lsm
integer :: iseed_spp_lsm
integer :: skebs_on
integer :: sppt_on
integer :: spp_on
integer :: rand_perturb_on
integer :: num_stoch_levels
integer :: seed_dim
integer , DIMENSION(max_domains) :: sfs_opt
integer , DIMENSION(max_domains) :: m_opt
real , DIMENSION(max_domains) :: lakedepth_default
real , DIMENSION(max_domains) :: lake_min_elev
integer , DIMENSION(max_domains) :: use_lakedepth
integer :: p_lev_diags
integer :: p_lev_diags_dfi
integer :: num_press_levels
real , DIMENSION(max_plevs) :: press_levels
integer :: use_tot_or_hyd_p
integer :: extrap_below_grnd
real :: p_lev_missing
real , DIMENSION(max_domains) :: p_lev_interval
integer :: z_lev_diags
integer :: z_lev_diags_dfi
integer :: num_z_levels
real , DIMENSION(max_zlevs) :: z_levels
real :: z_lev_missing
real , DIMENSION(max_domains) :: z_lev_interval
integer , DIMENSION(max_domains) :: afwa_diag_opt
integer , DIMENSION(max_domains) :: afwa_ptype_opt
integer , DIMENSION(max_domains) :: afwa_vil_opt
integer , DIMENSION(max_domains) :: afwa_radar_opt
integer , DIMENSION(max_domains) :: afwa_severe_opt
integer , DIMENSION(max_domains) :: afwa_icing_opt
integer , DIMENSION(max_domains) :: afwa_vis_opt
integer , DIMENSION(max_domains) :: afwa_cloud_opt
integer , DIMENSION(max_domains) :: afwa_therm_opt
integer , DIMENSION(max_domains) :: afwa_turb_opt
integer , DIMENSION(max_domains) :: afwa_buoy_opt
real :: afwa_ptype_ccn_tmp
real :: afwa_ptype_tot_melt
integer :: afwa_bad_data_check
integer :: mean_diag
integer :: mean_freq
integer , DIMENSION(max_domains) :: mean_interval
integer , DIMENSION(max_domains) :: mean_diag_interval
integer , DIMENSION(max_domains) :: mean_diag_interval_s
integer , DIMENSION(max_domains) :: mean_diag_interval_m
integer , DIMENSION(max_domains) :: mean_diag_interval_h
integer , DIMENSION(max_domains) :: mean_diag_interval_d
integer , DIMENSION(max_domains) :: mean_diag_interval_mo
integer :: diurnal_diag
integer , DIMENSION(max_domains) :: nssl_ipelec
integer :: nssl_isaund
integer :: nssl_iscreen
real :: nssl_lightrad
integer :: nssl_idischarge
integer :: nssl_ibrkd
real :: nssl_ecrit
real :: nssl_disfrac
integer :: elec_physics
integer :: perturb_bdy
integer :: perturb_chem_bdy
integer :: hybrid_opt
real :: etac
integer :: num_wif_levels
integer :: wif_input_opt
integer :: diag_nwp2
integer , DIMENSION(max_domains) :: chem_opt
integer    :: last_item_in_struct









NAMELIST /time_control/ run_days
NAMELIST /time_control/ run_hours
NAMELIST /time_control/ run_minutes
NAMELIST /time_control/ run_seconds
NAMELIST /time_control/ start_year
NAMELIST /time_control/ start_month
NAMELIST /time_control/ start_day
NAMELIST /time_control/ start_hour
NAMELIST /time_control/ start_minute
NAMELIST /time_control/ start_second
NAMELIST /time_control/ end_year
NAMELIST /time_control/ end_month
NAMELIST /time_control/ end_day
NAMELIST /time_control/ end_hour
NAMELIST /time_control/ end_minute
NAMELIST /time_control/ end_second
NAMELIST /time_control/ interval_seconds
NAMELIST /time_control/ input_from_file
NAMELIST /time_control/ fine_input_stream
NAMELIST /time_control/ input_from_hires
NAMELIST /time_control/ rsmas_data_path
NAMELIST /time_control/ all_ic_times
NAMELIST /time_control/ julyr
NAMELIST /time_control/ julday
NAMELIST /time_control/ gmt
NAMELIST /time_control/ input_inname
NAMELIST /time_control/ input_outname
NAMELIST /time_control/ bdy_inname
NAMELIST /time_control/ bdy_outname
NAMELIST /time_control/ rst_inname
NAMELIST /time_control/ rst_outname
NAMELIST /time_control/ write_input
NAMELIST /time_control/ write_restart_at_0h
NAMELIST /time_control/ write_hist_at_0h_rst
NAMELIST /time_control/ adjust_output_times
NAMELIST /time_control/ adjust_input_times
NAMELIST /time_control/ diag_print
NAMELIST /time_control/ nocolons
NAMELIST /time_control/ cycling
NAMELIST /time_control/ output_diagnostics
NAMELIST /time_control/ nwp_diagnostics
NAMELIST /time_control/ output_ready_flag
NAMELIST /time_control/ force_use_old_data
NAMELIST /pio_control/ usepio
NAMELIST /pio_control/ pioprocs
NAMELIST /pio_control/ piostart
NAMELIST /pio_control/ piostride
NAMELIST /pio_control/ pioshift
NAMELIST /dfi_control/ dfi_opt
NAMELIST /dfi_control/ dfi_savehydmeteors
NAMELIST /dfi_control/ dfi_nfilter
NAMELIST /dfi_control/ dfi_write_filtered_input
NAMELIST /dfi_control/ dfi_write_dfi_history
NAMELIST /dfi_control/ dfi_cutoff_seconds
NAMELIST /dfi_control/ dfi_time_dim
NAMELIST /dfi_control/ dfi_fwdstop_year
NAMELIST /dfi_control/ dfi_fwdstop_month
NAMELIST /dfi_control/ dfi_fwdstop_day
NAMELIST /dfi_control/ dfi_fwdstop_hour
NAMELIST /dfi_control/ dfi_fwdstop_minute
NAMELIST /dfi_control/ dfi_fwdstop_second
NAMELIST /dfi_control/ dfi_bckstop_year
NAMELIST /dfi_control/ dfi_bckstop_month
NAMELIST /dfi_control/ dfi_bckstop_day
NAMELIST /dfi_control/ dfi_bckstop_hour
NAMELIST /dfi_control/ dfi_bckstop_minute
NAMELIST /dfi_control/ dfi_bckstop_second
NAMELIST /domains/ time_step
NAMELIST /domains/ time_step_fract_num
NAMELIST /domains/ time_step_fract_den
NAMELIST /domains/ time_step_dfi
NAMELIST /domains/ min_time_step
NAMELIST /domains/ min_time_step_den
NAMELIST /domains/ max_time_step
NAMELIST /domains/ max_time_step_den
NAMELIST /domains/ target_cfl
NAMELIST /domains/ target_hcfl
NAMELIST /domains/ max_step_increase_pct
NAMELIST /domains/ starting_time_step
NAMELIST /domains/ starting_time_step_den
NAMELIST /domains/ step_to_output_time
NAMELIST /domains/ adaptation_domain
NAMELIST /domains/ use_adaptive_time_step
NAMELIST /domains/ use_adaptive_time_step_dfi
NAMELIST /domains/ max_dom
NAMELIST /domains/ lats_to_mic
NAMELIST /domains/ s_we
NAMELIST /domains/ e_we
NAMELIST /domains/ s_sn
NAMELIST /domains/ e_sn
NAMELIST /domains/ s_vert
NAMELIST /domains/ e_vert
NAMELIST /domains/ num_metgrid_levels
NAMELIST /domains/ num_metgrid_soil_levels
NAMELIST /domains/ p_top_requested
NAMELIST /domains/ interp_theta
NAMELIST /domains/ interp_type
NAMELIST /domains/ rebalance
NAMELIST /domains/ vert_refine_method
NAMELIST /domains/ vert_refine_fact
NAMELIST /domains/ extrap_type
NAMELIST /domains/ t_extrap_type
NAMELIST /domains/ hypsometric_opt
NAMELIST /domains/ lowest_lev_from_sfc
NAMELIST /domains/ use_levels_below_ground
NAMELIST /domains/ use_tavg_for_tsk
NAMELIST /domains/ use_surface
NAMELIST /domains/ lagrange_order
NAMELIST /domains/ linear_interp
NAMELIST /domains/ force_sfc_in_vinterp
NAMELIST /domains/ zap_close_levels
NAMELIST /domains/ maxw_horiz_pres_diff
NAMELIST /domains/ trop_horiz_pres_diff
NAMELIST /domains/ maxw_above_this_level
NAMELIST /domains/ use_maxw_level
NAMELIST /domains/ use_trop_level
NAMELIST /domains/ sfcp_to_sfcp
NAMELIST /domains/ adjust_heights
NAMELIST /domains/ smooth_cg_topo
NAMELIST /domains/ nest_interp_coord
NAMELIST /domains/ interp_method_type
NAMELIST /domains/ aggregate_lu
NAMELIST /domains/ rh2qv_wrt_liquid
NAMELIST /domains/ rh2qv_method
NAMELIST /domains/ qv_max_p_safe
NAMELIST /domains/ qv_max_flag
NAMELIST /domains/ qv_max_value
NAMELIST /domains/ qv_min_p_safe
NAMELIST /domains/ qv_min_flag
NAMELIST /domains/ qv_min_value
NAMELIST /domains/ ideal_init_method
NAMELIST /domains/ dx
NAMELIST /domains/ dy
NAMELIST /domains/ grid_id
NAMELIST /domains/ grid_allowed
NAMELIST /domains/ parent_id
NAMELIST /domains/ i_parent_start
NAMELIST /domains/ j_parent_start
NAMELIST /domains/ parent_grid_ratio
NAMELIST /domains/ parent_time_step_ratio
NAMELIST /domains/ feedback
NAMELIST /domains/ smooth_option
NAMELIST /domains/ blend_width
NAMELIST /domains/ ztop
NAMELIST /domains/ moad_grid_ratio
NAMELIST /domains/ moad_time_step_ratio
NAMELIST /domains/ shw
NAMELIST /domains/ tile_sz_x
NAMELIST /domains/ tile_sz_y
NAMELIST /domains/ numtiles
NAMELIST /domains/ numtiles_inc
NAMELIST /domains/ numtiles_x
NAMELIST /domains/ numtiles_y
NAMELIST /domains/ tile_strategy
NAMELIST /domains/ nproc_x
NAMELIST /domains/ nproc_y
NAMELIST /domains/ irand
NAMELIST /domains/ num_moves
NAMELIST /domains/ ts_buf_size
NAMELIST /domains/ max_ts_locs
NAMELIST /domains/ tslist_unstagger_winds
NAMELIST /domains/ vortex_interval
NAMELIST /domains/ max_vortex_speed
NAMELIST /domains/ corral_dist
NAMELIST /domains/ track_level
NAMELIST /domains/ time_to_move
NAMELIST /domains/ move_id
NAMELIST /domains/ move_interval
NAMELIST /domains/ move_cd_x
NAMELIST /domains/ move_cd_y
NAMELIST /domains/ swap_x
NAMELIST /domains/ swap_y
NAMELIST /domains/ cycle_x
NAMELIST /domains/ cycle_y
NAMELIST /domains/ reorder_mesh
NAMELIST /domains/ perturb_input
NAMELIST /domains/ eta_levels
NAMELIST /domains/ auto_levels_opt
NAMELIST /domains/ max_dz
NAMELIST /domains/ dzbot
NAMELIST /domains/ dzstretch_s
NAMELIST /domains/ dzstretch_u
NAMELIST /domains/ ocean_levels
NAMELIST /domains/ ocean_z
NAMELIST /domains/ ocean_t
NAMELIST /domains/ ocean_s
NAMELIST /domains/ num_traj
NAMELIST /domains/ max_ts_level
NAMELIST /domains/ track_loc_in
NAMELIST /domains/ num_ext_model_couple_dom
NAMELIST /tc/ insert_bogus_storm
NAMELIST /tc/ remove_storm
NAMELIST /tc/ num_storm
NAMELIST /tc/ latc_loc
NAMELIST /tc/ lonc_loc
NAMELIST /tc/ vmax_meters_per_second
NAMELIST /tc/ rmax
NAMELIST /tc/ vmax_ratio
NAMELIST /tc/ rankine_lid
NAMELIST /physics/ physics_suite
NAMELIST /physics/ force_read_thompson
NAMELIST /physics/ write_thompson_tables
NAMELIST /physics/ mp_physics
NAMELIST /physics/ nssl_cccn
NAMELIST /physics/ nssl_alphah
NAMELIST /physics/ nssl_alphahl
NAMELIST /physics/ nssl_cnoh
NAMELIST /physics/ nssl_cnohl
NAMELIST /physics/ nssl_cnor
NAMELIST /physics/ nssl_cnos
NAMELIST /physics/ nssl_rho_qh
NAMELIST /physics/ nssl_rho_qhl
NAMELIST /physics/ nssl_rho_qs
NAMELIST /physics/ nudge_lightning
NAMELIST /physics/ nudge_light_times
NAMELIST /physics/ nudge_light_timee
NAMELIST /physics/ nudge_light_int
NAMELIST /physics/ path_to_files
NAMELIST /physics/ gsfcgce_hail
NAMELIST /physics/ gsfcgce_2ice
NAMELIST /physics/ progn
NAMELIST /physics/ accum_mode
NAMELIST /physics/ aitken_mode
NAMELIST /physics/ coarse_mode
NAMELIST /physics/ do_radar_ref
NAMELIST /physics/ ra_lw_physics
NAMELIST /physics/ ra_sw_physics
NAMELIST /physics/ radt
NAMELIST /physics/ naer
NAMELIST /physics/ sf_sfclay_physics
NAMELIST /physics/ sf_surface_physics
NAMELIST /physics/ bl_pbl_physics
NAMELIST /physics/ bl_mynn_tkebudget
NAMELIST /physics/ ysu_topdown_pblmix
NAMELIST /physics/ shinhong_tke_diag
NAMELIST /physics/ bl_mynn_tkeadvect
NAMELIST /physics/ bl_mynn_cloudpdf
NAMELIST /physics/ bl_mynn_mixlength
NAMELIST /physics/ bl_mynn_edmf
NAMELIST /physics/ bl_mynn_edmf_mom
NAMELIST /physics/ bl_mynn_edmf_tke
NAMELIST /physics/ bl_mynn_mixscalars
NAMELIST /physics/ bl_mynn_cloudmix
NAMELIST /physics/ bl_mynn_mixqt
NAMELIST /physics/ icloud_bl
NAMELIST /physics/ mfshconv
NAMELIST /physics/ sf_urban_physics
NAMELIST /physics/ bldt
NAMELIST /physics/ cu_physics
NAMELIST /physics/ shcu_physics
NAMELIST /physics/ cu_diag
NAMELIST /physics/ kf_edrates
NAMELIST /physics/ kfeta_trigger
NAMELIST /physics/ nsas_dx_factor
NAMELIST /physics/ cudt
NAMELIST /physics/ gsmdt
NAMELIST /physics/ isfflx
NAMELIST /physics/ ifsnow
NAMELIST /physics/ icloud
NAMELIST /physics/ cldovrlp
NAMELIST /physics/ ideal_xland
NAMELIST /physics/ swrad_scat
NAMELIST /physics/ surface_input_source
NAMELIST /physics/ num_soil_layers
NAMELIST /physics/ maxpatch
NAMELIST /physics/ num_snow_layers
NAMELIST /physics/ num_snso_layers
NAMELIST /physics/ num_urban_hi
NAMELIST /physics/ num_months
NAMELIST /physics/ sf_surface_mosaic
NAMELIST /physics/ mosaic_cat
NAMELIST /physics/ mosaic_lu
NAMELIST /physics/ mosaic_soil
NAMELIST /physics/ flag_sm_adj
NAMELIST /physics/ maxiens
NAMELIST /physics/ maxens
NAMELIST /physics/ maxens2
NAMELIST /physics/ maxens3
NAMELIST /physics/ ensdim
NAMELIST /physics/ cugd_avedx
NAMELIST /physics/ clos_choice
NAMELIST /physics/ imomentum
NAMELIST /physics/ ishallow
NAMELIST /physics/ convtrans_avglen_m
NAMELIST /physics/ num_land_cat
NAMELIST /physics/ num_soil_cat
NAMELIST /physics/ mp_zero_out
NAMELIST /physics/ mp_zero_out_thresh
NAMELIST /physics/ seaice_threshold
NAMELIST /physics/ sst_update
NAMELIST /physics/ sst_skin
NAMELIST /physics/ tmn_update
NAMELIST /physics/ usemonalb
NAMELIST /physics/ rdmaxalb
NAMELIST /physics/ rdlai2d
NAMELIST /physics/ ua_phys
NAMELIST /physics/ opt_thcnd
NAMELIST /physics/ co2tf
NAMELIST /physics/ ra_call_offset
NAMELIST /physics/ cam_abs_freq_s
NAMELIST /physics/ levsiz
NAMELIST /physics/ paerlev
NAMELIST /physics/ cam_abs_dim1
NAMELIST /physics/ cam_abs_dim2
NAMELIST /physics/ lagday
NAMELIST /physics/ no_src_types
NAMELIST /physics/ alevsiz
NAMELIST /physics/ o3input
NAMELIST /physics/ aer_opt
NAMELIST /physics/ swint_opt
NAMELIST /physics/ aer_type
NAMELIST /physics/ aer_aod550_opt
NAMELIST /physics/ aer_angexp_opt
NAMELIST /physics/ aer_ssa_opt
NAMELIST /physics/ aer_asy_opt
NAMELIST /physics/ aer_aod550_val
NAMELIST /physics/ aer_angexp_val
NAMELIST /physics/ aer_ssa_val
NAMELIST /physics/ aer_asy_val
NAMELIST /physics/ cu_rad_feedback
NAMELIST /physics/ dust_emis
NAMELIST /physics/ erosion_dim
NAMELIST /physics/ no_src_types_cu
NAMELIST /physics/ alevsiz_cu
NAMELIST /physics/ aercu_opt
NAMELIST /physics/ aercu_fct
NAMELIST /physics/ shallowcu_forced_ra
NAMELIST /physics/ numbins
NAMELIST /physics/ thbinsize
NAMELIST /physics/ rbinsize
NAMELIST /physics/ mindeepfreq
NAMELIST /physics/ minshallowfreq
NAMELIST /physics/ shcu_aerosols_opt
NAMELIST /physics/ pxlsm_smois_init
NAMELIST /physics/ pxlsm_modis_veg
NAMELIST /physics/ omlcall
NAMELIST /physics/ sf_ocean_physics
NAMELIST /physics/ traj_opt
NAMELIST /physics/ dm_has_traj
NAMELIST /physics/ tracercall
NAMELIST /physics/ omdt
NAMELIST /physics/ oml_hml0
NAMELIST /physics/ oml_gamma
NAMELIST /physics/ oml_relaxation_time
NAMELIST /physics/ isftcflx
NAMELIST /physics/ iz0tlnd
NAMELIST /physics/ shadlen
NAMELIST /physics/ slope_rad
NAMELIST /physics/ topo_shading
NAMELIST /physics/ topo_wind
NAMELIST /physics/ no_mp_heating
NAMELIST /physics/ fractional_seaice
NAMELIST /physics/ seaice_snowdepth_opt
NAMELIST /physics/ seaice_snowdepth_max
NAMELIST /physics/ seaice_snowdepth_min
NAMELIST /physics/ seaice_albedo_opt
NAMELIST /physics/ seaice_albedo_default
NAMELIST /physics/ seaice_thickness_opt
NAMELIST /physics/ seaice_thickness_default
NAMELIST /physics/ tice2tsk_if2cold
NAMELIST /physics/ bucket_mm
NAMELIST /physics/ bucket_j
NAMELIST /physics/ mp_tend_lim
NAMELIST /physics/ prec_acc_dt
NAMELIST /physics/ grav_settling
NAMELIST /physics/ sas_pgcon
NAMELIST /physics/ scalar_pblmix
NAMELIST /physics/ tracer_pblmix
NAMELIST /physics/ use_aero_icbc
NAMELIST /physics/ use_rap_aero_icbc
NAMELIST /physics/ use_mp_re
NAMELIST /physics/ ccn_conc
NAMELIST /physics/ hail_opt
NAMELIST /physics/ morr_rimed_ice
NAMELIST /physics/ clean_atm_diag
NAMELIST /noah_mp/ dveg
NAMELIST /noah_mp/ opt_crs
NAMELIST /noah_mp/ opt_btr
NAMELIST /noah_mp/ opt_run
NAMELIST /noah_mp/ opt_sfc
NAMELIST /noah_mp/ opt_frz
NAMELIST /noah_mp/ opt_inf
NAMELIST /noah_mp/ opt_rad
NAMELIST /noah_mp/ opt_alb
NAMELIST /noah_mp/ opt_snf
NAMELIST /noah_mp/ opt_tbot
NAMELIST /noah_mp/ opt_stc
NAMELIST /noah_mp/ opt_gla
NAMELIST /noah_mp/ opt_rsf
NAMELIST /noah_mp/ opt_soil
NAMELIST /noah_mp/ opt_pedo
NAMELIST /noah_mp/ opt_crop
NAMELIST /physics/ wtddt
NAMELIST /fdda/ fgdt
NAMELIST /fdda/ fgdtzero
NAMELIST /fdda/ grid_fdda
NAMELIST /fdda/ grid_sfdda
NAMELIST /fdda/ if_no_pbl_nudging_uv
NAMELIST /fdda/ if_no_pbl_nudging_t
NAMELIST /fdda/ if_no_pbl_nudging_ph
NAMELIST /fdda/ if_no_pbl_nudging_q
NAMELIST /fdda/ if_zfac_uv
NAMELIST /fdda/ k_zfac_uv
NAMELIST /fdda/ if_zfac_t
NAMELIST /fdda/ k_zfac_t
NAMELIST /fdda/ if_zfac_ph
NAMELIST /fdda/ k_zfac_ph
NAMELIST /fdda/ if_zfac_q
NAMELIST /fdda/ k_zfac_q
NAMELIST /fdda/ dk_zfac_uv
NAMELIST /fdda/ dk_zfac_t
NAMELIST /fdda/ dk_zfac_ph
NAMELIST /fdda/ dk_zfac_q
NAMELIST /fdda/ ktrop
NAMELIST /fdda/ guv
NAMELIST /fdda/ guv_sfc
NAMELIST /fdda/ gt
NAMELIST /fdda/ gt_sfc
NAMELIST /fdda/ gq
NAMELIST /fdda/ gq_sfc
NAMELIST /fdda/ gph
NAMELIST /fdda/ dtramp_min
NAMELIST /fdda/ if_ramping
NAMELIST /fdda/ rinblw
NAMELIST /fdda/ xwavenum
NAMELIST /fdda/ ywavenum
NAMELIST /fdda/ pxlsm_soil_nudge
NAMELIST /fdda/ obs_nudge_opt
NAMELIST /fdda/ max_obs
NAMELIST /fdda/ fdda_start
NAMELIST /fdda/ fdda_end
NAMELIST /fdda/ obs_nudge_wind
NAMELIST /fdda/ obs_coef_wind
NAMELIST /fdda/ obs_nudge_temp
NAMELIST /fdda/ obs_coef_temp
NAMELIST /fdda/ obs_nudge_mois
NAMELIST /fdda/ obs_coef_mois
NAMELIST /fdda/ obs_nudge_pstr
NAMELIST /fdda/ obs_coef_pstr
NAMELIST /fdda/ obs_no_pbl_nudge_uv
NAMELIST /fdda/ obs_no_pbl_nudge_t
NAMELIST /fdda/ obs_no_pbl_nudge_q
NAMELIST /fdda/ obs_sfc_scheme_horiz
NAMELIST /fdda/ obs_sfc_scheme_vert
NAMELIST /fdda/ obs_max_sndng_gap
NAMELIST /fdda/ obs_nudgezfullr1_uv
NAMELIST /fdda/ obs_nudgezrampr1_uv
NAMELIST /fdda/ obs_nudgezfullr2_uv
NAMELIST /fdda/ obs_nudgezrampr2_uv
NAMELIST /fdda/ obs_nudgezfullr4_uv
NAMELIST /fdda/ obs_nudgezrampr4_uv
NAMELIST /fdda/ obs_nudgezfullr1_t
NAMELIST /fdda/ obs_nudgezrampr1_t
NAMELIST /fdda/ obs_nudgezfullr2_t
NAMELIST /fdda/ obs_nudgezrampr2_t
NAMELIST /fdda/ obs_nudgezfullr4_t
NAMELIST /fdda/ obs_nudgezrampr4_t
NAMELIST /fdda/ obs_nudgezfullr1_q
NAMELIST /fdda/ obs_nudgezrampr1_q
NAMELIST /fdda/ obs_nudgezfullr2_q
NAMELIST /fdda/ obs_nudgezrampr2_q
NAMELIST /fdda/ obs_nudgezfullr4_q
NAMELIST /fdda/ obs_nudgezrampr4_q
NAMELIST /fdda/ obs_nudgezfullmin
NAMELIST /fdda/ obs_nudgezrampmin
NAMELIST /fdda/ obs_nudgezmax
NAMELIST /fdda/ obs_sfcfact
NAMELIST /fdda/ obs_sfcfacr
NAMELIST /fdda/ obs_dpsmx
NAMELIST /fdda/ obs_rinxy
NAMELIST /fdda/ obs_rinsig
NAMELIST /fdda/ obs_twindo
NAMELIST /fdda/ obs_npfi
NAMELIST /fdda/ obs_ionf
NAMELIST /fdda/ obs_idynin
NAMELIST /fdda/ obs_dtramp
NAMELIST /fdda/ obs_prt_max
NAMELIST /fdda/ obs_prt_freq
NAMELIST /fdda/ obs_ipf_in4dob
NAMELIST /fdda/ obs_ipf_errob
NAMELIST /fdda/ obs_ipf_nudob
NAMELIST /fdda/ obs_ipf_init
NAMELIST /fdda/ obs_scl_neg_qv_innov
NAMELIST /scm/ scm_force
NAMELIST /scm/ scm_force_dx
NAMELIST /scm/ num_force_layers
NAMELIST /scm/ scm_lu_index
NAMELIST /scm/ scm_isltyp
NAMELIST /scm/ scm_vegfra
NAMELIST /scm/ scm_canwat
NAMELIST /scm/ scm_lat
NAMELIST /scm/ scm_lon
NAMELIST /scm/ scm_th_t_tend
NAMELIST /scm/ scm_qv_t_tend
NAMELIST /scm/ scm_th_adv
NAMELIST /scm/ scm_wind_adv
NAMELIST /scm/ scm_qv_adv
NAMELIST /scm/ scm_ql_adv
NAMELIST /scm/ scm_vert_adv
NAMELIST /scm/ num_force_soil_layers
NAMELIST /scm/ scm_soilt_force
NAMELIST /scm/ scm_soilq_force
NAMELIST /scm/ scm_force_th_largescale
NAMELIST /scm/ scm_force_qv_largescale
NAMELIST /scm/ scm_force_ql_largescale
NAMELIST /scm/ scm_force_wind_largescale
NAMELIST /scm/ scm_force_skintemp
NAMELIST /scm/ scm_force_flux
NAMELIST /dynamics/ dyn_opt
NAMELIST /dynamics/ rk_ord
NAMELIST /dynamics/ w_damping
NAMELIST /dynamics/ diff_opt
NAMELIST /dynamics/ diff_opt_dfi
NAMELIST /dynamics/ km_opt
NAMELIST /dynamics/ km_opt_dfi
NAMELIST /dynamics/ damp_opt
NAMELIST /dynamics/ rad_nudge
NAMELIST /dynamics/ gwd_opt
NAMELIST /dynamics/ max_rot_angle_gwd
NAMELIST /dynamics/ zdamp
NAMELIST /dynamics/ dampcoef
NAMELIST /dynamics/ khdif
NAMELIST /dynamics/ kvdif
NAMELIST /dynamics/ diff_6th_factor
NAMELIST /dynamics/ diff_6th_opt
NAMELIST /dynamics/ diff_6th_slopeopt
NAMELIST /dynamics/ diff_6th_thresh
NAMELIST /dynamics/ use_theta_m
NAMELIST /dynamics/ use_q_diabatic
NAMELIST /dynamics/ c_s
NAMELIST /dynamics/ c_k
NAMELIST /dynamics/ smdiv
NAMELIST /dynamics/ emdiv
NAMELIST /dynamics/ epssm
NAMELIST /dynamics/ non_hydrostatic
NAMELIST /dynamics/ use_input_w
NAMELIST /dynamics/ time_step_sound
NAMELIST /dynamics/ h_mom_adv_order
NAMELIST /dynamics/ v_mom_adv_order
NAMELIST /dynamics/ h_sca_adv_order
NAMELIST /dynamics/ v_sca_adv_order
NAMELIST /dynamics/ momentum_adv_opt
NAMELIST /dynamics/ moist_adv_opt
NAMELIST /dynamics/ moist_adv_dfi_opt
NAMELIST /dynamics/ chem_adv_opt
NAMELIST /dynamics/ tracer_adv_opt
NAMELIST /dynamics/ scalar_adv_opt
NAMELIST /dynamics/ tke_adv_opt
NAMELIST /dynamics/ moist_mix2_off
NAMELIST /dynamics/ chem_mix2_off
NAMELIST /dynamics/ tracer_mix2_off
NAMELIST /dynamics/ scalar_mix2_off
NAMELIST /dynamics/ tke_mix2_off
NAMELIST /dynamics/ moist_mix6_off
NAMELIST /dynamics/ chem_mix6_off
NAMELIST /dynamics/ tracer_mix6_off
NAMELIST /dynamics/ scalar_mix6_off
NAMELIST /dynamics/ tke_mix6_off
NAMELIST /dynamics/ top_radiation
NAMELIST /dynamics/ mix_isotropic
NAMELIST /dynamics/ mix_upper_bound
NAMELIST /dynamics/ top_lid
NAMELIST /dynamics/ tke_upper_bound
NAMELIST /dynamics/ tke_drag_coefficient
NAMELIST /dynamics/ tke_heat_flux
NAMELIST /dynamics/ pert_coriolis
NAMELIST /dynamics/ coriolis2d
NAMELIST /dynamics/ mix_full_fields
NAMELIST /dynamics/ base_pres
NAMELIST /dynamics/ base_temp
NAMELIST /dynamics/ base_lapse
NAMELIST /dynamics/ iso_temp
NAMELIST /dynamics/ base_pres_strat
NAMELIST /dynamics/ base_lapse_strat
NAMELIST /dynamics/ use_baseparam_fr_nml
NAMELIST /dynamics/ fft_filter_lat
NAMELIST /dynamics/ coupled_filtering
NAMELIST /dynamics/ pos_def
NAMELIST /dynamics/ swap_pole_with_next_j
NAMELIST /dynamics/ actual_distance_average
NAMELIST /dynamics/ rotated_pole
NAMELIST /dynamics/ do_coriolis
NAMELIST /dynamics/ do_curvature
NAMELIST /dynamics/ do_gradp
NAMELIST /dynamics/ tracer_opt
NAMELIST /dynamics/ tenddiag
NAMELIST /bdy_control/ spec_bdy_width
NAMELIST /bdy_control/ spec_zone
NAMELIST /bdy_control/ relax_zone
NAMELIST /bdy_control/ specified
NAMELIST /bdy_control/ constant_bc
NAMELIST /bdy_control/ periodic_x
NAMELIST /bdy_control/ symmetric_xs
NAMELIST /bdy_control/ symmetric_xe
NAMELIST /bdy_control/ open_xs
NAMELIST /bdy_control/ open_xe
NAMELIST /bdy_control/ periodic_y
NAMELIST /bdy_control/ symmetric_ys
NAMELIST /bdy_control/ symmetric_ye
NAMELIST /bdy_control/ open_ys
NAMELIST /bdy_control/ open_ye
NAMELIST /bdy_control/ polar
NAMELIST /bdy_control/ nested
NAMELIST /bdy_control/ spec_exp
NAMELIST /bdy_control/ spec_bdy_final_mu
NAMELIST /bdy_control/ real_data_init_type
NAMELIST /bdy_control/ have_bcs_moist
NAMELIST /bdy_control/ have_bcs_scalar
NAMELIST /grib2/ background_proc_id
NAMELIST /grib2/ forecast_proc_id
NAMELIST /grib2/ production_status
NAMELIST /grib2/ compression
NAMELIST /physics/ windfarm_opt
NAMELIST /physics/ windfarm_ij
NAMELIST /ideal/ ideal_case
NAMELIST /physics/ hailcast_opt
NAMELIST /physics/ haildt
NAMELIST /physics/ lightning_option
NAMELIST /physics/ lightning_dt
NAMELIST /physics/ lightning_start_seconds
NAMELIST /physics/ flashrate_factor
NAMELIST /physics/ iccg_method
NAMELIST /physics/ iccg_prescribed_num
NAMELIST /physics/ iccg_prescribed_den
NAMELIST /physics/ cellcount_method
NAMELIST /physics/ cldtop_adjustment
NAMELIST /physics/ sf_lake_physics
NAMELIST /time_control/ auxinput1_inname
NAMELIST /time_control/ io_form_auxinput1
NAMELIST /time_control/ override_restart_timers
NAMELIST /time_control/ auxhist1_inname
NAMELIST /time_control/ auxhist1_outname
NAMELIST /time_control/ auxhist1_interval_y
NAMELIST /time_control/ auxhist1_interval_d
NAMELIST /time_control/ auxhist1_interval_h
NAMELIST /time_control/ auxhist1_interval_m
NAMELIST /time_control/ auxhist1_interval_s
NAMELIST /time_control/ auxhist1_interval
NAMELIST /time_control/ auxhist1_begin_y
NAMELIST /time_control/ auxhist1_begin_d
NAMELIST /time_control/ auxhist1_begin_h
NAMELIST /time_control/ auxhist1_begin_m
NAMELIST /time_control/ auxhist1_begin_s
NAMELIST /time_control/ auxhist1_begin
NAMELIST /time_control/ auxhist1_end_y
NAMELIST /time_control/ auxhist1_end_d
NAMELIST /time_control/ auxhist1_end_h
NAMELIST /time_control/ auxhist1_end_m
NAMELIST /time_control/ auxhist1_end_s
NAMELIST /time_control/ auxhist1_end
NAMELIST /time_control/ io_form_auxhist1
NAMELIST /time_control/ frames_per_auxhist1
NAMELIST /time_control/ auxhist2_inname
NAMELIST /time_control/ auxhist2_outname
NAMELIST /time_control/ auxhist2_interval_y
NAMELIST /time_control/ auxhist2_interval_d
NAMELIST /time_control/ auxhist2_interval_h
NAMELIST /time_control/ auxhist2_interval_m
NAMELIST /time_control/ auxhist2_interval_s
NAMELIST /time_control/ auxhist2_interval
NAMELIST /time_control/ auxhist2_begin_y
NAMELIST /time_control/ auxhist2_begin_d
NAMELIST /time_control/ auxhist2_begin_h
NAMELIST /time_control/ auxhist2_begin_m
NAMELIST /time_control/ auxhist2_begin_s
NAMELIST /time_control/ auxhist2_begin
NAMELIST /time_control/ auxhist2_end_y
NAMELIST /time_control/ auxhist2_end_d
NAMELIST /time_control/ auxhist2_end_h
NAMELIST /time_control/ auxhist2_end_m
NAMELIST /time_control/ auxhist2_end_s
NAMELIST /time_control/ auxhist2_end
NAMELIST /time_control/ io_form_auxhist2
NAMELIST /time_control/ frames_per_auxhist2
NAMELIST /time_control/ auxhist3_inname
NAMELIST /time_control/ auxhist3_outname
NAMELIST /time_control/ auxhist3_interval_y
NAMELIST /time_control/ auxhist3_interval_d
NAMELIST /time_control/ auxhist3_interval_h
NAMELIST /time_control/ auxhist3_interval_m
NAMELIST /time_control/ auxhist3_interval_s
NAMELIST /time_control/ auxhist3_interval
NAMELIST /time_control/ auxhist3_begin_y
NAMELIST /time_control/ auxhist3_begin_d
NAMELIST /time_control/ auxhist3_begin_h
NAMELIST /time_control/ auxhist3_begin_m
NAMELIST /time_control/ auxhist3_begin_s
NAMELIST /time_control/ auxhist3_begin
NAMELIST /time_control/ auxhist3_end_y
NAMELIST /time_control/ auxhist3_end_d
NAMELIST /time_control/ auxhist3_end_h
NAMELIST /time_control/ auxhist3_end_m
NAMELIST /time_control/ auxhist3_end_s
NAMELIST /time_control/ auxhist3_end
NAMELIST /time_control/ io_form_auxhist3
NAMELIST /time_control/ frames_per_auxhist3
NAMELIST /time_control/ auxhist4_inname
NAMELIST /time_control/ auxhist4_outname
NAMELIST /time_control/ auxhist4_interval_y
NAMELIST /time_control/ auxhist4_interval_d
NAMELIST /time_control/ auxhist4_interval_h
NAMELIST /time_control/ auxhist4_interval_m
NAMELIST /time_control/ auxhist4_interval_s
NAMELIST /time_control/ auxhist4_interval
NAMELIST /time_control/ auxhist4_begin_y
NAMELIST /time_control/ auxhist4_begin_d
NAMELIST /time_control/ auxhist4_begin_h
NAMELIST /time_control/ auxhist4_begin_m
NAMELIST /time_control/ auxhist4_begin_s
NAMELIST /time_control/ auxhist4_begin
NAMELIST /time_control/ auxhist4_end_y
NAMELIST /time_control/ auxhist4_end_d
NAMELIST /time_control/ auxhist4_end_h
NAMELIST /time_control/ auxhist4_end_m
NAMELIST /time_control/ auxhist4_end_s
NAMELIST /time_control/ auxhist4_end
NAMELIST /time_control/ io_form_auxhist4
NAMELIST /time_control/ frames_per_auxhist4
NAMELIST /time_control/ auxhist5_inname
NAMELIST /time_control/ auxhist5_outname
NAMELIST /time_control/ auxhist5_interval_y
NAMELIST /time_control/ auxhist5_interval_d
NAMELIST /time_control/ auxhist5_interval_h
NAMELIST /time_control/ auxhist5_interval_m
NAMELIST /time_control/ auxhist5_interval_s
NAMELIST /time_control/ auxhist5_interval
NAMELIST /time_control/ auxhist5_begin_y
NAMELIST /time_control/ auxhist5_begin_d
NAMELIST /time_control/ auxhist5_begin_h
NAMELIST /time_control/ auxhist5_begin_m
NAMELIST /time_control/ auxhist5_begin_s
NAMELIST /time_control/ auxhist5_begin
NAMELIST /time_control/ auxhist5_end_y
NAMELIST /time_control/ auxhist5_end_d
NAMELIST /time_control/ auxhist5_end_h
NAMELIST /time_control/ auxhist5_end_m
NAMELIST /time_control/ auxhist5_end_s
NAMELIST /time_control/ auxhist5_end
NAMELIST /time_control/ io_form_auxhist5
NAMELIST /time_control/ frames_per_auxhist5
NAMELIST /time_control/ auxhist6_inname
NAMELIST /time_control/ auxhist6_outname
NAMELIST /time_control/ auxhist6_interval_y
NAMELIST /time_control/ auxhist6_interval_d
NAMELIST /time_control/ auxhist6_interval_h
NAMELIST /time_control/ auxhist6_interval_m
NAMELIST /time_control/ auxhist6_interval_s
NAMELIST /time_control/ auxhist6_interval
NAMELIST /time_control/ auxhist6_begin_y
NAMELIST /time_control/ auxhist6_begin_d
NAMELIST /time_control/ auxhist6_begin_h
NAMELIST /time_control/ auxhist6_begin_m
NAMELIST /time_control/ auxhist6_begin_s
NAMELIST /time_control/ auxhist6_begin
NAMELIST /time_control/ auxhist6_end_y
NAMELIST /time_control/ auxhist6_end_d
NAMELIST /time_control/ auxhist6_end_h
NAMELIST /time_control/ auxhist6_end_m
NAMELIST /time_control/ auxhist6_end_s
NAMELIST /time_control/ auxhist6_end
NAMELIST /time_control/ io_form_auxhist6
NAMELIST /time_control/ frames_per_auxhist6
NAMELIST /time_control/ auxhist7_inname
NAMELIST /time_control/ auxhist7_outname
NAMELIST /time_control/ auxhist7_interval_y
NAMELIST /time_control/ auxhist7_interval_d
NAMELIST /time_control/ auxhist7_interval_h
NAMELIST /time_control/ auxhist7_interval_m
NAMELIST /time_control/ auxhist7_interval_s
NAMELIST /time_control/ auxhist7_interval
NAMELIST /time_control/ auxhist7_begin_y
NAMELIST /time_control/ auxhist7_begin_d
NAMELIST /time_control/ auxhist7_begin_h
NAMELIST /time_control/ auxhist7_begin_m
NAMELIST /time_control/ auxhist7_begin_s
NAMELIST /time_control/ auxhist7_begin
NAMELIST /time_control/ auxhist7_end_y
NAMELIST /time_control/ auxhist7_end_d
NAMELIST /time_control/ auxhist7_end_h
NAMELIST /time_control/ auxhist7_end_m
NAMELIST /time_control/ auxhist7_end_s
NAMELIST /time_control/ auxhist7_end
NAMELIST /time_control/ io_form_auxhist7
NAMELIST /time_control/ frames_per_auxhist7
NAMELIST /time_control/ auxhist8_inname
NAMELIST /time_control/ auxhist8_outname
NAMELIST /time_control/ auxhist8_interval_y
NAMELIST /time_control/ auxhist8_interval_d
NAMELIST /time_control/ auxhist8_interval_h
NAMELIST /time_control/ auxhist8_interval_m
NAMELIST /time_control/ auxhist8_interval_s
NAMELIST /time_control/ auxhist8_interval
NAMELIST /time_control/ auxhist8_begin_y
NAMELIST /time_control/ auxhist8_begin_d
NAMELIST /time_control/ auxhist8_begin_h
NAMELIST /time_control/ auxhist8_begin_m
NAMELIST /time_control/ auxhist8_begin_s
NAMELIST /time_control/ auxhist8_begin
NAMELIST /time_control/ auxhist8_end_y
NAMELIST /time_control/ auxhist8_end_d
NAMELIST /time_control/ auxhist8_end_h
NAMELIST /time_control/ auxhist8_end_m
NAMELIST /time_control/ auxhist8_end_s
NAMELIST /time_control/ auxhist8_end
NAMELIST /time_control/ io_form_auxhist8
NAMELIST /time_control/ frames_per_auxhist8
NAMELIST /time_control/ auxhist9_inname
NAMELIST /time_control/ auxhist9_outname
NAMELIST /time_control/ auxhist9_interval_y
NAMELIST /time_control/ auxhist9_interval_d
NAMELIST /time_control/ auxhist9_interval_h
NAMELIST /time_control/ auxhist9_interval_m
NAMELIST /time_control/ auxhist9_interval_s
NAMELIST /time_control/ auxhist9_interval
NAMELIST /time_control/ auxhist9_begin_y
NAMELIST /time_control/ auxhist9_begin_d
NAMELIST /time_control/ auxhist9_begin_h
NAMELIST /time_control/ auxhist9_begin_m
NAMELIST /time_control/ auxhist9_begin_s
NAMELIST /time_control/ auxhist9_begin
NAMELIST /time_control/ auxhist9_end_y
NAMELIST /time_control/ auxhist9_end_d
NAMELIST /time_control/ auxhist9_end_h
NAMELIST /time_control/ auxhist9_end_m
NAMELIST /time_control/ auxhist9_end_s
NAMELIST /time_control/ auxhist9_end
NAMELIST /time_control/ io_form_auxhist9
NAMELIST /time_control/ frames_per_auxhist9
NAMELIST /time_control/ auxhist10_inname
NAMELIST /time_control/ auxhist10_outname
NAMELIST /time_control/ auxhist10_interval_y
NAMELIST /time_control/ auxhist10_interval_d
NAMELIST /time_control/ auxhist10_interval_h
NAMELIST /time_control/ auxhist10_interval_m
NAMELIST /time_control/ auxhist10_interval_s
NAMELIST /time_control/ auxhist10_interval
NAMELIST /time_control/ auxhist10_begin_y
NAMELIST /time_control/ auxhist10_begin_d
NAMELIST /time_control/ auxhist10_begin_h
NAMELIST /time_control/ auxhist10_begin_m
NAMELIST /time_control/ auxhist10_begin_s
NAMELIST /time_control/ auxhist10_begin
NAMELIST /time_control/ auxhist10_end_y
NAMELIST /time_control/ auxhist10_end_d
NAMELIST /time_control/ auxhist10_end_h
NAMELIST /time_control/ auxhist10_end_m
NAMELIST /time_control/ auxhist10_end_s
NAMELIST /time_control/ auxhist10_end
NAMELIST /time_control/ io_form_auxhist10
NAMELIST /time_control/ frames_per_auxhist10
NAMELIST /time_control/ auxhist11_inname
NAMELIST /time_control/ auxhist11_outname
NAMELIST /time_control/ auxhist11_interval_y
NAMELIST /time_control/ auxhist11_interval_d
NAMELIST /time_control/ auxhist11_interval_h
NAMELIST /time_control/ auxhist11_interval_m
NAMELIST /time_control/ auxhist11_interval_s
NAMELIST /time_control/ auxhist11_interval
NAMELIST /time_control/ auxhist11_begin_y
NAMELIST /time_control/ auxhist11_begin_d
NAMELIST /time_control/ auxhist11_begin_h
NAMELIST /time_control/ auxhist11_begin_m
NAMELIST /time_control/ auxhist11_begin_s
NAMELIST /time_control/ auxhist11_begin
NAMELIST /time_control/ auxhist11_end_y
NAMELIST /time_control/ auxhist11_end_d
NAMELIST /time_control/ auxhist11_end_h
NAMELIST /time_control/ auxhist11_end_m
NAMELIST /time_control/ auxhist11_end_s
NAMELIST /time_control/ auxhist11_end
NAMELIST /time_control/ io_form_auxhist11
NAMELIST /time_control/ frames_per_auxhist11
NAMELIST /time_control/ auxhist12_inname
NAMELIST /time_control/ auxhist12_outname
NAMELIST /time_control/ auxhist12_interval_y
NAMELIST /time_control/ auxhist12_interval_d
NAMELIST /time_control/ auxhist12_interval_h
NAMELIST /time_control/ auxhist12_interval_m
NAMELIST /time_control/ auxhist12_interval_s
NAMELIST /time_control/ auxhist12_interval
NAMELIST /time_control/ auxhist12_begin_y
NAMELIST /time_control/ auxhist12_begin_d
NAMELIST /time_control/ auxhist12_begin_h
NAMELIST /time_control/ auxhist12_begin_m
NAMELIST /time_control/ auxhist12_begin_s
NAMELIST /time_control/ auxhist12_begin
NAMELIST /time_control/ auxhist12_end_y
NAMELIST /time_control/ auxhist12_end_d
NAMELIST /time_control/ auxhist12_end_h
NAMELIST /time_control/ auxhist12_end_m
NAMELIST /time_control/ auxhist12_end_s
NAMELIST /time_control/ auxhist12_end
NAMELIST /time_control/ io_form_auxhist12
NAMELIST /time_control/ frames_per_auxhist12
NAMELIST /time_control/ auxhist13_inname
NAMELIST /time_control/ auxhist13_outname
NAMELIST /time_control/ auxhist13_interval_y
NAMELIST /time_control/ auxhist13_interval_d
NAMELIST /time_control/ auxhist13_interval_h
NAMELIST /time_control/ auxhist13_interval_m
NAMELIST /time_control/ auxhist13_interval_s
NAMELIST /time_control/ auxhist13_interval
NAMELIST /time_control/ auxhist13_begin_y
NAMELIST /time_control/ auxhist13_begin_d
NAMELIST /time_control/ auxhist13_begin_h
NAMELIST /time_control/ auxhist13_begin_m
NAMELIST /time_control/ auxhist13_begin_s
NAMELIST /time_control/ auxhist13_begin
NAMELIST /time_control/ auxhist13_end_y
NAMELIST /time_control/ auxhist13_end_d
NAMELIST /time_control/ auxhist13_end_h
NAMELIST /time_control/ auxhist13_end_m
NAMELIST /time_control/ auxhist13_end_s
NAMELIST /time_control/ auxhist13_end
NAMELIST /time_control/ io_form_auxhist13
NAMELIST /time_control/ frames_per_auxhist13
NAMELIST /time_control/ auxhist14_inname
NAMELIST /time_control/ auxhist14_outname
NAMELIST /time_control/ auxhist14_interval_y
NAMELIST /time_control/ auxhist14_interval_d
NAMELIST /time_control/ auxhist14_interval_h
NAMELIST /time_control/ auxhist14_interval_m
NAMELIST /time_control/ auxhist14_interval_s
NAMELIST /time_control/ auxhist14_interval
NAMELIST /time_control/ auxhist14_begin_y
NAMELIST /time_control/ auxhist14_begin_d
NAMELIST /time_control/ auxhist14_begin_h
NAMELIST /time_control/ auxhist14_begin_m
NAMELIST /time_control/ auxhist14_begin_s
NAMELIST /time_control/ auxhist14_begin
NAMELIST /time_control/ auxhist14_end_y
NAMELIST /time_control/ auxhist14_end_d
NAMELIST /time_control/ auxhist14_end_h
NAMELIST /time_control/ auxhist14_end_m
NAMELIST /time_control/ auxhist14_end_s
NAMELIST /time_control/ auxhist14_end
NAMELIST /time_control/ io_form_auxhist14
NAMELIST /time_control/ frames_per_auxhist14
NAMELIST /time_control/ auxhist15_inname
NAMELIST /time_control/ auxhist15_outname
NAMELIST /time_control/ auxhist15_interval_y
NAMELIST /time_control/ auxhist15_interval_d
NAMELIST /time_control/ auxhist15_interval_h
NAMELIST /time_control/ auxhist15_interval_m
NAMELIST /time_control/ auxhist15_interval_s
NAMELIST /time_control/ auxhist15_interval
NAMELIST /time_control/ auxhist15_begin_y
NAMELIST /time_control/ auxhist15_begin_d
NAMELIST /time_control/ auxhist15_begin_h
NAMELIST /time_control/ auxhist15_begin_m
NAMELIST /time_control/ auxhist15_begin_s
NAMELIST /time_control/ auxhist15_begin
NAMELIST /time_control/ auxhist15_end_y
NAMELIST /time_control/ auxhist15_end_d
NAMELIST /time_control/ auxhist15_end_h
NAMELIST /time_control/ auxhist15_end_m
NAMELIST /time_control/ auxhist15_end_s
NAMELIST /time_control/ auxhist15_end
NAMELIST /time_control/ io_form_auxhist15
NAMELIST /time_control/ frames_per_auxhist15
NAMELIST /time_control/ auxhist16_inname
NAMELIST /time_control/ auxhist16_outname
NAMELIST /time_control/ auxhist16_interval_y
NAMELIST /time_control/ auxhist16_interval_d
NAMELIST /time_control/ auxhist16_interval_h
NAMELIST /time_control/ auxhist16_interval_m
NAMELIST /time_control/ auxhist16_interval_s
NAMELIST /time_control/ auxhist16_interval
NAMELIST /time_control/ auxhist16_begin_y
NAMELIST /time_control/ auxhist16_begin_d
NAMELIST /time_control/ auxhist16_begin_h
NAMELIST /time_control/ auxhist16_begin_m
NAMELIST /time_control/ auxhist16_begin_s
NAMELIST /time_control/ auxhist16_begin
NAMELIST /time_control/ auxhist16_end_y
NAMELIST /time_control/ auxhist16_end_d
NAMELIST /time_control/ auxhist16_end_h
NAMELIST /time_control/ auxhist16_end_m
NAMELIST /time_control/ auxhist16_end_s
NAMELIST /time_control/ auxhist16_end
NAMELIST /time_control/ io_form_auxhist16
NAMELIST /time_control/ frames_per_auxhist16
NAMELIST /time_control/ auxhist17_inname
NAMELIST /time_control/ auxhist17_outname
NAMELIST /time_control/ auxhist17_interval_y
NAMELIST /time_control/ auxhist17_interval_d
NAMELIST /time_control/ auxhist17_interval_h
NAMELIST /time_control/ auxhist17_interval_m
NAMELIST /time_control/ auxhist17_interval_s
NAMELIST /time_control/ auxhist17_interval
NAMELIST /time_control/ auxhist17_begin_y
NAMELIST /time_control/ auxhist17_begin_d
NAMELIST /time_control/ auxhist17_begin_h
NAMELIST /time_control/ auxhist17_begin_m
NAMELIST /time_control/ auxhist17_begin_s
NAMELIST /time_control/ auxhist17_begin
NAMELIST /time_control/ auxhist17_end_y
NAMELIST /time_control/ auxhist17_end_d
NAMELIST /time_control/ auxhist17_end_h
NAMELIST /time_control/ auxhist17_end_m
NAMELIST /time_control/ auxhist17_end_s
NAMELIST /time_control/ auxhist17_end
NAMELIST /time_control/ io_form_auxhist17
NAMELIST /time_control/ frames_per_auxhist17
NAMELIST /time_control/ auxhist18_inname
NAMELIST /time_control/ auxhist18_outname
NAMELIST /time_control/ auxhist18_interval_y
NAMELIST /time_control/ auxhist18_interval_d
NAMELIST /time_control/ auxhist18_interval_h
NAMELIST /time_control/ auxhist18_interval_m
NAMELIST /time_control/ auxhist18_interval_s
NAMELIST /time_control/ auxhist18_interval
NAMELIST /time_control/ auxhist18_begin_y
NAMELIST /time_control/ auxhist18_begin_d
NAMELIST /time_control/ auxhist18_begin_h
NAMELIST /time_control/ auxhist18_begin_m
NAMELIST /time_control/ auxhist18_begin_s
NAMELIST /time_control/ auxhist18_begin
NAMELIST /time_control/ auxhist18_end_y
NAMELIST /time_control/ auxhist18_end_d
NAMELIST /time_control/ auxhist18_end_h
NAMELIST /time_control/ auxhist18_end_m
NAMELIST /time_control/ auxhist18_end_s
NAMELIST /time_control/ auxhist18_end
NAMELIST /time_control/ io_form_auxhist18
NAMELIST /time_control/ frames_per_auxhist18
NAMELIST /time_control/ auxhist19_inname
NAMELIST /time_control/ auxhist19_outname
NAMELIST /time_control/ auxhist19_interval_y
NAMELIST /time_control/ auxhist19_interval_d
NAMELIST /time_control/ auxhist19_interval_h
NAMELIST /time_control/ auxhist19_interval_m
NAMELIST /time_control/ auxhist19_interval_s
NAMELIST /time_control/ auxhist19_interval
NAMELIST /time_control/ auxhist19_begin_y
NAMELIST /time_control/ auxhist19_begin_d
NAMELIST /time_control/ auxhist19_begin_h
NAMELIST /time_control/ auxhist19_begin_m
NAMELIST /time_control/ auxhist19_begin_s
NAMELIST /time_control/ auxhist19_begin
NAMELIST /time_control/ auxhist19_end_y
NAMELIST /time_control/ auxhist19_end_d
NAMELIST /time_control/ auxhist19_end_h
NAMELIST /time_control/ auxhist19_end_m
NAMELIST /time_control/ auxhist19_end_s
NAMELIST /time_control/ auxhist19_end
NAMELIST /time_control/ io_form_auxhist19
NAMELIST /time_control/ frames_per_auxhist19
NAMELIST /time_control/ auxhist20_inname
NAMELIST /time_control/ auxhist20_outname
NAMELIST /time_control/ auxhist20_interval_y
NAMELIST /time_control/ auxhist20_interval_d
NAMELIST /time_control/ auxhist20_interval_h
NAMELIST /time_control/ auxhist20_interval_m
NAMELIST /time_control/ auxhist20_interval_s
NAMELIST /time_control/ auxhist20_interval
NAMELIST /time_control/ auxhist20_begin_y
NAMELIST /time_control/ auxhist20_begin_d
NAMELIST /time_control/ auxhist20_begin_h
NAMELIST /time_control/ auxhist20_begin_m
NAMELIST /time_control/ auxhist20_begin_s
NAMELIST /time_control/ auxhist20_begin
NAMELIST /time_control/ auxhist20_end_y
NAMELIST /time_control/ auxhist20_end_d
NAMELIST /time_control/ auxhist20_end_h
NAMELIST /time_control/ auxhist20_end_m
NAMELIST /time_control/ auxhist20_end_s
NAMELIST /time_control/ auxhist20_end
NAMELIST /time_control/ io_form_auxhist20
NAMELIST /time_control/ frames_per_auxhist20
NAMELIST /time_control/ auxhist21_inname
NAMELIST /time_control/ auxhist21_outname
NAMELIST /time_control/ auxhist21_interval_y
NAMELIST /time_control/ auxhist21_interval_d
NAMELIST /time_control/ auxhist21_interval_h
NAMELIST /time_control/ auxhist21_interval_m
NAMELIST /time_control/ auxhist21_interval_s
NAMELIST /time_control/ auxhist21_interval
NAMELIST /time_control/ auxhist21_begin_y
NAMELIST /time_control/ auxhist21_begin_d
NAMELIST /time_control/ auxhist21_begin_h
NAMELIST /time_control/ auxhist21_begin_m
NAMELIST /time_control/ auxhist21_begin_s
NAMELIST /time_control/ auxhist21_begin
NAMELIST /time_control/ auxhist21_end_y
NAMELIST /time_control/ auxhist21_end_d
NAMELIST /time_control/ auxhist21_end_h
NAMELIST /time_control/ auxhist21_end_m
NAMELIST /time_control/ auxhist21_end_s
NAMELIST /time_control/ auxhist21_end
NAMELIST /time_control/ io_form_auxhist21
NAMELIST /time_control/ frames_per_auxhist21
NAMELIST /time_control/ auxhist22_inname
NAMELIST /time_control/ auxhist22_outname
NAMELIST /time_control/ auxhist22_interval_y
NAMELIST /time_control/ auxhist22_interval_d
NAMELIST /time_control/ auxhist22_interval_h
NAMELIST /time_control/ auxhist22_interval_m
NAMELIST /time_control/ auxhist22_interval_s
NAMELIST /time_control/ auxhist22_interval
NAMELIST /time_control/ auxhist22_begin_y
NAMELIST /time_control/ auxhist22_begin_d
NAMELIST /time_control/ auxhist22_begin_h
NAMELIST /time_control/ auxhist22_begin_m
NAMELIST /time_control/ auxhist22_begin_s
NAMELIST /time_control/ auxhist22_begin
NAMELIST /time_control/ auxhist22_end_y
NAMELIST /time_control/ auxhist22_end_d
NAMELIST /time_control/ auxhist22_end_h
NAMELIST /time_control/ auxhist22_end_m
NAMELIST /time_control/ auxhist22_end_s
NAMELIST /time_control/ auxhist22_end
NAMELIST /time_control/ io_form_auxhist22
NAMELIST /time_control/ frames_per_auxhist22
NAMELIST /time_control/ auxhist23_inname
NAMELIST /time_control/ auxhist23_outname
NAMELIST /time_control/ auxhist23_interval_y
NAMELIST /time_control/ auxhist23_interval_d
NAMELIST /time_control/ auxhist23_interval_h
NAMELIST /time_control/ auxhist23_interval_m
NAMELIST /time_control/ auxhist23_interval_s
NAMELIST /time_control/ auxhist23_interval
NAMELIST /time_control/ auxhist23_begin_y
NAMELIST /time_control/ auxhist23_begin_d
NAMELIST /time_control/ auxhist23_begin_h
NAMELIST /time_control/ auxhist23_begin_m
NAMELIST /time_control/ auxhist23_begin_s
NAMELIST /time_control/ auxhist23_begin
NAMELIST /time_control/ auxhist23_end_y
NAMELIST /time_control/ auxhist23_end_d
NAMELIST /time_control/ auxhist23_end_h
NAMELIST /time_control/ auxhist23_end_m
NAMELIST /time_control/ auxhist23_end_s
NAMELIST /time_control/ auxhist23_end
NAMELIST /time_control/ io_form_auxhist23
NAMELIST /time_control/ frames_per_auxhist23
NAMELIST /time_control/ auxhist24_inname
NAMELIST /time_control/ auxhist24_outname
NAMELIST /time_control/ auxhist24_interval_y
NAMELIST /time_control/ auxhist24_interval_d
NAMELIST /time_control/ auxhist24_interval_h
NAMELIST /time_control/ auxhist24_interval_m
NAMELIST /time_control/ auxhist24_interval_s
NAMELIST /time_control/ auxhist24_interval
NAMELIST /time_control/ auxhist24_begin_y
NAMELIST /time_control/ auxhist24_begin_d
NAMELIST /time_control/ auxhist24_begin_h
NAMELIST /time_control/ auxhist24_begin_m
NAMELIST /time_control/ auxhist24_begin_s
NAMELIST /time_control/ auxhist24_begin
NAMELIST /time_control/ auxhist24_end_y
NAMELIST /time_control/ auxhist24_end_d
NAMELIST /time_control/ auxhist24_end_h
NAMELIST /time_control/ auxhist24_end_m
NAMELIST /time_control/ auxhist24_end_s
NAMELIST /time_control/ auxhist24_end
NAMELIST /time_control/ io_form_auxhist24
NAMELIST /time_control/ frames_per_auxhist24
NAMELIST /time_control/ auxinput1_outname
NAMELIST /time_control/ auxinput1_interval_y
NAMELIST /time_control/ auxinput1_interval_d
NAMELIST /time_control/ auxinput1_interval_h
NAMELIST /time_control/ auxinput1_interval_m
NAMELIST /time_control/ auxinput1_interval_s
NAMELIST /time_control/ auxinput1_interval
NAMELIST /time_control/ auxinput1_begin_y
NAMELIST /time_control/ auxinput1_begin_d
NAMELIST /time_control/ auxinput1_begin_h
NAMELIST /time_control/ auxinput1_begin_m
NAMELIST /time_control/ auxinput1_begin_s
NAMELIST /time_control/ auxinput1_begin
NAMELIST /time_control/ auxinput1_end_y
NAMELIST /time_control/ auxinput1_end_d
NAMELIST /time_control/ auxinput1_end_h
NAMELIST /time_control/ auxinput1_end_m
NAMELIST /time_control/ auxinput1_end_s
NAMELIST /time_control/ auxinput1_end
NAMELIST /time_control/ frames_per_auxinput1
NAMELIST /time_control/ auxinput2_inname
NAMELIST /time_control/ auxinput2_outname
NAMELIST /time_control/ auxinput2_interval_y
NAMELIST /time_control/ auxinput2_interval_d
NAMELIST /time_control/ auxinput2_interval_h
NAMELIST /time_control/ auxinput2_interval_m
NAMELIST /time_control/ auxinput2_interval_s
NAMELIST /time_control/ auxinput2_interval
NAMELIST /time_control/ auxinput2_begin_y
NAMELIST /time_control/ auxinput2_begin_d
NAMELIST /time_control/ auxinput2_begin_h
NAMELIST /time_control/ auxinput2_begin_m
NAMELIST /time_control/ auxinput2_begin_s
NAMELIST /time_control/ auxinput2_begin
NAMELIST /time_control/ auxinput2_end_y
NAMELIST /time_control/ auxinput2_end_d
NAMELIST /time_control/ auxinput2_end_h
NAMELIST /time_control/ auxinput2_end_m
NAMELIST /time_control/ auxinput2_end_s
NAMELIST /time_control/ auxinput2_end
NAMELIST /time_control/ io_form_auxinput2
NAMELIST /time_control/ frames_per_auxinput2
NAMELIST /time_control/ auxinput3_inname
NAMELIST /time_control/ auxinput3_outname
NAMELIST /time_control/ auxinput3_interval_y
NAMELIST /time_control/ auxinput3_interval_d
NAMELIST /time_control/ auxinput3_interval_h
NAMELIST /time_control/ auxinput3_interval_m
NAMELIST /time_control/ auxinput3_interval_s
NAMELIST /time_control/ auxinput3_interval
NAMELIST /time_control/ auxinput3_begin_y
NAMELIST /time_control/ auxinput3_begin_d
NAMELIST /time_control/ auxinput3_begin_h
NAMELIST /time_control/ auxinput3_begin_m
NAMELIST /time_control/ auxinput3_begin_s
NAMELIST /time_control/ auxinput3_begin
NAMELIST /time_control/ auxinput3_end_y
NAMELIST /time_control/ auxinput3_end_d
NAMELIST /time_control/ auxinput3_end_h
NAMELIST /time_control/ auxinput3_end_m
NAMELIST /time_control/ auxinput3_end_s
NAMELIST /time_control/ auxinput3_end
NAMELIST /time_control/ io_form_auxinput3
NAMELIST /time_control/ frames_per_auxinput3
NAMELIST /time_control/ auxinput4_inname
NAMELIST /time_control/ auxinput4_outname
NAMELIST /time_control/ auxinput4_interval_y
NAMELIST /time_control/ auxinput4_interval_d
NAMELIST /time_control/ auxinput4_interval_h
NAMELIST /time_control/ auxinput4_interval_m
NAMELIST /time_control/ auxinput4_interval_s
NAMELIST /time_control/ auxinput4_interval
NAMELIST /time_control/ auxinput4_begin_y
NAMELIST /time_control/ auxinput4_begin_d
NAMELIST /time_control/ auxinput4_begin_h
NAMELIST /time_control/ auxinput4_begin_m
NAMELIST /time_control/ auxinput4_begin_s
NAMELIST /time_control/ auxinput4_begin
NAMELIST /time_control/ auxinput4_end_y
NAMELIST /time_control/ auxinput4_end_d
NAMELIST /time_control/ auxinput4_end_h
NAMELIST /time_control/ auxinput4_end_m
NAMELIST /time_control/ auxinput4_end_s
NAMELIST /time_control/ auxinput4_end
NAMELIST /time_control/ io_form_auxinput4
NAMELIST /time_control/ frames_per_auxinput4
NAMELIST /time_control/ auxinput5_inname
NAMELIST /time_control/ auxinput5_outname
NAMELIST /time_control/ auxinput5_interval_y
NAMELIST /time_control/ auxinput5_interval_d
NAMELIST /time_control/ auxinput5_interval_h
NAMELIST /time_control/ auxinput5_interval_m
NAMELIST /time_control/ auxinput5_interval_s
NAMELIST /time_control/ auxinput5_interval
NAMELIST /time_control/ auxinput5_begin_y
NAMELIST /time_control/ auxinput5_begin_d
NAMELIST /time_control/ auxinput5_begin_h
NAMELIST /time_control/ auxinput5_begin_m
NAMELIST /time_control/ auxinput5_begin_s
NAMELIST /time_control/ auxinput5_begin
NAMELIST /time_control/ auxinput5_end_y
NAMELIST /time_control/ auxinput5_end_d
NAMELIST /time_control/ auxinput5_end_h
NAMELIST /time_control/ auxinput5_end_m
NAMELIST /time_control/ auxinput5_end_s
NAMELIST /time_control/ auxinput5_end
NAMELIST /time_control/ io_form_auxinput5
NAMELIST /time_control/ frames_per_auxinput5
NAMELIST /time_control/ auxinput6_inname
NAMELIST /time_control/ auxinput6_outname
NAMELIST /time_control/ auxinput6_interval_y
NAMELIST /time_control/ auxinput6_interval_d
NAMELIST /time_control/ auxinput6_interval_h
NAMELIST /time_control/ auxinput6_interval_m
NAMELIST /time_control/ auxinput6_interval_s
NAMELIST /time_control/ auxinput6_interval
NAMELIST /time_control/ auxinput6_begin_y
NAMELIST /time_control/ auxinput6_begin_d
NAMELIST /time_control/ auxinput6_begin_h
NAMELIST /time_control/ auxinput6_begin_m
NAMELIST /time_control/ auxinput6_begin_s
NAMELIST /time_control/ auxinput6_begin
NAMELIST /time_control/ auxinput6_end_y
NAMELIST /time_control/ auxinput6_end_d
NAMELIST /time_control/ auxinput6_end_h
NAMELIST /time_control/ auxinput6_end_m
NAMELIST /time_control/ auxinput6_end_s
NAMELIST /time_control/ auxinput6_end
NAMELIST /time_control/ io_form_auxinput6
NAMELIST /time_control/ frames_per_auxinput6
NAMELIST /time_control/ auxinput7_inname
NAMELIST /time_control/ auxinput7_outname
NAMELIST /time_control/ auxinput7_interval_y
NAMELIST /time_control/ auxinput7_interval_d
NAMELIST /time_control/ auxinput7_interval_h
NAMELIST /time_control/ auxinput7_interval_m
NAMELIST /time_control/ auxinput7_interval_s
NAMELIST /time_control/ auxinput7_interval
NAMELIST /time_control/ auxinput7_begin_y
NAMELIST /time_control/ auxinput7_begin_d
NAMELIST /time_control/ auxinput7_begin_h
NAMELIST /time_control/ auxinput7_begin_m
NAMELIST /time_control/ auxinput7_begin_s
NAMELIST /time_control/ auxinput7_begin
NAMELIST /time_control/ auxinput7_end_y
NAMELIST /time_control/ auxinput7_end_d
NAMELIST /time_control/ auxinput7_end_h
NAMELIST /time_control/ auxinput7_end_m
NAMELIST /time_control/ auxinput7_end_s
NAMELIST /time_control/ auxinput7_end
NAMELIST /time_control/ io_form_auxinput7
NAMELIST /time_control/ frames_per_auxinput7
NAMELIST /time_control/ auxinput8_inname
NAMELIST /time_control/ auxinput8_outname
NAMELIST /time_control/ auxinput8_interval_y
NAMELIST /time_control/ auxinput8_interval_d
NAMELIST /time_control/ auxinput8_interval_h
NAMELIST /time_control/ auxinput8_interval_m
NAMELIST /time_control/ auxinput8_interval_s
NAMELIST /time_control/ auxinput8_interval
NAMELIST /time_control/ auxinput8_begin_y
NAMELIST /time_control/ auxinput8_begin_d
NAMELIST /time_control/ auxinput8_begin_h
NAMELIST /time_control/ auxinput8_begin_m
NAMELIST /time_control/ auxinput8_begin_s
NAMELIST /time_control/ auxinput8_begin
NAMELIST /time_control/ auxinput8_end_y
NAMELIST /time_control/ auxinput8_end_d
NAMELIST /time_control/ auxinput8_end_h
NAMELIST /time_control/ auxinput8_end_m
NAMELIST /time_control/ auxinput8_end_s
NAMELIST /time_control/ auxinput8_end
NAMELIST /time_control/ io_form_auxinput8
NAMELIST /time_control/ frames_per_auxinput8
NAMELIST /time_control/ auxinput9_inname
NAMELIST /time_control/ auxinput9_outname
NAMELIST /time_control/ auxinput9_interval_y
NAMELIST /time_control/ auxinput9_interval_d
NAMELIST /time_control/ auxinput9_interval_h
NAMELIST /time_control/ auxinput9_interval_m
NAMELIST /time_control/ auxinput9_interval_s
NAMELIST /time_control/ auxinput9_interval
NAMELIST /time_control/ auxinput9_begin_y
NAMELIST /time_control/ auxinput9_begin_d
NAMELIST /time_control/ auxinput9_begin_h
NAMELIST /time_control/ auxinput9_begin_m
NAMELIST /time_control/ auxinput9_begin_s
NAMELIST /time_control/ auxinput9_begin
NAMELIST /time_control/ auxinput9_end_y
NAMELIST /time_control/ auxinput9_end_d
NAMELIST /time_control/ auxinput9_end_h
NAMELIST /time_control/ auxinput9_end_m
NAMELIST /time_control/ auxinput9_end_s
NAMELIST /time_control/ auxinput9_end
NAMELIST /time_control/ io_form_auxinput9
NAMELIST /time_control/ frames_per_auxinput9
NAMELIST /time_control/ auxinput10_inname
NAMELIST /time_control/ auxinput10_outname
NAMELIST /time_control/ auxinput10_interval_y
NAMELIST /time_control/ auxinput10_interval_d
NAMELIST /time_control/ auxinput10_interval_h
NAMELIST /time_control/ auxinput10_interval_m
NAMELIST /time_control/ auxinput10_interval_s
NAMELIST /time_control/ auxinput10_interval
NAMELIST /time_control/ auxinput10_begin_y
NAMELIST /time_control/ auxinput10_begin_d
NAMELIST /time_control/ auxinput10_begin_h
NAMELIST /time_control/ auxinput10_begin_m
NAMELIST /time_control/ auxinput10_begin_s
NAMELIST /time_control/ auxinput10_begin
NAMELIST /time_control/ auxinput10_end_y
NAMELIST /time_control/ auxinput10_end_d
NAMELIST /time_control/ auxinput10_end_h
NAMELIST /time_control/ auxinput10_end_m
NAMELIST /time_control/ auxinput10_end_s
NAMELIST /time_control/ auxinput10_end
NAMELIST /time_control/ io_form_auxinput10
NAMELIST /time_control/ frames_per_auxinput10
NAMELIST /time_control/ auxinput11_inname
NAMELIST /time_control/ auxinput11_outname
NAMELIST /time_control/ auxinput11_interval_y
NAMELIST /time_control/ auxinput11_interval_d
NAMELIST /time_control/ auxinput11_interval_h
NAMELIST /time_control/ auxinput11_interval_m
NAMELIST /time_control/ auxinput11_interval_s
NAMELIST /time_control/ auxinput11_interval
NAMELIST /time_control/ auxinput11_begin_y
NAMELIST /time_control/ auxinput11_begin_d
NAMELIST /time_control/ auxinput11_begin_h
NAMELIST /time_control/ auxinput11_begin_m
NAMELIST /time_control/ auxinput11_begin_s
NAMELIST /time_control/ auxinput11_begin
NAMELIST /time_control/ auxinput11_end_y
NAMELIST /time_control/ auxinput11_end_d
NAMELIST /time_control/ auxinput11_end_h
NAMELIST /time_control/ auxinput11_end_m
NAMELIST /time_control/ auxinput11_end_s
NAMELIST /time_control/ auxinput11_end
NAMELIST /time_control/ io_form_auxinput11
NAMELIST /time_control/ frames_per_auxinput11
NAMELIST /time_control/ auxinput12_inname
NAMELIST /time_control/ auxinput12_outname
NAMELIST /time_control/ auxinput12_interval_y
NAMELIST /time_control/ auxinput12_interval_d
NAMELIST /time_control/ auxinput12_interval_h
NAMELIST /time_control/ auxinput12_interval_m
NAMELIST /time_control/ auxinput12_interval_s
NAMELIST /time_control/ auxinput12_interval
NAMELIST /time_control/ auxinput12_begin_y
NAMELIST /time_control/ auxinput12_begin_d
NAMELIST /time_control/ auxinput12_begin_h
NAMELIST /time_control/ auxinput12_begin_m
NAMELIST /time_control/ auxinput12_begin_s
NAMELIST /time_control/ auxinput12_begin
NAMELIST /time_control/ auxinput12_end_y
NAMELIST /time_control/ auxinput12_end_d
NAMELIST /time_control/ auxinput12_end_h
NAMELIST /time_control/ auxinput12_end_m
NAMELIST /time_control/ auxinput12_end_s
NAMELIST /time_control/ auxinput12_end
NAMELIST /time_control/ io_form_auxinput12
NAMELIST /time_control/ frames_per_auxinput12
NAMELIST /time_control/ auxinput13_inname
NAMELIST /time_control/ auxinput13_outname
NAMELIST /time_control/ auxinput13_interval_y
NAMELIST /time_control/ auxinput13_interval_d
NAMELIST /time_control/ auxinput13_interval_h
NAMELIST /time_control/ auxinput13_interval_m
NAMELIST /time_control/ auxinput13_interval_s
NAMELIST /time_control/ auxinput13_interval
NAMELIST /time_control/ auxinput13_begin_y
NAMELIST /time_control/ auxinput13_begin_d
NAMELIST /time_control/ auxinput13_begin_h
NAMELIST /time_control/ auxinput13_begin_m
NAMELIST /time_control/ auxinput13_begin_s
NAMELIST /time_control/ auxinput13_begin
NAMELIST /time_control/ auxinput13_end_y
NAMELIST /time_control/ auxinput13_end_d
NAMELIST /time_control/ auxinput13_end_h
NAMELIST /time_control/ auxinput13_end_m
NAMELIST /time_control/ auxinput13_end_s
NAMELIST /time_control/ auxinput13_end
NAMELIST /time_control/ io_form_auxinput13
NAMELIST /time_control/ frames_per_auxinput13
NAMELIST /time_control/ auxinput14_inname
NAMELIST /time_control/ auxinput14_outname
NAMELIST /time_control/ auxinput14_interval_y
NAMELIST /time_control/ auxinput14_interval_d
NAMELIST /time_control/ auxinput14_interval_h
NAMELIST /time_control/ auxinput14_interval_m
NAMELIST /time_control/ auxinput14_interval_s
NAMELIST /time_control/ auxinput14_interval
NAMELIST /time_control/ auxinput14_begin_y
NAMELIST /time_control/ auxinput14_begin_d
NAMELIST /time_control/ auxinput14_begin_h
NAMELIST /time_control/ auxinput14_begin_m
NAMELIST /time_control/ auxinput14_begin_s
NAMELIST /time_control/ auxinput14_begin
NAMELIST /time_control/ auxinput14_end_y
NAMELIST /time_control/ auxinput14_end_d
NAMELIST /time_control/ auxinput14_end_h
NAMELIST /time_control/ auxinput14_end_m
NAMELIST /time_control/ auxinput14_end_s
NAMELIST /time_control/ auxinput14_end
NAMELIST /time_control/ io_form_auxinput14
NAMELIST /time_control/ frames_per_auxinput14
NAMELIST /time_control/ auxinput15_inname
NAMELIST /time_control/ auxinput15_outname
NAMELIST /time_control/ auxinput15_interval_y
NAMELIST /time_control/ auxinput15_interval_d
NAMELIST /time_control/ auxinput15_interval_h
NAMELIST /time_control/ auxinput15_interval_m
NAMELIST /time_control/ auxinput15_interval_s
NAMELIST /time_control/ auxinput15_interval
NAMELIST /time_control/ auxinput15_begin_y
NAMELIST /time_control/ auxinput15_begin_d
NAMELIST /time_control/ auxinput15_begin_h
NAMELIST /time_control/ auxinput15_begin_m
NAMELIST /time_control/ auxinput15_begin_s
NAMELIST /time_control/ auxinput15_begin
NAMELIST /time_control/ auxinput15_end_y
NAMELIST /time_control/ auxinput15_end_d
NAMELIST /time_control/ auxinput15_end_h
NAMELIST /time_control/ auxinput15_end_m
NAMELIST /time_control/ auxinput15_end_s
NAMELIST /time_control/ auxinput15_end
NAMELIST /time_control/ io_form_auxinput15
NAMELIST /time_control/ frames_per_auxinput15
NAMELIST /time_control/ auxinput16_inname
NAMELIST /time_control/ auxinput16_outname
NAMELIST /time_control/ auxinput16_interval_y
NAMELIST /time_control/ auxinput16_interval_d
NAMELIST /time_control/ auxinput16_interval_h
NAMELIST /time_control/ auxinput16_interval_m
NAMELIST /time_control/ auxinput16_interval_s
NAMELIST /time_control/ auxinput16_interval
NAMELIST /time_control/ auxinput16_begin_y
NAMELIST /time_control/ auxinput16_begin_d
NAMELIST /time_control/ auxinput16_begin_h
NAMELIST /time_control/ auxinput16_begin_m
NAMELIST /time_control/ auxinput16_begin_s
NAMELIST /time_control/ auxinput16_begin
NAMELIST /time_control/ auxinput16_end_y
NAMELIST /time_control/ auxinput16_end_d
NAMELIST /time_control/ auxinput16_end_h
NAMELIST /time_control/ auxinput16_end_m
NAMELIST /time_control/ auxinput16_end_s
NAMELIST /time_control/ auxinput16_end
NAMELIST /time_control/ io_form_auxinput16
NAMELIST /time_control/ frames_per_auxinput16
NAMELIST /time_control/ auxinput17_inname
NAMELIST /time_control/ auxinput17_outname
NAMELIST /time_control/ auxinput17_interval_y
NAMELIST /time_control/ auxinput17_interval_d
NAMELIST /time_control/ auxinput17_interval_h
NAMELIST /time_control/ auxinput17_interval_m
NAMELIST /time_control/ auxinput17_interval_s
NAMELIST /time_control/ auxinput17_interval
NAMELIST /time_control/ auxinput17_begin_y
NAMELIST /time_control/ auxinput17_begin_d
NAMELIST /time_control/ auxinput17_begin_h
NAMELIST /time_control/ auxinput17_begin_m
NAMELIST /time_control/ auxinput17_begin_s
NAMELIST /time_control/ auxinput17_begin
NAMELIST /time_control/ auxinput17_end_y
NAMELIST /time_control/ auxinput17_end_d
NAMELIST /time_control/ auxinput17_end_h
NAMELIST /time_control/ auxinput17_end_m
NAMELIST /time_control/ auxinput17_end_s
NAMELIST /time_control/ auxinput17_end
NAMELIST /time_control/ io_form_auxinput17
NAMELIST /time_control/ frames_per_auxinput17
NAMELIST /time_control/ auxinput18_inname
NAMELIST /time_control/ auxinput18_outname
NAMELIST /time_control/ auxinput18_interval_y
NAMELIST /time_control/ auxinput18_interval_d
NAMELIST /time_control/ auxinput18_interval_h
NAMELIST /time_control/ auxinput18_interval_m
NAMELIST /time_control/ auxinput18_interval_s
NAMELIST /time_control/ auxinput18_interval
NAMELIST /time_control/ auxinput18_begin_y
NAMELIST /time_control/ auxinput18_begin_d
NAMELIST /time_control/ auxinput18_begin_h
NAMELIST /time_control/ auxinput18_begin_m
NAMELIST /time_control/ auxinput18_begin_s
NAMELIST /time_control/ auxinput18_begin
NAMELIST /time_control/ auxinput18_end_y
NAMELIST /time_control/ auxinput18_end_d
NAMELIST /time_control/ auxinput18_end_h
NAMELIST /time_control/ auxinput18_end_m
NAMELIST /time_control/ auxinput18_end_s
NAMELIST /time_control/ auxinput18_end
NAMELIST /time_control/ io_form_auxinput18
NAMELIST /time_control/ frames_per_auxinput18
NAMELIST /time_control/ auxinput19_inname
NAMELIST /time_control/ auxinput19_outname
NAMELIST /time_control/ auxinput19_interval_y
NAMELIST /time_control/ auxinput19_interval_d
NAMELIST /time_control/ auxinput19_interval_h
NAMELIST /time_control/ auxinput19_interval_m
NAMELIST /time_control/ auxinput19_interval_s
NAMELIST /time_control/ auxinput19_interval
NAMELIST /time_control/ auxinput19_begin_y
NAMELIST /time_control/ auxinput19_begin_d
NAMELIST /time_control/ auxinput19_begin_h
NAMELIST /time_control/ auxinput19_begin_m
NAMELIST /time_control/ auxinput19_begin_s
NAMELIST /time_control/ auxinput19_begin
NAMELIST /time_control/ auxinput19_end_y
NAMELIST /time_control/ auxinput19_end_d
NAMELIST /time_control/ auxinput19_end_h
NAMELIST /time_control/ auxinput19_end_m
NAMELIST /time_control/ auxinput19_end_s
NAMELIST /time_control/ auxinput19_end
NAMELIST /time_control/ io_form_auxinput19
NAMELIST /time_control/ frames_per_auxinput19
NAMELIST /time_control/ auxinput20_inname
NAMELIST /time_control/ auxinput20_outname
NAMELIST /time_control/ auxinput20_interval_y
NAMELIST /time_control/ auxinput20_interval_d
NAMELIST /time_control/ auxinput20_interval_h
NAMELIST /time_control/ auxinput20_interval_m
NAMELIST /time_control/ auxinput20_interval_s
NAMELIST /time_control/ auxinput20_interval
NAMELIST /time_control/ auxinput20_begin_y
NAMELIST /time_control/ auxinput20_begin_d
NAMELIST /time_control/ auxinput20_begin_h
NAMELIST /time_control/ auxinput20_begin_m
NAMELIST /time_control/ auxinput20_begin_s
NAMELIST /time_control/ auxinput20_begin
NAMELIST /time_control/ auxinput20_end_y
NAMELIST /time_control/ auxinput20_end_d
NAMELIST /time_control/ auxinput20_end_h
NAMELIST /time_control/ auxinput20_end_m
NAMELIST /time_control/ auxinput20_end_s
NAMELIST /time_control/ auxinput20_end
NAMELIST /time_control/ io_form_auxinput20
NAMELIST /time_control/ frames_per_auxinput20
NAMELIST /time_control/ auxinput21_inname
NAMELIST /time_control/ auxinput21_outname
NAMELIST /time_control/ auxinput21_interval_y
NAMELIST /time_control/ auxinput21_interval_d
NAMELIST /time_control/ auxinput21_interval_h
NAMELIST /time_control/ auxinput21_interval_m
NAMELIST /time_control/ auxinput21_interval_s
NAMELIST /time_control/ auxinput21_interval
NAMELIST /time_control/ auxinput21_begin_y
NAMELIST /time_control/ auxinput21_begin_d
NAMELIST /time_control/ auxinput21_begin_h
NAMELIST /time_control/ auxinput21_begin_m
NAMELIST /time_control/ auxinput21_begin_s
NAMELIST /time_control/ auxinput21_begin
NAMELIST /time_control/ auxinput21_end_y
NAMELIST /time_control/ auxinput21_end_d
NAMELIST /time_control/ auxinput21_end_h
NAMELIST /time_control/ auxinput21_end_m
NAMELIST /time_control/ auxinput21_end_s
NAMELIST /time_control/ auxinput21_end
NAMELIST /time_control/ io_form_auxinput21
NAMELIST /time_control/ frames_per_auxinput21
NAMELIST /time_control/ auxinput22_inname
NAMELIST /time_control/ auxinput22_outname
NAMELIST /time_control/ auxinput22_interval_y
NAMELIST /time_control/ auxinput22_interval_d
NAMELIST /time_control/ auxinput22_interval_h
NAMELIST /time_control/ auxinput22_interval_m
NAMELIST /time_control/ auxinput22_interval_s
NAMELIST /time_control/ auxinput22_interval
NAMELIST /time_control/ auxinput22_begin_y
NAMELIST /time_control/ auxinput22_begin_d
NAMELIST /time_control/ auxinput22_begin_h
NAMELIST /time_control/ auxinput22_begin_m
NAMELIST /time_control/ auxinput22_begin_s
NAMELIST /time_control/ auxinput22_begin
NAMELIST /time_control/ auxinput22_end_y
NAMELIST /time_control/ auxinput22_end_d
NAMELIST /time_control/ auxinput22_end_h
NAMELIST /time_control/ auxinput22_end_m
NAMELIST /time_control/ auxinput22_end_s
NAMELIST /time_control/ auxinput22_end
NAMELIST /time_control/ io_form_auxinput22
NAMELIST /time_control/ frames_per_auxinput22
NAMELIST /time_control/ auxinput23_inname
NAMELIST /time_control/ auxinput23_outname
NAMELIST /time_control/ auxinput23_interval_y
NAMELIST /time_control/ auxinput23_interval_d
NAMELIST /time_control/ auxinput23_interval_h
NAMELIST /time_control/ auxinput23_interval_m
NAMELIST /time_control/ auxinput23_interval_s
NAMELIST /time_control/ auxinput23_interval
NAMELIST /time_control/ auxinput23_begin_y
NAMELIST /time_control/ auxinput23_begin_d
NAMELIST /time_control/ auxinput23_begin_h
NAMELIST /time_control/ auxinput23_begin_m
NAMELIST /time_control/ auxinput23_begin_s
NAMELIST /time_control/ auxinput23_begin
NAMELIST /time_control/ auxinput23_end_y
NAMELIST /time_control/ auxinput23_end_d
NAMELIST /time_control/ auxinput23_end_h
NAMELIST /time_control/ auxinput23_end_m
NAMELIST /time_control/ auxinput23_end_s
NAMELIST /time_control/ auxinput23_end
NAMELIST /time_control/ io_form_auxinput23
NAMELIST /time_control/ frames_per_auxinput23
NAMELIST /time_control/ auxinput24_inname
NAMELIST /time_control/ auxinput24_outname
NAMELIST /time_control/ auxinput24_interval_y
NAMELIST /time_control/ auxinput24_interval_d
NAMELIST /time_control/ auxinput24_interval_h
NAMELIST /time_control/ auxinput24_interval_m
NAMELIST /time_control/ auxinput24_interval_s
NAMELIST /time_control/ auxinput24_interval
NAMELIST /time_control/ auxinput24_begin_y
NAMELIST /time_control/ auxinput24_begin_d
NAMELIST /time_control/ auxinput24_begin_h
NAMELIST /time_control/ auxinput24_begin_m
NAMELIST /time_control/ auxinput24_begin_s
NAMELIST /time_control/ auxinput24_begin
NAMELIST /time_control/ auxinput24_end_y
NAMELIST /time_control/ auxinput24_end_d
NAMELIST /time_control/ auxinput24_end_h
NAMELIST /time_control/ auxinput24_end_m
NAMELIST /time_control/ auxinput24_end_s
NAMELIST /time_control/ auxinput24_end
NAMELIST /time_control/ io_form_auxinput24
NAMELIST /time_control/ frames_per_auxinput24
NAMELIST /time_control/ history_interval
NAMELIST /time_control/ frames_per_outfile
NAMELIST /time_control/ restart
NAMELIST /time_control/ restart_interval
NAMELIST /time_control/ io_form_input
NAMELIST /time_control/ io_form_history
NAMELIST /time_control/ io_form_restart
NAMELIST /time_control/ io_form_boundary
NAMELIST /time_control/ debug_level
NAMELIST /time_control/ self_test_domain
NAMELIST /time_control/ history_outname
NAMELIST /time_control/ history_inname
NAMELIST /time_control/ use_netcdf_classic
NAMELIST /time_control/ history_interval_d
NAMELIST /time_control/ history_interval_h
NAMELIST /time_control/ history_interval_m
NAMELIST /time_control/ history_interval_s
NAMELIST /time_control/ inputout_interval_d
NAMELIST /time_control/ inputout_interval_h
NAMELIST /time_control/ inputout_interval_m
NAMELIST /time_control/ inputout_interval_s
NAMELIST /time_control/ inputout_interval
NAMELIST /time_control/ restart_interval_d
NAMELIST /time_control/ restart_interval_h
NAMELIST /time_control/ restart_interval_m
NAMELIST /time_control/ restart_interval_s
NAMELIST /time_control/ history_begin_y
NAMELIST /time_control/ history_begin_d
NAMELIST /time_control/ history_begin_h
NAMELIST /time_control/ history_begin_m
NAMELIST /time_control/ history_begin_s
NAMELIST /time_control/ history_begin
NAMELIST /time_control/ inputout_begin_y
NAMELIST /time_control/ inputout_begin_d
NAMELIST /time_control/ inputout_begin_h
NAMELIST /time_control/ inputout_begin_m
NAMELIST /time_control/ inputout_begin_s
NAMELIST /time_control/ restart_begin_y
NAMELIST /time_control/ restart_begin_d
NAMELIST /time_control/ restart_begin_h
NAMELIST /time_control/ restart_begin_m
NAMELIST /time_control/ restart_begin_s
NAMELIST /time_control/ restart_begin
NAMELIST /time_control/ history_end_y
NAMELIST /time_control/ history_end_d
NAMELIST /time_control/ history_end_h
NAMELIST /time_control/ history_end_m
NAMELIST /time_control/ history_end_s
NAMELIST /time_control/ history_end
NAMELIST /time_control/ inputout_end_y
NAMELIST /time_control/ inputout_end_d
NAMELIST /time_control/ inputout_end_h
NAMELIST /time_control/ inputout_end_m
NAMELIST /time_control/ inputout_end_s
NAMELIST /time_control/ reset_simulation_start
NAMELIST /domains/ sr_x
NAMELIST /domains/ sr_y
NAMELIST /fdda/ sgfdda_inname
NAMELIST /fdda/ gfdda_inname
NAMELIST /fdda/ sgfdda_interval_d
NAMELIST /fdda/ sgfdda_interval_h
NAMELIST /fdda/ sgfdda_interval_m
NAMELIST /fdda/ sgfdda_interval_s
NAMELIST /fdda/ sgfdda_interval_y
NAMELIST /fdda/ sgfdda_interval
NAMELIST /fdda/ gfdda_interval_d
NAMELIST /fdda/ gfdda_interval_h
NAMELIST /fdda/ gfdda_interval_m
NAMELIST /fdda/ gfdda_interval_s
NAMELIST /fdda/ gfdda_interval_y
NAMELIST /fdda/ gfdda_interval
NAMELIST /fdda/ sgfdda_begin_y
NAMELIST /fdda/ sgfdda_begin_d
NAMELIST /fdda/ sgfdda_begin_h
NAMELIST /fdda/ sgfdda_begin_m
NAMELIST /fdda/ sgfdda_begin_s
NAMELIST /fdda/ gfdda_begin_y
NAMELIST /fdda/ gfdda_begin_d
NAMELIST /fdda/ gfdda_begin_h
NAMELIST /fdda/ gfdda_begin_m
NAMELIST /fdda/ gfdda_begin_s
NAMELIST /fdda/ sgfdda_end_y
NAMELIST /fdda/ sgfdda_end_d
NAMELIST /fdda/ sgfdda_end_h
NAMELIST /fdda/ sgfdda_end_m
NAMELIST /fdda/ sgfdda_end_s
NAMELIST /fdda/ gfdda_end_y
NAMELIST /fdda/ gfdda_end_d
NAMELIST /fdda/ gfdda_end_h
NAMELIST /fdda/ gfdda_end_m
NAMELIST /fdda/ gfdda_end_s
NAMELIST /fdda/ io_form_sgfdda
NAMELIST /fdda/ io_form_gfdda
NAMELIST /time_control/ iofields_filename
NAMELIST /time_control/ ignore_iofields_warning
NAMELIST /time_control/ ncd_nofill
NAMELIST /fire/ ifire
NAMELIST /fire/ fire_boundary_guard
NAMELIST /fire/ fire_num_ignitions
NAMELIST /fire/ fire_ignition_ros1
NAMELIST /fire/ fire_ignition_start_lon1
NAMELIST /fire/ fire_ignition_start_lat1
NAMELIST /fire/ fire_ignition_end_lon1
NAMELIST /fire/ fire_ignition_end_lat1
NAMELIST /fire/ fire_ignition_radius1
NAMELIST /fire/ fire_ignition_start_time1
NAMELIST /fire/ fire_ignition_end_time1
NAMELIST /fire/ fire_ignition_ros2
NAMELIST /fire/ fire_ignition_start_lon2
NAMELIST /fire/ fire_ignition_start_lat2
NAMELIST /fire/ fire_ignition_end_lon2
NAMELIST /fire/ fire_ignition_end_lat2
NAMELIST /fire/ fire_ignition_radius2
NAMELIST /fire/ fire_ignition_start_time2
NAMELIST /fire/ fire_ignition_end_time2
NAMELIST /fire/ fire_ignition_ros3
NAMELIST /fire/ fire_ignition_start_lon3
NAMELIST /fire/ fire_ignition_start_lat3
NAMELIST /fire/ fire_ignition_end_lon3
NAMELIST /fire/ fire_ignition_end_lat3
NAMELIST /fire/ fire_ignition_radius3
NAMELIST /fire/ fire_ignition_start_time3
NAMELIST /fire/ fire_ignition_end_time3
NAMELIST /fire/ fire_ignition_ros4
NAMELIST /fire/ fire_ignition_start_lon4
NAMELIST /fire/ fire_ignition_start_lat4
NAMELIST /fire/ fire_ignition_end_lon4
NAMELIST /fire/ fire_ignition_end_lat4
NAMELIST /fire/ fire_ignition_radius4
NAMELIST /fire/ fire_ignition_start_time4
NAMELIST /fire/ fire_ignition_end_time4
NAMELIST /fire/ fire_ignition_ros5
NAMELIST /fire/ fire_ignition_start_lon5
NAMELIST /fire/ fire_ignition_start_lat5
NAMELIST /fire/ fire_ignition_end_lon5
NAMELIST /fire/ fire_ignition_end_lat5
NAMELIST /fire/ fire_ignition_radius5
NAMELIST /fire/ fire_ignition_start_time5
NAMELIST /fire/ fire_ignition_end_time5
NAMELIST /fire/ fire_ignition_start_x1
NAMELIST /fire/ fire_ignition_start_y1
NAMELIST /fire/ fire_ignition_end_x1
NAMELIST /fire/ fire_ignition_end_y1
NAMELIST /fire/ fire_ignition_start_x2
NAMELIST /fire/ fire_ignition_start_y2
NAMELIST /fire/ fire_ignition_end_x2
NAMELIST /fire/ fire_ignition_end_y2
NAMELIST /fire/ fire_ignition_start_x3
NAMELIST /fire/ fire_ignition_start_y3
NAMELIST /fire/ fire_ignition_end_x3
NAMELIST /fire/ fire_ignition_end_y3
NAMELIST /fire/ fire_ignition_start_x4
NAMELIST /fire/ fire_ignition_start_y4
NAMELIST /fire/ fire_ignition_end_x4
NAMELIST /fire/ fire_ignition_end_y4
NAMELIST /fire/ fire_ignition_start_x5
NAMELIST /fire/ fire_ignition_start_y5
NAMELIST /fire/ fire_ignition_end_x5
NAMELIST /fire/ fire_ignition_end_y5
NAMELIST /fire/ fire_lat_init
NAMELIST /fire/ fire_lon_init
NAMELIST /fire/ fire_ign_time
NAMELIST /fire/ fire_shape
NAMELIST /fire/ fire_sprd_mdl
NAMELIST /fire/ fire_crwn_hgt
NAMELIST /fire/ fire_ext_grnd
NAMELIST /fire/ fire_ext_crwn
NAMELIST /fire/ fire_wind_height
NAMELIST /fire/ fire_fuel_read
NAMELIST /fire/ fire_fuel_cat
NAMELIST /fire/ fire_print_msg
NAMELIST /fire/ fire_print_file
NAMELIST /fire/ fire_fuel_left_method
NAMELIST /fire/ fire_fuel_left_irl
NAMELIST /fire/ fire_fuel_left_jrl
NAMELIST /fire/ fire_grows_only
NAMELIST /fire/ fire_upwinding
NAMELIST /fire/ fire_upwind_split
NAMELIST /fire/ fire_viscosity
NAMELIST /fire/ fire_lfn_ext_up
NAMELIST /fire/ fire_topo_from_atm
NAMELIST /fire/ fire_advection
NAMELIST /fire/ fire_test_steps
NAMELIST /fire/ fire_const_time
NAMELIST /fire/ fire_const_grnhfx
NAMELIST /fire/ fire_const_grnqfx
NAMELIST /fire/ fire_atm_feedback
NAMELIST /fire/ fire_mountain_type
NAMELIST /fire/ fire_mountain_height
NAMELIST /fire/ fire_mountain_start_x
NAMELIST /fire/ fire_mountain_start_y
NAMELIST /fire/ fire_mountain_end_x
NAMELIST /fire/ fire_mountain_end_y
NAMELIST /fire/ delt_perturbation
NAMELIST /fire/ xrad_perturbation
NAMELIST /fire/ yrad_perturbation
NAMELIST /fire/ zrad_perturbation
NAMELIST /fire/ hght_perturbation
NAMELIST /fire/ stretch_grd
NAMELIST /fire/ stretch_hyp
NAMELIST /fire/ z_grd_scale
NAMELIST /fire/ sfc_full_init
NAMELIST /fire/ sfc_lu_index
NAMELIST /fire/ sfc_tsk
NAMELIST /fire/ sfc_tmn
NAMELIST /fire/ fire_read_lu
NAMELIST /fire/ fire_read_tsk
NAMELIST /fire/ fire_read_tmn
NAMELIST /fire/ fire_read_atm_ht
NAMELIST /fire/ fire_read_fire_ht
NAMELIST /fire/ fire_read_atm_grad
NAMELIST /fire/ fire_read_fire_grad
NAMELIST /fire/ sfc_vegfra
NAMELIST /fire/ sfc_canwat
NAMELIST /fire/ sfc_ivgtyp
NAMELIST /fire/ sfc_isltyp
NAMELIST /fire/ fire_lsm_reinit
NAMELIST /fire/ fire_lsm_reinit_iter
NAMELIST /fire/ fire_upwinding_reinit
NAMELIST /fire/ fire_is_real_perim
NAMELIST /fire/ fire_lsm_band_ngp
NAMELIST /fire/ fire_lsm_zcoupling
NAMELIST /fire/ fire_lsm_zcoupling_ref
NAMELIST /fire/ fire_tracer_smoke
NAMELIST /fire/ fire_viscosity_bg
NAMELIST /fire/ fire_viscosity_band
NAMELIST /fire/ fire_viscosity_ngp
NAMELIST /fire/ fire_slope_factor
NAMELIST /dynamics/ do_avgflx_em
NAMELIST /dynamics/ do_avgflx_cugd
NAMELIST /stoch/ nens
NAMELIST /stoch/ skebs
NAMELIST /stoch/ stoch_force_opt
NAMELIST /stoch/ skebs_vertstruc
NAMELIST /stoch/ stoch_vertstruc_opt
NAMELIST /stoch/ tot_backscat_psi
NAMELIST /stoch/ tot_backscat_t
NAMELIST /stoch/ ztau_psi
NAMELIST /stoch/ ztau_t
NAMELIST /stoch/ rexponent_psi
NAMELIST /stoch/ rexponent_t
NAMELIST /stoch/ zsigma2_eps
NAMELIST /stoch/ zsigma2_eta
NAMELIST /stoch/ kminforc
NAMELIST /stoch/ lminforc
NAMELIST /stoch/ kminforct
NAMELIST /stoch/ lminforct
NAMELIST /stoch/ kmaxforc
NAMELIST /stoch/ lmaxforc
NAMELIST /stoch/ kmaxforct
NAMELIST /stoch/ lmaxforct
NAMELIST /stoch/ iseed_skebs
NAMELIST /stoch/ sppt
NAMELIST /stoch/ gridpt_stddev_sppt
NAMELIST /stoch/ stddev_cutoff_sppt
NAMELIST /stoch/ lengthscale_sppt
NAMELIST /stoch/ timescale_sppt
NAMELIST /stoch/ sppt_vertstruc
NAMELIST /stoch/ iseed_sppt
NAMELIST /stoch/ rand_perturb
NAMELIST /stoch/ gridpt_stddev_rand_pert
NAMELIST /stoch/ stddev_cutoff_rand_pert
NAMELIST /stoch/ lengthscale_rand_pert
NAMELIST /stoch/ timescale_rand_pert
NAMELIST /stoch/ rand_pert_vertstruc
NAMELIST /stoch/ iseed_rand_pert
NAMELIST /stoch/ spp
NAMELIST /stoch/ hrrr_cycling
NAMELIST /stoch/ spp_conv
NAMELIST /stoch/ gridpt_stddev_spp_conv
NAMELIST /stoch/ stddev_cutoff_spp_conv
NAMELIST /stoch/ lengthscale_spp_conv
NAMELIST /stoch/ timescale_spp_conv
NAMELIST /stoch/ vertstruc_spp_conv
NAMELIST /stoch/ iseed_spp_conv
NAMELIST /stoch/ spp_pbl
NAMELIST /stoch/ gridpt_stddev_spp_pbl
NAMELIST /stoch/ stddev_cutoff_spp_pbl
NAMELIST /stoch/ lengthscale_spp_pbl
NAMELIST /stoch/ timescale_spp_pbl
NAMELIST /stoch/ vertstruc_spp_pbl
NAMELIST /stoch/ iseed_spp_pbl
NAMELIST /stoch/ spp_lsm
NAMELIST /stoch/ gridpt_stddev_spp_lsm
NAMELIST /stoch/ stddev_cutoff_spp_lsm
NAMELIST /stoch/ lengthscale_spp_lsm
NAMELIST /stoch/ timescale_spp_lsm
NAMELIST /stoch/ vertstruc_spp_lsm
NAMELIST /stoch/ iseed_spp_lsm
NAMELIST /dynamics/ sfs_opt
NAMELIST /dynamics/ m_opt
NAMELIST /physics/ lakedepth_default
NAMELIST /physics/ lake_min_elev
NAMELIST /physics/ use_lakedepth
NAMELIST /diags/ p_lev_diags
NAMELIST /diags/ p_lev_diags_dfi
NAMELIST /diags/ num_press_levels
NAMELIST /diags/ press_levels
NAMELIST /diags/ use_tot_or_hyd_p
NAMELIST /diags/ extrap_below_grnd
NAMELIST /diags/ p_lev_missing
NAMELIST /diags/ z_lev_diags
NAMELIST /diags/ z_lev_diags_dfi
NAMELIST /diags/ num_z_levels
NAMELIST /diags/ z_levels
NAMELIST /diags/ z_lev_missing
NAMELIST /afwa/ afwa_diag_opt
NAMELIST /afwa/ afwa_ptype_opt
NAMELIST /afwa/ afwa_vil_opt
NAMELIST /afwa/ afwa_radar_opt
NAMELIST /afwa/ afwa_severe_opt
NAMELIST /afwa/ afwa_icing_opt
NAMELIST /afwa/ afwa_vis_opt
NAMELIST /afwa/ afwa_cloud_opt
NAMELIST /afwa/ afwa_therm_opt
NAMELIST /afwa/ afwa_turb_opt
NAMELIST /afwa/ afwa_buoy_opt
NAMELIST /afwa/ afwa_ptype_ccn_tmp
NAMELIST /afwa/ afwa_ptype_tot_melt
NAMELIST /afwa/ afwa_bad_data_check
NAMELIST /time_control/ mean_diag
NAMELIST /time_control/ mean_freq
NAMELIST /time_control/ mean_interval
NAMELIST /time_control/ mean_diag_interval
NAMELIST /time_control/ mean_diag_interval_s
NAMELIST /time_control/ mean_diag_interval_m
NAMELIST /time_control/ mean_diag_interval_h
NAMELIST /time_control/ mean_diag_interval_d
NAMELIST /time_control/ mean_diag_interval_mo
NAMELIST /time_control/ diurnal_diag
NAMELIST /physics/ nssl_ipelec
NAMELIST /physics/ nssl_isaund
NAMELIST /physics/ nssl_iscreen
NAMELIST /physics/ nssl_lightrad
NAMELIST /physics/ nssl_idischarge
NAMELIST /physics/ nssl_ibrkd
NAMELIST /physics/ nssl_ecrit
NAMELIST /physics/ nssl_disfrac
NAMELIST /physics/ elec_physics
NAMELIST /stoch/ perturb_bdy
NAMELIST /stoch/ perturb_chem_bdy
NAMELIST /dynamics/ hybrid_opt
NAMELIST /dynamics/ etac
NAMELIST /domains/ num_wif_levels
NAMELIST /domains/ wif_input_opt
NAMELIST /diags/ diag_nwp2
NAMELIST /physics/ chem_opt


      OPEN ( UNIT   = nml_read_unit    ,      &
             FILE   = "namelist.input" ,      &
             FORM   = "FORMATTED"      ,      &
             STATUS = "OLD"            ,      &
             IOSTAT = io_status         )

      IF ( io_status .NE. 0 ) THEN
        CALL wrf_error_fatal3("<stdin>",8684,&
'ERROR OPENING namelist.input' )
      ENDIF

      OPEN ( UNIT   = nml_write_unit    ,      &
             FILE   = "namelist.output" ,      &
             FORM   = "FORMATTED"      ,      &
             STATUS = "REPLACE"        ,      &
             IOSTAT = io_status         )

      IF ( io_status .NE. 0 ) THEN
        CALL wrf_error_fatal3("<stdin>",8695,&
'ERROR OPENING namelist.output' )
      ENDIF








run_days = 0
run_hours = 0
run_minutes = 0
run_seconds = 0
start_year = 1993
start_month = 03
start_day = 13
start_hour = 12
start_minute = 00
start_second = 00
end_year = 1993
end_month = 03
end_day = 14
end_hour = 12
end_minute = 00
end_second = 00
interval_seconds = 10800
input_from_file = .false.
fine_input_stream = 0
input_from_hires = .false.
rsmas_data_path = "."
all_ic_times = .false.
julyr = 0
julday = 1
gmt = 0.
input_inname = "wrfinput_d<domain>"
input_outname = "wrfinput_d<domain>"
bdy_inname = "wrfbdy_d<domain>"
bdy_outname = "wrfbdy_d<domain>"
rst_inname = "wrfrst_d<domain>_<date>"
rst_outname = "wrfrst_d<domain>_<date>"
write_input = .false.
write_restart_at_0h = .false.
write_hist_at_0h_rst = .false.
adjust_output_times = .false.
adjust_input_times = .false.
diag_print = 0
nocolons = .false.
cycling = .false.
output_diagnostics = 0
nwp_diagnostics = 0
output_ready_flag = .false.
force_use_old_data = .false.
usepio = .false.
pioprocs = 0
piostart = 1
piostride = 1
pioshift = 1
dfi_opt = 0
dfi_savehydmeteors = 0
dfi_nfilter = 7
dfi_write_filtered_input = .true.
dfi_write_dfi_history = .false.
dfi_cutoff_seconds = 3600
dfi_time_dim = 1000
dfi_fwdstop_year = 2004
dfi_fwdstop_month = 03
dfi_fwdstop_day = 13
dfi_fwdstop_hour = 12
dfi_fwdstop_minute = 00
dfi_fwdstop_second = 00
dfi_bckstop_year = 2004
dfi_bckstop_month = 03
dfi_bckstop_day = 14
dfi_bckstop_hour = 12
dfi_bckstop_minute = 00
dfi_bckstop_second = 00
time_step = -1
time_step_fract_num = 0
time_step_fract_den = 1
time_step_dfi = -1
min_time_step = -1
min_time_step_den = 0
max_time_step = -1
max_time_step_den = 0
target_cfl = 1.2
target_hcfl = 0.84
max_step_increase_pct = 5
starting_time_step = -1
starting_time_step_den = 0
step_to_output_time = .true.
adaptation_domain = 1
use_adaptive_time_step = .false.
use_adaptive_time_step_dfi = .false.
max_dom = 1
lats_to_mic = 0
s_we = 1
e_we = 32
s_sn = 1
e_sn = 32
s_vert = 1
e_vert = 31
num_metgrid_levels = 27
num_metgrid_soil_levels = 4
p_top_requested = 5000
interp_theta = .false.
interp_type = 2
rebalance = 0
vert_refine_method = 0
vert_refine_fact = 1
extrap_type = 2
t_extrap_type = 2
hypsometric_opt = 2
lowest_lev_from_sfc = .false.
use_levels_below_ground = .true.
use_tavg_for_tsk = .false.
use_surface = .true.
lagrange_order = 2
linear_interp = 1
force_sfc_in_vinterp = 1
zap_close_levels = 500
maxw_horiz_pres_diff = 5000
trop_horiz_pres_diff = 5000
maxw_above_this_level = 30000
use_maxw_level = 0
use_trop_level = 0
sfcp_to_sfcp = .false.
adjust_heights = .false.
smooth_cg_topo = .false.
nest_interp_coord = 0
interp_method_type = 2
aggregate_lu = .false.
rh2qv_wrt_liquid = .true.
rh2qv_method = 1
qv_max_p_safe = 10000
qv_max_flag = 1.e-5
qv_max_value = 3.e-6
qv_min_p_safe = 110000
qv_min_flag = 1.e-6
qv_min_value = 1.e-6
ideal_init_method = 1
dx = 200
dy = 200
grid_id = 1
grid_allowed = .true.
parent_id = 0
i_parent_start = 1
j_parent_start = 1
parent_grid_ratio = 1
parent_time_step_ratio = 1
feedback = 1
smooth_option = 2
blend_width = 5
ztop = 15000.
moad_grid_ratio = 1
moad_time_step_ratio = 1
shw = 2
tile_sz_x = 0
tile_sz_y = 0
numtiles = 1
numtiles_inc = 0
numtiles_x = 0
numtiles_y = 0
tile_strategy = 0
nproc_x = -1
nproc_y = -1
irand = 0
dt = 2.
fft_used = 0
cu_used = 0
shcu_used = 0
cam_used = 0
alloc_qndropsource = 0
num_moves = 0
ts_buf_size = 200
max_ts_locs = 5
tslist_ij = .false.
tslist_unstagger_winds = .false.
vortex_interval = 15
max_vortex_speed = 40
corral_dist = 8
track_level = 50000
time_to_move = 0.
move_id = 0
move_interval = 999999999
move_cd_x = 0
move_cd_y = 0
swap_x = .false.
swap_y = .false.
cycle_x = .false.
cycle_y = .false.
reorder_mesh = .false.
perturb_input = .false.
eta_levels = -1.
auto_levels_opt = 2
max_dz = 1000.
dzbot = 50.
dzstretch_s = 1.3
dzstretch_u = 1.1
ocean_levels = 30
ocean_z = -1
ocean_t = -1
ocean_s = -1
num_traj = 1000
max_ts_level = 15
track_loc_in = 0
num_ext_model_couple_dom = 1
insert_bogus_storm = .false.
remove_storm = .false.
num_storm = 1
latc_loc = -999.
lonc_loc = -999.
vmax_meters_per_second = -999.
rmax = -999.
vmax_ratio = -999.
rankine_lid = -999.
physics_suite = "none"
force_read_thompson = .false.
write_thompson_tables = .true.
mp_physics = -1
nssl_cccn = 0.5e9
nssl_alphah = 0
nssl_alphahl = 1
nssl_cnoh = 4.e5
nssl_cnohl = 4.e4
nssl_cnor = 8.e5
nssl_cnos = 3.e6
nssl_rho_qh = 500.
nssl_rho_qhl = 900.
nssl_rho_qs = 100.
nudge_lightning = 0
nudge_light_times = 0
nudge_light_timee = 7200
nudge_light_int = 600
path_to_files = "~/WRFV3/"
gsfcgce_hail = 0
gsfcgce_2ice = 0
progn = 0
accum_mode = 1000.0e6
aitken_mode = 300.0e6
coarse_mode = 0.2e6
do_radar_ref = 0
compute_radar_ref = 0
ra_lw_physics = -1
ra_sw_physics = -1
radt = 0
naer = 1e9
sf_sfclay_physics = -1
sf_surface_physics = -1
bl_pbl_physics = -1
bl_mynn_tkebudget = 0
ysu_topdown_pblmix = 0
shinhong_tke_diag = 0
bl_mynn_tkeadvect = .false.
bl_mynn_cloudpdf = 2
bl_mynn_mixlength = 1
bl_mynn_edmf = 1
bl_mynn_edmf_mom = 1
bl_mynn_edmf_tke = 0
bl_mynn_mixscalars = 0
bl_mynn_cloudmix = 1
bl_mynn_mixqt = 0
icloud_bl = 1
mfshconv = 1
sf_urban_physics = 0
bldt = 0
cu_physics = -1
shcu_physics = 0
cu_diag = 0
kf_edrates = 0
kfeta_trigger = 1
nsas_dx_factor = 0
cudt = 0
gsmdt = 0
isfflx = 1
ifsnow = 1
icloud = 1
cldovrlp = 2
ideal_xland = 1
swrad_scat = 1
surface_input_source = 3
num_soil_layers = 5
maxpatch = 10
num_snow_layers = 3
num_snso_layers = 7
num_urban_ndm = 1
num_urban_ng = 1
num_urban_nwr = 1
num_urban_ngb = 1
num_urban_nf = 1
num_urban_nz = 1
num_urban_nbui = 1
urban_map_zrd = 1
urban_map_zwd = 1
urban_map_gd = 1
urban_map_zd = 1
urban_map_zdf = 1
urban_map_bd = 1
urban_map_wd = 1
urban_map_gbd = 1
urban_map_fbd = 1
num_urban_hi = 15
num_months = 12
sf_surface_mosaic = 0
mosaic_cat = 3
mosaic_cat_soil = 12
mosaic_lu = 0
mosaic_soil = 0
flag_sm_adj = 0
maxiens = 1
maxens = 3
maxens2 = 3
maxens3 = 16
ensdim = 144
cugd_avedx = 1
clos_choice = 0
imomentum = 0
ishallow = 0
convtrans_avglen_m = 30
num_land_cat = 21
num_soil_cat = 16
mp_zero_out = 0
mp_zero_out_thresh = 1.e-8
seaice_threshold = 100
sst_update = 0
sst_skin = 0
tmn_update = 0
usemonalb = .false.
rdmaxalb = .true.
rdlai2d = .false.
ua_phys = .false.
opt_thcnd = 1
co2tf = 1
ra_call_offset = 0
cam_abs_freq_s = 21600.
levsiz = 1
paerlev = 1
cam_abs_dim1 = 1
cam_abs_dim2 = 1
lagday = 150
no_src_types = 1
alevsiz = 1
o3input = 2
aer_opt = 0
swint_opt = 0
aer_type = 1
aer_aod550_opt = 1
aer_angexp_opt = 1
aer_ssa_opt = 1
aer_asy_opt = 1
aer_aod550_val = 0.12
aer_angexp_val = 1.3
aer_ssa_val = 0.85
aer_asy_val = 0.90
cu_rad_feedback = .false.
dust_emis = 0
erosion_dim = 3
no_src_types_cu = 1
alevsiz_cu = 1
aercu_opt = 0
aercu_fct = 1.0
aercu_used = 0
shallowcu_forced_ra = .false.
numbins = 1
thbinsize = 1
rbinsize = 1
mindeepfreq = 1
minshallowfreq = 1
shcu_aerosols_opt = 0
icloud_cu = 0
pxlsm_smois_init = 1
pxlsm_modis_veg = 0
omlcall = 0
sf_ocean_physics = 0
traj_opt = 0
dm_has_traj = .false.
tracercall = 0
omdt = 1
oml_hml0 = 50
oml_gamma = 0.14
oml_relaxation_time = 0.
isftcflx = 0
iz0tlnd = 0
shadlen = 25000.
slope_rad = 0
topo_shading = 0
topo_wind = 0
no_mp_heating = 0
fractional_seaice = 0
seaice_snowdepth_opt = 0
seaice_snowdepth_max = 1.e10
seaice_snowdepth_min = 0.001
seaice_albedo_opt = 0
seaice_albedo_default = 0.65
seaice_thickness_opt = 0
seaice_thickness_default = 3.0
tice2tsk_if2cold = .false.
bucket_mm = -1.
bucket_j = -1.
mp_tend_lim = 10.
prec_acc_dt = 0.
prec_acc_opt = 0
bucketr_opt = 0
bucketf_opt = 0
process_time_series = 0
grav_settling = 0
sas_pgcon = 0.55
scalar_pblmix = 0
tracer_pblmix = 1
use_aero_icbc = .false.
use_rap_aero_icbc = .false.
use_mp_re = 1
ccn_conc = 1.0e8
hail_opt = 0
morr_rimed_ice = 1
clean_atm_diag = 0
calc_clean_atm_diag = 0
dveg = 4
opt_crs = 1
opt_btr = 1
opt_run = 3
opt_sfc = 1
opt_frz = 1
opt_inf = 1
opt_rad = 3
opt_alb = 2
opt_snf = 1
opt_tbot = 2
opt_stc = 1
opt_gla = 1
opt_rsf = 1
opt_soil = 1
opt_pedo = 1
opt_crop = 0
wtddt = 30.
wrf_hydro = 0
fgdt = 0
fgdtzero = 0
grid_fdda = 0
grid_sfdda = 0
if_no_pbl_nudging_uv = 0
if_no_pbl_nudging_t = 0
if_no_pbl_nudging_ph = 0
if_no_pbl_nudging_q = 0
if_zfac_uv = 0
k_zfac_uv = 0
if_zfac_t = 0
k_zfac_t = 0
if_zfac_ph = 0
k_zfac_ph = 0
if_zfac_q = 0
k_zfac_q = 0
dk_zfac_uv = 1
dk_zfac_t = 1
dk_zfac_ph = 1
dk_zfac_q = 1
ktrop = 0
guv = 0
guv_sfc = 0
gt = 0
gt_sfc = 0
gq = 0
gq_sfc = 0
gph = 0
dtramp_min = 0
if_ramping = 0
rinblw = 0
xwavenum = 0
ywavenum = 0
pxlsm_soil_nudge = 0
fasdas = 0
obs_nudge_opt = 0
max_obs = 0
fdda_start = 0
fdda_end = 0
obs_nudge_wind = 0
obs_coef_wind = 0
obs_nudge_temp = 0
obs_coef_temp = 0
obs_nudge_mois = 0
obs_coef_mois = 0
obs_nudge_pstr = 0
obs_coef_pstr = 0
obs_no_pbl_nudge_uv = 0
obs_no_pbl_nudge_t = 0
obs_no_pbl_nudge_q = 0
obs_sfc_scheme_horiz = 0
obs_sfc_scheme_vert = 0
obs_max_sndng_gap = 20
obs_nudgezfullr1_uv = 50
obs_nudgezrampr1_uv = 50
obs_nudgezfullr2_uv = 50
obs_nudgezrampr2_uv = 50
obs_nudgezfullr4_uv = -5000
obs_nudgezrampr4_uv = 50
obs_nudgezfullr1_t = 50
obs_nudgezrampr1_t = 50
obs_nudgezfullr2_t = 50
obs_nudgezrampr2_t = 50
obs_nudgezfullr4_t = -5000
obs_nudgezrampr4_t = 50
obs_nudgezfullr1_q = 50
obs_nudgezrampr1_q = 50
obs_nudgezfullr2_q = 50
obs_nudgezrampr2_q = 50
obs_nudgezfullr4_q = -5000
obs_nudgezrampr4_q = 50
obs_nudgezfullmin = 50
obs_nudgezrampmin = 50
obs_nudgezmax = 3000
obs_sfcfact = 1.0
obs_sfcfacr = 1.0
obs_dpsmx = 7.5
obs_rinxy = 0
obs_rinsig = 0
obs_twindo = 0
obs_npfi = 0
obs_ionf = 1
obs_idynin = 0
obs_dtramp = 0
obs_prt_max = 1000
obs_prt_freq = 1000
obs_ipf_in4dob = .false.
obs_ipf_errob = .false.
obs_ipf_nudob = .false.
obs_ipf_init = .true.
obs_scl_neg_qv_innov = 0
scm_force = 0
scm_force_dx = 4000.
num_force_layers = 8
scm_lu_index = 2
scm_isltyp = 4
scm_vegfra = 50.
scm_canwat = 0.0
scm_lat = 36.605
scm_lon = -97.485
scm_th_t_tend = .true.
scm_qv_t_tend = .true.
scm_th_adv = .true.
scm_wind_adv = .true.
scm_qv_adv = .true.
scm_ql_adv = .false.
scm_vert_adv = .true.
num_force_soil_layers = 5
scm_soilt_force = .false.
scm_soilq_force = .false.
scm_force_th_largescale = .false.
scm_force_qv_largescale = .false.
scm_force_ql_largescale = .false.
scm_force_wind_largescale = .false.
scm_force_skintemp = 0
scm_force_flux = 0
dyn_opt = 2
rk_ord = 3
w_damping = 0
diff_opt = -1
diff_opt_dfi = 0
km_opt = -1
km_opt_dfi = 1
damp_opt = 0
rad_nudge = 0
gwd_opt = 0
max_rot_angle_gwd = 22.5
zdamp = 5000.
dampcoef = 0.
khdif = 0
kvdif = 0
diff_6th_factor = 0.12
diff_6th_opt = 0
diff_6th_slopeopt = 0
diff_6th_thresh = 0.10
use_theta_m = 1
use_q_diabatic = 0
c_s = 0.25
c_k = 0.15
smdiv = 0.1
emdiv = 0.01
epssm = .1
non_hydrostatic = .true.
use_input_w = .false.
time_step_sound = 0
h_mom_adv_order = 5
v_mom_adv_order = 3
h_sca_adv_order = 5
v_sca_adv_order = 3
momentum_adv_opt = 1
moist_adv_opt = 1
moist_adv_dfi_opt = 0
chem_adv_opt = 1
tracer_adv_opt = 1
scalar_adv_opt = 1
tke_adv_opt = 1
moist_mix2_off = .false.
chem_mix2_off = .false.
tracer_mix2_off = .false.
scalar_mix2_off = .false.
tke_mix2_off = .false.
moist_mix6_off = .false.
chem_mix6_off = .false.
tracer_mix6_off = .false.
scalar_mix6_off = .false.
tke_mix6_off = .false.
top_radiation = .false.
mix_isotropic = 0
mix_upper_bound = 0.1
top_lid = .false.
tke_upper_bound = 1000.
tke_drag_coefficient = 0.
tke_heat_flux = 0.
pert_coriolis = .false.
coriolis2d = .false.
mix_full_fields = .false.
base_pres = 100000.
base_temp = 290.
base_lapse = 50.
iso_temp = 200.00
base_pres_strat = 0.
base_lapse_strat = -11.
use_baseparam_fr_nml = .false.
fft_filter_lat = 91.
coupled_filtering = .true.
pos_def = .false.
swap_pole_with_next_j = .false.
actual_distance_average = .false.
rotated_pole = .false.
do_coriolis = .true.
do_curvature = .true.
do_gradp = .true.
tracer_opt = 0
tenddiag = 0
spec_bdy_width = 5
spec_zone = 1
relax_zone = 4
specified = .false.
constant_bc = .false.
periodic_x = .false.
symmetric_xs = .false.
symmetric_xe = .false.
open_xs = .false.
open_xe = .false.
periodic_y = .false.
symmetric_ys = .false.
symmetric_ye = .false.
open_ys = .false.
open_ye = .false.
polar = .false.
nested = .false.
spec_exp = 0.
spec_bdy_final_mu = 1
real_data_init_type = 1
have_bcs_moist = .false.
have_bcs_scalar = .false.
background_proc_id = 255
forecast_proc_id = 255
production_status = 255
compression = 40
nobs_ndg_vars = 6
nobs_err_flds = 10
cen_lat = 0
cen_lon = 0
truelat1 = 0
truelat2 = 0
moad_cen_lat = 0
stand_lon = 0
pole_lat = 0
pole_lon = 0
flag_metgrid = 0
flag_snow = 0
flag_psfc = 0
flag_sm000010 = 0
flag_sm010040 = 0
flag_sm040100 = 0
flag_sm100200 = 0
flag_st000010 = 0
flag_st010040 = 0
flag_st040100 = 0
flag_st100200 = 0
flag_soil_layers = 0
flag_slp = 0
flag_soilhgt = 0
flag_mf_xy = 0
flag_um_soil = 0
bdyfrq = 0
mminlu = " "
iswater = 0
islake = 0
isice = 0
isurban = 0
isoilwater = 0
map_proj = 0
use_wps_input = 0
dfi_stage = 3
mp_physics_dfi = -1
bl_pbl_physics_dfi = -1
windfarm_opt = 0
windfarm_ij = 0
ideal_case = 0
hailcast_opt = 0
haildt = 0
lightning_option = 0
lightning_dt = 0.
lightning_start_seconds = 0.
flashrate_factor = 1.0
iccg_method = 0
iccg_prescribed_num = 0.0
iccg_prescribed_den = 1.0
cellcount_method = 0
cldtop_adjustment = 0.
sf_lake_physics = 0
auxinput1_inname = "met_em.d<domain>.<date>"
io_form_auxinput1 = 2
override_restart_timers = .false.
auxhist1_inname = "auxhist1_d<domain>_<date>"
auxhist1_outname = "auxhist1_d<domain>_<date>"
auxhist1_interval_y = 0
auxhist1_interval_d = 0
auxhist1_interval_h = 0
auxhist1_interval_m = 0
auxhist1_interval_s = 0
auxhist1_interval = 0
auxhist1_begin_y = 0
auxhist1_begin_d = 0
auxhist1_begin_h = 0
auxhist1_begin_m = 0
auxhist1_begin_s = 0
auxhist1_begin = 0
auxhist1_end_y = 0
auxhist1_end_d = 0
auxhist1_end_h = 0
auxhist1_end_m = 0
auxhist1_end_s = 0
auxhist1_end = 0
io_form_auxhist1 = 0
frames_per_auxhist1 = 999999
auxhist2_inname = "auxhist2_d<domain>_<date>"
auxhist2_outname = "auxhist2_d<domain>_<date>"
auxhist2_interval_y = 0
auxhist2_interval_d = 0
auxhist2_interval_h = 0
auxhist2_interval_m = 0
auxhist2_interval_s = 0
auxhist2_interval = 0
auxhist2_begin_y = 0
auxhist2_begin_d = 0
auxhist2_begin_h = 0
auxhist2_begin_m = 0
auxhist2_begin_s = 0
auxhist2_begin = 0
auxhist2_end_y = 0
auxhist2_end_d = 0
auxhist2_end_h = 0
auxhist2_end_m = 0
auxhist2_end_s = 0
auxhist2_end = 0
io_form_auxhist2 = 0
frames_per_auxhist2 = 999999
auxhist3_inname = "auxhist3_d<domain>_<date>"
auxhist3_outname = "auxhist3_d<domain>_<date>"
auxhist3_interval_y = 0
auxhist3_interval_d = 0
auxhist3_interval_h = 0
auxhist3_interval_m = 0
auxhist3_interval_s = 0
auxhist3_interval = 0
auxhist3_begin_y = 0
auxhist3_begin_d = 0
auxhist3_begin_h = 0
auxhist3_begin_m = 0
auxhist3_begin_s = 0
auxhist3_begin = 0
auxhist3_end_y = 0
auxhist3_end_d = 0
auxhist3_end_h = 0
auxhist3_end_m = 0
auxhist3_end_s = 0
auxhist3_end = 0
io_form_auxhist3 = 0
frames_per_auxhist3 = 999999
auxhist4_inname = "auxhist4_d<domain>_<date>"
auxhist4_outname = "auxhist4_d<domain>_<date>"
auxhist4_interval_y = 0
auxhist4_interval_d = 0
auxhist4_interval_h = 0
auxhist4_interval_m = 0
auxhist4_interval_s = 0
auxhist4_interval = 0
auxhist4_begin_y = 0
auxhist4_begin_d = 0
auxhist4_begin_h = 0
auxhist4_begin_m = 0
auxhist4_begin_s = 0
auxhist4_begin = 0
auxhist4_end_y = 0
auxhist4_end_d = 0
auxhist4_end_h = 0
auxhist4_end_m = 0
auxhist4_end_s = 0
auxhist4_end = 0
io_form_auxhist4 = 0
frames_per_auxhist4 = 999999
auxhist5_inname = "auxhist5_d<domain>_<date>"
auxhist5_outname = "auxhist5_d<domain>_<date>"
auxhist5_interval_y = 0
auxhist5_interval_d = 0
auxhist5_interval_h = 0
auxhist5_interval_m = 0
auxhist5_interval_s = 0
auxhist5_interval = 0
auxhist5_begin_y = 0
auxhist5_begin_d = 0
auxhist5_begin_h = 0
auxhist5_begin_m = 0
auxhist5_begin_s = 0
auxhist5_begin = 0
auxhist5_end_y = 0
auxhist5_end_d = 0
auxhist5_end_h = 0
auxhist5_end_m = 0
auxhist5_end_s = 0
auxhist5_end = 0
io_form_auxhist5 = 0
frames_per_auxhist5 = 999999
auxhist6_inname = "auxhist6_d<domain>_<date>"
auxhist6_outname = "auxhist6_d<domain>_<date>"
auxhist6_interval_y = 0
auxhist6_interval_d = 0
auxhist6_interval_h = 0
auxhist6_interval_m = 0
auxhist6_interval_s = 0
auxhist6_interval = 0
auxhist6_begin_y = 0
auxhist6_begin_d = 0
auxhist6_begin_h = 0
auxhist6_begin_m = 0
auxhist6_begin_s = 0
auxhist6_begin = 0
auxhist6_end_y = 0
auxhist6_end_d = 0
auxhist6_end_h = 0
auxhist6_end_m = 0
auxhist6_end_s = 0
auxhist6_end = 0
io_form_auxhist6 = 0
frames_per_auxhist6 = 999999
auxhist7_inname = "auxhist7_d<domain>_<date>"
auxhist7_outname = "auxhist7_d<domain>_<date>"
auxhist7_interval_y = 0
auxhist7_interval_d = 0
auxhist7_interval_h = 0
auxhist7_interval_m = 0
auxhist7_interval_s = 0
auxhist7_interval = 0
auxhist7_begin_y = 0
auxhist7_begin_d = 0
auxhist7_begin_h = 0
auxhist7_begin_m = 0
auxhist7_begin_s = 0
auxhist7_begin = 0
auxhist7_end_y = 0
auxhist7_end_d = 0
auxhist7_end_h = 0
auxhist7_end_m = 0
auxhist7_end_s = 0
auxhist7_end = 0
io_form_auxhist7 = 0
frames_per_auxhist7 = 999999
auxhist8_inname = "auxhist8_d<domain>_<date>"
auxhist8_outname = "auxhist8_d<domain>_<date>"
auxhist8_interval_y = 0
auxhist8_interval_d = 0
auxhist8_interval_h = 0
auxhist8_interval_m = 0
auxhist8_interval_s = 0
auxhist8_interval = 0
auxhist8_begin_y = 0
auxhist8_begin_d = 0
auxhist8_begin_h = 0
auxhist8_begin_m = 0
auxhist8_begin_s = 0
auxhist8_begin = 0
auxhist8_end_y = 0
auxhist8_end_d = 0
auxhist8_end_h = 0
auxhist8_end_m = 0
auxhist8_end_s = 0
auxhist8_end = 0
io_form_auxhist8 = 0
frames_per_auxhist8 = 999999
auxhist9_inname = "auxhist9_d<domain>_<date>"
auxhist9_outname = "auxhist9_d<domain>_<date>"
auxhist9_interval_y = 0
auxhist9_interval_d = 0
auxhist9_interval_h = 0
auxhist9_interval_m = 0
auxhist9_interval_s = 0
auxhist9_interval = 0
auxhist9_begin_y = 0
auxhist9_begin_d = 0
auxhist9_begin_h = 0
auxhist9_begin_m = 0
auxhist9_begin_s = 0
auxhist9_begin = 0
auxhist9_end_y = 0
auxhist9_end_d = 0
auxhist9_end_h = 0
auxhist9_end_m = 0
auxhist9_end_s = 0
auxhist9_end = 0
io_form_auxhist9 = 0
frames_per_auxhist9 = 999999
auxhist10_inname = "auxhist10_d<domain>_<date>"
auxhist10_outname = "auxhist10_d<domain>_<date>"
auxhist10_interval_y = 0
auxhist10_interval_d = 0
auxhist10_interval_h = 0
auxhist10_interval_m = 0
auxhist10_interval_s = 0
auxhist10_interval = 0
auxhist10_begin_y = 0
auxhist10_begin_d = 0
auxhist10_begin_h = 0
auxhist10_begin_m = 0
auxhist10_begin_s = 0
auxhist10_begin = 0
auxhist10_end_y = 0
auxhist10_end_d = 0
auxhist10_end_h = 0
auxhist10_end_m = 0
auxhist10_end_s = 0
auxhist10_end = 0
io_form_auxhist10 = 0
frames_per_auxhist10 = 999999
auxhist11_inname = "auxhist11_d<domain>_<date>"
auxhist11_outname = "auxhist11_d<domain>_<date>"
auxhist11_interval_y = 0
auxhist11_interval_d = 0
auxhist11_interval_h = 0
auxhist11_interval_m = 0
auxhist11_interval_s = 0
auxhist11_interval = 0
auxhist11_begin_y = 0
auxhist11_begin_d = 0
auxhist11_begin_h = 0
auxhist11_begin_m = 0
auxhist11_begin_s = 0
auxhist11_begin = 0
auxhist11_end_y = 0
auxhist11_end_d = 0
auxhist11_end_h = 0
auxhist11_end_m = 0
auxhist11_end_s = 0
auxhist11_end = 0
io_form_auxhist11 = 0
frames_per_auxhist11 = 999999
auxhist12_inname = "auxhist12_d<domain>_<date>"
auxhist12_outname = "auxhist12_d<domain>_<date>"
auxhist12_interval_y = 0
auxhist12_interval_d = 0
auxhist12_interval_h = 0
auxhist12_interval_m = 0
auxhist12_interval_s = 0
auxhist12_interval = 0
auxhist12_begin_y = 0
auxhist12_begin_d = 0
auxhist12_begin_h = 0
auxhist12_begin_m = 0
auxhist12_begin_s = 0
auxhist12_begin = 0
auxhist12_end_y = 0
auxhist12_end_d = 0
auxhist12_end_h = 0
auxhist12_end_m = 0
auxhist12_end_s = 0
auxhist12_end = 0
io_form_auxhist12 = 0
frames_per_auxhist12 = 999999
auxhist13_inname = "auxhist13_d<domain>_<date>"
auxhist13_outname = "auxhist13_d<domain>_<date>"
auxhist13_interval_y = 0
auxhist13_interval_d = 0
auxhist13_interval_h = 0
auxhist13_interval_m = 0
auxhist13_interval_s = 0
auxhist13_interval = 0
auxhist13_begin_y = 0
auxhist13_begin_d = 0
auxhist13_begin_h = 0
auxhist13_begin_m = 0
auxhist13_begin_s = 0
auxhist13_begin = 0
auxhist13_end_y = 0
auxhist13_end_d = 0
auxhist13_end_h = 0
auxhist13_end_m = 0
auxhist13_end_s = 0
auxhist13_end = 0
io_form_auxhist13 = 0
frames_per_auxhist13 = 999999
auxhist14_inname = "auxhist14_d<domain>_<date>"
auxhist14_outname = "auxhist14_d<domain>_<date>"
auxhist14_interval_y = 0
auxhist14_interval_d = 0
auxhist14_interval_h = 0
auxhist14_interval_m = 0
auxhist14_interval_s = 0
auxhist14_interval = 0
auxhist14_begin_y = 0
auxhist14_begin_d = 0
auxhist14_begin_h = 0
auxhist14_begin_m = 0
auxhist14_begin_s = 0
auxhist14_begin = 0
auxhist14_end_y = 0
auxhist14_end_d = 0
auxhist14_end_h = 0
auxhist14_end_m = 0
auxhist14_end_s = 0
auxhist14_end = 0
io_form_auxhist14 = 0
frames_per_auxhist14 = 999999
auxhist15_inname = "auxhist15_d<domain>_<date>"
auxhist15_outname = "auxhist15_d<domain>_<date>"
auxhist15_interval_y = 0
auxhist15_interval_d = 0
auxhist15_interval_h = 0
auxhist15_interval_m = 0
auxhist15_interval_s = 0
auxhist15_interval = 0
auxhist15_begin_y = 0
auxhist15_begin_d = 0
auxhist15_begin_h = 0
auxhist15_begin_m = 0
auxhist15_begin_s = 0
auxhist15_begin = 0
auxhist15_end_y = 0
auxhist15_end_d = 0
auxhist15_end_h = 0
auxhist15_end_m = 0
auxhist15_end_s = 0
auxhist15_end = 0
io_form_auxhist15 = 0
frames_per_auxhist15 = 999999
auxhist16_inname = "auxhist16_d<domain>_<date>"
auxhist16_outname = "auxhist16_d<domain>_<date>"
auxhist16_interval_y = 0
auxhist16_interval_d = 0
auxhist16_interval_h = 0
auxhist16_interval_m = 0
auxhist16_interval_s = 0
auxhist16_interval = 0
auxhist16_begin_y = 0
auxhist16_begin_d = 0
auxhist16_begin_h = 0
auxhist16_begin_m = 0
auxhist16_begin_s = 0
auxhist16_begin = 0
auxhist16_end_y = 0
auxhist16_end_d = 0
auxhist16_end_h = 0
auxhist16_end_m = 0
auxhist16_end_s = 0
auxhist16_end = 0
io_form_auxhist16 = 0
frames_per_auxhist16 = 999999
auxhist17_inname = "auxhist17_d<domain>_<date>"
auxhist17_outname = "auxhist17_d<domain>_<date>"
auxhist17_interval_y = 0
auxhist17_interval_d = 0
auxhist17_interval_h = 0
auxhist17_interval_m = 0
auxhist17_interval_s = 0
auxhist17_interval = 0
auxhist17_begin_y = 0
auxhist17_begin_d = 0
auxhist17_begin_h = 0
auxhist17_begin_m = 0
auxhist17_begin_s = 0
auxhist17_begin = 0
auxhist17_end_y = 0
auxhist17_end_d = 0
auxhist17_end_h = 0
auxhist17_end_m = 0
auxhist17_end_s = 0
auxhist17_end = 0
io_form_auxhist17 = 0
frames_per_auxhist17 = 999999
auxhist18_inname = "auxhist18_d<domain>_<date>"
auxhist18_outname = "auxhist18_d<domain>_<date>"
auxhist18_interval_y = 0
auxhist18_interval_d = 0
auxhist18_interval_h = 0
auxhist18_interval_m = 0
auxhist18_interval_s = 0
auxhist18_interval = 0
auxhist18_begin_y = 0
auxhist18_begin_d = 0
auxhist18_begin_h = 0
auxhist18_begin_m = 0
auxhist18_begin_s = 0
auxhist18_begin = 0
auxhist18_end_y = 0
auxhist18_end_d = 0
auxhist18_end_h = 0
auxhist18_end_m = 0
auxhist18_end_s = 0
auxhist18_end = 0
io_form_auxhist18 = 0
frames_per_auxhist18 = 999999
auxhist19_inname = "auxhist19_d<domain>_<date>"
auxhist19_outname = "auxhist19_d<domain>_<date>"
auxhist19_interval_y = 0
auxhist19_interval_d = 0
auxhist19_interval_h = 0
auxhist19_interval_m = 0
auxhist19_interval_s = 0
auxhist19_interval = 0
auxhist19_begin_y = 0
auxhist19_begin_d = 0
auxhist19_begin_h = 0
auxhist19_begin_m = 0
auxhist19_begin_s = 0
auxhist19_begin = 0
auxhist19_end_y = 0
auxhist19_end_d = 0
auxhist19_end_h = 0
auxhist19_end_m = 0
auxhist19_end_s = 0
auxhist19_end = 0
io_form_auxhist19 = 0
frames_per_auxhist19 = 999999
auxhist20_inname = "auxhist20_d<domain>_<date>"
auxhist20_outname = "auxhist20_d<domain>_<date>"
auxhist20_interval_y = 0
auxhist20_interval_d = 0
auxhist20_interval_h = 0
auxhist20_interval_m = 0
auxhist20_interval_s = 0
auxhist20_interval = 0
auxhist20_begin_y = 0
auxhist20_begin_d = 0
auxhist20_begin_h = 0
auxhist20_begin_m = 0
auxhist20_begin_s = 0
auxhist20_begin = 0
auxhist20_end_y = 0
auxhist20_end_d = 0
auxhist20_end_h = 0
auxhist20_end_m = 0
auxhist20_end_s = 0
auxhist20_end = 0
io_form_auxhist20 = 0
frames_per_auxhist20 = 999999
auxhist21_inname = "auxhist21_d<domain>_<date>"
auxhist21_outname = "auxhist21_d<domain>_<date>"
auxhist21_interval_y = 0
auxhist21_interval_d = 0
auxhist21_interval_h = 0
auxhist21_interval_m = 0
auxhist21_interval_s = 0
auxhist21_interval = 0
auxhist21_begin_y = 0
auxhist21_begin_d = 0
auxhist21_begin_h = 0
auxhist21_begin_m = 0
auxhist21_begin_s = 0
auxhist21_begin = 0
auxhist21_end_y = 0
auxhist21_end_d = 0
auxhist21_end_h = 0
auxhist21_end_m = 0
auxhist21_end_s = 0
auxhist21_end = 0
io_form_auxhist21 = 0
frames_per_auxhist21 = 999999
auxhist22_inname = "auxhist22_d<domain>_<date>"
auxhist22_outname = "auxhist22_d<domain>_<date>"
auxhist22_interval_y = 0
auxhist22_interval_d = 0
auxhist22_interval_h = 0
auxhist22_interval_m = 0
auxhist22_interval_s = 0
auxhist22_interval = 0
auxhist22_begin_y = 0
auxhist22_begin_d = 0
auxhist22_begin_h = 0
auxhist22_begin_m = 0
auxhist22_begin_s = 0
auxhist22_begin = 0
auxhist22_end_y = 0
auxhist22_end_d = 0
auxhist22_end_h = 0
auxhist22_end_m = 0
auxhist22_end_s = 0
auxhist22_end = 0
io_form_auxhist22 = 0
frames_per_auxhist22 = 999999
auxhist23_inname = "auxhist23_d<domain>_<date>"
auxhist23_outname = "auxhist23_d<domain>_<date>"
auxhist23_interval_y = 0
auxhist23_interval_d = 0
auxhist23_interval_h = 0
auxhist23_interval_m = 0
auxhist23_interval_s = 0
auxhist23_interval = 0
auxhist23_begin_y = 0
auxhist23_begin_d = 0
auxhist23_begin_h = 0
auxhist23_begin_m = 0
auxhist23_begin_s = 0
auxhist23_begin = 0
auxhist23_end_y = 0
auxhist23_end_d = 0
auxhist23_end_h = 0
auxhist23_end_m = 0
auxhist23_end_s = 0
auxhist23_end = 0
io_form_auxhist23 = 0
frames_per_auxhist23 = 999999
auxhist24_inname = "auxhist24_d<domain>_<date>"
auxhist24_outname = "auxhist24_d<domain>_<date>"
auxhist24_interval_y = 0
auxhist24_interval_d = 0
auxhist24_interval_h = 0
auxhist24_interval_m = 0
auxhist24_interval_s = 0
auxhist24_interval = 0
auxhist24_begin_y = 0
auxhist24_begin_d = 0
auxhist24_begin_h = 0
auxhist24_begin_m = 0
auxhist24_begin_s = 0
auxhist24_begin = 0
auxhist24_end_y = 0
auxhist24_end_d = 0
auxhist24_end_h = 0
auxhist24_end_m = 0
auxhist24_end_s = 0
auxhist24_end = 0
io_form_auxhist24 = 0
frames_per_auxhist24 = 999999
auxinput1_outname = "auxinput1_d<domain>_<date>"
auxinput1_interval_y = 0
auxinput1_interval_d = 0
auxinput1_interval_h = 0
auxinput1_interval_m = 0
auxinput1_interval_s = 0
auxinput1_interval = 0
auxinput1_begin_y = 0
auxinput1_begin_d = 0
auxinput1_begin_h = 0
auxinput1_begin_m = 0
auxinput1_begin_s = 0
auxinput1_begin = 0
auxinput1_end_y = 0
auxinput1_end_d = 0
auxinput1_end_h = 0
auxinput1_end_m = 0
auxinput1_end_s = 0
auxinput1_end = 0
frames_per_auxinput1 = 999999
auxinput2_inname = "auxinput2_d<domain>_<date>"
auxinput2_outname = "auxinput2_d<domain>_<date>"
auxinput2_interval_y = 0
auxinput2_interval_d = 0
auxinput2_interval_h = 0
auxinput2_interval_m = 0
auxinput2_interval_s = 0
auxinput2_interval = 0
auxinput2_begin_y = 0
auxinput2_begin_d = 0
auxinput2_begin_h = 0
auxinput2_begin_m = 0
auxinput2_begin_s = 0
auxinput2_begin = 0
auxinput2_end_y = 0
auxinput2_end_d = 0
auxinput2_end_h = 0
auxinput2_end_m = 0
auxinput2_end_s = 0
auxinput2_end = 0
io_form_auxinput2 = 0
frames_per_auxinput2 = 999999
auxinput3_inname = "auxinput3_d<domain>_<date>"
auxinput3_outname = "auxinput3_d<domain>_<date>"
auxinput3_interval_y = 0
auxinput3_interval_d = 0
auxinput3_interval_h = 0
auxinput3_interval_m = 0
auxinput3_interval_s = 0
auxinput3_interval = 0
auxinput3_begin_y = 0
auxinput3_begin_d = 0
auxinput3_begin_h = 0
auxinput3_begin_m = 0
auxinput3_begin_s = 0
auxinput3_begin = 0
auxinput3_end_y = 0
auxinput3_end_d = 0
auxinput3_end_h = 0
auxinput3_end_m = 0
auxinput3_end_s = 0
auxinput3_end = 0
io_form_auxinput3 = 0
frames_per_auxinput3 = 999999
auxinput4_inname = "auxinput4_d<domain>_<date>"
auxinput4_outname = "auxinput4_d<domain>_<date>"
auxinput4_interval_y = 0
auxinput4_interval_d = 0
auxinput4_interval_h = 0
auxinput4_interval_m = 0
auxinput4_interval_s = 0
auxinput4_interval = 0
auxinput4_begin_y = 0
auxinput4_begin_d = 0
auxinput4_begin_h = 0
auxinput4_begin_m = 0
auxinput4_begin_s = 0
auxinput4_begin = 0
auxinput4_end_y = 0
auxinput4_end_d = 0
auxinput4_end_h = 0
auxinput4_end_m = 0
auxinput4_end_s = 0
auxinput4_end = 0
io_form_auxinput4 = 0
frames_per_auxinput4 = 999999
auxinput5_inname = "auxinput5_d<domain>_<date>"
auxinput5_outname = "auxinput5_d<domain>_<date>"
auxinput5_interval_y = 0
auxinput5_interval_d = 0
auxinput5_interval_h = 0
auxinput5_interval_m = 0
auxinput5_interval_s = 0
auxinput5_interval = 0
auxinput5_begin_y = 0
auxinput5_begin_d = 0
auxinput5_begin_h = 0
auxinput5_begin_m = 0
auxinput5_begin_s = 0
auxinput5_begin = 0
auxinput5_end_y = 0
auxinput5_end_d = 0
auxinput5_end_h = 0
auxinput5_end_m = 0
auxinput5_end_s = 0
auxinput5_end = 0
io_form_auxinput5 = 0
frames_per_auxinput5 = 999999
auxinput6_inname = "auxinput6_d<domain>_<date>"
auxinput6_outname = "auxinput6_d<domain>_<date>"
auxinput6_interval_y = 0
auxinput6_interval_d = 0
auxinput6_interval_h = 0
auxinput6_interval_m = 0
auxinput6_interval_s = 0
auxinput6_interval = 0
auxinput6_begin_y = 0
auxinput6_begin_d = 0
auxinput6_begin_h = 0
auxinput6_begin_m = 0
auxinput6_begin_s = 0
auxinput6_begin = 0
auxinput6_end_y = 0
auxinput6_end_d = 0
auxinput6_end_h = 0
auxinput6_end_m = 0
auxinput6_end_s = 0
auxinput6_end = 0
io_form_auxinput6 = 0
frames_per_auxinput6 = 999999
auxinput7_inname = "auxinput7_d<domain>_<date>"
auxinput7_outname = "auxinput7_d<domain>_<date>"
auxinput7_interval_y = 0
auxinput7_interval_d = 0
auxinput7_interval_h = 0
auxinput7_interval_m = 0
auxinput7_interval_s = 0
auxinput7_interval = 0
auxinput7_begin_y = 0
auxinput7_begin_d = 0
auxinput7_begin_h = 0
auxinput7_begin_m = 0
auxinput7_begin_s = 0
auxinput7_begin = 0
auxinput7_end_y = 0
auxinput7_end_d = 0
auxinput7_end_h = 0
auxinput7_end_m = 0
auxinput7_end_s = 0
auxinput7_end = 0
io_form_auxinput7 = 0
frames_per_auxinput7 = 999999
auxinput8_inname = "auxinput8_d<domain>_<date>"
auxinput8_outname = "auxinput8_d<domain>_<date>"
auxinput8_interval_y = 0
auxinput8_interval_d = 0
auxinput8_interval_h = 0
auxinput8_interval_m = 0
auxinput8_interval_s = 0
auxinput8_interval = 0
auxinput8_begin_y = 0
auxinput8_begin_d = 0
auxinput8_begin_h = 0
auxinput8_begin_m = 0
auxinput8_begin_s = 0
auxinput8_begin = 0
auxinput8_end_y = 0
auxinput8_end_d = 0
auxinput8_end_h = 0
auxinput8_end_m = 0
auxinput8_end_s = 0
auxinput8_end = 0
io_form_auxinput8 = 0
frames_per_auxinput8 = 999999
auxinput9_inname = "auxinput9_d<domain>_<date>"
auxinput9_outname = "auxinput9_d<domain>_<date>"
auxinput9_interval_y = 0
auxinput9_interval_d = 0
auxinput9_interval_h = 0
auxinput9_interval_m = 0
auxinput9_interval_s = 0
auxinput9_interval = 0
auxinput9_begin_y = 0
auxinput9_begin_d = 0
auxinput9_begin_h = 0
auxinput9_begin_m = 0
auxinput9_begin_s = 0
auxinput9_begin = 0
auxinput9_end_y = 0
auxinput9_end_d = 0
auxinput9_end_h = 0
auxinput9_end_m = 0
auxinput9_end_s = 0
auxinput9_end = 0
io_form_auxinput9 = 0
frames_per_auxinput9 = 999999
auxinput10_inname = "auxinput10_d<domain>_<date>"
auxinput10_outname = "auxinput10_d<domain>_<date>"
auxinput10_interval_y = 0
auxinput10_interval_d = 0
auxinput10_interval_h = 0
auxinput10_interval_m = 0
auxinput10_interval_s = 0
auxinput10_interval = 0
auxinput10_begin_y = 0
auxinput10_begin_d = 0
auxinput10_begin_h = 0
auxinput10_begin_m = 0
auxinput10_begin_s = 0
auxinput10_begin = 0
auxinput10_end_y = 0
auxinput10_end_d = 0
auxinput10_end_h = 0
auxinput10_end_m = 0
auxinput10_end_s = 0
auxinput10_end = 0
io_form_auxinput10 = 0
frames_per_auxinput10 = 999999
auxinput11_inname = "auxinput11_d<domain>_<date>"
auxinput11_outname = "auxinput11_d<domain>_<date>"
auxinput11_interval_y = 0
auxinput11_interval_d = 0
auxinput11_interval_h = 0
auxinput11_interval_m = 0
auxinput11_interval_s = 0
auxinput11_interval = 0
auxinput11_begin_y = 0
auxinput11_begin_d = 0
auxinput11_begin_h = 0
auxinput11_begin_m = 0
auxinput11_begin_s = 0
auxinput11_begin = 0
auxinput11_end_y = 0
auxinput11_end_d = 0
auxinput11_end_h = 0
auxinput11_end_m = 0
auxinput11_end_s = 0
auxinput11_end = 0
io_form_auxinput11 = 0
frames_per_auxinput11 = 999999
auxinput12_inname = "auxinput12_d<domain>_<date>"
auxinput12_outname = "auxinput12_d<domain>_<date>"
auxinput12_interval_y = 0
auxinput12_interval_d = 0
auxinput12_interval_h = 0
auxinput12_interval_m = 0
auxinput12_interval_s = 0
auxinput12_interval = 0
auxinput12_begin_y = 0
auxinput12_begin_d = 0
auxinput12_begin_h = 0
auxinput12_begin_m = 0
auxinput12_begin_s = 0
auxinput12_begin = 0
auxinput12_end_y = 0
auxinput12_end_d = 0
auxinput12_end_h = 0
auxinput12_end_m = 0
auxinput12_end_s = 0
auxinput12_end = 0
io_form_auxinput12 = 0
frames_per_auxinput12 = 999999
auxinput13_inname = "auxinput13_d<domain>_<date>"
auxinput13_outname = "auxinput13_d<domain>_<date>"
auxinput13_interval_y = 0
auxinput13_interval_d = 0
auxinput13_interval_h = 0
auxinput13_interval_m = 0
auxinput13_interval_s = 0
auxinput13_interval = 0
auxinput13_begin_y = 0
auxinput13_begin_d = 0
auxinput13_begin_h = 0
auxinput13_begin_m = 0
auxinput13_begin_s = 0
auxinput13_begin = 0
auxinput13_end_y = 0
auxinput13_end_d = 0
auxinput13_end_h = 0
auxinput13_end_m = 0
auxinput13_end_s = 0
auxinput13_end = 0
io_form_auxinput13 = 0
frames_per_auxinput13 = 999999
auxinput14_inname = "auxinput14_d<domain>_<date>"
auxinput14_outname = "auxinput14_d<domain>_<date>"
auxinput14_interval_y = 0
auxinput14_interval_d = 0
auxinput14_interval_h = 0
auxinput14_interval_m = 0
auxinput14_interval_s = 0
auxinput14_interval = 0
auxinput14_begin_y = 0
auxinput14_begin_d = 0
auxinput14_begin_h = 0
auxinput14_begin_m = 0
auxinput14_begin_s = 0
auxinput14_begin = 0
auxinput14_end_y = 0
auxinput14_end_d = 0
auxinput14_end_h = 0
auxinput14_end_m = 0
auxinput14_end_s = 0
auxinput14_end = 0
io_form_auxinput14 = 0
frames_per_auxinput14 = 999999
auxinput15_inname = "auxinput15_d<domain>_<date>"
auxinput15_outname = "auxinput15_d<domain>_<date>"
auxinput15_interval_y = 0
auxinput15_interval_d = 0
auxinput15_interval_h = 0
auxinput15_interval_m = 0
auxinput15_interval_s = 0
auxinput15_interval = 0
auxinput15_begin_y = 0
auxinput15_begin_d = 0
auxinput15_begin_h = 0
auxinput15_begin_m = 0
auxinput15_begin_s = 0
auxinput15_begin = 0
auxinput15_end_y = 0
auxinput15_end_d = 0
auxinput15_end_h = 0
auxinput15_end_m = 0
auxinput15_end_s = 0
auxinput15_end = 0
io_form_auxinput15 = 0
frames_per_auxinput15 = 999999
auxinput16_inname = "auxinput16_d<domain>_<date>"
auxinput16_outname = "auxinput16_d<domain>_<date>"
auxinput16_interval_y = 0
auxinput16_interval_d = 0
auxinput16_interval_h = 0
auxinput16_interval_m = 0
auxinput16_interval_s = 0
auxinput16_interval = 0
auxinput16_begin_y = 0
auxinput16_begin_d = 0
auxinput16_begin_h = 0
auxinput16_begin_m = 0
auxinput16_begin_s = 0
auxinput16_begin = 0
auxinput16_end_y = 0
auxinput16_end_d = 0
auxinput16_end_h = 0
auxinput16_end_m = 0
auxinput16_end_s = 0
auxinput16_end = 0
io_form_auxinput16 = 0
frames_per_auxinput16 = 999999
auxinput17_inname = "auxinput17_d<domain>_<date>"
auxinput17_outname = "auxinput17_d<domain>_<date>"
auxinput17_interval_y = 0
auxinput17_interval_d = 0
auxinput17_interval_h = 0
auxinput17_interval_m = 0
auxinput17_interval_s = 0
auxinput17_interval = 0
auxinput17_begin_y = 0
auxinput17_begin_d = 0
auxinput17_begin_h = 0
auxinput17_begin_m = 0
auxinput17_begin_s = 0
auxinput17_begin = 0
auxinput17_end_y = 0
auxinput17_end_d = 0
auxinput17_end_h = 0
auxinput17_end_m = 0
auxinput17_end_s = 0
auxinput17_end = 0
io_form_auxinput17 = 0
frames_per_auxinput17 = 999999
auxinput18_inname = "auxinput18_d<domain>_<date>"
auxinput18_outname = "auxinput18_d<domain>_<date>"
auxinput18_interval_y = 0
auxinput18_interval_d = 0
auxinput18_interval_h = 0
auxinput18_interval_m = 0
auxinput18_interval_s = 0
auxinput18_interval = 0
auxinput18_begin_y = 0
auxinput18_begin_d = 0
auxinput18_begin_h = 0
auxinput18_begin_m = 0
auxinput18_begin_s = 0
auxinput18_begin = 0
auxinput18_end_y = 0
auxinput18_end_d = 0
auxinput18_end_h = 0
auxinput18_end_m = 0
auxinput18_end_s = 0
auxinput18_end = 0
io_form_auxinput18 = 0
frames_per_auxinput18 = 999999
auxinput19_inname = "auxinput19_d<domain>_<date>"
auxinput19_outname = "auxinput19_d<domain>_<date>"
auxinput19_interval_y = 0
auxinput19_interval_d = 0
auxinput19_interval_h = 0
auxinput19_interval_m = 0
auxinput19_interval_s = 0
auxinput19_interval = 0
auxinput19_begin_y = 0
auxinput19_begin_d = 0
auxinput19_begin_h = 0
auxinput19_begin_m = 0
auxinput19_begin_s = 0
auxinput19_begin = 0
auxinput19_end_y = 0
auxinput19_end_d = 0
auxinput19_end_h = 0
auxinput19_end_m = 0
auxinput19_end_s = 0
auxinput19_end = 0
io_form_auxinput19 = 0
frames_per_auxinput19 = 999999
auxinput20_inname = "auxinput20_d<domain>_<date>"
auxinput20_outname = "auxinput20_d<domain>_<date>"
auxinput20_interval_y = 0
auxinput20_interval_d = 0
auxinput20_interval_h = 0
auxinput20_interval_m = 0
auxinput20_interval_s = 0
auxinput20_interval = 0
auxinput20_begin_y = 0
auxinput20_begin_d = 0
auxinput20_begin_h = 0
auxinput20_begin_m = 0
auxinput20_begin_s = 0
auxinput20_begin = 0
auxinput20_end_y = 0
auxinput20_end_d = 0
auxinput20_end_h = 0
auxinput20_end_m = 0
auxinput20_end_s = 0
auxinput20_end = 0
io_form_auxinput20 = 0
frames_per_auxinput20 = 999999
auxinput21_inname = "auxinput21_d<domain>_<date>"
auxinput21_outname = "auxinput21_d<domain>_<date>"
auxinput21_interval_y = 0
auxinput21_interval_d = 0
auxinput21_interval_h = 0
auxinput21_interval_m = 0
auxinput21_interval_s = 0
auxinput21_interval = 0
auxinput21_begin_y = 0
auxinput21_begin_d = 0
auxinput21_begin_h = 0
auxinput21_begin_m = 0
auxinput21_begin_s = 0
auxinput21_begin = 0
auxinput21_end_y = 0
auxinput21_end_d = 0
auxinput21_end_h = 0
auxinput21_end_m = 0
auxinput21_end_s = 0
auxinput21_end = 0
io_form_auxinput21 = 0
frames_per_auxinput21 = 999999
auxinput22_inname = "auxinput22_d<domain>_<date>"
auxinput22_outname = "auxinput22_d<domain>_<date>"
auxinput22_interval_y = 0
auxinput22_interval_d = 0
auxinput22_interval_h = 0
auxinput22_interval_m = 0
auxinput22_interval_s = 0
auxinput22_interval = 0
auxinput22_begin_y = 0
auxinput22_begin_d = 0
auxinput22_begin_h = 0
auxinput22_begin_m = 0
auxinput22_begin_s = 0
auxinput22_begin = 0
auxinput22_end_y = 0
auxinput22_end_d = 0
auxinput22_end_h = 0
auxinput22_end_m = 0
auxinput22_end_s = 0
auxinput22_end = 0
io_form_auxinput22 = 0
frames_per_auxinput22 = 999999
auxinput23_inname = "auxinput23_d<domain>_<date>"
auxinput23_outname = "auxinput23_d<domain>_<date>"
auxinput23_interval_y = 0
auxinput23_interval_d = 0
auxinput23_interval_h = 0
auxinput23_interval_m = 0
auxinput23_interval_s = 0
auxinput23_interval = 0
auxinput23_begin_y = 0
auxinput23_begin_d = 0
auxinput23_begin_h = 0
auxinput23_begin_m = 0
auxinput23_begin_s = 0
auxinput23_begin = 0
auxinput23_end_y = 0
auxinput23_end_d = 0
auxinput23_end_h = 0
auxinput23_end_m = 0
auxinput23_end_s = 0
auxinput23_end = 0
io_form_auxinput23 = 0
frames_per_auxinput23 = 999999
auxinput24_inname = "auxinput24_d<domain>_<date>"
auxinput24_outname = "auxinput24_d<domain>_<date>"
auxinput24_interval_y = 0
auxinput24_interval_d = 0
auxinput24_interval_h = 0
auxinput24_interval_m = 0
auxinput24_interval_s = 0
auxinput24_interval = 0
auxinput24_begin_y = 0
auxinput24_begin_d = 0
auxinput24_begin_h = 0
auxinput24_begin_m = 0
auxinput24_begin_s = 0
auxinput24_begin = 0
auxinput24_end_y = 0
auxinput24_end_d = 0
auxinput24_end_h = 0
auxinput24_end_m = 0
auxinput24_end_s = 0
auxinput24_end = 0
io_form_auxinput24 = 0
frames_per_auxinput24 = 999999
history_interval = 0
frames_per_outfile = 10
restart = .false.
restart_interval = 0
io_form_input = 2
io_form_history = 2
io_form_restart = 2
io_form_boundary = 2
debug_level = 0
self_test_domain = .false.
history_outname = "wrfout_d<domain>_<date>"
history_inname = "wrfhist_d<domain>_<date>"
use_netcdf_classic = .false.
history_interval_d = 0
history_interval_h = 0
history_interval_m = 0
history_interval_s = 0
inputout_interval_d = 0
inputout_interval_h = 0
inputout_interval_m = 0
inputout_interval_s = 0
inputout_interval = 0
restart_interval_d = 0
restart_interval_h = 0
restart_interval_m = 0
restart_interval_s = 0
history_begin_y = 0
history_begin_d = 0
history_begin_h = 0
history_begin_m = 0
history_begin_s = 0
history_begin = 0
inputout_begin_y = 0
inputout_begin_d = 0
inputout_begin_h = 0
inputout_begin_m = 0
inputout_begin_s = 0
restart_begin_y = 0
restart_begin_d = 0
restart_begin_h = 0
restart_begin_m = 0
restart_begin_s = 0
restart_begin = 0
history_end_y = 0
history_end_d = 0
history_end_h = 0
history_end_m = 0
history_end_s = 0
history_end = 0
inputout_end_y = 0
inputout_end_d = 0
inputout_end_h = 0
inputout_end_m = 0
inputout_end_s = 0
simulation_start_year = 0
simulation_start_month = 0
simulation_start_day = 0
simulation_start_hour = 0
simulation_start_minute = 0
simulation_start_second = 0
reset_simulation_start = .false.
sr_x = 0
sr_y = 0
sgfdda_inname = "sgfdda_d<domain>"
gfdda_inname = "gfdda_d<domain>"
sgfdda_interval_d = 0
sgfdda_interval_h = 0
sgfdda_interval_m = 0
sgfdda_interval_s = 0
sgfdda_interval_y = 0
sgfdda_interval = 0
gfdda_interval_d = 0
gfdda_interval_h = 0
gfdda_interval_m = 0
gfdda_interval_s = 0
gfdda_interval_y = 0
gfdda_interval = 0
sgfdda_begin_y = 0
sgfdda_begin_d = 0
sgfdda_begin_h = 0
sgfdda_begin_m = 0
sgfdda_begin_s = 0
gfdda_begin_y = 0
gfdda_begin_d = 0
gfdda_begin_h = 0
gfdda_begin_m = 0
gfdda_begin_s = 0
sgfdda_end_y = 0
sgfdda_end_d = 0
sgfdda_end_h = 0
sgfdda_end_m = 0
sgfdda_end_s = 0
gfdda_end_y = 0
gfdda_end_d = 0
gfdda_end_h = 0
gfdda_end_m = 0
gfdda_end_s = 0
io_form_sgfdda = 2
io_form_gfdda = 2
iofields_filename = "NONE_SPECIFIED"
ignore_iofields_warning = .true.
ncd_nofill = .true.
ifire = 0
fire_boundary_guard = 8
fire_num_ignitions = 0
fire_ignition_ros1 = 0.01
fire_ignition_start_lon1 = 0.
fire_ignition_start_lat1 = 0.
fire_ignition_end_lon1 = 0.
fire_ignition_end_lat1 = 0.
fire_ignition_radius1 = 0.
fire_ignition_start_time1 = 0.
fire_ignition_end_time1 = 0.
fire_ignition_ros2 = 0.01
fire_ignition_start_lon2 = 0.
fire_ignition_start_lat2 = 0.
fire_ignition_end_lon2 = 0.
fire_ignition_end_lat2 = 0.
fire_ignition_radius2 = 0.
fire_ignition_start_time2 = 0.
fire_ignition_end_time2 = 0.
fire_ignition_ros3 = 0.01
fire_ignition_start_lon3 = 0.
fire_ignition_start_lat3 = 0.
fire_ignition_end_lon3 = 0.
fire_ignition_end_lat3 = 0.
fire_ignition_radius3 = 0.
fire_ignition_start_time3 = 0.
fire_ignition_end_time3 = 0.
fire_ignition_ros4 = 0.01
fire_ignition_start_lon4 = 0.
fire_ignition_start_lat4 = 0.
fire_ignition_end_lon4 = 0.
fire_ignition_end_lat4 = 0.
fire_ignition_radius4 = 0.
fire_ignition_start_time4 = 0.
fire_ignition_end_time4 = 0.
fire_ignition_ros5 = 0.01
fire_ignition_start_lon5 = 0.
fire_ignition_start_lat5 = 0.
fire_ignition_end_lon5 = 0.
fire_ignition_end_lat5 = 0.
fire_ignition_radius5 = 0.
fire_ignition_start_time5 = 0.
fire_ignition_end_time5 = 0.
fire_ignition_start_x1 = 0.
fire_ignition_start_y1 = 0.
fire_ignition_end_x1 = 0.
fire_ignition_end_y1 = 0.
fire_ignition_start_x2 = 0.
fire_ignition_start_y2 = 0.
fire_ignition_end_x2 = 0.
fire_ignition_end_y2 = 0.
fire_ignition_start_x3 = 0.
fire_ignition_start_y3 = 0.
fire_ignition_end_x3 = 0.
fire_ignition_end_y3 = 0.
fire_ignition_start_x4 = 0.
fire_ignition_start_y4 = 0.
fire_ignition_end_x4 = 0.
fire_ignition_end_y4 = 0.
fire_ignition_start_x5 = 0.
fire_ignition_start_y5 = 0.
fire_ignition_end_x5 = 0.
fire_ignition_end_y5 = 0.
fire_lat_init = 0.
fire_lon_init = 0.
fire_ign_time = 0.
fire_shape = 0
fire_sprd_mdl = 1
fire_crwn_hgt = 15.
fire_ext_grnd = 50.
fire_ext_crwn = 50.
fire_wind_height = 6.096
fire_fuel_read = -1
fire_fuel_cat = 1
fire_print_msg = 0
fire_print_file = 0
fire_fuel_left_method = 1
fire_fuel_left_irl = 2
fire_fuel_left_jrl = 2
fire_grows_only = 1
fire_upwinding = 9
fire_upwind_split = 0
fire_viscosity = 0.4
fire_lfn_ext_up = 1.0
fire_topo_from_atm = 1
fire_advection = 1
fire_test_steps = 0
fire_const_time = -1.
fire_const_grnhfx = 0.
fire_const_grnqfx = 0.
fire_atm_feedback = 1.
fire_mountain_type = 0
fire_mountain_height = 500.
fire_mountain_start_x = 100.
fire_mountain_start_y = 100.
fire_mountain_end_x = 100.
fire_mountain_end_y = 100.
delt_perturbation = 0.
xrad_perturbation = 0.
yrad_perturbation = 0.
zrad_perturbation = 0.
hght_perturbation = 0.
stretch_grd = .true.
stretch_hyp = .false.
z_grd_scale = 0.40
sfc_full_init = .false.
sfc_lu_index = 28
sfc_tsk = 285.0
sfc_tmn = 285.0
fire_read_lu = .false.
fire_read_tsk = .false.
fire_read_tmn = .false.
fire_read_atm_ht = .false.
fire_read_fire_ht = .false.
fire_read_atm_grad = .false.
fire_read_fire_grad = .false.
sfc_vegfra = 0.5
sfc_canwat = 0
sfc_ivgtyp = 18
sfc_isltyp = 7
fire_lsm_reinit = .true.
fire_lsm_reinit_iter = 1
fire_upwinding_reinit = 4
fire_is_real_perim = .false.
fire_lsm_band_ngp = 4
fire_lsm_zcoupling = .false.
fire_lsm_zcoupling_ref = 50.
fire_tracer_smoke = 0.02
fire_viscosity_bg = 0.4
fire_viscosity_band = 0.5
fire_viscosity_ngp = 2
fire_slope_factor = 1.0
do_avgflx_em = 0
do_avgflx_cugd = 0
nens = 1
skebs = 0
stoch_force_opt = 0
skebs_vertstruc = 0
stoch_vertstruc_opt = 0
tot_backscat_psi = 1.0e-05
tot_backscat_t = 1.0e-06
ztau_psi = 10800.0
ztau_t = 10800.0
rexponent_psi = -1.83
rexponent_t = -1.83
zsigma2_eps = 0.0833
zsigma2_eta = 0.0833
kminforc = 1
lminforc = 1
kminforct = 1
lminforct = 1
kmaxforc = 1000000
lmaxforc = 1000000
kmaxforct = 1000000
lmaxforct = 1000000
iseed_skebs = 811
kmaxforch = 0
lmaxforch = 0
kmaxforcth = 0
lmaxforcth = 0
sppt = 0
gridpt_stddev_sppt = 0.5
stddev_cutoff_sppt = 2.0
lengthscale_sppt = 150000.0
timescale_sppt = 21600.0
sppt_vertstruc = 0
iseed_sppt = 53
rand_perturb = 0
gridpt_stddev_rand_pert = 0.03
stddev_cutoff_rand_pert = 3.0
lengthscale_rand_pert = 500000.0
timescale_rand_pert = 21600.0
rand_pert_vertstruc = 0
iseed_rand_pert = 17
spp = 0
hrrr_cycling = .true.
spp_conv = 0
gridpt_stddev_spp_conv = 0.3
stddev_cutoff_spp_conv = 3.0
lengthscale_spp_conv = 150000.0
timescale_spp_conv = 21600.0
vertstruc_spp_conv = 0
iseed_spp_conv = 171
spp_pbl = 0
gridpt_stddev_spp_pbl = 0.15
stddev_cutoff_spp_pbl = 2.0
lengthscale_spp_pbl = 700000.0
timescale_spp_pbl = 21600.0
vertstruc_spp_pbl = 0
iseed_spp_pbl = 217
spp_lsm = 0
gridpt_stddev_spp_lsm = 0.3
stddev_cutoff_spp_lsm = 3.0
lengthscale_spp_lsm = 50000.0
timescale_spp_lsm = 86400.0
vertstruc_spp_lsm = 0
iseed_spp_lsm = 317
skebs_on = 0
sppt_on = 0
spp_on = 0
rand_perturb_on = 0
num_stoch_levels = 1
seed_dim = 0
sfs_opt = 0
m_opt = 0
lakedepth_default = 50
lake_min_elev = 5
use_lakedepth = 1
p_lev_diags = 0
p_lev_diags_dfi = 0
num_press_levels = 0
press_levels = 0
use_tot_or_hyd_p = 2
extrap_below_grnd = 1
p_lev_missing = -999
p_lev_interval = 0
z_lev_diags = 0
z_lev_diags_dfi = 0
num_z_levels = 0
z_levels = 0
z_lev_missing = -999
z_lev_interval = 0
afwa_diag_opt = 0
afwa_ptype_opt = 0
afwa_vil_opt = 0
afwa_radar_opt = 0
afwa_severe_opt = 0
afwa_icing_opt = 0
afwa_vis_opt = 0
afwa_cloud_opt = 0
afwa_therm_opt = 0
afwa_turb_opt = 0
afwa_buoy_opt = 0
afwa_ptype_ccn_tmp = 264.15
afwa_ptype_tot_melt = 50.0
afwa_bad_data_check = 0
mean_diag = 0
mean_freq = 0
mean_interval = 0
mean_diag_interval = 0
mean_diag_interval_s = 0
mean_diag_interval_m = 0
mean_diag_interval_h = 0
mean_diag_interval_d = 0
mean_diag_interval_mo = 0
diurnal_diag = 0
nssl_ipelec = 0
nssl_isaund = 12
nssl_iscreen = 0
nssl_lightrad = 12000
nssl_idischarge = 1
nssl_ibrkd = 4
nssl_ecrit = 120000
nssl_disfrac = 0.3
elec_physics = 0
perturb_bdy = 0
perturb_chem_bdy = 0
hybrid_opt = 2
etac = 0.2
num_wif_levels = 27
wif_input_opt = 0
diag_nwp2 = 0
chem_opt = 0












 nml_read_error = .FALSE.
 NML_LOOP : DO i=1,17
    REWIND ( UNIT = nml_read_unit )
    SELECT CASE ( i )
       CASE ( 1 ) 
          nml_name = "time_control"
          READ   ( UNIT = nml_read_unit , NML = time_control , ERR=9201, END=9202 )
          WRITE ( UNIT = nml_write_unit, NML = time_control )
          CYCLE NML_LOOP
       CASE ( 2 ) 
          nml_name = "pio_control"
          READ   ( UNIT = nml_read_unit , NML = pio_control , ERR=9201, END=9202 )
          WRITE ( UNIT = nml_write_unit, NML = pio_control )
          CYCLE NML_LOOP
       CASE ( 3 ) 
          nml_name = "dfi_control"
          READ   ( UNIT = nml_read_unit , NML = dfi_control , ERR=9201, END=9202 )
          WRITE ( UNIT = nml_write_unit, NML = dfi_control )
          CYCLE NML_LOOP
       CASE ( 4 ) 
          nml_name = "domains"
          READ   ( UNIT = nml_read_unit , NML = domains , ERR=9201, END=9202 )
          WRITE ( UNIT = nml_write_unit, NML = domains )
          CYCLE NML_LOOP
       CASE ( 5 ) 
          nml_name = "tc"
          READ   ( UNIT = nml_read_unit , NML = tc , ERR=9201, END=9202 )
          WRITE ( UNIT = nml_write_unit, NML = tc )
          CYCLE NML_LOOP
       CASE ( 6 ) 
          nml_name = "physics"
          READ   ( UNIT = nml_read_unit , NML = physics , ERR=9201, END=9202 )
          WRITE ( UNIT = nml_write_unit, NML = physics )
          CYCLE NML_LOOP
       CASE ( 7 ) 
          nml_name = "noah_mp"
          READ   ( UNIT = nml_read_unit , NML = noah_mp , ERR=9201, END=9202 )
          WRITE ( UNIT = nml_write_unit, NML = noah_mp )
          CYCLE NML_LOOP
       CASE ( 8 ) 
          nml_name = "fdda"
          READ   ( UNIT = nml_read_unit , NML = fdda , ERR=9201, END=9202 )
          WRITE ( UNIT = nml_write_unit, NML = fdda )
          CYCLE NML_LOOP
       CASE ( 9 ) 
          nml_name = "scm"
          READ   ( UNIT = nml_read_unit , NML = scm , ERR=9201, END=9202 )
          WRITE ( UNIT = nml_write_unit, NML = scm )
          CYCLE NML_LOOP
       CASE ( 10 ) 
          nml_name = "dynamics"
          READ   ( UNIT = nml_read_unit , NML = dynamics , ERR=9201, END=9202 )
          WRITE ( UNIT = nml_write_unit, NML = dynamics )
          CYCLE NML_LOOP
       CASE ( 11 ) 
          nml_name = "bdy_control"
          READ   ( UNIT = nml_read_unit , NML = bdy_control , ERR=9201, END=9202 )
          WRITE ( UNIT = nml_write_unit, NML = bdy_control )
          CYCLE NML_LOOP
       CASE ( 12 ) 
          nml_name = "grib2"
          READ   ( UNIT = nml_read_unit , NML = grib2 , ERR=9201, END=9202 )
          WRITE ( UNIT = nml_write_unit, NML = grib2 )
          CYCLE NML_LOOP
       CASE ( 13 ) 
          nml_name = "ideal"
          READ   ( UNIT = nml_read_unit , NML = ideal , ERR=9201, END=9202 )
          WRITE ( UNIT = nml_write_unit, NML = ideal )
          CYCLE NML_LOOP
       CASE ( 14 ) 
          nml_name = "fire"
          READ   ( UNIT = nml_read_unit , NML = fire , ERR=9201, END=9202 )
          WRITE ( UNIT = nml_write_unit, NML = fire )
          CYCLE NML_LOOP
       CASE ( 15 ) 
          nml_name = "stoch"
          READ   ( UNIT = nml_read_unit , NML = stoch , ERR=9201, END=9202 )
          WRITE ( UNIT = nml_write_unit, NML = stoch )
          CYCLE NML_LOOP
       CASE ( 16 ) 
          nml_name = "diags"
          READ   ( UNIT = nml_read_unit , NML = diags , ERR=9201, END=9202 )
          WRITE ( UNIT = nml_write_unit, NML = diags )
          CYCLE NML_LOOP
       CASE ( 17 ) 
          nml_name = "afwa"
          READ   ( UNIT = nml_read_unit , NML = afwa , ERR=9201, END=9202 )
          WRITE ( UNIT = nml_write_unit, NML = afwa )
          CYCLE NML_LOOP
    END SELECT
9201 CALL wrf_message("  ------ ERROR while reading namelist "//TRIM(nml_name)//" ------")
    nml_read_error = .TRUE.
    BACKSPACE ( UNIT = nml_read_unit )
    BACKSPACE ( UNIT = nml_read_unit )
    READ ( UNIT = nml_read_unit , FMT = '(A)' ) entire_line
    CALL wrf_message("Maybe here?:     "//TRIM(entire_line))
    READ ( UNIT = nml_read_unit , FMT = '(A)' ) entire_line
    CALL wrf_message("Maybe here?:     "//TRIM(entire_line))
    CALL wrf_alt_nml_obsolete(nml_read_unit, TRIM(nml_name))
    CYCLE NML_LOOP
9202 CALL wrf_debug(1,"Namelist "//TRIM(nml_name)//" not found in namelist.input.")
     CALL wrf_debug(1," --> Using registry defaults for variables in "//TRIM(nml_name))
 END DO NML_LOOP
 
 IF ( nml_read_error ) CALL wrf_error_fatal3("<stdin>",10943,&
"ERRORS while reading one or more namelists from namelist.input.")










      DO i = 1, max_dom
         mp_physics(i) = mp_physics(max_dom)
      ENDDO










 model_config_rec % run_days                   =  run_days 
 model_config_rec % run_hours                  =  run_hours 
 model_config_rec % run_minutes                =  run_minutes 
 model_config_rec % run_seconds                =  run_seconds 
 model_config_rec % start_year                 =  start_year 
 model_config_rec % start_month                =  start_month 
 model_config_rec % start_day                  =  start_day 
 model_config_rec % start_hour                 =  start_hour 
 model_config_rec % start_minute               =  start_minute 
 model_config_rec % start_second               =  start_second 
 model_config_rec % end_year                   =  end_year 
 model_config_rec % end_month                  =  end_month 
 model_config_rec % end_day                    =  end_day 
 model_config_rec % end_hour                   =  end_hour 
 model_config_rec % end_minute                 =  end_minute 
 model_config_rec % end_second                 =  end_second 
 model_config_rec % interval_seconds           =  interval_seconds 
 model_config_rec % input_from_file            =  input_from_file 
 model_config_rec % fine_input_stream          =  fine_input_stream 
 model_config_rec % input_from_hires           =  input_from_hires 
 model_config_rec % rsmas_data_path            =  rsmas_data_path 
 model_config_rec % all_ic_times               =  all_ic_times 
 model_config_rec % julyr                      =  julyr 
 model_config_rec % julday                     =  julday 
 model_config_rec % gmt                        =  gmt 
 model_config_rec % input_inname               =  input_inname 
 model_config_rec % input_outname              =  input_outname 
 model_config_rec % bdy_inname                 =  bdy_inname 
 model_config_rec % bdy_outname                =  bdy_outname 
 model_config_rec % rst_inname                 =  rst_inname 
 model_config_rec % rst_outname                =  rst_outname 
 model_config_rec % write_input                =  write_input 
 model_config_rec % write_restart_at_0h        =  write_restart_at_0h 
 model_config_rec % write_hist_at_0h_rst       =  write_hist_at_0h_rst 
 model_config_rec % adjust_output_times        =  adjust_output_times 
 model_config_rec % adjust_input_times         =  adjust_input_times 
 model_config_rec % diag_print                 =  diag_print 
 model_config_rec % nocolons                   =  nocolons 
 model_config_rec % cycling                    =  cycling 
 model_config_rec % output_diagnostics         =  output_diagnostics 
 model_config_rec % nwp_diagnostics            =  nwp_diagnostics 
 model_config_rec % output_ready_flag          =  output_ready_flag 
 model_config_rec % force_use_old_data         =  force_use_old_data 
 model_config_rec % usepio                     =  usepio 
 model_config_rec % pioprocs                   =  pioprocs 
 model_config_rec % piostart                   =  piostart 
 model_config_rec % piostride                  =  piostride 
 model_config_rec % pioshift                   =  pioshift 
 model_config_rec % dfi_opt                    =  dfi_opt 
 model_config_rec % dfi_savehydmeteors         =  dfi_savehydmeteors 
 model_config_rec % dfi_nfilter                =  dfi_nfilter 
 model_config_rec % dfi_write_filtered_input   =  dfi_write_filtered_input 
 model_config_rec % dfi_write_dfi_history      =  dfi_write_dfi_history 
 model_config_rec % dfi_cutoff_seconds         =  dfi_cutoff_seconds 
 model_config_rec % dfi_time_dim               =  dfi_time_dim 
 model_config_rec % dfi_fwdstop_year           =  dfi_fwdstop_year 
 model_config_rec % dfi_fwdstop_month          =  dfi_fwdstop_month 
 model_config_rec % dfi_fwdstop_day            =  dfi_fwdstop_day 
 model_config_rec % dfi_fwdstop_hour           =  dfi_fwdstop_hour 
 model_config_rec % dfi_fwdstop_minute         =  dfi_fwdstop_minute 
 model_config_rec % dfi_fwdstop_second         =  dfi_fwdstop_second 
 model_config_rec % dfi_bckstop_year           =  dfi_bckstop_year 
 model_config_rec % dfi_bckstop_month          =  dfi_bckstop_month 
 model_config_rec % dfi_bckstop_day            =  dfi_bckstop_day 
 model_config_rec % dfi_bckstop_hour           =  dfi_bckstop_hour 
 model_config_rec % dfi_bckstop_minute         =  dfi_bckstop_minute 
 model_config_rec % dfi_bckstop_second         =  dfi_bckstop_second 
 model_config_rec % time_step                  =  time_step 
 model_config_rec % time_step_fract_num        =  time_step_fract_num 
 model_config_rec % time_step_fract_den        =  time_step_fract_den 
 model_config_rec % time_step_dfi              =  time_step_dfi 
 model_config_rec % min_time_step              =  min_time_step 
 model_config_rec % min_time_step_den          =  min_time_step_den 
 model_config_rec % max_time_step              =  max_time_step 
 model_config_rec % max_time_step_den          =  max_time_step_den 
 model_config_rec % target_cfl                 =  target_cfl 
 model_config_rec % target_hcfl                =  target_hcfl 
 model_config_rec % max_step_increase_pct      =  max_step_increase_pct 
 model_config_rec % starting_time_step         =  starting_time_step 
 model_config_rec % starting_time_step_den     =  starting_time_step_den 
 model_config_rec % step_to_output_time        =  step_to_output_time 
 model_config_rec % adaptation_domain          =  adaptation_domain 
 model_config_rec % use_adaptive_time_step     =  use_adaptive_time_step 
 model_config_rec % use_adaptive_time_step_dfi =  use_adaptive_time_step_dfi 
 model_config_rec % max_dom                    =  max_dom 
 model_config_rec % lats_to_mic                =  lats_to_mic 
 model_config_rec % s_we                       =  s_we 
 model_config_rec % e_we                       =  e_we 
 model_config_rec % s_sn                       =  s_sn 
 model_config_rec % e_sn                       =  e_sn 
 model_config_rec % s_vert                     =  s_vert 
 model_config_rec % e_vert                     =  e_vert 
 model_config_rec % num_metgrid_levels         =  num_metgrid_levels 
 model_config_rec % num_metgrid_soil_levels    =  num_metgrid_soil_levels 
 model_config_rec % p_top_requested            =  p_top_requested 
 model_config_rec % interp_theta               =  interp_theta 
 model_config_rec % interp_type                =  interp_type 
 model_config_rec % rebalance                  =  rebalance 
 model_config_rec % vert_refine_method         =  vert_refine_method 
 model_config_rec % vert_refine_fact           =  vert_refine_fact 
 model_config_rec % extrap_type                =  extrap_type 
 model_config_rec % t_extrap_type              =  t_extrap_type 
 model_config_rec % hypsometric_opt            =  hypsometric_opt 
 model_config_rec % lowest_lev_from_sfc        =  lowest_lev_from_sfc 
 model_config_rec % use_levels_below_ground    =  use_levels_below_ground 
 model_config_rec % use_tavg_for_tsk           =  use_tavg_for_tsk 
 model_config_rec % use_surface                =  use_surface 
 model_config_rec % lagrange_order             =  lagrange_order 
 model_config_rec % linear_interp              =  linear_interp 
 model_config_rec % force_sfc_in_vinterp       =  force_sfc_in_vinterp 
 model_config_rec % zap_close_levels           =  zap_close_levels 
 model_config_rec % maxw_horiz_pres_diff       =  maxw_horiz_pres_diff 
 model_config_rec % trop_horiz_pres_diff       =  trop_horiz_pres_diff 
 model_config_rec % maxw_above_this_level      =  maxw_above_this_level 
 model_config_rec % use_maxw_level             =  use_maxw_level 
 model_config_rec % use_trop_level             =  use_trop_level 
 model_config_rec % sfcp_to_sfcp               =  sfcp_to_sfcp 
 model_config_rec % adjust_heights             =  adjust_heights 
 model_config_rec % smooth_cg_topo             =  smooth_cg_topo 
 model_config_rec % nest_interp_coord          =  nest_interp_coord 
 model_config_rec % interp_method_type         =  interp_method_type 
 model_config_rec % aggregate_lu               =  aggregate_lu 
 model_config_rec % rh2qv_wrt_liquid           =  rh2qv_wrt_liquid 
 model_config_rec % rh2qv_method               =  rh2qv_method 
 model_config_rec % qv_max_p_safe              =  qv_max_p_safe 
 model_config_rec % qv_max_flag                =  qv_max_flag 
 model_config_rec % qv_max_value               =  qv_max_value 
 model_config_rec % qv_min_p_safe              =  qv_min_p_safe 
 model_config_rec % qv_min_flag                =  qv_min_flag 
 model_config_rec % qv_min_value               =  qv_min_value 
 model_config_rec % ideal_init_method          =  ideal_init_method 
 model_config_rec % dx                         =  dx 
 model_config_rec % dy                         =  dy 
 model_config_rec % grid_id                    =  grid_id 
 model_config_rec % grid_allowed               =  grid_allowed 
 model_config_rec % parent_id                  =  parent_id 
 model_config_rec % i_parent_start             =  i_parent_start 
 model_config_rec % j_parent_start             =  j_parent_start 
 model_config_rec % parent_grid_ratio          =  parent_grid_ratio 
 model_config_rec % parent_time_step_ratio     =  parent_time_step_ratio 
 model_config_rec % feedback                   =  feedback 
 model_config_rec % smooth_option              =  smooth_option 
 model_config_rec % blend_width                =  blend_width 
 model_config_rec % ztop                       =  ztop 
 model_config_rec % moad_grid_ratio            =  moad_grid_ratio 
 model_config_rec % moad_time_step_ratio       =  moad_time_step_ratio 
 model_config_rec % shw                        =  shw 
 model_config_rec % tile_sz_x                  =  tile_sz_x 
 model_config_rec % tile_sz_y                  =  tile_sz_y 
 model_config_rec % numtiles                   =  numtiles 
 model_config_rec % numtiles_inc               =  numtiles_inc 
 model_config_rec % numtiles_x                 =  numtiles_x 
 model_config_rec % numtiles_y                 =  numtiles_y 
 model_config_rec % tile_strategy              =  tile_strategy 
 model_config_rec % nproc_x                    =  nproc_x 
 model_config_rec % nproc_y                    =  nproc_y 
 model_config_rec % irand                      =  irand 
 model_config_rec % dt                         =  dt 
 model_config_rec % fft_used                   =  fft_used 
 model_config_rec % cu_used                    =  cu_used 
 model_config_rec % shcu_used                  =  shcu_used 
 model_config_rec % cam_used                   =  cam_used 
 model_config_rec % alloc_qndropsource         =  alloc_qndropsource 
 model_config_rec % num_moves                  =  num_moves 
 model_config_rec % ts_buf_size                =  ts_buf_size 
 model_config_rec % max_ts_locs                =  max_ts_locs 
 model_config_rec % tslist_ij                  =  tslist_ij 
 model_config_rec % tslist_unstagger_winds     =  tslist_unstagger_winds 
 model_config_rec % vortex_interval            =  vortex_interval 
 model_config_rec % max_vortex_speed           =  max_vortex_speed 
 model_config_rec % corral_dist                =  corral_dist 
 model_config_rec % track_level                =  track_level 
 model_config_rec % time_to_move               =  time_to_move 
 model_config_rec % move_id                    =  move_id 
 model_config_rec % move_interval              =  move_interval 
 model_config_rec % move_cd_x                  =  move_cd_x 
 model_config_rec % move_cd_y                  =  move_cd_y 
 model_config_rec % swap_x                     =  swap_x 
 model_config_rec % swap_y                     =  swap_y 
 model_config_rec % cycle_x                    =  cycle_x 
 model_config_rec % cycle_y                    =  cycle_y 
 model_config_rec % reorder_mesh               =  reorder_mesh 
 model_config_rec % perturb_input              =  perturb_input 
 model_config_rec % eta_levels                 =  eta_levels 
 model_config_rec % auto_levels_opt            =  auto_levels_opt 
 model_config_rec % max_dz                     =  max_dz 
 model_config_rec % dzbot                      =  dzbot 
 model_config_rec % dzstretch_s                =  dzstretch_s 
 model_config_rec % dzstretch_u                =  dzstretch_u 
 model_config_rec % ocean_levels               =  ocean_levels 
 model_config_rec % ocean_z                    =  ocean_z 
 model_config_rec % ocean_t                    =  ocean_t 
 model_config_rec % ocean_s                    =  ocean_s 
 model_config_rec % num_traj                   =  num_traj 
 model_config_rec % max_ts_level               =  max_ts_level 
 model_config_rec % track_loc_in               =  track_loc_in 
 model_config_rec % num_ext_model_couple_dom   =  num_ext_model_couple_dom 
 model_config_rec % insert_bogus_storm         =  insert_bogus_storm 
 model_config_rec % remove_storm               =  remove_storm 
 model_config_rec % num_storm                  =  num_storm 
 model_config_rec % latc_loc                   =  latc_loc 
 model_config_rec % lonc_loc                   =  lonc_loc 
 model_config_rec % vmax_meters_per_second     =  vmax_meters_per_second 
 model_config_rec % rmax                       =  rmax 
 model_config_rec % vmax_ratio                 =  vmax_ratio 
 model_config_rec % rankine_lid                =  rankine_lid 
 model_config_rec % physics_suite              =  physics_suite 
 model_config_rec % force_read_thompson        =  force_read_thompson 
 model_config_rec % write_thompson_tables      =  write_thompson_tables 
 model_config_rec % mp_physics                 =  mp_physics 
 model_config_rec % nssl_cccn                  =  nssl_cccn 
 model_config_rec % nssl_alphah                =  nssl_alphah 
 model_config_rec % nssl_alphahl               =  nssl_alphahl 
 model_config_rec % nssl_cnoh                  =  nssl_cnoh 
 model_config_rec % nssl_cnohl                 =  nssl_cnohl 
 model_config_rec % nssl_cnor                  =  nssl_cnor 
 model_config_rec % nssl_cnos                  =  nssl_cnos 
 model_config_rec % nssl_rho_qh                =  nssl_rho_qh 
 model_config_rec % nssl_rho_qhl               =  nssl_rho_qhl 
 model_config_rec % nssl_rho_qs                =  nssl_rho_qs 
 model_config_rec % nudge_lightning            =  nudge_lightning 
 model_config_rec % nudge_light_times          =  nudge_light_times 
 model_config_rec % nudge_light_timee          =  nudge_light_timee 
 model_config_rec % nudge_light_int            =  nudge_light_int 
 model_config_rec % path_to_files              =  path_to_files 
 model_config_rec % gsfcgce_hail               =  gsfcgce_hail 
 model_config_rec % gsfcgce_2ice               =  gsfcgce_2ice 
 model_config_rec % progn                      =  progn 
 model_config_rec % accum_mode                 =  accum_mode 
 model_config_rec % aitken_mode                =  aitken_mode 
 model_config_rec % coarse_mode                =  coarse_mode 
 model_config_rec % do_radar_ref               =  do_radar_ref 
 model_config_rec % compute_radar_ref          =  compute_radar_ref 
 model_config_rec % ra_lw_physics              =  ra_lw_physics 
 model_config_rec % ra_sw_physics              =  ra_sw_physics 
 model_config_rec % radt                       =  radt 
 model_config_rec % naer                       =  naer 
 model_config_rec % sf_sfclay_physics          =  sf_sfclay_physics 
 model_config_rec % sf_surface_physics         =  sf_surface_physics 
 model_config_rec % bl_pbl_physics             =  bl_pbl_physics 
 model_config_rec % bl_mynn_tkebudget          =  bl_mynn_tkebudget 
 model_config_rec % ysu_topdown_pblmix         =  ysu_topdown_pblmix 
 model_config_rec % shinhong_tke_diag          =  shinhong_tke_diag 
 model_config_rec % bl_mynn_tkeadvect          =  bl_mynn_tkeadvect 
 model_config_rec % bl_mynn_cloudpdf           =  bl_mynn_cloudpdf 
 model_config_rec % bl_mynn_mixlength          =  bl_mynn_mixlength 
 model_config_rec % bl_mynn_edmf               =  bl_mynn_edmf 
 model_config_rec % bl_mynn_edmf_mom           =  bl_mynn_edmf_mom 
 model_config_rec % bl_mynn_edmf_tke           =  bl_mynn_edmf_tke 
 model_config_rec % bl_mynn_mixscalars         =  bl_mynn_mixscalars 
 model_config_rec % bl_mynn_cloudmix           =  bl_mynn_cloudmix 
 model_config_rec % bl_mynn_mixqt              =  bl_mynn_mixqt 
 model_config_rec % icloud_bl                  =  icloud_bl 
 model_config_rec % mfshconv                   =  mfshconv 
 model_config_rec % sf_urban_physics           =  sf_urban_physics 
 model_config_rec % bldt                       =  bldt 
 model_config_rec % cu_physics                 =  cu_physics 
 model_config_rec % shcu_physics               =  shcu_physics 
 model_config_rec % cu_diag                    =  cu_diag 
 model_config_rec % kf_edrates                 =  kf_edrates 
 model_config_rec % kfeta_trigger              =  kfeta_trigger 
 model_config_rec % nsas_dx_factor             =  nsas_dx_factor 
 model_config_rec % cudt                       =  cudt 
 model_config_rec % gsmdt                      =  gsmdt 
 model_config_rec % isfflx                     =  isfflx 
 model_config_rec % ifsnow                     =  ifsnow 
 model_config_rec % icloud                     =  icloud 
 model_config_rec % cldovrlp                   =  cldovrlp 
 model_config_rec % ideal_xland                =  ideal_xland 
 model_config_rec % swrad_scat                 =  swrad_scat 
 model_config_rec % surface_input_source       =  surface_input_source 
 model_config_rec % num_soil_layers            =  num_soil_layers 
 model_config_rec % maxpatch                   =  maxpatch 
 model_config_rec % num_snow_layers            =  num_snow_layers 
 model_config_rec % num_snso_layers            =  num_snso_layers 
 model_config_rec % num_urban_ndm              =  num_urban_ndm 
 model_config_rec % num_urban_ng               =  num_urban_ng 
 model_config_rec % num_urban_nwr              =  num_urban_nwr 
 model_config_rec % num_urban_ngb              =  num_urban_ngb 
 model_config_rec % num_urban_nf               =  num_urban_nf 
 model_config_rec % num_urban_nz               =  num_urban_nz 
 model_config_rec % num_urban_nbui             =  num_urban_nbui 
 model_config_rec % urban_map_zrd              =  urban_map_zrd 
 model_config_rec % urban_map_zwd              =  urban_map_zwd 
 model_config_rec % urban_map_gd               =  urban_map_gd 
 model_config_rec % urban_map_zd               =  urban_map_zd 
 model_config_rec % urban_map_zdf              =  urban_map_zdf 
 model_config_rec % urban_map_bd               =  urban_map_bd 
 model_config_rec % urban_map_wd               =  urban_map_wd 
 model_config_rec % urban_map_gbd              =  urban_map_gbd 
 model_config_rec % urban_map_fbd              =  urban_map_fbd 
 model_config_rec % num_urban_hi               =  num_urban_hi 
 model_config_rec % num_months                 =  num_months 
 model_config_rec % sf_surface_mosaic          =  sf_surface_mosaic 
 model_config_rec % mosaic_cat                 =  mosaic_cat 
 model_config_rec % mosaic_cat_soil            =  mosaic_cat_soil 
 model_config_rec % mosaic_lu                  =  mosaic_lu 
 model_config_rec % mosaic_soil                =  mosaic_soil 
 model_config_rec % flag_sm_adj                =  flag_sm_adj 
 model_config_rec % maxiens                    =  maxiens 
 model_config_rec % maxens                     =  maxens 
 model_config_rec % maxens2                    =  maxens2 
 model_config_rec % maxens3                    =  maxens3 
 model_config_rec % ensdim                     =  ensdim 
 model_config_rec % cugd_avedx                 =  cugd_avedx 
 model_config_rec % clos_choice                =  clos_choice 
 model_config_rec % imomentum                  =  imomentum 
 model_config_rec % ishallow                   =  ishallow 
 model_config_rec % convtrans_avglen_m         =  convtrans_avglen_m 
 model_config_rec % num_land_cat               =  num_land_cat 
 model_config_rec % num_soil_cat               =  num_soil_cat 
 model_config_rec % mp_zero_out                =  mp_zero_out 
 model_config_rec % mp_zero_out_thresh         =  mp_zero_out_thresh 
 model_config_rec % seaice_threshold           =  seaice_threshold 
 model_config_rec % sst_update                 =  sst_update 
 model_config_rec % sst_skin                   =  sst_skin 
 model_config_rec % tmn_update                 =  tmn_update 
 model_config_rec % usemonalb                  =  usemonalb 
 model_config_rec % rdmaxalb                   =  rdmaxalb 
 model_config_rec % rdlai2d                    =  rdlai2d 
 model_config_rec % ua_phys                    =  ua_phys 
 model_config_rec % opt_thcnd                  =  opt_thcnd 
 model_config_rec % co2tf                      =  co2tf 
 model_config_rec % ra_call_offset             =  ra_call_offset 
 model_config_rec % cam_abs_freq_s             =  cam_abs_freq_s 
 model_config_rec % levsiz                     =  levsiz 
 model_config_rec % paerlev                    =  paerlev 
 model_config_rec % cam_abs_dim1               =  cam_abs_dim1 
 model_config_rec % cam_abs_dim2               =  cam_abs_dim2 
 model_config_rec % lagday                     =  lagday 
 model_config_rec % no_src_types               =  no_src_types 
 model_config_rec % alevsiz                    =  alevsiz 
 model_config_rec % o3input                    =  o3input 
 model_config_rec % aer_opt                    =  aer_opt 
 model_config_rec % swint_opt                  =  swint_opt 
 model_config_rec % aer_type                   =  aer_type 
 model_config_rec % aer_aod550_opt             =  aer_aod550_opt 
 model_config_rec % aer_angexp_opt             =  aer_angexp_opt 
 model_config_rec % aer_ssa_opt                =  aer_ssa_opt 
 model_config_rec % aer_asy_opt                =  aer_asy_opt 
 model_config_rec % aer_aod550_val             =  aer_aod550_val 
 model_config_rec % aer_angexp_val             =  aer_angexp_val 
 model_config_rec % aer_ssa_val                =  aer_ssa_val 
 model_config_rec % aer_asy_val                =  aer_asy_val 
 model_config_rec % cu_rad_feedback            =  cu_rad_feedback 
 model_config_rec % dust_emis                  =  dust_emis 
 model_config_rec % erosion_dim                =  erosion_dim 
 model_config_rec % no_src_types_cu            =  no_src_types_cu 
 model_config_rec % alevsiz_cu                 =  alevsiz_cu 
 model_config_rec % aercu_opt                  =  aercu_opt 
 model_config_rec % aercu_fct                  =  aercu_fct 
 model_config_rec % aercu_used                 =  aercu_used 
 model_config_rec % shallowcu_forced_ra        =  shallowcu_forced_ra 
 model_config_rec % numbins                    =  numbins 
 model_config_rec % thbinsize                  =  thbinsize 
 model_config_rec % rbinsize                   =  rbinsize 
 model_config_rec % mindeepfreq                =  mindeepfreq 
 model_config_rec % minshallowfreq             =  minshallowfreq 
 model_config_rec % shcu_aerosols_opt          =  shcu_aerosols_opt 
 model_config_rec % icloud_cu                  =  icloud_cu 
 model_config_rec % pxlsm_smois_init           =  pxlsm_smois_init 
 model_config_rec % pxlsm_modis_veg            =  pxlsm_modis_veg 
 model_config_rec % omlcall                    =  omlcall 
 model_config_rec % sf_ocean_physics           =  sf_ocean_physics 
 model_config_rec % traj_opt                   =  traj_opt 
 model_config_rec % dm_has_traj                =  dm_has_traj 
 model_config_rec % tracercall                 =  tracercall 
 model_config_rec % omdt                       =  omdt 
 model_config_rec % oml_hml0                   =  oml_hml0 
 model_config_rec % oml_gamma                  =  oml_gamma 
 model_config_rec % oml_relaxation_time        =  oml_relaxation_time 
 model_config_rec % isftcflx                   =  isftcflx 
 model_config_rec % iz0tlnd                    =  iz0tlnd 
 model_config_rec % shadlen                    =  shadlen 
 model_config_rec % slope_rad                  =  slope_rad 
 model_config_rec % topo_shading               =  topo_shading 
 model_config_rec % topo_wind                  =  topo_wind 
 model_config_rec % no_mp_heating              =  no_mp_heating 
 model_config_rec % fractional_seaice          =  fractional_seaice 
 model_config_rec % seaice_snowdepth_opt       =  seaice_snowdepth_opt 
 model_config_rec % seaice_snowdepth_max       =  seaice_snowdepth_max 
 model_config_rec % seaice_snowdepth_min       =  seaice_snowdepth_min 
 model_config_rec % seaice_albedo_opt          =  seaice_albedo_opt 
 model_config_rec % seaice_albedo_default      =  seaice_albedo_default 
 model_config_rec % seaice_thickness_opt       =  seaice_thickness_opt 
 model_config_rec % seaice_thickness_default   =  seaice_thickness_default 
 model_config_rec % tice2tsk_if2cold           =  tice2tsk_if2cold 
 model_config_rec % bucket_mm                  =  bucket_mm 
 model_config_rec % bucket_j                   =  bucket_j 
 model_config_rec % mp_tend_lim                =  mp_tend_lim 
 model_config_rec % prec_acc_dt                =  prec_acc_dt 
 model_config_rec % prec_acc_opt               =  prec_acc_opt 
 model_config_rec % bucketr_opt                =  bucketr_opt 
 model_config_rec % bucketf_opt                =  bucketf_opt 
 model_config_rec % process_time_series        =  process_time_series 
 model_config_rec % grav_settling              =  grav_settling 
 model_config_rec % sas_pgcon                  =  sas_pgcon 
 model_config_rec % scalar_pblmix              =  scalar_pblmix 
 model_config_rec % tracer_pblmix              =  tracer_pblmix 
 model_config_rec % use_aero_icbc              =  use_aero_icbc 
 model_config_rec % use_rap_aero_icbc          =  use_rap_aero_icbc 
 model_config_rec % use_mp_re                  =  use_mp_re 
 model_config_rec % ccn_conc                   =  ccn_conc 
 model_config_rec % hail_opt                   =  hail_opt 
 model_config_rec % morr_rimed_ice             =  morr_rimed_ice 
 model_config_rec % clean_atm_diag             =  clean_atm_diag 
 model_config_rec % calc_clean_atm_diag        =  calc_clean_atm_diag 
 model_config_rec % dveg                       =  dveg 
 model_config_rec % opt_crs                    =  opt_crs 
 model_config_rec % opt_btr                    =  opt_btr 
 model_config_rec % opt_run                    =  opt_run 
 model_config_rec % opt_sfc                    =  opt_sfc 
 model_config_rec % opt_frz                    =  opt_frz 
 model_config_rec % opt_inf                    =  opt_inf 
 model_config_rec % opt_rad                    =  opt_rad 
 model_config_rec % opt_alb                    =  opt_alb 
 model_config_rec % opt_snf                    =  opt_snf 
 model_config_rec % opt_tbot                   =  opt_tbot 
 model_config_rec % opt_stc                    =  opt_stc 
 model_config_rec % opt_gla                    =  opt_gla 
 model_config_rec % opt_rsf                    =  opt_rsf 
 model_config_rec % opt_soil                   =  opt_soil 
 model_config_rec % opt_pedo                   =  opt_pedo 
 model_config_rec % opt_crop                   =  opt_crop 
 model_config_rec % wtddt                      =  wtddt 
 model_config_rec % wrf_hydro                  =  wrf_hydro 
 model_config_rec % fgdt                       =  fgdt 
 model_config_rec % fgdtzero                   =  fgdtzero 
 model_config_rec % grid_fdda                  =  grid_fdda 
 model_config_rec % grid_sfdda                 =  grid_sfdda 
 model_config_rec % if_no_pbl_nudging_uv       =  if_no_pbl_nudging_uv 
 model_config_rec % if_no_pbl_nudging_t        =  if_no_pbl_nudging_t 
 model_config_rec % if_no_pbl_nudging_ph       =  if_no_pbl_nudging_ph 
 model_config_rec % if_no_pbl_nudging_q        =  if_no_pbl_nudging_q 
 model_config_rec % if_zfac_uv                 =  if_zfac_uv 
 model_config_rec % k_zfac_uv                  =  k_zfac_uv 
 model_config_rec % if_zfac_t                  =  if_zfac_t 
 model_config_rec % k_zfac_t                   =  k_zfac_t 
 model_config_rec % if_zfac_ph                 =  if_zfac_ph 
 model_config_rec % k_zfac_ph                  =  k_zfac_ph 
 model_config_rec % if_zfac_q                  =  if_zfac_q 
 model_config_rec % k_zfac_q                   =  k_zfac_q 
 model_config_rec % dk_zfac_uv                 =  dk_zfac_uv 
 model_config_rec % dk_zfac_t                  =  dk_zfac_t 
 model_config_rec % dk_zfac_ph                 =  dk_zfac_ph 
 model_config_rec % dk_zfac_q                  =  dk_zfac_q 
 model_config_rec % ktrop                      =  ktrop 
 model_config_rec % guv                        =  guv 
 model_config_rec % guv_sfc                    =  guv_sfc 
 model_config_rec % gt                         =  gt 
 model_config_rec % gt_sfc                     =  gt_sfc 
 model_config_rec % gq                         =  gq 
 model_config_rec % gq_sfc                     =  gq_sfc 
 model_config_rec % gph                        =  gph 
 model_config_rec % dtramp_min                 =  dtramp_min 
 model_config_rec % if_ramping                 =  if_ramping 
 model_config_rec % rinblw                     =  rinblw 
 model_config_rec % xwavenum                   =  xwavenum 
 model_config_rec % ywavenum                   =  ywavenum 
 model_config_rec % pxlsm_soil_nudge           =  pxlsm_soil_nudge 
 model_config_rec % fasdas                     =  fasdas 
 model_config_rec % obs_nudge_opt              =  obs_nudge_opt 
 model_config_rec % max_obs                    =  max_obs 
 model_config_rec % fdda_start                 =  fdda_start 
 model_config_rec % fdda_end                   =  fdda_end 
 model_config_rec % obs_nudge_wind             =  obs_nudge_wind 
 model_config_rec % obs_coef_wind              =  obs_coef_wind 
 model_config_rec % obs_nudge_temp             =  obs_nudge_temp 
 model_config_rec % obs_coef_temp              =  obs_coef_temp 
 model_config_rec % obs_nudge_mois             =  obs_nudge_mois 
 model_config_rec % obs_coef_mois              =  obs_coef_mois 
 model_config_rec % obs_nudge_pstr             =  obs_nudge_pstr 
 model_config_rec % obs_coef_pstr              =  obs_coef_pstr 
 model_config_rec % obs_no_pbl_nudge_uv        =  obs_no_pbl_nudge_uv 
 model_config_rec % obs_no_pbl_nudge_t         =  obs_no_pbl_nudge_t 
 model_config_rec % obs_no_pbl_nudge_q         =  obs_no_pbl_nudge_q 
 model_config_rec % obs_sfc_scheme_horiz       =  obs_sfc_scheme_horiz 
 model_config_rec % obs_sfc_scheme_vert        =  obs_sfc_scheme_vert 
 model_config_rec % obs_max_sndng_gap          =  obs_max_sndng_gap 
 model_config_rec % obs_nudgezfullr1_uv        =  obs_nudgezfullr1_uv 
 model_config_rec % obs_nudgezrampr1_uv        =  obs_nudgezrampr1_uv 
 model_config_rec % obs_nudgezfullr2_uv        =  obs_nudgezfullr2_uv 
 model_config_rec % obs_nudgezrampr2_uv        =  obs_nudgezrampr2_uv 
 model_config_rec % obs_nudgezfullr4_uv        =  obs_nudgezfullr4_uv 
 model_config_rec % obs_nudgezrampr4_uv        =  obs_nudgezrampr4_uv 
 model_config_rec % obs_nudgezfullr1_t         =  obs_nudgezfullr1_t 
 model_config_rec % obs_nudgezrampr1_t         =  obs_nudgezrampr1_t 
 model_config_rec % obs_nudgezfullr2_t         =  obs_nudgezfullr2_t 
 model_config_rec % obs_nudgezrampr2_t         =  obs_nudgezrampr2_t 
 model_config_rec % obs_nudgezfullr4_t         =  obs_nudgezfullr4_t 
 model_config_rec % obs_nudgezrampr4_t         =  obs_nudgezrampr4_t 
 model_config_rec % obs_nudgezfullr1_q         =  obs_nudgezfullr1_q 
 model_config_rec % obs_nudgezrampr1_q         =  obs_nudgezrampr1_q 
 model_config_rec % obs_nudgezfullr2_q         =  obs_nudgezfullr2_q 
 model_config_rec % obs_nudgezrampr2_q         =  obs_nudgezrampr2_q 
 model_config_rec % obs_nudgezfullr4_q         =  obs_nudgezfullr4_q 
 model_config_rec % obs_nudgezrampr4_q         =  obs_nudgezrampr4_q 
 model_config_rec % obs_nudgezfullmin          =  obs_nudgezfullmin 
 model_config_rec % obs_nudgezrampmin          =  obs_nudgezrampmin 
 model_config_rec % obs_nudgezmax              =  obs_nudgezmax 
 model_config_rec % obs_sfcfact                =  obs_sfcfact 
 model_config_rec % obs_sfcfacr                =  obs_sfcfacr 
 model_config_rec % obs_dpsmx                  =  obs_dpsmx 
 model_config_rec % obs_rinxy                  =  obs_rinxy 
 model_config_rec % obs_rinsig                 =  obs_rinsig 
 model_config_rec % obs_twindo                 =  obs_twindo 
 model_config_rec % obs_npfi                   =  obs_npfi 
 model_config_rec % obs_ionf                   =  obs_ionf 
 model_config_rec % obs_idynin                 =  obs_idynin 
 model_config_rec % obs_dtramp                 =  obs_dtramp 
 model_config_rec % obs_prt_max                =  obs_prt_max 
 model_config_rec % obs_prt_freq               =  obs_prt_freq 
 model_config_rec % obs_ipf_in4dob             =  obs_ipf_in4dob 
 model_config_rec % obs_ipf_errob              =  obs_ipf_errob 
 model_config_rec % obs_ipf_nudob              =  obs_ipf_nudob 
 model_config_rec % obs_ipf_init               =  obs_ipf_init 
 model_config_rec % obs_scl_neg_qv_innov       =  obs_scl_neg_qv_innov 
 model_config_rec % scm_force                  =  scm_force 
 model_config_rec % scm_force_dx               =  scm_force_dx 
 model_config_rec % num_force_layers           =  num_force_layers 
 model_config_rec % scm_lu_index               =  scm_lu_index 
 model_config_rec % scm_isltyp                 =  scm_isltyp 
 model_config_rec % scm_vegfra                 =  scm_vegfra 
 model_config_rec % scm_canwat                 =  scm_canwat 
 model_config_rec % scm_lat                    =  scm_lat 
 model_config_rec % scm_lon                    =  scm_lon 
 model_config_rec % scm_th_t_tend              =  scm_th_t_tend 
 model_config_rec % scm_qv_t_tend              =  scm_qv_t_tend 
 model_config_rec % scm_th_adv                 =  scm_th_adv 
 model_config_rec % scm_wind_adv               =  scm_wind_adv 
 model_config_rec % scm_qv_adv                 =  scm_qv_adv 
 model_config_rec % scm_ql_adv                 =  scm_ql_adv 
 model_config_rec % scm_vert_adv               =  scm_vert_adv 
 model_config_rec % num_force_soil_layers      =  num_force_soil_layers 
 model_config_rec % scm_soilt_force            =  scm_soilt_force 
 model_config_rec % scm_soilq_force            =  scm_soilq_force 
 model_config_rec % scm_force_th_largescale    =  scm_force_th_largescale 
 model_config_rec % scm_force_qv_largescale    =  scm_force_qv_largescale 
 model_config_rec % scm_force_ql_largescale    =  scm_force_ql_largescale 
 model_config_rec % scm_force_wind_largescale  =  scm_force_wind_largescale 
 model_config_rec % scm_force_skintemp         =  scm_force_skintemp 
 model_config_rec % scm_force_flux             =  scm_force_flux 
 model_config_rec % dyn_opt                    =  dyn_opt 
 model_config_rec % rk_ord                     =  rk_ord 
 model_config_rec % w_damping                  =  w_damping 
 model_config_rec % diff_opt                   =  diff_opt 
 model_config_rec % diff_opt_dfi               =  diff_opt_dfi 
 model_config_rec % km_opt                     =  km_opt 
 model_config_rec % km_opt_dfi                 =  km_opt_dfi 
 model_config_rec % damp_opt                   =  damp_opt 
 model_config_rec % rad_nudge                  =  rad_nudge 
 model_config_rec % gwd_opt                    =  gwd_opt 
 model_config_rec % max_rot_angle_gwd          =  max_rot_angle_gwd 
 model_config_rec % zdamp                      =  zdamp 
 model_config_rec % dampcoef                   =  dampcoef 
 model_config_rec % khdif                      =  khdif 
 model_config_rec % kvdif                      =  kvdif 
 model_config_rec % diff_6th_factor            =  diff_6th_factor 
 model_config_rec % diff_6th_opt               =  diff_6th_opt 
 model_config_rec % diff_6th_slopeopt          =  diff_6th_slopeopt 
 model_config_rec % diff_6th_thresh            =  diff_6th_thresh 
 model_config_rec % use_theta_m                =  use_theta_m 
 model_config_rec % use_q_diabatic             =  use_q_diabatic 
 model_config_rec % c_s                        =  c_s 
 model_config_rec % c_k                        =  c_k 
 model_config_rec % smdiv                      =  smdiv 
 model_config_rec % emdiv                      =  emdiv 
 model_config_rec % epssm                      =  epssm 
 model_config_rec % non_hydrostatic            =  non_hydrostatic 
 model_config_rec % use_input_w                =  use_input_w 
 model_config_rec % time_step_sound            =  time_step_sound 
 model_config_rec % h_mom_adv_order            =  h_mom_adv_order 
 model_config_rec % v_mom_adv_order            =  v_mom_adv_order 
 model_config_rec % h_sca_adv_order            =  h_sca_adv_order 
 model_config_rec % v_sca_adv_order            =  v_sca_adv_order 
 model_config_rec % momentum_adv_opt           =  momentum_adv_opt 
 model_config_rec % moist_adv_opt              =  moist_adv_opt 
 model_config_rec % moist_adv_dfi_opt          =  moist_adv_dfi_opt 
 model_config_rec % chem_adv_opt               =  chem_adv_opt 
 model_config_rec % tracer_adv_opt             =  tracer_adv_opt 
 model_config_rec % scalar_adv_opt             =  scalar_adv_opt 
 model_config_rec % tke_adv_opt                =  tke_adv_opt 
 model_config_rec % moist_mix2_off             =  moist_mix2_off 
 model_config_rec % chem_mix2_off              =  chem_mix2_off 
 model_config_rec % tracer_mix2_off            =  tracer_mix2_off 
 model_config_rec % scalar_mix2_off            =  scalar_mix2_off 
 model_config_rec % tke_mix2_off               =  tke_mix2_off 
 model_config_rec % moist_mix6_off             =  moist_mix6_off 
 model_config_rec % chem_mix6_off              =  chem_mix6_off 
 model_config_rec % tracer_mix6_off            =  tracer_mix6_off 
 model_config_rec % scalar_mix6_off            =  scalar_mix6_off 
 model_config_rec % tke_mix6_off               =  tke_mix6_off 
 model_config_rec % top_radiation              =  top_radiation 
 model_config_rec % mix_isotropic              =  mix_isotropic 
 model_config_rec % mix_upper_bound            =  mix_upper_bound 
 model_config_rec % top_lid                    =  top_lid 
 model_config_rec % tke_upper_bound            =  tke_upper_bound 
 model_config_rec % tke_drag_coefficient       =  tke_drag_coefficient 
 model_config_rec % tke_heat_flux              =  tke_heat_flux 
 model_config_rec % pert_coriolis              =  pert_coriolis 
 model_config_rec % coriolis2d                 =  coriolis2d 
 model_config_rec % mix_full_fields            =  mix_full_fields 
 model_config_rec % base_pres                  =  base_pres 
 model_config_rec % base_temp                  =  base_temp 
 model_config_rec % base_lapse                 =  base_lapse 
 model_config_rec % iso_temp                   =  iso_temp 
 model_config_rec % base_pres_strat            =  base_pres_strat 
 model_config_rec % base_lapse_strat           =  base_lapse_strat 
 model_config_rec % use_baseparam_fr_nml       =  use_baseparam_fr_nml 
 model_config_rec % fft_filter_lat             =  fft_filter_lat 
 model_config_rec % coupled_filtering          =  coupled_filtering 
 model_config_rec % pos_def                    =  pos_def 
 model_config_rec % swap_pole_with_next_j      =  swap_pole_with_next_j 
 model_config_rec % actual_distance_average    =  actual_distance_average 
 model_config_rec % rotated_pole               =  rotated_pole 
 model_config_rec % do_coriolis                =  do_coriolis 
 model_config_rec % do_curvature               =  do_curvature 
 model_config_rec % do_gradp                   =  do_gradp 
 model_config_rec % tracer_opt                 =  tracer_opt 
 model_config_rec % tenddiag                   =  tenddiag 
 model_config_rec % spec_bdy_width             =  spec_bdy_width 
 model_config_rec % spec_zone                  =  spec_zone 
 model_config_rec % relax_zone                 =  relax_zone 
 model_config_rec % specified                  =  specified 
 model_config_rec % constant_bc                =  constant_bc 
 model_config_rec % periodic_x                 =  periodic_x 
 model_config_rec % symmetric_xs               =  symmetric_xs 
 model_config_rec % symmetric_xe               =  symmetric_xe 
 model_config_rec % open_xs                    =  open_xs 
 model_config_rec % open_xe                    =  open_xe 
 model_config_rec % periodic_y                 =  periodic_y 
 model_config_rec % symmetric_ys               =  symmetric_ys 
 model_config_rec % symmetric_ye               =  symmetric_ye 
 model_config_rec % open_ys                    =  open_ys 
 model_config_rec % open_ye                    =  open_ye 
 model_config_rec % polar                      =  polar 
 model_config_rec % nested                     =  nested 
 model_config_rec % spec_exp                   =  spec_exp 
 model_config_rec % spec_bdy_final_mu          =  spec_bdy_final_mu 
 model_config_rec % real_data_init_type        =  real_data_init_type 
 model_config_rec % have_bcs_moist             =  have_bcs_moist 
 model_config_rec % have_bcs_scalar            =  have_bcs_scalar 
 model_config_rec % background_proc_id         =  background_proc_id 
 model_config_rec % forecast_proc_id           =  forecast_proc_id 
 model_config_rec % production_status          =  production_status 
 model_config_rec % compression                =  compression 
 model_config_rec % nobs_ndg_vars              =  nobs_ndg_vars 
 model_config_rec % nobs_err_flds              =  nobs_err_flds 
 model_config_rec % cen_lat                    =  cen_lat 
 model_config_rec % cen_lon                    =  cen_lon 
 model_config_rec % truelat1                   =  truelat1 
 model_config_rec % truelat2                   =  truelat2 
 model_config_rec % moad_cen_lat               =  moad_cen_lat 
 model_config_rec % stand_lon                  =  stand_lon 
 model_config_rec % pole_lat                   =  pole_lat 
 model_config_rec % pole_lon                   =  pole_lon 
 model_config_rec % flag_metgrid               =  flag_metgrid 
 model_config_rec % flag_snow                  =  flag_snow 
 model_config_rec % flag_psfc                  =  flag_psfc 
 model_config_rec % flag_sm000010              =  flag_sm000010 
 model_config_rec % flag_sm010040              =  flag_sm010040 
 model_config_rec % flag_sm040100              =  flag_sm040100 
 model_config_rec % flag_sm100200              =  flag_sm100200 
 model_config_rec % flag_st000010              =  flag_st000010 
 model_config_rec % flag_st010040              =  flag_st010040 
 model_config_rec % flag_st040100              =  flag_st040100 
 model_config_rec % flag_st100200              =  flag_st100200 
 model_config_rec % flag_soil_layers           =  flag_soil_layers 
 model_config_rec % flag_slp                   =  flag_slp 
 model_config_rec % flag_soilhgt               =  flag_soilhgt 
 model_config_rec % flag_mf_xy                 =  flag_mf_xy 
 model_config_rec % flag_um_soil               =  flag_um_soil 
 model_config_rec % bdyfrq                     =  bdyfrq 
 model_config_rec % mminlu                     =  mminlu 
 model_config_rec % iswater                    =  iswater 
 model_config_rec % islake                     =  islake 
 model_config_rec % isice                      =  isice 
 model_config_rec % isurban                    =  isurban 
 model_config_rec % isoilwater                 =  isoilwater 
 model_config_rec % map_proj                   =  map_proj 
 model_config_rec % use_wps_input              =  use_wps_input 
 model_config_rec % dfi_stage                  =  dfi_stage 
 model_config_rec % mp_physics_dfi             =  mp_physics_dfi 
 model_config_rec % bl_pbl_physics_dfi         =  bl_pbl_physics_dfi 
 model_config_rec % windfarm_opt               =  windfarm_opt 
 model_config_rec % windfarm_ij                =  windfarm_ij 
 model_config_rec % ideal_case                 =  ideal_case 
 model_config_rec % hailcast_opt               =  hailcast_opt 
 model_config_rec % haildt                     =  haildt 
 model_config_rec % lightning_option           =  lightning_option 
 model_config_rec % lightning_dt               =  lightning_dt 
 model_config_rec % lightning_start_seconds    =  lightning_start_seconds 
 model_config_rec % flashrate_factor           =  flashrate_factor 
 model_config_rec % iccg_method                =  iccg_method 
 model_config_rec % iccg_prescribed_num        =  iccg_prescribed_num 
 model_config_rec % iccg_prescribed_den        =  iccg_prescribed_den 
 model_config_rec % cellcount_method           =  cellcount_method 
 model_config_rec % cldtop_adjustment          =  cldtop_adjustment 
 model_config_rec % sf_lake_physics            =  sf_lake_physics 
 model_config_rec % auxinput1_inname           =  auxinput1_inname 
 model_config_rec % io_form_auxinput1          =  io_form_auxinput1 
 model_config_rec % override_restart_timers    =  override_restart_timers 
 model_config_rec % auxhist1_inname            =  auxhist1_inname 
 model_config_rec % auxhist1_outname           =  auxhist1_outname 
 model_config_rec % auxhist1_interval_y        =  auxhist1_interval_y 
 model_config_rec % auxhist1_interval_d        =  auxhist1_interval_d 
 model_config_rec % auxhist1_interval_h        =  auxhist1_interval_h 
 model_config_rec % auxhist1_interval_m        =  auxhist1_interval_m 
 model_config_rec % auxhist1_interval_s        =  auxhist1_interval_s 
 model_config_rec % auxhist1_interval          =  auxhist1_interval 
 model_config_rec % auxhist1_begin_y           =  auxhist1_begin_y 
 model_config_rec % auxhist1_begin_d           =  auxhist1_begin_d 
 model_config_rec % auxhist1_begin_h           =  auxhist1_begin_h 
 model_config_rec % auxhist1_begin_m           =  auxhist1_begin_m 
 model_config_rec % auxhist1_begin_s           =  auxhist1_begin_s 
 model_config_rec % auxhist1_begin             =  auxhist1_begin 
 model_config_rec % auxhist1_end_y             =  auxhist1_end_y 
 model_config_rec % auxhist1_end_d             =  auxhist1_end_d 
 model_config_rec % auxhist1_end_h             =  auxhist1_end_h 
 model_config_rec % auxhist1_end_m             =  auxhist1_end_m 
 model_config_rec % auxhist1_end_s             =  auxhist1_end_s 
 model_config_rec % auxhist1_end               =  auxhist1_end 
 model_config_rec % io_form_auxhist1           =  io_form_auxhist1 
 model_config_rec % frames_per_auxhist1        =  frames_per_auxhist1 
 model_config_rec % auxhist2_inname            =  auxhist2_inname 
 model_config_rec % auxhist2_outname           =  auxhist2_outname 
 model_config_rec % auxhist2_interval_y        =  auxhist2_interval_y 
 model_config_rec % auxhist2_interval_d        =  auxhist2_interval_d 
 model_config_rec % auxhist2_interval_h        =  auxhist2_interval_h 
 model_config_rec % auxhist2_interval_m        =  auxhist2_interval_m 
 model_config_rec % auxhist2_interval_s        =  auxhist2_interval_s 
 model_config_rec % auxhist2_interval          =  auxhist2_interval 
 model_config_rec % auxhist2_begin_y           =  auxhist2_begin_y 
 model_config_rec % auxhist2_begin_d           =  auxhist2_begin_d 
 model_config_rec % auxhist2_begin_h           =  auxhist2_begin_h 
 model_config_rec % auxhist2_begin_m           =  auxhist2_begin_m 
 model_config_rec % auxhist2_begin_s           =  auxhist2_begin_s 
 model_config_rec % auxhist2_begin             =  auxhist2_begin 
 model_config_rec % auxhist2_end_y             =  auxhist2_end_y 
 model_config_rec % auxhist2_end_d             =  auxhist2_end_d 
 model_config_rec % auxhist2_end_h             =  auxhist2_end_h 
 model_config_rec % auxhist2_end_m             =  auxhist2_end_m 
 model_config_rec % auxhist2_end_s             =  auxhist2_end_s 
 model_config_rec % auxhist2_end               =  auxhist2_end 
 model_config_rec % io_form_auxhist2           =  io_form_auxhist2 
 model_config_rec % frames_per_auxhist2        =  frames_per_auxhist2 
 model_config_rec % auxhist3_inname            =  auxhist3_inname 
 model_config_rec % auxhist3_outname           =  auxhist3_outname 
 model_config_rec % auxhist3_interval_y        =  auxhist3_interval_y 
 model_config_rec % auxhist3_interval_d        =  auxhist3_interval_d 
 model_config_rec % auxhist3_interval_h        =  auxhist3_interval_h 
 model_config_rec % auxhist3_interval_m        =  auxhist3_interval_m 
 model_config_rec % auxhist3_interval_s        =  auxhist3_interval_s 
 model_config_rec % auxhist3_interval          =  auxhist3_interval 
 model_config_rec % auxhist3_begin_y           =  auxhist3_begin_y 
 model_config_rec % auxhist3_begin_d           =  auxhist3_begin_d 
 model_config_rec % auxhist3_begin_h           =  auxhist3_begin_h 
 model_config_rec % auxhist3_begin_m           =  auxhist3_begin_m 
 model_config_rec % auxhist3_begin_s           =  auxhist3_begin_s 
 model_config_rec % auxhist3_begin             =  auxhist3_begin 
 model_config_rec % auxhist3_end_y             =  auxhist3_end_y 
 model_config_rec % auxhist3_end_d             =  auxhist3_end_d 
 model_config_rec % auxhist3_end_h             =  auxhist3_end_h 
 model_config_rec % auxhist3_end_m             =  auxhist3_end_m 
 model_config_rec % auxhist3_end_s             =  auxhist3_end_s 
 model_config_rec % auxhist3_end               =  auxhist3_end 
 model_config_rec % io_form_auxhist3           =  io_form_auxhist3 
 model_config_rec % frames_per_auxhist3        =  frames_per_auxhist3 
 model_config_rec % auxhist4_inname            =  auxhist4_inname 
 model_config_rec % auxhist4_outname           =  auxhist4_outname 
 model_config_rec % auxhist4_interval_y        =  auxhist4_interval_y 
 model_config_rec % auxhist4_interval_d        =  auxhist4_interval_d 
 model_config_rec % auxhist4_interval_h        =  auxhist4_interval_h 
 model_config_rec % auxhist4_interval_m        =  auxhist4_interval_m 
 model_config_rec % auxhist4_interval_s        =  auxhist4_interval_s 
 model_config_rec % auxhist4_interval          =  auxhist4_interval 
 model_config_rec % auxhist4_begin_y           =  auxhist4_begin_y 
 model_config_rec % auxhist4_begin_d           =  auxhist4_begin_d 
 model_config_rec % auxhist4_begin_h           =  auxhist4_begin_h 
 model_config_rec % auxhist4_begin_m           =  auxhist4_begin_m 
 model_config_rec % auxhist4_begin_s           =  auxhist4_begin_s 
 model_config_rec % auxhist4_begin             =  auxhist4_begin 
 model_config_rec % auxhist4_end_y             =  auxhist4_end_y 
 model_config_rec % auxhist4_end_d             =  auxhist4_end_d 
 model_config_rec % auxhist4_end_h             =  auxhist4_end_h 
 model_config_rec % auxhist4_end_m             =  auxhist4_end_m 
 model_config_rec % auxhist4_end_s             =  auxhist4_end_s 
 model_config_rec % auxhist4_end               =  auxhist4_end 
 model_config_rec % io_form_auxhist4           =  io_form_auxhist4 
 model_config_rec % frames_per_auxhist4        =  frames_per_auxhist4 
 model_config_rec % auxhist5_inname            =  auxhist5_inname 
 model_config_rec % auxhist5_outname           =  auxhist5_outname 
 model_config_rec % auxhist5_interval_y        =  auxhist5_interval_y 
 model_config_rec % auxhist5_interval_d        =  auxhist5_interval_d 
 model_config_rec % auxhist5_interval_h        =  auxhist5_interval_h 
 model_config_rec % auxhist5_interval_m        =  auxhist5_interval_m 
 model_config_rec % auxhist5_interval_s        =  auxhist5_interval_s 
 model_config_rec % auxhist5_interval          =  auxhist5_interval 
 model_config_rec % auxhist5_begin_y           =  auxhist5_begin_y 
 model_config_rec % auxhist5_begin_d           =  auxhist5_begin_d 
 model_config_rec % auxhist5_begin_h           =  auxhist5_begin_h 
 model_config_rec % auxhist5_begin_m           =  auxhist5_begin_m 
 model_config_rec % auxhist5_begin_s           =  auxhist5_begin_s 
 model_config_rec % auxhist5_begin             =  auxhist5_begin 
 model_config_rec % auxhist5_end_y             =  auxhist5_end_y 
 model_config_rec % auxhist5_end_d             =  auxhist5_end_d 
 model_config_rec % auxhist5_end_h             =  auxhist5_end_h 
 model_config_rec % auxhist5_end_m             =  auxhist5_end_m 
 model_config_rec % auxhist5_end_s             =  auxhist5_end_s 
 model_config_rec % auxhist5_end               =  auxhist5_end 
 model_config_rec % io_form_auxhist5           =  io_form_auxhist5 
 model_config_rec % frames_per_auxhist5        =  frames_per_auxhist5 
 model_config_rec % auxhist6_inname            =  auxhist6_inname 
 model_config_rec % auxhist6_outname           =  auxhist6_outname 
 model_config_rec % auxhist6_interval_y        =  auxhist6_interval_y 
 model_config_rec % auxhist6_interval_d        =  auxhist6_interval_d 
 model_config_rec % auxhist6_interval_h        =  auxhist6_interval_h 
 model_config_rec % auxhist6_interval_m        =  auxhist6_interval_m 
 model_config_rec % auxhist6_interval_s        =  auxhist6_interval_s 
 model_config_rec % auxhist6_interval          =  auxhist6_interval 
 model_config_rec % auxhist6_begin_y           =  auxhist6_begin_y 
 model_config_rec % auxhist6_begin_d           =  auxhist6_begin_d 
 model_config_rec % auxhist6_begin_h           =  auxhist6_begin_h 
 model_config_rec % auxhist6_begin_m           =  auxhist6_begin_m 
 model_config_rec % auxhist6_begin_s           =  auxhist6_begin_s 
 model_config_rec % auxhist6_begin             =  auxhist6_begin 
 model_config_rec % auxhist6_end_y             =  auxhist6_end_y 
 model_config_rec % auxhist6_end_d             =  auxhist6_end_d 
 model_config_rec % auxhist6_end_h             =  auxhist6_end_h 
 model_config_rec % auxhist6_end_m             =  auxhist6_end_m 
 model_config_rec % auxhist6_end_s             =  auxhist6_end_s 
 model_config_rec % auxhist6_end               =  auxhist6_end 
 model_config_rec % io_form_auxhist6           =  io_form_auxhist6 
 model_config_rec % frames_per_auxhist6        =  frames_per_auxhist6 
 model_config_rec % auxhist7_inname            =  auxhist7_inname 
 model_config_rec % auxhist7_outname           =  auxhist7_outname 
 model_config_rec % auxhist7_interval_y        =  auxhist7_interval_y 
 model_config_rec % auxhist7_interval_d        =  auxhist7_interval_d 
 model_config_rec % auxhist7_interval_h        =  auxhist7_interval_h 
 model_config_rec % auxhist7_interval_m        =  auxhist7_interval_m 
 model_config_rec % auxhist7_interval_s        =  auxhist7_interval_s 
 model_config_rec % auxhist7_interval          =  auxhist7_interval 
 model_config_rec % auxhist7_begin_y           =  auxhist7_begin_y 
 model_config_rec % auxhist7_begin_d           =  auxhist7_begin_d 
 model_config_rec % auxhist7_begin_h           =  auxhist7_begin_h 
 model_config_rec % auxhist7_begin_m           =  auxhist7_begin_m 
 model_config_rec % auxhist7_begin_s           =  auxhist7_begin_s 
 model_config_rec % auxhist7_begin             =  auxhist7_begin 
 model_config_rec % auxhist7_end_y             =  auxhist7_end_y 
 model_config_rec % auxhist7_end_d             =  auxhist7_end_d 
 model_config_rec % auxhist7_end_h             =  auxhist7_end_h 
 model_config_rec % auxhist7_end_m             =  auxhist7_end_m 
 model_config_rec % auxhist7_end_s             =  auxhist7_end_s 
 model_config_rec % auxhist7_end               =  auxhist7_end 
 model_config_rec % io_form_auxhist7           =  io_form_auxhist7 
 model_config_rec % frames_per_auxhist7        =  frames_per_auxhist7 
 model_config_rec % auxhist8_inname            =  auxhist8_inname 
 model_config_rec % auxhist8_outname           =  auxhist8_outname 
 model_config_rec % auxhist8_interval_y        =  auxhist8_interval_y 
 model_config_rec % auxhist8_interval_d        =  auxhist8_interval_d 
 model_config_rec % auxhist8_interval_h        =  auxhist8_interval_h 
 model_config_rec % auxhist8_interval_m        =  auxhist8_interval_m 
 model_config_rec % auxhist8_interval_s        =  auxhist8_interval_s 
 model_config_rec % auxhist8_interval          =  auxhist8_interval 
 model_config_rec % auxhist8_begin_y           =  auxhist8_begin_y 
 model_config_rec % auxhist8_begin_d           =  auxhist8_begin_d 
 model_config_rec % auxhist8_begin_h           =  auxhist8_begin_h 
 model_config_rec % auxhist8_begin_m           =  auxhist8_begin_m 
 model_config_rec % auxhist8_begin_s           =  auxhist8_begin_s 
 model_config_rec % auxhist8_begin             =  auxhist8_begin 
 model_config_rec % auxhist8_end_y             =  auxhist8_end_y 
 model_config_rec % auxhist8_end_d             =  auxhist8_end_d 
 model_config_rec % auxhist8_end_h             =  auxhist8_end_h 
 model_config_rec % auxhist8_end_m             =  auxhist8_end_m 
 model_config_rec % auxhist8_end_s             =  auxhist8_end_s 
 model_config_rec % auxhist8_end               =  auxhist8_end 
 model_config_rec % io_form_auxhist8           =  io_form_auxhist8 
 model_config_rec % frames_per_auxhist8        =  frames_per_auxhist8 
 model_config_rec % auxhist9_inname            =  auxhist9_inname 
 model_config_rec % auxhist9_outname           =  auxhist9_outname 
 model_config_rec % auxhist9_interval_y        =  auxhist9_interval_y 
 model_config_rec % auxhist9_interval_d        =  auxhist9_interval_d 
 model_config_rec % auxhist9_interval_h        =  auxhist9_interval_h 
 model_config_rec % auxhist9_interval_m        =  auxhist9_interval_m 
 model_config_rec % auxhist9_interval_s        =  auxhist9_interval_s 
 model_config_rec % auxhist9_interval          =  auxhist9_interval 
 model_config_rec % auxhist9_begin_y           =  auxhist9_begin_y 
 model_config_rec % auxhist9_begin_d           =  auxhist9_begin_d 
 model_config_rec % auxhist9_begin_h           =  auxhist9_begin_h 
 model_config_rec % auxhist9_begin_m           =  auxhist9_begin_m 
 model_config_rec % auxhist9_begin_s           =  auxhist9_begin_s 
 model_config_rec % auxhist9_begin             =  auxhist9_begin 
 model_config_rec % auxhist9_end_y             =  auxhist9_end_y 
 model_config_rec % auxhist9_end_d             =  auxhist9_end_d 
 model_config_rec % auxhist9_end_h             =  auxhist9_end_h 
 model_config_rec % auxhist9_end_m             =  auxhist9_end_m 
 model_config_rec % auxhist9_end_s             =  auxhist9_end_s 
 model_config_rec % auxhist9_end               =  auxhist9_end 
 model_config_rec % io_form_auxhist9           =  io_form_auxhist9 
 model_config_rec % frames_per_auxhist9        =  frames_per_auxhist9 
 model_config_rec % auxhist10_inname           =  auxhist10_inname 
 model_config_rec % auxhist10_outname          =  auxhist10_outname 
 model_config_rec % auxhist10_interval_y       =  auxhist10_interval_y 
 model_config_rec % auxhist10_interval_d       =  auxhist10_interval_d 
 model_config_rec % auxhist10_interval_h       =  auxhist10_interval_h 
 model_config_rec % auxhist10_interval_m       =  auxhist10_interval_m 
 model_config_rec % auxhist10_interval_s       =  auxhist10_interval_s 
 model_config_rec % auxhist10_interval         =  auxhist10_interval 
 model_config_rec % auxhist10_begin_y          =  auxhist10_begin_y 
 model_config_rec % auxhist10_begin_d          =  auxhist10_begin_d 
 model_config_rec % auxhist10_begin_h          =  auxhist10_begin_h 
 model_config_rec % auxhist10_begin_m          =  auxhist10_begin_m 
 model_config_rec % auxhist10_begin_s          =  auxhist10_begin_s 
 model_config_rec % auxhist10_begin            =  auxhist10_begin 
 model_config_rec % auxhist10_end_y            =  auxhist10_end_y 
 model_config_rec % auxhist10_end_d            =  auxhist10_end_d 
 model_config_rec % auxhist10_end_h            =  auxhist10_end_h 
 model_config_rec % auxhist10_end_m            =  auxhist10_end_m 
 model_config_rec % auxhist10_end_s            =  auxhist10_end_s 
 model_config_rec % auxhist10_end              =  auxhist10_end 
 model_config_rec % io_form_auxhist10          =  io_form_auxhist10 
 model_config_rec % frames_per_auxhist10       =  frames_per_auxhist10 
 model_config_rec % auxhist11_inname           =  auxhist11_inname 
 model_config_rec % auxhist11_outname          =  auxhist11_outname 
 model_config_rec % auxhist11_interval_y       =  auxhist11_interval_y 
 model_config_rec % auxhist11_interval_d       =  auxhist11_interval_d 
 model_config_rec % auxhist11_interval_h       =  auxhist11_interval_h 
 model_config_rec % auxhist11_interval_m       =  auxhist11_interval_m 
 model_config_rec % auxhist11_interval_s       =  auxhist11_interval_s 
 model_config_rec % auxhist11_interval         =  auxhist11_interval 
 model_config_rec % auxhist11_begin_y          =  auxhist11_begin_y 
 model_config_rec % auxhist11_begin_d          =  auxhist11_begin_d 
 model_config_rec % auxhist11_begin_h          =  auxhist11_begin_h 
 model_config_rec % auxhist11_begin_m          =  auxhist11_begin_m 
 model_config_rec % auxhist11_begin_s          =  auxhist11_begin_s 
 model_config_rec % auxhist11_begin            =  auxhist11_begin 
 model_config_rec % auxhist11_end_y            =  auxhist11_end_y 
 model_config_rec % auxhist11_end_d            =  auxhist11_end_d 
 model_config_rec % auxhist11_end_h            =  auxhist11_end_h 
 model_config_rec % auxhist11_end_m            =  auxhist11_end_m 
 model_config_rec % auxhist11_end_s            =  auxhist11_end_s 
 model_config_rec % auxhist11_end              =  auxhist11_end 
 model_config_rec % io_form_auxhist11          =  io_form_auxhist11 
 model_config_rec % frames_per_auxhist11       =  frames_per_auxhist11 
 model_config_rec % auxhist12_inname           =  auxhist12_inname 
 model_config_rec % auxhist12_outname          =  auxhist12_outname 
 model_config_rec % auxhist12_interval_y       =  auxhist12_interval_y 
 model_config_rec % auxhist12_interval_d       =  auxhist12_interval_d 
 model_config_rec % auxhist12_interval_h       =  auxhist12_interval_h 
 model_config_rec % auxhist12_interval_m       =  auxhist12_interval_m 
 model_config_rec % auxhist12_interval_s       =  auxhist12_interval_s 
 model_config_rec % auxhist12_interval         =  auxhist12_interval 
 model_config_rec % auxhist12_begin_y          =  auxhist12_begin_y 
 model_config_rec % auxhist12_begin_d          =  auxhist12_begin_d 
 model_config_rec % auxhist12_begin_h          =  auxhist12_begin_h 
 model_config_rec % auxhist12_begin_m          =  auxhist12_begin_m 
 model_config_rec % auxhist12_begin_s          =  auxhist12_begin_s 
 model_config_rec % auxhist12_begin            =  auxhist12_begin 
 model_config_rec % auxhist12_end_y            =  auxhist12_end_y 
 model_config_rec % auxhist12_end_d            =  auxhist12_end_d 
 model_config_rec % auxhist12_end_h            =  auxhist12_end_h 
 model_config_rec % auxhist12_end_m            =  auxhist12_end_m 
 model_config_rec % auxhist12_end_s            =  auxhist12_end_s 
 model_config_rec % auxhist12_end              =  auxhist12_end 
 model_config_rec % io_form_auxhist12          =  io_form_auxhist12 
 model_config_rec % frames_per_auxhist12       =  frames_per_auxhist12 
 model_config_rec % auxhist13_inname           =  auxhist13_inname 
 model_config_rec % auxhist13_outname          =  auxhist13_outname 
 model_config_rec % auxhist13_interval_y       =  auxhist13_interval_y 
 model_config_rec % auxhist13_interval_d       =  auxhist13_interval_d 
 model_config_rec % auxhist13_interval_h       =  auxhist13_interval_h 
 model_config_rec % auxhist13_interval_m       =  auxhist13_interval_m 
 model_config_rec % auxhist13_interval_s       =  auxhist13_interval_s 
 model_config_rec % auxhist13_interval         =  auxhist13_interval 
 model_config_rec % auxhist13_begin_y          =  auxhist13_begin_y 
 model_config_rec % auxhist13_begin_d          =  auxhist13_begin_d 
 model_config_rec % auxhist13_begin_h          =  auxhist13_begin_h 
 model_config_rec % auxhist13_begin_m          =  auxhist13_begin_m 
 model_config_rec % auxhist13_begin_s          =  auxhist13_begin_s 
 model_config_rec % auxhist13_begin            =  auxhist13_begin 
 model_config_rec % auxhist13_end_y            =  auxhist13_end_y 
 model_config_rec % auxhist13_end_d            =  auxhist13_end_d 
 model_config_rec % auxhist13_end_h            =  auxhist13_end_h 
 model_config_rec % auxhist13_end_m            =  auxhist13_end_m 
 model_config_rec % auxhist13_end_s            =  auxhist13_end_s 
 model_config_rec % auxhist13_end              =  auxhist13_end 
 model_config_rec % io_form_auxhist13          =  io_form_auxhist13 
 model_config_rec % frames_per_auxhist13       =  frames_per_auxhist13 
 model_config_rec % auxhist14_inname           =  auxhist14_inname 
 model_config_rec % auxhist14_outname          =  auxhist14_outname 
 model_config_rec % auxhist14_interval_y       =  auxhist14_interval_y 
 model_config_rec % auxhist14_interval_d       =  auxhist14_interval_d 
 model_config_rec % auxhist14_interval_h       =  auxhist14_interval_h 
 model_config_rec % auxhist14_interval_m       =  auxhist14_interval_m 
 model_config_rec % auxhist14_interval_s       =  auxhist14_interval_s 
 model_config_rec % auxhist14_interval         =  auxhist14_interval 
 model_config_rec % auxhist14_begin_y          =  auxhist14_begin_y 
 model_config_rec % auxhist14_begin_d          =  auxhist14_begin_d 
 model_config_rec % auxhist14_begin_h          =  auxhist14_begin_h 
 model_config_rec % auxhist14_begin_m          =  auxhist14_begin_m 
 model_config_rec % auxhist14_begin_s          =  auxhist14_begin_s 
 model_config_rec % auxhist14_begin            =  auxhist14_begin 
 model_config_rec % auxhist14_end_y            =  auxhist14_end_y 
 model_config_rec % auxhist14_end_d            =  auxhist14_end_d 
 model_config_rec % auxhist14_end_h            =  auxhist14_end_h 
 model_config_rec % auxhist14_end_m            =  auxhist14_end_m 
 model_config_rec % auxhist14_end_s            =  auxhist14_end_s 
 model_config_rec % auxhist14_end              =  auxhist14_end 
 model_config_rec % io_form_auxhist14          =  io_form_auxhist14 
 model_config_rec % frames_per_auxhist14       =  frames_per_auxhist14 
 model_config_rec % auxhist15_inname           =  auxhist15_inname 
 model_config_rec % auxhist15_outname          =  auxhist15_outname 
 model_config_rec % auxhist15_interval_y       =  auxhist15_interval_y 
 model_config_rec % auxhist15_interval_d       =  auxhist15_interval_d 
 model_config_rec % auxhist15_interval_h       =  auxhist15_interval_h 
 model_config_rec % auxhist15_interval_m       =  auxhist15_interval_m 
 model_config_rec % auxhist15_interval_s       =  auxhist15_interval_s 
 model_config_rec % auxhist15_interval         =  auxhist15_interval 
 model_config_rec % auxhist15_begin_y          =  auxhist15_begin_y 
 model_config_rec % auxhist15_begin_d          =  auxhist15_begin_d 
 model_config_rec % auxhist15_begin_h          =  auxhist15_begin_h 
 model_config_rec % auxhist15_begin_m          =  auxhist15_begin_m 
 model_config_rec % auxhist15_begin_s          =  auxhist15_begin_s 
 model_config_rec % auxhist15_begin            =  auxhist15_begin 
 model_config_rec % auxhist15_end_y            =  auxhist15_end_y 
 model_config_rec % auxhist15_end_d            =  auxhist15_end_d 
 model_config_rec % auxhist15_end_h            =  auxhist15_end_h 
 model_config_rec % auxhist15_end_m            =  auxhist15_end_m 
 model_config_rec % auxhist15_end_s            =  auxhist15_end_s 
 model_config_rec % auxhist15_end              =  auxhist15_end 
 model_config_rec % io_form_auxhist15          =  io_form_auxhist15 
 model_config_rec % frames_per_auxhist15       =  frames_per_auxhist15 
 model_config_rec % auxhist16_inname           =  auxhist16_inname 
 model_config_rec % auxhist16_outname          =  auxhist16_outname 
 model_config_rec % auxhist16_interval_y       =  auxhist16_interval_y 
 model_config_rec % auxhist16_interval_d       =  auxhist16_interval_d 
 model_config_rec % auxhist16_interval_h       =  auxhist16_interval_h 
 model_config_rec % auxhist16_interval_m       =  auxhist16_interval_m 
 model_config_rec % auxhist16_interval_s       =  auxhist16_interval_s 
 model_config_rec % auxhist16_interval         =  auxhist16_interval 
 model_config_rec % auxhist16_begin_y          =  auxhist16_begin_y 
 model_config_rec % auxhist16_begin_d          =  auxhist16_begin_d 
 model_config_rec % auxhist16_begin_h          =  auxhist16_begin_h 
 model_config_rec % auxhist16_begin_m          =  auxhist16_begin_m 
 model_config_rec % auxhist16_begin_s          =  auxhist16_begin_s 
 model_config_rec % auxhist16_begin            =  auxhist16_begin 
 model_config_rec % auxhist16_end_y            =  auxhist16_end_y 
 model_config_rec % auxhist16_end_d            =  auxhist16_end_d 
 model_config_rec % auxhist16_end_h            =  auxhist16_end_h 
 model_config_rec % auxhist16_end_m            =  auxhist16_end_m 
 model_config_rec % auxhist16_end_s            =  auxhist16_end_s 
 model_config_rec % auxhist16_end              =  auxhist16_end 
 model_config_rec % io_form_auxhist16          =  io_form_auxhist16 
 model_config_rec % frames_per_auxhist16       =  frames_per_auxhist16 
 model_config_rec % auxhist17_inname           =  auxhist17_inname 
 model_config_rec % auxhist17_outname          =  auxhist17_outname 
 model_config_rec % auxhist17_interval_y       =  auxhist17_interval_y 
 model_config_rec % auxhist17_interval_d       =  auxhist17_interval_d 
 model_config_rec % auxhist17_interval_h       =  auxhist17_interval_h 
 model_config_rec % auxhist17_interval_m       =  auxhist17_interval_m 
 model_config_rec % auxhist17_interval_s       =  auxhist17_interval_s 
 model_config_rec % auxhist17_interval         =  auxhist17_interval 
 model_config_rec % auxhist17_begin_y          =  auxhist17_begin_y 
 model_config_rec % auxhist17_begin_d          =  auxhist17_begin_d 
 model_config_rec % auxhist17_begin_h          =  auxhist17_begin_h 
 model_config_rec % auxhist17_begin_m          =  auxhist17_begin_m 
 model_config_rec % auxhist17_begin_s          =  auxhist17_begin_s 
 model_config_rec % auxhist17_begin            =  auxhist17_begin 
 model_config_rec % auxhist17_end_y            =  auxhist17_end_y 
 model_config_rec % auxhist17_end_d            =  auxhist17_end_d 
 model_config_rec % auxhist17_end_h            =  auxhist17_end_h 
 model_config_rec % auxhist17_end_m            =  auxhist17_end_m 
 model_config_rec % auxhist17_end_s            =  auxhist17_end_s 
 model_config_rec % auxhist17_end              =  auxhist17_end 
 model_config_rec % io_form_auxhist17          =  io_form_auxhist17 
 model_config_rec % frames_per_auxhist17       =  frames_per_auxhist17 
 model_config_rec % auxhist18_inname           =  auxhist18_inname 
 model_config_rec % auxhist18_outname          =  auxhist18_outname 
 model_config_rec % auxhist18_interval_y       =  auxhist18_interval_y 
 model_config_rec % auxhist18_interval_d       =  auxhist18_interval_d 
 model_config_rec % auxhist18_interval_h       =  auxhist18_interval_h 
 model_config_rec % auxhist18_interval_m       =  auxhist18_interval_m 
 model_config_rec % auxhist18_interval_s       =  auxhist18_interval_s 
 model_config_rec % auxhist18_interval         =  auxhist18_interval 
 model_config_rec % auxhist18_begin_y          =  auxhist18_begin_y 
 model_config_rec % auxhist18_begin_d          =  auxhist18_begin_d 
 model_config_rec % auxhist18_begin_h          =  auxhist18_begin_h 
 model_config_rec % auxhist18_begin_m          =  auxhist18_begin_m 
 model_config_rec % auxhist18_begin_s          =  auxhist18_begin_s 
 model_config_rec % auxhist18_begin            =  auxhist18_begin 
 model_config_rec % auxhist18_end_y            =  auxhist18_end_y 
 model_config_rec % auxhist18_end_d            =  auxhist18_end_d 
 model_config_rec % auxhist18_end_h            =  auxhist18_end_h 
 model_config_rec % auxhist18_end_m            =  auxhist18_end_m 
 model_config_rec % auxhist18_end_s            =  auxhist18_end_s 
 model_config_rec % auxhist18_end              =  auxhist18_end 
 model_config_rec % io_form_auxhist18          =  io_form_auxhist18 
 model_config_rec % frames_per_auxhist18       =  frames_per_auxhist18 
 model_config_rec % auxhist19_inname           =  auxhist19_inname 
 model_config_rec % auxhist19_outname          =  auxhist19_outname 
 model_config_rec % auxhist19_interval_y       =  auxhist19_interval_y 
 model_config_rec % auxhist19_interval_d       =  auxhist19_interval_d 
 model_config_rec % auxhist19_interval_h       =  auxhist19_interval_h 
 model_config_rec % auxhist19_interval_m       =  auxhist19_interval_m 
 model_config_rec % auxhist19_interval_s       =  auxhist19_interval_s 
 model_config_rec % auxhist19_interval         =  auxhist19_interval 
 model_config_rec % auxhist19_begin_y          =  auxhist19_begin_y 
 model_config_rec % auxhist19_begin_d          =  auxhist19_begin_d 
 model_config_rec % auxhist19_begin_h          =  auxhist19_begin_h 
 model_config_rec % auxhist19_begin_m          =  auxhist19_begin_m 
 model_config_rec % auxhist19_begin_s          =  auxhist19_begin_s 
 model_config_rec % auxhist19_begin            =  auxhist19_begin 
 model_config_rec % auxhist19_end_y            =  auxhist19_end_y 
 model_config_rec % auxhist19_end_d            =  auxhist19_end_d 
 model_config_rec % auxhist19_end_h            =  auxhist19_end_h 
 model_config_rec % auxhist19_end_m            =  auxhist19_end_m 
 model_config_rec % auxhist19_end_s            =  auxhist19_end_s 
 model_config_rec % auxhist19_end              =  auxhist19_end 
 model_config_rec % io_form_auxhist19          =  io_form_auxhist19 
 model_config_rec % frames_per_auxhist19       =  frames_per_auxhist19 
 model_config_rec % auxhist20_inname           =  auxhist20_inname 
 model_config_rec % auxhist20_outname          =  auxhist20_outname 
 model_config_rec % auxhist20_interval_y       =  auxhist20_interval_y 
 model_config_rec % auxhist20_interval_d       =  auxhist20_interval_d 
 model_config_rec % auxhist20_interval_h       =  auxhist20_interval_h 
 model_config_rec % auxhist20_interval_m       =  auxhist20_interval_m 
 model_config_rec % auxhist20_interval_s       =  auxhist20_interval_s 
 model_config_rec % auxhist20_interval         =  auxhist20_interval 
 model_config_rec % auxhist20_begin_y          =  auxhist20_begin_y 
 model_config_rec % auxhist20_begin_d          =  auxhist20_begin_d 
 model_config_rec % auxhist20_begin_h          =  auxhist20_begin_h 
 model_config_rec % auxhist20_begin_m          =  auxhist20_begin_m 
 model_config_rec % auxhist20_begin_s          =  auxhist20_begin_s 
 model_config_rec % auxhist20_begin            =  auxhist20_begin 
 model_config_rec % auxhist20_end_y            =  auxhist20_end_y 
 model_config_rec % auxhist20_end_d            =  auxhist20_end_d 
 model_config_rec % auxhist20_end_h            =  auxhist20_end_h 
 model_config_rec % auxhist20_end_m            =  auxhist20_end_m 
 model_config_rec % auxhist20_end_s            =  auxhist20_end_s 
 model_config_rec % auxhist20_end              =  auxhist20_end 
 model_config_rec % io_form_auxhist20          =  io_form_auxhist20 
 model_config_rec % frames_per_auxhist20       =  frames_per_auxhist20 
 model_config_rec % auxhist21_inname           =  auxhist21_inname 
 model_config_rec % auxhist21_outname          =  auxhist21_outname 
 model_config_rec % auxhist21_interval_y       =  auxhist21_interval_y 
 model_config_rec % auxhist21_interval_d       =  auxhist21_interval_d 
 model_config_rec % auxhist21_interval_h       =  auxhist21_interval_h 
 model_config_rec % auxhist21_interval_m       =  auxhist21_interval_m 
 model_config_rec % auxhist21_interval_s       =  auxhist21_interval_s 
 model_config_rec % auxhist21_interval         =  auxhist21_interval 
 model_config_rec % auxhist21_begin_y          =  auxhist21_begin_y 
 model_config_rec % auxhist21_begin_d          =  auxhist21_begin_d 
 model_config_rec % auxhist21_begin_h          =  auxhist21_begin_h 
 model_config_rec % auxhist21_begin_m          =  auxhist21_begin_m 
 model_config_rec % auxhist21_begin_s          =  auxhist21_begin_s 
 model_config_rec % auxhist21_begin            =  auxhist21_begin 
 model_config_rec % auxhist21_end_y            =  auxhist21_end_y 
 model_config_rec % auxhist21_end_d            =  auxhist21_end_d 
 model_config_rec % auxhist21_end_h            =  auxhist21_end_h 
 model_config_rec % auxhist21_end_m            =  auxhist21_end_m 
 model_config_rec % auxhist21_end_s            =  auxhist21_end_s 
 model_config_rec % auxhist21_end              =  auxhist21_end 
 model_config_rec % io_form_auxhist21          =  io_form_auxhist21 
 model_config_rec % frames_per_auxhist21       =  frames_per_auxhist21 
 model_config_rec % auxhist22_inname           =  auxhist22_inname 
 model_config_rec % auxhist22_outname          =  auxhist22_outname 
 model_config_rec % auxhist22_interval_y       =  auxhist22_interval_y 
 model_config_rec % auxhist22_interval_d       =  auxhist22_interval_d 
 model_config_rec % auxhist22_interval_h       =  auxhist22_interval_h 
 model_config_rec % auxhist22_interval_m       =  auxhist22_interval_m 
 model_config_rec % auxhist22_interval_s       =  auxhist22_interval_s 
 model_config_rec % auxhist22_interval         =  auxhist22_interval 
 model_config_rec % auxhist22_begin_y          =  auxhist22_begin_y 
 model_config_rec % auxhist22_begin_d          =  auxhist22_begin_d 
 model_config_rec % auxhist22_begin_h          =  auxhist22_begin_h 
 model_config_rec % auxhist22_begin_m          =  auxhist22_begin_m 
 model_config_rec % auxhist22_begin_s          =  auxhist22_begin_s 
 model_config_rec % auxhist22_begin            =  auxhist22_begin 
 model_config_rec % auxhist22_end_y            =  auxhist22_end_y 
 model_config_rec % auxhist22_end_d            =  auxhist22_end_d 
 model_config_rec % auxhist22_end_h            =  auxhist22_end_h 
 model_config_rec % auxhist22_end_m            =  auxhist22_end_m 
 model_config_rec % auxhist22_end_s            =  auxhist22_end_s 
 model_config_rec % auxhist22_end              =  auxhist22_end 
 model_config_rec % io_form_auxhist22          =  io_form_auxhist22 
 model_config_rec % frames_per_auxhist22       =  frames_per_auxhist22 
 model_config_rec % auxhist23_inname           =  auxhist23_inname 
 model_config_rec % auxhist23_outname          =  auxhist23_outname 
 model_config_rec % auxhist23_interval_y       =  auxhist23_interval_y 
 model_config_rec % auxhist23_interval_d       =  auxhist23_interval_d 
 model_config_rec % auxhist23_interval_h       =  auxhist23_interval_h 
 model_config_rec % auxhist23_interval_m       =  auxhist23_interval_m 
 model_config_rec % auxhist23_interval_s       =  auxhist23_interval_s 
 model_config_rec % auxhist23_interval         =  auxhist23_interval 
 model_config_rec % auxhist23_begin_y          =  auxhist23_begin_y 
 model_config_rec % auxhist23_begin_d          =  auxhist23_begin_d 
 model_config_rec % auxhist23_begin_h          =  auxhist23_begin_h 
 model_config_rec % auxhist23_begin_m          =  auxhist23_begin_m 
 model_config_rec % auxhist23_begin_s          =  auxhist23_begin_s 
 model_config_rec % auxhist23_begin            =  auxhist23_begin 
 model_config_rec % auxhist23_end_y            =  auxhist23_end_y 
 model_config_rec % auxhist23_end_d            =  auxhist23_end_d 
 model_config_rec % auxhist23_end_h            =  auxhist23_end_h 
 model_config_rec % auxhist23_end_m            =  auxhist23_end_m 
 model_config_rec % auxhist23_end_s            =  auxhist23_end_s 
 model_config_rec % auxhist23_end              =  auxhist23_end 
 model_config_rec % io_form_auxhist23          =  io_form_auxhist23 
 model_config_rec % frames_per_auxhist23       =  frames_per_auxhist23 
 model_config_rec % auxhist24_inname           =  auxhist24_inname 
 model_config_rec % auxhist24_outname          =  auxhist24_outname 
 model_config_rec % auxhist24_interval_y       =  auxhist24_interval_y 
 model_config_rec % auxhist24_interval_d       =  auxhist24_interval_d 
 model_config_rec % auxhist24_interval_h       =  auxhist24_interval_h 
 model_config_rec % auxhist24_interval_m       =  auxhist24_interval_m 
 model_config_rec % auxhist24_interval_s       =  auxhist24_interval_s 
 model_config_rec % auxhist24_interval         =  auxhist24_interval 
 model_config_rec % auxhist24_begin_y          =  auxhist24_begin_y 
 model_config_rec % auxhist24_begin_d          =  auxhist24_begin_d 
 model_config_rec % auxhist24_begin_h          =  auxhist24_begin_h 
 model_config_rec % auxhist24_begin_m          =  auxhist24_begin_m 
 model_config_rec % auxhist24_begin_s          =  auxhist24_begin_s 
 model_config_rec % auxhist24_begin            =  auxhist24_begin 
 model_config_rec % auxhist24_end_y            =  auxhist24_end_y 
 model_config_rec % auxhist24_end_d            =  auxhist24_end_d 
 model_config_rec % auxhist24_end_h            =  auxhist24_end_h 
 model_config_rec % auxhist24_end_m            =  auxhist24_end_m 
 model_config_rec % auxhist24_end_s            =  auxhist24_end_s 
 model_config_rec % auxhist24_end              =  auxhist24_end 
 model_config_rec % io_form_auxhist24          =  io_form_auxhist24 
 model_config_rec % frames_per_auxhist24       =  frames_per_auxhist24 
 model_config_rec % auxinput1_outname          =  auxinput1_outname 
 model_config_rec % auxinput1_interval_y       =  auxinput1_interval_y 
 model_config_rec % auxinput1_interval_d       =  auxinput1_interval_d 
 model_config_rec % auxinput1_interval_h       =  auxinput1_interval_h 
 model_config_rec % auxinput1_interval_m       =  auxinput1_interval_m 
 model_config_rec % auxinput1_interval_s       =  auxinput1_interval_s 
 model_config_rec % auxinput1_interval         =  auxinput1_interval 
 model_config_rec % auxinput1_begin_y          =  auxinput1_begin_y 
 model_config_rec % auxinput1_begin_d          =  auxinput1_begin_d 
 model_config_rec % auxinput1_begin_h          =  auxinput1_begin_h 
 model_config_rec % auxinput1_begin_m          =  auxinput1_begin_m 
 model_config_rec % auxinput1_begin_s          =  auxinput1_begin_s 
 model_config_rec % auxinput1_begin            =  auxinput1_begin 
 model_config_rec % auxinput1_end_y            =  auxinput1_end_y 
 model_config_rec % auxinput1_end_d            =  auxinput1_end_d 
 model_config_rec % auxinput1_end_h            =  auxinput1_end_h 
 model_config_rec % auxinput1_end_m            =  auxinput1_end_m 
 model_config_rec % auxinput1_end_s            =  auxinput1_end_s 
 model_config_rec % auxinput1_end              =  auxinput1_end 
 model_config_rec % frames_per_auxinput1       =  frames_per_auxinput1 
 model_config_rec % auxinput2_inname           =  auxinput2_inname 
 model_config_rec % auxinput2_outname          =  auxinput2_outname 
 model_config_rec % auxinput2_interval_y       =  auxinput2_interval_y 
 model_config_rec % auxinput2_interval_d       =  auxinput2_interval_d 
 model_config_rec % auxinput2_interval_h       =  auxinput2_interval_h 
 model_config_rec % auxinput2_interval_m       =  auxinput2_interval_m 
 model_config_rec % auxinput2_interval_s       =  auxinput2_interval_s 
 model_config_rec % auxinput2_interval         =  auxinput2_interval 
 model_config_rec % auxinput2_begin_y          =  auxinput2_begin_y 
 model_config_rec % auxinput2_begin_d          =  auxinput2_begin_d 
 model_config_rec % auxinput2_begin_h          =  auxinput2_begin_h 
 model_config_rec % auxinput2_begin_m          =  auxinput2_begin_m 
 model_config_rec % auxinput2_begin_s          =  auxinput2_begin_s 
 model_config_rec % auxinput2_begin            =  auxinput2_begin 
 model_config_rec % auxinput2_end_y            =  auxinput2_end_y 
 model_config_rec % auxinput2_end_d            =  auxinput2_end_d 
 model_config_rec % auxinput2_end_h            =  auxinput2_end_h 
 model_config_rec % auxinput2_end_m            =  auxinput2_end_m 
 model_config_rec % auxinput2_end_s            =  auxinput2_end_s 
 model_config_rec % auxinput2_end              =  auxinput2_end 
 model_config_rec % io_form_auxinput2          =  io_form_auxinput2 
 model_config_rec % frames_per_auxinput2       =  frames_per_auxinput2 
 model_config_rec % auxinput3_inname           =  auxinput3_inname 
 model_config_rec % auxinput3_outname          =  auxinput3_outname 
 model_config_rec % auxinput3_interval_y       =  auxinput3_interval_y 
 model_config_rec % auxinput3_interval_d       =  auxinput3_interval_d 
 model_config_rec % auxinput3_interval_h       =  auxinput3_interval_h 
 model_config_rec % auxinput3_interval_m       =  auxinput3_interval_m 
 model_config_rec % auxinput3_interval_s       =  auxinput3_interval_s 
 model_config_rec % auxinput3_interval         =  auxinput3_interval 
 model_config_rec % auxinput3_begin_y          =  auxinput3_begin_y 
 model_config_rec % auxinput3_begin_d          =  auxinput3_begin_d 
 model_config_rec % auxinput3_begin_h          =  auxinput3_begin_h 
 model_config_rec % auxinput3_begin_m          =  auxinput3_begin_m 
 model_config_rec % auxinput3_begin_s          =  auxinput3_begin_s 
 model_config_rec % auxinput3_begin            =  auxinput3_begin 
 model_config_rec % auxinput3_end_y            =  auxinput3_end_y 
 model_config_rec % auxinput3_end_d            =  auxinput3_end_d 
 model_config_rec % auxinput3_end_h            =  auxinput3_end_h 
 model_config_rec % auxinput3_end_m            =  auxinput3_end_m 
 model_config_rec % auxinput3_end_s            =  auxinput3_end_s 
 model_config_rec % auxinput3_end              =  auxinput3_end 
 model_config_rec % io_form_auxinput3          =  io_form_auxinput3 
 model_config_rec % frames_per_auxinput3       =  frames_per_auxinput3 
 model_config_rec % auxinput4_inname           =  auxinput4_inname 
 model_config_rec % auxinput4_outname          =  auxinput4_outname 
 model_config_rec % auxinput4_interval_y       =  auxinput4_interval_y 
 model_config_rec % auxinput4_interval_d       =  auxinput4_interval_d 
 model_config_rec % auxinput4_interval_h       =  auxinput4_interval_h 
 model_config_rec % auxinput4_interval_m       =  auxinput4_interval_m 
 model_config_rec % auxinput4_interval_s       =  auxinput4_interval_s 
 model_config_rec % auxinput4_interval         =  auxinput4_interval 
 model_config_rec % auxinput4_begin_y          =  auxinput4_begin_y 
 model_config_rec % auxinput4_begin_d          =  auxinput4_begin_d 
 model_config_rec % auxinput4_begin_h          =  auxinput4_begin_h 
 model_config_rec % auxinput4_begin_m          =  auxinput4_begin_m 
 model_config_rec % auxinput4_begin_s          =  auxinput4_begin_s 
 model_config_rec % auxinput4_begin            =  auxinput4_begin 
 model_config_rec % auxinput4_end_y            =  auxinput4_end_y 
 model_config_rec % auxinput4_end_d            =  auxinput4_end_d 
 model_config_rec % auxinput4_end_h            =  auxinput4_end_h 
 model_config_rec % auxinput4_end_m            =  auxinput4_end_m 
 model_config_rec % auxinput4_end_s            =  auxinput4_end_s 
 model_config_rec % auxinput4_end              =  auxinput4_end 
 model_config_rec % io_form_auxinput4          =  io_form_auxinput4 
 model_config_rec % frames_per_auxinput4       =  frames_per_auxinput4 
 model_config_rec % auxinput5_inname           =  auxinput5_inname 
 model_config_rec % auxinput5_outname          =  auxinput5_outname 
 model_config_rec % auxinput5_interval_y       =  auxinput5_interval_y 
 model_config_rec % auxinput5_interval_d       =  auxinput5_interval_d 
 model_config_rec % auxinput5_interval_h       =  auxinput5_interval_h 
 model_config_rec % auxinput5_interval_m       =  auxinput5_interval_m 
 model_config_rec % auxinput5_interval_s       =  auxinput5_interval_s 
 model_config_rec % auxinput5_interval         =  auxinput5_interval 
 model_config_rec % auxinput5_begin_y          =  auxinput5_begin_y 
 model_config_rec % auxinput5_begin_d          =  auxinput5_begin_d 
 model_config_rec % auxinput5_begin_h          =  auxinput5_begin_h 
 model_config_rec % auxinput5_begin_m          =  auxinput5_begin_m 
 model_config_rec % auxinput5_begin_s          =  auxinput5_begin_s 
 model_config_rec % auxinput5_begin            =  auxinput5_begin 
 model_config_rec % auxinput5_end_y            =  auxinput5_end_y 
 model_config_rec % auxinput5_end_d            =  auxinput5_end_d 
 model_config_rec % auxinput5_end_h            =  auxinput5_end_h 
 model_config_rec % auxinput5_end_m            =  auxinput5_end_m 
 model_config_rec % auxinput5_end_s            =  auxinput5_end_s 
 model_config_rec % auxinput5_end              =  auxinput5_end 
 model_config_rec % io_form_auxinput5          =  io_form_auxinput5 
 model_config_rec % frames_per_auxinput5       =  frames_per_auxinput5 
 model_config_rec % auxinput6_inname           =  auxinput6_inname 
 model_config_rec % auxinput6_outname          =  auxinput6_outname 
 model_config_rec % auxinput6_interval_y       =  auxinput6_interval_y 
 model_config_rec % auxinput6_interval_d       =  auxinput6_interval_d 
 model_config_rec % auxinput6_interval_h       =  auxinput6_interval_h 
 model_config_rec % auxinput6_interval_m       =  auxinput6_interval_m 
 model_config_rec % auxinput6_interval_s       =  auxinput6_interval_s 
 model_config_rec % auxinput6_interval         =  auxinput6_interval 
 model_config_rec % auxinput6_begin_y          =  auxinput6_begin_y 
 model_config_rec % auxinput6_begin_d          =  auxinput6_begin_d 
 model_config_rec % auxinput6_begin_h          =  auxinput6_begin_h 
 model_config_rec % auxinput6_begin_m          =  auxinput6_begin_m 
 model_config_rec % auxinput6_begin_s          =  auxinput6_begin_s 
 model_config_rec % auxinput6_begin            =  auxinput6_begin 
 model_config_rec % auxinput6_end_y            =  auxinput6_end_y 
 model_config_rec % auxinput6_end_d            =  auxinput6_end_d 
 model_config_rec % auxinput6_end_h            =  auxinput6_end_h 
 model_config_rec % auxinput6_end_m            =  auxinput6_end_m 
 model_config_rec % auxinput6_end_s            =  auxinput6_end_s 
 model_config_rec % auxinput6_end              =  auxinput6_end 
 model_config_rec % io_form_auxinput6          =  io_form_auxinput6 
 model_config_rec % frames_per_auxinput6       =  frames_per_auxinput6 
 model_config_rec % auxinput7_inname           =  auxinput7_inname 
 model_config_rec % auxinput7_outname          =  auxinput7_outname 
 model_config_rec % auxinput7_interval_y       =  auxinput7_interval_y 
 model_config_rec % auxinput7_interval_d       =  auxinput7_interval_d 
 model_config_rec % auxinput7_interval_h       =  auxinput7_interval_h 
 model_config_rec % auxinput7_interval_m       =  auxinput7_interval_m 
 model_config_rec % auxinput7_interval_s       =  auxinput7_interval_s 
 model_config_rec % auxinput7_interval         =  auxinput7_interval 
 model_config_rec % auxinput7_begin_y          =  auxinput7_begin_y 
 model_config_rec % auxinput7_begin_d          =  auxinput7_begin_d 
 model_config_rec % auxinput7_begin_h          =  auxinput7_begin_h 
 model_config_rec % auxinput7_begin_m          =  auxinput7_begin_m 
 model_config_rec % auxinput7_begin_s          =  auxinput7_begin_s 
 model_config_rec % auxinput7_begin            =  auxinput7_begin 
 model_config_rec % auxinput7_end_y            =  auxinput7_end_y 
 model_config_rec % auxinput7_end_d            =  auxinput7_end_d 
 model_config_rec % auxinput7_end_h            =  auxinput7_end_h 
 model_config_rec % auxinput7_end_m            =  auxinput7_end_m 
 model_config_rec % auxinput7_end_s            =  auxinput7_end_s 
 model_config_rec % auxinput7_end              =  auxinput7_end 
 model_config_rec % io_form_auxinput7          =  io_form_auxinput7 
 model_config_rec % frames_per_auxinput7       =  frames_per_auxinput7 
 model_config_rec % auxinput8_inname           =  auxinput8_inname 
 model_config_rec % auxinput8_outname          =  auxinput8_outname 
 model_config_rec % auxinput8_interval_y       =  auxinput8_interval_y 
 model_config_rec % auxinput8_interval_d       =  auxinput8_interval_d 
 model_config_rec % auxinput8_interval_h       =  auxinput8_interval_h 
 model_config_rec % auxinput8_interval_m       =  auxinput8_interval_m 
 model_config_rec % auxinput8_interval_s       =  auxinput8_interval_s 
 model_config_rec % auxinput8_interval         =  auxinput8_interval 
 model_config_rec % auxinput8_begin_y          =  auxinput8_begin_y 
 model_config_rec % auxinput8_begin_d          =  auxinput8_begin_d 
 model_config_rec % auxinput8_begin_h          =  auxinput8_begin_h 
 model_config_rec % auxinput8_begin_m          =  auxinput8_begin_m 
 model_config_rec % auxinput8_begin_s          =  auxinput8_begin_s 
 model_config_rec % auxinput8_begin            =  auxinput8_begin 
 model_config_rec % auxinput8_end_y            =  auxinput8_end_y 
 model_config_rec % auxinput8_end_d            =  auxinput8_end_d 
 model_config_rec % auxinput8_end_h            =  auxinput8_end_h 
 model_config_rec % auxinput8_end_m            =  auxinput8_end_m 
 model_config_rec % auxinput8_end_s            =  auxinput8_end_s 
 model_config_rec % auxinput8_end              =  auxinput8_end 
 model_config_rec % io_form_auxinput8          =  io_form_auxinput8 
 model_config_rec % frames_per_auxinput8       =  frames_per_auxinput8 
 model_config_rec % auxinput9_inname           =  auxinput9_inname 
 model_config_rec % auxinput9_outname          =  auxinput9_outname 
 model_config_rec % auxinput9_interval_y       =  auxinput9_interval_y 
 model_config_rec % auxinput9_interval_d       =  auxinput9_interval_d 
 model_config_rec % auxinput9_interval_h       =  auxinput9_interval_h 
 model_config_rec % auxinput9_interval_m       =  auxinput9_interval_m 
 model_config_rec % auxinput9_interval_s       =  auxinput9_interval_s 
 model_config_rec % auxinput9_interval         =  auxinput9_interval 
 model_config_rec % auxinput9_begin_y          =  auxinput9_begin_y 
 model_config_rec % auxinput9_begin_d          =  auxinput9_begin_d 
 model_config_rec % auxinput9_begin_h          =  auxinput9_begin_h 
 model_config_rec % auxinput9_begin_m          =  auxinput9_begin_m 
 model_config_rec % auxinput9_begin_s          =  auxinput9_begin_s 
 model_config_rec % auxinput9_begin            =  auxinput9_begin 
 model_config_rec % auxinput9_end_y            =  auxinput9_end_y 
 model_config_rec % auxinput9_end_d            =  auxinput9_end_d 
 model_config_rec % auxinput9_end_h            =  auxinput9_end_h 
 model_config_rec % auxinput9_end_m            =  auxinput9_end_m 
 model_config_rec % auxinput9_end_s            =  auxinput9_end_s 
 model_config_rec % auxinput9_end              =  auxinput9_end 
 model_config_rec % io_form_auxinput9          =  io_form_auxinput9 
 model_config_rec % frames_per_auxinput9       =  frames_per_auxinput9 
 model_config_rec % auxinput10_inname          =  auxinput10_inname 
 model_config_rec % auxinput10_outname         =  auxinput10_outname 
 model_config_rec % auxinput10_interval_y      =  auxinput10_interval_y 
 model_config_rec % auxinput10_interval_d      =  auxinput10_interval_d 
 model_config_rec % auxinput10_interval_h      =  auxinput10_interval_h 
 model_config_rec % auxinput10_interval_m      =  auxinput10_interval_m 
 model_config_rec % auxinput10_interval_s      =  auxinput10_interval_s 
 model_config_rec % auxinput10_interval        =  auxinput10_interval 
 model_config_rec % auxinput10_begin_y         =  auxinput10_begin_y 
 model_config_rec % auxinput10_begin_d         =  auxinput10_begin_d 
 model_config_rec % auxinput10_begin_h         =  auxinput10_begin_h 
 model_config_rec % auxinput10_begin_m         =  auxinput10_begin_m 
 model_config_rec % auxinput10_begin_s         =  auxinput10_begin_s 
 model_config_rec % auxinput10_begin           =  auxinput10_begin 
 model_config_rec % auxinput10_end_y           =  auxinput10_end_y 
 model_config_rec % auxinput10_end_d           =  auxinput10_end_d 
 model_config_rec % auxinput10_end_h           =  auxinput10_end_h 
 model_config_rec % auxinput10_end_m           =  auxinput10_end_m 
 model_config_rec % auxinput10_end_s           =  auxinput10_end_s 
 model_config_rec % auxinput10_end             =  auxinput10_end 
 model_config_rec % io_form_auxinput10         =  io_form_auxinput10 
 model_config_rec % frames_per_auxinput10      =  frames_per_auxinput10 
 model_config_rec % auxinput11_inname          =  auxinput11_inname 
 model_config_rec % auxinput11_outname         =  auxinput11_outname 
 model_config_rec % auxinput11_interval_y      =  auxinput11_interval_y 
 model_config_rec % auxinput11_interval_d      =  auxinput11_interval_d 
 model_config_rec % auxinput11_interval_h      =  auxinput11_interval_h 
 model_config_rec % auxinput11_interval_m      =  auxinput11_interval_m 
 model_config_rec % auxinput11_interval_s      =  auxinput11_interval_s 
 model_config_rec % auxinput11_interval        =  auxinput11_interval 
 model_config_rec % auxinput11_begin_y         =  auxinput11_begin_y 
 model_config_rec % auxinput11_begin_d         =  auxinput11_begin_d 
 model_config_rec % auxinput11_begin_h         =  auxinput11_begin_h 
 model_config_rec % auxinput11_begin_m         =  auxinput11_begin_m 
 model_config_rec % auxinput11_begin_s         =  auxinput11_begin_s 
 model_config_rec % auxinput11_begin           =  auxinput11_begin 
 model_config_rec % auxinput11_end_y           =  auxinput11_end_y 
 model_config_rec % auxinput11_end_d           =  auxinput11_end_d 
 model_config_rec % auxinput11_end_h           =  auxinput11_end_h 
 model_config_rec % auxinput11_end_m           =  auxinput11_end_m 
 model_config_rec % auxinput11_end_s           =  auxinput11_end_s 
 model_config_rec % auxinput11_end             =  auxinput11_end 
 model_config_rec % io_form_auxinput11         =  io_form_auxinput11 
 model_config_rec % frames_per_auxinput11      =  frames_per_auxinput11 
 model_config_rec % auxinput12_inname          =  auxinput12_inname 
 model_config_rec % auxinput12_outname         =  auxinput12_outname 
 model_config_rec % auxinput12_interval_y      =  auxinput12_interval_y 
 model_config_rec % auxinput12_interval_d      =  auxinput12_interval_d 
 model_config_rec % auxinput12_interval_h      =  auxinput12_interval_h 
 model_config_rec % auxinput12_interval_m      =  auxinput12_interval_m 
 model_config_rec % auxinput12_interval_s      =  auxinput12_interval_s 
 model_config_rec % auxinput12_interval        =  auxinput12_interval 
 model_config_rec % auxinput12_begin_y         =  auxinput12_begin_y 
 model_config_rec % auxinput12_begin_d         =  auxinput12_begin_d 
 model_config_rec % auxinput12_begin_h         =  auxinput12_begin_h 
 model_config_rec % auxinput12_begin_m         =  auxinput12_begin_m 
 model_config_rec % auxinput12_begin_s         =  auxinput12_begin_s 
 model_config_rec % auxinput12_begin           =  auxinput12_begin 
 model_config_rec % auxinput12_end_y           =  auxinput12_end_y 
 model_config_rec % auxinput12_end_d           =  auxinput12_end_d 
 model_config_rec % auxinput12_end_h           =  auxinput12_end_h 
 model_config_rec % auxinput12_end_m           =  auxinput12_end_m 
 model_config_rec % auxinput12_end_s           =  auxinput12_end_s 
 model_config_rec % auxinput12_end             =  auxinput12_end 
 model_config_rec % io_form_auxinput12         =  io_form_auxinput12 
 model_config_rec % frames_per_auxinput12      =  frames_per_auxinput12 
 model_config_rec % auxinput13_inname          =  auxinput13_inname 
 model_config_rec % auxinput13_outname         =  auxinput13_outname 
 model_config_rec % auxinput13_interval_y      =  auxinput13_interval_y 
 model_config_rec % auxinput13_interval_d      =  auxinput13_interval_d 
 model_config_rec % auxinput13_interval_h      =  auxinput13_interval_h 
 model_config_rec % auxinput13_interval_m      =  auxinput13_interval_m 
 model_config_rec % auxinput13_interval_s      =  auxinput13_interval_s 
 model_config_rec % auxinput13_interval        =  auxinput13_interval 
 model_config_rec % auxinput13_begin_y         =  auxinput13_begin_y 
 model_config_rec % auxinput13_begin_d         =  auxinput13_begin_d 
 model_config_rec % auxinput13_begin_h         =  auxinput13_begin_h 
 model_config_rec % auxinput13_begin_m         =  auxinput13_begin_m 
 model_config_rec % auxinput13_begin_s         =  auxinput13_begin_s 
 model_config_rec % auxinput13_begin           =  auxinput13_begin 
 model_config_rec % auxinput13_end_y           =  auxinput13_end_y 
 model_config_rec % auxinput13_end_d           =  auxinput13_end_d 
 model_config_rec % auxinput13_end_h           =  auxinput13_end_h 
 model_config_rec % auxinput13_end_m           =  auxinput13_end_m 
 model_config_rec % auxinput13_end_s           =  auxinput13_end_s 
 model_config_rec % auxinput13_end             =  auxinput13_end 
 model_config_rec % io_form_auxinput13         =  io_form_auxinput13 
 model_config_rec % frames_per_auxinput13      =  frames_per_auxinput13 
 model_config_rec % auxinput14_inname          =  auxinput14_inname 
 model_config_rec % auxinput14_outname         =  auxinput14_outname 
 model_config_rec % auxinput14_interval_y      =  auxinput14_interval_y 
 model_config_rec % auxinput14_interval_d      =  auxinput14_interval_d 
 model_config_rec % auxinput14_interval_h      =  auxinput14_interval_h 
 model_config_rec % auxinput14_interval_m      =  auxinput14_interval_m 
 model_config_rec % auxinput14_interval_s      =  auxinput14_interval_s 
 model_config_rec % auxinput14_interval        =  auxinput14_interval 
 model_config_rec % auxinput14_begin_y         =  auxinput14_begin_y 
 model_config_rec % auxinput14_begin_d         =  auxinput14_begin_d 
 model_config_rec % auxinput14_begin_h         =  auxinput14_begin_h 
 model_config_rec % auxinput14_begin_m         =  auxinput14_begin_m 
 model_config_rec % auxinput14_begin_s         =  auxinput14_begin_s 
 model_config_rec % auxinput14_begin           =  auxinput14_begin 
 model_config_rec % auxinput14_end_y           =  auxinput14_end_y 
 model_config_rec % auxinput14_end_d           =  auxinput14_end_d 
 model_config_rec % auxinput14_end_h           =  auxinput14_end_h 
 model_config_rec % auxinput14_end_m           =  auxinput14_end_m 
 model_config_rec % auxinput14_end_s           =  auxinput14_end_s 
 model_config_rec % auxinput14_end             =  auxinput14_end 
 model_config_rec % io_form_auxinput14         =  io_form_auxinput14 
 model_config_rec % frames_per_auxinput14      =  frames_per_auxinput14 
 model_config_rec % auxinput15_inname          =  auxinput15_inname 
 model_config_rec % auxinput15_outname         =  auxinput15_outname 
 model_config_rec % auxinput15_interval_y      =  auxinput15_interval_y 
 model_config_rec % auxinput15_interval_d      =  auxinput15_interval_d 
 model_config_rec % auxinput15_interval_h      =  auxinput15_interval_h 
 model_config_rec % auxinput15_interval_m      =  auxinput15_interval_m 
 model_config_rec % auxinput15_interval_s      =  auxinput15_interval_s 
 model_config_rec % auxinput15_interval        =  auxinput15_interval 
 model_config_rec % auxinput15_begin_y         =  auxinput15_begin_y 
 model_config_rec % auxinput15_begin_d         =  auxinput15_begin_d 
 model_config_rec % auxinput15_begin_h         =  auxinput15_begin_h 
 model_config_rec % auxinput15_begin_m         =  auxinput15_begin_m 
 model_config_rec % auxinput15_begin_s         =  auxinput15_begin_s 
 model_config_rec % auxinput15_begin           =  auxinput15_begin 
 model_config_rec % auxinput15_end_y           =  auxinput15_end_y 
 model_config_rec % auxinput15_end_d           =  auxinput15_end_d 
 model_config_rec % auxinput15_end_h           =  auxinput15_end_h 
 model_config_rec % auxinput15_end_m           =  auxinput15_end_m 
 model_config_rec % auxinput15_end_s           =  auxinput15_end_s 
 model_config_rec % auxinput15_end             =  auxinput15_end 
 model_config_rec % io_form_auxinput15         =  io_form_auxinput15 
 model_config_rec % frames_per_auxinput15      =  frames_per_auxinput15 
 model_config_rec % auxinput16_inname          =  auxinput16_inname 
 model_config_rec % auxinput16_outname         =  auxinput16_outname 
 model_config_rec % auxinput16_interval_y      =  auxinput16_interval_y 
 model_config_rec % auxinput16_interval_d      =  auxinput16_interval_d 
 model_config_rec % auxinput16_interval_h      =  auxinput16_interval_h 
 model_config_rec % auxinput16_interval_m      =  auxinput16_interval_m 
 model_config_rec % auxinput16_interval_s      =  auxinput16_interval_s 
 model_config_rec % auxinput16_interval        =  auxinput16_interval 
 model_config_rec % auxinput16_begin_y         =  auxinput16_begin_y 
 model_config_rec % auxinput16_begin_d         =  auxinput16_begin_d 
 model_config_rec % auxinput16_begin_h         =  auxinput16_begin_h 
 model_config_rec % auxinput16_begin_m         =  auxinput16_begin_m 
 model_config_rec % auxinput16_begin_s         =  auxinput16_begin_s 
 model_config_rec % auxinput16_begin           =  auxinput16_begin 
 model_config_rec % auxinput16_end_y           =  auxinput16_end_y 
 model_config_rec % auxinput16_end_d           =  auxinput16_end_d 
 model_config_rec % auxinput16_end_h           =  auxinput16_end_h 
 model_config_rec % auxinput16_end_m           =  auxinput16_end_m 
 model_config_rec % auxinput16_end_s           =  auxinput16_end_s 
 model_config_rec % auxinput16_end             =  auxinput16_end 
 model_config_rec % io_form_auxinput16         =  io_form_auxinput16 
 model_config_rec % frames_per_auxinput16      =  frames_per_auxinput16 
 model_config_rec % auxinput17_inname          =  auxinput17_inname 
 model_config_rec % auxinput17_outname         =  auxinput17_outname 
 model_config_rec % auxinput17_interval_y      =  auxinput17_interval_y 
 model_config_rec % auxinput17_interval_d      =  auxinput17_interval_d 
 model_config_rec % auxinput17_interval_h      =  auxinput17_interval_h 
 model_config_rec % auxinput17_interval_m      =  auxinput17_interval_m 
 model_config_rec % auxinput17_interval_s      =  auxinput17_interval_s 
 model_config_rec % auxinput17_interval        =  auxinput17_interval 
 model_config_rec % auxinput17_begin_y         =  auxinput17_begin_y 
 model_config_rec % auxinput17_begin_d         =  auxinput17_begin_d 
 model_config_rec % auxinput17_begin_h         =  auxinput17_begin_h 
 model_config_rec % auxinput17_begin_m         =  auxinput17_begin_m 
 model_config_rec % auxinput17_begin_s         =  auxinput17_begin_s 
 model_config_rec % auxinput17_begin           =  auxinput17_begin 
 model_config_rec % auxinput17_end_y           =  auxinput17_end_y 
 model_config_rec % auxinput17_end_d           =  auxinput17_end_d 
 model_config_rec % auxinput17_end_h           =  auxinput17_end_h 
 model_config_rec % auxinput17_end_m           =  auxinput17_end_m 
 model_config_rec % auxinput17_end_s           =  auxinput17_end_s 
 model_config_rec % auxinput17_end             =  auxinput17_end 
 model_config_rec % io_form_auxinput17         =  io_form_auxinput17 
 model_config_rec % frames_per_auxinput17      =  frames_per_auxinput17 
 model_config_rec % auxinput18_inname          =  auxinput18_inname 
 model_config_rec % auxinput18_outname         =  auxinput18_outname 
 model_config_rec % auxinput18_interval_y      =  auxinput18_interval_y 
 model_config_rec % auxinput18_interval_d      =  auxinput18_interval_d 
 model_config_rec % auxinput18_interval_h      =  auxinput18_interval_h 
 model_config_rec % auxinput18_interval_m      =  auxinput18_interval_m 
 model_config_rec % auxinput18_interval_s      =  auxinput18_interval_s 
 model_config_rec % auxinput18_interval        =  auxinput18_interval 
 model_config_rec % auxinput18_begin_y         =  auxinput18_begin_y 
 model_config_rec % auxinput18_begin_d         =  auxinput18_begin_d 
 model_config_rec % auxinput18_begin_h         =  auxinput18_begin_h 
 model_config_rec % auxinput18_begin_m         =  auxinput18_begin_m 
 model_config_rec % auxinput18_begin_s         =  auxinput18_begin_s 
 model_config_rec % auxinput18_begin           =  auxinput18_begin 
 model_config_rec % auxinput18_end_y           =  auxinput18_end_y 
 model_config_rec % auxinput18_end_d           =  auxinput18_end_d 
 model_config_rec % auxinput18_end_h           =  auxinput18_end_h 
 model_config_rec % auxinput18_end_m           =  auxinput18_end_m 
 model_config_rec % auxinput18_end_s           =  auxinput18_end_s 
 model_config_rec % auxinput18_end             =  auxinput18_end 
 model_config_rec % io_form_auxinput18         =  io_form_auxinput18 
 model_config_rec % frames_per_auxinput18      =  frames_per_auxinput18 
 model_config_rec % auxinput19_inname          =  auxinput19_inname 
 model_config_rec % auxinput19_outname         =  auxinput19_outname 
 model_config_rec % auxinput19_interval_y      =  auxinput19_interval_y 
 model_config_rec % auxinput19_interval_d      =  auxinput19_interval_d 
 model_config_rec % auxinput19_interval_h      =  auxinput19_interval_h 
 model_config_rec % auxinput19_interval_m      =  auxinput19_interval_m 
 model_config_rec % auxinput19_interval_s      =  auxinput19_interval_s 
 model_config_rec % auxinput19_interval        =  auxinput19_interval 
 model_config_rec % auxinput19_begin_y         =  auxinput19_begin_y 
 model_config_rec % auxinput19_begin_d         =  auxinput19_begin_d 
 model_config_rec % auxinput19_begin_h         =  auxinput19_begin_h 
 model_config_rec % auxinput19_begin_m         =  auxinput19_begin_m 
 model_config_rec % auxinput19_begin_s         =  auxinput19_begin_s 
 model_config_rec % auxinput19_begin           =  auxinput19_begin 
 model_config_rec % auxinput19_end_y           =  auxinput19_end_y 
 model_config_rec % auxinput19_end_d           =  auxinput19_end_d 
 model_config_rec % auxinput19_end_h           =  auxinput19_end_h 
 model_config_rec % auxinput19_end_m           =  auxinput19_end_m 
 model_config_rec % auxinput19_end_s           =  auxinput19_end_s 
 model_config_rec % auxinput19_end             =  auxinput19_end 
 model_config_rec % io_form_auxinput19         =  io_form_auxinput19 
 model_config_rec % frames_per_auxinput19      =  frames_per_auxinput19 
 model_config_rec % auxinput20_inname          =  auxinput20_inname 
 model_config_rec % auxinput20_outname         =  auxinput20_outname 
 model_config_rec % auxinput20_interval_y      =  auxinput20_interval_y 
 model_config_rec % auxinput20_interval_d      =  auxinput20_interval_d 
 model_config_rec % auxinput20_interval_h      =  auxinput20_interval_h 
 model_config_rec % auxinput20_interval_m      =  auxinput20_interval_m 
 model_config_rec % auxinput20_interval_s      =  auxinput20_interval_s 
 model_config_rec % auxinput20_interval        =  auxinput20_interval 
 model_config_rec % auxinput20_begin_y         =  auxinput20_begin_y 
 model_config_rec % auxinput20_begin_d         =  auxinput20_begin_d 
 model_config_rec % auxinput20_begin_h         =  auxinput20_begin_h 
 model_config_rec % auxinput20_begin_m         =  auxinput20_begin_m 
 model_config_rec % auxinput20_begin_s         =  auxinput20_begin_s 
 model_config_rec % auxinput20_begin           =  auxinput20_begin 
 model_config_rec % auxinput20_end_y           =  auxinput20_end_y 
 model_config_rec % auxinput20_end_d           =  auxinput20_end_d 
 model_config_rec % auxinput20_end_h           =  auxinput20_end_h 
 model_config_rec % auxinput20_end_m           =  auxinput20_end_m 
 model_config_rec % auxinput20_end_s           =  auxinput20_end_s 
 model_config_rec % auxinput20_end             =  auxinput20_end 
 model_config_rec % io_form_auxinput20         =  io_form_auxinput20 
 model_config_rec % frames_per_auxinput20      =  frames_per_auxinput20 
 model_config_rec % auxinput21_inname          =  auxinput21_inname 
 model_config_rec % auxinput21_outname         =  auxinput21_outname 
 model_config_rec % auxinput21_interval_y      =  auxinput21_interval_y 
 model_config_rec % auxinput21_interval_d      =  auxinput21_interval_d 
 model_config_rec % auxinput21_interval_h      =  auxinput21_interval_h 
 model_config_rec % auxinput21_interval_m      =  auxinput21_interval_m 
 model_config_rec % auxinput21_interval_s      =  auxinput21_interval_s 
 model_config_rec % auxinput21_interval        =  auxinput21_interval 
 model_config_rec % auxinput21_begin_y         =  auxinput21_begin_y 
 model_config_rec % auxinput21_begin_d         =  auxinput21_begin_d 
 model_config_rec % auxinput21_begin_h         =  auxinput21_begin_h 
 model_config_rec % auxinput21_begin_m         =  auxinput21_begin_m 
 model_config_rec % auxinput21_begin_s         =  auxinput21_begin_s 
 model_config_rec % auxinput21_begin           =  auxinput21_begin 
 model_config_rec % auxinput21_end_y           =  auxinput21_end_y 
 model_config_rec % auxinput21_end_d           =  auxinput21_end_d 
 model_config_rec % auxinput21_end_h           =  auxinput21_end_h 
 model_config_rec % auxinput21_end_m           =  auxinput21_end_m 
 model_config_rec % auxinput21_end_s           =  auxinput21_end_s 
 model_config_rec % auxinput21_end             =  auxinput21_end 
 model_config_rec % io_form_auxinput21         =  io_form_auxinput21 
 model_config_rec % frames_per_auxinput21      =  frames_per_auxinput21 
 model_config_rec % auxinput22_inname          =  auxinput22_inname 
 model_config_rec % auxinput22_outname         =  auxinput22_outname 
 model_config_rec % auxinput22_interval_y      =  auxinput22_interval_y 
 model_config_rec % auxinput22_interval_d      =  auxinput22_interval_d 
 model_config_rec % auxinput22_interval_h      =  auxinput22_interval_h 
 model_config_rec % auxinput22_interval_m      =  auxinput22_interval_m 
 model_config_rec % auxinput22_interval_s      =  auxinput22_interval_s 
 model_config_rec % auxinput22_interval        =  auxinput22_interval 
 model_config_rec % auxinput22_begin_y         =  auxinput22_begin_y 
 model_config_rec % auxinput22_begin_d         =  auxinput22_begin_d 
 model_config_rec % auxinput22_begin_h         =  auxinput22_begin_h 
 model_config_rec % auxinput22_begin_m         =  auxinput22_begin_m 
 model_config_rec % auxinput22_begin_s         =  auxinput22_begin_s 
 model_config_rec % auxinput22_begin           =  auxinput22_begin 
 model_config_rec % auxinput22_end_y           =  auxinput22_end_y 
 model_config_rec % auxinput22_end_d           =  auxinput22_end_d 
 model_config_rec % auxinput22_end_h           =  auxinput22_end_h 
 model_config_rec % auxinput22_end_m           =  auxinput22_end_m 
 model_config_rec % auxinput22_end_s           =  auxinput22_end_s 
 model_config_rec % auxinput22_end             =  auxinput22_end 
 model_config_rec % io_form_auxinput22         =  io_form_auxinput22 
 model_config_rec % frames_per_auxinput22      =  frames_per_auxinput22 
 model_config_rec % auxinput23_inname          =  auxinput23_inname 
 model_config_rec % auxinput23_outname         =  auxinput23_outname 
 model_config_rec % auxinput23_interval_y      =  auxinput23_interval_y 
 model_config_rec % auxinput23_interval_d      =  auxinput23_interval_d 
 model_config_rec % auxinput23_interval_h      =  auxinput23_interval_h 
 model_config_rec % auxinput23_interval_m      =  auxinput23_interval_m 
 model_config_rec % auxinput23_interval_s      =  auxinput23_interval_s 
 model_config_rec % auxinput23_interval        =  auxinput23_interval 
 model_config_rec % auxinput23_begin_y         =  auxinput23_begin_y 
 model_config_rec % auxinput23_begin_d         =  auxinput23_begin_d 
 model_config_rec % auxinput23_begin_h         =  auxinput23_begin_h 
 model_config_rec % auxinput23_begin_m         =  auxinput23_begin_m 
 model_config_rec % auxinput23_begin_s         =  auxinput23_begin_s 
 model_config_rec % auxinput23_begin           =  auxinput23_begin 
 model_config_rec % auxinput23_end_y           =  auxinput23_end_y 
 model_config_rec % auxinput23_end_d           =  auxinput23_end_d 
 model_config_rec % auxinput23_end_h           =  auxinput23_end_h 
 model_config_rec % auxinput23_end_m           =  auxinput23_end_m 
 model_config_rec % auxinput23_end_s           =  auxinput23_end_s 
 model_config_rec % auxinput23_end             =  auxinput23_end 
 model_config_rec % io_form_auxinput23         =  io_form_auxinput23 
 model_config_rec % frames_per_auxinput23      =  frames_per_auxinput23 
 model_config_rec % auxinput24_inname          =  auxinput24_inname 
 model_config_rec % auxinput24_outname         =  auxinput24_outname 
 model_config_rec % auxinput24_interval_y      =  auxinput24_interval_y 
 model_config_rec % auxinput24_interval_d      =  auxinput24_interval_d 
 model_config_rec % auxinput24_interval_h      =  auxinput24_interval_h 
 model_config_rec % auxinput24_interval_m      =  auxinput24_interval_m 
 model_config_rec % auxinput24_interval_s      =  auxinput24_interval_s 
 model_config_rec % auxinput24_interval        =  auxinput24_interval 
 model_config_rec % auxinput24_begin_y         =  auxinput24_begin_y 
 model_config_rec % auxinput24_begin_d         =  auxinput24_begin_d 
 model_config_rec % auxinput24_begin_h         =  auxinput24_begin_h 
 model_config_rec % auxinput24_begin_m         =  auxinput24_begin_m 
 model_config_rec % auxinput24_begin_s         =  auxinput24_begin_s 
 model_config_rec % auxinput24_begin           =  auxinput24_begin 
 model_config_rec % auxinput24_end_y           =  auxinput24_end_y 
 model_config_rec % auxinput24_end_d           =  auxinput24_end_d 
 model_config_rec % auxinput24_end_h           =  auxinput24_end_h 
 model_config_rec % auxinput24_end_m           =  auxinput24_end_m 
 model_config_rec % auxinput24_end_s           =  auxinput24_end_s 
 model_config_rec % auxinput24_end             =  auxinput24_end 
 model_config_rec % io_form_auxinput24         =  io_form_auxinput24 
 model_config_rec % frames_per_auxinput24      =  frames_per_auxinput24 
 model_config_rec % history_interval           =  history_interval 
 model_config_rec % frames_per_outfile         =  frames_per_outfile 
 model_config_rec % restart                    =  restart 
 model_config_rec % restart_interval           =  restart_interval 
 model_config_rec % io_form_input              =  io_form_input 
 model_config_rec % io_form_history            =  io_form_history 
 model_config_rec % io_form_restart            =  io_form_restart 
 model_config_rec % io_form_boundary           =  io_form_boundary 
 model_config_rec % debug_level                =  debug_level 
 model_config_rec % self_test_domain           =  self_test_domain 
 model_config_rec % history_outname            =  history_outname 
 model_config_rec % history_inname             =  history_inname 
 model_config_rec % use_netcdf_classic         =  use_netcdf_classic 
 model_config_rec % history_interval_d         =  history_interval_d 
 model_config_rec % history_interval_h         =  history_interval_h 
 model_config_rec % history_interval_m         =  history_interval_m 
 model_config_rec % history_interval_s         =  history_interval_s 
 model_config_rec % inputout_interval_d        =  inputout_interval_d 
 model_config_rec % inputout_interval_h        =  inputout_interval_h 
 model_config_rec % inputout_interval_m        =  inputout_interval_m 
 model_config_rec % inputout_interval_s        =  inputout_interval_s 
 model_config_rec % inputout_interval          =  inputout_interval 
 model_config_rec % restart_interval_d         =  restart_interval_d 
 model_config_rec % restart_interval_h         =  restart_interval_h 
 model_config_rec % restart_interval_m         =  restart_interval_m 
 model_config_rec % restart_interval_s         =  restart_interval_s 
 model_config_rec % history_begin_y            =  history_begin_y 
 model_config_rec % history_begin_d            =  history_begin_d 
 model_config_rec % history_begin_h            =  history_begin_h 
 model_config_rec % history_begin_m            =  history_begin_m 
 model_config_rec % history_begin_s            =  history_begin_s 
 model_config_rec % history_begin              =  history_begin 
 model_config_rec % inputout_begin_y           =  inputout_begin_y 
 model_config_rec % inputout_begin_d           =  inputout_begin_d 
 model_config_rec % inputout_begin_h           =  inputout_begin_h 
 model_config_rec % inputout_begin_m           =  inputout_begin_m 
 model_config_rec % inputout_begin_s           =  inputout_begin_s 
 model_config_rec % restart_begin_y            =  restart_begin_y 
 model_config_rec % restart_begin_d            =  restart_begin_d 
 model_config_rec % restart_begin_h            =  restart_begin_h 
 model_config_rec % restart_begin_m            =  restart_begin_m 
 model_config_rec % restart_begin_s            =  restart_begin_s 
 model_config_rec % restart_begin              =  restart_begin 
 model_config_rec % history_end_y              =  history_end_y 
 model_config_rec % history_end_d              =  history_end_d 
 model_config_rec % history_end_h              =  history_end_h 
 model_config_rec % history_end_m              =  history_end_m 
 model_config_rec % history_end_s              =  history_end_s 
 model_config_rec % history_end                =  history_end 
 model_config_rec % inputout_end_y             =  inputout_end_y 
 model_config_rec % inputout_end_d             =  inputout_end_d 
 model_config_rec % inputout_end_h             =  inputout_end_h 
 model_config_rec % inputout_end_m             =  inputout_end_m 
 model_config_rec % inputout_end_s             =  inputout_end_s 
 model_config_rec % simulation_start_year      =  simulation_start_year 
 model_config_rec % simulation_start_month     =  simulation_start_month 
 model_config_rec % simulation_start_day       =  simulation_start_day 
 model_config_rec % simulation_start_hour      =  simulation_start_hour 
 model_config_rec % simulation_start_minute    =  simulation_start_minute 
 model_config_rec % simulation_start_second    =  simulation_start_second 
 model_config_rec % reset_simulation_start     =  reset_simulation_start 
 model_config_rec % sr_x                       =  sr_x 
 model_config_rec % sr_y                       =  sr_y 
 model_config_rec % sgfdda_inname              =  sgfdda_inname 
 model_config_rec % gfdda_inname               =  gfdda_inname 
 model_config_rec % sgfdda_interval_d          =  sgfdda_interval_d 
 model_config_rec % sgfdda_interval_h          =  sgfdda_interval_h 
 model_config_rec % sgfdda_interval_m          =  sgfdda_interval_m 
 model_config_rec % sgfdda_interval_s          =  sgfdda_interval_s 
 model_config_rec % sgfdda_interval_y          =  sgfdda_interval_y 
 model_config_rec % sgfdda_interval            =  sgfdda_interval 
 model_config_rec % gfdda_interval_d           =  gfdda_interval_d 
 model_config_rec % gfdda_interval_h           =  gfdda_interval_h 
 model_config_rec % gfdda_interval_m           =  gfdda_interval_m 
 model_config_rec % gfdda_interval_s           =  gfdda_interval_s 
 model_config_rec % gfdda_interval_y           =  gfdda_interval_y 
 model_config_rec % gfdda_interval             =  gfdda_interval 
 model_config_rec % sgfdda_begin_y             =  sgfdda_begin_y 
 model_config_rec % sgfdda_begin_d             =  sgfdda_begin_d 
 model_config_rec % sgfdda_begin_h             =  sgfdda_begin_h 
 model_config_rec % sgfdda_begin_m             =  sgfdda_begin_m 
 model_config_rec % sgfdda_begin_s             =  sgfdda_begin_s 
 model_config_rec % gfdda_begin_y              =  gfdda_begin_y 
 model_config_rec % gfdda_begin_d              =  gfdda_begin_d 
 model_config_rec % gfdda_begin_h              =  gfdda_begin_h 
 model_config_rec % gfdda_begin_m              =  gfdda_begin_m 
 model_config_rec % gfdda_begin_s              =  gfdda_begin_s 
 model_config_rec % sgfdda_end_y               =  sgfdda_end_y 
 model_config_rec % sgfdda_end_d               =  sgfdda_end_d 
 model_config_rec % sgfdda_end_h               =  sgfdda_end_h 
 model_config_rec % sgfdda_end_m               =  sgfdda_end_m 
 model_config_rec % sgfdda_end_s               =  sgfdda_end_s 
 model_config_rec % gfdda_end_y                =  gfdda_end_y 
 model_config_rec % gfdda_end_d                =  gfdda_end_d 
 model_config_rec % gfdda_end_h                =  gfdda_end_h 
 model_config_rec % gfdda_end_m                =  gfdda_end_m 
 model_config_rec % gfdda_end_s                =  gfdda_end_s 
 model_config_rec % io_form_sgfdda             =  io_form_sgfdda 
 model_config_rec % io_form_gfdda              =  io_form_gfdda 
 model_config_rec % iofields_filename          =  iofields_filename 
 model_config_rec % ignore_iofields_warning    =  ignore_iofields_warning 
 model_config_rec % ncd_nofill                 =  ncd_nofill 
 model_config_rec % ifire                      =  ifire 
 model_config_rec % fire_boundary_guard        =  fire_boundary_guard 
 model_config_rec % fire_num_ignitions         =  fire_num_ignitions 
 model_config_rec % fire_ignition_ros1         =  fire_ignition_ros1 
 model_config_rec % fire_ignition_start_lon1   =  fire_ignition_start_lon1 
 model_config_rec % fire_ignition_start_lat1   =  fire_ignition_start_lat1 
 model_config_rec % fire_ignition_end_lon1     =  fire_ignition_end_lon1 
 model_config_rec % fire_ignition_end_lat1     =  fire_ignition_end_lat1 
 model_config_rec % fire_ignition_radius1      =  fire_ignition_radius1 
 model_config_rec % fire_ignition_start_time1  =  fire_ignition_start_time1 
 model_config_rec % fire_ignition_end_time1    =  fire_ignition_end_time1 
 model_config_rec % fire_ignition_ros2         =  fire_ignition_ros2 
 model_config_rec % fire_ignition_start_lon2   =  fire_ignition_start_lon2 
 model_config_rec % fire_ignition_start_lat2   =  fire_ignition_start_lat2 
 model_config_rec % fire_ignition_end_lon2     =  fire_ignition_end_lon2 
 model_config_rec % fire_ignition_end_lat2     =  fire_ignition_end_lat2 
 model_config_rec % fire_ignition_radius2      =  fire_ignition_radius2 
 model_config_rec % fire_ignition_start_time2  =  fire_ignition_start_time2 
 model_config_rec % fire_ignition_end_time2    =  fire_ignition_end_time2 
 model_config_rec % fire_ignition_ros3         =  fire_ignition_ros3 
 model_config_rec % fire_ignition_start_lon3   =  fire_ignition_start_lon3 
 model_config_rec % fire_ignition_start_lat3   =  fire_ignition_start_lat3 
 model_config_rec % fire_ignition_end_lon3     =  fire_ignition_end_lon3 
 model_config_rec % fire_ignition_end_lat3     =  fire_ignition_end_lat3 
 model_config_rec % fire_ignition_radius3      =  fire_ignition_radius3 
 model_config_rec % fire_ignition_start_time3  =  fire_ignition_start_time3 
 model_config_rec % fire_ignition_end_time3    =  fire_ignition_end_time3 
 model_config_rec % fire_ignition_ros4         =  fire_ignition_ros4 
 model_config_rec % fire_ignition_start_lon4   =  fire_ignition_start_lon4 
 model_config_rec % fire_ignition_start_lat4   =  fire_ignition_start_lat4 
 model_config_rec % fire_ignition_end_lon4     =  fire_ignition_end_lon4 
 model_config_rec % fire_ignition_end_lat4     =  fire_ignition_end_lat4 
 model_config_rec % fire_ignition_radius4      =  fire_ignition_radius4 
 model_config_rec % fire_ignition_start_time4  =  fire_ignition_start_time4 
 model_config_rec % fire_ignition_end_time4    =  fire_ignition_end_time4 
 model_config_rec % fire_ignition_ros5         =  fire_ignition_ros5 
 model_config_rec % fire_ignition_start_lon5   =  fire_ignition_start_lon5 
 model_config_rec % fire_ignition_start_lat5   =  fire_ignition_start_lat5 
 model_config_rec % fire_ignition_end_lon5     =  fire_ignition_end_lon5 
 model_config_rec % fire_ignition_end_lat5     =  fire_ignition_end_lat5 
 model_config_rec % fire_ignition_radius5      =  fire_ignition_radius5 
 model_config_rec % fire_ignition_start_time5  =  fire_ignition_start_time5 
 model_config_rec % fire_ignition_end_time5    =  fire_ignition_end_time5 
 model_config_rec % fire_ignition_start_x1     =  fire_ignition_start_x1 
 model_config_rec % fire_ignition_start_y1     =  fire_ignition_start_y1 
 model_config_rec % fire_ignition_end_x1       =  fire_ignition_end_x1 
 model_config_rec % fire_ignition_end_y1       =  fire_ignition_end_y1 
 model_config_rec % fire_ignition_start_x2     =  fire_ignition_start_x2 
 model_config_rec % fire_ignition_start_y2     =  fire_ignition_start_y2 
 model_config_rec % fire_ignition_end_x2       =  fire_ignition_end_x2 
 model_config_rec % fire_ignition_end_y2       =  fire_ignition_end_y2 
 model_config_rec % fire_ignition_start_x3     =  fire_ignition_start_x3 
 model_config_rec % fire_ignition_start_y3     =  fire_ignition_start_y3 
 model_config_rec % fire_ignition_end_x3       =  fire_ignition_end_x3 
 model_config_rec % fire_ignition_end_y3       =  fire_ignition_end_y3 
 model_config_rec % fire_ignition_start_x4     =  fire_ignition_start_x4 
 model_config_rec % fire_ignition_start_y4     =  fire_ignition_start_y4 
 model_config_rec % fire_ignition_end_x4       =  fire_ignition_end_x4 
 model_config_rec % fire_ignition_end_y4       =  fire_ignition_end_y4 
 model_config_rec % fire_ignition_start_x5     =  fire_ignition_start_x5 
 model_config_rec % fire_ignition_start_y5     =  fire_ignition_start_y5 
 model_config_rec % fire_ignition_end_x5       =  fire_ignition_end_x5 
 model_config_rec % fire_ignition_end_y5       =  fire_ignition_end_y5 
 model_config_rec % fire_lat_init              =  fire_lat_init 
 model_config_rec % fire_lon_init              =  fire_lon_init 
 model_config_rec % fire_ign_time              =  fire_ign_time 
 model_config_rec % fire_shape                 =  fire_shape 
 model_config_rec % fire_sprd_mdl              =  fire_sprd_mdl 
 model_config_rec % fire_crwn_hgt              =  fire_crwn_hgt 
 model_config_rec % fire_ext_grnd              =  fire_ext_grnd 
 model_config_rec % fire_ext_crwn              =  fire_ext_crwn 
 model_config_rec % fire_wind_height           =  fire_wind_height 
 model_config_rec % fire_fuel_read             =  fire_fuel_read 
 model_config_rec % fire_fuel_cat              =  fire_fuel_cat 
 model_config_rec % fire_print_msg             =  fire_print_msg 
 model_config_rec % fire_print_file            =  fire_print_file 
 model_config_rec % fire_fuel_left_method      =  fire_fuel_left_method 
 model_config_rec % fire_fuel_left_irl         =  fire_fuel_left_irl 
 model_config_rec % fire_fuel_left_jrl         =  fire_fuel_left_jrl 
 model_config_rec % fire_grows_only            =  fire_grows_only 
 model_config_rec % fire_upwinding             =  fire_upwinding 
 model_config_rec % fire_upwind_split          =  fire_upwind_split 
 model_config_rec % fire_viscosity             =  fire_viscosity 
 model_config_rec % fire_lfn_ext_up            =  fire_lfn_ext_up 
 model_config_rec % fire_topo_from_atm         =  fire_topo_from_atm 
 model_config_rec % fire_advection             =  fire_advection 
 model_config_rec % fire_test_steps            =  fire_test_steps 
 model_config_rec % fire_const_time            =  fire_const_time 
 model_config_rec % fire_const_grnhfx          =  fire_const_grnhfx 
 model_config_rec % fire_const_grnqfx          =  fire_const_grnqfx 
 model_config_rec % fire_atm_feedback          =  fire_atm_feedback 
 model_config_rec % fire_mountain_type         =  fire_mountain_type 
 model_config_rec % fire_mountain_height       =  fire_mountain_height 
 model_config_rec % fire_mountain_start_x      =  fire_mountain_start_x 
 model_config_rec % fire_mountain_start_y      =  fire_mountain_start_y 
 model_config_rec % fire_mountain_end_x        =  fire_mountain_end_x 
 model_config_rec % fire_mountain_end_y        =  fire_mountain_end_y 
 model_config_rec % delt_perturbation          =  delt_perturbation 
 model_config_rec % xrad_perturbation          =  xrad_perturbation 
 model_config_rec % yrad_perturbation          =  yrad_perturbation 
 model_config_rec % zrad_perturbation          =  zrad_perturbation 
 model_config_rec % hght_perturbation          =  hght_perturbation 
 model_config_rec % stretch_grd                =  stretch_grd 
 model_config_rec % stretch_hyp                =  stretch_hyp 
 model_config_rec % z_grd_scale                =  z_grd_scale 
 model_config_rec % sfc_full_init              =  sfc_full_init 
 model_config_rec % sfc_lu_index               =  sfc_lu_index 
 model_config_rec % sfc_tsk                    =  sfc_tsk 
 model_config_rec % sfc_tmn                    =  sfc_tmn 
 model_config_rec % fire_read_lu               =  fire_read_lu 
 model_config_rec % fire_read_tsk              =  fire_read_tsk 
 model_config_rec % fire_read_tmn              =  fire_read_tmn 
 model_config_rec % fire_read_atm_ht           =  fire_read_atm_ht 
 model_config_rec % fire_read_fire_ht          =  fire_read_fire_ht 
 model_config_rec % fire_read_atm_grad         =  fire_read_atm_grad 
 model_config_rec % fire_read_fire_grad        =  fire_read_fire_grad 
 model_config_rec % sfc_vegfra                 =  sfc_vegfra 
 model_config_rec % sfc_canwat                 =  sfc_canwat 
 model_config_rec % sfc_ivgtyp                 =  sfc_ivgtyp 
 model_config_rec % sfc_isltyp                 =  sfc_isltyp 
 model_config_rec % fire_lsm_reinit            =  fire_lsm_reinit 
 model_config_rec % fire_lsm_reinit_iter       =  fire_lsm_reinit_iter 
 model_config_rec % fire_upwinding_reinit      =  fire_upwinding_reinit 
 model_config_rec % fire_is_real_perim         =  fire_is_real_perim 
 model_config_rec % fire_lsm_band_ngp          =  fire_lsm_band_ngp 
 model_config_rec % fire_lsm_zcoupling         =  fire_lsm_zcoupling 
 model_config_rec % fire_lsm_zcoupling_ref     =  fire_lsm_zcoupling_ref 
 model_config_rec % fire_tracer_smoke          =  fire_tracer_smoke 
 model_config_rec % fire_viscosity_bg          =  fire_viscosity_bg 
 model_config_rec % fire_viscosity_band        =  fire_viscosity_band 
 model_config_rec % fire_viscosity_ngp         =  fire_viscosity_ngp 
 model_config_rec % fire_slope_factor          =  fire_slope_factor 
 model_config_rec % do_avgflx_em               =  do_avgflx_em 
 model_config_rec % do_avgflx_cugd             =  do_avgflx_cugd 
 model_config_rec % nens                       =  nens 
 model_config_rec % skebs                      =  skebs 
 model_config_rec % stoch_force_opt            =  stoch_force_opt 
 model_config_rec % skebs_vertstruc            =  skebs_vertstruc 
 model_config_rec % stoch_vertstruc_opt        =  stoch_vertstruc_opt 
 model_config_rec % tot_backscat_psi           =  tot_backscat_psi 
 model_config_rec % tot_backscat_t             =  tot_backscat_t 
 model_config_rec % ztau_psi                   =  ztau_psi 
 model_config_rec % ztau_t                     =  ztau_t 
 model_config_rec % rexponent_psi              =  rexponent_psi 
 model_config_rec % rexponent_t                =  rexponent_t 
 model_config_rec % zsigma2_eps                =  zsigma2_eps 
 model_config_rec % zsigma2_eta                =  zsigma2_eta 
 model_config_rec % kminforc                   =  kminforc 
 model_config_rec % lminforc                   =  lminforc 
 model_config_rec % kminforct                  =  kminforct 
 model_config_rec % lminforct                  =  lminforct 
 model_config_rec % kmaxforc                   =  kmaxforc 
 model_config_rec % lmaxforc                   =  lmaxforc 
 model_config_rec % kmaxforct                  =  kmaxforct 
 model_config_rec % lmaxforct                  =  lmaxforct 
 model_config_rec % iseed_skebs                =  iseed_skebs 
 model_config_rec % kmaxforch                  =  kmaxforch 
 model_config_rec % lmaxforch                  =  lmaxforch 
 model_config_rec % kmaxforcth                 =  kmaxforcth 
 model_config_rec % lmaxforcth                 =  lmaxforcth 
 model_config_rec % sppt                       =  sppt 
 model_config_rec % gridpt_stddev_sppt         =  gridpt_stddev_sppt 
 model_config_rec % stddev_cutoff_sppt         =  stddev_cutoff_sppt 
 model_config_rec % lengthscale_sppt           =  lengthscale_sppt 
 model_config_rec % timescale_sppt             =  timescale_sppt 
 model_config_rec % sppt_vertstruc             =  sppt_vertstruc 
 model_config_rec % iseed_sppt                 =  iseed_sppt 
 model_config_rec % rand_perturb               =  rand_perturb 
 model_config_rec % gridpt_stddev_rand_pert    =  gridpt_stddev_rand_pert 
 model_config_rec % stddev_cutoff_rand_pert    =  stddev_cutoff_rand_pert 
 model_config_rec % lengthscale_rand_pert      =  lengthscale_rand_pert 
 model_config_rec % timescale_rand_pert        =  timescale_rand_pert 
 model_config_rec % rand_pert_vertstruc        =  rand_pert_vertstruc 
 model_config_rec % iseed_rand_pert            =  iseed_rand_pert 
 model_config_rec % spp                        =  spp 
 model_config_rec % hrrr_cycling               =  hrrr_cycling 
 model_config_rec % spp_conv                   =  spp_conv 
 model_config_rec % gridpt_stddev_spp_conv     =  gridpt_stddev_spp_conv 
 model_config_rec % stddev_cutoff_spp_conv     =  stddev_cutoff_spp_conv 
 model_config_rec % lengthscale_spp_conv       =  lengthscale_spp_conv 
 model_config_rec % timescale_spp_conv         =  timescale_spp_conv 
 model_config_rec % vertstruc_spp_conv         =  vertstruc_spp_conv 
 model_config_rec % iseed_spp_conv             =  iseed_spp_conv 
 model_config_rec % spp_pbl                    =  spp_pbl 
 model_config_rec % gridpt_stddev_spp_pbl      =  gridpt_stddev_spp_pbl 
 model_config_rec % stddev_cutoff_spp_pbl      =  stddev_cutoff_spp_pbl 
 model_config_rec % lengthscale_spp_pbl        =  lengthscale_spp_pbl 
 model_config_rec % timescale_spp_pbl          =  timescale_spp_pbl 
 model_config_rec % vertstruc_spp_pbl          =  vertstruc_spp_pbl 
 model_config_rec % iseed_spp_pbl              =  iseed_spp_pbl 
 model_config_rec % spp_lsm                    =  spp_lsm 
 model_config_rec % gridpt_stddev_spp_lsm      =  gridpt_stddev_spp_lsm 
 model_config_rec % stddev_cutoff_spp_lsm      =  stddev_cutoff_spp_lsm 
 model_config_rec % lengthscale_spp_lsm        =  lengthscale_spp_lsm 
 model_config_rec % timescale_spp_lsm          =  timescale_spp_lsm 
 model_config_rec % vertstruc_spp_lsm          =  vertstruc_spp_lsm 
 model_config_rec % iseed_spp_lsm              =  iseed_spp_lsm 
 model_config_rec % skebs_on                   =  skebs_on 
 model_config_rec % sppt_on                    =  sppt_on 
 model_config_rec % spp_on                     =  spp_on 
 model_config_rec % rand_perturb_on            =  rand_perturb_on 
 model_config_rec % num_stoch_levels           =  num_stoch_levels 
 model_config_rec % seed_dim                   =  seed_dim 
 model_config_rec % sfs_opt                    =  sfs_opt 
 model_config_rec % m_opt                      =  m_opt 
 model_config_rec % lakedepth_default          =  lakedepth_default 
 model_config_rec % lake_min_elev              =  lake_min_elev 
 model_config_rec % use_lakedepth              =  use_lakedepth 
 model_config_rec % p_lev_diags                =  p_lev_diags 
 model_config_rec % p_lev_diags_dfi            =  p_lev_diags_dfi 
 model_config_rec % num_press_levels           =  num_press_levels 
 model_config_rec % press_levels               =  press_levels 
 model_config_rec % use_tot_or_hyd_p           =  use_tot_or_hyd_p 
 model_config_rec % extrap_below_grnd          =  extrap_below_grnd 
 model_config_rec % p_lev_missing              =  p_lev_missing 
 model_config_rec % p_lev_interval             =  p_lev_interval 
 model_config_rec % z_lev_diags                =  z_lev_diags 
 model_config_rec % z_lev_diags_dfi            =  z_lev_diags_dfi 
 model_config_rec % num_z_levels               =  num_z_levels 
 model_config_rec % z_levels                   =  z_levels 
 model_config_rec % z_lev_missing              =  z_lev_missing 
 model_config_rec % z_lev_interval             =  z_lev_interval 
 model_config_rec % afwa_diag_opt              =  afwa_diag_opt 
 model_config_rec % afwa_ptype_opt             =  afwa_ptype_opt 
 model_config_rec % afwa_vil_opt               =  afwa_vil_opt 
 model_config_rec % afwa_radar_opt             =  afwa_radar_opt 
 model_config_rec % afwa_severe_opt            =  afwa_severe_opt 
 model_config_rec % afwa_icing_opt             =  afwa_icing_opt 
 model_config_rec % afwa_vis_opt               =  afwa_vis_opt 
 model_config_rec % afwa_cloud_opt             =  afwa_cloud_opt 
 model_config_rec % afwa_therm_opt             =  afwa_therm_opt 
 model_config_rec % afwa_turb_opt              =  afwa_turb_opt 
 model_config_rec % afwa_buoy_opt              =  afwa_buoy_opt 
 model_config_rec % afwa_ptype_ccn_tmp         =  afwa_ptype_ccn_tmp 
 model_config_rec % afwa_ptype_tot_melt        =  afwa_ptype_tot_melt 
 model_config_rec % afwa_bad_data_check        =  afwa_bad_data_check 
 model_config_rec % mean_diag                  =  mean_diag 
 model_config_rec % mean_freq                  =  mean_freq 
 model_config_rec % mean_interval              =  mean_interval 
 model_config_rec % mean_diag_interval         =  mean_diag_interval 
 model_config_rec % mean_diag_interval_s       =  mean_diag_interval_s 
 model_config_rec % mean_diag_interval_m       =  mean_diag_interval_m 
 model_config_rec % mean_diag_interval_h       =  mean_diag_interval_h 
 model_config_rec % mean_diag_interval_d       =  mean_diag_interval_d 
 model_config_rec % mean_diag_interval_mo      =  mean_diag_interval_mo 
 model_config_rec % diurnal_diag               =  diurnal_diag 
 model_config_rec % nssl_ipelec                =  nssl_ipelec 
 model_config_rec % nssl_isaund                =  nssl_isaund 
 model_config_rec % nssl_iscreen               =  nssl_iscreen 
 model_config_rec % nssl_lightrad              =  nssl_lightrad 
 model_config_rec % nssl_idischarge            =  nssl_idischarge 
 model_config_rec % nssl_ibrkd                 =  nssl_ibrkd 
 model_config_rec % nssl_ecrit                 =  nssl_ecrit 
 model_config_rec % nssl_disfrac               =  nssl_disfrac 
 model_config_rec % elec_physics               =  elec_physics 
 model_config_rec % perturb_bdy                =  perturb_bdy 
 model_config_rec % perturb_chem_bdy           =  perturb_chem_bdy 
 model_config_rec % hybrid_opt                 =  hybrid_opt 
 model_config_rec % etac                       =  etac 
 model_config_rec % num_wif_levels             =  num_wif_levels 
 model_config_rec % wif_input_opt              =  wif_input_opt 
 model_config_rec % diag_nwp2                  =  diag_nwp2 
 model_config_rec % chem_opt                   =  chem_opt 



      CLOSE ( UNIT = nml_read_unit , IOSTAT = io_status )

      IF ( io_status .NE. 0 ) THEN
        CALL wrf_error_fatal3("<stdin>",13095,&
'ERROR CLOSING namelist.input' )
      ENDIF

      CLOSE ( UNIT = nml_write_unit , IOSTAT = io_status )

      IF ( io_status .NE. 0 ) THEN
        CALL wrf_error_fatal3("<stdin>",13102,&
'ERROR CLOSING namelist.output' )
      ENDIF


      RETURN

   END SUBROUTINE initial_config

   SUBROUTINE get_config_as_buffer( buffer, buflen, ncopied )

      INTEGER,   INTENT(INOUT) ::  buffer(*)
      INTEGER,   INTENT(IN)    ::  buflen
      INTEGER,   INTENT(OUT)   ::  ncopied

      INTEGER :: nbytes
      CALL wrf_num_bytes_between ( model_config_rec%last_item_in_struct ,   &
                                   model_config_rec%first_item_in_struct ,  &
                                   nbytes )


      IF ( nbytes .gt. buflen ) THEN
        CALL wrf_error_fatal3("<stdin>",13124,&
        "get_config_rec_as_buffer: buffer size too small for config_rec" )
      ENDIF
      CALL wrf_mem_copy( model_config_rec, buffer, nbytes )
      ncopied = nbytes
      RETURN
   END SUBROUTINE get_config_as_buffer

   SUBROUTINE set_config_as_buffer( buffer, buflen )

      INTEGER,   INTENT(INOUT) ::  buffer(*)
      INTEGER,   INTENT(IN)    ::  buflen

      INTEGER :: nbytes
      CALL wrf_num_bytes_between ( model_config_rec%last_item_in_struct ,  &
                                   model_config_rec%first_item_in_struct , &
                                   nbytes )


      IF ( nbytes .gt. buflen ) THEN
        CALL wrf_error_fatal3("<stdin>",13144,&
        "set_config_rec_as_buffer: buffer length too small to fill model config record" )
      ENDIF
      CALL wrf_mem_copy( buffer, model_config_rec, nbytes )
      RETURN
   END SUBROUTINE set_config_as_buffer

   SUBROUTINE model_to_grid_config_rec ( id_id , model_config_rec , grid_config_rec )
      INTEGER , INTENT(IN)                         ::  id_id
      TYPE ( model_config_rec_type ) , INTENT(IN)  ::  model_config_rec
      TYPE ( grid_config_rec_type  ) , INTENT(OUT) ::  grid_config_rec


































 grid_config_rec % run_days                   = model_config_rec % run_days 
 grid_config_rec % run_hours                  = model_config_rec % run_hours 
 grid_config_rec % run_minutes                = model_config_rec % run_minutes 
 grid_config_rec % run_seconds                = model_config_rec % run_seconds 
 grid_config_rec % start_year                 = model_config_rec % start_year (id_id)
 grid_config_rec % start_month                = model_config_rec % start_month (id_id)
 grid_config_rec % start_day                  = model_config_rec % start_day (id_id)
 grid_config_rec % start_hour                 = model_config_rec % start_hour (id_id)
 grid_config_rec % start_minute               = model_config_rec % start_minute (id_id)
 grid_config_rec % start_second               = model_config_rec % start_second (id_id)
 grid_config_rec % end_year                   = model_config_rec % end_year (id_id)
 grid_config_rec % end_month                  = model_config_rec % end_month (id_id)
 grid_config_rec % end_day                    = model_config_rec % end_day (id_id)
 grid_config_rec % end_hour                   = model_config_rec % end_hour (id_id)
 grid_config_rec % end_minute                 = model_config_rec % end_minute (id_id)
 grid_config_rec % end_second                 = model_config_rec % end_second (id_id)
 grid_config_rec % interval_seconds           = model_config_rec % interval_seconds 
 grid_config_rec % input_from_file            = model_config_rec % input_from_file (id_id)
 grid_config_rec % fine_input_stream          = model_config_rec % fine_input_stream (id_id)
 grid_config_rec % input_from_hires           = model_config_rec % input_from_hires (id_id)
 grid_config_rec % rsmas_data_path            = model_config_rec % rsmas_data_path 
 grid_config_rec % all_ic_times               = model_config_rec % all_ic_times 
 grid_config_rec % julyr                      = model_config_rec % julyr (id_id)
 grid_config_rec % julday                     = model_config_rec % julday (id_id)
 grid_config_rec % gmt                        = model_config_rec % gmt (id_id)
 grid_config_rec % input_inname               = model_config_rec % input_inname 
 grid_config_rec % input_outname              = model_config_rec % input_outname 
 grid_config_rec % bdy_inname                 = model_config_rec % bdy_inname 
 grid_config_rec % bdy_outname                = model_config_rec % bdy_outname 
 grid_config_rec % rst_inname                 = model_config_rec % rst_inname 
 grid_config_rec % rst_outname                = model_config_rec % rst_outname 
 grid_config_rec % write_input                = model_config_rec % write_input 
 grid_config_rec % write_restart_at_0h        = model_config_rec % write_restart_at_0h 
 grid_config_rec % write_hist_at_0h_rst       = model_config_rec % write_hist_at_0h_rst 
 grid_config_rec % adjust_output_times        = model_config_rec % adjust_output_times 
 grid_config_rec % adjust_input_times         = model_config_rec % adjust_input_times 
 grid_config_rec % diag_print                 = model_config_rec % diag_print 
 grid_config_rec % nocolons                   = model_config_rec % nocolons 
 grid_config_rec % cycling                    = model_config_rec % cycling 
 grid_config_rec % output_diagnostics         = model_config_rec % output_diagnostics 
 grid_config_rec % nwp_diagnostics            = model_config_rec % nwp_diagnostics 
 grid_config_rec % output_ready_flag          = model_config_rec % output_ready_flag 
 grid_config_rec % force_use_old_data         = model_config_rec % force_use_old_data 
 grid_config_rec % usepio                     = model_config_rec % usepio 
 grid_config_rec % pioprocs                   = model_config_rec % pioprocs 
 grid_config_rec % piostart                   = model_config_rec % piostart 
 grid_config_rec % piostride                  = model_config_rec % piostride 
 grid_config_rec % pioshift                   = model_config_rec % pioshift 
 grid_config_rec % dfi_opt                    = model_config_rec % dfi_opt 
 grid_config_rec % dfi_savehydmeteors         = model_config_rec % dfi_savehydmeteors 
 grid_config_rec % dfi_nfilter                = model_config_rec % dfi_nfilter 
 grid_config_rec % dfi_write_filtered_input   = model_config_rec % dfi_write_filtered_input 
 grid_config_rec % dfi_write_dfi_history      = model_config_rec % dfi_write_dfi_history 
 grid_config_rec % dfi_cutoff_seconds         = model_config_rec % dfi_cutoff_seconds 
 grid_config_rec % dfi_time_dim               = model_config_rec % dfi_time_dim 
 grid_config_rec % dfi_fwdstop_year           = model_config_rec % dfi_fwdstop_year 
 grid_config_rec % dfi_fwdstop_month          = model_config_rec % dfi_fwdstop_month 
 grid_config_rec % dfi_fwdstop_day            = model_config_rec % dfi_fwdstop_day 
 grid_config_rec % dfi_fwdstop_hour           = model_config_rec % dfi_fwdstop_hour 
 grid_config_rec % dfi_fwdstop_minute         = model_config_rec % dfi_fwdstop_minute 
 grid_config_rec % dfi_fwdstop_second         = model_config_rec % dfi_fwdstop_second 
 grid_config_rec % dfi_bckstop_year           = model_config_rec % dfi_bckstop_year 
 grid_config_rec % dfi_bckstop_month          = model_config_rec % dfi_bckstop_month 
 grid_config_rec % dfi_bckstop_day            = model_config_rec % dfi_bckstop_day 
 grid_config_rec % dfi_bckstop_hour           = model_config_rec % dfi_bckstop_hour 
 grid_config_rec % dfi_bckstop_minute         = model_config_rec % dfi_bckstop_minute 
 grid_config_rec % dfi_bckstop_second         = model_config_rec % dfi_bckstop_second 
 grid_config_rec % time_step                  = model_config_rec % time_step 
 grid_config_rec % time_step_fract_num        = model_config_rec % time_step_fract_num 
 grid_config_rec % time_step_fract_den        = model_config_rec % time_step_fract_den 
 grid_config_rec % time_step_dfi              = model_config_rec % time_step_dfi 
 grid_config_rec % min_time_step              = model_config_rec % min_time_step (id_id)
 grid_config_rec % min_time_step_den          = model_config_rec % min_time_step_den (id_id)
 grid_config_rec % max_time_step              = model_config_rec % max_time_step (id_id)
 grid_config_rec % max_time_step_den          = model_config_rec % max_time_step_den (id_id)
 grid_config_rec % target_cfl                 = model_config_rec % target_cfl (id_id)
 grid_config_rec % target_hcfl                = model_config_rec % target_hcfl (id_id)
 grid_config_rec % max_step_increase_pct      = model_config_rec % max_step_increase_pct (id_id)
 grid_config_rec % starting_time_step         = model_config_rec % starting_time_step (id_id)
 grid_config_rec % starting_time_step_den     = model_config_rec % starting_time_step_den (id_id)
 grid_config_rec % step_to_output_time        = model_config_rec % step_to_output_time 
 grid_config_rec % adaptation_domain          = model_config_rec % adaptation_domain 
 grid_config_rec % use_adaptive_time_step     = model_config_rec % use_adaptive_time_step 
 grid_config_rec % use_adaptive_time_step_dfi = model_config_rec % use_adaptive_time_step_dfi 
 grid_config_rec % max_dom                    = model_config_rec % max_dom 
 grid_config_rec % lats_to_mic                = model_config_rec % lats_to_mic 
 grid_config_rec % s_we                       = model_config_rec % s_we (id_id)
 grid_config_rec % e_we                       = model_config_rec % e_we (id_id)
 grid_config_rec % s_sn                       = model_config_rec % s_sn (id_id)
 grid_config_rec % e_sn                       = model_config_rec % e_sn (id_id)
 grid_config_rec % s_vert                     = model_config_rec % s_vert (id_id)
 grid_config_rec % e_vert                     = model_config_rec % e_vert (id_id)
 grid_config_rec % num_metgrid_levels         = model_config_rec % num_metgrid_levels 
 grid_config_rec % num_metgrid_soil_levels    = model_config_rec % num_metgrid_soil_levels 
 grid_config_rec % p_top_requested            = model_config_rec % p_top_requested 
 grid_config_rec % interp_theta               = model_config_rec % interp_theta 
 grid_config_rec % interp_type                = model_config_rec % interp_type 
 grid_config_rec % rebalance                  = model_config_rec % rebalance 
 grid_config_rec % vert_refine_method         = model_config_rec % vert_refine_method (id_id)
 grid_config_rec % vert_refine_fact           = model_config_rec % vert_refine_fact 
 grid_config_rec % extrap_type                = model_config_rec % extrap_type 
 grid_config_rec % t_extrap_type              = model_config_rec % t_extrap_type 
 grid_config_rec % hypsometric_opt            = model_config_rec % hypsometric_opt 
 grid_config_rec % lowest_lev_from_sfc        = model_config_rec % lowest_lev_from_sfc 
 grid_config_rec % use_levels_below_ground    = model_config_rec % use_levels_below_ground 
 grid_config_rec % use_tavg_for_tsk           = model_config_rec % use_tavg_for_tsk 
 grid_config_rec % use_surface                = model_config_rec % use_surface 
 grid_config_rec % lagrange_order             = model_config_rec % lagrange_order 
 grid_config_rec % linear_interp              = model_config_rec % linear_interp 
 grid_config_rec % force_sfc_in_vinterp       = model_config_rec % force_sfc_in_vinterp 
 grid_config_rec % zap_close_levels           = model_config_rec % zap_close_levels 
 grid_config_rec % maxw_horiz_pres_diff       = model_config_rec % maxw_horiz_pres_diff 
 grid_config_rec % trop_horiz_pres_diff       = model_config_rec % trop_horiz_pres_diff 
 grid_config_rec % maxw_above_this_level      = model_config_rec % maxw_above_this_level 
 grid_config_rec % use_maxw_level             = model_config_rec % use_maxw_level 
 grid_config_rec % use_trop_level             = model_config_rec % use_trop_level 
 grid_config_rec % sfcp_to_sfcp               = model_config_rec % sfcp_to_sfcp 
 grid_config_rec % adjust_heights             = model_config_rec % adjust_heights 
 grid_config_rec % smooth_cg_topo             = model_config_rec % smooth_cg_topo 
 grid_config_rec % nest_interp_coord          = model_config_rec % nest_interp_coord 
 grid_config_rec % interp_method_type         = model_config_rec % interp_method_type 
 grid_config_rec % aggregate_lu               = model_config_rec % aggregate_lu 
 grid_config_rec % rh2qv_wrt_liquid           = model_config_rec % rh2qv_wrt_liquid 
 grid_config_rec % rh2qv_method               = model_config_rec % rh2qv_method 
 grid_config_rec % qv_max_p_safe              = model_config_rec % qv_max_p_safe 
 grid_config_rec % qv_max_flag                = model_config_rec % qv_max_flag 
 grid_config_rec % qv_max_value               = model_config_rec % qv_max_value 
 grid_config_rec % qv_min_p_safe              = model_config_rec % qv_min_p_safe 
 grid_config_rec % qv_min_flag                = model_config_rec % qv_min_flag 
 grid_config_rec % qv_min_value               = model_config_rec % qv_min_value 
 grid_config_rec % ideal_init_method          = model_config_rec % ideal_init_method 
 grid_config_rec % dx                         = model_config_rec % dx (id_id)
 grid_config_rec % dy                         = model_config_rec % dy (id_id)
 grid_config_rec % grid_id                    = model_config_rec % grid_id (id_id)
 grid_config_rec % grid_allowed               = model_config_rec % grid_allowed (id_id)
 grid_config_rec % parent_id                  = model_config_rec % parent_id (id_id)
 grid_config_rec % i_parent_start             = model_config_rec % i_parent_start (id_id)
 grid_config_rec % j_parent_start             = model_config_rec % j_parent_start (id_id)
 grid_config_rec % parent_grid_ratio          = model_config_rec % parent_grid_ratio (id_id)
 grid_config_rec % parent_time_step_ratio     = model_config_rec % parent_time_step_ratio (id_id)
 grid_config_rec % feedback                   = model_config_rec % feedback 
 grid_config_rec % smooth_option              = model_config_rec % smooth_option 
 grid_config_rec % blend_width                = model_config_rec % blend_width 
 grid_config_rec % ztop                       = model_config_rec % ztop (id_id)
 grid_config_rec % moad_grid_ratio            = model_config_rec % moad_grid_ratio (id_id)
 grid_config_rec % moad_time_step_ratio       = model_config_rec % moad_time_step_ratio (id_id)
 grid_config_rec % shw                        = model_config_rec % shw (id_id)
 grid_config_rec % tile_sz_x                  = model_config_rec % tile_sz_x 
 grid_config_rec % tile_sz_y                  = model_config_rec % tile_sz_y 
 grid_config_rec % numtiles                   = model_config_rec % numtiles 
 grid_config_rec % numtiles_inc               = model_config_rec % numtiles_inc 
 grid_config_rec % numtiles_x                 = model_config_rec % numtiles_x 
 grid_config_rec % numtiles_y                 = model_config_rec % numtiles_y 
 grid_config_rec % tile_strategy              = model_config_rec % tile_strategy 
 grid_config_rec % nproc_x                    = model_config_rec % nproc_x 
 grid_config_rec % nproc_y                    = model_config_rec % nproc_y 
 grid_config_rec % irand                      = model_config_rec % irand 
 grid_config_rec % dt                         = model_config_rec % dt (id_id)
 grid_config_rec % fft_used                   = model_config_rec % fft_used 
 grid_config_rec % cu_used                    = model_config_rec % cu_used 
 grid_config_rec % shcu_used                  = model_config_rec % shcu_used 
 grid_config_rec % cam_used                   = model_config_rec % cam_used 
 grid_config_rec % alloc_qndropsource         = model_config_rec % alloc_qndropsource 
 grid_config_rec % num_moves                  = model_config_rec % num_moves 
 grid_config_rec % ts_buf_size                = model_config_rec % ts_buf_size 
 grid_config_rec % max_ts_locs                = model_config_rec % max_ts_locs 
 grid_config_rec % tslist_ij                  = model_config_rec % tslist_ij 
 grid_config_rec % tslist_unstagger_winds     = model_config_rec % tslist_unstagger_winds 
 grid_config_rec % vortex_interval            = model_config_rec % vortex_interval (id_id)
 grid_config_rec % max_vortex_speed           = model_config_rec % max_vortex_speed (id_id)
 grid_config_rec % corral_dist                = model_config_rec % corral_dist (id_id)
 grid_config_rec % track_level                = model_config_rec % track_level 
 grid_config_rec % time_to_move               = model_config_rec % time_to_move (id_id)
 grid_config_rec % move_id                    = model_config_rec % move_id (id_id)
 grid_config_rec % move_interval              = model_config_rec % move_interval (id_id)
 grid_config_rec % move_cd_x                  = model_config_rec % move_cd_x (id_id)
 grid_config_rec % move_cd_y                  = model_config_rec % move_cd_y (id_id)
 grid_config_rec % swap_x                     = model_config_rec % swap_x (id_id)
 grid_config_rec % swap_y                     = model_config_rec % swap_y (id_id)
 grid_config_rec % cycle_x                    = model_config_rec % cycle_x (id_id)
 grid_config_rec % cycle_y                    = model_config_rec % cycle_y (id_id)
 grid_config_rec % reorder_mesh               = model_config_rec % reorder_mesh 
 grid_config_rec % perturb_input              = model_config_rec % perturb_input 
 grid_config_rec % eta_levels                 = model_config_rec % eta_levels (id_id)
 grid_config_rec % auto_levels_opt            = model_config_rec % auto_levels_opt 
 grid_config_rec % max_dz                     = model_config_rec % max_dz 
 grid_config_rec % dzbot                      = model_config_rec % dzbot 
 grid_config_rec % dzstretch_s                = model_config_rec % dzstretch_s 
 grid_config_rec % dzstretch_u                = model_config_rec % dzstretch_u 
 grid_config_rec % ocean_levels               = model_config_rec % ocean_levels 
 grid_config_rec % ocean_z                    = model_config_rec % ocean_z (id_id)
 grid_config_rec % ocean_t                    = model_config_rec % ocean_t (id_id)
 grid_config_rec % ocean_s                    = model_config_rec % ocean_s (id_id)
 grid_config_rec % num_traj                   = model_config_rec % num_traj 
 grid_config_rec % max_ts_level               = model_config_rec % max_ts_level 
 grid_config_rec % track_loc_in               = model_config_rec % track_loc_in 
 grid_config_rec % num_ext_model_couple_dom   = model_config_rec % num_ext_model_couple_dom 
 grid_config_rec % insert_bogus_storm         = model_config_rec % insert_bogus_storm 
 grid_config_rec % remove_storm               = model_config_rec % remove_storm 
 grid_config_rec % num_storm                  = model_config_rec % num_storm 
 grid_config_rec % latc_loc                   = model_config_rec % latc_loc (id_id)
 grid_config_rec % lonc_loc                   = model_config_rec % lonc_loc (id_id)
 grid_config_rec % vmax_meters_per_second     = model_config_rec % vmax_meters_per_second (id_id)
 grid_config_rec % rmax                       = model_config_rec % rmax (id_id)
 grid_config_rec % vmax_ratio                 = model_config_rec % vmax_ratio (id_id)
 grid_config_rec % rankine_lid                = model_config_rec % rankine_lid 
 grid_config_rec % physics_suite              = model_config_rec % physics_suite 
 grid_config_rec % force_read_thompson        = model_config_rec % force_read_thompson 
 grid_config_rec % write_thompson_tables      = model_config_rec % write_thompson_tables 
 grid_config_rec % mp_physics                 = model_config_rec % mp_physics (id_id)
 grid_config_rec % nssl_cccn                  = model_config_rec % nssl_cccn (id_id)
 grid_config_rec % nssl_alphah                = model_config_rec % nssl_alphah (id_id)
 grid_config_rec % nssl_alphahl               = model_config_rec % nssl_alphahl (id_id)
 grid_config_rec % nssl_cnoh                  = model_config_rec % nssl_cnoh (id_id)
 grid_config_rec % nssl_cnohl                 = model_config_rec % nssl_cnohl (id_id)
 grid_config_rec % nssl_cnor                  = model_config_rec % nssl_cnor (id_id)
 grid_config_rec % nssl_cnos                  = model_config_rec % nssl_cnos (id_id)
 grid_config_rec % nssl_rho_qh                = model_config_rec % nssl_rho_qh (id_id)
 grid_config_rec % nssl_rho_qhl               = model_config_rec % nssl_rho_qhl (id_id)
 grid_config_rec % nssl_rho_qs                = model_config_rec % nssl_rho_qs (id_id)
 grid_config_rec % nudge_lightning            = model_config_rec % nudge_lightning (id_id)
 grid_config_rec % nudge_light_times          = model_config_rec % nudge_light_times (id_id)
 grid_config_rec % nudge_light_timee          = model_config_rec % nudge_light_timee (id_id)
 grid_config_rec % nudge_light_int            = model_config_rec % nudge_light_int (id_id)
 grid_config_rec % path_to_files              = model_config_rec % path_to_files 
 grid_config_rec % gsfcgce_hail               = model_config_rec % gsfcgce_hail 
 grid_config_rec % gsfcgce_2ice               = model_config_rec % gsfcgce_2ice 
 grid_config_rec % progn                      = model_config_rec % progn (id_id)
 grid_config_rec % accum_mode                 = model_config_rec % accum_mode 
 grid_config_rec % aitken_mode                = model_config_rec % aitken_mode 
 grid_config_rec % coarse_mode                = model_config_rec % coarse_mode 
 grid_config_rec % do_radar_ref               = model_config_rec % do_radar_ref 
 grid_config_rec % compute_radar_ref          = model_config_rec % compute_radar_ref 
 grid_config_rec % ra_lw_physics              = model_config_rec % ra_lw_physics (id_id)
 grid_config_rec % ra_sw_physics              = model_config_rec % ra_sw_physics (id_id)
 grid_config_rec % radt                       = model_config_rec % radt (id_id)
 grid_config_rec % naer                       = model_config_rec % naer (id_id)
 grid_config_rec % sf_sfclay_physics          = model_config_rec % sf_sfclay_physics (id_id)
 grid_config_rec % sf_surface_physics         = model_config_rec % sf_surface_physics (id_id)
 grid_config_rec % bl_pbl_physics             = model_config_rec % bl_pbl_physics (id_id)
 grid_config_rec % bl_mynn_tkebudget          = model_config_rec % bl_mynn_tkebudget (id_id)
 grid_config_rec % ysu_topdown_pblmix         = model_config_rec % ysu_topdown_pblmix 
 grid_config_rec % shinhong_tke_diag          = model_config_rec % shinhong_tke_diag (id_id)
 grid_config_rec % bl_mynn_tkeadvect          = model_config_rec % bl_mynn_tkeadvect (id_id)
 grid_config_rec % bl_mynn_cloudpdf           = model_config_rec % bl_mynn_cloudpdf 
 grid_config_rec % bl_mynn_mixlength          = model_config_rec % bl_mynn_mixlength 
 grid_config_rec % bl_mynn_edmf               = model_config_rec % bl_mynn_edmf (id_id)
 grid_config_rec % bl_mynn_edmf_mom           = model_config_rec % bl_mynn_edmf_mom (id_id)
 grid_config_rec % bl_mynn_edmf_tke           = model_config_rec % bl_mynn_edmf_tke (id_id)
 grid_config_rec % bl_mynn_mixscalars         = model_config_rec % bl_mynn_mixscalars (id_id)
 grid_config_rec % bl_mynn_cloudmix           = model_config_rec % bl_mynn_cloudmix (id_id)
 grid_config_rec % bl_mynn_mixqt              = model_config_rec % bl_mynn_mixqt (id_id)
 grid_config_rec % icloud_bl                  = model_config_rec % icloud_bl 
 grid_config_rec % mfshconv                   = model_config_rec % mfshconv (id_id)
 grid_config_rec % sf_urban_physics           = model_config_rec % sf_urban_physics (id_id)
 grid_config_rec % bldt                       = model_config_rec % bldt (id_id)
 grid_config_rec % cu_physics                 = model_config_rec % cu_physics (id_id)
 grid_config_rec % shcu_physics               = model_config_rec % shcu_physics (id_id)
 grid_config_rec % cu_diag                    = model_config_rec % cu_diag (id_id)
 grid_config_rec % kf_edrates                 = model_config_rec % kf_edrates (id_id)
 grid_config_rec % kfeta_trigger              = model_config_rec % kfeta_trigger 
 grid_config_rec % nsas_dx_factor             = model_config_rec % nsas_dx_factor 
 grid_config_rec % cudt                       = model_config_rec % cudt (id_id)
 grid_config_rec % gsmdt                      = model_config_rec % gsmdt (id_id)
 grid_config_rec % isfflx                     = model_config_rec % isfflx 
 grid_config_rec % ifsnow                     = model_config_rec % ifsnow 
 grid_config_rec % icloud                     = model_config_rec % icloud 
 grid_config_rec % cldovrlp                   = model_config_rec % cldovrlp 
 grid_config_rec % ideal_xland                = model_config_rec % ideal_xland 
 grid_config_rec % swrad_scat                 = model_config_rec % swrad_scat 
 grid_config_rec % surface_input_source       = model_config_rec % surface_input_source 
 grid_config_rec % num_soil_layers            = model_config_rec % num_soil_layers 
 grid_config_rec % maxpatch                   = model_config_rec % maxpatch 
 grid_config_rec % num_snow_layers            = model_config_rec % num_snow_layers 
 grid_config_rec % num_snso_layers            = model_config_rec % num_snso_layers 
 grid_config_rec % num_urban_ndm              = model_config_rec % num_urban_ndm 
 grid_config_rec % num_urban_ng               = model_config_rec % num_urban_ng 
 grid_config_rec % num_urban_nwr              = model_config_rec % num_urban_nwr 
 grid_config_rec % num_urban_ngb              = model_config_rec % num_urban_ngb 
 grid_config_rec % num_urban_nf               = model_config_rec % num_urban_nf 
 grid_config_rec % num_urban_nz               = model_config_rec % num_urban_nz 
 grid_config_rec % num_urban_nbui             = model_config_rec % num_urban_nbui 
 grid_config_rec % urban_map_zrd              = model_config_rec % urban_map_zrd 
 grid_config_rec % urban_map_zwd              = model_config_rec % urban_map_zwd 
 grid_config_rec % urban_map_gd               = model_config_rec % urban_map_gd 
 grid_config_rec % urban_map_zd               = model_config_rec % urban_map_zd 
 grid_config_rec % urban_map_zdf              = model_config_rec % urban_map_zdf 
 grid_config_rec % urban_map_bd               = model_config_rec % urban_map_bd 
 grid_config_rec % urban_map_wd               = model_config_rec % urban_map_wd 
 grid_config_rec % urban_map_gbd              = model_config_rec % urban_map_gbd 
 grid_config_rec % urban_map_fbd              = model_config_rec % urban_map_fbd 
 grid_config_rec % num_urban_hi               = model_config_rec % num_urban_hi 
 grid_config_rec % num_months                 = model_config_rec % num_months 
 grid_config_rec % sf_surface_mosaic          = model_config_rec % sf_surface_mosaic 
 grid_config_rec % mosaic_cat                 = model_config_rec % mosaic_cat 
 grid_config_rec % mosaic_cat_soil            = model_config_rec % mosaic_cat_soil 
 grid_config_rec % mosaic_lu                  = model_config_rec % mosaic_lu 
 grid_config_rec % mosaic_soil                = model_config_rec % mosaic_soil 
 grid_config_rec % flag_sm_adj                = model_config_rec % flag_sm_adj 
 grid_config_rec % maxiens                    = model_config_rec % maxiens 
 grid_config_rec % maxens                     = model_config_rec % maxens 
 grid_config_rec % maxens2                    = model_config_rec % maxens2 
 grid_config_rec % maxens3                    = model_config_rec % maxens3 
 grid_config_rec % ensdim                     = model_config_rec % ensdim 
 grid_config_rec % cugd_avedx                 = model_config_rec % cugd_avedx 
 grid_config_rec % clos_choice                = model_config_rec % clos_choice 
 grid_config_rec % imomentum                  = model_config_rec % imomentum 
 grid_config_rec % ishallow                   = model_config_rec % ishallow 
 grid_config_rec % convtrans_avglen_m         = model_config_rec % convtrans_avglen_m 
 grid_config_rec % num_land_cat               = model_config_rec % num_land_cat 
 grid_config_rec % num_soil_cat               = model_config_rec % num_soil_cat 
 grid_config_rec % mp_zero_out                = model_config_rec % mp_zero_out 
 grid_config_rec % mp_zero_out_thresh         = model_config_rec % mp_zero_out_thresh 
 grid_config_rec % seaice_threshold           = model_config_rec % seaice_threshold 
 grid_config_rec % sst_update                 = model_config_rec % sst_update 
 grid_config_rec % sst_skin                   = model_config_rec % sst_skin 
 grid_config_rec % tmn_update                 = model_config_rec % tmn_update 
 grid_config_rec % usemonalb                  = model_config_rec % usemonalb 
 grid_config_rec % rdmaxalb                   = model_config_rec % rdmaxalb 
 grid_config_rec % rdlai2d                    = model_config_rec % rdlai2d 
 grid_config_rec % ua_phys                    = model_config_rec % ua_phys 
 grid_config_rec % opt_thcnd                  = model_config_rec % opt_thcnd 
 grid_config_rec % co2tf                      = model_config_rec % co2tf 
 grid_config_rec % ra_call_offset             = model_config_rec % ra_call_offset 
 grid_config_rec % cam_abs_freq_s             = model_config_rec % cam_abs_freq_s 
 grid_config_rec % levsiz                     = model_config_rec % levsiz 
 grid_config_rec % paerlev                    = model_config_rec % paerlev 
 grid_config_rec % cam_abs_dim1               = model_config_rec % cam_abs_dim1 
 grid_config_rec % cam_abs_dim2               = model_config_rec % cam_abs_dim2 
 grid_config_rec % lagday                     = model_config_rec % lagday 
 grid_config_rec % no_src_types               = model_config_rec % no_src_types 
 grid_config_rec % alevsiz                    = model_config_rec % alevsiz 
 grid_config_rec % o3input                    = model_config_rec % o3input 
 grid_config_rec % aer_opt                    = model_config_rec % aer_opt 
 grid_config_rec % swint_opt                  = model_config_rec % swint_opt 
 grid_config_rec % aer_type                   = model_config_rec % aer_type (id_id)
 grid_config_rec % aer_aod550_opt             = model_config_rec % aer_aod550_opt (id_id)
 grid_config_rec % aer_angexp_opt             = model_config_rec % aer_angexp_opt (id_id)
 grid_config_rec % aer_ssa_opt                = model_config_rec % aer_ssa_opt (id_id)
 grid_config_rec % aer_asy_opt                = model_config_rec % aer_asy_opt (id_id)
 grid_config_rec % aer_aod550_val             = model_config_rec % aer_aod550_val (id_id)
 grid_config_rec % aer_angexp_val             = model_config_rec % aer_angexp_val (id_id)
 grid_config_rec % aer_ssa_val                = model_config_rec % aer_ssa_val (id_id)
 grid_config_rec % aer_asy_val                = model_config_rec % aer_asy_val (id_id)
 grid_config_rec % cu_rad_feedback            = model_config_rec % cu_rad_feedback (id_id)
 grid_config_rec % dust_emis                  = model_config_rec % dust_emis 
 grid_config_rec % erosion_dim                = model_config_rec % erosion_dim 
 grid_config_rec % no_src_types_cu            = model_config_rec % no_src_types_cu 
 grid_config_rec % alevsiz_cu                 = model_config_rec % alevsiz_cu 
 grid_config_rec % aercu_opt                  = model_config_rec % aercu_opt 
 grid_config_rec % aercu_fct                  = model_config_rec % aercu_fct 
 grid_config_rec % aercu_used                 = model_config_rec % aercu_used 
 grid_config_rec % shallowcu_forced_ra        = model_config_rec % shallowcu_forced_ra (id_id)
 grid_config_rec % numbins                    = model_config_rec % numbins (id_id)
 grid_config_rec % thbinsize                  = model_config_rec % thbinsize (id_id)
 grid_config_rec % rbinsize                   = model_config_rec % rbinsize (id_id)
 grid_config_rec % mindeepfreq                = model_config_rec % mindeepfreq (id_id)
 grid_config_rec % minshallowfreq             = model_config_rec % minshallowfreq (id_id)
 grid_config_rec % shcu_aerosols_opt          = model_config_rec % shcu_aerosols_opt (id_id)
 grid_config_rec % icloud_cu                  = model_config_rec % icloud_cu (id_id)
 grid_config_rec % pxlsm_smois_init           = model_config_rec % pxlsm_smois_init (id_id)
 grid_config_rec % pxlsm_modis_veg            = model_config_rec % pxlsm_modis_veg (id_id)
 grid_config_rec % omlcall                    = model_config_rec % omlcall 
 grid_config_rec % sf_ocean_physics           = model_config_rec % sf_ocean_physics 
 grid_config_rec % traj_opt                   = model_config_rec % traj_opt 
 grid_config_rec % dm_has_traj                = model_config_rec % dm_has_traj (id_id)
 grid_config_rec % tracercall                 = model_config_rec % tracercall 
 grid_config_rec % omdt                       = model_config_rec % omdt 
 grid_config_rec % oml_hml0                   = model_config_rec % oml_hml0 
 grid_config_rec % oml_gamma                  = model_config_rec % oml_gamma 
 grid_config_rec % oml_relaxation_time        = model_config_rec % oml_relaxation_time 
 grid_config_rec % isftcflx                   = model_config_rec % isftcflx 
 grid_config_rec % iz0tlnd                    = model_config_rec % iz0tlnd 
 grid_config_rec % shadlen                    = model_config_rec % shadlen 
 grid_config_rec % slope_rad                  = model_config_rec % slope_rad (id_id)
 grid_config_rec % topo_shading               = model_config_rec % topo_shading (id_id)
 grid_config_rec % topo_wind                  = model_config_rec % topo_wind (id_id)
 grid_config_rec % no_mp_heating              = model_config_rec % no_mp_heating 
 grid_config_rec % fractional_seaice          = model_config_rec % fractional_seaice 
 grid_config_rec % seaice_snowdepth_opt       = model_config_rec % seaice_snowdepth_opt 
 grid_config_rec % seaice_snowdepth_max       = model_config_rec % seaice_snowdepth_max 
 grid_config_rec % seaice_snowdepth_min       = model_config_rec % seaice_snowdepth_min 
 grid_config_rec % seaice_albedo_opt          = model_config_rec % seaice_albedo_opt 
 grid_config_rec % seaice_albedo_default      = model_config_rec % seaice_albedo_default 
 grid_config_rec % seaice_thickness_opt       = model_config_rec % seaice_thickness_opt 
 grid_config_rec % seaice_thickness_default   = model_config_rec % seaice_thickness_default 
 grid_config_rec % tice2tsk_if2cold           = model_config_rec % tice2tsk_if2cold 
 grid_config_rec % bucket_mm                  = model_config_rec % bucket_mm 
 grid_config_rec % bucket_j                   = model_config_rec % bucket_j 
 grid_config_rec % mp_tend_lim                = model_config_rec % mp_tend_lim 
 grid_config_rec % prec_acc_dt                = model_config_rec % prec_acc_dt (id_id)
 grid_config_rec % prec_acc_opt               = model_config_rec % prec_acc_opt 
 grid_config_rec % bucketr_opt                = model_config_rec % bucketr_opt 
 grid_config_rec % bucketf_opt                = model_config_rec % bucketf_opt 
 grid_config_rec % process_time_series        = model_config_rec % process_time_series 
 grid_config_rec % grav_settling              = model_config_rec % grav_settling (id_id)
 grid_config_rec % sas_pgcon                  = model_config_rec % sas_pgcon (id_id)
 grid_config_rec % scalar_pblmix              = model_config_rec % scalar_pblmix (id_id)
 grid_config_rec % tracer_pblmix              = model_config_rec % tracer_pblmix (id_id)
 grid_config_rec % use_aero_icbc              = model_config_rec % use_aero_icbc 
 grid_config_rec % use_rap_aero_icbc          = model_config_rec % use_rap_aero_icbc 
 grid_config_rec % use_mp_re                  = model_config_rec % use_mp_re 
 grid_config_rec % ccn_conc                   = model_config_rec % ccn_conc 
 grid_config_rec % hail_opt                   = model_config_rec % hail_opt 
 grid_config_rec % morr_rimed_ice             = model_config_rec % morr_rimed_ice 
 grid_config_rec % clean_atm_diag             = model_config_rec % clean_atm_diag 
 grid_config_rec % calc_clean_atm_diag        = model_config_rec % calc_clean_atm_diag 
 grid_config_rec % dveg                       = model_config_rec % dveg 
 grid_config_rec % opt_crs                    = model_config_rec % opt_crs 
 grid_config_rec % opt_btr                    = model_config_rec % opt_btr 
 grid_config_rec % opt_run                    = model_config_rec % opt_run 
 grid_config_rec % opt_sfc                    = model_config_rec % opt_sfc 
 grid_config_rec % opt_frz                    = model_config_rec % opt_frz 
 grid_config_rec % opt_inf                    = model_config_rec % opt_inf 
 grid_config_rec % opt_rad                    = model_config_rec % opt_rad 
 grid_config_rec % opt_alb                    = model_config_rec % opt_alb 
 grid_config_rec % opt_snf                    = model_config_rec % opt_snf 
 grid_config_rec % opt_tbot                   = model_config_rec % opt_tbot 
 grid_config_rec % opt_stc                    = model_config_rec % opt_stc 
 grid_config_rec % opt_gla                    = model_config_rec % opt_gla 
 grid_config_rec % opt_rsf                    = model_config_rec % opt_rsf 
 grid_config_rec % opt_soil                   = model_config_rec % opt_soil 
 grid_config_rec % opt_pedo                   = model_config_rec % opt_pedo 
 grid_config_rec % opt_crop                   = model_config_rec % opt_crop 
 grid_config_rec % wtddt                      = model_config_rec % wtddt (id_id)
 grid_config_rec % wrf_hydro                  = model_config_rec % wrf_hydro 
 grid_config_rec % fgdt                       = model_config_rec % fgdt (id_id)
 grid_config_rec % fgdtzero                   = model_config_rec % fgdtzero (id_id)
 grid_config_rec % grid_fdda                  = model_config_rec % grid_fdda (id_id)
 grid_config_rec % grid_sfdda                 = model_config_rec % grid_sfdda (id_id)
 grid_config_rec % if_no_pbl_nudging_uv       = model_config_rec % if_no_pbl_nudging_uv (id_id)
 grid_config_rec % if_no_pbl_nudging_t        = model_config_rec % if_no_pbl_nudging_t (id_id)
 grid_config_rec % if_no_pbl_nudging_ph       = model_config_rec % if_no_pbl_nudging_ph (id_id)
 grid_config_rec % if_no_pbl_nudging_q        = model_config_rec % if_no_pbl_nudging_q (id_id)
 grid_config_rec % if_zfac_uv                 = model_config_rec % if_zfac_uv (id_id)
 grid_config_rec % k_zfac_uv                  = model_config_rec % k_zfac_uv (id_id)
 grid_config_rec % if_zfac_t                  = model_config_rec % if_zfac_t (id_id)
 grid_config_rec % k_zfac_t                   = model_config_rec % k_zfac_t (id_id)
 grid_config_rec % if_zfac_ph                 = model_config_rec % if_zfac_ph (id_id)
 grid_config_rec % k_zfac_ph                  = model_config_rec % k_zfac_ph (id_id)
 grid_config_rec % if_zfac_q                  = model_config_rec % if_zfac_q (id_id)
 grid_config_rec % k_zfac_q                   = model_config_rec % k_zfac_q (id_id)
 grid_config_rec % dk_zfac_uv                 = model_config_rec % dk_zfac_uv (id_id)
 grid_config_rec % dk_zfac_t                  = model_config_rec % dk_zfac_t (id_id)
 grid_config_rec % dk_zfac_ph                 = model_config_rec % dk_zfac_ph (id_id)
 grid_config_rec % dk_zfac_q                  = model_config_rec % dk_zfac_q (id_id)
 grid_config_rec % ktrop                      = model_config_rec % ktrop 
 grid_config_rec % guv                        = model_config_rec % guv (id_id)
 grid_config_rec % guv_sfc                    = model_config_rec % guv_sfc (id_id)
 grid_config_rec % gt                         = model_config_rec % gt (id_id)
 grid_config_rec % gt_sfc                     = model_config_rec % gt_sfc (id_id)
 grid_config_rec % gq                         = model_config_rec % gq (id_id)
 grid_config_rec % gq_sfc                     = model_config_rec % gq_sfc (id_id)
 grid_config_rec % gph                        = model_config_rec % gph (id_id)
 grid_config_rec % dtramp_min                 = model_config_rec % dtramp_min 
 grid_config_rec % if_ramping                 = model_config_rec % if_ramping 
 grid_config_rec % rinblw                     = model_config_rec % rinblw (id_id)
 grid_config_rec % xwavenum                   = model_config_rec % xwavenum (id_id)
 grid_config_rec % ywavenum                   = model_config_rec % ywavenum (id_id)
 grid_config_rec % pxlsm_soil_nudge           = model_config_rec % pxlsm_soil_nudge (id_id)
 grid_config_rec % fasdas                     = model_config_rec % fasdas (id_id)
 grid_config_rec % obs_nudge_opt              = model_config_rec % obs_nudge_opt (id_id)
 grid_config_rec % max_obs                    = model_config_rec % max_obs 
 grid_config_rec % fdda_start                 = model_config_rec % fdda_start (id_id)
 grid_config_rec % fdda_end                   = model_config_rec % fdda_end (id_id)
 grid_config_rec % obs_nudge_wind             = model_config_rec % obs_nudge_wind (id_id)
 grid_config_rec % obs_coef_wind              = model_config_rec % obs_coef_wind (id_id)
 grid_config_rec % obs_nudge_temp             = model_config_rec % obs_nudge_temp (id_id)
 grid_config_rec % obs_coef_temp              = model_config_rec % obs_coef_temp (id_id)
 grid_config_rec % obs_nudge_mois             = model_config_rec % obs_nudge_mois (id_id)
 grid_config_rec % obs_coef_mois              = model_config_rec % obs_coef_mois (id_id)
 grid_config_rec % obs_nudge_pstr             = model_config_rec % obs_nudge_pstr (id_id)
 grid_config_rec % obs_coef_pstr              = model_config_rec % obs_coef_pstr (id_id)
 grid_config_rec % obs_no_pbl_nudge_uv        = model_config_rec % obs_no_pbl_nudge_uv (id_id)
 grid_config_rec % obs_no_pbl_nudge_t         = model_config_rec % obs_no_pbl_nudge_t (id_id)
 grid_config_rec % obs_no_pbl_nudge_q         = model_config_rec % obs_no_pbl_nudge_q (id_id)
 grid_config_rec % obs_sfc_scheme_horiz       = model_config_rec % obs_sfc_scheme_horiz 
 grid_config_rec % obs_sfc_scheme_vert        = model_config_rec % obs_sfc_scheme_vert 
 grid_config_rec % obs_max_sndng_gap          = model_config_rec % obs_max_sndng_gap 
 grid_config_rec % obs_nudgezfullr1_uv        = model_config_rec % obs_nudgezfullr1_uv 
 grid_config_rec % obs_nudgezrampr1_uv        = model_config_rec % obs_nudgezrampr1_uv 
 grid_config_rec % obs_nudgezfullr2_uv        = model_config_rec % obs_nudgezfullr2_uv 
 grid_config_rec % obs_nudgezrampr2_uv        = model_config_rec % obs_nudgezrampr2_uv 
 grid_config_rec % obs_nudgezfullr4_uv        = model_config_rec % obs_nudgezfullr4_uv 
 grid_config_rec % obs_nudgezrampr4_uv        = model_config_rec % obs_nudgezrampr4_uv 
 grid_config_rec % obs_nudgezfullr1_t         = model_config_rec % obs_nudgezfullr1_t 
 grid_config_rec % obs_nudgezrampr1_t         = model_config_rec % obs_nudgezrampr1_t 
 grid_config_rec % obs_nudgezfullr2_t         = model_config_rec % obs_nudgezfullr2_t 
 grid_config_rec % obs_nudgezrampr2_t         = model_config_rec % obs_nudgezrampr2_t 
 grid_config_rec % obs_nudgezfullr4_t         = model_config_rec % obs_nudgezfullr4_t 
 grid_config_rec % obs_nudgezrampr4_t         = model_config_rec % obs_nudgezrampr4_t 
 grid_config_rec % obs_nudgezfullr1_q         = model_config_rec % obs_nudgezfullr1_q 
 grid_config_rec % obs_nudgezrampr1_q         = model_config_rec % obs_nudgezrampr1_q 
 grid_config_rec % obs_nudgezfullr2_q         = model_config_rec % obs_nudgezfullr2_q 
 grid_config_rec % obs_nudgezrampr2_q         = model_config_rec % obs_nudgezrampr2_q 
 grid_config_rec % obs_nudgezfullr4_q         = model_config_rec % obs_nudgezfullr4_q 
 grid_config_rec % obs_nudgezrampr4_q         = model_config_rec % obs_nudgezrampr4_q 
 grid_config_rec % obs_nudgezfullmin          = model_config_rec % obs_nudgezfullmin 
 grid_config_rec % obs_nudgezrampmin          = model_config_rec % obs_nudgezrampmin 
 grid_config_rec % obs_nudgezmax              = model_config_rec % obs_nudgezmax 
 grid_config_rec % obs_sfcfact                = model_config_rec % obs_sfcfact 
 grid_config_rec % obs_sfcfacr                = model_config_rec % obs_sfcfacr 
 grid_config_rec % obs_dpsmx                  = model_config_rec % obs_dpsmx 
 grid_config_rec % obs_rinxy                  = model_config_rec % obs_rinxy (id_id)
 grid_config_rec % obs_rinsig                 = model_config_rec % obs_rinsig 
 grid_config_rec % obs_twindo                 = model_config_rec % obs_twindo (id_id)
 grid_config_rec % obs_npfi                   = model_config_rec % obs_npfi 
 grid_config_rec % obs_ionf                   = model_config_rec % obs_ionf (id_id)
 grid_config_rec % obs_idynin                 = model_config_rec % obs_idynin 
 grid_config_rec % obs_dtramp                 = model_config_rec % obs_dtramp 
 grid_config_rec % obs_prt_max                = model_config_rec % obs_prt_max 
 grid_config_rec % obs_prt_freq               = model_config_rec % obs_prt_freq (id_id)
 grid_config_rec % obs_ipf_in4dob             = model_config_rec % obs_ipf_in4dob 
 grid_config_rec % obs_ipf_errob              = model_config_rec % obs_ipf_errob 
 grid_config_rec % obs_ipf_nudob              = model_config_rec % obs_ipf_nudob 
 grid_config_rec % obs_ipf_init               = model_config_rec % obs_ipf_init 
 grid_config_rec % obs_scl_neg_qv_innov       = model_config_rec % obs_scl_neg_qv_innov 
 grid_config_rec % scm_force                  = model_config_rec % scm_force 
 grid_config_rec % scm_force_dx               = model_config_rec % scm_force_dx 
 grid_config_rec % num_force_layers           = model_config_rec % num_force_layers 
 grid_config_rec % scm_lu_index               = model_config_rec % scm_lu_index 
 grid_config_rec % scm_isltyp                 = model_config_rec % scm_isltyp 
 grid_config_rec % scm_vegfra                 = model_config_rec % scm_vegfra 
 grid_config_rec % scm_canwat                 = model_config_rec % scm_canwat 
 grid_config_rec % scm_lat                    = model_config_rec % scm_lat 
 grid_config_rec % scm_lon                    = model_config_rec % scm_lon 
 grid_config_rec % scm_th_t_tend              = model_config_rec % scm_th_t_tend 
 grid_config_rec % scm_qv_t_tend              = model_config_rec % scm_qv_t_tend 
 grid_config_rec % scm_th_adv                 = model_config_rec % scm_th_adv 
 grid_config_rec % scm_wind_adv               = model_config_rec % scm_wind_adv 
 grid_config_rec % scm_qv_adv                 = model_config_rec % scm_qv_adv 
 grid_config_rec % scm_ql_adv                 = model_config_rec % scm_ql_adv 
 grid_config_rec % scm_vert_adv               = model_config_rec % scm_vert_adv 
 grid_config_rec % num_force_soil_layers      = model_config_rec % num_force_soil_layers 
 grid_config_rec % scm_soilt_force            = model_config_rec % scm_soilt_force 
 grid_config_rec % scm_soilq_force            = model_config_rec % scm_soilq_force 
 grid_config_rec % scm_force_th_largescale    = model_config_rec % scm_force_th_largescale 
 grid_config_rec % scm_force_qv_largescale    = model_config_rec % scm_force_qv_largescale 
 grid_config_rec % scm_force_ql_largescale    = model_config_rec % scm_force_ql_largescale 
 grid_config_rec % scm_force_wind_largescale  = model_config_rec % scm_force_wind_largescale 
 grid_config_rec % scm_force_skintemp         = model_config_rec % scm_force_skintemp 
 grid_config_rec % scm_force_flux             = model_config_rec % scm_force_flux 
 grid_config_rec % dyn_opt                    = model_config_rec % dyn_opt 
 grid_config_rec % rk_ord                     = model_config_rec % rk_ord 
 grid_config_rec % w_damping                  = model_config_rec % w_damping 
 grid_config_rec % diff_opt                   = model_config_rec % diff_opt (id_id)
 grid_config_rec % diff_opt_dfi               = model_config_rec % diff_opt_dfi (id_id)
 grid_config_rec % km_opt                     = model_config_rec % km_opt (id_id)
 grid_config_rec % km_opt_dfi                 = model_config_rec % km_opt_dfi (id_id)
 grid_config_rec % damp_opt                   = model_config_rec % damp_opt 
 grid_config_rec % rad_nudge                  = model_config_rec % rad_nudge 
 grid_config_rec % gwd_opt                    = model_config_rec % gwd_opt 
 grid_config_rec % max_rot_angle_gwd          = model_config_rec % max_rot_angle_gwd 
 grid_config_rec % zdamp                      = model_config_rec % zdamp (id_id)
 grid_config_rec % dampcoef                   = model_config_rec % dampcoef (id_id)
 grid_config_rec % khdif                      = model_config_rec % khdif (id_id)
 grid_config_rec % kvdif                      = model_config_rec % kvdif (id_id)
 grid_config_rec % diff_6th_factor            = model_config_rec % diff_6th_factor (id_id)
 grid_config_rec % diff_6th_opt               = model_config_rec % diff_6th_opt (id_id)
 grid_config_rec % diff_6th_slopeopt          = model_config_rec % diff_6th_slopeopt (id_id)
 grid_config_rec % diff_6th_thresh            = model_config_rec % diff_6th_thresh (id_id)
 grid_config_rec % use_theta_m                = model_config_rec % use_theta_m 
 grid_config_rec % use_q_diabatic             = model_config_rec % use_q_diabatic 
 grid_config_rec % c_s                        = model_config_rec % c_s (id_id)
 grid_config_rec % c_k                        = model_config_rec % c_k (id_id)
 grid_config_rec % smdiv                      = model_config_rec % smdiv (id_id)
 grid_config_rec % emdiv                      = model_config_rec % emdiv (id_id)
 grid_config_rec % epssm                      = model_config_rec % epssm (id_id)
 grid_config_rec % non_hydrostatic            = model_config_rec % non_hydrostatic (id_id)
 grid_config_rec % use_input_w                = model_config_rec % use_input_w 
 grid_config_rec % time_step_sound            = model_config_rec % time_step_sound (id_id)
 grid_config_rec % h_mom_adv_order            = model_config_rec % h_mom_adv_order (id_id)
 grid_config_rec % v_mom_adv_order            = model_config_rec % v_mom_adv_order (id_id)
 grid_config_rec % h_sca_adv_order            = model_config_rec % h_sca_adv_order (id_id)
 grid_config_rec % v_sca_adv_order            = model_config_rec % v_sca_adv_order (id_id)
 grid_config_rec % momentum_adv_opt           = model_config_rec % momentum_adv_opt (id_id)
 grid_config_rec % moist_adv_opt              = model_config_rec % moist_adv_opt (id_id)
 grid_config_rec % moist_adv_dfi_opt          = model_config_rec % moist_adv_dfi_opt (id_id)
 grid_config_rec % chem_adv_opt               = model_config_rec % chem_adv_opt (id_id)
 grid_config_rec % tracer_adv_opt             = model_config_rec % tracer_adv_opt (id_id)
 grid_config_rec % scalar_adv_opt             = model_config_rec % scalar_adv_opt (id_id)
 grid_config_rec % tke_adv_opt                = model_config_rec % tke_adv_opt (id_id)
 grid_config_rec % moist_mix2_off             = model_config_rec % moist_mix2_off (id_id)
 grid_config_rec % chem_mix2_off              = model_config_rec % chem_mix2_off (id_id)
 grid_config_rec % tracer_mix2_off            = model_config_rec % tracer_mix2_off (id_id)
 grid_config_rec % scalar_mix2_off            = model_config_rec % scalar_mix2_off (id_id)
 grid_config_rec % tke_mix2_off               = model_config_rec % tke_mix2_off (id_id)
 grid_config_rec % moist_mix6_off             = model_config_rec % moist_mix6_off (id_id)
 grid_config_rec % chem_mix6_off              = model_config_rec % chem_mix6_off (id_id)
 grid_config_rec % tracer_mix6_off            = model_config_rec % tracer_mix6_off (id_id)
 grid_config_rec % scalar_mix6_off            = model_config_rec % scalar_mix6_off (id_id)
 grid_config_rec % tke_mix6_off               = model_config_rec % tke_mix6_off (id_id)
 grid_config_rec % top_radiation              = model_config_rec % top_radiation (id_id)
 grid_config_rec % mix_isotropic              = model_config_rec % mix_isotropic (id_id)
 grid_config_rec % mix_upper_bound            = model_config_rec % mix_upper_bound (id_id)
 grid_config_rec % top_lid                    = model_config_rec % top_lid (id_id)
 grid_config_rec % tke_upper_bound            = model_config_rec % tke_upper_bound (id_id)
 grid_config_rec % tke_drag_coefficient       = model_config_rec % tke_drag_coefficient (id_id)
 grid_config_rec % tke_heat_flux              = model_config_rec % tke_heat_flux (id_id)
 grid_config_rec % pert_coriolis              = model_config_rec % pert_coriolis (id_id)
 grid_config_rec % coriolis2d                 = model_config_rec % coriolis2d (id_id)
 grid_config_rec % mix_full_fields            = model_config_rec % mix_full_fields (id_id)
 grid_config_rec % base_pres                  = model_config_rec % base_pres 
 grid_config_rec % base_temp                  = model_config_rec % base_temp 
 grid_config_rec % base_lapse                 = model_config_rec % base_lapse 
 grid_config_rec % iso_temp                   = model_config_rec % iso_temp 
 grid_config_rec % base_pres_strat            = model_config_rec % base_pres_strat 
 grid_config_rec % base_lapse_strat           = model_config_rec % base_lapse_strat 
 grid_config_rec % use_baseparam_fr_nml       = model_config_rec % use_baseparam_fr_nml 
 grid_config_rec % fft_filter_lat             = model_config_rec % fft_filter_lat 
 grid_config_rec % coupled_filtering          = model_config_rec % coupled_filtering 
 grid_config_rec % pos_def                    = model_config_rec % pos_def 
 grid_config_rec % swap_pole_with_next_j      = model_config_rec % swap_pole_with_next_j 
 grid_config_rec % actual_distance_average    = model_config_rec % actual_distance_average 
 grid_config_rec % rotated_pole               = model_config_rec % rotated_pole 
 grid_config_rec % do_coriolis                = model_config_rec % do_coriolis (id_id)
 grid_config_rec % do_curvature               = model_config_rec % do_curvature (id_id)
 grid_config_rec % do_gradp                   = model_config_rec % do_gradp (id_id)
 grid_config_rec % tracer_opt                 = model_config_rec % tracer_opt (id_id)
 grid_config_rec % tenddiag                   = model_config_rec % tenddiag (id_id)
 grid_config_rec % spec_bdy_width             = model_config_rec % spec_bdy_width 
 grid_config_rec % spec_zone                  = model_config_rec % spec_zone 
 grid_config_rec % relax_zone                 = model_config_rec % relax_zone 
 grid_config_rec % specified                  = model_config_rec % specified (id_id)
 grid_config_rec % constant_bc                = model_config_rec % constant_bc 
 grid_config_rec % periodic_x                 = model_config_rec % periodic_x (id_id)
 grid_config_rec % symmetric_xs               = model_config_rec % symmetric_xs (id_id)
 grid_config_rec % symmetric_xe               = model_config_rec % symmetric_xe (id_id)
 grid_config_rec % open_xs                    = model_config_rec % open_xs (id_id)
 grid_config_rec % open_xe                    = model_config_rec % open_xe (id_id)
 grid_config_rec % periodic_y                 = model_config_rec % periodic_y (id_id)
 grid_config_rec % symmetric_ys               = model_config_rec % symmetric_ys (id_id)
 grid_config_rec % symmetric_ye               = model_config_rec % symmetric_ye (id_id)
 grid_config_rec % open_ys                    = model_config_rec % open_ys (id_id)
 grid_config_rec % open_ye                    = model_config_rec % open_ye (id_id)
 grid_config_rec % polar                      = model_config_rec % polar (id_id)
 grid_config_rec % nested                     = model_config_rec % nested (id_id)
 grid_config_rec % spec_exp                   = model_config_rec % spec_exp 
 grid_config_rec % spec_bdy_final_mu          = model_config_rec % spec_bdy_final_mu 
 grid_config_rec % real_data_init_type        = model_config_rec % real_data_init_type 
 grid_config_rec % have_bcs_moist             = model_config_rec % have_bcs_moist (id_id)
 grid_config_rec % have_bcs_scalar            = model_config_rec % have_bcs_scalar (id_id)
 grid_config_rec % background_proc_id         = model_config_rec % background_proc_id 
 grid_config_rec % forecast_proc_id           = model_config_rec % forecast_proc_id 
 grid_config_rec % production_status          = model_config_rec % production_status 
 grid_config_rec % compression                = model_config_rec % compression 
 grid_config_rec % nobs_ndg_vars              = model_config_rec % nobs_ndg_vars 
 grid_config_rec % nobs_err_flds              = model_config_rec % nobs_err_flds 
 grid_config_rec % cen_lat                    = model_config_rec % cen_lat (id_id)
 grid_config_rec % cen_lon                    = model_config_rec % cen_lon (id_id)
 grid_config_rec % truelat1                   = model_config_rec % truelat1 (id_id)
 grid_config_rec % truelat2                   = model_config_rec % truelat2 (id_id)
 grid_config_rec % moad_cen_lat               = model_config_rec % moad_cen_lat (id_id)
 grid_config_rec % stand_lon                  = model_config_rec % stand_lon (id_id)
 grid_config_rec % pole_lat                   = model_config_rec % pole_lat (id_id)
 grid_config_rec % pole_lon                   = model_config_rec % pole_lon (id_id)
 grid_config_rec % flag_metgrid               = model_config_rec % flag_metgrid 
 grid_config_rec % flag_snow                  = model_config_rec % flag_snow 
 grid_config_rec % flag_psfc                  = model_config_rec % flag_psfc 
 grid_config_rec % flag_sm000010              = model_config_rec % flag_sm000010 
 grid_config_rec % flag_sm010040              = model_config_rec % flag_sm010040 
 grid_config_rec % flag_sm040100              = model_config_rec % flag_sm040100 
 grid_config_rec % flag_sm100200              = model_config_rec % flag_sm100200 
 grid_config_rec % flag_st000010              = model_config_rec % flag_st000010 
 grid_config_rec % flag_st010040              = model_config_rec % flag_st010040 
 grid_config_rec % flag_st040100              = model_config_rec % flag_st040100 
 grid_config_rec % flag_st100200              = model_config_rec % flag_st100200 
 grid_config_rec % flag_soil_layers           = model_config_rec % flag_soil_layers 
 grid_config_rec % flag_slp                   = model_config_rec % flag_slp 
 grid_config_rec % flag_soilhgt               = model_config_rec % flag_soilhgt 
 grid_config_rec % flag_mf_xy                 = model_config_rec % flag_mf_xy 
 grid_config_rec % flag_um_soil               = model_config_rec % flag_um_soil 
 grid_config_rec % bdyfrq                     = model_config_rec % bdyfrq (id_id)
 grid_config_rec % mminlu                     = model_config_rec % mminlu (id_id)
 grid_config_rec % iswater                    = model_config_rec % iswater (id_id)
 grid_config_rec % islake                     = model_config_rec % islake (id_id)
 grid_config_rec % isice                      = model_config_rec % isice (id_id)
 grid_config_rec % isurban                    = model_config_rec % isurban (id_id)
 grid_config_rec % isoilwater                 = model_config_rec % isoilwater (id_id)
 grid_config_rec % map_proj                   = model_config_rec % map_proj (id_id)
 grid_config_rec % use_wps_input              = model_config_rec % use_wps_input 
 grid_config_rec % dfi_stage                  = model_config_rec % dfi_stage (id_id)
 grid_config_rec % mp_physics_dfi             = model_config_rec % mp_physics_dfi (id_id)
 grid_config_rec % bl_pbl_physics_dfi         = model_config_rec % bl_pbl_physics_dfi (id_id)
 grid_config_rec % windfarm_opt               = model_config_rec % windfarm_opt (id_id)
 grid_config_rec % windfarm_ij                = model_config_rec % windfarm_ij 
 grid_config_rec % ideal_case                 = model_config_rec % ideal_case 
 grid_config_rec % hailcast_opt               = model_config_rec % hailcast_opt (id_id)
 grid_config_rec % haildt                     = model_config_rec % haildt (id_id)
 grid_config_rec % lightning_option           = model_config_rec % lightning_option (id_id)
 grid_config_rec % lightning_dt               = model_config_rec % lightning_dt (id_id)
 grid_config_rec % lightning_start_seconds    = model_config_rec % lightning_start_seconds (id_id)
 grid_config_rec % flashrate_factor           = model_config_rec % flashrate_factor (id_id)
 grid_config_rec % iccg_method                = model_config_rec % iccg_method (id_id)
 grid_config_rec % iccg_prescribed_num        = model_config_rec % iccg_prescribed_num (id_id)
 grid_config_rec % iccg_prescribed_den        = model_config_rec % iccg_prescribed_den (id_id)
 grid_config_rec % cellcount_method           = model_config_rec % cellcount_method (id_id)
 grid_config_rec % cldtop_adjustment          = model_config_rec % cldtop_adjustment (id_id)
 grid_config_rec % sf_lake_physics            = model_config_rec % sf_lake_physics (id_id)
 grid_config_rec % auxinput1_inname           = model_config_rec % auxinput1_inname 
 grid_config_rec % io_form_auxinput1          = model_config_rec % io_form_auxinput1 
 grid_config_rec % override_restart_timers    = model_config_rec % override_restart_timers 
 grid_config_rec % auxhist1_inname            = model_config_rec % auxhist1_inname 
 grid_config_rec % auxhist1_outname           = model_config_rec % auxhist1_outname 
 grid_config_rec % auxhist1_interval_y        = model_config_rec % auxhist1_interval_y (id_id)
 grid_config_rec % auxhist1_interval_d        = model_config_rec % auxhist1_interval_d (id_id)
 grid_config_rec % auxhist1_interval_h        = model_config_rec % auxhist1_interval_h (id_id)
 grid_config_rec % auxhist1_interval_m        = model_config_rec % auxhist1_interval_m (id_id)
 grid_config_rec % auxhist1_interval_s        = model_config_rec % auxhist1_interval_s (id_id)
 grid_config_rec % auxhist1_interval          = model_config_rec % auxhist1_interval (id_id)
 grid_config_rec % auxhist1_begin_y           = model_config_rec % auxhist1_begin_y (id_id)
 grid_config_rec % auxhist1_begin_d           = model_config_rec % auxhist1_begin_d (id_id)
 grid_config_rec % auxhist1_begin_h           = model_config_rec % auxhist1_begin_h (id_id)
 grid_config_rec % auxhist1_begin_m           = model_config_rec % auxhist1_begin_m (id_id)
 grid_config_rec % auxhist1_begin_s           = model_config_rec % auxhist1_begin_s (id_id)
 grid_config_rec % auxhist1_begin             = model_config_rec % auxhist1_begin (id_id)
 grid_config_rec % auxhist1_end_y             = model_config_rec % auxhist1_end_y (id_id)
 grid_config_rec % auxhist1_end_d             = model_config_rec % auxhist1_end_d (id_id)
 grid_config_rec % auxhist1_end_h             = model_config_rec % auxhist1_end_h (id_id)
 grid_config_rec % auxhist1_end_m             = model_config_rec % auxhist1_end_m (id_id)
 grid_config_rec % auxhist1_end_s             = model_config_rec % auxhist1_end_s (id_id)
 grid_config_rec % auxhist1_end               = model_config_rec % auxhist1_end (id_id)
 grid_config_rec % io_form_auxhist1           = model_config_rec % io_form_auxhist1 
 grid_config_rec % frames_per_auxhist1        = model_config_rec % frames_per_auxhist1 (id_id)
 grid_config_rec % auxhist2_inname            = model_config_rec % auxhist2_inname 
 grid_config_rec % auxhist2_outname           = model_config_rec % auxhist2_outname 
 grid_config_rec % auxhist2_interval_y        = model_config_rec % auxhist2_interval_y (id_id)
 grid_config_rec % auxhist2_interval_d        = model_config_rec % auxhist2_interval_d (id_id)
 grid_config_rec % auxhist2_interval_h        = model_config_rec % auxhist2_interval_h (id_id)
 grid_config_rec % auxhist2_interval_m        = model_config_rec % auxhist2_interval_m (id_id)
 grid_config_rec % auxhist2_interval_s        = model_config_rec % auxhist2_interval_s (id_id)
 grid_config_rec % auxhist2_interval          = model_config_rec % auxhist2_interval (id_id)
 grid_config_rec % auxhist2_begin_y           = model_config_rec % auxhist2_begin_y (id_id)
 grid_config_rec % auxhist2_begin_d           = model_config_rec % auxhist2_begin_d (id_id)
 grid_config_rec % auxhist2_begin_h           = model_config_rec % auxhist2_begin_h (id_id)
 grid_config_rec % auxhist2_begin_m           = model_config_rec % auxhist2_begin_m (id_id)
 grid_config_rec % auxhist2_begin_s           = model_config_rec % auxhist2_begin_s (id_id)
 grid_config_rec % auxhist2_begin             = model_config_rec % auxhist2_begin (id_id)
 grid_config_rec % auxhist2_end_y             = model_config_rec % auxhist2_end_y (id_id)
 grid_config_rec % auxhist2_end_d             = model_config_rec % auxhist2_end_d (id_id)
 grid_config_rec % auxhist2_end_h             = model_config_rec % auxhist2_end_h (id_id)
 grid_config_rec % auxhist2_end_m             = model_config_rec % auxhist2_end_m (id_id)
 grid_config_rec % auxhist2_end_s             = model_config_rec % auxhist2_end_s (id_id)
 grid_config_rec % auxhist2_end               = model_config_rec % auxhist2_end (id_id)
 grid_config_rec % io_form_auxhist2           = model_config_rec % io_form_auxhist2 
 grid_config_rec % frames_per_auxhist2        = model_config_rec % frames_per_auxhist2 (id_id)
 grid_config_rec % auxhist3_inname            = model_config_rec % auxhist3_inname 
 grid_config_rec % auxhist3_outname           = model_config_rec % auxhist3_outname 
 grid_config_rec % auxhist3_interval_y        = model_config_rec % auxhist3_interval_y (id_id)
 grid_config_rec % auxhist3_interval_d        = model_config_rec % auxhist3_interval_d (id_id)
 grid_config_rec % auxhist3_interval_h        = model_config_rec % auxhist3_interval_h (id_id)
 grid_config_rec % auxhist3_interval_m        = model_config_rec % auxhist3_interval_m (id_id)
 grid_config_rec % auxhist3_interval_s        = model_config_rec % auxhist3_interval_s (id_id)
 grid_config_rec % auxhist3_interval          = model_config_rec % auxhist3_interval (id_id)
 grid_config_rec % auxhist3_begin_y           = model_config_rec % auxhist3_begin_y (id_id)
 grid_config_rec % auxhist3_begin_d           = model_config_rec % auxhist3_begin_d (id_id)
 grid_config_rec % auxhist3_begin_h           = model_config_rec % auxhist3_begin_h (id_id)
 grid_config_rec % auxhist3_begin_m           = model_config_rec % auxhist3_begin_m (id_id)
 grid_config_rec % auxhist3_begin_s           = model_config_rec % auxhist3_begin_s (id_id)
 grid_config_rec % auxhist3_begin             = model_config_rec % auxhist3_begin (id_id)
 grid_config_rec % auxhist3_end_y             = model_config_rec % auxhist3_end_y (id_id)
 grid_config_rec % auxhist3_end_d             = model_config_rec % auxhist3_end_d (id_id)
 grid_config_rec % auxhist3_end_h             = model_config_rec % auxhist3_end_h (id_id)
 grid_config_rec % auxhist3_end_m             = model_config_rec % auxhist3_end_m (id_id)
 grid_config_rec % auxhist3_end_s             = model_config_rec % auxhist3_end_s (id_id)
 grid_config_rec % auxhist3_end               = model_config_rec % auxhist3_end (id_id)
 grid_config_rec % io_form_auxhist3           = model_config_rec % io_form_auxhist3 
 grid_config_rec % frames_per_auxhist3        = model_config_rec % frames_per_auxhist3 (id_id)
 grid_config_rec % auxhist4_inname            = model_config_rec % auxhist4_inname 
 grid_config_rec % auxhist4_outname           = model_config_rec % auxhist4_outname 
 grid_config_rec % auxhist4_interval_y        = model_config_rec % auxhist4_interval_y (id_id)
 grid_config_rec % auxhist4_interval_d        = model_config_rec % auxhist4_interval_d (id_id)
 grid_config_rec % auxhist4_interval_h        = model_config_rec % auxhist4_interval_h (id_id)
 grid_config_rec % auxhist4_interval_m        = model_config_rec % auxhist4_interval_m (id_id)
 grid_config_rec % auxhist4_interval_s        = model_config_rec % auxhist4_interval_s (id_id)
 grid_config_rec % auxhist4_interval          = model_config_rec % auxhist4_interval (id_id)
 grid_config_rec % auxhist4_begin_y           = model_config_rec % auxhist4_begin_y (id_id)
 grid_config_rec % auxhist4_begin_d           = model_config_rec % auxhist4_begin_d (id_id)
 grid_config_rec % auxhist4_begin_h           = model_config_rec % auxhist4_begin_h (id_id)
 grid_config_rec % auxhist4_begin_m           = model_config_rec % auxhist4_begin_m (id_id)
 grid_config_rec % auxhist4_begin_s           = model_config_rec % auxhist4_begin_s (id_id)
 grid_config_rec % auxhist4_begin             = model_config_rec % auxhist4_begin (id_id)
 grid_config_rec % auxhist4_end_y             = model_config_rec % auxhist4_end_y (id_id)
 grid_config_rec % auxhist4_end_d             = model_config_rec % auxhist4_end_d (id_id)
 grid_config_rec % auxhist4_end_h             = model_config_rec % auxhist4_end_h (id_id)
 grid_config_rec % auxhist4_end_m             = model_config_rec % auxhist4_end_m (id_id)
 grid_config_rec % auxhist4_end_s             = model_config_rec % auxhist4_end_s (id_id)
 grid_config_rec % auxhist4_end               = model_config_rec % auxhist4_end (id_id)
 grid_config_rec % io_form_auxhist4           = model_config_rec % io_form_auxhist4 
 grid_config_rec % frames_per_auxhist4        = model_config_rec % frames_per_auxhist4 (id_id)
 grid_config_rec % auxhist5_inname            = model_config_rec % auxhist5_inname 
 grid_config_rec % auxhist5_outname           = model_config_rec % auxhist5_outname 
 grid_config_rec % auxhist5_interval_y        = model_config_rec % auxhist5_interval_y (id_id)
 grid_config_rec % auxhist5_interval_d        = model_config_rec % auxhist5_interval_d (id_id)
 grid_config_rec % auxhist5_interval_h        = model_config_rec % auxhist5_interval_h (id_id)
 grid_config_rec % auxhist5_interval_m        = model_config_rec % auxhist5_interval_m (id_id)
 grid_config_rec % auxhist5_interval_s        = model_config_rec % auxhist5_interval_s (id_id)
 grid_config_rec % auxhist5_interval          = model_config_rec % auxhist5_interval (id_id)
 grid_config_rec % auxhist5_begin_y           = model_config_rec % auxhist5_begin_y (id_id)
 grid_config_rec % auxhist5_begin_d           = model_config_rec % auxhist5_begin_d (id_id)
 grid_config_rec % auxhist5_begin_h           = model_config_rec % auxhist5_begin_h (id_id)
 grid_config_rec % auxhist5_begin_m           = model_config_rec % auxhist5_begin_m (id_id)
 grid_config_rec % auxhist5_begin_s           = model_config_rec % auxhist5_begin_s (id_id)
 grid_config_rec % auxhist5_begin             = model_config_rec % auxhist5_begin (id_id)
 grid_config_rec % auxhist5_end_y             = model_config_rec % auxhist5_end_y (id_id)
 grid_config_rec % auxhist5_end_d             = model_config_rec % auxhist5_end_d (id_id)
 grid_config_rec % auxhist5_end_h             = model_config_rec % auxhist5_end_h (id_id)
 grid_config_rec % auxhist5_end_m             = model_config_rec % auxhist5_end_m (id_id)
 grid_config_rec % auxhist5_end_s             = model_config_rec % auxhist5_end_s (id_id)
 grid_config_rec % auxhist5_end               = model_config_rec % auxhist5_end (id_id)
 grid_config_rec % io_form_auxhist5           = model_config_rec % io_form_auxhist5 
 grid_config_rec % frames_per_auxhist5        = model_config_rec % frames_per_auxhist5 (id_id)
 grid_config_rec % auxhist6_inname            = model_config_rec % auxhist6_inname 
 grid_config_rec % auxhist6_outname           = model_config_rec % auxhist6_outname 
 grid_config_rec % auxhist6_interval_y        = model_config_rec % auxhist6_interval_y (id_id)
 grid_config_rec % auxhist6_interval_d        = model_config_rec % auxhist6_interval_d (id_id)
 grid_config_rec % auxhist6_interval_h        = model_config_rec % auxhist6_interval_h (id_id)
 grid_config_rec % auxhist6_interval_m        = model_config_rec % auxhist6_interval_m (id_id)
 grid_config_rec % auxhist6_interval_s        = model_config_rec % auxhist6_interval_s (id_id)
 grid_config_rec % auxhist6_interval          = model_config_rec % auxhist6_interval (id_id)
 grid_config_rec % auxhist6_begin_y           = model_config_rec % auxhist6_begin_y (id_id)
 grid_config_rec % auxhist6_begin_d           = model_config_rec % auxhist6_begin_d (id_id)
 grid_config_rec % auxhist6_begin_h           = model_config_rec % auxhist6_begin_h (id_id)
 grid_config_rec % auxhist6_begin_m           = model_config_rec % auxhist6_begin_m (id_id)
 grid_config_rec % auxhist6_begin_s           = model_config_rec % auxhist6_begin_s (id_id)
 grid_config_rec % auxhist6_begin             = model_config_rec % auxhist6_begin (id_id)
 grid_config_rec % auxhist6_end_y             = model_config_rec % auxhist6_end_y (id_id)
 grid_config_rec % auxhist6_end_d             = model_config_rec % auxhist6_end_d (id_id)
 grid_config_rec % auxhist6_end_h             = model_config_rec % auxhist6_end_h (id_id)
 grid_config_rec % auxhist6_end_m             = model_config_rec % auxhist6_end_m (id_id)
 grid_config_rec % auxhist6_end_s             = model_config_rec % auxhist6_end_s (id_id)
 grid_config_rec % auxhist6_end               = model_config_rec % auxhist6_end (id_id)
 grid_config_rec % io_form_auxhist6           = model_config_rec % io_form_auxhist6 
 grid_config_rec % frames_per_auxhist6        = model_config_rec % frames_per_auxhist6 (id_id)
 grid_config_rec % auxhist7_inname            = model_config_rec % auxhist7_inname 
 grid_config_rec % auxhist7_outname           = model_config_rec % auxhist7_outname 
 grid_config_rec % auxhist7_interval_y        = model_config_rec % auxhist7_interval_y (id_id)
 grid_config_rec % auxhist7_interval_d        = model_config_rec % auxhist7_interval_d (id_id)
 grid_config_rec % auxhist7_interval_h        = model_config_rec % auxhist7_interval_h (id_id)
 grid_config_rec % auxhist7_interval_m        = model_config_rec % auxhist7_interval_m (id_id)
 grid_config_rec % auxhist7_interval_s        = model_config_rec % auxhist7_interval_s (id_id)
 grid_config_rec % auxhist7_interval          = model_config_rec % auxhist7_interval (id_id)
 grid_config_rec % auxhist7_begin_y           = model_config_rec % auxhist7_begin_y (id_id)
 grid_config_rec % auxhist7_begin_d           = model_config_rec % auxhist7_begin_d (id_id)
 grid_config_rec % auxhist7_begin_h           = model_config_rec % auxhist7_begin_h (id_id)
 grid_config_rec % auxhist7_begin_m           = model_config_rec % auxhist7_begin_m (id_id)
 grid_config_rec % auxhist7_begin_s           = model_config_rec % auxhist7_begin_s (id_id)
 grid_config_rec % auxhist7_begin             = model_config_rec % auxhist7_begin (id_id)
 grid_config_rec % auxhist7_end_y             = model_config_rec % auxhist7_end_y (id_id)
 grid_config_rec % auxhist7_end_d             = model_config_rec % auxhist7_end_d (id_id)
 grid_config_rec % auxhist7_end_h             = model_config_rec % auxhist7_end_h (id_id)
 grid_config_rec % auxhist7_end_m             = model_config_rec % auxhist7_end_m (id_id)
 grid_config_rec % auxhist7_end_s             = model_config_rec % auxhist7_end_s (id_id)
 grid_config_rec % auxhist7_end               = model_config_rec % auxhist7_end (id_id)
 grid_config_rec % io_form_auxhist7           = model_config_rec % io_form_auxhist7 
 grid_config_rec % frames_per_auxhist7        = model_config_rec % frames_per_auxhist7 (id_id)
 grid_config_rec % auxhist8_inname            = model_config_rec % auxhist8_inname 
 grid_config_rec % auxhist8_outname           = model_config_rec % auxhist8_outname 
 grid_config_rec % auxhist8_interval_y        = model_config_rec % auxhist8_interval_y (id_id)
 grid_config_rec % auxhist8_interval_d        = model_config_rec % auxhist8_interval_d (id_id)
 grid_config_rec % auxhist8_interval_h        = model_config_rec % auxhist8_interval_h (id_id)
 grid_config_rec % auxhist8_interval_m        = model_config_rec % auxhist8_interval_m (id_id)
 grid_config_rec % auxhist8_interval_s        = model_config_rec % auxhist8_interval_s (id_id)
 grid_config_rec % auxhist8_interval          = model_config_rec % auxhist8_interval (id_id)
 grid_config_rec % auxhist8_begin_y           = model_config_rec % auxhist8_begin_y (id_id)
 grid_config_rec % auxhist8_begin_d           = model_config_rec % auxhist8_begin_d (id_id)
 grid_config_rec % auxhist8_begin_h           = model_config_rec % auxhist8_begin_h (id_id)
 grid_config_rec % auxhist8_begin_m           = model_config_rec % auxhist8_begin_m (id_id)
 grid_config_rec % auxhist8_begin_s           = model_config_rec % auxhist8_begin_s (id_id)
 grid_config_rec % auxhist8_begin             = model_config_rec % auxhist8_begin (id_id)
 grid_config_rec % auxhist8_end_y             = model_config_rec % auxhist8_end_y (id_id)
 grid_config_rec % auxhist8_end_d             = model_config_rec % auxhist8_end_d (id_id)
 grid_config_rec % auxhist8_end_h             = model_config_rec % auxhist8_end_h (id_id)
 grid_config_rec % auxhist8_end_m             = model_config_rec % auxhist8_end_m (id_id)
 grid_config_rec % auxhist8_end_s             = model_config_rec % auxhist8_end_s (id_id)
 grid_config_rec % auxhist8_end               = model_config_rec % auxhist8_end (id_id)
 grid_config_rec % io_form_auxhist8           = model_config_rec % io_form_auxhist8 
 grid_config_rec % frames_per_auxhist8        = model_config_rec % frames_per_auxhist8 (id_id)
 grid_config_rec % auxhist9_inname            = model_config_rec % auxhist9_inname 
 grid_config_rec % auxhist9_outname           = model_config_rec % auxhist9_outname 
 grid_config_rec % auxhist9_interval_y        = model_config_rec % auxhist9_interval_y (id_id)
 grid_config_rec % auxhist9_interval_d        = model_config_rec % auxhist9_interval_d (id_id)
 grid_config_rec % auxhist9_interval_h        = model_config_rec % auxhist9_interval_h (id_id)
 grid_config_rec % auxhist9_interval_m        = model_config_rec % auxhist9_interval_m (id_id)
 grid_config_rec % auxhist9_interval_s        = model_config_rec % auxhist9_interval_s (id_id)
 grid_config_rec % auxhist9_interval          = model_config_rec % auxhist9_interval (id_id)
 grid_config_rec % auxhist9_begin_y           = model_config_rec % auxhist9_begin_y (id_id)
 grid_config_rec % auxhist9_begin_d           = model_config_rec % auxhist9_begin_d (id_id)
 grid_config_rec % auxhist9_begin_h           = model_config_rec % auxhist9_begin_h (id_id)
 grid_config_rec % auxhist9_begin_m           = model_config_rec % auxhist9_begin_m (id_id)
 grid_config_rec % auxhist9_begin_s           = model_config_rec % auxhist9_begin_s (id_id)
 grid_config_rec % auxhist9_begin             = model_config_rec % auxhist9_begin (id_id)
 grid_config_rec % auxhist9_end_y             = model_config_rec % auxhist9_end_y (id_id)
 grid_config_rec % auxhist9_end_d             = model_config_rec % auxhist9_end_d (id_id)
 grid_config_rec % auxhist9_end_h             = model_config_rec % auxhist9_end_h (id_id)
 grid_config_rec % auxhist9_end_m             = model_config_rec % auxhist9_end_m (id_id)
 grid_config_rec % auxhist9_end_s             = model_config_rec % auxhist9_end_s (id_id)
 grid_config_rec % auxhist9_end               = model_config_rec % auxhist9_end (id_id)
 grid_config_rec % io_form_auxhist9           = model_config_rec % io_form_auxhist9 
 grid_config_rec % frames_per_auxhist9        = model_config_rec % frames_per_auxhist9 (id_id)
 grid_config_rec % auxhist10_inname           = model_config_rec % auxhist10_inname 
 grid_config_rec % auxhist10_outname          = model_config_rec % auxhist10_outname 
 grid_config_rec % auxhist10_interval_y       = model_config_rec % auxhist10_interval_y (id_id)
 grid_config_rec % auxhist10_interval_d       = model_config_rec % auxhist10_interval_d (id_id)
 grid_config_rec % auxhist10_interval_h       = model_config_rec % auxhist10_interval_h (id_id)
 grid_config_rec % auxhist10_interval_m       = model_config_rec % auxhist10_interval_m (id_id)
 grid_config_rec % auxhist10_interval_s       = model_config_rec % auxhist10_interval_s (id_id)
 grid_config_rec % auxhist10_interval         = model_config_rec % auxhist10_interval (id_id)
 grid_config_rec % auxhist10_begin_y          = model_config_rec % auxhist10_begin_y (id_id)
 grid_config_rec % auxhist10_begin_d          = model_config_rec % auxhist10_begin_d (id_id)
 grid_config_rec % auxhist10_begin_h          = model_config_rec % auxhist10_begin_h (id_id)
 grid_config_rec % auxhist10_begin_m          = model_config_rec % auxhist10_begin_m (id_id)
 grid_config_rec % auxhist10_begin_s          = model_config_rec % auxhist10_begin_s (id_id)
 grid_config_rec % auxhist10_begin            = model_config_rec % auxhist10_begin (id_id)
 grid_config_rec % auxhist10_end_y            = model_config_rec % auxhist10_end_y (id_id)
 grid_config_rec % auxhist10_end_d            = model_config_rec % auxhist10_end_d (id_id)
 grid_config_rec % auxhist10_end_h            = model_config_rec % auxhist10_end_h (id_id)
 grid_config_rec % auxhist10_end_m            = model_config_rec % auxhist10_end_m (id_id)
 grid_config_rec % auxhist10_end_s            = model_config_rec % auxhist10_end_s (id_id)
 grid_config_rec % auxhist10_end              = model_config_rec % auxhist10_end (id_id)
 grid_config_rec % io_form_auxhist10          = model_config_rec % io_form_auxhist10 
 grid_config_rec % frames_per_auxhist10       = model_config_rec % frames_per_auxhist10 (id_id)
 grid_config_rec % auxhist11_inname           = model_config_rec % auxhist11_inname 
 grid_config_rec % auxhist11_outname          = model_config_rec % auxhist11_outname 
 grid_config_rec % auxhist11_interval_y       = model_config_rec % auxhist11_interval_y (id_id)
 grid_config_rec % auxhist11_interval_d       = model_config_rec % auxhist11_interval_d (id_id)
 grid_config_rec % auxhist11_interval_h       = model_config_rec % auxhist11_interval_h (id_id)
 grid_config_rec % auxhist11_interval_m       = model_config_rec % auxhist11_interval_m (id_id)
 grid_config_rec % auxhist11_interval_s       = model_config_rec % auxhist11_interval_s (id_id)
 grid_config_rec % auxhist11_interval         = model_config_rec % auxhist11_interval (id_id)
 grid_config_rec % auxhist11_begin_y          = model_config_rec % auxhist11_begin_y (id_id)
 grid_config_rec % auxhist11_begin_d          = model_config_rec % auxhist11_begin_d (id_id)
 grid_config_rec % auxhist11_begin_h          = model_config_rec % auxhist11_begin_h (id_id)
 grid_config_rec % auxhist11_begin_m          = model_config_rec % auxhist11_begin_m (id_id)
 grid_config_rec % auxhist11_begin_s          = model_config_rec % auxhist11_begin_s (id_id)
 grid_config_rec % auxhist11_begin            = model_config_rec % auxhist11_begin (id_id)
 grid_config_rec % auxhist11_end_y            = model_config_rec % auxhist11_end_y (id_id)
 grid_config_rec % auxhist11_end_d            = model_config_rec % auxhist11_end_d (id_id)
 grid_config_rec % auxhist11_end_h            = model_config_rec % auxhist11_end_h (id_id)
 grid_config_rec % auxhist11_end_m            = model_config_rec % auxhist11_end_m (id_id)
 grid_config_rec % auxhist11_end_s            = model_config_rec % auxhist11_end_s (id_id)
 grid_config_rec % auxhist11_end              = model_config_rec % auxhist11_end (id_id)
 grid_config_rec % io_form_auxhist11          = model_config_rec % io_form_auxhist11 
 grid_config_rec % frames_per_auxhist11       = model_config_rec % frames_per_auxhist11 (id_id)
 grid_config_rec % auxhist12_inname           = model_config_rec % auxhist12_inname 
 grid_config_rec % auxhist12_outname          = model_config_rec % auxhist12_outname 
 grid_config_rec % auxhist12_interval_y       = model_config_rec % auxhist12_interval_y (id_id)
 grid_config_rec % auxhist12_interval_d       = model_config_rec % auxhist12_interval_d (id_id)
 grid_config_rec % auxhist12_interval_h       = model_config_rec % auxhist12_interval_h (id_id)
 grid_config_rec % auxhist12_interval_m       = model_config_rec % auxhist12_interval_m (id_id)
 grid_config_rec % auxhist12_interval_s       = model_config_rec % auxhist12_interval_s (id_id)
 grid_config_rec % auxhist12_interval         = model_config_rec % auxhist12_interval (id_id)
 grid_config_rec % auxhist12_begin_y          = model_config_rec % auxhist12_begin_y (id_id)
 grid_config_rec % auxhist12_begin_d          = model_config_rec % auxhist12_begin_d (id_id)
 grid_config_rec % auxhist12_begin_h          = model_config_rec % auxhist12_begin_h (id_id)
 grid_config_rec % auxhist12_begin_m          = model_config_rec % auxhist12_begin_m (id_id)
 grid_config_rec % auxhist12_begin_s          = model_config_rec % auxhist12_begin_s (id_id)
 grid_config_rec % auxhist12_begin            = model_config_rec % auxhist12_begin (id_id)
 grid_config_rec % auxhist12_end_y            = model_config_rec % auxhist12_end_y (id_id)
 grid_config_rec % auxhist12_end_d            = model_config_rec % auxhist12_end_d (id_id)
 grid_config_rec % auxhist12_end_h            = model_config_rec % auxhist12_end_h (id_id)
 grid_config_rec % auxhist12_end_m            = model_config_rec % auxhist12_end_m (id_id)
 grid_config_rec % auxhist12_end_s            = model_config_rec % auxhist12_end_s (id_id)
 grid_config_rec % auxhist12_end              = model_config_rec % auxhist12_end (id_id)
 grid_config_rec % io_form_auxhist12          = model_config_rec % io_form_auxhist12 
 grid_config_rec % frames_per_auxhist12       = model_config_rec % frames_per_auxhist12 (id_id)
 grid_config_rec % auxhist13_inname           = model_config_rec % auxhist13_inname 
 grid_config_rec % auxhist13_outname          = model_config_rec % auxhist13_outname 
 grid_config_rec % auxhist13_interval_y       = model_config_rec % auxhist13_interval_y (id_id)
 grid_config_rec % auxhist13_interval_d       = model_config_rec % auxhist13_interval_d (id_id)
 grid_config_rec % auxhist13_interval_h       = model_config_rec % auxhist13_interval_h (id_id)
 grid_config_rec % auxhist13_interval_m       = model_config_rec % auxhist13_interval_m (id_id)
 grid_config_rec % auxhist13_interval_s       = model_config_rec % auxhist13_interval_s (id_id)
 grid_config_rec % auxhist13_interval         = model_config_rec % auxhist13_interval (id_id)
 grid_config_rec % auxhist13_begin_y          = model_config_rec % auxhist13_begin_y (id_id)
 grid_config_rec % auxhist13_begin_d          = model_config_rec % auxhist13_begin_d (id_id)
 grid_config_rec % auxhist13_begin_h          = model_config_rec % auxhist13_begin_h (id_id)
 grid_config_rec % auxhist13_begin_m          = model_config_rec % auxhist13_begin_m (id_id)
 grid_config_rec % auxhist13_begin_s          = model_config_rec % auxhist13_begin_s (id_id)
 grid_config_rec % auxhist13_begin            = model_config_rec % auxhist13_begin (id_id)
 grid_config_rec % auxhist13_end_y            = model_config_rec % auxhist13_end_y (id_id)
 grid_config_rec % auxhist13_end_d            = model_config_rec % auxhist13_end_d (id_id)
 grid_config_rec % auxhist13_end_h            = model_config_rec % auxhist13_end_h (id_id)
 grid_config_rec % auxhist13_end_m            = model_config_rec % auxhist13_end_m (id_id)
 grid_config_rec % auxhist13_end_s            = model_config_rec % auxhist13_end_s (id_id)
 grid_config_rec % auxhist13_end              = model_config_rec % auxhist13_end (id_id)
 grid_config_rec % io_form_auxhist13          = model_config_rec % io_form_auxhist13 
 grid_config_rec % frames_per_auxhist13       = model_config_rec % frames_per_auxhist13 (id_id)
 grid_config_rec % auxhist14_inname           = model_config_rec % auxhist14_inname 
 grid_config_rec % auxhist14_outname          = model_config_rec % auxhist14_outname 
 grid_config_rec % auxhist14_interval_y       = model_config_rec % auxhist14_interval_y (id_id)
 grid_config_rec % auxhist14_interval_d       = model_config_rec % auxhist14_interval_d (id_id)
 grid_config_rec % auxhist14_interval_h       = model_config_rec % auxhist14_interval_h (id_id)
 grid_config_rec % auxhist14_interval_m       = model_config_rec % auxhist14_interval_m (id_id)
 grid_config_rec % auxhist14_interval_s       = model_config_rec % auxhist14_interval_s (id_id)
 grid_config_rec % auxhist14_interval         = model_config_rec % auxhist14_interval (id_id)
 grid_config_rec % auxhist14_begin_y          = model_config_rec % auxhist14_begin_y (id_id)
 grid_config_rec % auxhist14_begin_d          = model_config_rec % auxhist14_begin_d (id_id)
 grid_config_rec % auxhist14_begin_h          = model_config_rec % auxhist14_begin_h (id_id)
 grid_config_rec % auxhist14_begin_m          = model_config_rec % auxhist14_begin_m (id_id)
 grid_config_rec % auxhist14_begin_s          = model_config_rec % auxhist14_begin_s (id_id)
 grid_config_rec % auxhist14_begin            = model_config_rec % auxhist14_begin (id_id)
 grid_config_rec % auxhist14_end_y            = model_config_rec % auxhist14_end_y (id_id)
 grid_config_rec % auxhist14_end_d            = model_config_rec % auxhist14_end_d (id_id)
 grid_config_rec % auxhist14_end_h            = model_config_rec % auxhist14_end_h (id_id)
 grid_config_rec % auxhist14_end_m            = model_config_rec % auxhist14_end_m (id_id)
 grid_config_rec % auxhist14_end_s            = model_config_rec % auxhist14_end_s (id_id)
 grid_config_rec % auxhist14_end              = model_config_rec % auxhist14_end (id_id)
 grid_config_rec % io_form_auxhist14          = model_config_rec % io_form_auxhist14 
 grid_config_rec % frames_per_auxhist14       = model_config_rec % frames_per_auxhist14 (id_id)
 grid_config_rec % auxhist15_inname           = model_config_rec % auxhist15_inname 
 grid_config_rec % auxhist15_outname          = model_config_rec % auxhist15_outname 
 grid_config_rec % auxhist15_interval_y       = model_config_rec % auxhist15_interval_y (id_id)
 grid_config_rec % auxhist15_interval_d       = model_config_rec % auxhist15_interval_d (id_id)
 grid_config_rec % auxhist15_interval_h       = model_config_rec % auxhist15_interval_h (id_id)
 grid_config_rec % auxhist15_interval_m       = model_config_rec % auxhist15_interval_m (id_id)
 grid_config_rec % auxhist15_interval_s       = model_config_rec % auxhist15_interval_s (id_id)
 grid_config_rec % auxhist15_interval         = model_config_rec % auxhist15_interval (id_id)
 grid_config_rec % auxhist15_begin_y          = model_config_rec % auxhist15_begin_y (id_id)
 grid_config_rec % auxhist15_begin_d          = model_config_rec % auxhist15_begin_d (id_id)
 grid_config_rec % auxhist15_begin_h          = model_config_rec % auxhist15_begin_h (id_id)
 grid_config_rec % auxhist15_begin_m          = model_config_rec % auxhist15_begin_m (id_id)
 grid_config_rec % auxhist15_begin_s          = model_config_rec % auxhist15_begin_s (id_id)
 grid_config_rec % auxhist15_begin            = model_config_rec % auxhist15_begin (id_id)
 grid_config_rec % auxhist15_end_y            = model_config_rec % auxhist15_end_y (id_id)
 grid_config_rec % auxhist15_end_d            = model_config_rec % auxhist15_end_d (id_id)
 grid_config_rec % auxhist15_end_h            = model_config_rec % auxhist15_end_h (id_id)
 grid_config_rec % auxhist15_end_m            = model_config_rec % auxhist15_end_m (id_id)
 grid_config_rec % auxhist15_end_s            = model_config_rec % auxhist15_end_s (id_id)
 grid_config_rec % auxhist15_end              = model_config_rec % auxhist15_end (id_id)
 grid_config_rec % io_form_auxhist15          = model_config_rec % io_form_auxhist15 
 grid_config_rec % frames_per_auxhist15       = model_config_rec % frames_per_auxhist15 (id_id)
 grid_config_rec % auxhist16_inname           = model_config_rec % auxhist16_inname 
 grid_config_rec % auxhist16_outname          = model_config_rec % auxhist16_outname 
 grid_config_rec % auxhist16_interval_y       = model_config_rec % auxhist16_interval_y (id_id)
 grid_config_rec % auxhist16_interval_d       = model_config_rec % auxhist16_interval_d (id_id)
 grid_config_rec % auxhist16_interval_h       = model_config_rec % auxhist16_interval_h (id_id)
 grid_config_rec % auxhist16_interval_m       = model_config_rec % auxhist16_interval_m (id_id)
 grid_config_rec % auxhist16_interval_s       = model_config_rec % auxhist16_interval_s (id_id)
 grid_config_rec % auxhist16_interval         = model_config_rec % auxhist16_interval (id_id)
 grid_config_rec % auxhist16_begin_y          = model_config_rec % auxhist16_begin_y (id_id)
 grid_config_rec % auxhist16_begin_d          = model_config_rec % auxhist16_begin_d (id_id)
 grid_config_rec % auxhist16_begin_h          = model_config_rec % auxhist16_begin_h (id_id)
 grid_config_rec % auxhist16_begin_m          = model_config_rec % auxhist16_begin_m (id_id)
 grid_config_rec % auxhist16_begin_s          = model_config_rec % auxhist16_begin_s (id_id)
 grid_config_rec % auxhist16_begin            = model_config_rec % auxhist16_begin (id_id)
 grid_config_rec % auxhist16_end_y            = model_config_rec % auxhist16_end_y (id_id)
 grid_config_rec % auxhist16_end_d            = model_config_rec % auxhist16_end_d (id_id)
 grid_config_rec % auxhist16_end_h            = model_config_rec % auxhist16_end_h (id_id)
 grid_config_rec % auxhist16_end_m            = model_config_rec % auxhist16_end_m (id_id)
 grid_config_rec % auxhist16_end_s            = model_config_rec % auxhist16_end_s (id_id)
 grid_config_rec % auxhist16_end              = model_config_rec % auxhist16_end (id_id)
 grid_config_rec % io_form_auxhist16          = model_config_rec % io_form_auxhist16 
 grid_config_rec % frames_per_auxhist16       = model_config_rec % frames_per_auxhist16 (id_id)
 grid_config_rec % auxhist17_inname           = model_config_rec % auxhist17_inname 
 grid_config_rec % auxhist17_outname          = model_config_rec % auxhist17_outname 
 grid_config_rec % auxhist17_interval_y       = model_config_rec % auxhist17_interval_y (id_id)
 grid_config_rec % auxhist17_interval_d       = model_config_rec % auxhist17_interval_d (id_id)
 grid_config_rec % auxhist17_interval_h       = model_config_rec % auxhist17_interval_h (id_id)
 grid_config_rec % auxhist17_interval_m       = model_config_rec % auxhist17_interval_m (id_id)
 grid_config_rec % auxhist17_interval_s       = model_config_rec % auxhist17_interval_s (id_id)
 grid_config_rec % auxhist17_interval         = model_config_rec % auxhist17_interval (id_id)
 grid_config_rec % auxhist17_begin_y          = model_config_rec % auxhist17_begin_y (id_id)
 grid_config_rec % auxhist17_begin_d          = model_config_rec % auxhist17_begin_d (id_id)
 grid_config_rec % auxhist17_begin_h          = model_config_rec % auxhist17_begin_h (id_id)
 grid_config_rec % auxhist17_begin_m          = model_config_rec % auxhist17_begin_m (id_id)
 grid_config_rec % auxhist17_begin_s          = model_config_rec % auxhist17_begin_s (id_id)
 grid_config_rec % auxhist17_begin            = model_config_rec % auxhist17_begin (id_id)
 grid_config_rec % auxhist17_end_y            = model_config_rec % auxhist17_end_y (id_id)
 grid_config_rec % auxhist17_end_d            = model_config_rec % auxhist17_end_d (id_id)
 grid_config_rec % auxhist17_end_h            = model_config_rec % auxhist17_end_h (id_id)
 grid_config_rec % auxhist17_end_m            = model_config_rec % auxhist17_end_m (id_id)
 grid_config_rec % auxhist17_end_s            = model_config_rec % auxhist17_end_s (id_id)
 grid_config_rec % auxhist17_end              = model_config_rec % auxhist17_end (id_id)
 grid_config_rec % io_form_auxhist17          = model_config_rec % io_form_auxhist17 
 grid_config_rec % frames_per_auxhist17       = model_config_rec % frames_per_auxhist17 (id_id)
 grid_config_rec % auxhist18_inname           = model_config_rec % auxhist18_inname 
 grid_config_rec % auxhist18_outname          = model_config_rec % auxhist18_outname 
 grid_config_rec % auxhist18_interval_y       = model_config_rec % auxhist18_interval_y (id_id)
 grid_config_rec % auxhist18_interval_d       = model_config_rec % auxhist18_interval_d (id_id)
 grid_config_rec % auxhist18_interval_h       = model_config_rec % auxhist18_interval_h (id_id)
 grid_config_rec % auxhist18_interval_m       = model_config_rec % auxhist18_interval_m (id_id)
 grid_config_rec % auxhist18_interval_s       = model_config_rec % auxhist18_interval_s (id_id)
 grid_config_rec % auxhist18_interval         = model_config_rec % auxhist18_interval (id_id)
 grid_config_rec % auxhist18_begin_y          = model_config_rec % auxhist18_begin_y (id_id)
 grid_config_rec % auxhist18_begin_d          = model_config_rec % auxhist18_begin_d (id_id)
 grid_config_rec % auxhist18_begin_h          = model_config_rec % auxhist18_begin_h (id_id)
 grid_config_rec % auxhist18_begin_m          = model_config_rec % auxhist18_begin_m (id_id)
 grid_config_rec % auxhist18_begin_s          = model_config_rec % auxhist18_begin_s (id_id)
 grid_config_rec % auxhist18_begin            = model_config_rec % auxhist18_begin (id_id)
 grid_config_rec % auxhist18_end_y            = model_config_rec % auxhist18_end_y (id_id)
 grid_config_rec % auxhist18_end_d            = model_config_rec % auxhist18_end_d (id_id)
 grid_config_rec % auxhist18_end_h            = model_config_rec % auxhist18_end_h (id_id)
 grid_config_rec % auxhist18_end_m            = model_config_rec % auxhist18_end_m (id_id)
 grid_config_rec % auxhist18_end_s            = model_config_rec % auxhist18_end_s (id_id)
 grid_config_rec % auxhist18_end              = model_config_rec % auxhist18_end (id_id)
 grid_config_rec % io_form_auxhist18          = model_config_rec % io_form_auxhist18 
 grid_config_rec % frames_per_auxhist18       = model_config_rec % frames_per_auxhist18 (id_id)
 grid_config_rec % auxhist19_inname           = model_config_rec % auxhist19_inname 
 grid_config_rec % auxhist19_outname          = model_config_rec % auxhist19_outname 
 grid_config_rec % auxhist19_interval_y       = model_config_rec % auxhist19_interval_y (id_id)
 grid_config_rec % auxhist19_interval_d       = model_config_rec % auxhist19_interval_d (id_id)
 grid_config_rec % auxhist19_interval_h       = model_config_rec % auxhist19_interval_h (id_id)
 grid_config_rec % auxhist19_interval_m       = model_config_rec % auxhist19_interval_m (id_id)
 grid_config_rec % auxhist19_interval_s       = model_config_rec % auxhist19_interval_s (id_id)
 grid_config_rec % auxhist19_interval         = model_config_rec % auxhist19_interval (id_id)
 grid_config_rec % auxhist19_begin_y          = model_config_rec % auxhist19_begin_y (id_id)
 grid_config_rec % auxhist19_begin_d          = model_config_rec % auxhist19_begin_d (id_id)
 grid_config_rec % auxhist19_begin_h          = model_config_rec % auxhist19_begin_h (id_id)
 grid_config_rec % auxhist19_begin_m          = model_config_rec % auxhist19_begin_m (id_id)
 grid_config_rec % auxhist19_begin_s          = model_config_rec % auxhist19_begin_s (id_id)
 grid_config_rec % auxhist19_begin            = model_config_rec % auxhist19_begin (id_id)
 grid_config_rec % auxhist19_end_y            = model_config_rec % auxhist19_end_y (id_id)
 grid_config_rec % auxhist19_end_d            = model_config_rec % auxhist19_end_d (id_id)
 grid_config_rec % auxhist19_end_h            = model_config_rec % auxhist19_end_h (id_id)
 grid_config_rec % auxhist19_end_m            = model_config_rec % auxhist19_end_m (id_id)
 grid_config_rec % auxhist19_end_s            = model_config_rec % auxhist19_end_s (id_id)
 grid_config_rec % auxhist19_end              = model_config_rec % auxhist19_end (id_id)
 grid_config_rec % io_form_auxhist19          = model_config_rec % io_form_auxhist19 
 grid_config_rec % frames_per_auxhist19       = model_config_rec % frames_per_auxhist19 (id_id)
 grid_config_rec % auxhist20_inname           = model_config_rec % auxhist20_inname 
 grid_config_rec % auxhist20_outname          = model_config_rec % auxhist20_outname 
 grid_config_rec % auxhist20_interval_y       = model_config_rec % auxhist20_interval_y (id_id)
 grid_config_rec % auxhist20_interval_d       = model_config_rec % auxhist20_interval_d (id_id)
 grid_config_rec % auxhist20_interval_h       = model_config_rec % auxhist20_interval_h (id_id)
 grid_config_rec % auxhist20_interval_m       = model_config_rec % auxhist20_interval_m (id_id)
 grid_config_rec % auxhist20_interval_s       = model_config_rec % auxhist20_interval_s (id_id)
 grid_config_rec % auxhist20_interval         = model_config_rec % auxhist20_interval (id_id)
 grid_config_rec % auxhist20_begin_y          = model_config_rec % auxhist20_begin_y (id_id)
 grid_config_rec % auxhist20_begin_d          = model_config_rec % auxhist20_begin_d (id_id)
 grid_config_rec % auxhist20_begin_h          = model_config_rec % auxhist20_begin_h (id_id)
 grid_config_rec % auxhist20_begin_m          = model_config_rec % auxhist20_begin_m (id_id)
 grid_config_rec % auxhist20_begin_s          = model_config_rec % auxhist20_begin_s (id_id)
 grid_config_rec % auxhist20_begin            = model_config_rec % auxhist20_begin (id_id)
 grid_config_rec % auxhist20_end_y            = model_config_rec % auxhist20_end_y (id_id)
 grid_config_rec % auxhist20_end_d            = model_config_rec % auxhist20_end_d (id_id)
 grid_config_rec % auxhist20_end_h            = model_config_rec % auxhist20_end_h (id_id)
 grid_config_rec % auxhist20_end_m            = model_config_rec % auxhist20_end_m (id_id)
 grid_config_rec % auxhist20_end_s            = model_config_rec % auxhist20_end_s (id_id)
 grid_config_rec % auxhist20_end              = model_config_rec % auxhist20_end (id_id)
 grid_config_rec % io_form_auxhist20          = model_config_rec % io_form_auxhist20 
 grid_config_rec % frames_per_auxhist20       = model_config_rec % frames_per_auxhist20 (id_id)
 grid_config_rec % auxhist21_inname           = model_config_rec % auxhist21_inname 
 grid_config_rec % auxhist21_outname          = model_config_rec % auxhist21_outname 
 grid_config_rec % auxhist21_interval_y       = model_config_rec % auxhist21_interval_y (id_id)
 grid_config_rec % auxhist21_interval_d       = model_config_rec % auxhist21_interval_d (id_id)
 grid_config_rec % auxhist21_interval_h       = model_config_rec % auxhist21_interval_h (id_id)
 grid_config_rec % auxhist21_interval_m       = model_config_rec % auxhist21_interval_m (id_id)
 grid_config_rec % auxhist21_interval_s       = model_config_rec % auxhist21_interval_s (id_id)
 grid_config_rec % auxhist21_interval         = model_config_rec % auxhist21_interval (id_id)
 grid_config_rec % auxhist21_begin_y          = model_config_rec % auxhist21_begin_y (id_id)
 grid_config_rec % auxhist21_begin_d          = model_config_rec % auxhist21_begin_d (id_id)
 grid_config_rec % auxhist21_begin_h          = model_config_rec % auxhist21_begin_h (id_id)
 grid_config_rec % auxhist21_begin_m          = model_config_rec % auxhist21_begin_m (id_id)
 grid_config_rec % auxhist21_begin_s          = model_config_rec % auxhist21_begin_s (id_id)
 grid_config_rec % auxhist21_begin            = model_config_rec % auxhist21_begin (id_id)
 grid_config_rec % auxhist21_end_y            = model_config_rec % auxhist21_end_y (id_id)
 grid_config_rec % auxhist21_end_d            = model_config_rec % auxhist21_end_d (id_id)
 grid_config_rec % auxhist21_end_h            = model_config_rec % auxhist21_end_h (id_id)
 grid_config_rec % auxhist21_end_m            = model_config_rec % auxhist21_end_m (id_id)
 grid_config_rec % auxhist21_end_s            = model_config_rec % auxhist21_end_s (id_id)
 grid_config_rec % auxhist21_end              = model_config_rec % auxhist21_end (id_id)
 grid_config_rec % io_form_auxhist21          = model_config_rec % io_form_auxhist21 
 grid_config_rec % frames_per_auxhist21       = model_config_rec % frames_per_auxhist21 (id_id)
 grid_config_rec % auxhist22_inname           = model_config_rec % auxhist22_inname 
 grid_config_rec % auxhist22_outname          = model_config_rec % auxhist22_outname 
 grid_config_rec % auxhist22_interval_y       = model_config_rec % auxhist22_interval_y (id_id)
 grid_config_rec % auxhist22_interval_d       = model_config_rec % auxhist22_interval_d (id_id)
 grid_config_rec % auxhist22_interval_h       = model_config_rec % auxhist22_interval_h (id_id)
 grid_config_rec % auxhist22_interval_m       = model_config_rec % auxhist22_interval_m (id_id)
 grid_config_rec % auxhist22_interval_s       = model_config_rec % auxhist22_interval_s (id_id)
 grid_config_rec % auxhist22_interval         = model_config_rec % auxhist22_interval (id_id)
 grid_config_rec % auxhist22_begin_y          = model_config_rec % auxhist22_begin_y (id_id)
 grid_config_rec % auxhist22_begin_d          = model_config_rec % auxhist22_begin_d (id_id)
 grid_config_rec % auxhist22_begin_h          = model_config_rec % auxhist22_begin_h (id_id)
 grid_config_rec % auxhist22_begin_m          = model_config_rec % auxhist22_begin_m (id_id)
 grid_config_rec % auxhist22_begin_s          = model_config_rec % auxhist22_begin_s (id_id)
 grid_config_rec % auxhist22_begin            = model_config_rec % auxhist22_begin (id_id)
 grid_config_rec % auxhist22_end_y            = model_config_rec % auxhist22_end_y (id_id)
 grid_config_rec % auxhist22_end_d            = model_config_rec % auxhist22_end_d (id_id)
 grid_config_rec % auxhist22_end_h            = model_config_rec % auxhist22_end_h (id_id)
 grid_config_rec % auxhist22_end_m            = model_config_rec % auxhist22_end_m (id_id)
 grid_config_rec % auxhist22_end_s            = model_config_rec % auxhist22_end_s (id_id)
 grid_config_rec % auxhist22_end              = model_config_rec % auxhist22_end (id_id)
 grid_config_rec % io_form_auxhist22          = model_config_rec % io_form_auxhist22 
 grid_config_rec % frames_per_auxhist22       = model_config_rec % frames_per_auxhist22 (id_id)
 grid_config_rec % auxhist23_inname           = model_config_rec % auxhist23_inname 
 grid_config_rec % auxhist23_outname          = model_config_rec % auxhist23_outname 
 grid_config_rec % auxhist23_interval_y       = model_config_rec % auxhist23_interval_y (id_id)
 grid_config_rec % auxhist23_interval_d       = model_config_rec % auxhist23_interval_d (id_id)
 grid_config_rec % auxhist23_interval_h       = model_config_rec % auxhist23_interval_h (id_id)
 grid_config_rec % auxhist23_interval_m       = model_config_rec % auxhist23_interval_m (id_id)
 grid_config_rec % auxhist23_interval_s       = model_config_rec % auxhist23_interval_s (id_id)
 grid_config_rec % auxhist23_interval         = model_config_rec % auxhist23_interval (id_id)
 grid_config_rec % auxhist23_begin_y          = model_config_rec % auxhist23_begin_y (id_id)
 grid_config_rec % auxhist23_begin_d          = model_config_rec % auxhist23_begin_d (id_id)
 grid_config_rec % auxhist23_begin_h          = model_config_rec % auxhist23_begin_h (id_id)
 grid_config_rec % auxhist23_begin_m          = model_config_rec % auxhist23_begin_m (id_id)
 grid_config_rec % auxhist23_begin_s          = model_config_rec % auxhist23_begin_s (id_id)
 grid_config_rec % auxhist23_begin            = model_config_rec % auxhist23_begin (id_id)
 grid_config_rec % auxhist23_end_y            = model_config_rec % auxhist23_end_y (id_id)
 grid_config_rec % auxhist23_end_d            = model_config_rec % auxhist23_end_d (id_id)
 grid_config_rec % auxhist23_end_h            = model_config_rec % auxhist23_end_h (id_id)
 grid_config_rec % auxhist23_end_m            = model_config_rec % auxhist23_end_m (id_id)
 grid_config_rec % auxhist23_end_s            = model_config_rec % auxhist23_end_s (id_id)
 grid_config_rec % auxhist23_end              = model_config_rec % auxhist23_end (id_id)
 grid_config_rec % io_form_auxhist23          = model_config_rec % io_form_auxhist23 
 grid_config_rec % frames_per_auxhist23       = model_config_rec % frames_per_auxhist23 (id_id)
 grid_config_rec % auxhist24_inname           = model_config_rec % auxhist24_inname 
 grid_config_rec % auxhist24_outname          = model_config_rec % auxhist24_outname 
 grid_config_rec % auxhist24_interval_y       = model_config_rec % auxhist24_interval_y (id_id)
 grid_config_rec % auxhist24_interval_d       = model_config_rec % auxhist24_interval_d (id_id)
 grid_config_rec % auxhist24_interval_h       = model_config_rec % auxhist24_interval_h (id_id)
 grid_config_rec % auxhist24_interval_m       = model_config_rec % auxhist24_interval_m (id_id)
 grid_config_rec % auxhist24_interval_s       = model_config_rec % auxhist24_interval_s (id_id)
 grid_config_rec % auxhist24_interval         = model_config_rec % auxhist24_interval (id_id)
 grid_config_rec % auxhist24_begin_y          = model_config_rec % auxhist24_begin_y (id_id)
 grid_config_rec % auxhist24_begin_d          = model_config_rec % auxhist24_begin_d (id_id)
 grid_config_rec % auxhist24_begin_h          = model_config_rec % auxhist24_begin_h (id_id)
 grid_config_rec % auxhist24_begin_m          = model_config_rec % auxhist24_begin_m (id_id)
 grid_config_rec % auxhist24_begin_s          = model_config_rec % auxhist24_begin_s (id_id)
 grid_config_rec % auxhist24_begin            = model_config_rec % auxhist24_begin (id_id)
 grid_config_rec % auxhist24_end_y            = model_config_rec % auxhist24_end_y (id_id)
 grid_config_rec % auxhist24_end_d            = model_config_rec % auxhist24_end_d (id_id)
 grid_config_rec % auxhist24_end_h            = model_config_rec % auxhist24_end_h (id_id)
 grid_config_rec % auxhist24_end_m            = model_config_rec % auxhist24_end_m (id_id)
 grid_config_rec % auxhist24_end_s            = model_config_rec % auxhist24_end_s (id_id)
 grid_config_rec % auxhist24_end              = model_config_rec % auxhist24_end (id_id)
 grid_config_rec % io_form_auxhist24          = model_config_rec % io_form_auxhist24 
 grid_config_rec % frames_per_auxhist24       = model_config_rec % frames_per_auxhist24 (id_id)
 grid_config_rec % auxinput1_outname          = model_config_rec % auxinput1_outname 
 grid_config_rec % auxinput1_interval_y       = model_config_rec % auxinput1_interval_y (id_id)
 grid_config_rec % auxinput1_interval_d       = model_config_rec % auxinput1_interval_d (id_id)
 grid_config_rec % auxinput1_interval_h       = model_config_rec % auxinput1_interval_h (id_id)
 grid_config_rec % auxinput1_interval_m       = model_config_rec % auxinput1_interval_m (id_id)
 grid_config_rec % auxinput1_interval_s       = model_config_rec % auxinput1_interval_s (id_id)
 grid_config_rec % auxinput1_interval         = model_config_rec % auxinput1_interval (id_id)
 grid_config_rec % auxinput1_begin_y          = model_config_rec % auxinput1_begin_y (id_id)
 grid_config_rec % auxinput1_begin_d          = model_config_rec % auxinput1_begin_d (id_id)
 grid_config_rec % auxinput1_begin_h          = model_config_rec % auxinput1_begin_h (id_id)
 grid_config_rec % auxinput1_begin_m          = model_config_rec % auxinput1_begin_m (id_id)
 grid_config_rec % auxinput1_begin_s          = model_config_rec % auxinput1_begin_s (id_id)
 grid_config_rec % auxinput1_begin            = model_config_rec % auxinput1_begin (id_id)
 grid_config_rec % auxinput1_end_y            = model_config_rec % auxinput1_end_y (id_id)
 grid_config_rec % auxinput1_end_d            = model_config_rec % auxinput1_end_d (id_id)
 grid_config_rec % auxinput1_end_h            = model_config_rec % auxinput1_end_h (id_id)
 grid_config_rec % auxinput1_end_m            = model_config_rec % auxinput1_end_m (id_id)
 grid_config_rec % auxinput1_end_s            = model_config_rec % auxinput1_end_s (id_id)
 grid_config_rec % auxinput1_end              = model_config_rec % auxinput1_end (id_id)
 grid_config_rec % frames_per_auxinput1       = model_config_rec % frames_per_auxinput1 (id_id)
 grid_config_rec % auxinput2_inname           = model_config_rec % auxinput2_inname 
 grid_config_rec % auxinput2_outname          = model_config_rec % auxinput2_outname 
 grid_config_rec % auxinput2_interval_y       = model_config_rec % auxinput2_interval_y (id_id)
 grid_config_rec % auxinput2_interval_d       = model_config_rec % auxinput2_interval_d (id_id)
 grid_config_rec % auxinput2_interval_h       = model_config_rec % auxinput2_interval_h (id_id)
 grid_config_rec % auxinput2_interval_m       = model_config_rec % auxinput2_interval_m (id_id)
 grid_config_rec % auxinput2_interval_s       = model_config_rec % auxinput2_interval_s (id_id)
 grid_config_rec % auxinput2_interval         = model_config_rec % auxinput2_interval (id_id)
 grid_config_rec % auxinput2_begin_y          = model_config_rec % auxinput2_begin_y (id_id)
 grid_config_rec % auxinput2_begin_d          = model_config_rec % auxinput2_begin_d (id_id)
 grid_config_rec % auxinput2_begin_h          = model_config_rec % auxinput2_begin_h (id_id)
 grid_config_rec % auxinput2_begin_m          = model_config_rec % auxinput2_begin_m (id_id)
 grid_config_rec % auxinput2_begin_s          = model_config_rec % auxinput2_begin_s (id_id)
 grid_config_rec % auxinput2_begin            = model_config_rec % auxinput2_begin (id_id)
 grid_config_rec % auxinput2_end_y            = model_config_rec % auxinput2_end_y (id_id)
 grid_config_rec % auxinput2_end_d            = model_config_rec % auxinput2_end_d (id_id)
 grid_config_rec % auxinput2_end_h            = model_config_rec % auxinput2_end_h (id_id)
 grid_config_rec % auxinput2_end_m            = model_config_rec % auxinput2_end_m (id_id)
 grid_config_rec % auxinput2_end_s            = model_config_rec % auxinput2_end_s (id_id)
 grid_config_rec % auxinput2_end              = model_config_rec % auxinput2_end (id_id)
 grid_config_rec % io_form_auxinput2          = model_config_rec % io_form_auxinput2 
 grid_config_rec % frames_per_auxinput2       = model_config_rec % frames_per_auxinput2 (id_id)
 grid_config_rec % auxinput3_inname           = model_config_rec % auxinput3_inname 
 grid_config_rec % auxinput3_outname          = model_config_rec % auxinput3_outname 
 grid_config_rec % auxinput3_interval_y       = model_config_rec % auxinput3_interval_y (id_id)
 grid_config_rec % auxinput3_interval_d       = model_config_rec % auxinput3_interval_d (id_id)
 grid_config_rec % auxinput3_interval_h       = model_config_rec % auxinput3_interval_h (id_id)
 grid_config_rec % auxinput3_interval_m       = model_config_rec % auxinput3_interval_m (id_id)
 grid_config_rec % auxinput3_interval_s       = model_config_rec % auxinput3_interval_s (id_id)
 grid_config_rec % auxinput3_interval         = model_config_rec % auxinput3_interval (id_id)
 grid_config_rec % auxinput3_begin_y          = model_config_rec % auxinput3_begin_y (id_id)
 grid_config_rec % auxinput3_begin_d          = model_config_rec % auxinput3_begin_d (id_id)
 grid_config_rec % auxinput3_begin_h          = model_config_rec % auxinput3_begin_h (id_id)
 grid_config_rec % auxinput3_begin_m          = model_config_rec % auxinput3_begin_m (id_id)
 grid_config_rec % auxinput3_begin_s          = model_config_rec % auxinput3_begin_s (id_id)
 grid_config_rec % auxinput3_begin            = model_config_rec % auxinput3_begin (id_id)
 grid_config_rec % auxinput3_end_y            = model_config_rec % auxinput3_end_y (id_id)
 grid_config_rec % auxinput3_end_d            = model_config_rec % auxinput3_end_d (id_id)
 grid_config_rec % auxinput3_end_h            = model_config_rec % auxinput3_end_h (id_id)
 grid_config_rec % auxinput3_end_m            = model_config_rec % auxinput3_end_m (id_id)
 grid_config_rec % auxinput3_end_s            = model_config_rec % auxinput3_end_s (id_id)
 grid_config_rec % auxinput3_end              = model_config_rec % auxinput3_end (id_id)
 grid_config_rec % io_form_auxinput3          = model_config_rec % io_form_auxinput3 
 grid_config_rec % frames_per_auxinput3       = model_config_rec % frames_per_auxinput3 (id_id)
 grid_config_rec % auxinput4_inname           = model_config_rec % auxinput4_inname 
 grid_config_rec % auxinput4_outname          = model_config_rec % auxinput4_outname 
 grid_config_rec % auxinput4_interval_y       = model_config_rec % auxinput4_interval_y (id_id)
 grid_config_rec % auxinput4_interval_d       = model_config_rec % auxinput4_interval_d (id_id)
 grid_config_rec % auxinput4_interval_h       = model_config_rec % auxinput4_interval_h (id_id)
 grid_config_rec % auxinput4_interval_m       = model_config_rec % auxinput4_interval_m (id_id)
 grid_config_rec % auxinput4_interval_s       = model_config_rec % auxinput4_interval_s (id_id)
 grid_config_rec % auxinput4_interval         = model_config_rec % auxinput4_interval (id_id)
 grid_config_rec % auxinput4_begin_y          = model_config_rec % auxinput4_begin_y (id_id)
 grid_config_rec % auxinput4_begin_d          = model_config_rec % auxinput4_begin_d (id_id)
 grid_config_rec % auxinput4_begin_h          = model_config_rec % auxinput4_begin_h (id_id)
 grid_config_rec % auxinput4_begin_m          = model_config_rec % auxinput4_begin_m (id_id)
 grid_config_rec % auxinput4_begin_s          = model_config_rec % auxinput4_begin_s (id_id)
 grid_config_rec % auxinput4_begin            = model_config_rec % auxinput4_begin (id_id)
 grid_config_rec % auxinput4_end_y            = model_config_rec % auxinput4_end_y (id_id)
 grid_config_rec % auxinput4_end_d            = model_config_rec % auxinput4_end_d (id_id)
 grid_config_rec % auxinput4_end_h            = model_config_rec % auxinput4_end_h (id_id)
 grid_config_rec % auxinput4_end_m            = model_config_rec % auxinput4_end_m (id_id)
 grid_config_rec % auxinput4_end_s            = model_config_rec % auxinput4_end_s (id_id)
 grid_config_rec % auxinput4_end              = model_config_rec % auxinput4_end (id_id)
 grid_config_rec % io_form_auxinput4          = model_config_rec % io_form_auxinput4 
 grid_config_rec % frames_per_auxinput4       = model_config_rec % frames_per_auxinput4 (id_id)
 grid_config_rec % auxinput5_inname           = model_config_rec % auxinput5_inname 
 grid_config_rec % auxinput5_outname          = model_config_rec % auxinput5_outname 
 grid_config_rec % auxinput5_interval_y       = model_config_rec % auxinput5_interval_y (id_id)
 grid_config_rec % auxinput5_interval_d       = model_config_rec % auxinput5_interval_d (id_id)
 grid_config_rec % auxinput5_interval_h       = model_config_rec % auxinput5_interval_h (id_id)
 grid_config_rec % auxinput5_interval_m       = model_config_rec % auxinput5_interval_m (id_id)
 grid_config_rec % auxinput5_interval_s       = model_config_rec % auxinput5_interval_s (id_id)
 grid_config_rec % auxinput5_interval         = model_config_rec % auxinput5_interval (id_id)
 grid_config_rec % auxinput5_begin_y          = model_config_rec % auxinput5_begin_y (id_id)
 grid_config_rec % auxinput5_begin_d          = model_config_rec % auxinput5_begin_d (id_id)
 grid_config_rec % auxinput5_begin_h          = model_config_rec % auxinput5_begin_h (id_id)
 grid_config_rec % auxinput5_begin_m          = model_config_rec % auxinput5_begin_m (id_id)
 grid_config_rec % auxinput5_begin_s          = model_config_rec % auxinput5_begin_s (id_id)
 grid_config_rec % auxinput5_begin            = model_config_rec % auxinput5_begin (id_id)
 grid_config_rec % auxinput5_end_y            = model_config_rec % auxinput5_end_y (id_id)
 grid_config_rec % auxinput5_end_d            = model_config_rec % auxinput5_end_d (id_id)
 grid_config_rec % auxinput5_end_h            = model_config_rec % auxinput5_end_h (id_id)
 grid_config_rec % auxinput5_end_m            = model_config_rec % auxinput5_end_m (id_id)
 grid_config_rec % auxinput5_end_s            = model_config_rec % auxinput5_end_s (id_id)
 grid_config_rec % auxinput5_end              = model_config_rec % auxinput5_end (id_id)
 grid_config_rec % io_form_auxinput5          = model_config_rec % io_form_auxinput5 
 grid_config_rec % frames_per_auxinput5       = model_config_rec % frames_per_auxinput5 (id_id)
 grid_config_rec % auxinput6_inname           = model_config_rec % auxinput6_inname 
 grid_config_rec % auxinput6_outname          = model_config_rec % auxinput6_outname 
 grid_config_rec % auxinput6_interval_y       = model_config_rec % auxinput6_interval_y (id_id)
 grid_config_rec % auxinput6_interval_d       = model_config_rec % auxinput6_interval_d (id_id)
 grid_config_rec % auxinput6_interval_h       = model_config_rec % auxinput6_interval_h (id_id)
 grid_config_rec % auxinput6_interval_m       = model_config_rec % auxinput6_interval_m (id_id)
 grid_config_rec % auxinput6_interval_s       = model_config_rec % auxinput6_interval_s (id_id)
 grid_config_rec % auxinput6_interval         = model_config_rec % auxinput6_interval (id_id)
 grid_config_rec % auxinput6_begin_y          = model_config_rec % auxinput6_begin_y (id_id)
 grid_config_rec % auxinput6_begin_d          = model_config_rec % auxinput6_begin_d (id_id)
 grid_config_rec % auxinput6_begin_h          = model_config_rec % auxinput6_begin_h (id_id)
 grid_config_rec % auxinput6_begin_m          = model_config_rec % auxinput6_begin_m (id_id)
 grid_config_rec % auxinput6_begin_s          = model_config_rec % auxinput6_begin_s (id_id)
 grid_config_rec % auxinput6_begin            = model_config_rec % auxinput6_begin (id_id)
 grid_config_rec % auxinput6_end_y            = model_config_rec % auxinput6_end_y (id_id)
 grid_config_rec % auxinput6_end_d            = model_config_rec % auxinput6_end_d (id_id)
 grid_config_rec % auxinput6_end_h            = model_config_rec % auxinput6_end_h (id_id)
 grid_config_rec % auxinput6_end_m            = model_config_rec % auxinput6_end_m (id_id)
 grid_config_rec % auxinput6_end_s            = model_config_rec % auxinput6_end_s (id_id)
 grid_config_rec % auxinput6_end              = model_config_rec % auxinput6_end (id_id)
 grid_config_rec % io_form_auxinput6          = model_config_rec % io_form_auxinput6 
 grid_config_rec % frames_per_auxinput6       = model_config_rec % frames_per_auxinput6 (id_id)
 grid_config_rec % auxinput7_inname           = model_config_rec % auxinput7_inname 
 grid_config_rec % auxinput7_outname          = model_config_rec % auxinput7_outname 
 grid_config_rec % auxinput7_interval_y       = model_config_rec % auxinput7_interval_y (id_id)
 grid_config_rec % auxinput7_interval_d       = model_config_rec % auxinput7_interval_d (id_id)
 grid_config_rec % auxinput7_interval_h       = model_config_rec % auxinput7_interval_h (id_id)
 grid_config_rec % auxinput7_interval_m       = model_config_rec % auxinput7_interval_m (id_id)
 grid_config_rec % auxinput7_interval_s       = model_config_rec % auxinput7_interval_s (id_id)
 grid_config_rec % auxinput7_interval         = model_config_rec % auxinput7_interval (id_id)
 grid_config_rec % auxinput7_begin_y          = model_config_rec % auxinput7_begin_y (id_id)
 grid_config_rec % auxinput7_begin_d          = model_config_rec % auxinput7_begin_d (id_id)
 grid_config_rec % auxinput7_begin_h          = model_config_rec % auxinput7_begin_h (id_id)
 grid_config_rec % auxinput7_begin_m          = model_config_rec % auxinput7_begin_m (id_id)
 grid_config_rec % auxinput7_begin_s          = model_config_rec % auxinput7_begin_s (id_id)
 grid_config_rec % auxinput7_begin            = model_config_rec % auxinput7_begin (id_id)
 grid_config_rec % auxinput7_end_y            = model_config_rec % auxinput7_end_y (id_id)
 grid_config_rec % auxinput7_end_d            = model_config_rec % auxinput7_end_d (id_id)
 grid_config_rec % auxinput7_end_h            = model_config_rec % auxinput7_end_h (id_id)
 grid_config_rec % auxinput7_end_m            = model_config_rec % auxinput7_end_m (id_id)
 grid_config_rec % auxinput7_end_s            = model_config_rec % auxinput7_end_s (id_id)
 grid_config_rec % auxinput7_end              = model_config_rec % auxinput7_end (id_id)
 grid_config_rec % io_form_auxinput7          = model_config_rec % io_form_auxinput7 
 grid_config_rec % frames_per_auxinput7       = model_config_rec % frames_per_auxinput7 (id_id)
 grid_config_rec % auxinput8_inname           = model_config_rec % auxinput8_inname 
 grid_config_rec % auxinput8_outname          = model_config_rec % auxinput8_outname 
 grid_config_rec % auxinput8_interval_y       = model_config_rec % auxinput8_interval_y (id_id)
 grid_config_rec % auxinput8_interval_d       = model_config_rec % auxinput8_interval_d (id_id)
 grid_config_rec % auxinput8_interval_h       = model_config_rec % auxinput8_interval_h (id_id)
 grid_config_rec % auxinput8_interval_m       = model_config_rec % auxinput8_interval_m (id_id)
 grid_config_rec % auxinput8_interval_s       = model_config_rec % auxinput8_interval_s (id_id)
 grid_config_rec % auxinput8_interval         = model_config_rec % auxinput8_interval (id_id)
 grid_config_rec % auxinput8_begin_y          = model_config_rec % auxinput8_begin_y (id_id)
 grid_config_rec % auxinput8_begin_d          = model_config_rec % auxinput8_begin_d (id_id)
 grid_config_rec % auxinput8_begin_h          = model_config_rec % auxinput8_begin_h (id_id)
 grid_config_rec % auxinput8_begin_m          = model_config_rec % auxinput8_begin_m (id_id)
 grid_config_rec % auxinput8_begin_s          = model_config_rec % auxinput8_begin_s (id_id)
 grid_config_rec % auxinput8_begin            = model_config_rec % auxinput8_begin (id_id)
 grid_config_rec % auxinput8_end_y            = model_config_rec % auxinput8_end_y (id_id)
 grid_config_rec % auxinput8_end_d            = model_config_rec % auxinput8_end_d (id_id)
 grid_config_rec % auxinput8_end_h            = model_config_rec % auxinput8_end_h (id_id)
 grid_config_rec % auxinput8_end_m            = model_config_rec % auxinput8_end_m (id_id)
 grid_config_rec % auxinput8_end_s            = model_config_rec % auxinput8_end_s (id_id)
 grid_config_rec % auxinput8_end              = model_config_rec % auxinput8_end (id_id)
 grid_config_rec % io_form_auxinput8          = model_config_rec % io_form_auxinput8 
 grid_config_rec % frames_per_auxinput8       = model_config_rec % frames_per_auxinput8 (id_id)
 grid_config_rec % auxinput9_inname           = model_config_rec % auxinput9_inname 
 grid_config_rec % auxinput9_outname          = model_config_rec % auxinput9_outname 
 grid_config_rec % auxinput9_interval_y       = model_config_rec % auxinput9_interval_y (id_id)
 grid_config_rec % auxinput9_interval_d       = model_config_rec % auxinput9_interval_d (id_id)
 grid_config_rec % auxinput9_interval_h       = model_config_rec % auxinput9_interval_h (id_id)
 grid_config_rec % auxinput9_interval_m       = model_config_rec % auxinput9_interval_m (id_id)
 grid_config_rec % auxinput9_interval_s       = model_config_rec % auxinput9_interval_s (id_id)
 grid_config_rec % auxinput9_interval         = model_config_rec % auxinput9_interval (id_id)
 grid_config_rec % auxinput9_begin_y          = model_config_rec % auxinput9_begin_y (id_id)
 grid_config_rec % auxinput9_begin_d          = model_config_rec % auxinput9_begin_d (id_id)
 grid_config_rec % auxinput9_begin_h          = model_config_rec % auxinput9_begin_h (id_id)
 grid_config_rec % auxinput9_begin_m          = model_config_rec % auxinput9_begin_m (id_id)
 grid_config_rec % auxinput9_begin_s          = model_config_rec % auxinput9_begin_s (id_id)
 grid_config_rec % auxinput9_begin            = model_config_rec % auxinput9_begin (id_id)
 grid_config_rec % auxinput9_end_y            = model_config_rec % auxinput9_end_y (id_id)
 grid_config_rec % auxinput9_end_d            = model_config_rec % auxinput9_end_d (id_id)
 grid_config_rec % auxinput9_end_h            = model_config_rec % auxinput9_end_h (id_id)
 grid_config_rec % auxinput9_end_m            = model_config_rec % auxinput9_end_m (id_id)
 grid_config_rec % auxinput9_end_s            = model_config_rec % auxinput9_end_s (id_id)
 grid_config_rec % auxinput9_end              = model_config_rec % auxinput9_end (id_id)
 grid_config_rec % io_form_auxinput9          = model_config_rec % io_form_auxinput9 
 grid_config_rec % frames_per_auxinput9       = model_config_rec % frames_per_auxinput9 (id_id)
 grid_config_rec % auxinput10_inname          = model_config_rec % auxinput10_inname 
 grid_config_rec % auxinput10_outname         = model_config_rec % auxinput10_outname 
 grid_config_rec % auxinput10_interval_y      = model_config_rec % auxinput10_interval_y (id_id)
 grid_config_rec % auxinput10_interval_d      = model_config_rec % auxinput10_interval_d (id_id)
 grid_config_rec % auxinput10_interval_h      = model_config_rec % auxinput10_interval_h (id_id)
 grid_config_rec % auxinput10_interval_m      = model_config_rec % auxinput10_interval_m (id_id)
 grid_config_rec % auxinput10_interval_s      = model_config_rec % auxinput10_interval_s (id_id)
 grid_config_rec % auxinput10_interval        = model_config_rec % auxinput10_interval (id_id)
 grid_config_rec % auxinput10_begin_y         = model_config_rec % auxinput10_begin_y (id_id)
 grid_config_rec % auxinput10_begin_d         = model_config_rec % auxinput10_begin_d (id_id)
 grid_config_rec % auxinput10_begin_h         = model_config_rec % auxinput10_begin_h (id_id)
 grid_config_rec % auxinput10_begin_m         = model_config_rec % auxinput10_begin_m (id_id)
 grid_config_rec % auxinput10_begin_s         = model_config_rec % auxinput10_begin_s (id_id)
 grid_config_rec % auxinput10_begin           = model_config_rec % auxinput10_begin (id_id)
 grid_config_rec % auxinput10_end_y           = model_config_rec % auxinput10_end_y (id_id)
 grid_config_rec % auxinput10_end_d           = model_config_rec % auxinput10_end_d (id_id)
 grid_config_rec % auxinput10_end_h           = model_config_rec % auxinput10_end_h (id_id)
 grid_config_rec % auxinput10_end_m           = model_config_rec % auxinput10_end_m (id_id)
 grid_config_rec % auxinput10_end_s           = model_config_rec % auxinput10_end_s (id_id)
 grid_config_rec % auxinput10_end             = model_config_rec % auxinput10_end (id_id)
 grid_config_rec % io_form_auxinput10         = model_config_rec % io_form_auxinput10 
 grid_config_rec % frames_per_auxinput10      = model_config_rec % frames_per_auxinput10 (id_id)
 grid_config_rec % auxinput11_inname          = model_config_rec % auxinput11_inname 
 grid_config_rec % auxinput11_outname         = model_config_rec % auxinput11_outname 
 grid_config_rec % auxinput11_interval_y      = model_config_rec % auxinput11_interval_y (id_id)
 grid_config_rec % auxinput11_interval_d      = model_config_rec % auxinput11_interval_d (id_id)
 grid_config_rec % auxinput11_interval_h      = model_config_rec % auxinput11_interval_h (id_id)
 grid_config_rec % auxinput11_interval_m      = model_config_rec % auxinput11_interval_m (id_id)
 grid_config_rec % auxinput11_interval_s      = model_config_rec % auxinput11_interval_s (id_id)
 grid_config_rec % auxinput11_interval        = model_config_rec % auxinput11_interval (id_id)
 grid_config_rec % auxinput11_begin_y         = model_config_rec % auxinput11_begin_y (id_id)
 grid_config_rec % auxinput11_begin_d         = model_config_rec % auxinput11_begin_d (id_id)
 grid_config_rec % auxinput11_begin_h         = model_config_rec % auxinput11_begin_h (id_id)
 grid_config_rec % auxinput11_begin_m         = model_config_rec % auxinput11_begin_m (id_id)
 grid_config_rec % auxinput11_begin_s         = model_config_rec % auxinput11_begin_s (id_id)
 grid_config_rec % auxinput11_begin           = model_config_rec % auxinput11_begin (id_id)
 grid_config_rec % auxinput11_end_y           = model_config_rec % auxinput11_end_y (id_id)
 grid_config_rec % auxinput11_end_d           = model_config_rec % auxinput11_end_d (id_id)
 grid_config_rec % auxinput11_end_h           = model_config_rec % auxinput11_end_h (id_id)
 grid_config_rec % auxinput11_end_m           = model_config_rec % auxinput11_end_m (id_id)
 grid_config_rec % auxinput11_end_s           = model_config_rec % auxinput11_end_s (id_id)
 grid_config_rec % auxinput11_end             = model_config_rec % auxinput11_end (id_id)
 grid_config_rec % io_form_auxinput11         = model_config_rec % io_form_auxinput11 
 grid_config_rec % frames_per_auxinput11      = model_config_rec % frames_per_auxinput11 (id_id)
 grid_config_rec % auxinput12_inname          = model_config_rec % auxinput12_inname 
 grid_config_rec % auxinput12_outname         = model_config_rec % auxinput12_outname 
 grid_config_rec % auxinput12_interval_y      = model_config_rec % auxinput12_interval_y (id_id)
 grid_config_rec % auxinput12_interval_d      = model_config_rec % auxinput12_interval_d (id_id)
 grid_config_rec % auxinput12_interval_h      = model_config_rec % auxinput12_interval_h (id_id)
 grid_config_rec % auxinput12_interval_m      = model_config_rec % auxinput12_interval_m (id_id)
 grid_config_rec % auxinput12_interval_s      = model_config_rec % auxinput12_interval_s (id_id)
 grid_config_rec % auxinput12_interval        = model_config_rec % auxinput12_interval (id_id)
 grid_config_rec % auxinput12_begin_y         = model_config_rec % auxinput12_begin_y (id_id)
 grid_config_rec % auxinput12_begin_d         = model_config_rec % auxinput12_begin_d (id_id)
 grid_config_rec % auxinput12_begin_h         = model_config_rec % auxinput12_begin_h (id_id)
 grid_config_rec % auxinput12_begin_m         = model_config_rec % auxinput12_begin_m (id_id)
 grid_config_rec % auxinput12_begin_s         = model_config_rec % auxinput12_begin_s (id_id)
 grid_config_rec % auxinput12_begin           = model_config_rec % auxinput12_begin (id_id)
 grid_config_rec % auxinput12_end_y           = model_config_rec % auxinput12_end_y (id_id)
 grid_config_rec % auxinput12_end_d           = model_config_rec % auxinput12_end_d (id_id)
 grid_config_rec % auxinput12_end_h           = model_config_rec % auxinput12_end_h (id_id)
 grid_config_rec % auxinput12_end_m           = model_config_rec % auxinput12_end_m (id_id)
 grid_config_rec % auxinput12_end_s           = model_config_rec % auxinput12_end_s (id_id)
 grid_config_rec % auxinput12_end             = model_config_rec % auxinput12_end (id_id)
 grid_config_rec % io_form_auxinput12         = model_config_rec % io_form_auxinput12 
 grid_config_rec % frames_per_auxinput12      = model_config_rec % frames_per_auxinput12 (id_id)
 grid_config_rec % auxinput13_inname          = model_config_rec % auxinput13_inname 
 grid_config_rec % auxinput13_outname         = model_config_rec % auxinput13_outname 
 grid_config_rec % auxinput13_interval_y      = model_config_rec % auxinput13_interval_y (id_id)
 grid_config_rec % auxinput13_interval_d      = model_config_rec % auxinput13_interval_d (id_id)
 grid_config_rec % auxinput13_interval_h      = model_config_rec % auxinput13_interval_h (id_id)
 grid_config_rec % auxinput13_interval_m      = model_config_rec % auxinput13_interval_m (id_id)
 grid_config_rec % auxinput13_interval_s      = model_config_rec % auxinput13_interval_s (id_id)
 grid_config_rec % auxinput13_interval        = model_config_rec % auxinput13_interval (id_id)
 grid_config_rec % auxinput13_begin_y         = model_config_rec % auxinput13_begin_y (id_id)
 grid_config_rec % auxinput13_begin_d         = model_config_rec % auxinput13_begin_d (id_id)
 grid_config_rec % auxinput13_begin_h         = model_config_rec % auxinput13_begin_h (id_id)
 grid_config_rec % auxinput13_begin_m         = model_config_rec % auxinput13_begin_m (id_id)
 grid_config_rec % auxinput13_begin_s         = model_config_rec % auxinput13_begin_s (id_id)
 grid_config_rec % auxinput13_begin           = model_config_rec % auxinput13_begin (id_id)
 grid_config_rec % auxinput13_end_y           = model_config_rec % auxinput13_end_y (id_id)
 grid_config_rec % auxinput13_end_d           = model_config_rec % auxinput13_end_d (id_id)
 grid_config_rec % auxinput13_end_h           = model_config_rec % auxinput13_end_h (id_id)
 grid_config_rec % auxinput13_end_m           = model_config_rec % auxinput13_end_m (id_id)
 grid_config_rec % auxinput13_end_s           = model_config_rec % auxinput13_end_s (id_id)
 grid_config_rec % auxinput13_end             = model_config_rec % auxinput13_end (id_id)
 grid_config_rec % io_form_auxinput13         = model_config_rec % io_form_auxinput13 
 grid_config_rec % frames_per_auxinput13      = model_config_rec % frames_per_auxinput13 (id_id)
 grid_config_rec % auxinput14_inname          = model_config_rec % auxinput14_inname 
 grid_config_rec % auxinput14_outname         = model_config_rec % auxinput14_outname 
 grid_config_rec % auxinput14_interval_y      = model_config_rec % auxinput14_interval_y (id_id)
 grid_config_rec % auxinput14_interval_d      = model_config_rec % auxinput14_interval_d (id_id)
 grid_config_rec % auxinput14_interval_h      = model_config_rec % auxinput14_interval_h (id_id)
 grid_config_rec % auxinput14_interval_m      = model_config_rec % auxinput14_interval_m (id_id)
 grid_config_rec % auxinput14_interval_s      = model_config_rec % auxinput14_interval_s (id_id)
 grid_config_rec % auxinput14_interval        = model_config_rec % auxinput14_interval (id_id)
 grid_config_rec % auxinput14_begin_y         = model_config_rec % auxinput14_begin_y (id_id)
 grid_config_rec % auxinput14_begin_d         = model_config_rec % auxinput14_begin_d (id_id)
 grid_config_rec % auxinput14_begin_h         = model_config_rec % auxinput14_begin_h (id_id)
 grid_config_rec % auxinput14_begin_m         = model_config_rec % auxinput14_begin_m (id_id)
 grid_config_rec % auxinput14_begin_s         = model_config_rec % auxinput14_begin_s (id_id)
 grid_config_rec % auxinput14_begin           = model_config_rec % auxinput14_begin (id_id)
 grid_config_rec % auxinput14_end_y           = model_config_rec % auxinput14_end_y (id_id)
 grid_config_rec % auxinput14_end_d           = model_config_rec % auxinput14_end_d (id_id)
 grid_config_rec % auxinput14_end_h           = model_config_rec % auxinput14_end_h (id_id)
 grid_config_rec % auxinput14_end_m           = model_config_rec % auxinput14_end_m (id_id)
 grid_config_rec % auxinput14_end_s           = model_config_rec % auxinput14_end_s (id_id)
 grid_config_rec % auxinput14_end             = model_config_rec % auxinput14_end (id_id)
 grid_config_rec % io_form_auxinput14         = model_config_rec % io_form_auxinput14 
 grid_config_rec % frames_per_auxinput14      = model_config_rec % frames_per_auxinput14 (id_id)
 grid_config_rec % auxinput15_inname          = model_config_rec % auxinput15_inname 
 grid_config_rec % auxinput15_outname         = model_config_rec % auxinput15_outname 
 grid_config_rec % auxinput15_interval_y      = model_config_rec % auxinput15_interval_y (id_id)
 grid_config_rec % auxinput15_interval_d      = model_config_rec % auxinput15_interval_d (id_id)
 grid_config_rec % auxinput15_interval_h      = model_config_rec % auxinput15_interval_h (id_id)
 grid_config_rec % auxinput15_interval_m      = model_config_rec % auxinput15_interval_m (id_id)
 grid_config_rec % auxinput15_interval_s      = model_config_rec % auxinput15_interval_s (id_id)
 grid_config_rec % auxinput15_interval        = model_config_rec % auxinput15_interval (id_id)
 grid_config_rec % auxinput15_begin_y         = model_config_rec % auxinput15_begin_y (id_id)
 grid_config_rec % auxinput15_begin_d         = model_config_rec % auxinput15_begin_d (id_id)
 grid_config_rec % auxinput15_begin_h         = model_config_rec % auxinput15_begin_h (id_id)
 grid_config_rec % auxinput15_begin_m         = model_config_rec % auxinput15_begin_m (id_id)
 grid_config_rec % auxinput15_begin_s         = model_config_rec % auxinput15_begin_s (id_id)
 grid_config_rec % auxinput15_begin           = model_config_rec % auxinput15_begin (id_id)
 grid_config_rec % auxinput15_end_y           = model_config_rec % auxinput15_end_y (id_id)
 grid_config_rec % auxinput15_end_d           = model_config_rec % auxinput15_end_d (id_id)
 grid_config_rec % auxinput15_end_h           = model_config_rec % auxinput15_end_h (id_id)
 grid_config_rec % auxinput15_end_m           = model_config_rec % auxinput15_end_m (id_id)
 grid_config_rec % auxinput15_end_s           = model_config_rec % auxinput15_end_s (id_id)
 grid_config_rec % auxinput15_end             = model_config_rec % auxinput15_end (id_id)
 grid_config_rec % io_form_auxinput15         = model_config_rec % io_form_auxinput15 
 grid_config_rec % frames_per_auxinput15      = model_config_rec % frames_per_auxinput15 (id_id)
 grid_config_rec % auxinput16_inname          = model_config_rec % auxinput16_inname 
 grid_config_rec % auxinput16_outname         = model_config_rec % auxinput16_outname 
 grid_config_rec % auxinput16_interval_y      = model_config_rec % auxinput16_interval_y (id_id)
 grid_config_rec % auxinput16_interval_d      = model_config_rec % auxinput16_interval_d (id_id)
 grid_config_rec % auxinput16_interval_h      = model_config_rec % auxinput16_interval_h (id_id)
 grid_config_rec % auxinput16_interval_m      = model_config_rec % auxinput16_interval_m (id_id)
 grid_config_rec % auxinput16_interval_s      = model_config_rec % auxinput16_interval_s (id_id)
 grid_config_rec % auxinput16_interval        = model_config_rec % auxinput16_interval (id_id)
 grid_config_rec % auxinput16_begin_y         = model_config_rec % auxinput16_begin_y (id_id)
 grid_config_rec % auxinput16_begin_d         = model_config_rec % auxinput16_begin_d (id_id)
 grid_config_rec % auxinput16_begin_h         = model_config_rec % auxinput16_begin_h (id_id)
 grid_config_rec % auxinput16_begin_m         = model_config_rec % auxinput16_begin_m (id_id)
 grid_config_rec % auxinput16_begin_s         = model_config_rec % auxinput16_begin_s (id_id)
 grid_config_rec % auxinput16_begin           = model_config_rec % auxinput16_begin (id_id)
 grid_config_rec % auxinput16_end_y           = model_config_rec % auxinput16_end_y (id_id)
 grid_config_rec % auxinput16_end_d           = model_config_rec % auxinput16_end_d (id_id)
 grid_config_rec % auxinput16_end_h           = model_config_rec % auxinput16_end_h (id_id)
 grid_config_rec % auxinput16_end_m           = model_config_rec % auxinput16_end_m (id_id)
 grid_config_rec % auxinput16_end_s           = model_config_rec % auxinput16_end_s (id_id)
 grid_config_rec % auxinput16_end             = model_config_rec % auxinput16_end (id_id)
 grid_config_rec % io_form_auxinput16         = model_config_rec % io_form_auxinput16 
 grid_config_rec % frames_per_auxinput16      = model_config_rec % frames_per_auxinput16 (id_id)
 grid_config_rec % auxinput17_inname          = model_config_rec % auxinput17_inname 
 grid_config_rec % auxinput17_outname         = model_config_rec % auxinput17_outname 
 grid_config_rec % auxinput17_interval_y      = model_config_rec % auxinput17_interval_y (id_id)
 grid_config_rec % auxinput17_interval_d      = model_config_rec % auxinput17_interval_d (id_id)
 grid_config_rec % auxinput17_interval_h      = model_config_rec % auxinput17_interval_h (id_id)
 grid_config_rec % auxinput17_interval_m      = model_config_rec % auxinput17_interval_m (id_id)
 grid_config_rec % auxinput17_interval_s      = model_config_rec % auxinput17_interval_s (id_id)
 grid_config_rec % auxinput17_interval        = model_config_rec % auxinput17_interval (id_id)
 grid_config_rec % auxinput17_begin_y         = model_config_rec % auxinput17_begin_y (id_id)
 grid_config_rec % auxinput17_begin_d         = model_config_rec % auxinput17_begin_d (id_id)
 grid_config_rec % auxinput17_begin_h         = model_config_rec % auxinput17_begin_h (id_id)
 grid_config_rec % auxinput17_begin_m         = model_config_rec % auxinput17_begin_m (id_id)
 grid_config_rec % auxinput17_begin_s         = model_config_rec % auxinput17_begin_s (id_id)
 grid_config_rec % auxinput17_begin           = model_config_rec % auxinput17_begin (id_id)
 grid_config_rec % auxinput17_end_y           = model_config_rec % auxinput17_end_y (id_id)
 grid_config_rec % auxinput17_end_d           = model_config_rec % auxinput17_end_d (id_id)
 grid_config_rec % auxinput17_end_h           = model_config_rec % auxinput17_end_h (id_id)
 grid_config_rec % auxinput17_end_m           = model_config_rec % auxinput17_end_m (id_id)
 grid_config_rec % auxinput17_end_s           = model_config_rec % auxinput17_end_s (id_id)
 grid_config_rec % auxinput17_end             = model_config_rec % auxinput17_end (id_id)
 grid_config_rec % io_form_auxinput17         = model_config_rec % io_form_auxinput17 
 grid_config_rec % frames_per_auxinput17      = model_config_rec % frames_per_auxinput17 (id_id)
 grid_config_rec % auxinput18_inname          = model_config_rec % auxinput18_inname 
 grid_config_rec % auxinput18_outname         = model_config_rec % auxinput18_outname 
 grid_config_rec % auxinput18_interval_y      = model_config_rec % auxinput18_interval_y (id_id)
 grid_config_rec % auxinput18_interval_d      = model_config_rec % auxinput18_interval_d (id_id)
 grid_config_rec % auxinput18_interval_h      = model_config_rec % auxinput18_interval_h (id_id)
 grid_config_rec % auxinput18_interval_m      = model_config_rec % auxinput18_interval_m (id_id)
 grid_config_rec % auxinput18_interval_s      = model_config_rec % auxinput18_interval_s (id_id)
 grid_config_rec % auxinput18_interval        = model_config_rec % auxinput18_interval (id_id)
 grid_config_rec % auxinput18_begin_y         = model_config_rec % auxinput18_begin_y (id_id)
 grid_config_rec % auxinput18_begin_d         = model_config_rec % auxinput18_begin_d (id_id)
 grid_config_rec % auxinput18_begin_h         = model_config_rec % auxinput18_begin_h (id_id)
 grid_config_rec % auxinput18_begin_m         = model_config_rec % auxinput18_begin_m (id_id)
 grid_config_rec % auxinput18_begin_s         = model_config_rec % auxinput18_begin_s (id_id)
 grid_config_rec % auxinput18_begin           = model_config_rec % auxinput18_begin (id_id)
 grid_config_rec % auxinput18_end_y           = model_config_rec % auxinput18_end_y (id_id)
 grid_config_rec % auxinput18_end_d           = model_config_rec % auxinput18_end_d (id_id)
 grid_config_rec % auxinput18_end_h           = model_config_rec % auxinput18_end_h (id_id)
 grid_config_rec % auxinput18_end_m           = model_config_rec % auxinput18_end_m (id_id)
 grid_config_rec % auxinput18_end_s           = model_config_rec % auxinput18_end_s (id_id)
 grid_config_rec % auxinput18_end             = model_config_rec % auxinput18_end (id_id)
 grid_config_rec % io_form_auxinput18         = model_config_rec % io_form_auxinput18 
 grid_config_rec % frames_per_auxinput18      = model_config_rec % frames_per_auxinput18 (id_id)
 grid_config_rec % auxinput19_inname          = model_config_rec % auxinput19_inname 
 grid_config_rec % auxinput19_outname         = model_config_rec % auxinput19_outname 
 grid_config_rec % auxinput19_interval_y      = model_config_rec % auxinput19_interval_y (id_id)
 grid_config_rec % auxinput19_interval_d      = model_config_rec % auxinput19_interval_d (id_id)
 grid_config_rec % auxinput19_interval_h      = model_config_rec % auxinput19_interval_h (id_id)
 grid_config_rec % auxinput19_interval_m      = model_config_rec % auxinput19_interval_m (id_id)
 grid_config_rec % auxinput19_interval_s      = model_config_rec % auxinput19_interval_s (id_id)
 grid_config_rec % auxinput19_interval        = model_config_rec % auxinput19_interval (id_id)
 grid_config_rec % auxinput19_begin_y         = model_config_rec % auxinput19_begin_y (id_id)
 grid_config_rec % auxinput19_begin_d         = model_config_rec % auxinput19_begin_d (id_id)
 grid_config_rec % auxinput19_begin_h         = model_config_rec % auxinput19_begin_h (id_id)
 grid_config_rec % auxinput19_begin_m         = model_config_rec % auxinput19_begin_m (id_id)
 grid_config_rec % auxinput19_begin_s         = model_config_rec % auxinput19_begin_s (id_id)
 grid_config_rec % auxinput19_begin           = model_config_rec % auxinput19_begin (id_id)
 grid_config_rec % auxinput19_end_y           = model_config_rec % auxinput19_end_y (id_id)
 grid_config_rec % auxinput19_end_d           = model_config_rec % auxinput19_end_d (id_id)
 grid_config_rec % auxinput19_end_h           = model_config_rec % auxinput19_end_h (id_id)
 grid_config_rec % auxinput19_end_m           = model_config_rec % auxinput19_end_m (id_id)
 grid_config_rec % auxinput19_end_s           = model_config_rec % auxinput19_end_s (id_id)
 grid_config_rec % auxinput19_end             = model_config_rec % auxinput19_end (id_id)
 grid_config_rec % io_form_auxinput19         = model_config_rec % io_form_auxinput19 
 grid_config_rec % frames_per_auxinput19      = model_config_rec % frames_per_auxinput19 (id_id)
 grid_config_rec % auxinput20_inname          = model_config_rec % auxinput20_inname 
 grid_config_rec % auxinput20_outname         = model_config_rec % auxinput20_outname 
 grid_config_rec % auxinput20_interval_y      = model_config_rec % auxinput20_interval_y (id_id)
 grid_config_rec % auxinput20_interval_d      = model_config_rec % auxinput20_interval_d (id_id)
 grid_config_rec % auxinput20_interval_h      = model_config_rec % auxinput20_interval_h (id_id)
 grid_config_rec % auxinput20_interval_m      = model_config_rec % auxinput20_interval_m (id_id)
 grid_config_rec % auxinput20_interval_s      = model_config_rec % auxinput20_interval_s (id_id)
 grid_config_rec % auxinput20_interval        = model_config_rec % auxinput20_interval (id_id)
 grid_config_rec % auxinput20_begin_y         = model_config_rec % auxinput20_begin_y (id_id)
 grid_config_rec % auxinput20_begin_d         = model_config_rec % auxinput20_begin_d (id_id)
 grid_config_rec % auxinput20_begin_h         = model_config_rec % auxinput20_begin_h (id_id)
 grid_config_rec % auxinput20_begin_m         = model_config_rec % auxinput20_begin_m (id_id)
 grid_config_rec % auxinput20_begin_s         = model_config_rec % auxinput20_begin_s (id_id)
 grid_config_rec % auxinput20_begin           = model_config_rec % auxinput20_begin (id_id)
 grid_config_rec % auxinput20_end_y           = model_config_rec % auxinput20_end_y (id_id)
 grid_config_rec % auxinput20_end_d           = model_config_rec % auxinput20_end_d (id_id)
 grid_config_rec % auxinput20_end_h           = model_config_rec % auxinput20_end_h (id_id)
 grid_config_rec % auxinput20_end_m           = model_config_rec % auxinput20_end_m (id_id)
 grid_config_rec % auxinput20_end_s           = model_config_rec % auxinput20_end_s (id_id)
 grid_config_rec % auxinput20_end             = model_config_rec % auxinput20_end (id_id)
 grid_config_rec % io_form_auxinput20         = model_config_rec % io_form_auxinput20 
 grid_config_rec % frames_per_auxinput20      = model_config_rec % frames_per_auxinput20 (id_id)
 grid_config_rec % auxinput21_inname          = model_config_rec % auxinput21_inname 
 grid_config_rec % auxinput21_outname         = model_config_rec % auxinput21_outname 
 grid_config_rec % auxinput21_interval_y      = model_config_rec % auxinput21_interval_y (id_id)
 grid_config_rec % auxinput21_interval_d      = model_config_rec % auxinput21_interval_d (id_id)
 grid_config_rec % auxinput21_interval_h      = model_config_rec % auxinput21_interval_h (id_id)
 grid_config_rec % auxinput21_interval_m      = model_config_rec % auxinput21_interval_m (id_id)
 grid_config_rec % auxinput21_interval_s      = model_config_rec % auxinput21_interval_s (id_id)
 grid_config_rec % auxinput21_interval        = model_config_rec % auxinput21_interval (id_id)
 grid_config_rec % auxinput21_begin_y         = model_config_rec % auxinput21_begin_y (id_id)
 grid_config_rec % auxinput21_begin_d         = model_config_rec % auxinput21_begin_d (id_id)
 grid_config_rec % auxinput21_begin_h         = model_config_rec % auxinput21_begin_h (id_id)
 grid_config_rec % auxinput21_begin_m         = model_config_rec % auxinput21_begin_m (id_id)
 grid_config_rec % auxinput21_begin_s         = model_config_rec % auxinput21_begin_s (id_id)
 grid_config_rec % auxinput21_begin           = model_config_rec % auxinput21_begin (id_id)
 grid_config_rec % auxinput21_end_y           = model_config_rec % auxinput21_end_y (id_id)
 grid_config_rec % auxinput21_end_d           = model_config_rec % auxinput21_end_d (id_id)
 grid_config_rec % auxinput21_end_h           = model_config_rec % auxinput21_end_h (id_id)
 grid_config_rec % auxinput21_end_m           = model_config_rec % auxinput21_end_m (id_id)
 grid_config_rec % auxinput21_end_s           = model_config_rec % auxinput21_end_s (id_id)
 grid_config_rec % auxinput21_end             = model_config_rec % auxinput21_end (id_id)
 grid_config_rec % io_form_auxinput21         = model_config_rec % io_form_auxinput21 
 grid_config_rec % frames_per_auxinput21      = model_config_rec % frames_per_auxinput21 (id_id)
 grid_config_rec % auxinput22_inname          = model_config_rec % auxinput22_inname 
 grid_config_rec % auxinput22_outname         = model_config_rec % auxinput22_outname 
 grid_config_rec % auxinput22_interval_y      = model_config_rec % auxinput22_interval_y (id_id)
 grid_config_rec % auxinput22_interval_d      = model_config_rec % auxinput22_interval_d (id_id)
 grid_config_rec % auxinput22_interval_h      = model_config_rec % auxinput22_interval_h (id_id)
 grid_config_rec % auxinput22_interval_m      = model_config_rec % auxinput22_interval_m (id_id)
 grid_config_rec % auxinput22_interval_s      = model_config_rec % auxinput22_interval_s (id_id)
 grid_config_rec % auxinput22_interval        = model_config_rec % auxinput22_interval (id_id)
 grid_config_rec % auxinput22_begin_y         = model_config_rec % auxinput22_begin_y (id_id)
 grid_config_rec % auxinput22_begin_d         = model_config_rec % auxinput22_begin_d (id_id)
 grid_config_rec % auxinput22_begin_h         = model_config_rec % auxinput22_begin_h (id_id)
 grid_config_rec % auxinput22_begin_m         = model_config_rec % auxinput22_begin_m (id_id)
 grid_config_rec % auxinput22_begin_s         = model_config_rec % auxinput22_begin_s (id_id)
 grid_config_rec % auxinput22_begin           = model_config_rec % auxinput22_begin (id_id)
 grid_config_rec % auxinput22_end_y           = model_config_rec % auxinput22_end_y (id_id)
 grid_config_rec % auxinput22_end_d           = model_config_rec % auxinput22_end_d (id_id)
 grid_config_rec % auxinput22_end_h           = model_config_rec % auxinput22_end_h (id_id)
 grid_config_rec % auxinput22_end_m           = model_config_rec % auxinput22_end_m (id_id)
 grid_config_rec % auxinput22_end_s           = model_config_rec % auxinput22_end_s (id_id)
 grid_config_rec % auxinput22_end             = model_config_rec % auxinput22_end (id_id)
 grid_config_rec % io_form_auxinput22         = model_config_rec % io_form_auxinput22 
 grid_config_rec % frames_per_auxinput22      = model_config_rec % frames_per_auxinput22 (id_id)
 grid_config_rec % auxinput23_inname          = model_config_rec % auxinput23_inname 
 grid_config_rec % auxinput23_outname         = model_config_rec % auxinput23_outname 
 grid_config_rec % auxinput23_interval_y      = model_config_rec % auxinput23_interval_y (id_id)
 grid_config_rec % auxinput23_interval_d      = model_config_rec % auxinput23_interval_d (id_id)
 grid_config_rec % auxinput23_interval_h      = model_config_rec % auxinput23_interval_h (id_id)
 grid_config_rec % auxinput23_interval_m      = model_config_rec % auxinput23_interval_m (id_id)
 grid_config_rec % auxinput23_interval_s      = model_config_rec % auxinput23_interval_s (id_id)
 grid_config_rec % auxinput23_interval        = model_config_rec % auxinput23_interval (id_id)
 grid_config_rec % auxinput23_begin_y         = model_config_rec % auxinput23_begin_y (id_id)
 grid_config_rec % auxinput23_begin_d         = model_config_rec % auxinput23_begin_d (id_id)
 grid_config_rec % auxinput23_begin_h         = model_config_rec % auxinput23_begin_h (id_id)
 grid_config_rec % auxinput23_begin_m         = model_config_rec % auxinput23_begin_m (id_id)
 grid_config_rec % auxinput23_begin_s         = model_config_rec % auxinput23_begin_s (id_id)
 grid_config_rec % auxinput23_begin           = model_config_rec % auxinput23_begin (id_id)
 grid_config_rec % auxinput23_end_y           = model_config_rec % auxinput23_end_y (id_id)
 grid_config_rec % auxinput23_end_d           = model_config_rec % auxinput23_end_d (id_id)
 grid_config_rec % auxinput23_end_h           = model_config_rec % auxinput23_end_h (id_id)
 grid_config_rec % auxinput23_end_m           = model_config_rec % auxinput23_end_m (id_id)
 grid_config_rec % auxinput23_end_s           = model_config_rec % auxinput23_end_s (id_id)
 grid_config_rec % auxinput23_end             = model_config_rec % auxinput23_end (id_id)
 grid_config_rec % io_form_auxinput23         = model_config_rec % io_form_auxinput23 
 grid_config_rec % frames_per_auxinput23      = model_config_rec % frames_per_auxinput23 (id_id)
 grid_config_rec % auxinput24_inname          = model_config_rec % auxinput24_inname 
 grid_config_rec % auxinput24_outname         = model_config_rec % auxinput24_outname 
 grid_config_rec % auxinput24_interval_y      = model_config_rec % auxinput24_interval_y (id_id)
 grid_config_rec % auxinput24_interval_d      = model_config_rec % auxinput24_interval_d (id_id)
 grid_config_rec % auxinput24_interval_h      = model_config_rec % auxinput24_interval_h (id_id)
 grid_config_rec % auxinput24_interval_m      = model_config_rec % auxinput24_interval_m (id_id)
 grid_config_rec % auxinput24_interval_s      = model_config_rec % auxinput24_interval_s (id_id)
 grid_config_rec % auxinput24_interval        = model_config_rec % auxinput24_interval (id_id)
 grid_config_rec % auxinput24_begin_y         = model_config_rec % auxinput24_begin_y (id_id)
 grid_config_rec % auxinput24_begin_d         = model_config_rec % auxinput24_begin_d (id_id)
 grid_config_rec % auxinput24_begin_h         = model_config_rec % auxinput24_begin_h (id_id)
 grid_config_rec % auxinput24_begin_m         = model_config_rec % auxinput24_begin_m (id_id)
 grid_config_rec % auxinput24_begin_s         = model_config_rec % auxinput24_begin_s (id_id)
 grid_config_rec % auxinput24_begin           = model_config_rec % auxinput24_begin (id_id)
 grid_config_rec % auxinput24_end_y           = model_config_rec % auxinput24_end_y (id_id)
 grid_config_rec % auxinput24_end_d           = model_config_rec % auxinput24_end_d (id_id)
 grid_config_rec % auxinput24_end_h           = model_config_rec % auxinput24_end_h (id_id)
 grid_config_rec % auxinput24_end_m           = model_config_rec % auxinput24_end_m (id_id)
 grid_config_rec % auxinput24_end_s           = model_config_rec % auxinput24_end_s (id_id)
 grid_config_rec % auxinput24_end             = model_config_rec % auxinput24_end (id_id)
 grid_config_rec % io_form_auxinput24         = model_config_rec % io_form_auxinput24 
 grid_config_rec % frames_per_auxinput24      = model_config_rec % frames_per_auxinput24 (id_id)
 grid_config_rec % history_interval           = model_config_rec % history_interval (id_id)
 grid_config_rec % frames_per_outfile         = model_config_rec % frames_per_outfile (id_id)
 grid_config_rec % restart                    = model_config_rec % restart 
 grid_config_rec % restart_interval           = model_config_rec % restart_interval 
 grid_config_rec % io_form_input              = model_config_rec % io_form_input 
 grid_config_rec % io_form_history            = model_config_rec % io_form_history 
 grid_config_rec % io_form_restart            = model_config_rec % io_form_restart 
 grid_config_rec % io_form_boundary           = model_config_rec % io_form_boundary 
 grid_config_rec % debug_level                = model_config_rec % debug_level 
 grid_config_rec % self_test_domain           = model_config_rec % self_test_domain 
 grid_config_rec % history_outname            = model_config_rec % history_outname 
 grid_config_rec % history_inname             = model_config_rec % history_inname 
 grid_config_rec % use_netcdf_classic         = model_config_rec % use_netcdf_classic 
 grid_config_rec % history_interval_d         = model_config_rec % history_interval_d (id_id)
 grid_config_rec % history_interval_h         = model_config_rec % history_interval_h (id_id)
 grid_config_rec % history_interval_m         = model_config_rec % history_interval_m (id_id)
 grid_config_rec % history_interval_s         = model_config_rec % history_interval_s (id_id)
 grid_config_rec % inputout_interval_d        = model_config_rec % inputout_interval_d (id_id)
 grid_config_rec % inputout_interval_h        = model_config_rec % inputout_interval_h (id_id)
 grid_config_rec % inputout_interval_m        = model_config_rec % inputout_interval_m (id_id)
 grid_config_rec % inputout_interval_s        = model_config_rec % inputout_interval_s (id_id)
 grid_config_rec % inputout_interval          = model_config_rec % inputout_interval (id_id)
 grid_config_rec % restart_interval_d         = model_config_rec % restart_interval_d 
 grid_config_rec % restart_interval_h         = model_config_rec % restart_interval_h 
 grid_config_rec % restart_interval_m         = model_config_rec % restart_interval_m 
 grid_config_rec % restart_interval_s         = model_config_rec % restart_interval_s 
 grid_config_rec % history_begin_y            = model_config_rec % history_begin_y (id_id)
 grid_config_rec % history_begin_d            = model_config_rec % history_begin_d (id_id)
 grid_config_rec % history_begin_h            = model_config_rec % history_begin_h (id_id)
 grid_config_rec % history_begin_m            = model_config_rec % history_begin_m (id_id)
 grid_config_rec % history_begin_s            = model_config_rec % history_begin_s (id_id)
 grid_config_rec % history_begin              = model_config_rec % history_begin (id_id)
 grid_config_rec % inputout_begin_y           = model_config_rec % inputout_begin_y (id_id)
 grid_config_rec % inputout_begin_d           = model_config_rec % inputout_begin_d (id_id)
 grid_config_rec % inputout_begin_h           = model_config_rec % inputout_begin_h (id_id)
 grid_config_rec % inputout_begin_m           = model_config_rec % inputout_begin_m (id_id)
 grid_config_rec % inputout_begin_s           = model_config_rec % inputout_begin_s (id_id)
 grid_config_rec % restart_begin_y            = model_config_rec % restart_begin_y 
 grid_config_rec % restart_begin_d            = model_config_rec % restart_begin_d 
 grid_config_rec % restart_begin_h            = model_config_rec % restart_begin_h 
 grid_config_rec % restart_begin_m            = model_config_rec % restart_begin_m 
 grid_config_rec % restart_begin_s            = model_config_rec % restart_begin_s 
 grid_config_rec % restart_begin              = model_config_rec % restart_begin 
 grid_config_rec % history_end_y              = model_config_rec % history_end_y (id_id)
 grid_config_rec % history_end_d              = model_config_rec % history_end_d (id_id)
 grid_config_rec % history_end_h              = model_config_rec % history_end_h (id_id)
 grid_config_rec % history_end_m              = model_config_rec % history_end_m (id_id)
 grid_config_rec % history_end_s              = model_config_rec % history_end_s (id_id)
 grid_config_rec % history_end                = model_config_rec % history_end (id_id)
 grid_config_rec % inputout_end_y             = model_config_rec % inputout_end_y (id_id)
 grid_config_rec % inputout_end_d             = model_config_rec % inputout_end_d (id_id)
 grid_config_rec % inputout_end_h             = model_config_rec % inputout_end_h (id_id)
 grid_config_rec % inputout_end_m             = model_config_rec % inputout_end_m (id_id)
 grid_config_rec % inputout_end_s             = model_config_rec % inputout_end_s (id_id)
 grid_config_rec % simulation_start_year      = model_config_rec % simulation_start_year 
 grid_config_rec % simulation_start_month     = model_config_rec % simulation_start_month 
 grid_config_rec % simulation_start_day       = model_config_rec % simulation_start_day 
 grid_config_rec % simulation_start_hour      = model_config_rec % simulation_start_hour 
 grid_config_rec % simulation_start_minute    = model_config_rec % simulation_start_minute 
 grid_config_rec % simulation_start_second    = model_config_rec % simulation_start_second 
 grid_config_rec % reset_simulation_start     = model_config_rec % reset_simulation_start 
 grid_config_rec % sr_x                       = model_config_rec % sr_x (id_id)
 grid_config_rec % sr_y                       = model_config_rec % sr_y (id_id)
 grid_config_rec % sgfdda_inname              = model_config_rec % sgfdda_inname 
 grid_config_rec % gfdda_inname               = model_config_rec % gfdda_inname 
 grid_config_rec % sgfdda_interval_d          = model_config_rec % sgfdda_interval_d (id_id)
 grid_config_rec % sgfdda_interval_h          = model_config_rec % sgfdda_interval_h (id_id)
 grid_config_rec % sgfdda_interval_m          = model_config_rec % sgfdda_interval_m (id_id)
 grid_config_rec % sgfdda_interval_s          = model_config_rec % sgfdda_interval_s (id_id)
 grid_config_rec % sgfdda_interval_y          = model_config_rec % sgfdda_interval_y (id_id)
 grid_config_rec % sgfdda_interval            = model_config_rec % sgfdda_interval (id_id)
 grid_config_rec % gfdda_interval_d           = model_config_rec % gfdda_interval_d (id_id)
 grid_config_rec % gfdda_interval_h           = model_config_rec % gfdda_interval_h (id_id)
 grid_config_rec % gfdda_interval_m           = model_config_rec % gfdda_interval_m (id_id)
 grid_config_rec % gfdda_interval_s           = model_config_rec % gfdda_interval_s (id_id)
 grid_config_rec % gfdda_interval_y           = model_config_rec % gfdda_interval_y (id_id)
 grid_config_rec % gfdda_interval             = model_config_rec % gfdda_interval (id_id)
 grid_config_rec % sgfdda_begin_y             = model_config_rec % sgfdda_begin_y (id_id)
 grid_config_rec % sgfdda_begin_d             = model_config_rec % sgfdda_begin_d (id_id)
 grid_config_rec % sgfdda_begin_h             = model_config_rec % sgfdda_begin_h (id_id)
 grid_config_rec % sgfdda_begin_m             = model_config_rec % sgfdda_begin_m (id_id)
 grid_config_rec % sgfdda_begin_s             = model_config_rec % sgfdda_begin_s (id_id)
 grid_config_rec % gfdda_begin_y              = model_config_rec % gfdda_begin_y (id_id)
 grid_config_rec % gfdda_begin_d              = model_config_rec % gfdda_begin_d (id_id)
 grid_config_rec % gfdda_begin_h              = model_config_rec % gfdda_begin_h (id_id)
 grid_config_rec % gfdda_begin_m              = model_config_rec % gfdda_begin_m (id_id)
 grid_config_rec % gfdda_begin_s              = model_config_rec % gfdda_begin_s (id_id)
 grid_config_rec % sgfdda_end_y               = model_config_rec % sgfdda_end_y (id_id)
 grid_config_rec % sgfdda_end_d               = model_config_rec % sgfdda_end_d (id_id)
 grid_config_rec % sgfdda_end_h               = model_config_rec % sgfdda_end_h (id_id)
 grid_config_rec % sgfdda_end_m               = model_config_rec % sgfdda_end_m (id_id)
 grid_config_rec % sgfdda_end_s               = model_config_rec % sgfdda_end_s (id_id)
 grid_config_rec % gfdda_end_y                = model_config_rec % gfdda_end_y (id_id)
 grid_config_rec % gfdda_end_d                = model_config_rec % gfdda_end_d (id_id)
 grid_config_rec % gfdda_end_h                = model_config_rec % gfdda_end_h (id_id)
 grid_config_rec % gfdda_end_m                = model_config_rec % gfdda_end_m (id_id)
 grid_config_rec % gfdda_end_s                = model_config_rec % gfdda_end_s (id_id)
 grid_config_rec % io_form_sgfdda             = model_config_rec % io_form_sgfdda 
 grid_config_rec % io_form_gfdda              = model_config_rec % io_form_gfdda 
 grid_config_rec % iofields_filename          = model_config_rec % iofields_filename (id_id)
 grid_config_rec % ignore_iofields_warning    = model_config_rec % ignore_iofields_warning 
 grid_config_rec % ncd_nofill                 = model_config_rec % ncd_nofill 
 grid_config_rec % ifire                      = model_config_rec % ifire (id_id)
 grid_config_rec % fire_boundary_guard        = model_config_rec % fire_boundary_guard (id_id)
 grid_config_rec % fire_num_ignitions         = model_config_rec % fire_num_ignitions (id_id)
 grid_config_rec % fire_ignition_ros1         = model_config_rec % fire_ignition_ros1 (id_id)
 grid_config_rec % fire_ignition_start_lon1   = model_config_rec % fire_ignition_start_lon1 (id_id)
 grid_config_rec % fire_ignition_start_lat1   = model_config_rec % fire_ignition_start_lat1 (id_id)
 grid_config_rec % fire_ignition_end_lon1     = model_config_rec % fire_ignition_end_lon1 (id_id)
 grid_config_rec % fire_ignition_end_lat1     = model_config_rec % fire_ignition_end_lat1 (id_id)
 grid_config_rec % fire_ignition_radius1      = model_config_rec % fire_ignition_radius1 (id_id)
 grid_config_rec % fire_ignition_start_time1  = model_config_rec % fire_ignition_start_time1 (id_id)
 grid_config_rec % fire_ignition_end_time1    = model_config_rec % fire_ignition_end_time1 (id_id)
 grid_config_rec % fire_ignition_ros2         = model_config_rec % fire_ignition_ros2 (id_id)
 grid_config_rec % fire_ignition_start_lon2   = model_config_rec % fire_ignition_start_lon2 (id_id)
 grid_config_rec % fire_ignition_start_lat2   = model_config_rec % fire_ignition_start_lat2 (id_id)
 grid_config_rec % fire_ignition_end_lon2     = model_config_rec % fire_ignition_end_lon2 (id_id)
 grid_config_rec % fire_ignition_end_lat2     = model_config_rec % fire_ignition_end_lat2 (id_id)
 grid_config_rec % fire_ignition_radius2      = model_config_rec % fire_ignition_radius2 (id_id)
 grid_config_rec % fire_ignition_start_time2  = model_config_rec % fire_ignition_start_time2 (id_id)
 grid_config_rec % fire_ignition_end_time2    = model_config_rec % fire_ignition_end_time2 (id_id)
 grid_config_rec % fire_ignition_ros3         = model_config_rec % fire_ignition_ros3 (id_id)
 grid_config_rec % fire_ignition_start_lon3   = model_config_rec % fire_ignition_start_lon3 (id_id)
 grid_config_rec % fire_ignition_start_lat3   = model_config_rec % fire_ignition_start_lat3 (id_id)
 grid_config_rec % fire_ignition_end_lon3     = model_config_rec % fire_ignition_end_lon3 (id_id)
 grid_config_rec % fire_ignition_end_lat3     = model_config_rec % fire_ignition_end_lat3 (id_id)
 grid_config_rec % fire_ignition_radius3      = model_config_rec % fire_ignition_radius3 (id_id)
 grid_config_rec % fire_ignition_start_time3  = model_config_rec % fire_ignition_start_time3 (id_id)
 grid_config_rec % fire_ignition_end_time3    = model_config_rec % fire_ignition_end_time3 (id_id)
 grid_config_rec % fire_ignition_ros4         = model_config_rec % fire_ignition_ros4 (id_id)
 grid_config_rec % fire_ignition_start_lon4   = model_config_rec % fire_ignition_start_lon4 (id_id)
 grid_config_rec % fire_ignition_start_lat4   = model_config_rec % fire_ignition_start_lat4 (id_id)
 grid_config_rec % fire_ignition_end_lon4     = model_config_rec % fire_ignition_end_lon4 (id_id)
 grid_config_rec % fire_ignition_end_lat4     = model_config_rec % fire_ignition_end_lat4 (id_id)
 grid_config_rec % fire_ignition_radius4      = model_config_rec % fire_ignition_radius4 (id_id)
 grid_config_rec % fire_ignition_start_time4  = model_config_rec % fire_ignition_start_time4 (id_id)
 grid_config_rec % fire_ignition_end_time4    = model_config_rec % fire_ignition_end_time4 (id_id)
 grid_config_rec % fire_ignition_ros5         = model_config_rec % fire_ignition_ros5 (id_id)
 grid_config_rec % fire_ignition_start_lon5   = model_config_rec % fire_ignition_start_lon5 (id_id)
 grid_config_rec % fire_ignition_start_lat5   = model_config_rec % fire_ignition_start_lat5 (id_id)
 grid_config_rec % fire_ignition_end_lon5     = model_config_rec % fire_ignition_end_lon5 (id_id)
 grid_config_rec % fire_ignition_end_lat5     = model_config_rec % fire_ignition_end_lat5 (id_id)
 grid_config_rec % fire_ignition_radius5      = model_config_rec % fire_ignition_radius5 (id_id)
 grid_config_rec % fire_ignition_start_time5  = model_config_rec % fire_ignition_start_time5 (id_id)
 grid_config_rec % fire_ignition_end_time5    = model_config_rec % fire_ignition_end_time5 (id_id)
 grid_config_rec % fire_ignition_start_x1     = model_config_rec % fire_ignition_start_x1 (id_id)
 grid_config_rec % fire_ignition_start_y1     = model_config_rec % fire_ignition_start_y1 (id_id)
 grid_config_rec % fire_ignition_end_x1       = model_config_rec % fire_ignition_end_x1 (id_id)
 grid_config_rec % fire_ignition_end_y1       = model_config_rec % fire_ignition_end_y1 (id_id)
 grid_config_rec % fire_ignition_start_x2     = model_config_rec % fire_ignition_start_x2 (id_id)
 grid_config_rec % fire_ignition_start_y2     = model_config_rec % fire_ignition_start_y2 (id_id)
 grid_config_rec % fire_ignition_end_x2       = model_config_rec % fire_ignition_end_x2 (id_id)
 grid_config_rec % fire_ignition_end_y2       = model_config_rec % fire_ignition_end_y2 (id_id)
 grid_config_rec % fire_ignition_start_x3     = model_config_rec % fire_ignition_start_x3 (id_id)
 grid_config_rec % fire_ignition_start_y3     = model_config_rec % fire_ignition_start_y3 (id_id)
 grid_config_rec % fire_ignition_end_x3       = model_config_rec % fire_ignition_end_x3 (id_id)
 grid_config_rec % fire_ignition_end_y3       = model_config_rec % fire_ignition_end_y3 (id_id)
 grid_config_rec % fire_ignition_start_x4     = model_config_rec % fire_ignition_start_x4 (id_id)
 grid_config_rec % fire_ignition_start_y4     = model_config_rec % fire_ignition_start_y4 (id_id)
 grid_config_rec % fire_ignition_end_x4       = model_config_rec % fire_ignition_end_x4 (id_id)
 grid_config_rec % fire_ignition_end_y4       = model_config_rec % fire_ignition_end_y4 (id_id)
 grid_config_rec % fire_ignition_start_x5     = model_config_rec % fire_ignition_start_x5 (id_id)
 grid_config_rec % fire_ignition_start_y5     = model_config_rec % fire_ignition_start_y5 (id_id)
 grid_config_rec % fire_ignition_end_x5       = model_config_rec % fire_ignition_end_x5 (id_id)
 grid_config_rec % fire_ignition_end_y5       = model_config_rec % fire_ignition_end_y5 (id_id)
 grid_config_rec % fire_lat_init              = model_config_rec % fire_lat_init (id_id)
 grid_config_rec % fire_lon_init              = model_config_rec % fire_lon_init (id_id)
 grid_config_rec % fire_ign_time              = model_config_rec % fire_ign_time (id_id)
 grid_config_rec % fire_shape                 = model_config_rec % fire_shape (id_id)
 grid_config_rec % fire_sprd_mdl              = model_config_rec % fire_sprd_mdl (id_id)
 grid_config_rec % fire_crwn_hgt              = model_config_rec % fire_crwn_hgt (id_id)
 grid_config_rec % fire_ext_grnd              = model_config_rec % fire_ext_grnd (id_id)
 grid_config_rec % fire_ext_crwn              = model_config_rec % fire_ext_crwn (id_id)
 grid_config_rec % fire_wind_height           = model_config_rec % fire_wind_height (id_id)
 grid_config_rec % fire_fuel_read             = model_config_rec % fire_fuel_read (id_id)
 grid_config_rec % fire_fuel_cat              = model_config_rec % fire_fuel_cat (id_id)
 grid_config_rec % fire_print_msg             = model_config_rec % fire_print_msg (id_id)
 grid_config_rec % fire_print_file            = model_config_rec % fire_print_file (id_id)
 grid_config_rec % fire_fuel_left_method      = model_config_rec % fire_fuel_left_method (id_id)
 grid_config_rec % fire_fuel_left_irl         = model_config_rec % fire_fuel_left_irl (id_id)
 grid_config_rec % fire_fuel_left_jrl         = model_config_rec % fire_fuel_left_jrl (id_id)
 grid_config_rec % fire_grows_only            = model_config_rec % fire_grows_only (id_id)
 grid_config_rec % fire_upwinding             = model_config_rec % fire_upwinding (id_id)
 grid_config_rec % fire_upwind_split          = model_config_rec % fire_upwind_split (id_id)
 grid_config_rec % fire_viscosity             = model_config_rec % fire_viscosity (id_id)
 grid_config_rec % fire_lfn_ext_up            = model_config_rec % fire_lfn_ext_up (id_id)
 grid_config_rec % fire_topo_from_atm         = model_config_rec % fire_topo_from_atm (id_id)
 grid_config_rec % fire_advection             = model_config_rec % fire_advection (id_id)
 grid_config_rec % fire_test_steps            = model_config_rec % fire_test_steps (id_id)
 grid_config_rec % fire_const_time            = model_config_rec % fire_const_time (id_id)
 grid_config_rec % fire_const_grnhfx          = model_config_rec % fire_const_grnhfx (id_id)
 grid_config_rec % fire_const_grnqfx          = model_config_rec % fire_const_grnqfx (id_id)
 grid_config_rec % fire_atm_feedback          = model_config_rec % fire_atm_feedback (id_id)
 grid_config_rec % fire_mountain_type         = model_config_rec % fire_mountain_type (id_id)
 grid_config_rec % fire_mountain_height       = model_config_rec % fire_mountain_height (id_id)
 grid_config_rec % fire_mountain_start_x      = model_config_rec % fire_mountain_start_x (id_id)
 grid_config_rec % fire_mountain_start_y      = model_config_rec % fire_mountain_start_y (id_id)
 grid_config_rec % fire_mountain_end_x        = model_config_rec % fire_mountain_end_x (id_id)
 grid_config_rec % fire_mountain_end_y        = model_config_rec % fire_mountain_end_y (id_id)
 grid_config_rec % delt_perturbation          = model_config_rec % delt_perturbation (id_id)
 grid_config_rec % xrad_perturbation          = model_config_rec % xrad_perturbation (id_id)
 grid_config_rec % yrad_perturbation          = model_config_rec % yrad_perturbation (id_id)
 grid_config_rec % zrad_perturbation          = model_config_rec % zrad_perturbation (id_id)
 grid_config_rec % hght_perturbation          = model_config_rec % hght_perturbation (id_id)
 grid_config_rec % stretch_grd                = model_config_rec % stretch_grd (id_id)
 grid_config_rec % stretch_hyp                = model_config_rec % stretch_hyp (id_id)
 grid_config_rec % z_grd_scale                = model_config_rec % z_grd_scale (id_id)
 grid_config_rec % sfc_full_init              = model_config_rec % sfc_full_init (id_id)
 grid_config_rec % sfc_lu_index               = model_config_rec % sfc_lu_index (id_id)
 grid_config_rec % sfc_tsk                    = model_config_rec % sfc_tsk (id_id)
 grid_config_rec % sfc_tmn                    = model_config_rec % sfc_tmn (id_id)
 grid_config_rec % fire_read_lu               = model_config_rec % fire_read_lu (id_id)
 grid_config_rec % fire_read_tsk              = model_config_rec % fire_read_tsk (id_id)
 grid_config_rec % fire_read_tmn              = model_config_rec % fire_read_tmn (id_id)
 grid_config_rec % fire_read_atm_ht           = model_config_rec % fire_read_atm_ht (id_id)
 grid_config_rec % fire_read_fire_ht          = model_config_rec % fire_read_fire_ht (id_id)
 grid_config_rec % fire_read_atm_grad         = model_config_rec % fire_read_atm_grad (id_id)
 grid_config_rec % fire_read_fire_grad        = model_config_rec % fire_read_fire_grad (id_id)
 grid_config_rec % sfc_vegfra                 = model_config_rec % sfc_vegfra (id_id)
 grid_config_rec % sfc_canwat                 = model_config_rec % sfc_canwat (id_id)
 grid_config_rec % sfc_ivgtyp                 = model_config_rec % sfc_ivgtyp (id_id)
 grid_config_rec % sfc_isltyp                 = model_config_rec % sfc_isltyp (id_id)
 grid_config_rec % fire_lsm_reinit            = model_config_rec % fire_lsm_reinit (id_id)
 grid_config_rec % fire_lsm_reinit_iter       = model_config_rec % fire_lsm_reinit_iter (id_id)
 grid_config_rec % fire_upwinding_reinit      = model_config_rec % fire_upwinding_reinit (id_id)
 grid_config_rec % fire_is_real_perim         = model_config_rec % fire_is_real_perim (id_id)
 grid_config_rec % fire_lsm_band_ngp          = model_config_rec % fire_lsm_band_ngp (id_id)
 grid_config_rec % fire_lsm_zcoupling         = model_config_rec % fire_lsm_zcoupling (id_id)
 grid_config_rec % fire_lsm_zcoupling_ref     = model_config_rec % fire_lsm_zcoupling_ref (id_id)
 grid_config_rec % fire_tracer_smoke          = model_config_rec % fire_tracer_smoke (id_id)
 grid_config_rec % fire_viscosity_bg          = model_config_rec % fire_viscosity_bg (id_id)
 grid_config_rec % fire_viscosity_band        = model_config_rec % fire_viscosity_band (id_id)
 grid_config_rec % fire_viscosity_ngp         = model_config_rec % fire_viscosity_ngp (id_id)
 grid_config_rec % fire_slope_factor          = model_config_rec % fire_slope_factor (id_id)
 grid_config_rec % do_avgflx_em               = model_config_rec % do_avgflx_em (id_id)
 grid_config_rec % do_avgflx_cugd             = model_config_rec % do_avgflx_cugd (id_id)
 grid_config_rec % nens                       = model_config_rec % nens 
 grid_config_rec % skebs                      = model_config_rec % skebs (id_id)
 grid_config_rec % stoch_force_opt            = model_config_rec % stoch_force_opt (id_id)
 grid_config_rec % skebs_vertstruc            = model_config_rec % skebs_vertstruc 
 grid_config_rec % stoch_vertstruc_opt        = model_config_rec % stoch_vertstruc_opt (id_id)
 grid_config_rec % tot_backscat_psi           = model_config_rec % tot_backscat_psi (id_id)
 grid_config_rec % tot_backscat_t             = model_config_rec % tot_backscat_t (id_id)
 grid_config_rec % ztau_psi                   = model_config_rec % ztau_psi 
 grid_config_rec % ztau_t                     = model_config_rec % ztau_t 
 grid_config_rec % rexponent_psi              = model_config_rec % rexponent_psi 
 grid_config_rec % rexponent_t                = model_config_rec % rexponent_t 
 grid_config_rec % zsigma2_eps                = model_config_rec % zsigma2_eps 
 grid_config_rec % zsigma2_eta                = model_config_rec % zsigma2_eta 
 grid_config_rec % kminforc                   = model_config_rec % kminforc 
 grid_config_rec % lminforc                   = model_config_rec % lminforc 
 grid_config_rec % kminforct                  = model_config_rec % kminforct 
 grid_config_rec % lminforct                  = model_config_rec % lminforct 
 grid_config_rec % kmaxforc                   = model_config_rec % kmaxforc 
 grid_config_rec % lmaxforc                   = model_config_rec % lmaxforc 
 grid_config_rec % kmaxforct                  = model_config_rec % kmaxforct 
 grid_config_rec % lmaxforct                  = model_config_rec % lmaxforct 
 grid_config_rec % iseed_skebs                = model_config_rec % iseed_skebs 
 grid_config_rec % kmaxforch                  = model_config_rec % kmaxforch 
 grid_config_rec % lmaxforch                  = model_config_rec % lmaxforch 
 grid_config_rec % kmaxforcth                 = model_config_rec % kmaxforcth 
 grid_config_rec % lmaxforcth                 = model_config_rec % lmaxforcth 
 grid_config_rec % sppt                       = model_config_rec % sppt (id_id)
 grid_config_rec % gridpt_stddev_sppt         = model_config_rec % gridpt_stddev_sppt (id_id)
 grid_config_rec % stddev_cutoff_sppt         = model_config_rec % stddev_cutoff_sppt (id_id)
 grid_config_rec % lengthscale_sppt           = model_config_rec % lengthscale_sppt (id_id)
 grid_config_rec % timescale_sppt             = model_config_rec % timescale_sppt (id_id)
 grid_config_rec % sppt_vertstruc             = model_config_rec % sppt_vertstruc 
 grid_config_rec % iseed_sppt                 = model_config_rec % iseed_sppt 
 grid_config_rec % rand_perturb               = model_config_rec % rand_perturb (id_id)
 grid_config_rec % gridpt_stddev_rand_pert    = model_config_rec % gridpt_stddev_rand_pert (id_id)
 grid_config_rec % stddev_cutoff_rand_pert    = model_config_rec % stddev_cutoff_rand_pert (id_id)
 grid_config_rec % lengthscale_rand_pert      = model_config_rec % lengthscale_rand_pert (id_id)
 grid_config_rec % timescale_rand_pert        = model_config_rec % timescale_rand_pert (id_id)
 grid_config_rec % rand_pert_vertstruc        = model_config_rec % rand_pert_vertstruc 
 grid_config_rec % iseed_rand_pert            = model_config_rec % iseed_rand_pert 
 grid_config_rec % spp                        = model_config_rec % spp (id_id)
 grid_config_rec % hrrr_cycling               = model_config_rec % hrrr_cycling 
 grid_config_rec % spp_conv                   = model_config_rec % spp_conv (id_id)
 grid_config_rec % gridpt_stddev_spp_conv     = model_config_rec % gridpt_stddev_spp_conv (id_id)
 grid_config_rec % stddev_cutoff_spp_conv     = model_config_rec % stddev_cutoff_spp_conv (id_id)
 grid_config_rec % lengthscale_spp_conv       = model_config_rec % lengthscale_spp_conv (id_id)
 grid_config_rec % timescale_spp_conv         = model_config_rec % timescale_spp_conv (id_id)
 grid_config_rec % vertstruc_spp_conv         = model_config_rec % vertstruc_spp_conv 
 grid_config_rec % iseed_spp_conv             = model_config_rec % iseed_spp_conv 
 grid_config_rec % spp_pbl                    = model_config_rec % spp_pbl (id_id)
 grid_config_rec % gridpt_stddev_spp_pbl      = model_config_rec % gridpt_stddev_spp_pbl (id_id)
 grid_config_rec % stddev_cutoff_spp_pbl      = model_config_rec % stddev_cutoff_spp_pbl (id_id)
 grid_config_rec % lengthscale_spp_pbl        = model_config_rec % lengthscale_spp_pbl (id_id)
 grid_config_rec % timescale_spp_pbl          = model_config_rec % timescale_spp_pbl (id_id)
 grid_config_rec % vertstruc_spp_pbl          = model_config_rec % vertstruc_spp_pbl 
 grid_config_rec % iseed_spp_pbl              = model_config_rec % iseed_spp_pbl 
 grid_config_rec % spp_lsm                    = model_config_rec % spp_lsm (id_id)
 grid_config_rec % gridpt_stddev_spp_lsm      = model_config_rec % gridpt_stddev_spp_lsm (id_id)
 grid_config_rec % stddev_cutoff_spp_lsm      = model_config_rec % stddev_cutoff_spp_lsm (id_id)
 grid_config_rec % lengthscale_spp_lsm        = model_config_rec % lengthscale_spp_lsm (id_id)
 grid_config_rec % timescale_spp_lsm          = model_config_rec % timescale_spp_lsm (id_id)
 grid_config_rec % vertstruc_spp_lsm          = model_config_rec % vertstruc_spp_lsm 
 grid_config_rec % iseed_spp_lsm              = model_config_rec % iseed_spp_lsm 
 grid_config_rec % skebs_on                   = model_config_rec % skebs_on 
 grid_config_rec % sppt_on                    = model_config_rec % sppt_on 
 grid_config_rec % spp_on                     = model_config_rec % spp_on 
 grid_config_rec % rand_perturb_on            = model_config_rec % rand_perturb_on 
 grid_config_rec % num_stoch_levels           = model_config_rec % num_stoch_levels 
 grid_config_rec % seed_dim                   = model_config_rec % seed_dim 
 grid_config_rec % sfs_opt                    = model_config_rec % sfs_opt (id_id)
 grid_config_rec % m_opt                      = model_config_rec % m_opt (id_id)
 grid_config_rec % lakedepth_default          = model_config_rec % lakedepth_default (id_id)
 grid_config_rec % lake_min_elev              = model_config_rec % lake_min_elev (id_id)
 grid_config_rec % use_lakedepth              = model_config_rec % use_lakedepth (id_id)
 grid_config_rec % p_lev_diags                = model_config_rec % p_lev_diags 
 grid_config_rec % p_lev_diags_dfi            = model_config_rec % p_lev_diags_dfi 
 grid_config_rec % num_press_levels           = model_config_rec % num_press_levels 
 grid_config_rec % press_levels               = model_config_rec % press_levels (id_id)
 grid_config_rec % use_tot_or_hyd_p           = model_config_rec % use_tot_or_hyd_p 
 grid_config_rec % extrap_below_grnd          = model_config_rec % extrap_below_grnd 
 grid_config_rec % p_lev_missing              = model_config_rec % p_lev_missing 
 grid_config_rec % p_lev_interval             = model_config_rec % p_lev_interval (id_id)
 grid_config_rec % z_lev_diags                = model_config_rec % z_lev_diags 
 grid_config_rec % z_lev_diags_dfi            = model_config_rec % z_lev_diags_dfi 
 grid_config_rec % num_z_levels               = model_config_rec % num_z_levels 
 grid_config_rec % z_levels                   = model_config_rec % z_levels (id_id)
 grid_config_rec % z_lev_missing              = model_config_rec % z_lev_missing 
 grid_config_rec % z_lev_interval             = model_config_rec % z_lev_interval (id_id)
 grid_config_rec % afwa_diag_opt              = model_config_rec % afwa_diag_opt (id_id)
 grid_config_rec % afwa_ptype_opt             = model_config_rec % afwa_ptype_opt (id_id)
 grid_config_rec % afwa_vil_opt               = model_config_rec % afwa_vil_opt (id_id)
 grid_config_rec % afwa_radar_opt             = model_config_rec % afwa_radar_opt (id_id)
 grid_config_rec % afwa_severe_opt            = model_config_rec % afwa_severe_opt (id_id)
 grid_config_rec % afwa_icing_opt             = model_config_rec % afwa_icing_opt (id_id)
 grid_config_rec % afwa_vis_opt               = model_config_rec % afwa_vis_opt (id_id)
 grid_config_rec % afwa_cloud_opt             = model_config_rec % afwa_cloud_opt (id_id)
 grid_config_rec % afwa_therm_opt             = model_config_rec % afwa_therm_opt (id_id)
 grid_config_rec % afwa_turb_opt              = model_config_rec % afwa_turb_opt (id_id)
 grid_config_rec % afwa_buoy_opt              = model_config_rec % afwa_buoy_opt (id_id)
 grid_config_rec % afwa_ptype_ccn_tmp         = model_config_rec % afwa_ptype_ccn_tmp 
 grid_config_rec % afwa_ptype_tot_melt        = model_config_rec % afwa_ptype_tot_melt 
 grid_config_rec % afwa_bad_data_check        = model_config_rec % afwa_bad_data_check 
 grid_config_rec % mean_diag                  = model_config_rec % mean_diag 
 grid_config_rec % mean_freq                  = model_config_rec % mean_freq 
 grid_config_rec % mean_interval              = model_config_rec % mean_interval (id_id)
 grid_config_rec % mean_diag_interval         = model_config_rec % mean_diag_interval (id_id)
 grid_config_rec % mean_diag_interval_s       = model_config_rec % mean_diag_interval_s (id_id)
 grid_config_rec % mean_diag_interval_m       = model_config_rec % mean_diag_interval_m (id_id)
 grid_config_rec % mean_diag_interval_h       = model_config_rec % mean_diag_interval_h (id_id)
 grid_config_rec % mean_diag_interval_d       = model_config_rec % mean_diag_interval_d (id_id)
 grid_config_rec % mean_diag_interval_mo      = model_config_rec % mean_diag_interval_mo (id_id)
 grid_config_rec % diurnal_diag               = model_config_rec % diurnal_diag 
 grid_config_rec % nssl_ipelec                = model_config_rec % nssl_ipelec (id_id)
 grid_config_rec % nssl_isaund                = model_config_rec % nssl_isaund 
 grid_config_rec % nssl_iscreen               = model_config_rec % nssl_iscreen 
 grid_config_rec % nssl_lightrad              = model_config_rec % nssl_lightrad 
 grid_config_rec % nssl_idischarge            = model_config_rec % nssl_idischarge 
 grid_config_rec % nssl_ibrkd                 = model_config_rec % nssl_ibrkd 
 grid_config_rec % nssl_ecrit                 = model_config_rec % nssl_ecrit 
 grid_config_rec % nssl_disfrac               = model_config_rec % nssl_disfrac 
 grid_config_rec % elec_physics               = model_config_rec % elec_physics 
 grid_config_rec % perturb_bdy                = model_config_rec % perturb_bdy 
 grid_config_rec % perturb_chem_bdy           = model_config_rec % perturb_chem_bdy 
 grid_config_rec % hybrid_opt                 = model_config_rec % hybrid_opt 
 grid_config_rec % etac                       = model_config_rec % etac 
 grid_config_rec % num_wif_levels             = model_config_rec % num_wif_levels 
 grid_config_rec % wif_input_opt              = model_config_rec % wif_input_opt 
 grid_config_rec % diag_nwp2                  = model_config_rec % diag_nwp2 
 grid_config_rec % chem_opt                   = model_config_rec % chem_opt (id_id)

   END SUBROUTINE model_to_grid_config_rec


   FUNCTION in_use_for_config ( id, vname ) RESULT ( in_use )
     INTEGER, INTENT(IN) :: id
     CHARACTER*(*), INTENT(IN) :: vname
     LOGICAL in_use
     INTEGER uses

     uses = 0
     in_use = .TRUE.

     IF      ( vname(1:1) .EQ. 'a' ) THEN






IF(TRIM(vname).EQ.'acphys_tot')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'acphysc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'acphyse')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'acphysd')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'acphyss')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'acphysm')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'acphysf')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'abstot')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'absnxt')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'acswupt')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'acswuptc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'acswdnt')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'acswdntc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'acswupb')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'acswupbc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'acswdnb')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'acswdnbc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'aclwupt')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'aclwuptc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'aclwdnt')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'aclwdntc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'aclwupb')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'aclwupbc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'aclwdnb')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'aclwdnbc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'aclwupt')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'aclwuptc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'aclwdnt')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'aclwdntc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'aclwupb')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'aclwupbc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'aclwdnb')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'aclwdnbc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'aclwupt')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.14
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.14
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'aclwuptc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.14
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.14
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'aclwdnt')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.14
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.14
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'aclwdntc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.14
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.14
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'aclwupb')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.14
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.14
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'aclwupbc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.14
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.14
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'aclwdnb')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.14
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.14
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'aclwdnbc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.14
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.14
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'aclwupt')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.24
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.24
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'aclwuptc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.24
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.24
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'aclwdnt')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.24
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.24
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'aclwdntc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.24
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.24
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'aclwupb')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.24
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.24
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'aclwupbc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.24
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.24
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'aclwdnb')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.24
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.24
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'aclwdnbc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.24
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.24
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'abstot')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'absnxt')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'acswupt')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'acswuptc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'acswdnt')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'acswdntc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'acswupb')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'acswupbc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'acswdnb')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'acswdnbc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'aclwupt')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'aclwuptc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'aclwdnt')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'aclwdntc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'aclwupb')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'aclwupbc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'aclwdnb')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'aclwdnbc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'acswupt')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'acswuptc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'acswdnt')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'acswdntc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'acswupb')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'acswupbc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'acswdnb')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'acswdnbc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'acswupt')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.14
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.14
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'acswuptc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.14
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.14
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'acswdnt')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.14
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.14
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'acswdntc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.14
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.14
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'acswupb')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.14
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.14
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'acswupbc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.14
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.14
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'acswdnb')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.14
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.14
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'acswdnbc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.14
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.14
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'acswupt')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.24
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.24
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'acswuptc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.24
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.24
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'acswdnt')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.24
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.24
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'acswdntc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.24
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.24
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'acswupb')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.24
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.24
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'acswupbc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.24
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.24
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'acswdnb')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.24
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.24
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'acswdnbc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.24
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.24
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'a_u_bep')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'a_v_bep')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'a_t_bep')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'a_q_bep')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'a_e_bep')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'a_u_bep')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'a_v_bep')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'a_t_bep')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'a_q_bep')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'a_e_bep')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'a_u_bep')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'a_v_bep')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'a_t_bep')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'a_q_bep')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'a_e_bep')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'acrunoff')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'alboldxy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'aparxy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'areaxy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'albedosubgrid')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'albedo_mosaic')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_mosaic.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_mosaic.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'albbck_mosaic')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_mosaic.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_mosaic.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'aquad_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ainckfsa')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'aerodm')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%aer_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%aer_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'aod5503d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%aer_opt.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%aer_opt.EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'aeromcu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%aercu_used.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%aercu_used.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'aerovar')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%aercu_used.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%aercu_used.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'albsi')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%seaice_albedo_opt.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%seaice_albedo_opt.EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'avg_fuel_frac')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ifire(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ifire(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'avgflx_rum')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%do_avgflx_em(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%do_avgflx_em(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'avgflx_rvm')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%do_avgflx_em(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%do_avgflx_em(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'avgflx_wwm')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%do_avgflx_em(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%do_avgflx_em(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'avgflx_cfu1')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%do_avgflx_cugd(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%do_avgflx_cugd(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'avgflx_cfd1')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%do_avgflx_cugd(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%do_avgflx_cugd(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'avgflx_dfu1')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%do_avgflx_cugd(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%do_avgflx_cugd(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'avgflx_efu1')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%do_avgflx_cugd(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%do_avgflx_cugd(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'avgflx_dfd1')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%do_avgflx_cugd(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%do_avgflx_cugd(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'avgflx_efd1')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%do_avgflx_cugd(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%do_avgflx_cugd(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'afwa_mslp')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%afwa_diag_opt(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%afwa_diag_opt(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'afwa_pwat')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%afwa_diag_opt(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%afwa_diag_opt(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'afwa_precip')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%afwa_diag_opt(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%afwa_diag_opt(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'afwa_totprecip')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%afwa_diag_opt(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%afwa_diag_opt(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'afwa_rain')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%afwa_ptype_opt(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%afwa_ptype_opt(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'afwa_snow')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%afwa_ptype_opt(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%afwa_ptype_opt(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'afwa_ice')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%afwa_ptype_opt(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%afwa_ptype_opt(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'afwa_fzra')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%afwa_ptype_opt(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%afwa_ptype_opt(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'afwa_snowfall')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%afwa_ptype_opt(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%afwa_ptype_opt(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'afwa_hail')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%afwa_severe_opt(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%afwa_severe_opt(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'afwa_cape')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%afwa_severe_opt(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%afwa_severe_opt(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'afwa_zlfc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%afwa_severe_opt(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%afwa_severe_opt(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'afwa_plfc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%afwa_severe_opt(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%afwa_severe_opt(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'afwa_lidx')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%afwa_severe_opt(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%afwa_severe_opt(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'afwa_cin')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%afwa_severe_opt(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%afwa_severe_opt(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'afwa_tornado')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%afwa_severe_opt(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%afwa_severe_opt(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'afwa_llws')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%afwa_severe_opt(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%afwa_severe_opt(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'afwa_cloud')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%afwa_cloud_opt(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%afwa_cloud_opt(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'afwa_cloud_ceil')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%afwa_cloud_opt(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%afwa_cloud_opt(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'afwa_vis')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%afwa_vis_opt(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%afwa_vis_opt(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'afwa_vis_dust')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%afwa_vis_opt(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%afwa_vis_opt(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'afwa_vis_alpha')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%afwa_vis_opt(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%afwa_vis_opt(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'afwa_heatidx')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%afwa_therm_opt(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%afwa_therm_opt(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'afwa_wchill')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%afwa_therm_opt(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%afwa_therm_opt(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'afwa_fits')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%afwa_therm_opt(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%afwa_therm_opt(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'afwa_turb')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%afwa_turb_opt(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%afwa_turb_opt(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'afwa_llturb')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%afwa_turb_opt(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%afwa_turb_opt(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'afwa_llturblgt')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%afwa_turb_opt(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%afwa_turb_opt(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'afwa_llturbmdt')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%afwa_turb_opt(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%afwa_turb_opt(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'afwa_llturbsvr')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%afwa_turb_opt(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%afwa_turb_opt(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'afwa_tlyrbot')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%afwa_turb_opt(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%afwa_turb_opt(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'afwa_tlyrtop')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%afwa_turb_opt(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%afwa_turb_opt(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'afwa_cape')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%afwa_buoy_opt(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%afwa_buoy_opt(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'afwa_zlfc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%afwa_buoy_opt(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%afwa_buoy_opt(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'afwa_plfc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%afwa_buoy_opt(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%afwa_buoy_opt(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'afwa_lidx')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%afwa_buoy_opt(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%afwa_buoy_opt(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'afwa_cape_mu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%afwa_buoy_opt(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%afwa_buoy_opt(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'afwa_cin')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%afwa_buoy_opt(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%afwa_buoy_opt(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'afwa_cin_mu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%afwa_buoy_opt(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%afwa_buoy_opt(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'albedo12m')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'albedo12m')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.2
  ENDIF
ENDIF

     ELSE IF ( vname(1:1) .EQ. 'b' ) THEN






IF(TRIM(vname).EQ.'b_u_bep')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'b_v_bep')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'b_t_bep')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'b_q_bep')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'b_e_bep')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'b_u_bep')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'b_v_bep')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'b_t_bep')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'b_q_bep')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'b_e_bep')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'b_u_bep')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'b_v_bep')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'b_t_bep')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'b_q_bep')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'b_e_bep')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'bgapxy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'bwo1')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.8
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.8
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'bto1')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.8
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.8
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'bio1')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.8
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.8
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'blo1')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.8
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.8
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'bwo2')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.8
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.8
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'bto2')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.8
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.8
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'bio2')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.8
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.8
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'blo2')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.8
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.8
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'bwo3')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.8
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.8
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'bto3')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.8
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.8
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'bio3')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.8
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.8
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'blo3')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.8
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.8
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'bwo4')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.8
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.8
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'bto4')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.8
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.8
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'bio4')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.8
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.8
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'blo4')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.8
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.8
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'bquad_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'bogbot_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'bogtop_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'bbb')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ifire(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ifire(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'betafl')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ifire(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ifire(id).EQ.2
  ENDIF
ENDIF

     ELSE IF ( vname(1:1) .EQ. 'c' ) THEN






IF(TRIM(vname).EQ.'cldfra_old_mp')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.11
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.11
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'cldfra_mp')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.11
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.11
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'cldfra_mp_all')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.11
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.11
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'cldfra_conv')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.11
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.11
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'cldfrai')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.11
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.11
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'cldfral')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.11
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.11
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ccn1_gs')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.40
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.40
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ccn2_gs')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.40
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.40
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ccn3_gs')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.40
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.40
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ccn4_gs')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.40
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.40
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ccn5_gs')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.40
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.40
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ccn6_gs')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.40
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.40
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ccn7_gs')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.40
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.40
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'cod2d_out')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ctop2d_out')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'cod2d_out')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ctop2d_out')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'cmcr_urb2d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'cmgr_sfcdif')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'chgr_sfcdif')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'cm_ac_urb3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'canliqxy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'canicexy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'cmxy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'chxy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'chvxy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'chbxy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'chleafxy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'chucxy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'chv2xy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'chb2xy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'chstarxy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'croptype')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'cropcat')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'canfra')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'clay_px')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'csand_px')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'cto1')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.8
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.8
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'cto2')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.8
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.8
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'cto3')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.8
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.8
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'cto4')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.8
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.8
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'canwat_mosaic')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_mosaic.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_mosaic.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'cov')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bl_pbl_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bl_pbl_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'cov')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bl_pbl_physics(id).EQ.6
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bl_pbl_physics(id).EQ.6
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'cf3d_temf')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bl_pbl_physics(id).EQ.10
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bl_pbl_physics(id).EQ.10
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'cfm_temf')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bl_pbl_physics(id).EQ.10
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bl_pbl_physics(id).EQ.10
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'cldfra_bl')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%icloud_bl.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%icloud_bl.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'cugd_qvten')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'cugd_tten')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'cugd_qvtens')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'cugd_ttens')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'cugd_qcten')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'cugd_qvten')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'cugd_tten')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'cugd_qvtens')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'cugd_ttens')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'cugd_qcten')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'cmfmc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'cmfmcdzm')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'cape')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'cldfratend_cup')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_physics(id).EQ.10
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_physics(id).EQ.10
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'cldfra_cup')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_physics(id).EQ.10
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_physics(id).EQ.10
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'cldfra_old')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cam_used.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cam_used.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'cmfmc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'cmfmc2')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'cbmf_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'cin_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'cinlcl_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'cbmflimit_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'cufrc_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'cquad_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'cmfsl')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'cmflq')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'cldfrash')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'cush')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'cldareaa')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'cldareab')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ca_rad')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'cw_rad')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'cldliqa')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'cldliqb')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'clddpthb')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'cldtopb')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'capesave')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'cu_uaf')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%aercu_used.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%aercu_used.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ccn_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%aercu_used.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%aercu_used.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'cg_flashcount')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%lightning_option(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%lightning_option(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'cg_flashrate')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%lightning_option(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%lightning_option(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'cg_flashcount')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%lightning_option(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%lightning_option(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'cg_flashrate')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%lightning_option(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%lightning_option(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'cg_flashcount')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%lightning_option(id).EQ.11
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%lightning_option(id).EQ.11
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'cg_flashrate')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%lightning_option(id).EQ.11
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%lightning_option(id).EQ.11
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'canhfx')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ifire(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ifire(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'canqfx')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ifire(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ifire(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'cfu1')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%do_avgflx_cugd(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%do_avgflx_cugd(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'cfd1')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%do_avgflx_cugd(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%do_avgflx_cugd(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'csol3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_lake_physics(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_lake_physics(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'cl_gc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'cf_gc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF

     ELSE IF ( vname(1:1) .EQ. 'd' ) THEN






IF(TRIM(vname).EQ.'dp3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.11
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.11
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dlf')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.11
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.11
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dlf2')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.11
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.11
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'di3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.50
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.50
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'di3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.51
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.51
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'di3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.52
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.52
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'di3d_2')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.52
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.52
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'di3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.55
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.55
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'di3d_2')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.55
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.55
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'di3d_3')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.55
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.55
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_re_cloud')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics_dfi(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics_dfi(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_re_ice')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics_dfi(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics_dfi(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_re_snow')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics_dfi(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics_dfi(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_re_cloud')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics_dfi(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics_dfi(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_re_ice')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics_dfi(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics_dfi(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_re_snow')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics_dfi(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics_dfi(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_re_cloud')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics_dfi(id).EQ.6
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics_dfi(id).EQ.6
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_re_ice')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics_dfi(id).EQ.6
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics_dfi(id).EQ.6
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_re_snow')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics_dfi(id).EQ.6
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics_dfi(id).EQ.6
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_re_cloud_gsfc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics_dfi(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics_dfi(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_re_rain_gsfc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics_dfi(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics_dfi(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_re_ice_gsfc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics_dfi(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics_dfi(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_re_snow_gsfc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics_dfi(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics_dfi(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_re_graupel_gsfc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics_dfi(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics_dfi(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_re_hail_gsfc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics_dfi(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics_dfi(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_re_cloud')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics_dfi(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics_dfi(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_re_ice')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics_dfi(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics_dfi(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_re_snow')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics_dfi(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics_dfi(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_re_cloud')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics_dfi(id).EQ.8
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics_dfi(id).EQ.8
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_re_ice')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics_dfi(id).EQ.8
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics_dfi(id).EQ.8
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_re_snow')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics_dfi(id).EQ.8
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics_dfi(id).EQ.8
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_re_cloud')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics_dfi(id).EQ.14
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics_dfi(id).EQ.14
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_re_ice')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics_dfi(id).EQ.14
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics_dfi(id).EQ.14
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_re_snow')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics_dfi(id).EQ.14
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics_dfi(id).EQ.14
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_re_cloud')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics_dfi(id).EQ.16
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics_dfi(id).EQ.16
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_re_ice')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics_dfi(id).EQ.16
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics_dfi(id).EQ.16
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_re_snow')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics_dfi(id).EQ.16
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics_dfi(id).EQ.16
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_re_cloud')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics_dfi(id).EQ.17
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics_dfi(id).EQ.17
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_re_ice')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics_dfi(id).EQ.17
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics_dfi(id).EQ.17
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_re_snow')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics_dfi(id).EQ.17
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics_dfi(id).EQ.17
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_re_cloud')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics_dfi(id).EQ.18
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics_dfi(id).EQ.18
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_re_ice')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics_dfi(id).EQ.18
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics_dfi(id).EQ.18
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_re_snow')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics_dfi(id).EQ.18
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics_dfi(id).EQ.18
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_re_cloud')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics_dfi(id).EQ.24
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics_dfi(id).EQ.24
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_re_ice')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics_dfi(id).EQ.24
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics_dfi(id).EQ.24
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_re_snow')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics_dfi(id).EQ.24
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics_dfi(id).EQ.24
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_re_cloud')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics_dfi(id).EQ.26
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics_dfi(id).EQ.26
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_re_ice')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics_dfi(id).EQ.26
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics_dfi(id).EQ.26
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_re_snow')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics_dfi(id).EQ.26
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics_dfi(id).EQ.26
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_re_cloud')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics_dfi(id).EQ.28
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics_dfi(id).EQ.28
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_re_ice')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics_dfi(id).EQ.28
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics_dfi(id).EQ.28
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_re_snow')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics_dfi(id).EQ.28
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics_dfi(id).EQ.28
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_re_cloud')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics_dfi(id).EQ.50
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics_dfi(id).EQ.50
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_re_ice')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics_dfi(id).EQ.50
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics_dfi(id).EQ.50
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_re_cloud')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics_dfi(id).EQ.51
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics_dfi(id).EQ.51
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_re_ice')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics_dfi(id).EQ.51
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics_dfi(id).EQ.51
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_re_cloud')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics_dfi(id).EQ.52
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics_dfi(id).EQ.52
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_re_ice')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics_dfi(id).EQ.52
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics_dfi(id).EQ.52
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_re_cloud')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics_dfi(id).EQ.55
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics_dfi(id).EQ.55
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_re_ice')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics_dfi(id).EQ.55
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics_dfi(id).EQ.55
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dlg_bep')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dl_u_bep')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'drelr_urb2d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'drelb_urb2d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'drelg_urb2d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dlg_bep')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dl_u_bep')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dlg_bep')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dl_u_bep')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'deeprechxy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dzsnow1')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dzsnow2')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dzsnow3')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dzsnow4')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dzsnow5')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dzo1')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.8
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.8
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dzo2')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.8
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.8
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dzo3')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.8
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.8
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dzo4')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.8
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.8
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'detr_edkf')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bl_pbl_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bl_pbl_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dqke')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bl_mynn_tkebudget(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bl_mynn_tkebudget(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dp3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'du3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dsubcld2d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dlf')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ddr_kf')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%kf_edrates(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%kf_edrates(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'der_kf')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%kf_edrates(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%kf_edrates(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dlf')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dlf2')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dwten_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'diten_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfgdp')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%grav_settling(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%grav_settling(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfgdp')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%grav_settling(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%grav_settling(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dif_analysis')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%grid_fdda(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%grid_fdda(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dif_xxx')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%grid_fdda(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%grid_fdda(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dif_yyy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%grid_fdda(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%grid_fdda(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dtaux3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%gwd_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%gwd_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dtauy3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%gwd_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%gwd_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dusfcg')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%gwd_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%gwd_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dvsfcg')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%gwd_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%gwd_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_u')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%dfi_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%dfi_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_v')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%dfi_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%dfi_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_w')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%dfi_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%dfi_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_ph')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%dfi_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%dfi_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_phb')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%dfi_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%dfi_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_ph0')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%dfi_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%dfi_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_php')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%dfi_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%dfi_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_t')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%dfi_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%dfi_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_p')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%dfi_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%dfi_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_ww')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%dfi_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%dfi_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_mu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%dfi_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%dfi_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_tke')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%dfi_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%dfi_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_pb')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%dfi_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%dfi_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_al')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%dfi_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%dfi_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_alt')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%dfi_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%dfi_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_tslb')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%dfi_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%dfi_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_smois')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%dfi_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%dfi_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_snow')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%dfi_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%dfi_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_snowh')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%dfi_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%dfi_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_canwat')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%dfi_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%dfi_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_smfr3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%dfi_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%dfi_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_keepfr3dflag')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%dfi_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%dfi_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_tsk')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%dfi_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%dfi_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_soilt1')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%dfi_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%dfi_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_tsnav')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%dfi_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%dfi_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_snowc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%dfi_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%dfi_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_qvg')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%dfi_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%dfi_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_rh')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%dfi_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%dfi_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_tten_rad')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%dfi_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%dfi_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_u')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%dfi_opt.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%dfi_opt.EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_v')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%dfi_opt.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%dfi_opt.EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_w')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%dfi_opt.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%dfi_opt.EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_ph')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%dfi_opt.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%dfi_opt.EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_phb')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%dfi_opt.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%dfi_opt.EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_ph0')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%dfi_opt.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%dfi_opt.EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_php')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%dfi_opt.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%dfi_opt.EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_t')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%dfi_opt.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%dfi_opt.EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_p')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%dfi_opt.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%dfi_opt.EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_ww')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%dfi_opt.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%dfi_opt.EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_mu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%dfi_opt.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%dfi_opt.EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_tke')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%dfi_opt.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%dfi_opt.EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_pb')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%dfi_opt.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%dfi_opt.EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_al')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%dfi_opt.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%dfi_opt.EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_alt')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%dfi_opt.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%dfi_opt.EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_tslb')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%dfi_opt.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%dfi_opt.EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_smois')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%dfi_opt.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%dfi_opt.EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_snow')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%dfi_opt.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%dfi_opt.EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_snowh')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%dfi_opt.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%dfi_opt.EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_canwat')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%dfi_opt.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%dfi_opt.EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_smfr3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%dfi_opt.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%dfi_opt.EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_keepfr3dflag')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%dfi_opt.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%dfi_opt.EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_tsk')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%dfi_opt.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%dfi_opt.EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_soilt1')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%dfi_opt.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%dfi_opt.EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_tsnav')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%dfi_opt.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%dfi_opt.EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_snowc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%dfi_opt.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%dfi_opt.EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_qvg')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%dfi_opt.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%dfi_opt.EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_rh')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%dfi_opt.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%dfi_opt.EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_tten_rad')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%dfi_opt.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%dfi_opt.EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_u')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%dfi_opt.EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%dfi_opt.EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_v')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%dfi_opt.EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%dfi_opt.EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_w')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%dfi_opt.EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%dfi_opt.EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_ph')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%dfi_opt.EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%dfi_opt.EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_phb')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%dfi_opt.EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%dfi_opt.EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_ph0')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%dfi_opt.EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%dfi_opt.EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_php')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%dfi_opt.EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%dfi_opt.EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_t')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%dfi_opt.EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%dfi_opt.EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_p')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%dfi_opt.EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%dfi_opt.EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_ww')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%dfi_opt.EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%dfi_opt.EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_mu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%dfi_opt.EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%dfi_opt.EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_tke')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%dfi_opt.EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%dfi_opt.EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_pb')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%dfi_opt.EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%dfi_opt.EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_al')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%dfi_opt.EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%dfi_opt.EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_alt')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%dfi_opt.EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%dfi_opt.EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_tslb')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%dfi_opt.EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%dfi_opt.EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_smois')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%dfi_opt.EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%dfi_opt.EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_snow')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%dfi_opt.EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%dfi_opt.EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_snowh')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%dfi_opt.EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%dfi_opt.EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_canwat')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%dfi_opt.EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%dfi_opt.EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_smfr3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%dfi_opt.EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%dfi_opt.EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_keepfr3dflag')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%dfi_opt.EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%dfi_opt.EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_tsk')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%dfi_opt.EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%dfi_opt.EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_soilt1')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%dfi_opt.EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%dfi_opt.EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_tsnav')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%dfi_opt.EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%dfi_opt.EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_snowc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%dfi_opt.EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%dfi_opt.EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_qvg')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%dfi_opt.EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%dfi_opt.EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_rh')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%dfi_opt.EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%dfi_opt.EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfi_tten_rad')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%dfi_opt.EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%dfi_opt.EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dum_yyy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%fft_used.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%fft_used.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfu1')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%do_avgflx_cugd(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%do_avgflx_cugd(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dfd1')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%do_avgflx_cugd(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%do_avgflx_cugd(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dz_lake3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_lake_physics(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_lake_physics(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dz3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_lake_physics(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_lake_physics(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'dir')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%diag_nwp2.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%diag_nwp2.EQ.1
  ENDIF
ENDIF

     ELSE IF ( vname(1:1) .EQ. 'e' ) THEN






IF(TRIM(vname).EQ.'efcg')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.40
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.40
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'efig')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.40
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.40
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'efsg')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.40
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.40
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'emstot')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'emstot')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'eahxy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ecanxy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'edirxy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'etranxy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'evgxy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'evbxy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'evcxy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'eqzwt')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'emiss_mosaic')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_mosaic.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_mosaic.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'embck_mosaic')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_mosaic.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_mosaic.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'el_pbl')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bl_pbl_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bl_pbl_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'el_pbl')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bl_pbl_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bl_pbl_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'entr_edkf')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bl_pbl_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bl_pbl_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'el_pbl')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bl_pbl_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bl_pbl_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'el_pbl')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bl_pbl_physics(id).EQ.6
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bl_pbl_physics(id).EQ.6
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'el_pbl')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bl_pbl_physics(id).EQ.8
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bl_pbl_physics(id).EQ.8
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'el_pbl')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bl_pbl_physics(id).EQ.11
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bl_pbl_physics(id).EQ.11
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'exch_tke')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bl_pbl_physics(id).EQ.12
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bl_pbl_physics(id).EQ.12
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'el_pbl')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bl_pbl_physics(id).EQ.12
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bl_pbl_physics(id).EQ.12
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'edmf_a')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bl_mynn_edmf(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bl_mynn_edmf(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'edmf_w')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bl_mynn_edmf(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bl_mynn_edmf(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'edmf_thl')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bl_mynn_edmf(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bl_mynn_edmf(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'edmf_qt')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bl_mynn_edmf(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bl_mynn_edmf(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'edmf_ent')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bl_mynn_edmf(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bl_mynn_edmf(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'edmf_qc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bl_mynn_edmf(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bl_mynn_edmf(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'evaptzm')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'evsntzm')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'evapqzm')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'evapcdp3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ed3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'eu3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'emkfbup_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'excessu_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'excessu0_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'exit_uwcu_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'exit_conden_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'exit_klclmkx_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'exit_klfcmkx_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'exit_ufrc_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'exit_wtw_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'exit_drycore_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'exit_wu_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'exit_cufliter_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'exit_kinv1_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'exit_rei_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'evapcsh')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'efcs')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%aercu_used.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%aercu_used.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'efis')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%aercu_used.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%aercu_used.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'efss')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%aercu_used.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%aercu_used.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'efu1')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%do_avgflx_cugd(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%do_avgflx_cugd(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'efd1')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%do_avgflx_cugd(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%do_avgflx_cugd(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'echotop')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%afwa_radar_opt(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%afwa_radar_opt(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'elecmag')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%elec_physics.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%elec_physics.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'elecx')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%elec_physics.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%elec_physics.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'elecy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%elec_physics.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%elec_physics.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'elecz')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%elec_physics.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%elec_physics.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'elecmag')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%elec_physics.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%elec_physics.EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'elecx')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%elec_physics.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%elec_physics.EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'elecy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%elec_physics.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%elec_physics.EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'elecz')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%elec_physics.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%elec_physics.EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'elecmag')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%elec_physics.EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%elec_physics.EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'elecx')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%elec_physics.EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%elec_physics.EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'elecy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%elec_physics.EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%elec_physics.EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'elecz')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%elec_physics.EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%elec_physics.EQ.3
  ENDIF
ENDIF

     ELSE IF ( vname(1:1) .EQ. 'f' ) THEN






IF(TRIM(vname).EQ.'f_ice_phy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'f_rain_phy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'f_rimef_phy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'f_ice_phy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.95
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.95
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'f_rain_phy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.95
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.95
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'f_rimef_phy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.95
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.95
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'flxhumr_urb2d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'flxhumb_urb2d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'flxhumg_urb2d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'flx4')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'fvb')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'fbur')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'fgsn')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'fwetxy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'fastcpxy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'fvegxy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'fsaxy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'firaxy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'fdepthxy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'fmsand_px')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'fio1')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.8
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.8
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'flo1')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.8
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.8
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'fio2')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.8
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.8
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'flo2')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.8
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.8
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'fio3')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.8
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.8
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'flo3')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.8
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.8
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'fio4')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.8
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.8
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'flo4')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.8
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.8
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'frac_up')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bl_pbl_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bl_pbl_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'fzsntzm')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'fcvt_qc_to_pr_cup')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_physics(id).EQ.10
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_physics(id).EQ.10
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'fcvt_qc_to_qi_cup')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_physics(id).EQ.10
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_physics(id).EQ.10
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'fcvt_qi_to_pr_cup')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_physics(id).EQ.10
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_physics(id).EQ.10
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'fer_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'fdr_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'flxrain_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'flxsnow_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'fgdp')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%grav_settling(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%grav_settling(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'fgdp')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%grav_settling(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%grav_settling(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'fdob')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%obs_nudge_opt(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%obs_nudge_opt(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'fourd_xxx')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%fft_used.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%fft_used.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'fuel_frac')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ifire(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ifire(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'fire_area')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ifire(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ifire(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'fgrnhfx')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ifire(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ifire(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'fgrnqfx')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ifire(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ifire(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'fcanhfx')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ifire(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ifire(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'fcanhfx')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ifire(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ifire(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'fcanqfx')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ifire(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ifire(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'fxlong')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ifire(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ifire(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'fxlat')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ifire(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ifire(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'fuel_time')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ifire(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ifire(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'fgip')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ifire(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ifire(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'field_conv')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%spp_on.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%spp_on.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'field_pbl')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%spp_on.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%spp_on.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'field_sf')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%spp_on.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%spp_on.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'fzlev')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%afwa_icing_opt(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%afwa_icing_opt(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'flshi')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%elec_physics.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%elec_physics.EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'flshn')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%elec_physics.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%elec_physics.EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'flshp')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%elec_physics.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%elec_physics.EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'flshi')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%elec_physics.EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%elec_physics.EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'flshn')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%elec_physics.EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%elec_physics.EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'flshp')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%elec_physics.EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%elec_physics.EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'field_u_tend_perturb')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%perturb_bdy.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%perturb_bdy.EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'field_v_tend_perturb')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%perturb_bdy.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%perturb_bdy.EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'field_t_tend_perturb')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%perturb_bdy.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%perturb_bdy.EQ.2
  ENDIF
ENDIF

     ELSE IF ( vname(1:1) .EQ. 'g' ) THEN






IF(TRIM(vname).EQ.'gppxy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ghvxy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ghbxy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'gddxy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'grainxy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'gecros_state')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%opt_crop.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%opt_crop.EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'grdflx_mosaic')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_mosaic.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_mosaic.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'g_urb2d_mosaic')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_mosaic.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_mosaic.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'gd_cloud')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_diag(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_diag(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'gd_cloud2')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_diag(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_diag(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'gd_cldfr')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_diag(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_diag(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'gd_cloud_a')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_diag(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_diag(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'gd_cloud2_a')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_diag(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_diag(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'grpl_max')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%nwp_diagnostics.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%nwp_diagnostics.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ght_max_p')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%nest_interp_coord.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%nest_interp_coord.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ght_min_p')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%nest_interp_coord.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%nest_interp_coord.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'grnhfx')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ifire(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ifire(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'grnqfx')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ifire(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ifire(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ght_pl')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%p_lev_diags.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%p_lev_diags.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ght_zl')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%z_lev_diags.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%z_lev_diags.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'grpl_flx_max')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%afwa_severe_opt(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%afwa_severe_opt(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'glw_mean')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mean_diag.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mean_diag.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'glw_diurn')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%diurnal_diag.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%diurnal_diag.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'geoheight')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%diag_nwp2.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%diag_nwp2.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ght_gc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'greenfrac')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ght_gc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'greenfrac')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.2
  ENDIF
ENDIF

     ELSE IF ( vname(1:1) .EQ. 'h' ) THEN






IF(TRIM(vname).EQ.'hgt_urb2d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'hi_urb2d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'hgt_urb2d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'hi_urb2d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'hgt_urb2d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'harvest')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'h2osno')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'h2ocan')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'h2ocan_col')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'h2osoi_liq_s1')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'h2osoi_liq_s2')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'h2osoi_liq_s3')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'h2osoi_liq_s4')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'h2osoi_liq_s5')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'h2osoi_liq1')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'h2osoi_liq2')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'h2osoi_liq3')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'h2osoi_liq4')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'h2osoi_liq5')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'h2osoi_liq6')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'h2osoi_liq7')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'h2osoi_liq8')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'h2osoi_liq9')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'h2osoi_liq10')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'h2osoi_ice_s1')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'h2osoi_ice_s2')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'h2osoi_ice_s3')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'h2osoi_ice_s4')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'h2osoi_ice_s5')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'h2osoi_ice1')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'h2osoi_ice2')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'h2osoi_ice3')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'h2osoi_ice4')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'h2osoi_ice5')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'h2osoi_ice6')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'h2osoi_ice7')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'h2osoi_ice8')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'h2osoi_ice9')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'h2osoi_ice10')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'h2osoi_vol1')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'h2osoi_vol2')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'h2osoi_vol3')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'h2osoi_vol4')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'h2osoi_vol5')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'h2osoi_vol6')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'h2osoi_vol7')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'h2osoi_vol8')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'h2osoi_vol9')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'h2osoi_vol10')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'hfxsubgrid')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ho1')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.8
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.8
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ho2')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.8
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.8
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ho3')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.8
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.8
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ho4')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.8
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.8
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'hfx_mosaic')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_mosaic.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_mosaic.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'hd_temf')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bl_pbl_physics(id).EQ.10
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bl_pbl_physics(id).EQ.10
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'hct_temf')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bl_pbl_physics(id).EQ.10
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bl_pbl_physics(id).EQ.10
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'hfx_fdda')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%grid_fdda(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%grid_fdda(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'hfx_fdda')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%grid_sfdda(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%grid_sfdda(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'hfx_both')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%grid_sfdda(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%grid_sfdda(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'hfx_fdda')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%grid_sfdda(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%grid_sfdda(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'hml')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_ocean_physics.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_ocean_physics.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'h0ml')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_ocean_physics.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_ocean_physics.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'huml')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_ocean_physics.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_ocean_physics.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'hvml')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_ocean_physics.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_ocean_physics.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'hml')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_ocean_physics.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_ocean_physics.EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'h0ml')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_ocean_physics.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_ocean_physics.EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'huml')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_ocean_physics.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_ocean_physics.EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'hvml')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_ocean_physics.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_ocean_physics.EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'hail_maxk1')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%nwp_diagnostics.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%nwp_diagnostics.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'hail_max2d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%nwp_diagnostics.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%nwp_diagnostics.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'hailcast_diam_max')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%hailcast_opt(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%hailcast_opt(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'hailcast_diam_mean')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%hailcast_opt(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%hailcast_opt(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'hailcast_diam_std')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%hailcast_opt(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%hailcast_opt(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'hailcast_dhail1')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%hailcast_opt(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%hailcast_opt(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'hailcast_dhail2')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%hailcast_opt(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%hailcast_opt(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'hailcast_dhail3')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%hailcast_opt(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%hailcast_opt(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'hailcast_dhail4')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%hailcast_opt(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%hailcast_opt(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'hailcast_dhail5')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%hailcast_opt(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%hailcast_opt(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'h2osno2d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_lake_physics(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_lake_physics(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'h2osoi_ice3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_lake_physics(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_lake_physics(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'h2osoi_liq3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_lake_physics(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_lake_physics(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'h2osoi_vol3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_lake_physics(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_lake_physics(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'height')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.30
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.30
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'height')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.32
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.32
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'hfx_mean')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mean_diag.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mean_diag.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'hfx_diurn')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%diurnal_diag.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%diurnal_diag.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ht_gc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'hgtmaxw')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'hgttrop')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ht_gc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.2
  ENDIF
ENDIF

     ELSE IF ( vname(1:1) .EQ. 'i' ) THEN






IF(TRIM(vname).EQ.'icwmrdp3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.11
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.11
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'iradius')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.11
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.11
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'itype')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.55
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.55
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'itype_2')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.55
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.55
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'itype_3')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.55
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.55
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'isnowxy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'irgxy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ircxy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'irbxy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'imperv')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'isnow')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.8
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.8
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'icwmrdp3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ideep2d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ind_delcin_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'icwmrsh')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'i_rainc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bucketr_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bucketr_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'i_rainnc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bucketr_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bucketr_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'i_acswupt')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bucketf_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bucketf_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'i_acswuptc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bucketf_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bucketf_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'i_acswdnt')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bucketf_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bucketf_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'i_acswdntc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bucketf_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bucketf_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'i_acswupb')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bucketf_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bucketf_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'i_acswupbc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bucketf_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bucketf_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'i_acswdnb')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bucketf_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bucketf_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'i_acswdnbc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bucketf_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bucketf_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'i_aclwupt')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bucketf_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bucketf_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'i_aclwuptc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bucketf_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bucketf_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'i_aclwdnt')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bucketf_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bucketf_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'i_aclwdntc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bucketf_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bucketf_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'i_aclwupb')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bucketf_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bucketf_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'i_aclwupbc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bucketf_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bucketf_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'i_aclwdnb')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bucketf_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bucketf_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'i_aclwdnbc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bucketf_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bucketf_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'icedepth')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%seaice_thickness_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%seaice_thickness_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ic_flashcount')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%lightning_option(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%lightning_option(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ic_flashrate')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%lightning_option(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%lightning_option(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ic_flashcount')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%lightning_option(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%lightning_option(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ic_flashrate')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%lightning_option(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%lightning_option(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ic_flashcount')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%lightning_option(id).EQ.11
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%lightning_option(id).EQ.11
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ic_flashrate')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%lightning_option(id).EQ.11
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%lightning_option(id).EQ.11
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ischap')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ifire(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ifire(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'icingtop')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%afwa_icing_opt(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%afwa_icing_opt(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'icingbot')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%afwa_icing_opt(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%afwa_icing_opt(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'icing_lg')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%afwa_icing_opt(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%afwa_icing_opt(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'icing_sm')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%afwa_icing_opt(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%afwa_icing_opt(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'induc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%elec_physics.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%elec_physics.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'induc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%elec_physics.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%elec_physics.EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'induc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%elec_physics.EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%elec_physics.EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'i_wif_now')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%wif_input_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%wif_input_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'i_wif_jan')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%wif_input_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%wif_input_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'i_wif_feb')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%wif_input_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%wif_input_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'i_wif_mar')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%wif_input_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%wif_input_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'i_wif_apr')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%wif_input_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%wif_input_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'i_wif_may')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%wif_input_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%wif_input_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'i_wif_jun')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%wif_input_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%wif_input_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'i_wif_jul')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%wif_input_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%wif_input_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'i_wif_aug')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%wif_input_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%wif_input_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'i_wif_sep')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%wif_input_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%wif_input_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'i_wif_oct')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%wif_input_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%wif_input_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'i_wif_nov')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%wif_input_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%wif_input_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'i_wif_dec')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%wif_input_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%wif_input_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'intq_gc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'icefrac_gc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'intq_gc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'icefrac_gc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.2
  ENDIF
ENDIF

     ELSE IF ( vname(1:1) .EQ. 'j' ) THEN






IF(TRIM(vname).EQ.'jt2d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_physics(id).EQ.7
  ENDIF
ENDIF

     ELSE IF ( vname(1:1) .EQ. 'k' ) THEN






IF(TRIM(vname).EQ.'keepfr3dflag')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'kh_temf')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bl_pbl_physics(id).EQ.10
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bl_pbl_physics(id).EQ.10
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'km_temf')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bl_pbl_physics(id).EQ.10
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bl_pbl_physics(id).EQ.10
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ktop_shallow')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bl_mynn_edmf(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bl_mynn_edmf(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'k22_shallow')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'kbcon_shallow')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ktop_shallow')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'k22_shallow')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'kbcon_shallow')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ktop_shallow')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'kbcon_deep')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_diag(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_diag(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ktop_deep')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_diag(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_diag(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'k22_deep')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_diag(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_diag(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'kdcldtop')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'kdcldbas')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'kext_ql')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.32
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.32
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'kext_qic')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.32
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.32
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'kext_qip')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.32
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.32
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'kext_qid')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.32
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.32
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'kext_qs')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.32
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.32
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'kext_qg')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.32
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.32
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'kext_qh')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.32
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.32
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'kext_qa')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.32
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.32
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'kext_ft_qic')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.32
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.32
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'kext_ft_qip')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.32
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.32
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'kext_ft_qid')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.32
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.32
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'kext_ft_qs')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.32
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.32
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'kext_ft_qg')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.32
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.32
  ENDIF
ENDIF

     ELSE IF ( vname(1:1) .EQ. 'l' ) THEN






IF(TRIM(vname).EQ.'lcd_old_mp')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.11
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.11
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'lradius')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.11
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.11
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'lwupt')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'lwuptc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'lwdnt')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'lwdntc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'lwupb')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'lwupbc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'lwdnb')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'lwdnbc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'lwupt')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'lwuptc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'lwdnt')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'lwdntc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'lwupb')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'lwupbc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'lwdnb')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'lwdnbc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'lwupt')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.14
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.14
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'lwuptc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.14
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.14
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'lwdnt')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.14
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.14
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'lwdntc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.14
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.14
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'lwupb')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.14
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.14
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'lwupbc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.14
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.14
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'lwdnb')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.14
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.14
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'lwdnbc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.14
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.14
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'lwupt')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.24
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.24
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'lwuptc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.24
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.24
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'lwdnt')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.24
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.24
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'lwdntc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.24
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.24
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'lwupb')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.24
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.24
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'lwupbc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.24
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.24
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'lwdnb')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.24
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.24
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'lwdnbc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.24
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.24
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'lwupt')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'lwuptc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'lwdnt')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'lwdntc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'lwupb')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'lwupbc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'lwdnb')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'lwdnbc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'lf_urb2d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'lp_urb2d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'lb_urb2d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'lp_urb2d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'lb_urb2d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'lf_ac_urb3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'lfvent_urb3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'lp_urb2d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'lb_urb2d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'lfmassxy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'lwup')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'lhsoi')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'lhveg')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'lhtran')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'lhsubgrid')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'lwupsubgrid')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'lai_px')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'lh_mosaic')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_mosaic.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_mosaic.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'lh_urb2d_mosaic')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_mosaic.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_mosaic.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'landusef2')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_mosaic.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_mosaic.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'lai_mosaic')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_mosaic.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_mosaic.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'lcl_temf')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bl_pbl_physics(id).EQ.10
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bl_pbl_physics(id).EQ.10
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'lengath2d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'lnterms')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_physics(id).EQ.10
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_physics(id).EQ.10
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'limit_shcu_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'limit_negcon_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'limit_ufrc_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'limit_ppen_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'limit_emf_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'limit_cinlcl_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'limit_cin_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'limit_cbmf_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'limit_rei_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ltopb')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'lpi')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%lightning_option(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%lightning_option(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'lwuptcln')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%calc_clean_atm_diag.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%calc_clean_atm_diag.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'lwdntcln')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%calc_clean_atm_diag.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%calc_clean_atm_diag.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'lwupbcln')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%calc_clean_atm_diag.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%calc_clean_atm_diag.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'lwdnbcln')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%calc_clean_atm_diag.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%calc_clean_atm_diag.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'lfn')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ifire(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ifire(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'lfn_hist')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ifire(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ifire(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'lfn_time')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ifire(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ifire(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'lake2d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_lake_physics(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_lake_physics(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'lakedepth2d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_lake_physics(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_lake_physics(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'lake_icefrac3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_lake_physics(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_lake_physics(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'lh_mean')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mean_diag.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mean_diag.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'lwupb_mean')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mean_diag.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mean_diag.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'lwupt_mean')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mean_diag.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mean_diag.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'lwdnt_mean')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mean_diag.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mean_diag.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'lh_diurn')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%diurnal_diag.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%diurnal_diag.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'lwupb_diurn')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%diurnal_diag.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%diurnal_diag.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'lwupt_diurn')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%diurnal_diag.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%diurnal_diag.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'lwdnt_diurn')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%diurnal_diag.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%diurnal_diag.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'light')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%elec_physics.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%elec_physics.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'lightdens')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%elec_physics.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%elec_physics.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'lightdis')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%elec_physics.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%elec_physics.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'light')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%elec_physics.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%elec_physics.EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'lightdens')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%elec_physics.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%elec_physics.EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'lightdis')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%elec_physics.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%elec_physics.EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'light')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%elec_physics.EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%elec_physics.EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'lightdens')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%elec_physics.EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%elec_physics.EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'lightdis')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%elec_physics.EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%elec_physics.EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'liqrain')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%diag_nwp2.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%diag_nwp2.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'lai12m')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF

     ELSE IF ( vname(1:1) .EQ. 'm' ) THEN






IF(TRIM(vname).EQ.'mskf_refl_10cm')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.40
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.40
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'mh_urb2d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'mosaic_cat_index')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_mosaic.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_mosaic.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'massflux_edkf')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bl_pbl_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bl_pbl_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'mf_temf')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bl_pbl_physics(id).EQ.10
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bl_pbl_physics(id).EQ.10
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'maxmf')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bl_mynn_edmf(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bl_mynn_edmf(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'md3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'mu3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'maxg2d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'mfup_cup')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_physics(id).EQ.10
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_physics(id).EQ.10
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'mfup_ent_cup')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_physics(id).EQ.10
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_physics(id).EQ.10
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'mfdn_cup')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_physics(id).EQ.10
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_physics(id).EQ.10
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'mfdn_ent_cup')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_physics(id).EQ.10
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_physics(id).EQ.10
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'max_p')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%nest_interp_coord.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%nest_interp_coord.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'min_p')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%nest_interp_coord.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%nest_interp_coord.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'midrh_min')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%afwa_severe_opt(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%afwa_severe_opt(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'midrh_min_old')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%afwa_severe_opt(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%afwa_severe_opt(id).EQ.1
  ENDIF
ENDIF

     ELSE IF ( vname(1:1) .EQ. 'n' ) THEN






IF(TRIM(vname).EQ.'neexy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'nppxy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'numc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'nump')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'nrasubgrid')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'nupdraft')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bl_mynn_edmf(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bl_mynn_edmf(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ntraprd_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ntsnprd_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'nc_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%aercu_used.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%aercu_used.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ni_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%aercu_used.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%aercu_used.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'nr_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%aercu_used.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%aercu_used.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ns_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%aercu_used.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%aercu_used.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'nfuel_cat')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ifire(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ifire(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'noninduc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%elec_physics.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%elec_physics.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'noninduc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%elec_physics.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%elec_physics.EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'noninduc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%elec_physics.EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%elec_physics.EQ.3
  ENDIF
ENDIF

     ELSE IF ( vname(1:1) .EQ. 'o' ) THEN






IF(TRIM(vname).EQ.'o3rad')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'o3rad')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.14
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.14
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'o3rad')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.24
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.24
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'o3rad')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'o3rad')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.14
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.14
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'o3rad')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.24
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.24
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'odis_ndg_old')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%grid_sfdda(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%grid_sfdda(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'odis_ndg_new')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%grid_sfdda(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%grid_sfdda(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'obs_savwt')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%obs_nudge_opt(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%obs_nudge_opt(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'odis_ndg_old')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%grid_sfdda(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%grid_sfdda(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'odis_ndg_new')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%grid_sfdda(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%grid_sfdda(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'oc12d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%gwd_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%gwd_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'oa1')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%gwd_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%gwd_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'oa2')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%gwd_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%gwd_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'oa3')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%gwd_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%gwd_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'oa4')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%gwd_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%gwd_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ol1')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%gwd_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%gwd_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ol2')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%gwd_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%gwd_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ol3')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%gwd_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%gwd_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ol4')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%gwd_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%gwd_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'om_tmp')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_ocean_physics.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_ocean_physics.EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'om_s')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_ocean_physics.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_ocean_physics.EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'om_depth')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_ocean_physics.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_ocean_physics.EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'om_u')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_ocean_physics.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_ocean_physics.EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'om_v')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_ocean_physics.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_ocean_physics.EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'om_lat')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_ocean_physics.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_ocean_physics.EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'om_lon')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_ocean_physics.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_ocean_physics.EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'om_ml')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_ocean_physics.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_ocean_physics.EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'om_tini')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_ocean_physics.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_ocean_physics.EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'om_sini')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_ocean_physics.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_ocean_physics.EQ.2
  ENDIF
ENDIF

     ELSE IF ( vname(1:1) .EQ. 'p' ) THEN






IF(TRIM(vname).EQ.'phys_tot')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'physc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'physe')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'physd')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'physs')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'physm')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'physf')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'preci3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'precs3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'precg3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'precr3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'prech3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'phii3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.55
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.55
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'phii3d_2')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.55
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.55
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'phii3d_3')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.55
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.55
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'precipfr')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'psnxy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'pexpxy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'planting')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'pgsxy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'precz')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'preccdzm')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'pconvb')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'pconvt')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'plcl_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'pinv_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'plfc_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'pbup_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ppen_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'pblmax')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'pblhavg')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'psl_ndg_old')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%grid_sfdda(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%grid_sfdda(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ps_ndg_old')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%grid_sfdda(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%grid_sfdda(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'psl_ndg_new')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%grid_sfdda(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%grid_sfdda(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ps_ndg_new')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%grid_sfdda(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%grid_sfdda(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'psl_ndg_old')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%grid_sfdda(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%grid_sfdda(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ps_ndg_old')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%grid_sfdda(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%grid_sfdda(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'psl_ndg_new')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%grid_sfdda(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%grid_sfdda(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ps_ndg_new')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%grid_sfdda(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%grid_sfdda(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'prec_acc_c')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%prec_acc_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%prec_acc_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'prec_acc_nc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%prec_acc_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%prec_acc_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'power')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%windfarm_opt(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%windfarm_opt(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ph_xxx')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%fft_used.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%fft_used.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'phiwc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ifire(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ifire(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'pattern_spp_conv')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%spp_on.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%spp_on.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'pattern_spp_pbl')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%spp_on.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%spp_on.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'pattern_spp_lsm')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%spp_on.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%spp_on.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'p_pl')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%p_lev_diags.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%p_lev_diags.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'psfc_mean')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mean_diag.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mean_diag.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'pmsl_mean')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mean_diag.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mean_diag.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'psfc_diurn')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%diurnal_diag.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%diurnal_diag.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'pot')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%elec_physics.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%elec_physics.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'pot')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%elec_physics.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%elec_physics.EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'pot')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%elec_physics.EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%elec_physics.EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'p_wif_now')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%wif_input_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%wif_input_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'p_wif_jan')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%wif_input_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%wif_input_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'p_wif_feb')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%wif_input_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%wif_input_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'p_wif_mar')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%wif_input_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%wif_input_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'p_wif_apr')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%wif_input_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%wif_input_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'p_wif_may')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%wif_input_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%wif_input_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'p_wif_jun')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%wif_input_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%wif_input_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'p_wif_jul')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%wif_input_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%wif_input_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'p_wif_aug')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%wif_input_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%wif_input_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'p_wif_sep')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%wif_input_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%wif_input_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'p_wif_oct')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%wif_input_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%wif_input_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'p_wif_nov')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%wif_input_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%wif_input_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'p_wif_dec')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%wif_input_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%wif_input_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'pressure')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%diag_nwp2.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%diag_nwp2.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'potential_t')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%diag_nwp2.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%diag_nwp2.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'p_gc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'pslv_gc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'pd_gc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'psfc_gc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'pdhs')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'prho_gc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'pdrho_gc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'pmaxw')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ptrop')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'p_gc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'pslv_gc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'pd_gc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'psfc_gc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'pdhs')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.2
  ENDIF
ENDIF

     ELSE IF ( vname(1:1) .EQ. 'q' ) THEN






IF(TRIM(vname).EQ.'qnwfa2d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.28
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.28
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qnifa2d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.28
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.28
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qv_old')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.50
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.50
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qv_old')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.51
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.51
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qv_old')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.52
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.52
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qndropsource')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%progn(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%progn(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qndropsource')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%alloc_qndropsource.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%alloc_qndropsource.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qlev_urb3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qsnowxy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'q2mvxy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'q2mbxy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qinxy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qrfxy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qrfsxy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qspringxy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qspringsxy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qslatxy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'q2subgrid')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'q2_ndg_new')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'q2_ndg_old')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'q2obs')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qsfc_mosaic')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_mosaic.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_mosaic.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qfx_mosaic')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_mosaic.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_mosaic.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qc_urb2d_mosaic')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_mosaic.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_mosaic.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qke')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bl_pbl_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bl_pbl_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qsq')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bl_pbl_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bl_pbl_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qke')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bl_pbl_physics(id).EQ.6
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bl_pbl_physics(id).EQ.6
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qsq')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bl_pbl_physics(id).EQ.6
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bl_pbl_physics(id).EQ.6
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qpert2d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bl_pbl_physics(id).EQ.9
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bl_pbl_physics(id).EQ.9
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qf_temf')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bl_pbl_physics(id).EQ.10
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bl_pbl_physics(id).EQ.10
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qlup_temf')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bl_pbl_physics(id).EQ.10
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bl_pbl_physics(id).EQ.10
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qtup_temf')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bl_pbl_physics(id).EQ.10
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bl_pbl_physics(id).EQ.10
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qshear')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bl_mynn_tkebudget(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bl_mynn_tkebudget(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qbuoy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bl_mynn_tkebudget(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bl_mynn_tkebudget(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qdiss')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bl_mynn_tkebudget(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bl_mynn_tkebudget(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qwt')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bl_mynn_tkebudget(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bl_mynn_tkebudget(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qc_bl')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%icloud_bl.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%icloud_bl.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qc_iu_cup')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_physics(id).EQ.10
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_physics(id).EQ.10
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qc_ic_cup')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_physics(id).EQ.10
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_physics(id).EQ.10
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qndrop_ic_cup')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_physics(id).EQ.10
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_physics(id).EQ.10
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qtflx_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qtten_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qvten_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qlten_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qiten_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qtsrc_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qtu_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qtu_emf_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qcu_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qlu_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qiu_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qrten_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qsten_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'q2_ndg_old')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%grid_sfdda(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%grid_sfdda(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'q2_ndg_new')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%grid_sfdda(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%grid_sfdda(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'q2_ndg_old')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%grid_sfdda(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%grid_sfdda(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'q2_ndg_new')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%grid_sfdda(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%grid_sfdda(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qnorm')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%grid_sfdda(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%grid_sfdda(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qfx_both')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%grid_sfdda(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%grid_sfdda(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qr_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%aercu_used.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%aercu_used.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qs_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%aercu_used.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%aercu_used.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qv_upstream_x')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%scm_force.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%scm_force.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qv_upstream_x_tend')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%scm_force.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%scm_force.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qv_upstream_y')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%scm_force.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%scm_force.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qv_upstream_y_tend')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%scm_force.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%scm_force.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qv_largescale')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%scm_force.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%scm_force.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qv_largescale_tend')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%scm_force.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%scm_force.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ql_largescale')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%scm_force.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%scm_force.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ql_largescale_tend')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%scm_force.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%scm_force.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ql_upstream_x')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%scm_force.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%scm_force.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ql_upstream_x_tend')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%scm_force.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%scm_force.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ql_upstream_y')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%scm_force.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%scm_force.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ql_upstream_y_tend')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%scm_force.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%scm_force.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'q_soil_forcing_val')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%scm_force.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%scm_force.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'q_soil_forcing_tend')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%scm_force.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%scm_force.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qv_t_tend')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%scm_force.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%scm_force.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'q2min')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%output_diagnostics.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%output_diagnostics.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'q2max')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%output_diagnostics.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%output_diagnostics.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'q2mean')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%output_diagnostics.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%output_diagnostics.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'q2std')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%output_diagnostics.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%output_diagnostics.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qv_old')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.30
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.30
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qv_old')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.32
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.32
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'q_pl')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%p_lev_diags.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%p_lev_diags.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'q_zl')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%z_lev_diags.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%z_lev_diags.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qicing_lg')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%afwa_icing_opt(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%afwa_icing_opt(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qicing_sm')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%afwa_icing_opt(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%afwa_icing_opt(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qicing_lg_max')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%afwa_icing_opt(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%afwa_icing_opt(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qicing_sm_max')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%afwa_icing_opt(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%afwa_icing_opt(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'q2_mean')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mean_diag.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mean_diag.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'q2_diurn')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%diurnal_diag.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%diurnal_diag.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qv_gc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qr_gc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qc_gc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qs_gc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qi_gc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qg_gc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qh_gc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qni_gc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qnc_gc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qnr_gc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qns_gc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qng_gc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qnh_gc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qnwfa_gc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qnwfa_now')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qnwfa_jan')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qnwfa_feb')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qnwfa_mar')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qnwfa_apr')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qnwfa_may')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qnwfa_jun')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qnwfa_jul')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qnwfa_aug')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qnwfa_sep')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qnwfa_oct')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qnwfa_nov')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qnwfa_dec')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qnifa_gc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qnifa_now')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qnifa_jan')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qnifa_feb')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qnifa_mar')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qnifa_apr')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qnifa_may')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qnifa_jun')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qnifa_jul')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qnifa_aug')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qnifa_sep')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qnifa_oct')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qnifa_nov')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qnifa_dec')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qntemp')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qntemp2')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qv_gc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qr_gc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qc_gc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qs_gc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qi_gc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qg_gc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qh_gc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qni_gc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qnc_gc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qnr_gc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qns_gc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qng_gc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'qnh_gc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.2
  ENDIF
ENDIF

     ELSE IF ( vname(1:1) .EQ. 'r' ) THEN






IF(TRIM(vname).EQ.'re_cloud')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'re_ice')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'re_snow')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'re_cloud')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'re_ice')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'re_snow')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'re_cloud')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.6
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.6
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'re_ice')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.6
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.6
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'re_snow')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.6
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.6
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'re_cloud_gsfc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'re_rain_gsfc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'re_ice_gsfc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'re_snow_gsfc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'re_graupel_gsfc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'re_hail_gsfc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'re_cloud')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'re_ice')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'re_snow')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'re_cloud')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.8
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.8
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'re_ice')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.8
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.8
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'re_snow')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.8
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.8
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rqrcuten')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.10
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.10
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rqscuten')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.10
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.10
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rqicuten')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.10
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.10
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rh_old_mp')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.11
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.11
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rimi')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.13
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.13
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'re_cloud')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.14
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.14
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'re_ice')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.14
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.14
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'re_snow')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.14
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.14
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'re_cloud')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.16
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.16
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'re_ice')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.16
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.16
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'re_snow')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.16
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.16
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'re_cloud')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.17
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.17
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'re_ice')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.17
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.17
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'re_snow')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.17
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.17
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'re_cloud')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.18
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.18
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'re_ice')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.18
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.18
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'re_snow')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.18
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.18
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'re_cloud')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.22
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.22
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'re_ice')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.22
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.22
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'re_snow')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.22
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.22
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'re_cloud')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.24
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.24
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'re_ice')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.24
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.24
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'re_snow')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.24
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.24
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'re_cloud')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.26
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.26
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'re_ice')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.26
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.26
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'re_snow')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.26
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.26
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'re_cloud')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.28
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.28
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'re_ice')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.28
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.28
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'re_snow')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.28
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.28
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'re_cloud')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.50
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.50
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'re_ice')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.50
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.50
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rhopo3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.50
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.50
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'refl_10cm')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.50
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.50
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'re_cloud')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.51
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.51
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'re_ice')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.51
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.51
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rhopo3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.51
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.51
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'refl_10cm')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.51
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.51
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'re_cloud')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.52
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.52
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'re_ice')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.52
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.52
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rhopo3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.52
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.52
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rhopo3d_2')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.52
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.52
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'refl_10cm')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.52
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.52
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rqrcuten')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.40
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.40
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rqscuten')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.40
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.40
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rqicuten')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.40
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.40
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'re_cloud')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.40
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.40
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'re_ice')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.40
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.40
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'re_snow')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.40
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.40
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'re_cloud')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.55
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.55
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'re_ice')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.55
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.55
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rhopo3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.55
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.55
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rhopo3d_2')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.55
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.55
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rhopo3d_3')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.55
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.55
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'refl_10cm')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.55
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.55
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'refl_10cm')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%compute_radar_ref.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%compute_radar_ref.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'refd_max')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%compute_radar_ref.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%compute_radar_ref.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'re_cloud_gsfc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'re_rain_gsfc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'re_ice_gsfc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'re_snow_gsfc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'re_graupel_gsfc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'re_hail_gsfc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'re_cloud')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'re_ice')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'re_snow')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'re_cloud_gsfc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'re_rain_gsfc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'re_ice_gsfc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'re_snow_gsfc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'re_graupel_gsfc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'re_hail_gsfc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'re_cloud')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'re_ice')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'re_snow')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rhosnf')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rtmassxy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'runsfxy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'runsbxy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rssunxy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rsshaxy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rechxy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rivercondxy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'riverbedxy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rechclim')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rn_urb2d_mosaic')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_mosaic.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_mosaic.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rs_mosaic')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_mosaic.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_mosaic.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rv_up')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bl_pbl_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bl_pbl_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rt_up')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bl_pbl_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bl_pbl_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rc_up')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bl_pbl_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bl_pbl_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rc_mf')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bl_pbl_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bl_pbl_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rprddp3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rliq')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rucuten')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_used.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_used.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rvcuten')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_used.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_used.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rthcuten')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_used.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_used.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rqvcuten')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_used.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_used.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rqrcuten')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_used.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_used.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rqccuten')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_used.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_used.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rqscuten')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_used.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_used.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rqicuten')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_used.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_used.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rqcncuten')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_used.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_used.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rqincuten')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_used.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_used.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rcwp_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rlwp_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'riwp_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rprdsh')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rliq2')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rliq')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rdcashten')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rqcdcshten')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rainshvb')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'radsave')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rushten')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_used.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_used.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rvshten')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_used.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_used.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rthshten')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_used.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_used.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rqvshten')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_used.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_used.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rqrshten')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_used.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_used.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rqcshten')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_used.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_used.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rqsshten')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_used.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_used.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rqishten')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_used.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_used.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rqgshten')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_used.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_used.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rqcnshten')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_used.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_used.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rqinshten')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_used.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_used.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rundgdten')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%grid_fdda(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%grid_fdda(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rvndgdten')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%grid_fdda(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%grid_fdda(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rthndgdten')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%grid_fdda(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%grid_fdda(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rphndgdten')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%grid_fdda(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%grid_fdda(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rqvndgdten')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%grid_fdda(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%grid_fdda(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rmundgdten')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%grid_fdda(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%grid_fdda(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rundgdten')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%grid_fdda(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%grid_fdda(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rvndgdten')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%grid_fdda(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%grid_fdda(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rthndgdten')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%grid_fdda(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%grid_fdda(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rphndgdten')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%grid_fdda(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%grid_fdda(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rqvndgdten')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%grid_fdda(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%grid_fdda(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rmundgdten')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%grid_fdda(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%grid_fdda(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rh_ndg_old')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%grid_sfdda(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%grid_sfdda(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rh_ndg_new')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%grid_sfdda(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%grid_sfdda(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rh_ndg_old')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%grid_sfdda(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%grid_sfdda(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rh_ndg_new')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%grid_sfdda(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%grid_sfdda(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'raincvmax')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%output_diagnostics.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%output_diagnostics.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rainncvmax')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%output_diagnostics.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%output_diagnostics.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'raincvmean')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%output_diagnostics.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%output_diagnostics.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rainncvmean')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%output_diagnostics.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%output_diagnostics.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'raincvstd')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%output_diagnostics.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%output_diagnostics.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rainncvstd')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%output_diagnostics.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%output_diagnostics.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ru_xxx')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%fft_used.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%fft_used.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rv_xxx')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%fft_used.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%fft_used.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rthfrten')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ifire(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ifire(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rqvfrten')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ifire(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ifire(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ros')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ifire(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ifire(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'r_0')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ifire(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ifire(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rstoch')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sppt_on.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sppt_on.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rand_real')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sppt_on.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sppt_on.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rand_imag')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sppt_on.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sppt_on.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rand_real_xxx')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sppt_on.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sppt_on.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rand_real_yyy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sppt_on.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sppt_on.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rand_imag_xxx')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sppt_on.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sppt_on.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rand_imag_yyy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sppt_on.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sppt_on.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ru_tendf_stoch')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%skebs_on.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%skebs_on.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rv_tendf_stoch')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%skebs_on.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%skebs_on.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rt_tendf_stoch')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%skebs_on.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%skebs_on.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rand_real')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%skebs_on.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%skebs_on.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rand_imag')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%skebs_on.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%skebs_on.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rand_real_xxx')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%skebs_on.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%skebs_on.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rand_real_yyy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%skebs_on.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%skebs_on.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rand_imag_xxx')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%skebs_on.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%skebs_on.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rand_imag_yyy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%skebs_on.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%skebs_on.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rand_pert')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%rand_perturb_on.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%rand_perturb_on.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rand_real')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%rand_perturb_on.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%rand_perturb_on.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rand_imag')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%rand_perturb_on.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%rand_perturb_on.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rand_real_xxx')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%rand_perturb_on.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%rand_perturb_on.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rand_real_yyy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%rand_perturb_on.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%rand_perturb_on.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rand_imag_xxx')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%rand_perturb_on.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%rand_perturb_on.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rand_imag_yyy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%rand_perturb_on.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%rand_perturb_on.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rand_real')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%spp_on.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%spp_on.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rand_imag')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%spp_on.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%spp_on.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rand_real_xxx')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%spp_on.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%spp_on.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rand_real_yyy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%spp_on.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%spp_on.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rand_imag_xxx')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%spp_on.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%spp_on.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rand_imag_yyy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%spp_on.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%spp_on.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rh_pl')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%p_lev_diags.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%p_lev_diags.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rh_zl')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%z_lev_diags.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%z_lev_diags.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'radarvil')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%afwa_vil_opt(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%afwa_vil_opt(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'refd_com')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%afwa_radar_opt(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%afwa_radar_opt(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'refd')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%afwa_radar_opt(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%afwa_radar_opt(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rscghis_2d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%elec_physics.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%elec_physics.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rscghis_2d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%elec_physics.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%elec_physics.EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rscghis_2d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%elec_physics.EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%elec_physics.EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rain')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%diag_nwp2.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%diag_nwp2.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rh')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%diag_nwp2.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%diag_nwp2.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rh_gc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'rh_gc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.2
  ENDIF
ENDIF

     ELSE IF ( vname(1:1) .EQ. 's' ) THEN






IF(TRIM(vname).EQ.'smaw3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.11
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.11
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'shfrc3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.11
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.11
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'swupt')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'swuptc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'swdnt')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'swdntc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'swupb')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'swupbc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'swdnb')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'swdnbc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'slwdn')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'slwup')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'swupt')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'swuptc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'swdnt')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'swdntc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'swupb')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'swupbc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'swdnb')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'swdnbc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'swupt')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'swuptc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'swdnt')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'swdntc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'swupb')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'swupbc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'swdnb')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'swdnbc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'swupt')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.14
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.14
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'swuptc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.14
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.14
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'swdnt')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.14
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.14
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'swdntc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.14
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.14
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'swupb')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.14
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.14
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'swupbc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.14
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.14
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'swdnb')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.14
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.14
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'swdnbc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.14
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.14
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'swupt')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.24
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.24
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'swuptc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.24
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.24
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'swdnt')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.24
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.24
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'swdntc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.24
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.24
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'swupb')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.24
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.24
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'swupbc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.24
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.24
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'swdnb')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.24
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.24
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'swdnbc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.24
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.24
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'sswdn')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'sswup')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'sfw1_urb3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'sfw2_urb3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'sfr_urb3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'sfg_urb3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'sf_bep')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'stdh_urb2d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'smr_urb3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'sf_bep')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'sfw1_urb3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'sfw2_urb3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'sfr_urb3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'sfg_urb3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'sf_bep')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'sf_ac_urb3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'sfvent_urb3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'sfwin1_urb3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'sfwin2_urb3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'sfw1_urb3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'sfw2_urb3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'sfr_urb3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'sfg_urb3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'smcrel')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'smfr3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'soilt1')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'snowfallac')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'sneqvoxy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'snicexy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'snliqxy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'stmassxy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'stblcpxy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'savxy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'sagxy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'shgxy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'shcxy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'shbxy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'smoiseq')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'smcwtdxy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'stepwtd')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'season_gdd')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'soilcomp')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'soilcl1')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'soilcl2')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'soilcl3')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'soilcl4')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'sabv')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'sabg')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'snl')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'snowdp')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'snowrds1')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'snowrds2')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'snowrds3')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'snowrds4')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'snowrds5')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'sabvsubgrid')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'sabgsubgrid')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'swupsubgrid')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ssib_fm')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.8
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.8
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ssib_fh')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.8
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.8
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ssib_cm')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.8
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.8
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ssibxdd')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.8
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.8
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ssib_br')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.8
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.8
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ssib_lhf')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.8
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.8
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ssib_shf')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.8
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.8
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ssib_ghf')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.8
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.8
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ssib_egs')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.8
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.8
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ssib_eci')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.8
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.8
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ssib_ect')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.8
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.8
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ssib_egi')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.8
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.8
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ssib_egt')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.8
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.8
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ssib_sdn')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.8
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.8
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ssib_sup')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.8
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.8
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ssib_ldn')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.8
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.8
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ssib_lup')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.8
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.8
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ssib_wat')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.8
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.8
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ssib_shc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.8
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.8
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ssib_shg')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.8
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.8
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ssib_lai')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.8
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.8
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ssib_vcf')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.8
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.8
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ssib_z00')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.8
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.8
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ssib_veg')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.8
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.8
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'swe')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.8
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.8
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'snowden')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.8
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.8
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'snowdepth')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.8
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.8
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'smois_mosaic')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_mosaic.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_mosaic.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'sh2o_mosaic')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_mosaic.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_mosaic.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'snow_mosaic')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_mosaic.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_mosaic.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'snowh_mosaic')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_mosaic.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_mosaic.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'snowc_mosaic')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_mosaic.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_mosaic.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'snotime_mosaic')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_mosaic.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_mosaic.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'sh_urb2d_mosaic')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_mosaic.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_mosaic.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'smcrel')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_mosaic.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_mosaic.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'sh3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bl_pbl_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bl_pbl_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'sh3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bl_pbl_physics(id).EQ.6
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bl_pbl_physics(id).EQ.6
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'smaw3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bl_pbl_physics(id).EQ.9
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bl_pbl_physics(id).EQ.9
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'shf_temf')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bl_pbl_physics(id).EQ.10
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bl_pbl_physics(id).EQ.10
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'shfrc3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'slflx_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'slten_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'snowsh')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'sda_hfx')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%grid_sfdda(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%grid_sfdda(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'sda_qfx')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%grid_sfdda(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%grid_sfdda(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'soil_depth_force')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%scm_force.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%scm_force.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'snow_acc_nc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%prec_acc_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%prec_acc_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'skintempmin')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%output_diagnostics.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%output_diagnostics.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'skintempmax')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%output_diagnostics.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%output_diagnostics.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'skintempmean')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%output_diagnostics.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%output_diagnostics.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'skintempstd')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%output_diagnostics.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%output_diagnostics.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'spduv10max')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%output_diagnostics.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%output_diagnostics.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'spduv10mean')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%output_diagnostics.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%output_diagnostics.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'spduv10std')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%output_diagnostics.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%output_diagnostics.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'snowsi')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%seaice_snowdepth_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%seaice_snowdepth_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'soldrain')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%wrf_hydro.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%wrf_hydro.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'swuptcln')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%calc_clean_atm_diag.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%calc_clean_atm_diag.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'swdntcln')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%calc_clean_atm_diag.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%calc_clean_atm_diag.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'swupbcln')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%calc_clean_atm_diag.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%calc_clean_atm_diag.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'swdnbcln')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%calc_clean_atm_diag.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%calc_clean_atm_diag.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'spptforcs')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sppt_on.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sppt_on.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'spptforcc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sppt_on.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sppt_on.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'sppt_amp')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sppt_on.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sppt_on.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'spstreamforcc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%skebs_on.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%skebs_on.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'spstreamforcs')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%skebs_on.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%skebs_on.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'sptforcc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%skebs_on.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%skebs_on.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'sptforcs')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%skebs_on.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%skebs_on.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'spstream_amp')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%skebs_on.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%skebs_on.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'spt_amp')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%skebs_on.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%skebs_on.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'spforcs')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%rand_perturb_on.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%rand_perturb_on.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'spforcc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%rand_perturb_on.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%rand_perturb_on.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'sp_amp')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%rand_perturb_on.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%rand_perturb_on.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'spforcs2')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%spp_on.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%spp_on.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'spforcc2')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%spp_on.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%spp_on.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'sp_amp2')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%spp_on.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%spp_on.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'spforcs3')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%spp_on.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%spp_on.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'spforcc3')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%spp_on.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%spp_on.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'sp_amp3')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%spp_on.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%spp_on.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'spforcs4')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%spp_on.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%spp_on.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'spforcc4')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%spp_on.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%spp_on.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'sp_amp4')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%spp_on.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%spp_on.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'savedtke12d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_lake_physics(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_lake_physics(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'snowdp2d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_lake_physics(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_lake_physics(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'snl2d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_lake_physics(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_lake_physics(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'s_pl')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%p_lev_diags.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%p_lev_diags.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'s_zl')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%z_lev_diags.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%z_lev_diags.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'swdnb_mean')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mean_diag.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mean_diag.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'swupb_mean')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mean_diag.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mean_diag.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'swupt_mean')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mean_diag.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mean_diag.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'swdnt_mean')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mean_diag.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mean_diag.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'swdnb_diurn')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%diurnal_diag.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%diurnal_diag.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'swupb_diurn')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%diurnal_diag.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%diurnal_diag.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'swupt_diurn')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%diurnal_diag.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%diurnal_diag.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'swdnt_diurn')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%diurnal_diag.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%diurnal_diag.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'sctot')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%elec_physics.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%elec_physics.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'sctot')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%elec_physics.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%elec_physics.EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'sctot')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%elec_physics.EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%elec_physics.EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'sealevelp')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%diag_nwp2.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%diag_nwp2.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'speed')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%diag_nwp2.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%diag_nwp2.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'sct_dom_gc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'scb_dom_gc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'sh_gc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'soil_layers')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'soil_levels')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'st')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'sm')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'sw')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'soilt')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'soilm')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'sm000007')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'sm007028')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'sm028100')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'sm100255')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'st000007')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'st007028')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'st028100')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'st100255')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'sm000010')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'sm010040')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'sm040100')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'sm100200')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'sm010200')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'soilm000')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'soilm005')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'soilm020')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'soilm040')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'soilm160')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'soilm300')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'sw000010')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'sw010040')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'sw040100')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'sw100200')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'sw010200')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'soilw000')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'soilw005')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'soilw020')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'soilw040')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'soilw160')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'soilw300')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'st000010')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'st010040')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'st040100')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'st100200')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'st010200')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'soilt000')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'soilt005')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'soilt020')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'soilt040')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'soilt160')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'soilt300')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'sct_dom_gc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'scb_dom_gc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'sh_gc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.2
  ENDIF
ENDIF

     ELSE IF ( vname(1:1) .EQ. 't' ) THEN






IF(TRIM(vname).EQ.'turbtype3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.11
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.11
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tke_pbl')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.11
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.11
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'taod5503d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.28
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.28
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'taod5502d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.28
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.28
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'th_old')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.50
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.50
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'th_old')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.51
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.51
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'th_old')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.52
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.52
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'taucldc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'taucldi')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tlwdn')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tlwup')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'taucldc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'taucldi')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_lw_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_lw_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'taucldc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'taucldi')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'taucldc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'taucldi')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tswdn')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tswup')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'taucldc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'taucldi')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ra_sw_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ra_sw_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tke_pbl')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_sfclay_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_sfclay_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'trb_urb4d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tw1_urb4d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tw2_urb4d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tgb_urb4d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tgr_urb2d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tgrl_urb3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'trl_urb3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tgl_urb3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tbl_urb3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'trb_urb4d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tw1_urb4d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tw2_urb4d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tgb_urb4d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'trl_urb3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tgl_urb3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tbl_urb3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tsk_rural')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'trb_urb4d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tw1_urb4d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tw2_urb4d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tgb_urb4d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tlev_urb3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tw1lev_urb3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tw2lev_urb3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tglev_urb3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tflev_urb3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'trl_urb3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tgl_urb3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tbl_urb3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tsk_rural')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tvxy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tgxy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tahxy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tsnoxy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'taussxy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'t2mvxy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'t2mbxy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tradxy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tgvxy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tgbxy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'trxy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'t_grnd')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'t_veg')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'t2m_max')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'t2m_min')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'t2clm')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'t_ref2m')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'t_soisno_s1')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'t_soisno_s2')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'t_soisno_s3')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'t_soisno_s4')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'t_soisno_s5')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'t_soisno1')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'t_soisno2')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'t_soisno3')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'t_soisno4')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'t_soisno5')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'t_soisno6')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'t_soisno7')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'t_soisno8')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'t_soisno9')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'t_soisno10')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'t_lake1')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'t_lake2')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'t_lake3')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'t_lake4')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'t_lake5')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'t_lake6')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'t_lake7')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'t_lake8')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'t_lake9')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'t_lake10')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'t2_ndg_new')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'t2_ndg_old')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'t2obs')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tkair')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.8
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.8
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tssn1')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.8
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.8
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tssno1')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.8
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.8
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tssn2')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.8
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.8
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tssno2')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.8
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.8
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tssn3')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.8
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.8
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tssno3')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.8
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.8
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tssn4')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.8
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.8
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tssno4')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.8
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.8
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tsk_mosaic')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_mosaic.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_mosaic.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tslb_mosaic')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_mosaic.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_mosaic.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tr_urb2d_mosaic')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_mosaic.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_mosaic.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tb_urb2d_mosaic')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_mosaic.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_mosaic.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tg_urb2d_mosaic')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_mosaic.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_mosaic.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tc_urb2d_mosaic')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_mosaic.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_mosaic.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ts_urb2d_mosaic')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_mosaic.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_mosaic.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ts_rul2d_mosaic')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_mosaic.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_mosaic.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'trl_urb3d_mosaic')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_mosaic.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_mosaic.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tbl_urb3d_mosaic')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_mosaic.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_mosaic.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tgl_urb3d_mosaic')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_mosaic.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_mosaic.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tke_pbl')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bl_pbl_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bl_pbl_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tke_pbl')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bl_pbl_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bl_pbl_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'thl_up')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bl_pbl_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bl_pbl_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'thv_up')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bl_pbl_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bl_pbl_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tke_pbl')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bl_pbl_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bl_pbl_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tsq')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bl_pbl_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bl_pbl_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tke_pbl')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bl_pbl_physics(id).EQ.6
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bl_pbl_physics(id).EQ.6
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tsq')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bl_pbl_physics(id).EQ.6
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bl_pbl_physics(id).EQ.6
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tke_pbl')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bl_pbl_physics(id).EQ.8
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bl_pbl_physics(id).EQ.8
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tauresx2d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bl_pbl_physics(id).EQ.9
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bl_pbl_physics(id).EQ.9
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tauresy2d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bl_pbl_physics(id).EQ.9
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bl_pbl_physics(id).EQ.9
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tpert2d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bl_pbl_physics(id).EQ.9
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bl_pbl_physics(id).EQ.9
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tke_pbl')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bl_pbl_physics(id).EQ.9
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bl_pbl_physics(id).EQ.9
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'turbtype3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bl_pbl_physics(id).EQ.9
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bl_pbl_physics(id).EQ.9
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'te_temf')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bl_pbl_physics(id).EQ.10
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bl_pbl_physics(id).EQ.10
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'thup_temf')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bl_pbl_physics(id).EQ.10
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bl_pbl_physics(id).EQ.10
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tke_pbl')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bl_pbl_physics(id).EQ.11
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bl_pbl_physics(id).EQ.11
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tke_pbl')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bl_pbl_physics(id).EQ.12
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bl_pbl_physics(id).EQ.12
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tpert2d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'timec_kf')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%kf_edrates(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%kf_edrates(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'thlsrc_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'thvlsrc_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tkeavg_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tophgt_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'thlu_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'thvu_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'thlu_emf_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tkeavg')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'t2_ndg_old')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%grid_sfdda(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%grid_sfdda(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'th2_ndg_old')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%grid_sfdda(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%grid_sfdda(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'t2_ndg_new')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%grid_sfdda(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%grid_sfdda(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'th2_ndg_new')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%grid_sfdda(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%grid_sfdda(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tob_ndg_old')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%grid_sfdda(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%grid_sfdda(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tob_ndg_new')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%grid_sfdda(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%grid_sfdda(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'t2_ndg_old')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%grid_sfdda(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%grid_sfdda(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'th2_ndg_old')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%grid_sfdda(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%grid_sfdda(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'t2_ndg_new')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%grid_sfdda(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%grid_sfdda(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'th2_ndg_new')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%grid_sfdda(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%grid_sfdda(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tob_ndg_old')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%grid_sfdda(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%grid_sfdda(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tob_ndg_new')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%grid_sfdda(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%grid_sfdda(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tml')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_ocean_physics.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_ocean_physics.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'t0ml')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_ocean_physics.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_ocean_physics.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tmoml')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_ocean_physics.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_ocean_physics.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tml')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_ocean_physics.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_ocean_physics.EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'t0ml')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_ocean_physics.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_ocean_physics.EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tmoml')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_ocean_physics.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_ocean_physics.EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'th_upstream_x')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%scm_force.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%scm_force.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'th_upstream_x_tend')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%scm_force.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%scm_force.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'th_upstream_y')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%scm_force.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%scm_force.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'th_upstream_y_tend')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%scm_force.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%scm_force.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tau_x')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%scm_force.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%scm_force.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tau_x_tend')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%scm_force.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%scm_force.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tau_y')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%scm_force.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%scm_force.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tau_y_tend')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%scm_force.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%scm_force.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'th_largescale')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%scm_force.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%scm_force.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'th_largescale_tend')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%scm_force.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%scm_force.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tau_largescale')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%scm_force.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%scm_force.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tau_largescale_tend')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%scm_force.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%scm_force.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'t_soil_forcing_val')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%scm_force.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%scm_force.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'t_soil_forcing_tend')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%scm_force.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%scm_force.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tau_soil')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%scm_force.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%scm_force.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'th_t_tend')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%scm_force.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%scm_force.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'t2min')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%output_diagnostics.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%output_diagnostics.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'t2max')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%output_diagnostics.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%output_diagnostics.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tt2min')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%output_diagnostics.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%output_diagnostics.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tt2max')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%output_diagnostics.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%output_diagnostics.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'t2mean')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%output_diagnostics.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%output_diagnostics.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'t2std')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%output_diagnostics.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%output_diagnostics.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tq2min')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%output_diagnostics.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%output_diagnostics.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tq2max')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%output_diagnostics.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%output_diagnostics.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tskintempmin')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%output_diagnostics.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%output_diagnostics.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tskintempmax')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%output_diagnostics.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%output_diagnostics.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tspduv10max')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%output_diagnostics.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%output_diagnostics.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'traincvmax')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%output_diagnostics.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%output_diagnostics.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'trainncvmax')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%output_diagnostics.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%output_diagnostics.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'t_max_p')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%nest_interp_coord.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%nest_interp_coord.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'t_min_p')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%nest_interp_coord.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%nest_interp_coord.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'traj_i')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%traj_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%traj_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'traj_j')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%traj_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%traj_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'traj_k')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%traj_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%traj_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'traj_lat')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%traj_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%traj_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'traj_long')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%traj_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%traj_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ts_hour')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%process_time_series.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%process_time_series.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ts_u')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%process_time_series.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%process_time_series.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ts_v')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%process_time_series.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%process_time_series.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ts_q')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%process_time_series.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%process_time_series.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ts_t')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%process_time_series.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%process_time_series.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ts_psfc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%process_time_series.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%process_time_series.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ts_glw')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%process_time_series.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%process_time_series.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ts_gsw')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%process_time_series.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%process_time_series.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ts_hfx')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%process_time_series.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%process_time_series.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ts_lh')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%process_time_series.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%process_time_series.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ts_tsk')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%process_time_series.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%process_time_series.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ts_tslb')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%process_time_series.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%process_time_series.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ts_clw')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%process_time_series.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%process_time_series.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ts_rainc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%process_time_series.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%process_time_series.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ts_rainnc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%process_time_series.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%process_time_series.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ts_u_profile')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%process_time_series.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%process_time_series.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ts_v_profile')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%process_time_series.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%process_time_series.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ts_gph_profile')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%process_time_series.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%process_time_series.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ts_th_profile')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%process_time_series.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%process_time_series.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'t_xxx')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%fft_used.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%fft_used.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tign_g')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ifire(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ifire(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'t_grnd2d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_lake_physics(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_lake_physics(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'t_lake3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_lake_physics(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_lake_physics(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'t_soisno3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_lake_physics(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_lake_physics(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tkmg3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_lake_physics(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_lake_physics(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tkdry3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_lake_physics(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_lake_physics(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tksatu3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_lake_physics(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_lake_physics(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'th_old')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.30
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.30
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tempc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.30
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.30
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'th_old')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.32
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.32
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tempc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.32
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.32
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'t_pl')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%p_lev_diags.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%p_lev_diags.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'td_pl')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%p_lev_diags.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%p_lev_diags.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'t_zl')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%z_lev_diags.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%z_lev_diags.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'td_zl')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%z_lev_diags.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%z_lev_diags.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tcoli_max')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%afwa_severe_opt(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%afwa_severe_opt(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tornado_mask')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%afwa_severe_opt(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%afwa_severe_opt(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tornado_dur')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%afwa_severe_opt(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%afwa_severe_opt(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tsk_mean')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mean_diag.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mean_diag.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'t2_mean')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mean_diag.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mean_diag.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'th2_mean')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mean_diag.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mean_diag.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tsk_diurn')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%diurnal_diag.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%diurnal_diag.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'t2_diurn')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%diurnal_diag.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%diurnal_diag.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'th2_diurn')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%diurnal_diag.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%diurnal_diag.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'temperature')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%diag_nwp2.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%diag_nwp2.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tpw')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%diag_nwp2.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%diag_nwp2.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'t_gc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tsk_gc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tavgsfc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tmn_gc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tmaxw')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ttrop')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'t_gc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tsk_gc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tavgsfc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'tmn_gc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.2
  ENDIF
ENDIF

     ELSE IF ( vname(1:1) .EQ. 'u' ) THEN






IF(TRIM(vname).EQ.'uc_urb2d_mosaic')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_mosaic.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_mosaic.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'u_up')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bl_pbl_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bl_pbl_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'uw_temf')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bl_pbl_physics(id).EQ.10
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bl_pbl_physics(id).EQ.10
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'updfra_cup')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_physics(id).EQ.10
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_physics(id).EQ.10
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'udr_kf')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%kf_edrates(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%kf_edrates(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'uer_kf')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%kf_edrates(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%kf_edrates(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'uflx_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'uten_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ufrcinvbase_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ufrclcl_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ufrc_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'uu_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'uu_emf_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'umf_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'uemf_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'u10_ndg_old')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%grid_sfdda(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%grid_sfdda(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'u10_ndg_new')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%grid_sfdda(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%grid_sfdda(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'u10_ndg_old')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%grid_sfdda(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%grid_sfdda(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'u10_ndg_new')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%grid_sfdda(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%grid_sfdda(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'u_g')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%scm_force.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%scm_force.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'u_g_tend')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%scm_force.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%scm_force.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'u_upstream_x')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%scm_force.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%scm_force.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'u_upstream_x_tend')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%scm_force.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%scm_force.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'u_upstream_y')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%scm_force.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%scm_force.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'u_upstream_y_tend')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%scm_force.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%scm_force.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'u_largescale')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%scm_force.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%scm_force.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'u_largescale_tend')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%scm_force.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%scm_force.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'u10max')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%output_diagnostics.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%output_diagnostics.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'u10mean')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%output_diagnostics.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%output_diagnostics.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'u10std')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%output_diagnostics.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%output_diagnostics.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'up_heli_max')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%nwp_diagnostics.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%nwp_diagnostics.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'u_xxx')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%fft_used.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%fft_used.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'uf')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ifire(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ifire(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'uah')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ifire(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ifire(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'u_pl')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%p_lev_diags.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%p_lev_diags.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'u_zl')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%z_lev_diags.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%z_lev_diags.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'up_heli_max')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%afwa_severe_opt(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%afwa_severe_opt(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'u10_mean')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mean_diag.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mean_diag.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'u10_diurn')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%diurnal_diag.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%diurnal_diag.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'umet')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%diag_nwp2.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%diag_nwp2.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'u_gc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'umaxw')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'utrop')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'urb_param')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'u_gc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.2
  ENDIF
ENDIF

     ELSE IF ( vname(1:1) .EQ. 'v' ) THEN






IF(TRIM(vname).EQ.'vmi3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.50
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.50
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'vmi3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.51
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.51
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'vmi3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.52
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.52
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'vmi3d_2')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.52
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.52
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'vmi3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.55
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.55
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'vmi3d_2')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.55
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.55
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'vmi3d_3')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.55
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.55
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'vl_bep')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'vl_bep')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'vl_bep')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_urban_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_urban_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'vegf_px')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'v_up')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bl_pbl_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bl_pbl_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'vw_temf')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bl_pbl_physics(id).EQ.10
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bl_pbl_physics(id).EQ.10
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'vflx_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'vten_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'vu_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'vu_emf_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'vdfg')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%grav_settling(id).EQ.0
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%grav_settling(id).EQ.0
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'vdfg')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%grav_settling(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%grav_settling(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'vdfg')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%grav_settling(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%grav_settling(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'v10_ndg_old')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%grid_sfdda(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%grid_sfdda(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'v10_ndg_new')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%grid_sfdda(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%grid_sfdda(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'v10_ndg_old')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%grid_sfdda(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%grid_sfdda(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'v10_ndg_new')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%grid_sfdda(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%grid_sfdda(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'v_g')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%scm_force.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%scm_force.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'v_g_tend')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%scm_force.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%scm_force.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'v_upstream_x')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%scm_force.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%scm_force.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'v_upstream_x_tend')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%scm_force.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%scm_force.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'v_upstream_y')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%scm_force.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%scm_force.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'v_upstream_y_tend')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%scm_force.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%scm_force.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'v_largescale')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%scm_force.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%scm_force.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'v_largescale_tend')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%scm_force.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%scm_force.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'v10max')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%output_diagnostics.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%output_diagnostics.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'v10mean')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%output_diagnostics.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%output_diagnostics.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'v10std')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%output_diagnostics.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%output_diagnostics.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'v_xxx')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%fft_used.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%fft_used.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'vf')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ifire(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ifire(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'vah')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ifire(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ifire(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'vertstrucc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sppt_on.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sppt_on.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'vertstrucs')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sppt_on.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sppt_on.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'vertampt')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sppt_on.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sppt_on.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'vertstrucc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%skebs_on.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%skebs_on.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'vertstrucs')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%skebs_on.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%skebs_on.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'vertampt')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%skebs_on.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%skebs_on.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'vertampuv')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%skebs_on.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%skebs_on.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'vertstrucc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%rand_perturb_on.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%rand_perturb_on.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'vertstrucs')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%rand_perturb_on.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%rand_perturb_on.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'vertampt')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%rand_perturb_on.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%rand_perturb_on.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'vertstrucc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%spp_on.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%spp_on.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'vertstrucs')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%spp_on.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%spp_on.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'vertampt')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%spp_on.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%spp_on.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'v_pl')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%p_lev_diags.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%p_lev_diags.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'v_zl')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%z_lev_diags.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%z_lev_diags.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'vil')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%afwa_vil_opt(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%afwa_vil_opt(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'v10_mean')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mean_diag.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mean_diag.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'v10_diurn')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%diurnal_diag.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%diurnal_diag.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'vmet')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%diag_nwp2.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%diag_nwp2.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'v_gc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'vmaxw')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'vtrop')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'v_gc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.2
  ENDIF
ENDIF

     ELSE IF ( vname(1:1) .EQ. 'w' ) THEN






IF(TRIM(vname).EQ.'wsedl3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.11
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.11
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'wact')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%mp_physics(id).EQ.40
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%mp_physics(id).EQ.40
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'wm_temf')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_sfclay_physics(id).EQ.10
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_sfclay_physics(id).EQ.10
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'wslakexy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'waxy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'wtxy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'woodxy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'wgapxy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'wtc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'wtp')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'wwlt_px')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'wfc_px')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'wsat_px')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'wo1')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.8
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.8
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'wo2')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.8
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.8
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'wo3')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.8
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.8
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'wo4')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.8
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.8
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'wu_tur')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bl_pbl_physics(id).EQ.8
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bl_pbl_physics(id).EQ.8
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'wv_tur')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bl_pbl_physics(id).EQ.8
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bl_pbl_physics(id).EQ.8
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'wt_tur')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bl_pbl_physics(id).EQ.8
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bl_pbl_physics(id).EQ.8
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'wq_tur')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bl_pbl_physics(id).EQ.8
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bl_pbl_physics(id).EQ.8
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'wpert2d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bl_pbl_physics(id).EQ.9
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bl_pbl_physics(id).EQ.9
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'wsedl3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bl_pbl_physics(id).EQ.9
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bl_pbl_physics(id).EQ.9
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'wupd_temf')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%bl_pbl_physics(id).EQ.10
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%bl_pbl_physics(id).EQ.10
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'w0avg')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_physics(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_physics(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'wup_cup')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_physics(id).EQ.10
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_physics(id).EQ.10
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'w0avg')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_physics(id).EQ.10
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_physics(id).EQ.10
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'w0avg')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_physics(id).EQ.11
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_physics(id).EQ.11
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'w_up')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_physics(id).EQ.11
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_physics(id).EQ.11
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'w0avg')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_physics(id).EQ.99
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_physics(id).EQ.99
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'winvbase_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'wlcl_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'wu_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'wub')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'w0avg')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'w_subs')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%scm_force.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%scm_force.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'w_subs_tend')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%scm_force.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%scm_force.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'wspd10max')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%nwp_diagnostics.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%nwp_diagnostics.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'w_up_max')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%nwp_diagnostics.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%nwp_diagnostics.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'w_dn_max')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%nwp_diagnostics.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%nwp_diagnostics.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'w_mean')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%nwp_diagnostics.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%nwp_diagnostics.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'w_xxx')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%fft_used.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%fft_used.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'ww_xxx')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%fft_used.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%fft_used.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'watsat3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_lake_physics(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_lake_physics(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'w_up_max')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%afwa_severe_opt(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%afwa_severe_opt(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'w_dn_max')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%afwa_severe_opt(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%afwa_severe_opt(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'w_mean')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%afwa_severe_opt(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%afwa_severe_opt(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'wspd10max')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%afwa_severe_opt(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%afwa_severe_opt(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'w_wif_now')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%wif_input_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%wif_input_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'w_wif_jan')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%wif_input_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%wif_input_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'w_wif_feb')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%wif_input_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%wif_input_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'w_wif_mar')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%wif_input_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%wif_input_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'w_wif_apr')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%wif_input_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%wif_input_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'w_wif_may')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%wif_input_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%wif_input_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'w_wif_jun')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%wif_input_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%wif_input_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'w_wif_jul')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%wif_input_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%wif_input_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'w_wif_aug')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%wif_input_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%wif_input_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'w_wif_sep')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%wif_input_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%wif_input_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'w_wif_oct')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%wif_input_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%wif_input_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'w_wif_nov')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%wif_input_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%wif_input_opt.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'w_wif_dec')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%wif_input_opt.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%wif_input_opt.EQ.1
  ENDIF
ENDIF

     ELSE IF ( vname(1:1) .EQ. 'x' ) THEN






IF(TRIM(vname).EQ.'xlaidyn')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'xsaixy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'xmb_shallow')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_physics(id).EQ.3
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_physics(id).EQ.3
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'xmb_shallow')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'xc_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'xtime1')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.5
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.5
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'xlat_gc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'xlong_gc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'xlat_gc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'xlong_gc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%use_wps_input.EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%use_wps_input.EQ.2
  ENDIF
ENDIF

     ELSE IF ( vname(1:1) .EQ. 'y' ) THEN







     ELSE IF ( vname(1:1) .EQ. 'z' ) THEN






IF(TRIM(vname).EQ.'zwtxy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'zsnsoxy')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_physics(id).EQ.4
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_physics(id).EQ.4
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'znt_mosaic')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_mosaic.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_mosaic.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'z0_mosaic')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_surface_mosaic.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_surface_mosaic.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'zmdt')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'zmdq')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'zmdice')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'zmdliq')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'zmflxprc')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'zmflxsnw')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'zmntprpd')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'zmntsnpd')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'zmeiheat')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'zmmtu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'zmmtv')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'zmmu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'zmmd')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'zmupgu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'zmupgd')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'zmvpgu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'zmvpgd')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'zmicuu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'zmicud')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'zmicvu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'zmicvd')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%cu_physics(id).EQ.7
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%cu_physics(id).EQ.7
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'zinv_cu')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%shcu_physics(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%shcu_physics(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'z_force')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%scm_force.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%scm_force.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'z_force_tend')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%scm_force.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%scm_force.EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'zsf')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%ifire(id).EQ.2
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%ifire(id).EQ.2
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'z_lake3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_lake_physics(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_lake_physics(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'z3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_lake_physics(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_lake_physics(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'zi3d')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%sf_lake_physics(id).EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%sf_lake_physics(id).EQ.1
  ENDIF
ENDIF
IF(TRIM(vname).EQ.'z_zl')THEN
  IF(uses.EQ.0)THEN
    in_use = model_config_rec%z_lev_diags.EQ.1
    uses = 1
  ELSE
    in_use = in_use.OR.model_config_rec%z_lev_diags.EQ.1
  ENDIF
ENDIF

     ENDIF

     RETURN
   END FUNCTION





   SUBROUTINE init_module_configure
     USE module_scalar_tables
     IMPLICIT NONE
     CALL init_module_scalar_tables
   END SUBROUTINE init_module_configure

   SUBROUTINE wrf_alt_nml_obsolete (nml_read_unit, nml_name)









     IMPLICIT NONE
     INTEGER, INTENT(IN)       :: nml_read_unit
     CHARACTER*(*), INTENT(IN) :: nml_name
     INTEGER                   :: nml_error







integer    :: first_item_in_struct
integer :: run_days
integer :: run_hours
integer :: run_minutes
integer :: run_seconds
integer , DIMENSION(max_domains) :: start_year
integer , DIMENSION(max_domains) :: start_month
integer , DIMENSION(max_domains) :: start_day
integer , DIMENSION(max_domains) :: start_hour
integer , DIMENSION(max_domains) :: start_minute
integer , DIMENSION(max_domains) :: start_second
integer , DIMENSION(max_domains) :: end_year
integer , DIMENSION(max_domains) :: end_month
integer , DIMENSION(max_domains) :: end_day
integer , DIMENSION(max_domains) :: end_hour
integer , DIMENSION(max_domains) :: end_minute
integer , DIMENSION(max_domains) :: end_second
integer :: interval_seconds
logical , DIMENSION(max_domains) :: input_from_file
integer , DIMENSION(max_domains) :: fine_input_stream
logical , DIMENSION(max_domains) :: input_from_hires
character*256 :: rsmas_data_path
logical :: all_ic_times
integer , DIMENSION(max_domains) :: julyr
integer , DIMENSION(max_domains) :: julday
real , DIMENSION(max_domains) :: gmt
character*256 :: input_inname
character*256 :: input_outname
character*256 :: bdy_inname
character*256 :: bdy_outname
character*256 :: rst_inname
character*256 :: rst_outname
logical :: write_input
logical :: write_restart_at_0h
logical :: write_hist_at_0h_rst
logical :: adjust_output_times
logical :: adjust_input_times
integer :: diag_print
logical :: nocolons
logical :: cycling
integer :: output_diagnostics
integer :: nwp_diagnostics
logical :: output_ready_flag
logical :: force_use_old_data
logical :: usepio
integer :: pioprocs
integer :: piostart
integer :: piostride
integer :: pioshift
integer :: dfi_opt
integer :: dfi_savehydmeteors
integer :: dfi_nfilter
logical :: dfi_write_filtered_input
logical :: dfi_write_dfi_history
integer :: dfi_cutoff_seconds
integer :: dfi_time_dim
integer :: dfi_fwdstop_year
integer :: dfi_fwdstop_month
integer :: dfi_fwdstop_day
integer :: dfi_fwdstop_hour
integer :: dfi_fwdstop_minute
integer :: dfi_fwdstop_second
integer :: dfi_bckstop_year
integer :: dfi_bckstop_month
integer :: dfi_bckstop_day
integer :: dfi_bckstop_hour
integer :: dfi_bckstop_minute
integer :: dfi_bckstop_second
integer :: time_step
integer :: time_step_fract_num
integer :: time_step_fract_den
integer :: time_step_dfi
integer , DIMENSION(max_domains) :: min_time_step
integer , DIMENSION(max_domains) :: min_time_step_den
integer , DIMENSION(max_domains) :: max_time_step
integer , DIMENSION(max_domains) :: max_time_step_den
real , DIMENSION(max_domains) :: target_cfl
real , DIMENSION(max_domains) :: target_hcfl
integer , DIMENSION(max_domains) :: max_step_increase_pct
integer , DIMENSION(max_domains) :: starting_time_step
integer , DIMENSION(max_domains) :: starting_time_step_den
logical :: step_to_output_time
integer :: adaptation_domain
logical :: use_adaptive_time_step
logical :: use_adaptive_time_step_dfi
integer :: max_dom
integer :: lats_to_mic
integer , DIMENSION(max_domains) :: s_we
integer , DIMENSION(max_domains) :: e_we
integer , DIMENSION(max_domains) :: s_sn
integer , DIMENSION(max_domains) :: e_sn
integer , DIMENSION(max_domains) :: s_vert
integer , DIMENSION(max_domains) :: e_vert
integer :: num_metgrid_levels
integer :: num_metgrid_soil_levels
real :: p_top_requested
logical :: interp_theta
integer :: interp_type
integer :: rebalance
integer , DIMENSION(max_domains) :: vert_refine_method
integer :: vert_refine_fact
integer :: extrap_type
integer :: t_extrap_type
integer :: hypsometric_opt
logical :: lowest_lev_from_sfc
logical :: use_levels_below_ground
logical :: use_tavg_for_tsk
logical :: use_surface
integer :: lagrange_order
integer :: linear_interp
integer :: force_sfc_in_vinterp
real :: zap_close_levels
real :: maxw_horiz_pres_diff
real :: trop_horiz_pres_diff
real :: maxw_above_this_level
integer :: use_maxw_level
integer :: use_trop_level
logical :: sfcp_to_sfcp
logical :: adjust_heights
logical :: smooth_cg_topo
integer :: nest_interp_coord
integer :: interp_method_type
logical :: aggregate_lu
logical :: rh2qv_wrt_liquid
integer :: rh2qv_method
real :: qv_max_p_safe
real :: qv_max_flag
real :: qv_max_value
real :: qv_min_p_safe
real :: qv_min_flag
real :: qv_min_value
integer :: ideal_init_method
real , DIMENSION(max_domains) :: dx
real , DIMENSION(max_domains) :: dy
integer , DIMENSION(max_domains) :: grid_id
logical , DIMENSION(max_domains) :: grid_allowed
integer , DIMENSION(max_domains) :: parent_id
integer , DIMENSION(max_domains) :: i_parent_start
integer , DIMENSION(max_domains) :: j_parent_start
integer , DIMENSION(max_domains) :: parent_grid_ratio
integer , DIMENSION(max_domains) :: parent_time_step_ratio
integer :: feedback
integer :: smooth_option
integer :: blend_width
real , DIMENSION(max_domains) :: ztop
integer , DIMENSION(max_domains) :: moad_grid_ratio
integer , DIMENSION(max_domains) :: moad_time_step_ratio
integer , DIMENSION(max_domains) :: shw
integer :: tile_sz_x
integer :: tile_sz_y
integer :: numtiles
integer :: numtiles_inc
integer :: numtiles_x
integer :: numtiles_y
integer :: tile_strategy
integer :: nproc_x
integer :: nproc_y
integer :: irand
real , DIMENSION(max_domains) :: dt
integer :: fft_used
integer :: cu_used
integer :: shcu_used
integer :: cam_used
integer :: alloc_qndropsource
integer :: num_moves
integer :: ts_buf_size
integer :: max_ts_locs
logical :: tslist_ij
logical :: tslist_unstagger_winds
integer , DIMENSION(max_domains) :: vortex_interval
integer , DIMENSION(max_domains) :: max_vortex_speed
integer , DIMENSION(max_domains) :: corral_dist
integer :: track_level
real , DIMENSION(max_domains) :: time_to_move
integer , DIMENSION(max_moves) :: move_id
integer , DIMENSION(max_moves) :: move_interval
integer , DIMENSION(max_moves) :: move_cd_x
integer , DIMENSION(max_moves) :: move_cd_y
logical , DIMENSION(max_domains) :: swap_x
logical , DIMENSION(max_domains) :: swap_y
logical , DIMENSION(max_domains) :: cycle_x
logical , DIMENSION(max_domains) :: cycle_y
logical :: reorder_mesh
logical :: perturb_input
real , DIMENSION(max_eta) :: eta_levels
integer :: auto_levels_opt
real :: max_dz
real :: dzbot
real :: dzstretch_s
real :: dzstretch_u
integer :: ocean_levels
real , DIMENSION(max_ocean) :: ocean_z
real , DIMENSION(max_ocean) :: ocean_t
real , DIMENSION(max_ocean) :: ocean_s
integer :: num_traj
integer :: max_ts_level
integer :: track_loc_in
integer :: num_ext_model_couple_dom
logical :: insert_bogus_storm
logical :: remove_storm
integer :: num_storm
real , DIMENSION(max_bogus) :: latc_loc
real , DIMENSION(max_bogus) :: lonc_loc
real , DIMENSION(max_bogus) :: vmax_meters_per_second
real , DIMENSION(max_bogus) :: rmax
real , DIMENSION(max_bogus) :: vmax_ratio
real :: rankine_lid
character*256 :: physics_suite
logical :: force_read_thompson
logical :: write_thompson_tables
integer , DIMENSION(max_domains) :: mp_physics
real , DIMENSION(max_domains) :: nssl_cccn
real , DIMENSION(max_domains) :: nssl_alphah
real , DIMENSION(max_domains) :: nssl_alphahl
real , DIMENSION(max_domains) :: nssl_cnoh
real , DIMENSION(max_domains) :: nssl_cnohl
real , DIMENSION(max_domains) :: nssl_cnor
real , DIMENSION(max_domains) :: nssl_cnos
real , DIMENSION(max_domains) :: nssl_rho_qh
real , DIMENSION(max_domains) :: nssl_rho_qhl
real , DIMENSION(max_domains) :: nssl_rho_qs
integer , DIMENSION(max_domains) :: nudge_lightning
integer , DIMENSION(max_domains) :: nudge_light_times
integer , DIMENSION(max_domains) :: nudge_light_timee
integer , DIMENSION(max_domains) :: nudge_light_int
character*256 :: path_to_files
integer :: gsfcgce_hail
integer :: gsfcgce_2ice
integer , DIMENSION(max_domains) :: progn
real :: accum_mode
real :: aitken_mode
real :: coarse_mode
integer :: do_radar_ref
integer :: compute_radar_ref
integer , DIMENSION(max_domains) :: ra_lw_physics
integer , DIMENSION(max_domains) :: ra_sw_physics
real , DIMENSION(max_domains) :: radt
real , DIMENSION(max_domains) :: naer
integer , DIMENSION(max_domains) :: sf_sfclay_physics
integer , DIMENSION(max_domains) :: sf_surface_physics
integer , DIMENSION(max_domains) :: bl_pbl_physics
integer , DIMENSION(max_domains) :: bl_mynn_tkebudget
integer :: ysu_topdown_pblmix
integer , DIMENSION(max_domains) :: shinhong_tke_diag
logical , DIMENSION(max_domains) :: bl_mynn_tkeadvect
integer :: bl_mynn_cloudpdf
integer :: bl_mynn_mixlength
integer , DIMENSION(max_domains) :: bl_mynn_edmf
integer , DIMENSION(max_domains) :: bl_mynn_edmf_mom
integer , DIMENSION(max_domains) :: bl_mynn_edmf_tke
integer , DIMENSION(max_domains) :: bl_mynn_mixscalars
integer , DIMENSION(max_domains) :: bl_mynn_cloudmix
integer , DIMENSION(max_domains) :: bl_mynn_mixqt
integer :: icloud_bl
integer , DIMENSION(max_domains) :: mfshconv
integer , DIMENSION(max_domains) :: sf_urban_physics
real , DIMENSION(max_domains) :: bldt
integer , DIMENSION(max_domains) :: cu_physics
integer , DIMENSION(max_domains) :: shcu_physics
integer , DIMENSION(max_domains) :: cu_diag
integer , DIMENSION(max_domains) :: kf_edrates
integer :: kfeta_trigger
integer :: nsas_dx_factor
real , DIMENSION(max_domains) :: cudt
real , DIMENSION(max_domains) :: gsmdt
integer :: isfflx
integer :: ifsnow
integer :: icloud
integer :: cldovrlp
integer :: ideal_xland
real :: swrad_scat
integer :: surface_input_source
integer :: num_soil_layers
integer :: maxpatch
integer :: num_snow_layers
integer :: num_snso_layers
integer :: num_urban_ndm
integer :: num_urban_ng
integer :: num_urban_nwr
integer :: num_urban_ngb
integer :: num_urban_nf
integer :: num_urban_nz
integer :: num_urban_nbui
integer :: urban_map_zrd
integer :: urban_map_zwd
integer :: urban_map_gd
integer :: urban_map_zd
integer :: urban_map_zdf
integer :: urban_map_bd
integer :: urban_map_wd
integer :: urban_map_gbd
integer :: urban_map_fbd
integer :: num_urban_hi
integer :: num_months
integer :: sf_surface_mosaic
integer :: mosaic_cat
integer :: mosaic_cat_soil
integer :: mosaic_lu
integer :: mosaic_soil
integer :: flag_sm_adj
integer :: maxiens
integer :: maxens
integer :: maxens2
integer :: maxens3
integer :: ensdim
integer :: cugd_avedx
integer :: clos_choice
integer :: imomentum
integer :: ishallow
real :: convtrans_avglen_m
integer :: num_land_cat
integer :: num_soil_cat
integer :: mp_zero_out
real :: mp_zero_out_thresh
real :: seaice_threshold
integer :: sst_update
integer :: sst_skin
integer :: tmn_update
logical :: usemonalb
logical :: rdmaxalb
logical :: rdlai2d
logical :: ua_phys
integer :: opt_thcnd
integer :: co2tf
integer :: ra_call_offset
real :: cam_abs_freq_s
integer :: levsiz
integer :: paerlev
integer :: cam_abs_dim1
integer :: cam_abs_dim2
integer :: lagday
integer :: no_src_types
integer :: alevsiz
integer :: o3input
integer :: aer_opt
integer :: swint_opt
integer , DIMENSION(max_domains) :: aer_type
integer , DIMENSION(max_domains) :: aer_aod550_opt
integer , DIMENSION(max_domains) :: aer_angexp_opt
integer , DIMENSION(max_domains) :: aer_ssa_opt
integer , DIMENSION(max_domains) :: aer_asy_opt
real , DIMENSION(max_domains) :: aer_aod550_val
real , DIMENSION(max_domains) :: aer_angexp_val
real , DIMENSION(max_domains) :: aer_ssa_val
real , DIMENSION(max_domains) :: aer_asy_val
logical , DIMENSION(max_domains) :: cu_rad_feedback
integer :: dust_emis
integer :: erosion_dim
integer :: no_src_types_cu
integer :: alevsiz_cu
integer :: aercu_opt
real :: aercu_fct
integer :: aercu_used
logical , DIMENSION(max_domains) :: shallowcu_forced_ra
integer , DIMENSION(max_domains) :: numbins
real , DIMENSION(max_domains) :: thbinsize
real , DIMENSION(max_domains) :: rbinsize
real , DIMENSION(max_domains) :: mindeepfreq
real , DIMENSION(max_domains) :: minshallowfreq
integer , DIMENSION(max_domains) :: shcu_aerosols_opt
integer , DIMENSION(max_domains) :: icloud_cu
integer , DIMENSION(max_domains) :: pxlsm_smois_init
integer , DIMENSION(max_domains) :: pxlsm_modis_veg
integer :: omlcall
integer :: sf_ocean_physics
integer :: traj_opt
logical , DIMENSION(max_domains) :: dm_has_traj
integer :: tracercall
real :: omdt
real :: oml_hml0
real :: oml_gamma
real :: oml_relaxation_time
integer :: isftcflx
integer :: iz0tlnd
real :: shadlen
integer , DIMENSION(max_domains) :: slope_rad
integer , DIMENSION(max_domains) :: topo_shading
integer , DIMENSION(max_domains) :: topo_wind
integer :: no_mp_heating
integer :: fractional_seaice
integer :: seaice_snowdepth_opt
real :: seaice_snowdepth_max
real :: seaice_snowdepth_min
integer :: seaice_albedo_opt
real :: seaice_albedo_default
integer :: seaice_thickness_opt
real :: seaice_thickness_default
logical :: tice2tsk_if2cold
real :: bucket_mm
real :: bucket_j
real :: mp_tend_lim
real , DIMENSION(max_domains) :: prec_acc_dt
integer :: prec_acc_opt
integer :: bucketr_opt
integer :: bucketf_opt
integer :: process_time_series
integer , DIMENSION(max_domains) :: grav_settling
real , DIMENSION(max_domains) :: sas_pgcon
integer , DIMENSION(max_domains) :: scalar_pblmix
integer , DIMENSION(max_domains) :: tracer_pblmix
logical :: use_aero_icbc
logical :: use_rap_aero_icbc
integer :: use_mp_re
real :: ccn_conc
integer :: hail_opt
integer :: morr_rimed_ice
integer :: clean_atm_diag
integer :: calc_clean_atm_diag
integer :: dveg
integer :: opt_crs
integer :: opt_btr
integer :: opt_run
integer :: opt_sfc
integer :: opt_frz
integer :: opt_inf
integer :: opt_rad
integer :: opt_alb
integer :: opt_snf
integer :: opt_tbot
integer :: opt_stc
integer :: opt_gla
integer :: opt_rsf
integer :: opt_soil
integer :: opt_pedo
integer :: opt_crop
real , DIMENSION(max_domains) :: wtddt
integer :: wrf_hydro
real , DIMENSION(max_domains) :: fgdt
integer , DIMENSION(max_domains) :: fgdtzero
integer , DIMENSION(max_domains) :: grid_fdda
integer , DIMENSION(max_domains) :: grid_sfdda
integer , DIMENSION(max_domains) :: if_no_pbl_nudging_uv
integer , DIMENSION(max_domains) :: if_no_pbl_nudging_t
integer , DIMENSION(max_domains) :: if_no_pbl_nudging_ph
integer , DIMENSION(max_domains) :: if_no_pbl_nudging_q
integer , DIMENSION(max_domains) :: if_zfac_uv
integer , DIMENSION(max_domains) :: k_zfac_uv
integer , DIMENSION(max_domains) :: if_zfac_t
integer , DIMENSION(max_domains) :: k_zfac_t
integer , DIMENSION(max_domains) :: if_zfac_ph
integer , DIMENSION(max_domains) :: k_zfac_ph
integer , DIMENSION(max_domains) :: if_zfac_q
integer , DIMENSION(max_domains) :: k_zfac_q
integer , DIMENSION(max_domains) :: dk_zfac_uv
integer , DIMENSION(max_domains) :: dk_zfac_t
integer , DIMENSION(max_domains) :: dk_zfac_ph
integer , DIMENSION(max_domains) :: dk_zfac_q
integer :: ktrop
real , DIMENSION(max_domains) :: guv
real , DIMENSION(max_domains) :: guv_sfc
real , DIMENSION(max_domains) :: gt
real , DIMENSION(max_domains) :: gt_sfc
real , DIMENSION(max_domains) :: gq
real , DIMENSION(max_domains) :: gq_sfc
real , DIMENSION(max_domains) :: gph
real :: dtramp_min
integer :: if_ramping
real , DIMENSION(max_domains) :: rinblw
integer , DIMENSION(max_domains) :: xwavenum
integer , DIMENSION(max_domains) :: ywavenum
integer , DIMENSION(max_domains) :: pxlsm_soil_nudge
integer , DIMENSION(max_domains) :: fasdas
integer , DIMENSION(max_domains) :: obs_nudge_opt
integer :: max_obs
real , DIMENSION(max_domains) :: fdda_start
real , DIMENSION(max_domains) :: fdda_end
integer , DIMENSION(max_domains) :: obs_nudge_wind
real , DIMENSION(max_domains) :: obs_coef_wind
integer , DIMENSION(max_domains) :: obs_nudge_temp
real , DIMENSION(max_domains) :: obs_coef_temp
integer , DIMENSION(max_domains) :: obs_nudge_mois
real , DIMENSION(max_domains) :: obs_coef_mois
integer , DIMENSION(max_domains) :: obs_nudge_pstr
real , DIMENSION(max_domains) :: obs_coef_pstr
integer , DIMENSION(max_domains) :: obs_no_pbl_nudge_uv
integer , DIMENSION(max_domains) :: obs_no_pbl_nudge_t
integer , DIMENSION(max_domains) :: obs_no_pbl_nudge_q
integer :: obs_sfc_scheme_horiz
integer :: obs_sfc_scheme_vert
real :: obs_max_sndng_gap
real :: obs_nudgezfullr1_uv
real :: obs_nudgezrampr1_uv
real :: obs_nudgezfullr2_uv
real :: obs_nudgezrampr2_uv
real :: obs_nudgezfullr4_uv
real :: obs_nudgezrampr4_uv
real :: obs_nudgezfullr1_t
real :: obs_nudgezrampr1_t
real :: obs_nudgezfullr2_t
real :: obs_nudgezrampr2_t
real :: obs_nudgezfullr4_t
real :: obs_nudgezrampr4_t
real :: obs_nudgezfullr1_q
real :: obs_nudgezrampr1_q
real :: obs_nudgezfullr2_q
real :: obs_nudgezrampr2_q
real :: obs_nudgezfullr4_q
real :: obs_nudgezrampr4_q
real :: obs_nudgezfullmin
real :: obs_nudgezrampmin
real :: obs_nudgezmax
real :: obs_sfcfact
real :: obs_sfcfacr
real :: obs_dpsmx
real , DIMENSION(max_domains) :: obs_rinxy
real :: obs_rinsig
real , DIMENSION(max_domains) :: obs_twindo
integer :: obs_npfi
integer , DIMENSION(max_domains) :: obs_ionf
integer :: obs_idynin
real :: obs_dtramp
integer :: obs_prt_max
integer , DIMENSION(max_domains) :: obs_prt_freq
logical :: obs_ipf_in4dob
logical :: obs_ipf_errob
logical :: obs_ipf_nudob
logical :: obs_ipf_init
integer :: obs_scl_neg_qv_innov
integer :: scm_force
real :: scm_force_dx
integer :: num_force_layers
integer :: scm_lu_index
integer :: scm_isltyp
real :: scm_vegfra
real :: scm_canwat
real :: scm_lat
real :: scm_lon
logical :: scm_th_t_tend
logical :: scm_qv_t_tend
logical :: scm_th_adv
logical :: scm_wind_adv
logical :: scm_qv_adv
logical :: scm_ql_adv
logical :: scm_vert_adv
integer :: num_force_soil_layers
logical :: scm_soilt_force
logical :: scm_soilq_force
logical :: scm_force_th_largescale
logical :: scm_force_qv_largescale
logical :: scm_force_ql_largescale
logical :: scm_force_wind_largescale
integer :: scm_force_skintemp
integer :: scm_force_flux
integer :: dyn_opt
integer :: rk_ord
integer :: w_damping
integer , DIMENSION(max_domains) :: diff_opt
integer , DIMENSION(max_domains) :: diff_opt_dfi
integer , DIMENSION(max_domains) :: km_opt
integer , DIMENSION(max_domains) :: km_opt_dfi
integer :: damp_opt
integer :: rad_nudge
integer :: gwd_opt
real :: max_rot_angle_gwd
real , DIMENSION(max_domains) :: zdamp
real , DIMENSION(max_domains) :: dampcoef
real , DIMENSION(max_domains) :: khdif
real , DIMENSION(max_domains) :: kvdif
real , DIMENSION(max_domains) :: diff_6th_factor
integer , DIMENSION(max_domains) :: diff_6th_opt
integer , DIMENSION(max_domains) :: diff_6th_slopeopt
real , DIMENSION(max_domains) :: diff_6th_thresh
integer :: use_theta_m
integer :: use_q_diabatic
real , DIMENSION(max_domains) :: c_s
real , DIMENSION(max_domains) :: c_k
real , DIMENSION(max_domains) :: smdiv
real , DIMENSION(max_domains) :: emdiv
real , DIMENSION(max_domains) :: epssm
logical , DIMENSION(max_domains) :: non_hydrostatic
logical :: use_input_w
integer , DIMENSION(max_domains) :: time_step_sound
integer , DIMENSION(max_domains) :: h_mom_adv_order
integer , DIMENSION(max_domains) :: v_mom_adv_order
integer , DIMENSION(max_domains) :: h_sca_adv_order
integer , DIMENSION(max_domains) :: v_sca_adv_order
integer , DIMENSION(max_domains) :: momentum_adv_opt
integer , DIMENSION(max_domains) :: moist_adv_opt
integer , DIMENSION(max_domains) :: moist_adv_dfi_opt
integer , DIMENSION(max_domains) :: chem_adv_opt
integer , DIMENSION(max_domains) :: tracer_adv_opt
integer , DIMENSION(max_domains) :: scalar_adv_opt
integer , DIMENSION(max_domains) :: tke_adv_opt
logical , DIMENSION(max_domains) :: moist_mix2_off
logical , DIMENSION(max_domains) :: chem_mix2_off
logical , DIMENSION(max_domains) :: tracer_mix2_off
logical , DIMENSION(max_domains) :: scalar_mix2_off
logical , DIMENSION(max_domains) :: tke_mix2_off
logical , DIMENSION(max_domains) :: moist_mix6_off
logical , DIMENSION(max_domains) :: chem_mix6_off
logical , DIMENSION(max_domains) :: tracer_mix6_off
logical , DIMENSION(max_domains) :: scalar_mix6_off
logical , DIMENSION(max_domains) :: tke_mix6_off
logical , DIMENSION(max_domains) :: top_radiation
integer , DIMENSION(max_domains) :: mix_isotropic
real , DIMENSION(max_domains) :: mix_upper_bound
logical , DIMENSION(max_domains) :: top_lid
real , DIMENSION(max_domains) :: tke_upper_bound
real , DIMENSION(max_domains) :: tke_drag_coefficient
real , DIMENSION(max_domains) :: tke_heat_flux
logical , DIMENSION(max_domains) :: pert_coriolis
logical , DIMENSION(max_domains) :: coriolis2d
logical , DIMENSION(max_domains) :: mix_full_fields
real :: base_pres
real :: base_temp
real :: base_lapse
real :: iso_temp
real :: base_pres_strat
real :: base_lapse_strat
logical :: use_baseparam_fr_nml
real :: fft_filter_lat
logical :: coupled_filtering
logical :: pos_def
logical :: swap_pole_with_next_j
logical :: actual_distance_average
logical :: rotated_pole
logical , DIMENSION(max_domains) :: do_coriolis
logical , DIMENSION(max_domains) :: do_curvature
logical , DIMENSION(max_domains) :: do_gradp
integer , DIMENSION(max_domains) :: tracer_opt
integer , DIMENSION(max_domains) :: tenddiag
integer :: spec_bdy_width
integer :: spec_zone
integer :: relax_zone
logical , DIMENSION(max_domains) :: specified
logical :: constant_bc
logical , DIMENSION(max_domains) :: periodic_x
logical , DIMENSION(max_domains) :: symmetric_xs
logical , DIMENSION(max_domains) :: symmetric_xe
logical , DIMENSION(max_domains) :: open_xs
logical , DIMENSION(max_domains) :: open_xe
logical , DIMENSION(max_domains) :: periodic_y
logical , DIMENSION(max_domains) :: symmetric_ys
logical , DIMENSION(max_domains) :: symmetric_ye
logical , DIMENSION(max_domains) :: open_ys
logical , DIMENSION(max_domains) :: open_ye
logical , DIMENSION(max_domains) :: polar
logical , DIMENSION(max_domains) :: nested
real :: spec_exp
integer :: spec_bdy_final_mu
integer :: real_data_init_type
logical , DIMENSION(max_domains) :: have_bcs_moist
logical , DIMENSION(max_domains) :: have_bcs_scalar
integer :: background_proc_id
integer :: forecast_proc_id
integer :: production_status
integer :: compression
integer :: nobs_ndg_vars
integer :: nobs_err_flds
real , DIMENSION(max_domains) :: cen_lat
real , DIMENSION(max_domains) :: cen_lon
real , DIMENSION(max_domains) :: truelat1
real , DIMENSION(max_domains) :: truelat2
real , DIMENSION(max_domains) :: moad_cen_lat
real , DIMENSION(max_domains) :: stand_lon
real , DIMENSION(max_domains) :: pole_lat
real , DIMENSION(max_domains) :: pole_lon
integer :: flag_metgrid
integer :: flag_snow
integer :: flag_psfc
integer :: flag_sm000010
integer :: flag_sm010040
integer :: flag_sm040100
integer :: flag_sm100200
integer :: flag_st000010
integer :: flag_st010040
integer :: flag_st040100
integer :: flag_st100200
integer :: flag_soil_layers
integer :: flag_slp
integer :: flag_soilhgt
integer :: flag_mf_xy
integer :: flag_um_soil
real , DIMENSION(max_domains) :: bdyfrq
character*256 , DIMENSION(max_domains) :: mminlu
integer , DIMENSION(max_domains) :: iswater
integer , DIMENSION(max_domains) :: islake
integer , DIMENSION(max_domains) :: isice
integer , DIMENSION(max_domains) :: isurban
integer , DIMENSION(max_domains) :: isoilwater
integer , DIMENSION(max_domains) :: map_proj
integer :: use_wps_input
integer , DIMENSION(max_domains) :: dfi_stage
integer , DIMENSION(max_domains) :: mp_physics_dfi
integer , DIMENSION(max_domains) :: bl_pbl_physics_dfi
integer , DIMENSION(max_domains) :: windfarm_opt
integer :: windfarm_ij
integer :: ideal_case
integer , DIMENSION(max_domains) :: hailcast_opt
real , DIMENSION(max_domains) :: haildt
integer , DIMENSION(max_domains) :: lightning_option
real , DIMENSION(max_domains) :: lightning_dt
real , DIMENSION(max_domains) :: lightning_start_seconds
real , DIMENSION(max_domains) :: flashrate_factor
integer , DIMENSION(max_domains) :: iccg_method
real , DIMENSION(max_domains) :: iccg_prescribed_num
real , DIMENSION(max_domains) :: iccg_prescribed_den
integer , DIMENSION(max_domains) :: cellcount_method
real , DIMENSION(max_domains) :: cldtop_adjustment
integer , DIMENSION(max_domains) :: sf_lake_physics
character*256 :: auxinput1_inname
integer :: io_form_auxinput1
logical :: override_restart_timers
character*256 :: auxhist1_inname
character*256 :: auxhist1_outname
integer , DIMENSION(max_domains) :: auxhist1_interval_y
integer , DIMENSION(max_domains) :: auxhist1_interval_d
integer , DIMENSION(max_domains) :: auxhist1_interval_h
integer , DIMENSION(max_domains) :: auxhist1_interval_m
integer , DIMENSION(max_domains) :: auxhist1_interval_s
integer , DIMENSION(max_domains) :: auxhist1_interval
integer , DIMENSION(max_domains) :: auxhist1_begin_y
integer , DIMENSION(max_domains) :: auxhist1_begin_d
integer , DIMENSION(max_domains) :: auxhist1_begin_h
integer , DIMENSION(max_domains) :: auxhist1_begin_m
integer , DIMENSION(max_domains) :: auxhist1_begin_s
integer , DIMENSION(max_domains) :: auxhist1_begin
integer , DIMENSION(max_domains) :: auxhist1_end_y
integer , DIMENSION(max_domains) :: auxhist1_end_d
integer , DIMENSION(max_domains) :: auxhist1_end_h
integer , DIMENSION(max_domains) :: auxhist1_end_m
integer , DIMENSION(max_domains) :: auxhist1_end_s
integer , DIMENSION(max_domains) :: auxhist1_end
integer :: io_form_auxhist1
integer , DIMENSION(max_domains) :: frames_per_auxhist1
character*256 :: auxhist2_inname
character*256 :: auxhist2_outname
integer , DIMENSION(max_domains) :: auxhist2_interval_y
integer , DIMENSION(max_domains) :: auxhist2_interval_d
integer , DIMENSION(max_domains) :: auxhist2_interval_h
integer , DIMENSION(max_domains) :: auxhist2_interval_m
integer , DIMENSION(max_domains) :: auxhist2_interval_s
integer , DIMENSION(max_domains) :: auxhist2_interval
integer , DIMENSION(max_domains) :: auxhist2_begin_y
integer , DIMENSION(max_domains) :: auxhist2_begin_d
integer , DIMENSION(max_domains) :: auxhist2_begin_h
integer , DIMENSION(max_domains) :: auxhist2_begin_m
integer , DIMENSION(max_domains) :: auxhist2_begin_s
integer , DIMENSION(max_domains) :: auxhist2_begin
integer , DIMENSION(max_domains) :: auxhist2_end_y
integer , DIMENSION(max_domains) :: auxhist2_end_d
integer , DIMENSION(max_domains) :: auxhist2_end_h
integer , DIMENSION(max_domains) :: auxhist2_end_m
integer , DIMENSION(max_domains) :: auxhist2_end_s
integer , DIMENSION(max_domains) :: auxhist2_end
integer :: io_form_auxhist2
integer , DIMENSION(max_domains) :: frames_per_auxhist2
character*256 :: auxhist3_inname
character*256 :: auxhist3_outname
integer , DIMENSION(max_domains) :: auxhist3_interval_y
integer , DIMENSION(max_domains) :: auxhist3_interval_d
integer , DIMENSION(max_domains) :: auxhist3_interval_h
integer , DIMENSION(max_domains) :: auxhist3_interval_m
integer , DIMENSION(max_domains) :: auxhist3_interval_s
integer , DIMENSION(max_domains) :: auxhist3_interval
integer , DIMENSION(max_domains) :: auxhist3_begin_y
integer , DIMENSION(max_domains) :: auxhist3_begin_d
integer , DIMENSION(max_domains) :: auxhist3_begin_h
integer , DIMENSION(max_domains) :: auxhist3_begin_m
integer , DIMENSION(max_domains) :: auxhist3_begin_s
integer , DIMENSION(max_domains) :: auxhist3_begin
integer , DIMENSION(max_domains) :: auxhist3_end_y
integer , DIMENSION(max_domains) :: auxhist3_end_d
integer , DIMENSION(max_domains) :: auxhist3_end_h
integer , DIMENSION(max_domains) :: auxhist3_end_m
integer , DIMENSION(max_domains) :: auxhist3_end_s
integer , DIMENSION(max_domains) :: auxhist3_end
integer :: io_form_auxhist3
integer , DIMENSION(max_domains) :: frames_per_auxhist3
character*256 :: auxhist4_inname
character*256 :: auxhist4_outname
integer , DIMENSION(max_domains) :: auxhist4_interval_y
integer , DIMENSION(max_domains) :: auxhist4_interval_d
integer , DIMENSION(max_domains) :: auxhist4_interval_h
integer , DIMENSION(max_domains) :: auxhist4_interval_m
integer , DIMENSION(max_domains) :: auxhist4_interval_s
integer , DIMENSION(max_domains) :: auxhist4_interval
integer , DIMENSION(max_domains) :: auxhist4_begin_y
integer , DIMENSION(max_domains) :: auxhist4_begin_d
integer , DIMENSION(max_domains) :: auxhist4_begin_h
integer , DIMENSION(max_domains) :: auxhist4_begin_m
integer , DIMENSION(max_domains) :: auxhist4_begin_s
integer , DIMENSION(max_domains) :: auxhist4_begin
integer , DIMENSION(max_domains) :: auxhist4_end_y
integer , DIMENSION(max_domains) :: auxhist4_end_d
integer , DIMENSION(max_domains) :: auxhist4_end_h
integer , DIMENSION(max_domains) :: auxhist4_end_m
integer , DIMENSION(max_domains) :: auxhist4_end_s
integer , DIMENSION(max_domains) :: auxhist4_end
integer :: io_form_auxhist4
integer , DIMENSION(max_domains) :: frames_per_auxhist4
character*256 :: auxhist5_inname
character*256 :: auxhist5_outname
integer , DIMENSION(max_domains) :: auxhist5_interval_y
integer , DIMENSION(max_domains) :: auxhist5_interval_d
integer , DIMENSION(max_domains) :: auxhist5_interval_h
integer , DIMENSION(max_domains) :: auxhist5_interval_m
integer , DIMENSION(max_domains) :: auxhist5_interval_s
integer , DIMENSION(max_domains) :: auxhist5_interval
integer , DIMENSION(max_domains) :: auxhist5_begin_y
integer , DIMENSION(max_domains) :: auxhist5_begin_d
integer , DIMENSION(max_domains) :: auxhist5_begin_h
integer , DIMENSION(max_domains) :: auxhist5_begin_m
integer , DIMENSION(max_domains) :: auxhist5_begin_s
integer , DIMENSION(max_domains) :: auxhist5_begin
integer , DIMENSION(max_domains) :: auxhist5_end_y
integer , DIMENSION(max_domains) :: auxhist5_end_d
integer , DIMENSION(max_domains) :: auxhist5_end_h
integer , DIMENSION(max_domains) :: auxhist5_end_m
integer , DIMENSION(max_domains) :: auxhist5_end_s
integer , DIMENSION(max_domains) :: auxhist5_end
integer :: io_form_auxhist5
integer , DIMENSION(max_domains) :: frames_per_auxhist5
character*256 :: auxhist6_inname
character*256 :: auxhist6_outname
integer , DIMENSION(max_domains) :: auxhist6_interval_y
integer , DIMENSION(max_domains) :: auxhist6_interval_d
integer , DIMENSION(max_domains) :: auxhist6_interval_h
integer , DIMENSION(max_domains) :: auxhist6_interval_m
integer , DIMENSION(max_domains) :: auxhist6_interval_s
integer , DIMENSION(max_domains) :: auxhist6_interval
integer , DIMENSION(max_domains) :: auxhist6_begin_y
integer , DIMENSION(max_domains) :: auxhist6_begin_d
integer , DIMENSION(max_domains) :: auxhist6_begin_h
integer , DIMENSION(max_domains) :: auxhist6_begin_m
integer , DIMENSION(max_domains) :: auxhist6_begin_s
integer , DIMENSION(max_domains) :: auxhist6_begin
integer , DIMENSION(max_domains) :: auxhist6_end_y
integer , DIMENSION(max_domains) :: auxhist6_end_d
integer , DIMENSION(max_domains) :: auxhist6_end_h
integer , DIMENSION(max_domains) :: auxhist6_end_m
integer , DIMENSION(max_domains) :: auxhist6_end_s
integer , DIMENSION(max_domains) :: auxhist6_end
integer :: io_form_auxhist6
integer , DIMENSION(max_domains) :: frames_per_auxhist6
character*256 :: auxhist7_inname
character*256 :: auxhist7_outname
integer , DIMENSION(max_domains) :: auxhist7_interval_y
integer , DIMENSION(max_domains) :: auxhist7_interval_d
integer , DIMENSION(max_domains) :: auxhist7_interval_h
integer , DIMENSION(max_domains) :: auxhist7_interval_m
integer , DIMENSION(max_domains) :: auxhist7_interval_s
integer , DIMENSION(max_domains) :: auxhist7_interval
integer , DIMENSION(max_domains) :: auxhist7_begin_y
integer , DIMENSION(max_domains) :: auxhist7_begin_d
integer , DIMENSION(max_domains) :: auxhist7_begin_h
integer , DIMENSION(max_domains) :: auxhist7_begin_m
integer , DIMENSION(max_domains) :: auxhist7_begin_s
integer , DIMENSION(max_domains) :: auxhist7_begin
integer , DIMENSION(max_domains) :: auxhist7_end_y
integer , DIMENSION(max_domains) :: auxhist7_end_d
integer , DIMENSION(max_domains) :: auxhist7_end_h
integer , DIMENSION(max_domains) :: auxhist7_end_m
integer , DIMENSION(max_domains) :: auxhist7_end_s
integer , DIMENSION(max_domains) :: auxhist7_end
integer :: io_form_auxhist7
integer , DIMENSION(max_domains) :: frames_per_auxhist7
character*256 :: auxhist8_inname
character*256 :: auxhist8_outname
integer , DIMENSION(max_domains) :: auxhist8_interval_y
integer , DIMENSION(max_domains) :: auxhist8_interval_d
integer , DIMENSION(max_domains) :: auxhist8_interval_h
integer , DIMENSION(max_domains) :: auxhist8_interval_m
integer , DIMENSION(max_domains) :: auxhist8_interval_s
integer , DIMENSION(max_domains) :: auxhist8_interval
integer , DIMENSION(max_domains) :: auxhist8_begin_y
integer , DIMENSION(max_domains) :: auxhist8_begin_d
integer , DIMENSION(max_domains) :: auxhist8_begin_h
integer , DIMENSION(max_domains) :: auxhist8_begin_m
integer , DIMENSION(max_domains) :: auxhist8_begin_s
integer , DIMENSION(max_domains) :: auxhist8_begin
integer , DIMENSION(max_domains) :: auxhist8_end_y
integer , DIMENSION(max_domains) :: auxhist8_end_d
integer , DIMENSION(max_domains) :: auxhist8_end_h
integer , DIMENSION(max_domains) :: auxhist8_end_m
integer , DIMENSION(max_domains) :: auxhist8_end_s
integer , DIMENSION(max_domains) :: auxhist8_end
integer :: io_form_auxhist8
integer , DIMENSION(max_domains) :: frames_per_auxhist8
character*256 :: auxhist9_inname
character*256 :: auxhist9_outname
integer , DIMENSION(max_domains) :: auxhist9_interval_y
integer , DIMENSION(max_domains) :: auxhist9_interval_d
integer , DIMENSION(max_domains) :: auxhist9_interval_h
integer , DIMENSION(max_domains) :: auxhist9_interval_m
integer , DIMENSION(max_domains) :: auxhist9_interval_s
integer , DIMENSION(max_domains) :: auxhist9_interval
integer , DIMENSION(max_domains) :: auxhist9_begin_y
integer , DIMENSION(max_domains) :: auxhist9_begin_d
integer , DIMENSION(max_domains) :: auxhist9_begin_h
integer , DIMENSION(max_domains) :: auxhist9_begin_m
integer , DIMENSION(max_domains) :: auxhist9_begin_s
integer , DIMENSION(max_domains) :: auxhist9_begin
integer , DIMENSION(max_domains) :: auxhist9_end_y
integer , DIMENSION(max_domains) :: auxhist9_end_d
integer , DIMENSION(max_domains) :: auxhist9_end_h
integer , DIMENSION(max_domains) :: auxhist9_end_m
integer , DIMENSION(max_domains) :: auxhist9_end_s
integer , DIMENSION(max_domains) :: auxhist9_end
integer :: io_form_auxhist9
integer , DIMENSION(max_domains) :: frames_per_auxhist9
character*256 :: auxhist10_inname
character*256 :: auxhist10_outname
integer , DIMENSION(max_domains) :: auxhist10_interval_y
integer , DIMENSION(max_domains) :: auxhist10_interval_d
integer , DIMENSION(max_domains) :: auxhist10_interval_h
integer , DIMENSION(max_domains) :: auxhist10_interval_m
integer , DIMENSION(max_domains) :: auxhist10_interval_s
integer , DIMENSION(max_domains) :: auxhist10_interval
integer , DIMENSION(max_domains) :: auxhist10_begin_y
integer , DIMENSION(max_domains) :: auxhist10_begin_d
integer , DIMENSION(max_domains) :: auxhist10_begin_h
integer , DIMENSION(max_domains) :: auxhist10_begin_m
integer , DIMENSION(max_domains) :: auxhist10_begin_s
integer , DIMENSION(max_domains) :: auxhist10_begin
integer , DIMENSION(max_domains) :: auxhist10_end_y
integer , DIMENSION(max_domains) :: auxhist10_end_d
integer , DIMENSION(max_domains) :: auxhist10_end_h
integer , DIMENSION(max_domains) :: auxhist10_end_m
integer , DIMENSION(max_domains) :: auxhist10_end_s
integer , DIMENSION(max_domains) :: auxhist10_end
integer :: io_form_auxhist10
integer , DIMENSION(max_domains) :: frames_per_auxhist10
character*256 :: auxhist11_inname
character*256 :: auxhist11_outname
integer , DIMENSION(max_domains) :: auxhist11_interval_y
integer , DIMENSION(max_domains) :: auxhist11_interval_d
integer , DIMENSION(max_domains) :: auxhist11_interval_h
integer , DIMENSION(max_domains) :: auxhist11_interval_m
integer , DIMENSION(max_domains) :: auxhist11_interval_s
integer , DIMENSION(max_domains) :: auxhist11_interval
integer , DIMENSION(max_domains) :: auxhist11_begin_y
integer , DIMENSION(max_domains) :: auxhist11_begin_d
integer , DIMENSION(max_domains) :: auxhist11_begin_h
integer , DIMENSION(max_domains) :: auxhist11_begin_m
integer , DIMENSION(max_domains) :: auxhist11_begin_s
integer , DIMENSION(max_domains) :: auxhist11_begin
integer , DIMENSION(max_domains) :: auxhist11_end_y
integer , DIMENSION(max_domains) :: auxhist11_end_d
integer , DIMENSION(max_domains) :: auxhist11_end_h
integer , DIMENSION(max_domains) :: auxhist11_end_m
integer , DIMENSION(max_domains) :: auxhist11_end_s
integer , DIMENSION(max_domains) :: auxhist11_end
integer :: io_form_auxhist11
integer , DIMENSION(max_domains) :: frames_per_auxhist11
character*256 :: auxhist12_inname
character*256 :: auxhist12_outname
integer , DIMENSION(max_domains) :: auxhist12_interval_y
integer , DIMENSION(max_domains) :: auxhist12_interval_d
integer , DIMENSION(max_domains) :: auxhist12_interval_h
integer , DIMENSION(max_domains) :: auxhist12_interval_m
integer , DIMENSION(max_domains) :: auxhist12_interval_s
integer , DIMENSION(max_domains) :: auxhist12_interval
integer , DIMENSION(max_domains) :: auxhist12_begin_y
integer , DIMENSION(max_domains) :: auxhist12_begin_d
integer , DIMENSION(max_domains) :: auxhist12_begin_h
integer , DIMENSION(max_domains) :: auxhist12_begin_m
integer , DIMENSION(max_domains) :: auxhist12_begin_s
integer , DIMENSION(max_domains) :: auxhist12_begin
integer , DIMENSION(max_domains) :: auxhist12_end_y
integer , DIMENSION(max_domains) :: auxhist12_end_d
integer , DIMENSION(max_domains) :: auxhist12_end_h
integer , DIMENSION(max_domains) :: auxhist12_end_m
integer , DIMENSION(max_domains) :: auxhist12_end_s
integer , DIMENSION(max_domains) :: auxhist12_end
integer :: io_form_auxhist12
integer , DIMENSION(max_domains) :: frames_per_auxhist12
character*256 :: auxhist13_inname
character*256 :: auxhist13_outname
integer , DIMENSION(max_domains) :: auxhist13_interval_y
integer , DIMENSION(max_domains) :: auxhist13_interval_d
integer , DIMENSION(max_domains) :: auxhist13_interval_h
integer , DIMENSION(max_domains) :: auxhist13_interval_m
integer , DIMENSION(max_domains) :: auxhist13_interval_s
integer , DIMENSION(max_domains) :: auxhist13_interval
integer , DIMENSION(max_domains) :: auxhist13_begin_y
integer , DIMENSION(max_domains) :: auxhist13_begin_d
integer , DIMENSION(max_domains) :: auxhist13_begin_h
integer , DIMENSION(max_domains) :: auxhist13_begin_m
integer , DIMENSION(max_domains) :: auxhist13_begin_s
integer , DIMENSION(max_domains) :: auxhist13_begin
integer , DIMENSION(max_domains) :: auxhist13_end_y
integer , DIMENSION(max_domains) :: auxhist13_end_d
integer , DIMENSION(max_domains) :: auxhist13_end_h
integer , DIMENSION(max_domains) :: auxhist13_end_m
integer , DIMENSION(max_domains) :: auxhist13_end_s
integer , DIMENSION(max_domains) :: auxhist13_end
integer :: io_form_auxhist13
integer , DIMENSION(max_domains) :: frames_per_auxhist13
character*256 :: auxhist14_inname
character*256 :: auxhist14_outname
integer , DIMENSION(max_domains) :: auxhist14_interval_y
integer , DIMENSION(max_domains) :: auxhist14_interval_d
integer , DIMENSION(max_domains) :: auxhist14_interval_h
integer , DIMENSION(max_domains) :: auxhist14_interval_m
integer , DIMENSION(max_domains) :: auxhist14_interval_s
integer , DIMENSION(max_domains) :: auxhist14_interval
integer , DIMENSION(max_domains) :: auxhist14_begin_y
integer , DIMENSION(max_domains) :: auxhist14_begin_d
integer , DIMENSION(max_domains) :: auxhist14_begin_h
integer , DIMENSION(max_domains) :: auxhist14_begin_m
integer , DIMENSION(max_domains) :: auxhist14_begin_s
integer , DIMENSION(max_domains) :: auxhist14_begin
integer , DIMENSION(max_domains) :: auxhist14_end_y
integer , DIMENSION(max_domains) :: auxhist14_end_d
integer , DIMENSION(max_domains) :: auxhist14_end_h
integer , DIMENSION(max_domains) :: auxhist14_end_m
integer , DIMENSION(max_domains) :: auxhist14_end_s
integer , DIMENSION(max_domains) :: auxhist14_end
integer :: io_form_auxhist14
integer , DIMENSION(max_domains) :: frames_per_auxhist14
character*256 :: auxhist15_inname
character*256 :: auxhist15_outname
integer , DIMENSION(max_domains) :: auxhist15_interval_y
integer , DIMENSION(max_domains) :: auxhist15_interval_d
integer , DIMENSION(max_domains) :: auxhist15_interval_h
integer , DIMENSION(max_domains) :: auxhist15_interval_m
integer , DIMENSION(max_domains) :: auxhist15_interval_s
integer , DIMENSION(max_domains) :: auxhist15_interval
integer , DIMENSION(max_domains) :: auxhist15_begin_y
integer , DIMENSION(max_domains) :: auxhist15_begin_d
integer , DIMENSION(max_domains) :: auxhist15_begin_h
integer , DIMENSION(max_domains) :: auxhist15_begin_m
integer , DIMENSION(max_domains) :: auxhist15_begin_s
integer , DIMENSION(max_domains) :: auxhist15_begin
integer , DIMENSION(max_domains) :: auxhist15_end_y
integer , DIMENSION(max_domains) :: auxhist15_end_d
integer , DIMENSION(max_domains) :: auxhist15_end_h
integer , DIMENSION(max_domains) :: auxhist15_end_m
integer , DIMENSION(max_domains) :: auxhist15_end_s
integer , DIMENSION(max_domains) :: auxhist15_end
integer :: io_form_auxhist15
integer , DIMENSION(max_domains) :: frames_per_auxhist15
character*256 :: auxhist16_inname
character*256 :: auxhist16_outname
integer , DIMENSION(max_domains) :: auxhist16_interval_y
integer , DIMENSION(max_domains) :: auxhist16_interval_d
integer , DIMENSION(max_domains) :: auxhist16_interval_h
integer , DIMENSION(max_domains) :: auxhist16_interval_m
integer , DIMENSION(max_domains) :: auxhist16_interval_s
integer , DIMENSION(max_domains) :: auxhist16_interval
integer , DIMENSION(max_domains) :: auxhist16_begin_y
integer , DIMENSION(max_domains) :: auxhist16_begin_d
integer , DIMENSION(max_domains) :: auxhist16_begin_h
integer , DIMENSION(max_domains) :: auxhist16_begin_m
integer , DIMENSION(max_domains) :: auxhist16_begin_s
integer , DIMENSION(max_domains) :: auxhist16_begin
integer , DIMENSION(max_domains) :: auxhist16_end_y
integer , DIMENSION(max_domains) :: auxhist16_end_d
integer , DIMENSION(max_domains) :: auxhist16_end_h
integer , DIMENSION(max_domains) :: auxhist16_end_m
integer , DIMENSION(max_domains) :: auxhist16_end_s
integer , DIMENSION(max_domains) :: auxhist16_end
integer :: io_form_auxhist16
integer , DIMENSION(max_domains) :: frames_per_auxhist16
character*256 :: auxhist17_inname
character*256 :: auxhist17_outname
integer , DIMENSION(max_domains) :: auxhist17_interval_y
integer , DIMENSION(max_domains) :: auxhist17_interval_d
integer , DIMENSION(max_domains) :: auxhist17_interval_h
integer , DIMENSION(max_domains) :: auxhist17_interval_m
integer , DIMENSION(max_domains) :: auxhist17_interval_s
integer , DIMENSION(max_domains) :: auxhist17_interval
integer , DIMENSION(max_domains) :: auxhist17_begin_y
integer , DIMENSION(max_domains) :: auxhist17_begin_d
integer , DIMENSION(max_domains) :: auxhist17_begin_h
integer , DIMENSION(max_domains) :: auxhist17_begin_m
integer , DIMENSION(max_domains) :: auxhist17_begin_s
integer , DIMENSION(max_domains) :: auxhist17_begin
integer , DIMENSION(max_domains) :: auxhist17_end_y
integer , DIMENSION(max_domains) :: auxhist17_end_d
integer , DIMENSION(max_domains) :: auxhist17_end_h
integer , DIMENSION(max_domains) :: auxhist17_end_m
integer , DIMENSION(max_domains) :: auxhist17_end_s
integer , DIMENSION(max_domains) :: auxhist17_end
integer :: io_form_auxhist17
integer , DIMENSION(max_domains) :: frames_per_auxhist17
character*256 :: auxhist18_inname
character*256 :: auxhist18_outname
integer , DIMENSION(max_domains) :: auxhist18_interval_y
integer , DIMENSION(max_domains) :: auxhist18_interval_d
integer , DIMENSION(max_domains) :: auxhist18_interval_h
integer , DIMENSION(max_domains) :: auxhist18_interval_m
integer , DIMENSION(max_domains) :: auxhist18_interval_s
integer , DIMENSION(max_domains) :: auxhist18_interval
integer , DIMENSION(max_domains) :: auxhist18_begin_y
integer , DIMENSION(max_domains) :: auxhist18_begin_d
integer , DIMENSION(max_domains) :: auxhist18_begin_h
integer , DIMENSION(max_domains) :: auxhist18_begin_m
integer , DIMENSION(max_domains) :: auxhist18_begin_s
integer , DIMENSION(max_domains) :: auxhist18_begin
integer , DIMENSION(max_domains) :: auxhist18_end_y
integer , DIMENSION(max_domains) :: auxhist18_end_d
integer , DIMENSION(max_domains) :: auxhist18_end_h
integer , DIMENSION(max_domains) :: auxhist18_end_m
integer , DIMENSION(max_domains) :: auxhist18_end_s
integer , DIMENSION(max_domains) :: auxhist18_end
integer :: io_form_auxhist18
integer , DIMENSION(max_domains) :: frames_per_auxhist18
character*256 :: auxhist19_inname
character*256 :: auxhist19_outname
integer , DIMENSION(max_domains) :: auxhist19_interval_y
integer , DIMENSION(max_domains) :: auxhist19_interval_d
integer , DIMENSION(max_domains) :: auxhist19_interval_h
integer , DIMENSION(max_domains) :: auxhist19_interval_m
integer , DIMENSION(max_domains) :: auxhist19_interval_s
integer , DIMENSION(max_domains) :: auxhist19_interval
integer , DIMENSION(max_domains) :: auxhist19_begin_y
integer , DIMENSION(max_domains) :: auxhist19_begin_d
integer , DIMENSION(max_domains) :: auxhist19_begin_h
integer , DIMENSION(max_domains) :: auxhist19_begin_m
integer , DIMENSION(max_domains) :: auxhist19_begin_s
integer , DIMENSION(max_domains) :: auxhist19_begin
integer , DIMENSION(max_domains) :: auxhist19_end_y
integer , DIMENSION(max_domains) :: auxhist19_end_d
integer , DIMENSION(max_domains) :: auxhist19_end_h
integer , DIMENSION(max_domains) :: auxhist19_end_m
integer , DIMENSION(max_domains) :: auxhist19_end_s
integer , DIMENSION(max_domains) :: auxhist19_end
integer :: io_form_auxhist19
integer , DIMENSION(max_domains) :: frames_per_auxhist19
character*256 :: auxhist20_inname
character*256 :: auxhist20_outname
integer , DIMENSION(max_domains) :: auxhist20_interval_y
integer , DIMENSION(max_domains) :: auxhist20_interval_d
integer , DIMENSION(max_domains) :: auxhist20_interval_h
integer , DIMENSION(max_domains) :: auxhist20_interval_m
integer , DIMENSION(max_domains) :: auxhist20_interval_s
integer , DIMENSION(max_domains) :: auxhist20_interval
integer , DIMENSION(max_domains) :: auxhist20_begin_y
integer , DIMENSION(max_domains) :: auxhist20_begin_d
integer , DIMENSION(max_domains) :: auxhist20_begin_h
integer , DIMENSION(max_domains) :: auxhist20_begin_m
integer , DIMENSION(max_domains) :: auxhist20_begin_s
integer , DIMENSION(max_domains) :: auxhist20_begin
integer , DIMENSION(max_domains) :: auxhist20_end_y
integer , DIMENSION(max_domains) :: auxhist20_end_d
integer , DIMENSION(max_domains) :: auxhist20_end_h
integer , DIMENSION(max_domains) :: auxhist20_end_m
integer , DIMENSION(max_domains) :: auxhist20_end_s
integer , DIMENSION(max_domains) :: auxhist20_end
integer :: io_form_auxhist20
integer , DIMENSION(max_domains) :: frames_per_auxhist20
character*256 :: auxhist21_inname
character*256 :: auxhist21_outname
integer , DIMENSION(max_domains) :: auxhist21_interval_y
integer , DIMENSION(max_domains) :: auxhist21_interval_d
integer , DIMENSION(max_domains) :: auxhist21_interval_h
integer , DIMENSION(max_domains) :: auxhist21_interval_m
integer , DIMENSION(max_domains) :: auxhist21_interval_s
integer , DIMENSION(max_domains) :: auxhist21_interval
integer , DIMENSION(max_domains) :: auxhist21_begin_y
integer , DIMENSION(max_domains) :: auxhist21_begin_d
integer , DIMENSION(max_domains) :: auxhist21_begin_h
integer , DIMENSION(max_domains) :: auxhist21_begin_m
integer , DIMENSION(max_domains) :: auxhist21_begin_s
integer , DIMENSION(max_domains) :: auxhist21_begin
integer , DIMENSION(max_domains) :: auxhist21_end_y
integer , DIMENSION(max_domains) :: auxhist21_end_d
integer , DIMENSION(max_domains) :: auxhist21_end_h
integer , DIMENSION(max_domains) :: auxhist21_end_m
integer , DIMENSION(max_domains) :: auxhist21_end_s
integer , DIMENSION(max_domains) :: auxhist21_end
integer :: io_form_auxhist21
integer , DIMENSION(max_domains) :: frames_per_auxhist21
character*256 :: auxhist22_inname
character*256 :: auxhist22_outname
integer , DIMENSION(max_domains) :: auxhist22_interval_y
integer , DIMENSION(max_domains) :: auxhist22_interval_d
integer , DIMENSION(max_domains) :: auxhist22_interval_h
integer , DIMENSION(max_domains) :: auxhist22_interval_m
integer , DIMENSION(max_domains) :: auxhist22_interval_s
integer , DIMENSION(max_domains) :: auxhist22_interval
integer , DIMENSION(max_domains) :: auxhist22_begin_y
integer , DIMENSION(max_domains) :: auxhist22_begin_d
integer , DIMENSION(max_domains) :: auxhist22_begin_h
integer , DIMENSION(max_domains) :: auxhist22_begin_m
integer , DIMENSION(max_domains) :: auxhist22_begin_s
integer , DIMENSION(max_domains) :: auxhist22_begin
integer , DIMENSION(max_domains) :: auxhist22_end_y
integer , DIMENSION(max_domains) :: auxhist22_end_d
integer , DIMENSION(max_domains) :: auxhist22_end_h
integer , DIMENSION(max_domains) :: auxhist22_end_m
integer , DIMENSION(max_domains) :: auxhist22_end_s
integer , DIMENSION(max_domains) :: auxhist22_end
integer :: io_form_auxhist22
integer , DIMENSION(max_domains) :: frames_per_auxhist22
character*256 :: auxhist23_inname
character*256 :: auxhist23_outname
integer , DIMENSION(max_domains) :: auxhist23_interval_y
integer , DIMENSION(max_domains) :: auxhist23_interval_d
integer , DIMENSION(max_domains) :: auxhist23_interval_h
integer , DIMENSION(max_domains) :: auxhist23_interval_m
integer , DIMENSION(max_domains) :: auxhist23_interval_s
integer , DIMENSION(max_domains) :: auxhist23_interval
integer , DIMENSION(max_domains) :: auxhist23_begin_y
integer , DIMENSION(max_domains) :: auxhist23_begin_d
integer , DIMENSION(max_domains) :: auxhist23_begin_h
integer , DIMENSION(max_domains) :: auxhist23_begin_m
integer , DIMENSION(max_domains) :: auxhist23_begin_s
integer , DIMENSION(max_domains) :: auxhist23_begin
integer , DIMENSION(max_domains) :: auxhist23_end_y
integer , DIMENSION(max_domains) :: auxhist23_end_d
integer , DIMENSION(max_domains) :: auxhist23_end_h
integer , DIMENSION(max_domains) :: auxhist23_end_m
integer , DIMENSION(max_domains) :: auxhist23_end_s
integer , DIMENSION(max_domains) :: auxhist23_end
integer :: io_form_auxhist23
integer , DIMENSION(max_domains) :: frames_per_auxhist23
character*256 :: auxhist24_inname
character*256 :: auxhist24_outname
integer , DIMENSION(max_domains) :: auxhist24_interval_y
integer , DIMENSION(max_domains) :: auxhist24_interval_d
integer , DIMENSION(max_domains) :: auxhist24_interval_h
integer , DIMENSION(max_domains) :: auxhist24_interval_m
integer , DIMENSION(max_domains) :: auxhist24_interval_s
integer , DIMENSION(max_domains) :: auxhist24_interval
integer , DIMENSION(max_domains) :: auxhist24_begin_y
integer , DIMENSION(max_domains) :: auxhist24_begin_d
integer , DIMENSION(max_domains) :: auxhist24_begin_h
integer , DIMENSION(max_domains) :: auxhist24_begin_m
integer , DIMENSION(max_domains) :: auxhist24_begin_s
integer , DIMENSION(max_domains) :: auxhist24_begin
integer , DIMENSION(max_domains) :: auxhist24_end_y
integer , DIMENSION(max_domains) :: auxhist24_end_d
integer , DIMENSION(max_domains) :: auxhist24_end_h
integer , DIMENSION(max_domains) :: auxhist24_end_m
integer , DIMENSION(max_domains) :: auxhist24_end_s
integer , DIMENSION(max_domains) :: auxhist24_end
integer :: io_form_auxhist24
integer , DIMENSION(max_domains) :: frames_per_auxhist24
character*256 :: auxinput1_outname
integer , DIMENSION(max_domains) :: auxinput1_interval_y
integer , DIMENSION(max_domains) :: auxinput1_interval_d
integer , DIMENSION(max_domains) :: auxinput1_interval_h
integer , DIMENSION(max_domains) :: auxinput1_interval_m
integer , DIMENSION(max_domains) :: auxinput1_interval_s
integer , DIMENSION(max_domains) :: auxinput1_interval
integer , DIMENSION(max_domains) :: auxinput1_begin_y
integer , DIMENSION(max_domains) :: auxinput1_begin_d
integer , DIMENSION(max_domains) :: auxinput1_begin_h
integer , DIMENSION(max_domains) :: auxinput1_begin_m
integer , DIMENSION(max_domains) :: auxinput1_begin_s
integer , DIMENSION(max_domains) :: auxinput1_begin
integer , DIMENSION(max_domains) :: auxinput1_end_y
integer , DIMENSION(max_domains) :: auxinput1_end_d
integer , DIMENSION(max_domains) :: auxinput1_end_h
integer , DIMENSION(max_domains) :: auxinput1_end_m
integer , DIMENSION(max_domains) :: auxinput1_end_s
integer , DIMENSION(max_domains) :: auxinput1_end
integer , DIMENSION(max_domains) :: frames_per_auxinput1
character*256 :: auxinput2_inname
character*256 :: auxinput2_outname
integer , DIMENSION(max_domains) :: auxinput2_interval_y
integer , DIMENSION(max_domains) :: auxinput2_interval_d
integer , DIMENSION(max_domains) :: auxinput2_interval_h
integer , DIMENSION(max_domains) :: auxinput2_interval_m
integer , DIMENSION(max_domains) :: auxinput2_interval_s
integer , DIMENSION(max_domains) :: auxinput2_interval
integer , DIMENSION(max_domains) :: auxinput2_begin_y
integer , DIMENSION(max_domains) :: auxinput2_begin_d
integer , DIMENSION(max_domains) :: auxinput2_begin_h
integer , DIMENSION(max_domains) :: auxinput2_begin_m
integer , DIMENSION(max_domains) :: auxinput2_begin_s
integer , DIMENSION(max_domains) :: auxinput2_begin
integer , DIMENSION(max_domains) :: auxinput2_end_y
integer , DIMENSION(max_domains) :: auxinput2_end_d
integer , DIMENSION(max_domains) :: auxinput2_end_h
integer , DIMENSION(max_domains) :: auxinput2_end_m
integer , DIMENSION(max_domains) :: auxinput2_end_s
integer , DIMENSION(max_domains) :: auxinput2_end
integer :: io_form_auxinput2
integer , DIMENSION(max_domains) :: frames_per_auxinput2
character*256 :: auxinput3_inname
character*256 :: auxinput3_outname
integer , DIMENSION(max_domains) :: auxinput3_interval_y
integer , DIMENSION(max_domains) :: auxinput3_interval_d
integer , DIMENSION(max_domains) :: auxinput3_interval_h
integer , DIMENSION(max_domains) :: auxinput3_interval_m
integer , DIMENSION(max_domains) :: auxinput3_interval_s
integer , DIMENSION(max_domains) :: auxinput3_interval
integer , DIMENSION(max_domains) :: auxinput3_begin_y
integer , DIMENSION(max_domains) :: auxinput3_begin_d
integer , DIMENSION(max_domains) :: auxinput3_begin_h
integer , DIMENSION(max_domains) :: auxinput3_begin_m
integer , DIMENSION(max_domains) :: auxinput3_begin_s
integer , DIMENSION(max_domains) :: auxinput3_begin
integer , DIMENSION(max_domains) :: auxinput3_end_y
integer , DIMENSION(max_domains) :: auxinput3_end_d
integer , DIMENSION(max_domains) :: auxinput3_end_h
integer , DIMENSION(max_domains) :: auxinput3_end_m
integer , DIMENSION(max_domains) :: auxinput3_end_s
integer , DIMENSION(max_domains) :: auxinput3_end
integer :: io_form_auxinput3
integer , DIMENSION(max_domains) :: frames_per_auxinput3
character*256 :: auxinput4_inname
character*256 :: auxinput4_outname
integer , DIMENSION(max_domains) :: auxinput4_interval_y
integer , DIMENSION(max_domains) :: auxinput4_interval_d
integer , DIMENSION(max_domains) :: auxinput4_interval_h
integer , DIMENSION(max_domains) :: auxinput4_interval_m
integer , DIMENSION(max_domains) :: auxinput4_interval_s
integer , DIMENSION(max_domains) :: auxinput4_interval
integer , DIMENSION(max_domains) :: auxinput4_begin_y
integer , DIMENSION(max_domains) :: auxinput4_begin_d
integer , DIMENSION(max_domains) :: auxinput4_begin_h
integer , DIMENSION(max_domains) :: auxinput4_begin_m
integer , DIMENSION(max_domains) :: auxinput4_begin_s
integer , DIMENSION(max_domains) :: auxinput4_begin
integer , DIMENSION(max_domains) :: auxinput4_end_y
integer , DIMENSION(max_domains) :: auxinput4_end_d
integer , DIMENSION(max_domains) :: auxinput4_end_h
integer , DIMENSION(max_domains) :: auxinput4_end_m
integer , DIMENSION(max_domains) :: auxinput4_end_s
integer , DIMENSION(max_domains) :: auxinput4_end
integer :: io_form_auxinput4
integer , DIMENSION(max_domains) :: frames_per_auxinput4
character*256 :: auxinput5_inname
character*256 :: auxinput5_outname
integer , DIMENSION(max_domains) :: auxinput5_interval_y
integer , DIMENSION(max_domains) :: auxinput5_interval_d
integer , DIMENSION(max_domains) :: auxinput5_interval_h
integer , DIMENSION(max_domains) :: auxinput5_interval_m
integer , DIMENSION(max_domains) :: auxinput5_interval_s
integer , DIMENSION(max_domains) :: auxinput5_interval
integer , DIMENSION(max_domains) :: auxinput5_begin_y
integer , DIMENSION(max_domains) :: auxinput5_begin_d
integer , DIMENSION(max_domains) :: auxinput5_begin_h
integer , DIMENSION(max_domains) :: auxinput5_begin_m
integer , DIMENSION(max_domains) :: auxinput5_begin_s
integer , DIMENSION(max_domains) :: auxinput5_begin
integer , DIMENSION(max_domains) :: auxinput5_end_y
integer , DIMENSION(max_domains) :: auxinput5_end_d
integer , DIMENSION(max_domains) :: auxinput5_end_h
integer , DIMENSION(max_domains) :: auxinput5_end_m
integer , DIMENSION(max_domains) :: auxinput5_end_s
integer , DIMENSION(max_domains) :: auxinput5_end
integer :: io_form_auxinput5
integer , DIMENSION(max_domains) :: frames_per_auxinput5
character*256 :: auxinput6_inname
character*256 :: auxinput6_outname
integer , DIMENSION(max_domains) :: auxinput6_interval_y
integer , DIMENSION(max_domains) :: auxinput6_interval_d
integer , DIMENSION(max_domains) :: auxinput6_interval_h
integer , DIMENSION(max_domains) :: auxinput6_interval_m
integer , DIMENSION(max_domains) :: auxinput6_interval_s
integer , DIMENSION(max_domains) :: auxinput6_interval
integer , DIMENSION(max_domains) :: auxinput6_begin_y
integer , DIMENSION(max_domains) :: auxinput6_begin_d
integer , DIMENSION(max_domains) :: auxinput6_begin_h
integer , DIMENSION(max_domains) :: auxinput6_begin_m
integer , DIMENSION(max_domains) :: auxinput6_begin_s
integer , DIMENSION(max_domains) :: auxinput6_begin
integer , DIMENSION(max_domains) :: auxinput6_end_y
integer , DIMENSION(max_domains) :: auxinput6_end_d
integer , DIMENSION(max_domains) :: auxinput6_end_h
integer , DIMENSION(max_domains) :: auxinput6_end_m
integer , DIMENSION(max_domains) :: auxinput6_end_s
integer , DIMENSION(max_domains) :: auxinput6_end
integer :: io_form_auxinput6
integer , DIMENSION(max_domains) :: frames_per_auxinput6
character*256 :: auxinput7_inname
character*256 :: auxinput7_outname
integer , DIMENSION(max_domains) :: auxinput7_interval_y
integer , DIMENSION(max_domains) :: auxinput7_interval_d
integer , DIMENSION(max_domains) :: auxinput7_interval_h
integer , DIMENSION(max_domains) :: auxinput7_interval_m
integer , DIMENSION(max_domains) :: auxinput7_interval_s
integer , DIMENSION(max_domains) :: auxinput7_interval
integer , DIMENSION(max_domains) :: auxinput7_begin_y
integer , DIMENSION(max_domains) :: auxinput7_begin_d
integer , DIMENSION(max_domains) :: auxinput7_begin_h
integer , DIMENSION(max_domains) :: auxinput7_begin_m
integer , DIMENSION(max_domains) :: auxinput7_begin_s
integer , DIMENSION(max_domains) :: auxinput7_begin
integer , DIMENSION(max_domains) :: auxinput7_end_y
integer , DIMENSION(max_domains) :: auxinput7_end_d
integer , DIMENSION(max_domains) :: auxinput7_end_h
integer , DIMENSION(max_domains) :: auxinput7_end_m
integer , DIMENSION(max_domains) :: auxinput7_end_s
integer , DIMENSION(max_domains) :: auxinput7_end
integer :: io_form_auxinput7
integer , DIMENSION(max_domains) :: frames_per_auxinput7
character*256 :: auxinput8_inname
character*256 :: auxinput8_outname
integer , DIMENSION(max_domains) :: auxinput8_interval_y
integer , DIMENSION(max_domains) :: auxinput8_interval_d
integer , DIMENSION(max_domains) :: auxinput8_interval_h
integer , DIMENSION(max_domains) :: auxinput8_interval_m
integer , DIMENSION(max_domains) :: auxinput8_interval_s
integer , DIMENSION(max_domains) :: auxinput8_interval
integer , DIMENSION(max_domains) :: auxinput8_begin_y
integer , DIMENSION(max_domains) :: auxinput8_begin_d
integer , DIMENSION(max_domains) :: auxinput8_begin_h
integer , DIMENSION(max_domains) :: auxinput8_begin_m
integer , DIMENSION(max_domains) :: auxinput8_begin_s
integer , DIMENSION(max_domains) :: auxinput8_begin
integer , DIMENSION(max_domains) :: auxinput8_end_y
integer , DIMENSION(max_domains) :: auxinput8_end_d
integer , DIMENSION(max_domains) :: auxinput8_end_h
integer , DIMENSION(max_domains) :: auxinput8_end_m
integer , DIMENSION(max_domains) :: auxinput8_end_s
integer , DIMENSION(max_domains) :: auxinput8_end
integer :: io_form_auxinput8
integer , DIMENSION(max_domains) :: frames_per_auxinput8
character*256 :: auxinput9_inname
character*256 :: auxinput9_outname
integer , DIMENSION(max_domains) :: auxinput9_interval_y
integer , DIMENSION(max_domains) :: auxinput9_interval_d
integer , DIMENSION(max_domains) :: auxinput9_interval_h
integer , DIMENSION(max_domains) :: auxinput9_interval_m
integer , DIMENSION(max_domains) :: auxinput9_interval_s
integer , DIMENSION(max_domains) :: auxinput9_interval
integer , DIMENSION(max_domains) :: auxinput9_begin_y
integer , DIMENSION(max_domains) :: auxinput9_begin_d
integer , DIMENSION(max_domains) :: auxinput9_begin_h
integer , DIMENSION(max_domains) :: auxinput9_begin_m
integer , DIMENSION(max_domains) :: auxinput9_begin_s
integer , DIMENSION(max_domains) :: auxinput9_begin
integer , DIMENSION(max_domains) :: auxinput9_end_y
integer , DIMENSION(max_domains) :: auxinput9_end_d
integer , DIMENSION(max_domains) :: auxinput9_end_h
integer , DIMENSION(max_domains) :: auxinput9_end_m
integer , DIMENSION(max_domains) :: auxinput9_end_s
integer , DIMENSION(max_domains) :: auxinput9_end
integer :: io_form_auxinput9
integer , DIMENSION(max_domains) :: frames_per_auxinput9
character*256 :: auxinput10_inname
character*256 :: auxinput10_outname
integer , DIMENSION(max_domains) :: auxinput10_interval_y
integer , DIMENSION(max_domains) :: auxinput10_interval_d
integer , DIMENSION(max_domains) :: auxinput10_interval_h
integer , DIMENSION(max_domains) :: auxinput10_interval_m
integer , DIMENSION(max_domains) :: auxinput10_interval_s
integer , DIMENSION(max_domains) :: auxinput10_interval
integer , DIMENSION(max_domains) :: auxinput10_begin_y
integer , DIMENSION(max_domains) :: auxinput10_begin_d
integer , DIMENSION(max_domains) :: auxinput10_begin_h
integer , DIMENSION(max_domains) :: auxinput10_begin_m
integer , DIMENSION(max_domains) :: auxinput10_begin_s
integer , DIMENSION(max_domains) :: auxinput10_begin
integer , DIMENSION(max_domains) :: auxinput10_end_y
integer , DIMENSION(max_domains) :: auxinput10_end_d
integer , DIMENSION(max_domains) :: auxinput10_end_h
integer , DIMENSION(max_domains) :: auxinput10_end_m
integer , DIMENSION(max_domains) :: auxinput10_end_s
integer , DIMENSION(max_domains) :: auxinput10_end
integer :: io_form_auxinput10
integer , DIMENSION(max_domains) :: frames_per_auxinput10
character*256 :: auxinput11_inname
character*256 :: auxinput11_outname
integer , DIMENSION(max_domains) :: auxinput11_interval_y
integer , DIMENSION(max_domains) :: auxinput11_interval_d
integer , DIMENSION(max_domains) :: auxinput11_interval_h
integer , DIMENSION(max_domains) :: auxinput11_interval_m
integer , DIMENSION(max_domains) :: auxinput11_interval_s
integer , DIMENSION(max_domains) :: auxinput11_interval
integer , DIMENSION(max_domains) :: auxinput11_begin_y
integer , DIMENSION(max_domains) :: auxinput11_begin_d
integer , DIMENSION(max_domains) :: auxinput11_begin_h
integer , DIMENSION(max_domains) :: auxinput11_begin_m
integer , DIMENSION(max_domains) :: auxinput11_begin_s
integer , DIMENSION(max_domains) :: auxinput11_begin
integer , DIMENSION(max_domains) :: auxinput11_end_y
integer , DIMENSION(max_domains) :: auxinput11_end_d
integer , DIMENSION(max_domains) :: auxinput11_end_h
integer , DIMENSION(max_domains) :: auxinput11_end_m
integer , DIMENSION(max_domains) :: auxinput11_end_s
integer , DIMENSION(max_domains) :: auxinput11_end
integer :: io_form_auxinput11
integer , DIMENSION(max_domains) :: frames_per_auxinput11
character*256 :: auxinput12_inname
character*256 :: auxinput12_outname
integer , DIMENSION(max_domains) :: auxinput12_interval_y
integer , DIMENSION(max_domains) :: auxinput12_interval_d
integer , DIMENSION(max_domains) :: auxinput12_interval_h
integer , DIMENSION(max_domains) :: auxinput12_interval_m
integer , DIMENSION(max_domains) :: auxinput12_interval_s
integer , DIMENSION(max_domains) :: auxinput12_interval
integer , DIMENSION(max_domains) :: auxinput12_begin_y
integer , DIMENSION(max_domains) :: auxinput12_begin_d
integer , DIMENSION(max_domains) :: auxinput12_begin_h
integer , DIMENSION(max_domains) :: auxinput12_begin_m
integer , DIMENSION(max_domains) :: auxinput12_begin_s
integer , DIMENSION(max_domains) :: auxinput12_begin
integer , DIMENSION(max_domains) :: auxinput12_end_y
integer , DIMENSION(max_domains) :: auxinput12_end_d
integer , DIMENSION(max_domains) :: auxinput12_end_h
integer , DIMENSION(max_domains) :: auxinput12_end_m
integer , DIMENSION(max_domains) :: auxinput12_end_s
integer , DIMENSION(max_domains) :: auxinput12_end
integer :: io_form_auxinput12
integer , DIMENSION(max_domains) :: frames_per_auxinput12
character*256 :: auxinput13_inname
character*256 :: auxinput13_outname
integer , DIMENSION(max_domains) :: auxinput13_interval_y
integer , DIMENSION(max_domains) :: auxinput13_interval_d
integer , DIMENSION(max_domains) :: auxinput13_interval_h
integer , DIMENSION(max_domains) :: auxinput13_interval_m
integer , DIMENSION(max_domains) :: auxinput13_interval_s
integer , DIMENSION(max_domains) :: auxinput13_interval
integer , DIMENSION(max_domains) :: auxinput13_begin_y
integer , DIMENSION(max_domains) :: auxinput13_begin_d
integer , DIMENSION(max_domains) :: auxinput13_begin_h
integer , DIMENSION(max_domains) :: auxinput13_begin_m
integer , DIMENSION(max_domains) :: auxinput13_begin_s
integer , DIMENSION(max_domains) :: auxinput13_begin
integer , DIMENSION(max_domains) :: auxinput13_end_y
integer , DIMENSION(max_domains) :: auxinput13_end_d
integer , DIMENSION(max_domains) :: auxinput13_end_h
integer , DIMENSION(max_domains) :: auxinput13_end_m
integer , DIMENSION(max_domains) :: auxinput13_end_s
integer , DIMENSION(max_domains) :: auxinput13_end
integer :: io_form_auxinput13
integer , DIMENSION(max_domains) :: frames_per_auxinput13
character*256 :: auxinput14_inname
character*256 :: auxinput14_outname
integer , DIMENSION(max_domains) :: auxinput14_interval_y
integer , DIMENSION(max_domains) :: auxinput14_interval_d
integer , DIMENSION(max_domains) :: auxinput14_interval_h
integer , DIMENSION(max_domains) :: auxinput14_interval_m
integer , DIMENSION(max_domains) :: auxinput14_interval_s
integer , DIMENSION(max_domains) :: auxinput14_interval
integer , DIMENSION(max_domains) :: auxinput14_begin_y
integer , DIMENSION(max_domains) :: auxinput14_begin_d
integer , DIMENSION(max_domains) :: auxinput14_begin_h
integer , DIMENSION(max_domains) :: auxinput14_begin_m
integer , DIMENSION(max_domains) :: auxinput14_begin_s
integer , DIMENSION(max_domains) :: auxinput14_begin
integer , DIMENSION(max_domains) :: auxinput14_end_y
integer , DIMENSION(max_domains) :: auxinput14_end_d
integer , DIMENSION(max_domains) :: auxinput14_end_h
integer , DIMENSION(max_domains) :: auxinput14_end_m
integer , DIMENSION(max_domains) :: auxinput14_end_s
integer , DIMENSION(max_domains) :: auxinput14_end
integer :: io_form_auxinput14
integer , DIMENSION(max_domains) :: frames_per_auxinput14
character*256 :: auxinput15_inname
character*256 :: auxinput15_outname
integer , DIMENSION(max_domains) :: auxinput15_interval_y
integer , DIMENSION(max_domains) :: auxinput15_interval_d
integer , DIMENSION(max_domains) :: auxinput15_interval_h
integer , DIMENSION(max_domains) :: auxinput15_interval_m
integer , DIMENSION(max_domains) :: auxinput15_interval_s
integer , DIMENSION(max_domains) :: auxinput15_interval
integer , DIMENSION(max_domains) :: auxinput15_begin_y
integer , DIMENSION(max_domains) :: auxinput15_begin_d
integer , DIMENSION(max_domains) :: auxinput15_begin_h
integer , DIMENSION(max_domains) :: auxinput15_begin_m
integer , DIMENSION(max_domains) :: auxinput15_begin_s
integer , DIMENSION(max_domains) :: auxinput15_begin
integer , DIMENSION(max_domains) :: auxinput15_end_y
integer , DIMENSION(max_domains) :: auxinput15_end_d
integer , DIMENSION(max_domains) :: auxinput15_end_h
integer , DIMENSION(max_domains) :: auxinput15_end_m
integer , DIMENSION(max_domains) :: auxinput15_end_s
integer , DIMENSION(max_domains) :: auxinput15_end
integer :: io_form_auxinput15
integer , DIMENSION(max_domains) :: frames_per_auxinput15
character*256 :: auxinput16_inname
character*256 :: auxinput16_outname
integer , DIMENSION(max_domains) :: auxinput16_interval_y
integer , DIMENSION(max_domains) :: auxinput16_interval_d
integer , DIMENSION(max_domains) :: auxinput16_interval_h
integer , DIMENSION(max_domains) :: auxinput16_interval_m
integer , DIMENSION(max_domains) :: auxinput16_interval_s
integer , DIMENSION(max_domains) :: auxinput16_interval
integer , DIMENSION(max_domains) :: auxinput16_begin_y
integer , DIMENSION(max_domains) :: auxinput16_begin_d
integer , DIMENSION(max_domains) :: auxinput16_begin_h
integer , DIMENSION(max_domains) :: auxinput16_begin_m
integer , DIMENSION(max_domains) :: auxinput16_begin_s
integer , DIMENSION(max_domains) :: auxinput16_begin
integer , DIMENSION(max_domains) :: auxinput16_end_y
integer , DIMENSION(max_domains) :: auxinput16_end_d
integer , DIMENSION(max_domains) :: auxinput16_end_h
integer , DIMENSION(max_domains) :: auxinput16_end_m
integer , DIMENSION(max_domains) :: auxinput16_end_s
integer , DIMENSION(max_domains) :: auxinput16_end
integer :: io_form_auxinput16
integer , DIMENSION(max_domains) :: frames_per_auxinput16
character*256 :: auxinput17_inname
character*256 :: auxinput17_outname
integer , DIMENSION(max_domains) :: auxinput17_interval_y
integer , DIMENSION(max_domains) :: auxinput17_interval_d
integer , DIMENSION(max_domains) :: auxinput17_interval_h
integer , DIMENSION(max_domains) :: auxinput17_interval_m
integer , DIMENSION(max_domains) :: auxinput17_interval_s
integer , DIMENSION(max_domains) :: auxinput17_interval
integer , DIMENSION(max_domains) :: auxinput17_begin_y
integer , DIMENSION(max_domains) :: auxinput17_begin_d
integer , DIMENSION(max_domains) :: auxinput17_begin_h
integer , DIMENSION(max_domains) :: auxinput17_begin_m
integer , DIMENSION(max_domains) :: auxinput17_begin_s
integer , DIMENSION(max_domains) :: auxinput17_begin
integer , DIMENSION(max_domains) :: auxinput17_end_y
integer , DIMENSION(max_domains) :: auxinput17_end_d
integer , DIMENSION(max_domains) :: auxinput17_end_h
integer , DIMENSION(max_domains) :: auxinput17_end_m
integer , DIMENSION(max_domains) :: auxinput17_end_s
integer , DIMENSION(max_domains) :: auxinput17_end
integer :: io_form_auxinput17
integer , DIMENSION(max_domains) :: frames_per_auxinput17
character*256 :: auxinput18_inname
character*256 :: auxinput18_outname
integer , DIMENSION(max_domains) :: auxinput18_interval_y
integer , DIMENSION(max_domains) :: auxinput18_interval_d
integer , DIMENSION(max_domains) :: auxinput18_interval_h
integer , DIMENSION(max_domains) :: auxinput18_interval_m
integer , DIMENSION(max_domains) :: auxinput18_interval_s
integer , DIMENSION(max_domains) :: auxinput18_interval
integer , DIMENSION(max_domains) :: auxinput18_begin_y
integer , DIMENSION(max_domains) :: auxinput18_begin_d
integer , DIMENSION(max_domains) :: auxinput18_begin_h
integer , DIMENSION(max_domains) :: auxinput18_begin_m
integer , DIMENSION(max_domains) :: auxinput18_begin_s
integer , DIMENSION(max_domains) :: auxinput18_begin
integer , DIMENSION(max_domains) :: auxinput18_end_y
integer , DIMENSION(max_domains) :: auxinput18_end_d
integer , DIMENSION(max_domains) :: auxinput18_end_h
integer , DIMENSION(max_domains) :: auxinput18_end_m
integer , DIMENSION(max_domains) :: auxinput18_end_s
integer , DIMENSION(max_domains) :: auxinput18_end
integer :: io_form_auxinput18
integer , DIMENSION(max_domains) :: frames_per_auxinput18
character*256 :: auxinput19_inname
character*256 :: auxinput19_outname
integer , DIMENSION(max_domains) :: auxinput19_interval_y
integer , DIMENSION(max_domains) :: auxinput19_interval_d
integer , DIMENSION(max_domains) :: auxinput19_interval_h
integer , DIMENSION(max_domains) :: auxinput19_interval_m
integer , DIMENSION(max_domains) :: auxinput19_interval_s
integer , DIMENSION(max_domains) :: auxinput19_interval
integer , DIMENSION(max_domains) :: auxinput19_begin_y
integer , DIMENSION(max_domains) :: auxinput19_begin_d
integer , DIMENSION(max_domains) :: auxinput19_begin_h
integer , DIMENSION(max_domains) :: auxinput19_begin_m
integer , DIMENSION(max_domains) :: auxinput19_begin_s
integer , DIMENSION(max_domains) :: auxinput19_begin
integer , DIMENSION(max_domains) :: auxinput19_end_y
integer , DIMENSION(max_domains) :: auxinput19_end_d
integer , DIMENSION(max_domains) :: auxinput19_end_h
integer , DIMENSION(max_domains) :: auxinput19_end_m
integer , DIMENSION(max_domains) :: auxinput19_end_s
integer , DIMENSION(max_domains) :: auxinput19_end
integer :: io_form_auxinput19
integer , DIMENSION(max_domains) :: frames_per_auxinput19
character*256 :: auxinput20_inname
character*256 :: auxinput20_outname
integer , DIMENSION(max_domains) :: auxinput20_interval_y
integer , DIMENSION(max_domains) :: auxinput20_interval_d
integer , DIMENSION(max_domains) :: auxinput20_interval_h
integer , DIMENSION(max_domains) :: auxinput20_interval_m
integer , DIMENSION(max_domains) :: auxinput20_interval_s
integer , DIMENSION(max_domains) :: auxinput20_interval
integer , DIMENSION(max_domains) :: auxinput20_begin_y
integer , DIMENSION(max_domains) :: auxinput20_begin_d
integer , DIMENSION(max_domains) :: auxinput20_begin_h
integer , DIMENSION(max_domains) :: auxinput20_begin_m
integer , DIMENSION(max_domains) :: auxinput20_begin_s
integer , DIMENSION(max_domains) :: auxinput20_begin
integer , DIMENSION(max_domains) :: auxinput20_end_y
integer , DIMENSION(max_domains) :: auxinput20_end_d
integer , DIMENSION(max_domains) :: auxinput20_end_h
integer , DIMENSION(max_domains) :: auxinput20_end_m
integer , DIMENSION(max_domains) :: auxinput20_end_s
integer , DIMENSION(max_domains) :: auxinput20_end
integer :: io_form_auxinput20
integer , DIMENSION(max_domains) :: frames_per_auxinput20
character*256 :: auxinput21_inname
character*256 :: auxinput21_outname
integer , DIMENSION(max_domains) :: auxinput21_interval_y
integer , DIMENSION(max_domains) :: auxinput21_interval_d
integer , DIMENSION(max_domains) :: auxinput21_interval_h
integer , DIMENSION(max_domains) :: auxinput21_interval_m
integer , DIMENSION(max_domains) :: auxinput21_interval_s
integer , DIMENSION(max_domains) :: auxinput21_interval
integer , DIMENSION(max_domains) :: auxinput21_begin_y
integer , DIMENSION(max_domains) :: auxinput21_begin_d
integer , DIMENSION(max_domains) :: auxinput21_begin_h
integer , DIMENSION(max_domains) :: auxinput21_begin_m
integer , DIMENSION(max_domains) :: auxinput21_begin_s
integer , DIMENSION(max_domains) :: auxinput21_begin
integer , DIMENSION(max_domains) :: auxinput21_end_y
integer , DIMENSION(max_domains) :: auxinput21_end_d
integer , DIMENSION(max_domains) :: auxinput21_end_h
integer , DIMENSION(max_domains) :: auxinput21_end_m
integer , DIMENSION(max_domains) :: auxinput21_end_s
integer , DIMENSION(max_domains) :: auxinput21_end
integer :: io_form_auxinput21
integer , DIMENSION(max_domains) :: frames_per_auxinput21
character*256 :: auxinput22_inname
character*256 :: auxinput22_outname
integer , DIMENSION(max_domains) :: auxinput22_interval_y
integer , DIMENSION(max_domains) :: auxinput22_interval_d
integer , DIMENSION(max_domains) :: auxinput22_interval_h
integer , DIMENSION(max_domains) :: auxinput22_interval_m
integer , DIMENSION(max_domains) :: auxinput22_interval_s
integer , DIMENSION(max_domains) :: auxinput22_interval
integer , DIMENSION(max_domains) :: auxinput22_begin_y
integer , DIMENSION(max_domains) :: auxinput22_begin_d
integer , DIMENSION(max_domains) :: auxinput22_begin_h
integer , DIMENSION(max_domains) :: auxinput22_begin_m
integer , DIMENSION(max_domains) :: auxinput22_begin_s
integer , DIMENSION(max_domains) :: auxinput22_begin
integer , DIMENSION(max_domains) :: auxinput22_end_y
integer , DIMENSION(max_domains) :: auxinput22_end_d
integer , DIMENSION(max_domains) :: auxinput22_end_h
integer , DIMENSION(max_domains) :: auxinput22_end_m
integer , DIMENSION(max_domains) :: auxinput22_end_s
integer , DIMENSION(max_domains) :: auxinput22_end
integer :: io_form_auxinput22
integer , DIMENSION(max_domains) :: frames_per_auxinput22
character*256 :: auxinput23_inname
character*256 :: auxinput23_outname
integer , DIMENSION(max_domains) :: auxinput23_interval_y
integer , DIMENSION(max_domains) :: auxinput23_interval_d
integer , DIMENSION(max_domains) :: auxinput23_interval_h
integer , DIMENSION(max_domains) :: auxinput23_interval_m
integer , DIMENSION(max_domains) :: auxinput23_interval_s
integer , DIMENSION(max_domains) :: auxinput23_interval
integer , DIMENSION(max_domains) :: auxinput23_begin_y
integer , DIMENSION(max_domains) :: auxinput23_begin_d
integer , DIMENSION(max_domains) :: auxinput23_begin_h
integer , DIMENSION(max_domains) :: auxinput23_begin_m
integer , DIMENSION(max_domains) :: auxinput23_begin_s
integer , DIMENSION(max_domains) :: auxinput23_begin
integer , DIMENSION(max_domains) :: auxinput23_end_y
integer , DIMENSION(max_domains) :: auxinput23_end_d
integer , DIMENSION(max_domains) :: auxinput23_end_h
integer , DIMENSION(max_domains) :: auxinput23_end_m
integer , DIMENSION(max_domains) :: auxinput23_end_s
integer , DIMENSION(max_domains) :: auxinput23_end
integer :: io_form_auxinput23
integer , DIMENSION(max_domains) :: frames_per_auxinput23
character*256 :: auxinput24_inname
character*256 :: auxinput24_outname
integer , DIMENSION(max_domains) :: auxinput24_interval_y
integer , DIMENSION(max_domains) :: auxinput24_interval_d
integer , DIMENSION(max_domains) :: auxinput24_interval_h
integer , DIMENSION(max_domains) :: auxinput24_interval_m
integer , DIMENSION(max_domains) :: auxinput24_interval_s
integer , DIMENSION(max_domains) :: auxinput24_interval
integer , DIMENSION(max_domains) :: auxinput24_begin_y
integer , DIMENSION(max_domains) :: auxinput24_begin_d
integer , DIMENSION(max_domains) :: auxinput24_begin_h
integer , DIMENSION(max_domains) :: auxinput24_begin_m
integer , DIMENSION(max_domains) :: auxinput24_begin_s
integer , DIMENSION(max_domains) :: auxinput24_begin
integer , DIMENSION(max_domains) :: auxinput24_end_y
integer , DIMENSION(max_domains) :: auxinput24_end_d
integer , DIMENSION(max_domains) :: auxinput24_end_h
integer , DIMENSION(max_domains) :: auxinput24_end_m
integer , DIMENSION(max_domains) :: auxinput24_end_s
integer , DIMENSION(max_domains) :: auxinput24_end
integer :: io_form_auxinput24
integer , DIMENSION(max_domains) :: frames_per_auxinput24
integer , DIMENSION(max_domains) :: history_interval
integer , DIMENSION(max_domains) :: frames_per_outfile
logical :: restart
integer :: restart_interval
integer :: io_form_input
integer :: io_form_history
integer :: io_form_restart
integer :: io_form_boundary
integer :: debug_level
logical :: self_test_domain
character*256 :: history_outname
character*256 :: history_inname
logical :: use_netcdf_classic
integer , DIMENSION(max_domains) :: history_interval_d
integer , DIMENSION(max_domains) :: history_interval_h
integer , DIMENSION(max_domains) :: history_interval_m
integer , DIMENSION(max_domains) :: history_interval_s
integer , DIMENSION(max_domains) :: inputout_interval_d
integer , DIMENSION(max_domains) :: inputout_interval_h
integer , DIMENSION(max_domains) :: inputout_interval_m
integer , DIMENSION(max_domains) :: inputout_interval_s
integer , DIMENSION(max_domains) :: inputout_interval
integer :: restart_interval_d
integer :: restart_interval_h
integer :: restart_interval_m
integer :: restart_interval_s
integer , DIMENSION(max_domains) :: history_begin_y
integer , DIMENSION(max_domains) :: history_begin_d
integer , DIMENSION(max_domains) :: history_begin_h
integer , DIMENSION(max_domains) :: history_begin_m
integer , DIMENSION(max_domains) :: history_begin_s
integer , DIMENSION(max_domains) :: history_begin
integer , DIMENSION(max_domains) :: inputout_begin_y
integer , DIMENSION(max_domains) :: inputout_begin_d
integer , DIMENSION(max_domains) :: inputout_begin_h
integer , DIMENSION(max_domains) :: inputout_begin_m
integer , DIMENSION(max_domains) :: inputout_begin_s
integer :: restart_begin_y
integer :: restart_begin_d
integer :: restart_begin_h
integer :: restart_begin_m
integer :: restart_begin_s
integer :: restart_begin
integer , DIMENSION(max_domains) :: history_end_y
integer , DIMENSION(max_domains) :: history_end_d
integer , DIMENSION(max_domains) :: history_end_h
integer , DIMENSION(max_domains) :: history_end_m
integer , DIMENSION(max_domains) :: history_end_s
integer , DIMENSION(max_domains) :: history_end
integer , DIMENSION(max_domains) :: inputout_end_y
integer , DIMENSION(max_domains) :: inputout_end_d
integer , DIMENSION(max_domains) :: inputout_end_h
integer , DIMENSION(max_domains) :: inputout_end_m
integer , DIMENSION(max_domains) :: inputout_end_s
integer :: simulation_start_year
integer :: simulation_start_month
integer :: simulation_start_day
integer :: simulation_start_hour
integer :: simulation_start_minute
integer :: simulation_start_second
logical :: reset_simulation_start
integer , DIMENSION(max_domains) :: sr_x
integer , DIMENSION(max_domains) :: sr_y
character*256 :: sgfdda_inname
character*256 :: gfdda_inname
integer , DIMENSION(max_domains) :: sgfdda_interval_d
integer , DIMENSION(max_domains) :: sgfdda_interval_h
integer , DIMENSION(max_domains) :: sgfdda_interval_m
integer , DIMENSION(max_domains) :: sgfdda_interval_s
integer , DIMENSION(max_domains) :: sgfdda_interval_y
integer , DIMENSION(max_domains) :: sgfdda_interval
integer , DIMENSION(max_domains) :: gfdda_interval_d
integer , DIMENSION(max_domains) :: gfdda_interval_h
integer , DIMENSION(max_domains) :: gfdda_interval_m
integer , DIMENSION(max_domains) :: gfdda_interval_s
integer , DIMENSION(max_domains) :: gfdda_interval_y
integer , DIMENSION(max_domains) :: gfdda_interval
integer , DIMENSION(max_domains) :: sgfdda_begin_y
integer , DIMENSION(max_domains) :: sgfdda_begin_d
integer , DIMENSION(max_domains) :: sgfdda_begin_h
integer , DIMENSION(max_domains) :: sgfdda_begin_m
integer , DIMENSION(max_domains) :: sgfdda_begin_s
integer , DIMENSION(max_domains) :: gfdda_begin_y
integer , DIMENSION(max_domains) :: gfdda_begin_d
integer , DIMENSION(max_domains) :: gfdda_begin_h
integer , DIMENSION(max_domains) :: gfdda_begin_m
integer , DIMENSION(max_domains) :: gfdda_begin_s
integer , DIMENSION(max_domains) :: sgfdda_end_y
integer , DIMENSION(max_domains) :: sgfdda_end_d
integer , DIMENSION(max_domains) :: sgfdda_end_h
integer , DIMENSION(max_domains) :: sgfdda_end_m
integer , DIMENSION(max_domains) :: sgfdda_end_s
integer , DIMENSION(max_domains) :: gfdda_end_y
integer , DIMENSION(max_domains) :: gfdda_end_d
integer , DIMENSION(max_domains) :: gfdda_end_h
integer , DIMENSION(max_domains) :: gfdda_end_m
integer , DIMENSION(max_domains) :: gfdda_end_s
integer :: io_form_sgfdda
integer :: io_form_gfdda
character*256 , DIMENSION(max_domains) :: iofields_filename
logical :: ignore_iofields_warning
logical :: ncd_nofill
integer , DIMENSION(max_domains) :: ifire
integer , DIMENSION(max_domains) :: fire_boundary_guard
integer , DIMENSION(max_domains) :: fire_num_ignitions
real , DIMENSION(max_domains) :: fire_ignition_ros1
real , DIMENSION(max_domains) :: fire_ignition_start_lon1
real , DIMENSION(max_domains) :: fire_ignition_start_lat1
real , DIMENSION(max_domains) :: fire_ignition_end_lon1
real , DIMENSION(max_domains) :: fire_ignition_end_lat1
real , DIMENSION(max_domains) :: fire_ignition_radius1
real , DIMENSION(max_domains) :: fire_ignition_start_time1
real , DIMENSION(max_domains) :: fire_ignition_end_time1
real , DIMENSION(max_domains) :: fire_ignition_ros2
real , DIMENSION(max_domains) :: fire_ignition_start_lon2
real , DIMENSION(max_domains) :: fire_ignition_start_lat2
real , DIMENSION(max_domains) :: fire_ignition_end_lon2
real , DIMENSION(max_domains) :: fire_ignition_end_lat2
real , DIMENSION(max_domains) :: fire_ignition_radius2
real , DIMENSION(max_domains) :: fire_ignition_start_time2
real , DIMENSION(max_domains) :: fire_ignition_end_time2
real , DIMENSION(max_domains) :: fire_ignition_ros3
real , DIMENSION(max_domains) :: fire_ignition_start_lon3
real , DIMENSION(max_domains) :: fire_ignition_start_lat3
real , DIMENSION(max_domains) :: fire_ignition_end_lon3
real , DIMENSION(max_domains) :: fire_ignition_end_lat3
real , DIMENSION(max_domains) :: fire_ignition_radius3
real , DIMENSION(max_domains) :: fire_ignition_start_time3
real , DIMENSION(max_domains) :: fire_ignition_end_time3
real , DIMENSION(max_domains) :: fire_ignition_ros4
real , DIMENSION(max_domains) :: fire_ignition_start_lon4
real , DIMENSION(max_domains) :: fire_ignition_start_lat4
real , DIMENSION(max_domains) :: fire_ignition_end_lon4
real , DIMENSION(max_domains) :: fire_ignition_end_lat4
real , DIMENSION(max_domains) :: fire_ignition_radius4
real , DIMENSION(max_domains) :: fire_ignition_start_time4
real , DIMENSION(max_domains) :: fire_ignition_end_time4
real , DIMENSION(max_domains) :: fire_ignition_ros5
real , DIMENSION(max_domains) :: fire_ignition_start_lon5
real , DIMENSION(max_domains) :: fire_ignition_start_lat5
real , DIMENSION(max_domains) :: fire_ignition_end_lon5
real , DIMENSION(max_domains) :: fire_ignition_end_lat5
real , DIMENSION(max_domains) :: fire_ignition_radius5
real , DIMENSION(max_domains) :: fire_ignition_start_time5
real , DIMENSION(max_domains) :: fire_ignition_end_time5
real , DIMENSION(max_domains) :: fire_ignition_start_x1
real , DIMENSION(max_domains) :: fire_ignition_start_y1
real , DIMENSION(max_domains) :: fire_ignition_end_x1
real , DIMENSION(max_domains) :: fire_ignition_end_y1
real , DIMENSION(max_domains) :: fire_ignition_start_x2
real , DIMENSION(max_domains) :: fire_ignition_start_y2
real , DIMENSION(max_domains) :: fire_ignition_end_x2
real , DIMENSION(max_domains) :: fire_ignition_end_y2
real , DIMENSION(max_domains) :: fire_ignition_start_x3
real , DIMENSION(max_domains) :: fire_ignition_start_y3
real , DIMENSION(max_domains) :: fire_ignition_end_x3
real , DIMENSION(max_domains) :: fire_ignition_end_y3
real , DIMENSION(max_domains) :: fire_ignition_start_x4
real , DIMENSION(max_domains) :: fire_ignition_start_y4
real , DIMENSION(max_domains) :: fire_ignition_end_x4
real , DIMENSION(max_domains) :: fire_ignition_end_y4
real , DIMENSION(max_domains) :: fire_ignition_start_x5
real , DIMENSION(max_domains) :: fire_ignition_start_y5
real , DIMENSION(max_domains) :: fire_ignition_end_x5
real , DIMENSION(max_domains) :: fire_ignition_end_y5
real , DIMENSION(max_domains) :: fire_lat_init
real , DIMENSION(max_domains) :: fire_lon_init
real , DIMENSION(max_domains) :: fire_ign_time
integer , DIMENSION(max_domains) :: fire_shape
integer , DIMENSION(max_domains) :: fire_sprd_mdl
real , DIMENSION(max_domains) :: fire_crwn_hgt
real , DIMENSION(max_domains) :: fire_ext_grnd
real , DIMENSION(max_domains) :: fire_ext_crwn
real , DIMENSION(max_domains) :: fire_wind_height
integer , DIMENSION(max_domains) :: fire_fuel_read
integer , DIMENSION(max_domains) :: fire_fuel_cat
integer , DIMENSION(max_domains) :: fire_print_msg
integer , DIMENSION(max_domains) :: fire_print_file
integer , DIMENSION(max_domains) :: fire_fuel_left_method
integer , DIMENSION(max_domains) :: fire_fuel_left_irl
integer , DIMENSION(max_domains) :: fire_fuel_left_jrl
integer , DIMENSION(max_domains) :: fire_grows_only
integer , DIMENSION(max_domains) :: fire_upwinding
integer , DIMENSION(max_domains) :: fire_upwind_split
real , DIMENSION(max_domains) :: fire_viscosity
real , DIMENSION(max_domains) :: fire_lfn_ext_up
integer , DIMENSION(max_domains) :: fire_topo_from_atm
integer , DIMENSION(max_domains) :: fire_advection
integer , DIMENSION(max_domains) :: fire_test_steps
real , DIMENSION(max_domains) :: fire_const_time
real , DIMENSION(max_domains) :: fire_const_grnhfx
real , DIMENSION(max_domains) :: fire_const_grnqfx
real , DIMENSION(max_domains) :: fire_atm_feedback
integer , DIMENSION(max_domains) :: fire_mountain_type
real , DIMENSION(max_domains) :: fire_mountain_height
real , DIMENSION(max_domains) :: fire_mountain_start_x
real , DIMENSION(max_domains) :: fire_mountain_start_y
real , DIMENSION(max_domains) :: fire_mountain_end_x
real , DIMENSION(max_domains) :: fire_mountain_end_y
real , DIMENSION(max_domains) :: delt_perturbation
real , DIMENSION(max_domains) :: xrad_perturbation
real , DIMENSION(max_domains) :: yrad_perturbation
real , DIMENSION(max_domains) :: zrad_perturbation
real , DIMENSION(max_domains) :: hght_perturbation
logical , DIMENSION(max_domains) :: stretch_grd
logical , DIMENSION(max_domains) :: stretch_hyp
real , DIMENSION(max_domains) :: z_grd_scale
logical , DIMENSION(max_domains) :: sfc_full_init
integer , DIMENSION(max_domains) :: sfc_lu_index
real , DIMENSION(max_domains) :: sfc_tsk
real , DIMENSION(max_domains) :: sfc_tmn
logical , DIMENSION(max_domains) :: fire_read_lu
logical , DIMENSION(max_domains) :: fire_read_tsk
logical , DIMENSION(max_domains) :: fire_read_tmn
logical , DIMENSION(max_domains) :: fire_read_atm_ht
logical , DIMENSION(max_domains) :: fire_read_fire_ht
logical , DIMENSION(max_domains) :: fire_read_atm_grad
logical , DIMENSION(max_domains) :: fire_read_fire_grad
real , DIMENSION(max_domains) :: sfc_vegfra
real , DIMENSION(max_domains) :: sfc_canwat
integer , DIMENSION(max_domains) :: sfc_ivgtyp
integer , DIMENSION(max_domains) :: sfc_isltyp
logical , DIMENSION(max_domains) :: fire_lsm_reinit
integer , DIMENSION(max_domains) :: fire_lsm_reinit_iter
integer , DIMENSION(max_domains) :: fire_upwinding_reinit
logical , DIMENSION(max_domains) :: fire_is_real_perim
integer , DIMENSION(max_domains) :: fire_lsm_band_ngp
logical , DIMENSION(max_domains) :: fire_lsm_zcoupling
real , DIMENSION(max_domains) :: fire_lsm_zcoupling_ref
real , DIMENSION(max_domains) :: fire_tracer_smoke
real , DIMENSION(max_domains) :: fire_viscosity_bg
real , DIMENSION(max_domains) :: fire_viscosity_band
integer , DIMENSION(max_domains) :: fire_viscosity_ngp
real , DIMENSION(max_domains) :: fire_slope_factor
integer , DIMENSION(max_domains) :: do_avgflx_em
integer , DIMENSION(max_domains) :: do_avgflx_cugd
integer :: nens
integer , DIMENSION(max_domains) :: skebs
integer , DIMENSION(max_domains) :: stoch_force_opt
integer :: skebs_vertstruc
integer , DIMENSION(max_domains) :: stoch_vertstruc_opt
real , DIMENSION(max_domains) :: tot_backscat_psi
real , DIMENSION(max_domains) :: tot_backscat_t
real :: ztau_psi
real :: ztau_t
real :: rexponent_psi
real :: rexponent_t
real :: zsigma2_eps
real :: zsigma2_eta
integer :: kminforc
integer :: lminforc
integer :: kminforct
integer :: lminforct
integer :: kmaxforc
integer :: lmaxforc
integer :: kmaxforct
integer :: lmaxforct
integer :: iseed_skebs
integer :: kmaxforch
integer :: lmaxforch
integer :: kmaxforcth
integer :: lmaxforcth
integer , DIMENSION(max_domains) :: sppt
real , DIMENSION(max_domains) :: gridpt_stddev_sppt
real , DIMENSION(max_domains) :: stddev_cutoff_sppt
real , DIMENSION(max_domains) :: lengthscale_sppt
real , DIMENSION(max_domains) :: timescale_sppt
integer :: sppt_vertstruc
integer :: iseed_sppt
integer , DIMENSION(max_domains) :: rand_perturb
real , DIMENSION(max_domains) :: gridpt_stddev_rand_pert
real , DIMENSION(max_domains) :: stddev_cutoff_rand_pert
real , DIMENSION(max_domains) :: lengthscale_rand_pert
real , DIMENSION(max_domains) :: timescale_rand_pert
integer :: rand_pert_vertstruc
integer :: iseed_rand_pert
integer , DIMENSION(max_domains) :: spp
logical :: hrrr_cycling
integer , DIMENSION(max_domains) :: spp_conv
real , DIMENSION(max_domains) :: gridpt_stddev_spp_conv
real , DIMENSION(max_domains) :: stddev_cutoff_spp_conv
real , DIMENSION(max_domains) :: lengthscale_spp_conv
real , DIMENSION(max_domains) :: timescale_spp_conv
integer :: vertstruc_spp_conv
integer :: iseed_spp_conv
integer , DIMENSION(max_domains) :: spp_pbl
real , DIMENSION(max_domains) :: gridpt_stddev_spp_pbl
real , DIMENSION(max_domains) :: stddev_cutoff_spp_pbl
real , DIMENSION(max_domains) :: lengthscale_spp_pbl
real , DIMENSION(max_domains) :: timescale_spp_pbl
integer :: vertstruc_spp_pbl
integer :: iseed_spp_pbl
integer , DIMENSION(max_domains) :: spp_lsm
real , DIMENSION(max_domains) :: gridpt_stddev_spp_lsm
real , DIMENSION(max_domains) :: stddev_cutoff_spp_lsm
real , DIMENSION(max_domains) :: lengthscale_spp_lsm
real , DIMENSION(max_domains) :: timescale_spp_lsm
integer :: vertstruc_spp_lsm
integer :: iseed_spp_lsm
integer :: skebs_on
integer :: sppt_on
integer :: spp_on
integer :: rand_perturb_on
integer :: num_stoch_levels
integer :: seed_dim
integer , DIMENSION(max_domains) :: sfs_opt
integer , DIMENSION(max_domains) :: m_opt
real , DIMENSION(max_domains) :: lakedepth_default
real , DIMENSION(max_domains) :: lake_min_elev
integer , DIMENSION(max_domains) :: use_lakedepth
integer :: p_lev_diags
integer :: p_lev_diags_dfi
integer :: num_press_levels
real , DIMENSION(max_plevs) :: press_levels
integer :: use_tot_or_hyd_p
integer :: extrap_below_grnd
real :: p_lev_missing
real , DIMENSION(max_domains) :: p_lev_interval
integer :: z_lev_diags
integer :: z_lev_diags_dfi
integer :: num_z_levels
real , DIMENSION(max_zlevs) :: z_levels
real :: z_lev_missing
real , DIMENSION(max_domains) :: z_lev_interval
integer , DIMENSION(max_domains) :: afwa_diag_opt
integer , DIMENSION(max_domains) :: afwa_ptype_opt
integer , DIMENSION(max_domains) :: afwa_vil_opt
integer , DIMENSION(max_domains) :: afwa_radar_opt
integer , DIMENSION(max_domains) :: afwa_severe_opt
integer , DIMENSION(max_domains) :: afwa_icing_opt
integer , DIMENSION(max_domains) :: afwa_vis_opt
integer , DIMENSION(max_domains) :: afwa_cloud_opt
integer , DIMENSION(max_domains) :: afwa_therm_opt
integer , DIMENSION(max_domains) :: afwa_turb_opt
integer , DIMENSION(max_domains) :: afwa_buoy_opt
real :: afwa_ptype_ccn_tmp
real :: afwa_ptype_tot_melt
integer :: afwa_bad_data_check
integer :: mean_diag
integer :: mean_freq
integer , DIMENSION(max_domains) :: mean_interval
integer , DIMENSION(max_domains) :: mean_diag_interval
integer , DIMENSION(max_domains) :: mean_diag_interval_s
integer , DIMENSION(max_domains) :: mean_diag_interval_m
integer , DIMENSION(max_domains) :: mean_diag_interval_h
integer , DIMENSION(max_domains) :: mean_diag_interval_d
integer , DIMENSION(max_domains) :: mean_diag_interval_mo
integer :: diurnal_diag
integer , DIMENSION(max_domains) :: nssl_ipelec
integer :: nssl_isaund
integer :: nssl_iscreen
real :: nssl_lightrad
integer :: nssl_idischarge
integer :: nssl_ibrkd
real :: nssl_ecrit
real :: nssl_disfrac
integer :: elec_physics
integer :: perturb_bdy
integer :: perturb_chem_bdy
integer :: hybrid_opt
real :: etac
integer :: num_wif_levels
integer :: wif_input_opt
integer :: diag_nwp2
integer , DIMENSION(max_domains) :: chem_opt
integer    :: last_item_in_struct







NAMELIST /time_control/ run_days
NAMELIST /time_control/ run_hours
NAMELIST /time_control/ run_minutes
NAMELIST /time_control/ run_seconds
NAMELIST /time_control/ start_year
NAMELIST /time_control/ start_month
NAMELIST /time_control/ start_day
NAMELIST /time_control/ start_hour
NAMELIST /time_control/ start_minute
NAMELIST /time_control/ start_second
NAMELIST /time_control/ end_year
NAMELIST /time_control/ end_month
NAMELIST /time_control/ end_day
NAMELIST /time_control/ end_hour
NAMELIST /time_control/ end_minute
NAMELIST /time_control/ end_second
NAMELIST /time_control/ interval_seconds
NAMELIST /time_control/ input_from_file
NAMELIST /time_control/ fine_input_stream
NAMELIST /time_control/ input_from_hires
NAMELIST /time_control/ rsmas_data_path
NAMELIST /time_control/ all_ic_times
NAMELIST /time_control/ julyr
NAMELIST /time_control/ julday
NAMELIST /time_control/ gmt
NAMELIST /time_control/ input_inname
NAMELIST /time_control/ input_outname
NAMELIST /time_control/ bdy_inname
NAMELIST /time_control/ bdy_outname
NAMELIST /time_control/ rst_inname
NAMELIST /time_control/ rst_outname
NAMELIST /time_control/ write_input
NAMELIST /time_control/ write_restart_at_0h
NAMELIST /time_control/ write_hist_at_0h_rst
NAMELIST /time_control/ adjust_output_times
NAMELIST /time_control/ adjust_input_times
NAMELIST /time_control/ diag_print
NAMELIST /time_control/ nocolons
NAMELIST /time_control/ cycling
NAMELIST /time_control/ output_diagnostics
NAMELIST /time_control/ nwp_diagnostics
NAMELIST /time_control/ output_ready_flag
NAMELIST /time_control/ force_use_old_data
NAMELIST /pio_control/ usepio
NAMELIST /pio_control/ pioprocs
NAMELIST /pio_control/ piostart
NAMELIST /pio_control/ piostride
NAMELIST /pio_control/ pioshift
NAMELIST /dfi_control/ dfi_opt
NAMELIST /dfi_control/ dfi_savehydmeteors
NAMELIST /dfi_control/ dfi_nfilter
NAMELIST /dfi_control/ dfi_write_filtered_input
NAMELIST /dfi_control/ dfi_write_dfi_history
NAMELIST /dfi_control/ dfi_cutoff_seconds
NAMELIST /dfi_control/ dfi_time_dim
NAMELIST /dfi_control/ dfi_fwdstop_year
NAMELIST /dfi_control/ dfi_fwdstop_month
NAMELIST /dfi_control/ dfi_fwdstop_day
NAMELIST /dfi_control/ dfi_fwdstop_hour
NAMELIST /dfi_control/ dfi_fwdstop_minute
NAMELIST /dfi_control/ dfi_fwdstop_second
NAMELIST /dfi_control/ dfi_bckstop_year
NAMELIST /dfi_control/ dfi_bckstop_month
NAMELIST /dfi_control/ dfi_bckstop_day
NAMELIST /dfi_control/ dfi_bckstop_hour
NAMELIST /dfi_control/ dfi_bckstop_minute
NAMELIST /dfi_control/ dfi_bckstop_second
NAMELIST /domains/ time_step
NAMELIST /domains/ time_step_fract_num
NAMELIST /domains/ time_step_fract_den
NAMELIST /domains/ time_step_dfi
NAMELIST /domains/ min_time_step
NAMELIST /domains/ min_time_step_den
NAMELIST /domains/ max_time_step
NAMELIST /domains/ max_time_step_den
NAMELIST /domains/ target_cfl
NAMELIST /domains/ target_hcfl
NAMELIST /domains/ max_step_increase_pct
NAMELIST /domains/ starting_time_step
NAMELIST /domains/ starting_time_step_den
NAMELIST /domains/ step_to_output_time
NAMELIST /domains/ adaptation_domain
NAMELIST /domains/ use_adaptive_time_step
NAMELIST /domains/ use_adaptive_time_step_dfi
NAMELIST /domains/ max_dom
NAMELIST /domains/ lats_to_mic
NAMELIST /domains/ s_we
NAMELIST /domains/ e_we
NAMELIST /domains/ s_sn
NAMELIST /domains/ e_sn
NAMELIST /domains/ s_vert
NAMELIST /domains/ e_vert
NAMELIST /domains/ num_metgrid_levels
NAMELIST /domains/ num_metgrid_soil_levels
NAMELIST /domains/ p_top_requested
NAMELIST /domains/ interp_theta
NAMELIST /domains/ interp_type
NAMELIST /domains/ rebalance
NAMELIST /domains/ vert_refine_method
NAMELIST /domains/ vert_refine_fact
NAMELIST /domains/ extrap_type
NAMELIST /domains/ t_extrap_type
NAMELIST /domains/ hypsometric_opt
NAMELIST /domains/ lowest_lev_from_sfc
NAMELIST /domains/ use_levels_below_ground
NAMELIST /domains/ use_tavg_for_tsk
NAMELIST /domains/ use_surface
NAMELIST /domains/ lagrange_order
NAMELIST /domains/ linear_interp
NAMELIST /domains/ force_sfc_in_vinterp
NAMELIST /domains/ zap_close_levels
NAMELIST /domains/ maxw_horiz_pres_diff
NAMELIST /domains/ trop_horiz_pres_diff
NAMELIST /domains/ maxw_above_this_level
NAMELIST /domains/ use_maxw_level
NAMELIST /domains/ use_trop_level
NAMELIST /domains/ sfcp_to_sfcp
NAMELIST /domains/ adjust_heights
NAMELIST /domains/ smooth_cg_topo
NAMELIST /domains/ nest_interp_coord
NAMELIST /domains/ interp_method_type
NAMELIST /domains/ aggregate_lu
NAMELIST /domains/ rh2qv_wrt_liquid
NAMELIST /domains/ rh2qv_method
NAMELIST /domains/ qv_max_p_safe
NAMELIST /domains/ qv_max_flag
NAMELIST /domains/ qv_max_value
NAMELIST /domains/ qv_min_p_safe
NAMELIST /domains/ qv_min_flag
NAMELIST /domains/ qv_min_value
NAMELIST /domains/ ideal_init_method
NAMELIST /domains/ dx
NAMELIST /domains/ dy
NAMELIST /domains/ grid_id
NAMELIST /domains/ grid_allowed
NAMELIST /domains/ parent_id
NAMELIST /domains/ i_parent_start
NAMELIST /domains/ j_parent_start
NAMELIST /domains/ parent_grid_ratio
NAMELIST /domains/ parent_time_step_ratio
NAMELIST /domains/ feedback
NAMELIST /domains/ smooth_option
NAMELIST /domains/ blend_width
NAMELIST /domains/ ztop
NAMELIST /domains/ moad_grid_ratio
NAMELIST /domains/ moad_time_step_ratio
NAMELIST /domains/ shw
NAMELIST /domains/ tile_sz_x
NAMELIST /domains/ tile_sz_y
NAMELIST /domains/ numtiles
NAMELIST /domains/ numtiles_inc
NAMELIST /domains/ numtiles_x
NAMELIST /domains/ numtiles_y
NAMELIST /domains/ tile_strategy
NAMELIST /domains/ nproc_x
NAMELIST /domains/ nproc_y
NAMELIST /domains/ irand
NAMELIST /domains/ num_moves
NAMELIST /domains/ ts_buf_size
NAMELIST /domains/ max_ts_locs
NAMELIST /domains/ tslist_unstagger_winds
NAMELIST /domains/ vortex_interval
NAMELIST /domains/ max_vortex_speed
NAMELIST /domains/ corral_dist
NAMELIST /domains/ track_level
NAMELIST /domains/ time_to_move
NAMELIST /domains/ move_id
NAMELIST /domains/ move_interval
NAMELIST /domains/ move_cd_x
NAMELIST /domains/ move_cd_y
NAMELIST /domains/ swap_x
NAMELIST /domains/ swap_y
NAMELIST /domains/ cycle_x
NAMELIST /domains/ cycle_y
NAMELIST /domains/ reorder_mesh
NAMELIST /domains/ perturb_input
NAMELIST /domains/ eta_levels
NAMELIST /domains/ auto_levels_opt
NAMELIST /domains/ max_dz
NAMELIST /domains/ dzbot
NAMELIST /domains/ dzstretch_s
NAMELIST /domains/ dzstretch_u
NAMELIST /domains/ ocean_levels
NAMELIST /domains/ ocean_z
NAMELIST /domains/ ocean_t
NAMELIST /domains/ ocean_s
NAMELIST /domains/ num_traj
NAMELIST /domains/ max_ts_level
NAMELIST /domains/ track_loc_in
NAMELIST /domains/ num_ext_model_couple_dom
NAMELIST /tc/ insert_bogus_storm
NAMELIST /tc/ remove_storm
NAMELIST /tc/ num_storm
NAMELIST /tc/ latc_loc
NAMELIST /tc/ lonc_loc
NAMELIST /tc/ vmax_meters_per_second
NAMELIST /tc/ rmax
NAMELIST /tc/ vmax_ratio
NAMELIST /tc/ rankine_lid
NAMELIST /physics/ physics_suite
NAMELIST /physics/ force_read_thompson
NAMELIST /physics/ write_thompson_tables
NAMELIST /physics/ mp_physics
NAMELIST /physics/ nssl_cccn
NAMELIST /physics/ nssl_alphah
NAMELIST /physics/ nssl_alphahl
NAMELIST /physics/ nssl_cnoh
NAMELIST /physics/ nssl_cnohl
NAMELIST /physics/ nssl_cnor
NAMELIST /physics/ nssl_cnos
NAMELIST /physics/ nssl_rho_qh
NAMELIST /physics/ nssl_rho_qhl
NAMELIST /physics/ nssl_rho_qs
NAMELIST /physics/ nudge_lightning
NAMELIST /physics/ nudge_light_times
NAMELIST /physics/ nudge_light_timee
NAMELIST /physics/ nudge_light_int
NAMELIST /physics/ path_to_files
NAMELIST /physics/ gsfcgce_hail
NAMELIST /physics/ gsfcgce_2ice
NAMELIST /physics/ progn
NAMELIST /physics/ accum_mode
NAMELIST /physics/ aitken_mode
NAMELIST /physics/ coarse_mode
NAMELIST /physics/ do_radar_ref
NAMELIST /physics/ ra_lw_physics
NAMELIST /physics/ ra_sw_physics
NAMELIST /physics/ radt
NAMELIST /physics/ naer
NAMELIST /physics/ sf_sfclay_physics
NAMELIST /physics/ sf_surface_physics
NAMELIST /physics/ bl_pbl_physics
NAMELIST /physics/ bl_mynn_tkebudget
NAMELIST /physics/ ysu_topdown_pblmix
NAMELIST /physics/ shinhong_tke_diag
NAMELIST /physics/ bl_mynn_tkeadvect
NAMELIST /physics/ bl_mynn_cloudpdf
NAMELIST /physics/ bl_mynn_mixlength
NAMELIST /physics/ bl_mynn_edmf
NAMELIST /physics/ bl_mynn_edmf_mom
NAMELIST /physics/ bl_mynn_edmf_tke
NAMELIST /physics/ bl_mynn_mixscalars
NAMELIST /physics/ bl_mynn_cloudmix
NAMELIST /physics/ bl_mynn_mixqt
NAMELIST /physics/ icloud_bl
NAMELIST /physics/ mfshconv
NAMELIST /physics/ sf_urban_physics
NAMELIST /physics/ bldt
NAMELIST /physics/ cu_physics
NAMELIST /physics/ shcu_physics
NAMELIST /physics/ cu_diag
NAMELIST /physics/ kf_edrates
NAMELIST /physics/ kfeta_trigger
NAMELIST /physics/ nsas_dx_factor
NAMELIST /physics/ cudt
NAMELIST /physics/ gsmdt
NAMELIST /physics/ isfflx
NAMELIST /physics/ ifsnow
NAMELIST /physics/ icloud
NAMELIST /physics/ cldovrlp
NAMELIST /physics/ ideal_xland
NAMELIST /physics/ swrad_scat
NAMELIST /physics/ surface_input_source
NAMELIST /physics/ num_soil_layers
NAMELIST /physics/ maxpatch
NAMELIST /physics/ num_snow_layers
NAMELIST /physics/ num_snso_layers
NAMELIST /physics/ num_urban_hi
NAMELIST /physics/ num_months
NAMELIST /physics/ sf_surface_mosaic
NAMELIST /physics/ mosaic_cat
NAMELIST /physics/ mosaic_lu
NAMELIST /physics/ mosaic_soil
NAMELIST /physics/ flag_sm_adj
NAMELIST /physics/ maxiens
NAMELIST /physics/ maxens
NAMELIST /physics/ maxens2
NAMELIST /physics/ maxens3
NAMELIST /physics/ ensdim
NAMELIST /physics/ cugd_avedx
NAMELIST /physics/ clos_choice
NAMELIST /physics/ imomentum
NAMELIST /physics/ ishallow
NAMELIST /physics/ convtrans_avglen_m
NAMELIST /physics/ num_land_cat
NAMELIST /physics/ num_soil_cat
NAMELIST /physics/ mp_zero_out
NAMELIST /physics/ mp_zero_out_thresh
NAMELIST /physics/ seaice_threshold
NAMELIST /physics/ sst_update
NAMELIST /physics/ sst_skin
NAMELIST /physics/ tmn_update
NAMELIST /physics/ usemonalb
NAMELIST /physics/ rdmaxalb
NAMELIST /physics/ rdlai2d
NAMELIST /physics/ ua_phys
NAMELIST /physics/ opt_thcnd
NAMELIST /physics/ co2tf
NAMELIST /physics/ ra_call_offset
NAMELIST /physics/ cam_abs_freq_s
NAMELIST /physics/ levsiz
NAMELIST /physics/ paerlev
NAMELIST /physics/ cam_abs_dim1
NAMELIST /physics/ cam_abs_dim2
NAMELIST /physics/ lagday
NAMELIST /physics/ no_src_types
NAMELIST /physics/ alevsiz
NAMELIST /physics/ o3input
NAMELIST /physics/ aer_opt
NAMELIST /physics/ swint_opt
NAMELIST /physics/ aer_type
NAMELIST /physics/ aer_aod550_opt
NAMELIST /physics/ aer_angexp_opt
NAMELIST /physics/ aer_ssa_opt
NAMELIST /physics/ aer_asy_opt
NAMELIST /physics/ aer_aod550_val
NAMELIST /physics/ aer_angexp_val
NAMELIST /physics/ aer_ssa_val
NAMELIST /physics/ aer_asy_val
NAMELIST /physics/ cu_rad_feedback
NAMELIST /physics/ dust_emis
NAMELIST /physics/ erosion_dim
NAMELIST /physics/ no_src_types_cu
NAMELIST /physics/ alevsiz_cu
NAMELIST /physics/ aercu_opt
NAMELIST /physics/ aercu_fct
NAMELIST /physics/ shallowcu_forced_ra
NAMELIST /physics/ numbins
NAMELIST /physics/ thbinsize
NAMELIST /physics/ rbinsize
NAMELIST /physics/ mindeepfreq
NAMELIST /physics/ minshallowfreq
NAMELIST /physics/ shcu_aerosols_opt
NAMELIST /physics/ pxlsm_smois_init
NAMELIST /physics/ pxlsm_modis_veg
NAMELIST /physics/ omlcall
NAMELIST /physics/ sf_ocean_physics
NAMELIST /physics/ traj_opt
NAMELIST /physics/ dm_has_traj
NAMELIST /physics/ tracercall
NAMELIST /physics/ omdt
NAMELIST /physics/ oml_hml0
NAMELIST /physics/ oml_gamma
NAMELIST /physics/ oml_relaxation_time
NAMELIST /physics/ isftcflx
NAMELIST /physics/ iz0tlnd
NAMELIST /physics/ shadlen
NAMELIST /physics/ slope_rad
NAMELIST /physics/ topo_shading
NAMELIST /physics/ topo_wind
NAMELIST /physics/ no_mp_heating
NAMELIST /physics/ fractional_seaice
NAMELIST /physics/ seaice_snowdepth_opt
NAMELIST /physics/ seaice_snowdepth_max
NAMELIST /physics/ seaice_snowdepth_min
NAMELIST /physics/ seaice_albedo_opt
NAMELIST /physics/ seaice_albedo_default
NAMELIST /physics/ seaice_thickness_opt
NAMELIST /physics/ seaice_thickness_default
NAMELIST /physics/ tice2tsk_if2cold
NAMELIST /physics/ bucket_mm
NAMELIST /physics/ bucket_j
NAMELIST /physics/ mp_tend_lim
NAMELIST /physics/ prec_acc_dt
NAMELIST /physics/ grav_settling
NAMELIST /physics/ sas_pgcon
NAMELIST /physics/ scalar_pblmix
NAMELIST /physics/ tracer_pblmix
NAMELIST /physics/ use_aero_icbc
NAMELIST /physics/ use_rap_aero_icbc
NAMELIST /physics/ use_mp_re
NAMELIST /physics/ ccn_conc
NAMELIST /physics/ hail_opt
NAMELIST /physics/ morr_rimed_ice
NAMELIST /physics/ clean_atm_diag
NAMELIST /noah_mp/ dveg
NAMELIST /noah_mp/ opt_crs
NAMELIST /noah_mp/ opt_btr
NAMELIST /noah_mp/ opt_run
NAMELIST /noah_mp/ opt_sfc
NAMELIST /noah_mp/ opt_frz
NAMELIST /noah_mp/ opt_inf
NAMELIST /noah_mp/ opt_rad
NAMELIST /noah_mp/ opt_alb
NAMELIST /noah_mp/ opt_snf
NAMELIST /noah_mp/ opt_tbot
NAMELIST /noah_mp/ opt_stc
NAMELIST /noah_mp/ opt_gla
NAMELIST /noah_mp/ opt_rsf
NAMELIST /noah_mp/ opt_soil
NAMELIST /noah_mp/ opt_pedo
NAMELIST /noah_mp/ opt_crop
NAMELIST /physics/ wtddt
NAMELIST /fdda/ fgdt
NAMELIST /fdda/ fgdtzero
NAMELIST /fdda/ grid_fdda
NAMELIST /fdda/ grid_sfdda
NAMELIST /fdda/ if_no_pbl_nudging_uv
NAMELIST /fdda/ if_no_pbl_nudging_t
NAMELIST /fdda/ if_no_pbl_nudging_ph
NAMELIST /fdda/ if_no_pbl_nudging_q
NAMELIST /fdda/ if_zfac_uv
NAMELIST /fdda/ k_zfac_uv
NAMELIST /fdda/ if_zfac_t
NAMELIST /fdda/ k_zfac_t
NAMELIST /fdda/ if_zfac_ph
NAMELIST /fdda/ k_zfac_ph
NAMELIST /fdda/ if_zfac_q
NAMELIST /fdda/ k_zfac_q
NAMELIST /fdda/ dk_zfac_uv
NAMELIST /fdda/ dk_zfac_t
NAMELIST /fdda/ dk_zfac_ph
NAMELIST /fdda/ dk_zfac_q
NAMELIST /fdda/ ktrop
NAMELIST /fdda/ guv
NAMELIST /fdda/ guv_sfc
NAMELIST /fdda/ gt
NAMELIST /fdda/ gt_sfc
NAMELIST /fdda/ gq
NAMELIST /fdda/ gq_sfc
NAMELIST /fdda/ gph
NAMELIST /fdda/ dtramp_min
NAMELIST /fdda/ if_ramping
NAMELIST /fdda/ rinblw
NAMELIST /fdda/ xwavenum
NAMELIST /fdda/ ywavenum
NAMELIST /fdda/ pxlsm_soil_nudge
NAMELIST /fdda/ obs_nudge_opt
NAMELIST /fdda/ max_obs
NAMELIST /fdda/ fdda_start
NAMELIST /fdda/ fdda_end
NAMELIST /fdda/ obs_nudge_wind
NAMELIST /fdda/ obs_coef_wind
NAMELIST /fdda/ obs_nudge_temp
NAMELIST /fdda/ obs_coef_temp
NAMELIST /fdda/ obs_nudge_mois
NAMELIST /fdda/ obs_coef_mois
NAMELIST /fdda/ obs_nudge_pstr
NAMELIST /fdda/ obs_coef_pstr
NAMELIST /fdda/ obs_no_pbl_nudge_uv
NAMELIST /fdda/ obs_no_pbl_nudge_t
NAMELIST /fdda/ obs_no_pbl_nudge_q
NAMELIST /fdda/ obs_sfc_scheme_horiz
NAMELIST /fdda/ obs_sfc_scheme_vert
NAMELIST /fdda/ obs_max_sndng_gap
NAMELIST /fdda/ obs_nudgezfullr1_uv
NAMELIST /fdda/ obs_nudgezrampr1_uv
NAMELIST /fdda/ obs_nudgezfullr2_uv
NAMELIST /fdda/ obs_nudgezrampr2_uv
NAMELIST /fdda/ obs_nudgezfullr4_uv
NAMELIST /fdda/ obs_nudgezrampr4_uv
NAMELIST /fdda/ obs_nudgezfullr1_t
NAMELIST /fdda/ obs_nudgezrampr1_t
NAMELIST /fdda/ obs_nudgezfullr2_t
NAMELIST /fdda/ obs_nudgezrampr2_t
NAMELIST /fdda/ obs_nudgezfullr4_t
NAMELIST /fdda/ obs_nudgezrampr4_t
NAMELIST /fdda/ obs_nudgezfullr1_q
NAMELIST /fdda/ obs_nudgezrampr1_q
NAMELIST /fdda/ obs_nudgezfullr2_q
NAMELIST /fdda/ obs_nudgezrampr2_q
NAMELIST /fdda/ obs_nudgezfullr4_q
NAMELIST /fdda/ obs_nudgezrampr4_q
NAMELIST /fdda/ obs_nudgezfullmin
NAMELIST /fdda/ obs_nudgezrampmin
NAMELIST /fdda/ obs_nudgezmax
NAMELIST /fdda/ obs_sfcfact
NAMELIST /fdda/ obs_sfcfacr
NAMELIST /fdda/ obs_dpsmx
NAMELIST /fdda/ obs_rinxy
NAMELIST /fdda/ obs_rinsig
NAMELIST /fdda/ obs_twindo
NAMELIST /fdda/ obs_npfi
NAMELIST /fdda/ obs_ionf
NAMELIST /fdda/ obs_idynin
NAMELIST /fdda/ obs_dtramp
NAMELIST /fdda/ obs_prt_max
NAMELIST /fdda/ obs_prt_freq
NAMELIST /fdda/ obs_ipf_in4dob
NAMELIST /fdda/ obs_ipf_errob
NAMELIST /fdda/ obs_ipf_nudob
NAMELIST /fdda/ obs_ipf_init
NAMELIST /fdda/ obs_scl_neg_qv_innov
NAMELIST /scm/ scm_force
NAMELIST /scm/ scm_force_dx
NAMELIST /scm/ num_force_layers
NAMELIST /scm/ scm_lu_index
NAMELIST /scm/ scm_isltyp
NAMELIST /scm/ scm_vegfra
NAMELIST /scm/ scm_canwat
NAMELIST /scm/ scm_lat
NAMELIST /scm/ scm_lon
NAMELIST /scm/ scm_th_t_tend
NAMELIST /scm/ scm_qv_t_tend
NAMELIST /scm/ scm_th_adv
NAMELIST /scm/ scm_wind_adv
NAMELIST /scm/ scm_qv_adv
NAMELIST /scm/ scm_ql_adv
NAMELIST /scm/ scm_vert_adv
NAMELIST /scm/ num_force_soil_layers
NAMELIST /scm/ scm_soilt_force
NAMELIST /scm/ scm_soilq_force
NAMELIST /scm/ scm_force_th_largescale
NAMELIST /scm/ scm_force_qv_largescale
NAMELIST /scm/ scm_force_ql_largescale
NAMELIST /scm/ scm_force_wind_largescale
NAMELIST /scm/ scm_force_skintemp
NAMELIST /scm/ scm_force_flux
NAMELIST /dynamics/ dyn_opt
NAMELIST /dynamics/ rk_ord
NAMELIST /dynamics/ w_damping
NAMELIST /dynamics/ diff_opt
NAMELIST /dynamics/ diff_opt_dfi
NAMELIST /dynamics/ km_opt
NAMELIST /dynamics/ km_opt_dfi
NAMELIST /dynamics/ damp_opt
NAMELIST /dynamics/ rad_nudge
NAMELIST /dynamics/ gwd_opt
NAMELIST /dynamics/ max_rot_angle_gwd
NAMELIST /dynamics/ zdamp
NAMELIST /dynamics/ dampcoef
NAMELIST /dynamics/ khdif
NAMELIST /dynamics/ kvdif
NAMELIST /dynamics/ diff_6th_factor
NAMELIST /dynamics/ diff_6th_opt
NAMELIST /dynamics/ diff_6th_slopeopt
NAMELIST /dynamics/ diff_6th_thresh
NAMELIST /dynamics/ use_theta_m
NAMELIST /dynamics/ use_q_diabatic
NAMELIST /dynamics/ c_s
NAMELIST /dynamics/ c_k
NAMELIST /dynamics/ smdiv
NAMELIST /dynamics/ emdiv
NAMELIST /dynamics/ epssm
NAMELIST /dynamics/ non_hydrostatic
NAMELIST /dynamics/ use_input_w
NAMELIST /dynamics/ time_step_sound
NAMELIST /dynamics/ h_mom_adv_order
NAMELIST /dynamics/ v_mom_adv_order
NAMELIST /dynamics/ h_sca_adv_order
NAMELIST /dynamics/ v_sca_adv_order
NAMELIST /dynamics/ momentum_adv_opt
NAMELIST /dynamics/ moist_adv_opt
NAMELIST /dynamics/ moist_adv_dfi_opt
NAMELIST /dynamics/ chem_adv_opt
NAMELIST /dynamics/ tracer_adv_opt
NAMELIST /dynamics/ scalar_adv_opt
NAMELIST /dynamics/ tke_adv_opt
NAMELIST /dynamics/ moist_mix2_off
NAMELIST /dynamics/ chem_mix2_off
NAMELIST /dynamics/ tracer_mix2_off
NAMELIST /dynamics/ scalar_mix2_off
NAMELIST /dynamics/ tke_mix2_off
NAMELIST /dynamics/ moist_mix6_off
NAMELIST /dynamics/ chem_mix6_off
NAMELIST /dynamics/ tracer_mix6_off
NAMELIST /dynamics/ scalar_mix6_off
NAMELIST /dynamics/ tke_mix6_off
NAMELIST /dynamics/ top_radiation
NAMELIST /dynamics/ mix_isotropic
NAMELIST /dynamics/ mix_upper_bound
NAMELIST /dynamics/ top_lid
NAMELIST /dynamics/ tke_upper_bound
NAMELIST /dynamics/ tke_drag_coefficient
NAMELIST /dynamics/ tke_heat_flux
NAMELIST /dynamics/ pert_coriolis
NAMELIST /dynamics/ coriolis2d
NAMELIST /dynamics/ mix_full_fields
NAMELIST /dynamics/ base_pres
NAMELIST /dynamics/ base_temp
NAMELIST /dynamics/ base_lapse
NAMELIST /dynamics/ iso_temp
NAMELIST /dynamics/ base_pres_strat
NAMELIST /dynamics/ base_lapse_strat
NAMELIST /dynamics/ use_baseparam_fr_nml
NAMELIST /dynamics/ fft_filter_lat
NAMELIST /dynamics/ coupled_filtering
NAMELIST /dynamics/ pos_def
NAMELIST /dynamics/ swap_pole_with_next_j
NAMELIST /dynamics/ actual_distance_average
NAMELIST /dynamics/ rotated_pole
NAMELIST /dynamics/ do_coriolis
NAMELIST /dynamics/ do_curvature
NAMELIST /dynamics/ do_gradp
NAMELIST /dynamics/ tracer_opt
NAMELIST /dynamics/ tenddiag
NAMELIST /bdy_control/ spec_bdy_width
NAMELIST /bdy_control/ spec_zone
NAMELIST /bdy_control/ relax_zone
NAMELIST /bdy_control/ specified
NAMELIST /bdy_control/ constant_bc
NAMELIST /bdy_control/ periodic_x
NAMELIST /bdy_control/ symmetric_xs
NAMELIST /bdy_control/ symmetric_xe
NAMELIST /bdy_control/ open_xs
NAMELIST /bdy_control/ open_xe
NAMELIST /bdy_control/ periodic_y
NAMELIST /bdy_control/ symmetric_ys
NAMELIST /bdy_control/ symmetric_ye
NAMELIST /bdy_control/ open_ys
NAMELIST /bdy_control/ open_ye
NAMELIST /bdy_control/ polar
NAMELIST /bdy_control/ nested
NAMELIST /bdy_control/ spec_exp
NAMELIST /bdy_control/ spec_bdy_final_mu
NAMELIST /bdy_control/ real_data_init_type
NAMELIST /bdy_control/ have_bcs_moist
NAMELIST /bdy_control/ have_bcs_scalar
NAMELIST /grib2/ background_proc_id
NAMELIST /grib2/ forecast_proc_id
NAMELIST /grib2/ production_status
NAMELIST /grib2/ compression
NAMELIST /physics/ windfarm_opt
NAMELIST /physics/ windfarm_ij
NAMELIST /ideal/ ideal_case
NAMELIST /physics/ hailcast_opt
NAMELIST /physics/ haildt
NAMELIST /physics/ lightning_option
NAMELIST /physics/ lightning_dt
NAMELIST /physics/ lightning_start_seconds
NAMELIST /physics/ flashrate_factor
NAMELIST /physics/ iccg_method
NAMELIST /physics/ iccg_prescribed_num
NAMELIST /physics/ iccg_prescribed_den
NAMELIST /physics/ cellcount_method
NAMELIST /physics/ cldtop_adjustment
NAMELIST /physics/ sf_lake_physics
NAMELIST /time_control/ auxinput1_inname
NAMELIST /time_control/ io_form_auxinput1
NAMELIST /time_control/ override_restart_timers
NAMELIST /time_control/ auxhist1_inname
NAMELIST /time_control/ auxhist1_outname
NAMELIST /time_control/ auxhist1_interval_y
NAMELIST /time_control/ auxhist1_interval_d
NAMELIST /time_control/ auxhist1_interval_h
NAMELIST /time_control/ auxhist1_interval_m
NAMELIST /time_control/ auxhist1_interval_s
NAMELIST /time_control/ auxhist1_interval
NAMELIST /time_control/ auxhist1_begin_y
NAMELIST /time_control/ auxhist1_begin_d
NAMELIST /time_control/ auxhist1_begin_h
NAMELIST /time_control/ auxhist1_begin_m
NAMELIST /time_control/ auxhist1_begin_s
NAMELIST /time_control/ auxhist1_begin
NAMELIST /time_control/ auxhist1_end_y
NAMELIST /time_control/ auxhist1_end_d
NAMELIST /time_control/ auxhist1_end_h
NAMELIST /time_control/ auxhist1_end_m
NAMELIST /time_control/ auxhist1_end_s
NAMELIST /time_control/ auxhist1_end
NAMELIST /time_control/ io_form_auxhist1
NAMELIST /time_control/ frames_per_auxhist1
NAMELIST /time_control/ auxhist2_inname
NAMELIST /time_control/ auxhist2_outname
NAMELIST /time_control/ auxhist2_interval_y
NAMELIST /time_control/ auxhist2_interval_d
NAMELIST /time_control/ auxhist2_interval_h
NAMELIST /time_control/ auxhist2_interval_m
NAMELIST /time_control/ auxhist2_interval_s
NAMELIST /time_control/ auxhist2_interval
NAMELIST /time_control/ auxhist2_begin_y
NAMELIST /time_control/ auxhist2_begin_d
NAMELIST /time_control/ auxhist2_begin_h
NAMELIST /time_control/ auxhist2_begin_m
NAMELIST /time_control/ auxhist2_begin_s
NAMELIST /time_control/ auxhist2_begin
NAMELIST /time_control/ auxhist2_end_y
NAMELIST /time_control/ auxhist2_end_d
NAMELIST /time_control/ auxhist2_end_h
NAMELIST /time_control/ auxhist2_end_m
NAMELIST /time_control/ auxhist2_end_s
NAMELIST /time_control/ auxhist2_end
NAMELIST /time_control/ io_form_auxhist2
NAMELIST /time_control/ frames_per_auxhist2
NAMELIST /time_control/ auxhist3_inname
NAMELIST /time_control/ auxhist3_outname
NAMELIST /time_control/ auxhist3_interval_y
NAMELIST /time_control/ auxhist3_interval_d
NAMELIST /time_control/ auxhist3_interval_h
NAMELIST /time_control/ auxhist3_interval_m
NAMELIST /time_control/ auxhist3_interval_s
NAMELIST /time_control/ auxhist3_interval
NAMELIST /time_control/ auxhist3_begin_y
NAMELIST /time_control/ auxhist3_begin_d
NAMELIST /time_control/ auxhist3_begin_h
NAMELIST /time_control/ auxhist3_begin_m
NAMELIST /time_control/ auxhist3_begin_s
NAMELIST /time_control/ auxhist3_begin
NAMELIST /time_control/ auxhist3_end_y
NAMELIST /time_control/ auxhist3_end_d
NAMELIST /time_control/ auxhist3_end_h
NAMELIST /time_control/ auxhist3_end_m
NAMELIST /time_control/ auxhist3_end_s
NAMELIST /time_control/ auxhist3_end
NAMELIST /time_control/ io_form_auxhist3
NAMELIST /time_control/ frames_per_auxhist3
NAMELIST /time_control/ auxhist4_inname
NAMELIST /time_control/ auxhist4_outname
NAMELIST /time_control/ auxhist4_interval_y
NAMELIST /time_control/ auxhist4_interval_d
NAMELIST /time_control/ auxhist4_interval_h
NAMELIST /time_control/ auxhist4_interval_m
NAMELIST /time_control/ auxhist4_interval_s
NAMELIST /time_control/ auxhist4_interval
NAMELIST /time_control/ auxhist4_begin_y
NAMELIST /time_control/ auxhist4_begin_d
NAMELIST /time_control/ auxhist4_begin_h
NAMELIST /time_control/ auxhist4_begin_m
NAMELIST /time_control/ auxhist4_begin_s
NAMELIST /time_control/ auxhist4_begin
NAMELIST /time_control/ auxhist4_end_y
NAMELIST /time_control/ auxhist4_end_d
NAMELIST /time_control/ auxhist4_end_h
NAMELIST /time_control/ auxhist4_end_m
NAMELIST /time_control/ auxhist4_end_s
NAMELIST /time_control/ auxhist4_end
NAMELIST /time_control/ io_form_auxhist4
NAMELIST /time_control/ frames_per_auxhist4
NAMELIST /time_control/ auxhist5_inname
NAMELIST /time_control/ auxhist5_outname
NAMELIST /time_control/ auxhist5_interval_y
NAMELIST /time_control/ auxhist5_interval_d
NAMELIST /time_control/ auxhist5_interval_h
NAMELIST /time_control/ auxhist5_interval_m
NAMELIST /time_control/ auxhist5_interval_s
NAMELIST /time_control/ auxhist5_interval
NAMELIST /time_control/ auxhist5_begin_y
NAMELIST /time_control/ auxhist5_begin_d
NAMELIST /time_control/ auxhist5_begin_h
NAMELIST /time_control/ auxhist5_begin_m
NAMELIST /time_control/ auxhist5_begin_s
NAMELIST /time_control/ auxhist5_begin
NAMELIST /time_control/ auxhist5_end_y
NAMELIST /time_control/ auxhist5_end_d
NAMELIST /time_control/ auxhist5_end_h
NAMELIST /time_control/ auxhist5_end_m
NAMELIST /time_control/ auxhist5_end_s
NAMELIST /time_control/ auxhist5_end
NAMELIST /time_control/ io_form_auxhist5
NAMELIST /time_control/ frames_per_auxhist5
NAMELIST /time_control/ auxhist6_inname
NAMELIST /time_control/ auxhist6_outname
NAMELIST /time_control/ auxhist6_interval_y
NAMELIST /time_control/ auxhist6_interval_d
NAMELIST /time_control/ auxhist6_interval_h
NAMELIST /time_control/ auxhist6_interval_m
NAMELIST /time_control/ auxhist6_interval_s
NAMELIST /time_control/ auxhist6_interval
NAMELIST /time_control/ auxhist6_begin_y
NAMELIST /time_control/ auxhist6_begin_d
NAMELIST /time_control/ auxhist6_begin_h
NAMELIST /time_control/ auxhist6_begin_m
NAMELIST /time_control/ auxhist6_begin_s
NAMELIST /time_control/ auxhist6_begin
NAMELIST /time_control/ auxhist6_end_y
NAMELIST /time_control/ auxhist6_end_d
NAMELIST /time_control/ auxhist6_end_h
NAMELIST /time_control/ auxhist6_end_m
NAMELIST /time_control/ auxhist6_end_s
NAMELIST /time_control/ auxhist6_end
NAMELIST /time_control/ io_form_auxhist6
NAMELIST /time_control/ frames_per_auxhist6
NAMELIST /time_control/ auxhist7_inname
NAMELIST /time_control/ auxhist7_outname
NAMELIST /time_control/ auxhist7_interval_y
NAMELIST /time_control/ auxhist7_interval_d
NAMELIST /time_control/ auxhist7_interval_h
NAMELIST /time_control/ auxhist7_interval_m
NAMELIST /time_control/ auxhist7_interval_s
NAMELIST /time_control/ auxhist7_interval
NAMELIST /time_control/ auxhist7_begin_y
NAMELIST /time_control/ auxhist7_begin_d
NAMELIST /time_control/ auxhist7_begin_h
NAMELIST /time_control/ auxhist7_begin_m
NAMELIST /time_control/ auxhist7_begin_s
NAMELIST /time_control/ auxhist7_begin
NAMELIST /time_control/ auxhist7_end_y
NAMELIST /time_control/ auxhist7_end_d
NAMELIST /time_control/ auxhist7_end_h
NAMELIST /time_control/ auxhist7_end_m
NAMELIST /time_control/ auxhist7_end_s
NAMELIST /time_control/ auxhist7_end
NAMELIST /time_control/ io_form_auxhist7
NAMELIST /time_control/ frames_per_auxhist7
NAMELIST /time_control/ auxhist8_inname
NAMELIST /time_control/ auxhist8_outname
NAMELIST /time_control/ auxhist8_interval_y
NAMELIST /time_control/ auxhist8_interval_d
NAMELIST /time_control/ auxhist8_interval_h
NAMELIST /time_control/ auxhist8_interval_m
NAMELIST /time_control/ auxhist8_interval_s
NAMELIST /time_control/ auxhist8_interval
NAMELIST /time_control/ auxhist8_begin_y
NAMELIST /time_control/ auxhist8_begin_d
NAMELIST /time_control/ auxhist8_begin_h
NAMELIST /time_control/ auxhist8_begin_m
NAMELIST /time_control/ auxhist8_begin_s
NAMELIST /time_control/ auxhist8_begin
NAMELIST /time_control/ auxhist8_end_y
NAMELIST /time_control/ auxhist8_end_d
NAMELIST /time_control/ auxhist8_end_h
NAMELIST /time_control/ auxhist8_end_m
NAMELIST /time_control/ auxhist8_end_s
NAMELIST /time_control/ auxhist8_end
NAMELIST /time_control/ io_form_auxhist8
NAMELIST /time_control/ frames_per_auxhist8
NAMELIST /time_control/ auxhist9_inname
NAMELIST /time_control/ auxhist9_outname
NAMELIST /time_control/ auxhist9_interval_y
NAMELIST /time_control/ auxhist9_interval_d
NAMELIST /time_control/ auxhist9_interval_h
NAMELIST /time_control/ auxhist9_interval_m
NAMELIST /time_control/ auxhist9_interval_s
NAMELIST /time_control/ auxhist9_interval
NAMELIST /time_control/ auxhist9_begin_y
NAMELIST /time_control/ auxhist9_begin_d
NAMELIST /time_control/ auxhist9_begin_h
NAMELIST /time_control/ auxhist9_begin_m
NAMELIST /time_control/ auxhist9_begin_s
NAMELIST /time_control/ auxhist9_begin
NAMELIST /time_control/ auxhist9_end_y
NAMELIST /time_control/ auxhist9_end_d
NAMELIST /time_control/ auxhist9_end_h
NAMELIST /time_control/ auxhist9_end_m
NAMELIST /time_control/ auxhist9_end_s
NAMELIST /time_control/ auxhist9_end
NAMELIST /time_control/ io_form_auxhist9
NAMELIST /time_control/ frames_per_auxhist9
NAMELIST /time_control/ auxhist10_inname
NAMELIST /time_control/ auxhist10_outname
NAMELIST /time_control/ auxhist10_interval_y
NAMELIST /time_control/ auxhist10_interval_d
NAMELIST /time_control/ auxhist10_interval_h
NAMELIST /time_control/ auxhist10_interval_m
NAMELIST /time_control/ auxhist10_interval_s
NAMELIST /time_control/ auxhist10_interval
NAMELIST /time_control/ auxhist10_begin_y
NAMELIST /time_control/ auxhist10_begin_d
NAMELIST /time_control/ auxhist10_begin_h
NAMELIST /time_control/ auxhist10_begin_m
NAMELIST /time_control/ auxhist10_begin_s
NAMELIST /time_control/ auxhist10_begin
NAMELIST /time_control/ auxhist10_end_y
NAMELIST /time_control/ auxhist10_end_d
NAMELIST /time_control/ auxhist10_end_h
NAMELIST /time_control/ auxhist10_end_m
NAMELIST /time_control/ auxhist10_end_s
NAMELIST /time_control/ auxhist10_end
NAMELIST /time_control/ io_form_auxhist10
NAMELIST /time_control/ frames_per_auxhist10
NAMELIST /time_control/ auxhist11_inname
NAMELIST /time_control/ auxhist11_outname
NAMELIST /time_control/ auxhist11_interval_y
NAMELIST /time_control/ auxhist11_interval_d
NAMELIST /time_control/ auxhist11_interval_h
NAMELIST /time_control/ auxhist11_interval_m
NAMELIST /time_control/ auxhist11_interval_s
NAMELIST /time_control/ auxhist11_interval
NAMELIST /time_control/ auxhist11_begin_y
NAMELIST /time_control/ auxhist11_begin_d
NAMELIST /time_control/ auxhist11_begin_h
NAMELIST /time_control/ auxhist11_begin_m
NAMELIST /time_control/ auxhist11_begin_s
NAMELIST /time_control/ auxhist11_begin
NAMELIST /time_control/ auxhist11_end_y
NAMELIST /time_control/ auxhist11_end_d
NAMELIST /time_control/ auxhist11_end_h
NAMELIST /time_control/ auxhist11_end_m
NAMELIST /time_control/ auxhist11_end_s
NAMELIST /time_control/ auxhist11_end
NAMELIST /time_control/ io_form_auxhist11
NAMELIST /time_control/ frames_per_auxhist11
NAMELIST /time_control/ auxhist12_inname
NAMELIST /time_control/ auxhist12_outname
NAMELIST /time_control/ auxhist12_interval_y
NAMELIST /time_control/ auxhist12_interval_d
NAMELIST /time_control/ auxhist12_interval_h
NAMELIST /time_control/ auxhist12_interval_m
NAMELIST /time_control/ auxhist12_interval_s
NAMELIST /time_control/ auxhist12_interval
NAMELIST /time_control/ auxhist12_begin_y
NAMELIST /time_control/ auxhist12_begin_d
NAMELIST /time_control/ auxhist12_begin_h
NAMELIST /time_control/ auxhist12_begin_m
NAMELIST /time_control/ auxhist12_begin_s
NAMELIST /time_control/ auxhist12_begin
NAMELIST /time_control/ auxhist12_end_y
NAMELIST /time_control/ auxhist12_end_d
NAMELIST /time_control/ auxhist12_end_h
NAMELIST /time_control/ auxhist12_end_m
NAMELIST /time_control/ auxhist12_end_s
NAMELIST /time_control/ auxhist12_end
NAMELIST /time_control/ io_form_auxhist12
NAMELIST /time_control/ frames_per_auxhist12
NAMELIST /time_control/ auxhist13_inname
NAMELIST /time_control/ auxhist13_outname
NAMELIST /time_control/ auxhist13_interval_y
NAMELIST /time_control/ auxhist13_interval_d
NAMELIST /time_control/ auxhist13_interval_h
NAMELIST /time_control/ auxhist13_interval_m
NAMELIST /time_control/ auxhist13_interval_s
NAMELIST /time_control/ auxhist13_interval
NAMELIST /time_control/ auxhist13_begin_y
NAMELIST /time_control/ auxhist13_begin_d
NAMELIST /time_control/ auxhist13_begin_h
NAMELIST /time_control/ auxhist13_begin_m
NAMELIST /time_control/ auxhist13_begin_s
NAMELIST /time_control/ auxhist13_begin
NAMELIST /time_control/ auxhist13_end_y
NAMELIST /time_control/ auxhist13_end_d
NAMELIST /time_control/ auxhist13_end_h
NAMELIST /time_control/ auxhist13_end_m
NAMELIST /time_control/ auxhist13_end_s
NAMELIST /time_control/ auxhist13_end
NAMELIST /time_control/ io_form_auxhist13
NAMELIST /time_control/ frames_per_auxhist13
NAMELIST /time_control/ auxhist14_inname
NAMELIST /time_control/ auxhist14_outname
NAMELIST /time_control/ auxhist14_interval_y
NAMELIST /time_control/ auxhist14_interval_d
NAMELIST /time_control/ auxhist14_interval_h
NAMELIST /time_control/ auxhist14_interval_m
NAMELIST /time_control/ auxhist14_interval_s
NAMELIST /time_control/ auxhist14_interval
NAMELIST /time_control/ auxhist14_begin_y
NAMELIST /time_control/ auxhist14_begin_d
NAMELIST /time_control/ auxhist14_begin_h
NAMELIST /time_control/ auxhist14_begin_m
NAMELIST /time_control/ auxhist14_begin_s
NAMELIST /time_control/ auxhist14_begin
NAMELIST /time_control/ auxhist14_end_y
NAMELIST /time_control/ auxhist14_end_d
NAMELIST /time_control/ auxhist14_end_h
NAMELIST /time_control/ auxhist14_end_m
NAMELIST /time_control/ auxhist14_end_s
NAMELIST /time_control/ auxhist14_end
NAMELIST /time_control/ io_form_auxhist14
NAMELIST /time_control/ frames_per_auxhist14
NAMELIST /time_control/ auxhist15_inname
NAMELIST /time_control/ auxhist15_outname
NAMELIST /time_control/ auxhist15_interval_y
NAMELIST /time_control/ auxhist15_interval_d
NAMELIST /time_control/ auxhist15_interval_h
NAMELIST /time_control/ auxhist15_interval_m
NAMELIST /time_control/ auxhist15_interval_s
NAMELIST /time_control/ auxhist15_interval
NAMELIST /time_control/ auxhist15_begin_y
NAMELIST /time_control/ auxhist15_begin_d
NAMELIST /time_control/ auxhist15_begin_h
NAMELIST /time_control/ auxhist15_begin_m
NAMELIST /time_control/ auxhist15_begin_s
NAMELIST /time_control/ auxhist15_begin
NAMELIST /time_control/ auxhist15_end_y
NAMELIST /time_control/ auxhist15_end_d
NAMELIST /time_control/ auxhist15_end_h
NAMELIST /time_control/ auxhist15_end_m
NAMELIST /time_control/ auxhist15_end_s
NAMELIST /time_control/ auxhist15_end
NAMELIST /time_control/ io_form_auxhist15
NAMELIST /time_control/ frames_per_auxhist15
NAMELIST /time_control/ auxhist16_inname
NAMELIST /time_control/ auxhist16_outname
NAMELIST /time_control/ auxhist16_interval_y
NAMELIST /time_control/ auxhist16_interval_d
NAMELIST /time_control/ auxhist16_interval_h
NAMELIST /time_control/ auxhist16_interval_m
NAMELIST /time_control/ auxhist16_interval_s
NAMELIST /time_control/ auxhist16_interval
NAMELIST /time_control/ auxhist16_begin_y
NAMELIST /time_control/ auxhist16_begin_d
NAMELIST /time_control/ auxhist16_begin_h
NAMELIST /time_control/ auxhist16_begin_m
NAMELIST /time_control/ auxhist16_begin_s
NAMELIST /time_control/ auxhist16_begin
NAMELIST /time_control/ auxhist16_end_y
NAMELIST /time_control/ auxhist16_end_d
NAMELIST /time_control/ auxhist16_end_h
NAMELIST /time_control/ auxhist16_end_m
NAMELIST /time_control/ auxhist16_end_s
NAMELIST /time_control/ auxhist16_end
NAMELIST /time_control/ io_form_auxhist16
NAMELIST /time_control/ frames_per_auxhist16
NAMELIST /time_control/ auxhist17_inname
NAMELIST /time_control/ auxhist17_outname
NAMELIST /time_control/ auxhist17_interval_y
NAMELIST /time_control/ auxhist17_interval_d
NAMELIST /time_control/ auxhist17_interval_h
NAMELIST /time_control/ auxhist17_interval_m
NAMELIST /time_control/ auxhist17_interval_s
NAMELIST /time_control/ auxhist17_interval
NAMELIST /time_control/ auxhist17_begin_y
NAMELIST /time_control/ auxhist17_begin_d
NAMELIST /time_control/ auxhist17_begin_h
NAMELIST /time_control/ auxhist17_begin_m
NAMELIST /time_control/ auxhist17_begin_s
NAMELIST /time_control/ auxhist17_begin
NAMELIST /time_control/ auxhist17_end_y
NAMELIST /time_control/ auxhist17_end_d
NAMELIST /time_control/ auxhist17_end_h
NAMELIST /time_control/ auxhist17_end_m
NAMELIST /time_control/ auxhist17_end_s
NAMELIST /time_control/ auxhist17_end
NAMELIST /time_control/ io_form_auxhist17
NAMELIST /time_control/ frames_per_auxhist17
NAMELIST /time_control/ auxhist18_inname
NAMELIST /time_control/ auxhist18_outname
NAMELIST /time_control/ auxhist18_interval_y
NAMELIST /time_control/ auxhist18_interval_d
NAMELIST /time_control/ auxhist18_interval_h
NAMELIST /time_control/ auxhist18_interval_m
NAMELIST /time_control/ auxhist18_interval_s
NAMELIST /time_control/ auxhist18_interval
NAMELIST /time_control/ auxhist18_begin_y
NAMELIST /time_control/ auxhist18_begin_d
NAMELIST /time_control/ auxhist18_begin_h
NAMELIST /time_control/ auxhist18_begin_m
NAMELIST /time_control/ auxhist18_begin_s
NAMELIST /time_control/ auxhist18_begin
NAMELIST /time_control/ auxhist18_end_y
NAMELIST /time_control/ auxhist18_end_d
NAMELIST /time_control/ auxhist18_end_h
NAMELIST /time_control/ auxhist18_end_m
NAMELIST /time_control/ auxhist18_end_s
NAMELIST /time_control/ auxhist18_end
NAMELIST /time_control/ io_form_auxhist18
NAMELIST /time_control/ frames_per_auxhist18
NAMELIST /time_control/ auxhist19_inname
NAMELIST /time_control/ auxhist19_outname
NAMELIST /time_control/ auxhist19_interval_y
NAMELIST /time_control/ auxhist19_interval_d
NAMELIST /time_control/ auxhist19_interval_h
NAMELIST /time_control/ auxhist19_interval_m
NAMELIST /time_control/ auxhist19_interval_s
NAMELIST /time_control/ auxhist19_interval
NAMELIST /time_control/ auxhist19_begin_y
NAMELIST /time_control/ auxhist19_begin_d
NAMELIST /time_control/ auxhist19_begin_h
NAMELIST /time_control/ auxhist19_begin_m
NAMELIST /time_control/ auxhist19_begin_s
NAMELIST /time_control/ auxhist19_begin
NAMELIST /time_control/ auxhist19_end_y
NAMELIST /time_control/ auxhist19_end_d
NAMELIST /time_control/ auxhist19_end_h
NAMELIST /time_control/ auxhist19_end_m
NAMELIST /time_control/ auxhist19_end_s
NAMELIST /time_control/ auxhist19_end
NAMELIST /time_control/ io_form_auxhist19
NAMELIST /time_control/ frames_per_auxhist19
NAMELIST /time_control/ auxhist20_inname
NAMELIST /time_control/ auxhist20_outname
NAMELIST /time_control/ auxhist20_interval_y
NAMELIST /time_control/ auxhist20_interval_d
NAMELIST /time_control/ auxhist20_interval_h
NAMELIST /time_control/ auxhist20_interval_m
NAMELIST /time_control/ auxhist20_interval_s
NAMELIST /time_control/ auxhist20_interval
NAMELIST /time_control/ auxhist20_begin_y
NAMELIST /time_control/ auxhist20_begin_d
NAMELIST /time_control/ auxhist20_begin_h
NAMELIST /time_control/ auxhist20_begin_m
NAMELIST /time_control/ auxhist20_begin_s
NAMELIST /time_control/ auxhist20_begin
NAMELIST /time_control/ auxhist20_end_y
NAMELIST /time_control/ auxhist20_end_d
NAMELIST /time_control/ auxhist20_end_h
NAMELIST /time_control/ auxhist20_end_m
NAMELIST /time_control/ auxhist20_end_s
NAMELIST /time_control/ auxhist20_end
NAMELIST /time_control/ io_form_auxhist20
NAMELIST /time_control/ frames_per_auxhist20
NAMELIST /time_control/ auxhist21_inname
NAMELIST /time_control/ auxhist21_outname
NAMELIST /time_control/ auxhist21_interval_y
NAMELIST /time_control/ auxhist21_interval_d
NAMELIST /time_control/ auxhist21_interval_h
NAMELIST /time_control/ auxhist21_interval_m
NAMELIST /time_control/ auxhist21_interval_s
NAMELIST /time_control/ auxhist21_interval
NAMELIST /time_control/ auxhist21_begin_y
NAMELIST /time_control/ auxhist21_begin_d
NAMELIST /time_control/ auxhist21_begin_h
NAMELIST /time_control/ auxhist21_begin_m
NAMELIST /time_control/ auxhist21_begin_s
NAMELIST /time_control/ auxhist21_begin
NAMELIST /time_control/ auxhist21_end_y
NAMELIST /time_control/ auxhist21_end_d
NAMELIST /time_control/ auxhist21_end_h
NAMELIST /time_control/ auxhist21_end_m
NAMELIST /time_control/ auxhist21_end_s
NAMELIST /time_control/ auxhist21_end
NAMELIST /time_control/ io_form_auxhist21
NAMELIST /time_control/ frames_per_auxhist21
NAMELIST /time_control/ auxhist22_inname
NAMELIST /time_control/ auxhist22_outname
NAMELIST /time_control/ auxhist22_interval_y
NAMELIST /time_control/ auxhist22_interval_d
NAMELIST /time_control/ auxhist22_interval_h
NAMELIST /time_control/ auxhist22_interval_m
NAMELIST /time_control/ auxhist22_interval_s
NAMELIST /time_control/ auxhist22_interval
NAMELIST /time_control/ auxhist22_begin_y
NAMELIST /time_control/ auxhist22_begin_d
NAMELIST /time_control/ auxhist22_begin_h
NAMELIST /time_control/ auxhist22_begin_m
NAMELIST /time_control/ auxhist22_begin_s
NAMELIST /time_control/ auxhist22_begin
NAMELIST /time_control/ auxhist22_end_y
NAMELIST /time_control/ auxhist22_end_d
NAMELIST /time_control/ auxhist22_end_h
NAMELIST /time_control/ auxhist22_end_m
NAMELIST /time_control/ auxhist22_end_s
NAMELIST /time_control/ auxhist22_end
NAMELIST /time_control/ io_form_auxhist22
NAMELIST /time_control/ frames_per_auxhist22
NAMELIST /time_control/ auxhist23_inname
NAMELIST /time_control/ auxhist23_outname
NAMELIST /time_control/ auxhist23_interval_y
NAMELIST /time_control/ auxhist23_interval_d
NAMELIST /time_control/ auxhist23_interval_h
NAMELIST /time_control/ auxhist23_interval_m
NAMELIST /time_control/ auxhist23_interval_s
NAMELIST /time_control/ auxhist23_interval
NAMELIST /time_control/ auxhist23_begin_y
NAMELIST /time_control/ auxhist23_begin_d
NAMELIST /time_control/ auxhist23_begin_h
NAMELIST /time_control/ auxhist23_begin_m
NAMELIST /time_control/ auxhist23_begin_s
NAMELIST /time_control/ auxhist23_begin
NAMELIST /time_control/ auxhist23_end_y
NAMELIST /time_control/ auxhist23_end_d
NAMELIST /time_control/ auxhist23_end_h
NAMELIST /time_control/ auxhist23_end_m
NAMELIST /time_control/ auxhist23_end_s
NAMELIST /time_control/ auxhist23_end
NAMELIST /time_control/ io_form_auxhist23
NAMELIST /time_control/ frames_per_auxhist23
NAMELIST /time_control/ auxhist24_inname
NAMELIST /time_control/ auxhist24_outname
NAMELIST /time_control/ auxhist24_interval_y
NAMELIST /time_control/ auxhist24_interval_d
NAMELIST /time_control/ auxhist24_interval_h
NAMELIST /time_control/ auxhist24_interval_m
NAMELIST /time_control/ auxhist24_interval_s
NAMELIST /time_control/ auxhist24_interval
NAMELIST /time_control/ auxhist24_begin_y
NAMELIST /time_control/ auxhist24_begin_d
NAMELIST /time_control/ auxhist24_begin_h
NAMELIST /time_control/ auxhist24_begin_m
NAMELIST /time_control/ auxhist24_begin_s
NAMELIST /time_control/ auxhist24_begin
NAMELIST /time_control/ auxhist24_end_y
NAMELIST /time_control/ auxhist24_end_d
NAMELIST /time_control/ auxhist24_end_h
NAMELIST /time_control/ auxhist24_end_m
NAMELIST /time_control/ auxhist24_end_s
NAMELIST /time_control/ auxhist24_end
NAMELIST /time_control/ io_form_auxhist24
NAMELIST /time_control/ frames_per_auxhist24
NAMELIST /time_control/ auxinput1_outname
NAMELIST /time_control/ auxinput1_interval_y
NAMELIST /time_control/ auxinput1_interval_d
NAMELIST /time_control/ auxinput1_interval_h
NAMELIST /time_control/ auxinput1_interval_m
NAMELIST /time_control/ auxinput1_interval_s
NAMELIST /time_control/ auxinput1_interval
NAMELIST /time_control/ auxinput1_begin_y
NAMELIST /time_control/ auxinput1_begin_d
NAMELIST /time_control/ auxinput1_begin_h
NAMELIST /time_control/ auxinput1_begin_m
NAMELIST /time_control/ auxinput1_begin_s
NAMELIST /time_control/ auxinput1_begin
NAMELIST /time_control/ auxinput1_end_y
NAMELIST /time_control/ auxinput1_end_d
NAMELIST /time_control/ auxinput1_end_h
NAMELIST /time_control/ auxinput1_end_m
NAMELIST /time_control/ auxinput1_end_s
NAMELIST /time_control/ auxinput1_end
NAMELIST /time_control/ frames_per_auxinput1
NAMELIST /time_control/ auxinput2_inname
NAMELIST /time_control/ auxinput2_outname
NAMELIST /time_control/ auxinput2_interval_y
NAMELIST /time_control/ auxinput2_interval_d
NAMELIST /time_control/ auxinput2_interval_h
NAMELIST /time_control/ auxinput2_interval_m
NAMELIST /time_control/ auxinput2_interval_s
NAMELIST /time_control/ auxinput2_interval
NAMELIST /time_control/ auxinput2_begin_y
NAMELIST /time_control/ auxinput2_begin_d
NAMELIST /time_control/ auxinput2_begin_h
NAMELIST /time_control/ auxinput2_begin_m
NAMELIST /time_control/ auxinput2_begin_s
NAMELIST /time_control/ auxinput2_begin
NAMELIST /time_control/ auxinput2_end_y
NAMELIST /time_control/ auxinput2_end_d
NAMELIST /time_control/ auxinput2_end_h
NAMELIST /time_control/ auxinput2_end_m
NAMELIST /time_control/ auxinput2_end_s
NAMELIST /time_control/ auxinput2_end
NAMELIST /time_control/ io_form_auxinput2
NAMELIST /time_control/ frames_per_auxinput2
NAMELIST /time_control/ auxinput3_inname
NAMELIST /time_control/ auxinput3_outname
NAMELIST /time_control/ auxinput3_interval_y
NAMELIST /time_control/ auxinput3_interval_d
NAMELIST /time_control/ auxinput3_interval_h
NAMELIST /time_control/ auxinput3_interval_m
NAMELIST /time_control/ auxinput3_interval_s
NAMELIST /time_control/ auxinput3_interval
NAMELIST /time_control/ auxinput3_begin_y
NAMELIST /time_control/ auxinput3_begin_d
NAMELIST /time_control/ auxinput3_begin_h
NAMELIST /time_control/ auxinput3_begin_m
NAMELIST /time_control/ auxinput3_begin_s
NAMELIST /time_control/ auxinput3_begin
NAMELIST /time_control/ auxinput3_end_y
NAMELIST /time_control/ auxinput3_end_d
NAMELIST /time_control/ auxinput3_end_h
NAMELIST /time_control/ auxinput3_end_m
NAMELIST /time_control/ auxinput3_end_s
NAMELIST /time_control/ auxinput3_end
NAMELIST /time_control/ io_form_auxinput3
NAMELIST /time_control/ frames_per_auxinput3
NAMELIST /time_control/ auxinput4_inname
NAMELIST /time_control/ auxinput4_outname
NAMELIST /time_control/ auxinput4_interval_y
NAMELIST /time_control/ auxinput4_interval_d
NAMELIST /time_control/ auxinput4_interval_h
NAMELIST /time_control/ auxinput4_interval_m
NAMELIST /time_control/ auxinput4_interval_s
NAMELIST /time_control/ auxinput4_interval
NAMELIST /time_control/ auxinput4_begin_y
NAMELIST /time_control/ auxinput4_begin_d
NAMELIST /time_control/ auxinput4_begin_h
NAMELIST /time_control/ auxinput4_begin_m
NAMELIST /time_control/ auxinput4_begin_s
NAMELIST /time_control/ auxinput4_begin
NAMELIST /time_control/ auxinput4_end_y
NAMELIST /time_control/ auxinput4_end_d
NAMELIST /time_control/ auxinput4_end_h
NAMELIST /time_control/ auxinput4_end_m
NAMELIST /time_control/ auxinput4_end_s
NAMELIST /time_control/ auxinput4_end
NAMELIST /time_control/ io_form_auxinput4
NAMELIST /time_control/ frames_per_auxinput4
NAMELIST /time_control/ auxinput5_inname
NAMELIST /time_control/ auxinput5_outname
NAMELIST /time_control/ auxinput5_interval_y
NAMELIST /time_control/ auxinput5_interval_d
NAMELIST /time_control/ auxinput5_interval_h
NAMELIST /time_control/ auxinput5_interval_m
NAMELIST /time_control/ auxinput5_interval_s
NAMELIST /time_control/ auxinput5_interval
NAMELIST /time_control/ auxinput5_begin_y
NAMELIST /time_control/ auxinput5_begin_d
NAMELIST /time_control/ auxinput5_begin_h
NAMELIST /time_control/ auxinput5_begin_m
NAMELIST /time_control/ auxinput5_begin_s
NAMELIST /time_control/ auxinput5_begin
NAMELIST /time_control/ auxinput5_end_y
NAMELIST /time_control/ auxinput5_end_d
NAMELIST /time_control/ auxinput5_end_h
NAMELIST /time_control/ auxinput5_end_m
NAMELIST /time_control/ auxinput5_end_s
NAMELIST /time_control/ auxinput5_end
NAMELIST /time_control/ io_form_auxinput5
NAMELIST /time_control/ frames_per_auxinput5
NAMELIST /time_control/ auxinput6_inname
NAMELIST /time_control/ auxinput6_outname
NAMELIST /time_control/ auxinput6_interval_y
NAMELIST /time_control/ auxinput6_interval_d
NAMELIST /time_control/ auxinput6_interval_h
NAMELIST /time_control/ auxinput6_interval_m
NAMELIST /time_control/ auxinput6_interval_s
NAMELIST /time_control/ auxinput6_interval
NAMELIST /time_control/ auxinput6_begin_y
NAMELIST /time_control/ auxinput6_begin_d
NAMELIST /time_control/ auxinput6_begin_h
NAMELIST /time_control/ auxinput6_begin_m
NAMELIST /time_control/ auxinput6_begin_s
NAMELIST /time_control/ auxinput6_begin
NAMELIST /time_control/ auxinput6_end_y
NAMELIST /time_control/ auxinput6_end_d
NAMELIST /time_control/ auxinput6_end_h
NAMELIST /time_control/ auxinput6_end_m
NAMELIST /time_control/ auxinput6_end_s
NAMELIST /time_control/ auxinput6_end
NAMELIST /time_control/ io_form_auxinput6
NAMELIST /time_control/ frames_per_auxinput6
NAMELIST /time_control/ auxinput7_inname
NAMELIST /time_control/ auxinput7_outname
NAMELIST /time_control/ auxinput7_interval_y
NAMELIST /time_control/ auxinput7_interval_d
NAMELIST /time_control/ auxinput7_interval_h
NAMELIST /time_control/ auxinput7_interval_m
NAMELIST /time_control/ auxinput7_interval_s
NAMELIST /time_control/ auxinput7_interval
NAMELIST /time_control/ auxinput7_begin_y
NAMELIST /time_control/ auxinput7_begin_d
NAMELIST /time_control/ auxinput7_begin_h
NAMELIST /time_control/ auxinput7_begin_m
NAMELIST /time_control/ auxinput7_begin_s
NAMELIST /time_control/ auxinput7_begin
NAMELIST /time_control/ auxinput7_end_y
NAMELIST /time_control/ auxinput7_end_d
NAMELIST /time_control/ auxinput7_end_h
NAMELIST /time_control/ auxinput7_end_m
NAMELIST /time_control/ auxinput7_end_s
NAMELIST /time_control/ auxinput7_end
NAMELIST /time_control/ io_form_auxinput7
NAMELIST /time_control/ frames_per_auxinput7
NAMELIST /time_control/ auxinput8_inname
NAMELIST /time_control/ auxinput8_outname
NAMELIST /time_control/ auxinput8_interval_y
NAMELIST /time_control/ auxinput8_interval_d
NAMELIST /time_control/ auxinput8_interval_h
NAMELIST /time_control/ auxinput8_interval_m
NAMELIST /time_control/ auxinput8_interval_s
NAMELIST /time_control/ auxinput8_interval
NAMELIST /time_control/ auxinput8_begin_y
NAMELIST /time_control/ auxinput8_begin_d
NAMELIST /time_control/ auxinput8_begin_h
NAMELIST /time_control/ auxinput8_begin_m
NAMELIST /time_control/ auxinput8_begin_s
NAMELIST /time_control/ auxinput8_begin
NAMELIST /time_control/ auxinput8_end_y
NAMELIST /time_control/ auxinput8_end_d
NAMELIST /time_control/ auxinput8_end_h
NAMELIST /time_control/ auxinput8_end_m
NAMELIST /time_control/ auxinput8_end_s
NAMELIST /time_control/ auxinput8_end
NAMELIST /time_control/ io_form_auxinput8
NAMELIST /time_control/ frames_per_auxinput8
NAMELIST /time_control/ auxinput9_inname
NAMELIST /time_control/ auxinput9_outname
NAMELIST /time_control/ auxinput9_interval_y
NAMELIST /time_control/ auxinput9_interval_d
NAMELIST /time_control/ auxinput9_interval_h
NAMELIST /time_control/ auxinput9_interval_m
NAMELIST /time_control/ auxinput9_interval_s
NAMELIST /time_control/ auxinput9_interval
NAMELIST /time_control/ auxinput9_begin_y
NAMELIST /time_control/ auxinput9_begin_d
NAMELIST /time_control/ auxinput9_begin_h
NAMELIST /time_control/ auxinput9_begin_m
NAMELIST /time_control/ auxinput9_begin_s
NAMELIST /time_control/ auxinput9_begin
NAMELIST /time_control/ auxinput9_end_y
NAMELIST /time_control/ auxinput9_end_d
NAMELIST /time_control/ auxinput9_end_h
NAMELIST /time_control/ auxinput9_end_m
NAMELIST /time_control/ auxinput9_end_s
NAMELIST /time_control/ auxinput9_end
NAMELIST /time_control/ io_form_auxinput9
NAMELIST /time_control/ frames_per_auxinput9
NAMELIST /time_control/ auxinput10_inname
NAMELIST /time_control/ auxinput10_outname
NAMELIST /time_control/ auxinput10_interval_y
NAMELIST /time_control/ auxinput10_interval_d
NAMELIST /time_control/ auxinput10_interval_h
NAMELIST /time_control/ auxinput10_interval_m
NAMELIST /time_control/ auxinput10_interval_s
NAMELIST /time_control/ auxinput10_interval
NAMELIST /time_control/ auxinput10_begin_y
NAMELIST /time_control/ auxinput10_begin_d
NAMELIST /time_control/ auxinput10_begin_h
NAMELIST /time_control/ auxinput10_begin_m
NAMELIST /time_control/ auxinput10_begin_s
NAMELIST /time_control/ auxinput10_begin
NAMELIST /time_control/ auxinput10_end_y
NAMELIST /time_control/ auxinput10_end_d
NAMELIST /time_control/ auxinput10_end_h
NAMELIST /time_control/ auxinput10_end_m
NAMELIST /time_control/ auxinput10_end_s
NAMELIST /time_control/ auxinput10_end
NAMELIST /time_control/ io_form_auxinput10
NAMELIST /time_control/ frames_per_auxinput10
NAMELIST /time_control/ auxinput11_inname
NAMELIST /time_control/ auxinput11_outname
NAMELIST /time_control/ auxinput11_interval_y
NAMELIST /time_control/ auxinput11_interval_d
NAMELIST /time_control/ auxinput11_interval_h
NAMELIST /time_control/ auxinput11_interval_m
NAMELIST /time_control/ auxinput11_interval_s
NAMELIST /time_control/ auxinput11_interval
NAMELIST /time_control/ auxinput11_begin_y
NAMELIST /time_control/ auxinput11_begin_d
NAMELIST /time_control/ auxinput11_begin_h
NAMELIST /time_control/ auxinput11_begin_m
NAMELIST /time_control/ auxinput11_begin_s
NAMELIST /time_control/ auxinput11_begin
NAMELIST /time_control/ auxinput11_end_y
NAMELIST /time_control/ auxinput11_end_d
NAMELIST /time_control/ auxinput11_end_h
NAMELIST /time_control/ auxinput11_end_m
NAMELIST /time_control/ auxinput11_end_s
NAMELIST /time_control/ auxinput11_end
NAMELIST /time_control/ io_form_auxinput11
NAMELIST /time_control/ frames_per_auxinput11
NAMELIST /time_control/ auxinput12_inname
NAMELIST /time_control/ auxinput12_outname
NAMELIST /time_control/ auxinput12_interval_y
NAMELIST /time_control/ auxinput12_interval_d
NAMELIST /time_control/ auxinput12_interval_h
NAMELIST /time_control/ auxinput12_interval_m
NAMELIST /time_control/ auxinput12_interval_s
NAMELIST /time_control/ auxinput12_interval
NAMELIST /time_control/ auxinput12_begin_y
NAMELIST /time_control/ auxinput12_begin_d
NAMELIST /time_control/ auxinput12_begin_h
NAMELIST /time_control/ auxinput12_begin_m
NAMELIST /time_control/ auxinput12_begin_s
NAMELIST /time_control/ auxinput12_begin
NAMELIST /time_control/ auxinput12_end_y
NAMELIST /time_control/ auxinput12_end_d
NAMELIST /time_control/ auxinput12_end_h
NAMELIST /time_control/ auxinput12_end_m
NAMELIST /time_control/ auxinput12_end_s
NAMELIST /time_control/ auxinput12_end
NAMELIST /time_control/ io_form_auxinput12
NAMELIST /time_control/ frames_per_auxinput12
NAMELIST /time_control/ auxinput13_inname
NAMELIST /time_control/ auxinput13_outname
NAMELIST /time_control/ auxinput13_interval_y
NAMELIST /time_control/ auxinput13_interval_d
NAMELIST /time_control/ auxinput13_interval_h
NAMELIST /time_control/ auxinput13_interval_m
NAMELIST /time_control/ auxinput13_interval_s
NAMELIST /time_control/ auxinput13_interval
NAMELIST /time_control/ auxinput13_begin_y
NAMELIST /time_control/ auxinput13_begin_d
NAMELIST /time_control/ auxinput13_begin_h
NAMELIST /time_control/ auxinput13_begin_m
NAMELIST /time_control/ auxinput13_begin_s
NAMELIST /time_control/ auxinput13_begin
NAMELIST /time_control/ auxinput13_end_y
NAMELIST /time_control/ auxinput13_end_d
NAMELIST /time_control/ auxinput13_end_h
NAMELIST /time_control/ auxinput13_end_m
NAMELIST /time_control/ auxinput13_end_s
NAMELIST /time_control/ auxinput13_end
NAMELIST /time_control/ io_form_auxinput13
NAMELIST /time_control/ frames_per_auxinput13
NAMELIST /time_control/ auxinput14_inname
NAMELIST /time_control/ auxinput14_outname
NAMELIST /time_control/ auxinput14_interval_y
NAMELIST /time_control/ auxinput14_interval_d
NAMELIST /time_control/ auxinput14_interval_h
NAMELIST /time_control/ auxinput14_interval_m
NAMELIST /time_control/ auxinput14_interval_s
NAMELIST /time_control/ auxinput14_interval
NAMELIST /time_control/ auxinput14_begin_y
NAMELIST /time_control/ auxinput14_begin_d
NAMELIST /time_control/ auxinput14_begin_h
NAMELIST /time_control/ auxinput14_begin_m
NAMELIST /time_control/ auxinput14_begin_s
NAMELIST /time_control/ auxinput14_begin
NAMELIST /time_control/ auxinput14_end_y
NAMELIST /time_control/ auxinput14_end_d
NAMELIST /time_control/ auxinput14_end_h
NAMELIST /time_control/ auxinput14_end_m
NAMELIST /time_control/ auxinput14_end_s
NAMELIST /time_control/ auxinput14_end
NAMELIST /time_control/ io_form_auxinput14
NAMELIST /time_control/ frames_per_auxinput14
NAMELIST /time_control/ auxinput15_inname
NAMELIST /time_control/ auxinput15_outname
NAMELIST /time_control/ auxinput15_interval_y
NAMELIST /time_control/ auxinput15_interval_d
NAMELIST /time_control/ auxinput15_interval_h
NAMELIST /time_control/ auxinput15_interval_m
NAMELIST /time_control/ auxinput15_interval_s
NAMELIST /time_control/ auxinput15_interval
NAMELIST /time_control/ auxinput15_begin_y
NAMELIST /time_control/ auxinput15_begin_d
NAMELIST /time_control/ auxinput15_begin_h
NAMELIST /time_control/ auxinput15_begin_m
NAMELIST /time_control/ auxinput15_begin_s
NAMELIST /time_control/ auxinput15_begin
NAMELIST /time_control/ auxinput15_end_y
NAMELIST /time_control/ auxinput15_end_d
NAMELIST /time_control/ auxinput15_end_h
NAMELIST /time_control/ auxinput15_end_m
NAMELIST /time_control/ auxinput15_end_s
NAMELIST /time_control/ auxinput15_end
NAMELIST /time_control/ io_form_auxinput15
NAMELIST /time_control/ frames_per_auxinput15
NAMELIST /time_control/ auxinput16_inname
NAMELIST /time_control/ auxinput16_outname
NAMELIST /time_control/ auxinput16_interval_y
NAMELIST /time_control/ auxinput16_interval_d
NAMELIST /time_control/ auxinput16_interval_h
NAMELIST /time_control/ auxinput16_interval_m
NAMELIST /time_control/ auxinput16_interval_s
NAMELIST /time_control/ auxinput16_interval
NAMELIST /time_control/ auxinput16_begin_y
NAMELIST /time_control/ auxinput16_begin_d
NAMELIST /time_control/ auxinput16_begin_h
NAMELIST /time_control/ auxinput16_begin_m
NAMELIST /time_control/ auxinput16_begin_s
NAMELIST /time_control/ auxinput16_begin
NAMELIST /time_control/ auxinput16_end_y
NAMELIST /time_control/ auxinput16_end_d
NAMELIST /time_control/ auxinput16_end_h
NAMELIST /time_control/ auxinput16_end_m
NAMELIST /time_control/ auxinput16_end_s
NAMELIST /time_control/ auxinput16_end
NAMELIST /time_control/ io_form_auxinput16
NAMELIST /time_control/ frames_per_auxinput16
NAMELIST /time_control/ auxinput17_inname
NAMELIST /time_control/ auxinput17_outname
NAMELIST /time_control/ auxinput17_interval_y
NAMELIST /time_control/ auxinput17_interval_d
NAMELIST /time_control/ auxinput17_interval_h
NAMELIST /time_control/ auxinput17_interval_m
NAMELIST /time_control/ auxinput17_interval_s
NAMELIST /time_control/ auxinput17_interval
NAMELIST /time_control/ auxinput17_begin_y
NAMELIST /time_control/ auxinput17_begin_d
NAMELIST /time_control/ auxinput17_begin_h
NAMELIST /time_control/ auxinput17_begin_m
NAMELIST /time_control/ auxinput17_begin_s
NAMELIST /time_control/ auxinput17_begin
NAMELIST /time_control/ auxinput17_end_y
NAMELIST /time_control/ auxinput17_end_d
NAMELIST /time_control/ auxinput17_end_h
NAMELIST /time_control/ auxinput17_end_m
NAMELIST /time_control/ auxinput17_end_s
NAMELIST /time_control/ auxinput17_end
NAMELIST /time_control/ io_form_auxinput17
NAMELIST /time_control/ frames_per_auxinput17
NAMELIST /time_control/ auxinput18_inname
NAMELIST /time_control/ auxinput18_outname
NAMELIST /time_control/ auxinput18_interval_y
NAMELIST /time_control/ auxinput18_interval_d
NAMELIST /time_control/ auxinput18_interval_h
NAMELIST /time_control/ auxinput18_interval_m
NAMELIST /time_control/ auxinput18_interval_s
NAMELIST /time_control/ auxinput18_interval
NAMELIST /time_control/ auxinput18_begin_y
NAMELIST /time_control/ auxinput18_begin_d
NAMELIST /time_control/ auxinput18_begin_h
NAMELIST /time_control/ auxinput18_begin_m
NAMELIST /time_control/ auxinput18_begin_s
NAMELIST /time_control/ auxinput18_begin
NAMELIST /time_control/ auxinput18_end_y
NAMELIST /time_control/ auxinput18_end_d
NAMELIST /time_control/ auxinput18_end_h
NAMELIST /time_control/ auxinput18_end_m
NAMELIST /time_control/ auxinput18_end_s
NAMELIST /time_control/ auxinput18_end
NAMELIST /time_control/ io_form_auxinput18
NAMELIST /time_control/ frames_per_auxinput18
NAMELIST /time_control/ auxinput19_inname
NAMELIST /time_control/ auxinput19_outname
NAMELIST /time_control/ auxinput19_interval_y
NAMELIST /time_control/ auxinput19_interval_d
NAMELIST /time_control/ auxinput19_interval_h
NAMELIST /time_control/ auxinput19_interval_m
NAMELIST /time_control/ auxinput19_interval_s
NAMELIST /time_control/ auxinput19_interval
NAMELIST /time_control/ auxinput19_begin_y
NAMELIST /time_control/ auxinput19_begin_d
NAMELIST /time_control/ auxinput19_begin_h
NAMELIST /time_control/ auxinput19_begin_m
NAMELIST /time_control/ auxinput19_begin_s
NAMELIST /time_control/ auxinput19_begin
NAMELIST /time_control/ auxinput19_end_y
NAMELIST /time_control/ auxinput19_end_d
NAMELIST /time_control/ auxinput19_end_h
NAMELIST /time_control/ auxinput19_end_m
NAMELIST /time_control/ auxinput19_end_s
NAMELIST /time_control/ auxinput19_end
NAMELIST /time_control/ io_form_auxinput19
NAMELIST /time_control/ frames_per_auxinput19
NAMELIST /time_control/ auxinput20_inname
NAMELIST /time_control/ auxinput20_outname
NAMELIST /time_control/ auxinput20_interval_y
NAMELIST /time_control/ auxinput20_interval_d
NAMELIST /time_control/ auxinput20_interval_h
NAMELIST /time_control/ auxinput20_interval_m
NAMELIST /time_control/ auxinput20_interval_s
NAMELIST /time_control/ auxinput20_interval
NAMELIST /time_control/ auxinput20_begin_y
NAMELIST /time_control/ auxinput20_begin_d
NAMELIST /time_control/ auxinput20_begin_h
NAMELIST /time_control/ auxinput20_begin_m
NAMELIST /time_control/ auxinput20_begin_s
NAMELIST /time_control/ auxinput20_begin
NAMELIST /time_control/ auxinput20_end_y
NAMELIST /time_control/ auxinput20_end_d
NAMELIST /time_control/ auxinput20_end_h
NAMELIST /time_control/ auxinput20_end_m
NAMELIST /time_control/ auxinput20_end_s
NAMELIST /time_control/ auxinput20_end
NAMELIST /time_control/ io_form_auxinput20
NAMELIST /time_control/ frames_per_auxinput20
NAMELIST /time_control/ auxinput21_inname
NAMELIST /time_control/ auxinput21_outname
NAMELIST /time_control/ auxinput21_interval_y
NAMELIST /time_control/ auxinput21_interval_d
NAMELIST /time_control/ auxinput21_interval_h
NAMELIST /time_control/ auxinput21_interval_m
NAMELIST /time_control/ auxinput21_interval_s
NAMELIST /time_control/ auxinput21_interval
NAMELIST /time_control/ auxinput21_begin_y
NAMELIST /time_control/ auxinput21_begin_d
NAMELIST /time_control/ auxinput21_begin_h
NAMELIST /time_control/ auxinput21_begin_m
NAMELIST /time_control/ auxinput21_begin_s
NAMELIST /time_control/ auxinput21_begin
NAMELIST /time_control/ auxinput21_end_y
NAMELIST /time_control/ auxinput21_end_d
NAMELIST /time_control/ auxinput21_end_h
NAMELIST /time_control/ auxinput21_end_m
NAMELIST /time_control/ auxinput21_end_s
NAMELIST /time_control/ auxinput21_end
NAMELIST /time_control/ io_form_auxinput21
NAMELIST /time_control/ frames_per_auxinput21
NAMELIST /time_control/ auxinput22_inname
NAMELIST /time_control/ auxinput22_outname
NAMELIST /time_control/ auxinput22_interval_y
NAMELIST /time_control/ auxinput22_interval_d
NAMELIST /time_control/ auxinput22_interval_h
NAMELIST /time_control/ auxinput22_interval_m
NAMELIST /time_control/ auxinput22_interval_s
NAMELIST /time_control/ auxinput22_interval
NAMELIST /time_control/ auxinput22_begin_y
NAMELIST /time_control/ auxinput22_begin_d
NAMELIST /time_control/ auxinput22_begin_h
NAMELIST /time_control/ auxinput22_begin_m
NAMELIST /time_control/ auxinput22_begin_s
NAMELIST /time_control/ auxinput22_begin
NAMELIST /time_control/ auxinput22_end_y
NAMELIST /time_control/ auxinput22_end_d
NAMELIST /time_control/ auxinput22_end_h
NAMELIST /time_control/ auxinput22_end_m
NAMELIST /time_control/ auxinput22_end_s
NAMELIST /time_control/ auxinput22_end
NAMELIST /time_control/ io_form_auxinput22
NAMELIST /time_control/ frames_per_auxinput22
NAMELIST /time_control/ auxinput23_inname
NAMELIST /time_control/ auxinput23_outname
NAMELIST /time_control/ auxinput23_interval_y
NAMELIST /time_control/ auxinput23_interval_d
NAMELIST /time_control/ auxinput23_interval_h
NAMELIST /time_control/ auxinput23_interval_m
NAMELIST /time_control/ auxinput23_interval_s
NAMELIST /time_control/ auxinput23_interval
NAMELIST /time_control/ auxinput23_begin_y
NAMELIST /time_control/ auxinput23_begin_d
NAMELIST /time_control/ auxinput23_begin_h
NAMELIST /time_control/ auxinput23_begin_m
NAMELIST /time_control/ auxinput23_begin_s
NAMELIST /time_control/ auxinput23_begin
NAMELIST /time_control/ auxinput23_end_y
NAMELIST /time_control/ auxinput23_end_d
NAMELIST /time_control/ auxinput23_end_h
NAMELIST /time_control/ auxinput23_end_m
NAMELIST /time_control/ auxinput23_end_s
NAMELIST /time_control/ auxinput23_end
NAMELIST /time_control/ io_form_auxinput23
NAMELIST /time_control/ frames_per_auxinput23
NAMELIST /time_control/ auxinput24_inname
NAMELIST /time_control/ auxinput24_outname
NAMELIST /time_control/ auxinput24_interval_y
NAMELIST /time_control/ auxinput24_interval_d
NAMELIST /time_control/ auxinput24_interval_h
NAMELIST /time_control/ auxinput24_interval_m
NAMELIST /time_control/ auxinput24_interval_s
NAMELIST /time_control/ auxinput24_interval
NAMELIST /time_control/ auxinput24_begin_y
NAMELIST /time_control/ auxinput24_begin_d
NAMELIST /time_control/ auxinput24_begin_h
NAMELIST /time_control/ auxinput24_begin_m
NAMELIST /time_control/ auxinput24_begin_s
NAMELIST /time_control/ auxinput24_begin
NAMELIST /time_control/ auxinput24_end_y
NAMELIST /time_control/ auxinput24_end_d
NAMELIST /time_control/ auxinput24_end_h
NAMELIST /time_control/ auxinput24_end_m
NAMELIST /time_control/ auxinput24_end_s
NAMELIST /time_control/ auxinput24_end
NAMELIST /time_control/ io_form_auxinput24
NAMELIST /time_control/ frames_per_auxinput24
NAMELIST /time_control/ history_interval
NAMELIST /time_control/ frames_per_outfile
NAMELIST /time_control/ restart
NAMELIST /time_control/ restart_interval
NAMELIST /time_control/ io_form_input
NAMELIST /time_control/ io_form_history
NAMELIST /time_control/ io_form_restart
NAMELIST /time_control/ io_form_boundary
NAMELIST /time_control/ debug_level
NAMELIST /time_control/ self_test_domain
NAMELIST /time_control/ history_outname
NAMELIST /time_control/ history_inname
NAMELIST /time_control/ use_netcdf_classic
NAMELIST /time_control/ history_interval_d
NAMELIST /time_control/ history_interval_h
NAMELIST /time_control/ history_interval_m
NAMELIST /time_control/ history_interval_s
NAMELIST /time_control/ inputout_interval_d
NAMELIST /time_control/ inputout_interval_h
NAMELIST /time_control/ inputout_interval_m
NAMELIST /time_control/ inputout_interval_s
NAMELIST /time_control/ inputout_interval
NAMELIST /time_control/ restart_interval_d
NAMELIST /time_control/ restart_interval_h
NAMELIST /time_control/ restart_interval_m
NAMELIST /time_control/ restart_interval_s
NAMELIST /time_control/ history_begin_y
NAMELIST /time_control/ history_begin_d
NAMELIST /time_control/ history_begin_h
NAMELIST /time_control/ history_begin_m
NAMELIST /time_control/ history_begin_s
NAMELIST /time_control/ history_begin
NAMELIST /time_control/ inputout_begin_y
NAMELIST /time_control/ inputout_begin_d
NAMELIST /time_control/ inputout_begin_h
NAMELIST /time_control/ inputout_begin_m
NAMELIST /time_control/ inputout_begin_s
NAMELIST /time_control/ restart_begin_y
NAMELIST /time_control/ restart_begin_d
NAMELIST /time_control/ restart_begin_h
NAMELIST /time_control/ restart_begin_m
NAMELIST /time_control/ restart_begin_s
NAMELIST /time_control/ restart_begin
NAMELIST /time_control/ history_end_y
NAMELIST /time_control/ history_end_d
NAMELIST /time_control/ history_end_h
NAMELIST /time_control/ history_end_m
NAMELIST /time_control/ history_end_s
NAMELIST /time_control/ history_end
NAMELIST /time_control/ inputout_end_y
NAMELIST /time_control/ inputout_end_d
NAMELIST /time_control/ inputout_end_h
NAMELIST /time_control/ inputout_end_m
NAMELIST /time_control/ inputout_end_s
NAMELIST /time_control/ reset_simulation_start
NAMELIST /domains/ sr_x
NAMELIST /domains/ sr_y
NAMELIST /fdda/ sgfdda_inname
NAMELIST /fdda/ gfdda_inname
NAMELIST /fdda/ sgfdda_interval_d
NAMELIST /fdda/ sgfdda_interval_h
NAMELIST /fdda/ sgfdda_interval_m
NAMELIST /fdda/ sgfdda_interval_s
NAMELIST /fdda/ sgfdda_interval_y
NAMELIST /fdda/ sgfdda_interval
NAMELIST /fdda/ gfdda_interval_d
NAMELIST /fdda/ gfdda_interval_h
NAMELIST /fdda/ gfdda_interval_m
NAMELIST /fdda/ gfdda_interval_s
NAMELIST /fdda/ gfdda_interval_y
NAMELIST /fdda/ gfdda_interval
NAMELIST /fdda/ sgfdda_begin_y
NAMELIST /fdda/ sgfdda_begin_d
NAMELIST /fdda/ sgfdda_begin_h
NAMELIST /fdda/ sgfdda_begin_m
NAMELIST /fdda/ sgfdda_begin_s
NAMELIST /fdda/ gfdda_begin_y
NAMELIST /fdda/ gfdda_begin_d
NAMELIST /fdda/ gfdda_begin_h
NAMELIST /fdda/ gfdda_begin_m
NAMELIST /fdda/ gfdda_begin_s
NAMELIST /fdda/ sgfdda_end_y
NAMELIST /fdda/ sgfdda_end_d
NAMELIST /fdda/ sgfdda_end_h
NAMELIST /fdda/ sgfdda_end_m
NAMELIST /fdda/ sgfdda_end_s
NAMELIST /fdda/ gfdda_end_y
NAMELIST /fdda/ gfdda_end_d
NAMELIST /fdda/ gfdda_end_h
NAMELIST /fdda/ gfdda_end_m
NAMELIST /fdda/ gfdda_end_s
NAMELIST /fdda/ io_form_sgfdda
NAMELIST /fdda/ io_form_gfdda
NAMELIST /time_control/ iofields_filename
NAMELIST /time_control/ ignore_iofields_warning
NAMELIST /time_control/ ncd_nofill
NAMELIST /fire/ ifire
NAMELIST /fire/ fire_boundary_guard
NAMELIST /fire/ fire_num_ignitions
NAMELIST /fire/ fire_ignition_ros1
NAMELIST /fire/ fire_ignition_start_lon1
NAMELIST /fire/ fire_ignition_start_lat1
NAMELIST /fire/ fire_ignition_end_lon1
NAMELIST /fire/ fire_ignition_end_lat1
NAMELIST /fire/ fire_ignition_radius1
NAMELIST /fire/ fire_ignition_start_time1
NAMELIST /fire/ fire_ignition_end_time1
NAMELIST /fire/ fire_ignition_ros2
NAMELIST /fire/ fire_ignition_start_lon2
NAMELIST /fire/ fire_ignition_start_lat2
NAMELIST /fire/ fire_ignition_end_lon2
NAMELIST /fire/ fire_ignition_end_lat2
NAMELIST /fire/ fire_ignition_radius2
NAMELIST /fire/ fire_ignition_start_time2
NAMELIST /fire/ fire_ignition_end_time2
NAMELIST /fire/ fire_ignition_ros3
NAMELIST /fire/ fire_ignition_start_lon3
NAMELIST /fire/ fire_ignition_start_lat3
NAMELIST /fire/ fire_ignition_end_lon3
NAMELIST /fire/ fire_ignition_end_lat3
NAMELIST /fire/ fire_ignition_radius3
NAMELIST /fire/ fire_ignition_start_time3
NAMELIST /fire/ fire_ignition_end_time3
NAMELIST /fire/ fire_ignition_ros4
NAMELIST /fire/ fire_ignition_start_lon4
NAMELIST /fire/ fire_ignition_start_lat4
NAMELIST /fire/ fire_ignition_end_lon4
NAMELIST /fire/ fire_ignition_end_lat4
NAMELIST /fire/ fire_ignition_radius4
NAMELIST /fire/ fire_ignition_start_time4
NAMELIST /fire/ fire_ignition_end_time4
NAMELIST /fire/ fire_ignition_ros5
NAMELIST /fire/ fire_ignition_start_lon5
NAMELIST /fire/ fire_ignition_start_lat5
NAMELIST /fire/ fire_ignition_end_lon5
NAMELIST /fire/ fire_ignition_end_lat5
NAMELIST /fire/ fire_ignition_radius5
NAMELIST /fire/ fire_ignition_start_time5
NAMELIST /fire/ fire_ignition_end_time5
NAMELIST /fire/ fire_ignition_start_x1
NAMELIST /fire/ fire_ignition_start_y1
NAMELIST /fire/ fire_ignition_end_x1
NAMELIST /fire/ fire_ignition_end_y1
NAMELIST /fire/ fire_ignition_start_x2
NAMELIST /fire/ fire_ignition_start_y2
NAMELIST /fire/ fire_ignition_end_x2
NAMELIST /fire/ fire_ignition_end_y2
NAMELIST /fire/ fire_ignition_start_x3
NAMELIST /fire/ fire_ignition_start_y3
NAMELIST /fire/ fire_ignition_end_x3
NAMELIST /fire/ fire_ignition_end_y3
NAMELIST /fire/ fire_ignition_start_x4
NAMELIST /fire/ fire_ignition_start_y4
NAMELIST /fire/ fire_ignition_end_x4
NAMELIST /fire/ fire_ignition_end_y4
NAMELIST /fire/ fire_ignition_start_x5
NAMELIST /fire/ fire_ignition_start_y5
NAMELIST /fire/ fire_ignition_end_x5
NAMELIST /fire/ fire_ignition_end_y5
NAMELIST /fire/ fire_lat_init
NAMELIST /fire/ fire_lon_init
NAMELIST /fire/ fire_ign_time
NAMELIST /fire/ fire_shape
NAMELIST /fire/ fire_sprd_mdl
NAMELIST /fire/ fire_crwn_hgt
NAMELIST /fire/ fire_ext_grnd
NAMELIST /fire/ fire_ext_crwn
NAMELIST /fire/ fire_wind_height
NAMELIST /fire/ fire_fuel_read
NAMELIST /fire/ fire_fuel_cat
NAMELIST /fire/ fire_print_msg
NAMELIST /fire/ fire_print_file
NAMELIST /fire/ fire_fuel_left_method
NAMELIST /fire/ fire_fuel_left_irl
NAMELIST /fire/ fire_fuel_left_jrl
NAMELIST /fire/ fire_grows_only
NAMELIST /fire/ fire_upwinding
NAMELIST /fire/ fire_upwind_split
NAMELIST /fire/ fire_viscosity
NAMELIST /fire/ fire_lfn_ext_up
NAMELIST /fire/ fire_topo_from_atm
NAMELIST /fire/ fire_advection
NAMELIST /fire/ fire_test_steps
NAMELIST /fire/ fire_const_time
NAMELIST /fire/ fire_const_grnhfx
NAMELIST /fire/ fire_const_grnqfx
NAMELIST /fire/ fire_atm_feedback
NAMELIST /fire/ fire_mountain_type
NAMELIST /fire/ fire_mountain_height
NAMELIST /fire/ fire_mountain_start_x
NAMELIST /fire/ fire_mountain_start_y
NAMELIST /fire/ fire_mountain_end_x
NAMELIST /fire/ fire_mountain_end_y
NAMELIST /fire/ delt_perturbation
NAMELIST /fire/ xrad_perturbation
NAMELIST /fire/ yrad_perturbation
NAMELIST /fire/ zrad_perturbation
NAMELIST /fire/ hght_perturbation
NAMELIST /fire/ stretch_grd
NAMELIST /fire/ stretch_hyp
NAMELIST /fire/ z_grd_scale
NAMELIST /fire/ sfc_full_init
NAMELIST /fire/ sfc_lu_index
NAMELIST /fire/ sfc_tsk
NAMELIST /fire/ sfc_tmn
NAMELIST /fire/ fire_read_lu
NAMELIST /fire/ fire_read_tsk
NAMELIST /fire/ fire_read_tmn
NAMELIST /fire/ fire_read_atm_ht
NAMELIST /fire/ fire_read_fire_ht
NAMELIST /fire/ fire_read_atm_grad
NAMELIST /fire/ fire_read_fire_grad
NAMELIST /fire/ sfc_vegfra
NAMELIST /fire/ sfc_canwat
NAMELIST /fire/ sfc_ivgtyp
NAMELIST /fire/ sfc_isltyp
NAMELIST /fire/ fire_lsm_reinit
NAMELIST /fire/ fire_lsm_reinit_iter
NAMELIST /fire/ fire_upwinding_reinit
NAMELIST /fire/ fire_is_real_perim
NAMELIST /fire/ fire_lsm_band_ngp
NAMELIST /fire/ fire_lsm_zcoupling
NAMELIST /fire/ fire_lsm_zcoupling_ref
NAMELIST /fire/ fire_tracer_smoke
NAMELIST /fire/ fire_viscosity_bg
NAMELIST /fire/ fire_viscosity_band
NAMELIST /fire/ fire_viscosity_ngp
NAMELIST /fire/ fire_slope_factor
NAMELIST /dynamics/ do_avgflx_em
NAMELIST /dynamics/ do_avgflx_cugd
NAMELIST /stoch/ nens
NAMELIST /stoch/ skebs
NAMELIST /stoch/ stoch_force_opt
NAMELIST /stoch/ skebs_vertstruc
NAMELIST /stoch/ stoch_vertstruc_opt
NAMELIST /stoch/ tot_backscat_psi
NAMELIST /stoch/ tot_backscat_t
NAMELIST /stoch/ ztau_psi
NAMELIST /stoch/ ztau_t
NAMELIST /stoch/ rexponent_psi
NAMELIST /stoch/ rexponent_t
NAMELIST /stoch/ zsigma2_eps
NAMELIST /stoch/ zsigma2_eta
NAMELIST /stoch/ kminforc
NAMELIST /stoch/ lminforc
NAMELIST /stoch/ kminforct
NAMELIST /stoch/ lminforct
NAMELIST /stoch/ kmaxforc
NAMELIST /stoch/ lmaxforc
NAMELIST /stoch/ kmaxforct
NAMELIST /stoch/ lmaxforct
NAMELIST /stoch/ iseed_skebs
NAMELIST /stoch/ sppt
NAMELIST /stoch/ gridpt_stddev_sppt
NAMELIST /stoch/ stddev_cutoff_sppt
NAMELIST /stoch/ lengthscale_sppt
NAMELIST /stoch/ timescale_sppt
NAMELIST /stoch/ sppt_vertstruc
NAMELIST /stoch/ iseed_sppt
NAMELIST /stoch/ rand_perturb
NAMELIST /stoch/ gridpt_stddev_rand_pert
NAMELIST /stoch/ stddev_cutoff_rand_pert
NAMELIST /stoch/ lengthscale_rand_pert
NAMELIST /stoch/ timescale_rand_pert
NAMELIST /stoch/ rand_pert_vertstruc
NAMELIST /stoch/ iseed_rand_pert
NAMELIST /stoch/ spp
NAMELIST /stoch/ hrrr_cycling
NAMELIST /stoch/ spp_conv
NAMELIST /stoch/ gridpt_stddev_spp_conv
NAMELIST /stoch/ stddev_cutoff_spp_conv
NAMELIST /stoch/ lengthscale_spp_conv
NAMELIST /stoch/ timescale_spp_conv
NAMELIST /stoch/ vertstruc_spp_conv
NAMELIST /stoch/ iseed_spp_conv
NAMELIST /stoch/ spp_pbl
NAMELIST /stoch/ gridpt_stddev_spp_pbl
NAMELIST /stoch/ stddev_cutoff_spp_pbl
NAMELIST /stoch/ lengthscale_spp_pbl
NAMELIST /stoch/ timescale_spp_pbl
NAMELIST /stoch/ vertstruc_spp_pbl
NAMELIST /stoch/ iseed_spp_pbl
NAMELIST /stoch/ spp_lsm
NAMELIST /stoch/ gridpt_stddev_spp_lsm
NAMELIST /stoch/ stddev_cutoff_spp_lsm
NAMELIST /stoch/ lengthscale_spp_lsm
NAMELIST /stoch/ timescale_spp_lsm
NAMELIST /stoch/ vertstruc_spp_lsm
NAMELIST /stoch/ iseed_spp_lsm
NAMELIST /dynamics/ sfs_opt
NAMELIST /dynamics/ m_opt
NAMELIST /physics/ lakedepth_default
NAMELIST /physics/ lake_min_elev
NAMELIST /physics/ use_lakedepth
NAMELIST /diags/ p_lev_diags
NAMELIST /diags/ p_lev_diags_dfi
NAMELIST /diags/ num_press_levels
NAMELIST /diags/ press_levels
NAMELIST /diags/ use_tot_or_hyd_p
NAMELIST /diags/ extrap_below_grnd
NAMELIST /diags/ p_lev_missing
NAMELIST /diags/ z_lev_diags
NAMELIST /diags/ z_lev_diags_dfi
NAMELIST /diags/ num_z_levels
NAMELIST /diags/ z_levels
NAMELIST /diags/ z_lev_missing
NAMELIST /afwa/ afwa_diag_opt
NAMELIST /afwa/ afwa_ptype_opt
NAMELIST /afwa/ afwa_vil_opt
NAMELIST /afwa/ afwa_radar_opt
NAMELIST /afwa/ afwa_severe_opt
NAMELIST /afwa/ afwa_icing_opt
NAMELIST /afwa/ afwa_vis_opt
NAMELIST /afwa/ afwa_cloud_opt
NAMELIST /afwa/ afwa_therm_opt
NAMELIST /afwa/ afwa_turb_opt
NAMELIST /afwa/ afwa_buoy_opt
NAMELIST /afwa/ afwa_ptype_ccn_tmp
NAMELIST /afwa/ afwa_ptype_tot_melt
NAMELIST /afwa/ afwa_bad_data_check
NAMELIST /time_control/ mean_diag
NAMELIST /time_control/ mean_freq
NAMELIST /time_control/ mean_interval
NAMELIST /time_control/ mean_diag_interval
NAMELIST /time_control/ mean_diag_interval_s
NAMELIST /time_control/ mean_diag_interval_m
NAMELIST /time_control/ mean_diag_interval_h
NAMELIST /time_control/ mean_diag_interval_d
NAMELIST /time_control/ mean_diag_interval_mo
NAMELIST /time_control/ diurnal_diag
NAMELIST /physics/ nssl_ipelec
NAMELIST /physics/ nssl_isaund
NAMELIST /physics/ nssl_iscreen
NAMELIST /physics/ nssl_lightrad
NAMELIST /physics/ nssl_idischarge
NAMELIST /physics/ nssl_ibrkd
NAMELIST /physics/ nssl_ecrit
NAMELIST /physics/ nssl_disfrac
NAMELIST /physics/ elec_physics
NAMELIST /stoch/ perturb_bdy
NAMELIST /stoch/ perturb_chem_bdy
NAMELIST /dynamics/ hybrid_opt
NAMELIST /dynamics/ etac
NAMELIST /domains/ num_wif_levels
NAMELIST /domains/ wif_input_opt
NAMELIST /diags/ diag_nwp2
NAMELIST /physics/ chem_opt



     logical , DIMENSION(max_domains) :: pd_moist, pd_chem, pd_tke, pd_scalar
     NAMELIST /dynamics/                 pd_moist, pd_chem, pd_tke, pd_scalar

     integer , DIMENSION(max_domains) :: ucmcall
     NAMELIST /physics/                  ucmcall

     integer , DIMENSION(max_domains) :: obs_nobs_prt
     NAMELIST /fdda/                     obs_nobs_prt

     LOGICAL ::         global, print_detail_airep, print_detail_timing
     NAMELIST /wrfvar1/ global, print_detail_airep, print_detail_timing

     LOGICAL ::         write_qcw, write_qrn, write_qci, write_qsn
     NAMELIST /wrfvar2/ write_qcw, write_qrn, write_qci, write_qsn
     LOGICAL ::          write_qgr, write_filtered_obs
     NAMELIST /wrfvar2/  write_qgr, write_filtered_obs

     LOGICAL ::         use_eos_radobs, use_3dvar_phy
     NAMELIST /wrfvar4/ use_eos_radobs, use_3dvar_phy

     LOGICAL             :: use_crtm_kmatrix_fast
     NAMELIST /wrfvar14/    use_crtm_kmatrix_fast
     CHARACTER (LEN=256) :: spccoeff_file, taucoeff_file, aerosolcoeff_file
     NAMELIST /wrfvar14/    spccoeff_file, taucoeff_file, aerosolcoeff_file
     CHARACTER (LEN=256) :: cloudcoeff_file, emiscoeff_file
     NAMELIST /wrfvar14/    cloudcoeff_file, emiscoeff_file







     REWIND ( UNIT = nml_read_unit )


     if ( TRIM(nml_name) .eq. "dynamics" ) then

        READ   ( UNIT = nml_read_unit , NML = dynamics , iostat=nml_error )

        IF ( nml_error .EQ. 0 ) then    
           CALL wrf_debug(0, "-- Are pd_moist, pd_chem, pd_tke, or pd_scalar still in your "// &
                               TRIM(nml_name)//" namelist?")
           CALL wrf_debug(0, "-- Replace them with moist_adv_opt, chem_adv_opt, tke_adv_opt "// &
                             " and scalar_adv_opt, respectively.")
        ENDIF


     else if ( TRIM(nml_name) .eq. "physics" ) then

        READ   ( UNIT = nml_read_unit , NML = physics , iostat=nml_error )

        IF ( nml_error .EQ. 0 ) then    
           CALL wrf_debug(0, "-- Is ucmcall still in your "// TRIM(nml_name)//" namelist?")
           CALL wrf_debug(0, "-- Replace it with sf_urban_physics")
        ENDIF


     else if ( TRIM(nml_name) .eq. "fdda" ) then

        READ   ( UNIT = nml_read_unit , NML = fdda , iostat=nml_error )

        IF ( nml_error .EQ. 0 ) then    
           CALL wrf_debug(0, "-- Is obs_nobs_prt still in your "// TRIM(nml_name)//" namelist?")
           CALL wrf_debug(0, "-- Replace it with obs_prt_max")
        ENDIF


     else if ( TRIM(nml_name) .eq. "wrfvar1" ) then

        READ   ( UNIT = nml_read_unit , NML = wrfvar1 , iostat=nml_error )

        IF ( nml_error .EQ. 0 ) then    
           CALL wrf_debug(0, "-- Are global, print_detail_airep, print_detail_timing still in your "// &
                              TRIM(nml_name)//" namelist?")
           CALL wrf_debug(0, "-- Remove global, print_detail_airep, print_detail_timing "// &
                             "from wrfvar1 namelist as they are obsolete.")
        ENDIF


     else if ( TRIM(nml_name) .eq. "wrfvar2" ) then

        READ   ( UNIT = nml_read_unit , NML = wrfvar2 , iostat=nml_error )

        IF ( nml_error .EQ. 0 ) then    
           CALL wrf_debug(0, "-- Are write_qcw, write_qrn, write_qci, write_qsn, write_qgr, "// &
                             "write_filtered_obs still in your "// &
                              TRIM(nml_name)//" namelist?")
           CALL wrf_debug(0, "-- Remove write_qcw, write_qrn, write_qci, write_qsn, write_qgr, "// &
                             "write_filtered_obs as they are obsolete.")
        ENDIF


     else if ( TRIM(nml_name) .eq. "wrfvar4" ) then

        READ   ( UNIT = nml_read_unit , NML = wrfvar4 , iostat=nml_error )

        IF ( nml_error .EQ. 0 ) then    
           CALL wrf_debug(0, "-- Is use_3dvar_phy or use_eos_radobs still in your "// &
                              TRIM(nml_name)//" namelist?")
           CALL wrf_debug(0, "-- Remove use_3dvar_phy, use_eos_radobs as they are obsolete.")
        ENDIF


     else if ( TRIM(nml_name) .eq. "wrfvar14" ) then

     READ   ( UNIT = nml_read_unit , NML = wrfvar14 , iostat=nml_error )

        IF ( nml_error .EQ. 0 ) then    
           CALL wrf_debug(0, "-- Are use_crtm_kmatrix_fast, spccoeff_file, taucoeff_file, "// &
                             "aerosolcoeff_file, cloudcoeff_file, emiscoeff_file still in your "// &
                              TRIM(nml_name)//" namelist?")
           CALL wrf_debug(0, "-- Remove them as they are obsolete.")
        ENDIF


     else
         IF ( &







&      (TRIM(nml_name) .EQ. 'time_control') &
& .OR. (TRIM(nml_name) .EQ. 'pio_control') &
& .OR. (TRIM(nml_name) .EQ. 'dfi_control') &
& .OR. (TRIM(nml_name) .EQ. 'domains') &
& .OR. (TRIM(nml_name) .EQ. 'tc') &
& .OR. (TRIM(nml_name) .EQ. 'physics') &
& .OR. (TRIM(nml_name) .EQ. 'noah_mp') &
& .OR. (TRIM(nml_name) .EQ. 'fdda') &
& .OR. (TRIM(nml_name) .EQ. 'scm') &
& .OR. (TRIM(nml_name) .EQ. 'dynamics') &
& .OR. (TRIM(nml_name) .EQ. 'bdy_control') &
& .OR. (TRIM(nml_name) .EQ. 'grib2') &
& .OR. (TRIM(nml_name) .EQ. 'ideal') &
& .OR. (TRIM(nml_name) .EQ. 'fire') &
& .OR. (TRIM(nml_name) .EQ. 'stoch') &
& .OR. (TRIM(nml_name) .EQ. 'diags') &
& .OR. (TRIM(nml_name) .EQ. 'afwa') &
              ) THEN
            nml_error = 0
         ELSE
            CALL wrf_debug(0, TRIM(nml_name)//" is not a valid namelist name")
         ENDIF
     end if

     IF ( nml_error .NE. 0 ) then    
        return
     ENDIF

   END SUBROUTINE wrf_alt_nml_obsolete

END MODULE module_configure


SUBROUTINE set_scalar_indices_from_config ( idomain , dummy2, dummy1 )
  USE module_driver_constants
  USE module_state_description
  USE module_wrf_error
  USE module_configure, ONLY : model_config_rec
  USE module_scalar_tables
  IMPLICIT NONE
  INTEGER , INTENT(IN)  :: idomain
  INTEGER               :: dummy1
  INTEGER               :: dummy2

































  P_qv = 1 ; F_qv = .FALSE. 
  P_qc = 1 ; F_qc = .FALSE. 
  P_qr = 1 ; F_qr = .FALSE. 
  P_qi = 1 ; F_qi = .FALSE. 
  P_qi2 = 1 ; F_qi2 = .FALSE. 
  P_qi3 = 1 ; F_qi3 = .FALSE. 
  P_qs = 1 ; F_qs = .FALSE. 
  P_qg = 1 ; F_qg = .FALSE. 
  P_qh = 1 ; F_qh = .FALSE. 
  P_qip = 1 ; F_qip = .FALSE. 
  P_qic = 1 ; F_qic = .FALSE. 
  P_qid = 1 ; F_qid = .FALSE. 
  P_dfi_qv = 1 ; F_dfi_qv = .FALSE. 
  P_dfi_qc = 1 ; F_dfi_qc = .FALSE. 
  P_dfi_qr = 1 ; F_dfi_qr = .FALSE. 
  P_dfi_qi = 1 ; F_dfi_qi = .FALSE. 
  P_dfi_qi2 = 1 ; F_dfi_qi2 = .FALSE. 
  P_dfi_qi3 = 1 ; F_dfi_qi3 = .FALSE. 
  P_dfi_qs = 1 ; F_dfi_qs = .FALSE. 
  P_dfi_qg = 1 ; F_dfi_qg = .FALSE. 
  P_dfi_qh = 1 ; F_dfi_qh = .FALSE. 
  P_qndrop = 1 ; F_qndrop = .FALSE. 
  P_qni = 1 ; F_qni = .FALSE. 
  P_qni2 = 1 ; F_qni2 = .FALSE. 
  P_qni3 = 1 ; F_qni3 = .FALSE. 
  P_qt = 1 ; F_qt = .FALSE. 
  P_qns = 1 ; F_qns = .FALSE. 
  P_qnr = 1 ; F_qnr = .FALSE. 
  P_qng = 1 ; F_qng = .FALSE. 
  P_qnh = 1 ; F_qnh = .FALSE. 
  P_qnn = 1 ; F_qnn = .FALSE. 
  P_qnc = 1 ; F_qnc = .FALSE. 
  P_qvolg = 1 ; F_qvolg = .FALSE. 
  P_qvolh = 1 ; F_qvolh = .FALSE. 
  P_qrimef = 1 ; F_qrimef = .FALSE. 
  P_qir = 1 ; F_qir = .FALSE. 
  P_qib = 1 ; F_qib = .FALSE. 
  P_qir2 = 1 ; F_qir2 = .FALSE. 
  P_qib2 = 1 ; F_qib2 = .FALSE. 
  P_qvoli = 1 ; F_qvoli = .FALSE. 
  P_qaoli = 1 ; F_qaoli = .FALSE. 
  P_qvoli2 = 1 ; F_qvoli2 = .FALSE. 
  P_qaoli2 = 1 ; F_qaoli2 = .FALSE. 
  P_qvoli3 = 1 ; F_qvoli3 = .FALSE. 
  P_qaoli3 = 1 ; F_qaoli3 = .FALSE. 
  P_qke_adv = 1 ; F_qke_adv = .FALSE. 
  P_ff1i01 = 1 ; F_ff1i01 = .FALSE. 
  P_ff1i02 = 1 ; F_ff1i02 = .FALSE. 
  P_ff1i03 = 1 ; F_ff1i03 = .FALSE. 
  P_ff1i04 = 1 ; F_ff1i04 = .FALSE. 
  P_ff1i05 = 1 ; F_ff1i05 = .FALSE. 
  P_ff1i06 = 1 ; F_ff1i06 = .FALSE. 
  P_ff1i07 = 1 ; F_ff1i07 = .FALSE. 
  P_ff1i08 = 1 ; F_ff1i08 = .FALSE. 
  P_ff1i09 = 1 ; F_ff1i09 = .FALSE. 
  P_ff1i10 = 1 ; F_ff1i10 = .FALSE. 
  P_ff1i11 = 1 ; F_ff1i11 = .FALSE. 
  P_ff1i12 = 1 ; F_ff1i12 = .FALSE. 
  P_ff1i13 = 1 ; F_ff1i13 = .FALSE. 
  P_ff1i14 = 1 ; F_ff1i14 = .FALSE. 
  P_ff1i15 = 1 ; F_ff1i15 = .FALSE. 
  P_ff1i16 = 1 ; F_ff1i16 = .FALSE. 
  P_ff1i17 = 1 ; F_ff1i17 = .FALSE. 
  P_ff1i18 = 1 ; F_ff1i18 = .FALSE. 
  P_ff1i19 = 1 ; F_ff1i19 = .FALSE. 
  P_ff1i20 = 1 ; F_ff1i20 = .FALSE. 
  P_ff1i21 = 1 ; F_ff1i21 = .FALSE. 
  P_ff1i22 = 1 ; F_ff1i22 = .FALSE. 
  P_ff1i23 = 1 ; F_ff1i23 = .FALSE. 
  P_ff1i24 = 1 ; F_ff1i24 = .FALSE. 
  P_ff1i25 = 1 ; F_ff1i25 = .FALSE. 
  P_ff1i26 = 1 ; F_ff1i26 = .FALSE. 
  P_ff1i27 = 1 ; F_ff1i27 = .FALSE. 
  P_ff1i28 = 1 ; F_ff1i28 = .FALSE. 
  P_ff1i29 = 1 ; F_ff1i29 = .FALSE. 
  P_ff1i30 = 1 ; F_ff1i30 = .FALSE. 
  P_ff1i31 = 1 ; F_ff1i31 = .FALSE. 
  P_ff1i32 = 1 ; F_ff1i32 = .FALSE. 
  P_ff1i33 = 1 ; F_ff1i33 = .FALSE. 
  P_ff5i01 = 1 ; F_ff5i01 = .FALSE. 
  P_ff5i02 = 1 ; F_ff5i02 = .FALSE. 
  P_ff5i03 = 1 ; F_ff5i03 = .FALSE. 
  P_ff5i04 = 1 ; F_ff5i04 = .FALSE. 
  P_ff5i05 = 1 ; F_ff5i05 = .FALSE. 
  P_ff5i06 = 1 ; F_ff5i06 = .FALSE. 
  P_ff5i07 = 1 ; F_ff5i07 = .FALSE. 
  P_ff5i08 = 1 ; F_ff5i08 = .FALSE. 
  P_ff5i09 = 1 ; F_ff5i09 = .FALSE. 
  P_ff5i10 = 1 ; F_ff5i10 = .FALSE. 
  P_ff5i11 = 1 ; F_ff5i11 = .FALSE. 
  P_ff5i12 = 1 ; F_ff5i12 = .FALSE. 
  P_ff5i13 = 1 ; F_ff5i13 = .FALSE. 
  P_ff5i14 = 1 ; F_ff5i14 = .FALSE. 
  P_ff5i15 = 1 ; F_ff5i15 = .FALSE. 
  P_ff5i16 = 1 ; F_ff5i16 = .FALSE. 
  P_ff5i17 = 1 ; F_ff5i17 = .FALSE. 
  P_ff5i18 = 1 ; F_ff5i18 = .FALSE. 
  P_ff5i19 = 1 ; F_ff5i19 = .FALSE. 
  P_ff5i20 = 1 ; F_ff5i20 = .FALSE. 
  P_ff5i21 = 1 ; F_ff5i21 = .FALSE. 
  P_ff5i22 = 1 ; F_ff5i22 = .FALSE. 
  P_ff5i23 = 1 ; F_ff5i23 = .FALSE. 
  P_ff5i24 = 1 ; F_ff5i24 = .FALSE. 
  P_ff5i25 = 1 ; F_ff5i25 = .FALSE. 
  P_ff5i26 = 1 ; F_ff5i26 = .FALSE. 
  P_ff5i27 = 1 ; F_ff5i27 = .FALSE. 
  P_ff5i28 = 1 ; F_ff5i28 = .FALSE. 
  P_ff5i29 = 1 ; F_ff5i29 = .FALSE. 
  P_ff5i30 = 1 ; F_ff5i30 = .FALSE. 
  P_ff5i31 = 1 ; F_ff5i31 = .FALSE. 
  P_ff5i32 = 1 ; F_ff5i32 = .FALSE. 
  P_ff5i33 = 1 ; F_ff5i33 = .FALSE. 
  P_ff6i01 = 1 ; F_ff6i01 = .FALSE. 
  P_ff6i02 = 1 ; F_ff6i02 = .FALSE. 
  P_ff6i03 = 1 ; F_ff6i03 = .FALSE. 
  P_ff6i04 = 1 ; F_ff6i04 = .FALSE. 
  P_ff6i05 = 1 ; F_ff6i05 = .FALSE. 
  P_ff6i06 = 1 ; F_ff6i06 = .FALSE. 
  P_ff6i07 = 1 ; F_ff6i07 = .FALSE. 
  P_ff6i08 = 1 ; F_ff6i08 = .FALSE. 
  P_ff6i09 = 1 ; F_ff6i09 = .FALSE. 
  P_ff6i10 = 1 ; F_ff6i10 = .FALSE. 
  P_ff6i11 = 1 ; F_ff6i11 = .FALSE. 
  P_ff6i12 = 1 ; F_ff6i12 = .FALSE. 
  P_ff6i13 = 1 ; F_ff6i13 = .FALSE. 
  P_ff6i14 = 1 ; F_ff6i14 = .FALSE. 
  P_ff6i15 = 1 ; F_ff6i15 = .FALSE. 
  P_ff6i16 = 1 ; F_ff6i16 = .FALSE. 
  P_ff6i17 = 1 ; F_ff6i17 = .FALSE. 
  P_ff6i18 = 1 ; F_ff6i18 = .FALSE. 
  P_ff6i19 = 1 ; F_ff6i19 = .FALSE. 
  P_ff6i20 = 1 ; F_ff6i20 = .FALSE. 
  P_ff6i21 = 1 ; F_ff6i21 = .FALSE. 
  P_ff6i22 = 1 ; F_ff6i22 = .FALSE. 
  P_ff6i23 = 1 ; F_ff6i23 = .FALSE. 
  P_ff6i24 = 1 ; F_ff6i24 = .FALSE. 
  P_ff6i25 = 1 ; F_ff6i25 = .FALSE. 
  P_ff6i26 = 1 ; F_ff6i26 = .FALSE. 
  P_ff6i27 = 1 ; F_ff6i27 = .FALSE. 
  P_ff6i28 = 1 ; F_ff6i28 = .FALSE. 
  P_ff6i29 = 1 ; F_ff6i29 = .FALSE. 
  P_ff6i30 = 1 ; F_ff6i30 = .FALSE. 
  P_ff6i31 = 1 ; F_ff6i31 = .FALSE. 
  P_ff6i32 = 1 ; F_ff6i32 = .FALSE. 
  P_ff6i33 = 1 ; F_ff6i33 = .FALSE. 
  P_ff8i01 = 1 ; F_ff8i01 = .FALSE. 
  P_ff8i02 = 1 ; F_ff8i02 = .FALSE. 
  P_ff8i03 = 1 ; F_ff8i03 = .FALSE. 
  P_ff8i04 = 1 ; F_ff8i04 = .FALSE. 
  P_ff8i05 = 1 ; F_ff8i05 = .FALSE. 
  P_ff8i06 = 1 ; F_ff8i06 = .FALSE. 
  P_ff8i07 = 1 ; F_ff8i07 = .FALSE. 
  P_ff8i08 = 1 ; F_ff8i08 = .FALSE. 
  P_ff8i09 = 1 ; F_ff8i09 = .FALSE. 
  P_ff8i10 = 1 ; F_ff8i10 = .FALSE. 
  P_ff8i11 = 1 ; F_ff8i11 = .FALSE. 
  P_ff8i12 = 1 ; F_ff8i12 = .FALSE. 
  P_ff8i13 = 1 ; F_ff8i13 = .FALSE. 
  P_ff8i14 = 1 ; F_ff8i14 = .FALSE. 
  P_ff8i15 = 1 ; F_ff8i15 = .FALSE. 
  P_ff8i16 = 1 ; F_ff8i16 = .FALSE. 
  P_ff8i17 = 1 ; F_ff8i17 = .FALSE. 
  P_ff8i18 = 1 ; F_ff8i18 = .FALSE. 
  P_ff8i19 = 1 ; F_ff8i19 = .FALSE. 
  P_ff8i20 = 1 ; F_ff8i20 = .FALSE. 
  P_ff8i21 = 1 ; F_ff8i21 = .FALSE. 
  P_ff8i22 = 1 ; F_ff8i22 = .FALSE. 
  P_ff8i23 = 1 ; F_ff8i23 = .FALSE. 
  P_ff8i24 = 1 ; F_ff8i24 = .FALSE. 
  P_ff8i25 = 1 ; F_ff8i25 = .FALSE. 
  P_ff8i26 = 1 ; F_ff8i26 = .FALSE. 
  P_ff8i27 = 1 ; F_ff8i27 = .FALSE. 
  P_ff8i28 = 1 ; F_ff8i28 = .FALSE. 
  P_ff8i29 = 1 ; F_ff8i29 = .FALSE. 
  P_ff8i30 = 1 ; F_ff8i30 = .FALSE. 
  P_ff8i31 = 1 ; F_ff8i31 = .FALSE. 
  P_ff8i32 = 1 ; F_ff8i32 = .FALSE. 
  P_ff8i33 = 1 ; F_ff8i33 = .FALSE. 
  P_ff2i01 = 1 ; F_ff2i01 = .FALSE. 
  P_ff2i02 = 1 ; F_ff2i02 = .FALSE. 
  P_ff2i03 = 1 ; F_ff2i03 = .FALSE. 
  P_ff2i04 = 1 ; F_ff2i04 = .FALSE. 
  P_ff2i05 = 1 ; F_ff2i05 = .FALSE. 
  P_ff2i06 = 1 ; F_ff2i06 = .FALSE. 
  P_ff2i07 = 1 ; F_ff2i07 = .FALSE. 
  P_ff2i08 = 1 ; F_ff2i08 = .FALSE. 
  P_ff2i09 = 1 ; F_ff2i09 = .FALSE. 
  P_ff2i10 = 1 ; F_ff2i10 = .FALSE. 
  P_ff2i11 = 1 ; F_ff2i11 = .FALSE. 
  P_ff2i12 = 1 ; F_ff2i12 = .FALSE. 
  P_ff2i13 = 1 ; F_ff2i13 = .FALSE. 
  P_ff2i14 = 1 ; F_ff2i14 = .FALSE. 
  P_ff2i15 = 1 ; F_ff2i15 = .FALSE. 
  P_ff2i16 = 1 ; F_ff2i16 = .FALSE. 
  P_ff2i17 = 1 ; F_ff2i17 = .FALSE. 
  P_ff2i18 = 1 ; F_ff2i18 = .FALSE. 
  P_ff2i19 = 1 ; F_ff2i19 = .FALSE. 
  P_ff2i20 = 1 ; F_ff2i20 = .FALSE. 
  P_ff2i21 = 1 ; F_ff2i21 = .FALSE. 
  P_ff2i22 = 1 ; F_ff2i22 = .FALSE. 
  P_ff2i23 = 1 ; F_ff2i23 = .FALSE. 
  P_ff2i24 = 1 ; F_ff2i24 = .FALSE. 
  P_ff2i25 = 1 ; F_ff2i25 = .FALSE. 
  P_ff2i26 = 1 ; F_ff2i26 = .FALSE. 
  P_ff2i27 = 1 ; F_ff2i27 = .FALSE. 
  P_ff2i28 = 1 ; F_ff2i28 = .FALSE. 
  P_ff2i29 = 1 ; F_ff2i29 = .FALSE. 
  P_ff2i30 = 1 ; F_ff2i30 = .FALSE. 
  P_ff2i31 = 1 ; F_ff2i31 = .FALSE. 
  P_ff2i32 = 1 ; F_ff2i32 = .FALSE. 
  P_ff2i33 = 1 ; F_ff2i33 = .FALSE. 
  P_ff3i01 = 1 ; F_ff3i01 = .FALSE. 
  P_ff3i02 = 1 ; F_ff3i02 = .FALSE. 
  P_ff3i03 = 1 ; F_ff3i03 = .FALSE. 
  P_ff3i04 = 1 ; F_ff3i04 = .FALSE. 
  P_ff3i05 = 1 ; F_ff3i05 = .FALSE. 
  P_ff3i06 = 1 ; F_ff3i06 = .FALSE. 
  P_ff3i07 = 1 ; F_ff3i07 = .FALSE. 
  P_ff3i08 = 1 ; F_ff3i08 = .FALSE. 
  P_ff3i09 = 1 ; F_ff3i09 = .FALSE. 
  P_ff3i10 = 1 ; F_ff3i10 = .FALSE. 
  P_ff3i11 = 1 ; F_ff3i11 = .FALSE. 
  P_ff3i12 = 1 ; F_ff3i12 = .FALSE. 
  P_ff3i13 = 1 ; F_ff3i13 = .FALSE. 
  P_ff3i14 = 1 ; F_ff3i14 = .FALSE. 
  P_ff3i15 = 1 ; F_ff3i15 = .FALSE. 
  P_ff3i16 = 1 ; F_ff3i16 = .FALSE. 
  P_ff3i17 = 1 ; F_ff3i17 = .FALSE. 
  P_ff3i18 = 1 ; F_ff3i18 = .FALSE. 
  P_ff3i19 = 1 ; F_ff3i19 = .FALSE. 
  P_ff3i20 = 1 ; F_ff3i20 = .FALSE. 
  P_ff3i21 = 1 ; F_ff3i21 = .FALSE. 
  P_ff3i22 = 1 ; F_ff3i22 = .FALSE. 
  P_ff3i23 = 1 ; F_ff3i23 = .FALSE. 
  P_ff3i24 = 1 ; F_ff3i24 = .FALSE. 
  P_ff3i25 = 1 ; F_ff3i25 = .FALSE. 
  P_ff3i26 = 1 ; F_ff3i26 = .FALSE. 
  P_ff3i27 = 1 ; F_ff3i27 = .FALSE. 
  P_ff3i28 = 1 ; F_ff3i28 = .FALSE. 
  P_ff3i29 = 1 ; F_ff3i29 = .FALSE. 
  P_ff3i30 = 1 ; F_ff3i30 = .FALSE. 
  P_ff3i31 = 1 ; F_ff3i31 = .FALSE. 
  P_ff3i32 = 1 ; F_ff3i32 = .FALSE. 
  P_ff3i33 = 1 ; F_ff3i33 = .FALSE. 
  P_ff4i01 = 1 ; F_ff4i01 = .FALSE. 
  P_ff4i02 = 1 ; F_ff4i02 = .FALSE. 
  P_ff4i03 = 1 ; F_ff4i03 = .FALSE. 
  P_ff4i04 = 1 ; F_ff4i04 = .FALSE. 
  P_ff4i05 = 1 ; F_ff4i05 = .FALSE. 
  P_ff4i06 = 1 ; F_ff4i06 = .FALSE. 
  P_ff4i07 = 1 ; F_ff4i07 = .FALSE. 
  P_ff4i08 = 1 ; F_ff4i08 = .FALSE. 
  P_ff4i09 = 1 ; F_ff4i09 = .FALSE. 
  P_ff4i10 = 1 ; F_ff4i10 = .FALSE. 
  P_ff4i11 = 1 ; F_ff4i11 = .FALSE. 
  P_ff4i12 = 1 ; F_ff4i12 = .FALSE. 
  P_ff4i13 = 1 ; F_ff4i13 = .FALSE. 
  P_ff4i14 = 1 ; F_ff4i14 = .FALSE. 
  P_ff4i15 = 1 ; F_ff4i15 = .FALSE. 
  P_ff4i16 = 1 ; F_ff4i16 = .FALSE. 
  P_ff4i17 = 1 ; F_ff4i17 = .FALSE. 
  P_ff4i18 = 1 ; F_ff4i18 = .FALSE. 
  P_ff4i19 = 1 ; F_ff4i19 = .FALSE. 
  P_ff4i20 = 1 ; F_ff4i20 = .FALSE. 
  P_ff4i21 = 1 ; F_ff4i21 = .FALSE. 
  P_ff4i22 = 1 ; F_ff4i22 = .FALSE. 
  P_ff4i23 = 1 ; F_ff4i23 = .FALSE. 
  P_ff4i24 = 1 ; F_ff4i24 = .FALSE. 
  P_ff4i25 = 1 ; F_ff4i25 = .FALSE. 
  P_ff4i26 = 1 ; F_ff4i26 = .FALSE. 
  P_ff4i27 = 1 ; F_ff4i27 = .FALSE. 
  P_ff4i28 = 1 ; F_ff4i28 = .FALSE. 
  P_ff4i29 = 1 ; F_ff4i29 = .FALSE. 
  P_ff4i30 = 1 ; F_ff4i30 = .FALSE. 
  P_ff4i31 = 1 ; F_ff4i31 = .FALSE. 
  P_ff4i32 = 1 ; F_ff4i32 = .FALSE. 
  P_ff4i33 = 1 ; F_ff4i33 = .FALSE. 
  P_ff7i01 = 1 ; F_ff7i01 = .FALSE. 
  P_ff7i02 = 1 ; F_ff7i02 = .FALSE. 
  P_ff7i03 = 1 ; F_ff7i03 = .FALSE. 
  P_ff7i04 = 1 ; F_ff7i04 = .FALSE. 
  P_ff7i05 = 1 ; F_ff7i05 = .FALSE. 
  P_ff7i06 = 1 ; F_ff7i06 = .FALSE. 
  P_ff7i07 = 1 ; F_ff7i07 = .FALSE. 
  P_ff7i08 = 1 ; F_ff7i08 = .FALSE. 
  P_ff7i09 = 1 ; F_ff7i09 = .FALSE. 
  P_ff7i10 = 1 ; F_ff7i10 = .FALSE. 
  P_ff7i11 = 1 ; F_ff7i11 = .FALSE. 
  P_ff7i12 = 1 ; F_ff7i12 = .FALSE. 
  P_ff7i13 = 1 ; F_ff7i13 = .FALSE. 
  P_ff7i14 = 1 ; F_ff7i14 = .FALSE. 
  P_ff7i15 = 1 ; F_ff7i15 = .FALSE. 
  P_ff7i16 = 1 ; F_ff7i16 = .FALSE. 
  P_ff7i17 = 1 ; F_ff7i17 = .FALSE. 
  P_ff7i18 = 1 ; F_ff7i18 = .FALSE. 
  P_ff7i19 = 1 ; F_ff7i19 = .FALSE. 
  P_ff7i20 = 1 ; F_ff7i20 = .FALSE. 
  P_ff7i21 = 1 ; F_ff7i21 = .FALSE. 
  P_ff7i22 = 1 ; F_ff7i22 = .FALSE. 
  P_ff7i23 = 1 ; F_ff7i23 = .FALSE. 
  P_ff7i24 = 1 ; F_ff7i24 = .FALSE. 
  P_ff7i25 = 1 ; F_ff7i25 = .FALSE. 
  P_ff7i26 = 1 ; F_ff7i26 = .FALSE. 
  P_ff7i27 = 1 ; F_ff7i27 = .FALSE. 
  P_ff7i28 = 1 ; F_ff7i28 = .FALSE. 
  P_ff7i29 = 1 ; F_ff7i29 = .FALSE. 
  P_ff7i30 = 1 ; F_ff7i30 = .FALSE. 
  P_ff7i31 = 1 ; F_ff7i31 = .FALSE. 
  P_ff7i32 = 1 ; F_ff7i32 = .FALSE. 
  P_ff7i33 = 1 ; F_ff7i33 = .FALSE. 
  P_qnip = 1 ; F_qnip = .FALSE. 
  P_qnic = 1 ; F_qnic = .FALSE. 
  P_qnid = 1 ; F_qnid = .FALSE. 
  P_effr = 1 ; F_effr = .FALSE. 
  P_ice_effr = 1 ; F_ice_effr = .FALSE. 
  P_tot_effr = 1 ; F_tot_effr = .FALSE. 
  P_qic_effr = 1 ; F_qic_effr = .FALSE. 
  P_qip_effr = 1 ; F_qip_effr = .FALSE. 
  P_qid_effr = 1 ; F_qid_effr = .FALSE. 
  P_scr = 1 ; F_scr = .FALSE. 
  P_scw = 1 ; F_scw = .FALSE. 
  P_sci = 1 ; F_sci = .FALSE. 
  P_scs = 1 ; F_scs = .FALSE. 
  P_sch = 1 ; F_sch = .FALSE. 
  P_schl = 1 ; F_schl = .FALSE. 
  P_sciona = 1 ; F_sciona = .FALSE. 
  P_clnox = 1 ; F_clnox = .FALSE. 
  P_qnwfa = 1 ; F_qnwfa = .FALSE. 
  P_qnifa = 1 ; F_qnifa = .FALSE. 
  P_dfi_qndrop = 1 ; F_dfi_qndrop = .FALSE. 
  P_dfi_qni = 1 ; F_dfi_qni = .FALSE. 
  P_dfi_qni2 = 1 ; F_dfi_qni2 = .FALSE. 
  P_dfi_qni3 = 1 ; F_dfi_qni3 = .FALSE. 
  P_dfi_qt = 1 ; F_dfi_qt = .FALSE. 
  P_dfi_qns = 1 ; F_dfi_qns = .FALSE. 
  P_dfi_qnr = 1 ; F_dfi_qnr = .FALSE. 
  P_dfi_qng = 1 ; F_dfi_qng = .FALSE. 
  P_dfi_qnh = 1 ; F_dfi_qnh = .FALSE. 
  P_dfi_qnn = 1 ; F_dfi_qnn = .FALSE. 
  P_dfi_qnc = 1 ; F_dfi_qnc = .FALSE. 
  P_dfi_qvolg = 1 ; F_dfi_qvolg = .FALSE. 
  P_dfi_qvolh = 1 ; F_dfi_qvolh = .FALSE. 
  P_dfi_qir = 1 ; F_dfi_qir = .FALSE. 
  P_dfi_qib = 1 ; F_dfi_qib = .FALSE. 
  P_dfi_qir2 = 1 ; F_dfi_qir2 = .FALSE. 
  P_dfi_qib2 = 1 ; F_dfi_qib2 = .FALSE. 
  P_dfi_qvoli = 1 ; F_dfi_qvoli = .FALSE. 
  P_dfi_qaoli = 1 ; F_dfi_qaoli = .FALSE. 
  P_dfi_qvoli2 = 1 ; F_dfi_qvoli2 = .FALSE. 
  P_dfi_qaoli2 = 1 ; F_dfi_qaoli2 = .FALSE. 
  P_dfi_qvoli3 = 1 ; F_dfi_qvoli3 = .FALSE. 
  P_dfi_qaoli3 = 1 ; F_dfi_qaoli3 = .FALSE. 
  P_dfi_qke_adv = 1 ; F_dfi_qke_adv = .FALSE. 
  P_dfi_qnwfa = 1 ; F_dfi_qnwfa = .FALSE. 
  P_dfi_qnifa = 1 ; F_dfi_qnifa = .FALSE. 
  P_ocarbon = 1 ; F_ocarbon = .FALSE. 
  P_seasalt = 1 ; F_seasalt = .FALSE. 
  P_dust = 1 ; F_dust = .FALSE. 
  P_bcarbon = 1 ; F_bcarbon = .FALSE. 
  P_sulfate = 1 ; F_sulfate = .FALSE. 
  P_upperaer = 1 ; F_upperaer = .FALSE. 
  P_cu_dust1 = 1 ; F_cu_dust1 = .FALSE. 
  P_cu_dust2 = 1 ; F_cu_dust2 = .FALSE. 
  P_cu_dust3 = 1 ; F_cu_dust3 = .FALSE. 
  P_cu_dust4 = 1 ; F_cu_dust4 = .FALSE. 
  P_cu_seasalt = 1 ; F_cu_seasalt = .FALSE. 
  P_cu_sulfate = 1 ; F_cu_sulfate = .FALSE. 
  P_cu_phobcar = 1 ; F_cu_phobcar = .FALSE. 
  P_cu_phibcar = 1 ; F_cu_phibcar = .FALSE. 
  P_cu_phoocar = 1 ; F_cu_phoocar = .FALSE. 
  P_cu_phiocar = 1 ; F_cu_phiocar = .FALSE. 
  P_mth01 = 1 ; F_mth01 = .FALSE. 
  P_mth02 = 1 ; F_mth02 = .FALSE. 
  P_mth03 = 1 ; F_mth03 = .FALSE. 
  P_mth04 = 1 ; F_mth04 = .FALSE. 
  P_mth05 = 1 ; F_mth05 = .FALSE. 
  P_mth06 = 1 ; F_mth06 = .FALSE. 
  P_mth07 = 1 ; F_mth07 = .FALSE. 
  P_mth08 = 1 ; F_mth08 = .FALSE. 
  P_mth09 = 1 ; F_mth09 = .FALSE. 
  P_mth10 = 1 ; F_mth10 = .FALSE. 
  P_mth11 = 1 ; F_mth11 = .FALSE. 
  P_mth12 = 1 ; F_mth12 = .FALSE. 
  P_sul = 1 ; F_sul = .FALSE. 
  P_sslt = 1 ; F_sslt = .FALSE. 
  P_dust1 = 1 ; F_dust1 = .FALSE. 
  P_dust2 = 1 ; F_dust2 = .FALSE. 
  P_dust3 = 1 ; F_dust3 = .FALSE. 
  P_dust4 = 1 ; F_dust4 = .FALSE. 
  P_ocpho = 1 ; F_ocpho = .FALSE. 
  P_bcpho = 1 ; F_bcpho = .FALSE. 
  P_ocphi = 1 ; F_ocphi = .FALSE. 
  P_bcphi = 1 ; F_bcphi = .FALSE. 
  P_bg = 1 ; F_bg = .FALSE. 
  P_volc = 1 ; F_volc = .FALSE. 
  P_u_ndg_new = 1 ; F_u_ndg_new = .FALSE. 
  P_v_ndg_new = 1 ; F_v_ndg_new = .FALSE. 
  P_t_ndg_new = 1 ; F_t_ndg_new = .FALSE. 
  P_q_ndg_new = 1 ; F_q_ndg_new = .FALSE. 
  P_ph_ndg_new = 1 ; F_ph_ndg_new = .FALSE. 
  P_u_ndg_old = 1 ; F_u_ndg_old = .FALSE. 
  P_v_ndg_old = 1 ; F_v_ndg_old = .FALSE. 
  P_t_ndg_old = 1 ; F_t_ndg_old = .FALSE. 
  P_q_ndg_old = 1 ; F_q_ndg_old = .FALSE. 
  P_ph_ndg_old = 1 ; F_ph_ndg_old = .FALSE. 
  P_mu_ndg_new = 1 ; F_mu_ndg_new = .FALSE. 
  P_mu_ndg_old = 1 ; F_mu_ndg_old = .FALSE. 
  P_advh_qv = 1 ; F_advh_qv = .FALSE. 
  P_advz_qv = 1 ; F_advz_qv = .FALSE. 
  P_fire_smoke = 1 ; F_fire_smoke = .FALSE. 
  P_tr17_1 = 1 ; F_tr17_1 = .FALSE. 
  P_tr17_2 = 1 ; F_tr17_2 = .FALSE. 
  P_tr17_3 = 1 ; F_tr17_3 = .FALSE. 
  P_tr17_4 = 1 ; F_tr17_4 = .FALSE. 
  P_tr17_5 = 1 ; F_tr17_5 = .FALSE. 
  P_tr17_6 = 1 ; F_tr17_6 = .FALSE. 
  P_tr17_7 = 1 ; F_tr17_7 = .FALSE. 
  P_tr17_8 = 1 ; F_tr17_8 = .FALSE. 
  P_m11 = 1 ; F_m11 = .FALSE. 
  P_m22 = 1 ; F_m22 = .FALSE. 
  P_m33 = 1 ; F_m33 = .FALSE. 
  P_m12 = 1 ; F_m12 = .FALSE. 
  P_m13 = 1 ; F_m13 = .FALSE. 
  P_m23 = 1 ; F_m23 = .FALSE. 
  P_r12 = 1 ; F_r12 = .FALSE. 
  P_r13 = 1 ; F_r13 = .FALSE. 
  P_r23 = 1 ; F_r23 = .FALSE. 
  P_smnsmn = 1 ; F_smnsmn = .FALSE. 
  IF (model_config_rec%mp_physics(idomain)==0)THEN
   IF ( moist_index_table( PARAM_qv , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qv = moist_num_table(idomain)
     moist_index_table( PARAM_qv , idomain ) = P_qv
   ELSE
     P_qv = moist_index_table( PARAM_qv , idomain )
   END IF
   moist_boundary_table( idomain, P_qv ) = .TRUE.
   moist_dname_table( idomain, P_qv ) = 'QVAPOR'
   moist_desc_table( idomain, P_qv ) = 'Water vapor mixing ratio'
   moist_units_table( idomain, P_qv ) = 'kg kg-1'
   moist_streams_table( idomain, P_qv )%stream(1) = 33554435 
   moist_streams_table( idomain, P_qv )%stream(2) = 2097152 
   F_qv = .TRUE.
  END IF
  IF (model_config_rec%mp_physics(idomain)==1)THEN
   IF ( moist_index_table( PARAM_qv , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qv = moist_num_table(idomain)
     moist_index_table( PARAM_qv , idomain ) = P_qv
   ELSE
     P_qv = moist_index_table( PARAM_qv , idomain )
   END IF
   moist_boundary_table( idomain, P_qv ) = .TRUE.
   moist_dname_table( idomain, P_qv ) = 'QVAPOR'
   moist_desc_table( idomain, P_qv ) = 'Water vapor mixing ratio'
   moist_units_table( idomain, P_qv ) = 'kg kg-1'
   moist_streams_table( idomain, P_qv )%stream(1) = 33554435 
   moist_streams_table( idomain, P_qv )%stream(2) = 2097152 
   F_qv = .TRUE.
   IF ( moist_index_table( PARAM_qc , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qc = moist_num_table(idomain)
     moist_index_table( PARAM_qc , idomain ) = P_qc
   ELSE
     P_qc = moist_index_table( PARAM_qc , idomain )
   END IF
   moist_boundary_table( idomain, P_qc ) = .TRUE.
   moist_dname_table( idomain, P_qc ) = 'QCLOUD'
   moist_desc_table( idomain, P_qc ) = 'Cloud water mixing ratio'
   moist_units_table( idomain, P_qc ) = 'kg kg-1'
   moist_streams_table( idomain, P_qc )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qc )%stream(2) = 2097152 
   F_qc = .TRUE.
   IF ( moist_index_table( PARAM_qr , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qr = moist_num_table(idomain)
     moist_index_table( PARAM_qr , idomain ) = P_qr
   ELSE
     P_qr = moist_index_table( PARAM_qr , idomain )
   END IF
   moist_boundary_table( idomain, P_qr ) = .TRUE.
   moist_dname_table( idomain, P_qr ) = 'QRAIN'
   moist_desc_table( idomain, P_qr ) = 'Rain water mixing ratio'
   moist_units_table( idomain, P_qr ) = 'kg kg-1'
   moist_streams_table( idomain, P_qr )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qr )%stream(2) = 2097152 
   F_qr = .TRUE.
  END IF
  IF (model_config_rec%mp_physics(idomain)==2)THEN
   IF ( moist_index_table( PARAM_qv , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qv = moist_num_table(idomain)
     moist_index_table( PARAM_qv , idomain ) = P_qv
   ELSE
     P_qv = moist_index_table( PARAM_qv , idomain )
   END IF
   moist_boundary_table( idomain, P_qv ) = .TRUE.
   moist_dname_table( idomain, P_qv ) = 'QVAPOR'
   moist_desc_table( idomain, P_qv ) = 'Water vapor mixing ratio'
   moist_units_table( idomain, P_qv ) = 'kg kg-1'
   moist_streams_table( idomain, P_qv )%stream(1) = 33554435 
   moist_streams_table( idomain, P_qv )%stream(2) = 2097152 
   F_qv = .TRUE.
   IF ( moist_index_table( PARAM_qc , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qc = moist_num_table(idomain)
     moist_index_table( PARAM_qc , idomain ) = P_qc
   ELSE
     P_qc = moist_index_table( PARAM_qc , idomain )
   END IF
   moist_boundary_table( idomain, P_qc ) = .TRUE.
   moist_dname_table( idomain, P_qc ) = 'QCLOUD'
   moist_desc_table( idomain, P_qc ) = 'Cloud water mixing ratio'
   moist_units_table( idomain, P_qc ) = 'kg kg-1'
   moist_streams_table( idomain, P_qc )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qc )%stream(2) = 2097152 
   F_qc = .TRUE.
   IF ( moist_index_table( PARAM_qr , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qr = moist_num_table(idomain)
     moist_index_table( PARAM_qr , idomain ) = P_qr
   ELSE
     P_qr = moist_index_table( PARAM_qr , idomain )
   END IF
   moist_boundary_table( idomain, P_qr ) = .TRUE.
   moist_dname_table( idomain, P_qr ) = 'QRAIN'
   moist_desc_table( idomain, P_qr ) = 'Rain water mixing ratio'
   moist_units_table( idomain, P_qr ) = 'kg kg-1'
   moist_streams_table( idomain, P_qr )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qr )%stream(2) = 2097152 
   F_qr = .TRUE.
   IF ( moist_index_table( PARAM_qi , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qi = moist_num_table(idomain)
     moist_index_table( PARAM_qi , idomain ) = P_qi
   ELSE
     P_qi = moist_index_table( PARAM_qi , idomain )
   END IF
   moist_boundary_table( idomain, P_qi ) = .TRUE.
   moist_dname_table( idomain, P_qi ) = 'QICE'
   moist_desc_table( idomain, P_qi ) = 'Ice mixing ratio'
   moist_units_table( idomain, P_qi ) = 'kg kg-1'
   moist_streams_table( idomain, P_qi )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qi )%stream(2) = 2097152 
   F_qi = .TRUE.
   IF ( moist_index_table( PARAM_qs , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qs = moist_num_table(idomain)
     moist_index_table( PARAM_qs , idomain ) = P_qs
   ELSE
     P_qs = moist_index_table( PARAM_qs , idomain )
   END IF
   moist_boundary_table( idomain, P_qs ) = .TRUE.
   moist_dname_table( idomain, P_qs ) = 'QSNOW'
   moist_desc_table( idomain, P_qs ) = 'Snow mixing ratio'
   moist_units_table( idomain, P_qs ) = 'kg kg-1'
   moist_streams_table( idomain, P_qs )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qs )%stream(2) = 2097152 
   F_qs = .TRUE.
   IF ( moist_index_table( PARAM_qg , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qg = moist_num_table(idomain)
     moist_index_table( PARAM_qg , idomain ) = P_qg
   ELSE
     P_qg = moist_index_table( PARAM_qg , idomain )
   END IF
   moist_boundary_table( idomain, P_qg ) = .TRUE.
   moist_dname_table( idomain, P_qg ) = 'QGRAUP'
   moist_desc_table( idomain, P_qg ) = 'Graupel mixing ratio'
   moist_units_table( idomain, P_qg ) = 'kg kg-1'
   moist_streams_table( idomain, P_qg )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qg )%stream(2) = 2097152 
   F_qg = .TRUE.
  END IF
  IF (model_config_rec%mp_physics(idomain)==3)THEN
   IF ( moist_index_table( PARAM_qv , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qv = moist_num_table(idomain)
     moist_index_table( PARAM_qv , idomain ) = P_qv
   ELSE
     P_qv = moist_index_table( PARAM_qv , idomain )
   END IF
   moist_boundary_table( idomain, P_qv ) = .TRUE.
   moist_dname_table( idomain, P_qv ) = 'QVAPOR'
   moist_desc_table( idomain, P_qv ) = 'Water vapor mixing ratio'
   moist_units_table( idomain, P_qv ) = 'kg kg-1'
   moist_streams_table( idomain, P_qv )%stream(1) = 33554435 
   moist_streams_table( idomain, P_qv )%stream(2) = 2097152 
   F_qv = .TRUE.
   IF ( moist_index_table( PARAM_qc , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qc = moist_num_table(idomain)
     moist_index_table( PARAM_qc , idomain ) = P_qc
   ELSE
     P_qc = moist_index_table( PARAM_qc , idomain )
   END IF
   moist_boundary_table( idomain, P_qc ) = .TRUE.
   moist_dname_table( idomain, P_qc ) = 'QCLOUD'
   moist_desc_table( idomain, P_qc ) = 'Cloud water mixing ratio'
   moist_units_table( idomain, P_qc ) = 'kg kg-1'
   moist_streams_table( idomain, P_qc )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qc )%stream(2) = 2097152 
   F_qc = .TRUE.
   IF ( moist_index_table( PARAM_qr , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qr = moist_num_table(idomain)
     moist_index_table( PARAM_qr , idomain ) = P_qr
   ELSE
     P_qr = moist_index_table( PARAM_qr , idomain )
   END IF
   moist_boundary_table( idomain, P_qr ) = .TRUE.
   moist_dname_table( idomain, P_qr ) = 'QRAIN'
   moist_desc_table( idomain, P_qr ) = 'Rain water mixing ratio'
   moist_units_table( idomain, P_qr ) = 'kg kg-1'
   moist_streams_table( idomain, P_qr )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qr )%stream(2) = 2097152 
   F_qr = .TRUE.
  END IF
  IF (model_config_rec%mp_physics(idomain)==4)THEN
   IF ( moist_index_table( PARAM_qv , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qv = moist_num_table(idomain)
     moist_index_table( PARAM_qv , idomain ) = P_qv
   ELSE
     P_qv = moist_index_table( PARAM_qv , idomain )
   END IF
   moist_boundary_table( idomain, P_qv ) = .TRUE.
   moist_dname_table( idomain, P_qv ) = 'QVAPOR'
   moist_desc_table( idomain, P_qv ) = 'Water vapor mixing ratio'
   moist_units_table( idomain, P_qv ) = 'kg kg-1'
   moist_streams_table( idomain, P_qv )%stream(1) = 33554435 
   moist_streams_table( idomain, P_qv )%stream(2) = 2097152 
   F_qv = .TRUE.
   IF ( moist_index_table( PARAM_qc , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qc = moist_num_table(idomain)
     moist_index_table( PARAM_qc , idomain ) = P_qc
   ELSE
     P_qc = moist_index_table( PARAM_qc , idomain )
   END IF
   moist_boundary_table( idomain, P_qc ) = .TRUE.
   moist_dname_table( idomain, P_qc ) = 'QCLOUD'
   moist_desc_table( idomain, P_qc ) = 'Cloud water mixing ratio'
   moist_units_table( idomain, P_qc ) = 'kg kg-1'
   moist_streams_table( idomain, P_qc )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qc )%stream(2) = 2097152 
   F_qc = .TRUE.
   IF ( moist_index_table( PARAM_qr , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qr = moist_num_table(idomain)
     moist_index_table( PARAM_qr , idomain ) = P_qr
   ELSE
     P_qr = moist_index_table( PARAM_qr , idomain )
   END IF
   moist_boundary_table( idomain, P_qr ) = .TRUE.
   moist_dname_table( idomain, P_qr ) = 'QRAIN'
   moist_desc_table( idomain, P_qr ) = 'Rain water mixing ratio'
   moist_units_table( idomain, P_qr ) = 'kg kg-1'
   moist_streams_table( idomain, P_qr )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qr )%stream(2) = 2097152 
   F_qr = .TRUE.
   IF ( moist_index_table( PARAM_qi , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qi = moist_num_table(idomain)
     moist_index_table( PARAM_qi , idomain ) = P_qi
   ELSE
     P_qi = moist_index_table( PARAM_qi , idomain )
   END IF
   moist_boundary_table( idomain, P_qi ) = .TRUE.
   moist_dname_table( idomain, P_qi ) = 'QICE'
   moist_desc_table( idomain, P_qi ) = 'Ice mixing ratio'
   moist_units_table( idomain, P_qi ) = 'kg kg-1'
   moist_streams_table( idomain, P_qi )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qi )%stream(2) = 2097152 
   F_qi = .TRUE.
   IF ( moist_index_table( PARAM_qs , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qs = moist_num_table(idomain)
     moist_index_table( PARAM_qs , idomain ) = P_qs
   ELSE
     P_qs = moist_index_table( PARAM_qs , idomain )
   END IF
   moist_boundary_table( idomain, P_qs ) = .TRUE.
   moist_dname_table( idomain, P_qs ) = 'QSNOW'
   moist_desc_table( idomain, P_qs ) = 'Snow mixing ratio'
   moist_units_table( idomain, P_qs ) = 'kg kg-1'
   moist_streams_table( idomain, P_qs )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qs )%stream(2) = 2097152 
   F_qs = .TRUE.
  END IF
  IF (model_config_rec%mp_physics(idomain)==5)THEN
   IF ( moist_index_table( PARAM_qv , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qv = moist_num_table(idomain)
     moist_index_table( PARAM_qv , idomain ) = P_qv
   ELSE
     P_qv = moist_index_table( PARAM_qv , idomain )
   END IF
   moist_boundary_table( idomain, P_qv ) = .TRUE.
   moist_dname_table( idomain, P_qv ) = 'QVAPOR'
   moist_desc_table( idomain, P_qv ) = 'Water vapor mixing ratio'
   moist_units_table( idomain, P_qv ) = 'kg kg-1'
   moist_streams_table( idomain, P_qv )%stream(1) = 33554435 
   moist_streams_table( idomain, P_qv )%stream(2) = 2097152 
   F_qv = .TRUE.
   IF ( moist_index_table( PARAM_qc , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qc = moist_num_table(idomain)
     moist_index_table( PARAM_qc , idomain ) = P_qc
   ELSE
     P_qc = moist_index_table( PARAM_qc , idomain )
   END IF
   moist_boundary_table( idomain, P_qc ) = .TRUE.
   moist_dname_table( idomain, P_qc ) = 'QCLOUD'
   moist_desc_table( idomain, P_qc ) = 'Cloud water mixing ratio'
   moist_units_table( idomain, P_qc ) = 'kg kg-1'
   moist_streams_table( idomain, P_qc )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qc )%stream(2) = 2097152 
   F_qc = .TRUE.
   IF ( moist_index_table( PARAM_qr , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qr = moist_num_table(idomain)
     moist_index_table( PARAM_qr , idomain ) = P_qr
   ELSE
     P_qr = moist_index_table( PARAM_qr , idomain )
   END IF
   moist_boundary_table( idomain, P_qr ) = .TRUE.
   moist_dname_table( idomain, P_qr ) = 'QRAIN'
   moist_desc_table( idomain, P_qr ) = 'Rain water mixing ratio'
   moist_units_table( idomain, P_qr ) = 'kg kg-1'
   moist_streams_table( idomain, P_qr )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qr )%stream(2) = 2097152 
   F_qr = .TRUE.
   IF ( moist_index_table( PARAM_qi , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qi = moist_num_table(idomain)
     moist_index_table( PARAM_qi , idomain ) = P_qi
   ELSE
     P_qi = moist_index_table( PARAM_qi , idomain )
   END IF
   moist_boundary_table( idomain, P_qi ) = .TRUE.
   moist_dname_table( idomain, P_qi ) = 'QICE'
   moist_desc_table( idomain, P_qi ) = 'Ice mixing ratio'
   moist_units_table( idomain, P_qi ) = 'kg kg-1'
   moist_streams_table( idomain, P_qi )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qi )%stream(2) = 2097152 
   F_qi = .TRUE.
   IF ( scalar_index_table( PARAM_qt , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qt = scalar_num_table(idomain)
     scalar_index_table( PARAM_qt , idomain ) = P_qt
   ELSE
     P_qt = scalar_index_table( PARAM_qt , idomain )
   END IF
   scalar_boundary_table( idomain, P_qt ) = .TRUE.
   scalar_dname_table( idomain, P_qt ) = 'CWM'
   scalar_desc_table( idomain, P_qt ) = 'Total condensate mixing ratio'
   scalar_units_table( idomain, P_qt ) = 'kg kg-1'
   scalar_streams_table( idomain, P_qt )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qt )%stream(2) = 2097152 
   F_qt = .TRUE.
  END IF
  IF (model_config_rec%mp_physics(idomain)==15)THEN
   IF ( moist_index_table( PARAM_qv , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qv = moist_num_table(idomain)
     moist_index_table( PARAM_qv , idomain ) = P_qv
   ELSE
     P_qv = moist_index_table( PARAM_qv , idomain )
   END IF
   moist_boundary_table( idomain, P_qv ) = .TRUE.
   moist_dname_table( idomain, P_qv ) = 'QVAPOR'
   moist_desc_table( idomain, P_qv ) = 'Water vapor mixing ratio'
   moist_units_table( idomain, P_qv ) = 'kg kg-1'
   moist_streams_table( idomain, P_qv )%stream(1) = 33554435 
   moist_streams_table( idomain, P_qv )%stream(2) = 2097152 
   F_qv = .TRUE.
   IF ( moist_index_table( PARAM_qc , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qc = moist_num_table(idomain)
     moist_index_table( PARAM_qc , idomain ) = P_qc
   ELSE
     P_qc = moist_index_table( PARAM_qc , idomain )
   END IF
   moist_boundary_table( idomain, P_qc ) = .TRUE.
   moist_dname_table( idomain, P_qc ) = 'QCLOUD'
   moist_desc_table( idomain, P_qc ) = 'Cloud water mixing ratio'
   moist_units_table( idomain, P_qc ) = 'kg kg-1'
   moist_streams_table( idomain, P_qc )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qc )%stream(2) = 2097152 
   F_qc = .TRUE.
   IF ( moist_index_table( PARAM_qr , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qr = moist_num_table(idomain)
     moist_index_table( PARAM_qr , idomain ) = P_qr
   ELSE
     P_qr = moist_index_table( PARAM_qr , idomain )
   END IF
   moist_boundary_table( idomain, P_qr ) = .TRUE.
   moist_dname_table( idomain, P_qr ) = 'QRAIN'
   moist_desc_table( idomain, P_qr ) = 'Rain water mixing ratio'
   moist_units_table( idomain, P_qr ) = 'kg kg-1'
   moist_streams_table( idomain, P_qr )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qr )%stream(2) = 2097152 
   F_qr = .TRUE.
   IF ( moist_index_table( PARAM_qi , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qi = moist_num_table(idomain)
     moist_index_table( PARAM_qi , idomain ) = P_qi
   ELSE
     P_qi = moist_index_table( PARAM_qi , idomain )
   END IF
   moist_boundary_table( idomain, P_qi ) = .TRUE.
   moist_dname_table( idomain, P_qi ) = 'QICE'
   moist_desc_table( idomain, P_qi ) = 'Ice mixing ratio'
   moist_units_table( idomain, P_qi ) = 'kg kg-1'
   moist_streams_table( idomain, P_qi )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qi )%stream(2) = 2097152 
   F_qi = .TRUE.
   IF ( scalar_index_table( PARAM_qrimef , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qrimef = scalar_num_table(idomain)
     scalar_index_table( PARAM_qrimef , idomain ) = P_qrimef
   ELSE
     P_qrimef = scalar_index_table( PARAM_qrimef , idomain )
   END IF
   scalar_boundary_table( idomain, P_qrimef ) = .TRUE.
   scalar_dname_table( idomain, P_qrimef ) = 'QRIMEF'
   scalar_desc_table( idomain, P_qrimef ) = 'rime factor * qi'
   scalar_units_table( idomain, P_qrimef ) = 'kg kg-1'
   scalar_streams_table( idomain, P_qrimef )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qrimef )%stream(2) = 2097152 
   F_qrimef = .TRUE.
  END IF
  IF (model_config_rec%mp_physics(idomain)==6)THEN
   IF ( moist_index_table( PARAM_qv , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qv = moist_num_table(idomain)
     moist_index_table( PARAM_qv , idomain ) = P_qv
   ELSE
     P_qv = moist_index_table( PARAM_qv , idomain )
   END IF
   moist_boundary_table( idomain, P_qv ) = .TRUE.
   moist_dname_table( idomain, P_qv ) = 'QVAPOR'
   moist_desc_table( idomain, P_qv ) = 'Water vapor mixing ratio'
   moist_units_table( idomain, P_qv ) = 'kg kg-1'
   moist_streams_table( idomain, P_qv )%stream(1) = 33554435 
   moist_streams_table( idomain, P_qv )%stream(2) = 2097152 
   F_qv = .TRUE.
   IF ( moist_index_table( PARAM_qc , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qc = moist_num_table(idomain)
     moist_index_table( PARAM_qc , idomain ) = P_qc
   ELSE
     P_qc = moist_index_table( PARAM_qc , idomain )
   END IF
   moist_boundary_table( idomain, P_qc ) = .TRUE.
   moist_dname_table( idomain, P_qc ) = 'QCLOUD'
   moist_desc_table( idomain, P_qc ) = 'Cloud water mixing ratio'
   moist_units_table( idomain, P_qc ) = 'kg kg-1'
   moist_streams_table( idomain, P_qc )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qc )%stream(2) = 2097152 
   F_qc = .TRUE.
   IF ( moist_index_table( PARAM_qr , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qr = moist_num_table(idomain)
     moist_index_table( PARAM_qr , idomain ) = P_qr
   ELSE
     P_qr = moist_index_table( PARAM_qr , idomain )
   END IF
   moist_boundary_table( idomain, P_qr ) = .TRUE.
   moist_dname_table( idomain, P_qr ) = 'QRAIN'
   moist_desc_table( idomain, P_qr ) = 'Rain water mixing ratio'
   moist_units_table( idomain, P_qr ) = 'kg kg-1'
   moist_streams_table( idomain, P_qr )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qr )%stream(2) = 2097152 
   F_qr = .TRUE.
   IF ( moist_index_table( PARAM_qi , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qi = moist_num_table(idomain)
     moist_index_table( PARAM_qi , idomain ) = P_qi
   ELSE
     P_qi = moist_index_table( PARAM_qi , idomain )
   END IF
   moist_boundary_table( idomain, P_qi ) = .TRUE.
   moist_dname_table( idomain, P_qi ) = 'QICE'
   moist_desc_table( idomain, P_qi ) = 'Ice mixing ratio'
   moist_units_table( idomain, P_qi ) = 'kg kg-1'
   moist_streams_table( idomain, P_qi )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qi )%stream(2) = 2097152 
   F_qi = .TRUE.
   IF ( moist_index_table( PARAM_qs , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qs = moist_num_table(idomain)
     moist_index_table( PARAM_qs , idomain ) = P_qs
   ELSE
     P_qs = moist_index_table( PARAM_qs , idomain )
   END IF
   moist_boundary_table( idomain, P_qs ) = .TRUE.
   moist_dname_table( idomain, P_qs ) = 'QSNOW'
   moist_desc_table( idomain, P_qs ) = 'Snow mixing ratio'
   moist_units_table( idomain, P_qs ) = 'kg kg-1'
   moist_streams_table( idomain, P_qs )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qs )%stream(2) = 2097152 
   F_qs = .TRUE.
   IF ( moist_index_table( PARAM_qg , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qg = moist_num_table(idomain)
     moist_index_table( PARAM_qg , idomain ) = P_qg
   ELSE
     P_qg = moist_index_table( PARAM_qg , idomain )
   END IF
   moist_boundary_table( idomain, P_qg ) = .TRUE.
   moist_dname_table( idomain, P_qg ) = 'QGRAUP'
   moist_desc_table( idomain, P_qg ) = 'Graupel mixing ratio'
   moist_units_table( idomain, P_qg ) = 'kg kg-1'
   moist_streams_table( idomain, P_qg )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qg )%stream(2) = 2097152 
   F_qg = .TRUE.
  END IF
  IF (model_config_rec%mp_physics(idomain)==7)THEN
   IF ( moist_index_table( PARAM_qv , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qv = moist_num_table(idomain)
     moist_index_table( PARAM_qv , idomain ) = P_qv
   ELSE
     P_qv = moist_index_table( PARAM_qv , idomain )
   END IF
   moist_boundary_table( idomain, P_qv ) = .TRUE.
   moist_dname_table( idomain, P_qv ) = 'QVAPOR'
   moist_desc_table( idomain, P_qv ) = 'Water vapor mixing ratio'
   moist_units_table( idomain, P_qv ) = 'kg kg-1'
   moist_streams_table( idomain, P_qv )%stream(1) = 33554435 
   moist_streams_table( idomain, P_qv )%stream(2) = 2097152 
   F_qv = .TRUE.
   IF ( moist_index_table( PARAM_qc , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qc = moist_num_table(idomain)
     moist_index_table( PARAM_qc , idomain ) = P_qc
   ELSE
     P_qc = moist_index_table( PARAM_qc , idomain )
   END IF
   moist_boundary_table( idomain, P_qc ) = .TRUE.
   moist_dname_table( idomain, P_qc ) = 'QCLOUD'
   moist_desc_table( idomain, P_qc ) = 'Cloud water mixing ratio'
   moist_units_table( idomain, P_qc ) = 'kg kg-1'
   moist_streams_table( idomain, P_qc )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qc )%stream(2) = 2097152 
   F_qc = .TRUE.
   IF ( moist_index_table( PARAM_qr , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qr = moist_num_table(idomain)
     moist_index_table( PARAM_qr , idomain ) = P_qr
   ELSE
     P_qr = moist_index_table( PARAM_qr , idomain )
   END IF
   moist_boundary_table( idomain, P_qr ) = .TRUE.
   moist_dname_table( idomain, P_qr ) = 'QRAIN'
   moist_desc_table( idomain, P_qr ) = 'Rain water mixing ratio'
   moist_units_table( idomain, P_qr ) = 'kg kg-1'
   moist_streams_table( idomain, P_qr )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qr )%stream(2) = 2097152 
   F_qr = .TRUE.
   IF ( moist_index_table( PARAM_qi , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qi = moist_num_table(idomain)
     moist_index_table( PARAM_qi , idomain ) = P_qi
   ELSE
     P_qi = moist_index_table( PARAM_qi , idomain )
   END IF
   moist_boundary_table( idomain, P_qi ) = .TRUE.
   moist_dname_table( idomain, P_qi ) = 'QICE'
   moist_desc_table( idomain, P_qi ) = 'Ice mixing ratio'
   moist_units_table( idomain, P_qi ) = 'kg kg-1'
   moist_streams_table( idomain, P_qi )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qi )%stream(2) = 2097152 
   F_qi = .TRUE.
   IF ( moist_index_table( PARAM_qs , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qs = moist_num_table(idomain)
     moist_index_table( PARAM_qs , idomain ) = P_qs
   ELSE
     P_qs = moist_index_table( PARAM_qs , idomain )
   END IF
   moist_boundary_table( idomain, P_qs ) = .TRUE.
   moist_dname_table( idomain, P_qs ) = 'QSNOW'
   moist_desc_table( idomain, P_qs ) = 'Snow mixing ratio'
   moist_units_table( idomain, P_qs ) = 'kg kg-1'
   moist_streams_table( idomain, P_qs )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qs )%stream(2) = 2097152 
   F_qs = .TRUE.
   IF ( moist_index_table( PARAM_qg , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qg = moist_num_table(idomain)
     moist_index_table( PARAM_qg , idomain ) = P_qg
   ELSE
     P_qg = moist_index_table( PARAM_qg , idomain )
   END IF
   moist_boundary_table( idomain, P_qg ) = .TRUE.
   moist_dname_table( idomain, P_qg ) = 'QGRAUP'
   moist_desc_table( idomain, P_qg ) = 'Graupel mixing ratio'
   moist_units_table( idomain, P_qg ) = 'kg kg-1'
   moist_streams_table( idomain, P_qg )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qg )%stream(2) = 2097152 
   F_qg = .TRUE.
   IF ( moist_index_table( PARAM_qh , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qh = moist_num_table(idomain)
     moist_index_table( PARAM_qh , idomain ) = P_qh
   ELSE
     P_qh = moist_index_table( PARAM_qh , idomain )
   END IF
   moist_boundary_table( idomain, P_qh ) = .TRUE.
   moist_dname_table( idomain, P_qh ) = 'QHAIL'
   moist_desc_table( idomain, P_qh ) = 'Hail mixing ratio'
   moist_units_table( idomain, P_qh ) = 'kg kg-1'
   moist_streams_table( idomain, P_qh )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qh )%stream(2) = 2097152 
   F_qh = .TRUE.
  END IF
  IF (model_config_rec%mp_physics(idomain)==8)THEN
   IF ( moist_index_table( PARAM_qv , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qv = moist_num_table(idomain)
     moist_index_table( PARAM_qv , idomain ) = P_qv
   ELSE
     P_qv = moist_index_table( PARAM_qv , idomain )
   END IF
   moist_boundary_table( idomain, P_qv ) = .TRUE.
   moist_dname_table( idomain, P_qv ) = 'QVAPOR'
   moist_desc_table( idomain, P_qv ) = 'Water vapor mixing ratio'
   moist_units_table( idomain, P_qv ) = 'kg kg-1'
   moist_streams_table( idomain, P_qv )%stream(1) = 33554435 
   moist_streams_table( idomain, P_qv )%stream(2) = 2097152 
   F_qv = .TRUE.
   IF ( moist_index_table( PARAM_qc , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qc = moist_num_table(idomain)
     moist_index_table( PARAM_qc , idomain ) = P_qc
   ELSE
     P_qc = moist_index_table( PARAM_qc , idomain )
   END IF
   moist_boundary_table( idomain, P_qc ) = .TRUE.
   moist_dname_table( idomain, P_qc ) = 'QCLOUD'
   moist_desc_table( idomain, P_qc ) = 'Cloud water mixing ratio'
   moist_units_table( idomain, P_qc ) = 'kg kg-1'
   moist_streams_table( idomain, P_qc )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qc )%stream(2) = 2097152 
   F_qc = .TRUE.
   IF ( moist_index_table( PARAM_qr , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qr = moist_num_table(idomain)
     moist_index_table( PARAM_qr , idomain ) = P_qr
   ELSE
     P_qr = moist_index_table( PARAM_qr , idomain )
   END IF
   moist_boundary_table( idomain, P_qr ) = .TRUE.
   moist_dname_table( idomain, P_qr ) = 'QRAIN'
   moist_desc_table( idomain, P_qr ) = 'Rain water mixing ratio'
   moist_units_table( idomain, P_qr ) = 'kg kg-1'
   moist_streams_table( idomain, P_qr )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qr )%stream(2) = 2097152 
   F_qr = .TRUE.
   IF ( moist_index_table( PARAM_qi , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qi = moist_num_table(idomain)
     moist_index_table( PARAM_qi , idomain ) = P_qi
   ELSE
     P_qi = moist_index_table( PARAM_qi , idomain )
   END IF
   moist_boundary_table( idomain, P_qi ) = .TRUE.
   moist_dname_table( idomain, P_qi ) = 'QICE'
   moist_desc_table( idomain, P_qi ) = 'Ice mixing ratio'
   moist_units_table( idomain, P_qi ) = 'kg kg-1'
   moist_streams_table( idomain, P_qi )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qi )%stream(2) = 2097152 
   F_qi = .TRUE.
   IF ( moist_index_table( PARAM_qs , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qs = moist_num_table(idomain)
     moist_index_table( PARAM_qs , idomain ) = P_qs
   ELSE
     P_qs = moist_index_table( PARAM_qs , idomain )
   END IF
   moist_boundary_table( idomain, P_qs ) = .TRUE.
   moist_dname_table( idomain, P_qs ) = 'QSNOW'
   moist_desc_table( idomain, P_qs ) = 'Snow mixing ratio'
   moist_units_table( idomain, P_qs ) = 'kg kg-1'
   moist_streams_table( idomain, P_qs )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qs )%stream(2) = 2097152 
   F_qs = .TRUE.
   IF ( moist_index_table( PARAM_qg , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qg = moist_num_table(idomain)
     moist_index_table( PARAM_qg , idomain ) = P_qg
   ELSE
     P_qg = moist_index_table( PARAM_qg , idomain )
   END IF
   moist_boundary_table( idomain, P_qg ) = .TRUE.
   moist_dname_table( idomain, P_qg ) = 'QGRAUP'
   moist_desc_table( idomain, P_qg ) = 'Graupel mixing ratio'
   moist_units_table( idomain, P_qg ) = 'kg kg-1'
   moist_streams_table( idomain, P_qg )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qg )%stream(2) = 2097152 
   F_qg = .TRUE.
   IF ( scalar_index_table( PARAM_qni , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qni = scalar_num_table(idomain)
     scalar_index_table( PARAM_qni , idomain ) = P_qni
   ELSE
     P_qni = scalar_index_table( PARAM_qni , idomain )
   END IF
   scalar_boundary_table( idomain, P_qni ) = .TRUE.
   scalar_dname_table( idomain, P_qni ) = 'QNICE'
   scalar_desc_table( idomain, P_qni ) = 'Ice Number concentration'
   scalar_units_table( idomain, P_qni ) = '  kg-1'
   scalar_streams_table( idomain, P_qni )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qni )%stream(2) = 2097152 
   F_qni = .TRUE.
   IF ( scalar_index_table( PARAM_qnr , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qnr = scalar_num_table(idomain)
     scalar_index_table( PARAM_qnr , idomain ) = P_qnr
   ELSE
     P_qnr = scalar_index_table( PARAM_qnr , idomain )
   END IF
   scalar_boundary_table( idomain, P_qnr ) = .TRUE.
   scalar_dname_table( idomain, P_qnr ) = 'QNRAIN'
   scalar_desc_table( idomain, P_qnr ) = 'Rain Number concentration'
   scalar_units_table( idomain, P_qnr ) = '  kg(-1)'
   scalar_streams_table( idomain, P_qnr )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qnr )%stream(2) = 2097152 
   F_qnr = .TRUE.
  END IF
  IF (model_config_rec%mp_physics(idomain)==9)THEN
   IF ( moist_index_table( PARAM_qv , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qv = moist_num_table(idomain)
     moist_index_table( PARAM_qv , idomain ) = P_qv
   ELSE
     P_qv = moist_index_table( PARAM_qv , idomain )
   END IF
   moist_boundary_table( idomain, P_qv ) = .TRUE.
   moist_dname_table( idomain, P_qv ) = 'QVAPOR'
   moist_desc_table( idomain, P_qv ) = 'Water vapor mixing ratio'
   moist_units_table( idomain, P_qv ) = 'kg kg-1'
   moist_streams_table( idomain, P_qv )%stream(1) = 33554435 
   moist_streams_table( idomain, P_qv )%stream(2) = 2097152 
   F_qv = .TRUE.
   IF ( moist_index_table( PARAM_qc , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qc = moist_num_table(idomain)
     moist_index_table( PARAM_qc , idomain ) = P_qc
   ELSE
     P_qc = moist_index_table( PARAM_qc , idomain )
   END IF
   moist_boundary_table( idomain, P_qc ) = .TRUE.
   moist_dname_table( idomain, P_qc ) = 'QCLOUD'
   moist_desc_table( idomain, P_qc ) = 'Cloud water mixing ratio'
   moist_units_table( idomain, P_qc ) = 'kg kg-1'
   moist_streams_table( idomain, P_qc )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qc )%stream(2) = 2097152 
   F_qc = .TRUE.
   IF ( moist_index_table( PARAM_qr , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qr = moist_num_table(idomain)
     moist_index_table( PARAM_qr , idomain ) = P_qr
   ELSE
     P_qr = moist_index_table( PARAM_qr , idomain )
   END IF
   moist_boundary_table( idomain, P_qr ) = .TRUE.
   moist_dname_table( idomain, P_qr ) = 'QRAIN'
   moist_desc_table( idomain, P_qr ) = 'Rain water mixing ratio'
   moist_units_table( idomain, P_qr ) = 'kg kg-1'
   moist_streams_table( idomain, P_qr )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qr )%stream(2) = 2097152 
   F_qr = .TRUE.
   IF ( moist_index_table( PARAM_qi , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qi = moist_num_table(idomain)
     moist_index_table( PARAM_qi , idomain ) = P_qi
   ELSE
     P_qi = moist_index_table( PARAM_qi , idomain )
   END IF
   moist_boundary_table( idomain, P_qi ) = .TRUE.
   moist_dname_table( idomain, P_qi ) = 'QICE'
   moist_desc_table( idomain, P_qi ) = 'Ice mixing ratio'
   moist_units_table( idomain, P_qi ) = 'kg kg-1'
   moist_streams_table( idomain, P_qi )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qi )%stream(2) = 2097152 
   F_qi = .TRUE.
   IF ( moist_index_table( PARAM_qs , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qs = moist_num_table(idomain)
     moist_index_table( PARAM_qs , idomain ) = P_qs
   ELSE
     P_qs = moist_index_table( PARAM_qs , idomain )
   END IF
   moist_boundary_table( idomain, P_qs ) = .TRUE.
   moist_dname_table( idomain, P_qs ) = 'QSNOW'
   moist_desc_table( idomain, P_qs ) = 'Snow mixing ratio'
   moist_units_table( idomain, P_qs ) = 'kg kg-1'
   moist_streams_table( idomain, P_qs )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qs )%stream(2) = 2097152 
   F_qs = .TRUE.
   IF ( moist_index_table( PARAM_qg , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qg = moist_num_table(idomain)
     moist_index_table( PARAM_qg , idomain ) = P_qg
   ELSE
     P_qg = moist_index_table( PARAM_qg , idomain )
   END IF
   moist_boundary_table( idomain, P_qg ) = .TRUE.
   moist_dname_table( idomain, P_qg ) = 'QGRAUP'
   moist_desc_table( idomain, P_qg ) = 'Graupel mixing ratio'
   moist_units_table( idomain, P_qg ) = 'kg kg-1'
   moist_streams_table( idomain, P_qg )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qg )%stream(2) = 2097152 
   F_qg = .TRUE.
   IF ( moist_index_table( PARAM_qh , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qh = moist_num_table(idomain)
     moist_index_table( PARAM_qh , idomain ) = P_qh
   ELSE
     P_qh = moist_index_table( PARAM_qh , idomain )
   END IF
   moist_boundary_table( idomain, P_qh ) = .TRUE.
   moist_dname_table( idomain, P_qh ) = 'QHAIL'
   moist_desc_table( idomain, P_qh ) = 'Hail mixing ratio'
   moist_units_table( idomain, P_qh ) = 'kg kg-1'
   moist_streams_table( idomain, P_qh )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qh )%stream(2) = 2097152 
   F_qh = .TRUE.
   IF ( scalar_index_table( PARAM_qnc , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qnc = scalar_num_table(idomain)
     scalar_index_table( PARAM_qnc , idomain ) = P_qnc
   ELSE
     P_qnc = scalar_index_table( PARAM_qnc , idomain )
   END IF
   scalar_boundary_table( idomain, P_qnc ) = .TRUE.
   scalar_dname_table( idomain, P_qnc ) = 'QNCLOUD'
   scalar_desc_table( idomain, P_qnc ) = 'cloud water Number concentration'
   scalar_units_table( idomain, P_qnc ) = '  kg(-1)'
   scalar_streams_table( idomain, P_qnc )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qnc )%stream(2) = 2097152 
   F_qnc = .TRUE.
   IF ( scalar_index_table( PARAM_qnr , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qnr = scalar_num_table(idomain)
     scalar_index_table( PARAM_qnr , idomain ) = P_qnr
   ELSE
     P_qnr = scalar_index_table( PARAM_qnr , idomain )
   END IF
   scalar_boundary_table( idomain, P_qnr ) = .TRUE.
   scalar_dname_table( idomain, P_qnr ) = 'QNRAIN'
   scalar_desc_table( idomain, P_qnr ) = 'Rain Number concentration'
   scalar_units_table( idomain, P_qnr ) = '  kg(-1)'
   scalar_streams_table( idomain, P_qnr )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qnr )%stream(2) = 2097152 
   F_qnr = .TRUE.
   IF ( scalar_index_table( PARAM_qni , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qni = scalar_num_table(idomain)
     scalar_index_table( PARAM_qni , idomain ) = P_qni
   ELSE
     P_qni = scalar_index_table( PARAM_qni , idomain )
   END IF
   scalar_boundary_table( idomain, P_qni ) = .TRUE.
   scalar_dname_table( idomain, P_qni ) = 'QNICE'
   scalar_desc_table( idomain, P_qni ) = 'Ice Number concentration'
   scalar_units_table( idomain, P_qni ) = '  kg-1'
   scalar_streams_table( idomain, P_qni )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qni )%stream(2) = 2097152 
   F_qni = .TRUE.
   IF ( scalar_index_table( PARAM_qns , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qns = scalar_num_table(idomain)
     scalar_index_table( PARAM_qns , idomain ) = P_qns
   ELSE
     P_qns = scalar_index_table( PARAM_qns , idomain )
   END IF
   scalar_boundary_table( idomain, P_qns ) = .TRUE.
   scalar_dname_table( idomain, P_qns ) = 'QNSNOW'
   scalar_desc_table( idomain, P_qns ) = 'Snow Number concentration'
   scalar_units_table( idomain, P_qns ) = '  kg(-1)'
   scalar_streams_table( idomain, P_qns )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qns )%stream(2) = 2097152 
   F_qns = .TRUE.
   IF ( scalar_index_table( PARAM_qng , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qng = scalar_num_table(idomain)
     scalar_index_table( PARAM_qng , idomain ) = P_qng
   ELSE
     P_qng = scalar_index_table( PARAM_qng , idomain )
   END IF
   scalar_boundary_table( idomain, P_qng ) = .TRUE.
   scalar_dname_table( idomain, P_qng ) = 'QNGRAUPEL'
   scalar_desc_table( idomain, P_qng ) = 'Graupel Number concentration'
   scalar_units_table( idomain, P_qng ) = '  kg(-1)'
   scalar_streams_table( idomain, P_qng )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qng )%stream(2) = 2097152 
   F_qng = .TRUE.
   IF ( scalar_index_table( PARAM_qnh , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qnh = scalar_num_table(idomain)
     scalar_index_table( PARAM_qnh , idomain ) = P_qnh
   ELSE
     P_qnh = scalar_index_table( PARAM_qnh , idomain )
   END IF
   scalar_boundary_table( idomain, P_qnh ) = .TRUE.
   scalar_dname_table( idomain, P_qnh ) = 'QNHAIL'
   scalar_desc_table( idomain, P_qnh ) = 'Hail Number concentration'
   scalar_units_table( idomain, P_qnh ) = '  kg(-1)'
   scalar_streams_table( idomain, P_qnh )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qnh )%stream(2) = 2097152 
   F_qnh = .TRUE.
  END IF
  IF (model_config_rec%mp_physics(idomain)==10)THEN
   IF ( moist_index_table( PARAM_qv , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qv = moist_num_table(idomain)
     moist_index_table( PARAM_qv , idomain ) = P_qv
   ELSE
     P_qv = moist_index_table( PARAM_qv , idomain )
   END IF
   moist_boundary_table( idomain, P_qv ) = .TRUE.
   moist_dname_table( idomain, P_qv ) = 'QVAPOR'
   moist_desc_table( idomain, P_qv ) = 'Water vapor mixing ratio'
   moist_units_table( idomain, P_qv ) = 'kg kg-1'
   moist_streams_table( idomain, P_qv )%stream(1) = 33554435 
   moist_streams_table( idomain, P_qv )%stream(2) = 2097152 
   F_qv = .TRUE.
   IF ( moist_index_table( PARAM_qc , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qc = moist_num_table(idomain)
     moist_index_table( PARAM_qc , idomain ) = P_qc
   ELSE
     P_qc = moist_index_table( PARAM_qc , idomain )
   END IF
   moist_boundary_table( idomain, P_qc ) = .TRUE.
   moist_dname_table( idomain, P_qc ) = 'QCLOUD'
   moist_desc_table( idomain, P_qc ) = 'Cloud water mixing ratio'
   moist_units_table( idomain, P_qc ) = 'kg kg-1'
   moist_streams_table( idomain, P_qc )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qc )%stream(2) = 2097152 
   F_qc = .TRUE.
   IF ( moist_index_table( PARAM_qr , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qr = moist_num_table(idomain)
     moist_index_table( PARAM_qr , idomain ) = P_qr
   ELSE
     P_qr = moist_index_table( PARAM_qr , idomain )
   END IF
   moist_boundary_table( idomain, P_qr ) = .TRUE.
   moist_dname_table( idomain, P_qr ) = 'QRAIN'
   moist_desc_table( idomain, P_qr ) = 'Rain water mixing ratio'
   moist_units_table( idomain, P_qr ) = 'kg kg-1'
   moist_streams_table( idomain, P_qr )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qr )%stream(2) = 2097152 
   F_qr = .TRUE.
   IF ( moist_index_table( PARAM_qi , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qi = moist_num_table(idomain)
     moist_index_table( PARAM_qi , idomain ) = P_qi
   ELSE
     P_qi = moist_index_table( PARAM_qi , idomain )
   END IF
   moist_boundary_table( idomain, P_qi ) = .TRUE.
   moist_dname_table( idomain, P_qi ) = 'QICE'
   moist_desc_table( idomain, P_qi ) = 'Ice mixing ratio'
   moist_units_table( idomain, P_qi ) = 'kg kg-1'
   moist_streams_table( idomain, P_qi )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qi )%stream(2) = 2097152 
   F_qi = .TRUE.
   IF ( moist_index_table( PARAM_qs , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qs = moist_num_table(idomain)
     moist_index_table( PARAM_qs , idomain ) = P_qs
   ELSE
     P_qs = moist_index_table( PARAM_qs , idomain )
   END IF
   moist_boundary_table( idomain, P_qs ) = .TRUE.
   moist_dname_table( idomain, P_qs ) = 'QSNOW'
   moist_desc_table( idomain, P_qs ) = 'Snow mixing ratio'
   moist_units_table( idomain, P_qs ) = 'kg kg-1'
   moist_streams_table( idomain, P_qs )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qs )%stream(2) = 2097152 
   F_qs = .TRUE.
   IF ( moist_index_table( PARAM_qg , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qg = moist_num_table(idomain)
     moist_index_table( PARAM_qg , idomain ) = P_qg
   ELSE
     P_qg = moist_index_table( PARAM_qg , idomain )
   END IF
   moist_boundary_table( idomain, P_qg ) = .TRUE.
   moist_dname_table( idomain, P_qg ) = 'QGRAUP'
   moist_desc_table( idomain, P_qg ) = 'Graupel mixing ratio'
   moist_units_table( idomain, P_qg ) = 'kg kg-1'
   moist_streams_table( idomain, P_qg )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qg )%stream(2) = 2097152 
   F_qg = .TRUE.
   IF ( scalar_index_table( PARAM_qni , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qni = scalar_num_table(idomain)
     scalar_index_table( PARAM_qni , idomain ) = P_qni
   ELSE
     P_qni = scalar_index_table( PARAM_qni , idomain )
   END IF
   scalar_boundary_table( idomain, P_qni ) = .TRUE.
   scalar_dname_table( idomain, P_qni ) = 'QNICE'
   scalar_desc_table( idomain, P_qni ) = 'Ice Number concentration'
   scalar_units_table( idomain, P_qni ) = '  kg-1'
   scalar_streams_table( idomain, P_qni )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qni )%stream(2) = 2097152 
   F_qni = .TRUE.
   IF ( scalar_index_table( PARAM_qns , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qns = scalar_num_table(idomain)
     scalar_index_table( PARAM_qns , idomain ) = P_qns
   ELSE
     P_qns = scalar_index_table( PARAM_qns , idomain )
   END IF
   scalar_boundary_table( idomain, P_qns ) = .TRUE.
   scalar_dname_table( idomain, P_qns ) = 'QNSNOW'
   scalar_desc_table( idomain, P_qns ) = 'Snow Number concentration'
   scalar_units_table( idomain, P_qns ) = '  kg(-1)'
   scalar_streams_table( idomain, P_qns )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qns )%stream(2) = 2097152 
   F_qns = .TRUE.
   IF ( scalar_index_table( PARAM_qnr , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qnr = scalar_num_table(idomain)
     scalar_index_table( PARAM_qnr , idomain ) = P_qnr
   ELSE
     P_qnr = scalar_index_table( PARAM_qnr , idomain )
   END IF
   scalar_boundary_table( idomain, P_qnr ) = .TRUE.
   scalar_dname_table( idomain, P_qnr ) = 'QNRAIN'
   scalar_desc_table( idomain, P_qnr ) = 'Rain Number concentration'
   scalar_units_table( idomain, P_qnr ) = '  kg(-1)'
   scalar_streams_table( idomain, P_qnr )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qnr )%stream(2) = 2097152 
   F_qnr = .TRUE.
   IF ( scalar_index_table( PARAM_qng , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qng = scalar_num_table(idomain)
     scalar_index_table( PARAM_qng , idomain ) = P_qng
   ELSE
     P_qng = scalar_index_table( PARAM_qng , idomain )
   END IF
   scalar_boundary_table( idomain, P_qng ) = .TRUE.
   scalar_dname_table( idomain, P_qng ) = 'QNGRAUPEL'
   scalar_desc_table( idomain, P_qng ) = 'Graupel Number concentration'
   scalar_units_table( idomain, P_qng ) = '  kg(-1)'
   scalar_streams_table( idomain, P_qng )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qng )%stream(2) = 2097152 
   F_qng = .TRUE.
  END IF
  IF (model_config_rec%mp_physics(idomain)==11)THEN
   IF ( moist_index_table( PARAM_qv , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qv = moist_num_table(idomain)
     moist_index_table( PARAM_qv , idomain ) = P_qv
   ELSE
     P_qv = moist_index_table( PARAM_qv , idomain )
   END IF
   moist_boundary_table( idomain, P_qv ) = .TRUE.
   moist_dname_table( idomain, P_qv ) = 'QVAPOR'
   moist_desc_table( idomain, P_qv ) = 'Water vapor mixing ratio'
   moist_units_table( idomain, P_qv ) = 'kg kg-1'
   moist_streams_table( idomain, P_qv )%stream(1) = 33554435 
   moist_streams_table( idomain, P_qv )%stream(2) = 2097152 
   F_qv = .TRUE.
   IF ( moist_index_table( PARAM_qc , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qc = moist_num_table(idomain)
     moist_index_table( PARAM_qc , idomain ) = P_qc
   ELSE
     P_qc = moist_index_table( PARAM_qc , idomain )
   END IF
   moist_boundary_table( idomain, P_qc ) = .TRUE.
   moist_dname_table( idomain, P_qc ) = 'QCLOUD'
   moist_desc_table( idomain, P_qc ) = 'Cloud water mixing ratio'
   moist_units_table( idomain, P_qc ) = 'kg kg-1'
   moist_streams_table( idomain, P_qc )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qc )%stream(2) = 2097152 
   F_qc = .TRUE.
   IF ( moist_index_table( PARAM_qi , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qi = moist_num_table(idomain)
     moist_index_table( PARAM_qi , idomain ) = P_qi
   ELSE
     P_qi = moist_index_table( PARAM_qi , idomain )
   END IF
   moist_boundary_table( idomain, P_qi ) = .TRUE.
   moist_dname_table( idomain, P_qi ) = 'QICE'
   moist_desc_table( idomain, P_qi ) = 'Ice mixing ratio'
   moist_units_table( idomain, P_qi ) = 'kg kg-1'
   moist_streams_table( idomain, P_qi )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qi )%stream(2) = 2097152 
   F_qi = .TRUE.
   IF ( moist_index_table( PARAM_qr , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qr = moist_num_table(idomain)
     moist_index_table( PARAM_qr , idomain ) = P_qr
   ELSE
     P_qr = moist_index_table( PARAM_qr , idomain )
   END IF
   moist_boundary_table( idomain, P_qr ) = .TRUE.
   moist_dname_table( idomain, P_qr ) = 'QRAIN'
   moist_desc_table( idomain, P_qr ) = 'Rain water mixing ratio'
   moist_units_table( idomain, P_qr ) = 'kg kg-1'
   moist_streams_table( idomain, P_qr )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qr )%stream(2) = 2097152 
   F_qr = .TRUE.
   IF ( moist_index_table( PARAM_qs , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qs = moist_num_table(idomain)
     moist_index_table( PARAM_qs , idomain ) = P_qs
   ELSE
     P_qs = moist_index_table( PARAM_qs , idomain )
   END IF
   moist_boundary_table( idomain, P_qs ) = .TRUE.
   moist_dname_table( idomain, P_qs ) = 'QSNOW'
   moist_desc_table( idomain, P_qs ) = 'Snow mixing ratio'
   moist_units_table( idomain, P_qs ) = 'kg kg-1'
   moist_streams_table( idomain, P_qs )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qs )%stream(2) = 2097152 
   F_qs = .TRUE.
   IF ( scalar_index_table( PARAM_qnc , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qnc = scalar_num_table(idomain)
     scalar_index_table( PARAM_qnc , idomain ) = P_qnc
   ELSE
     P_qnc = scalar_index_table( PARAM_qnc , idomain )
   END IF
   scalar_boundary_table( idomain, P_qnc ) = .TRUE.
   scalar_dname_table( idomain, P_qnc ) = 'QNCLOUD'
   scalar_desc_table( idomain, P_qnc ) = 'cloud water Number concentration'
   scalar_units_table( idomain, P_qnc ) = '  kg(-1)'
   scalar_streams_table( idomain, P_qnc )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qnc )%stream(2) = 2097152 
   F_qnc = .TRUE.
   IF ( scalar_index_table( PARAM_qni , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qni = scalar_num_table(idomain)
     scalar_index_table( PARAM_qni , idomain ) = P_qni
   ELSE
     P_qni = scalar_index_table( PARAM_qni , idomain )
   END IF
   scalar_boundary_table( idomain, P_qni ) = .TRUE.
   scalar_dname_table( idomain, P_qni ) = 'QNICE'
   scalar_desc_table( idomain, P_qni ) = 'Ice Number concentration'
   scalar_units_table( idomain, P_qni ) = '  kg-1'
   scalar_streams_table( idomain, P_qni )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qni )%stream(2) = 2097152 
   F_qni = .TRUE.
   IF ( scalar_index_table( PARAM_qnr , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qnr = scalar_num_table(idomain)
     scalar_index_table( PARAM_qnr , idomain ) = P_qnr
   ELSE
     P_qnr = scalar_index_table( PARAM_qnr , idomain )
   END IF
   scalar_boundary_table( idomain, P_qnr ) = .TRUE.
   scalar_dname_table( idomain, P_qnr ) = 'QNRAIN'
   scalar_desc_table( idomain, P_qnr ) = 'Rain Number concentration'
   scalar_units_table( idomain, P_qnr ) = '  kg(-1)'
   scalar_streams_table( idomain, P_qnr )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qnr )%stream(2) = 2097152 
   F_qnr = .TRUE.
   IF ( scalar_index_table( PARAM_qns , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qns = scalar_num_table(idomain)
     scalar_index_table( PARAM_qns , idomain ) = P_qns
   ELSE
     P_qns = scalar_index_table( PARAM_qns , idomain )
   END IF
   scalar_boundary_table( idomain, P_qns ) = .TRUE.
   scalar_dname_table( idomain, P_qns ) = 'QNSNOW'
   scalar_desc_table( idomain, P_qns ) = 'Snow Number concentration'
   scalar_units_table( idomain, P_qns ) = '  kg(-1)'
   scalar_streams_table( idomain, P_qns )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qns )%stream(2) = 2097152 
   F_qns = .TRUE.
  END IF
  IF (model_config_rec%mp_physics(idomain)==13)THEN
   IF ( moist_index_table( PARAM_qv , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qv = moist_num_table(idomain)
     moist_index_table( PARAM_qv , idomain ) = P_qv
   ELSE
     P_qv = moist_index_table( PARAM_qv , idomain )
   END IF
   moist_boundary_table( idomain, P_qv ) = .TRUE.
   moist_dname_table( idomain, P_qv ) = 'QVAPOR'
   moist_desc_table( idomain, P_qv ) = 'Water vapor mixing ratio'
   moist_units_table( idomain, P_qv ) = 'kg kg-1'
   moist_streams_table( idomain, P_qv )%stream(1) = 33554435 
   moist_streams_table( idomain, P_qv )%stream(2) = 2097152 
   F_qv = .TRUE.
   IF ( moist_index_table( PARAM_qc , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qc = moist_num_table(idomain)
     moist_index_table( PARAM_qc , idomain ) = P_qc
   ELSE
     P_qc = moist_index_table( PARAM_qc , idomain )
   END IF
   moist_boundary_table( idomain, P_qc ) = .TRUE.
   moist_dname_table( idomain, P_qc ) = 'QCLOUD'
   moist_desc_table( idomain, P_qc ) = 'Cloud water mixing ratio'
   moist_units_table( idomain, P_qc ) = 'kg kg-1'
   moist_streams_table( idomain, P_qc )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qc )%stream(2) = 2097152 
   F_qc = .TRUE.
   IF ( moist_index_table( PARAM_qr , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qr = moist_num_table(idomain)
     moist_index_table( PARAM_qr , idomain ) = P_qr
   ELSE
     P_qr = moist_index_table( PARAM_qr , idomain )
   END IF
   moist_boundary_table( idomain, P_qr ) = .TRUE.
   moist_dname_table( idomain, P_qr ) = 'QRAIN'
   moist_desc_table( idomain, P_qr ) = 'Rain water mixing ratio'
   moist_units_table( idomain, P_qr ) = 'kg kg-1'
   moist_streams_table( idomain, P_qr )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qr )%stream(2) = 2097152 
   F_qr = .TRUE.
   IF ( moist_index_table( PARAM_qi , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qi = moist_num_table(idomain)
     moist_index_table( PARAM_qi , idomain ) = P_qi
   ELSE
     P_qi = moist_index_table( PARAM_qi , idomain )
   END IF
   moist_boundary_table( idomain, P_qi ) = .TRUE.
   moist_dname_table( idomain, P_qi ) = 'QICE'
   moist_desc_table( idomain, P_qi ) = 'Ice mixing ratio'
   moist_units_table( idomain, P_qi ) = 'kg kg-1'
   moist_streams_table( idomain, P_qi )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qi )%stream(2) = 2097152 
   F_qi = .TRUE.
   IF ( moist_index_table( PARAM_qs , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qs = moist_num_table(idomain)
     moist_index_table( PARAM_qs , idomain ) = P_qs
   ELSE
     P_qs = moist_index_table( PARAM_qs , idomain )
   END IF
   moist_boundary_table( idomain, P_qs ) = .TRUE.
   moist_dname_table( idomain, P_qs ) = 'QSNOW'
   moist_desc_table( idomain, P_qs ) = 'Snow mixing ratio'
   moist_units_table( idomain, P_qs ) = 'kg kg-1'
   moist_streams_table( idomain, P_qs )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qs )%stream(2) = 2097152 
   F_qs = .TRUE.
  END IF
  IF (model_config_rec%mp_physics(idomain)==14)THEN
   IF ( moist_index_table( PARAM_qv , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qv = moist_num_table(idomain)
     moist_index_table( PARAM_qv , idomain ) = P_qv
   ELSE
     P_qv = moist_index_table( PARAM_qv , idomain )
   END IF
   moist_boundary_table( idomain, P_qv ) = .TRUE.
   moist_dname_table( idomain, P_qv ) = 'QVAPOR'
   moist_desc_table( idomain, P_qv ) = 'Water vapor mixing ratio'
   moist_units_table( idomain, P_qv ) = 'kg kg-1'
   moist_streams_table( idomain, P_qv )%stream(1) = 33554435 
   moist_streams_table( idomain, P_qv )%stream(2) = 2097152 
   F_qv = .TRUE.
   IF ( moist_index_table( PARAM_qc , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qc = moist_num_table(idomain)
     moist_index_table( PARAM_qc , idomain ) = P_qc
   ELSE
     P_qc = moist_index_table( PARAM_qc , idomain )
   END IF
   moist_boundary_table( idomain, P_qc ) = .TRUE.
   moist_dname_table( idomain, P_qc ) = 'QCLOUD'
   moist_desc_table( idomain, P_qc ) = 'Cloud water mixing ratio'
   moist_units_table( idomain, P_qc ) = 'kg kg-1'
   moist_streams_table( idomain, P_qc )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qc )%stream(2) = 2097152 
   F_qc = .TRUE.
   IF ( moist_index_table( PARAM_qr , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qr = moist_num_table(idomain)
     moist_index_table( PARAM_qr , idomain ) = P_qr
   ELSE
     P_qr = moist_index_table( PARAM_qr , idomain )
   END IF
   moist_boundary_table( idomain, P_qr ) = .TRUE.
   moist_dname_table( idomain, P_qr ) = 'QRAIN'
   moist_desc_table( idomain, P_qr ) = 'Rain water mixing ratio'
   moist_units_table( idomain, P_qr ) = 'kg kg-1'
   moist_streams_table( idomain, P_qr )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qr )%stream(2) = 2097152 
   F_qr = .TRUE.
   IF ( moist_index_table( PARAM_qi , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qi = moist_num_table(idomain)
     moist_index_table( PARAM_qi , idomain ) = P_qi
   ELSE
     P_qi = moist_index_table( PARAM_qi , idomain )
   END IF
   moist_boundary_table( idomain, P_qi ) = .TRUE.
   moist_dname_table( idomain, P_qi ) = 'QICE'
   moist_desc_table( idomain, P_qi ) = 'Ice mixing ratio'
   moist_units_table( idomain, P_qi ) = 'kg kg-1'
   moist_streams_table( idomain, P_qi )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qi )%stream(2) = 2097152 
   F_qi = .TRUE.
   IF ( moist_index_table( PARAM_qs , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qs = moist_num_table(idomain)
     moist_index_table( PARAM_qs , idomain ) = P_qs
   ELSE
     P_qs = moist_index_table( PARAM_qs , idomain )
   END IF
   moist_boundary_table( idomain, P_qs ) = .TRUE.
   moist_dname_table( idomain, P_qs ) = 'QSNOW'
   moist_desc_table( idomain, P_qs ) = 'Snow mixing ratio'
   moist_units_table( idomain, P_qs ) = 'kg kg-1'
   moist_streams_table( idomain, P_qs )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qs )%stream(2) = 2097152 
   F_qs = .TRUE.
   IF ( scalar_index_table( PARAM_qnn , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qnn = scalar_num_table(idomain)
     scalar_index_table( PARAM_qnn , idomain ) = P_qnn
   ELSE
     P_qnn = scalar_index_table( PARAM_qnn , idomain )
   END IF
   scalar_boundary_table( idomain, P_qnn ) = .TRUE.
   scalar_dname_table( idomain, P_qnn ) = 'QNCCN'
   scalar_desc_table( idomain, P_qnn ) = 'CCN Number concentration'
   scalar_units_table( idomain, P_qnn ) = '  kg(-1)'
   scalar_streams_table( idomain, P_qnn )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qnn )%stream(2) = 2097152 
   F_qnn = .TRUE.
   IF ( scalar_index_table( PARAM_qnc , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qnc = scalar_num_table(idomain)
     scalar_index_table( PARAM_qnc , idomain ) = P_qnc
   ELSE
     P_qnc = scalar_index_table( PARAM_qnc , idomain )
   END IF
   scalar_boundary_table( idomain, P_qnc ) = .TRUE.
   scalar_dname_table( idomain, P_qnc ) = 'QNCLOUD'
   scalar_desc_table( idomain, P_qnc ) = 'cloud water Number concentration'
   scalar_units_table( idomain, P_qnc ) = '  kg(-1)'
   scalar_streams_table( idomain, P_qnc )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qnc )%stream(2) = 2097152 
   F_qnc = .TRUE.
   IF ( scalar_index_table( PARAM_qnr , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qnr = scalar_num_table(idomain)
     scalar_index_table( PARAM_qnr , idomain ) = P_qnr
   ELSE
     P_qnr = scalar_index_table( PARAM_qnr , idomain )
   END IF
   scalar_boundary_table( idomain, P_qnr ) = .TRUE.
   scalar_dname_table( idomain, P_qnr ) = 'QNRAIN'
   scalar_desc_table( idomain, P_qnr ) = 'Rain Number concentration'
   scalar_units_table( idomain, P_qnr ) = '  kg(-1)'
   scalar_streams_table( idomain, P_qnr )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qnr )%stream(2) = 2097152 
   F_qnr = .TRUE.
  END IF
  IF (model_config_rec%mp_physics(idomain)==16)THEN
   IF ( moist_index_table( PARAM_qv , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qv = moist_num_table(idomain)
     moist_index_table( PARAM_qv , idomain ) = P_qv
   ELSE
     P_qv = moist_index_table( PARAM_qv , idomain )
   END IF
   moist_boundary_table( idomain, P_qv ) = .TRUE.
   moist_dname_table( idomain, P_qv ) = 'QVAPOR'
   moist_desc_table( idomain, P_qv ) = 'Water vapor mixing ratio'
   moist_units_table( idomain, P_qv ) = 'kg kg-1'
   moist_streams_table( idomain, P_qv )%stream(1) = 33554435 
   moist_streams_table( idomain, P_qv )%stream(2) = 2097152 
   F_qv = .TRUE.
   IF ( moist_index_table( PARAM_qc , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qc = moist_num_table(idomain)
     moist_index_table( PARAM_qc , idomain ) = P_qc
   ELSE
     P_qc = moist_index_table( PARAM_qc , idomain )
   END IF
   moist_boundary_table( idomain, P_qc ) = .TRUE.
   moist_dname_table( idomain, P_qc ) = 'QCLOUD'
   moist_desc_table( idomain, P_qc ) = 'Cloud water mixing ratio'
   moist_units_table( idomain, P_qc ) = 'kg kg-1'
   moist_streams_table( idomain, P_qc )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qc )%stream(2) = 2097152 
   F_qc = .TRUE.
   IF ( moist_index_table( PARAM_qr , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qr = moist_num_table(idomain)
     moist_index_table( PARAM_qr , idomain ) = P_qr
   ELSE
     P_qr = moist_index_table( PARAM_qr , idomain )
   END IF
   moist_boundary_table( idomain, P_qr ) = .TRUE.
   moist_dname_table( idomain, P_qr ) = 'QRAIN'
   moist_desc_table( idomain, P_qr ) = 'Rain water mixing ratio'
   moist_units_table( idomain, P_qr ) = 'kg kg-1'
   moist_streams_table( idomain, P_qr )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qr )%stream(2) = 2097152 
   F_qr = .TRUE.
   IF ( moist_index_table( PARAM_qi , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qi = moist_num_table(idomain)
     moist_index_table( PARAM_qi , idomain ) = P_qi
   ELSE
     P_qi = moist_index_table( PARAM_qi , idomain )
   END IF
   moist_boundary_table( idomain, P_qi ) = .TRUE.
   moist_dname_table( idomain, P_qi ) = 'QICE'
   moist_desc_table( idomain, P_qi ) = 'Ice mixing ratio'
   moist_units_table( idomain, P_qi ) = 'kg kg-1'
   moist_streams_table( idomain, P_qi )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qi )%stream(2) = 2097152 
   F_qi = .TRUE.
   IF ( moist_index_table( PARAM_qs , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qs = moist_num_table(idomain)
     moist_index_table( PARAM_qs , idomain ) = P_qs
   ELSE
     P_qs = moist_index_table( PARAM_qs , idomain )
   END IF
   moist_boundary_table( idomain, P_qs ) = .TRUE.
   moist_dname_table( idomain, P_qs ) = 'QSNOW'
   moist_desc_table( idomain, P_qs ) = 'Snow mixing ratio'
   moist_units_table( idomain, P_qs ) = 'kg kg-1'
   moist_streams_table( idomain, P_qs )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qs )%stream(2) = 2097152 
   F_qs = .TRUE.
   IF ( moist_index_table( PARAM_qg , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qg = moist_num_table(idomain)
     moist_index_table( PARAM_qg , idomain ) = P_qg
   ELSE
     P_qg = moist_index_table( PARAM_qg , idomain )
   END IF
   moist_boundary_table( idomain, P_qg ) = .TRUE.
   moist_dname_table( idomain, P_qg ) = 'QGRAUP'
   moist_desc_table( idomain, P_qg ) = 'Graupel mixing ratio'
   moist_units_table( idomain, P_qg ) = 'kg kg-1'
   moist_streams_table( idomain, P_qg )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qg )%stream(2) = 2097152 
   F_qg = .TRUE.
   IF ( scalar_index_table( PARAM_qnn , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qnn = scalar_num_table(idomain)
     scalar_index_table( PARAM_qnn , idomain ) = P_qnn
   ELSE
     P_qnn = scalar_index_table( PARAM_qnn , idomain )
   END IF
   scalar_boundary_table( idomain, P_qnn ) = .TRUE.
   scalar_dname_table( idomain, P_qnn ) = 'QNCCN'
   scalar_desc_table( idomain, P_qnn ) = 'CCN Number concentration'
   scalar_units_table( idomain, P_qnn ) = '  kg(-1)'
   scalar_streams_table( idomain, P_qnn )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qnn )%stream(2) = 2097152 
   F_qnn = .TRUE.
   IF ( scalar_index_table( PARAM_qnc , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qnc = scalar_num_table(idomain)
     scalar_index_table( PARAM_qnc , idomain ) = P_qnc
   ELSE
     P_qnc = scalar_index_table( PARAM_qnc , idomain )
   END IF
   scalar_boundary_table( idomain, P_qnc ) = .TRUE.
   scalar_dname_table( idomain, P_qnc ) = 'QNCLOUD'
   scalar_desc_table( idomain, P_qnc ) = 'cloud water Number concentration'
   scalar_units_table( idomain, P_qnc ) = '  kg(-1)'
   scalar_streams_table( idomain, P_qnc )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qnc )%stream(2) = 2097152 
   F_qnc = .TRUE.
   IF ( scalar_index_table( PARAM_qnr , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qnr = scalar_num_table(idomain)
     scalar_index_table( PARAM_qnr , idomain ) = P_qnr
   ELSE
     P_qnr = scalar_index_table( PARAM_qnr , idomain )
   END IF
   scalar_boundary_table( idomain, P_qnr ) = .TRUE.
   scalar_dname_table( idomain, P_qnr ) = 'QNRAIN'
   scalar_desc_table( idomain, P_qnr ) = 'Rain Number concentration'
   scalar_units_table( idomain, P_qnr ) = '  kg(-1)'
   scalar_streams_table( idomain, P_qnr )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qnr )%stream(2) = 2097152 
   F_qnr = .TRUE.
  END IF
  IF (model_config_rec%mp_physics(idomain)==17)THEN
   IF ( moist_index_table( PARAM_qv , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qv = moist_num_table(idomain)
     moist_index_table( PARAM_qv , idomain ) = P_qv
   ELSE
     P_qv = moist_index_table( PARAM_qv , idomain )
   END IF
   moist_boundary_table( idomain, P_qv ) = .TRUE.
   moist_dname_table( idomain, P_qv ) = 'QVAPOR'
   moist_desc_table( idomain, P_qv ) = 'Water vapor mixing ratio'
   moist_units_table( idomain, P_qv ) = 'kg kg-1'
   moist_streams_table( idomain, P_qv )%stream(1) = 33554435 
   moist_streams_table( idomain, P_qv )%stream(2) = 2097152 
   F_qv = .TRUE.
   IF ( moist_index_table( PARAM_qc , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qc = moist_num_table(idomain)
     moist_index_table( PARAM_qc , idomain ) = P_qc
   ELSE
     P_qc = moist_index_table( PARAM_qc , idomain )
   END IF
   moist_boundary_table( idomain, P_qc ) = .TRUE.
   moist_dname_table( idomain, P_qc ) = 'QCLOUD'
   moist_desc_table( idomain, P_qc ) = 'Cloud water mixing ratio'
   moist_units_table( idomain, P_qc ) = 'kg kg-1'
   moist_streams_table( idomain, P_qc )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qc )%stream(2) = 2097152 
   F_qc = .TRUE.
   IF ( moist_index_table( PARAM_qr , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qr = moist_num_table(idomain)
     moist_index_table( PARAM_qr , idomain ) = P_qr
   ELSE
     P_qr = moist_index_table( PARAM_qr , idomain )
   END IF
   moist_boundary_table( idomain, P_qr ) = .TRUE.
   moist_dname_table( idomain, P_qr ) = 'QRAIN'
   moist_desc_table( idomain, P_qr ) = 'Rain water mixing ratio'
   moist_units_table( idomain, P_qr ) = 'kg kg-1'
   moist_streams_table( idomain, P_qr )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qr )%stream(2) = 2097152 
   F_qr = .TRUE.
   IF ( moist_index_table( PARAM_qi , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qi = moist_num_table(idomain)
     moist_index_table( PARAM_qi , idomain ) = P_qi
   ELSE
     P_qi = moist_index_table( PARAM_qi , idomain )
   END IF
   moist_boundary_table( idomain, P_qi ) = .TRUE.
   moist_dname_table( idomain, P_qi ) = 'QICE'
   moist_desc_table( idomain, P_qi ) = 'Ice mixing ratio'
   moist_units_table( idomain, P_qi ) = 'kg kg-1'
   moist_streams_table( idomain, P_qi )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qi )%stream(2) = 2097152 
   F_qi = .TRUE.
   IF ( moist_index_table( PARAM_qs , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qs = moist_num_table(idomain)
     moist_index_table( PARAM_qs , idomain ) = P_qs
   ELSE
     P_qs = moist_index_table( PARAM_qs , idomain )
   END IF
   moist_boundary_table( idomain, P_qs ) = .TRUE.
   moist_dname_table( idomain, P_qs ) = 'QSNOW'
   moist_desc_table( idomain, P_qs ) = 'Snow mixing ratio'
   moist_units_table( idomain, P_qs ) = 'kg kg-1'
   moist_streams_table( idomain, P_qs )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qs )%stream(2) = 2097152 
   F_qs = .TRUE.
   IF ( moist_index_table( PARAM_qg , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qg = moist_num_table(idomain)
     moist_index_table( PARAM_qg , idomain ) = P_qg
   ELSE
     P_qg = moist_index_table( PARAM_qg , idomain )
   END IF
   moist_boundary_table( idomain, P_qg ) = .TRUE.
   moist_dname_table( idomain, P_qg ) = 'QGRAUP'
   moist_desc_table( idomain, P_qg ) = 'Graupel mixing ratio'
   moist_units_table( idomain, P_qg ) = 'kg kg-1'
   moist_streams_table( idomain, P_qg )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qg )%stream(2) = 2097152 
   F_qg = .TRUE.
   IF ( moist_index_table( PARAM_qh , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qh = moist_num_table(idomain)
     moist_index_table( PARAM_qh , idomain ) = P_qh
   ELSE
     P_qh = moist_index_table( PARAM_qh , idomain )
   END IF
   moist_boundary_table( idomain, P_qh ) = .TRUE.
   moist_dname_table( idomain, P_qh ) = 'QHAIL'
   moist_desc_table( idomain, P_qh ) = 'Hail mixing ratio'
   moist_units_table( idomain, P_qh ) = 'kg kg-1'
   moist_streams_table( idomain, P_qh )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qh )%stream(2) = 2097152 
   F_qh = .TRUE.
   IF ( scalar_index_table( PARAM_qndrop , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qndrop = scalar_num_table(idomain)
     scalar_index_table( PARAM_qndrop , idomain ) = P_qndrop
   ELSE
     P_qndrop = scalar_index_table( PARAM_qndrop , idomain )
   END IF
   scalar_boundary_table( idomain, P_qndrop ) = .TRUE.
   scalar_dname_table( idomain, P_qndrop ) = 'QNDROP'
   scalar_desc_table( idomain, P_qndrop ) = 'Droplet number mixing ratio'
   scalar_units_table( idomain, P_qndrop ) = '  kg-1'
   scalar_streams_table( idomain, P_qndrop )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qndrop )%stream(2) = 2097152 
   F_qndrop = .TRUE.
   IF ( scalar_index_table( PARAM_qnr , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qnr = scalar_num_table(idomain)
     scalar_index_table( PARAM_qnr , idomain ) = P_qnr
   ELSE
     P_qnr = scalar_index_table( PARAM_qnr , idomain )
   END IF
   scalar_boundary_table( idomain, P_qnr ) = .TRUE.
   scalar_dname_table( idomain, P_qnr ) = 'QNRAIN'
   scalar_desc_table( idomain, P_qnr ) = 'Rain Number concentration'
   scalar_units_table( idomain, P_qnr ) = '  kg(-1)'
   scalar_streams_table( idomain, P_qnr )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qnr )%stream(2) = 2097152 
   F_qnr = .TRUE.
   IF ( scalar_index_table( PARAM_qni , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qni = scalar_num_table(idomain)
     scalar_index_table( PARAM_qni , idomain ) = P_qni
   ELSE
     P_qni = scalar_index_table( PARAM_qni , idomain )
   END IF
   scalar_boundary_table( idomain, P_qni ) = .TRUE.
   scalar_dname_table( idomain, P_qni ) = 'QNICE'
   scalar_desc_table( idomain, P_qni ) = 'Ice Number concentration'
   scalar_units_table( idomain, P_qni ) = '  kg-1'
   scalar_streams_table( idomain, P_qni )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qni )%stream(2) = 2097152 
   F_qni = .TRUE.
   IF ( scalar_index_table( PARAM_qns , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qns = scalar_num_table(idomain)
     scalar_index_table( PARAM_qns , idomain ) = P_qns
   ELSE
     P_qns = scalar_index_table( PARAM_qns , idomain )
   END IF
   scalar_boundary_table( idomain, P_qns ) = .TRUE.
   scalar_dname_table( idomain, P_qns ) = 'QNSNOW'
   scalar_desc_table( idomain, P_qns ) = 'Snow Number concentration'
   scalar_units_table( idomain, P_qns ) = '  kg(-1)'
   scalar_streams_table( idomain, P_qns )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qns )%stream(2) = 2097152 
   F_qns = .TRUE.
   IF ( scalar_index_table( PARAM_qng , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qng = scalar_num_table(idomain)
     scalar_index_table( PARAM_qng , idomain ) = P_qng
   ELSE
     P_qng = scalar_index_table( PARAM_qng , idomain )
   END IF
   scalar_boundary_table( idomain, P_qng ) = .TRUE.
   scalar_dname_table( idomain, P_qng ) = 'QNGRAUPEL'
   scalar_desc_table( idomain, P_qng ) = 'Graupel Number concentration'
   scalar_units_table( idomain, P_qng ) = '  kg(-1)'
   scalar_streams_table( idomain, P_qng )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qng )%stream(2) = 2097152 
   F_qng = .TRUE.
   IF ( scalar_index_table( PARAM_qnh , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qnh = scalar_num_table(idomain)
     scalar_index_table( PARAM_qnh , idomain ) = P_qnh
   ELSE
     P_qnh = scalar_index_table( PARAM_qnh , idomain )
   END IF
   scalar_boundary_table( idomain, P_qnh ) = .TRUE.
   scalar_dname_table( idomain, P_qnh ) = 'QNHAIL'
   scalar_desc_table( idomain, P_qnh ) = 'Hail Number concentration'
   scalar_units_table( idomain, P_qnh ) = '  kg(-1)'
   scalar_streams_table( idomain, P_qnh )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qnh )%stream(2) = 2097152 
   F_qnh = .TRUE.
   IF ( scalar_index_table( PARAM_qvolg , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qvolg = scalar_num_table(idomain)
     scalar_index_table( PARAM_qvolg , idomain ) = P_qvolg
   ELSE
     P_qvolg = scalar_index_table( PARAM_qvolg , idomain )
   END IF
   scalar_boundary_table( idomain, P_qvolg ) = .TRUE.
   scalar_dname_table( idomain, P_qvolg ) = 'QVGRAUPEL'
   scalar_desc_table( idomain, P_qvolg ) = 'Graupel Particle Volume'
   scalar_units_table( idomain, P_qvolg ) = 'm(3) kg(-1)'
   scalar_streams_table( idomain, P_qvolg )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qvolg )%stream(2) = 2097152 
   F_qvolg = .TRUE.
   IF ( scalar_index_table( PARAM_qvolh , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qvolh = scalar_num_table(idomain)
     scalar_index_table( PARAM_qvolh , idomain ) = P_qvolh
   ELSE
     P_qvolh = scalar_index_table( PARAM_qvolh , idomain )
   END IF
   scalar_boundary_table( idomain, P_qvolh ) = .TRUE.
   scalar_dname_table( idomain, P_qvolh ) = 'QVHAIL'
   scalar_desc_table( idomain, P_qvolh ) = 'Hail Particle Volume'
   scalar_units_table( idomain, P_qvolh ) = 'm(3) kg(-1)'
   scalar_streams_table( idomain, P_qvolh )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qvolh )%stream(2) = 2097152 
   F_qvolh = .TRUE.
  END IF
  IF (model_config_rec%mp_physics(idomain)==18)THEN
   IF ( moist_index_table( PARAM_qv , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qv = moist_num_table(idomain)
     moist_index_table( PARAM_qv , idomain ) = P_qv
   ELSE
     P_qv = moist_index_table( PARAM_qv , idomain )
   END IF
   moist_boundary_table( idomain, P_qv ) = .TRUE.
   moist_dname_table( idomain, P_qv ) = 'QVAPOR'
   moist_desc_table( idomain, P_qv ) = 'Water vapor mixing ratio'
   moist_units_table( idomain, P_qv ) = 'kg kg-1'
   moist_streams_table( idomain, P_qv )%stream(1) = 33554435 
   moist_streams_table( idomain, P_qv )%stream(2) = 2097152 
   F_qv = .TRUE.
   IF ( moist_index_table( PARAM_qc , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qc = moist_num_table(idomain)
     moist_index_table( PARAM_qc , idomain ) = P_qc
   ELSE
     P_qc = moist_index_table( PARAM_qc , idomain )
   END IF
   moist_boundary_table( idomain, P_qc ) = .TRUE.
   moist_dname_table( idomain, P_qc ) = 'QCLOUD'
   moist_desc_table( idomain, P_qc ) = 'Cloud water mixing ratio'
   moist_units_table( idomain, P_qc ) = 'kg kg-1'
   moist_streams_table( idomain, P_qc )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qc )%stream(2) = 2097152 
   F_qc = .TRUE.
   IF ( moist_index_table( PARAM_qr , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qr = moist_num_table(idomain)
     moist_index_table( PARAM_qr , idomain ) = P_qr
   ELSE
     P_qr = moist_index_table( PARAM_qr , idomain )
   END IF
   moist_boundary_table( idomain, P_qr ) = .TRUE.
   moist_dname_table( idomain, P_qr ) = 'QRAIN'
   moist_desc_table( idomain, P_qr ) = 'Rain water mixing ratio'
   moist_units_table( idomain, P_qr ) = 'kg kg-1'
   moist_streams_table( idomain, P_qr )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qr )%stream(2) = 2097152 
   F_qr = .TRUE.
   IF ( moist_index_table( PARAM_qi , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qi = moist_num_table(idomain)
     moist_index_table( PARAM_qi , idomain ) = P_qi
   ELSE
     P_qi = moist_index_table( PARAM_qi , idomain )
   END IF
   moist_boundary_table( idomain, P_qi ) = .TRUE.
   moist_dname_table( idomain, P_qi ) = 'QICE'
   moist_desc_table( idomain, P_qi ) = 'Ice mixing ratio'
   moist_units_table( idomain, P_qi ) = 'kg kg-1'
   moist_streams_table( idomain, P_qi )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qi )%stream(2) = 2097152 
   F_qi = .TRUE.
   IF ( moist_index_table( PARAM_qs , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qs = moist_num_table(idomain)
     moist_index_table( PARAM_qs , idomain ) = P_qs
   ELSE
     P_qs = moist_index_table( PARAM_qs , idomain )
   END IF
   moist_boundary_table( idomain, P_qs ) = .TRUE.
   moist_dname_table( idomain, P_qs ) = 'QSNOW'
   moist_desc_table( idomain, P_qs ) = 'Snow mixing ratio'
   moist_units_table( idomain, P_qs ) = 'kg kg-1'
   moist_streams_table( idomain, P_qs )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qs )%stream(2) = 2097152 
   F_qs = .TRUE.
   IF ( moist_index_table( PARAM_qg , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qg = moist_num_table(idomain)
     moist_index_table( PARAM_qg , idomain ) = P_qg
   ELSE
     P_qg = moist_index_table( PARAM_qg , idomain )
   END IF
   moist_boundary_table( idomain, P_qg ) = .TRUE.
   moist_dname_table( idomain, P_qg ) = 'QGRAUP'
   moist_desc_table( idomain, P_qg ) = 'Graupel mixing ratio'
   moist_units_table( idomain, P_qg ) = 'kg kg-1'
   moist_streams_table( idomain, P_qg )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qg )%stream(2) = 2097152 
   F_qg = .TRUE.
   IF ( moist_index_table( PARAM_qh , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qh = moist_num_table(idomain)
     moist_index_table( PARAM_qh , idomain ) = P_qh
   ELSE
     P_qh = moist_index_table( PARAM_qh , idomain )
   END IF
   moist_boundary_table( idomain, P_qh ) = .TRUE.
   moist_dname_table( idomain, P_qh ) = 'QHAIL'
   moist_desc_table( idomain, P_qh ) = 'Hail mixing ratio'
   moist_units_table( idomain, P_qh ) = 'kg kg-1'
   moist_streams_table( idomain, P_qh )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qh )%stream(2) = 2097152 
   F_qh = .TRUE.
   IF ( scalar_index_table( PARAM_qnn , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qnn = scalar_num_table(idomain)
     scalar_index_table( PARAM_qnn , idomain ) = P_qnn
   ELSE
     P_qnn = scalar_index_table( PARAM_qnn , idomain )
   END IF
   scalar_boundary_table( idomain, P_qnn ) = .TRUE.
   scalar_dname_table( idomain, P_qnn ) = 'QNCCN'
   scalar_desc_table( idomain, P_qnn ) = 'CCN Number concentration'
   scalar_units_table( idomain, P_qnn ) = '  kg(-1)'
   scalar_streams_table( idomain, P_qnn )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qnn )%stream(2) = 2097152 
   F_qnn = .TRUE.
   IF ( scalar_index_table( PARAM_qndrop , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qndrop = scalar_num_table(idomain)
     scalar_index_table( PARAM_qndrop , idomain ) = P_qndrop
   ELSE
     P_qndrop = scalar_index_table( PARAM_qndrop , idomain )
   END IF
   scalar_boundary_table( idomain, P_qndrop ) = .TRUE.
   scalar_dname_table( idomain, P_qndrop ) = 'QNDROP'
   scalar_desc_table( idomain, P_qndrop ) = 'Droplet number mixing ratio'
   scalar_units_table( idomain, P_qndrop ) = '  kg-1'
   scalar_streams_table( idomain, P_qndrop )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qndrop )%stream(2) = 2097152 
   F_qndrop = .TRUE.
   IF ( scalar_index_table( PARAM_qnr , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qnr = scalar_num_table(idomain)
     scalar_index_table( PARAM_qnr , idomain ) = P_qnr
   ELSE
     P_qnr = scalar_index_table( PARAM_qnr , idomain )
   END IF
   scalar_boundary_table( idomain, P_qnr ) = .TRUE.
   scalar_dname_table( idomain, P_qnr ) = 'QNRAIN'
   scalar_desc_table( idomain, P_qnr ) = 'Rain Number concentration'
   scalar_units_table( idomain, P_qnr ) = '  kg(-1)'
   scalar_streams_table( idomain, P_qnr )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qnr )%stream(2) = 2097152 
   F_qnr = .TRUE.
   IF ( scalar_index_table( PARAM_qni , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qni = scalar_num_table(idomain)
     scalar_index_table( PARAM_qni , idomain ) = P_qni
   ELSE
     P_qni = scalar_index_table( PARAM_qni , idomain )
   END IF
   scalar_boundary_table( idomain, P_qni ) = .TRUE.
   scalar_dname_table( idomain, P_qni ) = 'QNICE'
   scalar_desc_table( idomain, P_qni ) = 'Ice Number concentration'
   scalar_units_table( idomain, P_qni ) = '  kg-1'
   scalar_streams_table( idomain, P_qni )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qni )%stream(2) = 2097152 
   F_qni = .TRUE.
   IF ( scalar_index_table( PARAM_qns , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qns = scalar_num_table(idomain)
     scalar_index_table( PARAM_qns , idomain ) = P_qns
   ELSE
     P_qns = scalar_index_table( PARAM_qns , idomain )
   END IF
   scalar_boundary_table( idomain, P_qns ) = .TRUE.
   scalar_dname_table( idomain, P_qns ) = 'QNSNOW'
   scalar_desc_table( idomain, P_qns ) = 'Snow Number concentration'
   scalar_units_table( idomain, P_qns ) = '  kg(-1)'
   scalar_streams_table( idomain, P_qns )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qns )%stream(2) = 2097152 
   F_qns = .TRUE.
   IF ( scalar_index_table( PARAM_qng , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qng = scalar_num_table(idomain)
     scalar_index_table( PARAM_qng , idomain ) = P_qng
   ELSE
     P_qng = scalar_index_table( PARAM_qng , idomain )
   END IF
   scalar_boundary_table( idomain, P_qng ) = .TRUE.
   scalar_dname_table( idomain, P_qng ) = 'QNGRAUPEL'
   scalar_desc_table( idomain, P_qng ) = 'Graupel Number concentration'
   scalar_units_table( idomain, P_qng ) = '  kg(-1)'
   scalar_streams_table( idomain, P_qng )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qng )%stream(2) = 2097152 
   F_qng = .TRUE.
   IF ( scalar_index_table( PARAM_qnh , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qnh = scalar_num_table(idomain)
     scalar_index_table( PARAM_qnh , idomain ) = P_qnh
   ELSE
     P_qnh = scalar_index_table( PARAM_qnh , idomain )
   END IF
   scalar_boundary_table( idomain, P_qnh ) = .TRUE.
   scalar_dname_table( idomain, P_qnh ) = 'QNHAIL'
   scalar_desc_table( idomain, P_qnh ) = 'Hail Number concentration'
   scalar_units_table( idomain, P_qnh ) = '  kg(-1)'
   scalar_streams_table( idomain, P_qnh )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qnh )%stream(2) = 2097152 
   F_qnh = .TRUE.
   IF ( scalar_index_table( PARAM_qvolg , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qvolg = scalar_num_table(idomain)
     scalar_index_table( PARAM_qvolg , idomain ) = P_qvolg
   ELSE
     P_qvolg = scalar_index_table( PARAM_qvolg , idomain )
   END IF
   scalar_boundary_table( idomain, P_qvolg ) = .TRUE.
   scalar_dname_table( idomain, P_qvolg ) = 'QVGRAUPEL'
   scalar_desc_table( idomain, P_qvolg ) = 'Graupel Particle Volume'
   scalar_units_table( idomain, P_qvolg ) = 'm(3) kg(-1)'
   scalar_streams_table( idomain, P_qvolg )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qvolg )%stream(2) = 2097152 
   F_qvolg = .TRUE.
   IF ( scalar_index_table( PARAM_qvolh , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qvolh = scalar_num_table(idomain)
     scalar_index_table( PARAM_qvolh , idomain ) = P_qvolh
   ELSE
     P_qvolh = scalar_index_table( PARAM_qvolh , idomain )
   END IF
   scalar_boundary_table( idomain, P_qvolh ) = .TRUE.
   scalar_dname_table( idomain, P_qvolh ) = 'QVHAIL'
   scalar_desc_table( idomain, P_qvolh ) = 'Hail Particle Volume'
   scalar_units_table( idomain, P_qvolh ) = 'm(3) kg(-1)'
   scalar_streams_table( idomain, P_qvolh )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qvolh )%stream(2) = 2097152 
   F_qvolh = .TRUE.
  END IF
  IF (model_config_rec%mp_physics(idomain)==19)THEN
   IF ( moist_index_table( PARAM_qv , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qv = moist_num_table(idomain)
     moist_index_table( PARAM_qv , idomain ) = P_qv
   ELSE
     P_qv = moist_index_table( PARAM_qv , idomain )
   END IF
   moist_boundary_table( idomain, P_qv ) = .TRUE.
   moist_dname_table( idomain, P_qv ) = 'QVAPOR'
   moist_desc_table( idomain, P_qv ) = 'Water vapor mixing ratio'
   moist_units_table( idomain, P_qv ) = 'kg kg-1'
   moist_streams_table( idomain, P_qv )%stream(1) = 33554435 
   moist_streams_table( idomain, P_qv )%stream(2) = 2097152 
   F_qv = .TRUE.
   IF ( moist_index_table( PARAM_qc , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qc = moist_num_table(idomain)
     moist_index_table( PARAM_qc , idomain ) = P_qc
   ELSE
     P_qc = moist_index_table( PARAM_qc , idomain )
   END IF
   moist_boundary_table( idomain, P_qc ) = .TRUE.
   moist_dname_table( idomain, P_qc ) = 'QCLOUD'
   moist_desc_table( idomain, P_qc ) = 'Cloud water mixing ratio'
   moist_units_table( idomain, P_qc ) = 'kg kg-1'
   moist_streams_table( idomain, P_qc )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qc )%stream(2) = 2097152 
   F_qc = .TRUE.
   IF ( moist_index_table( PARAM_qr , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qr = moist_num_table(idomain)
     moist_index_table( PARAM_qr , idomain ) = P_qr
   ELSE
     P_qr = moist_index_table( PARAM_qr , idomain )
   END IF
   moist_boundary_table( idomain, P_qr ) = .TRUE.
   moist_dname_table( idomain, P_qr ) = 'QRAIN'
   moist_desc_table( idomain, P_qr ) = 'Rain water mixing ratio'
   moist_units_table( idomain, P_qr ) = 'kg kg-1'
   moist_streams_table( idomain, P_qr )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qr )%stream(2) = 2097152 
   F_qr = .TRUE.
   IF ( moist_index_table( PARAM_qi , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qi = moist_num_table(idomain)
     moist_index_table( PARAM_qi , idomain ) = P_qi
   ELSE
     P_qi = moist_index_table( PARAM_qi , idomain )
   END IF
   moist_boundary_table( idomain, P_qi ) = .TRUE.
   moist_dname_table( idomain, P_qi ) = 'QICE'
   moist_desc_table( idomain, P_qi ) = 'Ice mixing ratio'
   moist_units_table( idomain, P_qi ) = 'kg kg-1'
   moist_streams_table( idomain, P_qi )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qi )%stream(2) = 2097152 
   F_qi = .TRUE.
   IF ( moist_index_table( PARAM_qs , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qs = moist_num_table(idomain)
     moist_index_table( PARAM_qs , idomain ) = P_qs
   ELSE
     P_qs = moist_index_table( PARAM_qs , idomain )
   END IF
   moist_boundary_table( idomain, P_qs ) = .TRUE.
   moist_dname_table( idomain, P_qs ) = 'QSNOW'
   moist_desc_table( idomain, P_qs ) = 'Snow mixing ratio'
   moist_units_table( idomain, P_qs ) = 'kg kg-1'
   moist_streams_table( idomain, P_qs )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qs )%stream(2) = 2097152 
   F_qs = .TRUE.
   IF ( moist_index_table( PARAM_qg , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qg = moist_num_table(idomain)
     moist_index_table( PARAM_qg , idomain ) = P_qg
   ELSE
     P_qg = moist_index_table( PARAM_qg , idomain )
   END IF
   moist_boundary_table( idomain, P_qg ) = .TRUE.
   moist_dname_table( idomain, P_qg ) = 'QGRAUP'
   moist_desc_table( idomain, P_qg ) = 'Graupel mixing ratio'
   moist_units_table( idomain, P_qg ) = 'kg kg-1'
   moist_streams_table( idomain, P_qg )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qg )%stream(2) = 2097152 
   F_qg = .TRUE.
   IF ( moist_index_table( PARAM_qh , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qh = moist_num_table(idomain)
     moist_index_table( PARAM_qh , idomain ) = P_qh
   ELSE
     P_qh = moist_index_table( PARAM_qh , idomain )
   END IF
   moist_boundary_table( idomain, P_qh ) = .TRUE.
   moist_dname_table( idomain, P_qh ) = 'QHAIL'
   moist_desc_table( idomain, P_qh ) = 'Hail mixing ratio'
   moist_units_table( idomain, P_qh ) = 'kg kg-1'
   moist_streams_table( idomain, P_qh )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qh )%stream(2) = 2097152 
   F_qh = .TRUE.
   IF ( scalar_index_table( PARAM_qvolg , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qvolg = scalar_num_table(idomain)
     scalar_index_table( PARAM_qvolg , idomain ) = P_qvolg
   ELSE
     P_qvolg = scalar_index_table( PARAM_qvolg , idomain )
   END IF
   scalar_boundary_table( idomain, P_qvolg ) = .TRUE.
   scalar_dname_table( idomain, P_qvolg ) = 'QVGRAUPEL'
   scalar_desc_table( idomain, P_qvolg ) = 'Graupel Particle Volume'
   scalar_units_table( idomain, P_qvolg ) = 'm(3) kg(-1)'
   scalar_streams_table( idomain, P_qvolg )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qvolg )%stream(2) = 2097152 
   F_qvolg = .TRUE.
  END IF
  IF (model_config_rec%mp_physics(idomain)==21)THEN
   IF ( moist_index_table( PARAM_qv , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qv = moist_num_table(idomain)
     moist_index_table( PARAM_qv , idomain ) = P_qv
   ELSE
     P_qv = moist_index_table( PARAM_qv , idomain )
   END IF
   moist_boundary_table( idomain, P_qv ) = .TRUE.
   moist_dname_table( idomain, P_qv ) = 'QVAPOR'
   moist_desc_table( idomain, P_qv ) = 'Water vapor mixing ratio'
   moist_units_table( idomain, P_qv ) = 'kg kg-1'
   moist_streams_table( idomain, P_qv )%stream(1) = 33554435 
   moist_streams_table( idomain, P_qv )%stream(2) = 2097152 
   F_qv = .TRUE.
   IF ( moist_index_table( PARAM_qc , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qc = moist_num_table(idomain)
     moist_index_table( PARAM_qc , idomain ) = P_qc
   ELSE
     P_qc = moist_index_table( PARAM_qc , idomain )
   END IF
   moist_boundary_table( idomain, P_qc ) = .TRUE.
   moist_dname_table( idomain, P_qc ) = 'QCLOUD'
   moist_desc_table( idomain, P_qc ) = 'Cloud water mixing ratio'
   moist_units_table( idomain, P_qc ) = 'kg kg-1'
   moist_streams_table( idomain, P_qc )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qc )%stream(2) = 2097152 
   F_qc = .TRUE.
   IF ( moist_index_table( PARAM_qr , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qr = moist_num_table(idomain)
     moist_index_table( PARAM_qr , idomain ) = P_qr
   ELSE
     P_qr = moist_index_table( PARAM_qr , idomain )
   END IF
   moist_boundary_table( idomain, P_qr ) = .TRUE.
   moist_dname_table( idomain, P_qr ) = 'QRAIN'
   moist_desc_table( idomain, P_qr ) = 'Rain water mixing ratio'
   moist_units_table( idomain, P_qr ) = 'kg kg-1'
   moist_streams_table( idomain, P_qr )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qr )%stream(2) = 2097152 
   F_qr = .TRUE.
   IF ( moist_index_table( PARAM_qi , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qi = moist_num_table(idomain)
     moist_index_table( PARAM_qi , idomain ) = P_qi
   ELSE
     P_qi = moist_index_table( PARAM_qi , idomain )
   END IF
   moist_boundary_table( idomain, P_qi ) = .TRUE.
   moist_dname_table( idomain, P_qi ) = 'QICE'
   moist_desc_table( idomain, P_qi ) = 'Ice mixing ratio'
   moist_units_table( idomain, P_qi ) = 'kg kg-1'
   moist_streams_table( idomain, P_qi )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qi )%stream(2) = 2097152 
   F_qi = .TRUE.
   IF ( moist_index_table( PARAM_qs , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qs = moist_num_table(idomain)
     moist_index_table( PARAM_qs , idomain ) = P_qs
   ELSE
     P_qs = moist_index_table( PARAM_qs , idomain )
   END IF
   moist_boundary_table( idomain, P_qs ) = .TRUE.
   moist_dname_table( idomain, P_qs ) = 'QSNOW'
   moist_desc_table( idomain, P_qs ) = 'Snow mixing ratio'
   moist_units_table( idomain, P_qs ) = 'kg kg-1'
   moist_streams_table( idomain, P_qs )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qs )%stream(2) = 2097152 
   F_qs = .TRUE.
   IF ( moist_index_table( PARAM_qg , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qg = moist_num_table(idomain)
     moist_index_table( PARAM_qg , idomain ) = P_qg
   ELSE
     P_qg = moist_index_table( PARAM_qg , idomain )
   END IF
   moist_boundary_table( idomain, P_qg ) = .TRUE.
   moist_dname_table( idomain, P_qg ) = 'QGRAUP'
   moist_desc_table( idomain, P_qg ) = 'Graupel mixing ratio'
   moist_units_table( idomain, P_qg ) = 'kg kg-1'
   moist_streams_table( idomain, P_qg )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qg )%stream(2) = 2097152 
   F_qg = .TRUE.
  END IF
  IF (model_config_rec%mp_physics(idomain)==22)THEN
   IF ( moist_index_table( PARAM_qv , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qv = moist_num_table(idomain)
     moist_index_table( PARAM_qv , idomain ) = P_qv
   ELSE
     P_qv = moist_index_table( PARAM_qv , idomain )
   END IF
   moist_boundary_table( idomain, P_qv ) = .TRUE.
   moist_dname_table( idomain, P_qv ) = 'QVAPOR'
   moist_desc_table( idomain, P_qv ) = 'Water vapor mixing ratio'
   moist_units_table( idomain, P_qv ) = 'kg kg-1'
   moist_streams_table( idomain, P_qv )%stream(1) = 33554435 
   moist_streams_table( idomain, P_qv )%stream(2) = 2097152 
   F_qv = .TRUE.
   IF ( moist_index_table( PARAM_qc , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qc = moist_num_table(idomain)
     moist_index_table( PARAM_qc , idomain ) = P_qc
   ELSE
     P_qc = moist_index_table( PARAM_qc , idomain )
   END IF
   moist_boundary_table( idomain, P_qc ) = .TRUE.
   moist_dname_table( idomain, P_qc ) = 'QCLOUD'
   moist_desc_table( idomain, P_qc ) = 'Cloud water mixing ratio'
   moist_units_table( idomain, P_qc ) = 'kg kg-1'
   moist_streams_table( idomain, P_qc )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qc )%stream(2) = 2097152 
   F_qc = .TRUE.
   IF ( moist_index_table( PARAM_qr , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qr = moist_num_table(idomain)
     moist_index_table( PARAM_qr , idomain ) = P_qr
   ELSE
     P_qr = moist_index_table( PARAM_qr , idomain )
   END IF
   moist_boundary_table( idomain, P_qr ) = .TRUE.
   moist_dname_table( idomain, P_qr ) = 'QRAIN'
   moist_desc_table( idomain, P_qr ) = 'Rain water mixing ratio'
   moist_units_table( idomain, P_qr ) = 'kg kg-1'
   moist_streams_table( idomain, P_qr )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qr )%stream(2) = 2097152 
   F_qr = .TRUE.
   IF ( moist_index_table( PARAM_qi , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qi = moist_num_table(idomain)
     moist_index_table( PARAM_qi , idomain ) = P_qi
   ELSE
     P_qi = moist_index_table( PARAM_qi , idomain )
   END IF
   moist_boundary_table( idomain, P_qi ) = .TRUE.
   moist_dname_table( idomain, P_qi ) = 'QICE'
   moist_desc_table( idomain, P_qi ) = 'Ice mixing ratio'
   moist_units_table( idomain, P_qi ) = 'kg kg-1'
   moist_streams_table( idomain, P_qi )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qi )%stream(2) = 2097152 
   F_qi = .TRUE.
   IF ( moist_index_table( PARAM_qs , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qs = moist_num_table(idomain)
     moist_index_table( PARAM_qs , idomain ) = P_qs
   ELSE
     P_qs = moist_index_table( PARAM_qs , idomain )
   END IF
   moist_boundary_table( idomain, P_qs ) = .TRUE.
   moist_dname_table( idomain, P_qs ) = 'QSNOW'
   moist_desc_table( idomain, P_qs ) = 'Snow mixing ratio'
   moist_units_table( idomain, P_qs ) = 'kg kg-1'
   moist_streams_table( idomain, P_qs )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qs )%stream(2) = 2097152 
   F_qs = .TRUE.
   IF ( moist_index_table( PARAM_qg , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qg = moist_num_table(idomain)
     moist_index_table( PARAM_qg , idomain ) = P_qg
   ELSE
     P_qg = moist_index_table( PARAM_qg , idomain )
   END IF
   moist_boundary_table( idomain, P_qg ) = .TRUE.
   moist_dname_table( idomain, P_qg ) = 'QGRAUP'
   moist_desc_table( idomain, P_qg ) = 'Graupel mixing ratio'
   moist_units_table( idomain, P_qg ) = 'kg kg-1'
   moist_streams_table( idomain, P_qg )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qg )%stream(2) = 2097152 
   F_qg = .TRUE.
   IF ( scalar_index_table( PARAM_qndrop , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qndrop = scalar_num_table(idomain)
     scalar_index_table( PARAM_qndrop , idomain ) = P_qndrop
   ELSE
     P_qndrop = scalar_index_table( PARAM_qndrop , idomain )
   END IF
   scalar_boundary_table( idomain, P_qndrop ) = .TRUE.
   scalar_dname_table( idomain, P_qndrop ) = 'QNDROP'
   scalar_desc_table( idomain, P_qndrop ) = 'Droplet number mixing ratio'
   scalar_units_table( idomain, P_qndrop ) = '  kg-1'
   scalar_streams_table( idomain, P_qndrop )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qndrop )%stream(2) = 2097152 
   F_qndrop = .TRUE.
   IF ( scalar_index_table( PARAM_qnr , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qnr = scalar_num_table(idomain)
     scalar_index_table( PARAM_qnr , idomain ) = P_qnr
   ELSE
     P_qnr = scalar_index_table( PARAM_qnr , idomain )
   END IF
   scalar_boundary_table( idomain, P_qnr ) = .TRUE.
   scalar_dname_table( idomain, P_qnr ) = 'QNRAIN'
   scalar_desc_table( idomain, P_qnr ) = 'Rain Number concentration'
   scalar_units_table( idomain, P_qnr ) = '  kg(-1)'
   scalar_streams_table( idomain, P_qnr )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qnr )%stream(2) = 2097152 
   F_qnr = .TRUE.
   IF ( scalar_index_table( PARAM_qni , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qni = scalar_num_table(idomain)
     scalar_index_table( PARAM_qni , idomain ) = P_qni
   ELSE
     P_qni = scalar_index_table( PARAM_qni , idomain )
   END IF
   scalar_boundary_table( idomain, P_qni ) = .TRUE.
   scalar_dname_table( idomain, P_qni ) = 'QNICE'
   scalar_desc_table( idomain, P_qni ) = 'Ice Number concentration'
   scalar_units_table( idomain, P_qni ) = '  kg-1'
   scalar_streams_table( idomain, P_qni )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qni )%stream(2) = 2097152 
   F_qni = .TRUE.
   IF ( scalar_index_table( PARAM_qns , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qns = scalar_num_table(idomain)
     scalar_index_table( PARAM_qns , idomain ) = P_qns
   ELSE
     P_qns = scalar_index_table( PARAM_qns , idomain )
   END IF
   scalar_boundary_table( idomain, P_qns ) = .TRUE.
   scalar_dname_table( idomain, P_qns ) = 'QNSNOW'
   scalar_desc_table( idomain, P_qns ) = 'Snow Number concentration'
   scalar_units_table( idomain, P_qns ) = '  kg(-1)'
   scalar_streams_table( idomain, P_qns )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qns )%stream(2) = 2097152 
   F_qns = .TRUE.
   IF ( scalar_index_table( PARAM_qng , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qng = scalar_num_table(idomain)
     scalar_index_table( PARAM_qng , idomain ) = P_qng
   ELSE
     P_qng = scalar_index_table( PARAM_qng , idomain )
   END IF
   scalar_boundary_table( idomain, P_qng ) = .TRUE.
   scalar_dname_table( idomain, P_qng ) = 'QNGRAUPEL'
   scalar_desc_table( idomain, P_qng ) = 'Graupel Number concentration'
   scalar_units_table( idomain, P_qng ) = '  kg(-1)'
   scalar_streams_table( idomain, P_qng )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qng )%stream(2) = 2097152 
   F_qng = .TRUE.
   IF ( scalar_index_table( PARAM_qvolg , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qvolg = scalar_num_table(idomain)
     scalar_index_table( PARAM_qvolg , idomain ) = P_qvolg
   ELSE
     P_qvolg = scalar_index_table( PARAM_qvolg , idomain )
   END IF
   scalar_boundary_table( idomain, P_qvolg ) = .TRUE.
   scalar_dname_table( idomain, P_qvolg ) = 'QVGRAUPEL'
   scalar_desc_table( idomain, P_qvolg ) = 'Graupel Particle Volume'
   scalar_units_table( idomain, P_qvolg ) = 'm(3) kg(-1)'
   scalar_streams_table( idomain, P_qvolg )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qvolg )%stream(2) = 2097152 
   F_qvolg = .TRUE.
  END IF
  IF (model_config_rec%mp_physics(idomain)==24)THEN
   IF ( moist_index_table( PARAM_qv , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qv = moist_num_table(idomain)
     moist_index_table( PARAM_qv , idomain ) = P_qv
   ELSE
     P_qv = moist_index_table( PARAM_qv , idomain )
   END IF
   moist_boundary_table( idomain, P_qv ) = .TRUE.
   moist_dname_table( idomain, P_qv ) = 'QVAPOR'
   moist_desc_table( idomain, P_qv ) = 'Water vapor mixing ratio'
   moist_units_table( idomain, P_qv ) = 'kg kg-1'
   moist_streams_table( idomain, P_qv )%stream(1) = 33554435 
   moist_streams_table( idomain, P_qv )%stream(2) = 2097152 
   F_qv = .TRUE.
   IF ( moist_index_table( PARAM_qc , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qc = moist_num_table(idomain)
     moist_index_table( PARAM_qc , idomain ) = P_qc
   ELSE
     P_qc = moist_index_table( PARAM_qc , idomain )
   END IF
   moist_boundary_table( idomain, P_qc ) = .TRUE.
   moist_dname_table( idomain, P_qc ) = 'QCLOUD'
   moist_desc_table( idomain, P_qc ) = 'Cloud water mixing ratio'
   moist_units_table( idomain, P_qc ) = 'kg kg-1'
   moist_streams_table( idomain, P_qc )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qc )%stream(2) = 2097152 
   F_qc = .TRUE.
   IF ( moist_index_table( PARAM_qr , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qr = moist_num_table(idomain)
     moist_index_table( PARAM_qr , idomain ) = P_qr
   ELSE
     P_qr = moist_index_table( PARAM_qr , idomain )
   END IF
   moist_boundary_table( idomain, P_qr ) = .TRUE.
   moist_dname_table( idomain, P_qr ) = 'QRAIN'
   moist_desc_table( idomain, P_qr ) = 'Rain water mixing ratio'
   moist_units_table( idomain, P_qr ) = 'kg kg-1'
   moist_streams_table( idomain, P_qr )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qr )%stream(2) = 2097152 
   F_qr = .TRUE.
   IF ( moist_index_table( PARAM_qi , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qi = moist_num_table(idomain)
     moist_index_table( PARAM_qi , idomain ) = P_qi
   ELSE
     P_qi = moist_index_table( PARAM_qi , idomain )
   END IF
   moist_boundary_table( idomain, P_qi ) = .TRUE.
   moist_dname_table( idomain, P_qi ) = 'QICE'
   moist_desc_table( idomain, P_qi ) = 'Ice mixing ratio'
   moist_units_table( idomain, P_qi ) = 'kg kg-1'
   moist_streams_table( idomain, P_qi )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qi )%stream(2) = 2097152 
   F_qi = .TRUE.
   IF ( moist_index_table( PARAM_qs , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qs = moist_num_table(idomain)
     moist_index_table( PARAM_qs , idomain ) = P_qs
   ELSE
     P_qs = moist_index_table( PARAM_qs , idomain )
   END IF
   moist_boundary_table( idomain, P_qs ) = .TRUE.
   moist_dname_table( idomain, P_qs ) = 'QSNOW'
   moist_desc_table( idomain, P_qs ) = 'Snow mixing ratio'
   moist_units_table( idomain, P_qs ) = 'kg kg-1'
   moist_streams_table( idomain, P_qs )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qs )%stream(2) = 2097152 
   F_qs = .TRUE.
   IF ( moist_index_table( PARAM_qg , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qg = moist_num_table(idomain)
     moist_index_table( PARAM_qg , idomain ) = P_qg
   ELSE
     P_qg = moist_index_table( PARAM_qg , idomain )
   END IF
   moist_boundary_table( idomain, P_qg ) = .TRUE.
   moist_dname_table( idomain, P_qg ) = 'QGRAUP'
   moist_desc_table( idomain, P_qg ) = 'Graupel mixing ratio'
   moist_units_table( idomain, P_qg ) = 'kg kg-1'
   moist_streams_table( idomain, P_qg )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qg )%stream(2) = 2097152 
   F_qg = .TRUE.
   IF ( moist_index_table( PARAM_qh , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qh = moist_num_table(idomain)
     moist_index_table( PARAM_qh , idomain ) = P_qh
   ELSE
     P_qh = moist_index_table( PARAM_qh , idomain )
   END IF
   moist_boundary_table( idomain, P_qh ) = .TRUE.
   moist_dname_table( idomain, P_qh ) = 'QHAIL'
   moist_desc_table( idomain, P_qh ) = 'Hail mixing ratio'
   moist_units_table( idomain, P_qh ) = 'kg kg-1'
   moist_streams_table( idomain, P_qh )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qh )%stream(2) = 2097152 
   F_qh = .TRUE.
  END IF
  IF (model_config_rec%mp_physics(idomain)==26)THEN
   IF ( moist_index_table( PARAM_qv , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qv = moist_num_table(idomain)
     moist_index_table( PARAM_qv , idomain ) = P_qv
   ELSE
     P_qv = moist_index_table( PARAM_qv , idomain )
   END IF
   moist_boundary_table( idomain, P_qv ) = .TRUE.
   moist_dname_table( idomain, P_qv ) = 'QVAPOR'
   moist_desc_table( idomain, P_qv ) = 'Water vapor mixing ratio'
   moist_units_table( idomain, P_qv ) = 'kg kg-1'
   moist_streams_table( idomain, P_qv )%stream(1) = 33554435 
   moist_streams_table( idomain, P_qv )%stream(2) = 2097152 
   F_qv = .TRUE.
   IF ( moist_index_table( PARAM_qc , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qc = moist_num_table(idomain)
     moist_index_table( PARAM_qc , idomain ) = P_qc
   ELSE
     P_qc = moist_index_table( PARAM_qc , idomain )
   END IF
   moist_boundary_table( idomain, P_qc ) = .TRUE.
   moist_dname_table( idomain, P_qc ) = 'QCLOUD'
   moist_desc_table( idomain, P_qc ) = 'Cloud water mixing ratio'
   moist_units_table( idomain, P_qc ) = 'kg kg-1'
   moist_streams_table( idomain, P_qc )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qc )%stream(2) = 2097152 
   F_qc = .TRUE.
   IF ( moist_index_table( PARAM_qr , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qr = moist_num_table(idomain)
     moist_index_table( PARAM_qr , idomain ) = P_qr
   ELSE
     P_qr = moist_index_table( PARAM_qr , idomain )
   END IF
   moist_boundary_table( idomain, P_qr ) = .TRUE.
   moist_dname_table( idomain, P_qr ) = 'QRAIN'
   moist_desc_table( idomain, P_qr ) = 'Rain water mixing ratio'
   moist_units_table( idomain, P_qr ) = 'kg kg-1'
   moist_streams_table( idomain, P_qr )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qr )%stream(2) = 2097152 
   F_qr = .TRUE.
   IF ( moist_index_table( PARAM_qi , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qi = moist_num_table(idomain)
     moist_index_table( PARAM_qi , idomain ) = P_qi
   ELSE
     P_qi = moist_index_table( PARAM_qi , idomain )
   END IF
   moist_boundary_table( idomain, P_qi ) = .TRUE.
   moist_dname_table( idomain, P_qi ) = 'QICE'
   moist_desc_table( idomain, P_qi ) = 'Ice mixing ratio'
   moist_units_table( idomain, P_qi ) = 'kg kg-1'
   moist_streams_table( idomain, P_qi )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qi )%stream(2) = 2097152 
   F_qi = .TRUE.
   IF ( moist_index_table( PARAM_qs , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qs = moist_num_table(idomain)
     moist_index_table( PARAM_qs , idomain ) = P_qs
   ELSE
     P_qs = moist_index_table( PARAM_qs , idomain )
   END IF
   moist_boundary_table( idomain, P_qs ) = .TRUE.
   moist_dname_table( idomain, P_qs ) = 'QSNOW'
   moist_desc_table( idomain, P_qs ) = 'Snow mixing ratio'
   moist_units_table( idomain, P_qs ) = 'kg kg-1'
   moist_streams_table( idomain, P_qs )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qs )%stream(2) = 2097152 
   F_qs = .TRUE.
   IF ( moist_index_table( PARAM_qg , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qg = moist_num_table(idomain)
     moist_index_table( PARAM_qg , idomain ) = P_qg
   ELSE
     P_qg = moist_index_table( PARAM_qg , idomain )
   END IF
   moist_boundary_table( idomain, P_qg ) = .TRUE.
   moist_dname_table( idomain, P_qg ) = 'QGRAUP'
   moist_desc_table( idomain, P_qg ) = 'Graupel mixing ratio'
   moist_units_table( idomain, P_qg ) = 'kg kg-1'
   moist_streams_table( idomain, P_qg )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qg )%stream(2) = 2097152 
   F_qg = .TRUE.
   IF ( moist_index_table( PARAM_qh , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qh = moist_num_table(idomain)
     moist_index_table( PARAM_qh , idomain ) = P_qh
   ELSE
     P_qh = moist_index_table( PARAM_qh , idomain )
   END IF
   moist_boundary_table( idomain, P_qh ) = .TRUE.
   moist_dname_table( idomain, P_qh ) = 'QHAIL'
   moist_desc_table( idomain, P_qh ) = 'Hail mixing ratio'
   moist_units_table( idomain, P_qh ) = 'kg kg-1'
   moist_streams_table( idomain, P_qh )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qh )%stream(2) = 2097152 
   F_qh = .TRUE.
   IF ( scalar_index_table( PARAM_qnn , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qnn = scalar_num_table(idomain)
     scalar_index_table( PARAM_qnn , idomain ) = P_qnn
   ELSE
     P_qnn = scalar_index_table( PARAM_qnn , idomain )
   END IF
   scalar_boundary_table( idomain, P_qnn ) = .TRUE.
   scalar_dname_table( idomain, P_qnn ) = 'QNCCN'
   scalar_desc_table( idomain, P_qnn ) = 'CCN Number concentration'
   scalar_units_table( idomain, P_qnn ) = '  kg(-1)'
   scalar_streams_table( idomain, P_qnn )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qnn )%stream(2) = 2097152 
   F_qnn = .TRUE.
   IF ( scalar_index_table( PARAM_qnc , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qnc = scalar_num_table(idomain)
     scalar_index_table( PARAM_qnc , idomain ) = P_qnc
   ELSE
     P_qnc = scalar_index_table( PARAM_qnc , idomain )
   END IF
   scalar_boundary_table( idomain, P_qnc ) = .TRUE.
   scalar_dname_table( idomain, P_qnc ) = 'QNCLOUD'
   scalar_desc_table( idomain, P_qnc ) = 'cloud water Number concentration'
   scalar_units_table( idomain, P_qnc ) = '  kg(-1)'
   scalar_streams_table( idomain, P_qnc )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qnc )%stream(2) = 2097152 
   F_qnc = .TRUE.
   IF ( scalar_index_table( PARAM_qnr , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qnr = scalar_num_table(idomain)
     scalar_index_table( PARAM_qnr , idomain ) = P_qnr
   ELSE
     P_qnr = scalar_index_table( PARAM_qnr , idomain )
   END IF
   scalar_boundary_table( idomain, P_qnr ) = .TRUE.
   scalar_dname_table( idomain, P_qnr ) = 'QNRAIN'
   scalar_desc_table( idomain, P_qnr ) = 'Rain Number concentration'
   scalar_units_table( idomain, P_qnr ) = '  kg(-1)'
   scalar_streams_table( idomain, P_qnr )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qnr )%stream(2) = 2097152 
   F_qnr = .TRUE.
  END IF
  IF (model_config_rec%mp_physics(idomain)==28)THEN
   IF ( moist_index_table( PARAM_qv , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qv = moist_num_table(idomain)
     moist_index_table( PARAM_qv , idomain ) = P_qv
   ELSE
     P_qv = moist_index_table( PARAM_qv , idomain )
   END IF
   moist_boundary_table( idomain, P_qv ) = .TRUE.
   moist_dname_table( idomain, P_qv ) = 'QVAPOR'
   moist_desc_table( idomain, P_qv ) = 'Water vapor mixing ratio'
   moist_units_table( idomain, P_qv ) = 'kg kg-1'
   moist_streams_table( idomain, P_qv )%stream(1) = 33554435 
   moist_streams_table( idomain, P_qv )%stream(2) = 2097152 
   F_qv = .TRUE.
   IF ( moist_index_table( PARAM_qc , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qc = moist_num_table(idomain)
     moist_index_table( PARAM_qc , idomain ) = P_qc
   ELSE
     P_qc = moist_index_table( PARAM_qc , idomain )
   END IF
   moist_boundary_table( idomain, P_qc ) = .TRUE.
   moist_dname_table( idomain, P_qc ) = 'QCLOUD'
   moist_desc_table( idomain, P_qc ) = 'Cloud water mixing ratio'
   moist_units_table( idomain, P_qc ) = 'kg kg-1'
   moist_streams_table( idomain, P_qc )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qc )%stream(2) = 2097152 
   F_qc = .TRUE.
   IF ( moist_index_table( PARAM_qr , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qr = moist_num_table(idomain)
     moist_index_table( PARAM_qr , idomain ) = P_qr
   ELSE
     P_qr = moist_index_table( PARAM_qr , idomain )
   END IF
   moist_boundary_table( idomain, P_qr ) = .TRUE.
   moist_dname_table( idomain, P_qr ) = 'QRAIN'
   moist_desc_table( idomain, P_qr ) = 'Rain water mixing ratio'
   moist_units_table( idomain, P_qr ) = 'kg kg-1'
   moist_streams_table( idomain, P_qr )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qr )%stream(2) = 2097152 
   F_qr = .TRUE.
   IF ( moist_index_table( PARAM_qi , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qi = moist_num_table(idomain)
     moist_index_table( PARAM_qi , idomain ) = P_qi
   ELSE
     P_qi = moist_index_table( PARAM_qi , idomain )
   END IF
   moist_boundary_table( idomain, P_qi ) = .TRUE.
   moist_dname_table( idomain, P_qi ) = 'QICE'
   moist_desc_table( idomain, P_qi ) = 'Ice mixing ratio'
   moist_units_table( idomain, P_qi ) = 'kg kg-1'
   moist_streams_table( idomain, P_qi )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qi )%stream(2) = 2097152 
   F_qi = .TRUE.
   IF ( moist_index_table( PARAM_qs , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qs = moist_num_table(idomain)
     moist_index_table( PARAM_qs , idomain ) = P_qs
   ELSE
     P_qs = moist_index_table( PARAM_qs , idomain )
   END IF
   moist_boundary_table( idomain, P_qs ) = .TRUE.
   moist_dname_table( idomain, P_qs ) = 'QSNOW'
   moist_desc_table( idomain, P_qs ) = 'Snow mixing ratio'
   moist_units_table( idomain, P_qs ) = 'kg kg-1'
   moist_streams_table( idomain, P_qs )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qs )%stream(2) = 2097152 
   F_qs = .TRUE.
   IF ( moist_index_table( PARAM_qg , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qg = moist_num_table(idomain)
     moist_index_table( PARAM_qg , idomain ) = P_qg
   ELSE
     P_qg = moist_index_table( PARAM_qg , idomain )
   END IF
   moist_boundary_table( idomain, P_qg ) = .TRUE.
   moist_dname_table( idomain, P_qg ) = 'QGRAUP'
   moist_desc_table( idomain, P_qg ) = 'Graupel mixing ratio'
   moist_units_table( idomain, P_qg ) = 'kg kg-1'
   moist_streams_table( idomain, P_qg )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qg )%stream(2) = 2097152 
   F_qg = .TRUE.
   IF ( scalar_index_table( PARAM_qni , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qni = scalar_num_table(idomain)
     scalar_index_table( PARAM_qni , idomain ) = P_qni
   ELSE
     P_qni = scalar_index_table( PARAM_qni , idomain )
   END IF
   scalar_boundary_table( idomain, P_qni ) = .TRUE.
   scalar_dname_table( idomain, P_qni ) = 'QNICE'
   scalar_desc_table( idomain, P_qni ) = 'Ice Number concentration'
   scalar_units_table( idomain, P_qni ) = '  kg-1'
   scalar_streams_table( idomain, P_qni )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qni )%stream(2) = 2097152 
   F_qni = .TRUE.
   IF ( scalar_index_table( PARAM_qnr , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qnr = scalar_num_table(idomain)
     scalar_index_table( PARAM_qnr , idomain ) = P_qnr
   ELSE
     P_qnr = scalar_index_table( PARAM_qnr , idomain )
   END IF
   scalar_boundary_table( idomain, P_qnr ) = .TRUE.
   scalar_dname_table( idomain, P_qnr ) = 'QNRAIN'
   scalar_desc_table( idomain, P_qnr ) = 'Rain Number concentration'
   scalar_units_table( idomain, P_qnr ) = '  kg(-1)'
   scalar_streams_table( idomain, P_qnr )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qnr )%stream(2) = 2097152 
   F_qnr = .TRUE.
   IF ( scalar_index_table( PARAM_qnc , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qnc = scalar_num_table(idomain)
     scalar_index_table( PARAM_qnc , idomain ) = P_qnc
   ELSE
     P_qnc = scalar_index_table( PARAM_qnc , idomain )
   END IF
   scalar_boundary_table( idomain, P_qnc ) = .TRUE.
   scalar_dname_table( idomain, P_qnc ) = 'QNCLOUD'
   scalar_desc_table( idomain, P_qnc ) = 'cloud water Number concentration'
   scalar_units_table( idomain, P_qnc ) = '  kg(-1)'
   scalar_streams_table( idomain, P_qnc )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qnc )%stream(2) = 2097152 
   F_qnc = .TRUE.
   IF ( scalar_index_table( PARAM_qnwfa , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qnwfa = scalar_num_table(idomain)
     scalar_index_table( PARAM_qnwfa , idomain ) = P_qnwfa
   ELSE
     P_qnwfa = scalar_index_table( PARAM_qnwfa , idomain )
   END IF
   scalar_boundary_table( idomain, P_qnwfa ) = .TRUE.
   scalar_dname_table( idomain, P_qnwfa ) = 'QNWFA'
   scalar_desc_table( idomain, P_qnwfa ) = 'water-friendly aerosol number con'
   scalar_units_table( idomain, P_qnwfa ) = '  kg(-1)'
   scalar_streams_table( idomain, P_qnwfa )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qnwfa )%stream(2) = 2097152 
   F_qnwfa = .TRUE.
   IF ( scalar_index_table( PARAM_qnifa , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qnifa = scalar_num_table(idomain)
     scalar_index_table( PARAM_qnifa , idomain ) = P_qnifa
   ELSE
     P_qnifa = scalar_index_table( PARAM_qnifa , idomain )
   END IF
   scalar_boundary_table( idomain, P_qnifa ) = .TRUE.
   scalar_dname_table( idomain, P_qnifa ) = 'QNIFA'
   scalar_desc_table( idomain, P_qnifa ) = 'ice-friendly aerosol number con'
   scalar_units_table( idomain, P_qnifa ) = '  kg(-1)'
   scalar_streams_table( idomain, P_qnifa )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qnifa )%stream(2) = 2097152 
   F_qnifa = .TRUE.
  END IF
  IF (model_config_rec%mp_physics(idomain)==50)THEN
   IF ( moist_index_table( PARAM_qv , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qv = moist_num_table(idomain)
     moist_index_table( PARAM_qv , idomain ) = P_qv
   ELSE
     P_qv = moist_index_table( PARAM_qv , idomain )
   END IF
   moist_boundary_table( idomain, P_qv ) = .TRUE.
   moist_dname_table( idomain, P_qv ) = 'QVAPOR'
   moist_desc_table( idomain, P_qv ) = 'Water vapor mixing ratio'
   moist_units_table( idomain, P_qv ) = 'kg kg-1'
   moist_streams_table( idomain, P_qv )%stream(1) = 33554435 
   moist_streams_table( idomain, P_qv )%stream(2) = 2097152 
   F_qv = .TRUE.
   IF ( moist_index_table( PARAM_qc , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qc = moist_num_table(idomain)
     moist_index_table( PARAM_qc , idomain ) = P_qc
   ELSE
     P_qc = moist_index_table( PARAM_qc , idomain )
   END IF
   moist_boundary_table( idomain, P_qc ) = .TRUE.
   moist_dname_table( idomain, P_qc ) = 'QCLOUD'
   moist_desc_table( idomain, P_qc ) = 'Cloud water mixing ratio'
   moist_units_table( idomain, P_qc ) = 'kg kg-1'
   moist_streams_table( idomain, P_qc )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qc )%stream(2) = 2097152 
   F_qc = .TRUE.
   IF ( moist_index_table( PARAM_qr , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qr = moist_num_table(idomain)
     moist_index_table( PARAM_qr , idomain ) = P_qr
   ELSE
     P_qr = moist_index_table( PARAM_qr , idomain )
   END IF
   moist_boundary_table( idomain, P_qr ) = .TRUE.
   moist_dname_table( idomain, P_qr ) = 'QRAIN'
   moist_desc_table( idomain, P_qr ) = 'Rain water mixing ratio'
   moist_units_table( idomain, P_qr ) = 'kg kg-1'
   moist_streams_table( idomain, P_qr )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qr )%stream(2) = 2097152 
   F_qr = .TRUE.
   IF ( moist_index_table( PARAM_qi , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qi = moist_num_table(idomain)
     moist_index_table( PARAM_qi , idomain ) = P_qi
   ELSE
     P_qi = moist_index_table( PARAM_qi , idomain )
   END IF
   moist_boundary_table( idomain, P_qi ) = .TRUE.
   moist_dname_table( idomain, P_qi ) = 'QICE'
   moist_desc_table( idomain, P_qi ) = 'Ice mixing ratio'
   moist_units_table( idomain, P_qi ) = 'kg kg-1'
   moist_streams_table( idomain, P_qi )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qi )%stream(2) = 2097152 
   F_qi = .TRUE.
   IF ( scalar_index_table( PARAM_qni , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qni = scalar_num_table(idomain)
     scalar_index_table( PARAM_qni , idomain ) = P_qni
   ELSE
     P_qni = scalar_index_table( PARAM_qni , idomain )
   END IF
   scalar_boundary_table( idomain, P_qni ) = .TRUE.
   scalar_dname_table( idomain, P_qni ) = 'QNICE'
   scalar_desc_table( idomain, P_qni ) = 'Ice Number concentration'
   scalar_units_table( idomain, P_qni ) = '  kg-1'
   scalar_streams_table( idomain, P_qni )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qni )%stream(2) = 2097152 
   F_qni = .TRUE.
   IF ( scalar_index_table( PARAM_qnr , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qnr = scalar_num_table(idomain)
     scalar_index_table( PARAM_qnr , idomain ) = P_qnr
   ELSE
     P_qnr = scalar_index_table( PARAM_qnr , idomain )
   END IF
   scalar_boundary_table( idomain, P_qnr ) = .TRUE.
   scalar_dname_table( idomain, P_qnr ) = 'QNRAIN'
   scalar_desc_table( idomain, P_qnr ) = 'Rain Number concentration'
   scalar_units_table( idomain, P_qnr ) = '  kg(-1)'
   scalar_streams_table( idomain, P_qnr )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qnr )%stream(2) = 2097152 
   F_qnr = .TRUE.
   IF ( scalar_index_table( PARAM_qir , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qir = scalar_num_table(idomain)
     scalar_index_table( PARAM_qir , idomain ) = P_qir
   ELSE
     P_qir = scalar_index_table( PARAM_qir , idomain )
   END IF
   scalar_boundary_table( idomain, P_qir ) = .TRUE.
   scalar_dname_table( idomain, P_qir ) = 'QIR'
   scalar_desc_table( idomain, P_qir ) = 'Rime ice mass-1 mixing ratio'
   scalar_units_table( idomain, P_qir ) = 'kg kg(-1)'
   scalar_streams_table( idomain, P_qir )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qir )%stream(2) = 2097152 
   F_qir = .TRUE.
   IF ( scalar_index_table( PARAM_qib , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qib = scalar_num_table(idomain)
     scalar_index_table( PARAM_qib , idomain ) = P_qib
   ELSE
     P_qib = scalar_index_table( PARAM_qib , idomain )
   END IF
   scalar_boundary_table( idomain, P_qib ) = .TRUE.
   scalar_dname_table( idomain, P_qib ) = 'QIB'
   scalar_desc_table( idomain, P_qib ) = 'Rime ice volume-1 mixing ratio'
   scalar_units_table( idomain, P_qib ) = 'm(3) kg(-1)'
   scalar_streams_table( idomain, P_qib )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qib )%stream(2) = 2097152 
   F_qib = .TRUE.
  END IF
  IF (model_config_rec%mp_physics(idomain)==51)THEN
   IF ( moist_index_table( PARAM_qv , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qv = moist_num_table(idomain)
     moist_index_table( PARAM_qv , idomain ) = P_qv
   ELSE
     P_qv = moist_index_table( PARAM_qv , idomain )
   END IF
   moist_boundary_table( idomain, P_qv ) = .TRUE.
   moist_dname_table( idomain, P_qv ) = 'QVAPOR'
   moist_desc_table( idomain, P_qv ) = 'Water vapor mixing ratio'
   moist_units_table( idomain, P_qv ) = 'kg kg-1'
   moist_streams_table( idomain, P_qv )%stream(1) = 33554435 
   moist_streams_table( idomain, P_qv )%stream(2) = 2097152 
   F_qv = .TRUE.
   IF ( moist_index_table( PARAM_qc , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qc = moist_num_table(idomain)
     moist_index_table( PARAM_qc , idomain ) = P_qc
   ELSE
     P_qc = moist_index_table( PARAM_qc , idomain )
   END IF
   moist_boundary_table( idomain, P_qc ) = .TRUE.
   moist_dname_table( idomain, P_qc ) = 'QCLOUD'
   moist_desc_table( idomain, P_qc ) = 'Cloud water mixing ratio'
   moist_units_table( idomain, P_qc ) = 'kg kg-1'
   moist_streams_table( idomain, P_qc )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qc )%stream(2) = 2097152 
   F_qc = .TRUE.
   IF ( moist_index_table( PARAM_qr , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qr = moist_num_table(idomain)
     moist_index_table( PARAM_qr , idomain ) = P_qr
   ELSE
     P_qr = moist_index_table( PARAM_qr , idomain )
   END IF
   moist_boundary_table( idomain, P_qr ) = .TRUE.
   moist_dname_table( idomain, P_qr ) = 'QRAIN'
   moist_desc_table( idomain, P_qr ) = 'Rain water mixing ratio'
   moist_units_table( idomain, P_qr ) = 'kg kg-1'
   moist_streams_table( idomain, P_qr )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qr )%stream(2) = 2097152 
   F_qr = .TRUE.
   IF ( moist_index_table( PARAM_qi , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qi = moist_num_table(idomain)
     moist_index_table( PARAM_qi , idomain ) = P_qi
   ELSE
     P_qi = moist_index_table( PARAM_qi , idomain )
   END IF
   moist_boundary_table( idomain, P_qi ) = .TRUE.
   moist_dname_table( idomain, P_qi ) = 'QICE'
   moist_desc_table( idomain, P_qi ) = 'Ice mixing ratio'
   moist_units_table( idomain, P_qi ) = 'kg kg-1'
   moist_streams_table( idomain, P_qi )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qi )%stream(2) = 2097152 
   F_qi = .TRUE.
   IF ( scalar_index_table( PARAM_qnc , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qnc = scalar_num_table(idomain)
     scalar_index_table( PARAM_qnc , idomain ) = P_qnc
   ELSE
     P_qnc = scalar_index_table( PARAM_qnc , idomain )
   END IF
   scalar_boundary_table( idomain, P_qnc ) = .TRUE.
   scalar_dname_table( idomain, P_qnc ) = 'QNCLOUD'
   scalar_desc_table( idomain, P_qnc ) = 'cloud water Number concentration'
   scalar_units_table( idomain, P_qnc ) = '  kg(-1)'
   scalar_streams_table( idomain, P_qnc )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qnc )%stream(2) = 2097152 
   F_qnc = .TRUE.
   IF ( scalar_index_table( PARAM_qni , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qni = scalar_num_table(idomain)
     scalar_index_table( PARAM_qni , idomain ) = P_qni
   ELSE
     P_qni = scalar_index_table( PARAM_qni , idomain )
   END IF
   scalar_boundary_table( idomain, P_qni ) = .TRUE.
   scalar_dname_table( idomain, P_qni ) = 'QNICE'
   scalar_desc_table( idomain, P_qni ) = 'Ice Number concentration'
   scalar_units_table( idomain, P_qni ) = '  kg-1'
   scalar_streams_table( idomain, P_qni )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qni )%stream(2) = 2097152 
   F_qni = .TRUE.
   IF ( scalar_index_table( PARAM_qnr , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qnr = scalar_num_table(idomain)
     scalar_index_table( PARAM_qnr , idomain ) = P_qnr
   ELSE
     P_qnr = scalar_index_table( PARAM_qnr , idomain )
   END IF
   scalar_boundary_table( idomain, P_qnr ) = .TRUE.
   scalar_dname_table( idomain, P_qnr ) = 'QNRAIN'
   scalar_desc_table( idomain, P_qnr ) = 'Rain Number concentration'
   scalar_units_table( idomain, P_qnr ) = '  kg(-1)'
   scalar_streams_table( idomain, P_qnr )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qnr )%stream(2) = 2097152 
   F_qnr = .TRUE.
   IF ( scalar_index_table( PARAM_qir , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qir = scalar_num_table(idomain)
     scalar_index_table( PARAM_qir , idomain ) = P_qir
   ELSE
     P_qir = scalar_index_table( PARAM_qir , idomain )
   END IF
   scalar_boundary_table( idomain, P_qir ) = .TRUE.
   scalar_dname_table( idomain, P_qir ) = 'QIR'
   scalar_desc_table( idomain, P_qir ) = 'Rime ice mass-1 mixing ratio'
   scalar_units_table( idomain, P_qir ) = 'kg kg(-1)'
   scalar_streams_table( idomain, P_qir )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qir )%stream(2) = 2097152 
   F_qir = .TRUE.
   IF ( scalar_index_table( PARAM_qib , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qib = scalar_num_table(idomain)
     scalar_index_table( PARAM_qib , idomain ) = P_qib
   ELSE
     P_qib = scalar_index_table( PARAM_qib , idomain )
   END IF
   scalar_boundary_table( idomain, P_qib ) = .TRUE.
   scalar_dname_table( idomain, P_qib ) = 'QIB'
   scalar_desc_table( idomain, P_qib ) = 'Rime ice volume-1 mixing ratio'
   scalar_units_table( idomain, P_qib ) = 'm(3) kg(-1)'
   scalar_streams_table( idomain, P_qib )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qib )%stream(2) = 2097152 
   F_qib = .TRUE.
  END IF
  IF (model_config_rec%mp_physics(idomain)==52)THEN
   IF ( moist_index_table( PARAM_qv , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qv = moist_num_table(idomain)
     moist_index_table( PARAM_qv , idomain ) = P_qv
   ELSE
     P_qv = moist_index_table( PARAM_qv , idomain )
   END IF
   moist_boundary_table( idomain, P_qv ) = .TRUE.
   moist_dname_table( idomain, P_qv ) = 'QVAPOR'
   moist_desc_table( idomain, P_qv ) = 'Water vapor mixing ratio'
   moist_units_table( idomain, P_qv ) = 'kg kg-1'
   moist_streams_table( idomain, P_qv )%stream(1) = 33554435 
   moist_streams_table( idomain, P_qv )%stream(2) = 2097152 
   F_qv = .TRUE.
   IF ( moist_index_table( PARAM_qc , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qc = moist_num_table(idomain)
     moist_index_table( PARAM_qc , idomain ) = P_qc
   ELSE
     P_qc = moist_index_table( PARAM_qc , idomain )
   END IF
   moist_boundary_table( idomain, P_qc ) = .TRUE.
   moist_dname_table( idomain, P_qc ) = 'QCLOUD'
   moist_desc_table( idomain, P_qc ) = 'Cloud water mixing ratio'
   moist_units_table( idomain, P_qc ) = 'kg kg-1'
   moist_streams_table( idomain, P_qc )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qc )%stream(2) = 2097152 
   F_qc = .TRUE.
   IF ( moist_index_table( PARAM_qr , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qr = moist_num_table(idomain)
     moist_index_table( PARAM_qr , idomain ) = P_qr
   ELSE
     P_qr = moist_index_table( PARAM_qr , idomain )
   END IF
   moist_boundary_table( idomain, P_qr ) = .TRUE.
   moist_dname_table( idomain, P_qr ) = 'QRAIN'
   moist_desc_table( idomain, P_qr ) = 'Rain water mixing ratio'
   moist_units_table( idomain, P_qr ) = 'kg kg-1'
   moist_streams_table( idomain, P_qr )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qr )%stream(2) = 2097152 
   F_qr = .TRUE.
   IF ( moist_index_table( PARAM_qi , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qi = moist_num_table(idomain)
     moist_index_table( PARAM_qi , idomain ) = P_qi
   ELSE
     P_qi = moist_index_table( PARAM_qi , idomain )
   END IF
   moist_boundary_table( idomain, P_qi ) = .TRUE.
   moist_dname_table( idomain, P_qi ) = 'QICE'
   moist_desc_table( idomain, P_qi ) = 'Ice mixing ratio'
   moist_units_table( idomain, P_qi ) = 'kg kg-1'
   moist_streams_table( idomain, P_qi )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qi )%stream(2) = 2097152 
   F_qi = .TRUE.
   IF ( moist_index_table( PARAM_qi2 , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qi2 = moist_num_table(idomain)
     moist_index_table( PARAM_qi2 , idomain ) = P_qi2
   ELSE
     P_qi2 = moist_index_table( PARAM_qi2 , idomain )
   END IF
   moist_boundary_table( idomain, P_qi2 ) = .TRUE.
   moist_dname_table( idomain, P_qi2 ) = 'QICE2'
   moist_desc_table( idomain, P_qi2 ) = 'Ice mixing ratio cat 2'
   moist_units_table( idomain, P_qi2 ) = 'kg kg-1'
   moist_streams_table( idomain, P_qi2 )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qi2 )%stream(2) = 2097152 
   F_qi2 = .TRUE.
   IF ( scalar_index_table( PARAM_qnc , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qnc = scalar_num_table(idomain)
     scalar_index_table( PARAM_qnc , idomain ) = P_qnc
   ELSE
     P_qnc = scalar_index_table( PARAM_qnc , idomain )
   END IF
   scalar_boundary_table( idomain, P_qnc ) = .TRUE.
   scalar_dname_table( idomain, P_qnc ) = 'QNCLOUD'
   scalar_desc_table( idomain, P_qnc ) = 'cloud water Number concentration'
   scalar_units_table( idomain, P_qnc ) = '  kg(-1)'
   scalar_streams_table( idomain, P_qnc )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qnc )%stream(2) = 2097152 
   F_qnc = .TRUE.
   IF ( scalar_index_table( PARAM_qni , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qni = scalar_num_table(idomain)
     scalar_index_table( PARAM_qni , idomain ) = P_qni
   ELSE
     P_qni = scalar_index_table( PARAM_qni , idomain )
   END IF
   scalar_boundary_table( idomain, P_qni ) = .TRUE.
   scalar_dname_table( idomain, P_qni ) = 'QNICE'
   scalar_desc_table( idomain, P_qni ) = 'Ice Number concentration'
   scalar_units_table( idomain, P_qni ) = '  kg-1'
   scalar_streams_table( idomain, P_qni )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qni )%stream(2) = 2097152 
   F_qni = .TRUE.
   IF ( scalar_index_table( PARAM_qnr , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qnr = scalar_num_table(idomain)
     scalar_index_table( PARAM_qnr , idomain ) = P_qnr
   ELSE
     P_qnr = scalar_index_table( PARAM_qnr , idomain )
   END IF
   scalar_boundary_table( idomain, P_qnr ) = .TRUE.
   scalar_dname_table( idomain, P_qnr ) = 'QNRAIN'
   scalar_desc_table( idomain, P_qnr ) = 'Rain Number concentration'
   scalar_units_table( idomain, P_qnr ) = '  kg(-1)'
   scalar_streams_table( idomain, P_qnr )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qnr )%stream(2) = 2097152 
   F_qnr = .TRUE.
   IF ( scalar_index_table( PARAM_qir , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qir = scalar_num_table(idomain)
     scalar_index_table( PARAM_qir , idomain ) = P_qir
   ELSE
     P_qir = scalar_index_table( PARAM_qir , idomain )
   END IF
   scalar_boundary_table( idomain, P_qir ) = .TRUE.
   scalar_dname_table( idomain, P_qir ) = 'QIR'
   scalar_desc_table( idomain, P_qir ) = 'Rime ice mass-1 mixing ratio'
   scalar_units_table( idomain, P_qir ) = 'kg kg(-1)'
   scalar_streams_table( idomain, P_qir )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qir )%stream(2) = 2097152 
   F_qir = .TRUE.
   IF ( scalar_index_table( PARAM_qib , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qib = scalar_num_table(idomain)
     scalar_index_table( PARAM_qib , idomain ) = P_qib
   ELSE
     P_qib = scalar_index_table( PARAM_qib , idomain )
   END IF
   scalar_boundary_table( idomain, P_qib ) = .TRUE.
   scalar_dname_table( idomain, P_qib ) = 'QIB'
   scalar_desc_table( idomain, P_qib ) = 'Rime ice volume-1 mixing ratio'
   scalar_units_table( idomain, P_qib ) = 'm(3) kg(-1)'
   scalar_streams_table( idomain, P_qib )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qib )%stream(2) = 2097152 
   F_qib = .TRUE.
   IF ( scalar_index_table( PARAM_qni2 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qni2 = scalar_num_table(idomain)
     scalar_index_table( PARAM_qni2 , idomain ) = P_qni2
   ELSE
     P_qni2 = scalar_index_table( PARAM_qni2 , idomain )
   END IF
   scalar_boundary_table( idomain, P_qni2 ) = .TRUE.
   scalar_dname_table( idomain, P_qni2 ) = 'QNICE2'
   scalar_desc_table( idomain, P_qni2 ) = 'Ice Number concentration cat 2'
   scalar_units_table( idomain, P_qni2 ) = '  kg-1'
   scalar_streams_table( idomain, P_qni2 )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qni2 )%stream(2) = 2097152 
   F_qni2 = .TRUE.
   IF ( scalar_index_table( PARAM_qir2 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qir2 = scalar_num_table(idomain)
     scalar_index_table( PARAM_qir2 , idomain ) = P_qir2
   ELSE
     P_qir2 = scalar_index_table( PARAM_qir2 , idomain )
   END IF
   scalar_boundary_table( idomain, P_qir2 ) = .TRUE.
   scalar_dname_table( idomain, P_qir2 ) = 'QIR2'
   scalar_desc_table( idomain, P_qir2 ) = 'Rime ice mass-2 mixing ratio'
   scalar_units_table( idomain, P_qir2 ) = 'kg kg(-1)'
   scalar_streams_table( idomain, P_qir2 )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qir2 )%stream(2) = 2097152 
   F_qir2 = .TRUE.
   IF ( scalar_index_table( PARAM_qib2 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qib2 = scalar_num_table(idomain)
     scalar_index_table( PARAM_qib2 , idomain ) = P_qib2
   ELSE
     P_qib2 = scalar_index_table( PARAM_qib2 , idomain )
   END IF
   scalar_boundary_table( idomain, P_qib2 ) = .TRUE.
   scalar_dname_table( idomain, P_qib2 ) = 'QIB2'
   scalar_desc_table( idomain, P_qib2 ) = 'Rime ice volume-2 mixing ratio'
   scalar_units_table( idomain, P_qib2 ) = 'm(3) kg(-1)'
   scalar_streams_table( idomain, P_qib2 )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qib2 )%stream(2) = 2097152 
   F_qib2 = .TRUE.
  END IF
  IF (model_config_rec%mp_physics(idomain)==40)THEN
   IF ( moist_index_table( PARAM_qv , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qv = moist_num_table(idomain)
     moist_index_table( PARAM_qv , idomain ) = P_qv
   ELSE
     P_qv = moist_index_table( PARAM_qv , idomain )
   END IF
   moist_boundary_table( idomain, P_qv ) = .TRUE.
   moist_dname_table( idomain, P_qv ) = 'QVAPOR'
   moist_desc_table( idomain, P_qv ) = 'Water vapor mixing ratio'
   moist_units_table( idomain, P_qv ) = 'kg kg-1'
   moist_streams_table( idomain, P_qv )%stream(1) = 33554435 
   moist_streams_table( idomain, P_qv )%stream(2) = 2097152 
   F_qv = .TRUE.
   IF ( moist_index_table( PARAM_qc , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qc = moist_num_table(idomain)
     moist_index_table( PARAM_qc , idomain ) = P_qc
   ELSE
     P_qc = moist_index_table( PARAM_qc , idomain )
   END IF
   moist_boundary_table( idomain, P_qc ) = .TRUE.
   moist_dname_table( idomain, P_qc ) = 'QCLOUD'
   moist_desc_table( idomain, P_qc ) = 'Cloud water mixing ratio'
   moist_units_table( idomain, P_qc ) = 'kg kg-1'
   moist_streams_table( idomain, P_qc )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qc )%stream(2) = 2097152 
   F_qc = .TRUE.
   IF ( moist_index_table( PARAM_qr , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qr = moist_num_table(idomain)
     moist_index_table( PARAM_qr , idomain ) = P_qr
   ELSE
     P_qr = moist_index_table( PARAM_qr , idomain )
   END IF
   moist_boundary_table( idomain, P_qr ) = .TRUE.
   moist_dname_table( idomain, P_qr ) = 'QRAIN'
   moist_desc_table( idomain, P_qr ) = 'Rain water mixing ratio'
   moist_units_table( idomain, P_qr ) = 'kg kg-1'
   moist_streams_table( idomain, P_qr )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qr )%stream(2) = 2097152 
   F_qr = .TRUE.
   IF ( moist_index_table( PARAM_qi , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qi = moist_num_table(idomain)
     moist_index_table( PARAM_qi , idomain ) = P_qi
   ELSE
     P_qi = moist_index_table( PARAM_qi , idomain )
   END IF
   moist_boundary_table( idomain, P_qi ) = .TRUE.
   moist_dname_table( idomain, P_qi ) = 'QICE'
   moist_desc_table( idomain, P_qi ) = 'Ice mixing ratio'
   moist_units_table( idomain, P_qi ) = 'kg kg-1'
   moist_streams_table( idomain, P_qi )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qi )%stream(2) = 2097152 
   F_qi = .TRUE.
   IF ( moist_index_table( PARAM_qs , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qs = moist_num_table(idomain)
     moist_index_table( PARAM_qs , idomain ) = P_qs
   ELSE
     P_qs = moist_index_table( PARAM_qs , idomain )
   END IF
   moist_boundary_table( idomain, P_qs ) = .TRUE.
   moist_dname_table( idomain, P_qs ) = 'QSNOW'
   moist_desc_table( idomain, P_qs ) = 'Snow mixing ratio'
   moist_units_table( idomain, P_qs ) = 'kg kg-1'
   moist_streams_table( idomain, P_qs )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qs )%stream(2) = 2097152 
   F_qs = .TRUE.
   IF ( moist_index_table( PARAM_qg , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qg = moist_num_table(idomain)
     moist_index_table( PARAM_qg , idomain ) = P_qg
   ELSE
     P_qg = moist_index_table( PARAM_qg , idomain )
   END IF
   moist_boundary_table( idomain, P_qg ) = .TRUE.
   moist_dname_table( idomain, P_qg ) = 'QGRAUP'
   moist_desc_table( idomain, P_qg ) = 'Graupel mixing ratio'
   moist_units_table( idomain, P_qg ) = 'kg kg-1'
   moist_streams_table( idomain, P_qg )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qg )%stream(2) = 2097152 
   F_qg = .TRUE.
   IF ( scalar_index_table( PARAM_qnc , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qnc = scalar_num_table(idomain)
     scalar_index_table( PARAM_qnc , idomain ) = P_qnc
   ELSE
     P_qnc = scalar_index_table( PARAM_qnc , idomain )
   END IF
   scalar_boundary_table( idomain, P_qnc ) = .TRUE.
   scalar_dname_table( idomain, P_qnc ) = 'QNCLOUD'
   scalar_desc_table( idomain, P_qnc ) = 'cloud water Number concentration'
   scalar_units_table( idomain, P_qnc ) = '  kg(-1)'
   scalar_streams_table( idomain, P_qnc )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qnc )%stream(2) = 2097152 
   F_qnc = .TRUE.
   IF ( scalar_index_table( PARAM_qni , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qni = scalar_num_table(idomain)
     scalar_index_table( PARAM_qni , idomain ) = P_qni
   ELSE
     P_qni = scalar_index_table( PARAM_qni , idomain )
   END IF
   scalar_boundary_table( idomain, P_qni ) = .TRUE.
   scalar_dname_table( idomain, P_qni ) = 'QNICE'
   scalar_desc_table( idomain, P_qni ) = 'Ice Number concentration'
   scalar_units_table( idomain, P_qni ) = '  kg-1'
   scalar_streams_table( idomain, P_qni )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qni )%stream(2) = 2097152 
   F_qni = .TRUE.
   IF ( scalar_index_table( PARAM_qns , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qns = scalar_num_table(idomain)
     scalar_index_table( PARAM_qns , idomain ) = P_qns
   ELSE
     P_qns = scalar_index_table( PARAM_qns , idomain )
   END IF
   scalar_boundary_table( idomain, P_qns ) = .TRUE.
   scalar_dname_table( idomain, P_qns ) = 'QNSNOW'
   scalar_desc_table( idomain, P_qns ) = 'Snow Number concentration'
   scalar_units_table( idomain, P_qns ) = '  kg(-1)'
   scalar_streams_table( idomain, P_qns )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qns )%stream(2) = 2097152 
   F_qns = .TRUE.
   IF ( scalar_index_table( PARAM_qnr , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qnr = scalar_num_table(idomain)
     scalar_index_table( PARAM_qnr , idomain ) = P_qnr
   ELSE
     P_qnr = scalar_index_table( PARAM_qnr , idomain )
   END IF
   scalar_boundary_table( idomain, P_qnr ) = .TRUE.
   scalar_dname_table( idomain, P_qnr ) = 'QNRAIN'
   scalar_desc_table( idomain, P_qnr ) = 'Rain Number concentration'
   scalar_units_table( idomain, P_qnr ) = '  kg(-1)'
   scalar_streams_table( idomain, P_qnr )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qnr )%stream(2) = 2097152 
   F_qnr = .TRUE.
   IF ( scalar_index_table( PARAM_qng , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qng = scalar_num_table(idomain)
     scalar_index_table( PARAM_qng , idomain ) = P_qng
   ELSE
     P_qng = scalar_index_table( PARAM_qng , idomain )
   END IF
   scalar_boundary_table( idomain, P_qng ) = .TRUE.
   scalar_dname_table( idomain, P_qng ) = 'QNGRAUPEL'
   scalar_desc_table( idomain, P_qng ) = 'Graupel Number concentration'
   scalar_units_table( idomain, P_qng ) = '  kg(-1)'
   scalar_streams_table( idomain, P_qng )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qng )%stream(2) = 2097152 
   F_qng = .TRUE.
  END IF
  IF (model_config_rec%mp_physics(idomain)==55)THEN
   IF ( moist_index_table( PARAM_qv , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qv = moist_num_table(idomain)
     moist_index_table( PARAM_qv , idomain ) = P_qv
   ELSE
     P_qv = moist_index_table( PARAM_qv , idomain )
   END IF
   moist_boundary_table( idomain, P_qv ) = .TRUE.
   moist_dname_table( idomain, P_qv ) = 'QVAPOR'
   moist_desc_table( idomain, P_qv ) = 'Water vapor mixing ratio'
   moist_units_table( idomain, P_qv ) = 'kg kg-1'
   moist_streams_table( idomain, P_qv )%stream(1) = 33554435 
   moist_streams_table( idomain, P_qv )%stream(2) = 2097152 
   F_qv = .TRUE.
   IF ( moist_index_table( PARAM_qc , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qc = moist_num_table(idomain)
     moist_index_table( PARAM_qc , idomain ) = P_qc
   ELSE
     P_qc = moist_index_table( PARAM_qc , idomain )
   END IF
   moist_boundary_table( idomain, P_qc ) = .TRUE.
   moist_dname_table( idomain, P_qc ) = 'QCLOUD'
   moist_desc_table( idomain, P_qc ) = 'Cloud water mixing ratio'
   moist_units_table( idomain, P_qc ) = 'kg kg-1'
   moist_streams_table( idomain, P_qc )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qc )%stream(2) = 2097152 
   F_qc = .TRUE.
   IF ( moist_index_table( PARAM_qr , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qr = moist_num_table(idomain)
     moist_index_table( PARAM_qr , idomain ) = P_qr
   ELSE
     P_qr = moist_index_table( PARAM_qr , idomain )
   END IF
   moist_boundary_table( idomain, P_qr ) = .TRUE.
   moist_dname_table( idomain, P_qr ) = 'QRAIN'
   moist_desc_table( idomain, P_qr ) = 'Rain water mixing ratio'
   moist_units_table( idomain, P_qr ) = 'kg kg-1'
   moist_streams_table( idomain, P_qr )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qr )%stream(2) = 2097152 
   F_qr = .TRUE.
   IF ( moist_index_table( PARAM_qi , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qi = moist_num_table(idomain)
     moist_index_table( PARAM_qi , idomain ) = P_qi
   ELSE
     P_qi = moist_index_table( PARAM_qi , idomain )
   END IF
   moist_boundary_table( idomain, P_qi ) = .TRUE.
   moist_dname_table( idomain, P_qi ) = 'QICE'
   moist_desc_table( idomain, P_qi ) = 'Ice mixing ratio'
   moist_units_table( idomain, P_qi ) = 'kg kg-1'
   moist_streams_table( idomain, P_qi )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qi )%stream(2) = 2097152 
   F_qi = .TRUE.
   IF ( moist_index_table( PARAM_qi2 , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qi2 = moist_num_table(idomain)
     moist_index_table( PARAM_qi2 , idomain ) = P_qi2
   ELSE
     P_qi2 = moist_index_table( PARAM_qi2 , idomain )
   END IF
   moist_boundary_table( idomain, P_qi2 ) = .TRUE.
   moist_dname_table( idomain, P_qi2 ) = 'QICE2'
   moist_desc_table( idomain, P_qi2 ) = 'Ice mixing ratio cat 2'
   moist_units_table( idomain, P_qi2 ) = 'kg kg-1'
   moist_streams_table( idomain, P_qi2 )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qi2 )%stream(2) = 2097152 
   F_qi2 = .TRUE.
   IF ( moist_index_table( PARAM_qi3 , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qi3 = moist_num_table(idomain)
     moist_index_table( PARAM_qi3 , idomain ) = P_qi3
   ELSE
     P_qi3 = moist_index_table( PARAM_qi3 , idomain )
   END IF
   moist_boundary_table( idomain, P_qi3 ) = .TRUE.
   moist_dname_table( idomain, P_qi3 ) = 'QICE3'
   moist_desc_table( idomain, P_qi3 ) = 'Ice mixing ratio cat 3'
   moist_units_table( idomain, P_qi3 ) = 'kg kg-1'
   moist_streams_table( idomain, P_qi3 )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qi3 )%stream(2) = 2097152 
   F_qi3 = .TRUE.
   IF ( scalar_index_table( PARAM_qnr , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qnr = scalar_num_table(idomain)
     scalar_index_table( PARAM_qnr , idomain ) = P_qnr
   ELSE
     P_qnr = scalar_index_table( PARAM_qnr , idomain )
   END IF
   scalar_boundary_table( idomain, P_qnr ) = .TRUE.
   scalar_dname_table( idomain, P_qnr ) = 'QNRAIN'
   scalar_desc_table( idomain, P_qnr ) = 'Rain Number concentration'
   scalar_units_table( idomain, P_qnr ) = '  kg(-1)'
   scalar_streams_table( idomain, P_qnr )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qnr )%stream(2) = 2097152 
   F_qnr = .TRUE.
   IF ( scalar_index_table( PARAM_qni , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qni = scalar_num_table(idomain)
     scalar_index_table( PARAM_qni , idomain ) = P_qni
   ELSE
     P_qni = scalar_index_table( PARAM_qni , idomain )
   END IF
   scalar_boundary_table( idomain, P_qni ) = .TRUE.
   scalar_dname_table( idomain, P_qni ) = 'QNICE'
   scalar_desc_table( idomain, P_qni ) = 'Ice Number concentration'
   scalar_units_table( idomain, P_qni ) = '  kg-1'
   scalar_streams_table( idomain, P_qni )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qni )%stream(2) = 2097152 
   F_qni = .TRUE.
   IF ( scalar_index_table( PARAM_qvoli , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qvoli = scalar_num_table(idomain)
     scalar_index_table( PARAM_qvoli , idomain ) = P_qvoli
   ELSE
     P_qvoli = scalar_index_table( PARAM_qvoli , idomain )
   END IF
   scalar_boundary_table( idomain, P_qvoli ) = .TRUE.
   scalar_dname_table( idomain, P_qvoli ) = 'QVOLI'
   scalar_desc_table( idomain, P_qvoli ) = 'Ice volume-1 mixing ratio'
   scalar_units_table( idomain, P_qvoli ) = 'm(3) kg(-1)'
   scalar_streams_table( idomain, P_qvoli )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qvoli )%stream(2) = 2097152 
   F_qvoli = .TRUE.
   IF ( scalar_index_table( PARAM_qaoli , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qaoli = scalar_num_table(idomain)
     scalar_index_table( PARAM_qaoli , idomain ) = P_qaoli
   ELSE
     P_qaoli = scalar_index_table( PARAM_qaoli , idomain )
   END IF
   scalar_boundary_table( idomain, P_qaoli ) = .TRUE.
   scalar_dname_table( idomain, P_qaoli ) = 'QAOLI'
   scalar_desc_table( idomain, P_qaoli ) = 'Ice volume-1 times aspect ratio mixing ratio'
   scalar_units_table( idomain, P_qaoli ) = 'm(3) kg(-1)'
   scalar_streams_table( idomain, P_qaoli )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qaoli )%stream(2) = 2097152 
   F_qaoli = .TRUE.
   IF ( scalar_index_table( PARAM_qni2 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qni2 = scalar_num_table(idomain)
     scalar_index_table( PARAM_qni2 , idomain ) = P_qni2
   ELSE
     P_qni2 = scalar_index_table( PARAM_qni2 , idomain )
   END IF
   scalar_boundary_table( idomain, P_qni2 ) = .TRUE.
   scalar_dname_table( idomain, P_qni2 ) = 'QNICE2'
   scalar_desc_table( idomain, P_qni2 ) = 'Ice Number concentration cat 2'
   scalar_units_table( idomain, P_qni2 ) = '  kg-1'
   scalar_streams_table( idomain, P_qni2 )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qni2 )%stream(2) = 2097152 
   F_qni2 = .TRUE.
   IF ( scalar_index_table( PARAM_qvoli2 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qvoli2 = scalar_num_table(idomain)
     scalar_index_table( PARAM_qvoli2 , idomain ) = P_qvoli2
   ELSE
     P_qvoli2 = scalar_index_table( PARAM_qvoli2 , idomain )
   END IF
   scalar_boundary_table( idomain, P_qvoli2 ) = .TRUE.
   scalar_dname_table( idomain, P_qvoli2 ) = 'QVOLI2'
   scalar_desc_table( idomain, P_qvoli2 ) = 'Ice volume-2 mixing ratio'
   scalar_units_table( idomain, P_qvoli2 ) = 'm(3) kg(-1)'
   scalar_streams_table( idomain, P_qvoli2 )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qvoli2 )%stream(2) = 2097152 
   F_qvoli2 = .TRUE.
   IF ( scalar_index_table( PARAM_qaoli2 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qaoli2 = scalar_num_table(idomain)
     scalar_index_table( PARAM_qaoli2 , idomain ) = P_qaoli2
   ELSE
     P_qaoli2 = scalar_index_table( PARAM_qaoli2 , idomain )
   END IF
   scalar_boundary_table( idomain, P_qaoli2 ) = .TRUE.
   scalar_dname_table( idomain, P_qaoli2 ) = 'QAOLI2'
   scalar_desc_table( idomain, P_qaoli2 ) = 'Ice volume-2 times aspect ratio mixing ratio'
   scalar_units_table( idomain, P_qaoli2 ) = 'm(3) kg(-1)'
   scalar_streams_table( idomain, P_qaoli2 )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qaoli2 )%stream(2) = 2097152 
   F_qaoli2 = .TRUE.
   IF ( scalar_index_table( PARAM_qni3 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qni3 = scalar_num_table(idomain)
     scalar_index_table( PARAM_qni3 , idomain ) = P_qni3
   ELSE
     P_qni3 = scalar_index_table( PARAM_qni3 , idomain )
   END IF
   scalar_boundary_table( idomain, P_qni3 ) = .TRUE.
   scalar_dname_table( idomain, P_qni3 ) = 'QNICE3'
   scalar_desc_table( idomain, P_qni3 ) = 'Ice Number concentration cat 3'
   scalar_units_table( idomain, P_qni3 ) = '  kg-1'
   scalar_streams_table( idomain, P_qni3 )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qni3 )%stream(2) = 2097152 
   F_qni3 = .TRUE.
   IF ( scalar_index_table( PARAM_qvoli3 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qvoli3 = scalar_num_table(idomain)
     scalar_index_table( PARAM_qvoli3 , idomain ) = P_qvoli3
   ELSE
     P_qvoli3 = scalar_index_table( PARAM_qvoli3 , idomain )
   END IF
   scalar_boundary_table( idomain, P_qvoli3 ) = .TRUE.
   scalar_dname_table( idomain, P_qvoli3 ) = 'QVOLI3'
   scalar_desc_table( idomain, P_qvoli3 ) = 'Ice volume-3 mixing ratio'
   scalar_units_table( idomain, P_qvoli3 ) = 'm(3) kg(-1)'
   scalar_streams_table( idomain, P_qvoli3 )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qvoli3 )%stream(2) = 2097152 
   F_qvoli3 = .TRUE.
   IF ( scalar_index_table( PARAM_qaoli3 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qaoli3 = scalar_num_table(idomain)
     scalar_index_table( PARAM_qaoli3 , idomain ) = P_qaoli3
   ELSE
     P_qaoli3 = scalar_index_table( PARAM_qaoli3 , idomain )
   END IF
   scalar_boundary_table( idomain, P_qaoli3 ) = .TRUE.
   scalar_dname_table( idomain, P_qaoli3 ) = 'QAOLI3'
   scalar_desc_table( idomain, P_qaoli3 ) = 'Ice volume-3 times aspect ratio mixing ratio'
   scalar_units_table( idomain, P_qaoli3 ) = 'm(3) kg(-1)'
   scalar_streams_table( idomain, P_qaoli3 )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qaoli3 )%stream(2) = 2097152 
   F_qaoli3 = .TRUE.
  END IF
  IF (model_config_rec%mp_physics(idomain)==95)THEN
   IF ( moist_index_table( PARAM_qv , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qv = moist_num_table(idomain)
     moist_index_table( PARAM_qv , idomain ) = P_qv
   ELSE
     P_qv = moist_index_table( PARAM_qv , idomain )
   END IF
   moist_boundary_table( idomain, P_qv ) = .TRUE.
   moist_dname_table( idomain, P_qv ) = 'QVAPOR'
   moist_desc_table( idomain, P_qv ) = 'Water vapor mixing ratio'
   moist_units_table( idomain, P_qv ) = 'kg kg-1'
   moist_streams_table( idomain, P_qv )%stream(1) = 33554435 
   moist_streams_table( idomain, P_qv )%stream(2) = 2097152 
   F_qv = .TRUE.
   IF ( moist_index_table( PARAM_qc , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qc = moist_num_table(idomain)
     moist_index_table( PARAM_qc , idomain ) = P_qc
   ELSE
     P_qc = moist_index_table( PARAM_qc , idomain )
   END IF
   moist_boundary_table( idomain, P_qc ) = .TRUE.
   moist_dname_table( idomain, P_qc ) = 'QCLOUD'
   moist_desc_table( idomain, P_qc ) = 'Cloud water mixing ratio'
   moist_units_table( idomain, P_qc ) = 'kg kg-1'
   moist_streams_table( idomain, P_qc )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qc )%stream(2) = 2097152 
   F_qc = .TRUE.
   IF ( moist_index_table( PARAM_qr , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qr = moist_num_table(idomain)
     moist_index_table( PARAM_qr , idomain ) = P_qr
   ELSE
     P_qr = moist_index_table( PARAM_qr , idomain )
   END IF
   moist_boundary_table( idomain, P_qr ) = .TRUE.
   moist_dname_table( idomain, P_qr ) = 'QRAIN'
   moist_desc_table( idomain, P_qr ) = 'Rain water mixing ratio'
   moist_units_table( idomain, P_qr ) = 'kg kg-1'
   moist_streams_table( idomain, P_qr )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qr )%stream(2) = 2097152 
   F_qr = .TRUE.
   IF ( moist_index_table( PARAM_qs , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qs = moist_num_table(idomain)
     moist_index_table( PARAM_qs , idomain ) = P_qs
   ELSE
     P_qs = moist_index_table( PARAM_qs , idomain )
   END IF
   moist_boundary_table( idomain, P_qs ) = .TRUE.
   moist_dname_table( idomain, P_qs ) = 'QSNOW'
   moist_desc_table( idomain, P_qs ) = 'Snow mixing ratio'
   moist_units_table( idomain, P_qs ) = 'kg kg-1'
   moist_streams_table( idomain, P_qs )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qs )%stream(2) = 2097152 
   F_qs = .TRUE.
   IF ( scalar_index_table( PARAM_qt , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qt = scalar_num_table(idomain)
     scalar_index_table( PARAM_qt , idomain ) = P_qt
   ELSE
     P_qt = scalar_index_table( PARAM_qt , idomain )
   END IF
   scalar_boundary_table( idomain, P_qt ) = .TRUE.
   scalar_dname_table( idomain, P_qt ) = 'CWM'
   scalar_desc_table( idomain, P_qt ) = 'Total condensate mixing ratio'
   scalar_units_table( idomain, P_qt ) = 'kg kg-1'
   scalar_streams_table( idomain, P_qt )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qt )%stream(2) = 2097152 
   F_qt = .TRUE.
  END IF
  IF (model_config_rec%mp_physics(idomain)==97)THEN
   IF ( moist_index_table( PARAM_qv , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qv = moist_num_table(idomain)
     moist_index_table( PARAM_qv , idomain ) = P_qv
   ELSE
     P_qv = moist_index_table( PARAM_qv , idomain )
   END IF
   moist_boundary_table( idomain, P_qv ) = .TRUE.
   moist_dname_table( idomain, P_qv ) = 'QVAPOR'
   moist_desc_table( idomain, P_qv ) = 'Water vapor mixing ratio'
   moist_units_table( idomain, P_qv ) = 'kg kg-1'
   moist_streams_table( idomain, P_qv )%stream(1) = 33554435 
   moist_streams_table( idomain, P_qv )%stream(2) = 2097152 
   F_qv = .TRUE.
   IF ( moist_index_table( PARAM_qc , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qc = moist_num_table(idomain)
     moist_index_table( PARAM_qc , idomain ) = P_qc
   ELSE
     P_qc = moist_index_table( PARAM_qc , idomain )
   END IF
   moist_boundary_table( idomain, P_qc ) = .TRUE.
   moist_dname_table( idomain, P_qc ) = 'QCLOUD'
   moist_desc_table( idomain, P_qc ) = 'Cloud water mixing ratio'
   moist_units_table( idomain, P_qc ) = 'kg kg-1'
   moist_streams_table( idomain, P_qc )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qc )%stream(2) = 2097152 
   F_qc = .TRUE.
   IF ( moist_index_table( PARAM_qr , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qr = moist_num_table(idomain)
     moist_index_table( PARAM_qr , idomain ) = P_qr
   ELSE
     P_qr = moist_index_table( PARAM_qr , idomain )
   END IF
   moist_boundary_table( idomain, P_qr ) = .TRUE.
   moist_dname_table( idomain, P_qr ) = 'QRAIN'
   moist_desc_table( idomain, P_qr ) = 'Rain water mixing ratio'
   moist_units_table( idomain, P_qr ) = 'kg kg-1'
   moist_streams_table( idomain, P_qr )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qr )%stream(2) = 2097152 
   F_qr = .TRUE.
   IF ( moist_index_table( PARAM_qi , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qi = moist_num_table(idomain)
     moist_index_table( PARAM_qi , idomain ) = P_qi
   ELSE
     P_qi = moist_index_table( PARAM_qi , idomain )
   END IF
   moist_boundary_table( idomain, P_qi ) = .TRUE.
   moist_dname_table( idomain, P_qi ) = 'QICE'
   moist_desc_table( idomain, P_qi ) = 'Ice mixing ratio'
   moist_units_table( idomain, P_qi ) = 'kg kg-1'
   moist_streams_table( idomain, P_qi )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qi )%stream(2) = 2097152 
   F_qi = .TRUE.
   IF ( moist_index_table( PARAM_qs , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qs = moist_num_table(idomain)
     moist_index_table( PARAM_qs , idomain ) = P_qs
   ELSE
     P_qs = moist_index_table( PARAM_qs , idomain )
   END IF
   moist_boundary_table( idomain, P_qs ) = .TRUE.
   moist_dname_table( idomain, P_qs ) = 'QSNOW'
   moist_desc_table( idomain, P_qs ) = 'Snow mixing ratio'
   moist_units_table( idomain, P_qs ) = 'kg kg-1'
   moist_streams_table( idomain, P_qs )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qs )%stream(2) = 2097152 
   F_qs = .TRUE.
   IF ( moist_index_table( PARAM_qg , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qg = moist_num_table(idomain)
     moist_index_table( PARAM_qg , idomain ) = P_qg
   ELSE
     P_qg = moist_index_table( PARAM_qg , idomain )
   END IF
   moist_boundary_table( idomain, P_qg ) = .TRUE.
   moist_dname_table( idomain, P_qg ) = 'QGRAUP'
   moist_desc_table( idomain, P_qg ) = 'Graupel mixing ratio'
   moist_units_table( idomain, P_qg ) = 'kg kg-1'
   moist_streams_table( idomain, P_qg )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qg )%stream(2) = 2097152 
   F_qg = .TRUE.
  END IF
  IF (model_config_rec%compute_radar_ref==1)THEN
  END IF
  IF (model_config_rec%mp_physics_dfi(idomain)==-1)THEN
  END IF
  IF (model_config_rec%mp_physics_dfi(idomain)==0)THEN
   IF ( dfi_moist_index_table( PARAM_dfi_qv , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qv = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qv , idomain ) = P_dfi_qv
   ELSE
     P_dfi_qv = dfi_moist_index_table( PARAM_dfi_qv , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qv ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qv ) = 'DFI_QVAPOR'
   dfi_moist_desc_table( idomain, P_dfi_qv ) = 'Water vapor mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qv ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qv )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qv )%stream(2) = 2097152 
   F_dfi_qv = .TRUE.
  END IF
  IF (model_config_rec%mp_physics_dfi(idomain)==1)THEN
   IF ( dfi_moist_index_table( PARAM_dfi_qv , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qv = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qv , idomain ) = P_dfi_qv
   ELSE
     P_dfi_qv = dfi_moist_index_table( PARAM_dfi_qv , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qv ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qv ) = 'DFI_QVAPOR'
   dfi_moist_desc_table( idomain, P_dfi_qv ) = 'Water vapor mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qv ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qv )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qv )%stream(2) = 2097152 
   F_dfi_qv = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qc , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qc = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qc , idomain ) = P_dfi_qc
   ELSE
     P_dfi_qc = dfi_moist_index_table( PARAM_dfi_qc , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qc ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qc ) = 'DFI_QCLOUD'
   dfi_moist_desc_table( idomain, P_dfi_qc ) = 'Cloud water mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qc ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qc )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qc )%stream(2) = 2097152 
   F_dfi_qc = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qr , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qr = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qr , idomain ) = P_dfi_qr
   ELSE
     P_dfi_qr = dfi_moist_index_table( PARAM_dfi_qr , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qr ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qr ) = 'DFI_QRAIN'
   dfi_moist_desc_table( idomain, P_dfi_qr ) = 'Rain water mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qr ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qr )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qr )%stream(2) = 2097152 
   F_dfi_qr = .TRUE.
  END IF
  IF (model_config_rec%mp_physics_dfi(idomain)==2)THEN
   IF ( dfi_moist_index_table( PARAM_dfi_qv , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qv = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qv , idomain ) = P_dfi_qv
   ELSE
     P_dfi_qv = dfi_moist_index_table( PARAM_dfi_qv , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qv ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qv ) = 'DFI_QVAPOR'
   dfi_moist_desc_table( idomain, P_dfi_qv ) = 'Water vapor mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qv ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qv )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qv )%stream(2) = 2097152 
   F_dfi_qv = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qc , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qc = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qc , idomain ) = P_dfi_qc
   ELSE
     P_dfi_qc = dfi_moist_index_table( PARAM_dfi_qc , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qc ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qc ) = 'DFI_QCLOUD'
   dfi_moist_desc_table( idomain, P_dfi_qc ) = 'Cloud water mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qc ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qc )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qc )%stream(2) = 2097152 
   F_dfi_qc = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qr , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qr = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qr , idomain ) = P_dfi_qr
   ELSE
     P_dfi_qr = dfi_moist_index_table( PARAM_dfi_qr , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qr ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qr ) = 'DFI_QRAIN'
   dfi_moist_desc_table( idomain, P_dfi_qr ) = 'Rain water mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qr ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qr )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qr )%stream(2) = 2097152 
   F_dfi_qr = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qi , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qi = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qi , idomain ) = P_dfi_qi
   ELSE
     P_dfi_qi = dfi_moist_index_table( PARAM_dfi_qi , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qi ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qi ) = 'DFI_QICE'
   dfi_moist_desc_table( idomain, P_dfi_qi ) = 'Ice mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qi ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qi )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qi )%stream(2) = 2097152 
   F_dfi_qi = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qs , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qs = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qs , idomain ) = P_dfi_qs
   ELSE
     P_dfi_qs = dfi_moist_index_table( PARAM_dfi_qs , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qs ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qs ) = 'DFI_QSNOW'
   dfi_moist_desc_table( idomain, P_dfi_qs ) = 'Snow mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qs ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qs )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qs )%stream(2) = 2097152 
   F_dfi_qs = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qg , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qg = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qg , idomain ) = P_dfi_qg
   ELSE
     P_dfi_qg = dfi_moist_index_table( PARAM_dfi_qg , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qg ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qg ) = 'DFI_QGRAUP'
   dfi_moist_desc_table( idomain, P_dfi_qg ) = 'Graupel mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qg ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qg )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qg )%stream(2) = 2097152 
   F_dfi_qg = .TRUE.
  END IF
  IF (model_config_rec%mp_physics_dfi(idomain)==3)THEN
   IF ( dfi_moist_index_table( PARAM_dfi_qv , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qv = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qv , idomain ) = P_dfi_qv
   ELSE
     P_dfi_qv = dfi_moist_index_table( PARAM_dfi_qv , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qv ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qv ) = 'DFI_QVAPOR'
   dfi_moist_desc_table( idomain, P_dfi_qv ) = 'Water vapor mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qv ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qv )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qv )%stream(2) = 2097152 
   F_dfi_qv = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qc , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qc = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qc , idomain ) = P_dfi_qc
   ELSE
     P_dfi_qc = dfi_moist_index_table( PARAM_dfi_qc , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qc ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qc ) = 'DFI_QCLOUD'
   dfi_moist_desc_table( idomain, P_dfi_qc ) = 'Cloud water mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qc ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qc )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qc )%stream(2) = 2097152 
   F_dfi_qc = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qr , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qr = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qr , idomain ) = P_dfi_qr
   ELSE
     P_dfi_qr = dfi_moist_index_table( PARAM_dfi_qr , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qr ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qr ) = 'DFI_QRAIN'
   dfi_moist_desc_table( idomain, P_dfi_qr ) = 'Rain water mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qr ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qr )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qr )%stream(2) = 2097152 
   F_dfi_qr = .TRUE.
  END IF
  IF (model_config_rec%mp_physics_dfi(idomain)==4)THEN
   IF ( dfi_moist_index_table( PARAM_dfi_qv , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qv = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qv , idomain ) = P_dfi_qv
   ELSE
     P_dfi_qv = dfi_moist_index_table( PARAM_dfi_qv , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qv ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qv ) = 'DFI_QVAPOR'
   dfi_moist_desc_table( idomain, P_dfi_qv ) = 'Water vapor mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qv ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qv )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qv )%stream(2) = 2097152 
   F_dfi_qv = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qc , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qc = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qc , idomain ) = P_dfi_qc
   ELSE
     P_dfi_qc = dfi_moist_index_table( PARAM_dfi_qc , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qc ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qc ) = 'DFI_QCLOUD'
   dfi_moist_desc_table( idomain, P_dfi_qc ) = 'Cloud water mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qc ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qc )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qc )%stream(2) = 2097152 
   F_dfi_qc = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qr , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qr = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qr , idomain ) = P_dfi_qr
   ELSE
     P_dfi_qr = dfi_moist_index_table( PARAM_dfi_qr , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qr ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qr ) = 'DFI_QRAIN'
   dfi_moist_desc_table( idomain, P_dfi_qr ) = 'Rain water mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qr ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qr )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qr )%stream(2) = 2097152 
   F_dfi_qr = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qi , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qi = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qi , idomain ) = P_dfi_qi
   ELSE
     P_dfi_qi = dfi_moist_index_table( PARAM_dfi_qi , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qi ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qi ) = 'DFI_QICE'
   dfi_moist_desc_table( idomain, P_dfi_qi ) = 'Ice mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qi ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qi )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qi )%stream(2) = 2097152 
   F_dfi_qi = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qs , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qs = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qs , idomain ) = P_dfi_qs
   ELSE
     P_dfi_qs = dfi_moist_index_table( PARAM_dfi_qs , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qs ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qs ) = 'DFI_QSNOW'
   dfi_moist_desc_table( idomain, P_dfi_qs ) = 'Snow mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qs ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qs )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qs )%stream(2) = 2097152 
   F_dfi_qs = .TRUE.
  END IF
  IF (model_config_rec%mp_physics_dfi(idomain)==5)THEN
   IF ( dfi_moist_index_table( PARAM_dfi_qv , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qv = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qv , idomain ) = P_dfi_qv
   ELSE
     P_dfi_qv = dfi_moist_index_table( PARAM_dfi_qv , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qv ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qv ) = 'DFI_QVAPOR'
   dfi_moist_desc_table( idomain, P_dfi_qv ) = 'Water vapor mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qv ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qv )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qv )%stream(2) = 2097152 
   F_dfi_qv = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qc , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qc = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qc , idomain ) = P_dfi_qc
   ELSE
     P_dfi_qc = dfi_moist_index_table( PARAM_dfi_qc , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qc ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qc ) = 'DFI_QCLOUD'
   dfi_moist_desc_table( idomain, P_dfi_qc ) = 'Cloud water mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qc ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qc )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qc )%stream(2) = 2097152 
   F_dfi_qc = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qr , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qr = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qr , idomain ) = P_dfi_qr
   ELSE
     P_dfi_qr = dfi_moist_index_table( PARAM_dfi_qr , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qr ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qr ) = 'DFI_QRAIN'
   dfi_moist_desc_table( idomain, P_dfi_qr ) = 'Rain water mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qr ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qr )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qr )%stream(2) = 2097152 
   F_dfi_qr = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qi , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qi = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qi , idomain ) = P_dfi_qi
   ELSE
     P_dfi_qi = dfi_moist_index_table( PARAM_dfi_qi , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qi ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qi ) = 'DFI_QICE'
   dfi_moist_desc_table( idomain, P_dfi_qi ) = 'Ice mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qi ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qi )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qi )%stream(2) = 2097152 
   F_dfi_qi = .TRUE.
   IF ( dfi_scalar_index_table( PARAM_dfi_qt , idomain ) .lt. 1 ) THEN
     dfi_scalar_num_table(idomain) = dfi_scalar_num_table(idomain) + 1
     P_dfi_qt = dfi_scalar_num_table(idomain)
     dfi_scalar_index_table( PARAM_dfi_qt , idomain ) = P_dfi_qt
   ELSE
     P_dfi_qt = dfi_scalar_index_table( PARAM_dfi_qt , idomain )
   END IF
   dfi_scalar_boundary_table( idomain, P_dfi_qt ) = .TRUE.
   dfi_scalar_dname_table( idomain, P_dfi_qt ) = 'DFI_CWM'
   dfi_scalar_desc_table( idomain, P_dfi_qt ) = 'DFI Total condensate mixing ratio'
   dfi_scalar_units_table( idomain, P_dfi_qt ) = 'kg kg-1'
   dfi_scalar_streams_table( idomain, P_dfi_qt )%stream(1) = 0 
   dfi_scalar_streams_table( idomain, P_dfi_qt )%stream(2) = 2097152 
   F_dfi_qt = .TRUE.
  END IF
  IF (model_config_rec%mp_physics_dfi(idomain)==6)THEN
   IF ( dfi_moist_index_table( PARAM_dfi_qv , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qv = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qv , idomain ) = P_dfi_qv
   ELSE
     P_dfi_qv = dfi_moist_index_table( PARAM_dfi_qv , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qv ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qv ) = 'DFI_QVAPOR'
   dfi_moist_desc_table( idomain, P_dfi_qv ) = 'Water vapor mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qv ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qv )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qv )%stream(2) = 2097152 
   F_dfi_qv = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qc , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qc = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qc , idomain ) = P_dfi_qc
   ELSE
     P_dfi_qc = dfi_moist_index_table( PARAM_dfi_qc , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qc ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qc ) = 'DFI_QCLOUD'
   dfi_moist_desc_table( idomain, P_dfi_qc ) = 'Cloud water mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qc ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qc )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qc )%stream(2) = 2097152 
   F_dfi_qc = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qr , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qr = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qr , idomain ) = P_dfi_qr
   ELSE
     P_dfi_qr = dfi_moist_index_table( PARAM_dfi_qr , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qr ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qr ) = 'DFI_QRAIN'
   dfi_moist_desc_table( idomain, P_dfi_qr ) = 'Rain water mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qr ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qr )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qr )%stream(2) = 2097152 
   F_dfi_qr = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qi , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qi = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qi , idomain ) = P_dfi_qi
   ELSE
     P_dfi_qi = dfi_moist_index_table( PARAM_dfi_qi , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qi ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qi ) = 'DFI_QICE'
   dfi_moist_desc_table( idomain, P_dfi_qi ) = 'Ice mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qi ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qi )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qi )%stream(2) = 2097152 
   F_dfi_qi = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qs , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qs = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qs , idomain ) = P_dfi_qs
   ELSE
     P_dfi_qs = dfi_moist_index_table( PARAM_dfi_qs , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qs ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qs ) = 'DFI_QSNOW'
   dfi_moist_desc_table( idomain, P_dfi_qs ) = 'Snow mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qs ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qs )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qs )%stream(2) = 2097152 
   F_dfi_qs = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qg , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qg = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qg , idomain ) = P_dfi_qg
   ELSE
     P_dfi_qg = dfi_moist_index_table( PARAM_dfi_qg , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qg ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qg ) = 'DFI_QGRAUP'
   dfi_moist_desc_table( idomain, P_dfi_qg ) = 'Graupel mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qg ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qg )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qg )%stream(2) = 2097152 
   F_dfi_qg = .TRUE.
  END IF
  IF (model_config_rec%mp_physics_dfi(idomain)==7)THEN
   IF ( dfi_moist_index_table( PARAM_dfi_qv , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qv = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qv , idomain ) = P_dfi_qv
   ELSE
     P_dfi_qv = dfi_moist_index_table( PARAM_dfi_qv , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qv ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qv ) = 'DFI_QVAPOR'
   dfi_moist_desc_table( idomain, P_dfi_qv ) = 'Water vapor mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qv ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qv )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qv )%stream(2) = 2097152 
   F_dfi_qv = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qc , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qc = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qc , idomain ) = P_dfi_qc
   ELSE
     P_dfi_qc = dfi_moist_index_table( PARAM_dfi_qc , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qc ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qc ) = 'DFI_QCLOUD'
   dfi_moist_desc_table( idomain, P_dfi_qc ) = 'Cloud water mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qc ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qc )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qc )%stream(2) = 2097152 
   F_dfi_qc = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qr , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qr = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qr , idomain ) = P_dfi_qr
   ELSE
     P_dfi_qr = dfi_moist_index_table( PARAM_dfi_qr , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qr ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qr ) = 'DFI_QRAIN'
   dfi_moist_desc_table( idomain, P_dfi_qr ) = 'Rain water mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qr ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qr )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qr )%stream(2) = 2097152 
   F_dfi_qr = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qi , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qi = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qi , idomain ) = P_dfi_qi
   ELSE
     P_dfi_qi = dfi_moist_index_table( PARAM_dfi_qi , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qi ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qi ) = 'DFI_QICE'
   dfi_moist_desc_table( idomain, P_dfi_qi ) = 'Ice mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qi ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qi )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qi )%stream(2) = 2097152 
   F_dfi_qi = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qs , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qs = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qs , idomain ) = P_dfi_qs
   ELSE
     P_dfi_qs = dfi_moist_index_table( PARAM_dfi_qs , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qs ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qs ) = 'DFI_QSNOW'
   dfi_moist_desc_table( idomain, P_dfi_qs ) = 'Snow mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qs ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qs )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qs )%stream(2) = 2097152 
   F_dfi_qs = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qg , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qg = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qg , idomain ) = P_dfi_qg
   ELSE
     P_dfi_qg = dfi_moist_index_table( PARAM_dfi_qg , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qg ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qg ) = 'DFI_QGRAUP'
   dfi_moist_desc_table( idomain, P_dfi_qg ) = 'Graupel mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qg ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qg )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qg )%stream(2) = 2097152 
   F_dfi_qg = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qh , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qh = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qh , idomain ) = P_dfi_qh
   ELSE
     P_dfi_qh = dfi_moist_index_table( PARAM_dfi_qh , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qh ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qh ) = 'DFI_QHAIL'
   dfi_moist_desc_table( idomain, P_dfi_qh ) = 'Hail mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qh ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qh )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qh )%stream(2) = 2097152 
   F_dfi_qh = .TRUE.
  END IF
  IF (model_config_rec%mp_physics_dfi(idomain)==8)THEN
   IF ( dfi_moist_index_table( PARAM_dfi_qv , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qv = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qv , idomain ) = P_dfi_qv
   ELSE
     P_dfi_qv = dfi_moist_index_table( PARAM_dfi_qv , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qv ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qv ) = 'DFI_QVAPOR'
   dfi_moist_desc_table( idomain, P_dfi_qv ) = 'Water vapor mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qv ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qv )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qv )%stream(2) = 2097152 
   F_dfi_qv = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qc , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qc = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qc , idomain ) = P_dfi_qc
   ELSE
     P_dfi_qc = dfi_moist_index_table( PARAM_dfi_qc , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qc ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qc ) = 'DFI_QCLOUD'
   dfi_moist_desc_table( idomain, P_dfi_qc ) = 'Cloud water mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qc ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qc )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qc )%stream(2) = 2097152 
   F_dfi_qc = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qr , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qr = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qr , idomain ) = P_dfi_qr
   ELSE
     P_dfi_qr = dfi_moist_index_table( PARAM_dfi_qr , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qr ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qr ) = 'DFI_QRAIN'
   dfi_moist_desc_table( idomain, P_dfi_qr ) = 'Rain water mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qr ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qr )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qr )%stream(2) = 2097152 
   F_dfi_qr = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qi , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qi = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qi , idomain ) = P_dfi_qi
   ELSE
     P_dfi_qi = dfi_moist_index_table( PARAM_dfi_qi , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qi ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qi ) = 'DFI_QICE'
   dfi_moist_desc_table( idomain, P_dfi_qi ) = 'Ice mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qi ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qi )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qi )%stream(2) = 2097152 
   F_dfi_qi = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qs , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qs = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qs , idomain ) = P_dfi_qs
   ELSE
     P_dfi_qs = dfi_moist_index_table( PARAM_dfi_qs , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qs ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qs ) = 'DFI_QSNOW'
   dfi_moist_desc_table( idomain, P_dfi_qs ) = 'Snow mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qs ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qs )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qs )%stream(2) = 2097152 
   F_dfi_qs = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qg , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qg = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qg , idomain ) = P_dfi_qg
   ELSE
     P_dfi_qg = dfi_moist_index_table( PARAM_dfi_qg , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qg ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qg ) = 'DFI_QGRAUP'
   dfi_moist_desc_table( idomain, P_dfi_qg ) = 'Graupel mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qg ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qg )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qg )%stream(2) = 2097152 
   F_dfi_qg = .TRUE.
   IF ( dfi_scalar_index_table( PARAM_dfi_qni , idomain ) .lt. 1 ) THEN
     dfi_scalar_num_table(idomain) = dfi_scalar_num_table(idomain) + 1
     P_dfi_qni = dfi_scalar_num_table(idomain)
     dfi_scalar_index_table( PARAM_dfi_qni , idomain ) = P_dfi_qni
   ELSE
     P_dfi_qni = dfi_scalar_index_table( PARAM_dfi_qni , idomain )
   END IF
   dfi_scalar_boundary_table( idomain, P_dfi_qni ) = .TRUE.
   dfi_scalar_dname_table( idomain, P_dfi_qni ) = 'DFI_QNICE'
   dfi_scalar_desc_table( idomain, P_dfi_qni ) = 'DFI Ice Number concentration'
   dfi_scalar_units_table( idomain, P_dfi_qni ) = '  kg-1'
   dfi_scalar_streams_table( idomain, P_dfi_qni )%stream(1) = 0 
   dfi_scalar_streams_table( idomain, P_dfi_qni )%stream(2) = 2097152 
   F_dfi_qni = .TRUE.
   IF ( dfi_scalar_index_table( PARAM_dfi_qnr , idomain ) .lt. 1 ) THEN
     dfi_scalar_num_table(idomain) = dfi_scalar_num_table(idomain) + 1
     P_dfi_qnr = dfi_scalar_num_table(idomain)
     dfi_scalar_index_table( PARAM_dfi_qnr , idomain ) = P_dfi_qnr
   ELSE
     P_dfi_qnr = dfi_scalar_index_table( PARAM_dfi_qnr , idomain )
   END IF
   dfi_scalar_boundary_table( idomain, P_dfi_qnr ) = .TRUE.
   dfi_scalar_dname_table( idomain, P_dfi_qnr ) = 'DFI_QNRAIN'
   dfi_scalar_desc_table( idomain, P_dfi_qnr ) = 'DFI Rain Number concentration'
   dfi_scalar_units_table( idomain, P_dfi_qnr ) = '  kg(-1)'
   dfi_scalar_streams_table( idomain, P_dfi_qnr )%stream(1) = 0 
   dfi_scalar_streams_table( idomain, P_dfi_qnr )%stream(2) = 2097152 
   F_dfi_qnr = .TRUE.
  END IF
  IF (model_config_rec%mp_physics_dfi(idomain)==9)THEN
   IF ( dfi_moist_index_table( PARAM_dfi_qv , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qv = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qv , idomain ) = P_dfi_qv
   ELSE
     P_dfi_qv = dfi_moist_index_table( PARAM_dfi_qv , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qv ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qv ) = 'DFI_QVAPOR'
   dfi_moist_desc_table( idomain, P_dfi_qv ) = 'Water vapor mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qv ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qv )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qv )%stream(2) = 2097152 
   F_dfi_qv = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qc , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qc = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qc , idomain ) = P_dfi_qc
   ELSE
     P_dfi_qc = dfi_moist_index_table( PARAM_dfi_qc , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qc ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qc ) = 'DFI_QCLOUD'
   dfi_moist_desc_table( idomain, P_dfi_qc ) = 'Cloud water mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qc ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qc )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qc )%stream(2) = 2097152 
   F_dfi_qc = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qr , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qr = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qr , idomain ) = P_dfi_qr
   ELSE
     P_dfi_qr = dfi_moist_index_table( PARAM_dfi_qr , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qr ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qr ) = 'DFI_QRAIN'
   dfi_moist_desc_table( idomain, P_dfi_qr ) = 'Rain water mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qr ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qr )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qr )%stream(2) = 2097152 
   F_dfi_qr = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qi , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qi = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qi , idomain ) = P_dfi_qi
   ELSE
     P_dfi_qi = dfi_moist_index_table( PARAM_dfi_qi , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qi ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qi ) = 'DFI_QICE'
   dfi_moist_desc_table( idomain, P_dfi_qi ) = 'Ice mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qi ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qi )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qi )%stream(2) = 2097152 
   F_dfi_qi = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qs , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qs = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qs , idomain ) = P_dfi_qs
   ELSE
     P_dfi_qs = dfi_moist_index_table( PARAM_dfi_qs , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qs ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qs ) = 'DFI_QSNOW'
   dfi_moist_desc_table( idomain, P_dfi_qs ) = 'Snow mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qs ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qs )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qs )%stream(2) = 2097152 
   F_dfi_qs = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qg , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qg = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qg , idomain ) = P_dfi_qg
   ELSE
     P_dfi_qg = dfi_moist_index_table( PARAM_dfi_qg , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qg ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qg ) = 'DFI_QGRAUP'
   dfi_moist_desc_table( idomain, P_dfi_qg ) = 'Graupel mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qg ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qg )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qg )%stream(2) = 2097152 
   F_dfi_qg = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qh , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qh = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qh , idomain ) = P_dfi_qh
   ELSE
     P_dfi_qh = dfi_moist_index_table( PARAM_dfi_qh , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qh ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qh ) = 'DFI_QHAIL'
   dfi_moist_desc_table( idomain, P_dfi_qh ) = 'Hail mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qh ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qh )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qh )%stream(2) = 2097152 
   F_dfi_qh = .TRUE.
   IF ( dfi_scalar_index_table( PARAM_dfi_qnc , idomain ) .lt. 1 ) THEN
     dfi_scalar_num_table(idomain) = dfi_scalar_num_table(idomain) + 1
     P_dfi_qnc = dfi_scalar_num_table(idomain)
     dfi_scalar_index_table( PARAM_dfi_qnc , idomain ) = P_dfi_qnc
   ELSE
     P_dfi_qnc = dfi_scalar_index_table( PARAM_dfi_qnc , idomain )
   END IF
   dfi_scalar_boundary_table( idomain, P_dfi_qnc ) = .TRUE.
   dfi_scalar_dname_table( idomain, P_dfi_qnc ) = 'DFI_QNCLOUD'
   dfi_scalar_desc_table( idomain, P_dfi_qnc ) = 'DFI Cloud Number concentration'
   dfi_scalar_units_table( idomain, P_dfi_qnc ) = '  kg(-1)'
   dfi_scalar_streams_table( idomain, P_dfi_qnc )%stream(1) = 0 
   dfi_scalar_streams_table( idomain, P_dfi_qnc )%stream(2) = 2097152 
   F_dfi_qnc = .TRUE.
   IF ( dfi_scalar_index_table( PARAM_dfi_qnr , idomain ) .lt. 1 ) THEN
     dfi_scalar_num_table(idomain) = dfi_scalar_num_table(idomain) + 1
     P_dfi_qnr = dfi_scalar_num_table(idomain)
     dfi_scalar_index_table( PARAM_dfi_qnr , idomain ) = P_dfi_qnr
   ELSE
     P_dfi_qnr = dfi_scalar_index_table( PARAM_dfi_qnr , idomain )
   END IF
   dfi_scalar_boundary_table( idomain, P_dfi_qnr ) = .TRUE.
   dfi_scalar_dname_table( idomain, P_dfi_qnr ) = 'DFI_QNRAIN'
   dfi_scalar_desc_table( idomain, P_dfi_qnr ) = 'DFI Rain Number concentration'
   dfi_scalar_units_table( idomain, P_dfi_qnr ) = '  kg(-1)'
   dfi_scalar_streams_table( idomain, P_dfi_qnr )%stream(1) = 0 
   dfi_scalar_streams_table( idomain, P_dfi_qnr )%stream(2) = 2097152 
   F_dfi_qnr = .TRUE.
   IF ( dfi_scalar_index_table( PARAM_dfi_qni , idomain ) .lt. 1 ) THEN
     dfi_scalar_num_table(idomain) = dfi_scalar_num_table(idomain) + 1
     P_dfi_qni = dfi_scalar_num_table(idomain)
     dfi_scalar_index_table( PARAM_dfi_qni , idomain ) = P_dfi_qni
   ELSE
     P_dfi_qni = dfi_scalar_index_table( PARAM_dfi_qni , idomain )
   END IF
   dfi_scalar_boundary_table( idomain, P_dfi_qni ) = .TRUE.
   dfi_scalar_dname_table( idomain, P_dfi_qni ) = 'DFI_QNICE'
   dfi_scalar_desc_table( idomain, P_dfi_qni ) = 'DFI Ice Number concentration'
   dfi_scalar_units_table( idomain, P_dfi_qni ) = '  kg-1'
   dfi_scalar_streams_table( idomain, P_dfi_qni )%stream(1) = 0 
   dfi_scalar_streams_table( idomain, P_dfi_qni )%stream(2) = 2097152 
   F_dfi_qni = .TRUE.
   IF ( dfi_scalar_index_table( PARAM_dfi_qns , idomain ) .lt. 1 ) THEN
     dfi_scalar_num_table(idomain) = dfi_scalar_num_table(idomain) + 1
     P_dfi_qns = dfi_scalar_num_table(idomain)
     dfi_scalar_index_table( PARAM_dfi_qns , idomain ) = P_dfi_qns
   ELSE
     P_dfi_qns = dfi_scalar_index_table( PARAM_dfi_qns , idomain )
   END IF
   dfi_scalar_boundary_table( idomain, P_dfi_qns ) = .TRUE.
   dfi_scalar_dname_table( idomain, P_dfi_qns ) = 'DFI_QNSNOW'
   dfi_scalar_desc_table( idomain, P_dfi_qns ) = 'DFI Snow Number concentration'
   dfi_scalar_units_table( idomain, P_dfi_qns ) = '  kg(-1)'
   dfi_scalar_streams_table( idomain, P_dfi_qns )%stream(1) = 0 
   dfi_scalar_streams_table( idomain, P_dfi_qns )%stream(2) = 2097152 
   F_dfi_qns = .TRUE.
   IF ( dfi_scalar_index_table( PARAM_dfi_qng , idomain ) .lt. 1 ) THEN
     dfi_scalar_num_table(idomain) = dfi_scalar_num_table(idomain) + 1
     P_dfi_qng = dfi_scalar_num_table(idomain)
     dfi_scalar_index_table( PARAM_dfi_qng , idomain ) = P_dfi_qng
   ELSE
     P_dfi_qng = dfi_scalar_index_table( PARAM_dfi_qng , idomain )
   END IF
   dfi_scalar_boundary_table( idomain, P_dfi_qng ) = .TRUE.
   dfi_scalar_dname_table( idomain, P_dfi_qng ) = 'DFI_QNGRAUPEL'
   dfi_scalar_desc_table( idomain, P_dfi_qng ) = 'DFI Graupel Number concentration'
   dfi_scalar_units_table( idomain, P_dfi_qng ) = '  kg(-1)'
   dfi_scalar_streams_table( idomain, P_dfi_qng )%stream(1) = 0 
   dfi_scalar_streams_table( idomain, P_dfi_qng )%stream(2) = 2097152 
   F_dfi_qng = .TRUE.
   IF ( dfi_scalar_index_table( PARAM_dfi_qnh , idomain ) .lt. 1 ) THEN
     dfi_scalar_num_table(idomain) = dfi_scalar_num_table(idomain) + 1
     P_dfi_qnh = dfi_scalar_num_table(idomain)
     dfi_scalar_index_table( PARAM_dfi_qnh , idomain ) = P_dfi_qnh
   ELSE
     P_dfi_qnh = dfi_scalar_index_table( PARAM_dfi_qnh , idomain )
   END IF
   dfi_scalar_boundary_table( idomain, P_dfi_qnh ) = .TRUE.
   dfi_scalar_dname_table( idomain, P_dfi_qnh ) = 'DFI_QNHAIL'
   dfi_scalar_desc_table( idomain, P_dfi_qnh ) = 'DFI Hail Number concentration'
   dfi_scalar_units_table( idomain, P_dfi_qnh ) = '  kg(-1)'
   dfi_scalar_streams_table( idomain, P_dfi_qnh )%stream(1) = 0 
   dfi_scalar_streams_table( idomain, P_dfi_qnh )%stream(2) = 2097152 
   F_dfi_qnh = .TRUE.
  END IF
  IF (model_config_rec%mp_physics_dfi(idomain)==10)THEN
   IF ( dfi_moist_index_table( PARAM_dfi_qv , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qv = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qv , idomain ) = P_dfi_qv
   ELSE
     P_dfi_qv = dfi_moist_index_table( PARAM_dfi_qv , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qv ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qv ) = 'DFI_QVAPOR'
   dfi_moist_desc_table( idomain, P_dfi_qv ) = 'Water vapor mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qv ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qv )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qv )%stream(2) = 2097152 
   F_dfi_qv = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qc , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qc = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qc , idomain ) = P_dfi_qc
   ELSE
     P_dfi_qc = dfi_moist_index_table( PARAM_dfi_qc , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qc ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qc ) = 'DFI_QCLOUD'
   dfi_moist_desc_table( idomain, P_dfi_qc ) = 'Cloud water mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qc ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qc )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qc )%stream(2) = 2097152 
   F_dfi_qc = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qr , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qr = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qr , idomain ) = P_dfi_qr
   ELSE
     P_dfi_qr = dfi_moist_index_table( PARAM_dfi_qr , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qr ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qr ) = 'DFI_QRAIN'
   dfi_moist_desc_table( idomain, P_dfi_qr ) = 'Rain water mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qr ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qr )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qr )%stream(2) = 2097152 
   F_dfi_qr = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qi , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qi = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qi , idomain ) = P_dfi_qi
   ELSE
     P_dfi_qi = dfi_moist_index_table( PARAM_dfi_qi , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qi ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qi ) = 'DFI_QICE'
   dfi_moist_desc_table( idomain, P_dfi_qi ) = 'Ice mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qi ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qi )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qi )%stream(2) = 2097152 
   F_dfi_qi = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qs , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qs = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qs , idomain ) = P_dfi_qs
   ELSE
     P_dfi_qs = dfi_moist_index_table( PARAM_dfi_qs , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qs ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qs ) = 'DFI_QSNOW'
   dfi_moist_desc_table( idomain, P_dfi_qs ) = 'Snow mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qs ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qs )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qs )%stream(2) = 2097152 
   F_dfi_qs = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qg , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qg = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qg , idomain ) = P_dfi_qg
   ELSE
     P_dfi_qg = dfi_moist_index_table( PARAM_dfi_qg , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qg ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qg ) = 'DFI_QGRAUP'
   dfi_moist_desc_table( idomain, P_dfi_qg ) = 'Graupel mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qg ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qg )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qg )%stream(2) = 2097152 
   F_dfi_qg = .TRUE.
   IF ( dfi_scalar_index_table( PARAM_dfi_qni , idomain ) .lt. 1 ) THEN
     dfi_scalar_num_table(idomain) = dfi_scalar_num_table(idomain) + 1
     P_dfi_qni = dfi_scalar_num_table(idomain)
     dfi_scalar_index_table( PARAM_dfi_qni , idomain ) = P_dfi_qni
   ELSE
     P_dfi_qni = dfi_scalar_index_table( PARAM_dfi_qni , idomain )
   END IF
   dfi_scalar_boundary_table( idomain, P_dfi_qni ) = .TRUE.
   dfi_scalar_dname_table( idomain, P_dfi_qni ) = 'DFI_QNICE'
   dfi_scalar_desc_table( idomain, P_dfi_qni ) = 'DFI Ice Number concentration'
   dfi_scalar_units_table( idomain, P_dfi_qni ) = '  kg-1'
   dfi_scalar_streams_table( idomain, P_dfi_qni )%stream(1) = 0 
   dfi_scalar_streams_table( idomain, P_dfi_qni )%stream(2) = 2097152 
   F_dfi_qni = .TRUE.
   IF ( dfi_scalar_index_table( PARAM_dfi_qns , idomain ) .lt. 1 ) THEN
     dfi_scalar_num_table(idomain) = dfi_scalar_num_table(idomain) + 1
     P_dfi_qns = dfi_scalar_num_table(idomain)
     dfi_scalar_index_table( PARAM_dfi_qns , idomain ) = P_dfi_qns
   ELSE
     P_dfi_qns = dfi_scalar_index_table( PARAM_dfi_qns , idomain )
   END IF
   dfi_scalar_boundary_table( idomain, P_dfi_qns ) = .TRUE.
   dfi_scalar_dname_table( idomain, P_dfi_qns ) = 'DFI_QNSNOW'
   dfi_scalar_desc_table( idomain, P_dfi_qns ) = 'DFI Snow Number concentration'
   dfi_scalar_units_table( idomain, P_dfi_qns ) = '  kg(-1)'
   dfi_scalar_streams_table( idomain, P_dfi_qns )%stream(1) = 0 
   dfi_scalar_streams_table( idomain, P_dfi_qns )%stream(2) = 2097152 
   F_dfi_qns = .TRUE.
   IF ( dfi_scalar_index_table( PARAM_dfi_qnr , idomain ) .lt. 1 ) THEN
     dfi_scalar_num_table(idomain) = dfi_scalar_num_table(idomain) + 1
     P_dfi_qnr = dfi_scalar_num_table(idomain)
     dfi_scalar_index_table( PARAM_dfi_qnr , idomain ) = P_dfi_qnr
   ELSE
     P_dfi_qnr = dfi_scalar_index_table( PARAM_dfi_qnr , idomain )
   END IF
   dfi_scalar_boundary_table( idomain, P_dfi_qnr ) = .TRUE.
   dfi_scalar_dname_table( idomain, P_dfi_qnr ) = 'DFI_QNRAIN'
   dfi_scalar_desc_table( idomain, P_dfi_qnr ) = 'DFI Rain Number concentration'
   dfi_scalar_units_table( idomain, P_dfi_qnr ) = '  kg(-1)'
   dfi_scalar_streams_table( idomain, P_dfi_qnr )%stream(1) = 0 
   dfi_scalar_streams_table( idomain, P_dfi_qnr )%stream(2) = 2097152 
   F_dfi_qnr = .TRUE.
   IF ( dfi_scalar_index_table( PARAM_dfi_qng , idomain ) .lt. 1 ) THEN
     dfi_scalar_num_table(idomain) = dfi_scalar_num_table(idomain) + 1
     P_dfi_qng = dfi_scalar_num_table(idomain)
     dfi_scalar_index_table( PARAM_dfi_qng , idomain ) = P_dfi_qng
   ELSE
     P_dfi_qng = dfi_scalar_index_table( PARAM_dfi_qng , idomain )
   END IF
   dfi_scalar_boundary_table( idomain, P_dfi_qng ) = .TRUE.
   dfi_scalar_dname_table( idomain, P_dfi_qng ) = 'DFI_QNGRAUPEL'
   dfi_scalar_desc_table( idomain, P_dfi_qng ) = 'DFI Graupel Number concentration'
   dfi_scalar_units_table( idomain, P_dfi_qng ) = '  kg(-1)'
   dfi_scalar_streams_table( idomain, P_dfi_qng )%stream(1) = 0 
   dfi_scalar_streams_table( idomain, P_dfi_qng )%stream(2) = 2097152 
   F_dfi_qng = .TRUE.
  END IF
  IF (model_config_rec%mp_physics_dfi(idomain)==14)THEN
   IF ( dfi_moist_index_table( PARAM_dfi_qv , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qv = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qv , idomain ) = P_dfi_qv
   ELSE
     P_dfi_qv = dfi_moist_index_table( PARAM_dfi_qv , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qv ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qv ) = 'DFI_QVAPOR'
   dfi_moist_desc_table( idomain, P_dfi_qv ) = 'Water vapor mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qv ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qv )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qv )%stream(2) = 2097152 
   F_dfi_qv = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qc , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qc = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qc , idomain ) = P_dfi_qc
   ELSE
     P_dfi_qc = dfi_moist_index_table( PARAM_dfi_qc , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qc ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qc ) = 'DFI_QCLOUD'
   dfi_moist_desc_table( idomain, P_dfi_qc ) = 'Cloud water mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qc ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qc )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qc )%stream(2) = 2097152 
   F_dfi_qc = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qr , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qr = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qr , idomain ) = P_dfi_qr
   ELSE
     P_dfi_qr = dfi_moist_index_table( PARAM_dfi_qr , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qr ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qr ) = 'DFI_QRAIN'
   dfi_moist_desc_table( idomain, P_dfi_qr ) = 'Rain water mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qr ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qr )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qr )%stream(2) = 2097152 
   F_dfi_qr = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qi , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qi = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qi , idomain ) = P_dfi_qi
   ELSE
     P_dfi_qi = dfi_moist_index_table( PARAM_dfi_qi , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qi ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qi ) = 'DFI_QICE'
   dfi_moist_desc_table( idomain, P_dfi_qi ) = 'Ice mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qi ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qi )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qi )%stream(2) = 2097152 
   F_dfi_qi = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qs , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qs = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qs , idomain ) = P_dfi_qs
   ELSE
     P_dfi_qs = dfi_moist_index_table( PARAM_dfi_qs , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qs ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qs ) = 'DFI_QSNOW'
   dfi_moist_desc_table( idomain, P_dfi_qs ) = 'Snow mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qs ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qs )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qs )%stream(2) = 2097152 
   F_dfi_qs = .TRUE.
   IF ( dfi_scalar_index_table( PARAM_dfi_qnn , idomain ) .lt. 1 ) THEN
     dfi_scalar_num_table(idomain) = dfi_scalar_num_table(idomain) + 1
     P_dfi_qnn = dfi_scalar_num_table(idomain)
     dfi_scalar_index_table( PARAM_dfi_qnn , idomain ) = P_dfi_qnn
   ELSE
     P_dfi_qnn = dfi_scalar_index_table( PARAM_dfi_qnn , idomain )
   END IF
   dfi_scalar_boundary_table( idomain, P_dfi_qnn ) = .TRUE.
   dfi_scalar_dname_table( idomain, P_dfi_qnn ) = 'DFI_QNCC'
   dfi_scalar_desc_table( idomain, P_dfi_qnn ) = 'DFI CNN Number concentration'
   dfi_scalar_units_table( idomain, P_dfi_qnn ) = '  kg(-1)'
   dfi_scalar_streams_table( idomain, P_dfi_qnn )%stream(1) = 0 
   dfi_scalar_streams_table( idomain, P_dfi_qnn )%stream(2) = 2097152 
   F_dfi_qnn = .TRUE.
   IF ( dfi_scalar_index_table( PARAM_dfi_qnc , idomain ) .lt. 1 ) THEN
     dfi_scalar_num_table(idomain) = dfi_scalar_num_table(idomain) + 1
     P_dfi_qnc = dfi_scalar_num_table(idomain)
     dfi_scalar_index_table( PARAM_dfi_qnc , idomain ) = P_dfi_qnc
   ELSE
     P_dfi_qnc = dfi_scalar_index_table( PARAM_dfi_qnc , idomain )
   END IF
   dfi_scalar_boundary_table( idomain, P_dfi_qnc ) = .TRUE.
   dfi_scalar_dname_table( idomain, P_dfi_qnc ) = 'DFI_QNCLOUD'
   dfi_scalar_desc_table( idomain, P_dfi_qnc ) = 'DFI Cloud Number concentration'
   dfi_scalar_units_table( idomain, P_dfi_qnc ) = '  kg(-1)'
   dfi_scalar_streams_table( idomain, P_dfi_qnc )%stream(1) = 0 
   dfi_scalar_streams_table( idomain, P_dfi_qnc )%stream(2) = 2097152 
   F_dfi_qnc = .TRUE.
   IF ( dfi_scalar_index_table( PARAM_dfi_qnr , idomain ) .lt. 1 ) THEN
     dfi_scalar_num_table(idomain) = dfi_scalar_num_table(idomain) + 1
     P_dfi_qnr = dfi_scalar_num_table(idomain)
     dfi_scalar_index_table( PARAM_dfi_qnr , idomain ) = P_dfi_qnr
   ELSE
     P_dfi_qnr = dfi_scalar_index_table( PARAM_dfi_qnr , idomain )
   END IF
   dfi_scalar_boundary_table( idomain, P_dfi_qnr ) = .TRUE.
   dfi_scalar_dname_table( idomain, P_dfi_qnr ) = 'DFI_QNRAIN'
   dfi_scalar_desc_table( idomain, P_dfi_qnr ) = 'DFI Rain Number concentration'
   dfi_scalar_units_table( idomain, P_dfi_qnr ) = '  kg(-1)'
   dfi_scalar_streams_table( idomain, P_dfi_qnr )%stream(1) = 0 
   dfi_scalar_streams_table( idomain, P_dfi_qnr )%stream(2) = 2097152 
   F_dfi_qnr = .TRUE.
  END IF
  IF (model_config_rec%mp_physics_dfi(idomain)==16)THEN
   IF ( dfi_moist_index_table( PARAM_dfi_qv , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qv = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qv , idomain ) = P_dfi_qv
   ELSE
     P_dfi_qv = dfi_moist_index_table( PARAM_dfi_qv , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qv ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qv ) = 'DFI_QVAPOR'
   dfi_moist_desc_table( idomain, P_dfi_qv ) = 'Water vapor mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qv ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qv )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qv )%stream(2) = 2097152 
   F_dfi_qv = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qc , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qc = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qc , idomain ) = P_dfi_qc
   ELSE
     P_dfi_qc = dfi_moist_index_table( PARAM_dfi_qc , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qc ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qc ) = 'DFI_QCLOUD'
   dfi_moist_desc_table( idomain, P_dfi_qc ) = 'Cloud water mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qc ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qc )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qc )%stream(2) = 2097152 
   F_dfi_qc = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qr , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qr = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qr , idomain ) = P_dfi_qr
   ELSE
     P_dfi_qr = dfi_moist_index_table( PARAM_dfi_qr , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qr ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qr ) = 'DFI_QRAIN'
   dfi_moist_desc_table( idomain, P_dfi_qr ) = 'Rain water mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qr ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qr )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qr )%stream(2) = 2097152 
   F_dfi_qr = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qi , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qi = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qi , idomain ) = P_dfi_qi
   ELSE
     P_dfi_qi = dfi_moist_index_table( PARAM_dfi_qi , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qi ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qi ) = 'DFI_QICE'
   dfi_moist_desc_table( idomain, P_dfi_qi ) = 'Ice mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qi ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qi )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qi )%stream(2) = 2097152 
   F_dfi_qi = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qs , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qs = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qs , idomain ) = P_dfi_qs
   ELSE
     P_dfi_qs = dfi_moist_index_table( PARAM_dfi_qs , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qs ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qs ) = 'DFI_QSNOW'
   dfi_moist_desc_table( idomain, P_dfi_qs ) = 'Snow mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qs ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qs )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qs )%stream(2) = 2097152 
   F_dfi_qs = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qg , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qg = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qg , idomain ) = P_dfi_qg
   ELSE
     P_dfi_qg = dfi_moist_index_table( PARAM_dfi_qg , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qg ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qg ) = 'DFI_QGRAUP'
   dfi_moist_desc_table( idomain, P_dfi_qg ) = 'Graupel mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qg ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qg )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qg )%stream(2) = 2097152 
   F_dfi_qg = .TRUE.
   IF ( dfi_scalar_index_table( PARAM_dfi_qnn , idomain ) .lt. 1 ) THEN
     dfi_scalar_num_table(idomain) = dfi_scalar_num_table(idomain) + 1
     P_dfi_qnn = dfi_scalar_num_table(idomain)
     dfi_scalar_index_table( PARAM_dfi_qnn , idomain ) = P_dfi_qnn
   ELSE
     P_dfi_qnn = dfi_scalar_index_table( PARAM_dfi_qnn , idomain )
   END IF
   dfi_scalar_boundary_table( idomain, P_dfi_qnn ) = .TRUE.
   dfi_scalar_dname_table( idomain, P_dfi_qnn ) = 'DFI_QNCC'
   dfi_scalar_desc_table( idomain, P_dfi_qnn ) = 'DFI CNN Number concentration'
   dfi_scalar_units_table( idomain, P_dfi_qnn ) = '  kg(-1)'
   dfi_scalar_streams_table( idomain, P_dfi_qnn )%stream(1) = 0 
   dfi_scalar_streams_table( idomain, P_dfi_qnn )%stream(2) = 2097152 
   F_dfi_qnn = .TRUE.
   IF ( dfi_scalar_index_table( PARAM_dfi_qnc , idomain ) .lt. 1 ) THEN
     dfi_scalar_num_table(idomain) = dfi_scalar_num_table(idomain) + 1
     P_dfi_qnc = dfi_scalar_num_table(idomain)
     dfi_scalar_index_table( PARAM_dfi_qnc , idomain ) = P_dfi_qnc
   ELSE
     P_dfi_qnc = dfi_scalar_index_table( PARAM_dfi_qnc , idomain )
   END IF
   dfi_scalar_boundary_table( idomain, P_dfi_qnc ) = .TRUE.
   dfi_scalar_dname_table( idomain, P_dfi_qnc ) = 'DFI_QNCLOUD'
   dfi_scalar_desc_table( idomain, P_dfi_qnc ) = 'DFI Cloud Number concentration'
   dfi_scalar_units_table( idomain, P_dfi_qnc ) = '  kg(-1)'
   dfi_scalar_streams_table( idomain, P_dfi_qnc )%stream(1) = 0 
   dfi_scalar_streams_table( idomain, P_dfi_qnc )%stream(2) = 2097152 
   F_dfi_qnc = .TRUE.
   IF ( dfi_scalar_index_table( PARAM_dfi_qnr , idomain ) .lt. 1 ) THEN
     dfi_scalar_num_table(idomain) = dfi_scalar_num_table(idomain) + 1
     P_dfi_qnr = dfi_scalar_num_table(idomain)
     dfi_scalar_index_table( PARAM_dfi_qnr , idomain ) = P_dfi_qnr
   ELSE
     P_dfi_qnr = dfi_scalar_index_table( PARAM_dfi_qnr , idomain )
   END IF
   dfi_scalar_boundary_table( idomain, P_dfi_qnr ) = .TRUE.
   dfi_scalar_dname_table( idomain, P_dfi_qnr ) = 'DFI_QNRAIN'
   dfi_scalar_desc_table( idomain, P_dfi_qnr ) = 'DFI Rain Number concentration'
   dfi_scalar_units_table( idomain, P_dfi_qnr ) = '  kg(-1)'
   dfi_scalar_streams_table( idomain, P_dfi_qnr )%stream(1) = 0 
   dfi_scalar_streams_table( idomain, P_dfi_qnr )%stream(2) = 2097152 
   F_dfi_qnr = .TRUE.
  END IF
  IF (model_config_rec%mp_physics_dfi(idomain)==17)THEN
   IF ( dfi_moist_index_table( PARAM_dfi_qv , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qv = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qv , idomain ) = P_dfi_qv
   ELSE
     P_dfi_qv = dfi_moist_index_table( PARAM_dfi_qv , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qv ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qv ) = 'DFI_QVAPOR'
   dfi_moist_desc_table( idomain, P_dfi_qv ) = 'Water vapor mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qv ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qv )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qv )%stream(2) = 2097152 
   F_dfi_qv = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qc , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qc = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qc , idomain ) = P_dfi_qc
   ELSE
     P_dfi_qc = dfi_moist_index_table( PARAM_dfi_qc , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qc ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qc ) = 'DFI_QCLOUD'
   dfi_moist_desc_table( idomain, P_dfi_qc ) = 'Cloud water mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qc ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qc )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qc )%stream(2) = 2097152 
   F_dfi_qc = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qr , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qr = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qr , idomain ) = P_dfi_qr
   ELSE
     P_dfi_qr = dfi_moist_index_table( PARAM_dfi_qr , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qr ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qr ) = 'DFI_QRAIN'
   dfi_moist_desc_table( idomain, P_dfi_qr ) = 'Rain water mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qr ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qr )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qr )%stream(2) = 2097152 
   F_dfi_qr = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qi , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qi = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qi , idomain ) = P_dfi_qi
   ELSE
     P_dfi_qi = dfi_moist_index_table( PARAM_dfi_qi , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qi ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qi ) = 'DFI_QICE'
   dfi_moist_desc_table( idomain, P_dfi_qi ) = 'Ice mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qi ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qi )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qi )%stream(2) = 2097152 
   F_dfi_qi = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qs , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qs = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qs , idomain ) = P_dfi_qs
   ELSE
     P_dfi_qs = dfi_moist_index_table( PARAM_dfi_qs , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qs ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qs ) = 'DFI_QSNOW'
   dfi_moist_desc_table( idomain, P_dfi_qs ) = 'Snow mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qs ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qs )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qs )%stream(2) = 2097152 
   F_dfi_qs = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qg , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qg = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qg , idomain ) = P_dfi_qg
   ELSE
     P_dfi_qg = dfi_moist_index_table( PARAM_dfi_qg , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qg ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qg ) = 'DFI_QGRAUP'
   dfi_moist_desc_table( idomain, P_dfi_qg ) = 'Graupel mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qg ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qg )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qg )%stream(2) = 2097152 
   F_dfi_qg = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qh , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qh = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qh , idomain ) = P_dfi_qh
   ELSE
     P_dfi_qh = dfi_moist_index_table( PARAM_dfi_qh , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qh ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qh ) = 'DFI_QHAIL'
   dfi_moist_desc_table( idomain, P_dfi_qh ) = 'Hail mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qh ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qh )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qh )%stream(2) = 2097152 
   F_dfi_qh = .TRUE.
   IF ( dfi_scalar_index_table( PARAM_dfi_qndrop , idomain ) .lt. 1 ) THEN
     dfi_scalar_num_table(idomain) = dfi_scalar_num_table(idomain) + 1
     P_dfi_qndrop = dfi_scalar_num_table(idomain)
     dfi_scalar_index_table( PARAM_dfi_qndrop , idomain ) = P_dfi_qndrop
   ELSE
     P_dfi_qndrop = dfi_scalar_index_table( PARAM_dfi_qndrop , idomain )
   END IF
   dfi_scalar_boundary_table( idomain, P_dfi_qndrop ) = .TRUE.
   dfi_scalar_dname_table( idomain, P_dfi_qndrop ) = 'DFI_QNDROP'
   dfi_scalar_desc_table( idomain, P_dfi_qndrop ) = 'DFI Droplet number mixing ratio'
   dfi_scalar_units_table( idomain, P_dfi_qndrop ) = '  kg-1'
   dfi_scalar_streams_table( idomain, P_dfi_qndrop )%stream(1) = 0 
   dfi_scalar_streams_table( idomain, P_dfi_qndrop )%stream(2) = 2097152 
   F_dfi_qndrop = .TRUE.
   IF ( dfi_scalar_index_table( PARAM_dfi_qnr , idomain ) .lt. 1 ) THEN
     dfi_scalar_num_table(idomain) = dfi_scalar_num_table(idomain) + 1
     P_dfi_qnr = dfi_scalar_num_table(idomain)
     dfi_scalar_index_table( PARAM_dfi_qnr , idomain ) = P_dfi_qnr
   ELSE
     P_dfi_qnr = dfi_scalar_index_table( PARAM_dfi_qnr , idomain )
   END IF
   dfi_scalar_boundary_table( idomain, P_dfi_qnr ) = .TRUE.
   dfi_scalar_dname_table( idomain, P_dfi_qnr ) = 'DFI_QNRAIN'
   dfi_scalar_desc_table( idomain, P_dfi_qnr ) = 'DFI Rain Number concentration'
   dfi_scalar_units_table( idomain, P_dfi_qnr ) = '  kg(-1)'
   dfi_scalar_streams_table( idomain, P_dfi_qnr )%stream(1) = 0 
   dfi_scalar_streams_table( idomain, P_dfi_qnr )%stream(2) = 2097152 
   F_dfi_qnr = .TRUE.
   IF ( dfi_scalar_index_table( PARAM_dfi_qni , idomain ) .lt. 1 ) THEN
     dfi_scalar_num_table(idomain) = dfi_scalar_num_table(idomain) + 1
     P_dfi_qni = dfi_scalar_num_table(idomain)
     dfi_scalar_index_table( PARAM_dfi_qni , idomain ) = P_dfi_qni
   ELSE
     P_dfi_qni = dfi_scalar_index_table( PARAM_dfi_qni , idomain )
   END IF
   dfi_scalar_boundary_table( idomain, P_dfi_qni ) = .TRUE.
   dfi_scalar_dname_table( idomain, P_dfi_qni ) = 'DFI_QNICE'
   dfi_scalar_desc_table( idomain, P_dfi_qni ) = 'DFI Ice Number concentration'
   dfi_scalar_units_table( idomain, P_dfi_qni ) = '  kg-1'
   dfi_scalar_streams_table( idomain, P_dfi_qni )%stream(1) = 0 
   dfi_scalar_streams_table( idomain, P_dfi_qni )%stream(2) = 2097152 
   F_dfi_qni = .TRUE.
   IF ( dfi_scalar_index_table( PARAM_dfi_qns , idomain ) .lt. 1 ) THEN
     dfi_scalar_num_table(idomain) = dfi_scalar_num_table(idomain) + 1
     P_dfi_qns = dfi_scalar_num_table(idomain)
     dfi_scalar_index_table( PARAM_dfi_qns , idomain ) = P_dfi_qns
   ELSE
     P_dfi_qns = dfi_scalar_index_table( PARAM_dfi_qns , idomain )
   END IF
   dfi_scalar_boundary_table( idomain, P_dfi_qns ) = .TRUE.
   dfi_scalar_dname_table( idomain, P_dfi_qns ) = 'DFI_QNSNOW'
   dfi_scalar_desc_table( idomain, P_dfi_qns ) = 'DFI Snow Number concentration'
   dfi_scalar_units_table( idomain, P_dfi_qns ) = '  kg(-1)'
   dfi_scalar_streams_table( idomain, P_dfi_qns )%stream(1) = 0 
   dfi_scalar_streams_table( idomain, P_dfi_qns )%stream(2) = 2097152 
   F_dfi_qns = .TRUE.
   IF ( dfi_scalar_index_table( PARAM_dfi_qng , idomain ) .lt. 1 ) THEN
     dfi_scalar_num_table(idomain) = dfi_scalar_num_table(idomain) + 1
     P_dfi_qng = dfi_scalar_num_table(idomain)
     dfi_scalar_index_table( PARAM_dfi_qng , idomain ) = P_dfi_qng
   ELSE
     P_dfi_qng = dfi_scalar_index_table( PARAM_dfi_qng , idomain )
   END IF
   dfi_scalar_boundary_table( idomain, P_dfi_qng ) = .TRUE.
   dfi_scalar_dname_table( idomain, P_dfi_qng ) = 'DFI_QNGRAUPEL'
   dfi_scalar_desc_table( idomain, P_dfi_qng ) = 'DFI Graupel Number concentration'
   dfi_scalar_units_table( idomain, P_dfi_qng ) = '  kg(-1)'
   dfi_scalar_streams_table( idomain, P_dfi_qng )%stream(1) = 0 
   dfi_scalar_streams_table( idomain, P_dfi_qng )%stream(2) = 2097152 
   F_dfi_qng = .TRUE.
   IF ( dfi_scalar_index_table( PARAM_dfi_qnh , idomain ) .lt. 1 ) THEN
     dfi_scalar_num_table(idomain) = dfi_scalar_num_table(idomain) + 1
     P_dfi_qnh = dfi_scalar_num_table(idomain)
     dfi_scalar_index_table( PARAM_dfi_qnh , idomain ) = P_dfi_qnh
   ELSE
     P_dfi_qnh = dfi_scalar_index_table( PARAM_dfi_qnh , idomain )
   END IF
   dfi_scalar_boundary_table( idomain, P_dfi_qnh ) = .TRUE.
   dfi_scalar_dname_table( idomain, P_dfi_qnh ) = 'DFI_QNHAIL'
   dfi_scalar_desc_table( idomain, P_dfi_qnh ) = 'DFI Hail Number concentration'
   dfi_scalar_units_table( idomain, P_dfi_qnh ) = '  kg(-1)'
   dfi_scalar_streams_table( idomain, P_dfi_qnh )%stream(1) = 0 
   dfi_scalar_streams_table( idomain, P_dfi_qnh )%stream(2) = 2097152 
   F_dfi_qnh = .TRUE.
   IF ( dfi_scalar_index_table( PARAM_dfi_qvolg , idomain ) .lt. 1 ) THEN
     dfi_scalar_num_table(idomain) = dfi_scalar_num_table(idomain) + 1
     P_dfi_qvolg = dfi_scalar_num_table(idomain)
     dfi_scalar_index_table( PARAM_dfi_qvolg , idomain ) = P_dfi_qvolg
   ELSE
     P_dfi_qvolg = dfi_scalar_index_table( PARAM_dfi_qvolg , idomain )
   END IF
   dfi_scalar_boundary_table( idomain, P_dfi_qvolg ) = .TRUE.
   dfi_scalar_dname_table( idomain, P_dfi_qvolg ) = 'DFI_QVGRAUPEL'
   dfi_scalar_desc_table( idomain, P_dfi_qvolg ) = 'DFI Graupel Particle Volume'
   dfi_scalar_units_table( idomain, P_dfi_qvolg ) = 'm(3) kg(-1)'
   dfi_scalar_streams_table( idomain, P_dfi_qvolg )%stream(1) = 1 
   dfi_scalar_streams_table( idomain, P_dfi_qvolg )%stream(2) = 2097152 
   F_dfi_qvolg = .TRUE.
   IF ( dfi_scalar_index_table( PARAM_dfi_qvolh , idomain ) .lt. 1 ) THEN
     dfi_scalar_num_table(idomain) = dfi_scalar_num_table(idomain) + 1
     P_dfi_qvolh = dfi_scalar_num_table(idomain)
     dfi_scalar_index_table( PARAM_dfi_qvolh , idomain ) = P_dfi_qvolh
   ELSE
     P_dfi_qvolh = dfi_scalar_index_table( PARAM_dfi_qvolh , idomain )
   END IF
   dfi_scalar_boundary_table( idomain, P_dfi_qvolh ) = .TRUE.
   dfi_scalar_dname_table( idomain, P_dfi_qvolh ) = 'DFI_QVHAIL'
   dfi_scalar_desc_table( idomain, P_dfi_qvolh ) = 'DFI Hail Particle Volume'
   dfi_scalar_units_table( idomain, P_dfi_qvolh ) = 'm(3) kg(-1)'
   dfi_scalar_streams_table( idomain, P_dfi_qvolh )%stream(1) = 1 
   dfi_scalar_streams_table( idomain, P_dfi_qvolh )%stream(2) = 2097152 
   F_dfi_qvolh = .TRUE.
  END IF
  IF (model_config_rec%mp_physics_dfi(idomain)==18)THEN
   IF ( dfi_moist_index_table( PARAM_dfi_qv , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qv = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qv , idomain ) = P_dfi_qv
   ELSE
     P_dfi_qv = dfi_moist_index_table( PARAM_dfi_qv , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qv ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qv ) = 'DFI_QVAPOR'
   dfi_moist_desc_table( idomain, P_dfi_qv ) = 'Water vapor mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qv ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qv )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qv )%stream(2) = 2097152 
   F_dfi_qv = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qc , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qc = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qc , idomain ) = P_dfi_qc
   ELSE
     P_dfi_qc = dfi_moist_index_table( PARAM_dfi_qc , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qc ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qc ) = 'DFI_QCLOUD'
   dfi_moist_desc_table( idomain, P_dfi_qc ) = 'Cloud water mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qc ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qc )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qc )%stream(2) = 2097152 
   F_dfi_qc = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qr , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qr = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qr , idomain ) = P_dfi_qr
   ELSE
     P_dfi_qr = dfi_moist_index_table( PARAM_dfi_qr , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qr ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qr ) = 'DFI_QRAIN'
   dfi_moist_desc_table( idomain, P_dfi_qr ) = 'Rain water mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qr ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qr )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qr )%stream(2) = 2097152 
   F_dfi_qr = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qi , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qi = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qi , idomain ) = P_dfi_qi
   ELSE
     P_dfi_qi = dfi_moist_index_table( PARAM_dfi_qi , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qi ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qi ) = 'DFI_QICE'
   dfi_moist_desc_table( idomain, P_dfi_qi ) = 'Ice mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qi ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qi )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qi )%stream(2) = 2097152 
   F_dfi_qi = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qs , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qs = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qs , idomain ) = P_dfi_qs
   ELSE
     P_dfi_qs = dfi_moist_index_table( PARAM_dfi_qs , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qs ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qs ) = 'DFI_QSNOW'
   dfi_moist_desc_table( idomain, P_dfi_qs ) = 'Snow mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qs ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qs )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qs )%stream(2) = 2097152 
   F_dfi_qs = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qg , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qg = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qg , idomain ) = P_dfi_qg
   ELSE
     P_dfi_qg = dfi_moist_index_table( PARAM_dfi_qg , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qg ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qg ) = 'DFI_QGRAUP'
   dfi_moist_desc_table( idomain, P_dfi_qg ) = 'Graupel mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qg ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qg )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qg )%stream(2) = 2097152 
   F_dfi_qg = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qh , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qh = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qh , idomain ) = P_dfi_qh
   ELSE
     P_dfi_qh = dfi_moist_index_table( PARAM_dfi_qh , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qh ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qh ) = 'DFI_QHAIL'
   dfi_moist_desc_table( idomain, P_dfi_qh ) = 'Hail mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qh ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qh )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qh )%stream(2) = 2097152 
   F_dfi_qh = .TRUE.
   IF ( dfi_scalar_index_table( PARAM_dfi_qndrop , idomain ) .lt. 1 ) THEN
     dfi_scalar_num_table(idomain) = dfi_scalar_num_table(idomain) + 1
     P_dfi_qndrop = dfi_scalar_num_table(idomain)
     dfi_scalar_index_table( PARAM_dfi_qndrop , idomain ) = P_dfi_qndrop
   ELSE
     P_dfi_qndrop = dfi_scalar_index_table( PARAM_dfi_qndrop , idomain )
   END IF
   dfi_scalar_boundary_table( idomain, P_dfi_qndrop ) = .TRUE.
   dfi_scalar_dname_table( idomain, P_dfi_qndrop ) = 'DFI_QNDROP'
   dfi_scalar_desc_table( idomain, P_dfi_qndrop ) = 'DFI Droplet number mixing ratio'
   dfi_scalar_units_table( idomain, P_dfi_qndrop ) = '  kg-1'
   dfi_scalar_streams_table( idomain, P_dfi_qndrop )%stream(1) = 0 
   dfi_scalar_streams_table( idomain, P_dfi_qndrop )%stream(2) = 2097152 
   F_dfi_qndrop = .TRUE.
   IF ( dfi_scalar_index_table( PARAM_dfi_qnn , idomain ) .lt. 1 ) THEN
     dfi_scalar_num_table(idomain) = dfi_scalar_num_table(idomain) + 1
     P_dfi_qnn = dfi_scalar_num_table(idomain)
     dfi_scalar_index_table( PARAM_dfi_qnn , idomain ) = P_dfi_qnn
   ELSE
     P_dfi_qnn = dfi_scalar_index_table( PARAM_dfi_qnn , idomain )
   END IF
   dfi_scalar_boundary_table( idomain, P_dfi_qnn ) = .TRUE.
   dfi_scalar_dname_table( idomain, P_dfi_qnn ) = 'DFI_QNCC'
   dfi_scalar_desc_table( idomain, P_dfi_qnn ) = 'DFI CNN Number concentration'
   dfi_scalar_units_table( idomain, P_dfi_qnn ) = '  kg(-1)'
   dfi_scalar_streams_table( idomain, P_dfi_qnn )%stream(1) = 0 
   dfi_scalar_streams_table( idomain, P_dfi_qnn )%stream(2) = 2097152 
   F_dfi_qnn = .TRUE.
   IF ( dfi_scalar_index_table( PARAM_dfi_qnr , idomain ) .lt. 1 ) THEN
     dfi_scalar_num_table(idomain) = dfi_scalar_num_table(idomain) + 1
     P_dfi_qnr = dfi_scalar_num_table(idomain)
     dfi_scalar_index_table( PARAM_dfi_qnr , idomain ) = P_dfi_qnr
   ELSE
     P_dfi_qnr = dfi_scalar_index_table( PARAM_dfi_qnr , idomain )
   END IF
   dfi_scalar_boundary_table( idomain, P_dfi_qnr ) = .TRUE.
   dfi_scalar_dname_table( idomain, P_dfi_qnr ) = 'DFI_QNRAIN'
   dfi_scalar_desc_table( idomain, P_dfi_qnr ) = 'DFI Rain Number concentration'
   dfi_scalar_units_table( idomain, P_dfi_qnr ) = '  kg(-1)'
   dfi_scalar_streams_table( idomain, P_dfi_qnr )%stream(1) = 0 
   dfi_scalar_streams_table( idomain, P_dfi_qnr )%stream(2) = 2097152 
   F_dfi_qnr = .TRUE.
   IF ( dfi_scalar_index_table( PARAM_dfi_qni , idomain ) .lt. 1 ) THEN
     dfi_scalar_num_table(idomain) = dfi_scalar_num_table(idomain) + 1
     P_dfi_qni = dfi_scalar_num_table(idomain)
     dfi_scalar_index_table( PARAM_dfi_qni , idomain ) = P_dfi_qni
   ELSE
     P_dfi_qni = dfi_scalar_index_table( PARAM_dfi_qni , idomain )
   END IF
   dfi_scalar_boundary_table( idomain, P_dfi_qni ) = .TRUE.
   dfi_scalar_dname_table( idomain, P_dfi_qni ) = 'DFI_QNICE'
   dfi_scalar_desc_table( idomain, P_dfi_qni ) = 'DFI Ice Number concentration'
   dfi_scalar_units_table( idomain, P_dfi_qni ) = '  kg-1'
   dfi_scalar_streams_table( idomain, P_dfi_qni )%stream(1) = 0 
   dfi_scalar_streams_table( idomain, P_dfi_qni )%stream(2) = 2097152 
   F_dfi_qni = .TRUE.
   IF ( dfi_scalar_index_table( PARAM_dfi_qns , idomain ) .lt. 1 ) THEN
     dfi_scalar_num_table(idomain) = dfi_scalar_num_table(idomain) + 1
     P_dfi_qns = dfi_scalar_num_table(idomain)
     dfi_scalar_index_table( PARAM_dfi_qns , idomain ) = P_dfi_qns
   ELSE
     P_dfi_qns = dfi_scalar_index_table( PARAM_dfi_qns , idomain )
   END IF
   dfi_scalar_boundary_table( idomain, P_dfi_qns ) = .TRUE.
   dfi_scalar_dname_table( idomain, P_dfi_qns ) = 'DFI_QNSNOW'
   dfi_scalar_desc_table( idomain, P_dfi_qns ) = 'DFI Snow Number concentration'
   dfi_scalar_units_table( idomain, P_dfi_qns ) = '  kg(-1)'
   dfi_scalar_streams_table( idomain, P_dfi_qns )%stream(1) = 0 
   dfi_scalar_streams_table( idomain, P_dfi_qns )%stream(2) = 2097152 
   F_dfi_qns = .TRUE.
   IF ( dfi_scalar_index_table( PARAM_dfi_qng , idomain ) .lt. 1 ) THEN
     dfi_scalar_num_table(idomain) = dfi_scalar_num_table(idomain) + 1
     P_dfi_qng = dfi_scalar_num_table(idomain)
     dfi_scalar_index_table( PARAM_dfi_qng , idomain ) = P_dfi_qng
   ELSE
     P_dfi_qng = dfi_scalar_index_table( PARAM_dfi_qng , idomain )
   END IF
   dfi_scalar_boundary_table( idomain, P_dfi_qng ) = .TRUE.
   dfi_scalar_dname_table( idomain, P_dfi_qng ) = 'DFI_QNGRAUPEL'
   dfi_scalar_desc_table( idomain, P_dfi_qng ) = 'DFI Graupel Number concentration'
   dfi_scalar_units_table( idomain, P_dfi_qng ) = '  kg(-1)'
   dfi_scalar_streams_table( idomain, P_dfi_qng )%stream(1) = 0 
   dfi_scalar_streams_table( idomain, P_dfi_qng )%stream(2) = 2097152 
   F_dfi_qng = .TRUE.
   IF ( dfi_scalar_index_table( PARAM_dfi_qnh , idomain ) .lt. 1 ) THEN
     dfi_scalar_num_table(idomain) = dfi_scalar_num_table(idomain) + 1
     P_dfi_qnh = dfi_scalar_num_table(idomain)
     dfi_scalar_index_table( PARAM_dfi_qnh , idomain ) = P_dfi_qnh
   ELSE
     P_dfi_qnh = dfi_scalar_index_table( PARAM_dfi_qnh , idomain )
   END IF
   dfi_scalar_boundary_table( idomain, P_dfi_qnh ) = .TRUE.
   dfi_scalar_dname_table( idomain, P_dfi_qnh ) = 'DFI_QNHAIL'
   dfi_scalar_desc_table( idomain, P_dfi_qnh ) = 'DFI Hail Number concentration'
   dfi_scalar_units_table( idomain, P_dfi_qnh ) = '  kg(-1)'
   dfi_scalar_streams_table( idomain, P_dfi_qnh )%stream(1) = 0 
   dfi_scalar_streams_table( idomain, P_dfi_qnh )%stream(2) = 2097152 
   F_dfi_qnh = .TRUE.
   IF ( dfi_scalar_index_table( PARAM_dfi_qvolg , idomain ) .lt. 1 ) THEN
     dfi_scalar_num_table(idomain) = dfi_scalar_num_table(idomain) + 1
     P_dfi_qvolg = dfi_scalar_num_table(idomain)
     dfi_scalar_index_table( PARAM_dfi_qvolg , idomain ) = P_dfi_qvolg
   ELSE
     P_dfi_qvolg = dfi_scalar_index_table( PARAM_dfi_qvolg , idomain )
   END IF
   dfi_scalar_boundary_table( idomain, P_dfi_qvolg ) = .TRUE.
   dfi_scalar_dname_table( idomain, P_dfi_qvolg ) = 'DFI_QVGRAUPEL'
   dfi_scalar_desc_table( idomain, P_dfi_qvolg ) = 'DFI Graupel Particle Volume'
   dfi_scalar_units_table( idomain, P_dfi_qvolg ) = 'm(3) kg(-1)'
   dfi_scalar_streams_table( idomain, P_dfi_qvolg )%stream(1) = 1 
   dfi_scalar_streams_table( idomain, P_dfi_qvolg )%stream(2) = 2097152 
   F_dfi_qvolg = .TRUE.
  END IF
  IF (model_config_rec%mp_physics_dfi(idomain)==19)THEN
   IF ( dfi_moist_index_table( PARAM_dfi_qv , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qv = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qv , idomain ) = P_dfi_qv
   ELSE
     P_dfi_qv = dfi_moist_index_table( PARAM_dfi_qv , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qv ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qv ) = 'DFI_QVAPOR'
   dfi_moist_desc_table( idomain, P_dfi_qv ) = 'Water vapor mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qv ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qv )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qv )%stream(2) = 2097152 
   F_dfi_qv = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qc , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qc = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qc , idomain ) = P_dfi_qc
   ELSE
     P_dfi_qc = dfi_moist_index_table( PARAM_dfi_qc , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qc ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qc ) = 'DFI_QCLOUD'
   dfi_moist_desc_table( idomain, P_dfi_qc ) = 'Cloud water mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qc ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qc )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qc )%stream(2) = 2097152 
   F_dfi_qc = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qr , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qr = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qr , idomain ) = P_dfi_qr
   ELSE
     P_dfi_qr = dfi_moist_index_table( PARAM_dfi_qr , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qr ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qr ) = 'DFI_QRAIN'
   dfi_moist_desc_table( idomain, P_dfi_qr ) = 'Rain water mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qr ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qr )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qr )%stream(2) = 2097152 
   F_dfi_qr = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qi , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qi = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qi , idomain ) = P_dfi_qi
   ELSE
     P_dfi_qi = dfi_moist_index_table( PARAM_dfi_qi , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qi ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qi ) = 'DFI_QICE'
   dfi_moist_desc_table( idomain, P_dfi_qi ) = 'Ice mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qi ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qi )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qi )%stream(2) = 2097152 
   F_dfi_qi = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qs , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qs = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qs , idomain ) = P_dfi_qs
   ELSE
     P_dfi_qs = dfi_moist_index_table( PARAM_dfi_qs , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qs ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qs ) = 'DFI_QSNOW'
   dfi_moist_desc_table( idomain, P_dfi_qs ) = 'Snow mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qs ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qs )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qs )%stream(2) = 2097152 
   F_dfi_qs = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qg , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qg = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qg , idomain ) = P_dfi_qg
   ELSE
     P_dfi_qg = dfi_moist_index_table( PARAM_dfi_qg , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qg ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qg ) = 'DFI_QGRAUP'
   dfi_moist_desc_table( idomain, P_dfi_qg ) = 'Graupel mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qg ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qg )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qg )%stream(2) = 2097152 
   F_dfi_qg = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qh , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qh = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qh , idomain ) = P_dfi_qh
   ELSE
     P_dfi_qh = dfi_moist_index_table( PARAM_dfi_qh , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qh ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qh ) = 'DFI_QHAIL'
   dfi_moist_desc_table( idomain, P_dfi_qh ) = 'Hail mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qh ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qh )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qh )%stream(2) = 2097152 
   F_dfi_qh = .TRUE.
   IF ( dfi_scalar_index_table( PARAM_dfi_qvolg , idomain ) .lt. 1 ) THEN
     dfi_scalar_num_table(idomain) = dfi_scalar_num_table(idomain) + 1
     P_dfi_qvolg = dfi_scalar_num_table(idomain)
     dfi_scalar_index_table( PARAM_dfi_qvolg , idomain ) = P_dfi_qvolg
   ELSE
     P_dfi_qvolg = dfi_scalar_index_table( PARAM_dfi_qvolg , idomain )
   END IF
   dfi_scalar_boundary_table( idomain, P_dfi_qvolg ) = .TRUE.
   dfi_scalar_dname_table( idomain, P_dfi_qvolg ) = 'DFI_QVGRAUPEL'
   dfi_scalar_desc_table( idomain, P_dfi_qvolg ) = 'DFI Graupel Particle Volume'
   dfi_scalar_units_table( idomain, P_dfi_qvolg ) = 'm(3) kg(-1)'
   dfi_scalar_streams_table( idomain, P_dfi_qvolg )%stream(1) = 1 
   dfi_scalar_streams_table( idomain, P_dfi_qvolg )%stream(2) = 2097152 
   F_dfi_qvolg = .TRUE.
  END IF
  IF (model_config_rec%mp_physics_dfi(idomain)==21)THEN
   IF ( dfi_moist_index_table( PARAM_dfi_qv , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qv = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qv , idomain ) = P_dfi_qv
   ELSE
     P_dfi_qv = dfi_moist_index_table( PARAM_dfi_qv , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qv ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qv ) = 'DFI_QVAPOR'
   dfi_moist_desc_table( idomain, P_dfi_qv ) = 'Water vapor mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qv ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qv )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qv )%stream(2) = 2097152 
   F_dfi_qv = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qc , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qc = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qc , idomain ) = P_dfi_qc
   ELSE
     P_dfi_qc = dfi_moist_index_table( PARAM_dfi_qc , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qc ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qc ) = 'DFI_QCLOUD'
   dfi_moist_desc_table( idomain, P_dfi_qc ) = 'Cloud water mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qc ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qc )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qc )%stream(2) = 2097152 
   F_dfi_qc = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qr , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qr = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qr , idomain ) = P_dfi_qr
   ELSE
     P_dfi_qr = dfi_moist_index_table( PARAM_dfi_qr , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qr ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qr ) = 'DFI_QRAIN'
   dfi_moist_desc_table( idomain, P_dfi_qr ) = 'Rain water mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qr ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qr )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qr )%stream(2) = 2097152 
   F_dfi_qr = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qi , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qi = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qi , idomain ) = P_dfi_qi
   ELSE
     P_dfi_qi = dfi_moist_index_table( PARAM_dfi_qi , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qi ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qi ) = 'DFI_QICE'
   dfi_moist_desc_table( idomain, P_dfi_qi ) = 'Ice mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qi ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qi )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qi )%stream(2) = 2097152 
   F_dfi_qi = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qs , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qs = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qs , idomain ) = P_dfi_qs
   ELSE
     P_dfi_qs = dfi_moist_index_table( PARAM_dfi_qs , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qs ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qs ) = 'DFI_QSNOW'
   dfi_moist_desc_table( idomain, P_dfi_qs ) = 'Snow mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qs ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qs )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qs )%stream(2) = 2097152 
   F_dfi_qs = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qg , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qg = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qg , idomain ) = P_dfi_qg
   ELSE
     P_dfi_qg = dfi_moist_index_table( PARAM_dfi_qg , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qg ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qg ) = 'DFI_QGRAUP'
   dfi_moist_desc_table( idomain, P_dfi_qg ) = 'Graupel mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qg ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qg )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qg )%stream(2) = 2097152 
   F_dfi_qg = .TRUE.
  END IF
  IF (model_config_rec%mp_physics_dfi(idomain)==24)THEN
   IF ( dfi_moist_index_table( PARAM_dfi_qv , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qv = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qv , idomain ) = P_dfi_qv
   ELSE
     P_dfi_qv = dfi_moist_index_table( PARAM_dfi_qv , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qv ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qv ) = 'DFI_QVAPOR'
   dfi_moist_desc_table( idomain, P_dfi_qv ) = 'Water vapor mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qv ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qv )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qv )%stream(2) = 2097152 
   F_dfi_qv = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qc , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qc = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qc , idomain ) = P_dfi_qc
   ELSE
     P_dfi_qc = dfi_moist_index_table( PARAM_dfi_qc , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qc ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qc ) = 'DFI_QCLOUD'
   dfi_moist_desc_table( idomain, P_dfi_qc ) = 'Cloud water mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qc ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qc )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qc )%stream(2) = 2097152 
   F_dfi_qc = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qr , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qr = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qr , idomain ) = P_dfi_qr
   ELSE
     P_dfi_qr = dfi_moist_index_table( PARAM_dfi_qr , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qr ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qr ) = 'DFI_QRAIN'
   dfi_moist_desc_table( idomain, P_dfi_qr ) = 'Rain water mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qr ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qr )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qr )%stream(2) = 2097152 
   F_dfi_qr = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qi , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qi = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qi , idomain ) = P_dfi_qi
   ELSE
     P_dfi_qi = dfi_moist_index_table( PARAM_dfi_qi , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qi ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qi ) = 'DFI_QICE'
   dfi_moist_desc_table( idomain, P_dfi_qi ) = 'Ice mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qi ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qi )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qi )%stream(2) = 2097152 
   F_dfi_qi = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qs , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qs = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qs , idomain ) = P_dfi_qs
   ELSE
     P_dfi_qs = dfi_moist_index_table( PARAM_dfi_qs , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qs ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qs ) = 'DFI_QSNOW'
   dfi_moist_desc_table( idomain, P_dfi_qs ) = 'Snow mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qs ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qs )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qs )%stream(2) = 2097152 
   F_dfi_qs = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qg , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qg = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qg , idomain ) = P_dfi_qg
   ELSE
     P_dfi_qg = dfi_moist_index_table( PARAM_dfi_qg , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qg ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qg ) = 'DFI_QGRAUP'
   dfi_moist_desc_table( idomain, P_dfi_qg ) = 'Graupel mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qg ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qg )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qg )%stream(2) = 2097152 
   F_dfi_qg = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qh , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qh = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qh , idomain ) = P_dfi_qh
   ELSE
     P_dfi_qh = dfi_moist_index_table( PARAM_dfi_qh , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qh ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qh ) = 'DFI_QHAIL'
   dfi_moist_desc_table( idomain, P_dfi_qh ) = 'Hail mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qh ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qh )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qh )%stream(2) = 2097152 
   F_dfi_qh = .TRUE.
  END IF
  IF (model_config_rec%mp_physics_dfi(idomain)==26)THEN
   IF ( dfi_moist_index_table( PARAM_dfi_qv , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qv = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qv , idomain ) = P_dfi_qv
   ELSE
     P_dfi_qv = dfi_moist_index_table( PARAM_dfi_qv , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qv ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qv ) = 'DFI_QVAPOR'
   dfi_moist_desc_table( idomain, P_dfi_qv ) = 'Water vapor mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qv ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qv )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qv )%stream(2) = 2097152 
   F_dfi_qv = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qc , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qc = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qc , idomain ) = P_dfi_qc
   ELSE
     P_dfi_qc = dfi_moist_index_table( PARAM_dfi_qc , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qc ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qc ) = 'DFI_QCLOUD'
   dfi_moist_desc_table( idomain, P_dfi_qc ) = 'Cloud water mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qc ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qc )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qc )%stream(2) = 2097152 
   F_dfi_qc = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qr , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qr = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qr , idomain ) = P_dfi_qr
   ELSE
     P_dfi_qr = dfi_moist_index_table( PARAM_dfi_qr , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qr ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qr ) = 'DFI_QRAIN'
   dfi_moist_desc_table( idomain, P_dfi_qr ) = 'Rain water mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qr ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qr )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qr )%stream(2) = 2097152 
   F_dfi_qr = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qi , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qi = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qi , idomain ) = P_dfi_qi
   ELSE
     P_dfi_qi = dfi_moist_index_table( PARAM_dfi_qi , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qi ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qi ) = 'DFI_QICE'
   dfi_moist_desc_table( idomain, P_dfi_qi ) = 'Ice mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qi ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qi )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qi )%stream(2) = 2097152 
   F_dfi_qi = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qs , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qs = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qs , idomain ) = P_dfi_qs
   ELSE
     P_dfi_qs = dfi_moist_index_table( PARAM_dfi_qs , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qs ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qs ) = 'DFI_QSNOW'
   dfi_moist_desc_table( idomain, P_dfi_qs ) = 'Snow mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qs ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qs )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qs )%stream(2) = 2097152 
   F_dfi_qs = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qg , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qg = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qg , idomain ) = P_dfi_qg
   ELSE
     P_dfi_qg = dfi_moist_index_table( PARAM_dfi_qg , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qg ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qg ) = 'DFI_QGRAUP'
   dfi_moist_desc_table( idomain, P_dfi_qg ) = 'Graupel mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qg ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qg )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qg )%stream(2) = 2097152 
   F_dfi_qg = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qh , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qh = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qh , idomain ) = P_dfi_qh
   ELSE
     P_dfi_qh = dfi_moist_index_table( PARAM_dfi_qh , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qh ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qh ) = 'DFI_QHAIL'
   dfi_moist_desc_table( idomain, P_dfi_qh ) = 'Hail mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qh ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qh )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qh )%stream(2) = 2097152 
   F_dfi_qh = .TRUE.
   IF ( dfi_scalar_index_table( PARAM_dfi_qnn , idomain ) .lt. 1 ) THEN
     dfi_scalar_num_table(idomain) = dfi_scalar_num_table(idomain) + 1
     P_dfi_qnn = dfi_scalar_num_table(idomain)
     dfi_scalar_index_table( PARAM_dfi_qnn , idomain ) = P_dfi_qnn
   ELSE
     P_dfi_qnn = dfi_scalar_index_table( PARAM_dfi_qnn , idomain )
   END IF
   dfi_scalar_boundary_table( idomain, P_dfi_qnn ) = .TRUE.
   dfi_scalar_dname_table( idomain, P_dfi_qnn ) = 'DFI_QNCC'
   dfi_scalar_desc_table( idomain, P_dfi_qnn ) = 'DFI CNN Number concentration'
   dfi_scalar_units_table( idomain, P_dfi_qnn ) = '  kg(-1)'
   dfi_scalar_streams_table( idomain, P_dfi_qnn )%stream(1) = 0 
   dfi_scalar_streams_table( idomain, P_dfi_qnn )%stream(2) = 2097152 
   F_dfi_qnn = .TRUE.
   IF ( dfi_scalar_index_table( PARAM_dfi_qnc , idomain ) .lt. 1 ) THEN
     dfi_scalar_num_table(idomain) = dfi_scalar_num_table(idomain) + 1
     P_dfi_qnc = dfi_scalar_num_table(idomain)
     dfi_scalar_index_table( PARAM_dfi_qnc , idomain ) = P_dfi_qnc
   ELSE
     P_dfi_qnc = dfi_scalar_index_table( PARAM_dfi_qnc , idomain )
   END IF
   dfi_scalar_boundary_table( idomain, P_dfi_qnc ) = .TRUE.
   dfi_scalar_dname_table( idomain, P_dfi_qnc ) = 'DFI_QNCLOUD'
   dfi_scalar_desc_table( idomain, P_dfi_qnc ) = 'DFI Cloud Number concentration'
   dfi_scalar_units_table( idomain, P_dfi_qnc ) = '  kg(-1)'
   dfi_scalar_streams_table( idomain, P_dfi_qnc )%stream(1) = 0 
   dfi_scalar_streams_table( idomain, P_dfi_qnc )%stream(2) = 2097152 
   F_dfi_qnc = .TRUE.
   IF ( dfi_scalar_index_table( PARAM_dfi_qnr , idomain ) .lt. 1 ) THEN
     dfi_scalar_num_table(idomain) = dfi_scalar_num_table(idomain) + 1
     P_dfi_qnr = dfi_scalar_num_table(idomain)
     dfi_scalar_index_table( PARAM_dfi_qnr , idomain ) = P_dfi_qnr
   ELSE
     P_dfi_qnr = dfi_scalar_index_table( PARAM_dfi_qnr , idomain )
   END IF
   dfi_scalar_boundary_table( idomain, P_dfi_qnr ) = .TRUE.
   dfi_scalar_dname_table( idomain, P_dfi_qnr ) = 'DFI_QNRAIN'
   dfi_scalar_desc_table( idomain, P_dfi_qnr ) = 'DFI Rain Number concentration'
   dfi_scalar_units_table( idomain, P_dfi_qnr ) = '  kg(-1)'
   dfi_scalar_streams_table( idomain, P_dfi_qnr )%stream(1) = 0 
   dfi_scalar_streams_table( idomain, P_dfi_qnr )%stream(2) = 2097152 
   F_dfi_qnr = .TRUE.
  END IF
  IF (model_config_rec%mp_physics_dfi(idomain)==28)THEN
   IF ( dfi_moist_index_table( PARAM_dfi_qv , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qv = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qv , idomain ) = P_dfi_qv
   ELSE
     P_dfi_qv = dfi_moist_index_table( PARAM_dfi_qv , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qv ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qv ) = 'DFI_QVAPOR'
   dfi_moist_desc_table( idomain, P_dfi_qv ) = 'Water vapor mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qv ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qv )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qv )%stream(2) = 2097152 
   F_dfi_qv = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qc , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qc = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qc , idomain ) = P_dfi_qc
   ELSE
     P_dfi_qc = dfi_moist_index_table( PARAM_dfi_qc , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qc ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qc ) = 'DFI_QCLOUD'
   dfi_moist_desc_table( idomain, P_dfi_qc ) = 'Cloud water mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qc ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qc )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qc )%stream(2) = 2097152 
   F_dfi_qc = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qr , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qr = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qr , idomain ) = P_dfi_qr
   ELSE
     P_dfi_qr = dfi_moist_index_table( PARAM_dfi_qr , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qr ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qr ) = 'DFI_QRAIN'
   dfi_moist_desc_table( idomain, P_dfi_qr ) = 'Rain water mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qr ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qr )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qr )%stream(2) = 2097152 
   F_dfi_qr = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qi , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qi = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qi , idomain ) = P_dfi_qi
   ELSE
     P_dfi_qi = dfi_moist_index_table( PARAM_dfi_qi , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qi ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qi ) = 'DFI_QICE'
   dfi_moist_desc_table( idomain, P_dfi_qi ) = 'Ice mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qi ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qi )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qi )%stream(2) = 2097152 
   F_dfi_qi = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qs , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qs = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qs , idomain ) = P_dfi_qs
   ELSE
     P_dfi_qs = dfi_moist_index_table( PARAM_dfi_qs , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qs ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qs ) = 'DFI_QSNOW'
   dfi_moist_desc_table( idomain, P_dfi_qs ) = 'Snow mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qs ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qs )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qs )%stream(2) = 2097152 
   F_dfi_qs = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qg , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qg = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qg , idomain ) = P_dfi_qg
   ELSE
     P_dfi_qg = dfi_moist_index_table( PARAM_dfi_qg , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qg ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qg ) = 'DFI_QGRAUP'
   dfi_moist_desc_table( idomain, P_dfi_qg ) = 'Graupel mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qg ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qg )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qg )%stream(2) = 2097152 
   F_dfi_qg = .TRUE.
   IF ( dfi_scalar_index_table( PARAM_dfi_qni , idomain ) .lt. 1 ) THEN
     dfi_scalar_num_table(idomain) = dfi_scalar_num_table(idomain) + 1
     P_dfi_qni = dfi_scalar_num_table(idomain)
     dfi_scalar_index_table( PARAM_dfi_qni , idomain ) = P_dfi_qni
   ELSE
     P_dfi_qni = dfi_scalar_index_table( PARAM_dfi_qni , idomain )
   END IF
   dfi_scalar_boundary_table( idomain, P_dfi_qni ) = .TRUE.
   dfi_scalar_dname_table( idomain, P_dfi_qni ) = 'DFI_QNICE'
   dfi_scalar_desc_table( idomain, P_dfi_qni ) = 'DFI Ice Number concentration'
   dfi_scalar_units_table( idomain, P_dfi_qni ) = '  kg-1'
   dfi_scalar_streams_table( idomain, P_dfi_qni )%stream(1) = 0 
   dfi_scalar_streams_table( idomain, P_dfi_qni )%stream(2) = 2097152 
   F_dfi_qni = .TRUE.
   IF ( dfi_scalar_index_table( PARAM_dfi_qnr , idomain ) .lt. 1 ) THEN
     dfi_scalar_num_table(idomain) = dfi_scalar_num_table(idomain) + 1
     P_dfi_qnr = dfi_scalar_num_table(idomain)
     dfi_scalar_index_table( PARAM_dfi_qnr , idomain ) = P_dfi_qnr
   ELSE
     P_dfi_qnr = dfi_scalar_index_table( PARAM_dfi_qnr , idomain )
   END IF
   dfi_scalar_boundary_table( idomain, P_dfi_qnr ) = .TRUE.
   dfi_scalar_dname_table( idomain, P_dfi_qnr ) = 'DFI_QNRAIN'
   dfi_scalar_desc_table( idomain, P_dfi_qnr ) = 'DFI Rain Number concentration'
   dfi_scalar_units_table( idomain, P_dfi_qnr ) = '  kg(-1)'
   dfi_scalar_streams_table( idomain, P_dfi_qnr )%stream(1) = 0 
   dfi_scalar_streams_table( idomain, P_dfi_qnr )%stream(2) = 2097152 
   F_dfi_qnr = .TRUE.
   IF ( dfi_scalar_index_table( PARAM_dfi_qnc , idomain ) .lt. 1 ) THEN
     dfi_scalar_num_table(idomain) = dfi_scalar_num_table(idomain) + 1
     P_dfi_qnc = dfi_scalar_num_table(idomain)
     dfi_scalar_index_table( PARAM_dfi_qnc , idomain ) = P_dfi_qnc
   ELSE
     P_dfi_qnc = dfi_scalar_index_table( PARAM_dfi_qnc , idomain )
   END IF
   dfi_scalar_boundary_table( idomain, P_dfi_qnc ) = .TRUE.
   dfi_scalar_dname_table( idomain, P_dfi_qnc ) = 'DFI_QNCLOUD'
   dfi_scalar_desc_table( idomain, P_dfi_qnc ) = 'DFI Cloud Number concentration'
   dfi_scalar_units_table( idomain, P_dfi_qnc ) = '  kg(-1)'
   dfi_scalar_streams_table( idomain, P_dfi_qnc )%stream(1) = 0 
   dfi_scalar_streams_table( idomain, P_dfi_qnc )%stream(2) = 2097152 
   F_dfi_qnc = .TRUE.
   IF ( dfi_scalar_index_table( PARAM_dfi_qnwfa , idomain ) .lt. 1 ) THEN
     dfi_scalar_num_table(idomain) = dfi_scalar_num_table(idomain) + 1
     P_dfi_qnwfa = dfi_scalar_num_table(idomain)
     dfi_scalar_index_table( PARAM_dfi_qnwfa , idomain ) = P_dfi_qnwfa
   ELSE
     P_dfi_qnwfa = dfi_scalar_index_table( PARAM_dfi_qnwfa , idomain )
   END IF
   dfi_scalar_boundary_table( idomain, P_dfi_qnwfa ) = .TRUE.
   dfi_scalar_dname_table( idomain, P_dfi_qnwfa ) = 'DFI_QNWFA'
   dfi_scalar_desc_table( idomain, P_dfi_qnwfa ) = 'DFI water-friendly aerosol number con'
   dfi_scalar_units_table( idomain, P_dfi_qnwfa ) = '  kg(-1)'
   dfi_scalar_streams_table( idomain, P_dfi_qnwfa )%stream(1) = 33554433 
   dfi_scalar_streams_table( idomain, P_dfi_qnwfa )%stream(2) = 2097152 
   F_dfi_qnwfa = .TRUE.
   IF ( dfi_scalar_index_table( PARAM_dfi_qnifa , idomain ) .lt. 1 ) THEN
     dfi_scalar_num_table(idomain) = dfi_scalar_num_table(idomain) + 1
     P_dfi_qnifa = dfi_scalar_num_table(idomain)
     dfi_scalar_index_table( PARAM_dfi_qnifa , idomain ) = P_dfi_qnifa
   ELSE
     P_dfi_qnifa = dfi_scalar_index_table( PARAM_dfi_qnifa , idomain )
   END IF
   dfi_scalar_boundary_table( idomain, P_dfi_qnifa ) = .TRUE.
   dfi_scalar_dname_table( idomain, P_dfi_qnifa ) = 'DFI_QNIFA'
   dfi_scalar_desc_table( idomain, P_dfi_qnifa ) = 'DFI ice-friendly aerosol number con'
   dfi_scalar_units_table( idomain, P_dfi_qnifa ) = '  kg(-1)'
   dfi_scalar_streams_table( idomain, P_dfi_qnifa )%stream(1) = 33554433 
   dfi_scalar_streams_table( idomain, P_dfi_qnifa )%stream(2) = 2097152 
   F_dfi_qnifa = .TRUE.
  END IF
  IF (model_config_rec%mp_physics_dfi(idomain)==50)THEN
   IF ( dfi_moist_index_table( PARAM_dfi_qv , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qv = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qv , idomain ) = P_dfi_qv
   ELSE
     P_dfi_qv = dfi_moist_index_table( PARAM_dfi_qv , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qv ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qv ) = 'DFI_QVAPOR'
   dfi_moist_desc_table( idomain, P_dfi_qv ) = 'Water vapor mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qv ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qv )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qv )%stream(2) = 2097152 
   F_dfi_qv = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qc , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qc = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qc , idomain ) = P_dfi_qc
   ELSE
     P_dfi_qc = dfi_moist_index_table( PARAM_dfi_qc , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qc ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qc ) = 'DFI_QCLOUD'
   dfi_moist_desc_table( idomain, P_dfi_qc ) = 'Cloud water mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qc ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qc )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qc )%stream(2) = 2097152 
   F_dfi_qc = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qr , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qr = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qr , idomain ) = P_dfi_qr
   ELSE
     P_dfi_qr = dfi_moist_index_table( PARAM_dfi_qr , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qr ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qr ) = 'DFI_QRAIN'
   dfi_moist_desc_table( idomain, P_dfi_qr ) = 'Rain water mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qr ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qr )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qr )%stream(2) = 2097152 
   F_dfi_qr = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qi , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qi = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qi , idomain ) = P_dfi_qi
   ELSE
     P_dfi_qi = dfi_moist_index_table( PARAM_dfi_qi , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qi ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qi ) = 'DFI_QICE'
   dfi_moist_desc_table( idomain, P_dfi_qi ) = 'Ice mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qi ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qi )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qi )%stream(2) = 2097152 
   F_dfi_qi = .TRUE.
   IF ( dfi_scalar_index_table( PARAM_dfi_qni , idomain ) .lt. 1 ) THEN
     dfi_scalar_num_table(idomain) = dfi_scalar_num_table(idomain) + 1
     P_dfi_qni = dfi_scalar_num_table(idomain)
     dfi_scalar_index_table( PARAM_dfi_qni , idomain ) = P_dfi_qni
   ELSE
     P_dfi_qni = dfi_scalar_index_table( PARAM_dfi_qni , idomain )
   END IF
   dfi_scalar_boundary_table( idomain, P_dfi_qni ) = .TRUE.
   dfi_scalar_dname_table( idomain, P_dfi_qni ) = 'DFI_QNICE'
   dfi_scalar_desc_table( idomain, P_dfi_qni ) = 'DFI Ice Number concentration'
   dfi_scalar_units_table( idomain, P_dfi_qni ) = '  kg-1'
   dfi_scalar_streams_table( idomain, P_dfi_qni )%stream(1) = 0 
   dfi_scalar_streams_table( idomain, P_dfi_qni )%stream(2) = 2097152 
   F_dfi_qni = .TRUE.
   IF ( dfi_scalar_index_table( PARAM_dfi_qnr , idomain ) .lt. 1 ) THEN
     dfi_scalar_num_table(idomain) = dfi_scalar_num_table(idomain) + 1
     P_dfi_qnr = dfi_scalar_num_table(idomain)
     dfi_scalar_index_table( PARAM_dfi_qnr , idomain ) = P_dfi_qnr
   ELSE
     P_dfi_qnr = dfi_scalar_index_table( PARAM_dfi_qnr , idomain )
   END IF
   dfi_scalar_boundary_table( idomain, P_dfi_qnr ) = .TRUE.
   dfi_scalar_dname_table( idomain, P_dfi_qnr ) = 'DFI_QNRAIN'
   dfi_scalar_desc_table( idomain, P_dfi_qnr ) = 'DFI Rain Number concentration'
   dfi_scalar_units_table( idomain, P_dfi_qnr ) = '  kg(-1)'
   dfi_scalar_streams_table( idomain, P_dfi_qnr )%stream(1) = 0 
   dfi_scalar_streams_table( idomain, P_dfi_qnr )%stream(2) = 2097152 
   F_dfi_qnr = .TRUE.
   IF ( dfi_scalar_index_table( PARAM_dfi_qir , idomain ) .lt. 1 ) THEN
     dfi_scalar_num_table(idomain) = dfi_scalar_num_table(idomain) + 1
     P_dfi_qir = dfi_scalar_num_table(idomain)
     dfi_scalar_index_table( PARAM_dfi_qir , idomain ) = P_dfi_qir
   ELSE
     P_dfi_qir = dfi_scalar_index_table( PARAM_dfi_qir , idomain )
   END IF
   dfi_scalar_boundary_table( idomain, P_dfi_qir ) = .TRUE.
   dfi_scalar_dname_table( idomain, P_dfi_qir ) = 'DFI_QIR'
   dfi_scalar_desc_table( idomain, P_dfi_qir ) = 'DFI Rime ice mass-1 mixing ratio'
   dfi_scalar_units_table( idomain, P_dfi_qir ) = 'kg kg(-1)'
   dfi_scalar_streams_table( idomain, P_dfi_qir )%stream(1) = 1 
   dfi_scalar_streams_table( idomain, P_dfi_qir )%stream(2) = 2097152 
   F_dfi_qir = .TRUE.
   IF ( dfi_scalar_index_table( PARAM_dfi_qib , idomain ) .lt. 1 ) THEN
     dfi_scalar_num_table(idomain) = dfi_scalar_num_table(idomain) + 1
     P_dfi_qib = dfi_scalar_num_table(idomain)
     dfi_scalar_index_table( PARAM_dfi_qib , idomain ) = P_dfi_qib
   ELSE
     P_dfi_qib = dfi_scalar_index_table( PARAM_dfi_qib , idomain )
   END IF
   dfi_scalar_boundary_table( idomain, P_dfi_qib ) = .TRUE.
   dfi_scalar_dname_table( idomain, P_dfi_qib ) = 'DFI_QIB'
   dfi_scalar_desc_table( idomain, P_dfi_qib ) = 'DFI Rime ice volume-1 mixing ratio'
   dfi_scalar_units_table( idomain, P_dfi_qib ) = 'm(3) kg(-1)'
   dfi_scalar_streams_table( idomain, P_dfi_qib )%stream(1) = 1 
   dfi_scalar_streams_table( idomain, P_dfi_qib )%stream(2) = 2097152 
   F_dfi_qib = .TRUE.
  END IF
  IF (model_config_rec%mp_physics_dfi(idomain)==51)THEN
   IF ( dfi_moist_index_table( PARAM_dfi_qv , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qv = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qv , idomain ) = P_dfi_qv
   ELSE
     P_dfi_qv = dfi_moist_index_table( PARAM_dfi_qv , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qv ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qv ) = 'DFI_QVAPOR'
   dfi_moist_desc_table( idomain, P_dfi_qv ) = 'Water vapor mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qv ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qv )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qv )%stream(2) = 2097152 
   F_dfi_qv = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qc , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qc = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qc , idomain ) = P_dfi_qc
   ELSE
     P_dfi_qc = dfi_moist_index_table( PARAM_dfi_qc , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qc ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qc ) = 'DFI_QCLOUD'
   dfi_moist_desc_table( idomain, P_dfi_qc ) = 'Cloud water mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qc ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qc )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qc )%stream(2) = 2097152 
   F_dfi_qc = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qr , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qr = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qr , idomain ) = P_dfi_qr
   ELSE
     P_dfi_qr = dfi_moist_index_table( PARAM_dfi_qr , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qr ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qr ) = 'DFI_QRAIN'
   dfi_moist_desc_table( idomain, P_dfi_qr ) = 'Rain water mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qr ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qr )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qr )%stream(2) = 2097152 
   F_dfi_qr = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qi , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qi = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qi , idomain ) = P_dfi_qi
   ELSE
     P_dfi_qi = dfi_moist_index_table( PARAM_dfi_qi , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qi ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qi ) = 'DFI_QICE'
   dfi_moist_desc_table( idomain, P_dfi_qi ) = 'Ice mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qi ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qi )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qi )%stream(2) = 2097152 
   F_dfi_qi = .TRUE.
   IF ( dfi_scalar_index_table( PARAM_dfi_qnc , idomain ) .lt. 1 ) THEN
     dfi_scalar_num_table(idomain) = dfi_scalar_num_table(idomain) + 1
     P_dfi_qnc = dfi_scalar_num_table(idomain)
     dfi_scalar_index_table( PARAM_dfi_qnc , idomain ) = P_dfi_qnc
   ELSE
     P_dfi_qnc = dfi_scalar_index_table( PARAM_dfi_qnc , idomain )
   END IF
   dfi_scalar_boundary_table( idomain, P_dfi_qnc ) = .TRUE.
   dfi_scalar_dname_table( idomain, P_dfi_qnc ) = 'DFI_QNCLOUD'
   dfi_scalar_desc_table( idomain, P_dfi_qnc ) = 'DFI Cloud Number concentration'
   dfi_scalar_units_table( idomain, P_dfi_qnc ) = '  kg(-1)'
   dfi_scalar_streams_table( idomain, P_dfi_qnc )%stream(1) = 0 
   dfi_scalar_streams_table( idomain, P_dfi_qnc )%stream(2) = 2097152 
   F_dfi_qnc = .TRUE.
   IF ( dfi_scalar_index_table( PARAM_dfi_qni , idomain ) .lt. 1 ) THEN
     dfi_scalar_num_table(idomain) = dfi_scalar_num_table(idomain) + 1
     P_dfi_qni = dfi_scalar_num_table(idomain)
     dfi_scalar_index_table( PARAM_dfi_qni , idomain ) = P_dfi_qni
   ELSE
     P_dfi_qni = dfi_scalar_index_table( PARAM_dfi_qni , idomain )
   END IF
   dfi_scalar_boundary_table( idomain, P_dfi_qni ) = .TRUE.
   dfi_scalar_dname_table( idomain, P_dfi_qni ) = 'DFI_QNICE'
   dfi_scalar_desc_table( idomain, P_dfi_qni ) = 'DFI Ice Number concentration'
   dfi_scalar_units_table( idomain, P_dfi_qni ) = '  kg-1'
   dfi_scalar_streams_table( idomain, P_dfi_qni )%stream(1) = 0 
   dfi_scalar_streams_table( idomain, P_dfi_qni )%stream(2) = 2097152 
   F_dfi_qni = .TRUE.
   IF ( dfi_scalar_index_table( PARAM_dfi_qnr , idomain ) .lt. 1 ) THEN
     dfi_scalar_num_table(idomain) = dfi_scalar_num_table(idomain) + 1
     P_dfi_qnr = dfi_scalar_num_table(idomain)
     dfi_scalar_index_table( PARAM_dfi_qnr , idomain ) = P_dfi_qnr
   ELSE
     P_dfi_qnr = dfi_scalar_index_table( PARAM_dfi_qnr , idomain )
   END IF
   dfi_scalar_boundary_table( idomain, P_dfi_qnr ) = .TRUE.
   dfi_scalar_dname_table( idomain, P_dfi_qnr ) = 'DFI_QNRAIN'
   dfi_scalar_desc_table( idomain, P_dfi_qnr ) = 'DFI Rain Number concentration'
   dfi_scalar_units_table( idomain, P_dfi_qnr ) = '  kg(-1)'
   dfi_scalar_streams_table( idomain, P_dfi_qnr )%stream(1) = 0 
   dfi_scalar_streams_table( idomain, P_dfi_qnr )%stream(2) = 2097152 
   F_dfi_qnr = .TRUE.
   IF ( dfi_scalar_index_table( PARAM_dfi_qir , idomain ) .lt. 1 ) THEN
     dfi_scalar_num_table(idomain) = dfi_scalar_num_table(idomain) + 1
     P_dfi_qir = dfi_scalar_num_table(idomain)
     dfi_scalar_index_table( PARAM_dfi_qir , idomain ) = P_dfi_qir
   ELSE
     P_dfi_qir = dfi_scalar_index_table( PARAM_dfi_qir , idomain )
   END IF
   dfi_scalar_boundary_table( idomain, P_dfi_qir ) = .TRUE.
   dfi_scalar_dname_table( idomain, P_dfi_qir ) = 'DFI_QIR'
   dfi_scalar_desc_table( idomain, P_dfi_qir ) = 'DFI Rime ice mass-1 mixing ratio'
   dfi_scalar_units_table( idomain, P_dfi_qir ) = 'kg kg(-1)'
   dfi_scalar_streams_table( idomain, P_dfi_qir )%stream(1) = 1 
   dfi_scalar_streams_table( idomain, P_dfi_qir )%stream(2) = 2097152 
   F_dfi_qir = .TRUE.
   IF ( dfi_scalar_index_table( PARAM_dfi_qib , idomain ) .lt. 1 ) THEN
     dfi_scalar_num_table(idomain) = dfi_scalar_num_table(idomain) + 1
     P_dfi_qib = dfi_scalar_num_table(idomain)
     dfi_scalar_index_table( PARAM_dfi_qib , idomain ) = P_dfi_qib
   ELSE
     P_dfi_qib = dfi_scalar_index_table( PARAM_dfi_qib , idomain )
   END IF
   dfi_scalar_boundary_table( idomain, P_dfi_qib ) = .TRUE.
   dfi_scalar_dname_table( idomain, P_dfi_qib ) = 'DFI_QIB'
   dfi_scalar_desc_table( idomain, P_dfi_qib ) = 'DFI Rime ice volume-1 mixing ratio'
   dfi_scalar_units_table( idomain, P_dfi_qib ) = 'm(3) kg(-1)'
   dfi_scalar_streams_table( idomain, P_dfi_qib )%stream(1) = 1 
   dfi_scalar_streams_table( idomain, P_dfi_qib )%stream(2) = 2097152 
   F_dfi_qib = .TRUE.
  END IF
  IF (model_config_rec%mp_physics_dfi(idomain)==52)THEN
   IF ( dfi_moist_index_table( PARAM_dfi_qv , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qv = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qv , idomain ) = P_dfi_qv
   ELSE
     P_dfi_qv = dfi_moist_index_table( PARAM_dfi_qv , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qv ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qv ) = 'DFI_QVAPOR'
   dfi_moist_desc_table( idomain, P_dfi_qv ) = 'Water vapor mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qv ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qv )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qv )%stream(2) = 2097152 
   F_dfi_qv = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qc , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qc = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qc , idomain ) = P_dfi_qc
   ELSE
     P_dfi_qc = dfi_moist_index_table( PARAM_dfi_qc , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qc ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qc ) = 'DFI_QCLOUD'
   dfi_moist_desc_table( idomain, P_dfi_qc ) = 'Cloud water mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qc ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qc )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qc )%stream(2) = 2097152 
   F_dfi_qc = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qr , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qr = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qr , idomain ) = P_dfi_qr
   ELSE
     P_dfi_qr = dfi_moist_index_table( PARAM_dfi_qr , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qr ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qr ) = 'DFI_QRAIN'
   dfi_moist_desc_table( idomain, P_dfi_qr ) = 'Rain water mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qr ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qr )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qr )%stream(2) = 2097152 
   F_dfi_qr = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qi , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qi = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qi , idomain ) = P_dfi_qi
   ELSE
     P_dfi_qi = dfi_moist_index_table( PARAM_dfi_qi , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qi ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qi ) = 'DFI_QICE'
   dfi_moist_desc_table( idomain, P_dfi_qi ) = 'Ice mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qi ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qi )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qi )%stream(2) = 2097152 
   F_dfi_qi = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qi2 , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qi2 = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qi2 , idomain ) = P_dfi_qi2
   ELSE
     P_dfi_qi2 = dfi_moist_index_table( PARAM_dfi_qi2 , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qi2 ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qi2 ) = 'DFI_QICE2'
   dfi_moist_desc_table( idomain, P_dfi_qi2 ) = 'Ice mixing ratio cat 2'
   dfi_moist_units_table( idomain, P_dfi_qi2 ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qi2 )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qi2 )%stream(2) = 2097152 
   F_dfi_qi2 = .TRUE.
   IF ( dfi_scalar_index_table( PARAM_dfi_qnc , idomain ) .lt. 1 ) THEN
     dfi_scalar_num_table(idomain) = dfi_scalar_num_table(idomain) + 1
     P_dfi_qnc = dfi_scalar_num_table(idomain)
     dfi_scalar_index_table( PARAM_dfi_qnc , idomain ) = P_dfi_qnc
   ELSE
     P_dfi_qnc = dfi_scalar_index_table( PARAM_dfi_qnc , idomain )
   END IF
   dfi_scalar_boundary_table( idomain, P_dfi_qnc ) = .TRUE.
   dfi_scalar_dname_table( idomain, P_dfi_qnc ) = 'DFI_QNCLOUD'
   dfi_scalar_desc_table( idomain, P_dfi_qnc ) = 'DFI Cloud Number concentration'
   dfi_scalar_units_table( idomain, P_dfi_qnc ) = '  kg(-1)'
   dfi_scalar_streams_table( idomain, P_dfi_qnc )%stream(1) = 0 
   dfi_scalar_streams_table( idomain, P_dfi_qnc )%stream(2) = 2097152 
   F_dfi_qnc = .TRUE.
   IF ( dfi_scalar_index_table( PARAM_dfi_qni , idomain ) .lt. 1 ) THEN
     dfi_scalar_num_table(idomain) = dfi_scalar_num_table(idomain) + 1
     P_dfi_qni = dfi_scalar_num_table(idomain)
     dfi_scalar_index_table( PARAM_dfi_qni , idomain ) = P_dfi_qni
   ELSE
     P_dfi_qni = dfi_scalar_index_table( PARAM_dfi_qni , idomain )
   END IF
   dfi_scalar_boundary_table( idomain, P_dfi_qni ) = .TRUE.
   dfi_scalar_dname_table( idomain, P_dfi_qni ) = 'DFI_QNICE'
   dfi_scalar_desc_table( idomain, P_dfi_qni ) = 'DFI Ice Number concentration'
   dfi_scalar_units_table( idomain, P_dfi_qni ) = '  kg-1'
   dfi_scalar_streams_table( idomain, P_dfi_qni )%stream(1) = 0 
   dfi_scalar_streams_table( idomain, P_dfi_qni )%stream(2) = 2097152 
   F_dfi_qni = .TRUE.
   IF ( dfi_scalar_index_table( PARAM_dfi_qnr , idomain ) .lt. 1 ) THEN
     dfi_scalar_num_table(idomain) = dfi_scalar_num_table(idomain) + 1
     P_dfi_qnr = dfi_scalar_num_table(idomain)
     dfi_scalar_index_table( PARAM_dfi_qnr , idomain ) = P_dfi_qnr
   ELSE
     P_dfi_qnr = dfi_scalar_index_table( PARAM_dfi_qnr , idomain )
   END IF
   dfi_scalar_boundary_table( idomain, P_dfi_qnr ) = .TRUE.
   dfi_scalar_dname_table( idomain, P_dfi_qnr ) = 'DFI_QNRAIN'
   dfi_scalar_desc_table( idomain, P_dfi_qnr ) = 'DFI Rain Number concentration'
   dfi_scalar_units_table( idomain, P_dfi_qnr ) = '  kg(-1)'
   dfi_scalar_streams_table( idomain, P_dfi_qnr )%stream(1) = 0 
   dfi_scalar_streams_table( idomain, P_dfi_qnr )%stream(2) = 2097152 
   F_dfi_qnr = .TRUE.
   IF ( dfi_scalar_index_table( PARAM_dfi_qir , idomain ) .lt. 1 ) THEN
     dfi_scalar_num_table(idomain) = dfi_scalar_num_table(idomain) + 1
     P_dfi_qir = dfi_scalar_num_table(idomain)
     dfi_scalar_index_table( PARAM_dfi_qir , idomain ) = P_dfi_qir
   ELSE
     P_dfi_qir = dfi_scalar_index_table( PARAM_dfi_qir , idomain )
   END IF
   dfi_scalar_boundary_table( idomain, P_dfi_qir ) = .TRUE.
   dfi_scalar_dname_table( idomain, P_dfi_qir ) = 'DFI_QIR'
   dfi_scalar_desc_table( idomain, P_dfi_qir ) = 'DFI Rime ice mass-1 mixing ratio'
   dfi_scalar_units_table( idomain, P_dfi_qir ) = 'kg kg(-1)'
   dfi_scalar_streams_table( idomain, P_dfi_qir )%stream(1) = 1 
   dfi_scalar_streams_table( idomain, P_dfi_qir )%stream(2) = 2097152 
   F_dfi_qir = .TRUE.
   IF ( dfi_scalar_index_table( PARAM_dfi_qib , idomain ) .lt. 1 ) THEN
     dfi_scalar_num_table(idomain) = dfi_scalar_num_table(idomain) + 1
     P_dfi_qib = dfi_scalar_num_table(idomain)
     dfi_scalar_index_table( PARAM_dfi_qib , idomain ) = P_dfi_qib
   ELSE
     P_dfi_qib = dfi_scalar_index_table( PARAM_dfi_qib , idomain )
   END IF
   dfi_scalar_boundary_table( idomain, P_dfi_qib ) = .TRUE.
   dfi_scalar_dname_table( idomain, P_dfi_qib ) = 'DFI_QIB'
   dfi_scalar_desc_table( idomain, P_dfi_qib ) = 'DFI Rime ice volume-1 mixing ratio'
   dfi_scalar_units_table( idomain, P_dfi_qib ) = 'm(3) kg(-1)'
   dfi_scalar_streams_table( idomain, P_dfi_qib )%stream(1) = 1 
   dfi_scalar_streams_table( idomain, P_dfi_qib )%stream(2) = 2097152 
   F_dfi_qib = .TRUE.
   IF ( dfi_scalar_index_table( PARAM_dfi_qni2 , idomain ) .lt. 1 ) THEN
     dfi_scalar_num_table(idomain) = dfi_scalar_num_table(idomain) + 1
     P_dfi_qni2 = dfi_scalar_num_table(idomain)
     dfi_scalar_index_table( PARAM_dfi_qni2 , idomain ) = P_dfi_qni2
   ELSE
     P_dfi_qni2 = dfi_scalar_index_table( PARAM_dfi_qni2 , idomain )
   END IF
   dfi_scalar_boundary_table( idomain, P_dfi_qni2 ) = .TRUE.
   dfi_scalar_dname_table( idomain, P_dfi_qni2 ) = 'DFI_QNICE2'
   dfi_scalar_desc_table( idomain, P_dfi_qni2 ) = 'DFI Ice Number concentration cat 2'
   dfi_scalar_units_table( idomain, P_dfi_qni2 ) = '  kg-1'
   dfi_scalar_streams_table( idomain, P_dfi_qni2 )%stream(1) = 0 
   dfi_scalar_streams_table( idomain, P_dfi_qni2 )%stream(2) = 2097152 
   F_dfi_qni2 = .TRUE.
   IF ( dfi_scalar_index_table( PARAM_dfi_qir2 , idomain ) .lt. 1 ) THEN
     dfi_scalar_num_table(idomain) = dfi_scalar_num_table(idomain) + 1
     P_dfi_qir2 = dfi_scalar_num_table(idomain)
     dfi_scalar_index_table( PARAM_dfi_qir2 , idomain ) = P_dfi_qir2
   ELSE
     P_dfi_qir2 = dfi_scalar_index_table( PARAM_dfi_qir2 , idomain )
   END IF
   dfi_scalar_boundary_table( idomain, P_dfi_qir2 ) = .TRUE.
   dfi_scalar_dname_table( idomain, P_dfi_qir2 ) = 'DFI_QIR2'
   dfi_scalar_desc_table( idomain, P_dfi_qir2 ) = 'DFI Rime ice mass-2 mixing ratio'
   dfi_scalar_units_table( idomain, P_dfi_qir2 ) = 'kg kg(-1)'
   dfi_scalar_streams_table( idomain, P_dfi_qir2 )%stream(1) = 1 
   dfi_scalar_streams_table( idomain, P_dfi_qir2 )%stream(2) = 2097152 
   F_dfi_qir2 = .TRUE.
   IF ( dfi_scalar_index_table( PARAM_dfi_qib2 , idomain ) .lt. 1 ) THEN
     dfi_scalar_num_table(idomain) = dfi_scalar_num_table(idomain) + 1
     P_dfi_qib2 = dfi_scalar_num_table(idomain)
     dfi_scalar_index_table( PARAM_dfi_qib2 , idomain ) = P_dfi_qib2
   ELSE
     P_dfi_qib2 = dfi_scalar_index_table( PARAM_dfi_qib2 , idomain )
   END IF
   dfi_scalar_boundary_table( idomain, P_dfi_qib2 ) = .TRUE.
   dfi_scalar_dname_table( idomain, P_dfi_qib2 ) = 'DFI_QIB2'
   dfi_scalar_desc_table( idomain, P_dfi_qib2 ) = 'DFI Rime ice volume-2 mixing ratio'
   dfi_scalar_units_table( idomain, P_dfi_qib2 ) = 'm(3) kg(-1)'
   dfi_scalar_streams_table( idomain, P_dfi_qib2 )%stream(1) = 1 
   dfi_scalar_streams_table( idomain, P_dfi_qib2 )%stream(2) = 2097152 
   F_dfi_qib2 = .TRUE.
  END IF
  IF (model_config_rec%mp_physics_dfi(idomain)==55)THEN
   IF ( dfi_moist_index_table( PARAM_dfi_qv , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qv = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qv , idomain ) = P_dfi_qv
   ELSE
     P_dfi_qv = dfi_moist_index_table( PARAM_dfi_qv , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qv ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qv ) = 'DFI_QVAPOR'
   dfi_moist_desc_table( idomain, P_dfi_qv ) = 'Water vapor mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qv ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qv )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qv )%stream(2) = 2097152 
   F_dfi_qv = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qc , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qc = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qc , idomain ) = P_dfi_qc
   ELSE
     P_dfi_qc = dfi_moist_index_table( PARAM_dfi_qc , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qc ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qc ) = 'DFI_QCLOUD'
   dfi_moist_desc_table( idomain, P_dfi_qc ) = 'Cloud water mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qc ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qc )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qc )%stream(2) = 2097152 
   F_dfi_qc = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qr , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qr = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qr , idomain ) = P_dfi_qr
   ELSE
     P_dfi_qr = dfi_moist_index_table( PARAM_dfi_qr , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qr ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qr ) = 'DFI_QRAIN'
   dfi_moist_desc_table( idomain, P_dfi_qr ) = 'Rain water mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qr ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qr )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qr )%stream(2) = 2097152 
   F_dfi_qr = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qi , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qi = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qi , idomain ) = P_dfi_qi
   ELSE
     P_dfi_qi = dfi_moist_index_table( PARAM_dfi_qi , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qi ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qi ) = 'DFI_QICE'
   dfi_moist_desc_table( idomain, P_dfi_qi ) = 'Ice mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qi ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qi )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qi )%stream(2) = 2097152 
   F_dfi_qi = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qi2 , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qi2 = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qi2 , idomain ) = P_dfi_qi2
   ELSE
     P_dfi_qi2 = dfi_moist_index_table( PARAM_dfi_qi2 , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qi2 ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qi2 ) = 'DFI_QICE2'
   dfi_moist_desc_table( idomain, P_dfi_qi2 ) = 'Ice mixing ratio cat 2'
   dfi_moist_units_table( idomain, P_dfi_qi2 ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qi2 )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qi2 )%stream(2) = 2097152 
   F_dfi_qi2 = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qi3 , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qi3 = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qi3 , idomain ) = P_dfi_qi3
   ELSE
     P_dfi_qi3 = dfi_moist_index_table( PARAM_dfi_qi3 , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qi3 ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qi3 ) = 'DFI_QICE3'
   dfi_moist_desc_table( idomain, P_dfi_qi3 ) = 'Ice mixing ratio cat 3'
   dfi_moist_units_table( idomain, P_dfi_qi3 ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qi3 )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qi3 )%stream(2) = 2097152 
   F_dfi_qi3 = .TRUE.
   IF ( dfi_scalar_index_table( PARAM_dfi_qnr , idomain ) .lt. 1 ) THEN
     dfi_scalar_num_table(idomain) = dfi_scalar_num_table(idomain) + 1
     P_dfi_qnr = dfi_scalar_num_table(idomain)
     dfi_scalar_index_table( PARAM_dfi_qnr , idomain ) = P_dfi_qnr
   ELSE
     P_dfi_qnr = dfi_scalar_index_table( PARAM_dfi_qnr , idomain )
   END IF
   dfi_scalar_boundary_table( idomain, P_dfi_qnr ) = .TRUE.
   dfi_scalar_dname_table( idomain, P_dfi_qnr ) = 'DFI_QNRAIN'
   dfi_scalar_desc_table( idomain, P_dfi_qnr ) = 'DFI Rain Number concentration'
   dfi_scalar_units_table( idomain, P_dfi_qnr ) = '  kg(-1)'
   dfi_scalar_streams_table( idomain, P_dfi_qnr )%stream(1) = 0 
   dfi_scalar_streams_table( idomain, P_dfi_qnr )%stream(2) = 2097152 
   F_dfi_qnr = .TRUE.
   IF ( dfi_scalar_index_table( PARAM_dfi_qni , idomain ) .lt. 1 ) THEN
     dfi_scalar_num_table(idomain) = dfi_scalar_num_table(idomain) + 1
     P_dfi_qni = dfi_scalar_num_table(idomain)
     dfi_scalar_index_table( PARAM_dfi_qni , idomain ) = P_dfi_qni
   ELSE
     P_dfi_qni = dfi_scalar_index_table( PARAM_dfi_qni , idomain )
   END IF
   dfi_scalar_boundary_table( idomain, P_dfi_qni ) = .TRUE.
   dfi_scalar_dname_table( idomain, P_dfi_qni ) = 'DFI_QNICE'
   dfi_scalar_desc_table( idomain, P_dfi_qni ) = 'DFI Ice Number concentration'
   dfi_scalar_units_table( idomain, P_dfi_qni ) = '  kg-1'
   dfi_scalar_streams_table( idomain, P_dfi_qni )%stream(1) = 0 
   dfi_scalar_streams_table( idomain, P_dfi_qni )%stream(2) = 2097152 
   F_dfi_qni = .TRUE.
   IF ( dfi_scalar_index_table( PARAM_dfi_qvoli , idomain ) .lt. 1 ) THEN
     dfi_scalar_num_table(idomain) = dfi_scalar_num_table(idomain) + 1
     P_dfi_qvoli = dfi_scalar_num_table(idomain)
     dfi_scalar_index_table( PARAM_dfi_qvoli , idomain ) = P_dfi_qvoli
   ELSE
     P_dfi_qvoli = dfi_scalar_index_table( PARAM_dfi_qvoli , idomain )
   END IF
   dfi_scalar_boundary_table( idomain, P_dfi_qvoli ) = .TRUE.
   dfi_scalar_dname_table( idomain, P_dfi_qvoli ) = 'DFI_QVOLI'
   dfi_scalar_desc_table( idomain, P_dfi_qvoli ) = 'DFI Ice volume-1 mixing ratio'
   dfi_scalar_units_table( idomain, P_dfi_qvoli ) = 'kg kg(-1)'
   dfi_scalar_streams_table( idomain, P_dfi_qvoli )%stream(1) = 1 
   dfi_scalar_streams_table( idomain, P_dfi_qvoli )%stream(2) = 2097152 
   F_dfi_qvoli = .TRUE.
   IF ( dfi_scalar_index_table( PARAM_dfi_qaoli , idomain ) .lt. 1 ) THEN
     dfi_scalar_num_table(idomain) = dfi_scalar_num_table(idomain) + 1
     P_dfi_qaoli = dfi_scalar_num_table(idomain)
     dfi_scalar_index_table( PARAM_dfi_qaoli , idomain ) = P_dfi_qaoli
   ELSE
     P_dfi_qaoli = dfi_scalar_index_table( PARAM_dfi_qaoli , idomain )
   END IF
   dfi_scalar_boundary_table( idomain, P_dfi_qaoli ) = .TRUE.
   dfi_scalar_dname_table( idomain, P_dfi_qaoli ) = 'DFI_QAOLI'
   dfi_scalar_desc_table( idomain, P_dfi_qaoli ) = 'DFI Ice volume-1 times aspect ratio mixing ratio'
   dfi_scalar_units_table( idomain, P_dfi_qaoli ) = 'kg kg(-1)'
   dfi_scalar_streams_table( idomain, P_dfi_qaoli )%stream(1) = 1 
   dfi_scalar_streams_table( idomain, P_dfi_qaoli )%stream(2) = 2097152 
   F_dfi_qaoli = .TRUE.
   IF ( dfi_scalar_index_table( PARAM_dfi_qni2 , idomain ) .lt. 1 ) THEN
     dfi_scalar_num_table(idomain) = dfi_scalar_num_table(idomain) + 1
     P_dfi_qni2 = dfi_scalar_num_table(idomain)
     dfi_scalar_index_table( PARAM_dfi_qni2 , idomain ) = P_dfi_qni2
   ELSE
     P_dfi_qni2 = dfi_scalar_index_table( PARAM_dfi_qni2 , idomain )
   END IF
   dfi_scalar_boundary_table( idomain, P_dfi_qni2 ) = .TRUE.
   dfi_scalar_dname_table( idomain, P_dfi_qni2 ) = 'DFI_QNICE2'
   dfi_scalar_desc_table( idomain, P_dfi_qni2 ) = 'DFI Ice Number concentration cat 2'
   dfi_scalar_units_table( idomain, P_dfi_qni2 ) = '  kg-1'
   dfi_scalar_streams_table( idomain, P_dfi_qni2 )%stream(1) = 0 
   dfi_scalar_streams_table( idomain, P_dfi_qni2 )%stream(2) = 2097152 
   F_dfi_qni2 = .TRUE.
   IF ( dfi_scalar_index_table( PARAM_dfi_qvoli2 , idomain ) .lt. 1 ) THEN
     dfi_scalar_num_table(idomain) = dfi_scalar_num_table(idomain) + 1
     P_dfi_qvoli2 = dfi_scalar_num_table(idomain)
     dfi_scalar_index_table( PARAM_dfi_qvoli2 , idomain ) = P_dfi_qvoli2
   ELSE
     P_dfi_qvoli2 = dfi_scalar_index_table( PARAM_dfi_qvoli2 , idomain )
   END IF
   dfi_scalar_boundary_table( idomain, P_dfi_qvoli2 ) = .TRUE.
   dfi_scalar_dname_table( idomain, P_dfi_qvoli2 ) = 'DFI_QVOLI2'
   dfi_scalar_desc_table( idomain, P_dfi_qvoli2 ) = 'DFI Ice volume-2 mixing ratio'
   dfi_scalar_units_table( idomain, P_dfi_qvoli2 ) = 'kg kg(-1)'
   dfi_scalar_streams_table( idomain, P_dfi_qvoli2 )%stream(1) = 1 
   dfi_scalar_streams_table( idomain, P_dfi_qvoli2 )%stream(2) = 2097152 
   F_dfi_qvoli2 = .TRUE.
   IF ( dfi_scalar_index_table( PARAM_dfi_qaoli2 , idomain ) .lt. 1 ) THEN
     dfi_scalar_num_table(idomain) = dfi_scalar_num_table(idomain) + 1
     P_dfi_qaoli2 = dfi_scalar_num_table(idomain)
     dfi_scalar_index_table( PARAM_dfi_qaoli2 , idomain ) = P_dfi_qaoli2
   ELSE
     P_dfi_qaoli2 = dfi_scalar_index_table( PARAM_dfi_qaoli2 , idomain )
   END IF
   dfi_scalar_boundary_table( idomain, P_dfi_qaoli2 ) = .TRUE.
   dfi_scalar_dname_table( idomain, P_dfi_qaoli2 ) = 'DFI_QAOLI2'
   dfi_scalar_desc_table( idomain, P_dfi_qaoli2 ) = 'DFI Ice volume-2 times aspect ratio mixing ratio'
   dfi_scalar_units_table( idomain, P_dfi_qaoli2 ) = 'kg kg(-1)'
   dfi_scalar_streams_table( idomain, P_dfi_qaoli2 )%stream(1) = 1 
   dfi_scalar_streams_table( idomain, P_dfi_qaoli2 )%stream(2) = 2097152 
   F_dfi_qaoli2 = .TRUE.
   IF ( dfi_scalar_index_table( PARAM_dfi_qni3 , idomain ) .lt. 1 ) THEN
     dfi_scalar_num_table(idomain) = dfi_scalar_num_table(idomain) + 1
     P_dfi_qni3 = dfi_scalar_num_table(idomain)
     dfi_scalar_index_table( PARAM_dfi_qni3 , idomain ) = P_dfi_qni3
   ELSE
     P_dfi_qni3 = dfi_scalar_index_table( PARAM_dfi_qni3 , idomain )
   END IF
   dfi_scalar_boundary_table( idomain, P_dfi_qni3 ) = .TRUE.
   dfi_scalar_dname_table( idomain, P_dfi_qni3 ) = 'DFI_QNICE3'
   dfi_scalar_desc_table( idomain, P_dfi_qni3 ) = 'DFI Ice Number concentration cat 3'
   dfi_scalar_units_table( idomain, P_dfi_qni3 ) = '  kg-1'
   dfi_scalar_streams_table( idomain, P_dfi_qni3 )%stream(1) = 0 
   dfi_scalar_streams_table( idomain, P_dfi_qni3 )%stream(2) = 2097152 
   F_dfi_qni3 = .TRUE.
   IF ( dfi_scalar_index_table( PARAM_dfi_qvoli3 , idomain ) .lt. 1 ) THEN
     dfi_scalar_num_table(idomain) = dfi_scalar_num_table(idomain) + 1
     P_dfi_qvoli3 = dfi_scalar_num_table(idomain)
     dfi_scalar_index_table( PARAM_dfi_qvoli3 , idomain ) = P_dfi_qvoli3
   ELSE
     P_dfi_qvoli3 = dfi_scalar_index_table( PARAM_dfi_qvoli3 , idomain )
   END IF
   dfi_scalar_boundary_table( idomain, P_dfi_qvoli3 ) = .TRUE.
   dfi_scalar_dname_table( idomain, P_dfi_qvoli3 ) = 'DFI_QVOLI3'
   dfi_scalar_desc_table( idomain, P_dfi_qvoli3 ) = 'DFI Ice volume-3 mixing ratio'
   dfi_scalar_units_table( idomain, P_dfi_qvoli3 ) = 'kg kg(-1)'
   dfi_scalar_streams_table( idomain, P_dfi_qvoli3 )%stream(1) = 1 
   dfi_scalar_streams_table( idomain, P_dfi_qvoli3 )%stream(2) = 2097152 
   F_dfi_qvoli3 = .TRUE.
   IF ( dfi_scalar_index_table( PARAM_dfi_qaoli3 , idomain ) .lt. 1 ) THEN
     dfi_scalar_num_table(idomain) = dfi_scalar_num_table(idomain) + 1
     P_dfi_qaoli3 = dfi_scalar_num_table(idomain)
     dfi_scalar_index_table( PARAM_dfi_qaoli3 , idomain ) = P_dfi_qaoli3
   ELSE
     P_dfi_qaoli3 = dfi_scalar_index_table( PARAM_dfi_qaoli3 , idomain )
   END IF
   dfi_scalar_boundary_table( idomain, P_dfi_qaoli3 ) = .TRUE.
   dfi_scalar_dname_table( idomain, P_dfi_qaoli3 ) = 'DFI_QAOLI3'
   dfi_scalar_desc_table( idomain, P_dfi_qaoli3 ) = 'DFI Ice volume-3 times aspect ratio mixing ratio'
   dfi_scalar_units_table( idomain, P_dfi_qaoli3 ) = 'kg kg(-1)'
   dfi_scalar_streams_table( idomain, P_dfi_qaoli3 )%stream(1) = 1 
   dfi_scalar_streams_table( idomain, P_dfi_qaoli3 )%stream(2) = 2097152 
   F_dfi_qaoli3 = .TRUE.
  END IF
  IF (model_config_rec%mp_physics_dfi(idomain)==95)THEN
   IF ( dfi_moist_index_table( PARAM_dfi_qv , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qv = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qv , idomain ) = P_dfi_qv
   ELSE
     P_dfi_qv = dfi_moist_index_table( PARAM_dfi_qv , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qv ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qv ) = 'DFI_QVAPOR'
   dfi_moist_desc_table( idomain, P_dfi_qv ) = 'Water vapor mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qv ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qv )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qv )%stream(2) = 2097152 
   F_dfi_qv = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qc , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qc = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qc , idomain ) = P_dfi_qc
   ELSE
     P_dfi_qc = dfi_moist_index_table( PARAM_dfi_qc , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qc ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qc ) = 'DFI_QCLOUD'
   dfi_moist_desc_table( idomain, P_dfi_qc ) = 'Cloud water mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qc ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qc )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qc )%stream(2) = 2097152 
   F_dfi_qc = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qr , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qr = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qr , idomain ) = P_dfi_qr
   ELSE
     P_dfi_qr = dfi_moist_index_table( PARAM_dfi_qr , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qr ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qr ) = 'DFI_QRAIN'
   dfi_moist_desc_table( idomain, P_dfi_qr ) = 'Rain water mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qr ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qr )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qr )%stream(2) = 2097152 
   F_dfi_qr = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qs , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qs = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qs , idomain ) = P_dfi_qs
   ELSE
     P_dfi_qs = dfi_moist_index_table( PARAM_dfi_qs , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qs ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qs ) = 'DFI_QSNOW'
   dfi_moist_desc_table( idomain, P_dfi_qs ) = 'Snow mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qs ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qs )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qs )%stream(2) = 2097152 
   F_dfi_qs = .TRUE.
   IF ( dfi_scalar_index_table( PARAM_dfi_qt , idomain ) .lt. 1 ) THEN
     dfi_scalar_num_table(idomain) = dfi_scalar_num_table(idomain) + 1
     P_dfi_qt = dfi_scalar_num_table(idomain)
     dfi_scalar_index_table( PARAM_dfi_qt , idomain ) = P_dfi_qt
   ELSE
     P_dfi_qt = dfi_scalar_index_table( PARAM_dfi_qt , idomain )
   END IF
   dfi_scalar_boundary_table( idomain, P_dfi_qt ) = .TRUE.
   dfi_scalar_dname_table( idomain, P_dfi_qt ) = 'DFI_CWM'
   dfi_scalar_desc_table( idomain, P_dfi_qt ) = 'DFI Total condensate mixing ratio'
   dfi_scalar_units_table( idomain, P_dfi_qt ) = 'kg kg-1'
   dfi_scalar_streams_table( idomain, P_dfi_qt )%stream(1) = 0 
   dfi_scalar_streams_table( idomain, P_dfi_qt )%stream(2) = 2097152 
   F_dfi_qt = .TRUE.
  END IF
  IF (model_config_rec%mp_physics_dfi(idomain)==97)THEN
   IF ( dfi_moist_index_table( PARAM_dfi_qv , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qv = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qv , idomain ) = P_dfi_qv
   ELSE
     P_dfi_qv = dfi_moist_index_table( PARAM_dfi_qv , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qv ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qv ) = 'DFI_QVAPOR'
   dfi_moist_desc_table( idomain, P_dfi_qv ) = 'Water vapor mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qv ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qv )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qv )%stream(2) = 2097152 
   F_dfi_qv = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qc , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qc = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qc , idomain ) = P_dfi_qc
   ELSE
     P_dfi_qc = dfi_moist_index_table( PARAM_dfi_qc , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qc ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qc ) = 'DFI_QCLOUD'
   dfi_moist_desc_table( idomain, P_dfi_qc ) = 'Cloud water mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qc ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qc )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qc )%stream(2) = 2097152 
   F_dfi_qc = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qr , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qr = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qr , idomain ) = P_dfi_qr
   ELSE
     P_dfi_qr = dfi_moist_index_table( PARAM_dfi_qr , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qr ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qr ) = 'DFI_QRAIN'
   dfi_moist_desc_table( idomain, P_dfi_qr ) = 'Rain water mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qr ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qr )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qr )%stream(2) = 2097152 
   F_dfi_qr = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qi , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qi = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qi , idomain ) = P_dfi_qi
   ELSE
     P_dfi_qi = dfi_moist_index_table( PARAM_dfi_qi , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qi ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qi ) = 'DFI_QICE'
   dfi_moist_desc_table( idomain, P_dfi_qi ) = 'Ice mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qi ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qi )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qi )%stream(2) = 2097152 
   F_dfi_qi = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qs , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qs = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qs , idomain ) = P_dfi_qs
   ELSE
     P_dfi_qs = dfi_moist_index_table( PARAM_dfi_qs , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qs ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qs ) = 'DFI_QSNOW'
   dfi_moist_desc_table( idomain, P_dfi_qs ) = 'Snow mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qs ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qs )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qs )%stream(2) = 2097152 
   F_dfi_qs = .TRUE.
   IF ( dfi_moist_index_table( PARAM_dfi_qg , idomain ) .lt. 1 ) THEN
     dfi_moist_num_table(idomain) = dfi_moist_num_table(idomain) + 1
     P_dfi_qg = dfi_moist_num_table(idomain)
     dfi_moist_index_table( PARAM_dfi_qg , idomain ) = P_dfi_qg
   ELSE
     P_dfi_qg = dfi_moist_index_table( PARAM_dfi_qg , idomain )
   END IF
   dfi_moist_boundary_table( idomain, P_dfi_qg ) = .TRUE.
   dfi_moist_dname_table( idomain, P_dfi_qg ) = 'DFI_QGRAUP'
   dfi_moist_desc_table( idomain, P_dfi_qg ) = 'Graupel mixing ratio'
   dfi_moist_units_table( idomain, P_dfi_qg ) = 'kg kg-1'
   dfi_moist_streams_table( idomain, P_dfi_qg )%stream(1) = 0 
   dfi_moist_streams_table( idomain, P_dfi_qg )%stream(2) = 2097152 
   F_dfi_qg = .TRUE.
  END IF
  IF (model_config_rec%progn(idomain)==0)THEN
  END IF
  IF (model_config_rec%progn(idomain)==1)THEN
   IF ( scalar_index_table( PARAM_qndrop , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qndrop = scalar_num_table(idomain)
     scalar_index_table( PARAM_qndrop , idomain ) = P_qndrop
   ELSE
     P_qndrop = scalar_index_table( PARAM_qndrop , idomain )
   END IF
   scalar_boundary_table( idomain, P_qndrop ) = .TRUE.
   scalar_dname_table( idomain, P_qndrop ) = 'QNDROP'
   scalar_desc_table( idomain, P_qndrop ) = 'Droplet number mixing ratio'
   scalar_units_table( idomain, P_qndrop ) = '  kg-1'
   scalar_streams_table( idomain, P_qndrop )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qndrop )%stream(2) = 2097152 
   F_qndrop = .TRUE.
   IF ( dfi_scalar_index_table( PARAM_dfi_qndrop , idomain ) .lt. 1 ) THEN
     dfi_scalar_num_table(idomain) = dfi_scalar_num_table(idomain) + 1
     P_dfi_qndrop = dfi_scalar_num_table(idomain)
     dfi_scalar_index_table( PARAM_dfi_qndrop , idomain ) = P_dfi_qndrop
   ELSE
     P_dfi_qndrop = dfi_scalar_index_table( PARAM_dfi_qndrop , idomain )
   END IF
   dfi_scalar_boundary_table( idomain, P_dfi_qndrop ) = .TRUE.
   dfi_scalar_dname_table( idomain, P_dfi_qndrop ) = 'DFI_QNDROP'
   dfi_scalar_desc_table( idomain, P_dfi_qndrop ) = 'DFI Droplet number mixing ratio'
   dfi_scalar_units_table( idomain, P_dfi_qndrop ) = '  kg-1'
   dfi_scalar_streams_table( idomain, P_dfi_qndrop )%stream(1) = 0 
   dfi_scalar_streams_table( idomain, P_dfi_qndrop )%stream(2) = 2097152 
   F_dfi_qndrop = .TRUE.
  END IF
  IF (model_config_rec%alloc_qndropsource==0)THEN
  END IF
  IF (model_config_rec%alloc_qndropsource==1)THEN
  END IF
  IF (model_config_rec%ra_lw_physics(idomain)==1)THEN
  END IF
  IF (model_config_rec%ra_lw_physics(idomain)==3)THEN
   IF ( ozmixm_index_table( PARAM_mth01 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth01 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth01 , idomain ) = P_mth01
   ELSE
     P_mth01 = ozmixm_index_table( PARAM_mth01 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth01 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth01 ) = ''
   ozmixm_desc_table( idomain, P_mth01 ) = '-'
   ozmixm_units_table( idomain, P_mth01 ) = '-'
   ozmixm_streams_table( idomain, P_mth01 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth01 )%stream(2) = 0 
   F_mth01 = .TRUE.
   IF ( ozmixm_index_table( PARAM_mth02 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth02 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth02 , idomain ) = P_mth02
   ELSE
     P_mth02 = ozmixm_index_table( PARAM_mth02 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth02 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth02 ) = ''
   ozmixm_desc_table( idomain, P_mth02 ) = '-'
   ozmixm_units_table( idomain, P_mth02 ) = '-'
   ozmixm_streams_table( idomain, P_mth02 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth02 )%stream(2) = 0 
   F_mth02 = .TRUE.
   IF ( ozmixm_index_table( PARAM_mth03 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth03 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth03 , idomain ) = P_mth03
   ELSE
     P_mth03 = ozmixm_index_table( PARAM_mth03 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth03 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth03 ) = ''
   ozmixm_desc_table( idomain, P_mth03 ) = '-'
   ozmixm_units_table( idomain, P_mth03 ) = '-'
   ozmixm_streams_table( idomain, P_mth03 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth03 )%stream(2) = 0 
   F_mth03 = .TRUE.
   IF ( ozmixm_index_table( PARAM_mth04 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth04 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth04 , idomain ) = P_mth04
   ELSE
     P_mth04 = ozmixm_index_table( PARAM_mth04 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth04 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth04 ) = ''
   ozmixm_desc_table( idomain, P_mth04 ) = '-'
   ozmixm_units_table( idomain, P_mth04 ) = '-'
   ozmixm_streams_table( idomain, P_mth04 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth04 )%stream(2) = 0 
   F_mth04 = .TRUE.
   IF ( ozmixm_index_table( PARAM_mth05 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth05 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth05 , idomain ) = P_mth05
   ELSE
     P_mth05 = ozmixm_index_table( PARAM_mth05 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth05 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth05 ) = ''
   ozmixm_desc_table( idomain, P_mth05 ) = '-'
   ozmixm_units_table( idomain, P_mth05 ) = '-'
   ozmixm_streams_table( idomain, P_mth05 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth05 )%stream(2) = 0 
   F_mth05 = .TRUE.
   IF ( ozmixm_index_table( PARAM_mth06 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth06 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth06 , idomain ) = P_mth06
   ELSE
     P_mth06 = ozmixm_index_table( PARAM_mth06 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth06 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth06 ) = ''
   ozmixm_desc_table( idomain, P_mth06 ) = '-'
   ozmixm_units_table( idomain, P_mth06 ) = '-'
   ozmixm_streams_table( idomain, P_mth06 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth06 )%stream(2) = 0 
   F_mth06 = .TRUE.
   IF ( ozmixm_index_table( PARAM_mth07 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth07 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth07 , idomain ) = P_mth07
   ELSE
     P_mth07 = ozmixm_index_table( PARAM_mth07 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth07 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth07 ) = ''
   ozmixm_desc_table( idomain, P_mth07 ) = '-'
   ozmixm_units_table( idomain, P_mth07 ) = '-'
   ozmixm_streams_table( idomain, P_mth07 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth07 )%stream(2) = 0 
   F_mth07 = .TRUE.
   IF ( ozmixm_index_table( PARAM_mth08 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth08 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth08 , idomain ) = P_mth08
   ELSE
     P_mth08 = ozmixm_index_table( PARAM_mth08 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth08 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth08 ) = ''
   ozmixm_desc_table( idomain, P_mth08 ) = '-'
   ozmixm_units_table( idomain, P_mth08 ) = '-'
   ozmixm_streams_table( idomain, P_mth08 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth08 )%stream(2) = 0 
   F_mth08 = .TRUE.
   IF ( ozmixm_index_table( PARAM_mth09 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth09 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth09 , idomain ) = P_mth09
   ELSE
     P_mth09 = ozmixm_index_table( PARAM_mth09 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth09 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth09 ) = ''
   ozmixm_desc_table( idomain, P_mth09 ) = '-'
   ozmixm_units_table( idomain, P_mth09 ) = '-'
   ozmixm_streams_table( idomain, P_mth09 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth09 )%stream(2) = 0 
   F_mth09 = .TRUE.
   IF ( ozmixm_index_table( PARAM_mth10 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth10 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth10 , idomain ) = P_mth10
   ELSE
     P_mth10 = ozmixm_index_table( PARAM_mth10 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth10 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth10 ) = ''
   ozmixm_desc_table( idomain, P_mth10 ) = '-'
   ozmixm_units_table( idomain, P_mth10 ) = '-'
   ozmixm_streams_table( idomain, P_mth10 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth10 )%stream(2) = 0 
   F_mth10 = .TRUE.
   IF ( ozmixm_index_table( PARAM_mth11 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth11 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth11 , idomain ) = P_mth11
   ELSE
     P_mth11 = ozmixm_index_table( PARAM_mth11 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth11 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth11 ) = ''
   ozmixm_desc_table( idomain, P_mth11 ) = '-'
   ozmixm_units_table( idomain, P_mth11 ) = '-'
   ozmixm_streams_table( idomain, P_mth11 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth11 )%stream(2) = 0 
   F_mth11 = .TRUE.
   IF ( ozmixm_index_table( PARAM_mth12 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth12 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth12 , idomain ) = P_mth12
   ELSE
     P_mth12 = ozmixm_index_table( PARAM_mth12 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth12 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth12 ) = ''
   ozmixm_desc_table( idomain, P_mth12 ) = '-'
   ozmixm_units_table( idomain, P_mth12 ) = '-'
   ozmixm_streams_table( idomain, P_mth12 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth12 )%stream(2) = 0 
   F_mth12 = .TRUE.
   IF ( aerosolc_index_table( PARAM_sul , idomain ) .lt. 1 ) THEN
     aerosolc_num_table(idomain) = aerosolc_num_table(idomain) + 1
     P_sul = aerosolc_num_table(idomain)
     aerosolc_index_table( PARAM_sul , idomain ) = P_sul
   ELSE
     P_sul = aerosolc_index_table( PARAM_sul , idomain )
   END IF
   aerosolc_boundary_table( idomain, P_sul ) = .FALSE.
   aerosolc_dname_table( idomain, P_sul ) = 'SUL'
   aerosolc_desc_table( idomain, P_sul ) = 'SUL aerosol concentration'
   aerosolc_units_table( idomain, P_sul ) = '-'
   aerosolc_streams_table( idomain, P_sul )%stream(1) = 0 
   aerosolc_streams_table( idomain, P_sul )%stream(2) = 0 
   F_sul = .TRUE.
   IF ( aerosolc_index_table( PARAM_sslt , idomain ) .lt. 1 ) THEN
     aerosolc_num_table(idomain) = aerosolc_num_table(idomain) + 1
     P_sslt = aerosolc_num_table(idomain)
     aerosolc_index_table( PARAM_sslt , idomain ) = P_sslt
   ELSE
     P_sslt = aerosolc_index_table( PARAM_sslt , idomain )
   END IF
   aerosolc_boundary_table( idomain, P_sslt ) = .FALSE.
   aerosolc_dname_table( idomain, P_sslt ) = 'SSLT'
   aerosolc_desc_table( idomain, P_sslt ) = 'SSLT aerosol concentration'
   aerosolc_units_table( idomain, P_sslt ) = '-'
   aerosolc_streams_table( idomain, P_sslt )%stream(1) = 0 
   aerosolc_streams_table( idomain, P_sslt )%stream(2) = 0 
   F_sslt = .TRUE.
   IF ( aerosolc_index_table( PARAM_dust1 , idomain ) .lt. 1 ) THEN
     aerosolc_num_table(idomain) = aerosolc_num_table(idomain) + 1
     P_dust1 = aerosolc_num_table(idomain)
     aerosolc_index_table( PARAM_dust1 , idomain ) = P_dust1
   ELSE
     P_dust1 = aerosolc_index_table( PARAM_dust1 , idomain )
   END IF
   aerosolc_boundary_table( idomain, P_dust1 ) = .FALSE.
   aerosolc_dname_table( idomain, P_dust1 ) = 'DUST1'
   aerosolc_desc_table( idomain, P_dust1 ) = 'DUST1 aerosol concentration'
   aerosolc_units_table( idomain, P_dust1 ) = '-'
   aerosolc_streams_table( idomain, P_dust1 )%stream(1) = 0 
   aerosolc_streams_table( idomain, P_dust1 )%stream(2) = 0 
   F_dust1 = .TRUE.
   IF ( aerosolc_index_table( PARAM_dust2 , idomain ) .lt. 1 ) THEN
     aerosolc_num_table(idomain) = aerosolc_num_table(idomain) + 1
     P_dust2 = aerosolc_num_table(idomain)
     aerosolc_index_table( PARAM_dust2 , idomain ) = P_dust2
   ELSE
     P_dust2 = aerosolc_index_table( PARAM_dust2 , idomain )
   END IF
   aerosolc_boundary_table( idomain, P_dust2 ) = .FALSE.
   aerosolc_dname_table( idomain, P_dust2 ) = 'DUST2'
   aerosolc_desc_table( idomain, P_dust2 ) = 'DUST2 aerosol concentration'
   aerosolc_units_table( idomain, P_dust2 ) = '-'
   aerosolc_streams_table( idomain, P_dust2 )%stream(1) = 0 
   aerosolc_streams_table( idomain, P_dust2 )%stream(2) = 0 
   F_dust2 = .TRUE.
   IF ( aerosolc_index_table( PARAM_dust3 , idomain ) .lt. 1 ) THEN
     aerosolc_num_table(idomain) = aerosolc_num_table(idomain) + 1
     P_dust3 = aerosolc_num_table(idomain)
     aerosolc_index_table( PARAM_dust3 , idomain ) = P_dust3
   ELSE
     P_dust3 = aerosolc_index_table( PARAM_dust3 , idomain )
   END IF
   aerosolc_boundary_table( idomain, P_dust3 ) = .FALSE.
   aerosolc_dname_table( idomain, P_dust3 ) = 'DUST3'
   aerosolc_desc_table( idomain, P_dust3 ) = 'DUST3 aerosol concentration'
   aerosolc_units_table( idomain, P_dust3 ) = '-'
   aerosolc_streams_table( idomain, P_dust3 )%stream(1) = 0 
   aerosolc_streams_table( idomain, P_dust3 )%stream(2) = 0 
   F_dust3 = .TRUE.
   IF ( aerosolc_index_table( PARAM_dust4 , idomain ) .lt. 1 ) THEN
     aerosolc_num_table(idomain) = aerosolc_num_table(idomain) + 1
     P_dust4 = aerosolc_num_table(idomain)
     aerosolc_index_table( PARAM_dust4 , idomain ) = P_dust4
   ELSE
     P_dust4 = aerosolc_index_table( PARAM_dust4 , idomain )
   END IF
   aerosolc_boundary_table( idomain, P_dust4 ) = .FALSE.
   aerosolc_dname_table( idomain, P_dust4 ) = 'DUST4'
   aerosolc_desc_table( idomain, P_dust4 ) = 'DUST4 aerosol concentration'
   aerosolc_units_table( idomain, P_dust4 ) = '-'
   aerosolc_streams_table( idomain, P_dust4 )%stream(1) = 0 
   aerosolc_streams_table( idomain, P_dust4 )%stream(2) = 0 
   F_dust4 = .TRUE.
   IF ( aerosolc_index_table( PARAM_ocpho , idomain ) .lt. 1 ) THEN
     aerosolc_num_table(idomain) = aerosolc_num_table(idomain) + 1
     P_ocpho = aerosolc_num_table(idomain)
     aerosolc_index_table( PARAM_ocpho , idomain ) = P_ocpho
   ELSE
     P_ocpho = aerosolc_index_table( PARAM_ocpho , idomain )
   END IF
   aerosolc_boundary_table( idomain, P_ocpho ) = .FALSE.
   aerosolc_dname_table( idomain, P_ocpho ) = 'OCPHO'
   aerosolc_desc_table( idomain, P_ocpho ) = 'OCPHO aerosol concentration'
   aerosolc_units_table( idomain, P_ocpho ) = '-'
   aerosolc_streams_table( idomain, P_ocpho )%stream(1) = 0 
   aerosolc_streams_table( idomain, P_ocpho )%stream(2) = 0 
   F_ocpho = .TRUE.
   IF ( aerosolc_index_table( PARAM_bcpho , idomain ) .lt. 1 ) THEN
     aerosolc_num_table(idomain) = aerosolc_num_table(idomain) + 1
     P_bcpho = aerosolc_num_table(idomain)
     aerosolc_index_table( PARAM_bcpho , idomain ) = P_bcpho
   ELSE
     P_bcpho = aerosolc_index_table( PARAM_bcpho , idomain )
   END IF
   aerosolc_boundary_table( idomain, P_bcpho ) = .FALSE.
   aerosolc_dname_table( idomain, P_bcpho ) = 'BCPHO'
   aerosolc_desc_table( idomain, P_bcpho ) = 'BCPHO aerosol concentration'
   aerosolc_units_table( idomain, P_bcpho ) = '-'
   aerosolc_streams_table( idomain, P_bcpho )%stream(1) = 0 
   aerosolc_streams_table( idomain, P_bcpho )%stream(2) = 0 
   F_bcpho = .TRUE.
   IF ( aerosolc_index_table( PARAM_ocphi , idomain ) .lt. 1 ) THEN
     aerosolc_num_table(idomain) = aerosolc_num_table(idomain) + 1
     P_ocphi = aerosolc_num_table(idomain)
     aerosolc_index_table( PARAM_ocphi , idomain ) = P_ocphi
   ELSE
     P_ocphi = aerosolc_index_table( PARAM_ocphi , idomain )
   END IF
   aerosolc_boundary_table( idomain, P_ocphi ) = .FALSE.
   aerosolc_dname_table( idomain, P_ocphi ) = 'OCPHI'
   aerosolc_desc_table( idomain, P_ocphi ) = 'OCPHI aerosol concentration'
   aerosolc_units_table( idomain, P_ocphi ) = '-'
   aerosolc_streams_table( idomain, P_ocphi )%stream(1) = 0 
   aerosolc_streams_table( idomain, P_ocphi )%stream(2) = 0 
   F_ocphi = .TRUE.
   IF ( aerosolc_index_table( PARAM_bcphi , idomain ) .lt. 1 ) THEN
     aerosolc_num_table(idomain) = aerosolc_num_table(idomain) + 1
     P_bcphi = aerosolc_num_table(idomain)
     aerosolc_index_table( PARAM_bcphi , idomain ) = P_bcphi
   ELSE
     P_bcphi = aerosolc_index_table( PARAM_bcphi , idomain )
   END IF
   aerosolc_boundary_table( idomain, P_bcphi ) = .FALSE.
   aerosolc_dname_table( idomain, P_bcphi ) = 'BCPHI'
   aerosolc_desc_table( idomain, P_bcphi ) = 'BCPHI aerosol concentration'
   aerosolc_units_table( idomain, P_bcphi ) = '-'
   aerosolc_streams_table( idomain, P_bcphi )%stream(1) = 0 
   aerosolc_streams_table( idomain, P_bcphi )%stream(2) = 0 
   F_bcphi = .TRUE.
   IF ( aerosolc_index_table( PARAM_bg , idomain ) .lt. 1 ) THEN
     aerosolc_num_table(idomain) = aerosolc_num_table(idomain) + 1
     P_bg = aerosolc_num_table(idomain)
     aerosolc_index_table( PARAM_bg , idomain ) = P_bg
   ELSE
     P_bg = aerosolc_index_table( PARAM_bg , idomain )
   END IF
   aerosolc_boundary_table( idomain, P_bg ) = .FALSE.
   aerosolc_dname_table( idomain, P_bg ) = 'BG'
   aerosolc_desc_table( idomain, P_bg ) = 'BG aerosol concentration'
   aerosolc_units_table( idomain, P_bg ) = '-'
   aerosolc_streams_table( idomain, P_bg )%stream(1) = 0 
   aerosolc_streams_table( idomain, P_bg )%stream(2) = 0 
   F_bg = .TRUE.
   IF ( aerosolc_index_table( PARAM_volc , idomain ) .lt. 1 ) THEN
     aerosolc_num_table(idomain) = aerosolc_num_table(idomain) + 1
     P_volc = aerosolc_num_table(idomain)
     aerosolc_index_table( PARAM_volc , idomain ) = P_volc
   ELSE
     P_volc = aerosolc_index_table( PARAM_volc , idomain )
   END IF
   aerosolc_boundary_table( idomain, P_volc ) = .FALSE.
   aerosolc_dname_table( idomain, P_volc ) = 'VOLC'
   aerosolc_desc_table( idomain, P_volc ) = 'VOLC aerosol concentration'
   aerosolc_units_table( idomain, P_volc ) = '-'
   aerosolc_streams_table( idomain, P_volc )%stream(1) = 0 
   aerosolc_streams_table( idomain, P_volc )%stream(2) = 0 
   F_volc = .TRUE.
  END IF
  IF (model_config_rec%ra_lw_physics(idomain)==4)THEN
   IF ( ozmixm_index_table( PARAM_mth01 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth01 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth01 , idomain ) = P_mth01
   ELSE
     P_mth01 = ozmixm_index_table( PARAM_mth01 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth01 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth01 ) = ''
   ozmixm_desc_table( idomain, P_mth01 ) = '-'
   ozmixm_units_table( idomain, P_mth01 ) = '-'
   ozmixm_streams_table( idomain, P_mth01 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth01 )%stream(2) = 0 
   F_mth01 = .TRUE.
   IF ( ozmixm_index_table( PARAM_mth02 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth02 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth02 , idomain ) = P_mth02
   ELSE
     P_mth02 = ozmixm_index_table( PARAM_mth02 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth02 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth02 ) = ''
   ozmixm_desc_table( idomain, P_mth02 ) = '-'
   ozmixm_units_table( idomain, P_mth02 ) = '-'
   ozmixm_streams_table( idomain, P_mth02 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth02 )%stream(2) = 0 
   F_mth02 = .TRUE.
   IF ( ozmixm_index_table( PARAM_mth03 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth03 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth03 , idomain ) = P_mth03
   ELSE
     P_mth03 = ozmixm_index_table( PARAM_mth03 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth03 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth03 ) = ''
   ozmixm_desc_table( idomain, P_mth03 ) = '-'
   ozmixm_units_table( idomain, P_mth03 ) = '-'
   ozmixm_streams_table( idomain, P_mth03 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth03 )%stream(2) = 0 
   F_mth03 = .TRUE.
   IF ( ozmixm_index_table( PARAM_mth04 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth04 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth04 , idomain ) = P_mth04
   ELSE
     P_mth04 = ozmixm_index_table( PARAM_mth04 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth04 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth04 ) = ''
   ozmixm_desc_table( idomain, P_mth04 ) = '-'
   ozmixm_units_table( idomain, P_mth04 ) = '-'
   ozmixm_streams_table( idomain, P_mth04 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth04 )%stream(2) = 0 
   F_mth04 = .TRUE.
   IF ( ozmixm_index_table( PARAM_mth05 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth05 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth05 , idomain ) = P_mth05
   ELSE
     P_mth05 = ozmixm_index_table( PARAM_mth05 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth05 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth05 ) = ''
   ozmixm_desc_table( idomain, P_mth05 ) = '-'
   ozmixm_units_table( idomain, P_mth05 ) = '-'
   ozmixm_streams_table( idomain, P_mth05 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth05 )%stream(2) = 0 
   F_mth05 = .TRUE.
   IF ( ozmixm_index_table( PARAM_mth06 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth06 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth06 , idomain ) = P_mth06
   ELSE
     P_mth06 = ozmixm_index_table( PARAM_mth06 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth06 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth06 ) = ''
   ozmixm_desc_table( idomain, P_mth06 ) = '-'
   ozmixm_units_table( idomain, P_mth06 ) = '-'
   ozmixm_streams_table( idomain, P_mth06 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth06 )%stream(2) = 0 
   F_mth06 = .TRUE.
   IF ( ozmixm_index_table( PARAM_mth07 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth07 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth07 , idomain ) = P_mth07
   ELSE
     P_mth07 = ozmixm_index_table( PARAM_mth07 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth07 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth07 ) = ''
   ozmixm_desc_table( idomain, P_mth07 ) = '-'
   ozmixm_units_table( idomain, P_mth07 ) = '-'
   ozmixm_streams_table( idomain, P_mth07 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth07 )%stream(2) = 0 
   F_mth07 = .TRUE.
   IF ( ozmixm_index_table( PARAM_mth08 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth08 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth08 , idomain ) = P_mth08
   ELSE
     P_mth08 = ozmixm_index_table( PARAM_mth08 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth08 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth08 ) = ''
   ozmixm_desc_table( idomain, P_mth08 ) = '-'
   ozmixm_units_table( idomain, P_mth08 ) = '-'
   ozmixm_streams_table( idomain, P_mth08 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth08 )%stream(2) = 0 
   F_mth08 = .TRUE.
   IF ( ozmixm_index_table( PARAM_mth09 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth09 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth09 , idomain ) = P_mth09
   ELSE
     P_mth09 = ozmixm_index_table( PARAM_mth09 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth09 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth09 ) = ''
   ozmixm_desc_table( idomain, P_mth09 ) = '-'
   ozmixm_units_table( idomain, P_mth09 ) = '-'
   ozmixm_streams_table( idomain, P_mth09 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth09 )%stream(2) = 0 
   F_mth09 = .TRUE.
   IF ( ozmixm_index_table( PARAM_mth10 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth10 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth10 , idomain ) = P_mth10
   ELSE
     P_mth10 = ozmixm_index_table( PARAM_mth10 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth10 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth10 ) = ''
   ozmixm_desc_table( idomain, P_mth10 ) = '-'
   ozmixm_units_table( idomain, P_mth10 ) = '-'
   ozmixm_streams_table( idomain, P_mth10 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth10 )%stream(2) = 0 
   F_mth10 = .TRUE.
   IF ( ozmixm_index_table( PARAM_mth11 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth11 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth11 , idomain ) = P_mth11
   ELSE
     P_mth11 = ozmixm_index_table( PARAM_mth11 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth11 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth11 ) = ''
   ozmixm_desc_table( idomain, P_mth11 ) = '-'
   ozmixm_units_table( idomain, P_mth11 ) = '-'
   ozmixm_streams_table( idomain, P_mth11 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth11 )%stream(2) = 0 
   F_mth11 = .TRUE.
   IF ( ozmixm_index_table( PARAM_mth12 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth12 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth12 , idomain ) = P_mth12
   ELSE
     P_mth12 = ozmixm_index_table( PARAM_mth12 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth12 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth12 ) = ''
   ozmixm_desc_table( idomain, P_mth12 ) = '-'
   ozmixm_units_table( idomain, P_mth12 ) = '-'
   ozmixm_streams_table( idomain, P_mth12 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth12 )%stream(2) = 0 
   F_mth12 = .TRUE.
  END IF
  IF (model_config_rec%ra_lw_physics(idomain)==14)THEN
   IF ( ozmixm_index_table( PARAM_mth01 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth01 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth01 , idomain ) = P_mth01
   ELSE
     P_mth01 = ozmixm_index_table( PARAM_mth01 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth01 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth01 ) = ''
   ozmixm_desc_table( idomain, P_mth01 ) = '-'
   ozmixm_units_table( idomain, P_mth01 ) = '-'
   ozmixm_streams_table( idomain, P_mth01 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth01 )%stream(2) = 0 
   F_mth01 = .TRUE.
   IF ( ozmixm_index_table( PARAM_mth02 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth02 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth02 , idomain ) = P_mth02
   ELSE
     P_mth02 = ozmixm_index_table( PARAM_mth02 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth02 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth02 ) = ''
   ozmixm_desc_table( idomain, P_mth02 ) = '-'
   ozmixm_units_table( idomain, P_mth02 ) = '-'
   ozmixm_streams_table( idomain, P_mth02 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth02 )%stream(2) = 0 
   F_mth02 = .TRUE.
   IF ( ozmixm_index_table( PARAM_mth03 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth03 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth03 , idomain ) = P_mth03
   ELSE
     P_mth03 = ozmixm_index_table( PARAM_mth03 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth03 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth03 ) = ''
   ozmixm_desc_table( idomain, P_mth03 ) = '-'
   ozmixm_units_table( idomain, P_mth03 ) = '-'
   ozmixm_streams_table( idomain, P_mth03 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth03 )%stream(2) = 0 
   F_mth03 = .TRUE.
   IF ( ozmixm_index_table( PARAM_mth04 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth04 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth04 , idomain ) = P_mth04
   ELSE
     P_mth04 = ozmixm_index_table( PARAM_mth04 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth04 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth04 ) = ''
   ozmixm_desc_table( idomain, P_mth04 ) = '-'
   ozmixm_units_table( idomain, P_mth04 ) = '-'
   ozmixm_streams_table( idomain, P_mth04 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth04 )%stream(2) = 0 
   F_mth04 = .TRUE.
   IF ( ozmixm_index_table( PARAM_mth05 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth05 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth05 , idomain ) = P_mth05
   ELSE
     P_mth05 = ozmixm_index_table( PARAM_mth05 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth05 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth05 ) = ''
   ozmixm_desc_table( idomain, P_mth05 ) = '-'
   ozmixm_units_table( idomain, P_mth05 ) = '-'
   ozmixm_streams_table( idomain, P_mth05 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth05 )%stream(2) = 0 
   F_mth05 = .TRUE.
   IF ( ozmixm_index_table( PARAM_mth06 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth06 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth06 , idomain ) = P_mth06
   ELSE
     P_mth06 = ozmixm_index_table( PARAM_mth06 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth06 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth06 ) = ''
   ozmixm_desc_table( idomain, P_mth06 ) = '-'
   ozmixm_units_table( idomain, P_mth06 ) = '-'
   ozmixm_streams_table( idomain, P_mth06 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth06 )%stream(2) = 0 
   F_mth06 = .TRUE.
   IF ( ozmixm_index_table( PARAM_mth07 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth07 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth07 , idomain ) = P_mth07
   ELSE
     P_mth07 = ozmixm_index_table( PARAM_mth07 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth07 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth07 ) = ''
   ozmixm_desc_table( idomain, P_mth07 ) = '-'
   ozmixm_units_table( idomain, P_mth07 ) = '-'
   ozmixm_streams_table( idomain, P_mth07 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth07 )%stream(2) = 0 
   F_mth07 = .TRUE.
   IF ( ozmixm_index_table( PARAM_mth08 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth08 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth08 , idomain ) = P_mth08
   ELSE
     P_mth08 = ozmixm_index_table( PARAM_mth08 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth08 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth08 ) = ''
   ozmixm_desc_table( idomain, P_mth08 ) = '-'
   ozmixm_units_table( idomain, P_mth08 ) = '-'
   ozmixm_streams_table( idomain, P_mth08 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth08 )%stream(2) = 0 
   F_mth08 = .TRUE.
   IF ( ozmixm_index_table( PARAM_mth09 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth09 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth09 , idomain ) = P_mth09
   ELSE
     P_mth09 = ozmixm_index_table( PARAM_mth09 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth09 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth09 ) = ''
   ozmixm_desc_table( idomain, P_mth09 ) = '-'
   ozmixm_units_table( idomain, P_mth09 ) = '-'
   ozmixm_streams_table( idomain, P_mth09 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth09 )%stream(2) = 0 
   F_mth09 = .TRUE.
   IF ( ozmixm_index_table( PARAM_mth10 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth10 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth10 , idomain ) = P_mth10
   ELSE
     P_mth10 = ozmixm_index_table( PARAM_mth10 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth10 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth10 ) = ''
   ozmixm_desc_table( idomain, P_mth10 ) = '-'
   ozmixm_units_table( idomain, P_mth10 ) = '-'
   ozmixm_streams_table( idomain, P_mth10 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth10 )%stream(2) = 0 
   F_mth10 = .TRUE.
   IF ( ozmixm_index_table( PARAM_mth11 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth11 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth11 , idomain ) = P_mth11
   ELSE
     P_mth11 = ozmixm_index_table( PARAM_mth11 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth11 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth11 ) = ''
   ozmixm_desc_table( idomain, P_mth11 ) = '-'
   ozmixm_units_table( idomain, P_mth11 ) = '-'
   ozmixm_streams_table( idomain, P_mth11 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth11 )%stream(2) = 0 
   F_mth11 = .TRUE.
   IF ( ozmixm_index_table( PARAM_mth12 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth12 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth12 , idomain ) = P_mth12
   ELSE
     P_mth12 = ozmixm_index_table( PARAM_mth12 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth12 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth12 ) = ''
   ozmixm_desc_table( idomain, P_mth12 ) = '-'
   ozmixm_units_table( idomain, P_mth12 ) = '-'
   ozmixm_streams_table( idomain, P_mth12 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth12 )%stream(2) = 0 
   F_mth12 = .TRUE.
  END IF
  IF (model_config_rec%ra_lw_physics(idomain)==24)THEN
   IF ( ozmixm_index_table( PARAM_mth01 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth01 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth01 , idomain ) = P_mth01
   ELSE
     P_mth01 = ozmixm_index_table( PARAM_mth01 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth01 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth01 ) = ''
   ozmixm_desc_table( idomain, P_mth01 ) = '-'
   ozmixm_units_table( idomain, P_mth01 ) = '-'
   ozmixm_streams_table( idomain, P_mth01 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth01 )%stream(2) = 0 
   F_mth01 = .TRUE.
   IF ( ozmixm_index_table( PARAM_mth02 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth02 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth02 , idomain ) = P_mth02
   ELSE
     P_mth02 = ozmixm_index_table( PARAM_mth02 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth02 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth02 ) = ''
   ozmixm_desc_table( idomain, P_mth02 ) = '-'
   ozmixm_units_table( idomain, P_mth02 ) = '-'
   ozmixm_streams_table( idomain, P_mth02 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth02 )%stream(2) = 0 
   F_mth02 = .TRUE.
   IF ( ozmixm_index_table( PARAM_mth03 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth03 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth03 , idomain ) = P_mth03
   ELSE
     P_mth03 = ozmixm_index_table( PARAM_mth03 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth03 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth03 ) = ''
   ozmixm_desc_table( idomain, P_mth03 ) = '-'
   ozmixm_units_table( idomain, P_mth03 ) = '-'
   ozmixm_streams_table( idomain, P_mth03 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth03 )%stream(2) = 0 
   F_mth03 = .TRUE.
   IF ( ozmixm_index_table( PARAM_mth04 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth04 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth04 , idomain ) = P_mth04
   ELSE
     P_mth04 = ozmixm_index_table( PARAM_mth04 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth04 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth04 ) = ''
   ozmixm_desc_table( idomain, P_mth04 ) = '-'
   ozmixm_units_table( idomain, P_mth04 ) = '-'
   ozmixm_streams_table( idomain, P_mth04 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth04 )%stream(2) = 0 
   F_mth04 = .TRUE.
   IF ( ozmixm_index_table( PARAM_mth05 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth05 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth05 , idomain ) = P_mth05
   ELSE
     P_mth05 = ozmixm_index_table( PARAM_mth05 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth05 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth05 ) = ''
   ozmixm_desc_table( idomain, P_mth05 ) = '-'
   ozmixm_units_table( idomain, P_mth05 ) = '-'
   ozmixm_streams_table( idomain, P_mth05 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth05 )%stream(2) = 0 
   F_mth05 = .TRUE.
   IF ( ozmixm_index_table( PARAM_mth06 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth06 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth06 , idomain ) = P_mth06
   ELSE
     P_mth06 = ozmixm_index_table( PARAM_mth06 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth06 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth06 ) = ''
   ozmixm_desc_table( idomain, P_mth06 ) = '-'
   ozmixm_units_table( idomain, P_mth06 ) = '-'
   ozmixm_streams_table( idomain, P_mth06 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth06 )%stream(2) = 0 
   F_mth06 = .TRUE.
   IF ( ozmixm_index_table( PARAM_mth07 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth07 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth07 , idomain ) = P_mth07
   ELSE
     P_mth07 = ozmixm_index_table( PARAM_mth07 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth07 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth07 ) = ''
   ozmixm_desc_table( idomain, P_mth07 ) = '-'
   ozmixm_units_table( idomain, P_mth07 ) = '-'
   ozmixm_streams_table( idomain, P_mth07 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth07 )%stream(2) = 0 
   F_mth07 = .TRUE.
   IF ( ozmixm_index_table( PARAM_mth08 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth08 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth08 , idomain ) = P_mth08
   ELSE
     P_mth08 = ozmixm_index_table( PARAM_mth08 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth08 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth08 ) = ''
   ozmixm_desc_table( idomain, P_mth08 ) = '-'
   ozmixm_units_table( idomain, P_mth08 ) = '-'
   ozmixm_streams_table( idomain, P_mth08 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth08 )%stream(2) = 0 
   F_mth08 = .TRUE.
   IF ( ozmixm_index_table( PARAM_mth09 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth09 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth09 , idomain ) = P_mth09
   ELSE
     P_mth09 = ozmixm_index_table( PARAM_mth09 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth09 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth09 ) = ''
   ozmixm_desc_table( idomain, P_mth09 ) = '-'
   ozmixm_units_table( idomain, P_mth09 ) = '-'
   ozmixm_streams_table( idomain, P_mth09 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth09 )%stream(2) = 0 
   F_mth09 = .TRUE.
   IF ( ozmixm_index_table( PARAM_mth10 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth10 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth10 , idomain ) = P_mth10
   ELSE
     P_mth10 = ozmixm_index_table( PARAM_mth10 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth10 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth10 ) = ''
   ozmixm_desc_table( idomain, P_mth10 ) = '-'
   ozmixm_units_table( idomain, P_mth10 ) = '-'
   ozmixm_streams_table( idomain, P_mth10 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth10 )%stream(2) = 0 
   F_mth10 = .TRUE.
   IF ( ozmixm_index_table( PARAM_mth11 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth11 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth11 , idomain ) = P_mth11
   ELSE
     P_mth11 = ozmixm_index_table( PARAM_mth11 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth11 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth11 ) = ''
   ozmixm_desc_table( idomain, P_mth11 ) = '-'
   ozmixm_units_table( idomain, P_mth11 ) = '-'
   ozmixm_streams_table( idomain, P_mth11 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth11 )%stream(2) = 0 
   F_mth11 = .TRUE.
   IF ( ozmixm_index_table( PARAM_mth12 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth12 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth12 , idomain ) = P_mth12
   ELSE
     P_mth12 = ozmixm_index_table( PARAM_mth12 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth12 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth12 ) = ''
   ozmixm_desc_table( idomain, P_mth12 ) = '-'
   ozmixm_units_table( idomain, P_mth12 ) = '-'
   ozmixm_streams_table( idomain, P_mth12 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth12 )%stream(2) = 0 
   F_mth12 = .TRUE.
  END IF
  IF (model_config_rec%ra_lw_physics(idomain)==5)THEN
  END IF
  IF (model_config_rec%ra_lw_physics(idomain)==7)THEN
  END IF
  IF (model_config_rec%ra_lw_physics(idomain)==31)THEN
  END IF
  IF (model_config_rec%ra_lw_physics(idomain)==99)THEN
  END IF
  IF (model_config_rec%ra_sw_physics(idomain)==1)THEN
  END IF
  IF (model_config_rec%ra_sw_physics(idomain)==2)THEN
  END IF
  IF (model_config_rec%ra_sw_physics(idomain)==3)THEN
   IF ( ozmixm_index_table( PARAM_mth01 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth01 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth01 , idomain ) = P_mth01
   ELSE
     P_mth01 = ozmixm_index_table( PARAM_mth01 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth01 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth01 ) = ''
   ozmixm_desc_table( idomain, P_mth01 ) = '-'
   ozmixm_units_table( idomain, P_mth01 ) = '-'
   ozmixm_streams_table( idomain, P_mth01 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth01 )%stream(2) = 0 
   F_mth01 = .TRUE.
   IF ( ozmixm_index_table( PARAM_mth02 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth02 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth02 , idomain ) = P_mth02
   ELSE
     P_mth02 = ozmixm_index_table( PARAM_mth02 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth02 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth02 ) = ''
   ozmixm_desc_table( idomain, P_mth02 ) = '-'
   ozmixm_units_table( idomain, P_mth02 ) = '-'
   ozmixm_streams_table( idomain, P_mth02 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth02 )%stream(2) = 0 
   F_mth02 = .TRUE.
   IF ( ozmixm_index_table( PARAM_mth03 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth03 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth03 , idomain ) = P_mth03
   ELSE
     P_mth03 = ozmixm_index_table( PARAM_mth03 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth03 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth03 ) = ''
   ozmixm_desc_table( idomain, P_mth03 ) = '-'
   ozmixm_units_table( idomain, P_mth03 ) = '-'
   ozmixm_streams_table( idomain, P_mth03 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth03 )%stream(2) = 0 
   F_mth03 = .TRUE.
   IF ( ozmixm_index_table( PARAM_mth04 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth04 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth04 , idomain ) = P_mth04
   ELSE
     P_mth04 = ozmixm_index_table( PARAM_mth04 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth04 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth04 ) = ''
   ozmixm_desc_table( idomain, P_mth04 ) = '-'
   ozmixm_units_table( idomain, P_mth04 ) = '-'
   ozmixm_streams_table( idomain, P_mth04 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth04 )%stream(2) = 0 
   F_mth04 = .TRUE.
   IF ( ozmixm_index_table( PARAM_mth05 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth05 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth05 , idomain ) = P_mth05
   ELSE
     P_mth05 = ozmixm_index_table( PARAM_mth05 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth05 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth05 ) = ''
   ozmixm_desc_table( idomain, P_mth05 ) = '-'
   ozmixm_units_table( idomain, P_mth05 ) = '-'
   ozmixm_streams_table( idomain, P_mth05 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth05 )%stream(2) = 0 
   F_mth05 = .TRUE.
   IF ( ozmixm_index_table( PARAM_mth06 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth06 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth06 , idomain ) = P_mth06
   ELSE
     P_mth06 = ozmixm_index_table( PARAM_mth06 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth06 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth06 ) = ''
   ozmixm_desc_table( idomain, P_mth06 ) = '-'
   ozmixm_units_table( idomain, P_mth06 ) = '-'
   ozmixm_streams_table( idomain, P_mth06 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth06 )%stream(2) = 0 
   F_mth06 = .TRUE.
   IF ( ozmixm_index_table( PARAM_mth07 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth07 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth07 , idomain ) = P_mth07
   ELSE
     P_mth07 = ozmixm_index_table( PARAM_mth07 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth07 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth07 ) = ''
   ozmixm_desc_table( idomain, P_mth07 ) = '-'
   ozmixm_units_table( idomain, P_mth07 ) = '-'
   ozmixm_streams_table( idomain, P_mth07 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth07 )%stream(2) = 0 
   F_mth07 = .TRUE.
   IF ( ozmixm_index_table( PARAM_mth08 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth08 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth08 , idomain ) = P_mth08
   ELSE
     P_mth08 = ozmixm_index_table( PARAM_mth08 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth08 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth08 ) = ''
   ozmixm_desc_table( idomain, P_mth08 ) = '-'
   ozmixm_units_table( idomain, P_mth08 ) = '-'
   ozmixm_streams_table( idomain, P_mth08 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth08 )%stream(2) = 0 
   F_mth08 = .TRUE.
   IF ( ozmixm_index_table( PARAM_mth09 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth09 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth09 , idomain ) = P_mth09
   ELSE
     P_mth09 = ozmixm_index_table( PARAM_mth09 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth09 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth09 ) = ''
   ozmixm_desc_table( idomain, P_mth09 ) = '-'
   ozmixm_units_table( idomain, P_mth09 ) = '-'
   ozmixm_streams_table( idomain, P_mth09 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth09 )%stream(2) = 0 
   F_mth09 = .TRUE.
   IF ( ozmixm_index_table( PARAM_mth10 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth10 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth10 , idomain ) = P_mth10
   ELSE
     P_mth10 = ozmixm_index_table( PARAM_mth10 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth10 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth10 ) = ''
   ozmixm_desc_table( idomain, P_mth10 ) = '-'
   ozmixm_units_table( idomain, P_mth10 ) = '-'
   ozmixm_streams_table( idomain, P_mth10 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth10 )%stream(2) = 0 
   F_mth10 = .TRUE.
   IF ( ozmixm_index_table( PARAM_mth11 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth11 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth11 , idomain ) = P_mth11
   ELSE
     P_mth11 = ozmixm_index_table( PARAM_mth11 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth11 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth11 ) = ''
   ozmixm_desc_table( idomain, P_mth11 ) = '-'
   ozmixm_units_table( idomain, P_mth11 ) = '-'
   ozmixm_streams_table( idomain, P_mth11 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth11 )%stream(2) = 0 
   F_mth11 = .TRUE.
   IF ( ozmixm_index_table( PARAM_mth12 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth12 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth12 , idomain ) = P_mth12
   ELSE
     P_mth12 = ozmixm_index_table( PARAM_mth12 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth12 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth12 ) = ''
   ozmixm_desc_table( idomain, P_mth12 ) = '-'
   ozmixm_units_table( idomain, P_mth12 ) = '-'
   ozmixm_streams_table( idomain, P_mth12 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth12 )%stream(2) = 0 
   F_mth12 = .TRUE.
   IF ( aerosolc_index_table( PARAM_sul , idomain ) .lt. 1 ) THEN
     aerosolc_num_table(idomain) = aerosolc_num_table(idomain) + 1
     P_sul = aerosolc_num_table(idomain)
     aerosolc_index_table( PARAM_sul , idomain ) = P_sul
   ELSE
     P_sul = aerosolc_index_table( PARAM_sul , idomain )
   END IF
   aerosolc_boundary_table( idomain, P_sul ) = .FALSE.
   aerosolc_dname_table( idomain, P_sul ) = 'SUL'
   aerosolc_desc_table( idomain, P_sul ) = 'SUL aerosol concentration'
   aerosolc_units_table( idomain, P_sul ) = '-'
   aerosolc_streams_table( idomain, P_sul )%stream(1) = 0 
   aerosolc_streams_table( idomain, P_sul )%stream(2) = 0 
   F_sul = .TRUE.
   IF ( aerosolc_index_table( PARAM_sslt , idomain ) .lt. 1 ) THEN
     aerosolc_num_table(idomain) = aerosolc_num_table(idomain) + 1
     P_sslt = aerosolc_num_table(idomain)
     aerosolc_index_table( PARAM_sslt , idomain ) = P_sslt
   ELSE
     P_sslt = aerosolc_index_table( PARAM_sslt , idomain )
   END IF
   aerosolc_boundary_table( idomain, P_sslt ) = .FALSE.
   aerosolc_dname_table( idomain, P_sslt ) = 'SSLT'
   aerosolc_desc_table( idomain, P_sslt ) = 'SSLT aerosol concentration'
   aerosolc_units_table( idomain, P_sslt ) = '-'
   aerosolc_streams_table( idomain, P_sslt )%stream(1) = 0 
   aerosolc_streams_table( idomain, P_sslt )%stream(2) = 0 
   F_sslt = .TRUE.
   IF ( aerosolc_index_table( PARAM_dust1 , idomain ) .lt. 1 ) THEN
     aerosolc_num_table(idomain) = aerosolc_num_table(idomain) + 1
     P_dust1 = aerosolc_num_table(idomain)
     aerosolc_index_table( PARAM_dust1 , idomain ) = P_dust1
   ELSE
     P_dust1 = aerosolc_index_table( PARAM_dust1 , idomain )
   END IF
   aerosolc_boundary_table( idomain, P_dust1 ) = .FALSE.
   aerosolc_dname_table( idomain, P_dust1 ) = 'DUST1'
   aerosolc_desc_table( idomain, P_dust1 ) = 'DUST1 aerosol concentration'
   aerosolc_units_table( idomain, P_dust1 ) = '-'
   aerosolc_streams_table( idomain, P_dust1 )%stream(1) = 0 
   aerosolc_streams_table( idomain, P_dust1 )%stream(2) = 0 
   F_dust1 = .TRUE.
   IF ( aerosolc_index_table( PARAM_dust2 , idomain ) .lt. 1 ) THEN
     aerosolc_num_table(idomain) = aerosolc_num_table(idomain) + 1
     P_dust2 = aerosolc_num_table(idomain)
     aerosolc_index_table( PARAM_dust2 , idomain ) = P_dust2
   ELSE
     P_dust2 = aerosolc_index_table( PARAM_dust2 , idomain )
   END IF
   aerosolc_boundary_table( idomain, P_dust2 ) = .FALSE.
   aerosolc_dname_table( idomain, P_dust2 ) = 'DUST2'
   aerosolc_desc_table( idomain, P_dust2 ) = 'DUST2 aerosol concentration'
   aerosolc_units_table( idomain, P_dust2 ) = '-'
   aerosolc_streams_table( idomain, P_dust2 )%stream(1) = 0 
   aerosolc_streams_table( idomain, P_dust2 )%stream(2) = 0 
   F_dust2 = .TRUE.
   IF ( aerosolc_index_table( PARAM_dust3 , idomain ) .lt. 1 ) THEN
     aerosolc_num_table(idomain) = aerosolc_num_table(idomain) + 1
     P_dust3 = aerosolc_num_table(idomain)
     aerosolc_index_table( PARAM_dust3 , idomain ) = P_dust3
   ELSE
     P_dust3 = aerosolc_index_table( PARAM_dust3 , idomain )
   END IF
   aerosolc_boundary_table( idomain, P_dust3 ) = .FALSE.
   aerosolc_dname_table( idomain, P_dust3 ) = 'DUST3'
   aerosolc_desc_table( idomain, P_dust3 ) = 'DUST3 aerosol concentration'
   aerosolc_units_table( idomain, P_dust3 ) = '-'
   aerosolc_streams_table( idomain, P_dust3 )%stream(1) = 0 
   aerosolc_streams_table( idomain, P_dust3 )%stream(2) = 0 
   F_dust3 = .TRUE.
   IF ( aerosolc_index_table( PARAM_dust4 , idomain ) .lt. 1 ) THEN
     aerosolc_num_table(idomain) = aerosolc_num_table(idomain) + 1
     P_dust4 = aerosolc_num_table(idomain)
     aerosolc_index_table( PARAM_dust4 , idomain ) = P_dust4
   ELSE
     P_dust4 = aerosolc_index_table( PARAM_dust4 , idomain )
   END IF
   aerosolc_boundary_table( idomain, P_dust4 ) = .FALSE.
   aerosolc_dname_table( idomain, P_dust4 ) = 'DUST4'
   aerosolc_desc_table( idomain, P_dust4 ) = 'DUST4 aerosol concentration'
   aerosolc_units_table( idomain, P_dust4 ) = '-'
   aerosolc_streams_table( idomain, P_dust4 )%stream(1) = 0 
   aerosolc_streams_table( idomain, P_dust4 )%stream(2) = 0 
   F_dust4 = .TRUE.
   IF ( aerosolc_index_table( PARAM_ocpho , idomain ) .lt. 1 ) THEN
     aerosolc_num_table(idomain) = aerosolc_num_table(idomain) + 1
     P_ocpho = aerosolc_num_table(idomain)
     aerosolc_index_table( PARAM_ocpho , idomain ) = P_ocpho
   ELSE
     P_ocpho = aerosolc_index_table( PARAM_ocpho , idomain )
   END IF
   aerosolc_boundary_table( idomain, P_ocpho ) = .FALSE.
   aerosolc_dname_table( idomain, P_ocpho ) = 'OCPHO'
   aerosolc_desc_table( idomain, P_ocpho ) = 'OCPHO aerosol concentration'
   aerosolc_units_table( idomain, P_ocpho ) = '-'
   aerosolc_streams_table( idomain, P_ocpho )%stream(1) = 0 
   aerosolc_streams_table( idomain, P_ocpho )%stream(2) = 0 
   F_ocpho = .TRUE.
   IF ( aerosolc_index_table( PARAM_bcpho , idomain ) .lt. 1 ) THEN
     aerosolc_num_table(idomain) = aerosolc_num_table(idomain) + 1
     P_bcpho = aerosolc_num_table(idomain)
     aerosolc_index_table( PARAM_bcpho , idomain ) = P_bcpho
   ELSE
     P_bcpho = aerosolc_index_table( PARAM_bcpho , idomain )
   END IF
   aerosolc_boundary_table( idomain, P_bcpho ) = .FALSE.
   aerosolc_dname_table( idomain, P_bcpho ) = 'BCPHO'
   aerosolc_desc_table( idomain, P_bcpho ) = 'BCPHO aerosol concentration'
   aerosolc_units_table( idomain, P_bcpho ) = '-'
   aerosolc_streams_table( idomain, P_bcpho )%stream(1) = 0 
   aerosolc_streams_table( idomain, P_bcpho )%stream(2) = 0 
   F_bcpho = .TRUE.
   IF ( aerosolc_index_table( PARAM_ocphi , idomain ) .lt. 1 ) THEN
     aerosolc_num_table(idomain) = aerosolc_num_table(idomain) + 1
     P_ocphi = aerosolc_num_table(idomain)
     aerosolc_index_table( PARAM_ocphi , idomain ) = P_ocphi
   ELSE
     P_ocphi = aerosolc_index_table( PARAM_ocphi , idomain )
   END IF
   aerosolc_boundary_table( idomain, P_ocphi ) = .FALSE.
   aerosolc_dname_table( idomain, P_ocphi ) = 'OCPHI'
   aerosolc_desc_table( idomain, P_ocphi ) = 'OCPHI aerosol concentration'
   aerosolc_units_table( idomain, P_ocphi ) = '-'
   aerosolc_streams_table( idomain, P_ocphi )%stream(1) = 0 
   aerosolc_streams_table( idomain, P_ocphi )%stream(2) = 0 
   F_ocphi = .TRUE.
   IF ( aerosolc_index_table( PARAM_bcphi , idomain ) .lt. 1 ) THEN
     aerosolc_num_table(idomain) = aerosolc_num_table(idomain) + 1
     P_bcphi = aerosolc_num_table(idomain)
     aerosolc_index_table( PARAM_bcphi , idomain ) = P_bcphi
   ELSE
     P_bcphi = aerosolc_index_table( PARAM_bcphi , idomain )
   END IF
   aerosolc_boundary_table( idomain, P_bcphi ) = .FALSE.
   aerosolc_dname_table( idomain, P_bcphi ) = 'BCPHI'
   aerosolc_desc_table( idomain, P_bcphi ) = 'BCPHI aerosol concentration'
   aerosolc_units_table( idomain, P_bcphi ) = '-'
   aerosolc_streams_table( idomain, P_bcphi )%stream(1) = 0 
   aerosolc_streams_table( idomain, P_bcphi )%stream(2) = 0 
   F_bcphi = .TRUE.
   IF ( aerosolc_index_table( PARAM_bg , idomain ) .lt. 1 ) THEN
     aerosolc_num_table(idomain) = aerosolc_num_table(idomain) + 1
     P_bg = aerosolc_num_table(idomain)
     aerosolc_index_table( PARAM_bg , idomain ) = P_bg
   ELSE
     P_bg = aerosolc_index_table( PARAM_bg , idomain )
   END IF
   aerosolc_boundary_table( idomain, P_bg ) = .FALSE.
   aerosolc_dname_table( idomain, P_bg ) = 'BG'
   aerosolc_desc_table( idomain, P_bg ) = 'BG aerosol concentration'
   aerosolc_units_table( idomain, P_bg ) = '-'
   aerosolc_streams_table( idomain, P_bg )%stream(1) = 0 
   aerosolc_streams_table( idomain, P_bg )%stream(2) = 0 
   F_bg = .TRUE.
   IF ( aerosolc_index_table( PARAM_volc , idomain ) .lt. 1 ) THEN
     aerosolc_num_table(idomain) = aerosolc_num_table(idomain) + 1
     P_volc = aerosolc_num_table(idomain)
     aerosolc_index_table( PARAM_volc , idomain ) = P_volc
   ELSE
     P_volc = aerosolc_index_table( PARAM_volc , idomain )
   END IF
   aerosolc_boundary_table( idomain, P_volc ) = .FALSE.
   aerosolc_dname_table( idomain, P_volc ) = 'VOLC'
   aerosolc_desc_table( idomain, P_volc ) = 'VOLC aerosol concentration'
   aerosolc_units_table( idomain, P_volc ) = '-'
   aerosolc_streams_table( idomain, P_volc )%stream(1) = 0 
   aerosolc_streams_table( idomain, P_volc )%stream(2) = 0 
   F_volc = .TRUE.
  END IF
  IF (model_config_rec%ra_sw_physics(idomain)==4)THEN
   IF ( ozmixm_index_table( PARAM_mth01 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth01 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth01 , idomain ) = P_mth01
   ELSE
     P_mth01 = ozmixm_index_table( PARAM_mth01 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth01 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth01 ) = ''
   ozmixm_desc_table( idomain, P_mth01 ) = '-'
   ozmixm_units_table( idomain, P_mth01 ) = '-'
   ozmixm_streams_table( idomain, P_mth01 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth01 )%stream(2) = 0 
   F_mth01 = .TRUE.
   IF ( ozmixm_index_table( PARAM_mth02 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth02 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth02 , idomain ) = P_mth02
   ELSE
     P_mth02 = ozmixm_index_table( PARAM_mth02 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth02 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth02 ) = ''
   ozmixm_desc_table( idomain, P_mth02 ) = '-'
   ozmixm_units_table( idomain, P_mth02 ) = '-'
   ozmixm_streams_table( idomain, P_mth02 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth02 )%stream(2) = 0 
   F_mth02 = .TRUE.
   IF ( ozmixm_index_table( PARAM_mth03 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth03 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth03 , idomain ) = P_mth03
   ELSE
     P_mth03 = ozmixm_index_table( PARAM_mth03 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth03 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth03 ) = ''
   ozmixm_desc_table( idomain, P_mth03 ) = '-'
   ozmixm_units_table( idomain, P_mth03 ) = '-'
   ozmixm_streams_table( idomain, P_mth03 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth03 )%stream(2) = 0 
   F_mth03 = .TRUE.
   IF ( ozmixm_index_table( PARAM_mth04 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth04 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth04 , idomain ) = P_mth04
   ELSE
     P_mth04 = ozmixm_index_table( PARAM_mth04 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth04 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth04 ) = ''
   ozmixm_desc_table( idomain, P_mth04 ) = '-'
   ozmixm_units_table( idomain, P_mth04 ) = '-'
   ozmixm_streams_table( idomain, P_mth04 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth04 )%stream(2) = 0 
   F_mth04 = .TRUE.
   IF ( ozmixm_index_table( PARAM_mth05 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth05 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth05 , idomain ) = P_mth05
   ELSE
     P_mth05 = ozmixm_index_table( PARAM_mth05 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth05 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth05 ) = ''
   ozmixm_desc_table( idomain, P_mth05 ) = '-'
   ozmixm_units_table( idomain, P_mth05 ) = '-'
   ozmixm_streams_table( idomain, P_mth05 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth05 )%stream(2) = 0 
   F_mth05 = .TRUE.
   IF ( ozmixm_index_table( PARAM_mth06 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth06 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth06 , idomain ) = P_mth06
   ELSE
     P_mth06 = ozmixm_index_table( PARAM_mth06 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth06 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth06 ) = ''
   ozmixm_desc_table( idomain, P_mth06 ) = '-'
   ozmixm_units_table( idomain, P_mth06 ) = '-'
   ozmixm_streams_table( idomain, P_mth06 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth06 )%stream(2) = 0 
   F_mth06 = .TRUE.
   IF ( ozmixm_index_table( PARAM_mth07 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth07 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth07 , idomain ) = P_mth07
   ELSE
     P_mth07 = ozmixm_index_table( PARAM_mth07 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth07 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth07 ) = ''
   ozmixm_desc_table( idomain, P_mth07 ) = '-'
   ozmixm_units_table( idomain, P_mth07 ) = '-'
   ozmixm_streams_table( idomain, P_mth07 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth07 )%stream(2) = 0 
   F_mth07 = .TRUE.
   IF ( ozmixm_index_table( PARAM_mth08 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth08 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth08 , idomain ) = P_mth08
   ELSE
     P_mth08 = ozmixm_index_table( PARAM_mth08 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth08 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth08 ) = ''
   ozmixm_desc_table( idomain, P_mth08 ) = '-'
   ozmixm_units_table( idomain, P_mth08 ) = '-'
   ozmixm_streams_table( idomain, P_mth08 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth08 )%stream(2) = 0 
   F_mth08 = .TRUE.
   IF ( ozmixm_index_table( PARAM_mth09 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth09 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth09 , idomain ) = P_mth09
   ELSE
     P_mth09 = ozmixm_index_table( PARAM_mth09 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth09 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth09 ) = ''
   ozmixm_desc_table( idomain, P_mth09 ) = '-'
   ozmixm_units_table( idomain, P_mth09 ) = '-'
   ozmixm_streams_table( idomain, P_mth09 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth09 )%stream(2) = 0 
   F_mth09 = .TRUE.
   IF ( ozmixm_index_table( PARAM_mth10 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth10 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth10 , idomain ) = P_mth10
   ELSE
     P_mth10 = ozmixm_index_table( PARAM_mth10 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth10 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth10 ) = ''
   ozmixm_desc_table( idomain, P_mth10 ) = '-'
   ozmixm_units_table( idomain, P_mth10 ) = '-'
   ozmixm_streams_table( idomain, P_mth10 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth10 )%stream(2) = 0 
   F_mth10 = .TRUE.
   IF ( ozmixm_index_table( PARAM_mth11 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth11 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth11 , idomain ) = P_mth11
   ELSE
     P_mth11 = ozmixm_index_table( PARAM_mth11 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth11 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth11 ) = ''
   ozmixm_desc_table( idomain, P_mth11 ) = '-'
   ozmixm_units_table( idomain, P_mth11 ) = '-'
   ozmixm_streams_table( idomain, P_mth11 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth11 )%stream(2) = 0 
   F_mth11 = .TRUE.
   IF ( ozmixm_index_table( PARAM_mth12 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth12 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth12 , idomain ) = P_mth12
   ELSE
     P_mth12 = ozmixm_index_table( PARAM_mth12 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth12 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth12 ) = ''
   ozmixm_desc_table( idomain, P_mth12 ) = '-'
   ozmixm_units_table( idomain, P_mth12 ) = '-'
   ozmixm_streams_table( idomain, P_mth12 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth12 )%stream(2) = 0 
   F_mth12 = .TRUE.
   IF ( aerod_index_table( PARAM_ocarbon , idomain ) .lt. 1 ) THEN
     aerod_num_table(idomain) = aerod_num_table(idomain) + 1
     P_ocarbon = aerod_num_table(idomain)
     aerod_index_table( PARAM_ocarbon , idomain ) = P_ocarbon
   ELSE
     P_ocarbon = aerod_index_table( PARAM_ocarbon , idomain )
   END IF
   aerod_boundary_table( idomain, P_ocarbon ) = .FALSE.
   aerod_dname_table( idomain, P_ocarbon ) = 'ocarbon'
   aerod_desc_table( idomain, P_ocarbon ) = 'organic carbon'
   aerod_units_table( idomain, P_ocarbon ) = '-'
   aerod_streams_table( idomain, P_ocarbon )%stream(1) = 0 
   aerod_streams_table( idomain, P_ocarbon )%stream(2) = 0 
   F_ocarbon = .TRUE.
   IF ( aerod_index_table( PARAM_seasalt , idomain ) .lt. 1 ) THEN
     aerod_num_table(idomain) = aerod_num_table(idomain) + 1
     P_seasalt = aerod_num_table(idomain)
     aerod_index_table( PARAM_seasalt , idomain ) = P_seasalt
   ELSE
     P_seasalt = aerod_index_table( PARAM_seasalt , idomain )
   END IF
   aerod_boundary_table( idomain, P_seasalt ) = .FALSE.
   aerod_dname_table( idomain, P_seasalt ) = 'seasalt'
   aerod_desc_table( idomain, P_seasalt ) = 'sea salt'
   aerod_units_table( idomain, P_seasalt ) = '-'
   aerod_streams_table( idomain, P_seasalt )%stream(1) = 0 
   aerod_streams_table( idomain, P_seasalt )%stream(2) = 0 
   F_seasalt = .TRUE.
   IF ( aerod_index_table( PARAM_dust , idomain ) .lt. 1 ) THEN
     aerod_num_table(idomain) = aerod_num_table(idomain) + 1
     P_dust = aerod_num_table(idomain)
     aerod_index_table( PARAM_dust , idomain ) = P_dust
   ELSE
     P_dust = aerod_index_table( PARAM_dust , idomain )
   END IF
   aerod_boundary_table( idomain, P_dust ) = .FALSE.
   aerod_dname_table( idomain, P_dust ) = 'dust'
   aerod_desc_table( idomain, P_dust ) = 'dust'
   aerod_units_table( idomain, P_dust ) = '-'
   aerod_streams_table( idomain, P_dust )%stream(1) = 0 
   aerod_streams_table( idomain, P_dust )%stream(2) = 0 
   F_dust = .TRUE.
   IF ( aerod_index_table( PARAM_bcarbon , idomain ) .lt. 1 ) THEN
     aerod_num_table(idomain) = aerod_num_table(idomain) + 1
     P_bcarbon = aerod_num_table(idomain)
     aerod_index_table( PARAM_bcarbon , idomain ) = P_bcarbon
   ELSE
     P_bcarbon = aerod_index_table( PARAM_bcarbon , idomain )
   END IF
   aerod_boundary_table( idomain, P_bcarbon ) = .FALSE.
   aerod_dname_table( idomain, P_bcarbon ) = 'bcarbon'
   aerod_desc_table( idomain, P_bcarbon ) = 'black carbon'
   aerod_units_table( idomain, P_bcarbon ) = '-'
   aerod_streams_table( idomain, P_bcarbon )%stream(1) = 0 
   aerod_streams_table( idomain, P_bcarbon )%stream(2) = 0 
   F_bcarbon = .TRUE.
   IF ( aerod_index_table( PARAM_sulfate , idomain ) .lt. 1 ) THEN
     aerod_num_table(idomain) = aerod_num_table(idomain) + 1
     P_sulfate = aerod_num_table(idomain)
     aerod_index_table( PARAM_sulfate , idomain ) = P_sulfate
   ELSE
     P_sulfate = aerod_index_table( PARAM_sulfate , idomain )
   END IF
   aerod_boundary_table( idomain, P_sulfate ) = .FALSE.
   aerod_dname_table( idomain, P_sulfate ) = 'sulfate'
   aerod_desc_table( idomain, P_sulfate ) = 'sulfate'
   aerod_units_table( idomain, P_sulfate ) = '-'
   aerod_streams_table( idomain, P_sulfate )%stream(1) = 0 
   aerod_streams_table( idomain, P_sulfate )%stream(2) = 0 
   F_sulfate = .TRUE.
   IF ( aerod_index_table( PARAM_upperaer , idomain ) .lt. 1 ) THEN
     aerod_num_table(idomain) = aerod_num_table(idomain) + 1
     P_upperaer = aerod_num_table(idomain)
     aerod_index_table( PARAM_upperaer , idomain ) = P_upperaer
   ELSE
     P_upperaer = aerod_index_table( PARAM_upperaer , idomain )
   END IF
   aerod_boundary_table( idomain, P_upperaer ) = .FALSE.
   aerod_dname_table( idomain, P_upperaer ) = 'upperaer'
   aerod_desc_table( idomain, P_upperaer ) = 'volcanic ash'
   aerod_units_table( idomain, P_upperaer ) = '-'
   aerod_streams_table( idomain, P_upperaer )%stream(1) = 0 
   aerod_streams_table( idomain, P_upperaer )%stream(2) = 0 
   F_upperaer = .TRUE.
  END IF
  IF (model_config_rec%ra_sw_physics(idomain)==14)THEN
   IF ( ozmixm_index_table( PARAM_mth01 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth01 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth01 , idomain ) = P_mth01
   ELSE
     P_mth01 = ozmixm_index_table( PARAM_mth01 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth01 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth01 ) = ''
   ozmixm_desc_table( idomain, P_mth01 ) = '-'
   ozmixm_units_table( idomain, P_mth01 ) = '-'
   ozmixm_streams_table( idomain, P_mth01 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth01 )%stream(2) = 0 
   F_mth01 = .TRUE.
   IF ( ozmixm_index_table( PARAM_mth02 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth02 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth02 , idomain ) = P_mth02
   ELSE
     P_mth02 = ozmixm_index_table( PARAM_mth02 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth02 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth02 ) = ''
   ozmixm_desc_table( idomain, P_mth02 ) = '-'
   ozmixm_units_table( idomain, P_mth02 ) = '-'
   ozmixm_streams_table( idomain, P_mth02 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth02 )%stream(2) = 0 
   F_mth02 = .TRUE.
   IF ( ozmixm_index_table( PARAM_mth03 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth03 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth03 , idomain ) = P_mth03
   ELSE
     P_mth03 = ozmixm_index_table( PARAM_mth03 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth03 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth03 ) = ''
   ozmixm_desc_table( idomain, P_mth03 ) = '-'
   ozmixm_units_table( idomain, P_mth03 ) = '-'
   ozmixm_streams_table( idomain, P_mth03 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth03 )%stream(2) = 0 
   F_mth03 = .TRUE.
   IF ( ozmixm_index_table( PARAM_mth04 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth04 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth04 , idomain ) = P_mth04
   ELSE
     P_mth04 = ozmixm_index_table( PARAM_mth04 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth04 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth04 ) = ''
   ozmixm_desc_table( idomain, P_mth04 ) = '-'
   ozmixm_units_table( idomain, P_mth04 ) = '-'
   ozmixm_streams_table( idomain, P_mth04 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth04 )%stream(2) = 0 
   F_mth04 = .TRUE.
   IF ( ozmixm_index_table( PARAM_mth05 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth05 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth05 , idomain ) = P_mth05
   ELSE
     P_mth05 = ozmixm_index_table( PARAM_mth05 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth05 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth05 ) = ''
   ozmixm_desc_table( idomain, P_mth05 ) = '-'
   ozmixm_units_table( idomain, P_mth05 ) = '-'
   ozmixm_streams_table( idomain, P_mth05 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth05 )%stream(2) = 0 
   F_mth05 = .TRUE.
   IF ( ozmixm_index_table( PARAM_mth06 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth06 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth06 , idomain ) = P_mth06
   ELSE
     P_mth06 = ozmixm_index_table( PARAM_mth06 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth06 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth06 ) = ''
   ozmixm_desc_table( idomain, P_mth06 ) = '-'
   ozmixm_units_table( idomain, P_mth06 ) = '-'
   ozmixm_streams_table( idomain, P_mth06 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth06 )%stream(2) = 0 
   F_mth06 = .TRUE.
   IF ( ozmixm_index_table( PARAM_mth07 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth07 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth07 , idomain ) = P_mth07
   ELSE
     P_mth07 = ozmixm_index_table( PARAM_mth07 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth07 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth07 ) = ''
   ozmixm_desc_table( idomain, P_mth07 ) = '-'
   ozmixm_units_table( idomain, P_mth07 ) = '-'
   ozmixm_streams_table( idomain, P_mth07 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth07 )%stream(2) = 0 
   F_mth07 = .TRUE.
   IF ( ozmixm_index_table( PARAM_mth08 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth08 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth08 , idomain ) = P_mth08
   ELSE
     P_mth08 = ozmixm_index_table( PARAM_mth08 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth08 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth08 ) = ''
   ozmixm_desc_table( idomain, P_mth08 ) = '-'
   ozmixm_units_table( idomain, P_mth08 ) = '-'
   ozmixm_streams_table( idomain, P_mth08 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth08 )%stream(2) = 0 
   F_mth08 = .TRUE.
   IF ( ozmixm_index_table( PARAM_mth09 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth09 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth09 , idomain ) = P_mth09
   ELSE
     P_mth09 = ozmixm_index_table( PARAM_mth09 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth09 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth09 ) = ''
   ozmixm_desc_table( idomain, P_mth09 ) = '-'
   ozmixm_units_table( idomain, P_mth09 ) = '-'
   ozmixm_streams_table( idomain, P_mth09 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth09 )%stream(2) = 0 
   F_mth09 = .TRUE.
   IF ( ozmixm_index_table( PARAM_mth10 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth10 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth10 , idomain ) = P_mth10
   ELSE
     P_mth10 = ozmixm_index_table( PARAM_mth10 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth10 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth10 ) = ''
   ozmixm_desc_table( idomain, P_mth10 ) = '-'
   ozmixm_units_table( idomain, P_mth10 ) = '-'
   ozmixm_streams_table( idomain, P_mth10 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth10 )%stream(2) = 0 
   F_mth10 = .TRUE.
   IF ( ozmixm_index_table( PARAM_mth11 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth11 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth11 , idomain ) = P_mth11
   ELSE
     P_mth11 = ozmixm_index_table( PARAM_mth11 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth11 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth11 ) = ''
   ozmixm_desc_table( idomain, P_mth11 ) = '-'
   ozmixm_units_table( idomain, P_mth11 ) = '-'
   ozmixm_streams_table( idomain, P_mth11 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth11 )%stream(2) = 0 
   F_mth11 = .TRUE.
   IF ( ozmixm_index_table( PARAM_mth12 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth12 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth12 , idomain ) = P_mth12
   ELSE
     P_mth12 = ozmixm_index_table( PARAM_mth12 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth12 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth12 ) = ''
   ozmixm_desc_table( idomain, P_mth12 ) = '-'
   ozmixm_units_table( idomain, P_mth12 ) = '-'
   ozmixm_streams_table( idomain, P_mth12 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth12 )%stream(2) = 0 
   F_mth12 = .TRUE.
   IF ( aerod_index_table( PARAM_ocarbon , idomain ) .lt. 1 ) THEN
     aerod_num_table(idomain) = aerod_num_table(idomain) + 1
     P_ocarbon = aerod_num_table(idomain)
     aerod_index_table( PARAM_ocarbon , idomain ) = P_ocarbon
   ELSE
     P_ocarbon = aerod_index_table( PARAM_ocarbon , idomain )
   END IF
   aerod_boundary_table( idomain, P_ocarbon ) = .FALSE.
   aerod_dname_table( idomain, P_ocarbon ) = 'ocarbon'
   aerod_desc_table( idomain, P_ocarbon ) = 'organic carbon'
   aerod_units_table( idomain, P_ocarbon ) = '-'
   aerod_streams_table( idomain, P_ocarbon )%stream(1) = 0 
   aerod_streams_table( idomain, P_ocarbon )%stream(2) = 0 
   F_ocarbon = .TRUE.
   IF ( aerod_index_table( PARAM_seasalt , idomain ) .lt. 1 ) THEN
     aerod_num_table(idomain) = aerod_num_table(idomain) + 1
     P_seasalt = aerod_num_table(idomain)
     aerod_index_table( PARAM_seasalt , idomain ) = P_seasalt
   ELSE
     P_seasalt = aerod_index_table( PARAM_seasalt , idomain )
   END IF
   aerod_boundary_table( idomain, P_seasalt ) = .FALSE.
   aerod_dname_table( idomain, P_seasalt ) = 'seasalt'
   aerod_desc_table( idomain, P_seasalt ) = 'sea salt'
   aerod_units_table( idomain, P_seasalt ) = '-'
   aerod_streams_table( idomain, P_seasalt )%stream(1) = 0 
   aerod_streams_table( idomain, P_seasalt )%stream(2) = 0 
   F_seasalt = .TRUE.
   IF ( aerod_index_table( PARAM_dust , idomain ) .lt. 1 ) THEN
     aerod_num_table(idomain) = aerod_num_table(idomain) + 1
     P_dust = aerod_num_table(idomain)
     aerod_index_table( PARAM_dust , idomain ) = P_dust
   ELSE
     P_dust = aerod_index_table( PARAM_dust , idomain )
   END IF
   aerod_boundary_table( idomain, P_dust ) = .FALSE.
   aerod_dname_table( idomain, P_dust ) = 'dust'
   aerod_desc_table( idomain, P_dust ) = 'dust'
   aerod_units_table( idomain, P_dust ) = '-'
   aerod_streams_table( idomain, P_dust )%stream(1) = 0 
   aerod_streams_table( idomain, P_dust )%stream(2) = 0 
   F_dust = .TRUE.
   IF ( aerod_index_table( PARAM_bcarbon , idomain ) .lt. 1 ) THEN
     aerod_num_table(idomain) = aerod_num_table(idomain) + 1
     P_bcarbon = aerod_num_table(idomain)
     aerod_index_table( PARAM_bcarbon , idomain ) = P_bcarbon
   ELSE
     P_bcarbon = aerod_index_table( PARAM_bcarbon , idomain )
   END IF
   aerod_boundary_table( idomain, P_bcarbon ) = .FALSE.
   aerod_dname_table( idomain, P_bcarbon ) = 'bcarbon'
   aerod_desc_table( idomain, P_bcarbon ) = 'black carbon'
   aerod_units_table( idomain, P_bcarbon ) = '-'
   aerod_streams_table( idomain, P_bcarbon )%stream(1) = 0 
   aerod_streams_table( idomain, P_bcarbon )%stream(2) = 0 
   F_bcarbon = .TRUE.
   IF ( aerod_index_table( PARAM_sulfate , idomain ) .lt. 1 ) THEN
     aerod_num_table(idomain) = aerod_num_table(idomain) + 1
     P_sulfate = aerod_num_table(idomain)
     aerod_index_table( PARAM_sulfate , idomain ) = P_sulfate
   ELSE
     P_sulfate = aerod_index_table( PARAM_sulfate , idomain )
   END IF
   aerod_boundary_table( idomain, P_sulfate ) = .FALSE.
   aerod_dname_table( idomain, P_sulfate ) = 'sulfate'
   aerod_desc_table( idomain, P_sulfate ) = 'sulfate'
   aerod_units_table( idomain, P_sulfate ) = '-'
   aerod_streams_table( idomain, P_sulfate )%stream(1) = 0 
   aerod_streams_table( idomain, P_sulfate )%stream(2) = 0 
   F_sulfate = .TRUE.
   IF ( aerod_index_table( PARAM_upperaer , idomain ) .lt. 1 ) THEN
     aerod_num_table(idomain) = aerod_num_table(idomain) + 1
     P_upperaer = aerod_num_table(idomain)
     aerod_index_table( PARAM_upperaer , idomain ) = P_upperaer
   ELSE
     P_upperaer = aerod_index_table( PARAM_upperaer , idomain )
   END IF
   aerod_boundary_table( idomain, P_upperaer ) = .FALSE.
   aerod_dname_table( idomain, P_upperaer ) = 'upperaer'
   aerod_desc_table( idomain, P_upperaer ) = 'volcanic ash'
   aerod_units_table( idomain, P_upperaer ) = '-'
   aerod_streams_table( idomain, P_upperaer )%stream(1) = 0 
   aerod_streams_table( idomain, P_upperaer )%stream(2) = 0 
   F_upperaer = .TRUE.
  END IF
  IF (model_config_rec%ra_sw_physics(idomain)==24)THEN
   IF ( ozmixm_index_table( PARAM_mth01 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth01 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth01 , idomain ) = P_mth01
   ELSE
     P_mth01 = ozmixm_index_table( PARAM_mth01 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth01 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth01 ) = ''
   ozmixm_desc_table( idomain, P_mth01 ) = '-'
   ozmixm_units_table( idomain, P_mth01 ) = '-'
   ozmixm_streams_table( idomain, P_mth01 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth01 )%stream(2) = 0 
   F_mth01 = .TRUE.
   IF ( ozmixm_index_table( PARAM_mth02 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth02 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth02 , idomain ) = P_mth02
   ELSE
     P_mth02 = ozmixm_index_table( PARAM_mth02 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth02 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth02 ) = ''
   ozmixm_desc_table( idomain, P_mth02 ) = '-'
   ozmixm_units_table( idomain, P_mth02 ) = '-'
   ozmixm_streams_table( idomain, P_mth02 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth02 )%stream(2) = 0 
   F_mth02 = .TRUE.
   IF ( ozmixm_index_table( PARAM_mth03 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth03 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth03 , idomain ) = P_mth03
   ELSE
     P_mth03 = ozmixm_index_table( PARAM_mth03 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth03 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth03 ) = ''
   ozmixm_desc_table( idomain, P_mth03 ) = '-'
   ozmixm_units_table( idomain, P_mth03 ) = '-'
   ozmixm_streams_table( idomain, P_mth03 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth03 )%stream(2) = 0 
   F_mth03 = .TRUE.
   IF ( ozmixm_index_table( PARAM_mth04 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth04 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth04 , idomain ) = P_mth04
   ELSE
     P_mth04 = ozmixm_index_table( PARAM_mth04 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth04 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth04 ) = ''
   ozmixm_desc_table( idomain, P_mth04 ) = '-'
   ozmixm_units_table( idomain, P_mth04 ) = '-'
   ozmixm_streams_table( idomain, P_mth04 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth04 )%stream(2) = 0 
   F_mth04 = .TRUE.
   IF ( ozmixm_index_table( PARAM_mth05 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth05 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth05 , idomain ) = P_mth05
   ELSE
     P_mth05 = ozmixm_index_table( PARAM_mth05 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth05 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth05 ) = ''
   ozmixm_desc_table( idomain, P_mth05 ) = '-'
   ozmixm_units_table( idomain, P_mth05 ) = '-'
   ozmixm_streams_table( idomain, P_mth05 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth05 )%stream(2) = 0 
   F_mth05 = .TRUE.
   IF ( ozmixm_index_table( PARAM_mth06 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth06 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth06 , idomain ) = P_mth06
   ELSE
     P_mth06 = ozmixm_index_table( PARAM_mth06 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth06 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth06 ) = ''
   ozmixm_desc_table( idomain, P_mth06 ) = '-'
   ozmixm_units_table( idomain, P_mth06 ) = '-'
   ozmixm_streams_table( idomain, P_mth06 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth06 )%stream(2) = 0 
   F_mth06 = .TRUE.
   IF ( ozmixm_index_table( PARAM_mth07 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth07 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth07 , idomain ) = P_mth07
   ELSE
     P_mth07 = ozmixm_index_table( PARAM_mth07 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth07 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth07 ) = ''
   ozmixm_desc_table( idomain, P_mth07 ) = '-'
   ozmixm_units_table( idomain, P_mth07 ) = '-'
   ozmixm_streams_table( idomain, P_mth07 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth07 )%stream(2) = 0 
   F_mth07 = .TRUE.
   IF ( ozmixm_index_table( PARAM_mth08 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth08 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth08 , idomain ) = P_mth08
   ELSE
     P_mth08 = ozmixm_index_table( PARAM_mth08 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth08 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth08 ) = ''
   ozmixm_desc_table( idomain, P_mth08 ) = '-'
   ozmixm_units_table( idomain, P_mth08 ) = '-'
   ozmixm_streams_table( idomain, P_mth08 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth08 )%stream(2) = 0 
   F_mth08 = .TRUE.
   IF ( ozmixm_index_table( PARAM_mth09 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth09 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth09 , idomain ) = P_mth09
   ELSE
     P_mth09 = ozmixm_index_table( PARAM_mth09 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth09 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth09 ) = ''
   ozmixm_desc_table( idomain, P_mth09 ) = '-'
   ozmixm_units_table( idomain, P_mth09 ) = '-'
   ozmixm_streams_table( idomain, P_mth09 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth09 )%stream(2) = 0 
   F_mth09 = .TRUE.
   IF ( ozmixm_index_table( PARAM_mth10 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth10 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth10 , idomain ) = P_mth10
   ELSE
     P_mth10 = ozmixm_index_table( PARAM_mth10 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth10 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth10 ) = ''
   ozmixm_desc_table( idomain, P_mth10 ) = '-'
   ozmixm_units_table( idomain, P_mth10 ) = '-'
   ozmixm_streams_table( idomain, P_mth10 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth10 )%stream(2) = 0 
   F_mth10 = .TRUE.
   IF ( ozmixm_index_table( PARAM_mth11 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth11 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth11 , idomain ) = P_mth11
   ELSE
     P_mth11 = ozmixm_index_table( PARAM_mth11 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth11 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth11 ) = ''
   ozmixm_desc_table( idomain, P_mth11 ) = '-'
   ozmixm_units_table( idomain, P_mth11 ) = '-'
   ozmixm_streams_table( idomain, P_mth11 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth11 )%stream(2) = 0 
   F_mth11 = .TRUE.
   IF ( ozmixm_index_table( PARAM_mth12 , idomain ) .lt. 1 ) THEN
     ozmixm_num_table(idomain) = ozmixm_num_table(idomain) + 1
     P_mth12 = ozmixm_num_table(idomain)
     ozmixm_index_table( PARAM_mth12 , idomain ) = P_mth12
   ELSE
     P_mth12 = ozmixm_index_table( PARAM_mth12 , idomain )
   END IF
   ozmixm_boundary_table( idomain, P_mth12 ) = .FALSE.
   ozmixm_dname_table( idomain, P_mth12 ) = ''
   ozmixm_desc_table( idomain, P_mth12 ) = '-'
   ozmixm_units_table( idomain, P_mth12 ) = '-'
   ozmixm_streams_table( idomain, P_mth12 )%stream(1) = 0 
   ozmixm_streams_table( idomain, P_mth12 )%stream(2) = 0 
   F_mth12 = .TRUE.
   IF ( aerod_index_table( PARAM_ocarbon , idomain ) .lt. 1 ) THEN
     aerod_num_table(idomain) = aerod_num_table(idomain) + 1
     P_ocarbon = aerod_num_table(idomain)
     aerod_index_table( PARAM_ocarbon , idomain ) = P_ocarbon
   ELSE
     P_ocarbon = aerod_index_table( PARAM_ocarbon , idomain )
   END IF
   aerod_boundary_table( idomain, P_ocarbon ) = .FALSE.
   aerod_dname_table( idomain, P_ocarbon ) = 'ocarbon'
   aerod_desc_table( idomain, P_ocarbon ) = 'organic carbon'
   aerod_units_table( idomain, P_ocarbon ) = '-'
   aerod_streams_table( idomain, P_ocarbon )%stream(1) = 0 
   aerod_streams_table( idomain, P_ocarbon )%stream(2) = 0 
   F_ocarbon = .TRUE.
   IF ( aerod_index_table( PARAM_seasalt , idomain ) .lt. 1 ) THEN
     aerod_num_table(idomain) = aerod_num_table(idomain) + 1
     P_seasalt = aerod_num_table(idomain)
     aerod_index_table( PARAM_seasalt , idomain ) = P_seasalt
   ELSE
     P_seasalt = aerod_index_table( PARAM_seasalt , idomain )
   END IF
   aerod_boundary_table( idomain, P_seasalt ) = .FALSE.
   aerod_dname_table( idomain, P_seasalt ) = 'seasalt'
   aerod_desc_table( idomain, P_seasalt ) = 'sea salt'
   aerod_units_table( idomain, P_seasalt ) = '-'
   aerod_streams_table( idomain, P_seasalt )%stream(1) = 0 
   aerod_streams_table( idomain, P_seasalt )%stream(2) = 0 
   F_seasalt = .TRUE.
   IF ( aerod_index_table( PARAM_dust , idomain ) .lt. 1 ) THEN
     aerod_num_table(idomain) = aerod_num_table(idomain) + 1
     P_dust = aerod_num_table(idomain)
     aerod_index_table( PARAM_dust , idomain ) = P_dust
   ELSE
     P_dust = aerod_index_table( PARAM_dust , idomain )
   END IF
   aerod_boundary_table( idomain, P_dust ) = .FALSE.
   aerod_dname_table( idomain, P_dust ) = 'dust'
   aerod_desc_table( idomain, P_dust ) = 'dust'
   aerod_units_table( idomain, P_dust ) = '-'
   aerod_streams_table( idomain, P_dust )%stream(1) = 0 
   aerod_streams_table( idomain, P_dust )%stream(2) = 0 
   F_dust = .TRUE.
   IF ( aerod_index_table( PARAM_bcarbon , idomain ) .lt. 1 ) THEN
     aerod_num_table(idomain) = aerod_num_table(idomain) + 1
     P_bcarbon = aerod_num_table(idomain)
     aerod_index_table( PARAM_bcarbon , idomain ) = P_bcarbon
   ELSE
     P_bcarbon = aerod_index_table( PARAM_bcarbon , idomain )
   END IF
   aerod_boundary_table( idomain, P_bcarbon ) = .FALSE.
   aerod_dname_table( idomain, P_bcarbon ) = 'bcarbon'
   aerod_desc_table( idomain, P_bcarbon ) = 'black carbon'
   aerod_units_table( idomain, P_bcarbon ) = '-'
   aerod_streams_table( idomain, P_bcarbon )%stream(1) = 0 
   aerod_streams_table( idomain, P_bcarbon )%stream(2) = 0 
   F_bcarbon = .TRUE.
   IF ( aerod_index_table( PARAM_sulfate , idomain ) .lt. 1 ) THEN
     aerod_num_table(idomain) = aerod_num_table(idomain) + 1
     P_sulfate = aerod_num_table(idomain)
     aerod_index_table( PARAM_sulfate , idomain ) = P_sulfate
   ELSE
     P_sulfate = aerod_index_table( PARAM_sulfate , idomain )
   END IF
   aerod_boundary_table( idomain, P_sulfate ) = .FALSE.
   aerod_dname_table( idomain, P_sulfate ) = 'sulfate'
   aerod_desc_table( idomain, P_sulfate ) = 'sulfate'
   aerod_units_table( idomain, P_sulfate ) = '-'
   aerod_streams_table( idomain, P_sulfate )%stream(1) = 0 
   aerod_streams_table( idomain, P_sulfate )%stream(2) = 0 
   F_sulfate = .TRUE.
   IF ( aerod_index_table( PARAM_upperaer , idomain ) .lt. 1 ) THEN
     aerod_num_table(idomain) = aerod_num_table(idomain) + 1
     P_upperaer = aerod_num_table(idomain)
     aerod_index_table( PARAM_upperaer , idomain ) = P_upperaer
   ELSE
     P_upperaer = aerod_index_table( PARAM_upperaer , idomain )
   END IF
   aerod_boundary_table( idomain, P_upperaer ) = .FALSE.
   aerod_dname_table( idomain, P_upperaer ) = 'upperaer'
   aerod_desc_table( idomain, P_upperaer ) = 'volcanic ash'
   aerod_units_table( idomain, P_upperaer ) = '-'
   aerod_streams_table( idomain, P_upperaer )%stream(1) = 0 
   aerod_streams_table( idomain, P_upperaer )%stream(2) = 0 
   F_upperaer = .TRUE.
  END IF
  IF (model_config_rec%ra_sw_physics(idomain)==5)THEN
  END IF
  IF (model_config_rec%ra_sw_physics(idomain)==7)THEN
  END IF
  IF (model_config_rec%ra_sw_physics(idomain)==99)THEN
  END IF
  IF (model_config_rec%sf_sfclay_physics(idomain)==1)THEN
  END IF
  IF (model_config_rec%sf_sfclay_physics(idomain)==2)THEN
  END IF
  IF (model_config_rec%sf_sfclay_physics(idomain)==3)THEN
  END IF
  IF (model_config_rec%sf_sfclay_physics(idomain)==4)THEN
  END IF
  IF (model_config_rec%sf_sfclay_physics(idomain)==5)THEN
  END IF
  IF (model_config_rec%sf_sfclay_physics(idomain)==7)THEN
  END IF
  IF (model_config_rec%sf_sfclay_physics(idomain)==10)THEN
  END IF
  IF (model_config_rec%sf_sfclay_physics(idomain)==89)THEN
  END IF
  IF (model_config_rec%sf_sfclay_physics(idomain)==91)THEN
  END IF
  IF (model_config_rec%sf_urban_physics(idomain)==1)THEN
  END IF
  IF (model_config_rec%sf_urban_physics(idomain)==2)THEN
  END IF
  IF (model_config_rec%sf_urban_physics(idomain)==3)THEN
  END IF
  IF (model_config_rec%sf_surface_physics(idomain)==0)THEN
  END IF
  IF (model_config_rec%sf_surface_physics(idomain)==1)THEN
  END IF
  IF (model_config_rec%sf_surface_physics(idomain)==2)THEN
  END IF
  IF (model_config_rec%sf_surface_physics(idomain)==3)THEN
  END IF
  IF (model_config_rec%sf_surface_physics(idomain)==4)THEN
  END IF
  IF (model_config_rec%sf_surface_physics(idomain)==5)THEN
  END IF
  IF (model_config_rec%sf_surface_physics(idomain)==7)THEN
  END IF
  IF (model_config_rec%sf_surface_physics(idomain)==8)THEN
  END IF
  IF (model_config_rec%opt_crop==2)THEN
  END IF
  IF (model_config_rec%sf_surface_mosaic==1)THEN
  END IF
  IF (model_config_rec%bl_pbl_physics(idomain)==1)THEN
  END IF
  IF (model_config_rec%bl_pbl_physics(idomain)==2)THEN
  END IF
  IF (model_config_rec%bl_pbl_physics(idomain)==3)THEN
  END IF
  IF (model_config_rec%bl_pbl_physics(idomain)==4)THEN
  END IF
  IF (model_config_rec%bl_pbl_physics(idomain)==5)THEN
   IF ( scalar_index_table( PARAM_qke_adv , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qke_adv = scalar_num_table(idomain)
     scalar_index_table( PARAM_qke_adv , idomain ) = P_qke_adv
   ELSE
     P_qke_adv = scalar_index_table( PARAM_qke_adv , idomain )
   END IF
   scalar_boundary_table( idomain, P_qke_adv ) = .TRUE.
   scalar_dname_table( idomain, P_qke_adv ) = 'qke_adv'
   scalar_desc_table( idomain, P_qke_adv ) = 'twice TKE from MYNN'
   scalar_units_table( idomain, P_qke_adv ) = 'm2 s-2'
   scalar_streams_table( idomain, P_qke_adv )%stream(1) = 33554432 
   scalar_streams_table( idomain, P_qke_adv )%stream(2) = 2097152 
   F_qke_adv = .TRUE.
  END IF
  IF (model_config_rec%bl_pbl_physics(idomain)==6)THEN
   IF ( scalar_index_table( PARAM_qke_adv , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qke_adv = scalar_num_table(idomain)
     scalar_index_table( PARAM_qke_adv , idomain ) = P_qke_adv
   ELSE
     P_qke_adv = scalar_index_table( PARAM_qke_adv , idomain )
   END IF
   scalar_boundary_table( idomain, P_qke_adv ) = .TRUE.
   scalar_dname_table( idomain, P_qke_adv ) = 'qke_adv'
   scalar_desc_table( idomain, P_qke_adv ) = 'twice TKE from MYNN'
   scalar_units_table( idomain, P_qke_adv ) = 'm2 s-2'
   scalar_streams_table( idomain, P_qke_adv )%stream(1) = 33554432 
   scalar_streams_table( idomain, P_qke_adv )%stream(2) = 2097152 
   F_qke_adv = .TRUE.
  END IF
  IF (model_config_rec%bl_pbl_physics(idomain)==7)THEN
  END IF
  IF (model_config_rec%bl_pbl_physics(idomain)==8)THEN
  END IF
  IF (model_config_rec%bl_pbl_physics(idomain)==9)THEN
  END IF
  IF (model_config_rec%bl_pbl_physics(idomain)==10)THEN
  END IF
  IF (model_config_rec%bl_pbl_physics(idomain)==11)THEN
  END IF
  IF (model_config_rec%bl_pbl_physics(idomain)==12)THEN
  END IF
  IF (model_config_rec%bl_pbl_physics(idomain)==99)THEN
  END IF
  IF (model_config_rec%bl_mynn_tkebudget(idomain)==1)THEN
  END IF
  IF (model_config_rec%bl_mynn_edmf(idomain)==1)THEN
  END IF
  IF (model_config_rec%icloud_bl==1)THEN
  END IF
  IF (model_config_rec%bl_pbl_physics_dfi(idomain)==5)THEN
   IF ( dfi_scalar_index_table( PARAM_dfi_qke_adv , idomain ) .lt. 1 ) THEN
     dfi_scalar_num_table(idomain) = dfi_scalar_num_table(idomain) + 1
     P_dfi_qke_adv = dfi_scalar_num_table(idomain)
     dfi_scalar_index_table( PARAM_dfi_qke_adv , idomain ) = P_dfi_qke_adv
   ELSE
     P_dfi_qke_adv = dfi_scalar_index_table( PARAM_dfi_qke_adv , idomain )
   END IF
   dfi_scalar_boundary_table( idomain, P_dfi_qke_adv ) = .TRUE.
   dfi_scalar_dname_table( idomain, P_dfi_qke_adv ) = 'dfi_qke_adv'
   dfi_scalar_desc_table( idomain, P_dfi_qke_adv ) = 'DFI twice TKE from MYNN'
   dfi_scalar_units_table( idomain, P_dfi_qke_adv ) = 'm2 s-2'
   dfi_scalar_streams_table( idomain, P_dfi_qke_adv )%stream(1) = 0 
   dfi_scalar_streams_table( idomain, P_dfi_qke_adv )%stream(2) = 2097152 
   F_dfi_qke_adv = .TRUE.
  END IF
  IF (model_config_rec%bl_pbl_physics_dfi(idomain)==6)THEN
   IF ( dfi_scalar_index_table( PARAM_dfi_qke_adv , idomain ) .lt. 1 ) THEN
     dfi_scalar_num_table(idomain) = dfi_scalar_num_table(idomain) + 1
     P_dfi_qke_adv = dfi_scalar_num_table(idomain)
     dfi_scalar_index_table( PARAM_dfi_qke_adv , idomain ) = P_dfi_qke_adv
   ELSE
     P_dfi_qke_adv = dfi_scalar_index_table( PARAM_dfi_qke_adv , idomain )
   END IF
   dfi_scalar_boundary_table( idomain, P_dfi_qke_adv ) = .TRUE.
   dfi_scalar_dname_table( idomain, P_dfi_qke_adv ) = 'dfi_qke_adv'
   dfi_scalar_desc_table( idomain, P_dfi_qke_adv ) = 'DFI twice TKE from MYNN'
   dfi_scalar_units_table( idomain, P_dfi_qke_adv ) = 'm2 s-2'
   dfi_scalar_streams_table( idomain, P_dfi_qke_adv )%stream(1) = 0 
   dfi_scalar_streams_table( idomain, P_dfi_qke_adv )%stream(2) = 2097152 
   F_dfi_qke_adv = .TRUE.
  END IF
  IF (model_config_rec%cu_physics(idomain)==0)THEN
  END IF
  IF (model_config_rec%cu_physics(idomain)==1)THEN
  END IF
  IF (model_config_rec%cu_physics(idomain)==2)THEN
  END IF
  IF (model_config_rec%cu_physics(idomain)==3)THEN
  END IF
  IF (model_config_rec%cu_physics(idomain)==4)THEN
  END IF
  IF (model_config_rec%cu_physics(idomain)==5)THEN
  END IF
  IF (model_config_rec%cu_physics(idomain)==6)THEN
  END IF
  IF (model_config_rec%cu_physics(idomain)==7)THEN
  END IF
  IF (model_config_rec%cu_physics(idomain)==10)THEN
  END IF
  IF (model_config_rec%cu_physics(idomain)==11)THEN
  END IF
  IF (model_config_rec%cu_physics(idomain)==14)THEN
  END IF
  IF (model_config_rec%cu_physics(idomain)==96)THEN
  END IF
  IF (model_config_rec%cu_physics(idomain)==16)THEN
  END IF
  IF (model_config_rec%cu_physics(idomain)==93)THEN
  END IF
  IF (model_config_rec%cu_physics(idomain)==94)THEN
  END IF
  IF (model_config_rec%cu_physics(idomain)==95)THEN
  END IF
  IF (model_config_rec%cu_physics(idomain)==99)THEN
  END IF
  IF (model_config_rec%cu_diag(idomain)==1)THEN
  END IF
  IF (model_config_rec%kf_edrates(idomain)==1)THEN
  END IF
  IF (model_config_rec%cu_used==0)THEN
  END IF
  IF (model_config_rec%cu_used==1)THEN
  END IF
  IF (model_config_rec%cam_used==0)THEN
  END IF
  IF (model_config_rec%cam_used==1)THEN
  END IF
  IF (model_config_rec%shcu_physics(idomain)==0)THEN
  END IF
  IF (model_config_rec%shcu_physics(idomain)==1)THEN
  END IF
  IF (model_config_rec%shcu_physics(idomain)==2)THEN
  END IF
  IF (model_config_rec%shcu_physics(idomain)==3)THEN
  END IF
  IF (model_config_rec%shcu_physics(idomain)==4)THEN
  END IF
  IF (model_config_rec%shcu_physics(idomain)==5)THEN
  END IF
  IF (model_config_rec%shcu_used==0)THEN
  END IF
  IF (model_config_rec%shcu_used==1)THEN
  END IF
  IF (model_config_rec%grav_settling(idomain)==0)THEN
  END IF
  IF (model_config_rec%grav_settling(idomain)==1)THEN
  END IF
  IF (model_config_rec%grav_settling(idomain)==2)THEN
  END IF
  IF (model_config_rec%grid_fdda(idomain)==1)THEN
   IF ( fdda3d_index_table( PARAM_u_ndg_old , idomain ) .lt. 1 ) THEN
     fdda3d_num_table(idomain) = fdda3d_num_table(idomain) + 1
     P_u_ndg_old = fdda3d_num_table(idomain)
     fdda3d_index_table( PARAM_u_ndg_old , idomain ) = P_u_ndg_old
   ELSE
     P_u_ndg_old = fdda3d_index_table( PARAM_u_ndg_old , idomain )
   END IF
   fdda3d_boundary_table( idomain, P_u_ndg_old ) = .FALSE.
   fdda3d_dname_table( idomain, P_u_ndg_old ) = 'U_NDG_OLD'
   fdda3d_desc_table( idomain, P_u_ndg_old ) = 'OLD X WIND FOR FDDA GRID NUDGING'
   fdda3d_units_table( idomain, P_u_ndg_old ) = 'm s-1'
   fdda3d_streams_table( idomain, P_u_ndg_old )%stream(1) = 0 
   fdda3d_streams_table( idomain, P_u_ndg_old )%stream(2) = 2097168 
   F_u_ndg_old = .TRUE.
   IF ( fdda3d_index_table( PARAM_v_ndg_old , idomain ) .lt. 1 ) THEN
     fdda3d_num_table(idomain) = fdda3d_num_table(idomain) + 1
     P_v_ndg_old = fdda3d_num_table(idomain)
     fdda3d_index_table( PARAM_v_ndg_old , idomain ) = P_v_ndg_old
   ELSE
     P_v_ndg_old = fdda3d_index_table( PARAM_v_ndg_old , idomain )
   END IF
   fdda3d_boundary_table( idomain, P_v_ndg_old ) = .FALSE.
   fdda3d_dname_table( idomain, P_v_ndg_old ) = 'V_NDG_OLD'
   fdda3d_desc_table( idomain, P_v_ndg_old ) = 'OLD Y WIND FOR FDDA GRID NUDGING'
   fdda3d_units_table( idomain, P_v_ndg_old ) = 'm s-1'
   fdda3d_streams_table( idomain, P_v_ndg_old )%stream(1) = 0 
   fdda3d_streams_table( idomain, P_v_ndg_old )%stream(2) = 2097168 
   F_v_ndg_old = .TRUE.
   IF ( fdda3d_index_table( PARAM_t_ndg_old , idomain ) .lt. 1 ) THEN
     fdda3d_num_table(idomain) = fdda3d_num_table(idomain) + 1
     P_t_ndg_old = fdda3d_num_table(idomain)
     fdda3d_index_table( PARAM_t_ndg_old , idomain ) = P_t_ndg_old
   ELSE
     P_t_ndg_old = fdda3d_index_table( PARAM_t_ndg_old , idomain )
   END IF
   fdda3d_boundary_table( idomain, P_t_ndg_old ) = .FALSE.
   fdda3d_dname_table( idomain, P_t_ndg_old ) = 'T_NDG_OLD'
   fdda3d_desc_table( idomain, P_t_ndg_old ) = 'OLD PERT POT TEMP FOR FDDA GRID NUDGING'
   fdda3d_units_table( idomain, P_t_ndg_old ) = 'K'
   fdda3d_streams_table( idomain, P_t_ndg_old )%stream(1) = 0 
   fdda3d_streams_table( idomain, P_t_ndg_old )%stream(2) = 2097168 
   F_t_ndg_old = .TRUE.
   IF ( fdda3d_index_table( PARAM_q_ndg_old , idomain ) .lt. 1 ) THEN
     fdda3d_num_table(idomain) = fdda3d_num_table(idomain) + 1
     P_q_ndg_old = fdda3d_num_table(idomain)
     fdda3d_index_table( PARAM_q_ndg_old , idomain ) = P_q_ndg_old
   ELSE
     P_q_ndg_old = fdda3d_index_table( PARAM_q_ndg_old , idomain )
   END IF
   fdda3d_boundary_table( idomain, P_q_ndg_old ) = .FALSE.
   fdda3d_dname_table( idomain, P_q_ndg_old ) = 'Q_NDG_OLD'
   fdda3d_desc_table( idomain, P_q_ndg_old ) = 'OLD WATER VAPOR MIX RATIO FOR FDDA GRID NUDGING'
   fdda3d_units_table( idomain, P_q_ndg_old ) = 'kg/kg'
   fdda3d_streams_table( idomain, P_q_ndg_old )%stream(1) = 0 
   fdda3d_streams_table( idomain, P_q_ndg_old )%stream(2) = 2097168 
   F_q_ndg_old = .TRUE.
   IF ( fdda3d_index_table( PARAM_ph_ndg_old , idomain ) .lt. 1 ) THEN
     fdda3d_num_table(idomain) = fdda3d_num_table(idomain) + 1
     P_ph_ndg_old = fdda3d_num_table(idomain)
     fdda3d_index_table( PARAM_ph_ndg_old , idomain ) = P_ph_ndg_old
   ELSE
     P_ph_ndg_old = fdda3d_index_table( PARAM_ph_ndg_old , idomain )
   END IF
   fdda3d_boundary_table( idomain, P_ph_ndg_old ) = .FALSE.
   fdda3d_dname_table( idomain, P_ph_ndg_old ) = 'PH_NDG_OLD'
   fdda3d_desc_table( idomain, P_ph_ndg_old ) = 'OLD PERT GEOPOTENTIAL FOR FDDA GRID NUDGING'
   fdda3d_units_table( idomain, P_ph_ndg_old ) = 'kg/kg'
   fdda3d_streams_table( idomain, P_ph_ndg_old )%stream(1) = 0 
   fdda3d_streams_table( idomain, P_ph_ndg_old )%stream(2) = 2097168 
   F_ph_ndg_old = .TRUE.
   IF ( fdda3d_index_table( PARAM_u_ndg_new , idomain ) .lt. 1 ) THEN
     fdda3d_num_table(idomain) = fdda3d_num_table(idomain) + 1
     P_u_ndg_new = fdda3d_num_table(idomain)
     fdda3d_index_table( PARAM_u_ndg_new , idomain ) = P_u_ndg_new
   ELSE
     P_u_ndg_new = fdda3d_index_table( PARAM_u_ndg_new , idomain )
   END IF
   fdda3d_boundary_table( idomain, P_u_ndg_new ) = .FALSE.
   fdda3d_dname_table( idomain, P_u_ndg_new ) = 'U_NDG_NEW'
   fdda3d_desc_table( idomain, P_u_ndg_new ) = 'NEW X WIND FOR FDDA GRID NUDGING'
   fdda3d_units_table( idomain, P_u_ndg_new ) = 'm s-1'
   fdda3d_streams_table( idomain, P_u_ndg_new )%stream(1) = 0 
   fdda3d_streams_table( idomain, P_u_ndg_new )%stream(2) = 2097168 
   F_u_ndg_new = .TRUE.
   IF ( fdda3d_index_table( PARAM_v_ndg_new , idomain ) .lt. 1 ) THEN
     fdda3d_num_table(idomain) = fdda3d_num_table(idomain) + 1
     P_v_ndg_new = fdda3d_num_table(idomain)
     fdda3d_index_table( PARAM_v_ndg_new , idomain ) = P_v_ndg_new
   ELSE
     P_v_ndg_new = fdda3d_index_table( PARAM_v_ndg_new , idomain )
   END IF
   fdda3d_boundary_table( idomain, P_v_ndg_new ) = .FALSE.
   fdda3d_dname_table( idomain, P_v_ndg_new ) = 'V_NDG_NEW'
   fdda3d_desc_table( idomain, P_v_ndg_new ) = 'NEW Y WIND FOR FDDA GRID NUDGING'
   fdda3d_units_table( idomain, P_v_ndg_new ) = 'm s-1'
   fdda3d_streams_table( idomain, P_v_ndg_new )%stream(1) = 0 
   fdda3d_streams_table( idomain, P_v_ndg_new )%stream(2) = 2097168 
   F_v_ndg_new = .TRUE.
   IF ( fdda3d_index_table( PARAM_t_ndg_new , idomain ) .lt. 1 ) THEN
     fdda3d_num_table(idomain) = fdda3d_num_table(idomain) + 1
     P_t_ndg_new = fdda3d_num_table(idomain)
     fdda3d_index_table( PARAM_t_ndg_new , idomain ) = P_t_ndg_new
   ELSE
     P_t_ndg_new = fdda3d_index_table( PARAM_t_ndg_new , idomain )
   END IF
   fdda3d_boundary_table( idomain, P_t_ndg_new ) = .FALSE.
   fdda3d_dname_table( idomain, P_t_ndg_new ) = 'T_NDG_NEW'
   fdda3d_desc_table( idomain, P_t_ndg_new ) = 'NEW PERT POT TEMP FOR FDDA GRID NUDGING'
   fdda3d_units_table( idomain, P_t_ndg_new ) = 'K'
   fdda3d_streams_table( idomain, P_t_ndg_new )%stream(1) = 0 
   fdda3d_streams_table( idomain, P_t_ndg_new )%stream(2) = 2097168 
   F_t_ndg_new = .TRUE.
   IF ( fdda3d_index_table( PARAM_q_ndg_new , idomain ) .lt. 1 ) THEN
     fdda3d_num_table(idomain) = fdda3d_num_table(idomain) + 1
     P_q_ndg_new = fdda3d_num_table(idomain)
     fdda3d_index_table( PARAM_q_ndg_new , idomain ) = P_q_ndg_new
   ELSE
     P_q_ndg_new = fdda3d_index_table( PARAM_q_ndg_new , idomain )
   END IF
   fdda3d_boundary_table( idomain, P_q_ndg_new ) = .FALSE.
   fdda3d_dname_table( idomain, P_q_ndg_new ) = 'Q_NDG_NEW'
   fdda3d_desc_table( idomain, P_q_ndg_new ) = 'NEW WATER VAPOR MIX RATIO FOR FDDA GRID NUDGING'
   fdda3d_units_table( idomain, P_q_ndg_new ) = 'kg/kg'
   fdda3d_streams_table( idomain, P_q_ndg_new )%stream(1) = 0 
   fdda3d_streams_table( idomain, P_q_ndg_new )%stream(2) = 2097168 
   F_q_ndg_new = .TRUE.
   IF ( fdda3d_index_table( PARAM_ph_ndg_new , idomain ) .lt. 1 ) THEN
     fdda3d_num_table(idomain) = fdda3d_num_table(idomain) + 1
     P_ph_ndg_new = fdda3d_num_table(idomain)
     fdda3d_index_table( PARAM_ph_ndg_new , idomain ) = P_ph_ndg_new
   ELSE
     P_ph_ndg_new = fdda3d_index_table( PARAM_ph_ndg_new , idomain )
   END IF
   fdda3d_boundary_table( idomain, P_ph_ndg_new ) = .FALSE.
   fdda3d_dname_table( idomain, P_ph_ndg_new ) = 'PH_NDG_NEW'
   fdda3d_desc_table( idomain, P_ph_ndg_new ) = 'NEW PERT GEOPOTENTIAL FOR FDDA GRID NUDGING'
   fdda3d_units_table( idomain, P_ph_ndg_new ) = 'kg/kg'
   fdda3d_streams_table( idomain, P_ph_ndg_new )%stream(1) = 0 
   fdda3d_streams_table( idomain, P_ph_ndg_new )%stream(2) = 2097168 
   F_ph_ndg_new = .TRUE.
   IF ( fdda2d_index_table( PARAM_mu_ndg_old , idomain ) .lt. 1 ) THEN
     fdda2d_num_table(idomain) = fdda2d_num_table(idomain) + 1
     P_mu_ndg_old = fdda2d_num_table(idomain)
     fdda2d_index_table( PARAM_mu_ndg_old , idomain ) = P_mu_ndg_old
   ELSE
     P_mu_ndg_old = fdda2d_index_table( PARAM_mu_ndg_old , idomain )
   END IF
   fdda2d_boundary_table( idomain, P_mu_ndg_old ) = .FALSE.
   fdda2d_dname_table( idomain, P_mu_ndg_old ) = 'MU_NDG_OLD'
   fdda2d_desc_table( idomain, P_mu_ndg_old ) = 'OLD PERT COLUMN DRY MASS FOR FDDA GRID NUDGING'
   fdda2d_units_table( idomain, P_mu_ndg_old ) = 'Pa'
   fdda2d_streams_table( idomain, P_mu_ndg_old )%stream(1) = 0 
   fdda2d_streams_table( idomain, P_mu_ndg_old )%stream(2) = 2097168 
   F_mu_ndg_old = .TRUE.
   IF ( fdda2d_index_table( PARAM_mu_ndg_new , idomain ) .lt. 1 ) THEN
     fdda2d_num_table(idomain) = fdda2d_num_table(idomain) + 1
     P_mu_ndg_new = fdda2d_num_table(idomain)
     fdda2d_index_table( PARAM_mu_ndg_new , idomain ) = P_mu_ndg_new
   ELSE
     P_mu_ndg_new = fdda2d_index_table( PARAM_mu_ndg_new , idomain )
   END IF
   fdda2d_boundary_table( idomain, P_mu_ndg_new ) = .FALSE.
   fdda2d_dname_table( idomain, P_mu_ndg_new ) = 'MU_NDG_NEW'
   fdda2d_desc_table( idomain, P_mu_ndg_new ) = 'NEW PERT COLUMN DRY MASS FOR FDDA GRID NUDGING'
   fdda2d_units_table( idomain, P_mu_ndg_new ) = 'Pa'
   fdda2d_streams_table( idomain, P_mu_ndg_new )%stream(1) = 0 
   fdda2d_streams_table( idomain, P_mu_ndg_new )%stream(2) = 2097168 
   F_mu_ndg_new = .TRUE.
  END IF
  IF (model_config_rec%grid_fdda(idomain)==2)THEN
   IF ( fdda3d_index_table( PARAM_u_ndg_old , idomain ) .lt. 1 ) THEN
     fdda3d_num_table(idomain) = fdda3d_num_table(idomain) + 1
     P_u_ndg_old = fdda3d_num_table(idomain)
     fdda3d_index_table( PARAM_u_ndg_old , idomain ) = P_u_ndg_old
   ELSE
     P_u_ndg_old = fdda3d_index_table( PARAM_u_ndg_old , idomain )
   END IF
   fdda3d_boundary_table( idomain, P_u_ndg_old ) = .FALSE.
   fdda3d_dname_table( idomain, P_u_ndg_old ) = 'U_NDG_OLD'
   fdda3d_desc_table( idomain, P_u_ndg_old ) = 'OLD X WIND FOR FDDA GRID NUDGING'
   fdda3d_units_table( idomain, P_u_ndg_old ) = 'm s-1'
   fdda3d_streams_table( idomain, P_u_ndg_old )%stream(1) = 0 
   fdda3d_streams_table( idomain, P_u_ndg_old )%stream(2) = 2097168 
   F_u_ndg_old = .TRUE.
   IF ( fdda3d_index_table( PARAM_v_ndg_old , idomain ) .lt. 1 ) THEN
     fdda3d_num_table(idomain) = fdda3d_num_table(idomain) + 1
     P_v_ndg_old = fdda3d_num_table(idomain)
     fdda3d_index_table( PARAM_v_ndg_old , idomain ) = P_v_ndg_old
   ELSE
     P_v_ndg_old = fdda3d_index_table( PARAM_v_ndg_old , idomain )
   END IF
   fdda3d_boundary_table( idomain, P_v_ndg_old ) = .FALSE.
   fdda3d_dname_table( idomain, P_v_ndg_old ) = 'V_NDG_OLD'
   fdda3d_desc_table( idomain, P_v_ndg_old ) = 'OLD Y WIND FOR FDDA GRID NUDGING'
   fdda3d_units_table( idomain, P_v_ndg_old ) = 'm s-1'
   fdda3d_streams_table( idomain, P_v_ndg_old )%stream(1) = 0 
   fdda3d_streams_table( idomain, P_v_ndg_old )%stream(2) = 2097168 
   F_v_ndg_old = .TRUE.
   IF ( fdda3d_index_table( PARAM_t_ndg_old , idomain ) .lt. 1 ) THEN
     fdda3d_num_table(idomain) = fdda3d_num_table(idomain) + 1
     P_t_ndg_old = fdda3d_num_table(idomain)
     fdda3d_index_table( PARAM_t_ndg_old , idomain ) = P_t_ndg_old
   ELSE
     P_t_ndg_old = fdda3d_index_table( PARAM_t_ndg_old , idomain )
   END IF
   fdda3d_boundary_table( idomain, P_t_ndg_old ) = .FALSE.
   fdda3d_dname_table( idomain, P_t_ndg_old ) = 'T_NDG_OLD'
   fdda3d_desc_table( idomain, P_t_ndg_old ) = 'OLD PERT POT TEMP FOR FDDA GRID NUDGING'
   fdda3d_units_table( idomain, P_t_ndg_old ) = 'K'
   fdda3d_streams_table( idomain, P_t_ndg_old )%stream(1) = 0 
   fdda3d_streams_table( idomain, P_t_ndg_old )%stream(2) = 2097168 
   F_t_ndg_old = .TRUE.
   IF ( fdda3d_index_table( PARAM_q_ndg_old , idomain ) .lt. 1 ) THEN
     fdda3d_num_table(idomain) = fdda3d_num_table(idomain) + 1
     P_q_ndg_old = fdda3d_num_table(idomain)
     fdda3d_index_table( PARAM_q_ndg_old , idomain ) = P_q_ndg_old
   ELSE
     P_q_ndg_old = fdda3d_index_table( PARAM_q_ndg_old , idomain )
   END IF
   fdda3d_boundary_table( idomain, P_q_ndg_old ) = .FALSE.
   fdda3d_dname_table( idomain, P_q_ndg_old ) = 'Q_NDG_OLD'
   fdda3d_desc_table( idomain, P_q_ndg_old ) = 'OLD WATER VAPOR MIX RATIO FOR FDDA GRID NUDGING'
   fdda3d_units_table( idomain, P_q_ndg_old ) = 'kg/kg'
   fdda3d_streams_table( idomain, P_q_ndg_old )%stream(1) = 0 
   fdda3d_streams_table( idomain, P_q_ndg_old )%stream(2) = 2097168 
   F_q_ndg_old = .TRUE.
   IF ( fdda3d_index_table( PARAM_ph_ndg_old , idomain ) .lt. 1 ) THEN
     fdda3d_num_table(idomain) = fdda3d_num_table(idomain) + 1
     P_ph_ndg_old = fdda3d_num_table(idomain)
     fdda3d_index_table( PARAM_ph_ndg_old , idomain ) = P_ph_ndg_old
   ELSE
     P_ph_ndg_old = fdda3d_index_table( PARAM_ph_ndg_old , idomain )
   END IF
   fdda3d_boundary_table( idomain, P_ph_ndg_old ) = .FALSE.
   fdda3d_dname_table( idomain, P_ph_ndg_old ) = 'PH_NDG_OLD'
   fdda3d_desc_table( idomain, P_ph_ndg_old ) = 'OLD PERT GEOPOTENTIAL FOR FDDA GRID NUDGING'
   fdda3d_units_table( idomain, P_ph_ndg_old ) = 'kg/kg'
   fdda3d_streams_table( idomain, P_ph_ndg_old )%stream(1) = 0 
   fdda3d_streams_table( idomain, P_ph_ndg_old )%stream(2) = 2097168 
   F_ph_ndg_old = .TRUE.
   IF ( fdda3d_index_table( PARAM_u_ndg_new , idomain ) .lt. 1 ) THEN
     fdda3d_num_table(idomain) = fdda3d_num_table(idomain) + 1
     P_u_ndg_new = fdda3d_num_table(idomain)
     fdda3d_index_table( PARAM_u_ndg_new , idomain ) = P_u_ndg_new
   ELSE
     P_u_ndg_new = fdda3d_index_table( PARAM_u_ndg_new , idomain )
   END IF
   fdda3d_boundary_table( idomain, P_u_ndg_new ) = .FALSE.
   fdda3d_dname_table( idomain, P_u_ndg_new ) = 'U_NDG_NEW'
   fdda3d_desc_table( idomain, P_u_ndg_new ) = 'NEW X WIND FOR FDDA GRID NUDGING'
   fdda3d_units_table( idomain, P_u_ndg_new ) = 'm s-1'
   fdda3d_streams_table( idomain, P_u_ndg_new )%stream(1) = 0 
   fdda3d_streams_table( idomain, P_u_ndg_new )%stream(2) = 2097168 
   F_u_ndg_new = .TRUE.
   IF ( fdda3d_index_table( PARAM_v_ndg_new , idomain ) .lt. 1 ) THEN
     fdda3d_num_table(idomain) = fdda3d_num_table(idomain) + 1
     P_v_ndg_new = fdda3d_num_table(idomain)
     fdda3d_index_table( PARAM_v_ndg_new , idomain ) = P_v_ndg_new
   ELSE
     P_v_ndg_new = fdda3d_index_table( PARAM_v_ndg_new , idomain )
   END IF
   fdda3d_boundary_table( idomain, P_v_ndg_new ) = .FALSE.
   fdda3d_dname_table( idomain, P_v_ndg_new ) = 'V_NDG_NEW'
   fdda3d_desc_table( idomain, P_v_ndg_new ) = 'NEW Y WIND FOR FDDA GRID NUDGING'
   fdda3d_units_table( idomain, P_v_ndg_new ) = 'm s-1'
   fdda3d_streams_table( idomain, P_v_ndg_new )%stream(1) = 0 
   fdda3d_streams_table( idomain, P_v_ndg_new )%stream(2) = 2097168 
   F_v_ndg_new = .TRUE.
   IF ( fdda3d_index_table( PARAM_t_ndg_new , idomain ) .lt. 1 ) THEN
     fdda3d_num_table(idomain) = fdda3d_num_table(idomain) + 1
     P_t_ndg_new = fdda3d_num_table(idomain)
     fdda3d_index_table( PARAM_t_ndg_new , idomain ) = P_t_ndg_new
   ELSE
     P_t_ndg_new = fdda3d_index_table( PARAM_t_ndg_new , idomain )
   END IF
   fdda3d_boundary_table( idomain, P_t_ndg_new ) = .FALSE.
   fdda3d_dname_table( idomain, P_t_ndg_new ) = 'T_NDG_NEW'
   fdda3d_desc_table( idomain, P_t_ndg_new ) = 'NEW PERT POT TEMP FOR FDDA GRID NUDGING'
   fdda3d_units_table( idomain, P_t_ndg_new ) = 'K'
   fdda3d_streams_table( idomain, P_t_ndg_new )%stream(1) = 0 
   fdda3d_streams_table( idomain, P_t_ndg_new )%stream(2) = 2097168 
   F_t_ndg_new = .TRUE.
   IF ( fdda3d_index_table( PARAM_q_ndg_new , idomain ) .lt. 1 ) THEN
     fdda3d_num_table(idomain) = fdda3d_num_table(idomain) + 1
     P_q_ndg_new = fdda3d_num_table(idomain)
     fdda3d_index_table( PARAM_q_ndg_new , idomain ) = P_q_ndg_new
   ELSE
     P_q_ndg_new = fdda3d_index_table( PARAM_q_ndg_new , idomain )
   END IF
   fdda3d_boundary_table( idomain, P_q_ndg_new ) = .FALSE.
   fdda3d_dname_table( idomain, P_q_ndg_new ) = 'Q_NDG_NEW'
   fdda3d_desc_table( idomain, P_q_ndg_new ) = 'NEW WATER VAPOR MIX RATIO FOR FDDA GRID NUDGING'
   fdda3d_units_table( idomain, P_q_ndg_new ) = 'kg/kg'
   fdda3d_streams_table( idomain, P_q_ndg_new )%stream(1) = 0 
   fdda3d_streams_table( idomain, P_q_ndg_new )%stream(2) = 2097168 
   F_q_ndg_new = .TRUE.
   IF ( fdda3d_index_table( PARAM_ph_ndg_new , idomain ) .lt. 1 ) THEN
     fdda3d_num_table(idomain) = fdda3d_num_table(idomain) + 1
     P_ph_ndg_new = fdda3d_num_table(idomain)
     fdda3d_index_table( PARAM_ph_ndg_new , idomain ) = P_ph_ndg_new
   ELSE
     P_ph_ndg_new = fdda3d_index_table( PARAM_ph_ndg_new , idomain )
   END IF
   fdda3d_boundary_table( idomain, P_ph_ndg_new ) = .FALSE.
   fdda3d_dname_table( idomain, P_ph_ndg_new ) = 'PH_NDG_NEW'
   fdda3d_desc_table( idomain, P_ph_ndg_new ) = 'NEW PERT GEOPOTENTIAL FOR FDDA GRID NUDGING'
   fdda3d_units_table( idomain, P_ph_ndg_new ) = 'kg/kg'
   fdda3d_streams_table( idomain, P_ph_ndg_new )%stream(1) = 0 
   fdda3d_streams_table( idomain, P_ph_ndg_new )%stream(2) = 2097168 
   F_ph_ndg_new = .TRUE.
   IF ( fdda2d_index_table( PARAM_mu_ndg_old , idomain ) .lt. 1 ) THEN
     fdda2d_num_table(idomain) = fdda2d_num_table(idomain) + 1
     P_mu_ndg_old = fdda2d_num_table(idomain)
     fdda2d_index_table( PARAM_mu_ndg_old , idomain ) = P_mu_ndg_old
   ELSE
     P_mu_ndg_old = fdda2d_index_table( PARAM_mu_ndg_old , idomain )
   END IF
   fdda2d_boundary_table( idomain, P_mu_ndg_old ) = .FALSE.
   fdda2d_dname_table( idomain, P_mu_ndg_old ) = 'MU_NDG_OLD'
   fdda2d_desc_table( idomain, P_mu_ndg_old ) = 'OLD PERT COLUMN DRY MASS FOR FDDA GRID NUDGING'
   fdda2d_units_table( idomain, P_mu_ndg_old ) = 'Pa'
   fdda2d_streams_table( idomain, P_mu_ndg_old )%stream(1) = 0 
   fdda2d_streams_table( idomain, P_mu_ndg_old )%stream(2) = 2097168 
   F_mu_ndg_old = .TRUE.
   IF ( fdda2d_index_table( PARAM_mu_ndg_new , idomain ) .lt. 1 ) THEN
     fdda2d_num_table(idomain) = fdda2d_num_table(idomain) + 1
     P_mu_ndg_new = fdda2d_num_table(idomain)
     fdda2d_index_table( PARAM_mu_ndg_new , idomain ) = P_mu_ndg_new
   ELSE
     P_mu_ndg_new = fdda2d_index_table( PARAM_mu_ndg_new , idomain )
   END IF
   fdda2d_boundary_table( idomain, P_mu_ndg_new ) = .FALSE.
   fdda2d_dname_table( idomain, P_mu_ndg_new ) = 'MU_NDG_NEW'
   fdda2d_desc_table( idomain, P_mu_ndg_new ) = 'NEW PERT COLUMN DRY MASS FOR FDDA GRID NUDGING'
   fdda2d_units_table( idomain, P_mu_ndg_new ) = 'Pa'
   fdda2d_streams_table( idomain, P_mu_ndg_new )%stream(1) = 0 
   fdda2d_streams_table( idomain, P_mu_ndg_new )%stream(2) = 2097168 
   F_mu_ndg_new = .TRUE.
  END IF
  IF (model_config_rec%grid_sfdda(idomain)==1)THEN
  END IF
  IF (model_config_rec%obs_nudge_opt(idomain)==1)THEN
  END IF
  IF (model_config_rec%grid_sfdda(idomain)==2)THEN
  END IF
  IF (model_config_rec%aer_opt==1)THEN
  END IF
  IF (model_config_rec%aer_opt==2)THEN
  END IF
  IF (model_config_rec%aercu_used==1)THEN
   IF ( aerocu_index_table( PARAM_cu_sulfate , idomain ) .lt. 1 ) THEN
     aerocu_num_table(idomain) = aerocu_num_table(idomain) + 1
     P_cu_sulfate = aerocu_num_table(idomain)
     aerocu_index_table( PARAM_cu_sulfate , idomain ) = P_cu_sulfate
   ELSE
     P_cu_sulfate = aerocu_index_table( PARAM_cu_sulfate , idomain )
   END IF
   aerocu_boundary_table( idomain, P_cu_sulfate ) = .FALSE.
   aerocu_dname_table( idomain, P_cu_sulfate ) = 'cusulfate'
   aerocu_desc_table( idomain, P_cu_sulfate ) = 'sulfate'
   aerocu_units_table( idomain, P_cu_sulfate ) = 'ug m-3'
   aerocu_streams_table( idomain, P_cu_sulfate )%stream(1) = 1 
   aerocu_streams_table( idomain, P_cu_sulfate )%stream(2) = 0 
   F_cu_sulfate = .TRUE.
   IF ( aerocu_index_table( PARAM_cu_seasalt , idomain ) .lt. 1 ) THEN
     aerocu_num_table(idomain) = aerocu_num_table(idomain) + 1
     P_cu_seasalt = aerocu_num_table(idomain)
     aerocu_index_table( PARAM_cu_seasalt , idomain ) = P_cu_seasalt
   ELSE
     P_cu_seasalt = aerocu_index_table( PARAM_cu_seasalt , idomain )
   END IF
   aerocu_boundary_table( idomain, P_cu_seasalt ) = .FALSE.
   aerocu_dname_table( idomain, P_cu_seasalt ) = 'cuseasalt'
   aerocu_desc_table( idomain, P_cu_seasalt ) = 'sea salt'
   aerocu_units_table( idomain, P_cu_seasalt ) = 'ug m-3'
   aerocu_streams_table( idomain, P_cu_seasalt )%stream(1) = 1 
   aerocu_streams_table( idomain, P_cu_seasalt )%stream(2) = 0 
   F_cu_seasalt = .TRUE.
   IF ( aerocu_index_table( PARAM_cu_dust1 , idomain ) .lt. 1 ) THEN
     aerocu_num_table(idomain) = aerocu_num_table(idomain) + 1
     P_cu_dust1 = aerocu_num_table(idomain)
     aerocu_index_table( PARAM_cu_dust1 , idomain ) = P_cu_dust1
   ELSE
     P_cu_dust1 = aerocu_index_table( PARAM_cu_dust1 , idomain )
   END IF
   aerocu_boundary_table( idomain, P_cu_dust1 ) = .FALSE.
   aerocu_dname_table( idomain, P_cu_dust1 ) = 'cudust1'
   aerocu_desc_table( idomain, P_cu_dust1 ) = 'dust 1'
   aerocu_units_table( idomain, P_cu_dust1 ) = 'ug m-3'
   aerocu_streams_table( idomain, P_cu_dust1 )%stream(1) = 1 
   aerocu_streams_table( idomain, P_cu_dust1 )%stream(2) = 0 
   F_cu_dust1 = .TRUE.
   IF ( aerocu_index_table( PARAM_cu_dust2 , idomain ) .lt. 1 ) THEN
     aerocu_num_table(idomain) = aerocu_num_table(idomain) + 1
     P_cu_dust2 = aerocu_num_table(idomain)
     aerocu_index_table( PARAM_cu_dust2 , idomain ) = P_cu_dust2
   ELSE
     P_cu_dust2 = aerocu_index_table( PARAM_cu_dust2 , idomain )
   END IF
   aerocu_boundary_table( idomain, P_cu_dust2 ) = .FALSE.
   aerocu_dname_table( idomain, P_cu_dust2 ) = 'cudust2'
   aerocu_desc_table( idomain, P_cu_dust2 ) = 'dust 2'
   aerocu_units_table( idomain, P_cu_dust2 ) = 'ug m-3'
   aerocu_streams_table( idomain, P_cu_dust2 )%stream(1) = 1 
   aerocu_streams_table( idomain, P_cu_dust2 )%stream(2) = 0 
   F_cu_dust2 = .TRUE.
   IF ( aerocu_index_table( PARAM_cu_dust3 , idomain ) .lt. 1 ) THEN
     aerocu_num_table(idomain) = aerocu_num_table(idomain) + 1
     P_cu_dust3 = aerocu_num_table(idomain)
     aerocu_index_table( PARAM_cu_dust3 , idomain ) = P_cu_dust3
   ELSE
     P_cu_dust3 = aerocu_index_table( PARAM_cu_dust3 , idomain )
   END IF
   aerocu_boundary_table( idomain, P_cu_dust3 ) = .FALSE.
   aerocu_dname_table( idomain, P_cu_dust3 ) = 'cudust3'
   aerocu_desc_table( idomain, P_cu_dust3 ) = 'dust 3'
   aerocu_units_table( idomain, P_cu_dust3 ) = 'ug m-3'
   aerocu_streams_table( idomain, P_cu_dust3 )%stream(1) = 1 
   aerocu_streams_table( idomain, P_cu_dust3 )%stream(2) = 0 
   F_cu_dust3 = .TRUE.
   IF ( aerocu_index_table( PARAM_cu_dust4 , idomain ) .lt. 1 ) THEN
     aerocu_num_table(idomain) = aerocu_num_table(idomain) + 1
     P_cu_dust4 = aerocu_num_table(idomain)
     aerocu_index_table( PARAM_cu_dust4 , idomain ) = P_cu_dust4
   ELSE
     P_cu_dust4 = aerocu_index_table( PARAM_cu_dust4 , idomain )
   END IF
   aerocu_boundary_table( idomain, P_cu_dust4 ) = .FALSE.
   aerocu_dname_table( idomain, P_cu_dust4 ) = 'cudust4'
   aerocu_desc_table( idomain, P_cu_dust4 ) = 'dust 4'
   aerocu_units_table( idomain, P_cu_dust4 ) = 'ug m-3'
   aerocu_streams_table( idomain, P_cu_dust4 )%stream(1) = 1 
   aerocu_streams_table( idomain, P_cu_dust4 )%stream(2) = 0 
   F_cu_dust4 = .TRUE.
   IF ( aerocu_index_table( PARAM_cu_phoocar , idomain ) .lt. 1 ) THEN
     aerocu_num_table(idomain) = aerocu_num_table(idomain) + 1
     P_cu_phoocar = aerocu_num_table(idomain)
     aerocu_index_table( PARAM_cu_phoocar , idomain ) = P_cu_phoocar
   ELSE
     P_cu_phoocar = aerocu_index_table( PARAM_cu_phoocar , idomain )
   END IF
   aerocu_boundary_table( idomain, P_cu_phoocar ) = .FALSE.
   aerocu_dname_table( idomain, P_cu_phoocar ) = 'cuphoocar'
   aerocu_desc_table( idomain, P_cu_phoocar ) = 'hydrophobic organic carbon'
   aerocu_units_table( idomain, P_cu_phoocar ) = 'ug m-3'
   aerocu_streams_table( idomain, P_cu_phoocar )%stream(1) = 1 
   aerocu_streams_table( idomain, P_cu_phoocar )%stream(2) = 0 
   F_cu_phoocar = .TRUE.
   IF ( aerocu_index_table( PARAM_cu_phiocar , idomain ) .lt. 1 ) THEN
     aerocu_num_table(idomain) = aerocu_num_table(idomain) + 1
     P_cu_phiocar = aerocu_num_table(idomain)
     aerocu_index_table( PARAM_cu_phiocar , idomain ) = P_cu_phiocar
   ELSE
     P_cu_phiocar = aerocu_index_table( PARAM_cu_phiocar , idomain )
   END IF
   aerocu_boundary_table( idomain, P_cu_phiocar ) = .FALSE.
   aerocu_dname_table( idomain, P_cu_phiocar ) = 'cuphiocar'
   aerocu_desc_table( idomain, P_cu_phiocar ) = 'hydrophilic organic carbon'
   aerocu_units_table( idomain, P_cu_phiocar ) = 'ug m-3'
   aerocu_streams_table( idomain, P_cu_phiocar )%stream(1) = 1 
   aerocu_streams_table( idomain, P_cu_phiocar )%stream(2) = 0 
   F_cu_phiocar = .TRUE.
   IF ( aerocu_index_table( PARAM_cu_phobcar , idomain ) .lt. 1 ) THEN
     aerocu_num_table(idomain) = aerocu_num_table(idomain) + 1
     P_cu_phobcar = aerocu_num_table(idomain)
     aerocu_index_table( PARAM_cu_phobcar , idomain ) = P_cu_phobcar
   ELSE
     P_cu_phobcar = aerocu_index_table( PARAM_cu_phobcar , idomain )
   END IF
   aerocu_boundary_table( idomain, P_cu_phobcar ) = .FALSE.
   aerocu_dname_table( idomain, P_cu_phobcar ) = 'cuphobcar'
   aerocu_desc_table( idomain, P_cu_phobcar ) = 'hydrophobic black carbon'
   aerocu_units_table( idomain, P_cu_phobcar ) = 'ug m-3'
   aerocu_streams_table( idomain, P_cu_phobcar )%stream(1) = 1 
   aerocu_streams_table( idomain, P_cu_phobcar )%stream(2) = 0 
   F_cu_phobcar = .TRUE.
   IF ( aerocu_index_table( PARAM_cu_phibcar , idomain ) .lt. 1 ) THEN
     aerocu_num_table(idomain) = aerocu_num_table(idomain) + 1
     P_cu_phibcar = aerocu_num_table(idomain)
     aerocu_index_table( PARAM_cu_phibcar , idomain ) = P_cu_phibcar
   ELSE
     P_cu_phibcar = aerocu_index_table( PARAM_cu_phibcar , idomain )
   END IF
   aerocu_boundary_table( idomain, P_cu_phibcar ) = .FALSE.
   aerocu_dname_table( idomain, P_cu_phibcar ) = 'cuphibcar'
   aerocu_desc_table( idomain, P_cu_phibcar ) = 'hydrophilic black carbon'
   aerocu_units_table( idomain, P_cu_phibcar ) = 'ug m-3'
   aerocu_streams_table( idomain, P_cu_phibcar )%stream(1) = 1 
   aerocu_streams_table( idomain, P_cu_phibcar )%stream(2) = 0 
   F_cu_phibcar = .TRUE.
  END IF
  IF (model_config_rec%slope_rad(idomain)==1)THEN
  END IF
  IF (model_config_rec%gwd_opt==1)THEN
  END IF
  IF (model_config_rec%sf_ocean_physics==1)THEN
  END IF
  IF (model_config_rec%sf_ocean_physics==2)THEN
  END IF
  IF (model_config_rec%scm_force==1)THEN
  END IF
  IF (model_config_rec%prec_acc_opt==1)THEN
  END IF
  IF (model_config_rec%bucketr_opt==1)THEN
  END IF
  IF (model_config_rec%bucketf_opt==1)THEN
  END IF
  IF (model_config_rec%momentum_adv_opt(idomain)==1)THEN
  END IF
  IF (model_config_rec%momentum_adv_opt(idomain)==3)THEN
  END IF
  IF (model_config_rec%moist_adv_opt(idomain)==0)THEN
  END IF
  IF (model_config_rec%moist_adv_opt(idomain)==1)THEN
  END IF
  IF (model_config_rec%moist_adv_opt(idomain)==2)THEN
  END IF
  IF (model_config_rec%moist_adv_opt(idomain)==3)THEN
  END IF
  IF (model_config_rec%moist_adv_opt(idomain)==4)THEN
  END IF
  IF (model_config_rec%output_diagnostics==1)THEN
  END IF
  IF (model_config_rec%nwp_diagnostics==1)THEN
  END IF
  IF (model_config_rec%dfi_stage(idomain)==0)THEN
  END IF
  IF (model_config_rec%dfi_stage(idomain)==1)THEN
  END IF
  IF (model_config_rec%dfi_stage(idomain)==2)THEN
  END IF
  IF (model_config_rec%dfi_stage(idomain)==3)THEN
  END IF
  IF (model_config_rec%dfi_stage(idomain)==4)THEN
  END IF
  IF (model_config_rec%dfi_stage(idomain)==5)THEN
  END IF
  IF (model_config_rec%dfi_opt==0)THEN
  END IF
  IF (model_config_rec%dfi_opt==1)THEN
  END IF
  IF (model_config_rec%dfi_opt==2)THEN
  END IF
  IF (model_config_rec%dfi_opt==3)THEN
  END IF
  IF (model_config_rec%nest_interp_coord==0)THEN
  END IF
  IF (model_config_rec%nest_interp_coord==1)THEN
  END IF
  IF (model_config_rec%tenddiag(idomain)==0)THEN
  END IF
  IF (model_config_rec%tenddiag(idomain)==1)THEN
   IF ( advh_t_index_table( PARAM_advh_qv , idomain ) .lt. 1 ) THEN
     advh_t_num_table(idomain) = advh_t_num_table(idomain) + 1
     P_advh_qv = advh_t_num_table(idomain)
     advh_t_index_table( PARAM_advh_qv , idomain ) = P_advh_qv
   ELSE
     P_advh_qv = advh_t_index_table( PARAM_advh_qv , idomain )
   END IF
   advh_t_boundary_table( idomain, P_advh_qv ) = .FALSE.
   advh_t_dname_table( idomain, P_advh_qv ) = 'advh_qv'
   advh_t_desc_table( idomain, P_advh_qv ) = 'ACCUMULATED HORIZONTAL TENDENCY FOR WATER VAPOR'
   advh_t_units_table( idomain, P_advh_qv ) = 'kg kg-1'
   advh_t_streams_table( idomain, P_advh_qv )%stream(1) = 0 
   advh_t_streams_table( idomain, P_advh_qv )%stream(2) = 0 
   F_advh_qv = .TRUE.
   IF ( advz_t_index_table( PARAM_advz_qv , idomain ) .lt. 1 ) THEN
     advz_t_num_table(idomain) = advz_t_num_table(idomain) + 1
     P_advz_qv = advz_t_num_table(idomain)
     advz_t_index_table( PARAM_advz_qv , idomain ) = P_advz_qv
   ELSE
     P_advz_qv = advz_t_index_table( PARAM_advz_qv , idomain )
   END IF
   advz_t_boundary_table( idomain, P_advz_qv ) = .FALSE.
   advz_t_dname_table( idomain, P_advz_qv ) = 'advz_qv'
   advz_t_desc_table( idomain, P_advz_qv ) = 'ACCUMULATED VERTICAL TENDENCY FOR WATER VAPOR'
   advz_t_units_table( idomain, P_advz_qv ) = 'kg kg-1'
   advz_t_streams_table( idomain, P_advz_qv )%stream(1) = 0 
   advz_t_streams_table( idomain, P_advz_qv )%stream(2) = 0 
   F_advz_qv = .TRUE.
  END IF
  IF (model_config_rec%traj_opt==0)THEN
  END IF
  IF (model_config_rec%traj_opt==1)THEN
  END IF
  IF (model_config_rec%seaice_albedo_opt==0)THEN
  END IF
  IF (model_config_rec%seaice_albedo_opt==1)THEN
  END IF
  IF (model_config_rec%seaice_albedo_opt==2)THEN
  END IF
  IF (model_config_rec%seaice_snowdepth_opt==0)THEN
  END IF
  IF (model_config_rec%seaice_snowdepth_opt==1)THEN
  END IF
  IF (model_config_rec%seaice_thickness_opt==0)THEN
  END IF
  IF (model_config_rec%seaice_thickness_opt==1)THEN
  END IF
  IF (model_config_rec%process_time_series==0)THEN
  END IF
  IF (model_config_rec%process_time_series==1)THEN
  END IF
  IF (model_config_rec%hailcast_opt(idomain)==1)THEN
  END IF
  IF (model_config_rec%lightning_option(idomain)==0)THEN
  END IF
  IF (model_config_rec%lightning_option(idomain)==1)THEN
  END IF
  IF (model_config_rec%lightning_option(idomain)==2)THEN
  END IF
  IF (model_config_rec%lightning_option(idomain)==11)THEN
  END IF
  IF (model_config_rec%lightning_option(idomain)==3)THEN
  END IF
  IF (model_config_rec%io_form_restart==1)THEN
  END IF
  IF (model_config_rec%io_form_restart==2)THEN
  END IF
  IF (model_config_rec%io_form_restart==3)THEN
  END IF
  IF (model_config_rec%io_form_restart==4)THEN
  END IF
  IF (model_config_rec%io_form_restart==5)THEN
  END IF
  IF (model_config_rec%io_form_restart==6)THEN
  END IF
  IF (model_config_rec%io_form_restart==7)THEN
  END IF
  IF (model_config_rec%io_form_restart==8)THEN
  END IF
  IF (model_config_rec%io_form_restart==9)THEN
  END IF
  IF (model_config_rec%io_form_restart==10)THEN
  END IF
  IF (model_config_rec%io_form_restart==11)THEN
  END IF
  IF (model_config_rec%io_form_restart==12)THEN
  END IF
  IF (model_config_rec%wrf_hydro==0)THEN
  END IF
  IF (model_config_rec%wrf_hydro==1)THEN
  END IF
  IF (model_config_rec%windfarm_opt(idomain)==0)THEN
  END IF
  IF (model_config_rec%windfarm_opt(idomain)==1)THEN
  END IF
  IF (model_config_rec%ideal_case==0)THEN
  END IF
  IF (model_config_rec%ideal_case==1)THEN
  END IF
  IF (model_config_rec%ideal_case==2)THEN
  END IF
  IF (model_config_rec%ideal_case==3)THEN
  END IF
  IF (model_config_rec%ideal_case==4)THEN
  END IF
  IF (model_config_rec%ideal_case==5)THEN
  END IF
  IF (model_config_rec%ideal_case==6)THEN
  END IF
  IF (model_config_rec%ideal_case==7)THEN
  END IF
  IF (model_config_rec%ideal_case==8)THEN
  END IF
  IF (model_config_rec%ideal_case==9)THEN
  END IF
  IF (model_config_rec%calc_clean_atm_diag==1)THEN
  END IF
  IF (model_config_rec%fft_used==0)THEN
  END IF
  IF (model_config_rec%fft_used==1)THEN
  END IF
  IF (model_config_rec%ifire(idomain)==2)THEN
  END IF
  IF (model_config_rec%tracer_opt(idomain)==3)THEN
   IF ( tracer_index_table( PARAM_fire_smoke , idomain ) .lt. 1 ) THEN
     tracer_num_table(idomain) = tracer_num_table(idomain) + 1
     P_fire_smoke = tracer_num_table(idomain)
     tracer_index_table( PARAM_fire_smoke , idomain ) = P_fire_smoke
   ELSE
     P_fire_smoke = tracer_index_table( PARAM_fire_smoke , idomain )
   END IF
   tracer_boundary_table( idomain, P_fire_smoke ) = .TRUE.
   tracer_dname_table( idomain, P_fire_smoke ) = 'fire_smoke'
   tracer_desc_table( idomain, P_fire_smoke ) = 'fire_smoke'
   tracer_units_table( idomain, P_fire_smoke ) = 'g_smoke/kg_air'
   tracer_streams_table( idomain, P_fire_smoke )%stream(1) = 33554433 
   tracer_streams_table( idomain, P_fire_smoke )%stream(2) = 2097152 
   F_fire_smoke = .TRUE.
  END IF
  IF (model_config_rec%do_avgflx_em(idomain)==0)THEN
  END IF
  IF (model_config_rec%do_avgflx_em(idomain)==1)THEN
  END IF
  IF (model_config_rec%do_avgflx_cugd(idomain)==0)THEN
  END IF
  IF (model_config_rec%do_avgflx_cugd(idomain)==1)THEN
  END IF
  IF (model_config_rec%sppt_on==1)THEN
  END IF
  IF (model_config_rec%skebs_on==1)THEN
  END IF
  IF (model_config_rec%rand_perturb_on==1)THEN
  END IF
  IF (model_config_rec%spp_on==1)THEN
  END IF
  IF (model_config_rec%sfs_opt(idomain)==0)THEN
  END IF
  IF (model_config_rec%sfs_opt(idomain)==1)THEN
   IF ( nba_mij_index_table( PARAM_m11 , idomain ) .lt. 1 ) THEN
     nba_mij_num_table(idomain) = nba_mij_num_table(idomain) + 1
     P_m11 = nba_mij_num_table(idomain)
     nba_mij_index_table( PARAM_m11 , idomain ) = P_m11
   ELSE
     P_m11 = nba_mij_index_table( PARAM_m11 , idomain )
   END IF
   nba_mij_boundary_table( idomain, P_m11 ) = .FALSE.
   nba_mij_dname_table( idomain, P_m11 ) = 'm11'
   nba_mij_desc_table( idomain, P_m11 ) = '11 component of NBA subgrid stress tensor'
   nba_mij_units_table( idomain, P_m11 ) = 'm2 s-2'
   nba_mij_streams_table( idomain, P_m11 )%stream(1) = 1 
   nba_mij_streams_table( idomain, P_m11 )%stream(2) = 0 
   F_m11 = .TRUE.
   IF ( nba_mij_index_table( PARAM_m22 , idomain ) .lt. 1 ) THEN
     nba_mij_num_table(idomain) = nba_mij_num_table(idomain) + 1
     P_m22 = nba_mij_num_table(idomain)
     nba_mij_index_table( PARAM_m22 , idomain ) = P_m22
   ELSE
     P_m22 = nba_mij_index_table( PARAM_m22 , idomain )
   END IF
   nba_mij_boundary_table( idomain, P_m22 ) = .FALSE.
   nba_mij_dname_table( idomain, P_m22 ) = 'm22'
   nba_mij_desc_table( idomain, P_m22 ) = '22 component of NBA subgrid stress tensor'
   nba_mij_units_table( idomain, P_m22 ) = 'm2 s-2'
   nba_mij_streams_table( idomain, P_m22 )%stream(1) = 1 
   nba_mij_streams_table( idomain, P_m22 )%stream(2) = 0 
   F_m22 = .TRUE.
   IF ( nba_mij_index_table( PARAM_m33 , idomain ) .lt. 1 ) THEN
     nba_mij_num_table(idomain) = nba_mij_num_table(idomain) + 1
     P_m33 = nba_mij_num_table(idomain)
     nba_mij_index_table( PARAM_m33 , idomain ) = P_m33
   ELSE
     P_m33 = nba_mij_index_table( PARAM_m33 , idomain )
   END IF
   nba_mij_boundary_table( idomain, P_m33 ) = .FALSE.
   nba_mij_dname_table( idomain, P_m33 ) = 'm33'
   nba_mij_desc_table( idomain, P_m33 ) = '33 component of NBA subgrid stress tensor'
   nba_mij_units_table( idomain, P_m33 ) = 'm2 s-2'
   nba_mij_streams_table( idomain, P_m33 )%stream(1) = 1 
   nba_mij_streams_table( idomain, P_m33 )%stream(2) = 0 
   F_m33 = .TRUE.
   IF ( nba_mij_index_table( PARAM_m12 , idomain ) .lt. 1 ) THEN
     nba_mij_num_table(idomain) = nba_mij_num_table(idomain) + 1
     P_m12 = nba_mij_num_table(idomain)
     nba_mij_index_table( PARAM_m12 , idomain ) = P_m12
   ELSE
     P_m12 = nba_mij_index_table( PARAM_m12 , idomain )
   END IF
   nba_mij_boundary_table( idomain, P_m12 ) = .FALSE.
   nba_mij_dname_table( idomain, P_m12 ) = 'm12'
   nba_mij_desc_table( idomain, P_m12 ) = '12 component of NBA subgrid stress tensor'
   nba_mij_units_table( idomain, P_m12 ) = 'm2 s-2'
   nba_mij_streams_table( idomain, P_m12 )%stream(1) = 1 
   nba_mij_streams_table( idomain, P_m12 )%stream(2) = 0 
   F_m12 = .TRUE.
   IF ( nba_mij_index_table( PARAM_m13 , idomain ) .lt. 1 ) THEN
     nba_mij_num_table(idomain) = nba_mij_num_table(idomain) + 1
     P_m13 = nba_mij_num_table(idomain)
     nba_mij_index_table( PARAM_m13 , idomain ) = P_m13
   ELSE
     P_m13 = nba_mij_index_table( PARAM_m13 , idomain )
   END IF
   nba_mij_boundary_table( idomain, P_m13 ) = .FALSE.
   nba_mij_dname_table( idomain, P_m13 ) = 'm13'
   nba_mij_desc_table( idomain, P_m13 ) = '13 component of NBA subgrid stress tensor'
   nba_mij_units_table( idomain, P_m13 ) = 'm2 s-2'
   nba_mij_streams_table( idomain, P_m13 )%stream(1) = 1 
   nba_mij_streams_table( idomain, P_m13 )%stream(2) = 0 
   F_m13 = .TRUE.
   IF ( nba_mij_index_table( PARAM_m23 , idomain ) .lt. 1 ) THEN
     nba_mij_num_table(idomain) = nba_mij_num_table(idomain) + 1
     P_m23 = nba_mij_num_table(idomain)
     nba_mij_index_table( PARAM_m23 , idomain ) = P_m23
   ELSE
     P_m23 = nba_mij_index_table( PARAM_m23 , idomain )
   END IF
   nba_mij_boundary_table( idomain, P_m23 ) = .FALSE.
   nba_mij_dname_table( idomain, P_m23 ) = 'm23'
   nba_mij_desc_table( idomain, P_m23 ) = '23 component of NBA subgrid stress tensor'
   nba_mij_units_table( idomain, P_m23 ) = 'm2 s-2'
   nba_mij_streams_table( idomain, P_m23 )%stream(1) = 1 
   nba_mij_streams_table( idomain, P_m23 )%stream(2) = 0 
   F_m23 = .TRUE.
   IF ( nba_rij_index_table( PARAM_r12 , idomain ) .lt. 1 ) THEN
     nba_rij_num_table(idomain) = nba_rij_num_table(idomain) + 1
     P_r12 = nba_rij_num_table(idomain)
     nba_rij_index_table( PARAM_r12 , idomain ) = P_r12
   ELSE
     P_r12 = nba_rij_index_table( PARAM_r12 , idomain )
   END IF
   nba_rij_boundary_table( idomain, P_r12 ) = .FALSE.
   nba_rij_dname_table( idomain, P_r12 ) = 'r12'
   nba_rij_desc_table( idomain, P_r12 ) = '12 component of rotation tensor'
   nba_rij_units_table( idomain, P_r12 ) = 's-1'
   nba_rij_streams_table( idomain, P_r12 )%stream(1) = 0 
   nba_rij_streams_table( idomain, P_r12 )%stream(2) = 0 
   F_r12 = .TRUE.
   IF ( nba_rij_index_table( PARAM_r13 , idomain ) .lt. 1 ) THEN
     nba_rij_num_table(idomain) = nba_rij_num_table(idomain) + 1
     P_r13 = nba_rij_num_table(idomain)
     nba_rij_index_table( PARAM_r13 , idomain ) = P_r13
   ELSE
     P_r13 = nba_rij_index_table( PARAM_r13 , idomain )
   END IF
   nba_rij_boundary_table( idomain, P_r13 ) = .FALSE.
   nba_rij_dname_table( idomain, P_r13 ) = 'r13'
   nba_rij_desc_table( idomain, P_r13 ) = '13 component of rotation tensor'
   nba_rij_units_table( idomain, P_r13 ) = 's-1'
   nba_rij_streams_table( idomain, P_r13 )%stream(1) = 0 
   nba_rij_streams_table( idomain, P_r13 )%stream(2) = 0 
   F_r13 = .TRUE.
   IF ( nba_rij_index_table( PARAM_r23 , idomain ) .lt. 1 ) THEN
     nba_rij_num_table(idomain) = nba_rij_num_table(idomain) + 1
     P_r23 = nba_rij_num_table(idomain)
     nba_rij_index_table( PARAM_r23 , idomain ) = P_r23
   ELSE
     P_r23 = nba_rij_index_table( PARAM_r23 , idomain )
   END IF
   nba_rij_boundary_table( idomain, P_r23 ) = .FALSE.
   nba_rij_dname_table( idomain, P_r23 ) = 'r23'
   nba_rij_desc_table( idomain, P_r23 ) = '23 component of rotation tensor'
   nba_rij_units_table( idomain, P_r23 ) = 's-1'
   nba_rij_streams_table( idomain, P_r23 )%stream(1) = 0 
   nba_rij_streams_table( idomain, P_r23 )%stream(2) = 0 
   F_r23 = .TRUE.
   IF ( nba_rij_index_table( PARAM_smnsmn , idomain ) .lt. 1 ) THEN
     nba_rij_num_table(idomain) = nba_rij_num_table(idomain) + 1
     P_smnsmn = nba_rij_num_table(idomain)
     nba_rij_index_table( PARAM_smnsmn , idomain ) = P_smnsmn
   ELSE
     P_smnsmn = nba_rij_index_table( PARAM_smnsmn , idomain )
   END IF
   nba_rij_boundary_table( idomain, P_smnsmn ) = .FALSE.
   nba_rij_dname_table( idomain, P_smnsmn ) = 'smnsmn'
   nba_rij_desc_table( idomain, P_smnsmn ) = 'Smn*Smn'
   nba_rij_units_table( idomain, P_smnsmn ) = 's-2'
   nba_rij_streams_table( idomain, P_smnsmn )%stream(1) = 0 
   nba_rij_streams_table( idomain, P_smnsmn )%stream(2) = 0 
   F_smnsmn = .TRUE.
  END IF
  IF (model_config_rec%sfs_opt(idomain)==2)THEN
   IF ( nba_mij_index_table( PARAM_m11 , idomain ) .lt. 1 ) THEN
     nba_mij_num_table(idomain) = nba_mij_num_table(idomain) + 1
     P_m11 = nba_mij_num_table(idomain)
     nba_mij_index_table( PARAM_m11 , idomain ) = P_m11
   ELSE
     P_m11 = nba_mij_index_table( PARAM_m11 , idomain )
   END IF
   nba_mij_boundary_table( idomain, P_m11 ) = .FALSE.
   nba_mij_dname_table( idomain, P_m11 ) = 'm11'
   nba_mij_desc_table( idomain, P_m11 ) = '11 component of NBA subgrid stress tensor'
   nba_mij_units_table( idomain, P_m11 ) = 'm2 s-2'
   nba_mij_streams_table( idomain, P_m11 )%stream(1) = 1 
   nba_mij_streams_table( idomain, P_m11 )%stream(2) = 0 
   F_m11 = .TRUE.
   IF ( nba_mij_index_table( PARAM_m22 , idomain ) .lt. 1 ) THEN
     nba_mij_num_table(idomain) = nba_mij_num_table(idomain) + 1
     P_m22 = nba_mij_num_table(idomain)
     nba_mij_index_table( PARAM_m22 , idomain ) = P_m22
   ELSE
     P_m22 = nba_mij_index_table( PARAM_m22 , idomain )
   END IF
   nba_mij_boundary_table( idomain, P_m22 ) = .FALSE.
   nba_mij_dname_table( idomain, P_m22 ) = 'm22'
   nba_mij_desc_table( idomain, P_m22 ) = '22 component of NBA subgrid stress tensor'
   nba_mij_units_table( idomain, P_m22 ) = 'm2 s-2'
   nba_mij_streams_table( idomain, P_m22 )%stream(1) = 1 
   nba_mij_streams_table( idomain, P_m22 )%stream(2) = 0 
   F_m22 = .TRUE.
   IF ( nba_mij_index_table( PARAM_m33 , idomain ) .lt. 1 ) THEN
     nba_mij_num_table(idomain) = nba_mij_num_table(idomain) + 1
     P_m33 = nba_mij_num_table(idomain)
     nba_mij_index_table( PARAM_m33 , idomain ) = P_m33
   ELSE
     P_m33 = nba_mij_index_table( PARAM_m33 , idomain )
   END IF
   nba_mij_boundary_table( idomain, P_m33 ) = .FALSE.
   nba_mij_dname_table( idomain, P_m33 ) = 'm33'
   nba_mij_desc_table( idomain, P_m33 ) = '33 component of NBA subgrid stress tensor'
   nba_mij_units_table( idomain, P_m33 ) = 'm2 s-2'
   nba_mij_streams_table( idomain, P_m33 )%stream(1) = 1 
   nba_mij_streams_table( idomain, P_m33 )%stream(2) = 0 
   F_m33 = .TRUE.
   IF ( nba_mij_index_table( PARAM_m12 , idomain ) .lt. 1 ) THEN
     nba_mij_num_table(idomain) = nba_mij_num_table(idomain) + 1
     P_m12 = nba_mij_num_table(idomain)
     nba_mij_index_table( PARAM_m12 , idomain ) = P_m12
   ELSE
     P_m12 = nba_mij_index_table( PARAM_m12 , idomain )
   END IF
   nba_mij_boundary_table( idomain, P_m12 ) = .FALSE.
   nba_mij_dname_table( idomain, P_m12 ) = 'm12'
   nba_mij_desc_table( idomain, P_m12 ) = '12 component of NBA subgrid stress tensor'
   nba_mij_units_table( idomain, P_m12 ) = 'm2 s-2'
   nba_mij_streams_table( idomain, P_m12 )%stream(1) = 1 
   nba_mij_streams_table( idomain, P_m12 )%stream(2) = 0 
   F_m12 = .TRUE.
   IF ( nba_mij_index_table( PARAM_m13 , idomain ) .lt. 1 ) THEN
     nba_mij_num_table(idomain) = nba_mij_num_table(idomain) + 1
     P_m13 = nba_mij_num_table(idomain)
     nba_mij_index_table( PARAM_m13 , idomain ) = P_m13
   ELSE
     P_m13 = nba_mij_index_table( PARAM_m13 , idomain )
   END IF
   nba_mij_boundary_table( idomain, P_m13 ) = .FALSE.
   nba_mij_dname_table( idomain, P_m13 ) = 'm13'
   nba_mij_desc_table( idomain, P_m13 ) = '13 component of NBA subgrid stress tensor'
   nba_mij_units_table( idomain, P_m13 ) = 'm2 s-2'
   nba_mij_streams_table( idomain, P_m13 )%stream(1) = 1 
   nba_mij_streams_table( idomain, P_m13 )%stream(2) = 0 
   F_m13 = .TRUE.
   IF ( nba_mij_index_table( PARAM_m23 , idomain ) .lt. 1 ) THEN
     nba_mij_num_table(idomain) = nba_mij_num_table(idomain) + 1
     P_m23 = nba_mij_num_table(idomain)
     nba_mij_index_table( PARAM_m23 , idomain ) = P_m23
   ELSE
     P_m23 = nba_mij_index_table( PARAM_m23 , idomain )
   END IF
   nba_mij_boundary_table( idomain, P_m23 ) = .FALSE.
   nba_mij_dname_table( idomain, P_m23 ) = 'm23'
   nba_mij_desc_table( idomain, P_m23 ) = '23 component of NBA subgrid stress tensor'
   nba_mij_units_table( idomain, P_m23 ) = 'm2 s-2'
   nba_mij_streams_table( idomain, P_m23 )%stream(1) = 1 
   nba_mij_streams_table( idomain, P_m23 )%stream(2) = 0 
   F_m23 = .TRUE.
   IF ( nba_rij_index_table( PARAM_r12 , idomain ) .lt. 1 ) THEN
     nba_rij_num_table(idomain) = nba_rij_num_table(idomain) + 1
     P_r12 = nba_rij_num_table(idomain)
     nba_rij_index_table( PARAM_r12 , idomain ) = P_r12
   ELSE
     P_r12 = nba_rij_index_table( PARAM_r12 , idomain )
   END IF
   nba_rij_boundary_table( idomain, P_r12 ) = .FALSE.
   nba_rij_dname_table( idomain, P_r12 ) = 'r12'
   nba_rij_desc_table( idomain, P_r12 ) = '12 component of rotation tensor'
   nba_rij_units_table( idomain, P_r12 ) = 's-1'
   nba_rij_streams_table( idomain, P_r12 )%stream(1) = 0 
   nba_rij_streams_table( idomain, P_r12 )%stream(2) = 0 
   F_r12 = .TRUE.
   IF ( nba_rij_index_table( PARAM_r13 , idomain ) .lt. 1 ) THEN
     nba_rij_num_table(idomain) = nba_rij_num_table(idomain) + 1
     P_r13 = nba_rij_num_table(idomain)
     nba_rij_index_table( PARAM_r13 , idomain ) = P_r13
   ELSE
     P_r13 = nba_rij_index_table( PARAM_r13 , idomain )
   END IF
   nba_rij_boundary_table( idomain, P_r13 ) = .FALSE.
   nba_rij_dname_table( idomain, P_r13 ) = 'r13'
   nba_rij_desc_table( idomain, P_r13 ) = '13 component of rotation tensor'
   nba_rij_units_table( idomain, P_r13 ) = 's-1'
   nba_rij_streams_table( idomain, P_r13 )%stream(1) = 0 
   nba_rij_streams_table( idomain, P_r13 )%stream(2) = 0 
   F_r13 = .TRUE.
   IF ( nba_rij_index_table( PARAM_r23 , idomain ) .lt. 1 ) THEN
     nba_rij_num_table(idomain) = nba_rij_num_table(idomain) + 1
     P_r23 = nba_rij_num_table(idomain)
     nba_rij_index_table( PARAM_r23 , idomain ) = P_r23
   ELSE
     P_r23 = nba_rij_index_table( PARAM_r23 , idomain )
   END IF
   nba_rij_boundary_table( idomain, P_r23 ) = .FALSE.
   nba_rij_dname_table( idomain, P_r23 ) = 'r23'
   nba_rij_desc_table( idomain, P_r23 ) = '23 component of rotation tensor'
   nba_rij_units_table( idomain, P_r23 ) = 's-1'
   nba_rij_streams_table( idomain, P_r23 )%stream(1) = 0 
   nba_rij_streams_table( idomain, P_r23 )%stream(2) = 0 
   F_r23 = .TRUE.
   IF ( nba_rij_index_table( PARAM_smnsmn , idomain ) .lt. 1 ) THEN
     nba_rij_num_table(idomain) = nba_rij_num_table(idomain) + 1
     P_smnsmn = nba_rij_num_table(idomain)
     nba_rij_index_table( PARAM_smnsmn , idomain ) = P_smnsmn
   ELSE
     P_smnsmn = nba_rij_index_table( PARAM_smnsmn , idomain )
   END IF
   nba_rij_boundary_table( idomain, P_smnsmn ) = .FALSE.
   nba_rij_dname_table( idomain, P_smnsmn ) = 'smnsmn'
   nba_rij_desc_table( idomain, P_smnsmn ) = 'Smn*Smn'
   nba_rij_units_table( idomain, P_smnsmn ) = 's-2'
   nba_rij_streams_table( idomain, P_smnsmn )%stream(1) = 0 
   nba_rij_streams_table( idomain, P_smnsmn )%stream(2) = 0 
   F_smnsmn = .TRUE.
  END IF
  IF (model_config_rec%m_opt(idomain)==1)THEN
   IF ( nba_mij_index_table( PARAM_m11 , idomain ) .lt. 1 ) THEN
     nba_mij_num_table(idomain) = nba_mij_num_table(idomain) + 1
     P_m11 = nba_mij_num_table(idomain)
     nba_mij_index_table( PARAM_m11 , idomain ) = P_m11
   ELSE
     P_m11 = nba_mij_index_table( PARAM_m11 , idomain )
   END IF
   nba_mij_boundary_table( idomain, P_m11 ) = .FALSE.
   nba_mij_dname_table( idomain, P_m11 ) = 'm11'
   nba_mij_desc_table( idomain, P_m11 ) = '11 component of NBA subgrid stress tensor'
   nba_mij_units_table( idomain, P_m11 ) = 'm2 s-2'
   nba_mij_streams_table( idomain, P_m11 )%stream(1) = 1 
   nba_mij_streams_table( idomain, P_m11 )%stream(2) = 0 
   F_m11 = .TRUE.
   IF ( nba_mij_index_table( PARAM_m22 , idomain ) .lt. 1 ) THEN
     nba_mij_num_table(idomain) = nba_mij_num_table(idomain) + 1
     P_m22 = nba_mij_num_table(idomain)
     nba_mij_index_table( PARAM_m22 , idomain ) = P_m22
   ELSE
     P_m22 = nba_mij_index_table( PARAM_m22 , idomain )
   END IF
   nba_mij_boundary_table( idomain, P_m22 ) = .FALSE.
   nba_mij_dname_table( idomain, P_m22 ) = 'm22'
   nba_mij_desc_table( idomain, P_m22 ) = '22 component of NBA subgrid stress tensor'
   nba_mij_units_table( idomain, P_m22 ) = 'm2 s-2'
   nba_mij_streams_table( idomain, P_m22 )%stream(1) = 1 
   nba_mij_streams_table( idomain, P_m22 )%stream(2) = 0 
   F_m22 = .TRUE.
   IF ( nba_mij_index_table( PARAM_m33 , idomain ) .lt. 1 ) THEN
     nba_mij_num_table(idomain) = nba_mij_num_table(idomain) + 1
     P_m33 = nba_mij_num_table(idomain)
     nba_mij_index_table( PARAM_m33 , idomain ) = P_m33
   ELSE
     P_m33 = nba_mij_index_table( PARAM_m33 , idomain )
   END IF
   nba_mij_boundary_table( idomain, P_m33 ) = .FALSE.
   nba_mij_dname_table( idomain, P_m33 ) = 'm33'
   nba_mij_desc_table( idomain, P_m33 ) = '33 component of NBA subgrid stress tensor'
   nba_mij_units_table( idomain, P_m33 ) = 'm2 s-2'
   nba_mij_streams_table( idomain, P_m33 )%stream(1) = 1 
   nba_mij_streams_table( idomain, P_m33 )%stream(2) = 0 
   F_m33 = .TRUE.
   IF ( nba_mij_index_table( PARAM_m12 , idomain ) .lt. 1 ) THEN
     nba_mij_num_table(idomain) = nba_mij_num_table(idomain) + 1
     P_m12 = nba_mij_num_table(idomain)
     nba_mij_index_table( PARAM_m12 , idomain ) = P_m12
   ELSE
     P_m12 = nba_mij_index_table( PARAM_m12 , idomain )
   END IF
   nba_mij_boundary_table( idomain, P_m12 ) = .FALSE.
   nba_mij_dname_table( idomain, P_m12 ) = 'm12'
   nba_mij_desc_table( idomain, P_m12 ) = '12 component of NBA subgrid stress tensor'
   nba_mij_units_table( idomain, P_m12 ) = 'm2 s-2'
   nba_mij_streams_table( idomain, P_m12 )%stream(1) = 1 
   nba_mij_streams_table( idomain, P_m12 )%stream(2) = 0 
   F_m12 = .TRUE.
   IF ( nba_mij_index_table( PARAM_m13 , idomain ) .lt. 1 ) THEN
     nba_mij_num_table(idomain) = nba_mij_num_table(idomain) + 1
     P_m13 = nba_mij_num_table(idomain)
     nba_mij_index_table( PARAM_m13 , idomain ) = P_m13
   ELSE
     P_m13 = nba_mij_index_table( PARAM_m13 , idomain )
   END IF
   nba_mij_boundary_table( idomain, P_m13 ) = .FALSE.
   nba_mij_dname_table( idomain, P_m13 ) = 'm13'
   nba_mij_desc_table( idomain, P_m13 ) = '13 component of NBA subgrid stress tensor'
   nba_mij_units_table( idomain, P_m13 ) = 'm2 s-2'
   nba_mij_streams_table( idomain, P_m13 )%stream(1) = 1 
   nba_mij_streams_table( idomain, P_m13 )%stream(2) = 0 
   F_m13 = .TRUE.
   IF ( nba_mij_index_table( PARAM_m23 , idomain ) .lt. 1 ) THEN
     nba_mij_num_table(idomain) = nba_mij_num_table(idomain) + 1
     P_m23 = nba_mij_num_table(idomain)
     nba_mij_index_table( PARAM_m23 , idomain ) = P_m23
   ELSE
     P_m23 = nba_mij_index_table( PARAM_m23 , idomain )
   END IF
   nba_mij_boundary_table( idomain, P_m23 ) = .FALSE.
   nba_mij_dname_table( idomain, P_m23 ) = 'm23'
   nba_mij_desc_table( idomain, P_m23 ) = '23 component of NBA subgrid stress tensor'
   nba_mij_units_table( idomain, P_m23 ) = 'm2 s-2'
   nba_mij_streams_table( idomain, P_m23 )%stream(1) = 1 
   nba_mij_streams_table( idomain, P_m23 )%stream(2) = 0 
   F_m23 = .TRUE.
  END IF
  IF (model_config_rec%sf_lake_physics(idomain)==0)THEN
  END IF
  IF (model_config_rec%sf_lake_physics(idomain)==1)THEN
  END IF
  IF (model_config_rec%mp_physics(idomain)==30)THEN
   IF ( moist_index_table( PARAM_qv , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qv = moist_num_table(idomain)
     moist_index_table( PARAM_qv , idomain ) = P_qv
   ELSE
     P_qv = moist_index_table( PARAM_qv , idomain )
   END IF
   moist_boundary_table( idomain, P_qv ) = .TRUE.
   moist_dname_table( idomain, P_qv ) = 'QVAPOR'
   moist_desc_table( idomain, P_qv ) = 'Water vapor mixing ratio'
   moist_units_table( idomain, P_qv ) = 'kg kg-1'
   moist_streams_table( idomain, P_qv )%stream(1) = 33554435 
   moist_streams_table( idomain, P_qv )%stream(2) = 2097152 
   F_qv = .TRUE.
   IF ( moist_index_table( PARAM_qc , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qc = moist_num_table(idomain)
     moist_index_table( PARAM_qc , idomain ) = P_qc
   ELSE
     P_qc = moist_index_table( PARAM_qc , idomain )
   END IF
   moist_boundary_table( idomain, P_qc ) = .TRUE.
   moist_dname_table( idomain, P_qc ) = 'QCLOUD'
   moist_desc_table( idomain, P_qc ) = 'Cloud water mixing ratio'
   moist_units_table( idomain, P_qc ) = 'kg kg-1'
   moist_streams_table( idomain, P_qc )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qc )%stream(2) = 2097152 
   F_qc = .TRUE.
   IF ( moist_index_table( PARAM_qr , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qr = moist_num_table(idomain)
     moist_index_table( PARAM_qr , idomain ) = P_qr
   ELSE
     P_qr = moist_index_table( PARAM_qr , idomain )
   END IF
   moist_boundary_table( idomain, P_qr ) = .TRUE.
   moist_dname_table( idomain, P_qr ) = 'QRAIN'
   moist_desc_table( idomain, P_qr ) = 'Rain water mixing ratio'
   moist_units_table( idomain, P_qr ) = 'kg kg-1'
   moist_streams_table( idomain, P_qr )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qr )%stream(2) = 2097152 
   F_qr = .TRUE.
   IF ( moist_index_table( PARAM_qi , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qi = moist_num_table(idomain)
     moist_index_table( PARAM_qi , idomain ) = P_qi
   ELSE
     P_qi = moist_index_table( PARAM_qi , idomain )
   END IF
   moist_boundary_table( idomain, P_qi ) = .TRUE.
   moist_dname_table( idomain, P_qi ) = 'QICE'
   moist_desc_table( idomain, P_qi ) = 'Ice mixing ratio'
   moist_units_table( idomain, P_qi ) = 'kg kg-1'
   moist_streams_table( idomain, P_qi )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qi )%stream(2) = 2097152 
   F_qi = .TRUE.
   IF ( moist_index_table( PARAM_qs , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qs = moist_num_table(idomain)
     moist_index_table( PARAM_qs , idomain ) = P_qs
   ELSE
     P_qs = moist_index_table( PARAM_qs , idomain )
   END IF
   moist_boundary_table( idomain, P_qs ) = .TRUE.
   moist_dname_table( idomain, P_qs ) = 'QSNOW'
   moist_desc_table( idomain, P_qs ) = 'Snow mixing ratio'
   moist_units_table( idomain, P_qs ) = 'kg kg-1'
   moist_streams_table( idomain, P_qs )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qs )%stream(2) = 2097152 
   F_qs = .TRUE.
   IF ( moist_index_table( PARAM_qg , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qg = moist_num_table(idomain)
     moist_index_table( PARAM_qg , idomain ) = P_qg
   ELSE
     P_qg = moist_index_table( PARAM_qg , idomain )
   END IF
   moist_boundary_table( idomain, P_qg ) = .TRUE.
   moist_dname_table( idomain, P_qg ) = 'QGRAUP'
   moist_desc_table( idomain, P_qg ) = 'Graupel mixing ratio'
   moist_units_table( idomain, P_qg ) = 'kg kg-1'
   moist_streams_table( idomain, P_qg )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qg )%stream(2) = 2097152 
   F_qg = .TRUE.
   IF ( scalar_index_table( PARAM_ff1i01 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff1i01 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff1i01 , idomain ) = P_ff1i01
   ELSE
     P_ff1i01 = scalar_index_table( PARAM_ff1i01 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff1i01 ) = .TRUE.
   scalar_dname_table( idomain, P_ff1i01 ) = 'ff1i01'
   scalar_desc_table( idomain, P_ff1i01 ) = 'cloud/rain bin 1'
   scalar_units_table( idomain, P_ff1i01 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff1i01 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff1i01 )%stream(2) = 2097152 
   F_ff1i01 = .TRUE.
   IF ( scalar_index_table( PARAM_ff1i02 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff1i02 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff1i02 , idomain ) = P_ff1i02
   ELSE
     P_ff1i02 = scalar_index_table( PARAM_ff1i02 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff1i02 ) = .TRUE.
   scalar_dname_table( idomain, P_ff1i02 ) = 'ff1i02'
   scalar_desc_table( idomain, P_ff1i02 ) = 'cloud/rain bin 2'
   scalar_units_table( idomain, P_ff1i02 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff1i02 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff1i02 )%stream(2) = 2097152 
   F_ff1i02 = .TRUE.
   IF ( scalar_index_table( PARAM_ff1i03 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff1i03 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff1i03 , idomain ) = P_ff1i03
   ELSE
     P_ff1i03 = scalar_index_table( PARAM_ff1i03 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff1i03 ) = .TRUE.
   scalar_dname_table( idomain, P_ff1i03 ) = 'ff1i03'
   scalar_desc_table( idomain, P_ff1i03 ) = 'cloud/rain bin 3'
   scalar_units_table( idomain, P_ff1i03 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff1i03 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff1i03 )%stream(2) = 2097152 
   F_ff1i03 = .TRUE.
   IF ( scalar_index_table( PARAM_ff1i04 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff1i04 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff1i04 , idomain ) = P_ff1i04
   ELSE
     P_ff1i04 = scalar_index_table( PARAM_ff1i04 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff1i04 ) = .TRUE.
   scalar_dname_table( idomain, P_ff1i04 ) = 'ff1i04'
   scalar_desc_table( idomain, P_ff1i04 ) = 'cloud/rain bin 4'
   scalar_units_table( idomain, P_ff1i04 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff1i04 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff1i04 )%stream(2) = 2097152 
   F_ff1i04 = .TRUE.
   IF ( scalar_index_table( PARAM_ff1i05 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff1i05 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff1i05 , idomain ) = P_ff1i05
   ELSE
     P_ff1i05 = scalar_index_table( PARAM_ff1i05 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff1i05 ) = .TRUE.
   scalar_dname_table( idomain, P_ff1i05 ) = 'ff1i05'
   scalar_desc_table( idomain, P_ff1i05 ) = 'cloud/rain bin 5'
   scalar_units_table( idomain, P_ff1i05 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff1i05 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff1i05 )%stream(2) = 2097152 
   F_ff1i05 = .TRUE.
   IF ( scalar_index_table( PARAM_ff1i06 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff1i06 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff1i06 , idomain ) = P_ff1i06
   ELSE
     P_ff1i06 = scalar_index_table( PARAM_ff1i06 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff1i06 ) = .TRUE.
   scalar_dname_table( idomain, P_ff1i06 ) = 'ff1i06'
   scalar_desc_table( idomain, P_ff1i06 ) = 'cloud/rain bin 6'
   scalar_units_table( idomain, P_ff1i06 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff1i06 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff1i06 )%stream(2) = 2097152 
   F_ff1i06 = .TRUE.
   IF ( scalar_index_table( PARAM_ff1i07 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff1i07 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff1i07 , idomain ) = P_ff1i07
   ELSE
     P_ff1i07 = scalar_index_table( PARAM_ff1i07 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff1i07 ) = .TRUE.
   scalar_dname_table( idomain, P_ff1i07 ) = 'ff1i07'
   scalar_desc_table( idomain, P_ff1i07 ) = 'cloud/rain bin 7'
   scalar_units_table( idomain, P_ff1i07 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff1i07 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff1i07 )%stream(2) = 2097152 
   F_ff1i07 = .TRUE.
   IF ( scalar_index_table( PARAM_ff1i08 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff1i08 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff1i08 , idomain ) = P_ff1i08
   ELSE
     P_ff1i08 = scalar_index_table( PARAM_ff1i08 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff1i08 ) = .TRUE.
   scalar_dname_table( idomain, P_ff1i08 ) = 'ff1i08'
   scalar_desc_table( idomain, P_ff1i08 ) = 'cloud/rain bin 8'
   scalar_units_table( idomain, P_ff1i08 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff1i08 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff1i08 )%stream(2) = 2097152 
   F_ff1i08 = .TRUE.
   IF ( scalar_index_table( PARAM_ff1i09 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff1i09 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff1i09 , idomain ) = P_ff1i09
   ELSE
     P_ff1i09 = scalar_index_table( PARAM_ff1i09 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff1i09 ) = .TRUE.
   scalar_dname_table( idomain, P_ff1i09 ) = 'ff1i09'
   scalar_desc_table( idomain, P_ff1i09 ) = 'cloud/rain bin 9'
   scalar_units_table( idomain, P_ff1i09 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff1i09 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff1i09 )%stream(2) = 2097152 
   F_ff1i09 = .TRUE.
   IF ( scalar_index_table( PARAM_ff1i10 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff1i10 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff1i10 , idomain ) = P_ff1i10
   ELSE
     P_ff1i10 = scalar_index_table( PARAM_ff1i10 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff1i10 ) = .TRUE.
   scalar_dname_table( idomain, P_ff1i10 ) = 'ff1i10'
   scalar_desc_table( idomain, P_ff1i10 ) = 'cloud/rain bin 10'
   scalar_units_table( idomain, P_ff1i10 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff1i10 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff1i10 )%stream(2) = 2097152 
   F_ff1i10 = .TRUE.
   IF ( scalar_index_table( PARAM_ff1i11 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff1i11 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff1i11 , idomain ) = P_ff1i11
   ELSE
     P_ff1i11 = scalar_index_table( PARAM_ff1i11 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff1i11 ) = .TRUE.
   scalar_dname_table( idomain, P_ff1i11 ) = 'ff1i11'
   scalar_desc_table( idomain, P_ff1i11 ) = 'cloud/rain bin 11'
   scalar_units_table( idomain, P_ff1i11 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff1i11 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff1i11 )%stream(2) = 2097152 
   F_ff1i11 = .TRUE.
   IF ( scalar_index_table( PARAM_ff1i12 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff1i12 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff1i12 , idomain ) = P_ff1i12
   ELSE
     P_ff1i12 = scalar_index_table( PARAM_ff1i12 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff1i12 ) = .TRUE.
   scalar_dname_table( idomain, P_ff1i12 ) = 'ff1i12'
   scalar_desc_table( idomain, P_ff1i12 ) = 'cloud/rain bin 12'
   scalar_units_table( idomain, P_ff1i12 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff1i12 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff1i12 )%stream(2) = 2097152 
   F_ff1i12 = .TRUE.
   IF ( scalar_index_table( PARAM_ff1i13 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff1i13 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff1i13 , idomain ) = P_ff1i13
   ELSE
     P_ff1i13 = scalar_index_table( PARAM_ff1i13 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff1i13 ) = .TRUE.
   scalar_dname_table( idomain, P_ff1i13 ) = 'ff1i13'
   scalar_desc_table( idomain, P_ff1i13 ) = 'cloud/rain bin 13'
   scalar_units_table( idomain, P_ff1i13 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff1i13 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff1i13 )%stream(2) = 2097152 
   F_ff1i13 = .TRUE.
   IF ( scalar_index_table( PARAM_ff1i14 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff1i14 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff1i14 , idomain ) = P_ff1i14
   ELSE
     P_ff1i14 = scalar_index_table( PARAM_ff1i14 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff1i14 ) = .TRUE.
   scalar_dname_table( idomain, P_ff1i14 ) = 'ff1i14'
   scalar_desc_table( idomain, P_ff1i14 ) = 'cloud/rain bin 14'
   scalar_units_table( idomain, P_ff1i14 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff1i14 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff1i14 )%stream(2) = 2097152 
   F_ff1i14 = .TRUE.
   IF ( scalar_index_table( PARAM_ff1i15 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff1i15 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff1i15 , idomain ) = P_ff1i15
   ELSE
     P_ff1i15 = scalar_index_table( PARAM_ff1i15 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff1i15 ) = .TRUE.
   scalar_dname_table( idomain, P_ff1i15 ) = 'ff1i15'
   scalar_desc_table( idomain, P_ff1i15 ) = 'cloud/rain bin 15'
   scalar_units_table( idomain, P_ff1i15 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff1i15 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff1i15 )%stream(2) = 2097152 
   F_ff1i15 = .TRUE.
   IF ( scalar_index_table( PARAM_ff1i16 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff1i16 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff1i16 , idomain ) = P_ff1i16
   ELSE
     P_ff1i16 = scalar_index_table( PARAM_ff1i16 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff1i16 ) = .TRUE.
   scalar_dname_table( idomain, P_ff1i16 ) = 'ff1i16'
   scalar_desc_table( idomain, P_ff1i16 ) = 'cloud/rain bin 16'
   scalar_units_table( idomain, P_ff1i16 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff1i16 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff1i16 )%stream(2) = 2097152 
   F_ff1i16 = .TRUE.
   IF ( scalar_index_table( PARAM_ff1i17 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff1i17 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff1i17 , idomain ) = P_ff1i17
   ELSE
     P_ff1i17 = scalar_index_table( PARAM_ff1i17 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff1i17 ) = .TRUE.
   scalar_dname_table( idomain, P_ff1i17 ) = 'ff1i17'
   scalar_desc_table( idomain, P_ff1i17 ) = 'cloud/rain bin 17'
   scalar_units_table( idomain, P_ff1i17 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff1i17 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff1i17 )%stream(2) = 2097152 
   F_ff1i17 = .TRUE.
   IF ( scalar_index_table( PARAM_ff1i18 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff1i18 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff1i18 , idomain ) = P_ff1i18
   ELSE
     P_ff1i18 = scalar_index_table( PARAM_ff1i18 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff1i18 ) = .TRUE.
   scalar_dname_table( idomain, P_ff1i18 ) = 'ff1i18'
   scalar_desc_table( idomain, P_ff1i18 ) = 'cloud/rain bin 18'
   scalar_units_table( idomain, P_ff1i18 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff1i18 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff1i18 )%stream(2) = 2097152 
   F_ff1i18 = .TRUE.
   IF ( scalar_index_table( PARAM_ff1i19 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff1i19 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff1i19 , idomain ) = P_ff1i19
   ELSE
     P_ff1i19 = scalar_index_table( PARAM_ff1i19 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff1i19 ) = .TRUE.
   scalar_dname_table( idomain, P_ff1i19 ) = 'ff1i19'
   scalar_desc_table( idomain, P_ff1i19 ) = 'cloud/rain bin 19'
   scalar_units_table( idomain, P_ff1i19 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff1i19 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff1i19 )%stream(2) = 2097152 
   F_ff1i19 = .TRUE.
   IF ( scalar_index_table( PARAM_ff1i20 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff1i20 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff1i20 , idomain ) = P_ff1i20
   ELSE
     P_ff1i20 = scalar_index_table( PARAM_ff1i20 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff1i20 ) = .TRUE.
   scalar_dname_table( idomain, P_ff1i20 ) = 'ff1i20'
   scalar_desc_table( idomain, P_ff1i20 ) = 'cloud/rain bin 20'
   scalar_units_table( idomain, P_ff1i20 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff1i20 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff1i20 )%stream(2) = 2097152 
   F_ff1i20 = .TRUE.
   IF ( scalar_index_table( PARAM_ff1i21 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff1i21 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff1i21 , idomain ) = P_ff1i21
   ELSE
     P_ff1i21 = scalar_index_table( PARAM_ff1i21 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff1i21 ) = .TRUE.
   scalar_dname_table( idomain, P_ff1i21 ) = 'ff1i21'
   scalar_desc_table( idomain, P_ff1i21 ) = 'cloud/rain bin 21'
   scalar_units_table( idomain, P_ff1i21 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff1i21 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff1i21 )%stream(2) = 2097152 
   F_ff1i21 = .TRUE.
   IF ( scalar_index_table( PARAM_ff1i22 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff1i22 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff1i22 , idomain ) = P_ff1i22
   ELSE
     P_ff1i22 = scalar_index_table( PARAM_ff1i22 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff1i22 ) = .TRUE.
   scalar_dname_table( idomain, P_ff1i22 ) = 'ff1i22'
   scalar_desc_table( idomain, P_ff1i22 ) = 'cloud/rain bin 22'
   scalar_units_table( idomain, P_ff1i22 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff1i22 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff1i22 )%stream(2) = 2097152 
   F_ff1i22 = .TRUE.
   IF ( scalar_index_table( PARAM_ff1i23 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff1i23 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff1i23 , idomain ) = P_ff1i23
   ELSE
     P_ff1i23 = scalar_index_table( PARAM_ff1i23 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff1i23 ) = .TRUE.
   scalar_dname_table( idomain, P_ff1i23 ) = 'ff1i23'
   scalar_desc_table( idomain, P_ff1i23 ) = 'cloud/rain bin 23'
   scalar_units_table( idomain, P_ff1i23 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff1i23 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff1i23 )%stream(2) = 2097152 
   F_ff1i23 = .TRUE.
   IF ( scalar_index_table( PARAM_ff1i24 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff1i24 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff1i24 , idomain ) = P_ff1i24
   ELSE
     P_ff1i24 = scalar_index_table( PARAM_ff1i24 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff1i24 ) = .TRUE.
   scalar_dname_table( idomain, P_ff1i24 ) = 'ff1i24'
   scalar_desc_table( idomain, P_ff1i24 ) = 'cloud/rain bin 24'
   scalar_units_table( idomain, P_ff1i24 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff1i24 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff1i24 )%stream(2) = 2097152 
   F_ff1i24 = .TRUE.
   IF ( scalar_index_table( PARAM_ff1i25 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff1i25 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff1i25 , idomain ) = P_ff1i25
   ELSE
     P_ff1i25 = scalar_index_table( PARAM_ff1i25 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff1i25 ) = .TRUE.
   scalar_dname_table( idomain, P_ff1i25 ) = 'ff1i25'
   scalar_desc_table( idomain, P_ff1i25 ) = 'cloud/rain bin 25'
   scalar_units_table( idomain, P_ff1i25 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff1i25 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff1i25 )%stream(2) = 2097152 
   F_ff1i25 = .TRUE.
   IF ( scalar_index_table( PARAM_ff1i26 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff1i26 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff1i26 , idomain ) = P_ff1i26
   ELSE
     P_ff1i26 = scalar_index_table( PARAM_ff1i26 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff1i26 ) = .TRUE.
   scalar_dname_table( idomain, P_ff1i26 ) = 'ff1i26'
   scalar_desc_table( idomain, P_ff1i26 ) = 'cloud/rain bin 26'
   scalar_units_table( idomain, P_ff1i26 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff1i26 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff1i26 )%stream(2) = 2097152 
   F_ff1i26 = .TRUE.
   IF ( scalar_index_table( PARAM_ff1i27 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff1i27 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff1i27 , idomain ) = P_ff1i27
   ELSE
     P_ff1i27 = scalar_index_table( PARAM_ff1i27 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff1i27 ) = .TRUE.
   scalar_dname_table( idomain, P_ff1i27 ) = 'ff1i27'
   scalar_desc_table( idomain, P_ff1i27 ) = 'cloud/rain bin 27'
   scalar_units_table( idomain, P_ff1i27 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff1i27 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff1i27 )%stream(2) = 2097152 
   F_ff1i27 = .TRUE.
   IF ( scalar_index_table( PARAM_ff1i28 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff1i28 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff1i28 , idomain ) = P_ff1i28
   ELSE
     P_ff1i28 = scalar_index_table( PARAM_ff1i28 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff1i28 ) = .TRUE.
   scalar_dname_table( idomain, P_ff1i28 ) = 'ff1i28'
   scalar_desc_table( idomain, P_ff1i28 ) = 'cloud/rain bin 28'
   scalar_units_table( idomain, P_ff1i28 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff1i28 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff1i28 )%stream(2) = 2097152 
   F_ff1i28 = .TRUE.
   IF ( scalar_index_table( PARAM_ff1i29 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff1i29 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff1i29 , idomain ) = P_ff1i29
   ELSE
     P_ff1i29 = scalar_index_table( PARAM_ff1i29 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff1i29 ) = .TRUE.
   scalar_dname_table( idomain, P_ff1i29 ) = 'ff1i29'
   scalar_desc_table( idomain, P_ff1i29 ) = 'cloud/rain bin 29'
   scalar_units_table( idomain, P_ff1i29 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff1i29 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff1i29 )%stream(2) = 2097152 
   F_ff1i29 = .TRUE.
   IF ( scalar_index_table( PARAM_ff1i30 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff1i30 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff1i30 , idomain ) = P_ff1i30
   ELSE
     P_ff1i30 = scalar_index_table( PARAM_ff1i30 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff1i30 ) = .TRUE.
   scalar_dname_table( idomain, P_ff1i30 ) = 'ff1i30'
   scalar_desc_table( idomain, P_ff1i30 ) = 'cloud/rain bin 30'
   scalar_units_table( idomain, P_ff1i30 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff1i30 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff1i30 )%stream(2) = 2097152 
   F_ff1i30 = .TRUE.
   IF ( scalar_index_table( PARAM_ff1i31 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff1i31 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff1i31 , idomain ) = P_ff1i31
   ELSE
     P_ff1i31 = scalar_index_table( PARAM_ff1i31 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff1i31 ) = .TRUE.
   scalar_dname_table( idomain, P_ff1i31 ) = 'ff1i31'
   scalar_desc_table( idomain, P_ff1i31 ) = 'cloud/rain bin 31'
   scalar_units_table( idomain, P_ff1i31 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff1i31 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff1i31 )%stream(2) = 2097152 
   F_ff1i31 = .TRUE.
   IF ( scalar_index_table( PARAM_ff1i32 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff1i32 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff1i32 , idomain ) = P_ff1i32
   ELSE
     P_ff1i32 = scalar_index_table( PARAM_ff1i32 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff1i32 ) = .TRUE.
   scalar_dname_table( idomain, P_ff1i32 ) = 'ff1i32'
   scalar_desc_table( idomain, P_ff1i32 ) = 'cloud/rain bin 32'
   scalar_units_table( idomain, P_ff1i32 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff1i32 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff1i32 )%stream(2) = 2097152 
   F_ff1i32 = .TRUE.
   IF ( scalar_index_table( PARAM_ff1i33 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff1i33 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff1i33 , idomain ) = P_ff1i33
   ELSE
     P_ff1i33 = scalar_index_table( PARAM_ff1i33 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff1i33 ) = .TRUE.
   scalar_dname_table( idomain, P_ff1i33 ) = 'ff1i33'
   scalar_desc_table( idomain, P_ff1i33 ) = 'cloud/rain bin 33'
   scalar_units_table( idomain, P_ff1i33 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff1i33 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff1i33 )%stream(2) = 2097152 
   F_ff1i33 = .TRUE.
   IF ( scalar_index_table( PARAM_ff5i01 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff5i01 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff5i01 , idomain ) = P_ff5i01
   ELSE
     P_ff5i01 = scalar_index_table( PARAM_ff5i01 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff5i01 ) = .TRUE.
   scalar_dname_table( idomain, P_ff5i01 ) = 'ff5i01'
   scalar_desc_table( idomain, P_ff5i01 ) = 'snow bin 1'
   scalar_units_table( idomain, P_ff5i01 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff5i01 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff5i01 )%stream(2) = 2097152 
   F_ff5i01 = .TRUE.
   IF ( scalar_index_table( PARAM_ff5i02 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff5i02 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff5i02 , idomain ) = P_ff5i02
   ELSE
     P_ff5i02 = scalar_index_table( PARAM_ff5i02 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff5i02 ) = .TRUE.
   scalar_dname_table( idomain, P_ff5i02 ) = 'ff5i02'
   scalar_desc_table( idomain, P_ff5i02 ) = 'snow bin 2'
   scalar_units_table( idomain, P_ff5i02 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff5i02 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff5i02 )%stream(2) = 2097152 
   F_ff5i02 = .TRUE.
   IF ( scalar_index_table( PARAM_ff5i03 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff5i03 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff5i03 , idomain ) = P_ff5i03
   ELSE
     P_ff5i03 = scalar_index_table( PARAM_ff5i03 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff5i03 ) = .TRUE.
   scalar_dname_table( idomain, P_ff5i03 ) = 'ff5i03'
   scalar_desc_table( idomain, P_ff5i03 ) = 'snow bin 3'
   scalar_units_table( idomain, P_ff5i03 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff5i03 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff5i03 )%stream(2) = 2097152 
   F_ff5i03 = .TRUE.
   IF ( scalar_index_table( PARAM_ff5i04 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff5i04 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff5i04 , idomain ) = P_ff5i04
   ELSE
     P_ff5i04 = scalar_index_table( PARAM_ff5i04 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff5i04 ) = .TRUE.
   scalar_dname_table( idomain, P_ff5i04 ) = 'ff5i04'
   scalar_desc_table( idomain, P_ff5i04 ) = 'snow bin 4'
   scalar_units_table( idomain, P_ff5i04 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff5i04 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff5i04 )%stream(2) = 2097152 
   F_ff5i04 = .TRUE.
   IF ( scalar_index_table( PARAM_ff5i05 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff5i05 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff5i05 , idomain ) = P_ff5i05
   ELSE
     P_ff5i05 = scalar_index_table( PARAM_ff5i05 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff5i05 ) = .TRUE.
   scalar_dname_table( idomain, P_ff5i05 ) = 'ff5i05'
   scalar_desc_table( idomain, P_ff5i05 ) = 'snow bin 5'
   scalar_units_table( idomain, P_ff5i05 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff5i05 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff5i05 )%stream(2) = 2097152 
   F_ff5i05 = .TRUE.
   IF ( scalar_index_table( PARAM_ff5i06 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff5i06 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff5i06 , idomain ) = P_ff5i06
   ELSE
     P_ff5i06 = scalar_index_table( PARAM_ff5i06 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff5i06 ) = .TRUE.
   scalar_dname_table( idomain, P_ff5i06 ) = 'ff5i06'
   scalar_desc_table( idomain, P_ff5i06 ) = 'snow bin 6'
   scalar_units_table( idomain, P_ff5i06 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff5i06 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff5i06 )%stream(2) = 2097152 
   F_ff5i06 = .TRUE.
   IF ( scalar_index_table( PARAM_ff5i07 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff5i07 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff5i07 , idomain ) = P_ff5i07
   ELSE
     P_ff5i07 = scalar_index_table( PARAM_ff5i07 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff5i07 ) = .TRUE.
   scalar_dname_table( idomain, P_ff5i07 ) = 'ff5i07'
   scalar_desc_table( idomain, P_ff5i07 ) = 'snow bin 7'
   scalar_units_table( idomain, P_ff5i07 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff5i07 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff5i07 )%stream(2) = 2097152 
   F_ff5i07 = .TRUE.
   IF ( scalar_index_table( PARAM_ff5i08 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff5i08 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff5i08 , idomain ) = P_ff5i08
   ELSE
     P_ff5i08 = scalar_index_table( PARAM_ff5i08 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff5i08 ) = .TRUE.
   scalar_dname_table( idomain, P_ff5i08 ) = 'ff5i08'
   scalar_desc_table( idomain, P_ff5i08 ) = 'snow bin 8'
   scalar_units_table( idomain, P_ff5i08 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff5i08 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff5i08 )%stream(2) = 2097152 
   F_ff5i08 = .TRUE.
   IF ( scalar_index_table( PARAM_ff5i09 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff5i09 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff5i09 , idomain ) = P_ff5i09
   ELSE
     P_ff5i09 = scalar_index_table( PARAM_ff5i09 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff5i09 ) = .TRUE.
   scalar_dname_table( idomain, P_ff5i09 ) = 'ff5i09'
   scalar_desc_table( idomain, P_ff5i09 ) = 'snow bin 9'
   scalar_units_table( idomain, P_ff5i09 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff5i09 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff5i09 )%stream(2) = 2097152 
   F_ff5i09 = .TRUE.
   IF ( scalar_index_table( PARAM_ff5i10 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff5i10 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff5i10 , idomain ) = P_ff5i10
   ELSE
     P_ff5i10 = scalar_index_table( PARAM_ff5i10 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff5i10 ) = .TRUE.
   scalar_dname_table( idomain, P_ff5i10 ) = 'ff5i10'
   scalar_desc_table( idomain, P_ff5i10 ) = 'snow bin 10'
   scalar_units_table( idomain, P_ff5i10 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff5i10 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff5i10 )%stream(2) = 2097152 
   F_ff5i10 = .TRUE.
   IF ( scalar_index_table( PARAM_ff5i11 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff5i11 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff5i11 , idomain ) = P_ff5i11
   ELSE
     P_ff5i11 = scalar_index_table( PARAM_ff5i11 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff5i11 ) = .TRUE.
   scalar_dname_table( idomain, P_ff5i11 ) = 'ff5i11'
   scalar_desc_table( idomain, P_ff5i11 ) = 'snow bin 11'
   scalar_units_table( idomain, P_ff5i11 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff5i11 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff5i11 )%stream(2) = 2097152 
   F_ff5i11 = .TRUE.
   IF ( scalar_index_table( PARAM_ff5i12 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff5i12 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff5i12 , idomain ) = P_ff5i12
   ELSE
     P_ff5i12 = scalar_index_table( PARAM_ff5i12 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff5i12 ) = .TRUE.
   scalar_dname_table( idomain, P_ff5i12 ) = 'ff5i12'
   scalar_desc_table( idomain, P_ff5i12 ) = 'snow bin 12'
   scalar_units_table( idomain, P_ff5i12 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff5i12 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff5i12 )%stream(2) = 2097152 
   F_ff5i12 = .TRUE.
   IF ( scalar_index_table( PARAM_ff5i13 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff5i13 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff5i13 , idomain ) = P_ff5i13
   ELSE
     P_ff5i13 = scalar_index_table( PARAM_ff5i13 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff5i13 ) = .TRUE.
   scalar_dname_table( idomain, P_ff5i13 ) = 'ff5i13'
   scalar_desc_table( idomain, P_ff5i13 ) = 'snow bin 13'
   scalar_units_table( idomain, P_ff5i13 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff5i13 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff5i13 )%stream(2) = 2097152 
   F_ff5i13 = .TRUE.
   IF ( scalar_index_table( PARAM_ff5i14 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff5i14 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff5i14 , idomain ) = P_ff5i14
   ELSE
     P_ff5i14 = scalar_index_table( PARAM_ff5i14 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff5i14 ) = .TRUE.
   scalar_dname_table( idomain, P_ff5i14 ) = 'ff5i14'
   scalar_desc_table( idomain, P_ff5i14 ) = 'snow bin 14'
   scalar_units_table( idomain, P_ff5i14 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff5i14 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff5i14 )%stream(2) = 2097152 
   F_ff5i14 = .TRUE.
   IF ( scalar_index_table( PARAM_ff5i15 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff5i15 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff5i15 , idomain ) = P_ff5i15
   ELSE
     P_ff5i15 = scalar_index_table( PARAM_ff5i15 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff5i15 ) = .TRUE.
   scalar_dname_table( idomain, P_ff5i15 ) = 'ff5i15'
   scalar_desc_table( idomain, P_ff5i15 ) = 'snow bin 15'
   scalar_units_table( idomain, P_ff5i15 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff5i15 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff5i15 )%stream(2) = 2097152 
   F_ff5i15 = .TRUE.
   IF ( scalar_index_table( PARAM_ff5i16 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff5i16 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff5i16 , idomain ) = P_ff5i16
   ELSE
     P_ff5i16 = scalar_index_table( PARAM_ff5i16 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff5i16 ) = .TRUE.
   scalar_dname_table( idomain, P_ff5i16 ) = 'ff5i16'
   scalar_desc_table( idomain, P_ff5i16 ) = 'snow bin 16'
   scalar_units_table( idomain, P_ff5i16 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff5i16 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff5i16 )%stream(2) = 2097152 
   F_ff5i16 = .TRUE.
   IF ( scalar_index_table( PARAM_ff5i17 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff5i17 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff5i17 , idomain ) = P_ff5i17
   ELSE
     P_ff5i17 = scalar_index_table( PARAM_ff5i17 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff5i17 ) = .TRUE.
   scalar_dname_table( idomain, P_ff5i17 ) = 'ff5i17'
   scalar_desc_table( idomain, P_ff5i17 ) = 'snow bin 17'
   scalar_units_table( idomain, P_ff5i17 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff5i17 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff5i17 )%stream(2) = 2097152 
   F_ff5i17 = .TRUE.
   IF ( scalar_index_table( PARAM_ff5i18 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff5i18 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff5i18 , idomain ) = P_ff5i18
   ELSE
     P_ff5i18 = scalar_index_table( PARAM_ff5i18 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff5i18 ) = .TRUE.
   scalar_dname_table( idomain, P_ff5i18 ) = 'ff5i18'
   scalar_desc_table( idomain, P_ff5i18 ) = 'snow bin 18'
   scalar_units_table( idomain, P_ff5i18 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff5i18 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff5i18 )%stream(2) = 2097152 
   F_ff5i18 = .TRUE.
   IF ( scalar_index_table( PARAM_ff5i19 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff5i19 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff5i19 , idomain ) = P_ff5i19
   ELSE
     P_ff5i19 = scalar_index_table( PARAM_ff5i19 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff5i19 ) = .TRUE.
   scalar_dname_table( idomain, P_ff5i19 ) = 'ff5i19'
   scalar_desc_table( idomain, P_ff5i19 ) = 'snow bin 19'
   scalar_units_table( idomain, P_ff5i19 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff5i19 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff5i19 )%stream(2) = 2097152 
   F_ff5i19 = .TRUE.
   IF ( scalar_index_table( PARAM_ff5i20 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff5i20 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff5i20 , idomain ) = P_ff5i20
   ELSE
     P_ff5i20 = scalar_index_table( PARAM_ff5i20 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff5i20 ) = .TRUE.
   scalar_dname_table( idomain, P_ff5i20 ) = 'ff5i20'
   scalar_desc_table( idomain, P_ff5i20 ) = 'snow bin 20'
   scalar_units_table( idomain, P_ff5i20 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff5i20 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff5i20 )%stream(2) = 2097152 
   F_ff5i20 = .TRUE.
   IF ( scalar_index_table( PARAM_ff5i21 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff5i21 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff5i21 , idomain ) = P_ff5i21
   ELSE
     P_ff5i21 = scalar_index_table( PARAM_ff5i21 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff5i21 ) = .TRUE.
   scalar_dname_table( idomain, P_ff5i21 ) = 'ff5i21'
   scalar_desc_table( idomain, P_ff5i21 ) = 'snow bin 21'
   scalar_units_table( idomain, P_ff5i21 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff5i21 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff5i21 )%stream(2) = 2097152 
   F_ff5i21 = .TRUE.
   IF ( scalar_index_table( PARAM_ff5i22 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff5i22 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff5i22 , idomain ) = P_ff5i22
   ELSE
     P_ff5i22 = scalar_index_table( PARAM_ff5i22 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff5i22 ) = .TRUE.
   scalar_dname_table( idomain, P_ff5i22 ) = 'ff5i22'
   scalar_desc_table( idomain, P_ff5i22 ) = 'snow bin 22'
   scalar_units_table( idomain, P_ff5i22 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff5i22 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff5i22 )%stream(2) = 2097152 
   F_ff5i22 = .TRUE.
   IF ( scalar_index_table( PARAM_ff5i23 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff5i23 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff5i23 , idomain ) = P_ff5i23
   ELSE
     P_ff5i23 = scalar_index_table( PARAM_ff5i23 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff5i23 ) = .TRUE.
   scalar_dname_table( idomain, P_ff5i23 ) = 'ff5i23'
   scalar_desc_table( idomain, P_ff5i23 ) = 'snow bin 23'
   scalar_units_table( idomain, P_ff5i23 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff5i23 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff5i23 )%stream(2) = 2097152 
   F_ff5i23 = .TRUE.
   IF ( scalar_index_table( PARAM_ff5i24 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff5i24 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff5i24 , idomain ) = P_ff5i24
   ELSE
     P_ff5i24 = scalar_index_table( PARAM_ff5i24 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff5i24 ) = .TRUE.
   scalar_dname_table( idomain, P_ff5i24 ) = 'ff5i24'
   scalar_desc_table( idomain, P_ff5i24 ) = 'snow bin 24'
   scalar_units_table( idomain, P_ff5i24 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff5i24 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff5i24 )%stream(2) = 2097152 
   F_ff5i24 = .TRUE.
   IF ( scalar_index_table( PARAM_ff5i25 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff5i25 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff5i25 , idomain ) = P_ff5i25
   ELSE
     P_ff5i25 = scalar_index_table( PARAM_ff5i25 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff5i25 ) = .TRUE.
   scalar_dname_table( idomain, P_ff5i25 ) = 'ff5i25'
   scalar_desc_table( idomain, P_ff5i25 ) = 'snow bin 25'
   scalar_units_table( idomain, P_ff5i25 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff5i25 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff5i25 )%stream(2) = 2097152 
   F_ff5i25 = .TRUE.
   IF ( scalar_index_table( PARAM_ff5i26 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff5i26 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff5i26 , idomain ) = P_ff5i26
   ELSE
     P_ff5i26 = scalar_index_table( PARAM_ff5i26 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff5i26 ) = .TRUE.
   scalar_dname_table( idomain, P_ff5i26 ) = 'ff5i26'
   scalar_desc_table( idomain, P_ff5i26 ) = 'snow bin 26'
   scalar_units_table( idomain, P_ff5i26 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff5i26 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff5i26 )%stream(2) = 2097152 
   F_ff5i26 = .TRUE.
   IF ( scalar_index_table( PARAM_ff5i27 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff5i27 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff5i27 , idomain ) = P_ff5i27
   ELSE
     P_ff5i27 = scalar_index_table( PARAM_ff5i27 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff5i27 ) = .TRUE.
   scalar_dname_table( idomain, P_ff5i27 ) = 'ff5i27'
   scalar_desc_table( idomain, P_ff5i27 ) = 'snow bin 27'
   scalar_units_table( idomain, P_ff5i27 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff5i27 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff5i27 )%stream(2) = 2097152 
   F_ff5i27 = .TRUE.
   IF ( scalar_index_table( PARAM_ff5i28 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff5i28 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff5i28 , idomain ) = P_ff5i28
   ELSE
     P_ff5i28 = scalar_index_table( PARAM_ff5i28 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff5i28 ) = .TRUE.
   scalar_dname_table( idomain, P_ff5i28 ) = 'ff5i28'
   scalar_desc_table( idomain, P_ff5i28 ) = 'snow bin 28'
   scalar_units_table( idomain, P_ff5i28 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff5i28 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff5i28 )%stream(2) = 2097152 
   F_ff5i28 = .TRUE.
   IF ( scalar_index_table( PARAM_ff5i29 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff5i29 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff5i29 , idomain ) = P_ff5i29
   ELSE
     P_ff5i29 = scalar_index_table( PARAM_ff5i29 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff5i29 ) = .TRUE.
   scalar_dname_table( idomain, P_ff5i29 ) = 'ff5i29'
   scalar_desc_table( idomain, P_ff5i29 ) = 'snow bin 29'
   scalar_units_table( idomain, P_ff5i29 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff5i29 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff5i29 )%stream(2) = 2097152 
   F_ff5i29 = .TRUE.
   IF ( scalar_index_table( PARAM_ff5i30 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff5i30 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff5i30 , idomain ) = P_ff5i30
   ELSE
     P_ff5i30 = scalar_index_table( PARAM_ff5i30 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff5i30 ) = .TRUE.
   scalar_dname_table( idomain, P_ff5i30 ) = 'ff5i30'
   scalar_desc_table( idomain, P_ff5i30 ) = 'snow bin 30'
   scalar_units_table( idomain, P_ff5i30 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff5i30 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff5i30 )%stream(2) = 2097152 
   F_ff5i30 = .TRUE.
   IF ( scalar_index_table( PARAM_ff5i31 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff5i31 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff5i31 , idomain ) = P_ff5i31
   ELSE
     P_ff5i31 = scalar_index_table( PARAM_ff5i31 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff5i31 ) = .TRUE.
   scalar_dname_table( idomain, P_ff5i31 ) = 'ff5i31'
   scalar_desc_table( idomain, P_ff5i31 ) = 'snow bin 31'
   scalar_units_table( idomain, P_ff5i31 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff5i31 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff5i31 )%stream(2) = 2097152 
   F_ff5i31 = .TRUE.
   IF ( scalar_index_table( PARAM_ff5i32 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff5i32 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff5i32 , idomain ) = P_ff5i32
   ELSE
     P_ff5i32 = scalar_index_table( PARAM_ff5i32 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff5i32 ) = .TRUE.
   scalar_dname_table( idomain, P_ff5i32 ) = 'ff5i32'
   scalar_desc_table( idomain, P_ff5i32 ) = 'snow bin 32'
   scalar_units_table( idomain, P_ff5i32 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff5i32 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff5i32 )%stream(2) = 2097152 
   F_ff5i32 = .TRUE.
   IF ( scalar_index_table( PARAM_ff5i33 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff5i33 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff5i33 , idomain ) = P_ff5i33
   ELSE
     P_ff5i33 = scalar_index_table( PARAM_ff5i33 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff5i33 ) = .TRUE.
   scalar_dname_table( idomain, P_ff5i33 ) = 'ff5i33'
   scalar_desc_table( idomain, P_ff5i33 ) = 'snow bin 33'
   scalar_units_table( idomain, P_ff5i33 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff5i33 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff5i33 )%stream(2) = 2097152 
   F_ff5i33 = .TRUE.
   IF ( scalar_index_table( PARAM_ff6i01 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff6i01 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff6i01 , idomain ) = P_ff6i01
   ELSE
     P_ff6i01 = scalar_index_table( PARAM_ff6i01 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff6i01 ) = .TRUE.
   scalar_dname_table( idomain, P_ff6i01 ) = 'ff6i01'
   scalar_desc_table( idomain, P_ff6i01 ) = 'graupel bin 1'
   scalar_units_table( idomain, P_ff6i01 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff6i01 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff6i01 )%stream(2) = 2097152 
   F_ff6i01 = .TRUE.
   IF ( scalar_index_table( PARAM_ff6i02 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff6i02 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff6i02 , idomain ) = P_ff6i02
   ELSE
     P_ff6i02 = scalar_index_table( PARAM_ff6i02 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff6i02 ) = .TRUE.
   scalar_dname_table( idomain, P_ff6i02 ) = 'ff6i02'
   scalar_desc_table( idomain, P_ff6i02 ) = 'graupel bin 2'
   scalar_units_table( idomain, P_ff6i02 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff6i02 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff6i02 )%stream(2) = 2097152 
   F_ff6i02 = .TRUE.
   IF ( scalar_index_table( PARAM_ff6i03 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff6i03 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff6i03 , idomain ) = P_ff6i03
   ELSE
     P_ff6i03 = scalar_index_table( PARAM_ff6i03 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff6i03 ) = .TRUE.
   scalar_dname_table( idomain, P_ff6i03 ) = 'ff6i03'
   scalar_desc_table( idomain, P_ff6i03 ) = 'graupel bin 3'
   scalar_units_table( idomain, P_ff6i03 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff6i03 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff6i03 )%stream(2) = 2097152 
   F_ff6i03 = .TRUE.
   IF ( scalar_index_table( PARAM_ff6i04 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff6i04 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff6i04 , idomain ) = P_ff6i04
   ELSE
     P_ff6i04 = scalar_index_table( PARAM_ff6i04 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff6i04 ) = .TRUE.
   scalar_dname_table( idomain, P_ff6i04 ) = 'ff6i04'
   scalar_desc_table( idomain, P_ff6i04 ) = 'graupel bin 4'
   scalar_units_table( idomain, P_ff6i04 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff6i04 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff6i04 )%stream(2) = 2097152 
   F_ff6i04 = .TRUE.
   IF ( scalar_index_table( PARAM_ff6i05 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff6i05 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff6i05 , idomain ) = P_ff6i05
   ELSE
     P_ff6i05 = scalar_index_table( PARAM_ff6i05 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff6i05 ) = .TRUE.
   scalar_dname_table( idomain, P_ff6i05 ) = 'ff6i05'
   scalar_desc_table( idomain, P_ff6i05 ) = 'graupel bin 5'
   scalar_units_table( idomain, P_ff6i05 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff6i05 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff6i05 )%stream(2) = 2097152 
   F_ff6i05 = .TRUE.
   IF ( scalar_index_table( PARAM_ff6i06 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff6i06 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff6i06 , idomain ) = P_ff6i06
   ELSE
     P_ff6i06 = scalar_index_table( PARAM_ff6i06 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff6i06 ) = .TRUE.
   scalar_dname_table( idomain, P_ff6i06 ) = 'ff6i06'
   scalar_desc_table( idomain, P_ff6i06 ) = 'graupel bin 6'
   scalar_units_table( idomain, P_ff6i06 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff6i06 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff6i06 )%stream(2) = 2097152 
   F_ff6i06 = .TRUE.
   IF ( scalar_index_table( PARAM_ff6i07 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff6i07 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff6i07 , idomain ) = P_ff6i07
   ELSE
     P_ff6i07 = scalar_index_table( PARAM_ff6i07 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff6i07 ) = .TRUE.
   scalar_dname_table( idomain, P_ff6i07 ) = 'ff6i07'
   scalar_desc_table( idomain, P_ff6i07 ) = 'graupel bin 7'
   scalar_units_table( idomain, P_ff6i07 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff6i07 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff6i07 )%stream(2) = 2097152 
   F_ff6i07 = .TRUE.
   IF ( scalar_index_table( PARAM_ff6i08 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff6i08 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff6i08 , idomain ) = P_ff6i08
   ELSE
     P_ff6i08 = scalar_index_table( PARAM_ff6i08 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff6i08 ) = .TRUE.
   scalar_dname_table( idomain, P_ff6i08 ) = 'ff6i08'
   scalar_desc_table( idomain, P_ff6i08 ) = 'graupel bin 8'
   scalar_units_table( idomain, P_ff6i08 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff6i08 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff6i08 )%stream(2) = 2097152 
   F_ff6i08 = .TRUE.
   IF ( scalar_index_table( PARAM_ff6i09 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff6i09 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff6i09 , idomain ) = P_ff6i09
   ELSE
     P_ff6i09 = scalar_index_table( PARAM_ff6i09 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff6i09 ) = .TRUE.
   scalar_dname_table( idomain, P_ff6i09 ) = 'ff6i09'
   scalar_desc_table( idomain, P_ff6i09 ) = 'graupel bin 9'
   scalar_units_table( idomain, P_ff6i09 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff6i09 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff6i09 )%stream(2) = 2097152 
   F_ff6i09 = .TRUE.
   IF ( scalar_index_table( PARAM_ff6i10 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff6i10 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff6i10 , idomain ) = P_ff6i10
   ELSE
     P_ff6i10 = scalar_index_table( PARAM_ff6i10 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff6i10 ) = .TRUE.
   scalar_dname_table( idomain, P_ff6i10 ) = 'ff6i10'
   scalar_desc_table( idomain, P_ff6i10 ) = 'graupel bin 10'
   scalar_units_table( idomain, P_ff6i10 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff6i10 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff6i10 )%stream(2) = 2097152 
   F_ff6i10 = .TRUE.
   IF ( scalar_index_table( PARAM_ff6i11 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff6i11 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff6i11 , idomain ) = P_ff6i11
   ELSE
     P_ff6i11 = scalar_index_table( PARAM_ff6i11 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff6i11 ) = .TRUE.
   scalar_dname_table( idomain, P_ff6i11 ) = 'ff6i11'
   scalar_desc_table( idomain, P_ff6i11 ) = 'graupel bin 11'
   scalar_units_table( idomain, P_ff6i11 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff6i11 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff6i11 )%stream(2) = 2097152 
   F_ff6i11 = .TRUE.
   IF ( scalar_index_table( PARAM_ff6i12 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff6i12 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff6i12 , idomain ) = P_ff6i12
   ELSE
     P_ff6i12 = scalar_index_table( PARAM_ff6i12 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff6i12 ) = .TRUE.
   scalar_dname_table( idomain, P_ff6i12 ) = 'ff6i12'
   scalar_desc_table( idomain, P_ff6i12 ) = 'graupel bin 12'
   scalar_units_table( idomain, P_ff6i12 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff6i12 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff6i12 )%stream(2) = 2097152 
   F_ff6i12 = .TRUE.
   IF ( scalar_index_table( PARAM_ff6i13 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff6i13 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff6i13 , idomain ) = P_ff6i13
   ELSE
     P_ff6i13 = scalar_index_table( PARAM_ff6i13 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff6i13 ) = .TRUE.
   scalar_dname_table( idomain, P_ff6i13 ) = 'ff6i13'
   scalar_desc_table( idomain, P_ff6i13 ) = 'graupel bin 13'
   scalar_units_table( idomain, P_ff6i13 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff6i13 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff6i13 )%stream(2) = 2097152 
   F_ff6i13 = .TRUE.
   IF ( scalar_index_table( PARAM_ff6i14 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff6i14 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff6i14 , idomain ) = P_ff6i14
   ELSE
     P_ff6i14 = scalar_index_table( PARAM_ff6i14 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff6i14 ) = .TRUE.
   scalar_dname_table( idomain, P_ff6i14 ) = 'ff6i14'
   scalar_desc_table( idomain, P_ff6i14 ) = 'graupel bin 14'
   scalar_units_table( idomain, P_ff6i14 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff6i14 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff6i14 )%stream(2) = 2097152 
   F_ff6i14 = .TRUE.
   IF ( scalar_index_table( PARAM_ff6i15 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff6i15 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff6i15 , idomain ) = P_ff6i15
   ELSE
     P_ff6i15 = scalar_index_table( PARAM_ff6i15 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff6i15 ) = .TRUE.
   scalar_dname_table( idomain, P_ff6i15 ) = 'ff6i15'
   scalar_desc_table( idomain, P_ff6i15 ) = 'graupel bin 15'
   scalar_units_table( idomain, P_ff6i15 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff6i15 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff6i15 )%stream(2) = 2097152 
   F_ff6i15 = .TRUE.
   IF ( scalar_index_table( PARAM_ff6i16 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff6i16 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff6i16 , idomain ) = P_ff6i16
   ELSE
     P_ff6i16 = scalar_index_table( PARAM_ff6i16 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff6i16 ) = .TRUE.
   scalar_dname_table( idomain, P_ff6i16 ) = 'ff6i16'
   scalar_desc_table( idomain, P_ff6i16 ) = 'graupel bin 16'
   scalar_units_table( idomain, P_ff6i16 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff6i16 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff6i16 )%stream(2) = 2097152 
   F_ff6i16 = .TRUE.
   IF ( scalar_index_table( PARAM_ff6i17 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff6i17 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff6i17 , idomain ) = P_ff6i17
   ELSE
     P_ff6i17 = scalar_index_table( PARAM_ff6i17 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff6i17 ) = .TRUE.
   scalar_dname_table( idomain, P_ff6i17 ) = 'ff6i17'
   scalar_desc_table( idomain, P_ff6i17 ) = 'graupel bin 17'
   scalar_units_table( idomain, P_ff6i17 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff6i17 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff6i17 )%stream(2) = 2097152 
   F_ff6i17 = .TRUE.
   IF ( scalar_index_table( PARAM_ff6i18 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff6i18 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff6i18 , idomain ) = P_ff6i18
   ELSE
     P_ff6i18 = scalar_index_table( PARAM_ff6i18 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff6i18 ) = .TRUE.
   scalar_dname_table( idomain, P_ff6i18 ) = 'ff6i18'
   scalar_desc_table( idomain, P_ff6i18 ) = 'graupel bin 18'
   scalar_units_table( idomain, P_ff6i18 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff6i18 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff6i18 )%stream(2) = 2097152 
   F_ff6i18 = .TRUE.
   IF ( scalar_index_table( PARAM_ff6i19 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff6i19 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff6i19 , idomain ) = P_ff6i19
   ELSE
     P_ff6i19 = scalar_index_table( PARAM_ff6i19 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff6i19 ) = .TRUE.
   scalar_dname_table( idomain, P_ff6i19 ) = 'ff6i19'
   scalar_desc_table( idomain, P_ff6i19 ) = 'graupel bin 19'
   scalar_units_table( idomain, P_ff6i19 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff6i19 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff6i19 )%stream(2) = 2097152 
   F_ff6i19 = .TRUE.
   IF ( scalar_index_table( PARAM_ff6i20 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff6i20 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff6i20 , idomain ) = P_ff6i20
   ELSE
     P_ff6i20 = scalar_index_table( PARAM_ff6i20 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff6i20 ) = .TRUE.
   scalar_dname_table( idomain, P_ff6i20 ) = 'ff6i20'
   scalar_desc_table( idomain, P_ff6i20 ) = 'graupel bin 20'
   scalar_units_table( idomain, P_ff6i20 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff6i20 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff6i20 )%stream(2) = 2097152 
   F_ff6i20 = .TRUE.
   IF ( scalar_index_table( PARAM_ff6i21 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff6i21 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff6i21 , idomain ) = P_ff6i21
   ELSE
     P_ff6i21 = scalar_index_table( PARAM_ff6i21 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff6i21 ) = .TRUE.
   scalar_dname_table( idomain, P_ff6i21 ) = 'ff6i21'
   scalar_desc_table( idomain, P_ff6i21 ) = 'graupel bin 21'
   scalar_units_table( idomain, P_ff6i21 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff6i21 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff6i21 )%stream(2) = 2097152 
   F_ff6i21 = .TRUE.
   IF ( scalar_index_table( PARAM_ff6i22 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff6i22 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff6i22 , idomain ) = P_ff6i22
   ELSE
     P_ff6i22 = scalar_index_table( PARAM_ff6i22 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff6i22 ) = .TRUE.
   scalar_dname_table( idomain, P_ff6i22 ) = 'ff6i22'
   scalar_desc_table( idomain, P_ff6i22 ) = 'graupel bin 22'
   scalar_units_table( idomain, P_ff6i22 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff6i22 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff6i22 )%stream(2) = 2097152 
   F_ff6i22 = .TRUE.
   IF ( scalar_index_table( PARAM_ff6i23 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff6i23 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff6i23 , idomain ) = P_ff6i23
   ELSE
     P_ff6i23 = scalar_index_table( PARAM_ff6i23 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff6i23 ) = .TRUE.
   scalar_dname_table( idomain, P_ff6i23 ) = 'ff6i23'
   scalar_desc_table( idomain, P_ff6i23 ) = 'graupel bin 23'
   scalar_units_table( idomain, P_ff6i23 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff6i23 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff6i23 )%stream(2) = 2097152 
   F_ff6i23 = .TRUE.
   IF ( scalar_index_table( PARAM_ff6i24 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff6i24 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff6i24 , idomain ) = P_ff6i24
   ELSE
     P_ff6i24 = scalar_index_table( PARAM_ff6i24 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff6i24 ) = .TRUE.
   scalar_dname_table( idomain, P_ff6i24 ) = 'ff6i24'
   scalar_desc_table( idomain, P_ff6i24 ) = 'graupel bin 24'
   scalar_units_table( idomain, P_ff6i24 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff6i24 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff6i24 )%stream(2) = 2097152 
   F_ff6i24 = .TRUE.
   IF ( scalar_index_table( PARAM_ff6i25 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff6i25 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff6i25 , idomain ) = P_ff6i25
   ELSE
     P_ff6i25 = scalar_index_table( PARAM_ff6i25 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff6i25 ) = .TRUE.
   scalar_dname_table( idomain, P_ff6i25 ) = 'ff6i25'
   scalar_desc_table( idomain, P_ff6i25 ) = 'graupel bin 25'
   scalar_units_table( idomain, P_ff6i25 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff6i25 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff6i25 )%stream(2) = 2097152 
   F_ff6i25 = .TRUE.
   IF ( scalar_index_table( PARAM_ff6i26 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff6i26 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff6i26 , idomain ) = P_ff6i26
   ELSE
     P_ff6i26 = scalar_index_table( PARAM_ff6i26 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff6i26 ) = .TRUE.
   scalar_dname_table( idomain, P_ff6i26 ) = 'ff6i26'
   scalar_desc_table( idomain, P_ff6i26 ) = 'graupel bin 26'
   scalar_units_table( idomain, P_ff6i26 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff6i26 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff6i26 )%stream(2) = 2097152 
   F_ff6i26 = .TRUE.
   IF ( scalar_index_table( PARAM_ff6i27 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff6i27 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff6i27 , idomain ) = P_ff6i27
   ELSE
     P_ff6i27 = scalar_index_table( PARAM_ff6i27 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff6i27 ) = .TRUE.
   scalar_dname_table( idomain, P_ff6i27 ) = 'ff6i27'
   scalar_desc_table( idomain, P_ff6i27 ) = 'graupel bin 27'
   scalar_units_table( idomain, P_ff6i27 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff6i27 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff6i27 )%stream(2) = 2097152 
   F_ff6i27 = .TRUE.
   IF ( scalar_index_table( PARAM_ff6i28 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff6i28 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff6i28 , idomain ) = P_ff6i28
   ELSE
     P_ff6i28 = scalar_index_table( PARAM_ff6i28 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff6i28 ) = .TRUE.
   scalar_dname_table( idomain, P_ff6i28 ) = 'ff6i28'
   scalar_desc_table( idomain, P_ff6i28 ) = 'graupel bin 28'
   scalar_units_table( idomain, P_ff6i28 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff6i28 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff6i28 )%stream(2) = 2097152 
   F_ff6i28 = .TRUE.
   IF ( scalar_index_table( PARAM_ff6i29 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff6i29 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff6i29 , idomain ) = P_ff6i29
   ELSE
     P_ff6i29 = scalar_index_table( PARAM_ff6i29 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff6i29 ) = .TRUE.
   scalar_dname_table( idomain, P_ff6i29 ) = 'ff6i29'
   scalar_desc_table( idomain, P_ff6i29 ) = 'graupel bin 29'
   scalar_units_table( idomain, P_ff6i29 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff6i29 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff6i29 )%stream(2) = 2097152 
   F_ff6i29 = .TRUE.
   IF ( scalar_index_table( PARAM_ff6i30 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff6i30 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff6i30 , idomain ) = P_ff6i30
   ELSE
     P_ff6i30 = scalar_index_table( PARAM_ff6i30 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff6i30 ) = .TRUE.
   scalar_dname_table( idomain, P_ff6i30 ) = 'ff6i30'
   scalar_desc_table( idomain, P_ff6i30 ) = 'graupel bin 30'
   scalar_units_table( idomain, P_ff6i30 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff6i30 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff6i30 )%stream(2) = 2097152 
   F_ff6i30 = .TRUE.
   IF ( scalar_index_table( PARAM_ff6i31 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff6i31 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff6i31 , idomain ) = P_ff6i31
   ELSE
     P_ff6i31 = scalar_index_table( PARAM_ff6i31 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff6i31 ) = .TRUE.
   scalar_dname_table( idomain, P_ff6i31 ) = 'ff6i31'
   scalar_desc_table( idomain, P_ff6i31 ) = 'graupel bin 31'
   scalar_units_table( idomain, P_ff6i31 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff6i31 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff6i31 )%stream(2) = 2097152 
   F_ff6i31 = .TRUE.
   IF ( scalar_index_table( PARAM_ff6i32 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff6i32 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff6i32 , idomain ) = P_ff6i32
   ELSE
     P_ff6i32 = scalar_index_table( PARAM_ff6i32 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff6i32 ) = .TRUE.
   scalar_dname_table( idomain, P_ff6i32 ) = 'ff6i32'
   scalar_desc_table( idomain, P_ff6i32 ) = 'graupel bin 32'
   scalar_units_table( idomain, P_ff6i32 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff6i32 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff6i32 )%stream(2) = 2097152 
   F_ff6i32 = .TRUE.
   IF ( scalar_index_table( PARAM_ff6i33 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff6i33 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff6i33 , idomain ) = P_ff6i33
   ELSE
     P_ff6i33 = scalar_index_table( PARAM_ff6i33 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff6i33 ) = .TRUE.
   scalar_dname_table( idomain, P_ff6i33 ) = 'ff6i33'
   scalar_desc_table( idomain, P_ff6i33 ) = 'graupel bin 33'
   scalar_units_table( idomain, P_ff6i33 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff6i33 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff6i33 )%stream(2) = 2097152 
   F_ff6i33 = .TRUE.
   IF ( scalar_index_table( PARAM_ff8i01 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff8i01 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff8i01 , idomain ) = P_ff8i01
   ELSE
     P_ff8i01 = scalar_index_table( PARAM_ff8i01 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff8i01 ) = .TRUE.
   scalar_dname_table( idomain, P_ff8i01 ) = 'ff8i01'
   scalar_desc_table( idomain, P_ff8i01 ) = 'aerosols bin 1'
   scalar_units_table( idomain, P_ff8i01 ) = '  kg-1'
   scalar_streams_table( idomain, P_ff8i01 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff8i01 )%stream(2) = 2097152 
   F_ff8i01 = .TRUE.
   IF ( scalar_index_table( PARAM_ff8i02 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff8i02 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff8i02 , idomain ) = P_ff8i02
   ELSE
     P_ff8i02 = scalar_index_table( PARAM_ff8i02 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff8i02 ) = .TRUE.
   scalar_dname_table( idomain, P_ff8i02 ) = 'ff8i02'
   scalar_desc_table( idomain, P_ff8i02 ) = 'aerosols bin 2'
   scalar_units_table( idomain, P_ff8i02 ) = '  kg-1'
   scalar_streams_table( idomain, P_ff8i02 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff8i02 )%stream(2) = 2097152 
   F_ff8i02 = .TRUE.
   IF ( scalar_index_table( PARAM_ff8i03 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff8i03 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff8i03 , idomain ) = P_ff8i03
   ELSE
     P_ff8i03 = scalar_index_table( PARAM_ff8i03 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff8i03 ) = .TRUE.
   scalar_dname_table( idomain, P_ff8i03 ) = 'ff8i03'
   scalar_desc_table( idomain, P_ff8i03 ) = 'aerosols bin 3'
   scalar_units_table( idomain, P_ff8i03 ) = '  kg-1'
   scalar_streams_table( idomain, P_ff8i03 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff8i03 )%stream(2) = 2097152 
   F_ff8i03 = .TRUE.
   IF ( scalar_index_table( PARAM_ff8i04 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff8i04 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff8i04 , idomain ) = P_ff8i04
   ELSE
     P_ff8i04 = scalar_index_table( PARAM_ff8i04 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff8i04 ) = .TRUE.
   scalar_dname_table( idomain, P_ff8i04 ) = 'ff8i04'
   scalar_desc_table( idomain, P_ff8i04 ) = 'aerosols bin 4'
   scalar_units_table( idomain, P_ff8i04 ) = '  kg-1'
   scalar_streams_table( idomain, P_ff8i04 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff8i04 )%stream(2) = 2097152 
   F_ff8i04 = .TRUE.
   IF ( scalar_index_table( PARAM_ff8i05 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff8i05 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff8i05 , idomain ) = P_ff8i05
   ELSE
     P_ff8i05 = scalar_index_table( PARAM_ff8i05 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff8i05 ) = .TRUE.
   scalar_dname_table( idomain, P_ff8i05 ) = 'ff8i05'
   scalar_desc_table( idomain, P_ff8i05 ) = 'aerosols bin 5'
   scalar_units_table( idomain, P_ff8i05 ) = '  kg-1'
   scalar_streams_table( idomain, P_ff8i05 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff8i05 )%stream(2) = 2097152 
   F_ff8i05 = .TRUE.
   IF ( scalar_index_table( PARAM_ff8i06 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff8i06 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff8i06 , idomain ) = P_ff8i06
   ELSE
     P_ff8i06 = scalar_index_table( PARAM_ff8i06 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff8i06 ) = .TRUE.
   scalar_dname_table( idomain, P_ff8i06 ) = 'ff8i06'
   scalar_desc_table( idomain, P_ff8i06 ) = 'aerosols bin 6'
   scalar_units_table( idomain, P_ff8i06 ) = '  kg-1'
   scalar_streams_table( idomain, P_ff8i06 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff8i06 )%stream(2) = 2097152 
   F_ff8i06 = .TRUE.
   IF ( scalar_index_table( PARAM_ff8i07 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff8i07 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff8i07 , idomain ) = P_ff8i07
   ELSE
     P_ff8i07 = scalar_index_table( PARAM_ff8i07 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff8i07 ) = .TRUE.
   scalar_dname_table( idomain, P_ff8i07 ) = 'ff8i07'
   scalar_desc_table( idomain, P_ff8i07 ) = 'aerosols bin 7'
   scalar_units_table( idomain, P_ff8i07 ) = '  kg-1'
   scalar_streams_table( idomain, P_ff8i07 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff8i07 )%stream(2) = 2097152 
   F_ff8i07 = .TRUE.
   IF ( scalar_index_table( PARAM_ff8i08 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff8i08 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff8i08 , idomain ) = P_ff8i08
   ELSE
     P_ff8i08 = scalar_index_table( PARAM_ff8i08 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff8i08 ) = .TRUE.
   scalar_dname_table( idomain, P_ff8i08 ) = 'ff8i08'
   scalar_desc_table( idomain, P_ff8i08 ) = 'aerosols bin 8'
   scalar_units_table( idomain, P_ff8i08 ) = '  kg-1'
   scalar_streams_table( idomain, P_ff8i08 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff8i08 )%stream(2) = 2097152 
   F_ff8i08 = .TRUE.
   IF ( scalar_index_table( PARAM_ff8i09 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff8i09 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff8i09 , idomain ) = P_ff8i09
   ELSE
     P_ff8i09 = scalar_index_table( PARAM_ff8i09 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff8i09 ) = .TRUE.
   scalar_dname_table( idomain, P_ff8i09 ) = 'ff8i09'
   scalar_desc_table( idomain, P_ff8i09 ) = 'aerosols bin 9'
   scalar_units_table( idomain, P_ff8i09 ) = '  kg-1'
   scalar_streams_table( idomain, P_ff8i09 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff8i09 )%stream(2) = 2097152 
   F_ff8i09 = .TRUE.
   IF ( scalar_index_table( PARAM_ff8i10 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff8i10 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff8i10 , idomain ) = P_ff8i10
   ELSE
     P_ff8i10 = scalar_index_table( PARAM_ff8i10 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff8i10 ) = .TRUE.
   scalar_dname_table( idomain, P_ff8i10 ) = 'ff8i10'
   scalar_desc_table( idomain, P_ff8i10 ) = 'aerosols bin 10'
   scalar_units_table( idomain, P_ff8i10 ) = '  kg-1'
   scalar_streams_table( idomain, P_ff8i10 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff8i10 )%stream(2) = 2097152 
   F_ff8i10 = .TRUE.
   IF ( scalar_index_table( PARAM_ff8i11 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff8i11 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff8i11 , idomain ) = P_ff8i11
   ELSE
     P_ff8i11 = scalar_index_table( PARAM_ff8i11 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff8i11 ) = .TRUE.
   scalar_dname_table( idomain, P_ff8i11 ) = 'ff8i11'
   scalar_desc_table( idomain, P_ff8i11 ) = 'aerosols bin 11'
   scalar_units_table( idomain, P_ff8i11 ) = '  kg-1'
   scalar_streams_table( idomain, P_ff8i11 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff8i11 )%stream(2) = 2097152 
   F_ff8i11 = .TRUE.
   IF ( scalar_index_table( PARAM_ff8i12 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff8i12 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff8i12 , idomain ) = P_ff8i12
   ELSE
     P_ff8i12 = scalar_index_table( PARAM_ff8i12 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff8i12 ) = .TRUE.
   scalar_dname_table( idomain, P_ff8i12 ) = 'ff8i12'
   scalar_desc_table( idomain, P_ff8i12 ) = 'aerosols bin 12'
   scalar_units_table( idomain, P_ff8i12 ) = '  kg-1'
   scalar_streams_table( idomain, P_ff8i12 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff8i12 )%stream(2) = 2097152 
   F_ff8i12 = .TRUE.
   IF ( scalar_index_table( PARAM_ff8i13 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff8i13 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff8i13 , idomain ) = P_ff8i13
   ELSE
     P_ff8i13 = scalar_index_table( PARAM_ff8i13 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff8i13 ) = .TRUE.
   scalar_dname_table( idomain, P_ff8i13 ) = 'ff8i13'
   scalar_desc_table( idomain, P_ff8i13 ) = 'aerosols bin 13'
   scalar_units_table( idomain, P_ff8i13 ) = '  kg-1'
   scalar_streams_table( idomain, P_ff8i13 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff8i13 )%stream(2) = 2097152 
   F_ff8i13 = .TRUE.
   IF ( scalar_index_table( PARAM_ff8i14 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff8i14 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff8i14 , idomain ) = P_ff8i14
   ELSE
     P_ff8i14 = scalar_index_table( PARAM_ff8i14 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff8i14 ) = .TRUE.
   scalar_dname_table( idomain, P_ff8i14 ) = 'ff8i14'
   scalar_desc_table( idomain, P_ff8i14 ) = 'aerosols bin 14'
   scalar_units_table( idomain, P_ff8i14 ) = '  kg-1'
   scalar_streams_table( idomain, P_ff8i14 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff8i14 )%stream(2) = 2097152 
   F_ff8i14 = .TRUE.
   IF ( scalar_index_table( PARAM_ff8i15 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff8i15 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff8i15 , idomain ) = P_ff8i15
   ELSE
     P_ff8i15 = scalar_index_table( PARAM_ff8i15 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff8i15 ) = .TRUE.
   scalar_dname_table( idomain, P_ff8i15 ) = 'ff8i15'
   scalar_desc_table( idomain, P_ff8i15 ) = 'aerosols bin 15'
   scalar_units_table( idomain, P_ff8i15 ) = '  kg-1'
   scalar_streams_table( idomain, P_ff8i15 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff8i15 )%stream(2) = 2097152 
   F_ff8i15 = .TRUE.
   IF ( scalar_index_table( PARAM_ff8i16 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff8i16 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff8i16 , idomain ) = P_ff8i16
   ELSE
     P_ff8i16 = scalar_index_table( PARAM_ff8i16 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff8i16 ) = .TRUE.
   scalar_dname_table( idomain, P_ff8i16 ) = 'ff8i16'
   scalar_desc_table( idomain, P_ff8i16 ) = 'aerosols bin 16'
   scalar_units_table( idomain, P_ff8i16 ) = '  kg-1'
   scalar_streams_table( idomain, P_ff8i16 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff8i16 )%stream(2) = 2097152 
   F_ff8i16 = .TRUE.
   IF ( scalar_index_table( PARAM_ff8i17 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff8i17 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff8i17 , idomain ) = P_ff8i17
   ELSE
     P_ff8i17 = scalar_index_table( PARAM_ff8i17 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff8i17 ) = .TRUE.
   scalar_dname_table( idomain, P_ff8i17 ) = 'ff8i17'
   scalar_desc_table( idomain, P_ff8i17 ) = 'aerosols bin 17'
   scalar_units_table( idomain, P_ff8i17 ) = '  kg-1'
   scalar_streams_table( idomain, P_ff8i17 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff8i17 )%stream(2) = 2097152 
   F_ff8i17 = .TRUE.
   IF ( scalar_index_table( PARAM_ff8i18 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff8i18 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff8i18 , idomain ) = P_ff8i18
   ELSE
     P_ff8i18 = scalar_index_table( PARAM_ff8i18 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff8i18 ) = .TRUE.
   scalar_dname_table( idomain, P_ff8i18 ) = 'ff8i18'
   scalar_desc_table( idomain, P_ff8i18 ) = 'aerosols bin 18'
   scalar_units_table( idomain, P_ff8i18 ) = '  kg-1'
   scalar_streams_table( idomain, P_ff8i18 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff8i18 )%stream(2) = 2097152 
   F_ff8i18 = .TRUE.
   IF ( scalar_index_table( PARAM_ff8i19 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff8i19 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff8i19 , idomain ) = P_ff8i19
   ELSE
     P_ff8i19 = scalar_index_table( PARAM_ff8i19 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff8i19 ) = .TRUE.
   scalar_dname_table( idomain, P_ff8i19 ) = 'ff8i19'
   scalar_desc_table( idomain, P_ff8i19 ) = 'aerosols bin 19'
   scalar_units_table( idomain, P_ff8i19 ) = '  kg-1'
   scalar_streams_table( idomain, P_ff8i19 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff8i19 )%stream(2) = 2097152 
   F_ff8i19 = .TRUE.
   IF ( scalar_index_table( PARAM_ff8i20 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff8i20 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff8i20 , idomain ) = P_ff8i20
   ELSE
     P_ff8i20 = scalar_index_table( PARAM_ff8i20 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff8i20 ) = .TRUE.
   scalar_dname_table( idomain, P_ff8i20 ) = 'ff8i20'
   scalar_desc_table( idomain, P_ff8i20 ) = 'aerosols bin 20'
   scalar_units_table( idomain, P_ff8i20 ) = '  kg-1'
   scalar_streams_table( idomain, P_ff8i20 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff8i20 )%stream(2) = 2097152 
   F_ff8i20 = .TRUE.
   IF ( scalar_index_table( PARAM_ff8i21 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff8i21 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff8i21 , idomain ) = P_ff8i21
   ELSE
     P_ff8i21 = scalar_index_table( PARAM_ff8i21 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff8i21 ) = .TRUE.
   scalar_dname_table( idomain, P_ff8i21 ) = 'ff8i21'
   scalar_desc_table( idomain, P_ff8i21 ) = 'aerosols bin 21'
   scalar_units_table( idomain, P_ff8i21 ) = '  kg-1'
   scalar_streams_table( idomain, P_ff8i21 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff8i21 )%stream(2) = 2097152 
   F_ff8i21 = .TRUE.
   IF ( scalar_index_table( PARAM_ff8i22 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff8i22 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff8i22 , idomain ) = P_ff8i22
   ELSE
     P_ff8i22 = scalar_index_table( PARAM_ff8i22 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff8i22 ) = .TRUE.
   scalar_dname_table( idomain, P_ff8i22 ) = 'ff8i22'
   scalar_desc_table( idomain, P_ff8i22 ) = 'aerosols bin 22'
   scalar_units_table( idomain, P_ff8i22 ) = '  kg-1'
   scalar_streams_table( idomain, P_ff8i22 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff8i22 )%stream(2) = 2097152 
   F_ff8i22 = .TRUE.
   IF ( scalar_index_table( PARAM_ff8i23 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff8i23 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff8i23 , idomain ) = P_ff8i23
   ELSE
     P_ff8i23 = scalar_index_table( PARAM_ff8i23 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff8i23 ) = .TRUE.
   scalar_dname_table( idomain, P_ff8i23 ) = 'ff8i23'
   scalar_desc_table( idomain, P_ff8i23 ) = 'aerosols bin 23'
   scalar_units_table( idomain, P_ff8i23 ) = '  kg-1'
   scalar_streams_table( idomain, P_ff8i23 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff8i23 )%stream(2) = 2097152 
   F_ff8i23 = .TRUE.
   IF ( scalar_index_table( PARAM_ff8i24 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff8i24 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff8i24 , idomain ) = P_ff8i24
   ELSE
     P_ff8i24 = scalar_index_table( PARAM_ff8i24 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff8i24 ) = .TRUE.
   scalar_dname_table( idomain, P_ff8i24 ) = 'ff8i24'
   scalar_desc_table( idomain, P_ff8i24 ) = 'aerosols bin 24'
   scalar_units_table( idomain, P_ff8i24 ) = '  kg-1'
   scalar_streams_table( idomain, P_ff8i24 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff8i24 )%stream(2) = 2097152 
   F_ff8i24 = .TRUE.
   IF ( scalar_index_table( PARAM_ff8i25 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff8i25 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff8i25 , idomain ) = P_ff8i25
   ELSE
     P_ff8i25 = scalar_index_table( PARAM_ff8i25 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff8i25 ) = .TRUE.
   scalar_dname_table( idomain, P_ff8i25 ) = 'ff8i25'
   scalar_desc_table( idomain, P_ff8i25 ) = 'aerosols bin 25'
   scalar_units_table( idomain, P_ff8i25 ) = '  kg-1'
   scalar_streams_table( idomain, P_ff8i25 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff8i25 )%stream(2) = 2097152 
   F_ff8i25 = .TRUE.
   IF ( scalar_index_table( PARAM_ff8i26 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff8i26 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff8i26 , idomain ) = P_ff8i26
   ELSE
     P_ff8i26 = scalar_index_table( PARAM_ff8i26 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff8i26 ) = .TRUE.
   scalar_dname_table( idomain, P_ff8i26 ) = 'ff8i26'
   scalar_desc_table( idomain, P_ff8i26 ) = 'aerosols bin 26'
   scalar_units_table( idomain, P_ff8i26 ) = '  kg-1'
   scalar_streams_table( idomain, P_ff8i26 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff8i26 )%stream(2) = 2097152 
   F_ff8i26 = .TRUE.
   IF ( scalar_index_table( PARAM_ff8i27 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff8i27 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff8i27 , idomain ) = P_ff8i27
   ELSE
     P_ff8i27 = scalar_index_table( PARAM_ff8i27 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff8i27 ) = .TRUE.
   scalar_dname_table( idomain, P_ff8i27 ) = 'ff8i27'
   scalar_desc_table( idomain, P_ff8i27 ) = 'aerosols bin 27'
   scalar_units_table( idomain, P_ff8i27 ) = '  kg-1'
   scalar_streams_table( idomain, P_ff8i27 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff8i27 )%stream(2) = 2097152 
   F_ff8i27 = .TRUE.
   IF ( scalar_index_table( PARAM_ff8i28 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff8i28 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff8i28 , idomain ) = P_ff8i28
   ELSE
     P_ff8i28 = scalar_index_table( PARAM_ff8i28 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff8i28 ) = .TRUE.
   scalar_dname_table( idomain, P_ff8i28 ) = 'ff8i28'
   scalar_desc_table( idomain, P_ff8i28 ) = 'aerosols bin 28'
   scalar_units_table( idomain, P_ff8i28 ) = '  kg-1'
   scalar_streams_table( idomain, P_ff8i28 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff8i28 )%stream(2) = 2097152 
   F_ff8i28 = .TRUE.
   IF ( scalar_index_table( PARAM_ff8i29 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff8i29 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff8i29 , idomain ) = P_ff8i29
   ELSE
     P_ff8i29 = scalar_index_table( PARAM_ff8i29 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff8i29 ) = .TRUE.
   scalar_dname_table( idomain, P_ff8i29 ) = 'ff8i29'
   scalar_desc_table( idomain, P_ff8i29 ) = 'aerosols bin 29'
   scalar_units_table( idomain, P_ff8i29 ) = '  kg-1'
   scalar_streams_table( idomain, P_ff8i29 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff8i29 )%stream(2) = 2097152 
   F_ff8i29 = .TRUE.
   IF ( scalar_index_table( PARAM_ff8i30 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff8i30 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff8i30 , idomain ) = P_ff8i30
   ELSE
     P_ff8i30 = scalar_index_table( PARAM_ff8i30 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff8i30 ) = .TRUE.
   scalar_dname_table( idomain, P_ff8i30 ) = 'ff8i30'
   scalar_desc_table( idomain, P_ff8i30 ) = 'aerosols bin 30'
   scalar_units_table( idomain, P_ff8i30 ) = '  kg-1'
   scalar_streams_table( idomain, P_ff8i30 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff8i30 )%stream(2) = 2097152 
   F_ff8i30 = .TRUE.
   IF ( scalar_index_table( PARAM_ff8i31 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff8i31 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff8i31 , idomain ) = P_ff8i31
   ELSE
     P_ff8i31 = scalar_index_table( PARAM_ff8i31 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff8i31 ) = .TRUE.
   scalar_dname_table( idomain, P_ff8i31 ) = 'ff8i31'
   scalar_desc_table( idomain, P_ff8i31 ) = 'aerosols bin 31'
   scalar_units_table( idomain, P_ff8i31 ) = '  kg-1'
   scalar_streams_table( idomain, P_ff8i31 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff8i31 )%stream(2) = 2097152 
   F_ff8i31 = .TRUE.
   IF ( scalar_index_table( PARAM_ff8i32 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff8i32 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff8i32 , idomain ) = P_ff8i32
   ELSE
     P_ff8i32 = scalar_index_table( PARAM_ff8i32 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff8i32 ) = .TRUE.
   scalar_dname_table( idomain, P_ff8i32 ) = 'ff8i32'
   scalar_desc_table( idomain, P_ff8i32 ) = 'aerosols bin 32'
   scalar_units_table( idomain, P_ff8i32 ) = '  kg-1'
   scalar_streams_table( idomain, P_ff8i32 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff8i32 )%stream(2) = 2097152 
   F_ff8i32 = .TRUE.
   IF ( scalar_index_table( PARAM_ff8i33 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff8i33 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff8i33 , idomain ) = P_ff8i33
   ELSE
     P_ff8i33 = scalar_index_table( PARAM_ff8i33 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff8i33 ) = .TRUE.
   scalar_dname_table( idomain, P_ff8i33 ) = 'ff8i33'
   scalar_desc_table( idomain, P_ff8i33 ) = 'aerosols bin 33'
   scalar_units_table( idomain, P_ff8i33 ) = '  kg-1'
   scalar_streams_table( idomain, P_ff8i33 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff8i33 )%stream(2) = 2097152 
   F_ff8i33 = .TRUE.
   IF ( scalar_index_table( PARAM_qnn , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qnn = scalar_num_table(idomain)
     scalar_index_table( PARAM_qnn , idomain ) = P_qnn
   ELSE
     P_qnn = scalar_index_table( PARAM_qnn , idomain )
   END IF
   scalar_boundary_table( idomain, P_qnn ) = .TRUE.
   scalar_dname_table( idomain, P_qnn ) = 'QNCCN'
   scalar_desc_table( idomain, P_qnn ) = 'CCN Number concentration'
   scalar_units_table( idomain, P_qnn ) = '  kg(-1)'
   scalar_streams_table( idomain, P_qnn )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qnn )%stream(2) = 2097152 
   F_qnn = .TRUE.
   IF ( scalar_index_table( PARAM_qnc , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qnc = scalar_num_table(idomain)
     scalar_index_table( PARAM_qnc , idomain ) = P_qnc
   ELSE
     P_qnc = scalar_index_table( PARAM_qnc , idomain )
   END IF
   scalar_boundary_table( idomain, P_qnc ) = .TRUE.
   scalar_dname_table( idomain, P_qnc ) = 'QNCLOUD'
   scalar_desc_table( idomain, P_qnc ) = 'cloud water Number concentration'
   scalar_units_table( idomain, P_qnc ) = '  kg(-1)'
   scalar_streams_table( idomain, P_qnc )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qnc )%stream(2) = 2097152 
   F_qnc = .TRUE.
   IF ( scalar_index_table( PARAM_qnr , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qnr = scalar_num_table(idomain)
     scalar_index_table( PARAM_qnr , idomain ) = P_qnr
   ELSE
     P_qnr = scalar_index_table( PARAM_qnr , idomain )
   END IF
   scalar_boundary_table( idomain, P_qnr ) = .TRUE.
   scalar_dname_table( idomain, P_qnr ) = 'QNRAIN'
   scalar_desc_table( idomain, P_qnr ) = 'Rain Number concentration'
   scalar_units_table( idomain, P_qnr ) = '  kg(-1)'
   scalar_streams_table( idomain, P_qnr )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qnr )%stream(2) = 2097152 
   F_qnr = .TRUE.
   IF ( scalar_index_table( PARAM_qni , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qni = scalar_num_table(idomain)
     scalar_index_table( PARAM_qni , idomain ) = P_qni
   ELSE
     P_qni = scalar_index_table( PARAM_qni , idomain )
   END IF
   scalar_boundary_table( idomain, P_qni ) = .TRUE.
   scalar_dname_table( idomain, P_qni ) = 'QNICE'
   scalar_desc_table( idomain, P_qni ) = 'Ice Number concentration'
   scalar_units_table( idomain, P_qni ) = '  kg-1'
   scalar_streams_table( idomain, P_qni )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qni )%stream(2) = 2097152 
   F_qni = .TRUE.
   IF ( scalar_index_table( PARAM_qns , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qns = scalar_num_table(idomain)
     scalar_index_table( PARAM_qns , idomain ) = P_qns
   ELSE
     P_qns = scalar_index_table( PARAM_qns , idomain )
   END IF
   scalar_boundary_table( idomain, P_qns ) = .TRUE.
   scalar_dname_table( idomain, P_qns ) = 'QNSNOW'
   scalar_desc_table( idomain, P_qns ) = 'Snow Number concentration'
   scalar_units_table( idomain, P_qns ) = '  kg(-1)'
   scalar_streams_table( idomain, P_qns )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qns )%stream(2) = 2097152 
   F_qns = .TRUE.
   IF ( scalar_index_table( PARAM_qng , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qng = scalar_num_table(idomain)
     scalar_index_table( PARAM_qng , idomain ) = P_qng
   ELSE
     P_qng = scalar_index_table( PARAM_qng , idomain )
   END IF
   scalar_boundary_table( idomain, P_qng ) = .TRUE.
   scalar_dname_table( idomain, P_qng ) = 'QNGRAUPEL'
   scalar_desc_table( idomain, P_qng ) = 'Graupel Number concentration'
   scalar_units_table( idomain, P_qng ) = '  kg(-1)'
   scalar_streams_table( idomain, P_qng )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qng )%stream(2) = 2097152 
   F_qng = .TRUE.
   IF ( scalar_index_table( PARAM_effr , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_effr = scalar_num_table(idomain)
     scalar_index_table( PARAM_effr , idomain ) = P_effr
   ELSE
     P_effr = scalar_index_table( PARAM_effr , idomain )
   END IF
   scalar_boundary_table( idomain, P_effr ) = .TRUE.
   scalar_dname_table( idomain, P_effr ) = 'EFF_RADIUS'
   scalar_desc_table( idomain, P_effr ) = 'Effective Radius'
   scalar_units_table( idomain, P_effr ) = 'Microns'
   scalar_streams_table( idomain, P_effr )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_effr )%stream(2) = 2097152 
   F_effr = .TRUE.
   IF ( scalar_index_table( PARAM_ice_effr , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ice_effr = scalar_num_table(idomain)
     scalar_index_table( PARAM_ice_effr , idomain ) = P_ice_effr
   ELSE
     P_ice_effr = scalar_index_table( PARAM_ice_effr , idomain )
   END IF
   scalar_boundary_table( idomain, P_ice_effr ) = .TRUE.
   scalar_dname_table( idomain, P_ice_effr ) = 'ICE_EFF_RADIUS'
   scalar_desc_table( idomain, P_ice_effr ) = 'Ice Effective Radius'
   scalar_units_table( idomain, P_ice_effr ) = 'Microns'
   scalar_streams_table( idomain, P_ice_effr )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_ice_effr )%stream(2) = 2097152 
   F_ice_effr = .TRUE.
   IF ( scalar_index_table( PARAM_tot_effr , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_tot_effr = scalar_num_table(idomain)
     scalar_index_table( PARAM_tot_effr , idomain ) = P_tot_effr
   ELSE
     P_tot_effr = scalar_index_table( PARAM_tot_effr , idomain )
   END IF
   scalar_boundary_table( idomain, P_tot_effr ) = .TRUE.
   scalar_dname_table( idomain, P_tot_effr ) = 'TOT_EFF_RADIUS'
   scalar_desc_table( idomain, P_tot_effr ) = 'Tot Effective Radius'
   scalar_units_table( idomain, P_tot_effr ) = 'Microns'
   scalar_streams_table( idomain, P_tot_effr )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_tot_effr )%stream(2) = 2097152 
   F_tot_effr = .TRUE.
  END IF
  IF (model_config_rec%mp_physics(idomain)==32)THEN
   IF ( moist_index_table( PARAM_qv , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qv = moist_num_table(idomain)
     moist_index_table( PARAM_qv , idomain ) = P_qv
   ELSE
     P_qv = moist_index_table( PARAM_qv , idomain )
   END IF
   moist_boundary_table( idomain, P_qv ) = .TRUE.
   moist_dname_table( idomain, P_qv ) = 'QVAPOR'
   moist_desc_table( idomain, P_qv ) = 'Water vapor mixing ratio'
   moist_units_table( idomain, P_qv ) = 'kg kg-1'
   moist_streams_table( idomain, P_qv )%stream(1) = 33554435 
   moist_streams_table( idomain, P_qv )%stream(2) = 2097152 
   F_qv = .TRUE.
   IF ( moist_index_table( PARAM_qc , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qc = moist_num_table(idomain)
     moist_index_table( PARAM_qc , idomain ) = P_qc
   ELSE
     P_qc = moist_index_table( PARAM_qc , idomain )
   END IF
   moist_boundary_table( idomain, P_qc ) = .TRUE.
   moist_dname_table( idomain, P_qc ) = 'QCLOUD'
   moist_desc_table( idomain, P_qc ) = 'Cloud water mixing ratio'
   moist_units_table( idomain, P_qc ) = 'kg kg-1'
   moist_streams_table( idomain, P_qc )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qc )%stream(2) = 2097152 
   F_qc = .TRUE.
   IF ( moist_index_table( PARAM_qr , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qr = moist_num_table(idomain)
     moist_index_table( PARAM_qr , idomain ) = P_qr
   ELSE
     P_qr = moist_index_table( PARAM_qr , idomain )
   END IF
   moist_boundary_table( idomain, P_qr ) = .TRUE.
   moist_dname_table( idomain, P_qr ) = 'QRAIN'
   moist_desc_table( idomain, P_qr ) = 'Rain water mixing ratio'
   moist_units_table( idomain, P_qr ) = 'kg kg-1'
   moist_streams_table( idomain, P_qr )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qr )%stream(2) = 2097152 
   F_qr = .TRUE.
   IF ( moist_index_table( PARAM_qi , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qi = moist_num_table(idomain)
     moist_index_table( PARAM_qi , idomain ) = P_qi
   ELSE
     P_qi = moist_index_table( PARAM_qi , idomain )
   END IF
   moist_boundary_table( idomain, P_qi ) = .TRUE.
   moist_dname_table( idomain, P_qi ) = 'QICE'
   moist_desc_table( idomain, P_qi ) = 'Ice mixing ratio'
   moist_units_table( idomain, P_qi ) = 'kg kg-1'
   moist_streams_table( idomain, P_qi )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qi )%stream(2) = 2097152 
   F_qi = .TRUE.
   IF ( moist_index_table( PARAM_qic , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qic = moist_num_table(idomain)
     moist_index_table( PARAM_qic , idomain ) = P_qic
   ELSE
     P_qic = moist_index_table( PARAM_qic , idomain )
   END IF
   moist_boundary_table( idomain, P_qic ) = .TRUE.
   moist_dname_table( idomain, P_qic ) = 'QICEC'
   moist_desc_table( idomain, P_qic ) = 'Column Ice mixing ratio'
   moist_units_table( idomain, P_qic ) = 'kg kg-1'
   moist_streams_table( idomain, P_qic )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qic )%stream(2) = 2097152 
   F_qic = .TRUE.
   IF ( moist_index_table( PARAM_qip , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qip = moist_num_table(idomain)
     moist_index_table( PARAM_qip , idomain ) = P_qip
   ELSE
     P_qip = moist_index_table( PARAM_qip , idomain )
   END IF
   moist_boundary_table( idomain, P_qip ) = .TRUE.
   moist_dname_table( idomain, P_qip ) = 'QICEP'
   moist_desc_table( idomain, P_qip ) = 'Plate Ice mixing ratio'
   moist_units_table( idomain, P_qip ) = 'kg kg-1'
   moist_streams_table( idomain, P_qip )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qip )%stream(2) = 2097152 
   F_qip = .TRUE.
   IF ( moist_index_table( PARAM_qid , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qid = moist_num_table(idomain)
     moist_index_table( PARAM_qid , idomain ) = P_qid
   ELSE
     P_qid = moist_index_table( PARAM_qid , idomain )
   END IF
   moist_boundary_table( idomain, P_qid ) = .TRUE.
   moist_dname_table( idomain, P_qid ) = 'QICED'
   moist_desc_table( idomain, P_qid ) = 'Dendrite Ice mixing ratio'
   moist_units_table( idomain, P_qid ) = 'kg kg-1'
   moist_streams_table( idomain, P_qid )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qid )%stream(2) = 2097152 
   F_qid = .TRUE.
   IF ( moist_index_table( PARAM_qs , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qs = moist_num_table(idomain)
     moist_index_table( PARAM_qs , idomain ) = P_qs
   ELSE
     P_qs = moist_index_table( PARAM_qs , idomain )
   END IF
   moist_boundary_table( idomain, P_qs ) = .TRUE.
   moist_dname_table( idomain, P_qs ) = 'QSNOW'
   moist_desc_table( idomain, P_qs ) = 'Snow mixing ratio'
   moist_units_table( idomain, P_qs ) = 'kg kg-1'
   moist_streams_table( idomain, P_qs )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qs )%stream(2) = 2097152 
   F_qs = .TRUE.
   IF ( moist_index_table( PARAM_qg , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qg = moist_num_table(idomain)
     moist_index_table( PARAM_qg , idomain ) = P_qg
   ELSE
     P_qg = moist_index_table( PARAM_qg , idomain )
   END IF
   moist_boundary_table( idomain, P_qg ) = .TRUE.
   moist_dname_table( idomain, P_qg ) = 'QGRAUP'
   moist_desc_table( idomain, P_qg ) = 'Graupel mixing ratio'
   moist_units_table( idomain, P_qg ) = 'kg kg-1'
   moist_streams_table( idomain, P_qg )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qg )%stream(2) = 2097152 
   F_qg = .TRUE.
   IF ( moist_index_table( PARAM_qh , idomain ) .lt. 1 ) THEN
     moist_num_table(idomain) = moist_num_table(idomain) + 1
     P_qh = moist_num_table(idomain)
     moist_index_table( PARAM_qh , idomain ) = P_qh
   ELSE
     P_qh = moist_index_table( PARAM_qh , idomain )
   END IF
   moist_boundary_table( idomain, P_qh ) = .TRUE.
   moist_dname_table( idomain, P_qh ) = 'QHAIL'
   moist_desc_table( idomain, P_qh ) = 'Hail mixing ratio'
   moist_units_table( idomain, P_qh ) = 'kg kg-1'
   moist_streams_table( idomain, P_qh )%stream(1) = 33554433 
   moist_streams_table( idomain, P_qh )%stream(2) = 2097152 
   F_qh = .TRUE.
   IF ( scalar_index_table( PARAM_ff1i01 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff1i01 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff1i01 , idomain ) = P_ff1i01
   ELSE
     P_ff1i01 = scalar_index_table( PARAM_ff1i01 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff1i01 ) = .TRUE.
   scalar_dname_table( idomain, P_ff1i01 ) = 'ff1i01'
   scalar_desc_table( idomain, P_ff1i01 ) = 'cloud/rain bin 1'
   scalar_units_table( idomain, P_ff1i01 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff1i01 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff1i01 )%stream(2) = 2097152 
   F_ff1i01 = .TRUE.
   IF ( scalar_index_table( PARAM_ff1i02 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff1i02 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff1i02 , idomain ) = P_ff1i02
   ELSE
     P_ff1i02 = scalar_index_table( PARAM_ff1i02 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff1i02 ) = .TRUE.
   scalar_dname_table( idomain, P_ff1i02 ) = 'ff1i02'
   scalar_desc_table( idomain, P_ff1i02 ) = 'cloud/rain bin 2'
   scalar_units_table( idomain, P_ff1i02 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff1i02 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff1i02 )%stream(2) = 2097152 
   F_ff1i02 = .TRUE.
   IF ( scalar_index_table( PARAM_ff1i03 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff1i03 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff1i03 , idomain ) = P_ff1i03
   ELSE
     P_ff1i03 = scalar_index_table( PARAM_ff1i03 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff1i03 ) = .TRUE.
   scalar_dname_table( idomain, P_ff1i03 ) = 'ff1i03'
   scalar_desc_table( idomain, P_ff1i03 ) = 'cloud/rain bin 3'
   scalar_units_table( idomain, P_ff1i03 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff1i03 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff1i03 )%stream(2) = 2097152 
   F_ff1i03 = .TRUE.
   IF ( scalar_index_table( PARAM_ff1i04 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff1i04 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff1i04 , idomain ) = P_ff1i04
   ELSE
     P_ff1i04 = scalar_index_table( PARAM_ff1i04 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff1i04 ) = .TRUE.
   scalar_dname_table( idomain, P_ff1i04 ) = 'ff1i04'
   scalar_desc_table( idomain, P_ff1i04 ) = 'cloud/rain bin 4'
   scalar_units_table( idomain, P_ff1i04 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff1i04 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff1i04 )%stream(2) = 2097152 
   F_ff1i04 = .TRUE.
   IF ( scalar_index_table( PARAM_ff1i05 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff1i05 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff1i05 , idomain ) = P_ff1i05
   ELSE
     P_ff1i05 = scalar_index_table( PARAM_ff1i05 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff1i05 ) = .TRUE.
   scalar_dname_table( idomain, P_ff1i05 ) = 'ff1i05'
   scalar_desc_table( idomain, P_ff1i05 ) = 'cloud/rain bin 5'
   scalar_units_table( idomain, P_ff1i05 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff1i05 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff1i05 )%stream(2) = 2097152 
   F_ff1i05 = .TRUE.
   IF ( scalar_index_table( PARAM_ff1i06 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff1i06 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff1i06 , idomain ) = P_ff1i06
   ELSE
     P_ff1i06 = scalar_index_table( PARAM_ff1i06 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff1i06 ) = .TRUE.
   scalar_dname_table( idomain, P_ff1i06 ) = 'ff1i06'
   scalar_desc_table( idomain, P_ff1i06 ) = 'cloud/rain bin 6'
   scalar_units_table( idomain, P_ff1i06 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff1i06 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff1i06 )%stream(2) = 2097152 
   F_ff1i06 = .TRUE.
   IF ( scalar_index_table( PARAM_ff1i07 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff1i07 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff1i07 , idomain ) = P_ff1i07
   ELSE
     P_ff1i07 = scalar_index_table( PARAM_ff1i07 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff1i07 ) = .TRUE.
   scalar_dname_table( idomain, P_ff1i07 ) = 'ff1i07'
   scalar_desc_table( idomain, P_ff1i07 ) = 'cloud/rain bin 7'
   scalar_units_table( idomain, P_ff1i07 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff1i07 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff1i07 )%stream(2) = 2097152 
   F_ff1i07 = .TRUE.
   IF ( scalar_index_table( PARAM_ff1i08 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff1i08 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff1i08 , idomain ) = P_ff1i08
   ELSE
     P_ff1i08 = scalar_index_table( PARAM_ff1i08 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff1i08 ) = .TRUE.
   scalar_dname_table( idomain, P_ff1i08 ) = 'ff1i08'
   scalar_desc_table( idomain, P_ff1i08 ) = 'cloud/rain bin 8'
   scalar_units_table( idomain, P_ff1i08 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff1i08 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff1i08 )%stream(2) = 2097152 
   F_ff1i08 = .TRUE.
   IF ( scalar_index_table( PARAM_ff1i09 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff1i09 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff1i09 , idomain ) = P_ff1i09
   ELSE
     P_ff1i09 = scalar_index_table( PARAM_ff1i09 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff1i09 ) = .TRUE.
   scalar_dname_table( idomain, P_ff1i09 ) = 'ff1i09'
   scalar_desc_table( idomain, P_ff1i09 ) = 'cloud/rain bin 9'
   scalar_units_table( idomain, P_ff1i09 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff1i09 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff1i09 )%stream(2) = 2097152 
   F_ff1i09 = .TRUE.
   IF ( scalar_index_table( PARAM_ff1i10 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff1i10 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff1i10 , idomain ) = P_ff1i10
   ELSE
     P_ff1i10 = scalar_index_table( PARAM_ff1i10 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff1i10 ) = .TRUE.
   scalar_dname_table( idomain, P_ff1i10 ) = 'ff1i10'
   scalar_desc_table( idomain, P_ff1i10 ) = 'cloud/rain bin 10'
   scalar_units_table( idomain, P_ff1i10 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff1i10 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff1i10 )%stream(2) = 2097152 
   F_ff1i10 = .TRUE.
   IF ( scalar_index_table( PARAM_ff1i11 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff1i11 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff1i11 , idomain ) = P_ff1i11
   ELSE
     P_ff1i11 = scalar_index_table( PARAM_ff1i11 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff1i11 ) = .TRUE.
   scalar_dname_table( idomain, P_ff1i11 ) = 'ff1i11'
   scalar_desc_table( idomain, P_ff1i11 ) = 'cloud/rain bin 11'
   scalar_units_table( idomain, P_ff1i11 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff1i11 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff1i11 )%stream(2) = 2097152 
   F_ff1i11 = .TRUE.
   IF ( scalar_index_table( PARAM_ff1i12 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff1i12 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff1i12 , idomain ) = P_ff1i12
   ELSE
     P_ff1i12 = scalar_index_table( PARAM_ff1i12 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff1i12 ) = .TRUE.
   scalar_dname_table( idomain, P_ff1i12 ) = 'ff1i12'
   scalar_desc_table( idomain, P_ff1i12 ) = 'cloud/rain bin 12'
   scalar_units_table( idomain, P_ff1i12 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff1i12 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff1i12 )%stream(2) = 2097152 
   F_ff1i12 = .TRUE.
   IF ( scalar_index_table( PARAM_ff1i13 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff1i13 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff1i13 , idomain ) = P_ff1i13
   ELSE
     P_ff1i13 = scalar_index_table( PARAM_ff1i13 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff1i13 ) = .TRUE.
   scalar_dname_table( idomain, P_ff1i13 ) = 'ff1i13'
   scalar_desc_table( idomain, P_ff1i13 ) = 'cloud/rain bin 13'
   scalar_units_table( idomain, P_ff1i13 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff1i13 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff1i13 )%stream(2) = 2097152 
   F_ff1i13 = .TRUE.
   IF ( scalar_index_table( PARAM_ff1i14 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff1i14 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff1i14 , idomain ) = P_ff1i14
   ELSE
     P_ff1i14 = scalar_index_table( PARAM_ff1i14 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff1i14 ) = .TRUE.
   scalar_dname_table( idomain, P_ff1i14 ) = 'ff1i14'
   scalar_desc_table( idomain, P_ff1i14 ) = 'cloud/rain bin 14'
   scalar_units_table( idomain, P_ff1i14 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff1i14 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff1i14 )%stream(2) = 2097152 
   F_ff1i14 = .TRUE.
   IF ( scalar_index_table( PARAM_ff1i15 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff1i15 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff1i15 , idomain ) = P_ff1i15
   ELSE
     P_ff1i15 = scalar_index_table( PARAM_ff1i15 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff1i15 ) = .TRUE.
   scalar_dname_table( idomain, P_ff1i15 ) = 'ff1i15'
   scalar_desc_table( idomain, P_ff1i15 ) = 'cloud/rain bin 15'
   scalar_units_table( idomain, P_ff1i15 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff1i15 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff1i15 )%stream(2) = 2097152 
   F_ff1i15 = .TRUE.
   IF ( scalar_index_table( PARAM_ff1i16 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff1i16 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff1i16 , idomain ) = P_ff1i16
   ELSE
     P_ff1i16 = scalar_index_table( PARAM_ff1i16 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff1i16 ) = .TRUE.
   scalar_dname_table( idomain, P_ff1i16 ) = 'ff1i16'
   scalar_desc_table( idomain, P_ff1i16 ) = 'cloud/rain bin 16'
   scalar_units_table( idomain, P_ff1i16 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff1i16 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff1i16 )%stream(2) = 2097152 
   F_ff1i16 = .TRUE.
   IF ( scalar_index_table( PARAM_ff1i17 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff1i17 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff1i17 , idomain ) = P_ff1i17
   ELSE
     P_ff1i17 = scalar_index_table( PARAM_ff1i17 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff1i17 ) = .TRUE.
   scalar_dname_table( idomain, P_ff1i17 ) = 'ff1i17'
   scalar_desc_table( idomain, P_ff1i17 ) = 'cloud/rain bin 17'
   scalar_units_table( idomain, P_ff1i17 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff1i17 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff1i17 )%stream(2) = 2097152 
   F_ff1i17 = .TRUE.
   IF ( scalar_index_table( PARAM_ff1i18 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff1i18 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff1i18 , idomain ) = P_ff1i18
   ELSE
     P_ff1i18 = scalar_index_table( PARAM_ff1i18 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff1i18 ) = .TRUE.
   scalar_dname_table( idomain, P_ff1i18 ) = 'ff1i18'
   scalar_desc_table( idomain, P_ff1i18 ) = 'cloud/rain bin 18'
   scalar_units_table( idomain, P_ff1i18 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff1i18 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff1i18 )%stream(2) = 2097152 
   F_ff1i18 = .TRUE.
   IF ( scalar_index_table( PARAM_ff1i19 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff1i19 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff1i19 , idomain ) = P_ff1i19
   ELSE
     P_ff1i19 = scalar_index_table( PARAM_ff1i19 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff1i19 ) = .TRUE.
   scalar_dname_table( idomain, P_ff1i19 ) = 'ff1i19'
   scalar_desc_table( idomain, P_ff1i19 ) = 'cloud/rain bin 19'
   scalar_units_table( idomain, P_ff1i19 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff1i19 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff1i19 )%stream(2) = 2097152 
   F_ff1i19 = .TRUE.
   IF ( scalar_index_table( PARAM_ff1i20 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff1i20 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff1i20 , idomain ) = P_ff1i20
   ELSE
     P_ff1i20 = scalar_index_table( PARAM_ff1i20 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff1i20 ) = .TRUE.
   scalar_dname_table( idomain, P_ff1i20 ) = 'ff1i20'
   scalar_desc_table( idomain, P_ff1i20 ) = 'cloud/rain bin 20'
   scalar_units_table( idomain, P_ff1i20 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff1i20 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff1i20 )%stream(2) = 2097152 
   F_ff1i20 = .TRUE.
   IF ( scalar_index_table( PARAM_ff1i21 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff1i21 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff1i21 , idomain ) = P_ff1i21
   ELSE
     P_ff1i21 = scalar_index_table( PARAM_ff1i21 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff1i21 ) = .TRUE.
   scalar_dname_table( idomain, P_ff1i21 ) = 'ff1i21'
   scalar_desc_table( idomain, P_ff1i21 ) = 'cloud/rain bin 21'
   scalar_units_table( idomain, P_ff1i21 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff1i21 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff1i21 )%stream(2) = 2097152 
   F_ff1i21 = .TRUE.
   IF ( scalar_index_table( PARAM_ff1i22 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff1i22 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff1i22 , idomain ) = P_ff1i22
   ELSE
     P_ff1i22 = scalar_index_table( PARAM_ff1i22 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff1i22 ) = .TRUE.
   scalar_dname_table( idomain, P_ff1i22 ) = 'ff1i22'
   scalar_desc_table( idomain, P_ff1i22 ) = 'cloud/rain bin 22'
   scalar_units_table( idomain, P_ff1i22 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff1i22 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff1i22 )%stream(2) = 2097152 
   F_ff1i22 = .TRUE.
   IF ( scalar_index_table( PARAM_ff1i23 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff1i23 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff1i23 , idomain ) = P_ff1i23
   ELSE
     P_ff1i23 = scalar_index_table( PARAM_ff1i23 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff1i23 ) = .TRUE.
   scalar_dname_table( idomain, P_ff1i23 ) = 'ff1i23'
   scalar_desc_table( idomain, P_ff1i23 ) = 'cloud/rain bin 23'
   scalar_units_table( idomain, P_ff1i23 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff1i23 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff1i23 )%stream(2) = 2097152 
   F_ff1i23 = .TRUE.
   IF ( scalar_index_table( PARAM_ff1i24 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff1i24 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff1i24 , idomain ) = P_ff1i24
   ELSE
     P_ff1i24 = scalar_index_table( PARAM_ff1i24 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff1i24 ) = .TRUE.
   scalar_dname_table( idomain, P_ff1i24 ) = 'ff1i24'
   scalar_desc_table( idomain, P_ff1i24 ) = 'cloud/rain bin 24'
   scalar_units_table( idomain, P_ff1i24 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff1i24 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff1i24 )%stream(2) = 2097152 
   F_ff1i24 = .TRUE.
   IF ( scalar_index_table( PARAM_ff1i25 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff1i25 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff1i25 , idomain ) = P_ff1i25
   ELSE
     P_ff1i25 = scalar_index_table( PARAM_ff1i25 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff1i25 ) = .TRUE.
   scalar_dname_table( idomain, P_ff1i25 ) = 'ff1i25'
   scalar_desc_table( idomain, P_ff1i25 ) = 'cloud/rain bin 25'
   scalar_units_table( idomain, P_ff1i25 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff1i25 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff1i25 )%stream(2) = 2097152 
   F_ff1i25 = .TRUE.
   IF ( scalar_index_table( PARAM_ff1i26 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff1i26 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff1i26 , idomain ) = P_ff1i26
   ELSE
     P_ff1i26 = scalar_index_table( PARAM_ff1i26 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff1i26 ) = .TRUE.
   scalar_dname_table( idomain, P_ff1i26 ) = 'ff1i26'
   scalar_desc_table( idomain, P_ff1i26 ) = 'cloud/rain bin 26'
   scalar_units_table( idomain, P_ff1i26 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff1i26 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff1i26 )%stream(2) = 2097152 
   F_ff1i26 = .TRUE.
   IF ( scalar_index_table( PARAM_ff1i27 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff1i27 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff1i27 , idomain ) = P_ff1i27
   ELSE
     P_ff1i27 = scalar_index_table( PARAM_ff1i27 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff1i27 ) = .TRUE.
   scalar_dname_table( idomain, P_ff1i27 ) = 'ff1i27'
   scalar_desc_table( idomain, P_ff1i27 ) = 'cloud/rain bin 27'
   scalar_units_table( idomain, P_ff1i27 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff1i27 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff1i27 )%stream(2) = 2097152 
   F_ff1i27 = .TRUE.
   IF ( scalar_index_table( PARAM_ff1i28 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff1i28 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff1i28 , idomain ) = P_ff1i28
   ELSE
     P_ff1i28 = scalar_index_table( PARAM_ff1i28 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff1i28 ) = .TRUE.
   scalar_dname_table( idomain, P_ff1i28 ) = 'ff1i28'
   scalar_desc_table( idomain, P_ff1i28 ) = 'cloud/rain bin 28'
   scalar_units_table( idomain, P_ff1i28 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff1i28 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff1i28 )%stream(2) = 2097152 
   F_ff1i28 = .TRUE.
   IF ( scalar_index_table( PARAM_ff1i29 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff1i29 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff1i29 , idomain ) = P_ff1i29
   ELSE
     P_ff1i29 = scalar_index_table( PARAM_ff1i29 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff1i29 ) = .TRUE.
   scalar_dname_table( idomain, P_ff1i29 ) = 'ff1i29'
   scalar_desc_table( idomain, P_ff1i29 ) = 'cloud/rain bin 29'
   scalar_units_table( idomain, P_ff1i29 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff1i29 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff1i29 )%stream(2) = 2097152 
   F_ff1i29 = .TRUE.
   IF ( scalar_index_table( PARAM_ff1i30 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff1i30 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff1i30 , idomain ) = P_ff1i30
   ELSE
     P_ff1i30 = scalar_index_table( PARAM_ff1i30 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff1i30 ) = .TRUE.
   scalar_dname_table( idomain, P_ff1i30 ) = 'ff1i30'
   scalar_desc_table( idomain, P_ff1i30 ) = 'cloud/rain bin 30'
   scalar_units_table( idomain, P_ff1i30 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff1i30 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff1i30 )%stream(2) = 2097152 
   F_ff1i30 = .TRUE.
   IF ( scalar_index_table( PARAM_ff1i31 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff1i31 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff1i31 , idomain ) = P_ff1i31
   ELSE
     P_ff1i31 = scalar_index_table( PARAM_ff1i31 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff1i31 ) = .TRUE.
   scalar_dname_table( idomain, P_ff1i31 ) = 'ff1i31'
   scalar_desc_table( idomain, P_ff1i31 ) = 'cloud/rain bin 31'
   scalar_units_table( idomain, P_ff1i31 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff1i31 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff1i31 )%stream(2) = 2097152 
   F_ff1i31 = .TRUE.
   IF ( scalar_index_table( PARAM_ff1i32 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff1i32 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff1i32 , idomain ) = P_ff1i32
   ELSE
     P_ff1i32 = scalar_index_table( PARAM_ff1i32 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff1i32 ) = .TRUE.
   scalar_dname_table( idomain, P_ff1i32 ) = 'ff1i32'
   scalar_desc_table( idomain, P_ff1i32 ) = 'cloud/rain bin 32'
   scalar_units_table( idomain, P_ff1i32 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff1i32 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff1i32 )%stream(2) = 2097152 
   F_ff1i32 = .TRUE.
   IF ( scalar_index_table( PARAM_ff1i33 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff1i33 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff1i33 , idomain ) = P_ff1i33
   ELSE
     P_ff1i33 = scalar_index_table( PARAM_ff1i33 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff1i33 ) = .TRUE.
   scalar_dname_table( idomain, P_ff1i33 ) = 'ff1i33'
   scalar_desc_table( idomain, P_ff1i33 ) = 'cloud/rain bin 33'
   scalar_units_table( idomain, P_ff1i33 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff1i33 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff1i33 )%stream(2) = 2097152 
   F_ff1i33 = .TRUE.
   IF ( scalar_index_table( PARAM_ff5i01 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff5i01 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff5i01 , idomain ) = P_ff5i01
   ELSE
     P_ff5i01 = scalar_index_table( PARAM_ff5i01 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff5i01 ) = .TRUE.
   scalar_dname_table( idomain, P_ff5i01 ) = 'ff5i01'
   scalar_desc_table( idomain, P_ff5i01 ) = 'snow bin 1'
   scalar_units_table( idomain, P_ff5i01 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff5i01 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff5i01 )%stream(2) = 2097152 
   F_ff5i01 = .TRUE.
   IF ( scalar_index_table( PARAM_ff5i02 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff5i02 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff5i02 , idomain ) = P_ff5i02
   ELSE
     P_ff5i02 = scalar_index_table( PARAM_ff5i02 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff5i02 ) = .TRUE.
   scalar_dname_table( idomain, P_ff5i02 ) = 'ff5i02'
   scalar_desc_table( idomain, P_ff5i02 ) = 'snow bin 2'
   scalar_units_table( idomain, P_ff5i02 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff5i02 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff5i02 )%stream(2) = 2097152 
   F_ff5i02 = .TRUE.
   IF ( scalar_index_table( PARAM_ff5i03 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff5i03 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff5i03 , idomain ) = P_ff5i03
   ELSE
     P_ff5i03 = scalar_index_table( PARAM_ff5i03 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff5i03 ) = .TRUE.
   scalar_dname_table( idomain, P_ff5i03 ) = 'ff5i03'
   scalar_desc_table( idomain, P_ff5i03 ) = 'snow bin 3'
   scalar_units_table( idomain, P_ff5i03 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff5i03 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff5i03 )%stream(2) = 2097152 
   F_ff5i03 = .TRUE.
   IF ( scalar_index_table( PARAM_ff5i04 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff5i04 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff5i04 , idomain ) = P_ff5i04
   ELSE
     P_ff5i04 = scalar_index_table( PARAM_ff5i04 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff5i04 ) = .TRUE.
   scalar_dname_table( idomain, P_ff5i04 ) = 'ff5i04'
   scalar_desc_table( idomain, P_ff5i04 ) = 'snow bin 4'
   scalar_units_table( idomain, P_ff5i04 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff5i04 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff5i04 )%stream(2) = 2097152 
   F_ff5i04 = .TRUE.
   IF ( scalar_index_table( PARAM_ff5i05 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff5i05 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff5i05 , idomain ) = P_ff5i05
   ELSE
     P_ff5i05 = scalar_index_table( PARAM_ff5i05 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff5i05 ) = .TRUE.
   scalar_dname_table( idomain, P_ff5i05 ) = 'ff5i05'
   scalar_desc_table( idomain, P_ff5i05 ) = 'snow bin 5'
   scalar_units_table( idomain, P_ff5i05 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff5i05 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff5i05 )%stream(2) = 2097152 
   F_ff5i05 = .TRUE.
   IF ( scalar_index_table( PARAM_ff5i06 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff5i06 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff5i06 , idomain ) = P_ff5i06
   ELSE
     P_ff5i06 = scalar_index_table( PARAM_ff5i06 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff5i06 ) = .TRUE.
   scalar_dname_table( idomain, P_ff5i06 ) = 'ff5i06'
   scalar_desc_table( idomain, P_ff5i06 ) = 'snow bin 6'
   scalar_units_table( idomain, P_ff5i06 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff5i06 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff5i06 )%stream(2) = 2097152 
   F_ff5i06 = .TRUE.
   IF ( scalar_index_table( PARAM_ff5i07 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff5i07 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff5i07 , idomain ) = P_ff5i07
   ELSE
     P_ff5i07 = scalar_index_table( PARAM_ff5i07 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff5i07 ) = .TRUE.
   scalar_dname_table( idomain, P_ff5i07 ) = 'ff5i07'
   scalar_desc_table( idomain, P_ff5i07 ) = 'snow bin 7'
   scalar_units_table( idomain, P_ff5i07 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff5i07 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff5i07 )%stream(2) = 2097152 
   F_ff5i07 = .TRUE.
   IF ( scalar_index_table( PARAM_ff5i08 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff5i08 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff5i08 , idomain ) = P_ff5i08
   ELSE
     P_ff5i08 = scalar_index_table( PARAM_ff5i08 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff5i08 ) = .TRUE.
   scalar_dname_table( idomain, P_ff5i08 ) = 'ff5i08'
   scalar_desc_table( idomain, P_ff5i08 ) = 'snow bin 8'
   scalar_units_table( idomain, P_ff5i08 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff5i08 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff5i08 )%stream(2) = 2097152 
   F_ff5i08 = .TRUE.
   IF ( scalar_index_table( PARAM_ff5i09 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff5i09 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff5i09 , idomain ) = P_ff5i09
   ELSE
     P_ff5i09 = scalar_index_table( PARAM_ff5i09 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff5i09 ) = .TRUE.
   scalar_dname_table( idomain, P_ff5i09 ) = 'ff5i09'
   scalar_desc_table( idomain, P_ff5i09 ) = 'snow bin 9'
   scalar_units_table( idomain, P_ff5i09 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff5i09 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff5i09 )%stream(2) = 2097152 
   F_ff5i09 = .TRUE.
   IF ( scalar_index_table( PARAM_ff5i10 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff5i10 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff5i10 , idomain ) = P_ff5i10
   ELSE
     P_ff5i10 = scalar_index_table( PARAM_ff5i10 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff5i10 ) = .TRUE.
   scalar_dname_table( idomain, P_ff5i10 ) = 'ff5i10'
   scalar_desc_table( idomain, P_ff5i10 ) = 'snow bin 10'
   scalar_units_table( idomain, P_ff5i10 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff5i10 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff5i10 )%stream(2) = 2097152 
   F_ff5i10 = .TRUE.
   IF ( scalar_index_table( PARAM_ff5i11 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff5i11 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff5i11 , idomain ) = P_ff5i11
   ELSE
     P_ff5i11 = scalar_index_table( PARAM_ff5i11 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff5i11 ) = .TRUE.
   scalar_dname_table( idomain, P_ff5i11 ) = 'ff5i11'
   scalar_desc_table( idomain, P_ff5i11 ) = 'snow bin 11'
   scalar_units_table( idomain, P_ff5i11 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff5i11 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff5i11 )%stream(2) = 2097152 
   F_ff5i11 = .TRUE.
   IF ( scalar_index_table( PARAM_ff5i12 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff5i12 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff5i12 , idomain ) = P_ff5i12
   ELSE
     P_ff5i12 = scalar_index_table( PARAM_ff5i12 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff5i12 ) = .TRUE.
   scalar_dname_table( idomain, P_ff5i12 ) = 'ff5i12'
   scalar_desc_table( idomain, P_ff5i12 ) = 'snow bin 12'
   scalar_units_table( idomain, P_ff5i12 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff5i12 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff5i12 )%stream(2) = 2097152 
   F_ff5i12 = .TRUE.
   IF ( scalar_index_table( PARAM_ff5i13 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff5i13 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff5i13 , idomain ) = P_ff5i13
   ELSE
     P_ff5i13 = scalar_index_table( PARAM_ff5i13 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff5i13 ) = .TRUE.
   scalar_dname_table( idomain, P_ff5i13 ) = 'ff5i13'
   scalar_desc_table( idomain, P_ff5i13 ) = 'snow bin 13'
   scalar_units_table( idomain, P_ff5i13 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff5i13 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff5i13 )%stream(2) = 2097152 
   F_ff5i13 = .TRUE.
   IF ( scalar_index_table( PARAM_ff5i14 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff5i14 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff5i14 , idomain ) = P_ff5i14
   ELSE
     P_ff5i14 = scalar_index_table( PARAM_ff5i14 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff5i14 ) = .TRUE.
   scalar_dname_table( idomain, P_ff5i14 ) = 'ff5i14'
   scalar_desc_table( idomain, P_ff5i14 ) = 'snow bin 14'
   scalar_units_table( idomain, P_ff5i14 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff5i14 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff5i14 )%stream(2) = 2097152 
   F_ff5i14 = .TRUE.
   IF ( scalar_index_table( PARAM_ff5i15 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff5i15 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff5i15 , idomain ) = P_ff5i15
   ELSE
     P_ff5i15 = scalar_index_table( PARAM_ff5i15 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff5i15 ) = .TRUE.
   scalar_dname_table( idomain, P_ff5i15 ) = 'ff5i15'
   scalar_desc_table( idomain, P_ff5i15 ) = 'snow bin 15'
   scalar_units_table( idomain, P_ff5i15 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff5i15 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff5i15 )%stream(2) = 2097152 
   F_ff5i15 = .TRUE.
   IF ( scalar_index_table( PARAM_ff5i16 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff5i16 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff5i16 , idomain ) = P_ff5i16
   ELSE
     P_ff5i16 = scalar_index_table( PARAM_ff5i16 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff5i16 ) = .TRUE.
   scalar_dname_table( idomain, P_ff5i16 ) = 'ff5i16'
   scalar_desc_table( idomain, P_ff5i16 ) = 'snow bin 16'
   scalar_units_table( idomain, P_ff5i16 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff5i16 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff5i16 )%stream(2) = 2097152 
   F_ff5i16 = .TRUE.
   IF ( scalar_index_table( PARAM_ff5i17 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff5i17 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff5i17 , idomain ) = P_ff5i17
   ELSE
     P_ff5i17 = scalar_index_table( PARAM_ff5i17 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff5i17 ) = .TRUE.
   scalar_dname_table( idomain, P_ff5i17 ) = 'ff5i17'
   scalar_desc_table( idomain, P_ff5i17 ) = 'snow bin 17'
   scalar_units_table( idomain, P_ff5i17 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff5i17 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff5i17 )%stream(2) = 2097152 
   F_ff5i17 = .TRUE.
   IF ( scalar_index_table( PARAM_ff5i18 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff5i18 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff5i18 , idomain ) = P_ff5i18
   ELSE
     P_ff5i18 = scalar_index_table( PARAM_ff5i18 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff5i18 ) = .TRUE.
   scalar_dname_table( idomain, P_ff5i18 ) = 'ff5i18'
   scalar_desc_table( idomain, P_ff5i18 ) = 'snow bin 18'
   scalar_units_table( idomain, P_ff5i18 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff5i18 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff5i18 )%stream(2) = 2097152 
   F_ff5i18 = .TRUE.
   IF ( scalar_index_table( PARAM_ff5i19 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff5i19 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff5i19 , idomain ) = P_ff5i19
   ELSE
     P_ff5i19 = scalar_index_table( PARAM_ff5i19 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff5i19 ) = .TRUE.
   scalar_dname_table( idomain, P_ff5i19 ) = 'ff5i19'
   scalar_desc_table( idomain, P_ff5i19 ) = 'snow bin 19'
   scalar_units_table( idomain, P_ff5i19 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff5i19 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff5i19 )%stream(2) = 2097152 
   F_ff5i19 = .TRUE.
   IF ( scalar_index_table( PARAM_ff5i20 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff5i20 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff5i20 , idomain ) = P_ff5i20
   ELSE
     P_ff5i20 = scalar_index_table( PARAM_ff5i20 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff5i20 ) = .TRUE.
   scalar_dname_table( idomain, P_ff5i20 ) = 'ff5i20'
   scalar_desc_table( idomain, P_ff5i20 ) = 'snow bin 20'
   scalar_units_table( idomain, P_ff5i20 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff5i20 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff5i20 )%stream(2) = 2097152 
   F_ff5i20 = .TRUE.
   IF ( scalar_index_table( PARAM_ff5i21 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff5i21 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff5i21 , idomain ) = P_ff5i21
   ELSE
     P_ff5i21 = scalar_index_table( PARAM_ff5i21 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff5i21 ) = .TRUE.
   scalar_dname_table( idomain, P_ff5i21 ) = 'ff5i21'
   scalar_desc_table( idomain, P_ff5i21 ) = 'snow bin 21'
   scalar_units_table( idomain, P_ff5i21 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff5i21 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff5i21 )%stream(2) = 2097152 
   F_ff5i21 = .TRUE.
   IF ( scalar_index_table( PARAM_ff5i22 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff5i22 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff5i22 , idomain ) = P_ff5i22
   ELSE
     P_ff5i22 = scalar_index_table( PARAM_ff5i22 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff5i22 ) = .TRUE.
   scalar_dname_table( idomain, P_ff5i22 ) = 'ff5i22'
   scalar_desc_table( idomain, P_ff5i22 ) = 'snow bin 22'
   scalar_units_table( idomain, P_ff5i22 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff5i22 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff5i22 )%stream(2) = 2097152 
   F_ff5i22 = .TRUE.
   IF ( scalar_index_table( PARAM_ff5i23 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff5i23 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff5i23 , idomain ) = P_ff5i23
   ELSE
     P_ff5i23 = scalar_index_table( PARAM_ff5i23 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff5i23 ) = .TRUE.
   scalar_dname_table( idomain, P_ff5i23 ) = 'ff5i23'
   scalar_desc_table( idomain, P_ff5i23 ) = 'snow bin 23'
   scalar_units_table( idomain, P_ff5i23 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff5i23 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff5i23 )%stream(2) = 2097152 
   F_ff5i23 = .TRUE.
   IF ( scalar_index_table( PARAM_ff5i24 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff5i24 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff5i24 , idomain ) = P_ff5i24
   ELSE
     P_ff5i24 = scalar_index_table( PARAM_ff5i24 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff5i24 ) = .TRUE.
   scalar_dname_table( idomain, P_ff5i24 ) = 'ff5i24'
   scalar_desc_table( idomain, P_ff5i24 ) = 'snow bin 24'
   scalar_units_table( idomain, P_ff5i24 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff5i24 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff5i24 )%stream(2) = 2097152 
   F_ff5i24 = .TRUE.
   IF ( scalar_index_table( PARAM_ff5i25 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff5i25 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff5i25 , idomain ) = P_ff5i25
   ELSE
     P_ff5i25 = scalar_index_table( PARAM_ff5i25 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff5i25 ) = .TRUE.
   scalar_dname_table( idomain, P_ff5i25 ) = 'ff5i25'
   scalar_desc_table( idomain, P_ff5i25 ) = 'snow bin 25'
   scalar_units_table( idomain, P_ff5i25 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff5i25 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff5i25 )%stream(2) = 2097152 
   F_ff5i25 = .TRUE.
   IF ( scalar_index_table( PARAM_ff5i26 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff5i26 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff5i26 , idomain ) = P_ff5i26
   ELSE
     P_ff5i26 = scalar_index_table( PARAM_ff5i26 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff5i26 ) = .TRUE.
   scalar_dname_table( idomain, P_ff5i26 ) = 'ff5i26'
   scalar_desc_table( idomain, P_ff5i26 ) = 'snow bin 26'
   scalar_units_table( idomain, P_ff5i26 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff5i26 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff5i26 )%stream(2) = 2097152 
   F_ff5i26 = .TRUE.
   IF ( scalar_index_table( PARAM_ff5i27 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff5i27 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff5i27 , idomain ) = P_ff5i27
   ELSE
     P_ff5i27 = scalar_index_table( PARAM_ff5i27 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff5i27 ) = .TRUE.
   scalar_dname_table( idomain, P_ff5i27 ) = 'ff5i27'
   scalar_desc_table( idomain, P_ff5i27 ) = 'snow bin 27'
   scalar_units_table( idomain, P_ff5i27 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff5i27 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff5i27 )%stream(2) = 2097152 
   F_ff5i27 = .TRUE.
   IF ( scalar_index_table( PARAM_ff5i28 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff5i28 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff5i28 , idomain ) = P_ff5i28
   ELSE
     P_ff5i28 = scalar_index_table( PARAM_ff5i28 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff5i28 ) = .TRUE.
   scalar_dname_table( idomain, P_ff5i28 ) = 'ff5i28'
   scalar_desc_table( idomain, P_ff5i28 ) = 'snow bin 28'
   scalar_units_table( idomain, P_ff5i28 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff5i28 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff5i28 )%stream(2) = 2097152 
   F_ff5i28 = .TRUE.
   IF ( scalar_index_table( PARAM_ff5i29 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff5i29 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff5i29 , idomain ) = P_ff5i29
   ELSE
     P_ff5i29 = scalar_index_table( PARAM_ff5i29 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff5i29 ) = .TRUE.
   scalar_dname_table( idomain, P_ff5i29 ) = 'ff5i29'
   scalar_desc_table( idomain, P_ff5i29 ) = 'snow bin 29'
   scalar_units_table( idomain, P_ff5i29 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff5i29 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff5i29 )%stream(2) = 2097152 
   F_ff5i29 = .TRUE.
   IF ( scalar_index_table( PARAM_ff5i30 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff5i30 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff5i30 , idomain ) = P_ff5i30
   ELSE
     P_ff5i30 = scalar_index_table( PARAM_ff5i30 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff5i30 ) = .TRUE.
   scalar_dname_table( idomain, P_ff5i30 ) = 'ff5i30'
   scalar_desc_table( idomain, P_ff5i30 ) = 'snow bin 30'
   scalar_units_table( idomain, P_ff5i30 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff5i30 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff5i30 )%stream(2) = 2097152 
   F_ff5i30 = .TRUE.
   IF ( scalar_index_table( PARAM_ff5i31 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff5i31 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff5i31 , idomain ) = P_ff5i31
   ELSE
     P_ff5i31 = scalar_index_table( PARAM_ff5i31 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff5i31 ) = .TRUE.
   scalar_dname_table( idomain, P_ff5i31 ) = 'ff5i31'
   scalar_desc_table( idomain, P_ff5i31 ) = 'snow bin 31'
   scalar_units_table( idomain, P_ff5i31 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff5i31 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff5i31 )%stream(2) = 2097152 
   F_ff5i31 = .TRUE.
   IF ( scalar_index_table( PARAM_ff5i32 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff5i32 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff5i32 , idomain ) = P_ff5i32
   ELSE
     P_ff5i32 = scalar_index_table( PARAM_ff5i32 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff5i32 ) = .TRUE.
   scalar_dname_table( idomain, P_ff5i32 ) = 'ff5i32'
   scalar_desc_table( idomain, P_ff5i32 ) = 'snow bin 32'
   scalar_units_table( idomain, P_ff5i32 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff5i32 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff5i32 )%stream(2) = 2097152 
   F_ff5i32 = .TRUE.
   IF ( scalar_index_table( PARAM_ff5i33 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff5i33 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff5i33 , idomain ) = P_ff5i33
   ELSE
     P_ff5i33 = scalar_index_table( PARAM_ff5i33 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff5i33 ) = .TRUE.
   scalar_dname_table( idomain, P_ff5i33 ) = 'ff5i33'
   scalar_desc_table( idomain, P_ff5i33 ) = 'snow bin 33'
   scalar_units_table( idomain, P_ff5i33 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff5i33 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff5i33 )%stream(2) = 2097152 
   F_ff5i33 = .TRUE.
   IF ( scalar_index_table( PARAM_ff6i01 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff6i01 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff6i01 , idomain ) = P_ff6i01
   ELSE
     P_ff6i01 = scalar_index_table( PARAM_ff6i01 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff6i01 ) = .TRUE.
   scalar_dname_table( idomain, P_ff6i01 ) = 'ff6i01'
   scalar_desc_table( idomain, P_ff6i01 ) = 'graupel bin 1'
   scalar_units_table( idomain, P_ff6i01 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff6i01 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff6i01 )%stream(2) = 2097152 
   F_ff6i01 = .TRUE.
   IF ( scalar_index_table( PARAM_ff6i02 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff6i02 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff6i02 , idomain ) = P_ff6i02
   ELSE
     P_ff6i02 = scalar_index_table( PARAM_ff6i02 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff6i02 ) = .TRUE.
   scalar_dname_table( idomain, P_ff6i02 ) = 'ff6i02'
   scalar_desc_table( idomain, P_ff6i02 ) = 'graupel bin 2'
   scalar_units_table( idomain, P_ff6i02 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff6i02 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff6i02 )%stream(2) = 2097152 
   F_ff6i02 = .TRUE.
   IF ( scalar_index_table( PARAM_ff6i03 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff6i03 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff6i03 , idomain ) = P_ff6i03
   ELSE
     P_ff6i03 = scalar_index_table( PARAM_ff6i03 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff6i03 ) = .TRUE.
   scalar_dname_table( idomain, P_ff6i03 ) = 'ff6i03'
   scalar_desc_table( idomain, P_ff6i03 ) = 'graupel bin 3'
   scalar_units_table( idomain, P_ff6i03 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff6i03 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff6i03 )%stream(2) = 2097152 
   F_ff6i03 = .TRUE.
   IF ( scalar_index_table( PARAM_ff6i04 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff6i04 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff6i04 , idomain ) = P_ff6i04
   ELSE
     P_ff6i04 = scalar_index_table( PARAM_ff6i04 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff6i04 ) = .TRUE.
   scalar_dname_table( idomain, P_ff6i04 ) = 'ff6i04'
   scalar_desc_table( idomain, P_ff6i04 ) = 'graupel bin 4'
   scalar_units_table( idomain, P_ff6i04 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff6i04 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff6i04 )%stream(2) = 2097152 
   F_ff6i04 = .TRUE.
   IF ( scalar_index_table( PARAM_ff6i05 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff6i05 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff6i05 , idomain ) = P_ff6i05
   ELSE
     P_ff6i05 = scalar_index_table( PARAM_ff6i05 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff6i05 ) = .TRUE.
   scalar_dname_table( idomain, P_ff6i05 ) = 'ff6i05'
   scalar_desc_table( idomain, P_ff6i05 ) = 'graupel bin 5'
   scalar_units_table( idomain, P_ff6i05 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff6i05 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff6i05 )%stream(2) = 2097152 
   F_ff6i05 = .TRUE.
   IF ( scalar_index_table( PARAM_ff6i06 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff6i06 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff6i06 , idomain ) = P_ff6i06
   ELSE
     P_ff6i06 = scalar_index_table( PARAM_ff6i06 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff6i06 ) = .TRUE.
   scalar_dname_table( idomain, P_ff6i06 ) = 'ff6i06'
   scalar_desc_table( idomain, P_ff6i06 ) = 'graupel bin 6'
   scalar_units_table( idomain, P_ff6i06 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff6i06 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff6i06 )%stream(2) = 2097152 
   F_ff6i06 = .TRUE.
   IF ( scalar_index_table( PARAM_ff6i07 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff6i07 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff6i07 , idomain ) = P_ff6i07
   ELSE
     P_ff6i07 = scalar_index_table( PARAM_ff6i07 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff6i07 ) = .TRUE.
   scalar_dname_table( idomain, P_ff6i07 ) = 'ff6i07'
   scalar_desc_table( idomain, P_ff6i07 ) = 'graupel bin 7'
   scalar_units_table( idomain, P_ff6i07 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff6i07 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff6i07 )%stream(2) = 2097152 
   F_ff6i07 = .TRUE.
   IF ( scalar_index_table( PARAM_ff6i08 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff6i08 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff6i08 , idomain ) = P_ff6i08
   ELSE
     P_ff6i08 = scalar_index_table( PARAM_ff6i08 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff6i08 ) = .TRUE.
   scalar_dname_table( idomain, P_ff6i08 ) = 'ff6i08'
   scalar_desc_table( idomain, P_ff6i08 ) = 'graupel bin 8'
   scalar_units_table( idomain, P_ff6i08 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff6i08 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff6i08 )%stream(2) = 2097152 
   F_ff6i08 = .TRUE.
   IF ( scalar_index_table( PARAM_ff6i09 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff6i09 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff6i09 , idomain ) = P_ff6i09
   ELSE
     P_ff6i09 = scalar_index_table( PARAM_ff6i09 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff6i09 ) = .TRUE.
   scalar_dname_table( idomain, P_ff6i09 ) = 'ff6i09'
   scalar_desc_table( idomain, P_ff6i09 ) = 'graupel bin 9'
   scalar_units_table( idomain, P_ff6i09 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff6i09 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff6i09 )%stream(2) = 2097152 
   F_ff6i09 = .TRUE.
   IF ( scalar_index_table( PARAM_ff6i10 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff6i10 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff6i10 , idomain ) = P_ff6i10
   ELSE
     P_ff6i10 = scalar_index_table( PARAM_ff6i10 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff6i10 ) = .TRUE.
   scalar_dname_table( idomain, P_ff6i10 ) = 'ff6i10'
   scalar_desc_table( idomain, P_ff6i10 ) = 'graupel bin 10'
   scalar_units_table( idomain, P_ff6i10 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff6i10 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff6i10 )%stream(2) = 2097152 
   F_ff6i10 = .TRUE.
   IF ( scalar_index_table( PARAM_ff6i11 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff6i11 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff6i11 , idomain ) = P_ff6i11
   ELSE
     P_ff6i11 = scalar_index_table( PARAM_ff6i11 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff6i11 ) = .TRUE.
   scalar_dname_table( idomain, P_ff6i11 ) = 'ff6i11'
   scalar_desc_table( idomain, P_ff6i11 ) = 'graupel bin 11'
   scalar_units_table( idomain, P_ff6i11 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff6i11 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff6i11 )%stream(2) = 2097152 
   F_ff6i11 = .TRUE.
   IF ( scalar_index_table( PARAM_ff6i12 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff6i12 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff6i12 , idomain ) = P_ff6i12
   ELSE
     P_ff6i12 = scalar_index_table( PARAM_ff6i12 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff6i12 ) = .TRUE.
   scalar_dname_table( idomain, P_ff6i12 ) = 'ff6i12'
   scalar_desc_table( idomain, P_ff6i12 ) = 'graupel bin 12'
   scalar_units_table( idomain, P_ff6i12 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff6i12 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff6i12 )%stream(2) = 2097152 
   F_ff6i12 = .TRUE.
   IF ( scalar_index_table( PARAM_ff6i13 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff6i13 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff6i13 , idomain ) = P_ff6i13
   ELSE
     P_ff6i13 = scalar_index_table( PARAM_ff6i13 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff6i13 ) = .TRUE.
   scalar_dname_table( idomain, P_ff6i13 ) = 'ff6i13'
   scalar_desc_table( idomain, P_ff6i13 ) = 'graupel bin 13'
   scalar_units_table( idomain, P_ff6i13 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff6i13 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff6i13 )%stream(2) = 2097152 
   F_ff6i13 = .TRUE.
   IF ( scalar_index_table( PARAM_ff6i14 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff6i14 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff6i14 , idomain ) = P_ff6i14
   ELSE
     P_ff6i14 = scalar_index_table( PARAM_ff6i14 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff6i14 ) = .TRUE.
   scalar_dname_table( idomain, P_ff6i14 ) = 'ff6i14'
   scalar_desc_table( idomain, P_ff6i14 ) = 'graupel bin 14'
   scalar_units_table( idomain, P_ff6i14 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff6i14 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff6i14 )%stream(2) = 2097152 
   F_ff6i14 = .TRUE.
   IF ( scalar_index_table( PARAM_ff6i15 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff6i15 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff6i15 , idomain ) = P_ff6i15
   ELSE
     P_ff6i15 = scalar_index_table( PARAM_ff6i15 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff6i15 ) = .TRUE.
   scalar_dname_table( idomain, P_ff6i15 ) = 'ff6i15'
   scalar_desc_table( idomain, P_ff6i15 ) = 'graupel bin 15'
   scalar_units_table( idomain, P_ff6i15 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff6i15 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff6i15 )%stream(2) = 2097152 
   F_ff6i15 = .TRUE.
   IF ( scalar_index_table( PARAM_ff6i16 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff6i16 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff6i16 , idomain ) = P_ff6i16
   ELSE
     P_ff6i16 = scalar_index_table( PARAM_ff6i16 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff6i16 ) = .TRUE.
   scalar_dname_table( idomain, P_ff6i16 ) = 'ff6i16'
   scalar_desc_table( idomain, P_ff6i16 ) = 'graupel bin 16'
   scalar_units_table( idomain, P_ff6i16 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff6i16 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff6i16 )%stream(2) = 2097152 
   F_ff6i16 = .TRUE.
   IF ( scalar_index_table( PARAM_ff6i17 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff6i17 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff6i17 , idomain ) = P_ff6i17
   ELSE
     P_ff6i17 = scalar_index_table( PARAM_ff6i17 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff6i17 ) = .TRUE.
   scalar_dname_table( idomain, P_ff6i17 ) = 'ff6i17'
   scalar_desc_table( idomain, P_ff6i17 ) = 'graupel bin 17'
   scalar_units_table( idomain, P_ff6i17 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff6i17 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff6i17 )%stream(2) = 2097152 
   F_ff6i17 = .TRUE.
   IF ( scalar_index_table( PARAM_ff6i18 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff6i18 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff6i18 , idomain ) = P_ff6i18
   ELSE
     P_ff6i18 = scalar_index_table( PARAM_ff6i18 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff6i18 ) = .TRUE.
   scalar_dname_table( idomain, P_ff6i18 ) = 'ff6i18'
   scalar_desc_table( idomain, P_ff6i18 ) = 'graupel bin 18'
   scalar_units_table( idomain, P_ff6i18 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff6i18 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff6i18 )%stream(2) = 2097152 
   F_ff6i18 = .TRUE.
   IF ( scalar_index_table( PARAM_ff6i19 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff6i19 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff6i19 , idomain ) = P_ff6i19
   ELSE
     P_ff6i19 = scalar_index_table( PARAM_ff6i19 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff6i19 ) = .TRUE.
   scalar_dname_table( idomain, P_ff6i19 ) = 'ff6i19'
   scalar_desc_table( idomain, P_ff6i19 ) = 'graupel bin 19'
   scalar_units_table( idomain, P_ff6i19 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff6i19 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff6i19 )%stream(2) = 2097152 
   F_ff6i19 = .TRUE.
   IF ( scalar_index_table( PARAM_ff6i20 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff6i20 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff6i20 , idomain ) = P_ff6i20
   ELSE
     P_ff6i20 = scalar_index_table( PARAM_ff6i20 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff6i20 ) = .TRUE.
   scalar_dname_table( idomain, P_ff6i20 ) = 'ff6i20'
   scalar_desc_table( idomain, P_ff6i20 ) = 'graupel bin 20'
   scalar_units_table( idomain, P_ff6i20 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff6i20 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff6i20 )%stream(2) = 2097152 
   F_ff6i20 = .TRUE.
   IF ( scalar_index_table( PARAM_ff6i21 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff6i21 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff6i21 , idomain ) = P_ff6i21
   ELSE
     P_ff6i21 = scalar_index_table( PARAM_ff6i21 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff6i21 ) = .TRUE.
   scalar_dname_table( idomain, P_ff6i21 ) = 'ff6i21'
   scalar_desc_table( idomain, P_ff6i21 ) = 'graupel bin 21'
   scalar_units_table( idomain, P_ff6i21 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff6i21 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff6i21 )%stream(2) = 2097152 
   F_ff6i21 = .TRUE.
   IF ( scalar_index_table( PARAM_ff6i22 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff6i22 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff6i22 , idomain ) = P_ff6i22
   ELSE
     P_ff6i22 = scalar_index_table( PARAM_ff6i22 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff6i22 ) = .TRUE.
   scalar_dname_table( idomain, P_ff6i22 ) = 'ff6i22'
   scalar_desc_table( idomain, P_ff6i22 ) = 'graupel bin 22'
   scalar_units_table( idomain, P_ff6i22 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff6i22 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff6i22 )%stream(2) = 2097152 
   F_ff6i22 = .TRUE.
   IF ( scalar_index_table( PARAM_ff6i23 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff6i23 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff6i23 , idomain ) = P_ff6i23
   ELSE
     P_ff6i23 = scalar_index_table( PARAM_ff6i23 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff6i23 ) = .TRUE.
   scalar_dname_table( idomain, P_ff6i23 ) = 'ff6i23'
   scalar_desc_table( idomain, P_ff6i23 ) = 'graupel bin 23'
   scalar_units_table( idomain, P_ff6i23 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff6i23 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff6i23 )%stream(2) = 2097152 
   F_ff6i23 = .TRUE.
   IF ( scalar_index_table( PARAM_ff6i24 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff6i24 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff6i24 , idomain ) = P_ff6i24
   ELSE
     P_ff6i24 = scalar_index_table( PARAM_ff6i24 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff6i24 ) = .TRUE.
   scalar_dname_table( idomain, P_ff6i24 ) = 'ff6i24'
   scalar_desc_table( idomain, P_ff6i24 ) = 'graupel bin 24'
   scalar_units_table( idomain, P_ff6i24 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff6i24 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff6i24 )%stream(2) = 2097152 
   F_ff6i24 = .TRUE.
   IF ( scalar_index_table( PARAM_ff6i25 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff6i25 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff6i25 , idomain ) = P_ff6i25
   ELSE
     P_ff6i25 = scalar_index_table( PARAM_ff6i25 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff6i25 ) = .TRUE.
   scalar_dname_table( idomain, P_ff6i25 ) = 'ff6i25'
   scalar_desc_table( idomain, P_ff6i25 ) = 'graupel bin 25'
   scalar_units_table( idomain, P_ff6i25 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff6i25 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff6i25 )%stream(2) = 2097152 
   F_ff6i25 = .TRUE.
   IF ( scalar_index_table( PARAM_ff6i26 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff6i26 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff6i26 , idomain ) = P_ff6i26
   ELSE
     P_ff6i26 = scalar_index_table( PARAM_ff6i26 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff6i26 ) = .TRUE.
   scalar_dname_table( idomain, P_ff6i26 ) = 'ff6i26'
   scalar_desc_table( idomain, P_ff6i26 ) = 'graupel bin 26'
   scalar_units_table( idomain, P_ff6i26 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff6i26 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff6i26 )%stream(2) = 2097152 
   F_ff6i26 = .TRUE.
   IF ( scalar_index_table( PARAM_ff6i27 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff6i27 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff6i27 , idomain ) = P_ff6i27
   ELSE
     P_ff6i27 = scalar_index_table( PARAM_ff6i27 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff6i27 ) = .TRUE.
   scalar_dname_table( idomain, P_ff6i27 ) = 'ff6i27'
   scalar_desc_table( idomain, P_ff6i27 ) = 'graupel bin 27'
   scalar_units_table( idomain, P_ff6i27 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff6i27 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff6i27 )%stream(2) = 2097152 
   F_ff6i27 = .TRUE.
   IF ( scalar_index_table( PARAM_ff6i28 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff6i28 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff6i28 , idomain ) = P_ff6i28
   ELSE
     P_ff6i28 = scalar_index_table( PARAM_ff6i28 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff6i28 ) = .TRUE.
   scalar_dname_table( idomain, P_ff6i28 ) = 'ff6i28'
   scalar_desc_table( idomain, P_ff6i28 ) = 'graupel bin 28'
   scalar_units_table( idomain, P_ff6i28 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff6i28 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff6i28 )%stream(2) = 2097152 
   F_ff6i28 = .TRUE.
   IF ( scalar_index_table( PARAM_ff6i29 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff6i29 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff6i29 , idomain ) = P_ff6i29
   ELSE
     P_ff6i29 = scalar_index_table( PARAM_ff6i29 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff6i29 ) = .TRUE.
   scalar_dname_table( idomain, P_ff6i29 ) = 'ff6i29'
   scalar_desc_table( idomain, P_ff6i29 ) = 'graupel bin 29'
   scalar_units_table( idomain, P_ff6i29 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff6i29 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff6i29 )%stream(2) = 2097152 
   F_ff6i29 = .TRUE.
   IF ( scalar_index_table( PARAM_ff6i30 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff6i30 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff6i30 , idomain ) = P_ff6i30
   ELSE
     P_ff6i30 = scalar_index_table( PARAM_ff6i30 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff6i30 ) = .TRUE.
   scalar_dname_table( idomain, P_ff6i30 ) = 'ff6i30'
   scalar_desc_table( idomain, P_ff6i30 ) = 'graupel bin 30'
   scalar_units_table( idomain, P_ff6i30 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff6i30 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff6i30 )%stream(2) = 2097152 
   F_ff6i30 = .TRUE.
   IF ( scalar_index_table( PARAM_ff6i31 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff6i31 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff6i31 , idomain ) = P_ff6i31
   ELSE
     P_ff6i31 = scalar_index_table( PARAM_ff6i31 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff6i31 ) = .TRUE.
   scalar_dname_table( idomain, P_ff6i31 ) = 'ff6i31'
   scalar_desc_table( idomain, P_ff6i31 ) = 'graupel bin 31'
   scalar_units_table( idomain, P_ff6i31 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff6i31 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff6i31 )%stream(2) = 2097152 
   F_ff6i31 = .TRUE.
   IF ( scalar_index_table( PARAM_ff6i32 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff6i32 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff6i32 , idomain ) = P_ff6i32
   ELSE
     P_ff6i32 = scalar_index_table( PARAM_ff6i32 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff6i32 ) = .TRUE.
   scalar_dname_table( idomain, P_ff6i32 ) = 'ff6i32'
   scalar_desc_table( idomain, P_ff6i32 ) = 'graupel bin 32'
   scalar_units_table( idomain, P_ff6i32 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff6i32 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff6i32 )%stream(2) = 2097152 
   F_ff6i32 = .TRUE.
   IF ( scalar_index_table( PARAM_ff6i33 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff6i33 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff6i33 , idomain ) = P_ff6i33
   ELSE
     P_ff6i33 = scalar_index_table( PARAM_ff6i33 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff6i33 ) = .TRUE.
   scalar_dname_table( idomain, P_ff6i33 ) = 'ff6i33'
   scalar_desc_table( idomain, P_ff6i33 ) = 'graupel bin 33'
   scalar_units_table( idomain, P_ff6i33 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff6i33 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff6i33 )%stream(2) = 2097152 
   F_ff6i33 = .TRUE.
   IF ( scalar_index_table( PARAM_ff8i01 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff8i01 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff8i01 , idomain ) = P_ff8i01
   ELSE
     P_ff8i01 = scalar_index_table( PARAM_ff8i01 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff8i01 ) = .TRUE.
   scalar_dname_table( idomain, P_ff8i01 ) = 'ff8i01'
   scalar_desc_table( idomain, P_ff8i01 ) = 'aerosols bin 1'
   scalar_units_table( idomain, P_ff8i01 ) = '  kg-1'
   scalar_streams_table( idomain, P_ff8i01 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff8i01 )%stream(2) = 2097152 
   F_ff8i01 = .TRUE.
   IF ( scalar_index_table( PARAM_ff8i02 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff8i02 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff8i02 , idomain ) = P_ff8i02
   ELSE
     P_ff8i02 = scalar_index_table( PARAM_ff8i02 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff8i02 ) = .TRUE.
   scalar_dname_table( idomain, P_ff8i02 ) = 'ff8i02'
   scalar_desc_table( idomain, P_ff8i02 ) = 'aerosols bin 2'
   scalar_units_table( idomain, P_ff8i02 ) = '  kg-1'
   scalar_streams_table( idomain, P_ff8i02 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff8i02 )%stream(2) = 2097152 
   F_ff8i02 = .TRUE.
   IF ( scalar_index_table( PARAM_ff8i03 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff8i03 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff8i03 , idomain ) = P_ff8i03
   ELSE
     P_ff8i03 = scalar_index_table( PARAM_ff8i03 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff8i03 ) = .TRUE.
   scalar_dname_table( idomain, P_ff8i03 ) = 'ff8i03'
   scalar_desc_table( idomain, P_ff8i03 ) = 'aerosols bin 3'
   scalar_units_table( idomain, P_ff8i03 ) = '  kg-1'
   scalar_streams_table( idomain, P_ff8i03 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff8i03 )%stream(2) = 2097152 
   F_ff8i03 = .TRUE.
   IF ( scalar_index_table( PARAM_ff8i04 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff8i04 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff8i04 , idomain ) = P_ff8i04
   ELSE
     P_ff8i04 = scalar_index_table( PARAM_ff8i04 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff8i04 ) = .TRUE.
   scalar_dname_table( idomain, P_ff8i04 ) = 'ff8i04'
   scalar_desc_table( idomain, P_ff8i04 ) = 'aerosols bin 4'
   scalar_units_table( idomain, P_ff8i04 ) = '  kg-1'
   scalar_streams_table( idomain, P_ff8i04 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff8i04 )%stream(2) = 2097152 
   F_ff8i04 = .TRUE.
   IF ( scalar_index_table( PARAM_ff8i05 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff8i05 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff8i05 , idomain ) = P_ff8i05
   ELSE
     P_ff8i05 = scalar_index_table( PARAM_ff8i05 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff8i05 ) = .TRUE.
   scalar_dname_table( idomain, P_ff8i05 ) = 'ff8i05'
   scalar_desc_table( idomain, P_ff8i05 ) = 'aerosols bin 5'
   scalar_units_table( idomain, P_ff8i05 ) = '  kg-1'
   scalar_streams_table( idomain, P_ff8i05 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff8i05 )%stream(2) = 2097152 
   F_ff8i05 = .TRUE.
   IF ( scalar_index_table( PARAM_ff8i06 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff8i06 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff8i06 , idomain ) = P_ff8i06
   ELSE
     P_ff8i06 = scalar_index_table( PARAM_ff8i06 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff8i06 ) = .TRUE.
   scalar_dname_table( idomain, P_ff8i06 ) = 'ff8i06'
   scalar_desc_table( idomain, P_ff8i06 ) = 'aerosols bin 6'
   scalar_units_table( idomain, P_ff8i06 ) = '  kg-1'
   scalar_streams_table( idomain, P_ff8i06 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff8i06 )%stream(2) = 2097152 
   F_ff8i06 = .TRUE.
   IF ( scalar_index_table( PARAM_ff8i07 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff8i07 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff8i07 , idomain ) = P_ff8i07
   ELSE
     P_ff8i07 = scalar_index_table( PARAM_ff8i07 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff8i07 ) = .TRUE.
   scalar_dname_table( idomain, P_ff8i07 ) = 'ff8i07'
   scalar_desc_table( idomain, P_ff8i07 ) = 'aerosols bin 7'
   scalar_units_table( idomain, P_ff8i07 ) = '  kg-1'
   scalar_streams_table( idomain, P_ff8i07 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff8i07 )%stream(2) = 2097152 
   F_ff8i07 = .TRUE.
   IF ( scalar_index_table( PARAM_ff8i08 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff8i08 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff8i08 , idomain ) = P_ff8i08
   ELSE
     P_ff8i08 = scalar_index_table( PARAM_ff8i08 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff8i08 ) = .TRUE.
   scalar_dname_table( idomain, P_ff8i08 ) = 'ff8i08'
   scalar_desc_table( idomain, P_ff8i08 ) = 'aerosols bin 8'
   scalar_units_table( idomain, P_ff8i08 ) = '  kg-1'
   scalar_streams_table( idomain, P_ff8i08 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff8i08 )%stream(2) = 2097152 
   F_ff8i08 = .TRUE.
   IF ( scalar_index_table( PARAM_ff8i09 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff8i09 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff8i09 , idomain ) = P_ff8i09
   ELSE
     P_ff8i09 = scalar_index_table( PARAM_ff8i09 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff8i09 ) = .TRUE.
   scalar_dname_table( idomain, P_ff8i09 ) = 'ff8i09'
   scalar_desc_table( idomain, P_ff8i09 ) = 'aerosols bin 9'
   scalar_units_table( idomain, P_ff8i09 ) = '  kg-1'
   scalar_streams_table( idomain, P_ff8i09 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff8i09 )%stream(2) = 2097152 
   F_ff8i09 = .TRUE.
   IF ( scalar_index_table( PARAM_ff8i10 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff8i10 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff8i10 , idomain ) = P_ff8i10
   ELSE
     P_ff8i10 = scalar_index_table( PARAM_ff8i10 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff8i10 ) = .TRUE.
   scalar_dname_table( idomain, P_ff8i10 ) = 'ff8i10'
   scalar_desc_table( idomain, P_ff8i10 ) = 'aerosols bin 10'
   scalar_units_table( idomain, P_ff8i10 ) = '  kg-1'
   scalar_streams_table( idomain, P_ff8i10 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff8i10 )%stream(2) = 2097152 
   F_ff8i10 = .TRUE.
   IF ( scalar_index_table( PARAM_ff8i11 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff8i11 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff8i11 , idomain ) = P_ff8i11
   ELSE
     P_ff8i11 = scalar_index_table( PARAM_ff8i11 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff8i11 ) = .TRUE.
   scalar_dname_table( idomain, P_ff8i11 ) = 'ff8i11'
   scalar_desc_table( idomain, P_ff8i11 ) = 'aerosols bin 11'
   scalar_units_table( idomain, P_ff8i11 ) = '  kg-1'
   scalar_streams_table( idomain, P_ff8i11 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff8i11 )%stream(2) = 2097152 
   F_ff8i11 = .TRUE.
   IF ( scalar_index_table( PARAM_ff8i12 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff8i12 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff8i12 , idomain ) = P_ff8i12
   ELSE
     P_ff8i12 = scalar_index_table( PARAM_ff8i12 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff8i12 ) = .TRUE.
   scalar_dname_table( idomain, P_ff8i12 ) = 'ff8i12'
   scalar_desc_table( idomain, P_ff8i12 ) = 'aerosols bin 12'
   scalar_units_table( idomain, P_ff8i12 ) = '  kg-1'
   scalar_streams_table( idomain, P_ff8i12 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff8i12 )%stream(2) = 2097152 
   F_ff8i12 = .TRUE.
   IF ( scalar_index_table( PARAM_ff8i13 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff8i13 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff8i13 , idomain ) = P_ff8i13
   ELSE
     P_ff8i13 = scalar_index_table( PARAM_ff8i13 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff8i13 ) = .TRUE.
   scalar_dname_table( idomain, P_ff8i13 ) = 'ff8i13'
   scalar_desc_table( idomain, P_ff8i13 ) = 'aerosols bin 13'
   scalar_units_table( idomain, P_ff8i13 ) = '  kg-1'
   scalar_streams_table( idomain, P_ff8i13 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff8i13 )%stream(2) = 2097152 
   F_ff8i13 = .TRUE.
   IF ( scalar_index_table( PARAM_ff8i14 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff8i14 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff8i14 , idomain ) = P_ff8i14
   ELSE
     P_ff8i14 = scalar_index_table( PARAM_ff8i14 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff8i14 ) = .TRUE.
   scalar_dname_table( idomain, P_ff8i14 ) = 'ff8i14'
   scalar_desc_table( idomain, P_ff8i14 ) = 'aerosols bin 14'
   scalar_units_table( idomain, P_ff8i14 ) = '  kg-1'
   scalar_streams_table( idomain, P_ff8i14 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff8i14 )%stream(2) = 2097152 
   F_ff8i14 = .TRUE.
   IF ( scalar_index_table( PARAM_ff8i15 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff8i15 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff8i15 , idomain ) = P_ff8i15
   ELSE
     P_ff8i15 = scalar_index_table( PARAM_ff8i15 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff8i15 ) = .TRUE.
   scalar_dname_table( idomain, P_ff8i15 ) = 'ff8i15'
   scalar_desc_table( idomain, P_ff8i15 ) = 'aerosols bin 15'
   scalar_units_table( idomain, P_ff8i15 ) = '  kg-1'
   scalar_streams_table( idomain, P_ff8i15 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff8i15 )%stream(2) = 2097152 
   F_ff8i15 = .TRUE.
   IF ( scalar_index_table( PARAM_ff8i16 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff8i16 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff8i16 , idomain ) = P_ff8i16
   ELSE
     P_ff8i16 = scalar_index_table( PARAM_ff8i16 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff8i16 ) = .TRUE.
   scalar_dname_table( idomain, P_ff8i16 ) = 'ff8i16'
   scalar_desc_table( idomain, P_ff8i16 ) = 'aerosols bin 16'
   scalar_units_table( idomain, P_ff8i16 ) = '  kg-1'
   scalar_streams_table( idomain, P_ff8i16 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff8i16 )%stream(2) = 2097152 
   F_ff8i16 = .TRUE.
   IF ( scalar_index_table( PARAM_ff8i17 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff8i17 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff8i17 , idomain ) = P_ff8i17
   ELSE
     P_ff8i17 = scalar_index_table( PARAM_ff8i17 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff8i17 ) = .TRUE.
   scalar_dname_table( idomain, P_ff8i17 ) = 'ff8i17'
   scalar_desc_table( idomain, P_ff8i17 ) = 'aerosols bin 17'
   scalar_units_table( idomain, P_ff8i17 ) = '  kg-1'
   scalar_streams_table( idomain, P_ff8i17 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff8i17 )%stream(2) = 2097152 
   F_ff8i17 = .TRUE.
   IF ( scalar_index_table( PARAM_ff8i18 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff8i18 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff8i18 , idomain ) = P_ff8i18
   ELSE
     P_ff8i18 = scalar_index_table( PARAM_ff8i18 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff8i18 ) = .TRUE.
   scalar_dname_table( idomain, P_ff8i18 ) = 'ff8i18'
   scalar_desc_table( idomain, P_ff8i18 ) = 'aerosols bin 18'
   scalar_units_table( idomain, P_ff8i18 ) = '  kg-1'
   scalar_streams_table( idomain, P_ff8i18 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff8i18 )%stream(2) = 2097152 
   F_ff8i18 = .TRUE.
   IF ( scalar_index_table( PARAM_ff8i19 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff8i19 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff8i19 , idomain ) = P_ff8i19
   ELSE
     P_ff8i19 = scalar_index_table( PARAM_ff8i19 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff8i19 ) = .TRUE.
   scalar_dname_table( idomain, P_ff8i19 ) = 'ff8i19'
   scalar_desc_table( idomain, P_ff8i19 ) = 'aerosols bin 19'
   scalar_units_table( idomain, P_ff8i19 ) = '  kg-1'
   scalar_streams_table( idomain, P_ff8i19 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff8i19 )%stream(2) = 2097152 
   F_ff8i19 = .TRUE.
   IF ( scalar_index_table( PARAM_ff8i20 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff8i20 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff8i20 , idomain ) = P_ff8i20
   ELSE
     P_ff8i20 = scalar_index_table( PARAM_ff8i20 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff8i20 ) = .TRUE.
   scalar_dname_table( idomain, P_ff8i20 ) = 'ff8i20'
   scalar_desc_table( idomain, P_ff8i20 ) = 'aerosols bin 20'
   scalar_units_table( idomain, P_ff8i20 ) = '  kg-1'
   scalar_streams_table( idomain, P_ff8i20 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff8i20 )%stream(2) = 2097152 
   F_ff8i20 = .TRUE.
   IF ( scalar_index_table( PARAM_ff8i21 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff8i21 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff8i21 , idomain ) = P_ff8i21
   ELSE
     P_ff8i21 = scalar_index_table( PARAM_ff8i21 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff8i21 ) = .TRUE.
   scalar_dname_table( idomain, P_ff8i21 ) = 'ff8i21'
   scalar_desc_table( idomain, P_ff8i21 ) = 'aerosols bin 21'
   scalar_units_table( idomain, P_ff8i21 ) = '  kg-1'
   scalar_streams_table( idomain, P_ff8i21 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff8i21 )%stream(2) = 2097152 
   F_ff8i21 = .TRUE.
   IF ( scalar_index_table( PARAM_ff8i22 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff8i22 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff8i22 , idomain ) = P_ff8i22
   ELSE
     P_ff8i22 = scalar_index_table( PARAM_ff8i22 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff8i22 ) = .TRUE.
   scalar_dname_table( idomain, P_ff8i22 ) = 'ff8i22'
   scalar_desc_table( idomain, P_ff8i22 ) = 'aerosols bin 22'
   scalar_units_table( idomain, P_ff8i22 ) = '  kg-1'
   scalar_streams_table( idomain, P_ff8i22 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff8i22 )%stream(2) = 2097152 
   F_ff8i22 = .TRUE.
   IF ( scalar_index_table( PARAM_ff8i23 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff8i23 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff8i23 , idomain ) = P_ff8i23
   ELSE
     P_ff8i23 = scalar_index_table( PARAM_ff8i23 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff8i23 ) = .TRUE.
   scalar_dname_table( idomain, P_ff8i23 ) = 'ff8i23'
   scalar_desc_table( idomain, P_ff8i23 ) = 'aerosols bin 23'
   scalar_units_table( idomain, P_ff8i23 ) = '  kg-1'
   scalar_streams_table( idomain, P_ff8i23 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff8i23 )%stream(2) = 2097152 
   F_ff8i23 = .TRUE.
   IF ( scalar_index_table( PARAM_ff8i24 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff8i24 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff8i24 , idomain ) = P_ff8i24
   ELSE
     P_ff8i24 = scalar_index_table( PARAM_ff8i24 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff8i24 ) = .TRUE.
   scalar_dname_table( idomain, P_ff8i24 ) = 'ff8i24'
   scalar_desc_table( idomain, P_ff8i24 ) = 'aerosols bin 24'
   scalar_units_table( idomain, P_ff8i24 ) = '  kg-1'
   scalar_streams_table( idomain, P_ff8i24 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff8i24 )%stream(2) = 2097152 
   F_ff8i24 = .TRUE.
   IF ( scalar_index_table( PARAM_ff8i25 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff8i25 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff8i25 , idomain ) = P_ff8i25
   ELSE
     P_ff8i25 = scalar_index_table( PARAM_ff8i25 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff8i25 ) = .TRUE.
   scalar_dname_table( idomain, P_ff8i25 ) = 'ff8i25'
   scalar_desc_table( idomain, P_ff8i25 ) = 'aerosols bin 25'
   scalar_units_table( idomain, P_ff8i25 ) = '  kg-1'
   scalar_streams_table( idomain, P_ff8i25 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff8i25 )%stream(2) = 2097152 
   F_ff8i25 = .TRUE.
   IF ( scalar_index_table( PARAM_ff8i26 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff8i26 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff8i26 , idomain ) = P_ff8i26
   ELSE
     P_ff8i26 = scalar_index_table( PARAM_ff8i26 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff8i26 ) = .TRUE.
   scalar_dname_table( idomain, P_ff8i26 ) = 'ff8i26'
   scalar_desc_table( idomain, P_ff8i26 ) = 'aerosols bin 26'
   scalar_units_table( idomain, P_ff8i26 ) = '  kg-1'
   scalar_streams_table( idomain, P_ff8i26 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff8i26 )%stream(2) = 2097152 
   F_ff8i26 = .TRUE.
   IF ( scalar_index_table( PARAM_ff8i27 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff8i27 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff8i27 , idomain ) = P_ff8i27
   ELSE
     P_ff8i27 = scalar_index_table( PARAM_ff8i27 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff8i27 ) = .TRUE.
   scalar_dname_table( idomain, P_ff8i27 ) = 'ff8i27'
   scalar_desc_table( idomain, P_ff8i27 ) = 'aerosols bin 27'
   scalar_units_table( idomain, P_ff8i27 ) = '  kg-1'
   scalar_streams_table( idomain, P_ff8i27 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff8i27 )%stream(2) = 2097152 
   F_ff8i27 = .TRUE.
   IF ( scalar_index_table( PARAM_ff8i28 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff8i28 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff8i28 , idomain ) = P_ff8i28
   ELSE
     P_ff8i28 = scalar_index_table( PARAM_ff8i28 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff8i28 ) = .TRUE.
   scalar_dname_table( idomain, P_ff8i28 ) = 'ff8i28'
   scalar_desc_table( idomain, P_ff8i28 ) = 'aerosols bin 28'
   scalar_units_table( idomain, P_ff8i28 ) = '  kg-1'
   scalar_streams_table( idomain, P_ff8i28 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff8i28 )%stream(2) = 2097152 
   F_ff8i28 = .TRUE.
   IF ( scalar_index_table( PARAM_ff8i29 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff8i29 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff8i29 , idomain ) = P_ff8i29
   ELSE
     P_ff8i29 = scalar_index_table( PARAM_ff8i29 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff8i29 ) = .TRUE.
   scalar_dname_table( idomain, P_ff8i29 ) = 'ff8i29'
   scalar_desc_table( idomain, P_ff8i29 ) = 'aerosols bin 29'
   scalar_units_table( idomain, P_ff8i29 ) = '  kg-1'
   scalar_streams_table( idomain, P_ff8i29 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff8i29 )%stream(2) = 2097152 
   F_ff8i29 = .TRUE.
   IF ( scalar_index_table( PARAM_ff8i30 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff8i30 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff8i30 , idomain ) = P_ff8i30
   ELSE
     P_ff8i30 = scalar_index_table( PARAM_ff8i30 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff8i30 ) = .TRUE.
   scalar_dname_table( idomain, P_ff8i30 ) = 'ff8i30'
   scalar_desc_table( idomain, P_ff8i30 ) = 'aerosols bin 30'
   scalar_units_table( idomain, P_ff8i30 ) = '  kg-1'
   scalar_streams_table( idomain, P_ff8i30 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff8i30 )%stream(2) = 2097152 
   F_ff8i30 = .TRUE.
   IF ( scalar_index_table( PARAM_ff8i31 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff8i31 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff8i31 , idomain ) = P_ff8i31
   ELSE
     P_ff8i31 = scalar_index_table( PARAM_ff8i31 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff8i31 ) = .TRUE.
   scalar_dname_table( idomain, P_ff8i31 ) = 'ff8i31'
   scalar_desc_table( idomain, P_ff8i31 ) = 'aerosols bin 31'
   scalar_units_table( idomain, P_ff8i31 ) = '  kg-1'
   scalar_streams_table( idomain, P_ff8i31 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff8i31 )%stream(2) = 2097152 
   F_ff8i31 = .TRUE.
   IF ( scalar_index_table( PARAM_ff8i32 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff8i32 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff8i32 , idomain ) = P_ff8i32
   ELSE
     P_ff8i32 = scalar_index_table( PARAM_ff8i32 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff8i32 ) = .TRUE.
   scalar_dname_table( idomain, P_ff8i32 ) = 'ff8i32'
   scalar_desc_table( idomain, P_ff8i32 ) = 'aerosols bin 32'
   scalar_units_table( idomain, P_ff8i32 ) = '  kg-1'
   scalar_streams_table( idomain, P_ff8i32 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff8i32 )%stream(2) = 2097152 
   F_ff8i32 = .TRUE.
   IF ( scalar_index_table( PARAM_ff8i33 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff8i33 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff8i33 , idomain ) = P_ff8i33
   ELSE
     P_ff8i33 = scalar_index_table( PARAM_ff8i33 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff8i33 ) = .TRUE.
   scalar_dname_table( idomain, P_ff8i33 ) = 'ff8i33'
   scalar_desc_table( idomain, P_ff8i33 ) = 'aerosols bin 33'
   scalar_units_table( idomain, P_ff8i33 ) = '  kg-1'
   scalar_streams_table( idomain, P_ff8i33 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff8i33 )%stream(2) = 2097152 
   F_ff8i33 = .TRUE.
   IF ( scalar_index_table( PARAM_ff2i01 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff2i01 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff2i01 , idomain ) = P_ff2i01
   ELSE
     P_ff2i01 = scalar_index_table( PARAM_ff2i01 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff2i01 ) = .TRUE.
   scalar_dname_table( idomain, P_ff2i01 ) = 'ff2i01'
   scalar_desc_table( idomain, P_ff2i01 ) = 'ice/columns bin 1'
   scalar_units_table( idomain, P_ff2i01 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff2i01 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff2i01 )%stream(2) = 2097152 
   F_ff2i01 = .TRUE.
   IF ( scalar_index_table( PARAM_ff2i02 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff2i02 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff2i02 , idomain ) = P_ff2i02
   ELSE
     P_ff2i02 = scalar_index_table( PARAM_ff2i02 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff2i02 ) = .TRUE.
   scalar_dname_table( idomain, P_ff2i02 ) = 'ff2i02'
   scalar_desc_table( idomain, P_ff2i02 ) = 'ice/columns bin 2'
   scalar_units_table( idomain, P_ff2i02 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff2i02 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff2i02 )%stream(2) = 2097152 
   F_ff2i02 = .TRUE.
   IF ( scalar_index_table( PARAM_ff2i03 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff2i03 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff2i03 , idomain ) = P_ff2i03
   ELSE
     P_ff2i03 = scalar_index_table( PARAM_ff2i03 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff2i03 ) = .TRUE.
   scalar_dname_table( idomain, P_ff2i03 ) = 'ff2i03'
   scalar_desc_table( idomain, P_ff2i03 ) = 'ice/columns bin 3'
   scalar_units_table( idomain, P_ff2i03 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff2i03 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff2i03 )%stream(2) = 2097152 
   F_ff2i03 = .TRUE.
   IF ( scalar_index_table( PARAM_ff2i04 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff2i04 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff2i04 , idomain ) = P_ff2i04
   ELSE
     P_ff2i04 = scalar_index_table( PARAM_ff2i04 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff2i04 ) = .TRUE.
   scalar_dname_table( idomain, P_ff2i04 ) = 'ff2i04'
   scalar_desc_table( idomain, P_ff2i04 ) = 'ice/columns bin 4'
   scalar_units_table( idomain, P_ff2i04 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff2i04 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff2i04 )%stream(2) = 2097152 
   F_ff2i04 = .TRUE.
   IF ( scalar_index_table( PARAM_ff2i05 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff2i05 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff2i05 , idomain ) = P_ff2i05
   ELSE
     P_ff2i05 = scalar_index_table( PARAM_ff2i05 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff2i05 ) = .TRUE.
   scalar_dname_table( idomain, P_ff2i05 ) = 'ff2i05'
   scalar_desc_table( idomain, P_ff2i05 ) = 'ice/columns bin 5'
   scalar_units_table( idomain, P_ff2i05 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff2i05 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff2i05 )%stream(2) = 2097152 
   F_ff2i05 = .TRUE.
   IF ( scalar_index_table( PARAM_ff2i06 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff2i06 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff2i06 , idomain ) = P_ff2i06
   ELSE
     P_ff2i06 = scalar_index_table( PARAM_ff2i06 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff2i06 ) = .TRUE.
   scalar_dname_table( idomain, P_ff2i06 ) = 'ff2i06'
   scalar_desc_table( idomain, P_ff2i06 ) = 'ice/columns bin 6'
   scalar_units_table( idomain, P_ff2i06 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff2i06 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff2i06 )%stream(2) = 2097152 
   F_ff2i06 = .TRUE.
   IF ( scalar_index_table( PARAM_ff2i07 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff2i07 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff2i07 , idomain ) = P_ff2i07
   ELSE
     P_ff2i07 = scalar_index_table( PARAM_ff2i07 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff2i07 ) = .TRUE.
   scalar_dname_table( idomain, P_ff2i07 ) = 'ff2i07'
   scalar_desc_table( idomain, P_ff2i07 ) = 'ice/columns bin 7'
   scalar_units_table( idomain, P_ff2i07 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff2i07 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff2i07 )%stream(2) = 2097152 
   F_ff2i07 = .TRUE.
   IF ( scalar_index_table( PARAM_ff2i08 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff2i08 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff2i08 , idomain ) = P_ff2i08
   ELSE
     P_ff2i08 = scalar_index_table( PARAM_ff2i08 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff2i08 ) = .TRUE.
   scalar_dname_table( idomain, P_ff2i08 ) = 'ff2i08'
   scalar_desc_table( idomain, P_ff2i08 ) = 'ice/columns bin 8'
   scalar_units_table( idomain, P_ff2i08 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff2i08 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff2i08 )%stream(2) = 2097152 
   F_ff2i08 = .TRUE.
   IF ( scalar_index_table( PARAM_ff2i09 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff2i09 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff2i09 , idomain ) = P_ff2i09
   ELSE
     P_ff2i09 = scalar_index_table( PARAM_ff2i09 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff2i09 ) = .TRUE.
   scalar_dname_table( idomain, P_ff2i09 ) = 'ff2i09'
   scalar_desc_table( idomain, P_ff2i09 ) = 'ice/columns bin 9'
   scalar_units_table( idomain, P_ff2i09 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff2i09 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff2i09 )%stream(2) = 2097152 
   F_ff2i09 = .TRUE.
   IF ( scalar_index_table( PARAM_ff2i10 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff2i10 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff2i10 , idomain ) = P_ff2i10
   ELSE
     P_ff2i10 = scalar_index_table( PARAM_ff2i10 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff2i10 ) = .TRUE.
   scalar_dname_table( idomain, P_ff2i10 ) = 'ff2i10'
   scalar_desc_table( idomain, P_ff2i10 ) = 'ice/columns bin 10'
   scalar_units_table( idomain, P_ff2i10 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff2i10 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff2i10 )%stream(2) = 2097152 
   F_ff2i10 = .TRUE.
   IF ( scalar_index_table( PARAM_ff2i11 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff2i11 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff2i11 , idomain ) = P_ff2i11
   ELSE
     P_ff2i11 = scalar_index_table( PARAM_ff2i11 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff2i11 ) = .TRUE.
   scalar_dname_table( idomain, P_ff2i11 ) = 'ff2i11'
   scalar_desc_table( idomain, P_ff2i11 ) = 'ice/columns bin 11'
   scalar_units_table( idomain, P_ff2i11 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff2i11 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff2i11 )%stream(2) = 2097152 
   F_ff2i11 = .TRUE.
   IF ( scalar_index_table( PARAM_ff2i12 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff2i12 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff2i12 , idomain ) = P_ff2i12
   ELSE
     P_ff2i12 = scalar_index_table( PARAM_ff2i12 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff2i12 ) = .TRUE.
   scalar_dname_table( idomain, P_ff2i12 ) = 'ff2i12'
   scalar_desc_table( idomain, P_ff2i12 ) = 'ice/columns bin 12'
   scalar_units_table( idomain, P_ff2i12 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff2i12 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff2i12 )%stream(2) = 2097152 
   F_ff2i12 = .TRUE.
   IF ( scalar_index_table( PARAM_ff2i13 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff2i13 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff2i13 , idomain ) = P_ff2i13
   ELSE
     P_ff2i13 = scalar_index_table( PARAM_ff2i13 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff2i13 ) = .TRUE.
   scalar_dname_table( idomain, P_ff2i13 ) = 'ff2i13'
   scalar_desc_table( idomain, P_ff2i13 ) = 'ice/columns bin 13'
   scalar_units_table( idomain, P_ff2i13 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff2i13 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff2i13 )%stream(2) = 2097152 
   F_ff2i13 = .TRUE.
   IF ( scalar_index_table( PARAM_ff2i14 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff2i14 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff2i14 , idomain ) = P_ff2i14
   ELSE
     P_ff2i14 = scalar_index_table( PARAM_ff2i14 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff2i14 ) = .TRUE.
   scalar_dname_table( idomain, P_ff2i14 ) = 'ff2i14'
   scalar_desc_table( idomain, P_ff2i14 ) = 'ice/columns bin 14'
   scalar_units_table( idomain, P_ff2i14 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff2i14 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff2i14 )%stream(2) = 2097152 
   F_ff2i14 = .TRUE.
   IF ( scalar_index_table( PARAM_ff2i15 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff2i15 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff2i15 , idomain ) = P_ff2i15
   ELSE
     P_ff2i15 = scalar_index_table( PARAM_ff2i15 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff2i15 ) = .TRUE.
   scalar_dname_table( idomain, P_ff2i15 ) = 'ff2i15'
   scalar_desc_table( idomain, P_ff2i15 ) = 'ice/columns bin 15'
   scalar_units_table( idomain, P_ff2i15 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff2i15 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff2i15 )%stream(2) = 2097152 
   F_ff2i15 = .TRUE.
   IF ( scalar_index_table( PARAM_ff2i16 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff2i16 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff2i16 , idomain ) = P_ff2i16
   ELSE
     P_ff2i16 = scalar_index_table( PARAM_ff2i16 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff2i16 ) = .TRUE.
   scalar_dname_table( idomain, P_ff2i16 ) = 'ff2i16'
   scalar_desc_table( idomain, P_ff2i16 ) = 'ice/columns bin 16'
   scalar_units_table( idomain, P_ff2i16 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff2i16 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff2i16 )%stream(2) = 2097152 
   F_ff2i16 = .TRUE.
   IF ( scalar_index_table( PARAM_ff2i17 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff2i17 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff2i17 , idomain ) = P_ff2i17
   ELSE
     P_ff2i17 = scalar_index_table( PARAM_ff2i17 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff2i17 ) = .TRUE.
   scalar_dname_table( idomain, P_ff2i17 ) = 'ff2i17'
   scalar_desc_table( idomain, P_ff2i17 ) = 'ice/columns bin 17'
   scalar_units_table( idomain, P_ff2i17 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff2i17 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff2i17 )%stream(2) = 2097152 
   F_ff2i17 = .TRUE.
   IF ( scalar_index_table( PARAM_ff2i18 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff2i18 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff2i18 , idomain ) = P_ff2i18
   ELSE
     P_ff2i18 = scalar_index_table( PARAM_ff2i18 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff2i18 ) = .TRUE.
   scalar_dname_table( idomain, P_ff2i18 ) = 'ff2i18'
   scalar_desc_table( idomain, P_ff2i18 ) = 'ice/columns bin 18'
   scalar_units_table( idomain, P_ff2i18 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff2i18 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff2i18 )%stream(2) = 2097152 
   F_ff2i18 = .TRUE.
   IF ( scalar_index_table( PARAM_ff2i19 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff2i19 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff2i19 , idomain ) = P_ff2i19
   ELSE
     P_ff2i19 = scalar_index_table( PARAM_ff2i19 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff2i19 ) = .TRUE.
   scalar_dname_table( idomain, P_ff2i19 ) = 'ff2i19'
   scalar_desc_table( idomain, P_ff2i19 ) = 'ice/columns bin 19'
   scalar_units_table( idomain, P_ff2i19 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff2i19 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff2i19 )%stream(2) = 2097152 
   F_ff2i19 = .TRUE.
   IF ( scalar_index_table( PARAM_ff2i20 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff2i20 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff2i20 , idomain ) = P_ff2i20
   ELSE
     P_ff2i20 = scalar_index_table( PARAM_ff2i20 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff2i20 ) = .TRUE.
   scalar_dname_table( idomain, P_ff2i20 ) = 'ff2i20'
   scalar_desc_table( idomain, P_ff2i20 ) = 'ice/columns bin 20'
   scalar_units_table( idomain, P_ff2i20 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff2i20 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff2i20 )%stream(2) = 2097152 
   F_ff2i20 = .TRUE.
   IF ( scalar_index_table( PARAM_ff2i21 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff2i21 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff2i21 , idomain ) = P_ff2i21
   ELSE
     P_ff2i21 = scalar_index_table( PARAM_ff2i21 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff2i21 ) = .TRUE.
   scalar_dname_table( idomain, P_ff2i21 ) = 'ff2i21'
   scalar_desc_table( idomain, P_ff2i21 ) = 'ice/columns bin 21'
   scalar_units_table( idomain, P_ff2i21 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff2i21 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff2i21 )%stream(2) = 2097152 
   F_ff2i21 = .TRUE.
   IF ( scalar_index_table( PARAM_ff2i22 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff2i22 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff2i22 , idomain ) = P_ff2i22
   ELSE
     P_ff2i22 = scalar_index_table( PARAM_ff2i22 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff2i22 ) = .TRUE.
   scalar_dname_table( idomain, P_ff2i22 ) = 'ff2i22'
   scalar_desc_table( idomain, P_ff2i22 ) = 'ice/columns bin 22'
   scalar_units_table( idomain, P_ff2i22 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff2i22 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff2i22 )%stream(2) = 2097152 
   F_ff2i22 = .TRUE.
   IF ( scalar_index_table( PARAM_ff2i23 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff2i23 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff2i23 , idomain ) = P_ff2i23
   ELSE
     P_ff2i23 = scalar_index_table( PARAM_ff2i23 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff2i23 ) = .TRUE.
   scalar_dname_table( idomain, P_ff2i23 ) = 'ff2i23'
   scalar_desc_table( idomain, P_ff2i23 ) = 'ice/columns bin 23'
   scalar_units_table( idomain, P_ff2i23 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff2i23 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff2i23 )%stream(2) = 2097152 
   F_ff2i23 = .TRUE.
   IF ( scalar_index_table( PARAM_ff2i24 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff2i24 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff2i24 , idomain ) = P_ff2i24
   ELSE
     P_ff2i24 = scalar_index_table( PARAM_ff2i24 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff2i24 ) = .TRUE.
   scalar_dname_table( idomain, P_ff2i24 ) = 'ff2i24'
   scalar_desc_table( idomain, P_ff2i24 ) = 'ice/columns bin 24'
   scalar_units_table( idomain, P_ff2i24 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff2i24 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff2i24 )%stream(2) = 2097152 
   F_ff2i24 = .TRUE.
   IF ( scalar_index_table( PARAM_ff2i25 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff2i25 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff2i25 , idomain ) = P_ff2i25
   ELSE
     P_ff2i25 = scalar_index_table( PARAM_ff2i25 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff2i25 ) = .TRUE.
   scalar_dname_table( idomain, P_ff2i25 ) = 'ff2i25'
   scalar_desc_table( idomain, P_ff2i25 ) = 'ice/columns bin 25'
   scalar_units_table( idomain, P_ff2i25 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff2i25 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff2i25 )%stream(2) = 2097152 
   F_ff2i25 = .TRUE.
   IF ( scalar_index_table( PARAM_ff2i26 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff2i26 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff2i26 , idomain ) = P_ff2i26
   ELSE
     P_ff2i26 = scalar_index_table( PARAM_ff2i26 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff2i26 ) = .TRUE.
   scalar_dname_table( idomain, P_ff2i26 ) = 'ff2i26'
   scalar_desc_table( idomain, P_ff2i26 ) = 'ice/columns bin 26'
   scalar_units_table( idomain, P_ff2i26 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff2i26 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff2i26 )%stream(2) = 2097152 
   F_ff2i26 = .TRUE.
   IF ( scalar_index_table( PARAM_ff2i27 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff2i27 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff2i27 , idomain ) = P_ff2i27
   ELSE
     P_ff2i27 = scalar_index_table( PARAM_ff2i27 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff2i27 ) = .TRUE.
   scalar_dname_table( idomain, P_ff2i27 ) = 'ff2i27'
   scalar_desc_table( idomain, P_ff2i27 ) = 'ice/columns bin 27'
   scalar_units_table( idomain, P_ff2i27 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff2i27 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff2i27 )%stream(2) = 2097152 
   F_ff2i27 = .TRUE.
   IF ( scalar_index_table( PARAM_ff2i28 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff2i28 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff2i28 , idomain ) = P_ff2i28
   ELSE
     P_ff2i28 = scalar_index_table( PARAM_ff2i28 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff2i28 ) = .TRUE.
   scalar_dname_table( idomain, P_ff2i28 ) = 'ff2i28'
   scalar_desc_table( idomain, P_ff2i28 ) = 'ice/columns bin 28'
   scalar_units_table( idomain, P_ff2i28 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff2i28 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff2i28 )%stream(2) = 2097152 
   F_ff2i28 = .TRUE.
   IF ( scalar_index_table( PARAM_ff2i29 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff2i29 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff2i29 , idomain ) = P_ff2i29
   ELSE
     P_ff2i29 = scalar_index_table( PARAM_ff2i29 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff2i29 ) = .TRUE.
   scalar_dname_table( idomain, P_ff2i29 ) = 'ff2i29'
   scalar_desc_table( idomain, P_ff2i29 ) = 'ice/columns bin 29'
   scalar_units_table( idomain, P_ff2i29 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff2i29 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff2i29 )%stream(2) = 2097152 
   F_ff2i29 = .TRUE.
   IF ( scalar_index_table( PARAM_ff2i30 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff2i30 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff2i30 , idomain ) = P_ff2i30
   ELSE
     P_ff2i30 = scalar_index_table( PARAM_ff2i30 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff2i30 ) = .TRUE.
   scalar_dname_table( idomain, P_ff2i30 ) = 'ff2i30'
   scalar_desc_table( idomain, P_ff2i30 ) = 'ice/columns bin 30'
   scalar_units_table( idomain, P_ff2i30 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff2i30 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff2i30 )%stream(2) = 2097152 
   F_ff2i30 = .TRUE.
   IF ( scalar_index_table( PARAM_ff2i31 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff2i31 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff2i31 , idomain ) = P_ff2i31
   ELSE
     P_ff2i31 = scalar_index_table( PARAM_ff2i31 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff2i31 ) = .TRUE.
   scalar_dname_table( idomain, P_ff2i31 ) = 'ff2i31'
   scalar_desc_table( idomain, P_ff2i31 ) = 'ice/columns bin 31'
   scalar_units_table( idomain, P_ff2i31 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff2i31 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff2i31 )%stream(2) = 2097152 
   F_ff2i31 = .TRUE.
   IF ( scalar_index_table( PARAM_ff2i32 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff2i32 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff2i32 , idomain ) = P_ff2i32
   ELSE
     P_ff2i32 = scalar_index_table( PARAM_ff2i32 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff2i32 ) = .TRUE.
   scalar_dname_table( idomain, P_ff2i32 ) = 'ff2i32'
   scalar_desc_table( idomain, P_ff2i32 ) = 'ice/columns bin 32'
   scalar_units_table( idomain, P_ff2i32 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff2i32 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff2i32 )%stream(2) = 2097152 
   F_ff2i32 = .TRUE.
   IF ( scalar_index_table( PARAM_ff2i33 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff2i33 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff2i33 , idomain ) = P_ff2i33
   ELSE
     P_ff2i33 = scalar_index_table( PARAM_ff2i33 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff2i33 ) = .TRUE.
   scalar_dname_table( idomain, P_ff2i33 ) = 'ff2i33'
   scalar_desc_table( idomain, P_ff2i33 ) = 'ice/columns bin 33'
   scalar_units_table( idomain, P_ff2i33 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff2i33 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff2i33 )%stream(2) = 2097152 
   F_ff2i33 = .TRUE.
   IF ( scalar_index_table( PARAM_ff3i01 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff3i01 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff3i01 , idomain ) = P_ff3i01
   ELSE
     P_ff3i01 = scalar_index_table( PARAM_ff3i01 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff3i01 ) = .TRUE.
   scalar_dname_table( idomain, P_ff3i01 ) = 'ff3i01'
   scalar_desc_table( idomain, P_ff3i01 ) = 'ice/plates bin 1'
   scalar_units_table( idomain, P_ff3i01 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff3i01 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff3i01 )%stream(2) = 2097152 
   F_ff3i01 = .TRUE.
   IF ( scalar_index_table( PARAM_ff3i02 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff3i02 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff3i02 , idomain ) = P_ff3i02
   ELSE
     P_ff3i02 = scalar_index_table( PARAM_ff3i02 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff3i02 ) = .TRUE.
   scalar_dname_table( idomain, P_ff3i02 ) = 'ff3i02'
   scalar_desc_table( idomain, P_ff3i02 ) = 'ice/plates bin 2'
   scalar_units_table( idomain, P_ff3i02 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff3i02 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff3i02 )%stream(2) = 2097152 
   F_ff3i02 = .TRUE.
   IF ( scalar_index_table( PARAM_ff3i03 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff3i03 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff3i03 , idomain ) = P_ff3i03
   ELSE
     P_ff3i03 = scalar_index_table( PARAM_ff3i03 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff3i03 ) = .TRUE.
   scalar_dname_table( idomain, P_ff3i03 ) = 'ff3i03'
   scalar_desc_table( idomain, P_ff3i03 ) = 'ice/plates bin 3'
   scalar_units_table( idomain, P_ff3i03 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff3i03 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff3i03 )%stream(2) = 2097152 
   F_ff3i03 = .TRUE.
   IF ( scalar_index_table( PARAM_ff3i04 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff3i04 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff3i04 , idomain ) = P_ff3i04
   ELSE
     P_ff3i04 = scalar_index_table( PARAM_ff3i04 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff3i04 ) = .TRUE.
   scalar_dname_table( idomain, P_ff3i04 ) = 'ff3i04'
   scalar_desc_table( idomain, P_ff3i04 ) = 'ice/plates bin 4'
   scalar_units_table( idomain, P_ff3i04 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff3i04 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff3i04 )%stream(2) = 2097152 
   F_ff3i04 = .TRUE.
   IF ( scalar_index_table( PARAM_ff3i05 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff3i05 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff3i05 , idomain ) = P_ff3i05
   ELSE
     P_ff3i05 = scalar_index_table( PARAM_ff3i05 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff3i05 ) = .TRUE.
   scalar_dname_table( idomain, P_ff3i05 ) = 'ff3i05'
   scalar_desc_table( idomain, P_ff3i05 ) = 'ice/plates bin 5'
   scalar_units_table( idomain, P_ff3i05 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff3i05 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff3i05 )%stream(2) = 2097152 
   F_ff3i05 = .TRUE.
   IF ( scalar_index_table( PARAM_ff3i06 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff3i06 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff3i06 , idomain ) = P_ff3i06
   ELSE
     P_ff3i06 = scalar_index_table( PARAM_ff3i06 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff3i06 ) = .TRUE.
   scalar_dname_table( idomain, P_ff3i06 ) = 'ff3i06'
   scalar_desc_table( idomain, P_ff3i06 ) = 'ice/plates bin 6'
   scalar_units_table( idomain, P_ff3i06 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff3i06 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff3i06 )%stream(2) = 2097152 
   F_ff3i06 = .TRUE.
   IF ( scalar_index_table( PARAM_ff3i07 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff3i07 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff3i07 , idomain ) = P_ff3i07
   ELSE
     P_ff3i07 = scalar_index_table( PARAM_ff3i07 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff3i07 ) = .TRUE.
   scalar_dname_table( idomain, P_ff3i07 ) = 'ff3i07'
   scalar_desc_table( idomain, P_ff3i07 ) = 'ice/plates bin 7'
   scalar_units_table( idomain, P_ff3i07 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff3i07 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff3i07 )%stream(2) = 2097152 
   F_ff3i07 = .TRUE.
   IF ( scalar_index_table( PARAM_ff3i08 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff3i08 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff3i08 , idomain ) = P_ff3i08
   ELSE
     P_ff3i08 = scalar_index_table( PARAM_ff3i08 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff3i08 ) = .TRUE.
   scalar_dname_table( idomain, P_ff3i08 ) = 'ff3i08'
   scalar_desc_table( idomain, P_ff3i08 ) = 'ice/plates bin 8'
   scalar_units_table( idomain, P_ff3i08 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff3i08 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff3i08 )%stream(2) = 2097152 
   F_ff3i08 = .TRUE.
   IF ( scalar_index_table( PARAM_ff3i09 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff3i09 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff3i09 , idomain ) = P_ff3i09
   ELSE
     P_ff3i09 = scalar_index_table( PARAM_ff3i09 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff3i09 ) = .TRUE.
   scalar_dname_table( idomain, P_ff3i09 ) = 'ff3i09'
   scalar_desc_table( idomain, P_ff3i09 ) = 'ice/plates bin 9'
   scalar_units_table( idomain, P_ff3i09 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff3i09 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff3i09 )%stream(2) = 2097152 
   F_ff3i09 = .TRUE.
   IF ( scalar_index_table( PARAM_ff3i10 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff3i10 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff3i10 , idomain ) = P_ff3i10
   ELSE
     P_ff3i10 = scalar_index_table( PARAM_ff3i10 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff3i10 ) = .TRUE.
   scalar_dname_table( idomain, P_ff3i10 ) = 'ff3i10'
   scalar_desc_table( idomain, P_ff3i10 ) = 'ice/plates bin 10'
   scalar_units_table( idomain, P_ff3i10 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff3i10 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff3i10 )%stream(2) = 2097152 
   F_ff3i10 = .TRUE.
   IF ( scalar_index_table( PARAM_ff3i11 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff3i11 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff3i11 , idomain ) = P_ff3i11
   ELSE
     P_ff3i11 = scalar_index_table( PARAM_ff3i11 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff3i11 ) = .TRUE.
   scalar_dname_table( idomain, P_ff3i11 ) = 'ff3i11'
   scalar_desc_table( idomain, P_ff3i11 ) = 'ice/plates bin 11'
   scalar_units_table( idomain, P_ff3i11 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff3i11 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff3i11 )%stream(2) = 2097152 
   F_ff3i11 = .TRUE.
   IF ( scalar_index_table( PARAM_ff3i12 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff3i12 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff3i12 , idomain ) = P_ff3i12
   ELSE
     P_ff3i12 = scalar_index_table( PARAM_ff3i12 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff3i12 ) = .TRUE.
   scalar_dname_table( idomain, P_ff3i12 ) = 'ff3i12'
   scalar_desc_table( idomain, P_ff3i12 ) = 'ice/plates bin 12'
   scalar_units_table( idomain, P_ff3i12 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff3i12 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff3i12 )%stream(2) = 2097152 
   F_ff3i12 = .TRUE.
   IF ( scalar_index_table( PARAM_ff3i13 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff3i13 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff3i13 , idomain ) = P_ff3i13
   ELSE
     P_ff3i13 = scalar_index_table( PARAM_ff3i13 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff3i13 ) = .TRUE.
   scalar_dname_table( idomain, P_ff3i13 ) = 'ff3i13'
   scalar_desc_table( idomain, P_ff3i13 ) = 'ice/plates bin 13'
   scalar_units_table( idomain, P_ff3i13 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff3i13 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff3i13 )%stream(2) = 2097152 
   F_ff3i13 = .TRUE.
   IF ( scalar_index_table( PARAM_ff3i14 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff3i14 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff3i14 , idomain ) = P_ff3i14
   ELSE
     P_ff3i14 = scalar_index_table( PARAM_ff3i14 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff3i14 ) = .TRUE.
   scalar_dname_table( idomain, P_ff3i14 ) = 'ff3i14'
   scalar_desc_table( idomain, P_ff3i14 ) = 'ice/plates bin 14'
   scalar_units_table( idomain, P_ff3i14 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff3i14 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff3i14 )%stream(2) = 2097152 
   F_ff3i14 = .TRUE.
   IF ( scalar_index_table( PARAM_ff3i15 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff3i15 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff3i15 , idomain ) = P_ff3i15
   ELSE
     P_ff3i15 = scalar_index_table( PARAM_ff3i15 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff3i15 ) = .TRUE.
   scalar_dname_table( idomain, P_ff3i15 ) = 'ff3i15'
   scalar_desc_table( idomain, P_ff3i15 ) = 'ice/plates bin 15'
   scalar_units_table( idomain, P_ff3i15 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff3i15 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff3i15 )%stream(2) = 2097152 
   F_ff3i15 = .TRUE.
   IF ( scalar_index_table( PARAM_ff3i16 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff3i16 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff3i16 , idomain ) = P_ff3i16
   ELSE
     P_ff3i16 = scalar_index_table( PARAM_ff3i16 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff3i16 ) = .TRUE.
   scalar_dname_table( idomain, P_ff3i16 ) = 'ff3i16'
   scalar_desc_table( idomain, P_ff3i16 ) = 'ice/plates bin 16'
   scalar_units_table( idomain, P_ff3i16 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff3i16 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff3i16 )%stream(2) = 2097152 
   F_ff3i16 = .TRUE.
   IF ( scalar_index_table( PARAM_ff3i17 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff3i17 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff3i17 , idomain ) = P_ff3i17
   ELSE
     P_ff3i17 = scalar_index_table( PARAM_ff3i17 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff3i17 ) = .TRUE.
   scalar_dname_table( idomain, P_ff3i17 ) = 'ff3i17'
   scalar_desc_table( idomain, P_ff3i17 ) = 'ice/plates bin 17'
   scalar_units_table( idomain, P_ff3i17 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff3i17 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff3i17 )%stream(2) = 2097152 
   F_ff3i17 = .TRUE.
   IF ( scalar_index_table( PARAM_ff3i18 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff3i18 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff3i18 , idomain ) = P_ff3i18
   ELSE
     P_ff3i18 = scalar_index_table( PARAM_ff3i18 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff3i18 ) = .TRUE.
   scalar_dname_table( idomain, P_ff3i18 ) = 'ff3i18'
   scalar_desc_table( idomain, P_ff3i18 ) = 'ice/plates bin 18'
   scalar_units_table( idomain, P_ff3i18 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff3i18 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff3i18 )%stream(2) = 2097152 
   F_ff3i18 = .TRUE.
   IF ( scalar_index_table( PARAM_ff3i19 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff3i19 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff3i19 , idomain ) = P_ff3i19
   ELSE
     P_ff3i19 = scalar_index_table( PARAM_ff3i19 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff3i19 ) = .TRUE.
   scalar_dname_table( idomain, P_ff3i19 ) = 'ff3i19'
   scalar_desc_table( idomain, P_ff3i19 ) = 'ice/plates bin 19'
   scalar_units_table( idomain, P_ff3i19 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff3i19 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff3i19 )%stream(2) = 2097152 
   F_ff3i19 = .TRUE.
   IF ( scalar_index_table( PARAM_ff3i20 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff3i20 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff3i20 , idomain ) = P_ff3i20
   ELSE
     P_ff3i20 = scalar_index_table( PARAM_ff3i20 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff3i20 ) = .TRUE.
   scalar_dname_table( idomain, P_ff3i20 ) = 'ff3i20'
   scalar_desc_table( idomain, P_ff3i20 ) = 'ice/plates bin 20'
   scalar_units_table( idomain, P_ff3i20 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff3i20 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff3i20 )%stream(2) = 2097152 
   F_ff3i20 = .TRUE.
   IF ( scalar_index_table( PARAM_ff3i21 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff3i21 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff3i21 , idomain ) = P_ff3i21
   ELSE
     P_ff3i21 = scalar_index_table( PARAM_ff3i21 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff3i21 ) = .TRUE.
   scalar_dname_table( idomain, P_ff3i21 ) = 'ff3i21'
   scalar_desc_table( idomain, P_ff3i21 ) = 'ice/plates bin 21'
   scalar_units_table( idomain, P_ff3i21 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff3i21 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff3i21 )%stream(2) = 2097152 
   F_ff3i21 = .TRUE.
   IF ( scalar_index_table( PARAM_ff3i22 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff3i22 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff3i22 , idomain ) = P_ff3i22
   ELSE
     P_ff3i22 = scalar_index_table( PARAM_ff3i22 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff3i22 ) = .TRUE.
   scalar_dname_table( idomain, P_ff3i22 ) = 'ff3i22'
   scalar_desc_table( idomain, P_ff3i22 ) = 'ice/plates bin 22'
   scalar_units_table( idomain, P_ff3i22 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff3i22 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff3i22 )%stream(2) = 2097152 
   F_ff3i22 = .TRUE.
   IF ( scalar_index_table( PARAM_ff3i23 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff3i23 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff3i23 , idomain ) = P_ff3i23
   ELSE
     P_ff3i23 = scalar_index_table( PARAM_ff3i23 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff3i23 ) = .TRUE.
   scalar_dname_table( idomain, P_ff3i23 ) = 'ff3i23'
   scalar_desc_table( idomain, P_ff3i23 ) = 'ice/plates bin 23'
   scalar_units_table( idomain, P_ff3i23 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff3i23 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff3i23 )%stream(2) = 2097152 
   F_ff3i23 = .TRUE.
   IF ( scalar_index_table( PARAM_ff3i24 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff3i24 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff3i24 , idomain ) = P_ff3i24
   ELSE
     P_ff3i24 = scalar_index_table( PARAM_ff3i24 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff3i24 ) = .TRUE.
   scalar_dname_table( idomain, P_ff3i24 ) = 'ff3i24'
   scalar_desc_table( idomain, P_ff3i24 ) = 'ice/plates bin 24'
   scalar_units_table( idomain, P_ff3i24 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff3i24 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff3i24 )%stream(2) = 2097152 
   F_ff3i24 = .TRUE.
   IF ( scalar_index_table( PARAM_ff3i25 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff3i25 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff3i25 , idomain ) = P_ff3i25
   ELSE
     P_ff3i25 = scalar_index_table( PARAM_ff3i25 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff3i25 ) = .TRUE.
   scalar_dname_table( idomain, P_ff3i25 ) = 'ff3i25'
   scalar_desc_table( idomain, P_ff3i25 ) = 'ice/plates bin 25'
   scalar_units_table( idomain, P_ff3i25 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff3i25 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff3i25 )%stream(2) = 2097152 
   F_ff3i25 = .TRUE.
   IF ( scalar_index_table( PARAM_ff3i26 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff3i26 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff3i26 , idomain ) = P_ff3i26
   ELSE
     P_ff3i26 = scalar_index_table( PARAM_ff3i26 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff3i26 ) = .TRUE.
   scalar_dname_table( idomain, P_ff3i26 ) = 'ff3i26'
   scalar_desc_table( idomain, P_ff3i26 ) = 'ice/plates bin 26'
   scalar_units_table( idomain, P_ff3i26 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff3i26 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff3i26 )%stream(2) = 2097152 
   F_ff3i26 = .TRUE.
   IF ( scalar_index_table( PARAM_ff3i27 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff3i27 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff3i27 , idomain ) = P_ff3i27
   ELSE
     P_ff3i27 = scalar_index_table( PARAM_ff3i27 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff3i27 ) = .TRUE.
   scalar_dname_table( idomain, P_ff3i27 ) = 'ff3i27'
   scalar_desc_table( idomain, P_ff3i27 ) = 'ice/plates bin 27'
   scalar_units_table( idomain, P_ff3i27 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff3i27 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff3i27 )%stream(2) = 2097152 
   F_ff3i27 = .TRUE.
   IF ( scalar_index_table( PARAM_ff3i28 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff3i28 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff3i28 , idomain ) = P_ff3i28
   ELSE
     P_ff3i28 = scalar_index_table( PARAM_ff3i28 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff3i28 ) = .TRUE.
   scalar_dname_table( idomain, P_ff3i28 ) = 'ff3i28'
   scalar_desc_table( idomain, P_ff3i28 ) = 'ice/plates bin 28'
   scalar_units_table( idomain, P_ff3i28 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff3i28 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff3i28 )%stream(2) = 2097152 
   F_ff3i28 = .TRUE.
   IF ( scalar_index_table( PARAM_ff3i29 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff3i29 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff3i29 , idomain ) = P_ff3i29
   ELSE
     P_ff3i29 = scalar_index_table( PARAM_ff3i29 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff3i29 ) = .TRUE.
   scalar_dname_table( idomain, P_ff3i29 ) = 'ff3i29'
   scalar_desc_table( idomain, P_ff3i29 ) = 'ice/plates bin 29'
   scalar_units_table( idomain, P_ff3i29 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff3i29 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff3i29 )%stream(2) = 2097152 
   F_ff3i29 = .TRUE.
   IF ( scalar_index_table( PARAM_ff3i30 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff3i30 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff3i30 , idomain ) = P_ff3i30
   ELSE
     P_ff3i30 = scalar_index_table( PARAM_ff3i30 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff3i30 ) = .TRUE.
   scalar_dname_table( idomain, P_ff3i30 ) = 'ff3i30'
   scalar_desc_table( idomain, P_ff3i30 ) = 'ice/plates bin 30'
   scalar_units_table( idomain, P_ff3i30 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff3i30 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff3i30 )%stream(2) = 2097152 
   F_ff3i30 = .TRUE.
   IF ( scalar_index_table( PARAM_ff3i31 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff3i31 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff3i31 , idomain ) = P_ff3i31
   ELSE
     P_ff3i31 = scalar_index_table( PARAM_ff3i31 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff3i31 ) = .TRUE.
   scalar_dname_table( idomain, P_ff3i31 ) = 'ff3i31'
   scalar_desc_table( idomain, P_ff3i31 ) = 'ice/plates bin 31'
   scalar_units_table( idomain, P_ff3i31 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff3i31 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff3i31 )%stream(2) = 2097152 
   F_ff3i31 = .TRUE.
   IF ( scalar_index_table( PARAM_ff3i32 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff3i32 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff3i32 , idomain ) = P_ff3i32
   ELSE
     P_ff3i32 = scalar_index_table( PARAM_ff3i32 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff3i32 ) = .TRUE.
   scalar_dname_table( idomain, P_ff3i32 ) = 'ff3i32'
   scalar_desc_table( idomain, P_ff3i32 ) = 'ice/plates bin 32'
   scalar_units_table( idomain, P_ff3i32 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff3i32 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff3i32 )%stream(2) = 2097152 
   F_ff3i32 = .TRUE.
   IF ( scalar_index_table( PARAM_ff3i33 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff3i33 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff3i33 , idomain ) = P_ff3i33
   ELSE
     P_ff3i33 = scalar_index_table( PARAM_ff3i33 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff3i33 ) = .TRUE.
   scalar_dname_table( idomain, P_ff3i33 ) = 'ff3i33'
   scalar_desc_table( idomain, P_ff3i33 ) = 'ice/plates bin 33'
   scalar_units_table( idomain, P_ff3i33 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff3i33 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff3i33 )%stream(2) = 2097152 
   F_ff3i33 = .TRUE.
   IF ( scalar_index_table( PARAM_ff4i01 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff4i01 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff4i01 , idomain ) = P_ff4i01
   ELSE
     P_ff4i01 = scalar_index_table( PARAM_ff4i01 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff4i01 ) = .TRUE.
   scalar_dname_table( idomain, P_ff4i01 ) = 'ff4i01'
   scalar_desc_table( idomain, P_ff4i01 ) = 'ice/dendrites bin 1'
   scalar_units_table( idomain, P_ff4i01 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff4i01 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff4i01 )%stream(2) = 2097152 
   F_ff4i01 = .TRUE.
   IF ( scalar_index_table( PARAM_ff4i02 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff4i02 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff4i02 , idomain ) = P_ff4i02
   ELSE
     P_ff4i02 = scalar_index_table( PARAM_ff4i02 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff4i02 ) = .TRUE.
   scalar_dname_table( idomain, P_ff4i02 ) = 'ff4i02'
   scalar_desc_table( idomain, P_ff4i02 ) = 'ice/dendrites bin 2'
   scalar_units_table( idomain, P_ff4i02 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff4i02 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff4i02 )%stream(2) = 2097152 
   F_ff4i02 = .TRUE.
   IF ( scalar_index_table( PARAM_ff4i03 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff4i03 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff4i03 , idomain ) = P_ff4i03
   ELSE
     P_ff4i03 = scalar_index_table( PARAM_ff4i03 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff4i03 ) = .TRUE.
   scalar_dname_table( idomain, P_ff4i03 ) = 'ff4i03'
   scalar_desc_table( idomain, P_ff4i03 ) = 'ice/dendrites bin 3'
   scalar_units_table( idomain, P_ff4i03 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff4i03 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff4i03 )%stream(2) = 2097152 
   F_ff4i03 = .TRUE.
   IF ( scalar_index_table( PARAM_ff4i04 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff4i04 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff4i04 , idomain ) = P_ff4i04
   ELSE
     P_ff4i04 = scalar_index_table( PARAM_ff4i04 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff4i04 ) = .TRUE.
   scalar_dname_table( idomain, P_ff4i04 ) = 'ff4i04'
   scalar_desc_table( idomain, P_ff4i04 ) = 'ice/dendrites bin 4'
   scalar_units_table( idomain, P_ff4i04 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff4i04 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff4i04 )%stream(2) = 2097152 
   F_ff4i04 = .TRUE.
   IF ( scalar_index_table( PARAM_ff4i05 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff4i05 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff4i05 , idomain ) = P_ff4i05
   ELSE
     P_ff4i05 = scalar_index_table( PARAM_ff4i05 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff4i05 ) = .TRUE.
   scalar_dname_table( idomain, P_ff4i05 ) = 'ff4i05'
   scalar_desc_table( idomain, P_ff4i05 ) = 'ice/dendrites bin 5'
   scalar_units_table( idomain, P_ff4i05 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff4i05 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff4i05 )%stream(2) = 2097152 
   F_ff4i05 = .TRUE.
   IF ( scalar_index_table( PARAM_ff4i06 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff4i06 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff4i06 , idomain ) = P_ff4i06
   ELSE
     P_ff4i06 = scalar_index_table( PARAM_ff4i06 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff4i06 ) = .TRUE.
   scalar_dname_table( idomain, P_ff4i06 ) = 'ff4i06'
   scalar_desc_table( idomain, P_ff4i06 ) = 'ice/dendrites bin 6'
   scalar_units_table( idomain, P_ff4i06 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff4i06 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff4i06 )%stream(2) = 2097152 
   F_ff4i06 = .TRUE.
   IF ( scalar_index_table( PARAM_ff4i07 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff4i07 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff4i07 , idomain ) = P_ff4i07
   ELSE
     P_ff4i07 = scalar_index_table( PARAM_ff4i07 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff4i07 ) = .TRUE.
   scalar_dname_table( idomain, P_ff4i07 ) = 'ff4i07'
   scalar_desc_table( idomain, P_ff4i07 ) = 'ice/dendrites bin 7'
   scalar_units_table( idomain, P_ff4i07 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff4i07 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff4i07 )%stream(2) = 2097152 
   F_ff4i07 = .TRUE.
   IF ( scalar_index_table( PARAM_ff4i08 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff4i08 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff4i08 , idomain ) = P_ff4i08
   ELSE
     P_ff4i08 = scalar_index_table( PARAM_ff4i08 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff4i08 ) = .TRUE.
   scalar_dname_table( idomain, P_ff4i08 ) = 'ff4i08'
   scalar_desc_table( idomain, P_ff4i08 ) = 'ice/dendrites bin 8'
   scalar_units_table( idomain, P_ff4i08 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff4i08 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff4i08 )%stream(2) = 2097152 
   F_ff4i08 = .TRUE.
   IF ( scalar_index_table( PARAM_ff4i09 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff4i09 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff4i09 , idomain ) = P_ff4i09
   ELSE
     P_ff4i09 = scalar_index_table( PARAM_ff4i09 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff4i09 ) = .TRUE.
   scalar_dname_table( idomain, P_ff4i09 ) = 'ff4i09'
   scalar_desc_table( idomain, P_ff4i09 ) = 'ice/dendrites bin 9'
   scalar_units_table( idomain, P_ff4i09 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff4i09 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff4i09 )%stream(2) = 2097152 
   F_ff4i09 = .TRUE.
   IF ( scalar_index_table( PARAM_ff4i10 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff4i10 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff4i10 , idomain ) = P_ff4i10
   ELSE
     P_ff4i10 = scalar_index_table( PARAM_ff4i10 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff4i10 ) = .TRUE.
   scalar_dname_table( idomain, P_ff4i10 ) = 'ff4i10'
   scalar_desc_table( idomain, P_ff4i10 ) = 'ice/dendrites bin 10'
   scalar_units_table( idomain, P_ff4i10 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff4i10 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff4i10 )%stream(2) = 2097152 
   F_ff4i10 = .TRUE.
   IF ( scalar_index_table( PARAM_ff4i11 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff4i11 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff4i11 , idomain ) = P_ff4i11
   ELSE
     P_ff4i11 = scalar_index_table( PARAM_ff4i11 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff4i11 ) = .TRUE.
   scalar_dname_table( idomain, P_ff4i11 ) = 'ff4i11'
   scalar_desc_table( idomain, P_ff4i11 ) = 'ice/dendrites bin 11'
   scalar_units_table( idomain, P_ff4i11 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff4i11 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff4i11 )%stream(2) = 2097152 
   F_ff4i11 = .TRUE.
   IF ( scalar_index_table( PARAM_ff4i12 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff4i12 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff4i12 , idomain ) = P_ff4i12
   ELSE
     P_ff4i12 = scalar_index_table( PARAM_ff4i12 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff4i12 ) = .TRUE.
   scalar_dname_table( idomain, P_ff4i12 ) = 'ff4i12'
   scalar_desc_table( idomain, P_ff4i12 ) = 'ice/dendrites bin 12'
   scalar_units_table( idomain, P_ff4i12 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff4i12 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff4i12 )%stream(2) = 2097152 
   F_ff4i12 = .TRUE.
   IF ( scalar_index_table( PARAM_ff4i13 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff4i13 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff4i13 , idomain ) = P_ff4i13
   ELSE
     P_ff4i13 = scalar_index_table( PARAM_ff4i13 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff4i13 ) = .TRUE.
   scalar_dname_table( idomain, P_ff4i13 ) = 'ff4i13'
   scalar_desc_table( idomain, P_ff4i13 ) = 'ice/dendrites bin 13'
   scalar_units_table( idomain, P_ff4i13 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff4i13 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff4i13 )%stream(2) = 2097152 
   F_ff4i13 = .TRUE.
   IF ( scalar_index_table( PARAM_ff4i14 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff4i14 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff4i14 , idomain ) = P_ff4i14
   ELSE
     P_ff4i14 = scalar_index_table( PARAM_ff4i14 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff4i14 ) = .TRUE.
   scalar_dname_table( idomain, P_ff4i14 ) = 'ff4i14'
   scalar_desc_table( idomain, P_ff4i14 ) = 'ice/dendrites bin 14'
   scalar_units_table( idomain, P_ff4i14 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff4i14 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff4i14 )%stream(2) = 2097152 
   F_ff4i14 = .TRUE.
   IF ( scalar_index_table( PARAM_ff4i15 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff4i15 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff4i15 , idomain ) = P_ff4i15
   ELSE
     P_ff4i15 = scalar_index_table( PARAM_ff4i15 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff4i15 ) = .TRUE.
   scalar_dname_table( idomain, P_ff4i15 ) = 'ff4i15'
   scalar_desc_table( idomain, P_ff4i15 ) = 'ice/dendrites bin 15'
   scalar_units_table( idomain, P_ff4i15 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff4i15 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff4i15 )%stream(2) = 2097152 
   F_ff4i15 = .TRUE.
   IF ( scalar_index_table( PARAM_ff4i16 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff4i16 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff4i16 , idomain ) = P_ff4i16
   ELSE
     P_ff4i16 = scalar_index_table( PARAM_ff4i16 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff4i16 ) = .TRUE.
   scalar_dname_table( idomain, P_ff4i16 ) = 'ff4i16'
   scalar_desc_table( idomain, P_ff4i16 ) = 'ice/dendrites bin 16'
   scalar_units_table( idomain, P_ff4i16 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff4i16 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff4i16 )%stream(2) = 2097152 
   F_ff4i16 = .TRUE.
   IF ( scalar_index_table( PARAM_ff4i17 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff4i17 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff4i17 , idomain ) = P_ff4i17
   ELSE
     P_ff4i17 = scalar_index_table( PARAM_ff4i17 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff4i17 ) = .TRUE.
   scalar_dname_table( idomain, P_ff4i17 ) = 'ff4i17'
   scalar_desc_table( idomain, P_ff4i17 ) = 'ice/dendrites bin 17'
   scalar_units_table( idomain, P_ff4i17 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff4i17 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff4i17 )%stream(2) = 2097152 
   F_ff4i17 = .TRUE.
   IF ( scalar_index_table( PARAM_ff4i18 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff4i18 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff4i18 , idomain ) = P_ff4i18
   ELSE
     P_ff4i18 = scalar_index_table( PARAM_ff4i18 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff4i18 ) = .TRUE.
   scalar_dname_table( idomain, P_ff4i18 ) = 'ff4i18'
   scalar_desc_table( idomain, P_ff4i18 ) = 'ice/dendrites bin 18'
   scalar_units_table( idomain, P_ff4i18 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff4i18 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff4i18 )%stream(2) = 2097152 
   F_ff4i18 = .TRUE.
   IF ( scalar_index_table( PARAM_ff4i19 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff4i19 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff4i19 , idomain ) = P_ff4i19
   ELSE
     P_ff4i19 = scalar_index_table( PARAM_ff4i19 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff4i19 ) = .TRUE.
   scalar_dname_table( idomain, P_ff4i19 ) = 'ff4i19'
   scalar_desc_table( idomain, P_ff4i19 ) = 'ice/dendrites bin 19'
   scalar_units_table( idomain, P_ff4i19 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff4i19 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff4i19 )%stream(2) = 2097152 
   F_ff4i19 = .TRUE.
   IF ( scalar_index_table( PARAM_ff4i20 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff4i20 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff4i20 , idomain ) = P_ff4i20
   ELSE
     P_ff4i20 = scalar_index_table( PARAM_ff4i20 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff4i20 ) = .TRUE.
   scalar_dname_table( idomain, P_ff4i20 ) = 'ff4i20'
   scalar_desc_table( idomain, P_ff4i20 ) = 'ice/dendrites bin 20'
   scalar_units_table( idomain, P_ff4i20 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff4i20 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff4i20 )%stream(2) = 2097152 
   F_ff4i20 = .TRUE.
   IF ( scalar_index_table( PARAM_ff4i21 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff4i21 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff4i21 , idomain ) = P_ff4i21
   ELSE
     P_ff4i21 = scalar_index_table( PARAM_ff4i21 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff4i21 ) = .TRUE.
   scalar_dname_table( idomain, P_ff4i21 ) = 'ff4i21'
   scalar_desc_table( idomain, P_ff4i21 ) = 'ice/dendrites bin 21'
   scalar_units_table( idomain, P_ff4i21 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff4i21 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff4i21 )%stream(2) = 2097152 
   F_ff4i21 = .TRUE.
   IF ( scalar_index_table( PARAM_ff4i22 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff4i22 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff4i22 , idomain ) = P_ff4i22
   ELSE
     P_ff4i22 = scalar_index_table( PARAM_ff4i22 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff4i22 ) = .TRUE.
   scalar_dname_table( idomain, P_ff4i22 ) = 'ff4i22'
   scalar_desc_table( idomain, P_ff4i22 ) = 'ice/dendrites bin 22'
   scalar_units_table( idomain, P_ff4i22 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff4i22 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff4i22 )%stream(2) = 2097152 
   F_ff4i22 = .TRUE.
   IF ( scalar_index_table( PARAM_ff4i23 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff4i23 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff4i23 , idomain ) = P_ff4i23
   ELSE
     P_ff4i23 = scalar_index_table( PARAM_ff4i23 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff4i23 ) = .TRUE.
   scalar_dname_table( idomain, P_ff4i23 ) = 'ff4i23'
   scalar_desc_table( idomain, P_ff4i23 ) = 'ice/dendrites bin 23'
   scalar_units_table( idomain, P_ff4i23 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff4i23 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff4i23 )%stream(2) = 2097152 
   F_ff4i23 = .TRUE.
   IF ( scalar_index_table( PARAM_ff4i24 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff4i24 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff4i24 , idomain ) = P_ff4i24
   ELSE
     P_ff4i24 = scalar_index_table( PARAM_ff4i24 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff4i24 ) = .TRUE.
   scalar_dname_table( idomain, P_ff4i24 ) = 'ff4i24'
   scalar_desc_table( idomain, P_ff4i24 ) = 'ice/dendrites bin 24'
   scalar_units_table( idomain, P_ff4i24 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff4i24 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff4i24 )%stream(2) = 2097152 
   F_ff4i24 = .TRUE.
   IF ( scalar_index_table( PARAM_ff4i25 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff4i25 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff4i25 , idomain ) = P_ff4i25
   ELSE
     P_ff4i25 = scalar_index_table( PARAM_ff4i25 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff4i25 ) = .TRUE.
   scalar_dname_table( idomain, P_ff4i25 ) = 'ff4i25'
   scalar_desc_table( idomain, P_ff4i25 ) = 'ice/dendrites bin 25'
   scalar_units_table( idomain, P_ff4i25 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff4i25 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff4i25 )%stream(2) = 2097152 
   F_ff4i25 = .TRUE.
   IF ( scalar_index_table( PARAM_ff4i26 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff4i26 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff4i26 , idomain ) = P_ff4i26
   ELSE
     P_ff4i26 = scalar_index_table( PARAM_ff4i26 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff4i26 ) = .TRUE.
   scalar_dname_table( idomain, P_ff4i26 ) = 'ff4i26'
   scalar_desc_table( idomain, P_ff4i26 ) = 'ice/dendrites bin 26'
   scalar_units_table( idomain, P_ff4i26 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff4i26 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff4i26 )%stream(2) = 2097152 
   F_ff4i26 = .TRUE.
   IF ( scalar_index_table( PARAM_ff4i27 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff4i27 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff4i27 , idomain ) = P_ff4i27
   ELSE
     P_ff4i27 = scalar_index_table( PARAM_ff4i27 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff4i27 ) = .TRUE.
   scalar_dname_table( idomain, P_ff4i27 ) = 'ff4i27'
   scalar_desc_table( idomain, P_ff4i27 ) = 'ice/dendrites bin 27'
   scalar_units_table( idomain, P_ff4i27 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff4i27 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff4i27 )%stream(2) = 2097152 
   F_ff4i27 = .TRUE.
   IF ( scalar_index_table( PARAM_ff4i28 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff4i28 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff4i28 , idomain ) = P_ff4i28
   ELSE
     P_ff4i28 = scalar_index_table( PARAM_ff4i28 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff4i28 ) = .TRUE.
   scalar_dname_table( idomain, P_ff4i28 ) = 'ff4i28'
   scalar_desc_table( idomain, P_ff4i28 ) = 'ice/dendrites bin 28'
   scalar_units_table( idomain, P_ff4i28 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff4i28 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff4i28 )%stream(2) = 2097152 
   F_ff4i28 = .TRUE.
   IF ( scalar_index_table( PARAM_ff4i29 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff4i29 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff4i29 , idomain ) = P_ff4i29
   ELSE
     P_ff4i29 = scalar_index_table( PARAM_ff4i29 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff4i29 ) = .TRUE.
   scalar_dname_table( idomain, P_ff4i29 ) = 'ff4i29'
   scalar_desc_table( idomain, P_ff4i29 ) = 'ice/dendrites bin 29'
   scalar_units_table( idomain, P_ff4i29 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff4i29 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff4i29 )%stream(2) = 2097152 
   F_ff4i29 = .TRUE.
   IF ( scalar_index_table( PARAM_ff4i30 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff4i30 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff4i30 , idomain ) = P_ff4i30
   ELSE
     P_ff4i30 = scalar_index_table( PARAM_ff4i30 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff4i30 ) = .TRUE.
   scalar_dname_table( idomain, P_ff4i30 ) = 'ff4i30'
   scalar_desc_table( idomain, P_ff4i30 ) = 'ice/dendrites bin 30'
   scalar_units_table( idomain, P_ff4i30 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff4i30 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff4i30 )%stream(2) = 2097152 
   F_ff4i30 = .TRUE.
   IF ( scalar_index_table( PARAM_ff4i31 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff4i31 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff4i31 , idomain ) = P_ff4i31
   ELSE
     P_ff4i31 = scalar_index_table( PARAM_ff4i31 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff4i31 ) = .TRUE.
   scalar_dname_table( idomain, P_ff4i31 ) = 'ff4i31'
   scalar_desc_table( idomain, P_ff4i31 ) = 'ice/dendrites bin 31'
   scalar_units_table( idomain, P_ff4i31 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff4i31 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff4i31 )%stream(2) = 2097152 
   F_ff4i31 = .TRUE.
   IF ( scalar_index_table( PARAM_ff4i32 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff4i32 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff4i32 , idomain ) = P_ff4i32
   ELSE
     P_ff4i32 = scalar_index_table( PARAM_ff4i32 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff4i32 ) = .TRUE.
   scalar_dname_table( idomain, P_ff4i32 ) = 'ff4i32'
   scalar_desc_table( idomain, P_ff4i32 ) = 'ice/dendrites bin 32'
   scalar_units_table( idomain, P_ff4i32 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff4i32 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff4i32 )%stream(2) = 2097152 
   F_ff4i32 = .TRUE.
   IF ( scalar_index_table( PARAM_ff4i33 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff4i33 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff4i33 , idomain ) = P_ff4i33
   ELSE
     P_ff4i33 = scalar_index_table( PARAM_ff4i33 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff4i33 ) = .TRUE.
   scalar_dname_table( idomain, P_ff4i33 ) = 'ff4i33'
   scalar_desc_table( idomain, P_ff4i33 ) = 'ice/dendrites bin 33'
   scalar_units_table( idomain, P_ff4i33 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff4i33 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff4i33 )%stream(2) = 2097152 
   F_ff4i33 = .TRUE.
   IF ( scalar_index_table( PARAM_ff7i01 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff7i01 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff7i01 , idomain ) = P_ff7i01
   ELSE
     P_ff7i01 = scalar_index_table( PARAM_ff7i01 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff7i01 ) = .TRUE.
   scalar_dname_table( idomain, P_ff7i01 ) = 'ff7i01'
   scalar_desc_table( idomain, P_ff7i01 ) = 'hail bin 1'
   scalar_units_table( idomain, P_ff7i01 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff7i01 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff7i01 )%stream(2) = 2097152 
   F_ff7i01 = .TRUE.
   IF ( scalar_index_table( PARAM_ff7i02 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff7i02 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff7i02 , idomain ) = P_ff7i02
   ELSE
     P_ff7i02 = scalar_index_table( PARAM_ff7i02 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff7i02 ) = .TRUE.
   scalar_dname_table( idomain, P_ff7i02 ) = 'ff7i02'
   scalar_desc_table( idomain, P_ff7i02 ) = 'hail bin 2'
   scalar_units_table( idomain, P_ff7i02 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff7i02 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff7i02 )%stream(2) = 2097152 
   F_ff7i02 = .TRUE.
   IF ( scalar_index_table( PARAM_ff7i03 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff7i03 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff7i03 , idomain ) = P_ff7i03
   ELSE
     P_ff7i03 = scalar_index_table( PARAM_ff7i03 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff7i03 ) = .TRUE.
   scalar_dname_table( idomain, P_ff7i03 ) = 'ff7i03'
   scalar_desc_table( idomain, P_ff7i03 ) = 'hail bin 3'
   scalar_units_table( idomain, P_ff7i03 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff7i03 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff7i03 )%stream(2) = 2097152 
   F_ff7i03 = .TRUE.
   IF ( scalar_index_table( PARAM_ff7i04 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff7i04 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff7i04 , idomain ) = P_ff7i04
   ELSE
     P_ff7i04 = scalar_index_table( PARAM_ff7i04 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff7i04 ) = .TRUE.
   scalar_dname_table( idomain, P_ff7i04 ) = 'ff7i04'
   scalar_desc_table( idomain, P_ff7i04 ) = 'hail bin 4'
   scalar_units_table( idomain, P_ff7i04 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff7i04 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff7i04 )%stream(2) = 2097152 
   F_ff7i04 = .TRUE.
   IF ( scalar_index_table( PARAM_ff7i05 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff7i05 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff7i05 , idomain ) = P_ff7i05
   ELSE
     P_ff7i05 = scalar_index_table( PARAM_ff7i05 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff7i05 ) = .TRUE.
   scalar_dname_table( idomain, P_ff7i05 ) = 'ff7i05'
   scalar_desc_table( idomain, P_ff7i05 ) = 'hail bin 5'
   scalar_units_table( idomain, P_ff7i05 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff7i05 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff7i05 )%stream(2) = 2097152 
   F_ff7i05 = .TRUE.
   IF ( scalar_index_table( PARAM_ff7i06 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff7i06 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff7i06 , idomain ) = P_ff7i06
   ELSE
     P_ff7i06 = scalar_index_table( PARAM_ff7i06 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff7i06 ) = .TRUE.
   scalar_dname_table( idomain, P_ff7i06 ) = 'ff7i06'
   scalar_desc_table( idomain, P_ff7i06 ) = 'hail bin 6'
   scalar_units_table( idomain, P_ff7i06 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff7i06 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff7i06 )%stream(2) = 2097152 
   F_ff7i06 = .TRUE.
   IF ( scalar_index_table( PARAM_ff7i07 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff7i07 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff7i07 , idomain ) = P_ff7i07
   ELSE
     P_ff7i07 = scalar_index_table( PARAM_ff7i07 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff7i07 ) = .TRUE.
   scalar_dname_table( idomain, P_ff7i07 ) = 'ff7i07'
   scalar_desc_table( idomain, P_ff7i07 ) = 'hail bin 7'
   scalar_units_table( idomain, P_ff7i07 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff7i07 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff7i07 )%stream(2) = 2097152 
   F_ff7i07 = .TRUE.
   IF ( scalar_index_table( PARAM_ff7i08 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff7i08 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff7i08 , idomain ) = P_ff7i08
   ELSE
     P_ff7i08 = scalar_index_table( PARAM_ff7i08 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff7i08 ) = .TRUE.
   scalar_dname_table( idomain, P_ff7i08 ) = 'ff7i08'
   scalar_desc_table( idomain, P_ff7i08 ) = 'hail bin 8'
   scalar_units_table( idomain, P_ff7i08 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff7i08 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff7i08 )%stream(2) = 2097152 
   F_ff7i08 = .TRUE.
   IF ( scalar_index_table( PARAM_ff7i09 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff7i09 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff7i09 , idomain ) = P_ff7i09
   ELSE
     P_ff7i09 = scalar_index_table( PARAM_ff7i09 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff7i09 ) = .TRUE.
   scalar_dname_table( idomain, P_ff7i09 ) = 'ff7i09'
   scalar_desc_table( idomain, P_ff7i09 ) = 'hail bin 9'
   scalar_units_table( idomain, P_ff7i09 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff7i09 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff7i09 )%stream(2) = 2097152 
   F_ff7i09 = .TRUE.
   IF ( scalar_index_table( PARAM_ff7i10 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff7i10 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff7i10 , idomain ) = P_ff7i10
   ELSE
     P_ff7i10 = scalar_index_table( PARAM_ff7i10 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff7i10 ) = .TRUE.
   scalar_dname_table( idomain, P_ff7i10 ) = 'ff7i10'
   scalar_desc_table( idomain, P_ff7i10 ) = 'hail bin 10'
   scalar_units_table( idomain, P_ff7i10 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff7i10 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff7i10 )%stream(2) = 2097152 
   F_ff7i10 = .TRUE.
   IF ( scalar_index_table( PARAM_ff7i11 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff7i11 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff7i11 , idomain ) = P_ff7i11
   ELSE
     P_ff7i11 = scalar_index_table( PARAM_ff7i11 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff7i11 ) = .TRUE.
   scalar_dname_table( idomain, P_ff7i11 ) = 'ff7i11'
   scalar_desc_table( idomain, P_ff7i11 ) = 'hail bin 11'
   scalar_units_table( idomain, P_ff7i11 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff7i11 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff7i11 )%stream(2) = 2097152 
   F_ff7i11 = .TRUE.
   IF ( scalar_index_table( PARAM_ff7i12 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff7i12 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff7i12 , idomain ) = P_ff7i12
   ELSE
     P_ff7i12 = scalar_index_table( PARAM_ff7i12 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff7i12 ) = .TRUE.
   scalar_dname_table( idomain, P_ff7i12 ) = 'ff7i12'
   scalar_desc_table( idomain, P_ff7i12 ) = 'hail bin 12'
   scalar_units_table( idomain, P_ff7i12 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff7i12 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff7i12 )%stream(2) = 2097152 
   F_ff7i12 = .TRUE.
   IF ( scalar_index_table( PARAM_ff7i13 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff7i13 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff7i13 , idomain ) = P_ff7i13
   ELSE
     P_ff7i13 = scalar_index_table( PARAM_ff7i13 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff7i13 ) = .TRUE.
   scalar_dname_table( idomain, P_ff7i13 ) = 'ff7i13'
   scalar_desc_table( idomain, P_ff7i13 ) = 'hail bin 13'
   scalar_units_table( idomain, P_ff7i13 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff7i13 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff7i13 )%stream(2) = 2097152 
   F_ff7i13 = .TRUE.
   IF ( scalar_index_table( PARAM_ff7i14 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff7i14 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff7i14 , idomain ) = P_ff7i14
   ELSE
     P_ff7i14 = scalar_index_table( PARAM_ff7i14 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff7i14 ) = .TRUE.
   scalar_dname_table( idomain, P_ff7i14 ) = 'ff7i14'
   scalar_desc_table( idomain, P_ff7i14 ) = 'hail bin 14'
   scalar_units_table( idomain, P_ff7i14 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff7i14 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff7i14 )%stream(2) = 2097152 
   F_ff7i14 = .TRUE.
   IF ( scalar_index_table( PARAM_ff7i15 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff7i15 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff7i15 , idomain ) = P_ff7i15
   ELSE
     P_ff7i15 = scalar_index_table( PARAM_ff7i15 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff7i15 ) = .TRUE.
   scalar_dname_table( idomain, P_ff7i15 ) = 'ff7i15'
   scalar_desc_table( idomain, P_ff7i15 ) = 'hail bin 15'
   scalar_units_table( idomain, P_ff7i15 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff7i15 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff7i15 )%stream(2) = 2097152 
   F_ff7i15 = .TRUE.
   IF ( scalar_index_table( PARAM_ff7i16 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff7i16 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff7i16 , idomain ) = P_ff7i16
   ELSE
     P_ff7i16 = scalar_index_table( PARAM_ff7i16 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff7i16 ) = .TRUE.
   scalar_dname_table( idomain, P_ff7i16 ) = 'ff7i16'
   scalar_desc_table( idomain, P_ff7i16 ) = 'hail bin 16'
   scalar_units_table( idomain, P_ff7i16 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff7i16 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff7i16 )%stream(2) = 2097152 
   F_ff7i16 = .TRUE.
   IF ( scalar_index_table( PARAM_ff7i17 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff7i17 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff7i17 , idomain ) = P_ff7i17
   ELSE
     P_ff7i17 = scalar_index_table( PARAM_ff7i17 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff7i17 ) = .TRUE.
   scalar_dname_table( idomain, P_ff7i17 ) = 'ff7i17'
   scalar_desc_table( idomain, P_ff7i17 ) = 'hail bin 17'
   scalar_units_table( idomain, P_ff7i17 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff7i17 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff7i17 )%stream(2) = 2097152 
   F_ff7i17 = .TRUE.
   IF ( scalar_index_table( PARAM_ff7i18 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff7i18 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff7i18 , idomain ) = P_ff7i18
   ELSE
     P_ff7i18 = scalar_index_table( PARAM_ff7i18 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff7i18 ) = .TRUE.
   scalar_dname_table( idomain, P_ff7i18 ) = 'ff7i18'
   scalar_desc_table( idomain, P_ff7i18 ) = 'hail bin 18'
   scalar_units_table( idomain, P_ff7i18 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff7i18 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff7i18 )%stream(2) = 2097152 
   F_ff7i18 = .TRUE.
   IF ( scalar_index_table( PARAM_ff7i19 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff7i19 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff7i19 , idomain ) = P_ff7i19
   ELSE
     P_ff7i19 = scalar_index_table( PARAM_ff7i19 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff7i19 ) = .TRUE.
   scalar_dname_table( idomain, P_ff7i19 ) = 'ff7i19'
   scalar_desc_table( idomain, P_ff7i19 ) = 'hail bin 19'
   scalar_units_table( idomain, P_ff7i19 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff7i19 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff7i19 )%stream(2) = 2097152 
   F_ff7i19 = .TRUE.
   IF ( scalar_index_table( PARAM_ff7i20 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff7i20 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff7i20 , idomain ) = P_ff7i20
   ELSE
     P_ff7i20 = scalar_index_table( PARAM_ff7i20 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff7i20 ) = .TRUE.
   scalar_dname_table( idomain, P_ff7i20 ) = 'ff7i20'
   scalar_desc_table( idomain, P_ff7i20 ) = 'hail bin 20'
   scalar_units_table( idomain, P_ff7i20 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff7i20 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff7i20 )%stream(2) = 2097152 
   F_ff7i20 = .TRUE.
   IF ( scalar_index_table( PARAM_ff7i21 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff7i21 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff7i21 , idomain ) = P_ff7i21
   ELSE
     P_ff7i21 = scalar_index_table( PARAM_ff7i21 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff7i21 ) = .TRUE.
   scalar_dname_table( idomain, P_ff7i21 ) = 'ff7i21'
   scalar_desc_table( idomain, P_ff7i21 ) = 'hail bin 21'
   scalar_units_table( idomain, P_ff7i21 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff7i21 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff7i21 )%stream(2) = 2097152 
   F_ff7i21 = .TRUE.
   IF ( scalar_index_table( PARAM_ff7i22 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff7i22 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff7i22 , idomain ) = P_ff7i22
   ELSE
     P_ff7i22 = scalar_index_table( PARAM_ff7i22 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff7i22 ) = .TRUE.
   scalar_dname_table( idomain, P_ff7i22 ) = 'ff7i22'
   scalar_desc_table( idomain, P_ff7i22 ) = 'hail bin 22'
   scalar_units_table( idomain, P_ff7i22 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff7i22 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff7i22 )%stream(2) = 2097152 
   F_ff7i22 = .TRUE.
   IF ( scalar_index_table( PARAM_ff7i23 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff7i23 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff7i23 , idomain ) = P_ff7i23
   ELSE
     P_ff7i23 = scalar_index_table( PARAM_ff7i23 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff7i23 ) = .TRUE.
   scalar_dname_table( idomain, P_ff7i23 ) = 'ff7i23'
   scalar_desc_table( idomain, P_ff7i23 ) = 'hail bin 23'
   scalar_units_table( idomain, P_ff7i23 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff7i23 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff7i23 )%stream(2) = 2097152 
   F_ff7i23 = .TRUE.
   IF ( scalar_index_table( PARAM_ff7i24 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff7i24 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff7i24 , idomain ) = P_ff7i24
   ELSE
     P_ff7i24 = scalar_index_table( PARAM_ff7i24 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff7i24 ) = .TRUE.
   scalar_dname_table( idomain, P_ff7i24 ) = 'ff7i24'
   scalar_desc_table( idomain, P_ff7i24 ) = 'hail bin 24'
   scalar_units_table( idomain, P_ff7i24 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff7i24 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff7i24 )%stream(2) = 2097152 
   F_ff7i24 = .TRUE.
   IF ( scalar_index_table( PARAM_ff7i25 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff7i25 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff7i25 , idomain ) = P_ff7i25
   ELSE
     P_ff7i25 = scalar_index_table( PARAM_ff7i25 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff7i25 ) = .TRUE.
   scalar_dname_table( idomain, P_ff7i25 ) = 'ff7i25'
   scalar_desc_table( idomain, P_ff7i25 ) = 'hail bin 25'
   scalar_units_table( idomain, P_ff7i25 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff7i25 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff7i25 )%stream(2) = 2097152 
   F_ff7i25 = .TRUE.
   IF ( scalar_index_table( PARAM_ff7i26 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff7i26 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff7i26 , idomain ) = P_ff7i26
   ELSE
     P_ff7i26 = scalar_index_table( PARAM_ff7i26 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff7i26 ) = .TRUE.
   scalar_dname_table( idomain, P_ff7i26 ) = 'ff7i26'
   scalar_desc_table( idomain, P_ff7i26 ) = 'hail bin 26'
   scalar_units_table( idomain, P_ff7i26 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff7i26 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff7i26 )%stream(2) = 2097152 
   F_ff7i26 = .TRUE.
   IF ( scalar_index_table( PARAM_ff7i27 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff7i27 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff7i27 , idomain ) = P_ff7i27
   ELSE
     P_ff7i27 = scalar_index_table( PARAM_ff7i27 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff7i27 ) = .TRUE.
   scalar_dname_table( idomain, P_ff7i27 ) = 'ff7i27'
   scalar_desc_table( idomain, P_ff7i27 ) = 'hail bin 27'
   scalar_units_table( idomain, P_ff7i27 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff7i27 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff7i27 )%stream(2) = 2097152 
   F_ff7i27 = .TRUE.
   IF ( scalar_index_table( PARAM_ff7i28 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff7i28 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff7i28 , idomain ) = P_ff7i28
   ELSE
     P_ff7i28 = scalar_index_table( PARAM_ff7i28 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff7i28 ) = .TRUE.
   scalar_dname_table( idomain, P_ff7i28 ) = 'ff7i28'
   scalar_desc_table( idomain, P_ff7i28 ) = 'hail bin 28'
   scalar_units_table( idomain, P_ff7i28 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff7i28 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff7i28 )%stream(2) = 2097152 
   F_ff7i28 = .TRUE.
   IF ( scalar_index_table( PARAM_ff7i29 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff7i29 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff7i29 , idomain ) = P_ff7i29
   ELSE
     P_ff7i29 = scalar_index_table( PARAM_ff7i29 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff7i29 ) = .TRUE.
   scalar_dname_table( idomain, P_ff7i29 ) = 'ff7i29'
   scalar_desc_table( idomain, P_ff7i29 ) = 'hail bin 29'
   scalar_units_table( idomain, P_ff7i29 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff7i29 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff7i29 )%stream(2) = 2097152 
   F_ff7i29 = .TRUE.
   IF ( scalar_index_table( PARAM_ff7i30 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff7i30 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff7i30 , idomain ) = P_ff7i30
   ELSE
     P_ff7i30 = scalar_index_table( PARAM_ff7i30 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff7i30 ) = .TRUE.
   scalar_dname_table( idomain, P_ff7i30 ) = 'ff7i30'
   scalar_desc_table( idomain, P_ff7i30 ) = 'hail bin 30'
   scalar_units_table( idomain, P_ff7i30 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff7i30 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff7i30 )%stream(2) = 2097152 
   F_ff7i30 = .TRUE.
   IF ( scalar_index_table( PARAM_ff7i31 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff7i31 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff7i31 , idomain ) = P_ff7i31
   ELSE
     P_ff7i31 = scalar_index_table( PARAM_ff7i31 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff7i31 ) = .TRUE.
   scalar_dname_table( idomain, P_ff7i31 ) = 'ff7i31'
   scalar_desc_table( idomain, P_ff7i31 ) = 'hail bin 31'
   scalar_units_table( idomain, P_ff7i31 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff7i31 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff7i31 )%stream(2) = 2097152 
   F_ff7i31 = .TRUE.
   IF ( scalar_index_table( PARAM_ff7i32 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff7i32 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff7i32 , idomain ) = P_ff7i32
   ELSE
     P_ff7i32 = scalar_index_table( PARAM_ff7i32 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff7i32 ) = .TRUE.
   scalar_dname_table( idomain, P_ff7i32 ) = 'ff7i32'
   scalar_desc_table( idomain, P_ff7i32 ) = 'hail bin 32'
   scalar_units_table( idomain, P_ff7i32 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff7i32 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff7i32 )%stream(2) = 2097152 
   F_ff7i32 = .TRUE.
   IF ( scalar_index_table( PARAM_ff7i33 , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ff7i33 = scalar_num_table(idomain)
     scalar_index_table( PARAM_ff7i33 , idomain ) = P_ff7i33
   ELSE
     P_ff7i33 = scalar_index_table( PARAM_ff7i33 , idomain )
   END IF
   scalar_boundary_table( idomain, P_ff7i33 ) = .TRUE.
   scalar_dname_table( idomain, P_ff7i33 ) = 'ff7i33'
   scalar_desc_table( idomain, P_ff7i33 ) = 'hail bin 33'
   scalar_units_table( idomain, P_ff7i33 ) = '  kg kg-1'
   scalar_streams_table( idomain, P_ff7i33 )%stream(1) = 8 
   scalar_streams_table( idomain, P_ff7i33 )%stream(2) = 2097152 
   F_ff7i33 = .TRUE.
   IF ( scalar_index_table( PARAM_qnn , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qnn = scalar_num_table(idomain)
     scalar_index_table( PARAM_qnn , idomain ) = P_qnn
   ELSE
     P_qnn = scalar_index_table( PARAM_qnn , idomain )
   END IF
   scalar_boundary_table( idomain, P_qnn ) = .TRUE.
   scalar_dname_table( idomain, P_qnn ) = 'QNCCN'
   scalar_desc_table( idomain, P_qnn ) = 'CCN Number concentration'
   scalar_units_table( idomain, P_qnn ) = '  kg(-1)'
   scalar_streams_table( idomain, P_qnn )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qnn )%stream(2) = 2097152 
   F_qnn = .TRUE.
   IF ( scalar_index_table( PARAM_qnc , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qnc = scalar_num_table(idomain)
     scalar_index_table( PARAM_qnc , idomain ) = P_qnc
   ELSE
     P_qnc = scalar_index_table( PARAM_qnc , idomain )
   END IF
   scalar_boundary_table( idomain, P_qnc ) = .TRUE.
   scalar_dname_table( idomain, P_qnc ) = 'QNCLOUD'
   scalar_desc_table( idomain, P_qnc ) = 'cloud water Number concentration'
   scalar_units_table( idomain, P_qnc ) = '  kg(-1)'
   scalar_streams_table( idomain, P_qnc )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qnc )%stream(2) = 2097152 
   F_qnc = .TRUE.
   IF ( scalar_index_table( PARAM_qnr , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qnr = scalar_num_table(idomain)
     scalar_index_table( PARAM_qnr , idomain ) = P_qnr
   ELSE
     P_qnr = scalar_index_table( PARAM_qnr , idomain )
   END IF
   scalar_boundary_table( idomain, P_qnr ) = .TRUE.
   scalar_dname_table( idomain, P_qnr ) = 'QNRAIN'
   scalar_desc_table( idomain, P_qnr ) = 'Rain Number concentration'
   scalar_units_table( idomain, P_qnr ) = '  kg(-1)'
   scalar_streams_table( idomain, P_qnr )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qnr )%stream(2) = 2097152 
   F_qnr = .TRUE.
   IF ( scalar_index_table( PARAM_qni , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qni = scalar_num_table(idomain)
     scalar_index_table( PARAM_qni , idomain ) = P_qni
   ELSE
     P_qni = scalar_index_table( PARAM_qni , idomain )
   END IF
   scalar_boundary_table( idomain, P_qni ) = .TRUE.
   scalar_dname_table( idomain, P_qni ) = 'QNICE'
   scalar_desc_table( idomain, P_qni ) = 'Ice Number concentration'
   scalar_units_table( idomain, P_qni ) = '  kg-1'
   scalar_streams_table( idomain, P_qni )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qni )%stream(2) = 2097152 
   F_qni = .TRUE.
   IF ( scalar_index_table( PARAM_qnic , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qnic = scalar_num_table(idomain)
     scalar_index_table( PARAM_qnic , idomain ) = P_qnic
   ELSE
     P_qnic = scalar_index_table( PARAM_qnic , idomain )
   END IF
   scalar_boundary_table( idomain, P_qnic ) = .TRUE.
   scalar_dname_table( idomain, P_qnic ) = 'QNICEC'
   scalar_desc_table( idomain, P_qnic ) = 'Column Ice Number concentration'
   scalar_units_table( idomain, P_qnic ) = '  kg-1'
   scalar_streams_table( idomain, P_qnic )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qnic )%stream(2) = 2097152 
   F_qnic = .TRUE.
   IF ( scalar_index_table( PARAM_qnip , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qnip = scalar_num_table(idomain)
     scalar_index_table( PARAM_qnip , idomain ) = P_qnip
   ELSE
     P_qnip = scalar_index_table( PARAM_qnip , idomain )
   END IF
   scalar_boundary_table( idomain, P_qnip ) = .TRUE.
   scalar_dname_table( idomain, P_qnip ) = 'QNICEP'
   scalar_desc_table( idomain, P_qnip ) = 'Plate Ice Number concentration'
   scalar_units_table( idomain, P_qnip ) = '  kg-1'
   scalar_streams_table( idomain, P_qnip )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qnip )%stream(2) = 2097152 
   F_qnip = .TRUE.
   IF ( scalar_index_table( PARAM_qnid , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qnid = scalar_num_table(idomain)
     scalar_index_table( PARAM_qnid , idomain ) = P_qnid
   ELSE
     P_qnid = scalar_index_table( PARAM_qnid , idomain )
   END IF
   scalar_boundary_table( idomain, P_qnid ) = .TRUE.
   scalar_dname_table( idomain, P_qnid ) = 'QNICED'
   scalar_desc_table( idomain, P_qnid ) = 'Dendrite Ice Number concentration'
   scalar_units_table( idomain, P_qnid ) = '  kg-1'
   scalar_streams_table( idomain, P_qnid )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qnid )%stream(2) = 2097152 
   F_qnid = .TRUE.
   IF ( scalar_index_table( PARAM_qns , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qns = scalar_num_table(idomain)
     scalar_index_table( PARAM_qns , idomain ) = P_qns
   ELSE
     P_qns = scalar_index_table( PARAM_qns , idomain )
   END IF
   scalar_boundary_table( idomain, P_qns ) = .TRUE.
   scalar_dname_table( idomain, P_qns ) = 'QNSNOW'
   scalar_desc_table( idomain, P_qns ) = 'Snow Number concentration'
   scalar_units_table( idomain, P_qns ) = '  kg(-1)'
   scalar_streams_table( idomain, P_qns )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qns )%stream(2) = 2097152 
   F_qns = .TRUE.
   IF ( scalar_index_table( PARAM_qng , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qng = scalar_num_table(idomain)
     scalar_index_table( PARAM_qng , idomain ) = P_qng
   ELSE
     P_qng = scalar_index_table( PARAM_qng , idomain )
   END IF
   scalar_boundary_table( idomain, P_qng ) = .TRUE.
   scalar_dname_table( idomain, P_qng ) = 'QNGRAUPEL'
   scalar_desc_table( idomain, P_qng ) = 'Graupel Number concentration'
   scalar_units_table( idomain, P_qng ) = '  kg(-1)'
   scalar_streams_table( idomain, P_qng )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qng )%stream(2) = 2097152 
   F_qng = .TRUE.
   IF ( scalar_index_table( PARAM_qnh , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qnh = scalar_num_table(idomain)
     scalar_index_table( PARAM_qnh , idomain ) = P_qnh
   ELSE
     P_qnh = scalar_index_table( PARAM_qnh , idomain )
   END IF
   scalar_boundary_table( idomain, P_qnh ) = .TRUE.
   scalar_dname_table( idomain, P_qnh ) = 'QNHAIL'
   scalar_desc_table( idomain, P_qnh ) = 'Hail Number concentration'
   scalar_units_table( idomain, P_qnh ) = '  kg(-1)'
   scalar_streams_table( idomain, P_qnh )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qnh )%stream(2) = 2097152 
   F_qnh = .TRUE.
   IF ( scalar_index_table( PARAM_effr , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_effr = scalar_num_table(idomain)
     scalar_index_table( PARAM_effr , idomain ) = P_effr
   ELSE
     P_effr = scalar_index_table( PARAM_effr , idomain )
   END IF
   scalar_boundary_table( idomain, P_effr ) = .TRUE.
   scalar_dname_table( idomain, P_effr ) = 'EFF_RADIUS'
   scalar_desc_table( idomain, P_effr ) = 'Effective Radius'
   scalar_units_table( idomain, P_effr ) = 'Microns'
   scalar_streams_table( idomain, P_effr )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_effr )%stream(2) = 2097152 
   F_effr = .TRUE.
   IF ( scalar_index_table( PARAM_ice_effr , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_ice_effr = scalar_num_table(idomain)
     scalar_index_table( PARAM_ice_effr , idomain ) = P_ice_effr
   ELSE
     P_ice_effr = scalar_index_table( PARAM_ice_effr , idomain )
   END IF
   scalar_boundary_table( idomain, P_ice_effr ) = .TRUE.
   scalar_dname_table( idomain, P_ice_effr ) = 'ICE_EFF_RADIUS'
   scalar_desc_table( idomain, P_ice_effr ) = 'Ice Effective Radius'
   scalar_units_table( idomain, P_ice_effr ) = 'Microns'
   scalar_streams_table( idomain, P_ice_effr )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_ice_effr )%stream(2) = 2097152 
   F_ice_effr = .TRUE.
   IF ( scalar_index_table( PARAM_tot_effr , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_tot_effr = scalar_num_table(idomain)
     scalar_index_table( PARAM_tot_effr , idomain ) = P_tot_effr
   ELSE
     P_tot_effr = scalar_index_table( PARAM_tot_effr , idomain )
   END IF
   scalar_boundary_table( idomain, P_tot_effr ) = .TRUE.
   scalar_dname_table( idomain, P_tot_effr ) = 'TOT_EFF_RADIUS'
   scalar_desc_table( idomain, P_tot_effr ) = 'Tot Effective Radius'
   scalar_units_table( idomain, P_tot_effr ) = 'Microns'
   scalar_streams_table( idomain, P_tot_effr )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_tot_effr )%stream(2) = 2097152 
   F_tot_effr = .TRUE.
   IF ( scalar_index_table( PARAM_qic_effr , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qic_effr = scalar_num_table(idomain)
     scalar_index_table( PARAM_qic_effr , idomain ) = P_qic_effr
   ELSE
     P_qic_effr = scalar_index_table( PARAM_qic_effr , idomain )
   END IF
   scalar_boundary_table( idomain, P_qic_effr ) = .TRUE.
   scalar_dname_table( idomain, P_qic_effr ) = 'QIC_EFF_RADIUS'
   scalar_desc_table( idomain, P_qic_effr ) = 'QIC Effective Radius'
   scalar_units_table( idomain, P_qic_effr ) = 'Microns'
   scalar_streams_table( idomain, P_qic_effr )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qic_effr )%stream(2) = 2097152 
   F_qic_effr = .TRUE.
   IF ( scalar_index_table( PARAM_qip_effr , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qip_effr = scalar_num_table(idomain)
     scalar_index_table( PARAM_qip_effr , idomain ) = P_qip_effr
   ELSE
     P_qip_effr = scalar_index_table( PARAM_qip_effr , idomain )
   END IF
   scalar_boundary_table( idomain, P_qip_effr ) = .TRUE.
   scalar_dname_table( idomain, P_qip_effr ) = 'QIP_EFF_RADIUS'
   scalar_desc_table( idomain, P_qip_effr ) = 'QIP Effective Radius'
   scalar_units_table( idomain, P_qip_effr ) = 'Microns'
   scalar_streams_table( idomain, P_qip_effr )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qip_effr )%stream(2) = 2097152 
   F_qip_effr = .TRUE.
   IF ( scalar_index_table( PARAM_qid_effr , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_qid_effr = scalar_num_table(idomain)
     scalar_index_table( PARAM_qid_effr , idomain ) = P_qid_effr
   ELSE
     P_qid_effr = scalar_index_table( PARAM_qid_effr , idomain )
   END IF
   scalar_boundary_table( idomain, P_qid_effr ) = .TRUE.
   scalar_dname_table( idomain, P_qid_effr ) = 'QID_EFF_RADIUS'
   scalar_desc_table( idomain, P_qid_effr ) = 'QID Effective Radius'
   scalar_units_table( idomain, P_qid_effr ) = 'Microns'
   scalar_streams_table( idomain, P_qid_effr )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_qid_effr )%stream(2) = 2097152 
   F_qid_effr = .TRUE.
  END IF
  IF (model_config_rec%p_lev_diags==0)THEN
  END IF
  IF (model_config_rec%p_lev_diags==1)THEN
  END IF
  IF (model_config_rec%z_lev_diags==0)THEN
  END IF
  IF (model_config_rec%z_lev_diags==1)THEN
  END IF
  IF (model_config_rec%afwa_diag_opt(idomain)==1)THEN
  END IF
  IF (model_config_rec%afwa_ptype_opt(idomain)==1)THEN
  END IF
  IF (model_config_rec%afwa_vil_opt(idomain)==1)THEN
  END IF
  IF (model_config_rec%afwa_radar_opt(idomain)==1)THEN
  END IF
  IF (model_config_rec%afwa_severe_opt(idomain)==1)THEN
  END IF
  IF (model_config_rec%afwa_icing_opt(idomain)==1)THEN
  END IF
  IF (model_config_rec%afwa_cloud_opt(idomain)==1)THEN
  END IF
  IF (model_config_rec%afwa_vis_opt(idomain)==1)THEN
  END IF
  IF (model_config_rec%afwa_therm_opt(idomain)==1)THEN
  END IF
  IF (model_config_rec%afwa_turb_opt(idomain)==1)THEN
  END IF
  IF (model_config_rec%afwa_buoy_opt(idomain)==1)THEN
  END IF
  IF (model_config_rec%mean_diag==0)THEN
  END IF
  IF (model_config_rec%mean_diag==1)THEN
  END IF
  IF (model_config_rec%diurnal_diag==0)THEN
  END IF
  IF (model_config_rec%diurnal_diag==1)THEN
  END IF
  IF (model_config_rec%elec_physics==0)THEN
  END IF
  IF (model_config_rec%elec_physics==1)THEN
   IF ( scalar_index_table( PARAM_scr , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_scr = scalar_num_table(idomain)
     scalar_index_table( PARAM_scr , idomain ) = P_scr
   ELSE
     P_scr = scalar_index_table( PARAM_scr , idomain )
   END IF
   scalar_boundary_table( idomain, P_scr ) = .TRUE.
   scalar_dname_table( idomain, P_scr ) = 'SCR'
   scalar_desc_table( idomain, P_scr ) = 'Rain space charge mixing ratio'
   scalar_units_table( idomain, P_scr ) = '  C kg(-1)'
   scalar_streams_table( idomain, P_scr )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_scr )%stream(2) = 2097152 
   F_scr = .TRUE.
   IF ( scalar_index_table( PARAM_scw , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_scw = scalar_num_table(idomain)
     scalar_index_table( PARAM_scw , idomain ) = P_scw
   ELSE
     P_scw = scalar_index_table( PARAM_scw , idomain )
   END IF
   scalar_boundary_table( idomain, P_scw ) = .TRUE.
   scalar_dname_table( idomain, P_scw ) = 'SCW'
   scalar_desc_table( idomain, P_scw ) = 'cloud water space charge mixing ratio'
   scalar_units_table( idomain, P_scw ) = '  C kg(-1)'
   scalar_streams_table( idomain, P_scw )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_scw )%stream(2) = 2097152 
   F_scw = .TRUE.
   IF ( scalar_index_table( PARAM_sci , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_sci = scalar_num_table(idomain)
     scalar_index_table( PARAM_sci , idomain ) = P_sci
   ELSE
     P_sci = scalar_index_table( PARAM_sci , idomain )
   END IF
   scalar_boundary_table( idomain, P_sci ) = .TRUE.
   scalar_dname_table( idomain, P_sci ) = 'SCI'
   scalar_desc_table( idomain, P_sci ) = 'cloud ice space charge mixing ratio'
   scalar_units_table( idomain, P_sci ) = '  C kg(-1)'
   scalar_streams_table( idomain, P_sci )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_sci )%stream(2) = 2097152 
   F_sci = .TRUE.
   IF ( scalar_index_table( PARAM_scs , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_scs = scalar_num_table(idomain)
     scalar_index_table( PARAM_scs , idomain ) = P_scs
   ELSE
     P_scs = scalar_index_table( PARAM_scs , idomain )
   END IF
   scalar_boundary_table( idomain, P_scs ) = .TRUE.
   scalar_dname_table( idomain, P_scs ) = 'SCS'
   scalar_desc_table( idomain, P_scs ) = 'snow space charge mixing ratio'
   scalar_units_table( idomain, P_scs ) = '  C kg(-1)'
   scalar_streams_table( idomain, P_scs )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_scs )%stream(2) = 2097152 
   F_scs = .TRUE.
   IF ( scalar_index_table( PARAM_sch , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_sch = scalar_num_table(idomain)
     scalar_index_table( PARAM_sch , idomain ) = P_sch
   ELSE
     P_sch = scalar_index_table( PARAM_sch , idomain )
   END IF
   scalar_boundary_table( idomain, P_sch ) = .TRUE.
   scalar_dname_table( idomain, P_sch ) = 'SCH'
   scalar_desc_table( idomain, P_sch ) = 'graupel water space charge mixing ratio'
   scalar_units_table( idomain, P_sch ) = '  C kg(-1)'
   scalar_streams_table( idomain, P_sch )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_sch )%stream(2) = 2097152 
   F_sch = .TRUE.
   IF ( scalar_index_table( PARAM_schl , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_schl = scalar_num_table(idomain)
     scalar_index_table( PARAM_schl , idomain ) = P_schl
   ELSE
     P_schl = scalar_index_table( PARAM_schl , idomain )
   END IF
   scalar_boundary_table( idomain, P_schl ) = .TRUE.
   scalar_dname_table( idomain, P_schl ) = 'SCHL'
   scalar_desc_table( idomain, P_schl ) = 'hail water space charge mixing ratio'
   scalar_units_table( idomain, P_schl ) = '  C kg(-1)'
   scalar_streams_table( idomain, P_schl )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_schl )%stream(2) = 2097152 
   F_schl = .TRUE.
   IF ( scalar_index_table( PARAM_sciona , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_sciona = scalar_num_table(idomain)
     scalar_index_table( PARAM_sciona , idomain ) = P_sciona
   ELSE
     P_sciona = scalar_index_table( PARAM_sciona , idomain )
   END IF
   scalar_boundary_table( idomain, P_sciona ) = .TRUE.
   scalar_dname_table( idomain, P_sciona ) = 'SCIONA'
   scalar_desc_table( idomain, P_sciona ) = 'Passive net ion space charge'
   scalar_units_table( idomain, P_sciona ) = '  C kg(-1)'
   scalar_streams_table( idomain, P_sciona )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_sciona )%stream(2) = 2097152 
   F_sciona = .TRUE.
  END IF
  IF (model_config_rec%elec_physics==2)THEN
   IF ( scalar_index_table( PARAM_scr , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_scr = scalar_num_table(idomain)
     scalar_index_table( PARAM_scr , idomain ) = P_scr
   ELSE
     P_scr = scalar_index_table( PARAM_scr , idomain )
   END IF
   scalar_boundary_table( idomain, P_scr ) = .TRUE.
   scalar_dname_table( idomain, P_scr ) = 'SCR'
   scalar_desc_table( idomain, P_scr ) = 'Rain space charge mixing ratio'
   scalar_units_table( idomain, P_scr ) = '  C kg(-1)'
   scalar_streams_table( idomain, P_scr )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_scr )%stream(2) = 2097152 
   F_scr = .TRUE.
   IF ( scalar_index_table( PARAM_scw , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_scw = scalar_num_table(idomain)
     scalar_index_table( PARAM_scw , idomain ) = P_scw
   ELSE
     P_scw = scalar_index_table( PARAM_scw , idomain )
   END IF
   scalar_boundary_table( idomain, P_scw ) = .TRUE.
   scalar_dname_table( idomain, P_scw ) = 'SCW'
   scalar_desc_table( idomain, P_scw ) = 'cloud water space charge mixing ratio'
   scalar_units_table( idomain, P_scw ) = '  C kg(-1)'
   scalar_streams_table( idomain, P_scw )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_scw )%stream(2) = 2097152 
   F_scw = .TRUE.
   IF ( scalar_index_table( PARAM_sci , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_sci = scalar_num_table(idomain)
     scalar_index_table( PARAM_sci , idomain ) = P_sci
   ELSE
     P_sci = scalar_index_table( PARAM_sci , idomain )
   END IF
   scalar_boundary_table( idomain, P_sci ) = .TRUE.
   scalar_dname_table( idomain, P_sci ) = 'SCI'
   scalar_desc_table( idomain, P_sci ) = 'cloud ice space charge mixing ratio'
   scalar_units_table( idomain, P_sci ) = '  C kg(-1)'
   scalar_streams_table( idomain, P_sci )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_sci )%stream(2) = 2097152 
   F_sci = .TRUE.
   IF ( scalar_index_table( PARAM_scs , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_scs = scalar_num_table(idomain)
     scalar_index_table( PARAM_scs , idomain ) = P_scs
   ELSE
     P_scs = scalar_index_table( PARAM_scs , idomain )
   END IF
   scalar_boundary_table( idomain, P_scs ) = .TRUE.
   scalar_dname_table( idomain, P_scs ) = 'SCS'
   scalar_desc_table( idomain, P_scs ) = 'snow space charge mixing ratio'
   scalar_units_table( idomain, P_scs ) = '  C kg(-1)'
   scalar_streams_table( idomain, P_scs )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_scs )%stream(2) = 2097152 
   F_scs = .TRUE.
   IF ( scalar_index_table( PARAM_sch , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_sch = scalar_num_table(idomain)
     scalar_index_table( PARAM_sch , idomain ) = P_sch
   ELSE
     P_sch = scalar_index_table( PARAM_sch , idomain )
   END IF
   scalar_boundary_table( idomain, P_sch ) = .TRUE.
   scalar_dname_table( idomain, P_sch ) = 'SCH'
   scalar_desc_table( idomain, P_sch ) = 'graupel water space charge mixing ratio'
   scalar_units_table( idomain, P_sch ) = '  C kg(-1)'
   scalar_streams_table( idomain, P_sch )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_sch )%stream(2) = 2097152 
   F_sch = .TRUE.
   IF ( scalar_index_table( PARAM_schl , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_schl = scalar_num_table(idomain)
     scalar_index_table( PARAM_schl , idomain ) = P_schl
   ELSE
     P_schl = scalar_index_table( PARAM_schl , idomain )
   END IF
   scalar_boundary_table( idomain, P_schl ) = .TRUE.
   scalar_dname_table( idomain, P_schl ) = 'SCHL'
   scalar_desc_table( idomain, P_schl ) = 'hail water space charge mixing ratio'
   scalar_units_table( idomain, P_schl ) = '  C kg(-1)'
   scalar_streams_table( idomain, P_schl )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_schl )%stream(2) = 2097152 
   F_schl = .TRUE.
   IF ( scalar_index_table( PARAM_sciona , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_sciona = scalar_num_table(idomain)
     scalar_index_table( PARAM_sciona , idomain ) = P_sciona
   ELSE
     P_sciona = scalar_index_table( PARAM_sciona , idomain )
   END IF
   scalar_boundary_table( idomain, P_sciona ) = .TRUE.
   scalar_dname_table( idomain, P_sciona ) = 'SCIONA'
   scalar_desc_table( idomain, P_sciona ) = 'Passive net ion space charge'
   scalar_units_table( idomain, P_sciona ) = '  C kg(-1)'
   scalar_streams_table( idomain, P_sciona )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_sciona )%stream(2) = 2097152 
   F_sciona = .TRUE.
  END IF
  IF (model_config_rec%elec_physics==3)THEN
   IF ( scalar_index_table( PARAM_scr , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_scr = scalar_num_table(idomain)
     scalar_index_table( PARAM_scr , idomain ) = P_scr
   ELSE
     P_scr = scalar_index_table( PARAM_scr , idomain )
   END IF
   scalar_boundary_table( idomain, P_scr ) = .TRUE.
   scalar_dname_table( idomain, P_scr ) = 'SCR'
   scalar_desc_table( idomain, P_scr ) = 'Rain space charge mixing ratio'
   scalar_units_table( idomain, P_scr ) = '  C kg(-1)'
   scalar_streams_table( idomain, P_scr )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_scr )%stream(2) = 2097152 
   F_scr = .TRUE.
   IF ( scalar_index_table( PARAM_scw , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_scw = scalar_num_table(idomain)
     scalar_index_table( PARAM_scw , idomain ) = P_scw
   ELSE
     P_scw = scalar_index_table( PARAM_scw , idomain )
   END IF
   scalar_boundary_table( idomain, P_scw ) = .TRUE.
   scalar_dname_table( idomain, P_scw ) = 'SCW'
   scalar_desc_table( idomain, P_scw ) = 'cloud water space charge mixing ratio'
   scalar_units_table( idomain, P_scw ) = '  C kg(-1)'
   scalar_streams_table( idomain, P_scw )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_scw )%stream(2) = 2097152 
   F_scw = .TRUE.
   IF ( scalar_index_table( PARAM_sci , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_sci = scalar_num_table(idomain)
     scalar_index_table( PARAM_sci , idomain ) = P_sci
   ELSE
     P_sci = scalar_index_table( PARAM_sci , idomain )
   END IF
   scalar_boundary_table( idomain, P_sci ) = .TRUE.
   scalar_dname_table( idomain, P_sci ) = 'SCI'
   scalar_desc_table( idomain, P_sci ) = 'cloud ice space charge mixing ratio'
   scalar_units_table( idomain, P_sci ) = '  C kg(-1)'
   scalar_streams_table( idomain, P_sci )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_sci )%stream(2) = 2097152 
   F_sci = .TRUE.
   IF ( scalar_index_table( PARAM_scs , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_scs = scalar_num_table(idomain)
     scalar_index_table( PARAM_scs , idomain ) = P_scs
   ELSE
     P_scs = scalar_index_table( PARAM_scs , idomain )
   END IF
   scalar_boundary_table( idomain, P_scs ) = .TRUE.
   scalar_dname_table( idomain, P_scs ) = 'SCS'
   scalar_desc_table( idomain, P_scs ) = 'snow space charge mixing ratio'
   scalar_units_table( idomain, P_scs ) = '  C kg(-1)'
   scalar_streams_table( idomain, P_scs )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_scs )%stream(2) = 2097152 
   F_scs = .TRUE.
   IF ( scalar_index_table( PARAM_sch , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_sch = scalar_num_table(idomain)
     scalar_index_table( PARAM_sch , idomain ) = P_sch
   ELSE
     P_sch = scalar_index_table( PARAM_sch , idomain )
   END IF
   scalar_boundary_table( idomain, P_sch ) = .TRUE.
   scalar_dname_table( idomain, P_sch ) = 'SCH'
   scalar_desc_table( idomain, P_sch ) = 'graupel water space charge mixing ratio'
   scalar_units_table( idomain, P_sch ) = '  C kg(-1)'
   scalar_streams_table( idomain, P_sch )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_sch )%stream(2) = 2097152 
   F_sch = .TRUE.
   IF ( scalar_index_table( PARAM_schl , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_schl = scalar_num_table(idomain)
     scalar_index_table( PARAM_schl , idomain ) = P_schl
   ELSE
     P_schl = scalar_index_table( PARAM_schl , idomain )
   END IF
   scalar_boundary_table( idomain, P_schl ) = .TRUE.
   scalar_dname_table( idomain, P_schl ) = 'SCHL'
   scalar_desc_table( idomain, P_schl ) = 'hail water space charge mixing ratio'
   scalar_units_table( idomain, P_schl ) = '  C kg(-1)'
   scalar_streams_table( idomain, P_schl )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_schl )%stream(2) = 2097152 
   F_schl = .TRUE.
   IF ( scalar_index_table( PARAM_sciona , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_sciona = scalar_num_table(idomain)
     scalar_index_table( PARAM_sciona , idomain ) = P_sciona
   ELSE
     P_sciona = scalar_index_table( PARAM_sciona , idomain )
   END IF
   scalar_boundary_table( idomain, P_sciona ) = .TRUE.
   scalar_dname_table( idomain, P_sciona ) = 'SCIONA'
   scalar_desc_table( idomain, P_sciona ) = 'Passive net ion space charge'
   scalar_units_table( idomain, P_sciona ) = '  C kg(-1)'
   scalar_streams_table( idomain, P_sciona )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_sciona )%stream(2) = 2097152 
   F_sciona = .TRUE.
   IF ( scalar_index_table( PARAM_clnox , idomain ) .lt. 1 ) THEN
     scalar_num_table(idomain) = scalar_num_table(idomain) + 1
     P_clnox = scalar_num_table(idomain)
     scalar_index_table( PARAM_clnox , idomain ) = P_clnox
   ELSE
     P_clnox = scalar_index_table( PARAM_clnox , idomain )
   END IF
   scalar_boundary_table( idomain, P_clnox ) = .TRUE.
   scalar_dname_table( idomain, P_clnox ) = 'CLNOX'
   scalar_desc_table( idomain, P_clnox ) = 'Lightning NOx concentration'
   scalar_units_table( idomain, P_clnox ) = '  moles kg(-1)'
   scalar_streams_table( idomain, P_clnox )%stream(1) = 33554433 
   scalar_streams_table( idomain, P_clnox )%stream(2) = 2097152 
   F_clnox = .TRUE.
  END IF
  IF (model_config_rec%perturb_bdy==0)THEN
  END IF
  IF (model_config_rec%perturb_bdy==1)THEN
  END IF
  IF (model_config_rec%perturb_bdy==2)THEN
  END IF
  IF (model_config_rec%perturb_chem_bdy==1)THEN
  END IF
  IF (model_config_rec%wif_input_opt==1)THEN
  END IF
  IF (model_config_rec%diag_nwp2==0)THEN
  END IF
  IF (model_config_rec%diag_nwp2==1)THEN
  END IF
  IF (model_config_rec%tracer_opt(idomain)==2)THEN
   IF ( tracer_index_table( PARAM_tr17_1 , idomain ) .lt. 1 ) THEN
     tracer_num_table(idomain) = tracer_num_table(idomain) + 1
     P_tr17_1 = tracer_num_table(idomain)
     tracer_index_table( PARAM_tr17_1 , idomain ) = P_tr17_1
   ELSE
     P_tr17_1 = tracer_index_table( PARAM_tr17_1 , idomain )
   END IF
   tracer_boundary_table( idomain, P_tr17_1 ) = .TRUE.
   tracer_dname_table( idomain, P_tr17_1 ) = 'tr17_1'
   tracer_desc_table( idomain, P_tr17_1 ) = 'tr17_1'
   tracer_units_table( idomain, P_tr17_1 ) = 'Dimensionless'
   tracer_streams_table( idomain, P_tr17_1 )%stream(1) = 33554433 
   tracer_streams_table( idomain, P_tr17_1 )%stream(2) = 2097152 
   F_tr17_1 = .TRUE.
   IF ( tracer_index_table( PARAM_tr17_2 , idomain ) .lt. 1 ) THEN
     tracer_num_table(idomain) = tracer_num_table(idomain) + 1
     P_tr17_2 = tracer_num_table(idomain)
     tracer_index_table( PARAM_tr17_2 , idomain ) = P_tr17_2
   ELSE
     P_tr17_2 = tracer_index_table( PARAM_tr17_2 , idomain )
   END IF
   tracer_boundary_table( idomain, P_tr17_2 ) = .TRUE.
   tracer_dname_table( idomain, P_tr17_2 ) = 'tr17_2'
   tracer_desc_table( idomain, P_tr17_2 ) = 'tr17_2'
   tracer_units_table( idomain, P_tr17_2 ) = 'Dimensionless'
   tracer_streams_table( idomain, P_tr17_2 )%stream(1) = 33554433 
   tracer_streams_table( idomain, P_tr17_2 )%stream(2) = 2097152 
   F_tr17_2 = .TRUE.
   IF ( tracer_index_table( PARAM_tr17_3 , idomain ) .lt. 1 ) THEN
     tracer_num_table(idomain) = tracer_num_table(idomain) + 1
     P_tr17_3 = tracer_num_table(idomain)
     tracer_index_table( PARAM_tr17_3 , idomain ) = P_tr17_3
   ELSE
     P_tr17_3 = tracer_index_table( PARAM_tr17_3 , idomain )
   END IF
   tracer_boundary_table( idomain, P_tr17_3 ) = .TRUE.
   tracer_dname_table( idomain, P_tr17_3 ) = 'tr17_3'
   tracer_desc_table( idomain, P_tr17_3 ) = 'tr17_3'
   tracer_units_table( idomain, P_tr17_3 ) = 'Dimensionless'
   tracer_streams_table( idomain, P_tr17_3 )%stream(1) = 33554433 
   tracer_streams_table( idomain, P_tr17_3 )%stream(2) = 2097152 
   F_tr17_3 = .TRUE.
   IF ( tracer_index_table( PARAM_tr17_4 , idomain ) .lt. 1 ) THEN
     tracer_num_table(idomain) = tracer_num_table(idomain) + 1
     P_tr17_4 = tracer_num_table(idomain)
     tracer_index_table( PARAM_tr17_4 , idomain ) = P_tr17_4
   ELSE
     P_tr17_4 = tracer_index_table( PARAM_tr17_4 , idomain )
   END IF
   tracer_boundary_table( idomain, P_tr17_4 ) = .TRUE.
   tracer_dname_table( idomain, P_tr17_4 ) = 'tr17_4'
   tracer_desc_table( idomain, P_tr17_4 ) = 'tr17_4'
   tracer_units_table( idomain, P_tr17_4 ) = 'Dimensionless'
   tracer_streams_table( idomain, P_tr17_4 )%stream(1) = 33554433 
   tracer_streams_table( idomain, P_tr17_4 )%stream(2) = 2097152 
   F_tr17_4 = .TRUE.
   IF ( tracer_index_table( PARAM_tr17_5 , idomain ) .lt. 1 ) THEN
     tracer_num_table(idomain) = tracer_num_table(idomain) + 1
     P_tr17_5 = tracer_num_table(idomain)
     tracer_index_table( PARAM_tr17_5 , idomain ) = P_tr17_5
   ELSE
     P_tr17_5 = tracer_index_table( PARAM_tr17_5 , idomain )
   END IF
   tracer_boundary_table( idomain, P_tr17_5 ) = .TRUE.
   tracer_dname_table( idomain, P_tr17_5 ) = 'tr17_5'
   tracer_desc_table( idomain, P_tr17_5 ) = 'tr17_5'
   tracer_units_table( idomain, P_tr17_5 ) = 'Dimensionless'
   tracer_streams_table( idomain, P_tr17_5 )%stream(1) = 33554433 
   tracer_streams_table( idomain, P_tr17_5 )%stream(2) = 2097152 
   F_tr17_5 = .TRUE.
   IF ( tracer_index_table( PARAM_tr17_6 , idomain ) .lt. 1 ) THEN
     tracer_num_table(idomain) = tracer_num_table(idomain) + 1
     P_tr17_6 = tracer_num_table(idomain)
     tracer_index_table( PARAM_tr17_6 , idomain ) = P_tr17_6
   ELSE
     P_tr17_6 = tracer_index_table( PARAM_tr17_6 , idomain )
   END IF
   tracer_boundary_table( idomain, P_tr17_6 ) = .TRUE.
   tracer_dname_table( idomain, P_tr17_6 ) = 'tr17_6'
   tracer_desc_table( idomain, P_tr17_6 ) = 'tr17_6'
   tracer_units_table( idomain, P_tr17_6 ) = 'Dimensionless'
   tracer_streams_table( idomain, P_tr17_6 )%stream(1) = 33554433 
   tracer_streams_table( idomain, P_tr17_6 )%stream(2) = 2097152 
   F_tr17_6 = .TRUE.
   IF ( tracer_index_table( PARAM_tr17_7 , idomain ) .lt. 1 ) THEN
     tracer_num_table(idomain) = tracer_num_table(idomain) + 1
     P_tr17_7 = tracer_num_table(idomain)
     tracer_index_table( PARAM_tr17_7 , idomain ) = P_tr17_7
   ELSE
     P_tr17_7 = tracer_index_table( PARAM_tr17_7 , idomain )
   END IF
   tracer_boundary_table( idomain, P_tr17_7 ) = .TRUE.
   tracer_dname_table( idomain, P_tr17_7 ) = 'tr17_7'
   tracer_desc_table( idomain, P_tr17_7 ) = 'tr17_7'
   tracer_units_table( idomain, P_tr17_7 ) = 'Dimensionless'
   tracer_streams_table( idomain, P_tr17_7 )%stream(1) = 33554433 
   tracer_streams_table( idomain, P_tr17_7 )%stream(2) = 2097152 
   F_tr17_7 = .TRUE.
   IF ( tracer_index_table( PARAM_tr17_8 , idomain ) .lt. 1 ) THEN
     tracer_num_table(idomain) = tracer_num_table(idomain) + 1
     P_tr17_8 = tracer_num_table(idomain)
     tracer_index_table( PARAM_tr17_8 , idomain ) = P_tr17_8
   ELSE
     P_tr17_8 = tracer_index_table( PARAM_tr17_8 , idomain )
   END IF
   tracer_boundary_table( idomain, P_tr17_8 ) = .TRUE.
   tracer_dname_table( idomain, P_tr17_8 ) = 'tr17_8'
   tracer_desc_table( idomain, P_tr17_8 ) = 'tr17_8'
   tracer_units_table( idomain, P_tr17_8 ) = 'Dimensionless'
   tracer_streams_table( idomain, P_tr17_8 )%stream(1) = 33554433 
   tracer_streams_table( idomain, P_tr17_8 )%stream(2) = 2097152 
   F_tr17_8 = .TRUE.
  END IF
  IF (model_config_rec%use_wps_input==0)THEN
  END IF
  IF (model_config_rec%use_wps_input==1)THEN
  END IF
  IF (model_config_rec%use_wps_input==2)THEN
  END IF







  num_moist = moist_num_table( idomain )
  num_dfi_moist = dfi_moist_num_table( idomain )
  num_scalar = scalar_num_table( idomain )
  num_dfi_scalar = dfi_scalar_num_table( idomain )
  num_aerod = aerod_num_table( idomain )
  num_aerocu = aerocu_num_table( idomain )
  num_ozmixm = ozmixm_num_table( idomain )
  num_aerosolc = aerosolc_num_table( idomain )
  num_fdda3d = fdda3d_num_table( idomain )
  num_fdda2d = fdda2d_num_table( idomain )
  num_advh_t = advh_t_num_table( idomain )
  num_advz_t = advz_t_num_table( idomain )
  num_tracer = tracer_num_table( idomain )
  num_nba_mij = nba_mij_num_table( idomain )
  num_nba_rij = nba_rij_num_table( idomain )
  num_chem = chem_num_table( idomain )

  RETURN
END SUBROUTINE set_scalar_indices_from_config

   SUBROUTINE change_to_lower_case(instr,outstr)
     CHARACTER*(*) ,INTENT(IN)  :: instr
     CHARACTER*(*) ,INTENT(OUT) :: outstr

     CHARACTER*1                :: c
     INTEGER       ,PARAMETER   :: upper_to_lower =IACHAR('a')-IACHAR('A')
     INTEGER                    :: i,n,n1

     outstr = ' '
     N  = len(instr)
     N1 = len(outstr)
     N  = MIN(N,N1)
     outstr(1:N) = instr(1:N)
     DO i=1,N
       c = instr(i:i)
       if('A'<=c .and. c <='Z') outstr(i:i)=achar(iachar(c)+upper_to_lower)
     ENDDO

   END SUBROUTINE change_to_lower_case
